
/* i370-ibm-ld.c 1995/7/13 by Y.Nakashima */

#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <fcntl.h>

struct sym {
  unsigned 	 id;
  unsigned char	 space1[6];
  unsigned short len;
  unsigned char	 space2[4];
  unsigned char	 data[56];
  unsigned char	 lineno[8];
};

struct esd {
  unsigned 	 id;
  unsigned char	 space1[6];
  unsigned short len;
  unsigned char	 space2[2];
  unsigned short esdid;
  unsigned       id11;
  unsigned       id12;
  unsigned       typ1: 8;
  unsigned       adr1:24;
  unsigned       bnd1: 8;
  unsigned       len1:24;
  unsigned       id21;
  unsigned       id22;
  unsigned       typ2: 8;
  unsigned       adr2:24;
  unsigned       bnd2: 8;
  unsigned       len2:24;
  unsigned       id31;
  unsigned       id32;
  unsigned       typ3: 8;
  unsigned       adr3:24;
  unsigned       bnd3: 8;
  unsigned       len3:24;
  unsigned char	 space3[8];
  unsigned char	 lineno[8];
};

struct txt {
  unsigned 	 id;
  unsigned	 null: 8;
  unsigned	 addr:24;
  unsigned short space1;
  unsigned short len;
  unsigned char	 space2[2];
  unsigned short esdid;
  unsigned char	 data[56];
  unsigned char	 lineno[8];
};

struct rld {
  unsigned 	 id;
  unsigned char	 space1[6];
  unsigned short len;
  unsigned char	 space2[4];
  unsigned char	 data[56];
  unsigned char	 lineno[8];
};

struct end {
  unsigned 	 id;
  unsigned char	 data[76];
};

union obj {
  struct sym sym;
  struct esd esd;
  struct txt txt;
  struct rld rld;
  struct end end;
};

union obj rbuf;

#define ESDTABLE_SIZ 0x10000

unsigned last_esdid;

struct esdtable {
  unsigned	id1;
  unsigned	id2;
  unsigned	type:8;
  unsigned	addr:24;
} esdtable[ESDTABLE_SIZ];

unsigned char e2a[] = {
   0,  0,  0,  0,  0,'\t', 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
   0,  0,  0,  0,  0,'\n', 0,  0,'\r', 0,  0,  0,  0,  0,  0,  0,
   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
 ' ',  0,  0,  0,  0,  0,  0,  0,  0,  0,'.','.','<','(','+','|',
 '&',  0,  0,  0,  0,  0,  0,  0,  0,  0,'!','\\','*',')',';','^',
 '-','/',  0,  0,  0,  0,  0,  0,  0,  0,'|',',','%','_','>','?',
   0,  0,  0,  0,  0,  0,  0,  0,  0,'`',':','#','@','\'','=','\"',
   0,'a','b','c','d','e','f','g','h','i',  0,  0,  0,  0,  0,  0,
   0,'j','k','l','m','n','o','p','q','r',  0,  0,  0,  0,  0,  0,
   0,'~','s','t','u','v','w','x','y','z',  0,  0,  0,  0,  0,  0,
   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
 '{','A','B','C','D','E','F','G','H','I',  0,  0,  0,  0,  0,  0,
 '}','J','K','L','M','N','O','P','Q','R',  0,  0,  0,  0,  0,  0,
 '$',  0,'S','T','U','V','W','X','Y','Z',  0,  0,  0,  0,  0,  0,
 '0','1','2','3','4','5','6','7','8','9',  0,  0,  0,  0,  0,  0};

#ifdef SPARC
unsigned swap1(a) unsigned char a;
{ return (a); }

unsigned swap2(a) unsigned short a;
{ return (a); }

unsigned swap3(a) unsigned a;
{ return (a); }

unsigned swap4(a) unsigned a;
{ return (a); }
#endif

#ifdef INTEL
unsigned swap1(a) unsigned char a;
{ return (a); }

unsigned swap2(a) unsigned short a;
{ return (((a&0xff)<<8)|(a>>8)); }

unsigned swap3(a) unsigned a;
{ return (((a&0xff)<<16)|(a&0xff00)|(a>>16)); }

unsigned swap4(a) unsigned a;
{ return ((a<<24)|((a&0xff00)<<8)|((a&0xff0000)>>8)|(a>>24)); }
#endif

main(argc, argv) int argc; char *argv[];
{
  int	o_flag = 0;
  int	fd1 = 0;
  int	fd2 = 0;
  char  *fd1name = NULL;
  char  *fd2name = NULL;

  for (argc--, argv++; argc; argc--, argv++) {
    if (**argv == '-') {
      if (*(*argv+1) == 'o')
        o_flag++;
      else
        continue;
    }
    else if (!o_flag)
      fd1name = *argv;
    else {
      fd2name = *argv;
      o_flag = 0;
    }
  }

  if (!fd1name) {
    fprintf(stderr, "input object must be specified\n");
    exit(1);
  }
  if (fd1name && !fd2name)
    fd2name = "a.out";

  if ((fd1 = open(fd1name, O_RDONLY)) < 0) {
    fprintf(stderr, "can't open %s\n", fd1name);
    exit(1);
  }
  if ((fd2 = open(fd2name, O_CREAT|O_TRUNC, 0755)) < 0) {
    fprintf(stderr, "can't create %s\n", fd2name);
    exit(1);
  }
  if ((fd2 = open(fd2name, O_WRONLY)) < 0) {
    fprintf(stderr, "can't write on %s\n", fd2name);
    exit(1);
  }

  for (;;) {
    if (!read(fd1, &rbuf, 80)) {
      fprintf(stderr, "unexpected EOF ('END' not found)\n");
      exit(1);
      break;
    }
    if (swap4(rbuf.esd.id) == 0x02C5E2C4) { /* ESD */
      int esdid;

      esdid = swap2(rbuf.esd.esdid);
      if (swap2(rbuf.esd.len) > 0) {
        esdtable[esdid].id1  = swap4(rbuf.esd.id11);
        esdtable[esdid].id2  = swap4(rbuf.esd.id12);
        esdtable[esdid].type = swap1(rbuf.esd.typ1);
        esdtable[esdid].addr = swap3(rbuf.esd.adr1);
        last_esdid = esdid;
      }
      if (swap2(rbuf.esd.len) > 16) {
        esdtable[esdid+1].id1  = swap4(rbuf.esd.id21);
        esdtable[esdid+1].id2  = swap4(rbuf.esd.id22);
        esdtable[esdid+1].type = swap1(rbuf.esd.typ2);
        esdtable[esdid+1].addr = swap3(rbuf.esd.adr2);
        last_esdid = esdid+1;
      }
      if (swap2(rbuf.esd.len) > 32) {
        esdtable[esdid+2].id1  = swap4(rbuf.esd.id31);
        esdtable[esdid+2].id2  = swap4(rbuf.esd.id32);
        esdtable[esdid+2].type = swap1(rbuf.esd.typ3);
        esdtable[esdid+2].addr = swap3(rbuf.esd.adr3);
        last_esdid = esdid+2;
      }
    }
    else if (swap4(rbuf.txt.id) == 0x02E3E7E3) { /* TXT */
      if (lseek(fd2, swap3(rbuf.txt.addr), SEEK_SET) < 0) {
        fprintf(stderr, "seek failed in %s\n", fd2name);
        exit(1);
      }
      if (write(fd2, rbuf.txt.data, swap2(rbuf.txt.len)) < 0) {
        fprintf(stderr, "write failed in %s\n", fd2name);
        exit(1);
      }
    }
    else if (swap4(rbuf.rld.id) == 0x02D9D3C4) { /* RLD */
      unsigned char *rldp;
      unsigned len;
      unsigned esdid;
      unsigned target;
      unsigned addr;
      unsigned i;

      rldp = rbuf.rld.data;
      len  = swap2(rbuf.rld.len);
      while (len > 0) {
        esdid = swap2(*(unsigned short*)rldp);
        rldp += 4; len -= 4;
      cont:
        if (*rldp == 0x1c) {
          target = (*(rldp+1)<<16)|(*(rldp+2)<<8)|(*(rldp+3));
	  for (i=esdid+1; i<=last_esdid; i++) {
            if (esdtable[i].id1 == esdtable[esdid].id1 && esdtable[i].id2 == esdtable[esdid].id2)
              break;
          }
          if (i <= last_esdid) {
            addr = swap4(esdtable[i].addr);
            if (lseek(fd2, target, SEEK_SET) < 0) {
              fprintf(stderr, "seek failed in %s\n", fd2name);
              exit(1);
            }
            if (write(fd2, &addr, 4) < 0) {
              fprintf(stderr, "write failed in %s\n", fd2name);
              exit(1);
            }
          }
          else {
            printid(&esdtable[esdid].id1);
            fprintf(stderr, ":undefined (regard as 0)\n");
          }
        }
        else if (*rldp == 0x18 || *rldp == 0x14 || *rldp == 0x10) {
          printid(&esdtable[esdid].id1);
          fprintf(stderr, ":unknown reloc length\n");
        }
        else if (*rldp & 1) {
          rldp += 4; len -= 4;
          goto cont;
        }
        rldp += 4; len -= 4;
      }
    }
    else if (swap4(rbuf.end.id) == 0x02C5D5C4) { /* END */
      break;
    }
    else if (swap4(rbuf.sym.id) == 0x02E2E8D4) { /* SYM */
    }
    else {
      fprintf(stderr, "unknown ID detected\n");
    }
  }

  close(fd1);
  close(fd2);
  exit(0);
}

printid(buf) unsigned char *buf;
{
  int i;

  for (i=0; i<8; i++)
    fputc(e2a[*(buf+i)], stderr);
}

