{
static char ControlRcsId[] =
"$Id: control.c,v 1.6 1997/03/03 05:23:59 nakashim Exp nakashim $";

/* control.c 1995/7/18 */

/* M-on-RISC Dynamically Translating Simulator */
/*       Copyright (C) 1995 by FUJITSU LIMITED */
/*                 Primary writer: Y.Nakashima */
/*          nakashim@pine.mfd.cs.fujitsu.co.jp */

        unsigned ILC = (dim_version==1)
	                 ?(swap4(guest0->g1)&0xc)>>2
			 :(gmem0[swap4(guest0->g2)]>>6)+3>>1;
        unsigned NPC = (dim_version==1)
	                 ?(swap4(guest0->g2)&0x7fffffff)
			 :(swap4(guest0->g2)+(ILC<<1)&0x7fffffff);

        switch (swap4(guest0->g7) >> 30) {
        case 0: /* Program Exception or Step Execution */
          if (swap4(guest0->g7) & 0x00ff0000) {
	    llu op;
#ifdef DEBUG
	    umes("program exception: g7=0x%08.8x continuing...\n", swap4(guest0->g7));
#endif
	    *(unsigned*)(&gmem0[0x8c])
	      = swap4(ILC<<17
	            | (swap4(guest0->g7) & 0x00ff0000)>>16);
	    *(llu*)(&gmem0[0x28])
	      = swap8(0x000c000000000000LL
	            | (llu)(swap4(guest0->g1) & 0x03)<<44
	            | (llu)NPC
	            | (llu)(swap4(guest0->g7) & 0x10)<<27
	            | (llu)(swap4(guest0->g7) & 0x0f)<<40);

	    op = swap8(*(llu*)(&gmem0[0x68]));
	    guest0->g1 = swap4((swap4(guest0->g1) & ~0x03)
                             | ((unsigned)(op>>44) & 0x03));
	    guest0->g2 = swap4(((unsigned)(op    ) & 0x7fffffff));
	    guest0->g7 = swap4((swap4(guest0->g7) & ~0x1f)
                             | ((unsigned)(op>>27) & 0x10)
                             | ((unsigned)(op>>40) & 0x0f));
	  }
	  break;
        case 1: /* reserved */
          goto exit_loop;
        case 2: /* Special Instruction */
	  switch ((unsigned)(swap8(guest0->minsn)>>56)) {
	  case 0x0A: /* SVC */
	    {
	      llu op;
#ifdef DEBUG
	      umes("special insn(SVC) continuing...\n");
#endif
	      *(unsigned*)(&gmem0[0x88])
	        = swap4(ILC<<17
                      | (unsigned)(swap8(guest0->minsn)>>48&0xff));
	      *(llu*)(&gmem0[0x20])
		= swap8(0x000c000000000000LL
		      | (llu)(swap4(guest0->g1) & 0x03)<<44
		      | (llu)NPC
		      | (llu)(swap4(guest0->g7) & 0x10)<<27
	              | (llu)(swap4(guest0->g7) & 0x0f)<<40);
	      
	      op = swap8(*(llu*)(&gmem0[0x60]));
	      guest0->g1 = swap4((swap4(guest0->g1) & ~0x03)
			       | ((unsigned)(op>>44) & 0x03));
	      guest0->g2 = swap4(((unsigned)(op    ) & 0x7fffffff));
	      guest0->g7 = swap4((swap4(guest0->g7) & ~0x1f)
			       | ((unsigned)(op>>27) & 0x10)
		               | ((unsigned)(op>>40) & 0x0f));
	    }
	    break;
	  case 0xAF: /* MC */
	    {
	      unsigned b,d;
	      llu op;
#ifdef DEBUG
	      umes("special insn(MC) continuing...\n");
#endif
	      if (swap4(*(unsigned*)&gemm0[0x370]) & (0x00008000>>(swap8(guest0->minsn)>>48&0xf))) {
		*(unsigned*)(&gmem0[0x8c])
		  = swap4(ILC<<17 | 0x40);
		*(llu*)(&gmem0[0x28])
		  = swap8(0x000c000000000000LL
		        | (llu)(swap4(guest0->g1) & 0x03)<<44
		        | (llu)NPC
		        | (llu)(swap4(guest0->g7) & 0x10)<<27
		        | (llu)(swap4(guest0->g7) & 0x0f)<<40);

		op = swap8(*(llu*)(&gmem0[0x68]));
		guest0->g1 = swap4((swap4(guest0->g1) & ~0x03)
		                 | ((unsigned)(op>>44) & 0x03));
		guest0->g2 = swap4(((unsigned)(op    ) & 0x7fffffff));
		guest0->g7 = swap4((swap4(guest0->g7) & ~0x1f)
		                 | ((unsigned)(op>>27) & 0x10)
		                 | ((unsigned)(op>>40) & 0x0f));
		gmem0[0x94] =  0;
		gmem0[0x95] =  (swap8(guest0->minsn)>>48)&0xff;
		b  = (unsigned)(swap8(guest0->minsn)>>44)&0xf;
		d  = (unsigned)(swap8(guest0->minsn)>>32)&0xfff;
		*(unsigned*)(&gmem0[0x9c])
		  = swap4(((swap4(guest0->g7)&0x10)?0x7fffffff:0x00ffffff)
                          &(b?swap4(guest0->m[b])+d:d));
	      }
	      else
		guest0->g2 = swap4(NPC);
	    }
	    break;
	  case 0xB6: /* STCTL */
	    {
	      unsigned b,d;
	      llu op;
#ifdef DEBUG
	      umes("special insn(STCTL) continuing...\n");
#endif
	      /* assume CR8 */
	      guest0->g2 = swap4(NPC);
	      b  = (unsigned)(swap8(guest0->minsn)>>44)&0xf;
	      d  = (unsigned)(swap8(guest0->minsn)>>32)&0xfff;
	      *(unsigned*)&gmem0[b?swap4(guest0->m[b])+d:d] = *(unsigned*)&gemm0[0x370];
	    }
	    break;
	  case 0xB7: /* LCTL */
	    {
	      unsigned b,d;
	      llu op;
#ifdef DEBUG
	      umes("special insn(LCTL) continuing...\n");
#endif
	      /* assume CR8 */
	      guest0->g2 = swap4(NPC);
	      b  = (unsigned)(swap8(guest0->minsn)>>44)&0xf;
	      d  = (unsigned)(swap8(guest0->minsn)>>32)&0xfff;
	      *(unsigned*)&gemm0[0x370] = *(unsigned*)&gmem0[b?swap4(guest0->m[b])+d:d];
	    }
	    break;
	  case 0xBC: /* BCXX */
#ifdef DEBUG
	    umes("special insn(BCXX) continuing...\n");
#endif
	    guest0->g2 = swap4(NPC);
	    break;
	  case 0x82: /* LPSW */
	    {
	      unsigned b,d;
	      llu op;
#ifdef DEBUG
	      umes("special insn(LPSW) continuing...\n");
#endif
	      b  = (unsigned)(swap8(guest0->minsn)>>44)&0xf;
	      d  = (unsigned)(swap8(guest0->minsn)>>32)&0xfff;
	      op = swap8(*(llu*)&gmem0[b?swap4(guest0->m[b])+d:d]);
	      guest0->g1 = swap4((swap4(guest0->g1) & ~0x03)
                               | ((unsigned)(op>>44) & 0x03));
	      guest0->g2 = swap4(((unsigned)(op    ) & 0x7fffffff));
	      guest0->g7 = swap4((swap4(guest0->g7) & ~0x1f)
                               | ((unsigned)(op>>27) & 0x10)
                               | ((unsigned)(op>>40) & 0x0f));
	    }
	    break;
	  case 0x83: /* DIAG */
	    switch ((unsigned)(swap8(guest0->minsn)>>48 & 0xff)) {
	    case 0x01:
	    case 0x02:
	      umes("diagnose insn(FCR-DIAG): 0x%08.8x continuing...\n",
		   (unsigned)(swap8(guest0->minsn)>>32));
	      guest0->g2 = swap4(NPC);
	      break;
	    case 0xD9:
	      umes("diagnose insn(TMP-DIAG): 0x%08.8x continuing...\n",
		   (unsigned)(swap8(guest0->minsn)>>32));
	      guest0->g2 = swap4(NPC);
	      break;
	    case 0xD3:
	      umes("diagnose insn(TMP-DIAG): 0x%08.8x ...NG\n",
		   (unsigned)(swap8(guest0->minsn)>>32));
	      goto exit_loop;
	    case 0xFF:
	      umes("diagnose insn(TMP-DIAG): 0x%08.8x ...OK\n",
		   (unsigned)(swap8(guest0->minsn)>>32));
	      goto exit_loop;
	    default:
#ifdef DEBUG
	      umes("diagnose insn(DIAG): 0x%08.8x\n",
		   (unsigned)(swap8(guest0->minsn)>>32));
#endif
	      guest0->g2 = swap4(NPC);
	      goto exit_loop;
	    }
	    break;
	  case 0xB2: /* B2XX */
	    {
	      unsigned b,d;
	      llu op;
	      static llu clk;
		
	      if ((unsigned)(swap8(guest0->minsn)>>48) == 0xB204) {
#ifdef DEBUG
		umes("special insn(SCK) continuing...\n");
#endif
		guest0->g1 &= swap4(~3); /* CC=0 */
		guest0->g2 = swap4(NPC);
		b  = (unsigned)(swap8(guest0->minsn)>>44)&0xf;
		d  = (unsigned)(swap8(guest0->minsn)>>32)&0xfff;
		clrtime();
		clk = swap8(*(llu*)&gmem0[b?swap4(guest0->m[b])+d:d]);
		break;
	      }
	      else if ((unsigned)(swap8(guest0->minsn)>>48) == 0xB205) {
#ifdef DEBUG
		umes("special insn(STCK) continuing...\n");
#endif
		guest0->g1 &= swap4(~3); /* CC=0 */
		guest0->g2 = swap4(NPC);
		b  = (unsigned)(swap8(guest0->minsn)>>44)&0xf;
		d  = (unsigned)(swap8(guest0->minsn)>>32)&0xfff;
		*(llu*)&gmem0[b?swap4(guest0->m[b])+d:d] = swap8(clk+(i<<12));
		break;
	      }
	      else
		guest0->g2 = swap4(NPC);
	    }
	  default:
#ifdef DEBUG
	    umes("special insn: 0x%08.8x_%08.8x\n",
		 (unsigned)(swap8(guest0->minsn)>>32),
		 (unsigned)(swap8(guest0->minsn)));
#endif
	    guest0->g2 = swap4(NPC);
	    goto exit_loop;
	  }
	  break;
	case 3: /* Extended Function (emm call) */
	  if (extended(guest0, gmem0, NPC-4))
	    goto exit_loop;
	  guest0->g2 = swap4(NPC);
	  break;
	}
}
