
/* def.h 1995/7/18 */

/* M-on-RISC Dynamically Translating Simulator */
/*       Copyright (C) 1995 by FUJITSU LIMITED */
/*                 Primary writer: Y.Nakashima */
/*          nakashim@pine.mfd.cs.fujitsu.co.jp */

#ifndef LLU_DEFINED
typedef long long unsigned llu;
typedef long long int      ll;
#define LLU_DEFINED
#endif

#ifndef IBUF_PAGESIZE
#define IBUF_PAGESIZE	32768
#endif

#ifndef IBUF_SIZE
#define IBUF_SIZE	32768*16
#endif

#ifndef GUEST_PAGESIZE
#define GUEST_PAGESIZE  4096
#endif

#ifndef GUEST_MEMSIZE
#define GUEST_MEMSIZE   2097152 /* default size is 2MB */
#endif

#ifndef GUEST_STKSIZE
#define GUEST_STKSIZE   1048576 /* default size is 1MB */
#endif

struct m_op {
    char          *name;
    char          *args;
    int           mlen;
    int           (*cfunc)();
    int           (*tfunc)();
    int           term; /* 0:continue, 1:terminate */
    int           (*ifunc)();
    int           (*jfunc)();
};

llu		  m_step;	/* M step */

struct guest { /* must be aligned to 64B boundary */
    unsigned	  m[16];	/* +  0 ref by dim/emm */
    llu		  f[8];		/* + 64 ref by dim/emm */

    unsigned	  g0; /*reserved/* +128 (ignoded)      */
    unsigned	  g1;		/* +132 ref by dim/emm */
    unsigned	  g2;		/* +136 ref by dim/emm */
    unsigned	  g3;		/* +140 ref by dim/emm */
    unsigned	  g4;		/* +144 ref by dim/emm */
    unsigned	  g5;		/* +148 ref by dim/emm */
    unsigned	  g6; /*reserved/* +152 (ignored)      */
    unsigned	  g7; /*reserved/* +156 (ignored)      */
    unsigned      guest_memsize;/* +160 ->g3           */
    unsigned char *guest_mem;	/* +164 ->g4           */
    unsigned      host_imapsize;/* +168 ->g3           */
    unsigned      *host_imap;	/* +172 ->g5           */
    unsigned      host_bufpsize;/* +176 (alloc)        */
    unsigned char **host_ibufpp;/* +180 (alloc)        */
    unsigned char *ibuf;	/* +184 (alloc)        */
    unsigned char *freep;	/* +188 (alloc)        */
    unsigned char *interp_ibuf;	/* +192 ref by dim/emm */
    unsigned      csa;		/* +196 ref by dim/emm */
    llu		  minsn;	/* +200 ref by dim     */
    unsigned	  mlen;		/* +208 ref by dim     */
    unsigned	  cfunc;	/* +212 ref by dim     */
    unsigned	  tfunc;	/* +216 ref by dim     */
    unsigned	  term;		/* +220 ref by dim     */
    unsigned	  slen;		/* +224 ref by dim     */
    unsigned	  viarsave;	/* +228 ref by dim     */
    unsigned	  flusha;	/* +232 ref by dim     */
    unsigned	  ibufbpa;	/* +236 ref by dim     */
    unsigned	  rsv1;		/*      +240           */
    unsigned	  rsv2;		/*      +244           */
    unsigned	  rsv3;		/*      +248           */
    unsigned	  retasave;	/* +252 ref by dim     */

    unsigned	  param01[4];	/* +256 ref by dim     */
    unsigned	  param02[4];	/* +272 ref by dim     */
    unsigned	  rsv4[27];	/*      +288           */
    unsigned	  pa_mstep;	/* +396 ref by dim/emm */
    unsigned	  pa_trans;	/* +400 ref by dim/emm */
    unsigned	  pa_sinsn;	/* +404 ref by dim/emm */
    unsigned	  pa_pinsn;	/* +408 ref by dim/emm */
    unsigned	  br_hist_top;	/* +412 ref by dim/emm */
    unsigned	  br_hist_cp;	/* +416 ref by dim/emm */
    unsigned	  rsv5[21];	/*      +420           */
    unsigned	  cslocka;	/* +504 ref by dim/emm */
    unsigned	  emmptr;	/* +508 ref by     emm */
};

