
static char UtilRcsId[] =
"$Id: util.c,v 1.6 1996/12/24 07:30:37 nakashim Exp nakashim $";

/* util.c 1995/7/18 */

/* M-on-RISC Dynamically Translating Simulator */
/*       Copyright (C) 1995 by FUJITSU LIMITED */
/*                 Primary writer: Y.Nakashima */
/*          nakashim@pine.mfd.cs.fujitsu.co.jp */

unsigned char e2adump[] = {
 '.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.',
 '.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.',
 '.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.',
 '.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.',
 ' ','.','.','.','.','.','.','.','.','.','.','.','<','(','+','|',
 '&','.','.','.','.','.','.','.','.','.','!','$','*',')',';','^',
 '-','/','.','.','.','.','.','.','.','.','.',',','%','_','>','?',
 '.','.','.','.','.','.','.','.','.','.',':','#','@','\'','=','\"',/*"*/
 '.','a','b','c','d','e','f','g','h','i','.','.','.','.','.','.',
 '.','j','k','l','m','n','o','p','q','r','.','.','.','.','.','.',
 '.','~','s','t','u','v','w','x','y','z','.','.','.','[','.','.',
 '.','.','.','.','.','.','.','.','.','.','.','.','.',']','.','.',
 '{','A','B','C','D','E','F','G','H','I','.','.','.','.','.','.',
 '}','J','K','L','M','N','O','P','Q','R','.','.','.','.','.','.',
'\\','.','S','T','U','V','W','X','Y','Z','.','.','.','.','.','.',
 '0','1','2','3','4','5','6','7','8','9','.','.','.','.','.','.'};

disasm(guest, gmem, addr)
  struct guest *guest;
  unsigned char* gmem;
  unsigned addr;
{
  struct m_op *optblp;
  llu insn;
  unsigned char opcd;
  char *name;
  char *args;
  int mlen;

  opcd = gmem[addr];
  if (opcd != 0xb2)
    optblp = optable;
  else {
    opcd = gmem[addr+1];
    optblp = optb2xx;
  }
  insn = 0LL;

#ifdef MEMDIRECT
  name = optblp[opcd].name;
  args = optblp[opcd].args;
  mlen = optblp[opcd].mlen;
#else
  name = &mem[swap4(optblp[opcd].name)];
  args = &mem[swap4(optblp[opcd].args)];
  mlen = swap4(optblp[opcd].mlen);
#endif

  switch (mlen) {
  case 6:
    insn |= (llu)gmem[addr+5] << 16;
    insn |= (llu)gmem[addr+4] << 24;
  case 4:
    insn |= (llu)gmem[addr+3] << 32;
    insn |= (llu)gmem[addr+2] << 40;
  case 2:
    insn |= (llu)gmem[addr+1] << 48;
    insn |= (llu)gmem[addr  ] << 56;
    break;
  default:
    message("internal error: optblp[0x%02.2x].mlen=%d\n", opcd, mlen);
    return(2);
    break;
  }

  switch (mlen) {
  case 6:
    message("%06.6x: %04.4x %04.4x %04.4x %-6s",
      addr,
      (int)((insn >> 48) & 0xffff),
      (int)((insn >> 32) & 0xffff),
      (int)((insn >> 16) & 0xffff),
      name);
    break;
  case 4:
    message("%06.6x: %04.4x %04.4x      %-6s",
      addr,
      (int)((insn >> 48) & 0xffff),
      (int)((insn >> 32) & 0xffff),
      name);
    break;
  case 2:
    message("%06.6x: %04.4x           %-6s",
      addr,
      (int)((insn >> 48) & 0xffff),
      name);
    break;
  }

  for (;;) {
    switch (*args++) {
    case '\0':
      message("\n");
      return(mlen);
      break;
    case ',':
      message(",");
      break;
    case '1': /* r1 */
      message("%d", (int)((insn >> 52) & 0xf));
      break;
    case '2': /* r2 */
      message("%d", (int)((insn >> 48) & 0xf));
      break;
    case '3': /* dxr-r1 */
      message("%d", (int)((insn >> 36) & 0xf));
      break;
    case '4': /* dxr-r2 */
      message("%d", (int)((insn >> 32) & 0xf));
      break;
    case 'a': /* d2(x2,b2) */
      message("%d(%d,%d)",
        (int)((insn >> 32) & 0xfff),
        (int)((insn >> 48) & 0xf),
        (int)((insn >> 44) & 0xf));
      break;
    case 'b': /* d1(b1)/d2(b2) */
      message("%d(%d)",
        (int)((insn >> 32) & 0xfff),
        (int)((insn >> 44) & 0xf));
      break;
    case 'c': /* d1(l,b1) */
      message("%d(%d,%d)",
        (int)((insn >> 32) & 0xfff),
        (int)((insn >> 48) & 0xff)+1,
        (int)((insn >> 44) & 0xf));
      break;
    case 'd': /* d2(b2) */
      message("%d(%d)",
        (int)((insn >> 16) & 0xfff),
        (int)((insn >> 28) & 0xf));
      break;
    case 'f': /* d1(l1,b1) */
      message("%d(%d,%d)",
        (int)((insn >> 32) & 0xfff),
        (int)((insn >> 52) & 0xf)+1,
        (int)((insn >> 44) & 0xf));
      break;
    case 'g': /* d2(l2,b2) */
      message("%d(%d,%d)",
        (int)((insn >> 16) & 0xfff),
        (int)((insn >> 48) & 0xf)+1,
        (int)((insn >> 28) & 0xf));
      break;
    case 'i': /* i2 */
      message("%d", (int)((insn >> 48) & 0xff));
      break;
    case 'j': /* i3 */
      message("%d", (int)((insn >> 48) & 0xf));
      break;
    case 'm': /* m1 */
      message("%d", (int)((insn >> 52) & 0xf));
      break;
    case 'n': /* m3 */
      message("%d", (int)((insn >> 48) & 0xf));
      break;
    case 'x': /* diagnose */
      message("%d", (int)((insn >> 32) & 0xffffff));
      break;
    default:
      message("internal error: optblp[0x%02.2x].args=\"%s\"\n",
               opcd, args);
      return(mlen);
      break;
    }
  }
}

disp_stat(guest)
  struct guest *guest;
{
  int   i, j;
  char *bufP;
  char *sym;

  static unsigned m[16];
  static llu      f[8];

  if (!sc_noupdate || m[0] != guest->m[0] || m[1] != guest->m[1]
                   || m[2] != guest->m[2] || m[3] != guest->m[3]
                   || f[0] != guest->f[0] || f[1] != guest->f[1]) {
    scr_move(1);
    printf("m0: %08.8x %08.8x %08.8x %08.8x ",
 	    swap4(guest->m[0]), swap4(guest->m[1]),
            swap4(guest->m[2]), swap4(guest->m[3]));
    printf("f0: %08.8x-%08.8x %08.8x-%08.8x",
	    (int)(swap8(guest->f[0])>>32), (int)swap8(guest->f[0]),
	    (int)(swap8(guest->f[1])>>32), (int)swap8(guest->f[1]));
    scr_eol();
  }

  if (!sc_noupdate || m[4] != guest->m[4] || m[5] != guest->m[5]
                   || m[6] != guest->m[6] || m[7] != guest->m[7]
                   || f[2] != guest->f[2] || f[3] != guest->f[3]) {
    scr_move(2);
    printf("m4: %08.8x %08.8x %08.8x %08.8x ",
	    swap4(guest->m[4]), swap4(guest->m[5]),
            swap4(guest->m[6]), swap4(guest->m[7]));
    printf("f4: %08.8x-%08.8x %08.8x-%08.8x",
	    (int)(swap8(guest->f[2])>>32), (int)swap8(guest->f[2]),
	    (int)(swap8(guest->f[3])>>32), (int)swap8(guest->f[3]));
    scr_eol();
  }

  if (!sc_noupdate || m[ 8] != guest->m[ 8] || m[ 9] != guest->m[ 9]
                   || m[10] != guest->m[10] || m[11] != guest->m[11]
                   || f[ 4] != guest->f[ 4] || f[ 5] != guest->f[ 5]) {
    scr_move(3);
    printf("m8: %08.8x %08.8x %08.8x %08.8x ",
	    swap4(guest->m[8]), swap4(guest->m[9]),
            swap4(guest->m[10]), swap4(guest->m[11]));
    printf("f8: %08.8x-%08.8x %08.8x-%08.8x",
	    (int)(swap8(guest->f[4])>>32), (int)swap8(guest->f[4]),
	    (int)(swap8(guest->f[5])>>32), (int)swap8(guest->f[5]));
    scr_eol();
  }

  if (!sc_noupdate || m[12] != guest->m[12] || m[13] != guest->m[13]
                   || m[14] != guest->m[14] || m[15] != guest->m[15]
                   || f[ 6] != guest->f[ 6] || f[ 7] != guest->f[ 7]) {
    scr_move(4);
    printf("m12 %08.8x %08.8x %08.8x %08.8x ",
	    swap4(guest->m[12]), swap4(guest->m[13]),
            swap4(guest->m[14]), swap4(guest->m[15]));
    printf("f12 %08.8x-%08.8x %08.8x-%08.8x",
 	    (int)(swap8(guest->f[6])>>32), (int)swap8(guest->f[6]),
	    (int)(swap8(guest->f[7])>>32), (int)swap8(guest->f[7]));
    scr_eol();
  }

#ifdef SPECIALBOTTOM
  scr_move(sc_lines-1);
#else
  scr_move(sc_lines);
#endif
  printf("\033[36;2mIAR=%08.8x DS=%08.8x_%08.8x",
	 swap4(guest->g2),
         (int)(m_step>>32), (int)m_step);
  printf(" CC=%01.1x G7=%08.8x\033[0;0m",
         swap4(guest->g1)&3,
         swap4(guest->g7));
  scr_eol();

  scr_bot();

  sc_noupdate = 1;
  for (i=0; i<16; i++)
    m[i] = guest->m[i];
  for (i=0; i<8; i++)
    f[i] = guest->f[i];
}

req_system(s) char *s;
{
  scr_reset();
  if (system(s) == -1)
    message("can't fork \"%s\"\n", s);
#ifdef SPECIALBOTTOM
  scr_up();
#endif
  scr_setr(5);
}

message(s, i, j, k, l, m)
  char *s;
  int  i, j, k, l, m;
{
  log_output(s, i, j, k, l, m);
  printf(s, i, j, k, l, m);
}

log_output(s, i, j, k, l, m)
  char *s;
  int  i, j, k, l, m;
{
  fprintf(log_fp, s, i, j, k, l, m);
  fflush(log_fp);
}

scr_up()
{
  printf("\033[%uH\n", sc_lines);
}

scr_eol()
{
  printf("\033[K");
}

scr_move(r) {
  printf("\033[%uH", r);
}

scr_setr(r)
{
  scr_up();
  printf("\033[%uH\033[K", sc_lines);
#ifdef SPECIALBOTTOM
  printf("\033[%u;%ur", r, sc_lines-2);
#else
  printf("\033[%u;%ur", r, sc_lines-1);
#endif
  scr_bot();
  scr_eol();
}

scr_reset()
{
  printf("\033[1;%ur", sc_lines);
#ifdef SPECIALBOTTOM
  printf("\033[%uH", sc_lines-1);
#else
  printf("\033[%uH", sc_lines);
#endif
  fflush(stdout);
}

scr_bot()
{
#ifdef SPECIALBOTTOM
  printf("\033[%uH", sc_lines-2);
#else
  printf("\033[%uH", sc_lines-1);
#endif
  fflush(stdout);
}

mset(addr, d, len)
  char *addr;
  char d;
  int len;
{
  for (;len; len--)
    *addr++ = d;
}

char *
version()
{
  char *i;
  extern char RcsId[];

  for (i=RcsId; *i && *i!=' '; i++);
  for (       ; *i && *i==' '; i++);
  for (       ; *i && *i!=' '; i++);
  for (       ; *i && *i==' '; i++);
  return(i);
}

