
static char RcsId[] =
"$Id: main3.c,v 1.17 1997/04/10 12:32:22 nakashim Exp nakashim $";

/* main3.c 1995/7/18 */

/* M-on-RISC Dynamically Translating Simulator */
/*       Copyright (C) 1995 by FUJITSU LIMITED */
/*                 Primary writer: Y.Nakashima */
/*          nakashim@pine.mfd.cs.fujitsu.co.jp */

#include "../common/mdef.h"
#include "data"

_start()
{
#if 1
  /* init %TBR */
  asm("sethi %hi(0xff003000),%l0");
  asm("or %l0,%lo(0xff003000),%l0");
  asm("wr %l0,0,%tbr");  /* TBR=0xff003000 */
#endif

#if 0
  /* init %PSR */
  asm("sethi %hi(0x00001fc6),%l0");
  asm("or %l0,%lo(0x00001fc6),%l0");
  asm("wr %l0,0,%psr");  /* LEVEL=F */
  asm("or %l0,0x20,%l0");
  asm("wr %l0,0,%psr");  /* ET=1 */
#endif

#if 0
  /* initialize %WIM */
  asm("wr %g0,0x80,%wim");
  asm("nop");
  asm("nop");
  asm("nop");
#endif

  /* initialize %sp */
  asm("sethi %hi(0x017fffe0),%sp");
  asm("or %sp,%lo(0x017fffe0),%sp");

  main();
}

main()
{
  int obj_fd, addr, size, i;
  long	exectime, gettime();
  char  *version();
  unsigned miss, reference;
  unsigned char *sp, *ep;
  struct guest *guest0;
  unsigned char* gmem0;
  unsigned char* gemm0;
  int dim_version;
  extern unsigned dim_info[];

  /* enable ACTION.MIX */
  asm("lda [%g0]0x4c,%l0");
  asm("sethi %hi(0x1000),%l1");
  asm("or %l0,%l1,%l0");
  asm("sta %l0,[%g0]0x4c");

  /* page table base = 0x00007000 (16MB page mode) */
  *(unsigned*)0x00007404 = 0x001000ee; /* 0x01000000 as chacheable */
  *(unsigned*)0x00007408 = 0x002000ee; /* 0x02000000 as chacheable */

  /* flush MMU PDC */
  asm("sethi %hi(0x01000200),%l0");
  asm("or %l0,%lo(0x01000200),%l0");
  asm("sta %g0,[%l0]0x03");
  asm("sethi %hi(0x02000200),%l0");
  asm("or %l0,%lo(0x02000200),%l0");
  asm("sta %g0,[%l0]0x03");

  /* flush cache */
  asm("sta %g0,[%g0]0x36");
  asm("sta %g0,[%g0]0x37");
  asm("sethi %hi(0x80000000),%l0");
  asm("sta %g0,[%l0]0x36");
  asm("sta %g0,[%l0]0x37");

  /* change MMU MCNTL (I/D cacheable) */
  asm("sethi %hi(0x04015701),%l0");
  asm("or %l0,%lo(0x04015701),%l0");
  asm("sta %l0,[%g0]0x04");

  /* change MCC CCCR (I/D cacheable) */
  asm("sethi %hi(0x01c00a00),%l0");
  asm("or %l0,%lo(0x01c00a00),%l0");
  asm("or %g0,%g0,%l2");
  asm("or %g0,0x0c,%l3");
  asm("stda %l2,[%l0]0x02");

#if 0
  /* disable memory patrol */
  asm("sethi %hi(0xfff00118),%l0");
  asm("or %l0,%lo(0xfff00118),%l0");
  asm("sta %g0,[%l0]0x20");
#endif

/* small */
  guest0                       = (struct guest*)  0x01975800;
  mset(guest0, 0, sizeof(struct guest));
  gmem0                        = (unsigned char*) 0x01a00000;
  gemm0                        = (unsigned char*) 0x01975000;
  guest0->guest_mem            = (unsigned char*) 0x01a00000;
  guest0->host_imap            = (unsigned*)      0x01c00000;
  guest0->host_ibufpp          = (unsigned char**)0x01976000;
  guest0->ibuf = guest0->freep = (unsigned char*) 0x01980000;
  guest0->interp_ibuf          = (unsigned char*) 0x01978000;
  guest0->cslocka              =                  0x019757fc;
  guest0->emmptr               =                  0x01975000;
  guest0->pa_trans    = 0x00000000;
  guest0->pa_sinsn    = dim_info[3];
  guest0->pa_pinsn    = dim_info[4];
  guest0->br_hist_top = dim_info[5];
  guest0->br_hist_cp  = dim_info[5];
  dim_version         = dim_info[0];
/* fast *//*
  guest0                       = (struct guest*)  0x02040000;
  mset(guest0, 0, sizeof(struct guest));
  guest0->guest_mem            = (unsigned char*) 0x02200000;
  guest0->host_imap            = (unsigned*)      0x02800000;
  guest0->host_ibufpp          = (unsigned char**)0x02054000;
  guest0->ibuf = guest0->freep = (unsigned char*) 0x02080000;
  guest0->interp_ibuf          = (unsigned char*) 0x02108000;*/
/* slow *//*
  guest0                       = (struct guest*)  0x03000000;
  mset(guest0, 0, sizeof(struct guest));
  guest0->guest_mem            = (unsigned char*) 0x02400000;
  guest0->host_imap            = (unsigned*)      0x02000000;
  guest0->host_ibufpp          = (unsigned char**)0x02688000;
  guest0->ibuf = guest0->freep = (unsigned char*) 0x02600000;
  guest0->interp_ibuf          = (unsigned char*) 0x02680000;*/

  guest0->guest_memsize = GUEST_MEMSIZE;
  guest0->host_imapsize = (GUEST_MEMSIZE/2)*4;
  guest0->host_bufpsize = (GUEST_MEMSIZE/GUEST_PAGESIZE)*16;

  guest0->m[12] = GUEST_MEMSIZE-256;
  guest0->m[13] = GUEST_MEMSIZE-GUEST_STKSIZE;
  guest0->m[14] = GUEST_MEMSIZE-128;
  sp = guest0->guest_mem+GUEST_MEMSIZE-GUEST_STKSIZE;
  *(unsigned*)(sp+ 72) = 0x12345678;
  *(unsigned*)(sp+ 76) = GUEST_MEMSIZE-GUEST_STKSIZE+80;
  ep = guest0->guest_mem+GUEST_MEMSIZE-256;
  *(unsigned*)(ep+ 12) = GUEST_MEMSIZE-256;
  *(unsigned*)(ep+116) = GUEST_MEMSIZE-136;
  *(unsigned*)(ep+120) = 0x41000FFE;
  *(unsigned*)(ep+124) = 0x47000FED;
  *(unsigned*)(ep+128) = 0x41000FFF;
  *(unsigned*)(ep+132) = 0x47000FED;

  /* read load-module */
#if 0
#define PROGRAM "test/stan"
  if ((obj_fd = open(PROGRAM, 0)) == -1)
    pr("can't open \"%s\"\n", PROGRAM);
  else {
    addr = 0;
    while ((size = read(obj_fd, guest0->guest_mem+addr, 8192)) == 8192)
      addr += 8192;
    addr += size;
  }
#else
  for (addr=0; addr < sizeof (mobj); addr+=2)
    *(unsigned short*)(guest0->guest_mem+addr) = mobj[addr/2];
#endif

  pr("M-on-RISC Dynamically Translating Simulator\n");
  pr("Version %s\n", version());
  pr(" guest0=0x%08.8x\n", guest0);
  pr(" guest_mem=0x%08.8x guest_memsize=%u\n", guest0->guest_mem, guest0->guest_memsize);
  pr(" host_imap=0x%08.8x host_imapsize=%u\n", guest0->host_imap, guest0->host_imapsize);
  pr(" ibufpp=0x%08.8x\n", guest0->host_ibufpp);
  pr(" ibuf  =0x%08.8x i_ibuf=0x%08.8x\n", guest0->ibuf, guest0->interp_ibuf);
  pr(" ibuf_pagesize=%u ibuf_size=%u\n", IBUF_PAGESIZE, IBUF_SIZE);
  pr(" object=0x00000000-0x%08.8x\n", addr-1);
  pr(" stack =0x%08.8x-0x%08.8x\n", GUEST_MEMSIZE-GUEST_STKSIZE, GUEST_MEMSIZE-257);
  pr(" stkov =0x%08.8x-0x%08.8x\n", GUEST_MEMSIZE-256, GUEST_MEMSIZE-1);

  guest0->g1 = 0x00000000;
  guest0->g2 = 0x00000000;
  guest0->g3 = 0x00ffffff;
  guest0->g4 = (unsigned)guest0->guest_mem;
  guest0->g5 = (unsigned)guest0->host_imap;
  guest0->g7 = 0x00000820; /* IM=1,AM=0,PROG=0 */

  /* reset Miss/Reference Counter (2'nd cache) */
  asm("sethi %hi(0x01c00300),%l0");
  asm("or %l0,%lo(0x01c00300),%l0");
  asm("or %g0,%g0,%l2");
  asm("or %g0,%g0,%l3");
  asm("stda %l2,[%l0]0x02");

  clrtime();
  for (i=0;; i++) {
    m_step++;
    guest0->g7 &= ~0xc1ff0000;
    asm("ld %0,%%g7":"=m"(guest0->g7)::"%g7");
    dim_prog(guest0);
    asm("st %%g7,%0":"=m"(guest0->g7)::"%g7");

#include "../common/control.c"

  }
exit_loop:
  exectime = gettime();

  /* read Miss/Reference Counter (2'nd cache) */
  asm("sethi %hi(0x01c00300),%l6");
  asm("or %l0,%lo(0x01c00300),%l6");
  asm("ldda [%l6]0x02,%o0");
  asm("st %%o0,%0" : "=g" (miss) : : "%o0");
  asm("st %%o1,%0" : "=g" (reference) : : "%o1");
  pr("E-cache miss=0x%08.8x reference=0x%08.8x\n", miss, reference);

  pr("CPU break at 0x%08.8x (exec_time=%umsec)\n", guest0->g2, exectime);
  pr("guest0->g1,g7=0x%08.8x,0x%08.8x\n", guest0->g1, guest0->g7);

  _exit(0);
}

mset(addr, d, len)
  char *addr;
  char d;
  int len;
{
  for (;len; len--)
    *addr++ = d;
}

char *
version()
{
  char *i;
  extern char RcsId[];

  for (i=RcsId; *i && *i!=' '; i++);
  for (       ; *i && *i==' '; i++);
  for (       ; *i && *i!=' '; i++);
  for (       ; *i && *i==' '; i++);
  return(i);
}

