
static char RcsId[] =
"$Id: ip.c,v 1.4 1996/07/26 00:53:19 nakashim Exp nakashim $";

/* ip.c 1996/3/22 */

/* SPARC Integer Instruction Simulator         */
/*       Copyright (C) 1995 by FUJITSU LIMITED */
/*                 Primary writer: Y.Nakashima */
/*          nakashim@pine.mfd.cs.fujitsu.co.jp */

#include <stdio.h>
#include <sys/times.h>
#include <unistd.h>
#include <sys/file.h>
#include "sdef.h"

int	i_add(), i_addcc(), i_addx(), i_addxcc(), i_sub(), i_subcc();
int	i_subx(), i_subxcc(), i_sdiv(), i_sdivcc(), i_smul(), i_smulcc();
int	i_udiv(), i_udivcc(), i_umul(), i_umulcc(), i_and(), i_andcc();
int	i_andn(), i_andncc(), i_or(), i_orcc(), i_orn(), i_orncc();
int	i_xor(), i_xorcc(), i_xnor(), i_xnorcc(), i_sll(), i_srl();
int	i_sra(), i_sethi(), i_save(), i_restore(), i_ldsb(), i_ldsh();
int	i_ldub(), i_lduh(), i_ld(), i_ldd(), i_lda(), i_stb(), i_sth();
int	i_st(), i_std(), i_ldstub(), i_bicc(), i_call(), i_jmpl();
int	i_ticc(), i_rdy(), i_wry(), i_unimp(), i_flush(), i_xxx();

struct sparc_op insn00[] = {
    { "unimp",	i_unimp },	/* 0x0 */
    { "xxx",	i_xxx },	/* 0x1 */
    { "bicc",	i_bicc },	/* 0x2 */
    { "xxx",	i_xxx },	/* 0x3 */
    { "sethi",	i_sethi },	/* 0x4 */
    { "xxx",	i_xxx },	/* 0x5 */
    { "xxx",	i_xxx },	/* 0x6 */
    { "xxx",	i_xxx },	/* 0x7 */
};

struct sparc_op insn01[] = {
    { "call",	i_call },	/* 0x0 */
};

struct sparc_op insn10[] = {
    { "add",	i_add },	/* 0x00 */
    { "and",	i_and },	/* 0x01 */
    { "or",	i_or },		/* 0x02 */
    { "xor",	i_xor },	/* 0x03 */
    { "sub",	i_sub },	/* 0x04 */
    { "andn",	i_andn },	/* 0x05 */
    { "orn",	i_orn },	/* 0x06 */
    { "xnor",	i_xnor },	/* 0x07 */
    { "addx",	i_addx },	/* 0x08 */
    { "xxx",	i_xxx },	/* 0x09 */
    { "umul",	i_umul },	/* 0x0a */
    { "smul",	i_smul },	/* 0x0b */
    { "subx",	i_subx },	/* 0x0c */
    { "xxx",	i_xxx },	/* 0x0d */
    { "udiv",	i_udiv },	/* 0x0e */
    { "sdiv",	i_sdiv },	/* 0x0f */
    { "addcc",	i_addcc },	/* 0x10 */
    { "andcc",	i_andcc },	/* 0x11 */
    { "orcc",	i_orcc },	/* 0x12 */
    { "xorcc",	i_xorcc },	/* 0x13 */
    { "subcc",	i_subcc },	/* 0x14 */
    { "andncc",	i_andncc },	/* 0x15 */
    { "orncc",	i_orncc },	/* 0x16 */
    { "xnorcc",	i_xnorcc },	/* 0x17 */
    { "addxcc",	i_addxcc },	/* 0x18 */
    { "xxx",	i_xxx },	/* 0x19 */
    { "umulcc",	i_umulcc },	/* 0x1a */
    { "smulcc",	i_smulcc },	/* 0x1b */
    { "subxcc",	i_subxcc },	/* 0x1c */
    { "xxx",	i_xxx },	/* 0x1d */
    { "udivcc",	i_udivcc },	/* 0x1e */
    { "sdivcc",	i_sdivcc },	/* 0x1f */
    { "xxx",	i_xxx },	/* 0x20 */
    { "xxx",	i_xxx },	/* 0x21 */
    { "xxx",	i_xxx },	/* 0x22 */
    { "xxx",	i_xxx },	/* 0x23 */
    { "xxx",	i_xxx },	/* 0x24 */
    { "sll",	i_sll },	/* 0x25 */
    { "srl",	i_srl },	/* 0x26 */
    { "sra",	i_sra },	/* 0x27 */
    { "rdy",	i_rdy },	/* 0x28 */
    { "xxx",	i_xxx },	/* 0x29 */
    { "xxx",	i_xxx },	/* 0x2a */
    { "xxx",	i_xxx },	/* 0x2b */
    { "xxx",	i_xxx },	/* 0x2c */
    { "xxx",	i_xxx },	/* 0x2d */
    { "xxx",	i_xxx },	/* 0x2e */
    { "xxx",	i_xxx },	/* 0x2f */
    { "wry",	i_wry },	/* 0x30 */
    { "xxx",	i_xxx },	/* 0x31 */
    { "xxx",	i_xxx },	/* 0x32 */
    { "xxx",	i_xxx },	/* 0x33 */
    { "xxx",	i_xxx },	/* 0x34 */
    { "xxx",	i_xxx },	/* 0x35 */
    { "xxx",	i_xxx },	/* 0x36 */
    { "xxx",	i_xxx },	/* 0x37 */
    { "jmpl",	i_jmpl },	/* 0x38 */
    { "xxx",	i_xxx },	/* 0x39 */
    { "ticc",	i_ticc },	/* 0x3a */
    { "flush",	i_flush },	/* 0x3b */
    { "save",	i_save },	/* 0x3c */
    { "restore",i_restore },	/* 0x3d */
    { "xxx",	i_xxx },	/* 0x3e */
    { "xxx",	i_xxx },	/* 0x3f */
};

struct sparc_op insn11[] = {
    { "ld",	i_ld },		/* 0x00 */
    { "ldub",	i_ldub },	/* 0x01 */
    { "lduh",	i_lduh },	/* 0x02 */
    { "ldd",	i_ldd },	/* 0x03 */
    { "st",	i_st },		/* 0x04 */
    { "stb",	i_stb },	/* 0x05 */
    { "sth",	i_sth },	/* 0x06 */
    { "std",	i_std },	/* 0x07 */
    { "xxx",	i_xxx },	/* 0x08 */
    { "ldsb",	i_ldsb },	/* 0x09 */
    { "ldsh",	i_ldsh },	/* 0x0a */
    { "xxx",	i_xxx },	/* 0x0b */
    { "xxx",	i_xxx },	/* 0x0c */
    { "ldstub",	i_ldstub },	/* 0x0d */
    { "xxx",	i_xxx },	/* 0x0e */
    { "xxx",	i_xxx },	/* 0x0f */
    { "lda",	i_lda },	/* 0x10 */
    { "xxx",	i_xxx },	/* 0x11 */
    { "xxx",	i_xxx },	/* 0x12 */
    { "xxx",	i_xxx },	/* 0x13 */
    { "xxx",	i_xxx },	/* 0x14 */
    { "xxx",	i_xxx },	/* 0x15 */
    { "xxx",	i_xxx },	/* 0x16 */
    { "xxx",	i_xxx },	/* 0x17 */
    { "xxx",	i_xxx },	/* 0x18 */
    { "xxx",	i_xxx },	/* 0x19 */
    { "xxx",	i_xxx },	/* 0x1a */
    { "xxx",	i_xxx },	/* 0x1b */
    { "xxx",	i_xxx },	/* 0x1c */
    { "xxx",	i_xxx },	/* 0x1d */
    { "xxx",	i_xxx },	/* 0x1e */
    { "xxx",	i_xxx },	/* 0x1f */
    { "xxx",	i_xxx },	/* 0x20 */
    { "xxx",	i_xxx },	/* 0x21 */
    { "xxx",	i_xxx },	/* 0x22 */
    { "xxx",	i_xxx },	/* 0x23 */
    { "xxx",	i_xxx },	/* 0x24 */
    { "xxx",	i_xxx },	/* 0x25 */
    { "xxx",	i_xxx },	/* 0x26 */
    { "xxx",	i_xxx },	/* 0x27 */
    { "xxx",	i_xxx },	/* 0x28 */
    { "xxx",	i_xxx },	/* 0x29 */
    { "xxx",	i_xxx },	/* 0x2a */
    { "xxx",	i_xxx },	/* 0x2b */
    { "xxx",	i_xxx },	/* 0x2c */
    { "xxx",	i_xxx },	/* 0x2d */
    { "xxx",	i_xxx },	/* 0x2e */
    { "xxx",	i_xxx },	/* 0x2f */
    { "xxx",	i_xxx },	/* 0x30 */
    { "xxx",	i_xxx },	/* 0x31 */
    { "xxx",	i_xxx },	/* 0x32 */
    { "xxx",	i_xxx },	/* 0x33 */
    { "xxx",	i_xxx },	/* 0x34 */
    { "xxx",	i_xxx },	/* 0x35 */
    { "xxx",	i_xxx },	/* 0x36 */
    { "xxx",	i_xxx },	/* 0x37 */
    { "xxx",	i_xxx },	/* 0x38 */
    { "xxx",	i_xxx },	/* 0x39 */
    { "xxx",	i_xxx },	/* 0x3a */
    { "xxx",	i_xxx },	/* 0x3b */
    { "xxx",	i_xxx },	/* 0x3c */
    { "xxx",	i_xxx },	/* 0x3d */
    { "xxx",	i_xxx },	/* 0x3e */
    { "xxx",	i_xxx },	/* 0x3f */
};

int i_add(i) unsigned i;
{
  pc = npc;
  npc += 4;
  *m[i>>25&31] = *m[i>>14&31] + ((i&0x2000)?((int)(i<<19)>>19):*m[i&31]);
  *m[0] = 0;
  return(0);
}

int i_addcc(i) unsigned i;
{
  unsigned s1, s2, d;

  pc = npc;
  npc += 4;
  s1 = *m[i>>14&31];
  s2 = (i&0x2000)?((int)(i<<19)>>19):*m[i&31];
  *m[i>>25&31] = d = s1 + s2;
  *m[0] = 0;
  cc_n = d>>31;
  cc_z = d==0;
  cc_v = (s1>>31&&s2>>31&&!(d>>31)) || (!(s1>>31)&&!(s2>>31)&&d>>31);
  cc_c = (s1>>31&&s2>>31) || (!(d>>31)&&(s1>>31||s2>>31));
  return(0);
}

int i_addx(i) unsigned i;
{
  pc = npc;
  npc += 4;
  *m[i>>25&31] = *m[i>>14&31] + ((i&0x2000)?((int)(i<<19)>>19):*m[i&31]) + cc_c;
  *m[0] = 0;
  return(0);
}

int i_addxcc(i) unsigned i;
{
  unsigned s1, s2, d;

  pc = npc;
  npc += 4;
  s1 = *m[i>>14&31];
  s2 = (i&0x2000)?((int)(i<<19)>>19):*m[i&31];
  *m[i>>25&31] = d = s1 + s2 + cc_c;
  *m[0] = 0;
  cc_n = d>>31;
  cc_z = d==0;
  cc_v = (s1>>31&&s2>>31&&!(d>>31)) || (!(s1>>31)&&!(s2>>31)&&d>>31);
  cc_c = (s1>>31&&s2>>31) || (!(d>>31)&&(s1>>31||s2>>31));
  return(0);
}

int i_sub(i) unsigned i;
{
  pc = npc;
  npc += 4;
  *m[i>>25&31] = *m[i>>14&31] - ((i&0x2000)?((int)(i<<19)>>19):*m[i&31]);
  *m[0] = 0;
  return(0);
}

int i_subcc(i) unsigned i;
{
  unsigned s1, s2, d;

  pc = npc;
  npc += 4;
  s1 = *m[i>>14&31];
  s2 = (i&0x2000)?((int)(i<<19)>>19):*m[i&31];
  *m[i>>25&31] = d = s1 - s2;
  *m[0] = 0;
  cc_n = d>>31;
  cc_z = d==0;
  cc_v = (s1>>31&&!(s2>>31)&&!(d>>31)) || (!(s1>>31)&&s2>>31&&d>>31);
  cc_c = (!(s1>>31)&&s2>>31) || (d>>31&&(!(s1>>31)||s2>>31));
  return(0);
}

int i_subx(i) unsigned i;
{
  pc = npc;
  npc += 4;
  *m[i>>25&31] = *m[i>>14&31] - ((i&0x2000)?((int)(i<<19)>>19):*m[i&31]) - cc_c;
  *m[0] = 0;
  return(0);
}

int i_subxcc(i) unsigned i;
{
  unsigned s1, s2, d;

  pc = npc;
  npc += 4;
  s1 = *m[i>>14&31];
  s2 = (i&0x2000)?((int)(i<<19)>>19):*m[i&31];
  *m[i>>25&31] = d = s1 - s2 - cc_c;
  *m[0] = 0;
  cc_n = d>>31;
  cc_z = d==0;
  cc_v = (s1>>31&&!(s2>>31)&&!(d>>31)) || (!(s1>>31)&&s2>>31&&d>>31);
  cc_c = (!(s1>>31)&&s2>>31) || (d>>31&&(!(s1>>31)||s2>>31));
  return(0);
}

int i_sdiv(i) unsigned i;
{
  unsigned s1, s2;
  ll d;

  pc = npc;
  npc += 4;
  s1 = *m[i>>14&31];
  s2 = (i&0x2000)?((int)(i<<19)>>19):*m[i&31];
  d = (ll)((llu)y<<32|(llu)s1)/(ll)(int)s2;
  *m[i>>25&31] = d;
  *m[0] = 0;
  return(0);
}

int i_sdivcc(i) unsigned i;
{
  unsigned s1, s2;
  ll d;

  pc = npc;
  npc += 4;
  s1 = *m[i>>14&31];
  s2 = (i&0x2000)?((int)(i<<19)>>19):*m[i&31];
  d = (ll)((llu)y<<32|(llu)s1)/(ll)(int)s2;
  *m[i>>25&31] = d;
  *m[0] = 0;
  cc_n = (unsigned)d>>31;
  cc_z = (unsigned)d==0;
  cc_v = d!=(ll)(int)d;
  cc_c = 0;
  return(0);
}

int i_udiv(i) unsigned i;
{
  unsigned s1, s2;
  llu d;

  pc = npc;
  npc += 4;
  s1 = *m[i>>14&31];
  s2 = (i&0x2000)?((int)(i<<19)>>19):*m[i&31];
  d = ((llu)y<<32|(llu)s1)/(llu)s2;
  *m[i>>25&31] = d;
  *m[0] = 0;
  return(0);
}

int i_udivcc(i) unsigned i;
{
  unsigned s1, s2;
  llu d;

  pc = npc;
  npc += 4;
  s1 = *m[i>>14&31];
  s2 = (i&0x2000)?((int)(i<<19)>>19):*m[i&31];
  d = ((llu)y<<32|(llu)s1)/(llu)s2;
  *m[i>>25&31] = d;
  *m[0] = 0;
  cc_n = (unsigned)d>>31;
  cc_z = (unsigned)d==0;
  cc_v = (unsigned)(d>>32) != 0;
  cc_c = 0;
  return(0);
}

int i_smul(i) unsigned i;
{
  unsigned s1, s2;
  ll d;

  pc = npc;
  npc += 4;
  s1 = *m[i>>14&31];
  s2 = (i&0x2000)?((int)(i<<19)>>19):*m[i&31];
  d = (ll)(int)s1*(ll)(int)s2;
  y = (unsigned)(d>>32);
  *m[i>>25&31] = d;
  *m[0] = 0;
  return(0);
}

int i_smulcc(i) unsigned i;
{
  unsigned s1, s2;
  ll d;

  pc = npc;
  npc += 4;
  s1 = *m[i>>14&31];
  s2 = (i&0x2000)?((int)(i<<19)>>19):*m[i&31];
  d = (ll)(int)s1*(ll)(int)s2;
  y = (unsigned)(d>>32);
  *m[i>>25&31] = d;
  *m[0] = 0;
  cc_n = (unsigned)d>>31;
  cc_z = (unsigned)d==0;
  cc_v = 0;
  cc_c = 0;
  return(0);
}

int i_umul(i) unsigned i;
{
  unsigned s1, s2;
  llu d;

  pc = npc;
  npc += 4;
  s1 = *m[i>>14&31];
  s2 = (i&0x2000)?((int)(i<<19)>>19):*m[i&31];
  d = (llu)s1*(llu)s2;
  y = (unsigned)(d>>32);
  *m[i>>25&31] = d;
  *m[0] = 0;
  return(0);
}

int i_umulcc(i) unsigned i;
{
  unsigned s1, s2;
  llu d;

  pc = npc;
  npc += 4;
  s1 = *m[i>>14&31];
  s2 = (i&0x2000)?((int)(i<<19)>>19):*m[i&31];
  d = (llu)s1*(llu)s2;
  y = (unsigned)(d>>32);
  *m[i>>25&31] = d;
  *m[0] = 0;
  cc_n = (unsigned)d>>31;
  cc_z = (unsigned)d==0;
  cc_v = 0;
  cc_c = 0;
  return(0);
}

int i_and(i) unsigned i;
{
  pc = npc;
  npc += 4;
  *m[i>>25&31] = *m[i>>14&31] & ((i&0x2000)?((int)(i<<19)>>19):*m[i&31]);
  *m[0] = 0;
  return(0);
}

int i_andcc(i) unsigned i;
{
  unsigned s1, s2, d;

  pc = npc;
  npc += 4;
  s1 = *m[i>>14&31];
  s2 = (i&0x2000)?((int)(i<<19)>>19):*m[i&31];
  *m[i>>25&31] = d = s1 & s2;
  *m[0] = 0;
  cc_n = d>>31;
  cc_z = d==0;
  cc_v = 0;
  cc_c = 0;
  return(0);
}

int i_andn(i) unsigned i;
{
  pc = npc;
  npc += 4;
  *m[i>>25&31] = *m[i>>14&31] & ~((i&0x2000)?((int)(i<<19)>>19):*m[i&31]);
  *m[0] = 0;
  return(0);
}

int i_andncc(i) unsigned i;
{
  unsigned s1, s2, d;

  pc = npc;
  npc += 4;
  s1 = *m[i>>14&31];
  s2 = (i&0x2000)?((int)(i<<19)>>19):*m[i&31];
  *m[i>>25&31] = d = s1 & ~s2;
  *m[0] = 0;
  cc_n = d>>31;
  cc_z = d==0;
  cc_v = 0;
  cc_c = 0;
  return(0);
}

int i_or(i) unsigned i;
{
  pc = npc;
  npc += 4;
  *m[i>>25&31] = *m[i>>14&31] | ((i&0x2000)?((int)(i<<19)>>19):*m[i&31]);
  *m[0] = 0;
  return(0);
}

int i_orcc(i) unsigned i;
{
  unsigned s1, s2, d;

  pc = npc;
  npc += 4;
  s1 = *m[i>>14&31];
  s2 = (i&0x2000)?((int)(i<<19)>>19):*m[i&31];
  *m[i>>25&31] = d = s1 | s2;
  *m[0] = 0;
  cc_n = d>>31;
  cc_z = d==0;
  cc_v = 0;
  cc_c = 0;
  return(0);
}

int i_orn(i) unsigned i;
{
  pc = npc;
  npc += 4;
  *m[i>>25&31] = *m[i>>14&31] | ~((i&0x2000)?((int)(i<<19)>>19):*m[i&31]);
  *m[0] = 0;
  return(0);
}

int i_orncc(i) unsigned i;
{
  unsigned s1, s2, d;

  pc = npc;
  npc += 4;
  s1 = *m[i>>14&31];
  s2 = (i&0x2000)?((int)(i<<19)>>19):*m[i&31];
  *m[i>>25&31] = d = s1 | ~s2;
  *m[0] = 0;
  cc_n = d>>31;
  cc_z = d==0;
  cc_v = 0;
  cc_c = 0;
  return(0);
}

int i_xor(i) unsigned i;
{
  pc = npc;
  npc += 4;
  *m[i>>25&31] = *m[i>>14&31] ^ ((i&0x2000)?((int)(i<<19)>>19):*m[i&31]);
  *m[0] = 0;
  return(0);
}

int i_xorcc(i) unsigned i;
{
  unsigned s1, s2, d;

  pc = npc;
  npc += 4;
  s1 = *m[i>>14&31];
  s2 = (i&0x2000)?((int)(i<<19)>>19):*m[i&31];
  *m[i>>25&31] = d = s1 ^ s2;
  *m[0] = 0;
  cc_n = d>>31;
  cc_z = d==0;
  cc_v = 0;
  cc_c = 0;
  return(0);
}

int i_xnor(i) unsigned i;
{
  pc = npc;
  npc += 4;
  *m[i>>25&31] = *m[i>>14&31] ^ ~((i&0x2000)?((int)(i<<19)>>19):*m[i&31]);
  *m[0] = 0;
  return(0);
}

int i_xnorcc(i) unsigned i;
{
  unsigned s1, s2, d;

  pc = npc;
  npc += 4;
  s1 = *m[i>>14&31];
  s2 = (i&0x2000)?((int)(i<<19)>>19):*m[i&31];
  *m[i>>25&31] = d = s1 ^ ~s2;
  *m[0] = 0;
  cc_n = d>>31;
  cc_z = d==0;
  cc_v = 0;
  cc_c = 0;
  return(0);
}

int i_sll(i) unsigned i;
{
  pc = npc;
  npc += 4;
  *m[i>>25&31] = *m[i>>14&31] << (((i&0x2000)?((int)(i<<19)>>19):*m[i&31])&31);
  *m[0] = 0;
  return(0);
}

int i_srl(i) unsigned i;
{
  pc = npc;
  npc += 4;
  *m[i>>25&31] = *m[i>>14&31] >> (((i&0x2000)?((int)(i<<19)>>19):*m[i&31])&31);
  *m[0] = 0;
  return(0);
}

int i_sra(i) unsigned i;
{
  pc = npc;
  npc += 4;
  *m[i>>25&31] = (int)*m[i>>14&31] >> (((i&0x2000)?((int)(i<<19)>>19):*m[i&31])&31);
  *m[0] = 0;
  return(0);
}

int i_sethi(i) unsigned i;
{
  pc = npc;
  npc += 4;
  *m[i>>25&31] = i<<10;
  *m[0] = 0;
  return(0);
}

int i_save(i) unsigned i;
{
  int j;
  unsigned d;

  pc = npc;
  npc += 4;
  d = *m[i>>14&31] + ((i&0x2000)?((int)(i<<19)>>19):*m[i&31]);
  if (++winno == SPARC_WINSIZE) {
    message("i_save: Window overflow\n");
    return(1);
  }
  for (j=0; j<8; j++)
    m[8+j] = &o[winno*8+j]; /* out reg */
  for (j=0; j<8; j++)
    m[16+j] = &l[(winno-1)*8+j]; /* local reg */
  for (j=0; j<8; j++)
    m[24+j] = &o[(winno-1)*8+j]; /* in reg */
  *m[i>>25&31] = d;
  *m[0] = 0;
  return(0);
}

int i_restore(i) unsigned i;
{
  int j;
  unsigned d;

  pc = npc;
  npc += 4;
  d = *m[i>>14&31] + ((i&0x2000)?((int)(i<<19)>>19):*m[i&31]);
  if (--winno == 0) {
    /* message("i_restore: Window underflow\n"); */
    for (j=0; j<8; j++)
      m[8+j] = &o[j]; /* out reg */
    return(1);
  }
  for (j=0; j<8; j++)
    m[8+j] = &o[winno*8+j]; /* out reg */
  for (j=0; j<8; j++)
    m[16+j] = &l[(winno-1)*8+j]; /* local reg */
  for (j=0; j<8; j++)
    m[24+j] = &o[(winno-1)*8+j]; /* in reg */
  *m[i>>25&31] = d;
  *m[0] = 0;
  return(0);
}

int i_ldsb(i) unsigned i;
{
  unsigned char *p;

  pc = npc;
  npc += 4;
  opad = *m[i>>14&31] + ((i&0x2000)?((int)(i<<19)>>19):*m[i&31]);
  if (opad >= 0 && opad < SPARC_MEMSIZE) {
    p = &mem[opad];
    *m[i>>25&31] = (int)(char)*p;
    *m[0] = 0;
  }
  return(0);
}

int i_ldub(i) unsigned i;
{
  unsigned char *p;

  pc = npc;
  npc += 4;
  opad = *m[i>>14&31] + ((i&0x2000)?((int)(i<<19)>>19):*m[i&31]);
  if (opad >= 0 && opad < SPARC_MEMSIZE) {
    p = &mem[opad];
    *m[i>>25&31] = *p;
    *m[0] = 0;
  }
  return(0);
}

int i_ldsh(i) unsigned i;
{
  unsigned char *p;

  pc = npc;
  npc += 4;
  opad = *m[i>>14&31] + ((i&0x2000)?((int)(i<<19)>>19):*m[i&31]);
  if (opad >= 0 && opad < SPARC_MEMSIZE) {
    p = &mem[opad];
    *m[i>>25&31] = (int)(short)(*p<<8 | *(p+1));
    *m[0] = 0;
  }
  return(0);
}

int i_lduh(i) unsigned i;
{
  unsigned char *p;

  pc = npc;
  npc += 4;
  opad = *m[i>>14&31] + ((i&0x2000)?((int)(i<<19)>>19):*m[i&31]);
  if (opad >= 0 && opad < SPARC_MEMSIZE) {
    p = &mem[opad];
    *m[i>>25&31] = *p<<8 | *(p+1);
    *m[0] = 0;
  }
  return(0);
}

int i_ld(i) unsigned i;
{
  unsigned char *p;

  pc = npc;
  npc += 4;
  opad = *m[i>>14&31] + ((i&0x2000)?((int)(i<<19)>>19):*m[i&31]);
  if (opad >= 0 && opad < SPARC_MEMSIZE) {
    p = &mem[opad];
    *m[i>>25&31] = *p<<24 | *(p+1)<<16 | *(p+2)<<8 | *(p+3);
    *m[0] = 0;
  }
  return(0);
}

int i_ldd(i) unsigned i;
{
  unsigned char *p;

  pc = npc;
  npc += 4;
  opad = *m[i>>14&31] + ((i&0x2000)?((int)(i<<19)>>19):*m[i&31]);
  if (opad >= 0 && opad < SPARC_MEMSIZE) {
    p = &mem[opad];
    *m[i>>25&31  ] = *(p  )<<24 | *(p+1)<<16 | *(p+2)<<8 | *(p+3);
    *m[i>>25&31|1] = *(p+4)<<24 | *(p+5)<<16 | *(p+6)<<8 | *(p+7);
    *m[0] = 0;
  }
  return(0);
}

int i_lda(i) unsigned i;       
{   
  unsigned char *p;
  struct  tms utms;

  pc = npc;
  npc += 4;
  opad = *m[i>>14&31] + *m[i&31];
  if ((i>>5&255) == 0x20 && opad == 0xfff00304) { /* TOD */
    times(&utms);
    *m[i>>25&31] = utms.tms_utime * (1000000 / sysconf(_SC_CLK_TCK));
    *m[0] = 0;  
  } 
  return(0);
}

int i_stb(i) unsigned i;
{
  unsigned char *p;
  unsigned d;

  pc = npc;
  npc += 4;
  opad = *m[i>>14&31] + ((i&0x2000)?((int)(i<<19)>>19):*m[i&31]);
  if (opad >= 0 && opad < SPARC_MEMSIZE) {
    p = &mem[opad];
    d = *m[i>>25&31];
    *(p  ) = d;
  }
  return(0);
}

int i_sth(i) unsigned i;
{
  unsigned char *p;
  unsigned d;

  pc = npc;
  npc += 4;
  opad = *m[i>>14&31] + ((i&0x2000)?((int)(i<<19)>>19):*m[i&31]);
  if (opad >= 0 && opad < SPARC_MEMSIZE) {
    p = &mem[opad];
    d = *m[i>>25&31];
    *(p  ) = d>> 8;
    *(p+1) = d    ;
  }
  return(0);
}

int i_st(i) unsigned i;
{
  unsigned char *p;
  unsigned d;

  pc = npc;
  npc += 4;
  opad = *m[i>>14&31] + ((i&0x2000)?((int)(i<<19)>>19):*m[i&31]);
  if (opad >= 0 && opad < SPARC_MEMSIZE) {
    p = &mem[opad];
    d = *m[i>>25&31];
    *(p  ) = d>>24;
    *(p+1) = d>>16;
    *(p+2) = d>> 8;
    *(p+3) = d;
  }
  return(0);
}

int i_std(i) unsigned i;
{
  unsigned char *p;
  unsigned d;

  pc = npc;
  npc += 4;
  opad = *m[i>>14&31] + ((i&0x2000)?((int)(i<<19)>>19):*m[i&31]);
  if (opad >= 0 && opad < SPARC_MEMSIZE) {
    p = &mem[opad];
    d = *m[i>>25&31];
    *(p  ) = d>>24;
    *(p+1) = d>>16;
    *(p+2) = d>> 8;
    *(p+3) = d    ;
    d = *m[i>>25&31|1];
    *(p+4) = d>>24;
    *(p+5) = d>>16;
    *(p+6) = d>> 8;
    *(p+7) = d;
  }
  return(0);
}

int i_ldstub(i) unsigned i;
{
  unsigned char *p;

  pc = npc;
  npc += 4;
  opad = *m[i>>14&31] + ((i&0x2000)?((int)(i<<19)>>19):*m[i&31]);
  if (opad >= 0 && opad < SPARC_MEMSIZE) {
    p = &mem[opad];
    *m[i>>25&31] = *p;
    *m[0] = 0;
    *p = 0xff;
  }
  return(0);
}

int i_bicc(i) unsigned i;
{
  unsigned opc = pc;
  unsigned taken;

  pc = npc;
  switch (i>>25&15) {
  case 0:
    taken = 0;
    break;
  case 1:
    taken = cc_z;
    break;
  case 2:
    taken = cc_z || (cc_n ^ cc_v);
    break;
  case 3:
    taken = cc_n ^ cc_v;
    break;
  case 4:
    taken = cc_c || cc_z;
    break;
  case 5:
    taken = cc_c;
    break;
  case 6:
    taken = cc_n;
    break;
  case 7:
    taken = cc_v;
    break;
  case 8:
    npc = opc + ((int)(i<<10)>>8);
    if (i&0x20000000) /* annul */
      annul = 1;
    return(0);
    break;
  case 9:
    taken = !cc_z;
    break;
  case 10:
    taken = !(cc_z || (cc_n ^ cc_v));
    break;
  case 11:
    taken = !(cc_n ^ cc_v);
    break;
  case 12:
    taken = !(cc_c || cc_z);
    break;
  case 13:
    taken = !cc_c;
    break;
  case 14:
    taken = !cc_n;
    break;
  case 15:
    taken = !cc_v;
    break;
  }
  if (taken)
    npc = opc + ((int)(i<<10)>>8);
  else {
    npc += 4;
    if (i&0x20000000) /* annul */
      annul = 1;
  }
  return(0);
}

int i_call(i) unsigned i;
{
  unsigned opc = pc;

  pc = npc;
  npc = opc + (i<<2);
  *m[15] = opc;
  return(0);
}

int i_jmpl(i) unsigned i;
{
  unsigned opc = pc;

  pc = npc;
  npc = *m[i>>14&31] + ((i&0x2000)?((int)(i<<19)>>19):*m[i&31]);
  *m[i>>25&31] = opc;
  *m[0] = 0;
  return(0);
}

int i_ticc(i) unsigned i;
{
  char path[1024], *p;

  pc = npc;
  npc += 4;
  switch (*m[1]) {
  case 1: /* exit */
    message("i_ticc: Program normal end.\n");
    return(1);
    break;
  case 3: /* read */
    *m[8] = read(*m[8], &mem[*m[9]], *m[10]);
    break;
  case 4: /* write */
    fflush(stdout);
    *m[8] = write(*m[8], &mem[*m[9]], *m[10]);
    break;
  case 5: /* open */
    *m[8] = open(&mem[*m[8]], *m[9], *m[10]);
    break;
  case 6: /* close */
    *m[8] = close(*m[8]);
    break;
  default:
    message("i_ticc: Undefined sys_call (g1=0x%08.8x)\n", *m[1]);
    return(1);
    break;
  }
  return(0);
}

int i_rdy(i) unsigned i;
{
  pc = npc;
  npc += 4;
  *m[i>>25&31] = y;
  *m[0] = 0;
  return(0);
}

int i_wry(i) unsigned i;
{
  pc = npc;
  npc += 4;
  y = *m[i>>14&31] ^ ((i&0x2000)?((int)(i<<19)>>19):*m[i&31]);
  return(0);
}

int i_unimp(i) unsigned i;
{
  pc = npc;
  npc += 4;
  message("i_unimp: Unimp instruction detected\n");
  return(1);
}

int i_flush(i) unsigned i;
{
  pc = npc;
  npc += 4;
  return(0);
}

int i_xxx(i) unsigned i;
{
  pc = npc;
  npc += 4;
  message("i_xxx: unimplemented instruction (%08.8x) detected\n", i);
  return(1);
}

