
static char RcsId[] =
"$Id: ssim.c,v 1.9 1997/02/17 05:08:16 nakashim Exp nakashim $";

/* ssim.c 1996/3/22 */

/* SPARC Integer Instruction Simulator         */
/*       Copyright (C) 1995 by FUJITSU LIMITED */
/*                 Primary writer: Y.Nakashima */
/*          nakashim@pine.mfd.cs.fujitsu.co.jp */

#include "sdef.h"

ssim(trace)
  unsigned trace;
{
  extern struct sparc_op insn00[], insn01[], insn10[], insn11[];
  unsigned insn, i, retval;
  unsigned char *memp;
  struct sparc_op *sop;

  pc =0;
  npc = pc+4;

  for (;;) {
    opc = pc;
    if (pc >= SPARC_MEMSIZE) {
      message("Address too large: pc=0x%08.8x\n", pc);
      return;
    }
    memp = &mem[pc];
    insn = *memp<<24 | *(memp+1)<<16 | *(memp+2)<<8 | *(memp+3);
    switch (insn >> 30) {
    case 0:
      sop = &insn00[insn>>22&7];
      break;
    case 1:
      sop = &insn01[0];
      break;
    case 2:
      sop = &insn10[insn>>19&63];
      break;
    case 3:
      sop = &insn11[insn>>19&63];
      break;
    }
    
    if (!annul) {
      sparc_step++;
      retval = (sop->func)(insn);
      if (trace)
	message("  %08.8x: %08.8x [%08.8x] %02.2x O %s\n",
                 opc, insn, opad, (insn>>24&192)|(insn>>19&63), sop->name);
      if (retval)
        return;
    }
    else { /* nop */
      pc = npc;
      npc += 4;     
      annul = 0;
      if (trace)
	message("  %08.8x: %08.8x [%08.8x] %02.2x X %s\n",
                 opc, insn, opad, (insn>>24&192)|(insn>>19&63), sop->name);
    }
  }
}

