{
static char ControlRcsId[] =
"$Id: control.c,v 1.13 1997/06/05 08:45:19 nakashim Exp nakashim $";

/* control.c 1995/7/18 */

/* M-on-RISC Dynamically Translating Simulator */
/*       Copyright (C) 1995 by FUJITSU LIMITED */
/*                 Primary writer: Y.Nakashima */
/*          nakashim@pine.mfd.cs.fujitsu.co.jp */

        llu ILC = (gmem0[swap8(gcpu_s0->g2)]>>6)+3>>1;
        llu NPC = (swap8(gcpu_s0->g2)+(ILC<<1)&0x7fffffff);

        switch ((unsigned)(swap8(gcpu_s0->g7) >> 30) & 3) {
        case 1: /* reserved */
          goto exit_loop;
	case 3: /* Extended Function (emm call) */
	  if (extended(gcpu_s0, gmem0, (int)NPC-4))
	    goto exit_loop;
	  gcpu_s0->g2 = swap8(NPC);
	  break;
        case 2: /* Special Instruction */
	  switch ((unsigned)(swap8(gcpu_s0->minsn)>>56)) {
	  case 0x0A: /* SVC */
	    {
	      llu op;
#ifdef DEBUG
	      umes("special insn(SVC) continuing...\n");
#endif
	      *(unsigned*)(&gmem0[0x88])
		= swap4((unsigned)(ILC<<17
                                 | (swap8(gcpu_s0->minsn)>>48&0xff)));
	      *(llu*)(&gmem0[0x20])
  	        = swap8(0x000c000000000000LL
	            | (llu)(swap8(gcpu_s0->g1)       )<<44
		    | (llu)NPC
		    | (llu)(swap8(gcpu_s0->g7) & 0x10)<<27
	            | (llu)(swap8(gcpu_s0->g7) & 0x0f)<<40);
	      
	      op = swap8(*(llu*)(&gmem0[0x60]));
	      gcpu_s0->g1 = swap8((op>>44) & 0x03);
	      gcpu_s0->g2 = swap8((op    ) & 0x7fffffff);
	      gcpu_s0->g3 = (op>>27) & 0x10
		          ? swap8(0x000000007fffffffLL)
		          : swap8(0x0000000000ffffffLL);
	      gcpu_s0->g7 = swap8((swap8(gcpu_s0->g7) & ~0x1f)
                               | ((op>>27) & 0x10)
                               | ((op>>40) & 0x0f));
	    }
	    break;
	  case 0xAF: /* MC */
	    {
	      unsigned b,d;
	      llu op;
#ifdef DEBUG
	      umes("special insn(MC) continuing...\n");
#endif
	      if (swap4(gcpu_s0->cr[8]) & (0x00008000>>(swap8(gcpu_s0->minsn)>>48&0xf))) {
		*(unsigned*)(&gmem0[0x8c])
		  = swap4((unsigned)(ILC<<17 | 0x40));
		*(llu*)(&gmem0[0x28])
		  = swap8(0x000c000000000000LL
		        | (llu)(swap8(gcpu_s0->g1)       )<<44
		        | (llu)NPC
		        | (llu)(swap8(gcpu_s0->g7) & 0x10)<<27
		        | (llu)(swap8(gcpu_s0->g7) & 0x0f)<<40);
	      
		op = swap8(*(llu*)(&gmem0[0x68]));
		gcpu_s0->g1 = swap8((op>>44) & 0x03);
		gcpu_s0->g2 = swap8((op    ) & 0x7fffffff);
		gcpu_s0->g3 = (op>>27) & 0x10
		            ? swap8(0x000000007fffffffLL)
		            : swap8(0x0000000000ffffffLL);
		gcpu_s0->g7 = swap8((swap8(gcpu_s0->g7) & ~0x1f)
			         | ((op>>27) & 0x10)
			         | ((op>>40) & 0x0f));
		gmem0[0x94] =  0;
		gmem0[0x95] =  (swap8(gcpu_s0->minsn)>>48)&0xff;
		b  = (unsigned)(swap8(gcpu_s0->minsn)>>44)&0xf;
		d  = (unsigned)(swap8(gcpu_s0->minsn)>>32)&0xfff;
		*(unsigned*)(&gmem0[0x9c])
		  = swap4(((swap8(gcpu_s0->g7)&0x10)?0x7fffffff:0x00ffffff)
			  &(b?swap4(gcpu_s0->gr[b])+d:d));
	      }
	      else
		gcpu_s0->g2 = swap8(NPC);
	    }
	    break;
	  case 0xB6: /* STCTL */
	    {
	      unsigned b,d;
	      llu op;
#ifdef DEBUG
	      umes("special insn(STCTL) continuing...\n");
#endif
	      /* assume CR8 */
	      gcpu_s0->g2 = swap8(NPC);
	      b  = (unsigned)(swap8(gcpu_s0->minsn)>>44)&0xf;
	      d  = (unsigned)(swap8(gcpu_s0->minsn)>>32)&0xfff;
	      *(unsigned*)&gmem0[b?swap4(gcpu_s0->gr[b])+d:d] = gcpu_s0->cr[8];
	    }
	    break;
	  case 0xB7: /* LCTL */
	    {
	      unsigned b,d;
	      llu op;
#ifdef DEBUG
	      umes("special insn(LCTL) continuing...\n");
#endif
	      /* assume CR8 */
	      gcpu_s0->g2 = swap8(NPC);
	      b  = (unsigned)(swap8(gcpu_s0->minsn)>>44)&0xf;
	      d  = (unsigned)(swap8(gcpu_s0->minsn)>>32)&0xfff;
	      gcpu_s0->cr[8] = *(unsigned*)&gmem0[b?swap4(gcpu_s0->gr[b])+d:d];
	    }
	    break;
	  case 0xBC: /* BCXX */
#ifdef DEBUG
	    umes("special insn(BCXX) continuing...\n");
#endif
	    gcpu_s0->g2 = swap8(NPC);
	    break;
	  case 0x82: /* LPSW */
	    {
	      unsigned b,d;
	      llu op;
#ifdef DEBUG
	      umes("special insn(LPSW) continuing...\n");
#endif
	      b  = (unsigned)(swap8(gcpu_s0->minsn)>>44)&0xf;
	      d  = (unsigned)(swap8(gcpu_s0->minsn)>>32)&0xfff;
	      op = swap8(*(llu*)&gmem0[b?swap4(gcpu_s0->gr[b])+d:d]);
	      gcpu_s0->g1 = swap8((op>>44) & 0x03);
	      gcpu_s0->g2 = swap8((op    ) & 0x7fffffff);
	      gcpu_s0->g3 = (op>>27) & 0x10
		          ? swap8(0x000000007fffffffLL)
		          : swap8(0x0000000000ffffffLL);
	      gcpu_s0->g7 = swap8((swap8(gcpu_s0->g7) & ~0x1f)
                               | ((op>>27) & 0x10)
                               | ((op>>40) & 0x0f));
	    }
	    break;
	  case 0x83: /* DIAG */
	    switch ((unsigned)(swap8(gcpu_s0->minsn)>>48 & 0xff)) {
	    case 0x01:
	    case 0x02:
	      umes("diagnose insn(FCR-DIAG): 0x%08.8x continuing...\n",
		   (unsigned)(swap8(gcpu_s0->minsn)>>32));
	      gcpu_s0->g2 = swap8(NPC);
	      break;
	    case 0xD9:
	      umes("diagnose insn(TMP-DIAG): 0x%08.8x continuing...\n",
		   (unsigned)(swap8(gcpu_s0->minsn)>>32));
	      gcpu_s0->g2 = swap8(NPC);
	      break;
	    case 0xD3:
	      umes("diagnose insn(TMP-DIAG): 0x%08.8x ...NG\n",
		   (unsigned)(swap8(gcpu_s0->minsn)>>32));
	      goto exit_loop;
	    case 0xFF:
	      umes("diagnose insn(TMP-DIAG): 0x%08.8x ...OK\n",
		   (unsigned)(swap8(gcpu_s0->minsn)>>32));
	      goto exit_loop;
	    default:
#ifdef DEBUG
	      umes("diagnose insn(DIAG): 0x%08.8x\n",
		   (unsigned)(swap8(gcpu_s0->minsn)>>32));
#endif
	      gcpu_s0->g2 = swap8(NPC);
	      goto exit_loop;
	    }
	    break;
	  case 0xB2: /* B2XX */
	    {
	      unsigned b,d;
	      llu op;
	      static llu clk;
	      
	      if ((unsigned)(swap8(gcpu_s0->minsn)>>48) == 0xB204) {
#ifdef DEBUG
		umes("special insn(SCK) continuing...\n");
#endif
		gcpu_s0->g1 = swap8(0LL); /* CC=0 */
		gcpu_s0->g2 = swap8(NPC);
		b  = (unsigned)(swap8(gcpu_s0->minsn)>>44)&0xf;
		d  = (unsigned)(swap8(gcpu_s0->minsn)>>32)&0xfff;
		clrtime();
		clk = swap8(*(llu*)&gmem0[b?swap4(gcpu_s0->gr[b])+d:d]);
		break;
	      }
	      else if ((unsigned)(swap8(gcpu_s0->minsn)>>48) == 0xB205) {
#ifdef DEBUG
		umes("special insn(STCK) continuing...\n");
#endif
		gcpu_s0->g1 = swap8(0LL); /* CC=0 */
		gcpu_s0->g2 = swap8(NPC);
		b  = (unsigned)(swap8(gcpu_s0->minsn)>>44)&0xf;
		d  = (unsigned)(swap8(gcpu_s0->minsn)>>32)&0xfff;
		*(llu*)&gmem0[b?swap4(gcpu_s0->gr[b])+d:d] = swap8(clk+(llu)(i<<12));
		break;
	      }
	      else
		gcpu_s0->g2 = swap8(NPC);
	    }
	  default:
#ifdef DEBUG
	    umes("special insn(unknown): 0x%08.8x_%08.8x\n",
		 (unsigned)(swap8(gcpu_s0->minsn)>>32),
		 (unsigned)(swap8(gcpu_s0->minsn)));
#endif
	    gcpu_s0->g7 = swap8(swap8(gcpu_s0->g7) | 0x0000000000010000LL);
	    goto operation_exception;
	  }
	  break;
        case 0: /* Program Exception or Step Execution */
	operation_exception:
          if (swap8(gcpu_s0->g7) & 0x0000000000ff0000LL) {
	    llu op;
#ifdef DEBUG
	    umes("program exception: g2=0x%08.8x_%08.8x g7=0x%08.8x_%08.8x continuing...\n",
	          (int)(swap8(gcpu_s0->g2)>>32), (int)swap8(gcpu_s0->g2),
	          (int)(swap8(gcpu_s0->g7)>>32), (int)swap8(gcpu_s0->g7));
#endif
	    *(unsigned*)(&gmem0[0x8c])
	      = swap4((unsigned)(ILC<<17
	                       | (swap8(gcpu_s0->g7) & 0x00ff0000)>>16));
	    *(llu*)(&gmem0[0x28])
	      = swap8(0x000c000000000000LL
	            | (llu)(swap8(gcpu_s0->g1)       )<<44
	            | (llu)NPC
	            | (llu)(swap8(gcpu_s0->g7) & 0x10)<<27
	            | (llu)(swap8(gcpu_s0->g7) & 0x0f)<<40);

	    umes("OLD: g1=0x%08.8x_%08.8x g7=0x%08.8x_%08.8x\n",
	          (int)(swap8(gcpu_s0->g1)>>32), (int)swap8(gcpu_s0->g1),
	          (int)(swap8(gcpu_s0->g7)>>32), (int)swap8(gcpu_s0->g7));

	    op = swap8(*(llu*)(&gmem0[0x68]));
	    gcpu_s0->g1 = swap8((op>>44) & 0x03);
	    gcpu_s0->g2 = swap8((op    ) & 0x7fffffff);
	    gcpu_s0->g3 = (op>>27) & 0x10
		        ? swap8(0x000000007fffffffLL)
		        : swap8(0x0000000000ffffffLL);
	    gcpu_s0->g7 = swap8((swap8(gcpu_s0->g7) & ~0x1f)
                             | ((op>>27) & 0x10)
                             | ((op>>40) & 0x0f));

	    umes("NEW: g1=0x%08.8x_%08.8x g7=0x%08.8x_%08.8x\n",
	          (int)(swap8(gcpu_s0->g1)>>32), (int)swap8(gcpu_s0->g1),
	          (int)(swap8(gcpu_s0->g7)>>32), (int)swap8(gcpu_s0->g7));

	  }
	  break;
	}
}

