
static char RcsId[] =
"$Id: extlib.c,v 1.18 1997/05/20 09:44:42 nakashim Exp nakashim $";

/* extlib.c 1995/7/17 */

/* M-on-RISC Dynamically Translating Simulator */
/*       Copyright (C) 1995 by FUJITSU LIMITED */
/*                 Primary writer: Y.Nakashima */
/*          nakashim@pine.mfd.cs.fujitsu.co.jp */

#ifdef WITHOS
#include <stdio.h>
#include <sys/times.h>
#endif
#include "mdef.h"

unsigned *
emm_getibufbpa(gcpu_s, addr, type)
  struct gcpu_s *gcpu_s;
  unsigned addr;
  unsigned type; /* 0:instruction, 1:operand for CS/CDS */
  /* return 0 if no free space*/ 
  /* return 1 if first translation (dim() also returns with (1))*/ 
  /* return addr if normal end */ 
{
  int bufpent, i;
  unsigned char *bufp;

  if ((addr & ~(GUEST_PAGESIZE-1)) > GUEST_MEMSIZE) {
    umes("FATAL: emm_getibufa: address > GUEST_MEMSIZE: addr=0x%x\n", addr);
    return(0);
  }
  return((unsigned*)(UINT2P)gcpu_s->host_ibufpp+(addr/GUEST_PAGESIZE)*4+2);
}

unsigned
emm_ibuf_alloc(gcpu_s, addr)
  struct gcpu_s *gcpu_s;
  unsigned addr;
  /* addr:VIAR            */
  /* return 0 if failed   */
{
  int bufpent, i;
  unsigned char *bufp;

  if ((addr & ~(GUEST_PAGESIZE-1)) > GUEST_MEMSIZE) {
    umes("FATAL: emm_ibuf_alloc: address > GUEST_MEMSIZE: addr=0x%x\n", addr);
    return(0);
  }
  bufpent = (addr/GUEST_PAGESIZE)*4;
  bufp = (unsigned char*)(UINT2P)gcpu_s->freep;
  gcpu_s->freep += IBUF_PAGESIZE;
  if (gcpu_s->freep > gcpu_s->ibuf + IBUF_SIZE) {
    umes("FATAL: emm_ibuf_alloc: no free space\n");
    return(0);
  }
  if (((unsigned*)(UINT2P)gcpu_s->host_ibufpp)[bufpent+2] == 0)
    ((unsigned*)(UINT2P)gcpu_s->host_ibufpp)[bufpent] = (unsigned)(P2UINT)bufp;
  else
    *(unsigned*)(UINT2P)(((unsigned*)(UINT2P)gcpu_s->host_ibufpp)[bufpent+2]) = (unsigned)(P2UINT)bufp;
  ((unsigned*)(UINT2P)gcpu_s->host_ibufpp)[bufpent+2] = (unsigned)(P2UINT)bufp;
#ifdef DEBUG_IBUF
  *(unsigned*)(bufp  ) = (unsigned)0;
  *(unsigned*)(bufp+4) = IBUF_PAGESIZE - 8 - 16;
  for (i=1,bufp=(unsigned char*)(UINT2P)((unsigned*)gcpu_s->host_ibufpp)[bufpent];; i++)
    if (!(bufp = (unsigned char*)(UINT2P)*(unsigned*)bufp)) break;
  umes("emm_ibuf_alloc: ibuf allocated at 0x%x: maddr=0x%x, link=%d\n", ((unsigned*)gcpu_s->host_ibufpp)[bufpent+2], addr, i);
#endif
  return(((unsigned*)(UINT2P)gcpu_s->host_ibufpp)[bufpent+2]);
}

unsigned *
GCPU_gsdat(gcpu_s, addr, type)
  struct gcpu_s *gcpu_s;
  unsigned addr;
  unsigned type; /* 0x301:IF, 0x300:LD, 0x700:ST */
  /* return logical */ 
{
  umes("GCPU_gsdat: DAT not implemented: addr=0x%x type=0x%x\n", addr, type);
  return(0);
}

unsigned char e2aout[] = {
   0,  0,  0,  0,  0,'\t', 0,  0,  0,  0,  0,  0,  0,'\r', 0,  0,
   0,  0,  0,  0,  0,'\n', 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
  ' ', 0,  0,  0,  0,  0,  0,  0,  0,  0,  0, '.','<','(','+','|',
  '&', 0,  0,  0,  0,  0,  0,  0,  0,  0, '!','$','*',')',';','^',
  '-','/', 0,  0,  0,  0,  0,  0,  0,  0,  0, ',','%','_','>','?',
   0,  0,  0,  0,  0,  0,  0,  0,  0,  0, ':','#','@','\'','=','\"',/*"*/

   0, 'a','b','c','d','e','f','g','h','i', 0,  0,  0,  0,  0,  0,
   0, 'j','k','l','m','n','o','p','q','r', 0,  0,  0,  0,  0,  0,
   0, '~','s','t','u','v','w','x','y','z', 0,  0,  0, '[', 0,  0,
   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, ']', 0,  0,
  '{','A','B','C','D','E','F','G','H','I', 0,  0,  0,  0,  0,  0,
  '}','J','K','L','M','N','O','P','Q','R', 0,  0,  0,  0,  0,  0,
 '\\', 0, 'S','T','U','V','W','X','Y','Z', 0,  0,  0,  0,  0,  0,
  '0','1','2','3','4','5','6','7','8','9', 0,  0,  0,  0,  0,  0};

extended(gcpu_s, gmem, addr)
  struct gcpu_s *gcpu_s;
  unsigned char *gmem;
  unsigned addr;
{
  unsigned insn;

  insn  = (unsigned)gmem[addr+3];
  insn |= (unsigned)gmem[addr+2] << 8;
  insn |= (unsigned)gmem[addr+1] << 16;
  insn |= (unsigned)gmem[addr  ] << 24;

  if (insn != 0x47000fed) {
    return(0);
  }

  switch (swap4(gcpu_s->gr[0])) {
  case 0xff0: { /* NOP */
    return(0);
  }
  case 0xff1: { /* PRINTF */
    unsigned char *fmtp;
    unsigned char fmt[1024];
    unsigned char dfmt[5][1024];
    unsigned d[5];
    unsigned *argp;
    int arg_ent, status;

    argp = (unsigned*)&gmem[swap4(gcpu_s->gr[2])];
    arg_ent = -1;
    status = 0; /* 0:expect %, 1:expect number, 2:expect alpha, 0x10:escape */
    d[0] = swap4(*(argp+1));
    d[1] = swap4(*(argp+2));
    d[2] = swap4(*(argp+3));
    d[3] = swap4(*(argp+4));
    d[4] = swap4(*(argp+5));

    scpy(fmt, (char*)&gmem[swap4(*argp)]);
    for (fmtp = fmt; *fmtp; fmtp++)
      *fmtp = e2aout[*fmtp];

    for (fmtp = fmt; *fmtp; fmtp++) {
      if (status & 0x10)
        status &= ~0x10;
      else if (*fmtp == '\\')
        status |= 0x10;
      else if (!status && *fmtp == '%') {
        status = 1;
        if (++arg_ent > 4) {
          umes("extended function(PRINTF): too many arguments\n");
          return(0);
        }
      }
      else if (status == 1 && *fmtp == '+')
        status = 1;
      else if (status == 1 && *fmtp == '-')
        status = 1;
      else if (status == 1 && *fmtp >= '0' && *fmtp <= '9')
        status = 2;
      else if ((status == 1 || status == 2)
        && (*fmtp >= 'a' && *fmtp <= 'z' || *fmtp >= 'A' && *fmtp <= 'Z')) {
        status = 0;
        if (*fmtp == 'f' || *fmtp == 'e' ||*fmtp == 'g' 
          ||*fmtp == 'E' || *fmtp == 'G') {
          if (++arg_ent > 4) {
            umes("extended function(PRINTF): too many arguments\n");
            return(0);
          }
        }
        else if (*fmtp == 's') {
          scpy(dfmt[arg_ent], (char*)&gmem[d[arg_ent]]);
          for (fmtp = dfmt[arg_ent]; *fmtp; fmtp++)
            *fmtp = e2aout[*fmtp];
          d[arg_ent] = (unsigned)(P2UINT)dfmt[arg_ent];
        }
        else if (*fmtp == 'c')
          d[arg_ent] = e2aout[d[arg_ent]];
      }
    }
    smes(fmt, d[0], d[1], d[2], d[3], d[4]);
    return(0);
  }
  case 0xff2: { /* SCANF */
    unsigned char *fmtp;
    unsigned char fmt[1024];
    unsigned char dfmt[5][1024];
    unsigned d[5];
    unsigned *argp;
    int arg_ent, status;

    argp = (unsigned*)&gmem[swap4(gcpu_s->gr[2])];
    arg_ent = -1;
    status = 0; /* 0:expect %, 1:expect number, 2:expect alpha, 0x10:escape */
    d[0] = swap4(*(argp+1));
    d[1] = swap4(*(argp+2));
    d[2] = swap4(*(argp+3));
    d[3] = swap4(*(argp+4));
    d[4] = swap4(*(argp+5));

    scpy(fmt, (char*)&gmem[swap4(*argp)]);
    for (fmtp = fmt; *fmtp; fmtp++)
      *fmtp = e2aout[*fmtp];

    for (fmtp = fmt; *fmtp; fmtp++) {
      if (status & 0x10)
        status &= ~0x10;
      else if (*fmtp == '\\')
        status |= 0x10;
      else if (!status && *fmtp == '%') {
        status = 1;
        if (++arg_ent > 4) {
          umes("extended function(SCANF): too many arguments\n");
          return(0);
        }
      }
      else if (status == 1 && *fmtp == '+')
        status = 1;
      else if (status == 1 && *fmtp == '-')
        status = 1;
      else if (status == 1 && *fmtp >= '0' && *fmtp <= '9')
        status = 2;
      else if ((status == 1 || status == 2)
        && (*fmtp >= 'a' && *fmtp <= 'z' || *fmtp >= 'A' && *fmtp <= 'Z')) {
        status = 0;
        if (*fmtp == 'f' || *fmtp == 'e' ||*fmtp == 'g' 
          ||*fmtp == 'E' || *fmtp == 'G') {
          if (++arg_ent > 4) {
            umes("extended function(SCANF): too many arguments\n");
            return(0);
          }
        }
        d[arg_ent] = (unsigned)(P2UINT)(&gmem[d[arg_ent]]);
      }
    }
#ifdef WITHOS
    scanf(fmt, d[0],d[1],d[2],d[3],d[4]);
#endif
    return(0);
  }
  case 0xff3: { /* TIME */
    long gettime();

    gcpu_s->gr[15] = swap4(gettime());
    return(0);
  }
  case 0xffe: /* STACK OVERFLOW */
    umes("extended function(STACK OVERFLOW)\n");
    return(1);

  case 0xfff: /* PROGRAM NORMAL END */
    umes("extended function(PROGRAM NORMAL END)\n");
    return(1);

  default: /* UNDEFINED */
    umes("extended function(UNDEFINED): gcpu_s.gr[0]=0x%x\n", swap4(gcpu_s->gr[0]));
    return(1);
  }
}

smes(s, i, j, k, l, m)
  char *s; 
  int  i, j, k, l, m;
{
#ifdef WITHOS
  log_output(s, i, j, k, l, m);
#endif
#ifdef USEPRINTF
  printf("\033[32;7m");
  printf(s, i, j, k, l, m);
  printf("\033[0;0m");
#else
  pr("\033[32;7m");
  pr(s, i, j, k, l, m);
  pr("\033[0;0m");
#endif
}

umes(s, i, j, k, l, m)
  char *s; 
  int  i, j, k, l, m;
{
#ifdef WITHOS
  log_output(s, i, j, k, l, m);
#endif
#ifdef USEPRINTF
  printf("\033[36;4m");
  printf(s, i, j, k, l, m);
  printf("\033[0;0m");
#else
  pr("\033[36;4m");
  pr(s, i, j, k, l, m);
  pr("\033[0;0m");
#endif
}

#ifndef USEPRINTF
int  arg_dim[5];
int  argp;
int  cols;
int  sign;

pr(s, i, j, k, l, m)
  char *s;
  int  i, j, k, l, m;
{
  char	   *parse_format();
  char	   buf[1024];
  char	   *bufp;
  double   df;
  char     *p;
  int      len;
  int      si;
  unsigned usi;
  
  bufp = buf;
  argp = 0;
  arg_dim[0] = i;
  arg_dim[1] = j;
  arg_dim[2] = k;
  arg_dim[3] = l;
  arg_dim[4] = m;
  for(p = s; *p; p++) {
    cols = 10;
    sign = ' ';
    if ((char) *p != '%')
      *bufp++ = *p;
    else {    
      p = parse_format(p);
      switch (*p) {
      case '%':
	*bufp++ = '%';
	break;
      case 'd':
      case 'i':
	si = arg_dim[argp++];
	pr_dec(&bufp, si);
	break;
      case 'u':
	usi = arg_dim[argp++];
	pr_udec(&bufp, usi);
	break;
      case 'o':
	usi = arg_dim[argp++];
	pr_uoct(&bufp, usi);
	break;
      case 'p':
      case 'x':
      case 'X':
	usi = arg_dim[argp++];
	pr_uhex(&bufp, usi);
	break;
      case 'b':
	usi = arg_dim[argp++];
	pr_ubyte(&bufp, usi);
	break;
      case 'f':
	* (int*)&df    = arg_dim[argp++];
	*((int*)&df+1) = arg_dim[argp++]; 
	pr_double_f(&bufp, df);
	break;
      case 'e':
      case 'E':
      case 'g':
      case 'G':
	* (int*)&df    = arg_dim[argp++];
	*((int*)&df+1) = arg_dim[argp++]; 
	pr_double_e(&bufp, df);
	break;
      case 'c':
	*bufp++ = arg_dim[argp++];
	break;
      case 's':
        len = slen((char*)(UINT2P)arg_dim[argp]);
	scpy(bufp, (char*)(UINT2P)arg_dim[argp]);
	argp++;
	bufp += len;
	break;
      default:
	break;
      }
    }
  }
  *bufp = 0;

#ifdef PRWRITE
  write(1, buf, slen(buf));
#endif
#ifdef PRMPUTCHAR
  {
    char obuf[1024], *obufp, c;

    bufp = buf;
    obufp = obuf;
    while (c = *bufp++) {
      if (c == '\n')
        *obufp++ = '\r';
      *obufp++ = c;
    }
    
    /* write ttya */
    cif_struct0.name     = (llu)(P2UINT)"write";
    cif_struct0.nargs    = 3;
    cif_struct0.nreturns = 1;
    cif_struct0.param[0] = (llu)serial_ih;
    cif_struct0.param[1] = (llu)(P2UINT)obuf;
    cif_struct0.param[2] = (llu)(obufp-obuf);
    call_rom(&cif_struct0);
  }
#endif
}

pr_dec(p,q) char **p; int q;
{
  char ascii[20];
  int i;

  if (q == 0) {
    *(*p)++ = '0';
    return;
  }
  if (q < 0) {
    *(*p)++ = '-';
    q = -q;
  }
  else if (sign == '+')
    *(*p)++ = '+';
  for (i = 0; q;) {
    ascii[i++] = '0' + q%10;
    q = q/10;
  }
  for (i--; i >= 0 ; i--)
    *(*p)++ = ascii[i];
}

pr_udec(p,q) char **p; unsigned int q;
{
  char ascii[20];
  int i;

  if (q == 0) {
    *(*p)++ = '0';
    return;
  }
  for (i = 0; q;) {
    ascii[i++] = '0' + q%10;
    q = q/10;
  }
  for (i--; i >= 0 ; i--)
    *(*p)++ = ascii[i];
}

pr_uoct(p,q) char **p; unsigned int q;
{
  char ascii[20];
  int i;

  if (q == 0) {
    *(*p)++ = '0';
    return;
  }
  for (i = 0; q;) {
    ascii[i++] = '0' + (q & 7);
    q = q >> 3;
  }
  for (i--; i >= 0 ; i--)
    *(*p)++ = ascii[i];
}

pr_uhex(p,q) char **p; unsigned int q;
{
  unsigned u, l;
  int i;

  for (i=0; i<4; i++) {
    u = *((unsigned char*)&q+i) >> 4;
    l = *((unsigned char*)&q+i) & 15;
    *(*p)++ = u < 10 ? '0' + u : 'A' + u - 10;
    *(*p)++ = l < 10 ? '0' + l : 'A' + l - 10;
  }
}

pr_ubyte(p,q) char **p; unsigned int q;
{
  unsigned u, l;

  u = *((unsigned char*)&q+3) >> 4;
  l = *((unsigned char*)&q+3) & 15;
  *(*p)++ = u < 10 ? '0' + u : 'A' + u - 10;
  *(*p)++ = l < 10 ? '0' + l : 'A' + l - 10;
}

pr_double_f(p,q) char **p; double q;
{
  int x;

  if (q == 0.0) {
    *(*p)++ = '0';
    *(*p)++ = '.';
    for (; cols; cols--)
      *(*p)++ = '0';
    return;
  }
  if (q < 0.0) {
    *(*p)++ = '-';
    q = -q;
  }
  else if (sign == '+')
    *(*p)++ = '+';
  if (q >= 1.0) {
    for (x=0; q >= 10.0; x++)
      q = q / 10.0;
    for (; x >= 0; x--) {
      *(*p)++ = (int)q + '0';
      q = q - (int)q;
      q = q * 10.0;
    }
    *(*p)++ = '.';
    for (; cols; cols--) {
      *(*p)++ = (int)q + '0';
      q = q - (int)q;
      q = q * 10.0;
    }
  }
  else {
    for (x=1; q < 1.0; x--)
      q = q * 10.0;
    *(*p)++ = '0';
    *(*p)++ = '.';
    for (; x < 0 && cols; x++,cols--)
      *(*p)++ = '0';
    for (; cols ; cols--) {
      *(*p)++ = (int)q + '0';
      q = q - (int)q;
      q = q * 10.0;
    }
  }
}

pr_double_e(p,q) char **p; double q;
{
  int x;

  if (q == 0.0) {
    *(*p)++ = '0';
    *(*p)++ = '.';
    for (; cols; cols--)
      *(*p)++ = '0';
    *(*p)++ = 'E';
    *(*p)++ = '+';
    *(*p)++ = '0';
    *(*p)++ = '0';
    return;
  }
  if (q < 0.0) {
    *(*p)++ = '-';
    q = -q;
  }
  else if (sign == '+')
    *(*p)++ = '+';
  if (q >= 1.0) {
    for (x=0; q >= 10.0; x++)
      q = q / 10.0;
  }
  else {
    for (x=0; q < 1.0; x--)
      q = q * 10.0;
  }
  *(*p)++ = (int)q + '0';
  *(*p)++ = '.';
  for (; cols; cols--) {
    q = q - (int)q;
    q = q * 10.0;
    *(*p)++ = (int)q + '0';
  }
  *(*p)++ = 'E';
  *(*p)++ = x >= 0 ? '+' : '-';
  x = x >= 0 ? x : -x;
  *(*p)++ = x/10 + '0';
  *(*p)++ = x%10 + '0';
}

char *
parse_format(p)
  char *p;
{
  for (p++; *p; p++) {
    switch (*p) {
    case '*':
	cols = arg_dim[argp++];
	break;
    case '+':
	sign = '+';
	break;
    case '-':
    case ' ':
    case '#':
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'h':
    case 'l':
    case 'L':
    case '.':
	break;
    default: 
	return p;
    }
  }
  return p;
}
#endif

scpy(a, b)
  char *a, *b;
{
  while (*a++ = *b++);
}

slen(p)
  char *p;
{
  int len;

  for (len=0; *p++; len++);
  return(len);
}

#ifdef WITHOS
struct  tms utms;
#endif
long    tmssave;

clrtime()
{
#ifdef WITHOS
  times(&utms);
  tmssave = utms.tms_utime;
#else
  asm("rdpr  %tick,%i0");
  asm("sllx  %i0,1,%i0");
  asm("srlx  %i0,1,%i0");
  asm("sethi %hi(dtree_cpu_clock_frequency),%i1");
  asm("ld    [%i1+%lo(dtree_cpu_clock_frequency)],%i1");
  asm("udivx %i1,1000,%i1");
  asm("udivx %i0,%i1,%i0");
  asm("sethi %hi(tmssave),%i1");
  asm("st    %i0,[%i1+%lo(tmssave)]");
#endif
}

long
gettime()
{
#ifdef WITHOS
  times(&utms);
  return((utms.tms_utime-tmssave)*10);
#else
  asm("rdpr  %tick,%i0");                
  asm("sllx  %i0,1,%i0");
  asm("srlx  %i0,1,%i0");
  asm("sethi %hi(dtree_cpu_clock_frequency),%i1");
  asm("ld    [%i1+%lo(dtree_cpu_clock_frequency)],%i1");
  asm("udivx %i1,1000,%i1");
  asm("udivx %i0,%i1,%i0");
  asm("sethi %hi(tmssave),%i1");
  asm("ld    [%i1+%lo(tmssave)],%i1");
  asm("sub   %i0,%i1,%i0");
#endif
}

