
/* system.s 1995/7/18 */

/* M-on-RISC Dynamically Translating Simulator */
/*	 Copyright (C) 1995 by FUJITSU LIMITED */
/*		   Primary writer: Y.Nakashima */
/*	    nakashim@pine.mfd.cs.fujitsu.co.jp */

	.file	"system.s"
	.section ".data"
	.align	8
	.global system_RcsId
system_RcsId:
	.asciz	"$Id: system.s,v 1.6 1997/05/20 06:54:04 nakashim Exp nakashim $"

	.section ".text"
	.align	4
	.global open
open:
	add	%g0,5,%g1
	ta	8
	retl 
	nop 

	.section ".text"
	.align	4
	.global read
read:
	add	%g0,3,%g1
	ta	8
	retl 
	nop 

	.section ".text"
	.align	4
	.global write
write:
	add	%g0,4,%g1
	ta	8
	retl 
	nop 

	.section ".text"
	.align	4
	.global _exit
_exit:
	add	%g0,1,%g1
	ta	8
	retl 
	nop 

	.section ".text"
	.align	4
	.global extract_tlb
extract_tlb:
	sethi	%hi(i_tlb_tag0),%l0	!
	or	%l0,%lo(i_tlb_tag0),%l0	!
	add	%g0,%g0,%l1		! init counter
ext_itlbtag_loop:			!
	ldxa	[%l1]0x56,%l2		! I-TLB-tag(va=0-0x1f8,asi=0x56)
	stx	%l2,[%l0+%l1]		!
	subcc	%l1,0x1f8,%g0		!
	bne	ext_itlbtag_loop	!
	add	%l1,8,%l1		!
					!
	sethi	%hi(i_tlb_data0),%l0	!
	or	%l0,%lo(i_tlb_data0),%l0!
	add	%g0,%g0,%l1		! init counter
ext_itlbdata_loop:			!
	ldxa	[%l1]0x55,%l2		! I-TLB-data(va=0-0x1f8,asi=0x55)
	stx	%l2,[%l0+%l1]		!
	subcc	%l1,0x1f8,%g0		!
	bne	ext_itlbdata_loop	!
	add	%l1,8,%l1		!
					!
	sethi	%hi(d_tlb_tag0),%l0	!
	or	%l0,%lo(d_tlb_tag0),%l0	!
	add	%g0,%g0,%l1		! init counter
ext_dtlbtag_loop:			!
	ldxa	[%l1]0x5E,%l2		! D-TLB-tag(va=0-0x1f8,asi=0x5E)
	stx	%l2,[%l0+%l1]		!
	subcc	%l1,0x1f8,%g0		!
	bne	ext_dtlbtag_loop	!
	add	%l1,8,%l1		!
					!
	sethi	%hi(d_tlb_data0),%l0	!
	or	%l0,%lo(d_tlb_data0),%l0!
	add	%g0,%g0,%l1		! init counter
ext_dtlbdata_loop:			!
	ldxa	[%l1]0x5D,%l2		! D-TLB-data(va=0-0x1f8,asi=0x5D)
	stx	%l2,[%l0+%l1]		!
	subcc	%l1,0x1f8,%g0		!
	bne	ext_dtlbdata_loop	!
	add	%l1,8,%l1		!
					!
	retl				!
	nop				!

	.section ".text"
	.align	4
	.global get_context
get_context:
	add	%g0,0x8,%l1		!
	ldxa	[%l1]0x58,%o0		! Primary Context
	retl				!
	nop				!
	
	.section ".text"
	.align	4
	.global set_context
set_context:
	add	%g0,0x8,%l1		!
	stxa	%o0,[%l1]0x58		! Primary Context
	membar	#Sync			!
	retl				!
	nop				!
	
/**/

