
/* intlib.s 1995/7/18 */

/* M-on-RISC Dynamically Translating Simulator */
/*	 Copyright (C) 1995 by FUJITSU LIMITED */
/*		   Primary writer: Y.Nakashima */
/*	    nakashim@pine.mfd.cs.fujitsu.co.jp */

	.file	"intlib.s"
	.section ".data"
	.align	8
	.global intlib_RcsId
intlib_RcsId:
	.asciz	"$Id: intlib3.s,v 1.11 1997/06/23 08:17:54 nakashim Exp nakashim $"

!
! <SPARC stack frame>
!
! %fp-->  +-----------------------------------------+ ---
! %fp-off.|automatic var. not used  (%fp not used)  |  ^
!	  |-----------------------------------------|  |
! %sp+200 |%i7 is saved here		            |  size = 24
! %sp+192 |  (reserved)			            |  |
! %sp+184 |%i0 is saved here (struct *gcpu_s)	    |  v
!	  |-----------------------------------------| ---
! %sp+176 |1 double word for calee		    |  ^
! %sp+168 |1 double word for calee		    |  |
! %sp+160 |1 double word for calee		    |  |
! %sp+152 |1 double word for calee		    |  |
! %sp+144 |1 double word for calee		    |  |
! %sp+136 |1 double word for calee		    |  |
!	  |-----------------------------------------|  |
! %sp+off.|1 double word hidden param	            |  size = 184
!	  |-----------------------------------------|  |
! %sp+off.|16 double words for in,local (used by OS)|  v
! %sp-->  +-----------------------------------------+ ---
!
! <%g1-%g7 field assignment>
!
!    See dim.s.
!
! <%o0-%o7,%l0-%l7,%i0-%i7 assignment>
!
!	  +---------------------------------------------------+
!    %o0  |		    Work		              |
!	  +---------------------------------------------------+
!    %o1  |		    Work		              |
!	  +---------------------------------------------------+
!    %o2  |		    Work		              |
!	  +---------------------------------------------------+
!    %o3  |		    Work		              |
!	  +---------------------------------------------------+
!    %o4  |		    Work		              |
!	  +---------------------------------------------------+
!    %o5  |		    Work		              |
!	  +---------------------------------------------------+
!    %sp  |		Stack pointer		              |
!	  +---------------------------------------------------+
!    %o7  |		    Work		              |
!	  +---------------------------------------------------+
!    %l0  |		    Work		              |
!	  +---------------------------------------------------+
!    %l1  |		    Work		              |
!	  +---------------------------------------------------+
!    %l2  |		    Work		              |
!	  +---------------------------------------------------+
!    %l3  |		    Work		              |
!	  +---------------------------------------------------+
!    %l4  |		    Work		              |
!	  +---------------------------------------------------+
!    %l5  |		    Work		              |
!	  +---------------------------------------------------+
!    %l6  |		    Work		              |
!	  +---------------------------------------------------+
!    %l7  |		    Work		              |
!	  +---------------------------------------------------+
!    %i0  |                Param0		              |
!	  +---------------------------------------------------+
!    %i1  |                Param1		              |
!	  +---------------------------------------------------+
!    %i2  |                Param2		              |
!	  +---------------------------------------------------+
!    %i3  |                Param3		              |
!	  +---------------------------------------------------+
!    %i4  |                Param4		              |
!	  +---------------------------------------------------+
!    %i5  |		    Work		              |
!	  +---------------------------------------------------+
!    %fp  |		Frame pointer             	      |
!	  +---------------------------------------------------+
!    %i7  |	        Return Address		              |
!	  +---------------------------------------------------+
!

!
! MVCL Entry Point
!
!   %o1: working R1
!   %o2: working R2
!   %o3: working R1+1(L1)
!   %o4: working R2+1(L2)
!   %o5: PAD
!
	.section ".text"
	.align	4
	.global il_mvcl
il_mvcl:
		ld	[%sp+184],%o0	! struct *gcpu_s
		st	%o7,[%o0+828]	! save return address
		subcc	%o3,0,%g0	!
		bnz	_mvcl000	! if L1 == 0 then
		subcc	%o4,0,%g0	!
		bnz,a	_mvclexit	! if L1 == 0 && L2 != 0 then
		or	%g1,0x1,%g1	!   CC=1
		ba	_mvclexit	! if L1 == 0 && L2 == 0 then
		nop			!   CC=0
    _mvcl000:	bnz	_mvcl010	! if L1 != 0 && L2 == 0 then
		subcc	%o1,%o2,%g0	!
		or	%g1,0x2,%g1	!   CC=2
		ldub	[%g4+%o1],%g0	! force PAGEIN R1
		add	%g4,%o3,%o0	!
		sub	%o0,1,%o0	!
		subcc	%o3,2048,%g0	!
		bgu,a	_mvcl001	! if L1 > 2048 then R1+2047
		add	%g4,2047,%o0	! if L1 <=2048 then R1+L1-1
    _mvcl001:	ldub	[%o0+%o1],%g0	! force PAGEIN R1+min(L1-1,2047)

		/* START COPY (L1 != 0 && L2 == 0) */
		sll	%o5,8,%o7	!
		or	%o5,%o7,%o5	!
		sll	%o5,16,%o7	!
		or	%o5,%o7,%o5	! create PAD|PAD|PAD|PAD
		sub	%o0,%g4,%o0	!
		add	%o0,1,%o0	! create initial counter
		or	%o0,%o1,%o7	!
		andcc	%o7,3,%g0	! if not word aligned then skip
		bnz	_mvclpd2	!
		sub	%o3,%o0,%o3	! update L1
    _mvclpd1:	st	%o5,[%g4+%o1]	! padding (word aligned)
		subcc	%o0,4,%o0	! update counter
		bnz	_mvclpd1	!
		add	%o1,4,%o1	! update R1
		ba	_mvclexit	!
		nop			!
    _mvclpd2:	stb	%o5,[%g4+%o1]	! padding (not word aligned)
		subcc	%o0,1,%o0	! update counter
		bnz	_mvclpd2	!
		add	%o1,1,%o1	! update R1
		ba	_mvclexit	!
		nop			!
		/* STOP COPY (L1 != 0 && L2 == 0) */

    _mvcl010:	bleu	_mvcl020	! if R1 <= R2 then skip
		add	%o2,%o4,%o0	!
		subcc	%o1,%o0,%g0	!
		bcc	_mvcl020	! if R1 >= R2+L2 then skip
		nop			!
		ba	_mvclexit	! else
		or	%g1,0x3,%g1	!   CC=3
    _mvcl020:	ldub	[%g4+%o1],%g0	! force PAGEIN R1
		ldub	[%g4+%o2],%g0	! force PAGEIN R2
		subcc	%o3,%o4,%g0	!
		bgu	_mvcl040	! if L1 >  L2 then skip
		nop			!
		bne,a	_mvcl030	! if L1 == L2 then CC=0
		or	%g1,0x1,%g1	! if L1 <  L2 then CC=1
    _mvcl030:	add	%g4,%o3,%o0	!
		sub	%o0,1,%o0	!
		subcc	%o3,2048,%g0	!
		bgu,a	_mvcl031	! if L1 > 2048 then R1+2047
		add	%g4,2047,%o0	! if L1 <=2048 then R1+L1-1
    _mvcl031:	ba	_mvcl041	!
		nop			!
    _mvcl040:	or	%g1,0x2,%g1	! if L1 > L2 then CC=2 (padding)
		add	%g4,%o4,%o0	!
		sub	%o0,1,%o0	!
		subcc	%o4,2048,%g0	!
		bgu,a	_mvcl041	! if L2 > 2048 then R1+2047
		add	%g4,2047,%o0	! if L2 <=2048 then R1+L2-1
    _mvcl041:	ldub	[%o0+%o1],%g0	! force PAGEIN
		ldub	[%o0+%o2],%g0	! force PAGEIN

		/* START COPY (L1 != 0 && L2 != 0) */
		sub	%o0,%g4,%o0	!
		add	%o0,1,%o0	! create initial counter
		or	%o0,%o1,%o7	!
		or	%o7,%o2,%o7	!
		andcc	%o7,3,%g0	! if not word aligned then skip
		sub	%o3,%o0,%o3	! update L1
		bnz	_mvclcp2	!
		sub	%o4,%o0,%o4	! update L2
    _mvclcp1:	ld	[%g4+%o2],%o7	! get word (word aligned)
		add	%o2,4,%o2	! update R2
		subcc	%o0,4,%o0	! update counter
		st	%o7,[%g4+%o1]	! store word
		bnz	_mvclcp1	!
		add	%o1,4,%o1	! update R1
		ba	_mvclexit	!
		nop			!
    _mvclcp2:	ldub	[%g4+%o2],%o7	! get byte (not word aligned)
		add	%o2,1,%o2	! update R2
		subcc	%o0,1,%o0	! update counter
		stb	%o7,[%g4+%o1]	! store byte
		bnz	_mvclcp2	!
		add	%o1,1,%o1	! update R1
		/* STOP COPY (L1 != 0 && L2 != 0) */

    _mvclexit:	/* BREAK */
		ld	[%sp+184],%o0	! struct *gcpu_s
		ld	[%o0+828],%o7	! restore return address
		retl			!
		nop			!

!
! CLCL Entry Point
!
!   %o1: working R1
!   %o2: working R2
!   %o3: working R1+1(L1)
!   %o4: working R2+1(L2)
!   %o5: PAD
!
	.section ".text"
	.align	4
	.global il_clcl
il_clcl:
		ld	[%sp+184],%o0	! struct *gcpu_s
		st	%o7,[%o0+828]	! save return address
		orcc	%o3,%o4,%g0	!
		bz	_clclexit	! if L1 == 0 && L2 == 0 then
		subcc	%o3,0,%g0	!   CC=0
    _clcl000:	bnz	_clcl010	! if L1 == 0 && L2 != 0 then
		subcc	%o4,0,%g0	!
		ldub	[%g4+%o2],%g0	! force PAGEIN R2
		add	%g4,%o4,%o0	!
		sub	%o0,1,%o0	!
		subcc	%o4,2048,%g0	!
		bgu,a	_clcl001	! if L2 > 2048 then R2+2047
		add	%g4,2047,%o0	! if L2 <=2048 then R2+L2-1
    _clcl001:	ldub	[%o0+%o2],%g0	! force PAGEIN R2+min(L2-1,2047)

		/* START COMPARE (L1 == 0 && L2 != 0) */
		sll	%o5,8,%o7	!
		or	%o5,%o7,%o5	!
		sll	%o5,16,%o7	!
		or	%o5,%o7,%o5	! create PAD|PAD|PAD|PAD
		sub	%o0,%g4,%o0	!
		add	%o0,1,%o0	! create initial counter
		or	%o0,%o2,%o7	!
		andcc	%o7,3,%g0	! if not word aligned then skip
		sub	%o4,%o0,%o4	! update L2
		bnz,a	_clclpd2	!
		and	%o5,0xff,%o5	! create PAD
    _clclpd1:	ld	[%g4+%o2],%o7	!
		subcc	%o5,%o7,%g0	!
		bne,a	_clclpd2	!
		and	%o5,0xff,%o5	! create PAD
		subcc	%o0,4,%o0	! update counter
		bnz	_clclpd1	!
		add	%o2,4,%o2	! update R2
		ba	_clclexit	!
		nop			!
    _clclpd2:	ldub	[%g4+%o2],%o7	!
		subcc	%o5,%o7,%g0	!
		bne	_clcldiff2	!
		nop			!
		subcc	%o0,1,%o0	! update counter
		bnz	_clclpd2	!
		add	%o2,1,%o2	! update R2
		ba	_clclexit	!
		nop			!
		/* STOP COMPARE (L1 == 0 && L2 != 0) */

    _clcl010:	bnz	_clcl020	! if L1 != 0 && L2 == 0 then
		nop			!
		ldub	[%g4+%o1],%g0	! force PAGEIN R1
		add	%g4,%o3,%o0	!
		sub	%o0,1,%o0	!
		subcc	%o3,2048,%g0	!
		bgu,a	_clcl011	! if L1 > 2048 then R1+2047
		add	%g4,2047,%o0	! if L1 <=2048 then R1+L1-1
    _clcl011:	ldub	[%o0+%o1],%g0	! force PAGEIN R1+min(L1-1,2047)

		/* START COMPARE (L1 != 0 && L2 == 0) */
		sll	%o5,8,%o7	!
		or	%o5,%o7,%o5	!
		sll	%o5,16,%o7	!
		or	%o5,%o7,%o5	! create PAD|PAD|PAD|PAD
		sub	%o0,%g4,%o0	!
		add	%o0,1,%o0	! create initial counter
		or	%o0,%o1,%o7	!
		andcc	%o7,3,%g0	! if not word aligned then skip
		sub	%o3,%o0,%o3	! update L1
		add	%o5,%g0,%o7	! swap %o5,%o7
		bnz,a	_clclpd4	!
		and	%o7,0xff,%o7	! create PAD
    _clclpd3:	ld	[%g4+%o1],%o5	!
		subcc	%o5,%o7,%g0	!
		bne,a	_clclpd4	!
		and	%o7,0xff,%o7	! create PAD
		subcc	%o0,4,%o0	! update counter
		bnz	_clclpd3	!
		add	%o1,4,%o1	! update R1
		ba	_clclexit	!
		nop			!
    _clclpd4:	ldub	[%g4+%o1],%o5	!
		subcc	%o5,%o7,%g0	!
		bne	_clcldiff1	!
		nop			!
		subcc	%o0,1,%o0	! update counter
		bnz	_clclpd4	!
		add	%o1,1,%o1	! update R1
		ba	_clclexit	!
		nop			!
		/* STOP COMPARE (L1 != 0 && L2 == 0) */

    _clcl020:	ldub	[%g4+%o1],%g0	! force PAGEIN R1
		ldub	[%g4+%o2],%g0	! force PAGEIN R2
		subcc	%o3,%o4,%g0	!
		bgu	_clcl040	! if L1 >  L2 then skip
		nop			!
    _clcl030:	add	%g4,%o3,%o0	!
		sub	%o0,1,%o0	!
		subcc	%o3,2048,%g0	!
		bgu,a	_clcl031	! if L1 > 2048 then R1+2047
		add	%g4,2047,%o0	! if L1 <=2048 then R1+L1-1
    _clcl031:	ba	_clcl041	!
		nop			!
    _clcl040:	add	%g4,%o4,%o0	!
		sub	%o0,1,%o0	!
		subcc	%o4,2048,%g0	!
		bgu,a	_clcl041	! if L2 > 2048 then R1+2047
		add	%g4,2047,%o0	! if L2 <=2048 then R1+L2-1
    _clcl041:	ldub	[%o0+%o1],%g0	! force PAGEIN
		ldub	[%o0+%o2],%g0	! force PAGEIN

		/* START COMPARE (L1 != 0 && L2 != 0) */
		sub	%o0,%g4,%o0	!
		add	%o0,1,%o0	! create initial counter
		or	%o0,%o1,%o7	!
		or	%o7,%o2,%o7	!
		andcc	%o7,3,%g0	! if not word aligned then skip
		sub	%o3,%o0,%o3	! update L1
		bnz	_clclcp2	!
		sub	%o4,%o0,%o4	! update L2
    _clclcp1:	ld	[%g4+%o1],%o5	!
		ld	[%g4+%o2],%o7	!
		subcc	%o5,%o7,%g0	!
		bne	_clclcp2	!
		nop			!
		subcc	%o0,4,%o0	! update counter
		add	%o1,4,%o1	! update R1
		bnz	_clclcp1	!
		add	%o2,4,%o2	! update R2
		ba	_clclexit	!
		nop			!
    _clclcp2:	ldub	[%g4+%o1],%o5	!
		ldub	[%g4+%o2],%o7	!
		subcc	%o5,%o7,%g0	!
		bne	_clcldiff3	!
		nop			!
		subcc	%o0,1,%o0	! update counter
		add	%o1,1,%o1	! update R1
		bnz	_clclcp2	!
		add	%o2,1,%o2	! update R2
		ba	_clclexit	!
		nop			!
		/* STOP COMPARE (L1 != 0 && L2 != 0) */

    _clcldiff1:	ba	_clcldiff	!
		add	%o3,%o0,%o3	! fix L1
    _clcldiff3:	add	%o3,%o0,%o3	! fix L1
    _clcldiff2:	add	%o4,%o0,%o4	! fix L2
    _clcldiff:	bl,a	_clclexit	!
		or	%g1,0x1,%g1	! CC=1
		bg,a	_clclexit	!
		or	%g1,0x2,%g1	! CC=2

    _clclexit:	/* BREAK */
		ld	[%sp+184],%o0	! struct *gcpu_s
		ld	[%o0+828],%o7	! restore return address
		retl			!
		nop			!

!
! ED Entry Point
!
!   %i0: *gcpu_s
!   %i1: B1+D1
!   %i2: B2+D2
!   %i3: L
!   %i4: not used
!   %i5: not used
!   %i6: %fp
!   %i7: return address
!
	.section ".text"
	.align	4
	.global il_ed
il_ed:
		save	%sp,-208,%sp	! 12 + 92

		/******** TRIAL EXECUTION *********/
		sethi	%hi(0x00070000),%o7
		add	%g0,0,%l4	! reset R1 counter
		add	%g0,0,%l5	! reset R2 counter
		ldub	[%i1+%l4],%l0	! get fill-byte
		ba	__edtop		!
		nop			!
    __edloop:	subcc	%i3,%l4,%g0	!
		be	__edbreak	!
		add	%l4,1,%l4	! update R1 counter
    __edtop:	ldub	[%i1+%l4],%l1	! get pattern-byte
		subcc	%l1,0x20,%g0	!
		be	__ed0		!
		subcc	%l1,0x21,%g0	! if pattern-byte == 0x20/0x21 then
		bne	__edloop	!
    __ed0:	andcc	%l5,1,%g0	!
		bnz,a	__edloop	!
		add	%l5,1,%l5	!   update counter
		srl	%l5,1,%o0	! if left 4bit then
		ldub	[%i2+%o0],%l2	!   get new source-byte
		srl	%l2,4,%o0	!   get left 4bit
		and	%l2,0xf,%o1	!
		subcc	%o0,0xa,%g0	!
		bge,a	_edexit		!   if not digit then
		or	%g7,%o7,%g7	!     data exception
		subcc	%o1,0xa,%g0	!
		bge,a	__ed0s		!   if right 4bit is sign then
		add	%l5,1,%l5	!     increment counter to skip sign
    __ed0s:	ba	__edloop	!
		add	%l5,1,%l5	!   update counter
					! ====
    __edbreak:				!
	
		/******** ACTUAL EXECUTION ********/
		sethi	%hi(0x00070000),%o7
		add	%g0,0,%l4	! reset R1 counter
		add	%g0,0,%l5	! reset R2 counter
		add	%g0,0,%l6	! reset significance-indicator
		add	%g0,0,%l7	! reset internal-NZ
		ldub	[%i1+%l4],%l0	! get fill-byte
		ba	_edtop		!
		nop			!
    _edloop:	subcc	%i3,%l4,%g0	!
		be	_edbreak	!
		add	%l4,1,%l4	! update R1 counter
    _edtop:	ldub	[%i1+%l4],%l1	! get pattern-byte
		subcc	%l1,0x20,%g0	!
		bne,a	_ed1		!
		subcc	%l1,0x21,%g0	! if pattern-byte == 0x20 then
		andcc	%l5,1,%g0	!
		and	%l2,0xf,%o0	!
		bnz,a	_ed0r		!
		add	%g0,0,%o1	!
    _ed0l:	srl	%l5,1,%o0	! if left 4bit then
		ldub	[%i2+%o0],%l2	!   get new source-byte
		srl	%l2,4,%o0	!   get left 4bit
		and	%l2,0xf,%o1	!
    _ed0r:	subcc	%o0,0xa,%g0	!
		bge,a	_edexit		!   if not digit then
		or	%g7,%o7,%g7	!     data exception
		subcc	%o1,0xa,%g0	!
		bge,a	_ed0s		!   if right 4bit is sign then
		add	%l5,1,%l5	!     increment counter to skip sign
    _ed0s:	add	%l5,1,%l5	!   update counter
		subcc	%l6,0,%g0	!
		bnz	_ed0on		!   if sig-ind == off then
		subcc	%o0,0,%g0	!     if left 4bit == 0 then
    _ed0of:	bnz,a	_ed0ofnz	!
		add	%g0,1,%l7	!       (mark NZ)
    _ed0ofe:	ba	_edloop		!
		stb	%l0,[%i1+%l4]	!       store fill-byte
					! ----
    _ed0ofnz:	subcc	%o1,0xa,%g0	!     if left 4bit != 0 then
		be	_ed0ofnze	!       if right 4bit != '+' then
		subcc	%o1,0xc,%g0	!         force sig-ind = on
		be	_ed0ofnze	!
		subcc	%o1,0xe,%g0	!
		bge	_ed0ofnze	!
		nop			!
		add	%g0,1,%l6	!       endif
    _ed0ofnze:	or	%o0,0xf0,%o1	!       pack -> zone
		ba	_edloop		!
		stb	%o1,[%i1+%l4]	!       store digit
					! ----
    _ed0on:	bnz,a	_ed0onnz	!   if sig-ind == on then
		add	%g0,1,%l7	!     if if left 4bit == 0 then
    _ed0onnz:	subcc	%o1,0xa,%g0	!       (mark NZ)
		be,a	_ed0one		!     if right 4bit == '+' then
		add	%g0,0,%l6	!       force sig-ind = off
		subcc	%o1,0xc,%g0	!
		be,a	_ed0one		!
		add	%g0,0,%l6	!
		subcc	%o1,0xe,%g0	!
		bge,a	_ed0one		!
		add	%g0,0,%l6	!     endif
    _ed0one:	or	%o0,0xf0,%o1	!     pack -> zone
		ba	_edloop		!
		stb	%o1,[%i1+%l4]	!     store digit
					! ====
    _ed1:	bne,a	_ed2		!
		subcc	%l1,0x22,%g0	! if pattern-byte == 0x21 then
		andcc	%l5,1,%g0	!
		and	%l2,0xf,%o0	!
		bnz,a	_ed1r		!
		add	%g0,0,%o1	!
    _ed1l:	srl	%l5,1,%o0	! if left 4bit then
		ldub	[%i2+%o0],%l2	!   get new source-byte
		srl	%l2,4,%o0	!   get left 4bit
		and	%l2,0xf,%o1	!
    _ed1r:	subcc	%o0,0xa,%g0	!
		bge,a	_edexit		!   if not digit then
		or	%g7,%o7,%g7	!     data exception
		subcc	%o1,0xa,%g0	!
		bge,a	_ed1s		!   if right 4bit is sign then
		add	%l5,1,%l5	!     increment counter to skip sign
    _ed1s:	add	%l5,1,%l5	!   update counter
		subcc	%l6,0,%g0	!
		bnz	_ed1on		!   if sig-ind == off then
		subcc	%o0,0,%g0	!     if left 4bit == 0 then
    _ed1of:	bnz,a	_ed1ofnz	!
		add	%g0,1,%l7	!       (mark NZ)
		subcc	%o1,0xa,%g0	!       if right 4bit != '+' then
		be	_ed1ofe		!         force sig-ind = on
		subcc	%o1,0xc,%g0	!
		be	_ed1ofe		!
		subcc	%o1,0xe,%g0	!
		bge	_ed1ofe		!
		nop			!
		add	%g0,1,%l6	!       endif
    _ed1ofe:	ba	_edloop		!
		stb	%l0,[%i1+%l4]	!       store fill-byte
					! ----
    _ed1ofnz:	subcc	%o1,0xa,%g0	!     if left 4bit != 0 then
		be	_ed1ofnze	!       if right 4bit != '+' then
		subcc	%o1,0xc,%g0	!         force sig-ind = on
		be	_ed1ofnze	!
		subcc	%o1,0xe,%g0	!
		bge	_ed1ofnze	!
		nop			!
		add	%g0,1,%l6	!       endif
    _ed1ofnze:	or	%o0,0xf0,%o1	!       pack -> zone
		ba	_edloop		!
		stb	%o1,[%i1+%l4]	!       store digit
					! ----
    _ed1on:	bnz,a	_ed1onnz	!   if sig-ind == on then  
		add	%g0,1,%l7	!     if left 4bit == 0 then
    _ed1onnz:	subcc	%o1,0xa,%g0	!       (mark NZ)
		be,a	_ed1one		!     if right 4bit == '+' then
		add	%g0,0,%l6	!       force sig-ind = off
		subcc	%o1,0xc,%g0	!
		be,a	_ed1one		!
		add	%g0,0,%l6	!
		subcc	%o1,0xe,%g0	!
		bge,a	_ed1one		!
		add	%g0,0,%l6	!     endif
    _ed1one:	or	%o0,0xf0,%o1	!     pack -> zone
		ba	_edloop		!
		stb	%o1,[%i1+%l4]	!     store digit
					! ====
    _ed2:	bne,a	_ed3		!
		nop			! if pattern-byte == 0x22 then
		add	%g0,0,%l6	!   force sig-ind = off
		add	%g0,0,%l7	!   reset NZ
		ba	_edloop		!
		stb	%l0,[%i1+%l4]	!   store fill-byte
					! ====
    _ed3:	subcc	%l6,0,%g0	! if pattern-byte == message then
		bz,a	_edloop		!   if sig-ind == off then
		stb	%l0,[%i1+%l4]	!     store fill-byte
		ba	_edloop		!   if sig-ind == on then
		stb	%l1,[%i1+%l4]	!     store message-byte
					! ====
    _edbreak:	andn	%g1,0x3,%g1	! CC=0
		subcc	%l7,0,%g0	! if NZ == 0 then
		bz	_edexit		!   CC=0
		subcc	%l6,0,%g0	! if sig-ind == on then
		bnz,a	_edexit		!   CC=1
		or	%g1,0x1,%g1	! if sig-ind == off then
		or	%g1,0x2,%g1	!   CC=2
	
		/* RETURN */
    _edexit:	ret			!
		restore			!

!
! EDMK Entry Point
!
!   %i0: *gcpu_s
!   %i1: B1+D1
!   %i2: B2+D2
!   %i3: L
!   %i4: B1+D1(with no offset)
!   %i5: Mreg#1
!   %i6: %fp
!   %i7: return address
!
	.section ".text"
	.align	4
	.global il_edmk
il_edmk:
		save	%sp,-208,%sp	! 12 + 92

		/******** TRIAL EXECUTION *********/
		sethi	%hi(0x00070000),%o7
		add	%g0,0,%l4	! reset R1 counter
		add	%g0,0,%l5	! reset R2 counter
		ldub	[%i1+%l4],%l0	! get fill-byte
		ba	__edmktop	!
		nop			!
    __edmkloop:	subcc	%i3,%l4,%g0	!
		be	__edmkbreak	!
		add	%l4,1,%l4	! update R1 counter
    __edmktop:	ldub	[%i1+%l4],%l1	! get pattern-byte
		subcc	%l1,0x20,%g0	!
		be	__edmk0		!
		subcc	%l1,0x21,%g0	! if pattern-byte == 0x20/0x21 then
		bne	__edmkloop	!
    __edmk0:	andcc	%l5,1,%g0	!
		bnz,a	__edmkloop	!
		add	%l5,1,%l5	!   update counter
		srl	%l5,1,%o0	! if left 4bit then
		ldub	[%i2+%o0],%l2	!   get new source-byte
		srl	%l2,4,%o0	!   get left 4bit
		and	%l2,0xf,%o1	!
		subcc	%o0,0xa,%g0	!
		bge,a	_edmkexit	!   if not digit then
		or	%g7,%o7,%g7	!     data exception
		subcc	%o1,0xa,%g0	!
		bge,a	__edmk0s	!   if right 4bit is sign then
		add	%l5,1,%l5	!     increment counter to skip sign
    __edmk0s:	ba	__edmkloop	!
		add	%l5,1,%l5	!   update counter
					! ====
    __edmkbreak:			!
	
		/******** ACTUAL EXECUTION ********/
		sethi	%hi(0x00070000),%o7
		add	%i5,0,%l3	! reset internal-MARK
		add	%g0,0,%l4	! reset R1 counter
		add	%g0,0,%l5	! reset R2 counter
		add	%g0,0,%l6	! reset significance-indicator
		add	%g0,0,%l7	! reset internal-NZ
		ldub	[%i1+%l4],%l0	! get fill-byte
		ba	_edmktop	!
		nop			!
    _edmkloop:	subcc	%i3,%l4,%g0	!
		be	_edmkbreak	!
		add	%l4,1,%l4	! update R1 counter
    _edmktop:	ldub	[%i1+%l4],%l1	! get pattern-byte
		subcc	%l1,0x20,%g0	!
		bne,a	_edmk1		!
		subcc	%l1,0x21,%g0	! if pattern-byte == 0x20 then
		andcc	%l5,1,%g0	!
		and	%l2,0xf,%o0	!
		bnz,a	_edmk0r		!
		add	%g0,0,%o1	!
    _edmk0l:	srl	%l5,1,%o0	! if left 4bit then
		ldub	[%i2+%o0],%l2	!   get new source-byte
		srl	%l2,4,%o0	!   get left 4bit
		and	%l2,0xf,%o1	!
    _edmk0r:	subcc	%o0,0xa,%g0	!
		bge,a	_edmkexit	!   if not digit then
		or	%g7,%o7,%g7	!     data exception
		subcc	%o1,0xa,%g0	!
		bge,a	_edmk0s		!   if right 4bit is sign then
		add	%l5,1,%l5	!     increment counter to skip sign
    _edmk0s:	add	%l5,1,%l5	!   update counter
		subcc	%l6,0,%g0	!
		bnz	_edmk0on	!   if sig-ind == off then
		subcc	%o0,0,%g0	!     if left 4bit == 0 then
    _edmk0of:	bnz,a	_edmk0ofnz	!
		add	%g0,1,%l7	!       (mark NZ)
    _edmk0ofe:	ba	_edmkloop	!
		stb	%l0,[%i1+%l4]	!       store fill-byte
					! ----
    _edmk0ofnz:	subcc	%o1,0xa,%g0	!     if left 4bit != 0 then
		be	_edmk0ofnze	!       if right 4bit != '+' then
		subcc	%o1,0xc,%g0	!         force sig-ind = on
		be	_edmk0ofnze	!
		subcc	%o1,0xe,%g0	!
		bge	_edmk0ofnze	!
		nop			!
		add	%g0,1,%l6	!       endif
    _edmk0ofnze:add	%i4,%l4,%l3	!       MARK
		or	%o0,0xf0,%o1	!       pack -> zone
		ba	_edmkloop	!
		stb	%o1,[%i1+%l4]	!       store digit
					! ----
    _edmk0on:	bnz,a	_edmk0onnz	!   if sig-ind == on then
		add	%g0,1,%l7	!     if if left 4bit == 0 then
    _edmk0onnz:	subcc	%o1,0xa,%g0	!       (mark NZ)
		be,a	_edmk0one	!     if right 4bit == '+' then
		add	%g0,0,%l6	!       force sig-ind = off
		subcc	%o1,0xc,%g0	!
		be,a	_edmk0one	!
		add	%g0,0,%l6	!
		subcc	%o1,0xe,%g0	!
		bge,a	_edmk0one	!
		add	%g0,0,%l6	!     endif
    _edmk0one:	or	%o0,0xf0,%o1	!     pack -> zone
		ba	_edmkloop	!
		stb	%o1,[%i1+%l4]	!     store digit
					! ====
    _edmk1:	bne,a	_edmk2		!
		subcc	%l1,0x22,%g0	! if pattern-byte == 0x21 then
		andcc	%l5,1,%g0	!
		and	%l2,0xf,%o0	!
		bnz,a	_edmk1r		!
		add	%g0,0,%o1	!
    _edmk1l:	srl	%l5,1,%o0	! if left 4bit then
		ldub	[%i2+%o0],%l2	!   get new source-byte
		srl	%l2,4,%o0	!   get left 4bit
		and	%l2,0xf,%o1	!
    _edmk1r:	subcc	%o0,0xa,%g0	!
		bge,a	_edmkexit	!   if not digit then
		or	%g7,%o7,%g7	!     data exception
		subcc	%o1,0xa,%g0	!
		bge,a	_edmk1s		!   if right 4bit is sign then
		add	%l5,1,%l5	!     increment counter to skip sign
    _edmk1s:	add	%l5,1,%l5	!   update counter
		subcc	%l6,0,%g0	!
		bnz	_edmk1on	!   if sig-ind == off then
		subcc	%o0,0,%g0	!     if left 4bit == 0 then
    _edmk1of:	bnz,a	_edmk1ofnz	!
		add	%g0,1,%l7	!       (mark NZ)
		subcc	%o1,0xa,%g0	!       if right 4bit != '+' then
		be	_edmk1ofe	!         force sig-ind = on
		subcc	%o1,0xc,%g0	!
		be	_edmk1ofe	!
		subcc	%o1,0xe,%g0	!
		bge	_edmk1ofe	!
		nop			!
		add	%g0,1,%l6	!       endif
    _edmk1ofe:	ba	_edmkloop	!
		stb	%l0,[%i1+%l4]	!       store fill-byte
					! ----
    _edmk1ofnz:	subcc	%o1,0xa,%g0	!     if left 4bit != 0 then
		be	_edmk1ofnze	!       if right 4bit != '+' then
		subcc	%o1,0xc,%g0	!         force sig-ind = on
		be	_edmk1ofnze	!
		subcc	%o1,0xe,%g0	!
		bge	_edmk1ofnze	!
		nop			!
		add	%g0,1,%l6	!       endif
    _edmk1ofnze:add	%i4,%l4,%l3	!       MARK
		or	%o0,0xf0,%o1	!       pack -> zone
		ba	_edmkloop	!
		stb	%o1,[%i1+%l4]	!       store digit
					! ----
    _edmk1on:	bnz,a	_edmk1onnz	!   if sig-ind == on then  
		add	%g0,1,%l7	!     if left 4bit == 0 then
    _edmk1onnz:	subcc	%o1,0xa,%g0	!       (mark NZ)
		be,a	_edmk1one	!     if right 4bit == '+' then
		add	%g0,0,%l6	!       force sig-ind = off
		subcc	%o1,0xc,%g0	!
		be,a	_edmk1one	!
		add	%g0,0,%l6	!
		subcc	%o1,0xe,%g0	!
		bge,a	_edmk1one	!
		add	%g0,0,%l6	!     endif
    _edmk1one:	or	%o0,0xf0,%o1	!     pack -> zone
		ba	_edmkloop	!
		stb	%o1,[%i1+%l4]	!     store digit
					! ====
    _edmk2:	bne,a	_edmk3		!
		nop			! if pattern-byte == 0x22 then
		add	%g0,0,%l6	!   force sig-ind = off
		add	%g0,0,%l7	!   reset NZ
		ba	_edmkloop	!
		stb	%l0,[%i1+%l4]	!   store fill-byte
					! ====
    _edmk3:	subcc	%l6,0,%g0	! if pattern-byte == message then
		bz,a	_edmkloop	!   if sig-ind == off then
		stb	%l0,[%i1+%l4]	!     store fill-byte
		ba	_edmkloop	!   if sig-ind == on then
		stb	%l1,[%i1+%l4]	!     store message-byte
					! ====
    _edmkbreak:	andcc	%g7,0x10,%g0	! if AM == 1 then
		sethi	%hi(0x80000000),%o0
		bnz,a	_edmk24bit	!   get 31bit address
		andn	%l3,%o0,%i5	!   rewrite Mreg#1
		sethi	%hi(0xff000000),%o0
		and	%i5,%o0,%i5	! if AM == 0 then
		andn	%l3,%o0,%l3	!   get 24bit address
		or	%i5,%l3,%i5	!   rewrite Mreg#1
    _edmk24bit:	andn	%g1,0x3,%g1	! CC=0
		subcc	%l7,0,%g0	! if NZ == 0 then
		bz	_edmkexit	!   CC=0
		subcc	%l6,0,%g0	! if sig-ind == on then
		bnz,a	_edmkexit	!   CC=1
		or	%g1,0x1,%g1	! if sig-ind == off then
		or	%g1,0x2,%g1	!   CC=2
	
		/* RETURN */
    _edmkexit:	ret			!
		restore			!
	
!
! SRP Entry Point
!
!   %i0: *gcpu_s
!   %i1: B1+D1
!   %i2: B2+D2
!   %i3: L1
!   %i4: I3
!   %i5: not used
!   %i6: %fp
!   %i7: return address
!
	.section ".text"
	.align	4
	.global il_srp
il_srp:
		save	%sp,-208,%sp	! 12 + 92

		/* CLEAR PARAM01/02 */
		add	%i0,768,%o0	! top of param01/02
		add	%g0,32,%o1	! counter
    _srp000:	subcc	%o1,4,%o1	!
		bnz	_srp000		!
		st	%g0,[%o0+%o1]	! clear param01/02 with 0

		/* COPY R1 -> PARAM02,CHECK DATA,FIX SIGN */
    _srp001:	add	%i0,799,%o0	! bot of param02
		sub	%o0,%i3,%o0	! top of param02
		add	%i1,%g0,%o1	! top of B1
		add	%i3,%g0,%o3	! counter

		/* COPY BODY */
    _srp002:	sethi	%hi(0x00070000),%o7
		ldub	[%o1+%o3],%l0	! get rightmost R1/R2
		and	%l0,0xf,%l1	! extract sign
		subcc	%l1,0xf,%g0	!
		be,a	_srp004		!
		andn	%l0,0x3,%l0	! force Sign to be 0xC
		subcc	%l1,0xa,%g0	!
		bl,a	_srpexit	! if not sign then
		or	%g7,%o7,%g7	!   data exception
		or	%l0,0xc,%l0	! force Sign to be 0xC/D
		ba	_srp004		!
		andn	%l0,0x2,%l0	!
    _srp003:	ldub	[%o1+%o3],%l0	! get digit R1/R2
		and	%l0,0xf,%l1	! extract digit
		subcc	%l1,0xa,%g0	!
		bge,a	_srpexit	! if not digit then
		or	%g7,%o7,%g7	!   data exception
    _srp004:	srl	%l0,4,%l1	! extract digit
		subcc	%l1,0xa,%g0	!
		bge,a	_srpexit	! if not digit then
		or	%g7,%o7,%g7	!   data exception
		stb	%l0,[%o0+%o3]	! store param01/param02
		subcc	%o3,1,%o3	! update counter
		bpos	_srp003		!
		nop			!

		/* CHECK I3 */
		subcc	%i4,0xa,%g0	!
		bge,a	_srpexit	! if not digit then
		or	%g7,%o7,%g7	!   data exception

		/* CC=0 */
		andn	%g1,0x3,%g1	! CC=0

		/* CHECK SHIFT VALUE */
		ldd	[%i0+784],%l0	! load R2 -> %l0-%l3
		ldd	[%i0+792],%l2	!
		andn	%l3,0xf,%l3	! clear sign with 0
		sll	%i2,26,%i2	! extract signed-imm.6
		sra	%i2,26,%i2	!
		subcc	%g0,%i2,%i2	! if shift value >= 0 then
		ble,a	_srpl		!   shift left
		sub	%g0,%i2,%i2	!

		/* SHIFT RIGHT (1-32) R2 -> R2 */
    _srpr:	subcc	%i2,7,%g0	!
		bg	_srprs0		!
		subcc	%i2,8,%g0	! case 1 <= %i2 <= 7:
		sll	%i2,2,%o0	! shift count (right)
		or	%g0,32,%o1	!
		sub	%o1,%o0,%o1	! shift count (left)
		srl	%l3,%o0,%l3	!
		sll	%l2,%o1,%o2	!
		or	%o2,%l3,%l3	!
		srl	%l2,%o0,%l2	!
		sll	%l1,%o1,%o2	!
		or	%o2,%l2,%l2	!
		srl	%l1,%o0,%l1	!
		sll	%l0,%o1,%o2	!
		or	%o2,%l1,%l1	!
		ba	_srprs7		!
		srl	%l0,%o0,%l0	!
					!
    _srprs0:	bg	_srprs1		!
		subcc	%i2,15,%g0	! case %i2 == 8:
		add	%l2,%g0,%l3	!
		add	%l1,%g0,%l2	!
		add	%l0,%g0,%l1	!
		ba	_srprs7		!
		add	%g0,%g0,%l0	!
					!
    _srprs1:	bg	_srprs2		!
		subcc	%i2,16,%g0	! case 9 <= %i2 <= 15:
		sub	%i2,8,%i2	!
		sll	%i2,2,%o0	! shift count (right)
		or	%g0,32,%o1	!
		sub	%o1,%o0,%o1	! shift count (left)
		srl	%l2,%o0,%l3	!
		sll	%l1,%o1,%o2	!
		or	%o2,%l3,%l3	!
		srl	%l1,%o0,%l2	!
		sll	%l0,%o1,%o2	!
		or	%o2,%l2,%l2	!
		srl	%l0,%o0,%l1	!
		ba	_srprs7		!
		add	%g0,%g0,%l0	!
					!
    _srprs2:	bg	_srprs3		!
		subcc	%i2,23,%g0	! case %i2 == 16:
		add	%l1,%g0,%l3	!
		add	%l0,%g0,%l2	!
		add	%g0,%g0,%l1	!
		ba	_srprs7		!
		add	%g0,%g0,%l0	!
					!
    _srprs3:	bg	_srprs4		!
		subcc	%i2,24,%g0	! case 17 <= %i2 <= 23:
		sub	%i2,16,%i2	!
		sll	%i2,2,%o0	! shift count (right)
		or	%g0,32,%o1	!
		sub	%o1,%o0,%o1	! shift count (left)
		srl	%l1,%o0,%l3	!
		sll	%l0,%o1,%o2	!
		or	%o2,%l3,%l3	!
		srl	%l0,%o0,%l2	!
		add	%g0,%g0,%l1	!
		ba	_srprs7		!
		add	%g0,%g0,%l0	!
					!
    _srprs4:	bg	_srprs5		!
		subcc	%i2,31,%g0	! case %i2 == 24:
		add	%l0,%g0,%l3	!
		add	%g0,%g0,%l2	!
		add	%g0,%g0,%l1	!
		ba	_srprs7		!
		add	%g0,%g0,%l0	!
					!
    _srprs5:	bg	_srprs6		!
		nop			! case 25 <= %i2 <= 31:
		sub	%i2,24,%i2	!
		sll	%i2,2,%o0	! shift count (right)
		or	%g0,32,%o1	!
		sub	%o1,%o0,%o1	! shift count (left)
		srl	%l0,%o0,%l3	!
		add	%g0,%g0,%l2	!
		add	%g0,%g0,%l1	!
		ba	_srprs7		!
		add	%g0,%g0,%l0	!
					!
    _srprs6:	add	%g0,%g0,%l3	! case %i2 == 32:
		add	%g0,%g0,%l2	!
		add	%g0,%g0,%l1	!
		add	%g0,%g0,%l0	!

		/* COPY SIGN & SETUP ROUNDING */
    _srprs7:	ldub	[%i0+799],%o0	! load sign of R2
		and	%o0,0xf,%o0	! mask sign
		and	%l3,0xf,%o1	! rounding
		add	%o1,%i4,%o1	!
		andn	%l3,0xf,%l3	!
		or	%l3,%o0,%l3	!
		subcc	%o1,0xa,%g0	!
		bge,a	_srprs8		!
		or	%o0,0x10,%o0	!
    _srprs8:	stb	%o0,[%i0+783]	! store rounding
		std	%l0,[%i0+784]	! store R2
		std	%l2,[%i0+792]	!

		/* ADD R1+R2 -> R1 */
		add	%i0,783,%o0	! bot address of R1
		add	%i0,799,%o1	! bot address of R2
		add	%i3,0,%o3	!
    _srpr00:	sub	%o0,%o3,%o0	!
		sub	%o1,%o3,%o1	!
		add	%i3,0,%o2	! L1
		add	%g0,0,%l5	! accumulated zero
		add	%g0,0,%l6	! accumulated overflow
		ldub	[%o0+%o3],%l0	!
		ldub	[%o1+%o3],%l1	!
		ba	_srpr03		!
		and	%l0,0xf,%l2	! load sign
    _srpr01:	ldub	[%o0+%o3],%l0	!
		and	%l0,0xf,%l2	!
		ldub	[%o1+%o3],%l1	!
		and	%l1,0xf,%l3	!
		add	%l2,%l3,%l2	! add R1+R2 lower 4bit
		add	%l2,%l7,%l2	! add with carry
		subcc	%l2,0xa,%g0	!
		bneg	_srpr02		!
		nop			!
		sub	%l2,0x0a,%l2	! fix lower 4bit
		add	%l1,0x10,%l1	! propagate carry
    _srpr02:	or	%l5,%l2,%l5	! accumulated zero
    _srpr03:	and	%l0,0xf0,%l0	!
		and	%l1,0xf0,%l1	!
		add	%l0,%l1,%l0	! add R1+R2 upper 4bit
		subcc	%l0,0xa0,%g0	!
		bneg,a	_srpr04		!
		add	%g0,0,%l7	!
		sub	%l0,0xa0,%l0	! fix upper 4bit
		add	%g0,1,%l7	! propagate carry
    _srpr04:	or	%l5,%l0,%l5	! accumulated zero
		or	%l0,%l2,%l0	!
		!! stb	%l0,[%o0+%o3]	! (DEBUG)
		subcc	%o2,0,%g0	!
		bpos,a	_srpr05		!
		stb	%l0,[%i1+%o2]	! write back to R1
		or	%l6,%l0,%l6	! accumulated overflow
    _srpr05:	subcc	%o3,1,%o3	! decrement counter
		bpos	_srpr01		!
		sub	%o2,1,%o2	! decrement pointer
		orcc	%l6,%l7,%g0	! if accumulated overflow then
		bnz	_srpovf		!   decimal overflow
		nop			!   (can not be happened)
		ldub	[%i1+%i3],%o0	!
		andn	%o0,1,%o1	!
		orcc	%l5,%g0,%g0	! if accumulated zero then
		bz,a	_srpexit	!   CC=0
		stb	%o1,[%i1+%i3]	!   force positive zero
		andcc	%o0,1,%g0	!
		bnz,a	_srpexit	! if result < 0 then
		or	%g1,0x1,%g1	!   CC=1
		ba	_srpexit	! else
		or	%g1,0x2,%g1	!   CC=2

		/* SHIFT LEFT (0-31) R2 -> R1 */
    _srpl:	subcc	%i2,0,%g0	!
		bg	_srpls0		! case %i2 == 0:
		subcc	%i2,7,%g0	!
		ba	_srpls7		!
		add	%g0,%g0,%l6	! for checking overflow
					!
    _srpls0:	bg	_srpls1		!
		subcc	%i2,8,%g0	! case 1 <= %i2 <= 7:
		sll	%i2,2,%o0	! shift count (left)
		or	%g0,32,%o1	!
		sub	%o1,%o0,%o1	! shift count (right)
		srl	%l0,%o1,%l6	! for checking overflow
		sll	%l0,%o0,%l0	!
		srl	%l1,%o1,%o2	!
		or	%l0,%o2,%l0	!
		sll	%l1,%o0,%l1	!
		srl	%l2,%o1,%o2	!
		or	%l1,%o2,%l1	!
		sll	%l2,%o0,%l2	!
		srl	%l3,%o1,%o2	!
		or	%l2,%o2,%l2	!
		ba	_srpls7		!
		sll	%l3,%o0,%l3	!
					!
    _srpls1:	bg	_srpls2		!
		subcc	%i2,15,%g0	! case %i2 == 8:
		add	%l0,%g0,%l6	! for checking overflow
		add	%l1,%g0,%l0	!
		add	%l2,%g0,%l1	!
		add	%l3,%g0,%l2	!
		ba	_srpls7		!
		add	%g0,%g0,%l3	!
					!
    _srpls2:	bg	_srpls3		!
		subcc	%i2,16,%g0	! case 9 <= %i2 <= 15:
		sub	%i2,8,%i2	!
		sll	%i2,2,%o0	! shift count (left)
		or	%g0,32,%o1	!
		sub	%o1,%o0,%o1	! shift count (right)
		srl	%l1,%o1,%l6	! for checking overflow
		or	%l0,%l6,%l6	!
		sll	%l1,%o0,%l0	!
		srl	%l2,%o1,%o2	!
		or	%l0,%o2,%l0	!
		sll	%l2,%o0,%l1	!
		srl	%l3,%o1,%o2	!
		or	%l1,%o2,%l1	!
		sll	%l3,%o0,%l2	!
		ba	_srpls7		!
		add	%g0,%g0,%l3	!
					!
    _srpls3:	bg	_srpls4		!
		subcc	%i2,23,%g0	! case %i2 == 16:
		add	%l1,%g0,%l6	! for checking overflow
		or	%l0,%l6,%l6	!
		add	%l2,%g0,%l0	!
		add	%l3,%g0,%l1	!
		add	%g0,%g0,%l2	!
		ba	_srpls7		!
		add	%g0,%g0,%l3	!
					!
    _srpls4:	bg	_srpls5		!
		subcc	%i2,24,%g0	! case 17 <= %i2 <= 23:
		sub	%i2,16,%i2	!
		sll	%i2,2,%o0	! shift count (left)
		or	%g0,32,%o1	!
		sub	%o1,%o0,%o1	! shift count (right)
		srl	%l2,%o1,%l6	! for checking overflow
		or	%l1,%l6,%l6	!
		or	%l0,%l6,%l6	!
		sll	%l2,%o0,%l0	!
		srl	%l3,%o1,%o2	!
		or	%l0,%o2,%l0	!
		sll	%l3,%o0,%l1	!
		add	%g0,%g0,%l2	!
		ba	_srpls7		!
		add	%g0,%g0,%l3	!
					!
    _srpls5:	bg	_srpls6		!
		subcc	%i2,31,%g0	! case %i2 == 24:
		add	%l2,%g0,%l6	! for checking overflow
		or	%l1,%l6,%l6	!
		or	%l0,%l6,%l6	!
		add	%l3,%g0,%l0	!
		add	%g0,%g0,%l1	!
		add	%g0,%g0,%l2	!
		ba	_srpls7		!
		add	%g0,%g0,%l3	!
					!
    _srpls6:	sub	%i2,24,%i2	! case 25 <= %i2 <= 31:
		sll	%i2,2,%o0	! shift count (left)
		or	%g0,32,%o1	!
		sub	%o1,%o0,%o1	! shift count (right)
		srl	%l3,%o1,%l6	! for checking overflow
		or	%l2,%l6,%l6	!
		or	%l1,%l6,%l6	!
		or	%l0,%l6,%l6	! <-----------------------------+
		sll	%l3,%o0,%l0	!				|
		add	%g0,%g0,%l1	!				|
		add	%g0,%g0,%l2	!				|
		add	%g0,%g0,%l3	!				|

		/* COPY SIGN */
    _srpls7:	ldub	[%i0+799],%o0	! load sign of R2		|
		and	%o0,0xf,%o0	! mask sign			|
		or	%l3,%o0,%l3	!				|
		stb	%o0,[%i0+783]	!				|
		std	%l0,[%i0+784]	! store R2			|
		std	%l2,[%i0+792]	!				|

		/* ADD R1+R2 -> R1 */
		add	%i0,783,%o0	! bot address of R1		|
		add	%i0,799,%o1	! bot address of R2		|
		add	%g0,15,%o3	!				|
    _srpl00:	sub	%o0,%o3,%o0	!				|
		sub	%o1,%o3,%o1	!				|
		add	%i3,0,%o2	! L1				|
		add	%g0,0,%l5	! accumulated zero		|
		!! add	%g0,0,%l6	! accumulated overflow (dummy) -+
		ldub	[%o0+%o3],%l0	!
		ldub	[%o1+%o3],%l1	!
		ba	_srpl03		!
		and	%l0,0xf,%l2	! load sign
    _srpl01:	ldub	[%o0+%o3],%l0	!
		and	%l0,0xf,%l2	!
		ldub	[%o1+%o3],%l1	!
		and	%l1,0xf,%l3	!
		add	%l2,%l3,%l2	! add R1+R2 lower 4bit
		add	%l2,%l7,%l2	! add with carry
		subcc	%l2,0xa,%g0	!
		bneg	_srpl02		!
		nop			!
		sub	%l2,0x0a,%l2	! fix lower 4bit
		add	%l1,0x10,%l1	! propagate carry
    _srpl02:	or	%l5,%l2,%l5	! accumulated zero
    _srpl03:	and	%l0,0xf0,%l0	!
		and	%l1,0xf0,%l1	!
		add	%l0,%l1,%l0	! add R1+R2 upper 4bit
		subcc	%l0,0xa0,%g0	!
		bneg,a	_srpl04		!
		add	%g0,0,%l7	!
		sub	%l0,0xa0,%l0	! fix upper 4bit
		add	%g0,1,%l7	! propagate carry
    _srpl04:	or	%l5,%l0,%l5	! accumulated zero
		or	%l0,%l2,%l0	!
		!! stb	%l0,[%o0+%o3]	! (DEBUG)
		subcc	%o2,0,%g0	!
		bpos,a	_srpl05		!
		stb	%l0,[%i1+%o2]	! write back to R1
		or	%l6,%l0,%l6	! accumulated overflow
    _srpl05:	subcc	%o3,1,%o3	! decrement counter
		bpos	_srpl01		!
		sub	%o2,1,%o2	! decrement pointer
		orcc	%l6,%l7,%g0	! if accumulated overflow then
		bnz	_srpovf		!   decimal overflow
		nop			!
		ldub	[%i1+%i3],%o0	!
		andn	%o0,1,%o1	!
		orcc	%l5,%g0,%g0	! if accumulated zero then
		bz,a	_srpexit	!   CC=0
		stb	%o1,[%i1+%i3]	!   force positive zero
		andcc	%o0,1,%g0	!
		bnz,a	_srpexit	! if result < 0 then
		or	%g1,0x1,%g1	!   CC=1
		ba	_srpexit	! else
		or	%g1,0x2,%g1	!   CC=2

		/* DECIMAL OVERFLOW */
    _srpovf:	andcc	%g7,4,%g0	! CC=3
		bz	_srpexit	! if decimal overflow mask then
		or	%g1,0x3,%g1	!
		sethi	%hi(0x000A0000),%o7
		or	%g7,%o7,%g7	!   decimal overflow

		/* RETURN */
    _srpexit:	ret			!
		restore			!

!
! ZAP Entry Point
!
!   %i0: *gcpu_s
!   %i1: B1+D1
!   %i2: B2+D2
!   %i3: L1
!   %i4: L2
!   %i5: not used
!   %i6: %fp
!   %i7: return address
!
	.section ".text"
	.align	4
	.global il_zap
il_zap:
		save	%sp,-208,%sp	! 12 + 92

		/* CLEAR PARAM01/02 */
		add	%i0,768,%o0	! top of param01/02
		add	%g0,32,%o1	! counter
    _zap000:	subcc	%o1,4,%o1	!
		bnz	_zap000		!
		st	%g0,[%o0+%o1]	! clear param01/02 with 0

		/* COPY R2 -> PARAM02,CHECK DATA,FIX SIGN */
    _zap001:	add	%i0,799,%o0	! bot of param02
		sub	%o0,%i4,%o0	! top of param02
		add	%i2,%g0,%o1	! top of B2
		add	%i4,%g0,%o3	! counter

		/* COPY BODY */
    _zap002:	sethi	%hi(0x00070000),%o7
		ldub	[%o1+%o3],%l0	! get rightmost R1/R2
		and	%l0,0xf,%l1	! extract sign
		subcc	%l1,0xf,%g0	!
		be,a	_zap004		!
		andn	%l0,0x3,%l0	! force Sign to be 0xC
		subcc	%l1,0xa,%g0	!
		bl,a	_zapexit	! if not sign then
		or	%g7,%o7,%g7	!   data exception
		or	%l0,0xc,%l0	! force Sign to be 0xC/D
		ba	_zap004		!
		andn	%l0,0x2,%l0	!
    _zap003:	ldub	[%o1+%o3],%l0	! get digit R1/R2
		and	%l0,0xf,%l1	! extract digit
		subcc	%l1,0xa,%g0	!
		bge,a	_zapexit	! if not digit then
		or	%g7,%o7,%g7	!   data exception
    _zap004:	srl	%l0,4,%l1	! extract digit
		subcc	%l1,0xa,%g0	!
		bge,a	_zapexit	! if not digit then
		or	%g7,%o7,%g7	!   data exception
		stb	%l0,[%o0+%o3]	! store param01/param02
		subcc	%o3,1,%o3	! update counter
		bpos	_zap003		!
		nop			!

		/* CHECK B2 <= B1+L1 < B2+L2 */
		add	%i1,%i3,%o0	! B1+L1
		subcc	%i2,%o0,%g0	!
		bgu	_zapcc0		!
		add	%i2,%i4,%o1	! B2+L2
		subcc	%o0,%o1,%g0	!
		blu,a	_zapexit	!
		or	%g7,%o7,%g7	!   data exception
	
		/* CC=0 */
    _zapcc0:	andn	%g1,0x3,%g1	! CC=0

		/* COPY SIGN OF R2 */
		ldub	[%i0+799],%l7	! load sign of R2
		and	%l7,0x0f,%l7	! mask sign
		stb	%l7,[%i0+783]	! store sign of R1
	
		/* ADD R1+R2 -> R1 */
    _zapa:	add	%i0,783,%o0	! bot address of R1
		add	%i0,799,%o1	! bot address of R2
		subcc	%i3,%i4,%g0	!
		bg,a	_zapa00		!
		add	%i3,0,%o3	!
		add	%i4,0,%o3	!
    _zapa00:	sub	%o0,%o3,%o0	!
		sub	%o1,%o3,%o1	!
		add	%i3,0,%o2	! L1
		add	%g0,0,%l5	! accumulated zero
		add	%g0,0,%l6	! accumulated overflow
		ldub	[%o0+%o3],%l0	!
		ldub	[%o1+%o3],%l1	!
		ba	_zapa03		!
		and	%l0,0xf,%l2	! load sign
    _zapa01:	ldub	[%o0+%o3],%l0	!
		and	%l0,0xf,%l2	!
		ldub	[%o1+%o3],%l1	!
		and	%l1,0xf,%l3	!
		add	%l2,%l3,%l2	! add R1+R2 lower 4bit
		add	%l2,%l7,%l2	! add with carry
		subcc	%l2,0xa,%g0	!
		bneg	_zapa02		!
		nop			!
		sub	%l2,0x0a,%l2	! fix lower 4bit
		add	%l1,0x10,%l1	! propagate carry
    _zapa02:	or	%l5,%l2,%l5	! accumulated zero
    _zapa03:	and	%l0,0xf0,%l0	!
		and	%l1,0xf0,%l1	!
		add	%l0,%l1,%l0	! add R1+R2 upper 4bit
		subcc	%l0,0xa0,%g0	!
		bneg,a	_zapa04		!
		add	%g0,0,%l7	!
		sub	%l0,0xa0,%l0	! fix upper 4bit
		add	%g0,1,%l7	! propagate carry
    _zapa04:	or	%l5,%l0,%l5	! accumulated zero
		or	%l0,%l2,%l0	!
		!! stb	%l0,[%o0+%o3]	! (DEBUG)
		subcc	%o2,0,%g0	!
		bpos,a	_zapa05		!
		stb	%l0,[%i1+%o2]	! write back to R1
		or	%l6,%l0,%l6	! accumulated overflow
    _zapa05:	subcc	%o3,1,%o3	! decrement counter
		bpos	_zapa01		!
		sub	%o2,1,%o2	! decrement pointer
		orcc	%l6,%l7,%g0	! if accumulated overflow then
		bnz	_zapovf		!   decimal overflow
		nop			!
		ldub	[%i1+%i3],%o0	!
		andn	%o0,1,%o1	!
		orcc	%l5,%g0,%g0	! if accumulated zero then
		bz,a	_zapexit	!   CC=0
		stb	%o1,[%i1+%i3]	!   force positive zero
		andcc	%o0,1,%g0	!
		bnz,a	_zapexit	! if result < 0 then
		or	%g1,0x1,%g1	!   CC=1
		ba	_zapexit	! else
		or	%g1,0x2,%g1	!   CC=2

		/* DECIMAL OVERFLOW */
    _zapovf:	andcc	%g7,4,%g0	! CC=3
		bz	_zapexit	! if decimal overflow mask then
		or	%g1,0x3,%g1	!
		sethi	%hi(0x000A0000),%o7
		or	%g7,%o7,%g7	!   decimal overflow

		/* RETURN */
    _zapexit:	ret			!
		restore			!

!
! CP Entry Point
!
!   %i0: *gcpu_s
!   %i1: B1+D1
!   %i2: B2+D2
!   %i3: L1
!   %i4: L2
!   %i5: not used
!   %i6: %fp
!   %i7: return address
!
	.section ".text"
	.align	4
	.global il_cp
il_cp:
		save	%sp,-208,%sp	! 12 + 92

		/* CLEAR PARAM01/02 */
		add	%i0,768,%o0	! top of param01/02
		add	%g0,32,%o1	! counter
    _cp000:	subcc	%o1,4,%o1	!
		bnz	_cp000		!
		st	%g0,[%o0+%o1]	! clear param01/02 with 0

		/* COPY R1 -> PARAM01,CHECK DATA,FIX SIGN */
		add	%i0,783,%o0	! bot of param01
		sub	%o0,%i3,%o0	! top of param01
		add	%i1,%g0,%o1	! top of B1
		add	%i3,%g0,%o3	! counter
		ba	_cp002		!
		add	%g0,1,%o4	! slector

		/* COPY R2 -> PARAM02,CHECK DATA,FIX SIGN */
    _cp001:	add	%i0,799,%o0	! bot of param02
		sub	%o0,%i4,%o0	! top of param02
		add	%i2,%g0,%o1	! top of B2
		add	%i4,%g0,%o3	! counter

		/* COPY BODY */
    _cp002:	sethi	%hi(0x00070000),%o7
		ldub	[%o1+%o3],%l0	! get rightmost R1/R2
		and	%l0,0xf,%l1	! extract sign
		subcc	%l1,0xf,%g0	!
		be,a	_cp004		!
		andn	%l0,0x3,%l0	! force Sign to be 0xC
		subcc	%l1,0xa,%g0	!
		bl,a	_cpexit		! if not sign then
		or	%g7,%o7,%g7	!   data exception
		or	%l0,0xc,%l0	! force Sign to be 0xC/D
		ba	_cp004		!
		andn	%l0,0x2,%l0	!
    _cp003:	ldub	[%o1+%o3],%l0	! get digit R1/R2
		and	%l0,0xf,%l1	! extract digit
		subcc	%l1,0xa,%g0	!
		bge,a	_cpexit		! if not digit then
		or	%g7,%o7,%g7	!   data exception
    _cp004:	srl	%l0,4,%l1	! extract digit
		subcc	%l1,0xa,%g0	!
		bge,a	_cpexit		! if not digit then
		or	%g7,%o7,%g7	!   data exception
		stb	%l0,[%o0+%o3]	! store param01/param02
		subcc	%o3,1,%o3	! update counter
		bpos	_cp003		!
		nop			!
		subcc	%o4,1,%o4	! update selector
		bpos	_cp001		!
		nop			!

		/* CC=0 */
		andn	%g1,0x3,%g1	! CC=0

		/* COMPARE DATA/SIGN,STORE SIGN OF RESULT,BRANCH */
		ldd	[%i0+768],%l0	! load R1 -> %l0-%l3
		ldd	[%i0+776],%l2	!
		ldd	[%i0+784],%l4	! load R2 -> %l4-%l7
		ldd	[%i0+792],%l6	!
		or	%l0,%l1,%o0	!
		orcc	%o0,%l2,%g0	!
		bnz	_cp005		! if R1 == 00..0D then
		subcc	%l3,0x0d,%g0	!
		be,a	_cp005		!
		andn	%l3,0x01,%l3	!   force R1 = 00..0C
    _cp005:	or	%l4,%l5,%o0	!
		orcc	%o0,%l6,%g0	!
		bnz	_cp006		! if R2 == 00..0D then
		subcc	%l7,0x0d,%g0	!
		be,a	_cp006		!
		andn	%l7,0x01,%l7	!   force R2 = 00..0C
    _cp006:	and	%l3,0xf,%o1	! extract sign
		and	%l7,0xf,%o2	! extract sign
		subcc	%o1,%o2,%g0	!
		bg,a	_cpexit		! if R1 <  0 and R2 >= 0 then 
		or	%g1,0x1,%g1	!   CC=1
		bl,a	_cpexit		! if R1 >= 0 and R2 <  0 then 
		or	%g1,0x2,%g1	!   CC=2

		sub	%l3,%l7,%o3	! if R1 == R2 then
		sub	%l2,%l6,%o4	!
		or	%o3,%o4,%o0	!
		sub	%l1,%l5,%o3	!
		sub	%l0,%l4,%o4	!
		or	%o0,%o3,%o0	!
		orcc	%o0,%o4,%o0	!
		bz,a	_cpexit		!   CC=0	
		nop			!

		andcc	%o1,0x1,%g0	! if R1 <  0 and R2 <  0 then
		bz	_cp007		!
		subcc	%l3,%l7,%g0	!
		subxcc	%l2,%l6,%g0	!
		subxcc	%l1,%l5,%g0	!
		subxcc	%l0,%l4,%g0	!
		bcs,a	_cpexit		!   if ABS(R1) < ABS(R2) then
		or	%g1,0x2,%g1	!     CC=2
		ba	_cpexit		!   if ABS(R1) > ABS(R2) then
		or	%g1,0x1,%g1	!     CC=1
    _cp007:	subcc	%l3,%l7,%g0	! if R1 >  0 and R2 >  0 then
		subxcc	%l2,%l6,%g0	!
		subxcc	%l1,%l5,%g0	!
		subxcc	%l0,%l4,%g0	!
		bcs,a	_cpexit		!   if ABS(R1) < ABS(R2) then
		or	%g1,0x1,%g1	!     CC=1
		ba	_cpexit		!   if ABS(R1) > ABS(R2) then
		or	%g1,0x2,%g1	!     CC=2

		/* RETURN */
    _cpexit:	ret			!
		restore			!

!
! AP Entry Point
!
!   %i0: *gcpu_s
!   %i1: B1+D1
!   %i2: B2+D2
!   %i3: L1
!   %i4: L2
!   %i5: not used
!   %i6: %fp
!   %i7: return address
!
	.section ".text"
	.align	4
	.global il_ap
il_ap:
		save	%sp,-208,%sp	! 12 + 92

		/* CLEAR PARAM01/02 */
		add	%i0,768,%o0	! top of param01/02
		add	%g0,32,%o1	! counter
    _ap000:	subcc	%o1,4,%o1	!
		bnz	_ap000		!
		st	%g0,[%o0+%o1]	! clear param01/02 with 0

		/* COPY R1 -> PARAM01,CHECK DATA,FIX SIGN */
		add	%i0,783,%o0	! bot of param01
		sub	%o0,%i3,%o0	! top of param01
		add	%i1,%g0,%o1	! top of B1
		add	%i3,%g0,%o3	! counter
		ba	_ap002		!
		add	%g0,1,%o4	! slector

		/* COPY R2 -> PARAM02,CHECK DATA,FIX SIGN */
    _ap001:	add	%i0,799,%o0	! bot of param02
		sub	%o0,%i4,%o0	! top of param02
		add	%i2,%g0,%o1	! top of B2
		add	%i4,%g0,%o3	! counter

		/* COPY BODY */
    _ap002:	sethi	%hi(0x00070000),%o7
		ldub	[%o1+%o3],%l0	! get rightmost R1/R2
		and	%l0,0xf,%l1	! extract sign
		subcc	%l1,0xf,%g0	!
		be,a	_ap004		!
		andn	%l0,0x3,%l0	! force Sign to be 0xC
		subcc	%l1,0xa,%g0	!
		bl,a	_apexit		! if not sign then
		or	%g7,%o7,%g7	!   data exception
		or	%l0,0xc,%l0	! force Sign to be 0xC/D
		ba	_ap004		!
		andn	%l0,0x2,%l0	!
    _ap003:	ldub	[%o1+%o3],%l0	! get digit R1/R2
		and	%l0,0xf,%l1	! extract digit
		subcc	%l1,0xa,%g0	!
		bge,a	_apexit		! if not digit then
		or	%g7,%o7,%g7	!   data exception
    _ap004:	srl	%l0,4,%l1	! extract digit
		subcc	%l1,0xa,%g0	!
		bge,a	_apexit		! if not digit then
		or	%g7,%o7,%g7	!   data exception
		stb	%l0,[%o0+%o3]	! store param01/param02
		subcc	%o3,1,%o3	! update counter
		bpos	_ap003		!
		nop			!
		subcc	%o4,1,%o4	! update selector
		bpos	_ap001		!
		nop			!

		/* CC=0 */
		andn	%g1,0x3,%g1	! CC=0

		/* COMPARE DATA/SIGN,STORE SIGN OF RESULT,BRANCH */
		ldd	[%i0+768],%l0	! load R1 -> %l0-%l3
		ldd	[%i0+776],%l2	!
		ldd	[%i0+784],%l4	! load R2 -> %l4-%l7
		ldd	[%i0+792],%l6	!
		and	%l3,0xf,%o1	! extract sign
		and	%l7,0xf,%o2	! extract sign
		subcc	%o1,%o2,%g0	!
		be	_apa		! if ++ or -- then add
		nop			!    +- or -+ then sub
		andn	%l3,0xf,%o1	! mask sign
		andn	%l7,0xf,%o2	! mask sign
		subcc	%o1,%o2,%g0	!
		subxcc	%l2,%l6,%g0	!
		subxcc	%l1,%l5,%g0	!
		subxcc	%l0,%l4,%g0	! if ABS(R1) >= ABS(R2) then
		bgeu	_aps		!   do nothing
		nop			!   sign of result == sign of R1
		std	%l0,[%i0+784]	! if ABS(R1) <  ABS(R2) then
		std	%l2,[%i0+792]	!   swap R1,R2
		std	%l4,[%i0+768]	!   sign of result == sign of R1
		ba	_aps		!
		std	%l6,[%i0+776]	!

		/* ADD R1+R2 -> R1 */
    _apa:	add	%i0,783,%o0	! bot address of R1
		add	%i0,799,%o1	! bot address of R2
		subcc	%i3,%i4,%g0	!
		bg,a	_apa00		!
		add	%i3,0,%o3	!
		add	%i4,0,%o3	!
    _apa00:	sub	%o0,%o3,%o0	!
		sub	%o1,%o3,%o1	!
		add	%i3,0,%o2	! L1
		add	%g0,0,%l5	! accumulated zero
		add	%g0,0,%l6	! accumulated overflow
		ldub	[%o0+%o3],%l0	!
		ldub	[%o1+%o3],%l1	!
		ba	_apa03		!
		and	%l0,0xf,%l2	! load sign
    _apa01:	ldub	[%o0+%o3],%l0	!
		and	%l0,0xf,%l2	!
		ldub	[%o1+%o3],%l1	!
		and	%l1,0xf,%l3	!
		add	%l2,%l3,%l2	! add R1+R2 lower 4bit
		add	%l2,%l7,%l2	! add with carry
		subcc	%l2,0xa,%g0	!
		bneg	_apa02		!
		nop			!
		sub	%l2,0x0a,%l2	! fix lower 4bit
		add	%l1,0x10,%l1	! propagate carry
    _apa02:	or	%l5,%l2,%l5	! accumulated zero
    _apa03:	and	%l0,0xf0,%l0	!
		and	%l1,0xf0,%l1	!
		add	%l0,%l1,%l0	! add R1+R2 upper 4bit
		subcc	%l0,0xa0,%g0	!
		bneg,a	_apa04		!
		add	%g0,0,%l7	!
		sub	%l0,0xa0,%l0	! fix upper 4bit
		add	%g0,1,%l7	! propagate carry
    _apa04:	or	%l5,%l0,%l5	! accumulated zero
		or	%l0,%l2,%l0	!
		!! stb	%l0,[%o0+%o3]	! (DEBUG)
		subcc	%o2,0,%g0	!
		bpos,a	_apa05		!
		stb	%l0,[%i1+%o2]	! write back to R1
		or	%l6,%l0,%l6	! accumulated overflow
    _apa05:	subcc	%o3,1,%o3	! decrement counter
		bpos	_apa01		!
		sub	%o2,1,%o2	! decrement pointer
		orcc	%l6,%l7,%g0	! if accumulated overflow then
		bnz	_apovf		!   decimal overflow
		nop			!
		ldub	[%i1+%i3],%o0	!
		andn	%o0,1,%o1	!
		orcc	%l5,%g0,%g0	! if accumulated zero then
		bz,a	_apexit		!   CC=0
		stb	%o1,[%i1+%i3]	!   force positive zero
		andcc	%o0,1,%g0	!
		bnz,a	_apexit		! if result < 0 then
		or	%g1,0x1,%g1	!   CC=1
		ba	_apexit		! else
		or	%g1,0x2,%g1	!   CC=2

		/* SUB R1-R2 -> R1 */
    _aps:	add	%i0,783,%o0	! bot address of R1
		add	%i0,799,%o1	! bot address of R2
		subcc	%i3,%i4,%g0	!
		bg,a	_aps00		!
		add	%i3,0,%o3	!
		add	%i4,0,%o3	!
    _aps00:	sub	%o0,%o3,%o0	!
		sub	%o1,%o3,%o1	!
		add	%i3,0,%o2	! L1
		add	%g0,0,%l5	! accumulated zero
		add	%g0,0,%l6	! accumulated overflow
		ldub	[%o0+%o3],%l0	!
		ldub	[%o1+%o3],%l1	!
		ba	_aps03		!
		and	%l0,0xf,%l2	! load sign
    _aps01:	ldub	[%o0+%o3],%l0	!
		and	%l0,0xf,%l2	!
		ldub	[%o1+%o3],%l1	!
		and	%l1,0xf,%l3	!
		sub	%l2,%l3,%l2	! sub R1-R2 lower 4bit
		subcc	%l2,%l7,%l2	! sub with borrow
		bpos	_aps02		!
		nop			!
		add	%l2,0x0a,%l2	! fix lower 4bit
		add	%l1,0x10,%l1	! propagate borrow
    _aps02:	or	%l5,%l2,%l5	! accumulated zero
    _aps03:	and	%l0,0xf0,%l0	!
		and	%l1,0xf0,%l1	!
		subcc	%l0,%l1,%l0	! sub R1-R2 upper 4bit
		bpos,a	_aps04		!
		add	%g0,0,%l7	!
		add	%l0,0xa0,%l0	! fix upper 4bit
		add	%g0,1,%l7	! propagate carry
    _aps04:	or	%l5,%l0,%l5	! accumulated zero
		or	%l0,%l2,%l0	!
		!! stb	%l0,[%o0+%o3]	! (DEBUG)
		subcc	%o2,0,%g0	!
		bpos,a	_aps05		!
		stb	%l0,[%i1+%o2]	! write back to R1
		or	%l6,%l0,%l6	! accumulated overflow
    _aps05:	subcc	%o3,1,%o3	! decrement counter
		bpos	_aps01		!
		sub	%o2,1,%o2	! decrement pointer
		orcc	%l6,%l7,%g0	! if accumulated overflow then
		bnz	_apovf		!   decimal overflow
		nop			!
		ldub	[%i1+%i3],%o0	!
		andn	%o0,1,%o1	!
		orcc	%l5,%g0,%g0	! if accumulated zero then
		bz,a	_apexit		!   CC=0
		stb	%o1,[%i1+%i3]	!   force positive zero
		andcc	%o0,1,%g0	!
		bnz,a	_apexit		! if result < 0 then
		or	%g1,0x1,%g1	!   CC=1
		ba	_apexit		! else
		or	%g1,0x2,%g1	!   CC=2

		/* DECIMAL OVERFLOW */
    _apovf:	andcc	%g7,4,%g0	! CC=3
		bz	_apexit		! if decimal overflow mask then
		or	%g1,0x3,%g1	!
		sethi	%hi(0x000A0000),%o7
		or	%g7,%o7,%g7	!   decimal overflow

		/* RETURN */
    _apexit:	ret			!
		restore			!

!
! SP Entry Point
!
!   %i0: *gcpu_s
!   %i1: B1+D1
!   %i2: B2+D2
!   %i3: L1
!   %i4: L2
!   %i5: not used
!   %i6: %fp
!   %i7: return address
!
	.section ".text"
	.align	4
	.global il_sp
il_sp:
		save	%sp,-208,%sp	! 12 + 92

		/* CLEAR PARAM01/02 */
		add	%i0,768,%o0	! top of param01/02
		add	%g0,32,%o1	! counter
    _sp000:	subcc	%o1,4,%o1	!
		bnz	_sp000		!
		st	%g0,[%o0+%o1]	! clear param01/02 with 0

		/* COPY R1 -> PARAM01,CHECK DATA,FIX SIGN */
		add	%i0,783,%o0	! bot of param01
		sub	%o0,%i3,%o0	! top of param01
		add	%i1,%g0,%o1	! top of B1
		add	%i3,%g0,%o3	! counter
		ba	_sp002		!
		add	%g0,1,%o4	! slector

		/* COPY R2 -> PARAM02,CHECK DATA,FIX SIGN */
    _sp001:	add	%i0,799,%o0	! bot of param02
		sub	%o0,%i4,%o0	! top of param02
		add	%i2,%g0,%o1	! top of B2
		add	%i4,%g0,%o3	! counter

		/* COPY BODY */
    _sp002:	sethi	%hi(0x00070000),%o7
		ldub	[%o1+%o3],%l0	! get rightmost R1/R2
		and	%l0,0xf,%l1	! extract sign
		subcc	%l1,0xf,%g0	!
		be,a	_sp004		!
		andn	%l0,0x3,%l0	! force Sign to be 0xC
		subcc	%l1,0xa,%g0	!
		bl,a	_spexit		! if not sign then
		or	%g7,%o7,%g7	!   data exception
		or	%l0,0xc,%l0	! force Sign to be 0xC/D
		ba	_sp004		!
		andn	%l0,0x2,%l0	!
    _sp003:	ldub	[%o1+%o3],%l0	! get digit R1/R2
		and	%l0,0xf,%l1	! extract digit
		subcc	%l1,0xa,%g0	!
		bge,a	_spexit		! if not digit then
		or	%g7,%o7,%g7	!   data exception
    _sp004:	srl	%l0,4,%l1	! extract digit
		subcc	%l1,0xa,%g0	!
		bge,a	_spexit		! if not digit then
		or	%g7,%o7,%g7	!   data exception
		stb	%l0,[%o0+%o3]	! store param01/param02
		subcc	%o3,1,%o3	! update counter
		bpos	_sp003		!
		nop			!
		subcc	%o4,1,%o4	! update selector
		bpos	_sp001		!
		nop			!

		/* CC=0 */
		andn	%g1,0x3,%g1	! CC=0

		/* INVERT SIGN OF R2 */
		ldub	[%i0+799],%l7	! load sign of R2
		xor	%l7,0x01,%l7	! invert bit-0
		stb	%l7,[%i0+799]	! store sign of R2

		/* COMPARE DATA/SIGN,STORE SIGN OF RESULT,BRANCH */
		ldd	[%i0+768],%l0	! load R1 -> %l0-%l3
		ldd	[%i0+776],%l2	!
		ldd	[%i0+784],%l4	! load R2 -> %l4-%l7
		ldd	[%i0+792],%l6	!
		and	%l3,0xf,%o1	! extract sign
		and	%l7,0xf,%o2	! extract sign
		subcc	%o1,%o2,%g0	!
		be	_spa		! if ++ or -- then add
		nop			!    +- or -+ then sub
		andn	%l3,0xf,%o1	! mask sign
		andn	%l7,0xf,%o2	! mask sign
		subcc	%o1,%o2,%g0	!
		subxcc	%l2,%l6,%g0	!
		subxcc	%l1,%l5,%g0	!
		subxcc	%l0,%l4,%g0	! if ABS(R1) >= ABS(R2) then
		bgeu	_sps		!   do nothing
		nop			!   sign of result == sign of R1
		std	%l0,[%i0+784]	! if ABS(R1) <  ABS(R2) then
		std	%l2,[%i0+792]	!   swap R1,R2
		std	%l4,[%i0+768]	!   sign of result == sign of R1
		ba	_sps		!
		std	%l6,[%i0+776]	!

		/* ADD R1+R2 -> R1 */
    _spa:	add	%i0,783,%o0	! bot address of R1
		add	%i0,799,%o1	! bot address of R2
		subcc	%i3,%i4,%g0	!
		bg,a	_spa00		!
		add	%i3,0,%o3	!
		add	%i4,0,%o3	!
    _spa00:	sub	%o0,%o3,%o0	!
		sub	%o1,%o3,%o1	!
		add	%i3,0,%o2	! L1
		add	%g0,0,%l5	! accumulated zero
		add	%g0,0,%l6	! accumulated overflow
		ldub	[%o0+%o3],%l0	!
		ldub	[%o1+%o3],%l1	!
		ba	_spa03		!
		and	%l0,0xf,%l2	! load sign
    _spa01:	ldub	[%o0+%o3],%l0	!
		and	%l0,0xf,%l2	!
		ldub	[%o1+%o3],%l1	!
		and	%l1,0xf,%l3	!
		add	%l2,%l3,%l2	! add R1+R2 lower 4bit
		add	%l2,%l7,%l2	! add with carry
		subcc	%l2,0xa,%g0	!
		bneg	_spa02		!
		nop			!
		sub	%l2,0x0a,%l2	! fix lower 4bit
		add	%l1,0x10,%l1	! propagate carry
    _spa02:	or	%l5,%l2,%l5	! accumulated zero
    _spa03:	and	%l0,0xf0,%l0	!
		and	%l1,0xf0,%l1	!
		add	%l0,%l1,%l0	! add R1+R2 upper 4bit
		subcc	%l0,0xa0,%g0	!
		bneg,a	_spa04		!
		add	%g0,0,%l7	!
		sub	%l0,0xa0,%l0	! fix upper 4bit
		add	%g0,1,%l7	! propagate carry
    _spa04:	or	%l5,%l0,%l5	! accumulated zero
		or	%l0,%l2,%l0	!
		!! stb	%l0,[%o0+%o3]	! (DEBUG)
		subcc	%o2,0,%g0	!
		bpos,a	_spa05		!
		stb	%l0,[%i1+%o2]	! write back to R1
		or	%l6,%l0,%l6	! accumulated overflow
    _spa05:	subcc	%o3,1,%o3	! decrement counter
		bpos	_spa01		!
		sub	%o2,1,%o2	! decrement pointer
		orcc	%l6,%l7,%g0	! if accumulated overflow then
		bnz	_spovf		!   decimal overflow
		nop			!
		ldub	[%i1+%i3],%o0	!
		andn	%o0,1,%o1	!
		orcc	%l5,%g0,%g0	! if accumulated zero then
		bz,a	_spexit		!   CC=0
		stb	%o1,[%i1+%i3]	!   force positive zero
		andcc	%o0,1,%g0	!
		bnz,a	_spexit		! if result < 0 then
		or	%g1,0x1,%g1	!   CC=1
		ba	_spexit		! else
		or	%g1,0x2,%g1	!   CC=2

		/* SUB R1-R2 -> R1 */
    _sps:	add	%i0,783,%o0	! bot address of R1
		add	%i0,799,%o1	! bot address of R2
		subcc	%i3,%i4,%g0	!
		bg,a	_sps00		!
		add	%i3,0,%o3	!
		add	%i4,0,%o3	!
    _sps00:	sub	%o0,%o3,%o0	!
		sub	%o1,%o3,%o1	!
		add	%i3,0,%o2	! L1
		add	%g0,0,%l5	! accumulated zero
		add	%g0,0,%l6	! accumulated overflow
		ldub	[%o0+%o3],%l0	!
		ldub	[%o1+%o3],%l1	!
		ba	_sps03		!
		and	%l0,0xf,%l2	! load sign
    _sps01:	ldub	[%o0+%o3],%l0	!
		and	%l0,0xf,%l2	!
		ldub	[%o1+%o3],%l1	!
		and	%l1,0xf,%l3	!
		sub	%l2,%l3,%l2	! sub R1-R2 lower 4bit
		subcc	%l2,%l7,%l2	! sub with borrow
		bpos	_sps02		!
		nop			!
		add	%l2,0x0a,%l2	! fix lower 4bit
		add	%l1,0x10,%l1	! propagate borrow
    _sps02:	or	%l5,%l2,%l5	! accumulated zero
    _sps03:	and	%l0,0xf0,%l0	!
		and	%l1,0xf0,%l1	!
		subcc	%l0,%l1,%l0	! sub R1-R2 upper 4bit
		bpos,a	_sps04		!
		add	%g0,0,%l7	!
		add	%l0,0xa0,%l0	! fix upper 4bit
		add	%g0,1,%l7	! propagate carry
    _sps04:	or	%l5,%l0,%l5	! accumulated zero
		or	%l0,%l2,%l0	!
		!! stb	%l0,[%o0+%o3]	! (DEBUG)
		subcc	%o2,0,%g0	!
		bpos,a	_sps05		!
		stb	%l0,[%i1+%o2]	! write back to R1
		or	%l6,%l0,%l6	! accumulated overflow
    _sps05:	subcc	%o3,1,%o3	! decrement counter
		bpos	_sps01		!
		sub	%o2,1,%o2	! decrement pointer
		orcc	%l6,%l7,%g0	! if accumulated overflow then
		bnz	_spovf		!   decimal overflow
		nop			!
		ldub	[%i1+%i3],%o0	!
		andn	%o0,1,%o1	!
		orcc	%l5,%g0,%g0	! if accumulated zero then
		bz,a	_spexit		!   CC=0
		stb	%o1,[%i1+%i3]	!   force positive zero
		andcc	%o0,1,%g0	!
		bnz,a	_spexit		! if result < 0 then
		or	%g1,0x1,%g1	!   CC=1
		ba	_spexit		! else
		or	%g1,0x2,%g1	!   CC=2

		/* DECIMAL OVERFLOW */
    _spovf:	andcc	%g7,4,%g0	! CC=3
		bz	_spexit		! if decimal overflow mask then
		or	%g1,0x3,%g1	!
		sethi	%hi(0x000A0000),%o7
		or	%g7,%o7,%g7	!   decimal overflow

		/* RETURN */
    _spexit:	ret			!
		restore			!

!
! MP Entry Point
!
!   %i0: *gcpu_s
!   %i1: B1+D1
!   %i2: B2+D2
!   %i3: L1
!   %i4: L2
!   %i5: not used
!   %i6: %fp
!   %i7: return address
!
	.section ".text"
	.align	4
	.global il_mp
il_mp:
		save	%sp,-208,%sp	! 12 + 92

		/* CHECK L1/L2 */
		sethi	%hi(0x00060000),%o7
		subcc	%i4,7,%g0	!
		bg,a	_mpexit		! if L2 > 7 then
		or	%g7,%o7,%g7	!   specification exception
		subcc	%i4,%i3,%g0	!
		bge,a	_mpexit		! if L2 >= L1 then
		or	%g7,%o7,%g7	!   specification exception

		/* CLEAR PARAM01/02 */
		add	%i0,768,%o0	! top of param01/02
		add	%g0,32,%o1	! counter
    _mp000:	subcc	%o1,4,%o1	!
		bnz	_mp000		!
		st	%g0,[%o0+%o1]	! clear param01/02 with 0

		/* COPY R1 -> PARAM01,CHECK DATA,FIX SIGN */
		add	%i0,783,%o0	! bot of param01
		sub	%o0,%i3,%o0	! top of param01
		add	%i1,%g0,%o1	! top of B1
		add	%i3,%g0,%o3	! counter
		ba	_mp002		!
		add	%g0,1,%o4	! slector

		/* COPY R2 -> PARAM02,CHECK DATA,FIX SIGN */
    _mp001:	add	%i0,799,%o0	! bot of param02
		sub	%o0,%i4,%o0	! top of param02
		add	%i2,%g0,%o1	! top of B2
		add	%i4,%g0,%o3	! counter

		/* COPY BODY */
    _mp002:	sethi	%hi(0x00070000),%o7
		ldub	[%o1+%o3],%l0	! get rightmost R1/R2
		and	%l0,0xf,%l1	! extract sign
		subcc	%l1,0xf,%g0	!
		be,a	_mp004		!
		andn	%l0,0x3,%l0	! force Sign to be 0xC
		subcc	%l1,0xa,%g0	!
		bl,a	_mpexit		! if not sign then
		or	%g7,%o7,%g7	!   data exception
		or	%l0,0xc,%l0	! force Sign to be 0xC/D
		ba	_mp004		!
		andn	%l0,0x2,%l0	!
    _mp003:	ldub	[%o1+%o3],%l0	! get digit R1/R2
		and	%l0,0xf,%l1	! extract digit
		subcc	%l1,0xa,%g0	!
		bge,a	_mpexit		! if not digit then
		or	%g7,%o7,%g7	!   data exception
    _mp004:	srl	%l0,4,%l1	! extract digit
		subcc	%l1,0xa,%g0	!
		bge,a	_mpexit		! if not digit then
		or	%g7,%o7,%g7	!   data exception
		stb	%l0,[%o0+%o3]	! store param01/param02
		subcc	%o3,1,%o3	! update counter
		bpos	_mp003		!
		nop			!
		subcc	%o4,1,%o4	! update selector
		bpos	_mp001		!
		nop			!

		/* CHECK R1-LEADING-ZEROS >= R2-LENGTH */
		add	%i0,783,%o0	! bot of param01
		sub	%o0,%i3,%o0	! top of param01
		add	%g0,0,%o3	! byte offset
		add	%g0,0,%o4	! zero counter
    _mpcz00:	ldub	[%o0+%o3],%o1	!
		add	%o3,1,%o3	!
		subcc	%o1,0x00,%g0	!
		bz,a	_mpcz00		!
		add	%o4,1,%o4	!
		subcc	%o4,%i4,%g0	! 
		ble,a	_mpexit		! if leading-zeros < R2-len(%i4+1)
		or	%g7,%o7,%g7	!   data exception
	
		/* COMPARE DATA/SIGN,STORE SIGN OF RESULT,BRANCH */
		ldub	[%i0+783],%l1	! load sign of R1
		and	%l1,0xf,%o1	! extract sign
		ldub	[%i0+799],%l2	! load sign of R2
		and	%l2,0xf,%o2	! extract sign
		xorcc	%o1,%o2,%g0	!
		bz,a	_mp005		!
		add	%g0,0xc,%l7	! if ++ or -- then result:+
		add	%g0,0xd,%l7	!    +- or -+ then result:-

		/* CONVERT R1(BCD) -> R1(HEX) */
    _mp005:	add	%i0,783,%o0	! bot address of R1
		sub	%o0,%i3,%o0	! top address of R1
		add	%i3,0,%o1	! setup counter
		add	%g0,%g0,%l0	! clear %l0-%l3
		add	%g0,%g0,%l1	!
		add	%g0,%g0,%l2	!
		add	%g0,%g0,%l3	!
		add	%g0,%g0,%l4	!
		add	%g0,%g0,%l5	!
		subcc	%o1,0,%g0	! if 1-byte only then
		bz	_mp008		!   skip
		add	%g0,%g0,%l6	!
		ba	_mp007		!
		nop			!
    _mp006:	umul	%l3,100,%l3	! %l0-%l3 = %l0-%l3 * 100
		rd	%y,%l6		!
		umul	%l2,100,%l2	!
		rd	%y,%l5		!
		umul	%l1,100,%l1	!
		rd	%y,%l4		!
		umul	%l0,100,%l0	!
    _mp007:	ldub	[%o0],%o2	!
		srl	%o2,4,%o3	!
		umul	%o3,10,%o3	!
		and	%o2,0xf,%o2	!
		add	%o3,%o2,%o2	! get 1-byte (0-99)
		addcc	%l3,%o2,%l3	!
		addxcc	%l2,%l6,%l2	!
		addxcc	%l1,%l5,%l1	!
		addxcc	%l0,%l4,%l0	!
		subcc	%o1,1,%o1	!
		bnz	_mp006		!
		add	%o0,1,%o0	! ----
		umul	%l3,10,%l3	! %l0-%l3 = %l0-%l3 * 10
		rd	%y,%l6		!
		umul	%l2,10,%l2	!
		rd	%y,%l5		!
		umul	%l1,10,%l1	!
		rd	%y,%l4		!
		umul	%l0,10,%l0	!
    _mp008:	ldub	[%o0],%o2	!
		srl	%o2,4,%o2	! get 4-bit (0-9)
		addcc	%l3,%o2,%l3	!
		addxcc	%l2,%l6,%l2	!
		addxcc	%l1,%l5,%l1	!
		addxcc	%l0,%l4,%l0	!
	
		/* CONVERT R2(BCD) -> R2(HEX) */
    _mp009:	add	%i0,799,%o0	! bot address of R2
		sub	%o0,%i4,%o0	! top address of R2
		add	%i4,0,%o1	! setup counter
		add	%g0,%g0,%l4	! clear %l4-%l5
		add	%g0,%g0,%l5	!
		subcc	%o1,0,%g0	! if 1-byte only then
		bz	_mp00c		!   skip
		add	%g0,%g0,%l6	!
		ba	_mp00b		!
		nop			!
    _mp00a:	umul	%l5,100,%l5	! %l4-%l5 = %l4-%l5 * 100
		rd	%y,%l6		!
		umul	%l4,100,%l4	!
    _mp00b:	ldub	[%o0],%o2	!
		srl	%o2,4,%o3	!
		umul	%o3,10,%o3	!
		and	%o2,0xf,%o2	!
		add	%o3,%o2,%o2	! get 1-byte (0-99)
		addcc	%l5,%o2,%l5	!
		addxcc	%l4,%l6,%l4	!
		subcc	%o1,1,%o1	!
		bnz	_mp00a		!
		add	%o0,1,%o0	! ----
		umul	%l5,10,%l5	! %l4-%l5 = %l4-%l5 * 10
		rd	%y,%l6		!
		umul	%l4,10,%l4	!
    _mp00c:	ldub	[%o0],%o2	!
		srl	%o2,4,%o2	! get 4-bit (0-9)
		addcc	%l5,%o2,%l5	!
		addxcc	%l4,%l6,%l4	!
		!! std	%l0,[%i0+768]	! (DEBUG)
		!! std	%l2,[%i0+776]	! (DEBUG)
		!! std	%l4,[%i0+792]	! (DEBUG)
		bz	_mp00d		!
		nop

		/* MULT %l0-%l3 * %l4-(%l5) -> %o0-%o2 */
		umul	%l3,%l4,%o2	!     | %l0 | %l1 | %l2 | %l3 |
		rd	%y,%o5		!      *            %l4
		umul	%l2,%l4,%o1	!     -------------------------
		rd	%y,%o4		! %l6 | %o0 | %o1 | %o2 |     |
		umul	%l1,%l4,%o0	! <OV>|<--------valid-------->|
		rd	%y,%l6		! overflow bits
		umul	%l0,%l4,%o7	!
		or	%l6,%o7,%l6	! overflow bits
		rd	%y,%o7		!
		or	%l6,%o7,%l6	! overflow bits
		addcc	%o1,%o5,%o1	!
		addxcc	%o0,%o4,%o0	!
		addxcc	%g0,%g0,%o7	!
		or	%l6,%o7,%l6	! overflow bits

		/* MULT %l0-%l3 * (%l4)-%l5 -> %l0-%l3 */
		umul	%l3,%l5,%l3	!     | %l0 | %l1 | %l2 | %l3 |
		rd	%y,%o5		!      *                  %l5
		umul	%l2,%l5,%l2	!     -------------------------
		rd	%y,%o4		! %l6 | %l0 | %l1 | %l2 | %l3 |
		umul	%l1,%l5,%l1	! <OV>|<--------valid-------->|
		rd	%y,%o3		!
		umul	%l0,%l5,%l0	!
		rd	%y,%o7		!
		or	%l6,%o7,%l6	! overflow bits
		addcc	%l2,%o5,%l2	!
		addxcc	%l1,%o4,%l1	!
		addxcc	%l0,%o3,%l0	!
		addxcc	%g0,%g0,%o7	!
		or	%l6,%o7,%l6	! overflow bits

		/* MULT %l0-%l3 * %l4-%l5 -> %l0-%l3 */
		addcc	%l2,%o2,%l2	!
		addxcc	%l1,%o1,%l1	!
		addxcc	%l0,%o0,%l0	!
		addxcc	%g0,%g0,%o7	!
		ba	_mp00e		!
		orcc	%l6,%o7,%l6	! overflow bits

		/* MULT %l0-%l3 * %l5 -> %l0-%l3 */
    _mp00d:	umul	%l3,%l5,%l3	!     | %l0 | %l1 | %l2 | %l3 |
		rd	%y,%o5		!      *                  %l5
		umul	%l2,%l5,%l2	!     -------------------------
		rd	%y,%o4		! %l6 | %l0 | %l1 | %l2 | %l3 |
		umul	%l1,%l5,%l1	! <OV>|<--------valid-------->|
		rd	%y,%o3		!
		umul	%l0,%l5,%l0	!
		rd	%y,%l6		! overflow bits
		addcc	%l2,%o5,%l2	!
		addxcc	%l1,%o4,%l1	!
		addxcc	%l0,%o3,%l0	!
		addxcc	%g0,%g0,%o7	!
		orcc	%l6,%o7,%l6	! overflow bits

		/* CHECK OVERFLOW */
    _mp00e:	sethi	%hi(0x00070000),%o7
		bnz,a	_mpexit		! if overflow then
		or	%g7,%o7,%g7	!   data exception
		!! std	%l0,[%i0+768]	! (DEBUG)
		!! std	%l2,[%i0+776]	! (DEBUG)

		/* CONVERT R1(HEX) -> R1(BCD) */
		/* | %l0 | %l1 | %l2 | %l3 | sign=%l7 */
		add	%g0,0,%o5	! reset accumulated overflow
		subcc	%l0,0,%g0	!
		bnz	_mpr40		!
		subcc	%l1,0,%g0	!
		bnz	_mpr30		!
		subcc	%l2,0,%g0	!
		bnz	_mpr20		!
		nop			!

		/* %l3 -> BCD */
    _mpr10:	wr	%g0,0,%y	! ----------+
		udiv	%l3,100,%o1	!           | % 100
		umul	%o1,100,%o0	!           | / 100
		sub	%l3,%o0,%o0	! remainder |
		add	%o1,%g0,%l3	! ----------+
		add	%g0,0,%o1	! reminder % 10 -> %o0
		subcc	%o0,0x50,%o0	! reminder / 10 -> %o1
		bge,a	_mpr13		!
		or	%o1,0x8,%o1	!
		add	%o0,0x50,%o0	!
    _mpr13:	subcc	%o0,0x28,%o0	!
		bge,a	_mpr14		!
		or	%o1,0x4,%o1	!
		add	%o0,0x28,%o0	!
    _mpr14:	subcc	%o0,0x14,%o0	!
		bge,a	_mpr15		!
		add	%o1,0x2,%o1	!
		add	%o0,0x14,%o0	!
    _mpr15:	subcc	%o0,0x0a,%o0	!
		bge,a	_mpr16		!
		add	%o1,0x1,%o1	! %o0: upper 4-bit
		add	%o0,0x0a,%o0	! %o1: lower 4-bit
    _mpr16:	sll	%o0,4,%o0	!
		or	%o0,%l7,%o0	!
		add	%o1,%g0,%l7	!
		subcc	%i3,0,%g0	!
		bpos,a	_mpr17		!
		stb	%o0,[%i1+%i3]	!
		or	%o5,%o0,%o5	!
    _mpr17:	orcc	%l3,0,%o0	!
		bnz	_mpr10		!
    _mpr18:	subcc	%i3,1,%i3	! --------------------+
		bneg	_mpr19		!		      |
		nop			!		      |
		stb	%l7,[%i1+%i3]	! store carry or zero |
		ba	_mpr18		!		      |
		add	%g0,0,%l7	! --------------------+
    _mpr19:	orcc	%o5,%l7,%g0	!
		sethi	%hi(0x00070000),%o7
		bnz,a	_mpexit		! if overflow then
		or	%g7,%o7,%g7	!   data exception
		ba	_mpexit		!
		nop			!
			
		/* %l2 | %l3 -> BCD */
    _mpr20:	wr	%g0,0,%y	! ----------+
		udiv	%l2,100,%o1	!	    |
		umul	%o1,100,%o0	!	    |
		sub	%l2,%o0,%o0	!	    |
		add	%o1,%g0,%l2	!	    |
		wr	%o0,0,%y	! ----------+
		udiv	%l3,100,%o1	!           | % 100
		umul	%o1,100,%o0	!           | / 100
		sub	%l3,%o0,%o0	! remainder |
		add	%o1,%g0,%l3	! ----------+
		add	%g0,0,%o1	! reminder % 10 -> %o0
		subcc	%o0,0x50,%o0	! reminder / 10 -> %o1
		bge,a	_mpr23		!
		or	%o1,0x8,%o1	!
		add	%o0,0x50,%o0	!
    _mpr23:	subcc	%o0,0x28,%o0	!
		bge,a	_mpr24		!
		or	%o1,0x4,%o1	!
		add	%o0,0x28,%o0	!
    _mpr24:	subcc	%o0,0x14,%o0	!
		bge,a	_mpr25		!
		add	%o1,0x2,%o1	!
		add	%o0,0x14,%o0	!
    _mpr25:	subcc	%o0,0x0a,%o0	!
		bge,a	_mpr26		!
		add	%o1,0x1,%o1	! %o0: upper 4-bit
		add	%o0,0x0a,%o0	! %o1: lower 4-bit
    _mpr26:	sll	%o0,4,%o0	!
		or	%o0,%l7,%o0	!
		add	%o1,%g0,%l7	!
		subcc	%i3,0,%g0	!
		bpos,a	_mpr27		!
		stb	%o0,[%i1+%i3]	!
		or	%o5,%o0,%o5	!
    _mpr27:	orcc	%l2,%l3,%o0	!
		bnz	_mpr20		!
    _mpr28:	subcc	%i3,1,%i3	! --------------------+
		bneg	_mpr29		!		      |
		nop			!		      |
		stb	%l7,[%i1+%i3]	! store carry or zero |
		ba	_mpr28		!                     |
		add	%g0,0,%l7	! --------------------+
    _mpr29:	orcc	%o5,%l7,%g0	!
		sethi	%hi(0x00070000),%o7
		bnz,a	_mpexit		! if overflow then
		or	%g7,%o7,%g7	!   data exception
		ba	_mpexit		!
		nop			!

		/* %l1 | %l2 | %l3 -> BCD */
    _mpr30:	wr	%g0,0,%y	! ----------+
		udiv	%l1,100,%o1	!	    |
		umul	%o1,100,%o0	!	    |
		sub	%l1,%o0,%o0	!	    |
		add	%o1,%g0,%l1	!	    |
		wr	%o0,0,%y	! ----------+
		udiv	%l2,100,%o1	!	    |
		umul	%o1,100,%o0	!	    |
		sub	%l2,%o0,%o0	!	    |
		add	%o1,%g0,%l2	!	    |
		wr	%o0,0,%y	! ----------+
		udiv	%l3,100,%o1	!           | % 100
		umul	%o1,100,%o0	!           | / 100
		sub	%l3,%o0,%o0	! remainder |
		add	%o1,%g0,%l3	! ----------+
		add	%g0,0,%o1	! reminder % 10 -> %o0
		subcc	%o0,0x50,%o0	! reminder / 10 -> %o1
		bge,a	_mpr33		!
		or	%o1,0x8,%o1	!
		add	%o0,0x50,%o0	!
    _mpr33:	subcc	%o0,0x28,%o0	!
		bge,a	_mpr34		!
		or	%o1,0x4,%o1	!
		add	%o0,0x28,%o0	!
    _mpr34:	subcc	%o0,0x14,%o0	!
		bge,a	_mpr35		!
		add	%o1,0x2,%o1	!
		add	%o0,0x14,%o0	!
    _mpr35:	subcc	%o0,0x0a,%o0	!
		bge,a	_mpr36		!
		add	%o1,0x1,%o1	! %o0: upper 4-bit
		add	%o0,0x0a,%o0	! %o1: lower 4-bit
    _mpr36:	sll	%o0,4,%o0	!
		or	%o0,%l7,%o0	!
		add	%o1,%g0,%l7	!
		subcc	%i3,0,%g0	!
		bpos,a	_mpr37		!
		stb	%o0,[%i1+%i3]	!
		or	%o5,%o0,%o5	!
    _mpr37:	orcc	%l1,%l2,%o0	!
		orcc	%l3,%o0,%o0	!
		bnz	_mpr30		!
    _mpr38:	subcc	%i3,1,%i3	! --------------------+
		bneg	_mpr39		!		      |
		nop			!		      |
		stb	%l7,[%i1+%i3]	! store carry or zero |
		ba	_mpr38		!                     |
		add	%g0,0,%l7	! --------------------+
    _mpr39:	orcc	%o5,%l7,%g0	!
		sethi	%hi(0x00070000),%o7
		bnz,a	_mpexit		! if overflow then
		or	%g7,%o7,%g7	!   data exception
		ba	_mpexit		!
		nop			!
	
		/* %l0 | %l1 | %l2 | %l3 -> BCD */
    _mpr40:	wr	%g0,0,%y	! ----------+
		udiv	%l0,100,%o1	!	    |
		umul	%o1,100,%o0	!	    |
		sub	%l0,%o0,%o0	!	    |
		add	%o1,%g0,%l0	!	    |
		wr	%o0,0,%y	! ----------+
		udiv	%l1,100,%o1	!	    |
		umul	%o1,100,%o0	!	    |
		sub	%l1,%o0,%o0	!	    |
		add	%o1,%g0,%l1	!	    |
		wr	%o0,0,%y	! ----------+
		udiv	%l2,100,%o1	!	    |
		umul	%o1,100,%o0	!	    |
		sub	%l2,%o0,%o0	!	    |
		add	%o1,%g0,%l2	!	    |
		wr	%o0,0,%y	! ----------+
		udiv	%l3,100,%o1	!           | % 100
		umul	%o1,100,%o0	!           | / 100
		sub	%l3,%o0,%o0	! remainder |
		add	%o1,%g0,%l3	! ----------+
		add	%g0,0,%o1	! reminder % 10 -> %o0
		subcc	%o0,0x50,%o0	! reminder / 10 -> %o1
		bge,a	_mpr43		!
		or	%o1,0x8,%o1	!
		add	%o0,0x50,%o0	!
    _mpr43:	subcc	%o0,0x28,%o0	!
		bge,a	_mpr44		!
		or	%o1,0x4,%o1	!
		add	%o0,0x28,%o0	!
    _mpr44:	subcc	%o0,0x14,%o0	!
		bge,a	_mpr45		!
		add	%o1,0x2,%o1	!
		add	%o0,0x14,%o0	!
    _mpr45:	subcc	%o0,0x0a,%o0	!
		bge,a	_mpr46		!
		add	%o1,0x1,%o1	! %o0: upper 4-bit
		add	%o0,0x0a,%o0	! %o1: lower 4-bit
    _mpr46:	sll	%o0,4,%o0	!
		or	%o0,%l7,%o0	!
		add	%o1,%g0,%l7	!
		subcc	%i3,0,%g0	!
		bpos,a	_mpr47		!
		stb	%o0,[%i1+%i3]	!
		or	%o5,%o0,%o5	!
    _mpr47:	orcc	%l0,%l1,%o0	!
		orcc	%l2,%o0,%o0	!
		orcc	%l3,%o0,%o0	!
		bnz	_mpr40		!
    _mpr48:	subcc	%i3,1,%i3	! --------------------+
		bneg	_mpr49		!		      |
		nop			!		      |
		stb	%l7,[%i1+%i3]	! store carry or zero |
		ba	_mpr48		!                     |
		add	%g0,0,%l7	! --------------------+
    _mpr49:	orcc	%o5,%l7,%g0	!
		sethi	%hi(0x00070000),%o7
		bnz,a	_mpexit		! if overflow then
		or	%g7,%o7,%g7	!   data exception

		/* RETURN */
    _mpexit:	ret			!
		restore			!

!
! DP Entry Point
!
!   %i0: *gcpu_s
!   %i1: B1+D1
!   %i2: B2+D2
!   %i3: L1
!   %i4: L2
!   %i5: not used (internal work)
!   %i6: %fp
!   %i7: return address
!
	.section ".text"
	.align	4
	.global il_dp
il_dp:
		save	%sp,-208,%sp	! 12 + 92

		/* CHECK L1/L2 */
		sethi	%hi(0x00060000),%o7
		subcc	%i4,7,%g0	!
		bg,a	_dpexit		! if L2 > 7 then
		or	%g7,%o7,%g7	!   specification exception
		subcc	%i4,%i3,%g0	!
		bge,a	_dpexit		! if L2 >= L1 then
		or	%g7,%o7,%g7	!   specification exception

		/* CLEAR PARAM01/02 */
		add	%i0,768,%o0	! top of param01/02
		add	%g0,32,%o1	! counter
    _dp000:	subcc	%o1,4,%o1	!
		bnz	_dp000		!
		st	%g0,[%o0+%o1]	! clear param01/02 with 0

		/* COPY R1 -> PARAM01,CHECK DATA,FIX SIGN */
		add	%i0,783,%o0	! bot of param01
		sub	%o0,%i3,%o0	! top of param01
		add	%i1,%g0,%o1	! top of B1
		add	%i3,%g0,%o3	! counter
		ba	_dp002		!
		add	%g0,1,%o4	! slector

		/* COPY R2 -> PARAM02,CHECK DATA,FIX SIGN */
    _dp001:	add	%i0,799,%o0	! bot of param02
		sub	%o0,%i4,%o0	! top of param02
		add	%i2,%g0,%o1	! top of B2
		add	%i4,%g0,%o3	! counter

		/* COPY BODY */
    _dp002:	sethi	%hi(0x00070000),%o7
		ldub	[%o1+%o3],%l0	! get rightmost R1/R2
		and	%l0,0xf,%l1	! extract sign
		subcc	%l1,0xf,%g0	!
		be,a	_dp004		!
		andn	%l0,0x3,%l0	! force Sign to be 0xC
		subcc	%l1,0xa,%g0	!
		bl,a	_dpexit		! if not sign then
		or	%g7,%o7,%g7	!   data exception
		or	%l0,0xc,%l0	! force Sign to be 0xC/D
		ba	_dp004		!
		andn	%l0,0x2,%l0	!
    _dp003:	ldub	[%o1+%o3],%l0	! get digit R1/R2
		and	%l0,0xf,%l1	! extract digit
		subcc	%l1,0xa,%g0	!
		bge,a	_dpexit		! if not digit then
		or	%g7,%o7,%g7	!   data exception
    _dp004:	srl	%l0,4,%l1	! extract digit
		subcc	%l1,0xa,%g0	!
		bge,a	_dpexit		! if not digit then
		or	%g7,%o7,%g7	!   data exception
		stb	%l0,[%o0+%o3]	! store param01/param02
		subcc	%o3,1,%o3	! update counter
		bpos	_dp003		!
		nop			!
		subcc	%o4,1,%o4	! update selector
		bpos	_dp001		!
		nop			!

		/* COMPARE DATA/SIGN,STORE SIGN OF RESULT,BRANCH */
		ldub	[%i0+783],%l1	! load sign of R1
		and	%l1,0xf,%o1	! extract sign
		ldub	[%i0+799],%l2	! load sign of R2
		and	%l2,0xf,%o2	! extract sign
		add	%o1,0,%l7	! if sign of R == sign of R2
		xorcc	%o1,%o2,%g0	!
		bz,a	_dp005		!
		or	%l7,0xc00,%l7	! if ++ or -- then result:+
		or	%l7,0xd00,%l7	!    +- or -+ then result:-

		/* CONVERT R1(BCD) -> R1(HEX) */
    _dp005:	add	%i0,783,%o0	! bot address of R1
		sub	%o0,%i3,%o0	! top address of R1
		add	%i3,0,%o1	! setup counter
		add	%g0,%g0,%l0	! clear %l0-%l3
		add	%g0,%g0,%l1	!
		add	%g0,%g0,%l2	!
		add	%g0,%g0,%l3	!
		add	%g0,%g0,%l4	!
		add	%g0,%g0,%l5	!
		subcc	%o1,0,%g0	! if 1-byte only then
		bz	_dp008		!   skip
		add	%g0,%g0,%l6	!
		ba	_dp007		!
		nop			!
    _dp006:	umul	%l3,100,%l3	! %l0-%l3 = %l0-%l3 * 100
		rd	%y,%l6		!
		umul	%l2,100,%l2	!
		rd	%y,%l5		!
		umul	%l1,100,%l1	!
		rd	%y,%l4		!
		umul	%l0,100,%l0	!
    _dp007:	ldub	[%o0],%o2	!
		srl	%o2,4,%o3	!
		umul	%o3,10,%o3	!
		and	%o2,0xf,%o2	!
		add	%o3,%o2,%o2	! get 1-byte (0-99)
		addcc	%l3,%o2,%l3	!
		addxcc	%l2,%l6,%l2	!
		addxcc	%l1,%l5,%l1	!
		addxcc	%l0,%l4,%l0	!
		subcc	%o1,1,%o1	!
		bnz	_dp006		!
		add	%o0,1,%o0	! ----
		umul	%l3,10,%l3	! %l0-%l3 = %l0-%l3 * 10
		rd	%y,%l6		!
		umul	%l2,10,%l2	!
		rd	%y,%l5		!
		umul	%l1,10,%l1	!
		rd	%y,%l4		!
		umul	%l0,10,%l0	!
    _dp008:	ldub	[%o0],%o2	!
		srl	%o2,4,%o2	! get 4-bit (0-9)
		addcc	%l3,%o2,%l3	!
		addxcc	%l2,%l6,%l2	!
		addxcc	%l1,%l5,%l1	!
		addxcc	%l0,%l4,%l0	!
	
		/* CONVERT R2(BCD) -> R2(HEX) */
    _dp009:	add	%i0,799,%o0	! bot address of R2
		sub	%o0,%i4,%o0	! top address of R2
		add	%i4,0,%o1	! setup counter
		add	%g0,%g0,%l4	! clear %l4-%l5
		add	%g0,%g0,%l5	!
		subcc	%o1,0,%g0	! if 1-byte only then
		bz	_dp00c		!   skip
		add	%g0,%g0,%l6	!
		ba	_dp00b		!
		nop			!
    _dp00a:	umul	%l5,100,%l5	! %l4-%l5 = %l4-%l5 * 100
		rd	%y,%l6		!
		umul	%l4,100,%l4	!
    _dp00b:	ldub	[%o0],%o2	!
		srl	%o2,4,%o3	!
		umul	%o3,10,%o3	!
		and	%o2,0xf,%o2	!
		add	%o3,%o2,%o2	! get 1-byte (0-99)
		addcc	%l5,%o2,%l5	!
		addxcc	%l4,%l6,%l4	!
		subcc	%o1,1,%o1	!
		bnz	_dp00a		!
		add	%o0,1,%o0	! ----
		umul	%l5,10,%l5	! %l4-%l5 = %l4-%l5 * 10
		rd	%y,%l6		!
		umul	%l4,10,%l4	!
    _dp00c:	ldub	[%o0],%o2	!
		srl	%o2,4,%o2	! get 4-bit (0-9)
		addcc	%l5,%o2,%l5	!
		addxcc	%l4,%l6,%l4	!
		!! std	%l0,[%i0+768]	! (DEBUG)
		!! std	%l2,[%i0+776]	! (DEBUG)
		!! std	%l4,[%i0+792]	! (DEBUG)
		orcc	%l4,%l5,%g0	!
		sethi	%hi(0x000B0000),%o7
		bz,a	_dpexit		! if divisor == 0 then
		or	%g7,%o7,%g7	!   decimal divide (suppressed)
		subcc	%l4,0,%g0	! if %l4 == 0 then
		bz	_dp00d		!   short cut
		nop			!

		/* DIVIDE %l0-%l3 / %l4-%l5 -> %o0-%o3 */
		add	%g0,0,%o0	!
		add	%g0,0,%o1	!
		add	%g0,0,%o2	!
		add	%g0,0,%o3	!
		add	%g0,0,%l6	!
					!
    _dpd00s:	orcc	%l0,0,%g0	! if %l0 == 0 then skip
		bz	_dpd02s		!
		add	%g0,32,%o4	!
					!
    _dpd00:	srl	%l6,1,%l6	!        |%l0|%l1|%l2|%l3|
		sll	%l5,31,%o7	! %l4|%l5:%l6
		or	%o7,%l6,%l6	!        -----------------
		srl	%l5,1,%l5	!        |%o0|
		sll	%l4,31,%o7	!
		or	%o7,%l5,%l5	!
		srl	%l4,1,%l4	!
		subcc	%l0,%l6,%l0	!
		subxcc	%g0,%l5,%g0	!
		subxcc	%g0,%l4,%g0	!
		sll	%o0,1,%o0	!
		bge,a	_dpd01		!
		or	%o0,0x01,%o0	!
		addcc	%l0,%l6,%l0	!
    _dpd01:	subcc	%o4,1,%o4	!
		bnz	_dpd00		!
		nop			!
		add	%l5,0,%l4	!
		add	%l6,0,%l5	!
		add	%g0,0,%l6	!
					!
    _dpd02s:	orcc	%l0,%l1,%g0	! if %l0,%l1 == 0 then skip
		bz	_dpd04s		!
		add	%g0,32,%o4	!
					!
    _dpd02:	srl	%l6,1,%l6	!        |%l0|%l1|%l2|%l3|
		sll	%l5,31,%o7	!     %l4|%l5:%l6
		or	%o7,%l6,%l6	!        -----------------
		srl	%l5,1,%l5	!            |%o1|
		sll	%l4,31,%o7	!
		or	%o7,%l5,%l5	!
		srl	%l4,1,%l4	!
		subcc	%l1,%l6,%l1	!
		subxcc	%l0,%l5,%l0	!
		subxcc	%g0,%l4,%g0	!
		sll	%o1,1,%o1	!
		bge,a	_dpd03		!
		or	%o1,0x01,%o1	!
		addcc	%l1,%l6,%l1	!
		addxcc	%l0,%l5,%l0	!
    _dpd03:	subcc	%o4,1,%o4	!
		bnz	_dpd02		!
		nop			!
		add	%l5,0,%l4	!
		add	%l6,0,%l5	!
		add	%g0,0,%l6	!
					!
    _dpd04s:	or	%l0,%l1,%o7	! if %l0,%l1,%l2 == 0 then skip
		orcc	%o7,%l2,%g0	!
		bz	_dpd06s		!
		add	%g0,32,%o4	!
					!
    _dpd04:	srl	%l6,1,%l6	!        |%l0|%l1|%l2|%l3|
		sll	%l5,31,%o7	!         %l4|%l5:%l6
		or	%o7,%l6,%l6	!        -----------------
		srl	%l5,1,%l5	!                |%o2|
		sll	%l4,31,%o7	!
		or	%o7,%l5,%l5	!
		srl	%l4,1,%l4	!
		subcc	%l2,%l6,%l2	!
		subxcc	%l1,%l5,%l1	!
		subxcc	%l0,%l4,%l0	!
		sll	%o2,1,%o2	!
		bge,a	_dpd05		!
		or	%o2,0x01,%o2	!
		addcc	%l2,%l6,%l2	!
		addxcc	%l1,%l5,%l1	!
		addxcc	%l0,%l4,%l0	!
    _dpd05:	subcc	%o4,1,%o4	!
		bnz	_dpd04		!
		nop			!
		add	%l5,0,%l4	!
		add	%l6,0,%l5	!
		add	%g0,0,%l6	!
					!
    _dpd06s:	or	%l0,%l1,%o7	! if %l0,%l1,%l2,%l3 == 0 then skip
		or	%o7,%l2,%o7	!
		orcc	%o7,%l3,%g0	!
		bz	_dp00d		!
		add	%g0,32,%o4	!
					!
    _dpd06:	srl	%l6,1,%l6	!        |%l0|%l1|%l2|%l3|
		sll	%l5,31,%o7	!             %l4|%l5:%l6
		or	%o7,%l6,%l6	!        -----------------
		srl	%l5,1,%l5	!                    |%o3|
		sll	%l4,31,%o7	!
		or	%o7,%l5,%l5	!
		srl	%l4,1,%l4	!
		subcc	%l3,%l6,%l3	!
		subxcc	%l2,%l5,%l2	!
		subxcc	%l1,%l4,%l1	!
		sll	%o3,1,%o3	!
		bge,a	_dpd07		!
		or	%o3,0x01,%o3	!
		addcc	%l3,%l6,%l3	!
		addxcc	%l2,%l5,%l2	!
		addxcc	%l1,%l4,%l1	!
    _dpd07:	subcc	%o4,1,%o4	!
		bnz	_dpd06		!
		nop			!
		add	%l5,0,%l4	!
		ba	_dp00e		!
		add	%l6,0,%l5	!

		/* DIVIDE %l0-%l3 / %l5 -> %o0-%o3 */
    _dp00d:	add	%g0,0,%o0	!
		add	%g0,0,%o1	!
		add	%g0,0,%o2	!
		add	%g0,0,%o3	!
		add	%g0,0,%l6	!
					!
    _dpd10s:	orcc	%l0,0,%g0	! if %l0 == 0 then skip
		bz	_dpd12s		!
		add	%g0,32,%o4	!
					!
    _dpd10:	srl	%l6,1,%l6	!    |%l0|%l1|%l2|%l3|
		sll	%l5,31,%o7	! %l5:%l6
		or	%o7,%l6,%l6	!    -----------------
		srl	%l5,1,%l5	!    |%o0|
		subcc	%l0,%l6,%l0	!
		subxcc	%g0,%l5,%g0	!
		sll	%o0,1,%o0	!
		bge,a	_dpd11		!
		or	%o0,0x01,%o0	!
		addcc	%l0,%l6,%l0	!
    _dpd11:	subcc	%o4,1,%o4	!
		bnz	_dpd10		!
		nop			!
		add	%l6,0,%l5	!
		add	%g0,0,%l6	!
					!
    _dpd12s:	orcc	%l0,%l1,%g0	! if %l0,%l1 == 0 then skip
		bz	_dpd14s		!
		add	%g0,32,%o4	!
					!
    _dpd12:	srl	%l6,1,%l6	!    |%l0|%l1|%l2|%l3|
		sll	%l5,31,%o7	!     %l5:%l6
		or	%o7,%l6,%l6	!    -----------------
		srl	%l5,1,%l5	!        |%o1|
		subcc	%l1,%l6,%l1	!
		subxcc	%l0,%l5,%l0	!
		sll	%o1,1,%o1	!
		bge,a	_dpd13		!
		or	%o1,0x01,%o1	!
		addcc	%l1,%l6,%l1	!
		addxcc	%l0,%l5,%l0	!
    _dpd13:	subcc	%o4,1,%o4	!
		bnz	_dpd12		!
		nop			!
		add	%l6,0,%l5	!
		add	%g0,0,%l6	!
					!
    _dpd14s:	or	%l0,%l1,%o7	! if %l0,%l1,%l2 == 0 then skip
		orcc	%o7,%l2,%g0	!
		bz	_dpd16s		!
		add	%g0,32,%o4	!
					!
    _dpd14:	srl	%l6,1,%l6	!    |%l0|%l1|%l2|%l3|
		sll	%l5,31,%o7	!         %l5:%l6
		or	%o7,%l6,%l6	!    -----------------
		srl	%l5,1,%l5	!            |%o2|
		subcc	%l2,%l6,%l2	!
		subxcc	%l1,%l5,%l1	!
		sll	%o2,1,%o2	!
		bge,a	_dpd15		!
		or	%o2,0x01,%o2	!
		addcc	%l2,%l6,%l2	!
		addxcc	%l1,%l5,%l1	!
    _dpd15:	subcc	%o4,1,%o4	!
		bnz	_dpd14		!
		nop			!
		add	%l6,0,%l5	!
		add	%g0,0,%l6	!
					!
    _dpd16s:	or	%l0,%l1,%o7	! if %l0,%l1,%l2,%l3 == 0 then skip
		or	%o7,%l2,%o7	!
		orcc	%o7,%l3,%g0	!
		bz	_dp00e		!
		add	%g0,32,%o4	!
					!
    _dpd16:	srl	%l6,1,%l6	!    |%l0|%l1|%l2|%l3|
		sll	%l5,31,%o7	!             %l5:%l6
		or	%o7,%l6,%l6	!    -----------------
		srl	%l5,1,%l5	!                |%o3|
		subcc	%l3,%l6,%l3	!
		subxcc	%l2,%l5,%l2	!
		sll	%o3,1,%o3	!
		bge,a	_dpd17		!
		or	%o3,0x01,%o3	!
		addcc	%l3,%l6,%l3	!
		addxcc	%l2,%l5,%l2	!
    _dpd17:	subcc	%o4,1,%o4	!
		bnz	_dpd16		!
		nop			!
		add	%l6,0,%l5	!

		/* CONTROL SIGN */
		/* | %o0 | %o1 | %o2 | %o3 | ... quotient  */
		/*             | %l2 | %l3 | ... remainder */
		/*             | %l4 | %l5 | ... divisor   */
		/*          %l7.byte1 -> %l7 ... sign of quotient  */
		/*          %l7.byte0 -> %l6 ... sign of remainder */
		/*   %i1/%i3 -> original destination/legth	   */
		/*   %i2/%i4 -> temporal destination/legth	   */
		/*   %i5     -> work				   */
    _dp00e:	sub	%i3,%i4,%i5	!
		add	%i0,768,%i2	! temporal destination
		add	%i3,%g0,%i4	! temporal legth
		and	%l7,0xff,%l6	!
		srl	%l7,8,%l7	!

		/* CONVERT R(HEX) -> R(BCD) */
		/* | %l2 | %l3 | sign=%l6 */
    _dp00f:	add	%g0,0,%o5	! reset accumulated overflow
		subcc	%l2,0,%g0	!
		bnz	_dpq20		!
		nop			!

		/* %l3 -> BCD */
    _dpq10:	wr	%g0,0,%y	! ----------+
		udiv	%l3,100,%l1	!           | % 100
		umul	%l1,100,%l0	!           | / 100
		sub	%l3,%l0,%l0	! remainder |
		add	%l1,%g0,%l3	! ----------+
		add	%g0,0,%l1	! reminder % 10 -> %l0
		subcc	%l0,0x50,%l0	! reminder / 10 -> %l1
		bge,a	_dpq13		!
		or	%l1,0x8,%l1	!
		add	%l0,0x50,%l0	!
    _dpq13:	subcc	%l0,0x28,%l0	!
		bge,a	_dpq14		!
		or	%l1,0x4,%l1	!
		add	%l0,0x28,%l0	!
    _dpq14:	subcc	%l0,0x14,%l0	!
		bge,a	_dpq15		!
		add	%l1,0x2,%l1	!
		add	%l0,0x14,%l0	!
    _dpq15:	subcc	%l0,0x0a,%l0	!
		bge,a	_dpq16		!
		add	%l1,0x1,%l1	! %l0: upper 4-bit
		add	%l0,0x0a,%l0	! %l1: lower 4-bit
    _dpq16:	sll	%l0,4,%l0	!
		or	%l0,%l6,%l0	!
		add	%l1,%g0,%l6	!
		subcc	%i4,%i5,%g0	!
		bpos,a	_dpq17		!
		stb	%l0,[%i2+%i4]	!
		or	%o5,%l0,%o5	!
    _dpq17:	orcc	%l3,0,%l0	!
		bnz	_dpq10		!
    _dpq18:	sub	%i4,1,%i4	! --------------------+
		subcc	%i4,%i5,%g0	!		      |
		bneg	_dpq19		!		      |
		nop			!		      |
		stb	%l6,[%i2+%i4]	! store carry or zero |
		ba	_dpq18		!		      |
		add	%g0,0,%l6	! --------------------+
    _dpq19:	orcc	%o5,%l6,%g0	!
		sethi	%hi(0x000B0000),%o7
		bnz,a	_dpexit		! if overflow then
		or	%g7,%o7,%g7	!   decimal divide (suppressed)
		ba	_dp00g		!
		nop			!
			
		/* %l2 | %l3 -> BCD */
    _dpq20:	wr	%g0,0,%y	! ----------+
		udiv	%l2,100,%l1	!	    |
		umul	%l1,100,%l0	!	    |
		sub	%l2,%l0,%l0	!	    |
		add	%l1,%g0,%l2	!	    |
		wr	%l0,0,%y	! ----------+
		udiv	%l3,100,%l1	!           | % 100
		umul	%l1,100,%l0	!           | / 100
		sub	%l3,%l0,%l0	! remainder |
		add	%l1,%g0,%l3	! ----------+
		add	%g0,0,%l1	! reminder % 10 -> %l0
		subcc	%l0,0x50,%l0	! reminder / 10 -> %l1
		bge,a	_dpq23		!
		or	%l1,0x8,%l1	!
		add	%l0,0x50,%l0	!
    _dpq23:	subcc	%l0,0x28,%l0	!
		bge,a	_dpq24		!
		or	%l1,0x4,%l1	!
		add	%l0,0x28,%l0	!
    _dpq24:	subcc	%l0,0x14,%l0	!
		bge,a	_dpq25		!
		add	%l1,0x2,%l1	!
		add	%l0,0x14,%l0	!
    _dpq25:	subcc	%l0,0x0a,%l0	!
		bge,a	_dpq26		!
		add	%l1,0x1,%l1	! %l0: upper 4-bit
		add	%l0,0x0a,%l0	! %l1: lower 4-bit
    _dpq26:	sll	%l0,4,%l0	!
		or	%l0,%l6,%l0	!
		add	%l1,%g0,%l6	!
		subcc	%i4,%i5,%g0	!
		bpos,a	_dpq27		!
		stb	%l0,[%i2+%i4]	!
		or	%o5,%l0,%o5	!
    _dpq27:	orcc	%l2,%l3,%l0	!
		bnz	_dpq20		!
    _dpq28:	subcc	%i4,1,%i4	! --------------------+
		subcc	%i4,%i5,%g0	!		      |
		bneg	_dpq29		!		      |
		nop			!		      |
		stb	%l6,[%i2+%i4]	! store carry or zero |
		ba	_dpq28		!                     |
		add	%g0,0,%l6	! --------------------+
    _dpq29:	orcc	%o5,%l6,%g0	!
		sethi	%hi(0x000B0000),%o7
		bnz,a	_dpexit		! if overflow then
		or	%g7,%o7,%g7	!   decimal divide (suppressed)

		/* CONVERT Q(HEX) -> Q(BCD) */
		/* | %o0 | %o1 | %o2 | %o3 | sign=%l7 */
		/*	       v		      */
		/* | %l0 | %l1 | %l2 | %l3 | sign=%l7 */
    _dp00g:	add	%o0,0,%l0	!
		add	%o1,0,%l1	!
		add	%o2,0,%l2	!
		add	%o3,0,%l3	!
		add	%g0,0,%o5	! reset accumulated overflow
		sub	%i5,1,%i5	!
		subcc	%l0,0,%g0	!
		bnz	_dpr40		!
		subcc	%l1,0,%g0	!
		bnz	_dpr30		!
		subcc	%l2,0,%g0	!
		bnz	_dpr20		!
		nop			!

		/* %l3 -> BCD */
    _dpr10:	wr	%g0,0,%y	! ----------+
		udiv	%l3,100,%o1	!           | % 100
		umul	%o1,100,%o0	!           | / 100
		sub	%l3,%o0,%o0	! remainder |
		add	%o1,%g0,%l3	! ----------+
		add	%g0,0,%o1	! reminder % 10 -> %o0
		subcc	%o0,0x50,%o0	! reminder / 10 -> %o1
		bge,a	_dpr13		!
		or	%o1,0x8,%o1	!
		add	%o0,0x50,%o0	!
    _dpr13:	subcc	%o0,0x28,%o0	!
		bge,a	_dpr14		!
		or	%o1,0x4,%o1	!
		add	%o0,0x28,%o0	!
    _dpr14:	subcc	%o0,0x14,%o0	!
		bge,a	_dpr15		!
		add	%o1,0x2,%o1	!
		add	%o0,0x14,%o0	!
    _dpr15:	subcc	%o0,0x0a,%o0	!
		bge,a	_dpr16		!
		add	%o1,0x1,%o1	! %o0: upper 4-bit
		add	%o0,0x0a,%o0	! %o1: lower 4-bit
    _dpr16:	sll	%o0,4,%o0	!
		or	%o0,%l7,%o0	!
		add	%o1,%g0,%l7	!
		subcc	%i5,0,%g0	!
		bpos,a	_dpr17		!
		stb	%o0,[%i2+%i5]	!
		or	%o5,%o0,%o5	!
    _dpr17:	orcc	%l3,0,%o0	!
		bnz	_dpr10		!
    _dpr18:	subcc	%i5,1,%i5	! --------------------+
		bneg	_dpr19		!		      |
		nop			!		      |
		stb	%l7,[%i2+%i5]	! store carry or zero |
		ba	_dpr18		!		      |
		add	%g0,0,%l7	! --------------------+
    _dpr19:	orcc	%o5,%l7,%g0	!
		sethi	%hi(0x000B0000),%o7
		bnz,a	_dpexit		! if overflow then
		or	%g7,%o7,%g7	!   decimal divide (suppressed)
		ba	_dpcompl	!
		nop			!
			
		/* %l2 | %l3 -> BCD */
    _dpr20:	wr	%g0,0,%y	! ----------+
		udiv	%l2,100,%o1	!	    |
		umul	%o1,100,%o0	!	    |
		sub	%l2,%o0,%o0	!	    |
		add	%o1,%g0,%l2	!	    |
		wr	%o0,0,%y	! ----------+
		udiv	%l3,100,%o1	!           | % 100
		umul	%o1,100,%o0	!           | / 100
		sub	%l3,%o0,%o0	! remainder |
		add	%o1,%g0,%l3	! ----------+
		add	%g0,0,%o1	! reminder % 10 -> %o0
		subcc	%o0,0x50,%o0	! reminder / 10 -> %o1
		bge,a	_dpr23		!
		or	%o1,0x8,%o1	!
		add	%o0,0x50,%o0	!
    _dpr23:	subcc	%o0,0x28,%o0	!
		bge,a	_dpr24		!
		or	%o1,0x4,%o1	!
		add	%o0,0x28,%o0	!
    _dpr24:	subcc	%o0,0x14,%o0	!
		bge,a	_dpr25		!
		add	%o1,0x2,%o1	!
		add	%o0,0x14,%o0	!
    _dpr25:	subcc	%o0,0x0a,%o0	!
		bge,a	_dpr26		!
		add	%o1,0x1,%o1	! %o0: upper 4-bit
		add	%o0,0x0a,%o0	! %o1: lower 4-bit
    _dpr26:	sll	%o0,4,%o0	!
		or	%o0,%l7,%o0	!
		add	%o1,%g0,%l7	!
		subcc	%i5,0,%g0	!
		bpos,a	_dpr27		!
		stb	%o0,[%i2+%i5]	!
		or	%o5,%o0,%o5	!
    _dpr27:	orcc	%l2,%l3,%o0	!
		bnz	_dpr20		!
    _dpr28:	subcc	%i5,1,%i5	! --------------------+
		bneg	_dpr29		!		      |
		nop			!		      |
		stb	%l7,[%i2+%i5]	! store carry or zero |
		ba	_dpr28		!                     |
		add	%g0,0,%l7	! --------------------+
    _dpr29:	orcc	%o5,%l7,%g0	!
		sethi	%hi(0x000B0000),%o7
		bnz,a	_dpexit		! if overflow then
		or	%g7,%o7,%g7	!   decimal divide (suppressed)
		ba	_dpcompl	!
		nop			!

		/* %l1 | %l2 | %l3 -> BCD */
    _dpr30:	wr	%g0,0,%y	! ----------+
		udiv	%l1,100,%o1	!	    |
		umul	%o1,100,%o0	!	    |
		sub	%l1,%o0,%o0	!	    |
		add	%o1,%g0,%l1	!	    |
		wr	%o0,0,%y	! ----------+
		udiv	%l2,100,%o1	!	    |
		umul	%o1,100,%o0	!	    |
		sub	%l2,%o0,%o0	!	    |
		add	%o1,%g0,%l2	!	    |
		wr	%o0,0,%y	! ----------+
		udiv	%l3,100,%o1	!           | % 100
		umul	%o1,100,%o0	!           | / 100
		sub	%l3,%o0,%o0	! remainder |
		add	%o1,%g0,%l3	! ----------+
		add	%g0,0,%o1	! reminder % 10 -> %o0
		subcc	%o0,0x50,%o0	! reminder / 10 -> %o1
		bge,a	_dpr33		!
		or	%o1,0x8,%o1	!
		add	%o0,0x50,%o0	!
    _dpr33:	subcc	%o0,0x28,%o0	!
		bge,a	_dpr34		!
		or	%o1,0x4,%o1	!
		add	%o0,0x28,%o0	!
    _dpr34:	subcc	%o0,0x14,%o0	!
		bge,a	_dpr35		!
		add	%o1,0x2,%o1	!
		add	%o0,0x14,%o0	!
    _dpr35:	subcc	%o0,0x0a,%o0	!
		bge,a	_dpr36		!
		add	%o1,0x1,%o1	! %o0: upper 4-bit
		add	%o0,0x0a,%o0	! %o1: lower 4-bit
    _dpr36:	sll	%o0,4,%o0	!
		or	%o0,%l7,%o0	!
		add	%o1,%g0,%l7	!
		subcc	%i5,0,%g0	!
		bpos,a	_dpr37		!
		stb	%o0,[%i2+%i5]	!
		or	%o5,%o0,%o5	!
    _dpr37:	orcc	%l1,%l2,%o0	!
		orcc	%l3,%o0,%o0	!
		bnz	_dpr30		!
    _dpr38:	subcc	%i5,1,%i5	! --------------------+
		bneg	_dpr39		!		      |
		nop			!		      |
		stb	%l7,[%i2+%i5]	! store carry or zero |
		ba	_dpr38		!                     |
		add	%g0,0,%l7	! --------------------+
    _dpr39:	orcc	%o5,%l7,%g0	!
		sethi	%hi(0x000B0000),%o7
		bnz,a	_dpexit		! if overflow then
		or	%g7,%o7,%g7	!   decimal divide (suppressed)
		ba	_dpcompl	!
		nop			!
	
		/* %l0 | %l1 | %l2 | %l3 -> BCD */
    _dpr40:	wr	%g0,0,%y	! ----------+
		udiv	%l0,100,%o1	!	    |
		umul	%o1,100,%o0	!	    |
		sub	%l0,%o0,%o0	!	    |
		add	%o1,%g0,%l0	!	    |
		wr	%o0,0,%y	! ----------+
		udiv	%l1,100,%o1	!	    |
		umul	%o1,100,%o0	!	    |
		sub	%l1,%o0,%o0	!	    |
		add	%o1,%g0,%l1	!	    |
		wr	%o0,0,%y	! ----------+
		udiv	%l2,100,%o1	!	    |
		umul	%o1,100,%o0	!	    |
		sub	%l2,%o0,%o0	!	    |
		add	%o1,%g0,%l2	!	    |
		wr	%o0,0,%y	! ----------+
		udiv	%l3,100,%o1	!           | % 100
		umul	%o1,100,%o0	!           | / 100
		sub	%l3,%o0,%o0	! remainder |
		add	%o1,%g0,%l3	! ----------+
		add	%g0,0,%o1	! reminder % 10 -> %o0
		subcc	%o0,0x50,%o0	! reminder / 10 -> %o1
		bge,a	_dpr43		!
		or	%o1,0x8,%o1	!
		add	%o0,0x50,%o0	!
    _dpr43:	subcc	%o0,0x28,%o0	!
		bge,a	_dpr44		!
		or	%o1,0x4,%o1	!
		add	%o0,0x28,%o0	!
    _dpr44:	subcc	%o0,0x14,%o0	!
		bge,a	_dpr45		!
		add	%o1,0x2,%o1	!
		add	%o0,0x14,%o0	!
    _dpr45:	subcc	%o0,0x0a,%o0	!
		bge,a	_dpr46		!
		add	%o1,0x1,%o1	! %o0: upper 4-bit
		add	%o0,0x0a,%o0	! %o1: lower 4-bit
    _dpr46:	sll	%o0,4,%o0	!
		or	%o0,%l7,%o0	!
		add	%o1,%g0,%l7	!
		subcc	%i5,0,%g0	!
		bpos,a	_dpr47		!
		stb	%o0,[%i2+%i5]	!
		or	%o5,%o0,%o5	!
    _dpr47:	orcc	%l0,%l1,%o0	!
		orcc	%l2,%o0,%o0	!
		orcc	%l3,%o0,%o0	!
		bnz	_dpr40		!
    _dpr48:	subcc	%i5,1,%i5	! --------------------+
		bneg	_dpr49		!		      |
		nop			!		      |
		stb	%l7,[%i2+%i5]	! store carry or zero |
		ba	_dpr48		!                     |
		add	%g0,0,%l7	! --------------------+
    _dpr49:	orcc	%o5,%l7,%g0	!
		sethi	%hi(0x000B0000),%o7
		bnz,a	_dpexit		! if overflow then
		or	%g7,%o7,%g7	!   decimal divide (suppressed)

		/* NO ERRORS DETECTED */
		/*   %i1/%i3 -> original destination/legth	   */
		/*   %i2     -> temporal destination/legth	   */
    _dpcompl:	ldub	[%i2+%i3],%o0	!
		stb	%o0,[%i1+%i3]	!	
		subcc	%i3,1,%i3	!
		bpos	_dpcompl	!
		nop			!
	
		/* RETURN */
    _dpexit:	ret			!
		restore			!

/**/

