
static char RcsId[] =
"$Id: main1.c,v 3.62 1997/06/06 01:52:30 nakashim Exp nakashim $";

/* main.c 1995/7/18 */

/* M-on-RISC Dynamically Translating Simulator */
/*       Copyright (C) 1995 by FUJITSU LIMITED */
/*                 Primary writer: Y.Nakashima */
/*          nakashim@pine.mfd.cs.fujitsu.co.jp */

#include <stdio.h>
#include <errno.h>
#include <fcntl.h>
#include <sgtty.h>
#include <setjmp.h>
#include <sys/signal.h>
#include <sys/ttold.h>

void    *mset();
char	logfile[32];	/* name of log_file */
FILE	*log_fp;
FILE	*obj_fp;
int	sc_lines;	/* # of lines of terminal */
int     sc_noupdate;    /* redraw switch */
int	sigwinint;	/* SIGWINCH interrupt */
int	cmdintr;	/* command interrupt */
jmp_buf	sjbuf;
int     dim_version;
extern unsigned dim_info[];
extern struct m_op optable[];
extern struct m_op optb2xx[];

#include "../common/mdef.h"
#include "../common/util.c"

main(argc, argv)
  int argc;
  char **argv;
{
  void	onintr_sigwinch();
  void	onintr_cmd();
  void	onintr_sys();
  long	gettime();
  char	*getenv();
  char	*version();
  char	*termtype;
  char	*cmdP;
#ifdef IGNOREEOF
  char	save_eofc;
#endif
#define	BUFSIZE	1024
  char	buf[BUFSIZE];
  unsigned addr, step, data, i, j;
  unsigned char *sp, *ep;
  struct tchars TCHARS;
  struct gcpu_s *gcpu_s0;
  unsigned char* gmem0;
  unsigned sw_disasm, sw_step, sw_interp, sw_count;
  llu   minsn_count, stemp_count;

  termtype = getenv("TERM");
  switch(tgetent(buf, termtype)) {
  case -1:
    fprintf(stderr, "can't read termcap\n");
    exit(1);
    break;
  case 0:
    fprintf(stderr, "can't find your terminal type (%s) in termcap\n", termtype);
    exit(1);
    break;
  default:
    sc_lines = tgetnum("li");
    break;
  }

  if (argc != 2) {
    fprintf(stderr, "usage: %s <object>\n", *argv);
    exit(1);
  }

  if ((obj_fp = fopen(*(argv+1), "r")) == NULL) {
    fprintf(stderr, "can't read \"%s\"\n", *(argv+1));
    exit(1);
  }

  sprintf(logfile ,"/tmp/.dimlog%u", getpid());
  if ((log_fp = fopen(logfile, "w")) == NULL) {
    fprintf(stderr, "can't create \"%s\"\n", logfile);
    exit(1);
  }

  if ((gcpu_s0 = (struct gcpu_s*)memalign(sizeof(struct gcpu_s),sizeof(struct gcpu_s))) == NULL) {
    fprintf(stderr, "gcpu_s0 allocation failed (size=%d)\n", sizeof(struct gcpu_s));
    exit(1);
  }
  mset(gcpu_s0, 0, sizeof(struct gcpu_s));

  if ((gcpu_s0->guest_mem = (unsigned)memalign(GUEST_MEMSIZE,GUEST_MEMSIZE)) == 0) {
    fprintf(stderr, "guest_mem allocation failed (size=%d)\n", GUEST_MEMSIZE);
    exit(1);
  }
  if ((gcpu_s0->host_imap = (unsigned)memalign((GUEST_MEMSIZE/2)*4,(GUEST_MEMSIZE/2)*4)) == 0) {
    fprintf(stderr, "host_imap allocation failed (size=%d)\n", (GUEST_MEMSIZE/2)*4);
    exit(1);
  }
  if ((gcpu_s0->host_ibufpp = (unsigned)memalign((GUEST_MEMSIZE/GUEST_PAGESIZE)*16,(GUEST_MEMSIZE/GUEST_PAGESIZE)*16)) == 0) {
    fprintf(stderr, "host_ibufpp allocation failed (size=%d)\n", (GUEST_MEMSIZE/GUEST_PAGESIZE)*16);
    exit(1);
  }
  if ((gcpu_s0->ibuf = gcpu_s0->freep = (unsigned)memalign(IBUF_SIZE,IBUF_SIZE)) == 0) {
    fprintf(stderr, "ibuf allocation failed (size=%d)\n", IBUF_SIZE);
    exit(1);
  }
  if ((gcpu_s0->interp_ibuf = (unsigned)memalign(IBUF_PAGESIZE,IBUF_PAGESIZE)) == 0) {
    fprintf(stderr, "interp_ibuf allocation failed (size=%d)\n", IBUF_PAGESIZE);
    exit(1);
  }
  if ((gcpu_s0->cslocka = (unsigned)memalign(4,4)) == 0) {
    fprintf(stderr, "cslocka allocation failed (size=%d)\n", 4);
    exit(1);
  }
  gmem0 = (unsigned char*)gcpu_s0->guest_mem;
  mset(gcpu_s0->guest_mem, 0, GUEST_MEMSIZE);
  mset(gcpu_s0->host_imap, 0, (GUEST_MEMSIZE/2)*4);
  mset(gcpu_s0->host_ibufpp, 0, (GUEST_MEMSIZE/GUEST_PAGESIZE)*16);
  mset(gcpu_s0->ibuf, 0xff, IBUF_SIZE);
  mset(gcpu_s0->interp_ibuf, 0xff, IBUF_PAGESIZE);
  mset(gcpu_s0->cslocka, 0, 4);
  gcpu_s0->guest_memsize = GUEST_MEMSIZE;
  gcpu_s0->host_imapsize = (GUEST_MEMSIZE/2)*4;
  gcpu_s0->host_bufpsize = (GUEST_MEMSIZE/GUEST_PAGESIZE)*16;

  dim_version            = dim_info[0];
  gcpu_s0->pa_sinsn      = dim_info[3];
  gcpu_s0->pa_pinsn      = dim_info[4];
  gcpu_s0->br_hist_top   = dim_info[5];
  gcpu_s0->br_hist_cp    = dim_info[5];

  gcpu_s0->g1            = 0x0000000000000000LL;
  gcpu_s0->g2            = 0x0000000000000000LL;
  gcpu_s0->g3            = 0x0000000000ffffffLL;
  if (dim_version <= 3) {
    gcpu_s0->g4          = (llu)gcpu_s0->guest_mem;
    gcpu_s0->g5          = (llu)gcpu_s0->host_imap;
  }
  else {
    gcpu_s0->g4          = 0xffffffffffffffffLL;
    gcpu_s0->g5          = 0xffffffffffffffffLL;
    gcpu_s0->g6          = 0xffffffffffffffffLL;
    gcpu_s0->sta_key     = 0x7fffe000;
    gcpu_s0->acc_mask    = 0xffffe1ff;
    for (i=0; i<GTLB_SIZE; i++) {
      gcpu_s0->tlb[i].gs_if = 0x7fffe000ffffe1ffLL;
      gcpu_s0->tlb[i].gs_ld = 0x7fffe000ffffe1ffLL;
      gcpu_s0->tlb[i].gs_st = 0x7fffe000ffffffffLL;
      gcpu_s0->tlb[i].ds_la = ((llu)gcpu_s0->guest_mem|(llu)i << 12)<<32
			     |((llu)gcpu_s0->guest_mem|(llu)i << 12);
    }
  }
  gcpu_s0->g7            = 0x0000000000000800LL; /* IM=0,AM=0,PROG=0 */

/* åե졼  åХեե졼

    ^   SP(R13)                           EP(R12)
  |   +--------------------------+        +--------------------------+
  +-|-->|  0x10񤭹ޤ      |+ 0     |                          |+0
  | |   |--------------------------|        |--------------------------|
  | +---|   SP               |+ 4     |                          |+4
  |   |--------------------------|        |--------------------------|
  |   |                          |+ 8     |                          |+8
  |   |--------------------------|        |--------------------------|
  |   |  M14(ret-addr)       |+12     |  SP                |+12
  |   |--------------------------|        |--------------------------|
  |   |  M15(callƬ)       |+16     |                          |
  |   |--------------------------|        |                          |
  |   |  M0                  |+20     |                          |
  |   |--------------------------|      |                          |
  |   |  M12                 |+68     |                          |
  |   |--------------------------|        |                          |
  |   |SPΥԡ(any)   |+72     |                          |
  |   |--------------------------|        |                          |
  |  +--| SP                   |+76     |                          |
  |  |  |--------------------------|      |--------------------------|
  |  |  |                          |    +---|  Ķ      |+116
  |  |  |                          |    |   |--------------------------|
  |  |  |                          |    +-->|LA 0,0xFFE(0,0)41000FFE   |+120
  |  |  +--------------------------+        |--------------------------|
  |  +->|                          |        |BC 0,0xFED(0,0)47000FED   |+124
  |     |--------------------------|        |--------------------------|
  +-----|                          |   R14->|LA 0,0xFFF(0,0)41000FFF   |+128
        |--------------------------|        |--------------------------|
        |                          |        |BC 0,0xFED(0,0)47000FED   |+132
                                            |--------------------------|
                                            |          ͽ            |+136
                                            |--------------------------|
  Ͼ̴ؿ¦Ѱ                      |    |
                                            |--------------------------|
                                            |          ͽ            |+252
                                            +--------------------------+

  R11  Ƭɥ쥹
  R12  SPĶΤι¤   dimư0x1FFF00Ȥ
                                        0x1FFF000x1FFFFF˱ޤǼ
                                        (+124)dimĥ̿SPOV񤤤Ƥ
  R13  SP                           dimư0x100000(1MB)
  R14  return-addr(̿Ƭ)  dimư0x1FFF80     
  R15  callƬɥ쥹             dimư0x000000(gccmain)
*/
  gcpu_s0->gr[12] = GUEST_MEMSIZE-256;
  gcpu_s0->gr[13] = GUEST_MEMSIZE-GUEST_STKSIZE;
  gcpu_s0->gr[14] = GUEST_MEMSIZE-128;
  sp = (unsigned char*)gcpu_s0->guest_mem+GUEST_MEMSIZE-GUEST_STKSIZE;
  *(unsigned*)(sp+ 72) = 0x12345678;
  *(unsigned*)(sp+ 76) = GUEST_MEMSIZE-GUEST_STKSIZE+80;
  ep = (unsigned char*)gcpu_s0->guest_mem+GUEST_MEMSIZE-256;
  *(unsigned*)(ep+ 12) = GUEST_MEMSIZE-256;
  *(unsigned*)(ep+116) = GUEST_MEMSIZE-136;
  *(unsigned*)(ep+120) = 0x41000FFE;
  *(unsigned*)(ep+124) = 0x47000FED;
  *(unsigned*)(ep+128) = 0x41000FFF;
  *(unsigned*)(ep+132) = 0x47000FED;

  addr = -1;
  while ((i = getc(obj_fp)) != EOF) {
    if (++addr > GUEST_MEMSIZE-GUEST_STKSIZE-1) {
      fprintf(stderr, "object too large (size>%d)\n", GUEST_MEMSIZE-GUEST_STKSIZE-1);
      exit(1);
    }
    *(unsigned char*)(gcpu_s0->guest_mem+addr) = i;
  }

#ifdef IGNOREEOF
  ioctl(0, TIOCGETC, &TCHARS);
  save_eofc = TCHARS.t_eofc;
  TCHARS.t_eofc = 'w'-0x60;
  ioctl(0, TIOCSETC, &TCHARS);
#endif
  /* system("stty tabs"); */
  scr_setr(5);
  signal(SIGWINCH, onintr_sigwinch);

  message("M-on-RISC Dynamically Translating Simulator\n");
  message("Version %s\n", version());
  message(" gcpu_s=0x%08.8x\n", gcpu_s0);
  message(" memory=0x%08.8x memsize=%u\n", gcpu_s0->guest_mem, gcpu_s0->guest_memsize);
  message(" imap  =0x%08.8x mapsize=%u\n", gcpu_s0->host_imap, gcpu_s0->host_imapsize);
  message(" ibufpp=0x%08.8x\n", gcpu_s0->host_ibufpp);
  message(" ibuf  =0x%08.8x i_ibuf=0x%08.8x\n", gcpu_s0->ibuf, gcpu_s0->interp_ibuf);
  message(" ibuf_psize=%u ibuf_size=%u\n", IBUF_PAGESIZE, IBUF_SIZE);
  message(" object=0x00000000-0x%08.8x\n", addr);
  message(" stack =0x%08.8x-0x%08.8x\n", GUEST_MEMSIZE-GUEST_STKSIZE, GUEST_MEMSIZE-257);
  message(" stkov =0x%08.8x-0x%08.8x\n", GUEST_MEMSIZE-256, GUEST_MEMSIZE-1);
  message(" logfile =\"%s\"\n", logfile);

  addr = 0;
  step = 10;
  for (;;) {
    signal(SIGINT, SIG_IGN);
    setjmp(sjbuf);
    signal(SIGINT, onintr_cmd);

    sc_noupdate = 0;
    disp_stat(gcpu_s0);
    message("-> ");
    buf[0] = '\0';
    sigwinint = 0;
    if (fgets(cmdP = buf, BUFSIZE, stdin) == NULL) {
      if (!sigwinint)
        goto encounter_eof;
    }
    log_output(buf);

    switch (*cmdP++) {
    case '\0':
    case '\r':
    case '\n':
    case ' ':
      break; /* do nothing */

    case 'h':
      message("^C ............... stop\n");
      message("h ................ help\n");
      message("q ................ quit\n");
      message("l ................ display log\n");
      message("d [addr [step]] .. disassemble\n");
      message("m [addr [data]] .. dump/set gcpu_s memory\n");
      message("x [addr] ......... dump host_imap\n");
      message("z [addr] ......... dump host memory\n");
      message("a [addr] ......... set IAR\n");
      message("G [addr] ......... OCT go\n");
      message("S [step] ......... OCT step exec with no disasm\n");
      message("T [step] ......... OCT step exec with disasm\n");
      message("g [addr] ......... interpretive go\n");
      message("s [step] ......... interpretive step exec with no disasm\n");
      message("t [step] ......... interpretive step exec with disasm\n");
      message("c [addr] ......... interpretive count insn.\n");
      break;

    case 'q':
encounter_eof:
      scr_reset();
#ifdef IGNOREEOF
      TCHARS.t_eofc = save_eofc;
      ioctl(0, TIOCSETC, &TCHARS);
#endif
      /* system("stty -tabs"); */
      unlink(logfile);
      exit(0);
      break;

    case 'l':
      sprintf(buf, "less '-P%%f(%%i of %%m) [line %%lb/%%L %%pB\\%%]$' +G %s", logfile);
      req_system(buf);
      break;

    case 'd':
      sscanf(cmdP, "%x %d", &addr, &step);
      if (!step)
        step = 1;
      for (i=0; i<step; i++) {
        if (addr > GUEST_MEMSIZE-1) {
          message("address too large (addr>0x%06.6x)\n", GUEST_MEMSIZE-1);
          goto exit_dumpmem;
        }
        addr += disasm(gcpu_s0, gmem0, addr);
      }
exit_disassemble:
      break;

    case 'm':
      if (sscanf(cmdP, "%x %x", &addr, &data) == 2) {
	if (addr > GUEST_MEMSIZE-1 || addr+3 > GUEST_MEMSIZE-1) {
	  message("address to large (addr,addr+3>0x%06.6x)\n", GUEST_MEMSIZE-1);
	  goto exit_dumpmem;
	}
	message("%06.6x: %08.8x -> %08.8x\n",
		addr,
		*(unsigned char*)(gcpu_s0->guest_mem+addr  )<<24
	       |*(unsigned char*)(gcpu_s0->guest_mem+addr+1)<<16
	       |*(unsigned char*)(gcpu_s0->guest_mem+addr+2)<< 8
	       |*(unsigned char*)(gcpu_s0->guest_mem+addr+3),
		data);
	*(unsigned char*)(gcpu_s0->guest_mem+addr  ) = data>>24;
	*(unsigned char*)(gcpu_s0->guest_mem+addr+1) = data>>16;
	*(unsigned char*)(gcpu_s0->guest_mem+addr+2) = data>> 8;
	*(unsigned char*)(gcpu_s0->guest_mem+addr+3) = data    ;
      }
      else {
	message("  addr +0 +1 +2 +3 +4 +5 +6 +7  ");
	message("+8 +9 +a +b +c +d +e +f  ");
	message("0123456789abcdef\n");
	for (i = 0; i < 8; i++) {
	  message("%06.6x", addr);
	  for (j = 0; j < 16; j++) {
	    if (j == 8) message(" ");
	    if (addr+j > GUEST_MEMSIZE-1) {
	      message("address to large (addr>0x%06.6x)\n", GUEST_MEMSIZE-1);
	      goto exit_dumpmem;
	    }
	    message(" %02.2x", *(unsigned char*)(gcpu_s0->guest_mem+addr+j));
	  }
	  message("  ");
	  for (j = 0; j < 16; j++)
	    message("%c", e2adump[*(unsigned char*)(gcpu_s0->guest_mem+addr+j)]);
	  message("\n");
	  addr += 16;
	}
      }
exit_dumpmem:
      break;

    case 'x':
      sscanf(cmdP, "%x", &addr);
      for (i = 0; i < 16; i+=2)
        message("%06.6x -> bufbp=%08.8x lock=%08.8x imap=%08.8x\n",
          addr+i,
          ((unsigned char**)gcpu_s0->host_ibufpp)[((addr+i)/GUEST_PAGESIZE)*4+2],
          ((unsigned char**)gcpu_s0->host_ibufpp)[((addr+i)/GUEST_PAGESIZE)*4+3],
          ((unsigned*)gcpu_s0->host_imap)[(addr+i)/2]);
      addr += 16;
      break;

    case 'z':
      sscanf(cmdP, "%x", &addr);
      message("    addr +0 +1 +2 +3 +4 +5 +6 +7  ");
      message("+8 +9 +a +b +c +d +e +f\n");
      for (i = 0; i < 8; i++) {
        message("%08.8x", addr);
        for (j = 0; j < 16; j++) {
          if (j == 8) message(" ");
          message(" %02.2x", *((unsigned char*)addr+j));
        }
        message("\n");
        addr += 16;
      }
      break;

    case 'a':
      addr = (unsigned)gcpu_s0->g2;
      sscanf(cmdP, "%x", &addr);
      gcpu_s0->g2 = (llu)addr;
      break;

    case 'G':
    case 'S':
    case 'T':
    case 'g':
    case 's':
    case 't':
    case 'c':
      if (*(cmdP-1) == 'g' || *(cmdP-1) == 's' || *(cmdP-1) == 't'
       || *(cmdP-1) == 'c')
	sw_interp = 1;
      else
	sw_interp = 0;
      if (*(cmdP-1) == 'S' || *(cmdP-1) == 's'
       || *(cmdP-1) == 'T' || *(cmdP-1) == 't')
	sw_step = 1;
      else
	sw_step = 0;
      if (*(cmdP-1) == 'T' || *(cmdP-1) == 't')
	sw_disasm = 1;
      else
	sw_disasm = 0;
      if (*(cmdP-1) == 'c') {
	sw_count = 1;
	minsn_count = 0;
	stemp_count = 0;
      }
      else
	sw_count = 0;

      if (sw_step) {
	sscanf(cmdP, "%d", &step);
	if (!step)
	  step = 1;
      }
      else {
        addr = (unsigned)gcpu_s0->g2;
	sscanf(cmdP, "%x", &addr);
        gcpu_s0->g2 = (llu)addr;
      }

      cmdintr = 0;
      signal(SIGINT, SIG_IGN);
      signal(SIGINT, onintr_sys);
      if (dim_version <= 3) {
	if (sw_interp)
	  gcpu_s0->g7 |=  0x0000000000000020LL;
	else
	  gcpu_s0->g7 &= ~0x0000000000000020LL;
      }
      else {
	if (!sw_interp)
	  message("OCT not supported on dim_version=%d\n", dim_version);
	gcpu_s0->g7 &= ~0x0000000000000020LL;
      }

      clrtime();
      /* M operand/instruction can be placed at any boundary */
      asm("ta 6"); /* activate alignment-free */
      for (i=0; !sw_step || i<step; i++) {
        if (sw_disasm)
          disasm(gcpu_s0, gmem0, (int)gcpu_s0->g2);
	if (sw_count) {
	  minsn_count++;
	  stemp_count += getslen(gcpu_s0, (int)gcpu_s0->g2)/4;
	}
	gcpu_s0->g7 &= ~0xffffffffc1ff0000LL;
	if (sw_step || sw_count)
	  gcpu_s0->g7 |=  0x0000000001000000LL;
        asm("ldx %0,%%g7":"=m"(gcpu_s0->g7)::"%g7");
        dim_prog(gcpu_s0);
        asm("stx %%g7,%0":"=m"(gcpu_s0->g7)::"%g7");

#include "../common/control.c"

	if (cmdintr) { /* command break */
	  message("command break detected\n");
	  break;
	}
	if (sw_step)
	  disp_stat(gcpu_s0);
      }
exit_loop:
      if (sw_count) {
        message("minsn_count=0x%08.8x_%08.8x stemp_count=0x%08.8x_%08.8x\n",
		(unsigned)(minsn_count>>32), (unsigned)(minsn_count),
		(unsigned)(stemp_count>>32), (unsigned)(stemp_count));
      }
      message("M stopped (time=%umsec)\n", gettime());
      break;
      
    default:
      message("unknown command: \"%c\"\n", *(cmdP-1));
      break;
    }
  }
  exit(0);
}

void *
mset(addr, d, len)
  void *addr;
  int d;
  int len;
{
  char *p = (char*)addr;

  for (;len; len--)
    *p++ = d;
  
  return(addr);
} 

getslen(gcpu_s, addr)
  struct gcpu_s *gcpu_s;
  unsigned addr;
{
  struct m_op *optblp;
  llu insn;
  unsigned char opcd;
  char *args;
  int mlen;

  opcd = *(unsigned char*)(gcpu_s->guest_mem+addr);
  if (opcd != 0xb2)
    optblp = optable;
  else {
    opcd = *(unsigned char*)(gcpu_s->guest_mem+addr+1);
    optblp = optb2xx;
  }
  insn = 0LL;
  args = (unsigned char*)optblp[opcd].args;
  mlen = optblp[opcd].mlen;

  switch (mlen) {
  case 6:
    insn |= (llu)*(unsigned char*)(gcpu_s->guest_mem+addr+5) << 16;
    insn |= (llu)*(unsigned char*)(gcpu_s->guest_mem+addr+4) << 24;
  case 4:
    insn |= (llu)*(unsigned char*)(gcpu_s->guest_mem+addr+3) << 32;
    insn |= (llu)*(unsigned char*)(gcpu_s->guest_mem+addr+2) << 40;
  case 2:
    insn |= (llu)*(unsigned char*)(gcpu_s->guest_mem+addr+1) << 48;
    insn |= (llu)*(unsigned char*)(gcpu_s->guest_mem+addr  ) << 56;
    break;
  default:
    message("internal error: optblp[0x%02.2x].mlen=%d\n", opcd, mlen);
    return(2);
    break;
  }

  return(((int (*)())optblp[opcd].cfunc)(0, (unsigned)(insn>>32), (unsigned)(insn)));
}

void
onintr_sigwinch()
{
  struct winsize ws;

  if (ioctl (1, TIOCGWINSZ, &ws) != -1) {
    if (ws.ws_row != 0)
      sc_lines = ws.ws_row;
  }
  scr_reset();
  scr_setr(5);
  sigwinint = 1;
  signal(SIGWINCH, onintr_sigwinch);
}

void
onintr_cmd()
{
  message("!\n");
  longjmp(sjbuf, 1);
}

void
onintr_sys()
{
  signal(SIGINT, SIG_IGN);
  cmdintr = 1;
  signal(SIGINT, onintr_sys);
}

