
static char RcsId[] =
"$Id: main2.c,v 1.42 1997/06/11 05:58:27 nakashim Exp nakashim $";

/* main2.c 1995/7/18 */

/* M-on-RISC Dynamically Translating Simulator */
/*       Copyright (C) 1995 by FUJITSU LIMITED */
/*                 Primary writer: Y.Nakashima */
/*          nakashim@pine.mfd.cs.fujitsu.co.jp */

#include "../common/mdef.h"
#include "data"

void      *mset();
char      *version();
union dev_tree *get_prop();
union dev_tree *search_name();
union dev_tree *search_prop();
unsigned  open_ttya();
unsigned  obp_enter();
unsigned  obp_finddevice(), obp_peer(), obp_child(), obp_parent();
unsigned  obp_getproplen(), obp_getprop(), obp_nextprop();
unsigned  obp_set_trap_table(), obp_itlb_load(), obp_dtlb_load();

main(cif_service_handler)
     unsigned (*cif_service_handler)();
{
  unsigned        phandle, ihandle;
  int             obj_fd, addr, size, i, dim_version, exectime;
  extern unsigned dim_info[];
  struct gcpu_s   *gcpu_s0;
  unsigned char   *gmem0;
  unsigned char   *sp, *ep;

  call_obp = cif_service_handler;

#if 1
  /* init TLB */
  phandle = obp_finddevice("/chosen");
  obp_getprop(4, &ihandle, "mmu", phandle);
  obp_itlb_load(63, 0x00000000, 0xe0000200, 0x00000077, ihandle);
  obp_itlb_load(62, 0x00400000, 0xe0000200, 0x00400077, ihandle);
  obp_itlb_load(61, 0x00800000, 0xe0000200, 0x00800077, ihandle);
  obp_itlb_load(60, 0x00C00000, 0xe0000200, 0x00c00077, ihandle);
  obp_dtlb_load(63, 0x00000000, 0xe0000200, 0x00000077, ihandle);
  obp_dtlb_load(62, 0x00400000, 0xe0000200, 0x00400077, ihandle);
  obp_dtlb_load(61, 0x00800000, 0xe0000200, 0x00800077, ihandle);
  obp_dtlb_load(60, 0x00C00000, 0xe0000200, 0x00c00077, ihandle);
  obp_dtlb_load(59, 0x04000000, 0xe0000200, 0x04000077, ihandle);
  obp_dtlb_load(58, 0x04400000, 0xe0000200, 0x04400077, ihandle);
  obp_dtlb_load(57, 0x04800000, 0xe0000200, 0x04800077, ihandle);
  obp_dtlb_load(56, 0x04c00000, 0xe0000200, 0x04c00077, ihandle);
  obp_dtlb_load(55, 0x05000000, 0xe0000200, 0x05000077, ihandle);
  obp_dtlb_load(54, 0x05400000, 0xe0000200, 0x05400077, ihandle);
  obp_dtlb_load(53, 0x05800000, 0xe0000200, 0x05800077, ihandle);
  obp_dtlb_load(52, 0x05c00000, 0xe0000200, 0x05c00077, ihandle);
  obp_dtlb_load(51, 0x06000000, 0xe0000200, 0x06000077, ihandle);
  obp_dtlb_load(50, 0x06400000, 0xe0000200, 0x06400077, ihandle);
  obp_dtlb_load(49, 0x06800000, 0xe0000200, 0x06800077, ihandle);
  obp_dtlb_load(48, 0x06c00000, 0xe0000200, 0x06c00077, ihandle);
  obp_dtlb_load(47, 0x07000000, 0xe0000200, 0x07000077, ihandle);
  obp_dtlb_load(46, 0x07400000, 0xe0000200, 0x07400077, ihandle);
  obp_dtlb_load(45, 0x07800000, 0xe0000200, 0x07800077, ihandle);
  obp_dtlb_load(44, 0x07c00000, 0xe0000200, 0x07c00077, ihandle);
#endif

  /* extract TLB tag & data */
  extract_tlb();

  /* stop for RMGDB */
  obp_enter();

  /* open ttya */
  serial_ih = open_ttya();

  /* write opening message */
  pr("\n\n======== Welcome to RMV9 ========\n\n");

#if 1
  /* display TLB tag & data */
  pr("\n\n======== I-TLB ========\n\n");
  for (i=0; i<ULTRA_TLB_SIZE; i++)
    pr("%b: %08.8x%08.8x %08.8x%08.8x\n", i,
       (int)(i_tlb_tag0[i]>>32),   (int)(i_tlb_tag0[i]),
       (int)(i_tlb_data0[i]>>32),  (int)(i_tlb_data0[i]));
  pr("\n\n======== D-TLB ========\n\n");
  for (i=0; i<ULTRA_TLB_SIZE; i++)
    pr("%b: %08.8x%08.8x %08.8x%08.8x\n", i,
       (int)(d_tlb_tag0[i]>>32),   (int)(d_tlb_tag0[i]),
       (int)(d_tlb_data0[i]>>32),  (int)(d_tlb_data0[i]));
#endif

#if 1
  /* context change */
  pr("\n\n======== CHANGING CONTEXT ========\n\n");
  pr("old context=0x%08.8x\n", get_context());
  set_context(0x00); /* set PSTATE.IE=0 if other context */
  pr("new context=0x%08.8x\n", get_context());
#endif
    
  /* get device-tree */
  pr("\n\n======== GETTING DEVICE TREE ========\n\n");
  dev_treeP = &dev_tree0[0];
  dev_dataP = &dev_data0[0];
  get_device_tree();

#if 1
  /* display device-tree */
  pr("\n\n======== DISPLAY DEVICE TREE ========\n\n");
  display_device_tree();
#endif

  /* search device-tree */
  pr("\n\n======== SEARCH DEVICE TREE ========\n\n");
  if (search_device_tree("Fujitsu,GRANPOWER-7000/clock-frequency", (char*)&dtree_system_clock_frequency)) {
    search_device_tree("Fujitsu,GRANPOWER-7000/virtual-memory/page-size", (char*)&dtree_mem_page_size);
    search_device_tree("Fujitsu,GRANPOWER-7000/memory/available", (char*)&dtree_mem_avail0);
    search_device_tree("Fujitsu,GRANPOWER-7000/SUNW,UltraSPARC/manufacturer#", (char*)&dtree_cpu_manufacturer);
    search_device_tree("Fujitsu,GRANPOWER-7000/SUNW,UltraSPARC/implementation#", (char*)&dtree_cpu_implementation);
    search_device_tree("Fujitsu,GRANPOWER-7000/SUNW,UltraSPARC/ecache-associativity", (char*)&dtree_cpu_ecache_associativity);
    search_device_tree("Fujitsu,GRANPOWER-7000/SUNW,UltraSPARC/ecache-line-size", (char*)&dtree_cpu_ecache_line_size);
    search_device_tree("Fujitsu,GRANPOWER-7000/SUNW,UltraSPARC/ecache-size", (char*)&dtree_cpu_ecache_size);
    search_device_tree("Fujitsu,GRANPOWER-7000/SUNW,UltraSPARC/#dtlb-entries", (char*)&dtree_cpu_dtlb_entries);
    search_device_tree("Fujitsu,GRANPOWER-7000/SUNW,UltraSPARC/dcache-associativity", (char*)&dtree_cpu_dcache_associativity);
    search_device_tree("Fujitsu,GRANPOWER-7000/SUNW,UltraSPARC/dcache-line-size", (char*)&dtree_cpu_dcache_line_size);
    search_device_tree("Fujitsu,GRANPOWER-7000/SUNW,UltraSPARC/dcache-size", (char*)&dtree_cpu_dcache_size);
    search_device_tree("Fujitsu,GRANPOWER-7000/SUNW,UltraSPARC/#itlb-entries", (char*)&dtree_cpu_itlb_entries);
    search_device_tree("Fujitsu,GRANPOWER-7000/SUNW,UltraSPARC/icache-associativity", (char*)&dtree_cpu_icache_associativity);
    search_device_tree("Fujitsu,GRANPOWER-7000/SUNW,UltraSPARC/icache-line-size", (char*)&dtree_cpu_icache_line_size);
    search_device_tree("Fujitsu,GRANPOWER-7000/SUNW,UltraSPARC/icache-size", (char*)&dtree_cpu_icache_size);
    search_device_tree("Fujitsu,GRANPOWER-7000/SUNW,UltraSPARC/upa-portid", (char*)&dtree_cpu_upa_portid);
    search_device_tree("Fujitsu,GRANPOWER-7000/SUNW,UltraSPARC/clock-frequency", (char*)&dtree_cpu_clock_frequency);
  }
  else if (search_device_tree("SUNW,Ultra-1/clock-frequency", (char*)&dtree_system_clock_frequency)) {
    search_device_tree("SUNW,Ultra-1/clock-frequency", (char*)&dtree_system_clock_frequency);
    search_device_tree("SUNW,Ultra-1/virtual-memory/page-size", (char*)&dtree_mem_page_size);
    search_device_tree("SUNW,Ultra-1/memory/available", (char*)&dtree_mem_avail0);
    search_device_tree("SUNW,Ultra-1/SUNW,UltraSPARC/manufacturer#", (char*)&dtree_cpu_manufacturer);
    search_device_tree("SUNW,Ultra-1/SUNW,UltraSPARC/implementation#", (char*)&dtree_cpu_implementation);
    search_device_tree("SUNW,Ultra-1/SUNW,UltraSPARC/ecache-associativity", (char*)&dtree_cpu_ecache_associativity);
    search_device_tree("SUNW,Ultra-1/SUNW,UltraSPARC/ecache-line-size", (char*)&dtree_cpu_ecache_line_size);
    search_device_tree("SUNW,Ultra-1/SUNW,UltraSPARC/ecache-size", (char*)&dtree_cpu_ecache_size);
    search_device_tree("SUNW,Ultra-1/SUNW,UltraSPARC/#dtlb-entries", (char*)&dtree_cpu_dtlb_entries);
    search_device_tree("SUNW,Ultra-1/SUNW,UltraSPARC/dcache-associativity", (char*)&dtree_cpu_dcache_associativity);
    search_device_tree("SUNW,Ultra-1/SUNW,UltraSPARC/dcache-line-size", (char*)&dtree_cpu_dcache_line_size);
    search_device_tree("SUNW,Ultra-1/SUNW,UltraSPARC/dcache-size", (char*)&dtree_cpu_dcache_size);
    search_device_tree("SUNW,Ultra-1/SUNW,UltraSPARC/#itlb-entries", (char*)&dtree_cpu_itlb_entries);
    search_device_tree("SUNW,Ultra-1/SUNW,UltraSPARC/icache-associativity", (char*)&dtree_cpu_icache_associativity);
    search_device_tree("SUNW,Ultra-1/SUNW,UltraSPARC/icache-line-size", (char*)&dtree_cpu_icache_line_size);
    search_device_tree("SUNW,Ultra-1/SUNW,UltraSPARC/icache-size", (char*)&dtree_cpu_icache_size);
    search_device_tree("SUNW,Ultra-1/SUNW,UltraSPARC/upa-portid", (char*)&dtree_cpu_upa_portid);
    search_device_tree("SUNW,Ultra-1/SUNW,UltraSPARC/clock-frequency", (char*)&dtree_cpu_clock_frequency);
  }
  else
    pr("Legal model not found\n");

  pr("system_clock_frequency   = %u\n", dtree_system_clock_frequency);
  pr("mem_page_size            = %u\n", dtree_mem_page_size);
  pr("mem_available            =");
  for (i=0; i<MEM_AVAIL_SIZE; i++) {
    if (dtree_mem_avail0[i].len == 0LL)
      break;
    pr(" %08.8x%08.8x-%08.8x%08.8x",
       (int)(dtree_mem_avail0[i].start>>32), (int)dtree_mem_avail0[i].start,
       (int)(dtree_mem_avail0[i].len  >>32), (int)dtree_mem_avail0[i].len);
  }
  pr("\n");
  pr("cpu_manufacturer         = %u\n", dtree_cpu_manufacturer);
  pr("cpu_implementation       = %u\n", dtree_cpu_implementation);
  pr("cpu_ecache_associativity = %u\n", dtree_cpu_ecache_associativity);
  pr("cpu_ecache_line_size     = %u\n", dtree_cpu_ecache_line_size);
  pr("cpu_ecache_size          = %u\n", dtree_cpu_ecache_size);
  pr("cpu_dtlb_entries         = %u\n", dtree_cpu_dtlb_entries);
  pr("cpu_dcache_associativity = %u\n", dtree_cpu_dcache_associativity);
  pr("cpu_dcache_line_size     = %u\n", dtree_cpu_dcache_line_size);
  pr("cpu_dcache_size          = %u\n", dtree_cpu_dcache_size);
  pr("cpu_itlb_entries         = %u\n", dtree_cpu_itlb_entries);
  pr("cpu_icache_associativity = %u\n", dtree_cpu_icache_associativity);
  pr("cpu_icache_line_size     = %u\n", dtree_cpu_icache_line_size);
  pr("cpu_icache_size          = %u\n", dtree_cpu_icache_size);
  pr("cpu_upa_portid           = %u\n", dtree_cpu_upa_portid);
  pr("cpu_clock_frequency      = %u\n", dtree_cpu_clock_frequency);

  /* dim test */
  pr("\n\n======== DIM TEST ========\n\n");

  /* init gcpu_s0 */
  gcpu_s0                = (struct gcpu_s*) 0x00c5f000;
  mset(gcpu_s0, 0, sizeof(struct gcpu_s));
  gmem0                  = (unsigned char*) 0x04000000;
  gcpu_s0->guest_mem     = (unsigned)       0x04000000;
  gcpu_s0->host_imap     = (unsigned)       0x04100000;
  gcpu_s0->host_ibufpp   = (unsigned)       0x00c77000;
  gcpu_s0->ibuf          = (unsigned)       0x00c80000;
  gcpu_s0->freep         = (unsigned)       0x00c80000;
  gcpu_s0->interp_ibuf   = (unsigned)       0x00c78000;
  gcpu_s0->cslocka       = (unsigned)       0x00c76ffc;
  mset(gcpu_s0->guest_mem, 0, GUEST_MEMSIZE);
  mset(gcpu_s0->host_imap, 0, (GUEST_MEMSIZE/2)*4);
  mset(gcpu_s0->host_ibufpp, 0, (GUEST_MEMSIZE/GUEST_PAGESIZE)*16);
  mset(gcpu_s0->ibuf, 0xff, IBUF_SIZE);
  mset(gcpu_s0->interp_ibuf, 0xff, IBUF_PAGESIZE);
  mset(gcpu_s0->cslocka, 0, 4);
  gcpu_s0->guest_memsize = GUEST_MEMSIZE;
  gcpu_s0->host_imapsize = (GUEST_MEMSIZE/2)*4;
  gcpu_s0->host_bufpsize = (GUEST_MEMSIZE/GUEST_PAGESIZE)*16;

  dim_version            = dim_info[0];
  gcpu_s0->pa_sinsn      = dim_info[3];
  gcpu_s0->pa_pinsn      = dim_info[4];
  gcpu_s0->br_hist_top   = dim_info[5];
  gcpu_s0->br_hist_cp    = dim_info[5];

  gcpu_s0->g1            = 0x0000000000000000LL;
  gcpu_s0->g2            = 0x0000000000000000LL;
  gcpu_s0->g3            = 0x0000000000ffffffLL;
  if (dim_version <= 3) {
    gcpu_s0->g4          = (llu)gcpu_s0->guest_mem;
    gcpu_s0->g5          = (llu)gcpu_s0->host_imap;
  }
  else {
    gcpu_s0->g4          = 0xffffffffffffffffLL;
    gcpu_s0->g5          = 0xffffffffffffffffLL;
    gcpu_s0->g6          = 0xffffffffffffffffLL;
    gcpu_s0->sta_key     = 0x7fffe000;
    gcpu_s0->acc_mask    = 0xffffe1ff;
    for (i=0; i<GTLB_SIZE; i++) {
      gcpu_s0->tlb[i].gs_if = 0x7fffe000ffffe1ffLL;
      gcpu_s0->tlb[i].gs_ld = 0x7fffe000ffffe1ffLL;
      gcpu_s0->tlb[i].gs_st = 0x7fffe000ffffffffLL;
      gcpu_s0->tlb[i].ds_la = ((llu)gcpu_s0->guest_mem|(llu)i << 12)<<32
			     |((llu)gcpu_s0->guest_mem|(llu)i << 12);
    }
  }
  gcpu_s0->g7            = 0x0000000000000800LL; /* IM=0,AM=0,PROG=0 */

  /* init M space */
  gcpu_s0->gr[12] = GUEST_MEMSIZE-256;
  gcpu_s0->gr[13] = GUEST_MEMSIZE-GUEST_STKSIZE;
  gcpu_s0->gr[14] = GUEST_MEMSIZE-128;
  sp = (unsigned char*)gcpu_s0->guest_mem+GUEST_MEMSIZE-GUEST_STKSIZE;
  *(unsigned*)(sp+ 72) = 0x12345678;
  *(unsigned*)(sp+ 76) = GUEST_MEMSIZE-GUEST_STKSIZE+80;
  ep = (unsigned char*)gcpu_s0->guest_mem+GUEST_MEMSIZE-256;
  *(unsigned*)(ep+ 12) = GUEST_MEMSIZE-256;
  *(unsigned*)(ep+116) = GUEST_MEMSIZE-136;
  *(unsigned*)(ep+120) = 0x41000FFE;
  *(unsigned*)(ep+124) = 0x47000FED;
  *(unsigned*)(ep+128) = 0x41000FFF;
  *(unsigned*)(ep+132) = 0x47000FED;

  /* read load-module */
#if 0
#define PROGRAM "test/stan"
  if ((obj_fd = open(PROGRAM, 0)) == -1)
    pr("can't open \"%s\"\n", PROGRAM);
  else {
    addr = 0;
    while ((size = read(obj_fd, gcpu_s0->guest_mem+addr, 8192)) == 8192)
      addr += 8192;
    addr += size;
  }
#else
  for (addr=0; addr < sizeof (mobj); addr+=2)
    *(unsigned short*)(gcpu_s0->guest_mem+addr) = mobj[addr/2];
#endif

  /* write opening message */
  pr("M-on-RISC Dynamically Translating Simulator\n");
  pr("Version %s\n", version());
  pr(" gcpu_s=0x%08.8x\n", gcpu_s0);
  pr(" memory=0x%08.8x memsize=%u\n", gcpu_s0->guest_mem, gcpu_s0->guest_memsize);
  pr(" imap  =0x%08.8x mapsize=%u\n", gcpu_s0->host_imap, gcpu_s0->host_imapsize);
  pr(" ibufpp=0x%08.8x\n", gcpu_s0->host_ibufpp);
  pr(" ibuf  =0x%08.8x i_ibuf=0x%08.8x\n", gcpu_s0->ibuf, gcpu_s0->interp_ibuf);
  pr(" ibuf_psize=%u ibuf_size=%u\n", IBUF_PAGESIZE, IBUF_SIZE);
  pr(" object=0x00000000-0x%08.8x\n", addr-1);
  pr(" stack =0x%08.8x-0x%08.8x\n", GUEST_MEMSIZE-GUEST_STKSIZE, GUEST_MEMSIZE-257);
  pr(" stkov =0x%08.8x-0x%08.8x\n", GUEST_MEMSIZE-256, GUEST_MEMSIZE-1);

  clrtime();
  clrpa();
  for (i=0;; i++) {
    gcpu_s0->g7 &= ~0xffffffffc1ff0000LL;
    asm("ldx %0,%%g7":"=m"(gcpu_s0->g7)::"%g7");
    dim_prog(gcpu_s0);
    asm("stx %%g7,%0":"=m"(gcpu_s0->g7)::"%g7");

#include "../common/control.c"
  }
exit_loop:
  getpa();
  exectime = gettime();
  pr("M stopped at 0x%08.8x (exec_time=%umsec m_step=0x%08.8x)\n", (unsigned)gcpu_s0->g2, exectime, gcpu_s0->pa_minsn);
  pr("gcpu_s0->g1,g7=0x%08.8x_%08.0x,0x%08.8x_%08.0x\n",
     (unsigned)(gcpu_s0->g1>>32), (unsigned)(gcpu_s0->g1),
     (unsigned)(gcpu_s0->g7>>32), (unsigned)(gcpu_s0->g7));

#if 1
  /* display TLB tag & data */
  extract_tlb();
  pr("\n\n======== I-TLB ========\n\n");
  for (i=0; i<ULTRA_TLB_SIZE; i++)
    pr("%b: %08.8x%08.8x %08.8x%08.8x\n", i,
       (int)(i_tlb_tag0[i]>>32),   (int)(i_tlb_tag0[i]),
       (int)(i_tlb_data0[i]>>32),  (int)(i_tlb_data0[i]));
  pr("\n\n======== D-TLB ========\n\n");
  for (i=0; i<ULTRA_TLB_SIZE; i++)
    pr("%b: %08.8x%08.8x %08.8x%08.8x\n", i,
       (int)(d_tlb_tag0[i]>>32),   (int)(d_tlb_tag0[i]),
       (int)(d_tlb_data0[i]>>32),  (int)(d_tlb_data0[i]));
#endif
    
  /* program normal end */
  pr("\n\n======== PROGRAM NORMAL END ========\n\n");
  _exit(0);
}

void *
mset(addr, d, len)
  void *addr;
  int d;
  int len;
{
  char *p = (char*)addr;

  for (;len; len--)
    *p++ = d;

  return(addr);
}

strlen(p)
  char *p;
{
  int len;

  for (len=0; *p++; len++);
  return(len);
}

char *
strcpy(p, q)
  char *p, *q;
{
  for (; *p++ = *q++;);
  return (p);
}

strcmp(p, q)
  char *p, *q;
{
  for (; *p && *q && *p == *q; p++, q++);
  return (*p - *q);
}

strncmp(p, q, n)
  char *p, *q;
  int  n;
{
  int i;

  for (i=1; i<n && *p && *q && *p == *q; i++, p++, q++);
  return (*p - *q);
}

get_device_tree()
{
  unsigned phandle, new_phandle;
  union dev_tree *cur_parent, *cur_peer, *cur_node;
  
  if ((phandle = obp_finddevice("/")) == 0xffffffff)
    pr("obp_find_device: root not found\n");

  cur_parent = (union dev_tree *)0;
  cur_node = dev_treeP++;
  cur_node->node.prop = get_prop(phandle);
  cur_peer = cur_node;
    
 get_device_tree_loop1:
  if ((new_phandle = obp_child(phandle)) != 0) {
    phandle = new_phandle;
    cur_parent = cur_node;
    cur_node = dev_treeP++;
    cur_node->node.prop = get_prop(phandle);
    cur_node->node.parent = cur_parent;
    cur_parent->node.child = cur_node;
    cur_peer   = cur_node;
    goto get_device_tree_loop1;
  }

 get_device_tree_loop2:
  if ((new_phandle = obp_peer(phandle)) != 0) {
    phandle = new_phandle;
    cur_node = dev_treeP++;
    cur_node->node.prop = get_prop(phandle);
    cur_node->node.parent = cur_parent;
    cur_peer->node.peer = cur_node;
    cur_peer = cur_node;
    goto get_device_tree_loop1;
  }

  if ((new_phandle = obp_parent(phandle)) != 0) {
    phandle = new_phandle;
    cur_node = cur_parent;
    cur_parent = cur_parent->node.parent;
    cur_peer = cur_node;
    goto get_device_tree_loop2;
  }
  pr("get_device_tree: dev_tree_size=%d/%d\n", dev_treeP-&dev_tree0[0], DEV_TREE_SIZE);
  pr("get_device_tree: dev_data_size=%d/%d\n", dev_dataP-&dev_data0[0], DEV_DATA_SIZE);
}

search_device_tree(path, val)
     char *path;
     char *val;
{
  int   i, level, leaf;
  union dev_tree *cur, *next, *found;
  char  *p;
#define MAX_PATH_SIZE 1024
#define MAX_PATH_COUNT 32
  char  wp[MAX_PATH_SIZE];
  char  *np[MAX_PATH_COUNT];

  level = 0;
  strcpy(&wp[0], path);
  np[level++] = &wp[0];

  for (p = &wp[0]; *p; p++) {
    if (*p == '/') {
      *p = '\0';
      if (*(p+1))
	np[level++] = p+1;
      else
	break;
    }
  }
  leaf = level - 1;
  np[level] = (char*)0;

  level = 0;
  cur = &dev_tree0[0];

 search_device_tree_loop0:
  if ((found = search_name(cur, np[level])) != (union dev_tree*)0) {
    if (level == leaf - 1) {
      if ((found = search_prop(cur, np[leaf])) != (union dev_tree*)0) {
	for (i=0; i<found->prop.len; i++)
	  *(val+i) = *(found->prop.value+i);
	return(1);
      }
      else {
	pr("search_device_tree: property not found property=\"%s\"\n", path);
	return(0);
      }
    }
    else
      goto search_device_tree_loop1;
  }
  else {
    goto search_device_tree_loop2;
  }

 search_device_tree_loop1:
  if ((next = cur->node.child) != (union dev_tree*)0) {
    level++;
    cur = next;
    goto search_device_tree_loop0;
  }

 search_device_tree_loop2:
  if ((next = cur->node.peer) != (union dev_tree*)0) {
    cur = next;
    goto search_device_tree_loop0;
  }

  pr("search_device_tree: path not found path=\"%s\"\n", path);
  return(0);
}

union dev_tree *
search_name(dev_treeP, name)
     union dev_tree *dev_treeP;
     char *name;
{
  if ((dev_treeP = dev_treeP->node.prop) == (union dev_tree*)0)
    return((union dev_tree*)0);

  for (;; dev_treeP++) {
    if (!strcmp(dev_treeP->prop.name, "name")) {
      if (!strncmp(dev_treeP->prop.value, name, dev_treeP->prop.len))
	return(dev_treeP);
    }
    if (dev_treeP->prop.flag == 3)
      return((union dev_tree*)0);
  }
}

union dev_tree *
search_prop(dev_treeP, prop)
     union dev_tree *dev_treeP;
     char *prop;
{
  if ((dev_treeP = dev_treeP->node.prop) == (union dev_tree*)0)
    return((union dev_tree*)0);

  for (;; dev_treeP++) {
    if (!strcmp(dev_treeP->prop.name, prop))
      return(dev_treeP);
    if (dev_treeP->prop.flag == 3)
      return((union dev_tree*)0);
  }
}

display_device_tree()
{
  int i, level;
  union dev_tree *cur, *next;
  
  level = 0;
  cur = &dev_tree0[0];
  display_node(level, cur);
    
 display_device_tree_loop1:
  if ((next = cur->node.child) != (union dev_tree*)0) {
    level++;
    cur = next;
    for (i=0; i<level-1; i++)
      pr(" |");
    pr(" +--------\n");
    display_node(level, cur);
    goto display_device_tree_loop1;
  }

 display_device_tree_loop2:
  if ((next = cur->node.peer) != (union dev_tree*)0) {
    cur = next;
    for (i=0; i<level-1; i++)
      pr(" |");
    pr(" +--------\n");
    display_node(level, cur);
    goto display_device_tree_loop1;
  }

  if ((next = cur->node.parent) != (union dev_tree*)0) {
    level--;
    cur = next;
    goto display_device_tree_loop2;
  }
}

display_node(level, dev_treeP)
     int level;
     union dev_tree *dev_treeP;
{
  if ((dev_treeP = dev_treeP->node.prop) == (union dev_tree*)0)
    return;

  for (;; dev_treeP++) {
    display_prop(level, dev_treeP);
    if (dev_treeP->prop.flag == 3)
      break;
  }
}

display_prop(level, dev_treeP)
     int level;
     union dev_tree *dev_treeP;
{
  unsigned      i, j, k, l, m;
  unsigned      len = dev_treeP->prop.len;
  unsigned char *p = dev_treeP->prop.value;

  for (i=0; i<level; i++)
    pr(" |");

  pr(" %s", dev_treeP->prop.name);
  for (i=strlen(dev_treeP->prop.name); 32-i>0; i++)
    pr(" ");
  pr("=");

  switch (dev_treeP->prop.ptype) {
  case 0: /* byte */
    for (i=0; i<len; i++,p++)
      pr("%b ", *p);
    pr("\n");
    break;
  case 1: /* int32 */
    for (i=0; i<len; i+=4,p+=4) {
      j = (*p<<24)|(*(p+1)<<16)|(*(p+2)<<8)|*(p+3);
      pr("%08.8x ", j);
    }
    pr("\n");
    break;
  case 2: /* int64 */
    for (i=0; i<len; i+=8,p+=8) {
      j = (* p   <<24)|(*(p+1)<<16)|(*(p+2)<<8)|*(p+3);
      k = (*(p+4)<<24)|(*(p+5)<<16)|(*(p+6)<<8)|*(p+7);
      pr("%08.8x%08.8x ", j, k);
    }
    pr("\n");
    break;
  case 3: /* string */
    pr("\"");
    for (i=0; i<len; i++,p++)
      pr("%c", *p);
    pr("\"\n");
    break;
  case 4: /* range */
    for (i=0; i<len; i+=20,p+=20) {
      j = (* p    <<24)|(*(p+ 1)<<16)|(*(p+ 2)<<8)|*(p+ 3);
      k = (*(p+ 4)<<24)|(*(p+ 5)<<16)|(*(p+ 6)<<8)|*(p+ 7);
      l = (*(p+ 8)<<24)|(*(p+ 9)<<16)|(*(p+10)<<8)|*(p+11);
      m = (*(p+12)<<24)|(*(p+13)<<16)|(*(p+14)<<8)|*(p+15);
      pr("%08.8x%08.8x-%08.8x%08.8x-", j, k, l, m);
      j = (*(p+16)<<24)|(*(p+17)<<16)|(*(p+18)<<8)|*(p+19);
      pr("%08.8x ", j);
    }
    pr("\n");
    break;
  case 5: /* trans */
    for (i=0; i<len; i+=24,p+=24) {
      j = (* p    <<24)|(*(p+ 1)<<16)|(*(p+ 2)<<8)|*(p+ 3);
      k = (*(p+ 4)<<24)|(*(p+ 5)<<16)|(*(p+ 6)<<8)|*(p+ 7);
      l = (*(p+ 8)<<24)|(*(p+ 9)<<16)|(*(p+10)<<8)|*(p+11);
      m = (*(p+12)<<24)|(*(p+13)<<16)|(*(p+14)<<8)|*(p+15);
      pr("%08.8x%08.8x-%08.8x%08.8x-", j, k, l, m);
      j = (*(p+16)<<24)|(*(p+17)<<16)|(*(p+18)<<8)|*(p+19);
      k = (*(p+20)<<24)|(*(p+21)<<16)|(*(p+22)<<8)|*(p+23);
      pr("%08.8x%08.8x ", j, k);
    }
    pr("\n");
    break;
  default: /* not defined */
    pr("display_prop: property_type not defined: ptype=%d\n", dev_treeP->prop.ptype);
    break;
  }
}

struct prop_table {
  char *prop;
  int  ptype;
} prop_table0[] = {
  { "#dtlb-entries",        1 },
  { "#itlb-entries",        1 },
  { "#power-cycles",        3 },
  { "#size-cells",          1 },
  { "address-bits",         1 },
  { "address",              1 },
  { "ansi-terminal?",       3 },
  { "auto-boot?",           3 },
  { "available",            2 },
  { "awidth",               1 },
  { "banner-name",          3 },
  { "boardrev",             1 },
  { "boot-command",         3 },
  { "boot-device",          3 },
  { "boot-file",            3 },
  { "bootargs",             3 },
  { "bootpath",             3 },
  { "breakpoint-trap",      1 },
  { "burst-sizes",          1 },
  { "busmaster-regval",     1 },
  { "cable-selection",      3 },
  { "cdrom",                3 },
  { "character-set",        3 },
  { "chiprev",              1 },
  { "clock-frequency",      1 },
  { "dblbuf",               1 },
  { "dcache-associativity", 1 },
  { "dcache-line-size",     1 },
  { "dcache-size",          1 },
  { "depth",                1 },
  { "device_type",          3 },
  { "diag-device",          3 },
  { "diag-file",            3 },
  { "diag-level",           3 },
  { "diag-switch?",         3 },
  { "disk0",                3 },
  { "disk1",                3 },
  { "disk2",                3 },
  { "disk3",                3 },
  { "disk4",                3 },
  { "disk5",                3 },
  { "disk6",                3 },
  { "disk",                 3 },
  { "dma-model",            3 },
  { "ecache-associativity", 1 },
  { "ecache-line-size",     1 },
  { "ecache-size",          1 },
  { "emulation",            3 },
  { "existing",             2 },
  { "fbmapped",             1 },
  { "fcode-debug?",         3 },
  { "floppy",               3 },
  { "global-data",          1 },
  { "hbporch",              1 },
  { "height",               1 },
  { "hfporch",              1 },
  { "hfreq",                1 },
  { "hm-rev",               1 },
  { "hsync",                1 },
  { "icache-associativity", 1 },
  { "icache-line-size",     1 },
  { "icache-size",          1 },
  { "implementation#",      1 },
  { "input-device",         3 },
  { "interrupts",           1 },
  { "intr",                 1 },
  { "isp-fcode",            3 },
  { "keyboard!",            3 },
  { "keyboard-click?",      3 },
  { "keyboard",             3 },
  { "keymap",               3 },
  { "last-hardware-update", 3 },
  { "linebytes",            1 },
  { "load-base",            3 },
  { "local-mac-address?",   3 },
  { "manufacturer#",        1 },
  { "mask#",                1 },
  { "max-frame-size",       1 },
  { "memory",               1 },
  { "mfg-mode",             3 },
  { "mmu",                  1 },
  { "model",                3 },
  { "name",                 3 },
  { "net-aui",              3 },
  { "net-tpe",              3 },
  { "net",                  3 },
  { "nvramrc",              3 },
  { "oem-banner",           3 },
  { "oem-banner?",          3 },
  { "oem-logo?",            3 },
  { "oscillators",          3 },
  { "output-device",        3 },
  { "page-size",            1 },
  { "pixfreq",              1 },
  { "ranges",               4 },
  { "reg",                  1 },
  { "reset-reason",         3 },
  { "sbus-probe-list",      3 },
  { "screen-#columns",      3 },
  { "screen-#rows",         3 },
  { "screen",               3 },
  { "scsi",                 3 },
  { "security-#badlogins",  3 },
  { "security-mode",        3 },
  { "security-password",    3 },
  { "silent-mode?",         3 },
  { "slot-address-bits",    1 },
  { "sparc-version",        1 },
  { "stdin",                1 },
  { "stdout-#lines",        1 },
  { "stdout",               1 },
  { "system-board-date",    1 },
  { "system-board-serial#", 3 },
  { "tape0",                3 },
  { "tape1",                3 },
  { "tape",                 3 },
  { "tpe-link-test?",       3 },
  { "translations",         5 },
  { "ttya-ignore-cd",       3 },
  { "ttya-mode",            3 },
  { "ttya-rts-dtr-off",     3 },
  { "ttya",                 3 },
  { "ttyb-ignore-cd",       3 },
  { "ttyb-mode",            3 },
  { "ttyb-rts-dtr-off",     3 },
  { "ttyb",                 3 },
  { "up-burst-sizes",       1 },
  { "upa-portid",           1 },
  { "use-nvramrc?",         3 },
  { "vbporch",              1 },
  { "version#",             1 },
  { "version",              3 },
  { "vfporch",              1 },
  { "vfreq",                1 },
  { "vmsize",               1 },
  { "vsync",                1 },
  { "watchdog-reboot?",     3 },
  { "width",                1 },
};

get_ptype(prop)
     char *prop;
{
  int i;

  for (i=0; i<sizeof(prop_table0)/sizeof(struct prop_table); i++) {
    if (!strcmp(prop, prop_table0[i].prop))
      return(prop_table0[i].ptype);
  }
  return(0); /* assume bytes */
}

union dev_tree*
get_prop(phandle)
     unsigned phandle;
{
  unsigned len;
  union dev_tree *top = dev_treeP;
  char *prev = (char*)0;

  while(obp_nextprop(dev_dataP, prev, phandle)) {
    len  = obp_getproplen(dev_dataP, phandle);
    prev = dev_dataP;
    dev_treeP->prop.flag  = 2;
    dev_treeP->prop.ptype = get_ptype(dev_dataP);
    dev_treeP->prop.name  = dev_dataP;

    dev_dataP += 32;
    if (dev_dataP+32+len > &dev_data0[DEV_DATA_SIZE]) {
      pr("get_prop: dev_data0 overflow\n");
      return((union dev_tree*)0);
    }

    obp_getprop(len, dev_dataP, dev_treeP->prop.name, phandle);
    dev_treeP->prop.value = dev_dataP;
    dev_treeP->prop.len   = len;
    dev_dataP += len;

    if (++dev_treeP > &dev_tree0[DEV_TREE_SIZE]) {
      pr("get_prop: dev_tree0 overflow\n");
      return((union dev_tree*)0);
    }
  }
 
  if (prev) {
    (dev_treeP-1)->prop.flag = 3;
    return(top);
  }
  else
    return((union dev_tree*)0);
}

unsigned
open_ttya()
{
  cif_struct0.name     = (llu)(P2UINT)"open";
  cif_struct0.nargs    = 1;
  cif_struct0.nreturns = 1;
  cif_struct0.param[0] = (llu)(P2UINT)"/sbus/zs@f,1100000:a";
  call_rom(&cif_struct0);
  return((unsigned)cif_struct0.param[1]);
}

unsigned
obp_enter()
{
  cif_struct0.name     = (llu)(P2UINT)"enter";
  cif_struct0.nargs    = 0;
  cif_struct0.nreturns = 0;
  call_rom(&cif_struct0);
  return(0);
}

unsigned
obp_finddevice(devname)
     char *devname;
{
  cif_struct0.name     = (llu)(P2UINT)"finddevice";
  cif_struct0.nargs    = 1;
  cif_struct0.nreturns = 1;
  cif_struct0.param[0] = (llu)(P2UINT)devname;
  call_rom(&cif_struct0);
  return((unsigned)cif_struct0.param[1]);
}

unsigned
obp_peer(phandle)
     unsigned phandle;
{
  cif_struct0.name     = (llu)(P2UINT)"peer";
  cif_struct0.nargs    = 1;
  cif_struct0.nreturns = 1;
  cif_struct0.param[0] = (llu)phandle;
  call_rom(&cif_struct0);
  return((unsigned)cif_struct0.param[1]);
}

unsigned
obp_child(phandle)
     unsigned phandle;
{
  cif_struct0.name     = (llu)(P2UINT)"child";
  cif_struct0.nargs    = 1;
  cif_struct0.nreturns = 1;
  cif_struct0.param[0] = (llu)phandle;
  call_rom(&cif_struct0);
  return((unsigned)cif_struct0.param[1]);
}

unsigned
obp_parent(phandle)
     unsigned phandle;
{
  cif_struct0.name     = (llu)(P2UINT)"parent";
  cif_struct0.nargs    = 1;
  cif_struct0.nreturns = 1;
  cif_struct0.param[0] = (llu)phandle;
  call_rom(&cif_struct0);
  return((unsigned)cif_struct0.param[1]);
}

unsigned
obp_getproplen(prop, phandle)
     char *prop; unsigned phandle;
{
  cif_struct0.name     = (llu)(P2UINT)"getproplen";
  cif_struct0.nargs    = 2;
  cif_struct0.nreturns = 1;
  cif_struct0.param[0] = (llu)phandle;
  cif_struct0.param[1] = (llu)(P2UINT)prop;
  call_rom(&cif_struct0);
  return((unsigned)cif_struct0.param[2]);
}

unsigned
obp_getprop(len, buf, prop, phandle)
     unsigned len; char *buf,*prop; unsigned phandle;
{
  cif_struct0.name     = (llu)(P2UINT)"getprop";
  cif_struct0.nargs    = 4;
  cif_struct0.nreturns = 1;
  cif_struct0.param[0] = (llu)phandle;
  cif_struct0.param[1] = (llu)(P2UINT)prop;
  cif_struct0.param[2] = (llu)(P2UINT)buf;
  cif_struct0.param[3] = (llu)len;
  call_rom(&cif_struct0);
  return((unsigned)cif_struct0.param[4]);
}

unsigned
obp_nextprop(buf, prev, phandle)
     char *buf,*prev; unsigned phandle;
{
  cif_struct0.name     = (llu)(P2UINT)"nextprop";
  cif_struct0.nargs    = 3;
  cif_struct0.nreturns = 1;
  cif_struct0.param[0] = (llu)phandle;
  cif_struct0.param[1] = (llu)(P2UINT)prev;
  cif_struct0.param[2] = (llu)(P2UINT)buf;
  call_rom(&cif_struct0);
  return((unsigned)cif_struct0.param[3]);
}

unsigned
obp_set_trap_table(tba)
     unsigned tba;
{
  cif_struct0.name     = (llu)(P2UINT)"SUNW,set-trap-table";
  cif_struct0.nargs    = 1;
  cif_struct0.nreturns = 0;
  cif_struct0.param[0] = (llu)tba;
  call_rom(&cif_struct0);
  return(0);
}

unsigned
obp_itlb_load(index, vaddr, tteh, ttel, ihandle)
     unsigned index, vaddr, tteh, ttel, ihandle;
{
  cif_struct0.name     = (llu)(P2UINT)"call-method";
  cif_struct0.nargs    = 5;
  cif_struct0.nreturns = 1;
  cif_struct0.param[0] = (llu)(P2UINT)"SUNW,itlb-load";
  cif_struct0.param[1] = (llu)ihandle;
  cif_struct0.param[2] = (llu)vaddr;
  cif_struct0.param[3] = (llu)(tteh)<<32|(llu)(ttel);
  cif_struct0.param[4] = (llu)index;
  call_rom(&cif_struct0);
  return(0);
}

unsigned
obp_dtlb_load(index, vaddr, tteh, ttel, ihandle)
     unsigned index, vaddr, tteh, ttel, ihandle;
{
  cif_struct0.name     = (llu)(P2UINT)"call-method";
  cif_struct0.nargs    = 5;
  cif_struct0.nreturns = 1;
  cif_struct0.param[0] = (llu)(P2UINT)"SUNW,dtlb-load";
  cif_struct0.param[1] = (llu)ihandle;
  cif_struct0.param[2] = (llu)vaddr;
  cif_struct0.param[3] = (llu)(tteh)<<32|(llu)(ttel);
  cif_struct0.param[4] = (llu)index;
  call_rom(&cif_struct0);
  return(0);
}

int   old_pstate;
int   old_context;

call_rom(cif_structP)
  struct cif_struct *cif_structP;
{
#if 1
  asm("add    %g0,0x8,%l1");
  asm("ldxa   [%l1]0x58,%l0"); /* Save Primary Context */
  asm("st     %%l0,%0":"=m"(old_context)::"%l0");
  asm("stxa   %g0,[%l1]0x58"); /* Primary Context = 0 */
  asm("membar #Sync");
#endif

  asm("rdpr %pstate,%l0");
  asm("st   %%l0,%0":"=m"(old_pstate)::"%l0"); /* Save PSTATE */
  asm("andn %l0,0xa,%l0");                     /* AM=0 IE=0 */
  asm("wrpr %l0,0,%pstate");

  asm("sllx %fp,32,%fp");
  asm("srlx %fp,32,%fp");
  asm("sllx %sp,32,%sp");
  asm("srlx %sp,32,%sp");
  asm("sub  %sp,2047,%sp");

  (*call_obp)(cif_structP);

  asm("add  %sp,2047,%sp");
  asm("sllx %fp,32,%fp");
  asm("srlx %fp,32,%fp");
  asm("sllx %sp,32,%sp");
  asm("srlx %sp,32,%sp");

  asm("ld   %0,%%l0":"=m"(old_pstate)::"%l0"); /* Restore PSTATE */
  asm("wrpr %l0,0,%pstate");

#if 1
  asm("ld     %0,%%l0":"=m"(old_context)::"%l0");
  asm("add    %g0,0x8,%l1");
  asm("stxa   %l0,[%l1]0x58"); /* Restore Primary Context */
  asm("membar #Sync");
#endif
}

unsigned pcr0[2];
unsigned pcr1[2];

clrpa()
{
#ifndef WITHOS
  asm("sethi %hi(pcr0),%l0");
  asm("or    %l0,%lo(pcr0),%l0");
  asm("add   %g0,0,%l2");/* S1 */
  asm("add   %g0,1,%l3");/* S0 */
  asm("sll   %l2,11,%l2");
  asm("sll   %l3,4,%l3");
  asm("or    %l2,%l3,%l2");
  asm("wr    %l2,7,%asr16");
  asm("rd    %asr17,%l1");
  asm("st    %l1,[%l0+0]");
  asm("srlx  %l1,32,%l1");
  asm("st    %l1,[%l0+4]");
#endif
}

getpa()
{
#ifndef WITHOS
  int i;
  llu pstate, dcr;

  asm("sethi %hi(pcr1),%l0");
  asm("or    %l0,%lo(pcr1),%l0");
  asm("rd    %asr17,%l1");
  asm("st    %l1,[%l0+0]");
  asm("srlx  %l1,32,%l1");
  asm("st    %l1,[%l0+4]");

  pr("instr=0x%08.8x cycle=0x%08.8x\n", pcr1[0]-pcr0[0], pcr1[1]-pcr0[1]);

  asm("rdpr %%pstate,%%l0":::"%l0");
  asm("stx  %%l0,%0"      :"=m"(pstate)::"%l0");
  asm("rd   %%asr18,%%l0" :::"%l0");
  asm("stx  %%l0,%0"      :"=m"(dcr)::"%l0");

  pr("pstate=0x%08.8x_%08.0x,dcr=0x%08.8x_%08.0x\n",
     (unsigned)(pstate>>32), (unsigned)(pstate),
     (unsigned)(dcr   >>32), (unsigned)(dcr));
#endif
}

char *
version()
{
  char *i;
  extern char RcsId[];

  for (i=RcsId; *i && *i!=' '; i++);
  for (       ; *i && *i==' '; i++);
  for (       ; *i && *i!=' '; i++);
  for (       ; *i && *i==' '; i++);
  return(i);
}

