
/* start2.s 1995/7/18 */

/* M-on-RISC Dynamically Translating Simulator */
/*       Copyright (C) 1995 by FUJITSU LIMITED */
/*                 Primary writer: Y.Nakashima */
/*          nakashim@pine.mfd.cs.fujitsu.co.jp */

	.file	"start2.s"
	.section ".text"
	.align	16
	.global	_start
_start:
!
! Init Privileged Registers
!	 0: TPC		 1: TNPC	 2: TSTATE	 3: TT      
!	 4: TICK	 5: TBA		 6: PSTATE	 7: TL             
!	 8: PIL		 9: CWP		10: CANSAVE	11: CANRESTORE
!	12: CLEANWIN	13: OTHERWIN	14: WSTATE	15: FQ            
!	16-30:reserved					31: VER
!
	rdpr	%ver,%l0		!
	and	%l0,0x1f,%l0		! extract MAXWIN
	add	%l0,1,%l1		! MAXWIN+1   -> %l1
	sub	%l0,1,%l2		! MAXWIN-1   -> %l2
	wrpr	%l1,0,%cleanwin		! %cleanwin   = MAXWIN+1
	wrpr	%l2,0,%cansave		! %cansave    = MAXWIN-1
	wrpr	%g0,0,%tick		! %tick       = 0
	wrpr	%g0,0xc,%pstate		! %pstate     = AM,PRIV
	wrpr	%g0,0,%cwp		! %cwp        = 0
	wrpr	%g0,0,%canrestore	! %canrestore = 0
	wrpr	%g0,0,%otherwin		! %otherwin   = 0
	wrpr	%g0,0,%wstate		! %wstate     = 0

!
! Init Ancillary State Registers
!	 0: Y		 1: --		 2: CCR		 3: ASI
!	 4: TICK(ultra)	 5: PC(ultra)	 6: FPRS	 7: --
!	 8-15: reserved
!	16: PCR(ultra)	17: PIC(ultra)	18: DCR(ultra)	19: GSR(ultra)
!	20: SET_SOFTINT	 (ultra)
!	21: CLEAR_SOFTINT(ultra)
!	22: SOFTINT	 (ultra)
!	23: TICK_CMPR	 (ultra)
!	24-31: reserved
!
	wr	%g0,1,%asr18		! %dcr = 1

!
! DAT off
!
!	ldxa	[%g0]0x45,%l0		! load LCR(va=0,asi=0x45)
!	andn	%l0,0xc,%l0		! clear DM,IM
!	stxa	%l0,[%g0]0x45		! store LCR(va=0,asi=0x45)
!	membar	#Sync			!
	
!
! Set I/D-TLB entry #0
!
	add	%g0,0x30,%l1		!
	add	%g0,0x0,%l2		!

	sethi	%hi(tlbi00),%l0		!
	or	%l0,%lo(tlbi00),%l0	!
	ldx	[%l0],%l3		!
	ldx	[%l0+8],%l4		!
!	stxa	%l3,[%l1]0x50		! I-TLB tag access reg.
!	membar	#Sync			!
!	stxa	%l4,[%l2]0x55		! I-TLB-data(va=0,asi=0x55)
!	membar	#Sync			!

	sethi	%hi(tlbd00),%l0		!
	or	%l0,%lo(tlbd00),%l0	!
	ldx	[%l0],%l3		!
	ldx	[%l0+8],%l4		!
!	stxa	%l3,[%l1]0x58		! D-TLB tag access reg.
!	membar	#Sync			!
!	stxa	%l4,[%l2]0x5D		! D-TLB-data(va=0,asi=0x5D)
!	membar	#Sync			!

!
! Flush I/D-TLB entries (63-1)
!
	add	%g0,0x30,%l1		!
	add	%g0,-1,%l3		!
	add	%g0,0x1f8,%l2		! init counter
_start_clr_tlb_loop1:			!
	stxa	%g0,[%l2]0x55		! I-TLB-data(va=0-0x1f8,asi=0x55)
	membar	#Sync			!
	stxa	%l3,[%l1]0x50		! I-TLB tag access reg.
	membar	#Sync			!
	stxa	%g0,[%l2]0x5D		! D-TLB-data(va=0-0x1f8,asi=0x5D)
	membar	#Sync			!
	stxa	%l3,[%l1]0x58		! D-TLB tag access reg.
	membar	#Sync			!
	subcc	%l2,0x008,%g0		!
	bne	_start_clr_tlb_loop1	!
	sub	%l2,8,%l2		!

!
! Set I/D-TLB entry #63
!
	sethi	%hi(tlbe63),%l0		!
	or	%l0,%lo(tlbe63),%l0	!
	add	%g0,0x30,%l1		!
	add	%g0,0x1f8,%l2		!
	ldx	[%l0],%l3		!
	ldx	[%l0+8],%l4		!
!	stxa	%l3,[%l1]0x50		! I-TLB tag access reg.
!	membar	#Sync			!
!	stxa	%l4,[%l2]0x55		! I-TLB-data(va=0-0x1f8,asi=0x55)
!	membar	#Sync			!
!	stxa	%l3,[%l1]0x58		! D-TLB tag access reg.
!	membar	#Sync			!
!	stxa	%l4,[%l2]0x5D		! D-TLB-data(va=0-0x1f8,asi=0x5D)
!	membar	#Sync			!

!
! Flush I/D-TLB entries (62-1)
!
	add	%g0,0x30,%l1		!
	add	%g0,-1,%l3		!
	add	%g0,0x1f0,%l2		! init counter
_start_clr_tlb_loop2:			!
	stxa	%g0,[%l2]0x55		! I-TLB-data(va=0-0x1f8,asi=0x55)
	membar	#Sync			!
	stxa	%l3,[%l1]0x50		! I-TLB tag access reg.
	membar	#Sync			!
	stxa	%g0,[%l2]0x5D		! D-TLB-data(va=0-0x1f8,asi=0x5D)
	membar	#Sync			!
	stxa	%l3,[%l1]0x58		! D-TLB tag access reg.
	membar	#Sync			!
	subcc	%l2,0x008,%g0		!
	bne	_start_clr_tlb_loop2	!
	sub	%l2,8,%l2		!

!
! Set I/D-TLB entries (62-60)
!
	sethi	%hi(tlbe62),%l0		!
	or	%l0,%lo(tlbe62),%l0	!
	add	%g0,0x30,%l1		!
	add	%g0,0x1f0,%l2		!
_start_set_tlb_loop2:			!
	ldx	[%l0],%l3		!
	ldx	[%l0+8],%l4		!
!	stxa	%l3,[%l1]0x50		! I-TLB tag access reg.
!	membar	#Sync			!
!	stxa	%l4,[%l2]0x55		! I-TLB-data(va=0-0x1f8,asi=0x55)
!	membar	#Sync			!
!	stxa	%l3,[%l1]0x58		! D-TLB tag access reg.
!	membar	#Sync			!
!	stxa	%l4,[%l2]0x5D		! D-TLB-data(va=0-0x1f8,asi=0x5D)
!	membar	#Sync			!
	subcc	%l2,0x1e0,%g0		!
	sub	%l2,8,%l2		!
	bne	_start_set_tlb_loop2	!
	add	%l0,16,%l0		! update pointer
	
!
! Flush I/D-TLB entries (59-1)
!
	add	%g0,0x30,%l1		!
	add	%g0,-1,%l3		!
	add	%g0,0x1d8,%l2		! init counter
_start_clr_tlb_loop3:			!
	stxa	%g0,[%l2]0x55		! I-TLB-data(va=0-0x1f8,asi=0x55)
	membar	#Sync			!
	stxa	%l3,[%l1]0x50		! I-TLB tag access reg.
	membar	#Sync			!
	stxa	%g0,[%l2]0x5D		! D-TLB-data(va=0-0x1f8,asi=0x5D)
	membar	#Sync			!
	stxa	%l3,[%l1]0x58		! D-TLB tag access reg.
	membar	#Sync			!
	subcc	%l2,0x008,%g0		!
	bne	_start_clr_tlb_loop3	!
	sub	%l2,8,%l2		!

!
! Set D-TLB entries (59-44)
!
	sethi	%hi(tlbe59),%l0		!
	or	%l0,%lo(tlbe59),%l0	!
	add	%g0,0x30,%l1		!
	add	%g0,0x1d8,%l2		!
_start_set_tlb_loop3:			!
	ldx	[%l0],%l3		!
	ldx	[%l0+8],%l4		!
!	stxa	%l3,[%l1]0x58		! D-TLB tag access reg.
!	membar	#Sync			!
!	stxa	%l4,[%l2]0x5D		! D-TLB-data(va=0-0x1f8,asi=0x5D)
!	membar	#Sync			!
	subcc	%l2,0x160,%g0		!
	sub	%l2,8,%l2		!
	bne	_start_set_tlb_loop3	!
	add	%l0,16,%l0		! update pointer

!
! DAT on
!
!	ldxa	[%g0]0x45,%l0		! load LCR(va=0,asi=0x45)
!	or	%l0,0xc,%l0		! set DM,IM
!	stxa	%l0,[%g0]0x45		! store LCR(va=0,asi=0x45)
!	membar	#Sync			!

!
! Reset Privileged Registers
!	 0: TPC		 1: TNPC	 2: TSTATE	 3: TT      
!	 4: TICK	 5: TBA		 6: PSTATE	 7: TL             
!	 8: PIL		 9: CWP		10: CANSAVE	11: CANRESTORE
!	12: CLEANWIN	13: OTHERWIN	14: WSTATE	15: FQ            
!	16-30:reserved					31: VER
!
	wrpr	%g0,0,%tick		! %tick       = 0
	wrpr	%g0,0xe,%pstate		! %pstate     = AM,PRIV,IE

!
! Initialize %sp
!
	sethi	%hi(0x007fff00),%sp	! 0-0x7fffff: initial program area
	or	%sp,%lo(0x007fff00),%sp	!
	add	%o4,0,%o0		! cif_service_handler -> param0
	ba,a	main			!
	nop				!

	.section ".text"
	.align	16
	.global	_initdata
_initdata:
!
! TLB data
!
tlbe63:	.quad	0x0000000000000000,0xE000020000000077
tlbe62:	.quad	0x0000000000400000,0xE000020000400077
tlbe61:	.quad	0x0000000000800000,0xE000020000800077
tlbe60:	.quad	0x0000000000C00000,0xE000020000C00077

tlbe59:	.quad	0x0000000004000000,0xE000020004000077
tlbe58:	.quad	0x0000000004400000,0xE000020004400077
tlbe57:	.quad	0x0000000004800000,0xE000020004800077
tlbe56:	.quad	0x0000000004C00000,0xE000020004C00077
tlbe55:	.quad	0x0000000005000000,0xE000020005000077
tlbe54:	.quad	0x0000000005400000,0xE000020005400077
tlbe53:	.quad	0x0000000005800000,0xE000020005800077
tlbe52:	.quad	0x0000000005C00000,0xE000020005C00077
tlbe51:	.quad	0x0000000006000000,0xE000020006000077
tlbe50:	.quad	0x0000000006400000,0xE000020006400077
tlbe49:	.quad	0x0000000006800000,0xE000020006800077
tlbe48:	.quad	0x0000000006C00000,0xE000020006C00077
tlbe47:	.quad	0x0000000007000000,0xE000020007000077
tlbe46:	.quad	0x0000000007400000,0xE000020007400077
tlbe45:	.quad	0x0000000007800000,0xE000020007800077
tlbe44:	.quad	0x0000000007C00000,0xE000020007C00077

tlbi00:	.quad	0x00000000F0000000,0xC0006E0033F80064
tlbd00:	.quad	0xFFFFFFFFFFFFC000,0x8000000033F6E076

/**/
