
static char RcsId[] =
"$Id: ip.c,v 1.9 1997/06/05 07:17:32 nakashim Exp nakashim $";

/* ip.c 1996/3/22 */

/* SPARC Integer Instruction Simulator         */
/*       Copyright (C) 1995 by FUJITSU LIMITED */
/*                 Primary writer: Y.Nakashima */
/*          nakashim@pine.mfd.cs.fujitsu.co.jp */

#include <stdio.h>
#include <sys/times.h>
#include <unistd.h>
#include <sys/file.h>
#include "sdef.h"

int	i_add(), i_addcc(), i_addc(), i_addccc(), i_sub(), i_subcc();
int	i_subc(), i_subccc(), i_sdiv(), i_sdivcc(), i_smul(), i_smulcc();
int	i_udiv(), i_udivcc(), i_umul(), i_umulcc(), i_and(), i_andcc();
int     i_mulx(), i_sdivx(), i_udivx();
int	i_andn(), i_andncc(), i_or(), i_orcc(), i_orn(), i_orncc();
int	i_xor(), i_xorcc(), i_xnor(), i_xnorcc(), i_sll(), i_srl();
int	i_sra(), i_sethi(), i_save(), i_restore(), i_ldsb(), i_ldsh();
int     i_ldsw(), i_ldx(), i_movcc(), i_movr();
int	i_ldub(), i_lduh(), i_lduw(), i_ldd(), i_lduwa(), i_stb(), i_sth();
int	i_stx(), i_stw(), i_std(), i_ldstub(), i_bicc(), i_bpcc(), i_bpr();
int     i_call(), i_jmpl(), i_return();
int	i_ticc(), i_rdy(), i_wry(), i_illtrap(), i_flush(), i_xxx();

struct sparc_op insn00[] = {
    { "illtrap",i_illtrap },	/* 0x0 */
    { "bpcc",	i_bpcc },	/* 0x1 */
    { "bicc",	i_bicc },	/* 0x2 */
    { "bpr",	i_bpr },	/* 0x3 */
    { "sethi",	i_sethi },	/* 0x4 */
    { "xxx",	i_xxx },	/* 0x5 */
    { "xxx",	i_xxx },	/* 0x6 */
    { "xxx",	i_xxx },	/* 0x7 */
};

struct sparc_op insn01[] = {
    { "call",	i_call },	/* 0x0 */
};

struct sparc_op insn10[] = {
    { "add",	i_add },	/* 0x00 */
    { "and",	i_and },	/* 0x01 */
    { "or",	i_or },		/* 0x02 */
    { "xor",	i_xor },	/* 0x03 */
    { "sub",	i_sub },	/* 0x04 */
    { "andn",	i_andn },	/* 0x05 */
    { "orn",	i_orn },	/* 0x06 */
    { "xnor",	i_xnor },	/* 0x07 */
    { "addc",	i_addc },	/* 0x08 */
    { "mulx",	i_mulx },	/* 0x09 */
    { "umul",	i_umul },	/* 0x0a */
    { "smul",	i_smul },	/* 0x0b */
    { "subc",	i_subc },	/* 0x0c */
    { "udivx",	i_udivx },	/* 0x0d */
    { "udiv",	i_udiv },	/* 0x0e */
    { "sdiv",	i_sdiv },	/* 0x0f */
    { "addcc",	i_addcc },	/* 0x10 */
    { "andcc",	i_andcc },	/* 0x11 */
    { "orcc",	i_orcc },	/* 0x12 */
    { "xorcc",	i_xorcc },	/* 0x13 */
    { "subcc",	i_subcc },	/* 0x14 */
    { "andncc",	i_andncc },	/* 0x15 */
    { "orncc",	i_orncc },	/* 0x16 */
    { "xnorcc",	i_xnorcc },	/* 0x17 */
    { "addccc",	i_addccc },	/* 0x18 */
    { "xxx",	i_xxx },	/* 0x19 */
    { "umulcc",	i_umulcc },	/* 0x1a */
    { "smulcc",	i_smulcc },	/* 0x1b */
    { "subccc",	i_subccc },	/* 0x1c */
    { "xxx",	i_xxx },	/* 0x1d */
    { "udivcc",	i_udivcc },	/* 0x1e */
    { "sdivcc",	i_sdivcc },	/* 0x1f */
    { "xxx",	i_xxx },	/* 0x20 */
    { "xxx",	i_xxx },	/* 0x21 */
    { "xxx",	i_xxx },	/* 0x22 */
    { "xxx",	i_xxx },	/* 0x23 */
    { "xxx",	i_xxx },	/* 0x24 */
    { "sll",	i_sll },	/* 0x25 */
    { "srl",	i_srl },	/* 0x26 */
    { "sra",	i_sra },	/* 0x27 */
    { "rdy",	i_rdy },	/* 0x28 */
    { "xxx",	i_xxx },	/* 0x29 */
    { "xxx",	i_xxx },	/* 0x2a */
    { "xxx",	i_xxx },	/* 0x2b */
    { "movcc",	i_movcc },	/* 0x2c */
    { "sdivx",	i_sdivx },	/* 0x2d */
    { "xxx",	i_xxx },	/* 0x2e */
    { "movr",	i_movr },	/* 0x2f */
    { "wry",	i_wry },	/* 0x30 */
    { "xxx",	i_xxx },	/* 0x31 */
    { "xxx",	i_xxx },	/* 0x32 */
    { "xxx",	i_xxx },	/* 0x33 */
    { "xxx",	i_xxx },	/* 0x34 */
    { "xxx",	i_xxx },	/* 0x35 */
    { "xxx",	i_xxx },	/* 0x36 */
    { "xxx",	i_xxx },	/* 0x37 */
    { "jmpl",	i_jmpl },	/* 0x38 */
    { "return",	i_return },	/* 0x39 */
    { "ticc",	i_ticc },	/* 0x3a */
    { "flush",	i_flush },	/* 0x3b */
    { "save",	i_save },	/* 0x3c */
    { "restore",i_restore },	/* 0x3d */
    { "xxx",	i_xxx },	/* 0x3e */
    { "xxx",	i_xxx },	/* 0x3f */
};

struct sparc_op insn11[] = {
    { "lduw",	i_lduw },	/* 0x00 */
    { "ldub",	i_ldub },	/* 0x01 */
    { "lduh",	i_lduh },	/* 0x02 */
    { "ldd",	i_ldd },	/* 0x03 */
    { "stw",	i_stw },	/* 0x04 */
    { "stb",	i_stb },	/* 0x05 */
    { "sth",	i_sth },	/* 0x06 */
    { "std",	i_std },	/* 0x07 */
    { "ldsw",	i_ldsw },	/* 0x08 */
    { "ldsb",	i_ldsb },	/* 0x09 */
    { "ldsh",	i_ldsh },	/* 0x0a */
    { "ldx",	i_ldx },	/* 0x0b */
    { "xxx",	i_xxx },	/* 0x0c */
    { "ldstub",	i_ldstub },	/* 0x0d */
    { "stx",	i_stx },	/* 0x0e */
    { "xxx",	i_xxx },	/* 0x0f */
    { "lduwa",	i_lduwa },	/* 0x10 */
    { "xxx",	i_xxx },	/* 0x11 */
    { "xxx",	i_xxx },	/* 0x12 */
    { "xxx",	i_xxx },	/* 0x13 */
    { "xxx",	i_xxx },	/* 0x14 */
    { "xxx",	i_xxx },	/* 0x15 */
    { "xxx",	i_xxx },	/* 0x16 */
    { "xxx",	i_xxx },	/* 0x17 */
    { "xxx",	i_xxx },	/* 0x18 */
    { "xxx",	i_xxx },	/* 0x19 */
    { "xxx",	i_xxx },	/* 0x1a */
    { "xxx",	i_xxx },	/* 0x1b */
    { "xxx",	i_xxx },	/* 0x1c */
    { "xxx",	i_xxx },	/* 0x1d */
    { "xxx",	i_xxx },	/* 0x1e */
    { "xxx",	i_xxx },	/* 0x1f */
    { "xxx",	i_xxx },	/* 0x20 */
    { "xxx",	i_xxx },	/* 0x21 */
    { "xxx",	i_xxx },	/* 0x22 */
    { "xxx",	i_xxx },	/* 0x23 */
    { "xxx",	i_xxx },	/* 0x24 */
    { "xxx",	i_xxx },	/* 0x25 */
    { "xxx",	i_xxx },	/* 0x26 */
    { "xxx",	i_xxx },	/* 0x27 */
    { "xxx",	i_xxx },	/* 0x28 */
    { "xxx",	i_xxx },	/* 0x29 */
    { "xxx",	i_xxx },	/* 0x2a */
    { "xxx",	i_xxx },	/* 0x2b */
    { "xxx",	i_xxx },	/* 0x2c */
    { "xxx",	i_xxx },	/* 0x2d */
    { "xxx",	i_xxx },	/* 0x2e */
    { "xxx",	i_xxx },	/* 0x2f */
    { "xxx",	i_xxx },	/* 0x30 */
    { "xxx",	i_xxx },	/* 0x31 */
    { "xxx",	i_xxx },	/* 0x32 */
    { "xxx",	i_xxx },	/* 0x33 */
    { "xxx",	i_xxx },	/* 0x34 */
    { "xxx",	i_xxx },	/* 0x35 */
    { "xxx",	i_xxx },	/* 0x36 */
    { "xxx",	i_xxx },	/* 0x37 */
    { "xxx",	i_xxx },	/* 0x38 */
    { "xxx",	i_xxx },	/* 0x39 */
    { "xxx",	i_xxx },	/* 0x3a */
    { "xxx",	i_xxx },	/* 0x3b */
    { "xxx",	i_xxx },	/* 0x3c */
    { "xxx",	i_xxx },	/* 0x3d */
    { "xxx",	i_xxx },	/* 0x3e */
    { "xxx",	i_xxx },	/* 0x3f */
};

int i_add(i) unsigned i;
{
  pc = npc;
  npc += 4;
  *m[i>>25&31] = *m[i>>14&31] + ((i&0x2000)?(ll)((int)(i<<19)>>19):*m[i&31]);
  *m[0] = 0;
  return(0);
}

int i_addcc(i) unsigned i;
{
  llu      S1, S2, D;
  unsigned s1, s2, d;

  pc = npc;
  npc += 4;
  S1 = *m[i>>14&31];
  S2 = (i&0x2000)?(ll)((int)(i<<19)>>19):*m[i&31];
  *m[i>>25&31] = D = S1 + S2;
  *m[0] = 0;
  s1 = S1; s2 = S2; d = D;
  cc_n = d>>31;
  cc_z = d==0;
  cc_v = (s1>>31&&s2>>31&&!(d>>31)) || (!(s1>>31)&&!(s2>>31)&&d>>31);
  cc_c = (s1>>31&&s2>>31) || (!(d>>31)&&(s1>>31||s2>>31));
  cc_N = D>>63;
  cc_Z = D==0;
  cc_V = (S1>>63&&S2>>63&&!(D>>63)) || (!(S1>>63)&&!(S2>>63)&&D>>63);
  cc_C = (S1>>63&&S2>>63) || (!(D>>63)&&(S1>>63||S2>>63));
  return(0);
}

int i_addc(i) unsigned i;
{
  pc = npc;
  npc += 4;
  *m[i>>25&31] = *m[i>>14&31] + ((i&0x2000)?(ll)((int)(i<<19)>>19):*m[i&31]) + cc_c;
  *m[0] = 0;
  return(0);
}

int i_addccc(i) unsigned i;
{
  llu       S1, S2, D;
  unsigned  s1, s2, d;

  pc = npc;
  npc += 4;
  S1 = *m[i>>14&31];
  S2 = (i&0x2000)?(ll)((int)(i<<19)>>19):*m[i&31];
  *m[i>>25&31] = D = S1 + S2 + cc_c;
  *m[0] = 0;
  s1 = S1; s2 = S2; d = D;
  cc_n = d>>31;
  cc_z = d==0;
  cc_v = (s1>>31&&s2>>31&&!(d>>31)) || (!(s1>>31)&&!(s2>>31)&&d>>31);
  cc_c = (s1>>31&&s2>>31) || (!(d>>31)&&(s1>>31||s2>>31));
  cc_N = D>>63;
  cc_Z = D==0;
  cc_V = (S1>>63&&S2>>63&&!(D>>63)) || (!(S1>>63)&&!(S2>>63)&&D>>63);
  cc_C = (S1>>63&&S2>>63) || (!(D>>63)&&(S1>>63||S2>>63));
  return(0);
}

int i_sub(i) unsigned i;
{
  pc = npc;
  npc += 4;
  *m[i>>25&31] = *m[i>>14&31] - ((i&0x2000)?(ll)((int)(i<<19)>>19):*m[i&31]);
  *m[0] = 0;
  return(0);
}

int i_subcc(i) unsigned i;
{
  llu      S1, S2, D;
  unsigned s1, s2, d;

  pc = npc;
  npc += 4;
  S1 = *m[i>>14&31];
  S2 = (i&0x2000)?(ll)((int)(i<<19)>>19):*m[i&31];
  *m[i>>25&31] = D = S1 - S2;
  *m[0] = 0;
  s1 = S1; s2 = S2; d = D;
  cc_n = d>>31;
  cc_z = d==0;
  cc_v = (s1>>31&&!(s2>>31)&&!(d>>31)) || (!(s1>>31)&&s2>>31&&d>>31);
  cc_c = (!(s1>>31)&&s2>>31) || (d>>31&&(!(s1>>31)||s2>>31));
  cc_N = D>>63;
  cc_Z = D==0;
  cc_V = (S1>>63&&!(S2>>63)&&!(D>>63)) || (!(S1>>63)&&S2>>63&&D>>63);
  cc_C = (!(S1>>63)&&S2>>63) || (D>>63&&(!(S1>>63)||S2>>63));
  return(0);
}

int i_subc(i) unsigned i;
{
  pc = npc;
  npc += 4;
  *m[i>>25&31] = *m[i>>14&31] - ((i&0x2000)?(ll)((int)(i<<19)>>19):*m[i&31]) - cc_c;
  *m[0] = 0;
  return(0);
}

int i_subccc(i) unsigned i;
{
  llu      S1, S2, D;
  unsigned s1, s2, d;

  pc = npc;
  npc += 4;
  S1 = *m[i>>14&31];
  S2 = (i&0x2000)?(ll)((int)(i<<19)>>19):*m[i&31];
  *m[i>>25&31] = D = S1 - S2 - cc_c;
  *m[0] = 0;
  s1 = S1; s2 = S2; d = D;
  cc_n = d>>31;
  cc_z = d==0;
  cc_v = (s1>>31&&!(s2>>31)&&!(d>>31)) || (!(s1>>31)&&s2>>31&&d>>31);
  cc_c = (!(s1>>31)&&s2>>31) || (d>>31&&(!(s1>>31)||s2>>31));
  cc_N = D>>63;
  cc_Z = D==0;
  cc_V = (S1>>63&&!(S2>>63)&&!(D>>63)) || (!(S1>>63)&&S2>>63&&D>>63);
  cc_C = (!(S1>>63)&&S2>>63) || (D>>63&&(!(S1>>63)||S2>>63));
  return(0);
}

int i_sdiv(i) unsigned i;
{
  llu S1, S2;

  pc = npc;
  npc += 4;
  S1 = (llu)(unsigned)*m[i>>14&31];
  S2 = (i&0x2000)?(ll)((int)(i<<19)>>19):*m[i&31];
  *m[i>>25&31] = (ll)(int)((ll)(y<<32|S1)/(ll)(int)S2);
  *m[0] = 0;
  return(0);
}

int i_sdivcc(i) unsigned i;
{
  llu S1, S2;
  ll  D;
  unsigned d;

  pc = npc;
  npc += 4;
  S1 = (llu)(unsigned)*m[i>>14&31];
  S2 = (i&0x2000)?(ll)((int)(i<<19)>>19):*m[i&31];
  D = (ll)(y<<32|S1)/(ll)(int)S2;
  *m[i>>25&31] = (ll)(int)D;
  *m[0] = 0;
  d = D;
  cc_n = d>>31;
  cc_z = d==0;
  cc_v = D!=(ll)(int)d;
  cc_c = 0;
  cc_N = D>>63;
  cc_Z = D==0;
  cc_V = 0;
  cc_C = 0;
  return(0);
}

int i_udiv(i) unsigned i;
{
  llu S1, S2;

  pc = npc;
  npc += 4;
  S1 = (llu)(unsigned)*m[i>>14&31];
  S2 = (i&0x2000)?(ll)((int)(i<<19)>>19):*m[i&31];
  *m[i>>25&31] = (llu)(unsigned)((llu)(y<<32|S1)/(llu)(unsigned)S2);
  *m[0] = 0;
  return(0);
}

int i_udivcc(i) unsigned i;
{
  llu S1, S2;
  llu D;
  unsigned d;

  pc = npc;
  npc += 4;
  S1 = (llu)(unsigned)*m[i>>14&31];
  S2 = (i&0x2000)?(ll)((int)(i<<19)>>19):*m[i&31];
  D = (llu)(y<<32|S1)/(llu)(unsigned)S2;
  *m[i>>25&31] = (llu)(unsigned)D;
  *m[0] = 0;
  d = D;
  cc_n = d>>31;
  cc_z = d==0;
  cc_v = D!=(llu)(unsigned)d;
  cc_c = 0;
  cc_N = D>>63;
  cc_Z = D==0;
  cc_V = 0;
  cc_C = 0;
  return(0);
}

int i_sdivx(i) unsigned i;
{
  ll S1, S2;

  pc = npc;
  npc += 4;
  S1 = *m[i>>14&31];
  S2 = (i&0x2000)?(ll)((int)(i<<19)>>19):*m[i&31];
  *m[i>>25&31] = S1/S2;
  *m[0] = 0;
  return(0);
}

int i_udivx(i) unsigned i;
{
  llu S1, S2;

  pc = npc;
  npc += 4;
  S1 = *m[i>>14&31];
  S2 = (i&0x2000)?(ll)((int)(i<<19)>>19):*m[i&31];
  *m[i>>25&31] = S1/S2;
  *m[0] = 0;
  return(0);
}

int i_smul(i) unsigned i;
{
  llu S1, S2;
  ll D;

  pc = npc;
  npc += 4;
  S1 = (llu)(unsigned)*m[i>>14&31];
  S2 = (i&0x2000)?(ll)((int)(i<<19)>>19):*m[i&31];
  D = (ll)(int)S1*(ll)(int)S2;
  y = (llu)(unsigned)(D>>32);
  *m[i>>25&31] = D;
  *m[0] = 0;
  return(0);
}

int i_smulcc(i) unsigned i;
{
  llu S1, S2;
  ll D;
  unsigned d;

  pc = npc;
  npc += 4;
  S1 = (llu)(unsigned)*m[i>>14&31];
  S2 = (i&0x2000)?(ll)((int)(i<<19)>>19):*m[i&31];
  D = (ll)(int)S1*(ll)(int)S2;
  y = (llu)(unsigned)(D>>32);
  *m[i>>25&31] = D;
  *m[0] = 0;
  d = D;
  cc_n = d>>31;
  cc_z = d==0;
  cc_v = 0;
  cc_c = 0;
  cc_N = D>>63;
  cc_Z = D==0;
  cc_V = 0;
  cc_C = 0;
  return(0);
}

int i_umul(i) unsigned i;
{
  llu S1, S2;
  llu D;

  pc = npc;
  npc += 4;
  S1 = (llu)(unsigned)*m[i>>14&31];
  S2 = (i&0x2000)?(ll)((int)(i<<19)>>19):*m[i&31];
  D = (llu)(unsigned)S1*(llu)(unsigned)S2;
  y = (llu)(unsigned)(D>>32);
  *m[i>>25&31] = D;
  *m[0] = 0;
  return(0);
}

int i_umulcc(i) unsigned i;
{
  llu S1, S2;
  llu D;
  unsigned d;

  pc = npc;
  npc += 4;
  S1 = (llu)(unsigned)*m[i>>14&31];
  S2 = (i&0x2000)?(ll)((int)(i<<19)>>19):*m[i&31];
  D = (llu)(unsigned)S1*(llu)(unsigned)S2;
  y = (llu)(unsigned)(D>>32);
  *m[i>>25&31] = D;
  *m[0] = 0;
  d = D;
  cc_n = d>>31;
  cc_z = d==0;
  cc_v = 0;
  cc_c = 0;
  cc_N = D>>63;
  cc_Z = D==0;
  cc_V = 0;
  cc_C = 0;
  return(0);
}

int i_mulx(i) unsigned i;
{
  llu S1, S2;

  pc = npc;
  npc += 4;
  S1 = *m[i>>14&31];
  S2 = (i&0x2000)?(ll)((int)(i<<19)>>19):*m[i&31];
  *m[i>>25&31] = S1*S2;
  *m[0] = 0;
  return(0);
}

int i_and(i) unsigned i;
{
  pc = npc;
  npc += 4;
  *m[i>>25&31] = *m[i>>14&31] & ((i&0x2000)?(ll)((int)(i<<19)>>19):*m[i&31]);
  *m[0] = 0;
  return(0);
}

int i_andcc(i) unsigned i;
{
  llu      S1, S2, D;
  unsigned s1, s2, d;

  pc = npc;
  npc += 4;
  S1 = *m[i>>14&31];
  S2 = (i&0x2000)?(ll)((int)(i<<19)>>19):*m[i&31];
  *m[i>>25&31] = D = S1 & S2;
  *m[0] = 0;
  s1 = S1; s2 = S2; d = D;
  cc_n = d>>31;
  cc_z = d==0;
  cc_v = 0;
  cc_c = 0;
  cc_N = D>>63;
  cc_Z = D==0;
  cc_V = 0;
  cc_C = 0;
  return(0);
}

int i_andn(i) unsigned i;
{
  pc = npc;
  npc += 4;
  *m[i>>25&31] = *m[i>>14&31] & ~((i&0x2000)?(ll)((int)(i<<19)>>19):*m[i&31]);
  *m[0] = 0;
  return(0);
}

int i_andncc(i) unsigned i;
{
  llu      S1, S2, D;
  unsigned s1, s2, d;

  pc = npc;
  npc += 4;
  S1 = *m[i>>14&31];
  S2 = (i&0x2000)?(ll)((int)(i<<19)>>19):*m[i&31];
  *m[i>>25&31] = D = S1 & ~S2;
  *m[0] = 0;
  s1 = S1; s2 = S2; d = D;
  cc_n = d>>31;
  cc_z = d==0;
  cc_v = 0;
  cc_c = 0;
  cc_N = D>>63;
  cc_Z = D==0;
  cc_V = 0;
  cc_C = 0;
  return(0);
}

int i_or(i) unsigned i;
{
  pc = npc;
  npc += 4;
  *m[i>>25&31] = *m[i>>14&31] | ((i&0x2000)?(ll)((int)(i<<19)>>19):*m[i&31]);
  *m[0] = 0;
  return(0);
}

int i_orcc(i) unsigned i;
{
  llu      S1, S2, D;
  unsigned s1, s2, d;

  pc = npc;
  npc += 4;
  S1 = *m[i>>14&31];
  S2 = (i&0x2000)?(ll)((int)(i<<19)>>19):*m[i&31];
  *m[i>>25&31] = D = S1 | S2;
  *m[0] = 0;
  s1 = S1; s2 = S2; d = D;
  cc_n = d>>31;
  cc_z = d==0;
  cc_v = 0;
  cc_c = 0;
  cc_N = D>>63;
  cc_Z = D==0;
  cc_V = 0;
  cc_C = 0;
  return(0);
}

int i_orn(i) unsigned i;
{
  pc = npc;
  npc += 4;
  *m[i>>25&31] = *m[i>>14&31] | ~((i&0x2000)?(ll)((int)(i<<19)>>19):*m[i&31]);
  *m[0] = 0;
  return(0);
}

int i_orncc(i) unsigned i;
{
  llu      S1, S2, D;
  unsigned s1, s2, d;

  pc = npc;
  npc += 4;
  S1 = *m[i>>14&31];
  S2 = (i&0x2000)?(ll)((int)(i<<19)>>19):*m[i&31];
  *m[i>>25&31] = D = S1 | ~S2;
  *m[0] = 0;
  s1 = S1; s2 = S2; d = D;
  cc_n = d>>31;
  cc_z = d==0;
  cc_v = 0;
  cc_c = 0;
  cc_N = D>>63;
  cc_Z = D==0;
  cc_V = 0;
  cc_C = 0;
  return(0);
}

int i_xor(i) unsigned i;
{
  pc = npc;
  npc += 4;
  *m[i>>25&31] = *m[i>>14&31] ^ ((i&0x2000)?(ll)((int)(i<<19)>>19):*m[i&31]);
  *m[0] = 0;
  return(0);
}

int i_xorcc(i) unsigned i;
{
  llu      S1, S2, D;
  unsigned s1, s2, d;

  pc = npc;
  npc += 4;
  S1 = *m[i>>14&31];
  S2 = (i&0x2000)?(ll)((int)(i<<19)>>19):*m[i&31];
  *m[i>>25&31] = D = S1 ^ S2;
  *m[0] = 0;
  s1 = S1; s2 = S2; d = D;
  cc_n = d>>31;
  cc_z = d==0;
  cc_v = 0;
  cc_c = 0;
  cc_N = D>>63;
  cc_Z = D==0;
  cc_V = 0;
  cc_C = 0;
  return(0);
}

int i_xnor(i) unsigned i;
{
  pc = npc;
  npc += 4;
  *m[i>>25&31] = *m[i>>14&31] ^ ~((i&0x2000)?(ll)((int)(i<<19)>>19):*m[i&31]);
  *m[0] = 0;
  return(0);
}

int i_xnorcc(i) unsigned i;
{
  llu      S1, S2, D;
  unsigned s1, s2, d;

  pc = npc;
  npc += 4;
  S1 = *m[i>>14&31];
  S2 = (i&0x2000)?(ll)((int)(i<<19)>>19):*m[i&31];
  *m[i>>25&31] = D = S1 ^ ~S2;
  *m[0] = 0;
  s1 = S1; s2 = S2; d = D;
  cc_n = d>>31;
  cc_z = d==0;
  cc_v = 0;
  cc_c = 0;
  cc_N = D>>63;
  cc_Z = D==0;
  cc_V = 0;
  cc_C = 0;
  return(0);
}

int i_sll(i) unsigned i;
{
  pc = npc;
  npc += 4;
  if (i&0x1000) /* sllx */
    *m[i>>25&31] = *m[i>>14&31] << (((i&0x2000)?(ll)((int)(i<<19)>>19):*m[i&31])&63);
  else          /* sll  */
    *m[i>>25&31] = *m[i>>14&31] << (((i&0x2000)?(ll)((int)(i<<19)>>19):*m[i&31])&31);
  *m[0] = 0;
  return(0);
}

int i_srl(i) unsigned i;
{
  pc = npc;
  npc += 4;
  if (i&0x1000) /* srlx */
    *m[i>>25&31] = *m[i>>14&31] >> (((i&0x2000)?(ll)((int)(i<<19)>>19):*m[i&31])&63);
  else          /* srl  */
    *m[i>>25&31] = (llu)((unsigned)*m[i>>14&31] >> (((i&0x2000)?(ll)((int)(i<<19)>>19):*m[i&31])&31));
  *m[0] = 0;
  return(0);
}

int i_sra(i) unsigned i;
{
  pc = npc;
  npc += 4;
  if (i&0x1000) /* srax */
    *m[i>>25&31] = *m[i>>14&31] >> (((i&0x2000)?(ll)((int)(i<<19)>>19):*m[i&31])&63);
  else          /* sra  */
    *m[i>>25&31] = (ll)((int)*m[i>>14&31] >> (((i&0x2000)?(ll)((int)(i<<19)>>19):*m[i&31])&31));
  *m[0] = 0;
  return(0);
}

int i_sethi(i) unsigned i;
{
  pc = npc;
  npc += 4;
  *m[i>>25&31] = (llu)(unsigned)(i<<10);
  *m[0] = 0;
  return(0);
}

int i_save(i) unsigned i;
{
  int j;
  llu D;

  pc = npc;
  npc += 4;
  D = *m[i>>14&31] + ((i&0x2000)?(ll)((int)(i<<19)>>19):*m[i&31]);
  if (++winno == SPARC_WINSIZE) {
    message("i_save: Window overflow\n");
    return(1);
  }
  for (j=0; j<8; j++)
    m[8+j] = &o[winno*8+j]; /* out reg */
  for (j=0; j<8; j++)
    m[16+j] = &l[(winno-1)*8+j]; /* local reg */
  for (j=0; j<8; j++)
    m[24+j] = &o[(winno-1)*8+j]; /* in reg */
  *m[i>>25&31] = D;
  *m[0] = 0;
  return(0);
}

int i_restore(i) unsigned i;
{
  llu D;
  int j;

  pc = npc;
  npc += 4;
  D = *m[i>>14&31] + ((i&0x2000)?(ll)((int)(i<<19)>>19):*m[i&31]);
  if (--winno == 0) {
    /* message("i_restore: Window underflow\n"); */
    for (j=0; j<8; j++)
      m[8+j] = &o[j]; /* out reg */
    return(1);
  }
  for (j=0; j<8; j++)
    m[8+j] = &o[winno*8+j]; /* out reg */
  for (j=0; j<8; j++)
    m[16+j] = &l[(winno-1)*8+j]; /* local reg */
  for (j=0; j<8; j++)
    m[24+j] = &o[(winno-1)*8+j]; /* in reg */
  *m[i>>25&31] = D;
  *m[0] = 0;
  return(0);
}

int i_ldsb(i) unsigned i;
{
  unsigned char *p;

  pc = npc;
  npc += 4;
  opad = *m[i>>14&31] + ((i&0x2000)?(ll)((int)(i<<19)>>19):*m[i&31]);
  if (opad >= 0 && opad < SPARC_MEMSIZE) {
    p = &mem[opad];
    *m[i>>25&31] = (ll)(char)*p;
    *m[0] = 0;
  }
  return(0);
}

int i_ldub(i) unsigned i;
{
  unsigned char *p;

  pc = npc;
  npc += 4;
  opad = *m[i>>14&31] + ((i&0x2000)?(ll)((int)(i<<19)>>19):*m[i&31]);
  if (opad >= 0 && opad < SPARC_MEMSIZE) {
    p = &mem[opad];
    *m[i>>25&31] = (llu)(unsigned char)*p;
    *m[0] = 0;
  }
  return(0);
}

int i_ldsh(i) unsigned i;
{
  unsigned char *p;

  pc = npc;
  npc += 4;
  opad = *m[i>>14&31] + ((i&0x2000)?(ll)((int)(i<<19)>>19):*m[i&31]);
  if (opad >= 0 && opad < SPARC_MEMSIZE) {
    p = &mem[opad];
    *m[i>>25&31] = (ll)(short)(*p<<8 | *(p+1));
    *m[0] = 0;
  }
  return(0);
}

int i_lduh(i) unsigned i;
{
  unsigned char *p;

  pc = npc;
  npc += 4;
  opad = *m[i>>14&31] + ((i&0x2000)?(ll)((int)(i<<19)>>19):*m[i&31]);
  if (opad >= 0 && opad < SPARC_MEMSIZE) {
    p = &mem[opad];
    *m[i>>25&31] = (llu)(unsigned short)(*p<<8 | *(p+1));
    *m[0] = 0;
  }
  return(0);
}

int i_ldsw(i) unsigned i;
{
  unsigned char *p;

  pc = npc;
  npc += 4;
  opad = *m[i>>14&31] + ((i&0x2000)?(ll)((int)(i<<19)>>19):*m[i&31]);
  if (opad >= 0 && opad < SPARC_MEMSIZE) {
    p = &mem[opad];
    *m[i>>25&31] = (ll)(int)(*p<<24 | *(p+1)<<16 | *(p+2)<<8 | *(p+3));
    *m[0] = 0;
  }
  return(0);
}

int i_lduw(i) unsigned i;
{
  unsigned char *p;

  pc = npc;
  npc += 4;
  opad = *m[i>>14&31] + ((i&0x2000)?(ll)((int)(i<<19)>>19):*m[i&31]);
  if (opad >= 0 && opad < SPARC_MEMSIZE) {
    p = &mem[opad];
    *m[i>>25&31] = (llu)(unsigned)(*p<<24 | *(p+1)<<16 | *(p+2)<<8 | *(p+3));
    *m[0] = 0;
  }
  return(0);
}

int i_ldd(i) unsigned i;
{
  unsigned char *p;

  pc = npc;
  npc += 4;
  opad = *m[i>>14&31] + ((i&0x2000)?(ll)((int)(i<<19)>>19):*m[i&31]);
  if (opad >= 0 && opad < SPARC_MEMSIZE) {
    p = &mem[opad];
    *m[i>>25&31  ] = (llu)(unsigned)(*(p  )<<24 | *(p+1)<<16 | *(p+2)<<8 | *(p+3));
    *m[i>>25&31|1] = (llu)(unsigned)(*(p+4)<<24 | *(p+5)<<16 | *(p+6)<<8 | *(p+7));
    *m[0] = 0;
  }
  return(0);
}

int i_lduwa(i) unsigned i;       
{   
  unsigned char *p;
  struct  tms utms;

  pc = npc;
  npc += 4;
  opad = *m[i>>14&31] + *m[i&31];
  if ((i>>5&255) == 0x20 && opad == 0xfff00304) { /* TOD */
    times(&utms);
    *m[i>>25&31] = utms.tms_utime * (1000000 / sysconf(_SC_CLK_TCK));
    *m[0] = 0;  
  } 
  return(0);
}

int i_ldx(i) unsigned i;
{
  unsigned char *p;

  pc = npc;
  npc += 4;
  opad = *m[i>>14&31] + ((i&0x2000)?(ll)((int)(i<<19)>>19):*m[i&31]);
  if (opad >= 0 && opad < SPARC_MEMSIZE) {
    p = &mem[opad];
    *m[i>>25&31] = (llu)*(p  )<<56 | (llu)*(p+1)<<48 | (llu)*(p+2)<<40 | (llu)*(p+3)<<32
                 | (llu)*(p+4)<<24 | (llu)*(p+5)<<16 | (llu)*(p+6)<< 8 | (llu)*(p+7);
    *m[0] = 0;
  }
  return(0);
}

int i_stb(i) unsigned i;
{
  unsigned char *p;
  llu D;

  pc = npc;
  npc += 4;
  opad = *m[i>>14&31] + ((i&0x2000)?(ll)((int)(i<<19)>>19):*m[i&31]);
  if (opad >= 0 && opad < SPARC_MEMSIZE) {
    p = &mem[opad];
    D = *m[i>>25&31];
    *(p  ) = D;
  }
  return(0);
}

int i_sth(i) unsigned i;
{
  unsigned char *p;
  llu D;

  pc = npc;
  npc += 4;
  opad = *m[i>>14&31] + ((i&0x2000)?(ll)((int)(i<<19)>>19):*m[i&31]);
  if (opad >= 0 && opad < SPARC_MEMSIZE) {
    p = &mem[opad];
    D = *m[i>>25&31];
    *(p  ) = D>> 8;
    *(p+1) = D    ;
  }
  return(0);
}

int i_stw(i) unsigned i;
{
  unsigned char *p;
  llu D;

  pc = npc;
  npc += 4;
  opad = *m[i>>14&31] + ((i&0x2000)?(ll)((int)(i<<19)>>19):*m[i&31]);
  if (opad >= 0 && opad < SPARC_MEMSIZE) {
    p = &mem[opad];
    D = *m[i>>25&31];
    *(p  ) = D>>24;
    *(p+1) = D>>16;
    *(p+2) = D>> 8;
    *(p+3) = D;
  }
  return(0);
}

int i_std(i) unsigned i;
{
  unsigned char *p;
  llu D;

  pc = npc;
  npc += 4;
  opad = *m[i>>14&31] + ((i&0x2000)?(ll)((int)(i<<19)>>19):*m[i&31]);
  if (opad >= 0 && opad < SPARC_MEMSIZE) {
    p = &mem[opad];
    D = *m[i>>25&31];
    *(p  ) = D>>24;
    *(p+1) = D>>16;
    *(p+2) = D>> 8;
    *(p+3) = D    ;
    D = *m[i>>25&31|1];
    *(p+4) = D>>24;
    *(p+5) = D>>16;
    *(p+6) = D>> 8;
    *(p+7) = D;
  }
  return(0);
}

int i_stx(i) unsigned i;
{
  unsigned char *p;
  llu D;

  pc = npc;
  npc += 4;
  opad = *m[i>>14&31] + ((i&0x2000)?(ll)((int)(i<<19)>>19):*m[i&31]);
  if (opad >= 0 && opad < SPARC_MEMSIZE) {
    p = &mem[opad];
    D = *m[i>>25&31];
    *(p  ) = D>>56;
    *(p+1) = D>>48;
    *(p+2) = D>>40;
    *(p+3) = D>>32;
    *(p+4) = D>>24;
    *(p+5) = D>>16;
    *(p+6) = D>> 8;
    *(p+7) = D;
  }
  return(0);
}

int i_ldstub(i) unsigned i;
{
  unsigned char *p;

  pc = npc;
  npc += 4;
  opad = *m[i>>14&31] + ((i&0x2000)?(ll)((int)(i<<19)>>19):*m[i&31]);
  if (opad >= 0 && opad < SPARC_MEMSIZE) {
    p = &mem[opad];
    *m[i>>25&31] = *p;
    *m[0] = 0;
    *p = 0xff;
  }
  return(0);
}

int i_bicc(i) unsigned i;
{
  llu opc = pc;
  unsigned taken;

  pc = npc;
  switch (i>>25&15) {
  case 0:
    taken = 0;
    break;
  case 1:
    taken = cc_z;
    break;
  case 2:
    taken = cc_z || (cc_n ^ cc_v);
    break;
  case 3:
    taken = cc_n ^ cc_v;
    break;
  case 4:
    taken = cc_c || cc_z;
    break;
  case 5:
    taken = cc_c;
    break;
  case 6:
    taken = cc_n;
    break;
  case 7:
    taken = cc_v;
    break;
  case 8:
    npc = opc + (ll)((int)(i<<10)>>8);
    if (i&0x20000000) /* annul */
      annul = 1;
    return(0);
    break;
  case 9:
    taken = !cc_z;
    break;
  case 10:
    taken = !(cc_z || (cc_n ^ cc_v));
    break;
  case 11:
    taken = !(cc_n ^ cc_v);
    break;
  case 12:
    taken = !(cc_c || cc_z);
    break;
  case 13:
    taken = !cc_c;
    break;
  case 14:
    taken = !cc_n;
    break;
  case 15:
    taken = !cc_v;
    break;
  }
  if (taken)
    npc = opc + (ll)((int)(i<<10)>>8);
  else {
    npc += 4;
    if (i&0x20000000) /* annul */
      annul = 1;
  }
  return(0);
}

int i_bpcc(i) unsigned i;
{
  llu opc = pc;
  unsigned taken;

  pc = npc;
  switch (i>>25&15) {
  case 0:
    taken = 0;
    break;
  case 1:
    taken = (i&0x200000) ? cc_Z : cc_z;
    break;
  case 2:
    taken = (i&0x200000) ? cc_Z || (cc_N ^ cc_V) : cc_z || (cc_n ^ cc_v);
    break;
  case 3:
    taken = (i&0x200000)? cc_N ^ cc_V : cc_n ^ cc_v;
    break;
  case 4:
    taken = (i&0x200000)? cc_C || cc_Z : cc_c || cc_z;
    break;
  case 5:
    taken = (i&0x200000)? cc_C : cc_c;
    break;
  case 6:
    taken = (i&0x200000)? cc_N : cc_n;
    break;
  case 7:
    taken = (i&0x200000)? cc_V : cc_v;
    break;
  case 8:
    npc = opc + (ll)((int)(i<<13)>>11);
    if (i&0x20000000) /* annul */
      annul = 1;
    return(0);
    break;
  case 9:
    taken = (i&0x200000)? !cc_Z : !cc_z;
    break;
  case 10:
    taken = (i&0x200000)? !(cc_Z || (cc_N ^ cc_V)) : !(cc_z || (cc_n ^ cc_v));
    break;
  case 11:
    taken = (i&0x200000)? !(cc_N ^ cc_V) : !(cc_n ^ cc_v);
    break;
  case 12:
    taken = (i&0x200000)? !(cc_C || cc_Z) : !(cc_c || cc_z);
    break;
  case 13:
    taken = (i&0x200000)? !cc_C : !cc_c;
    break;
  case 14:
    taken = (i&0x200000)? !cc_N : !cc_n;
    break;
  case 15:
    taken = (i&0x200000)? !cc_V : !cc_v;
    break;
  }
  if (taken)
    npc = opc + (ll)((int)(i<<13)>>11);
  else {
    npc += 4;
    if (i&0x20000000) /* annul */
      annul = 1;
  }
  return(0);
}

int i_bpr(i) unsigned i;
{
  llu opc = pc;
  ll  S1;
  unsigned taken;

  pc = npc;
  S1 = *m[i>>14&31];
  switch (i>>25&7) {
  case 0:
    taken = 0; /* reserved */
    break;
  case 1:
    taken = S1 == 0;
    break;
  case 2:
    taken = S1 <= 0;
    break;
  case 3:
    taken = S1 < 0;
    break;
  case 4:
    taken = 0; /* reserved */
    break;
  case 5:
    taken = S1 != 0;
    break;
  case 6:
    taken = S1 > 0;
    break;
  case 7:
    taken = S1 >= 0;
    break;
  }
  if (taken)
    npc = opc + (ll)((int)((i>>20)<<30|(i<<18)>>2)>>14);
  else {
    npc += 4;
    if (i&0x20000000) /* annul */
      annul = 1;
  }
  return(0);
}

int i_movcc(i) unsigned i;
{
  unsigned taken;

  pc = npc;
  npc += 4;
  if (i&0x40000 == 0) {
    message("i_movcc: fccx not implemented.\n");
    return(1);
  }
  switch (i>>14&15) {
  case 0:
    taken = 0;
    break;
  case 1:
    taken = (i&0x1000) ? cc_Z : cc_z;
    break;
  case 2:
    taken = (i&0x1000) ? cc_Z || (cc_N ^ cc_V) : cc_z || (cc_n ^ cc_v);
    break;
  case 3:
    taken = (i&0x1000)? cc_N ^ cc_V : cc_n ^ cc_v;
    break;
  case 4:
    taken = (i&0x1000)? cc_C || cc_Z : cc_c || cc_z;
    break;
  case 5:
    taken = (i&0x1000)? cc_C : cc_c;
    break;
  case 6:
    taken = (i&0x1000)? cc_N : cc_n;
    break;
  case 7:
    taken = (i&0x1000)? cc_V : cc_v;
    break;
  case 8:
    taken = 1;
    break;
  case 9:
    taken = (i&0x1000)? !cc_Z : !cc_z;
    break;
  case 10:
    taken = (i&0x1000)? !(cc_Z || (cc_N ^ cc_V)) : !(cc_z || (cc_n ^ cc_v));
    break;
  case 11:
    taken = (i&0x1000)? !(cc_N ^ cc_V) : !(cc_n ^ cc_v);
    break;
  case 12:
    taken = (i&0x1000)? !(cc_C || cc_Z) : !(cc_c || cc_z);
    break;
  case 13:
    taken = (i&0x1000)? !cc_C : !cc_c;
    break;
  case 14:
    taken = (i&0x1000)? !cc_N : !cc_n;
    break;
  case 15:
    taken = (i&0x1000)? !cc_V : !cc_v;
    break;
  }
  if (taken) {
    *m[i>>25&31] = (i&0x2000)?(ll)((int)(i<<21)>>21):*m[i&31];
    *m[0] = 0;
  }
  return(0);
}

int i_movr(i) unsigned i;
{
  ll S1;
  unsigned taken;

  pc = npc;
  npc += 4;
  S1 = *m[i>>14&31];
  switch (i>>10&7) {
  case 0:
    taken = 0; /* reserved */
    break;
  case 1:
    taken = S1 == 0;
    break;
  case 2:
    taken = S1 <= 0;
    break;
  case 3:
    taken = S1 < 0;
    break;
  case 4:
    taken = 0; /* reserved */
    break;
  case 5:
    taken = S1 != 0;
    break;
  case 6:
    taken = S1 > 0;
    break;
  case 7:
    taken = S1 >= 0;
    break;
  }
  if (taken) {
    *m[i>>25&31] = (i&0x2000)?(ll)((int)(i<<22)>>22):*m[i&31];
    *m[0] = 0;
  }
  return(0);
}

int i_call(i) unsigned i;
{
  llu opc = pc;

  pc = npc;
  npc = opc + (ll)(int)(i<<2);
  *m[15] = opc;
  return(0);
}

int i_jmpl(i) unsigned i;
{
  llu opc = pc;

  pc = npc;
  npc = *m[i>>14&31] + ((i&0x2000)?(ll)((int)(i<<19)>>19):*m[i&31]);
  *m[i>>25&31] = opc;
  *m[0] = 0;
  return(0);
}

int i_return(i) unsigned i;
{
  llu opc = pc;
  int j;

  pc = npc;
  npc = *m[i>>14&31] + ((i&0x2000)?(ll)((int)(i<<19)>>19):*m[i&31]);
  if (--winno == 0) {
    /* message("i_restore: Window underflow\n"); */
    for (j=0; j<8; j++)
      m[8+j] = &o[j]; /* out reg */
    return(1);
  }
  for (j=0; j<8; j++)
    m[8+j] = &o[winno*8+j]; /* out reg */
  for (j=0; j<8; j++)
    m[16+j] = &l[(winno-1)*8+j]; /* local reg */
  for (j=0; j<8; j++)
    m[24+j] = &o[(winno-1)*8+j]; /* in reg */
  return(0);
}

int i_ticc(i) unsigned i;
{
  char path[1024], *p;
  unsigned taken;

  pc = npc;
  npc += 4;
  switch (i>>25&15) {
  case 0:
    taken = 0;
    break;
  case 1:
    taken = (i&0x1000) ? cc_Z : cc_z;
    break;
  case 2:
    taken = (i&0x1000) ? cc_Z || (cc_N ^ cc_V) : cc_z || (cc_n ^ cc_v);
    break;
  case 3:
    taken = (i&0x1000)? cc_N ^ cc_V : cc_n ^ cc_v;
    break;
  case 4:
    taken = (i&0x1000)? cc_C || cc_Z : cc_c || cc_z;
    break;
  case 5:
    taken = (i&0x1000)? cc_C : cc_c;
    break;
  case 6:
    taken = (i&0x1000)? cc_N : cc_n;
    break;
  case 7:
    taken = (i&0x1000)? cc_V : cc_v;
    break;
  case 8:
    taken = 1;
    break;
  case 9:
    taken = (i&0x1000)? !cc_Z : !cc_z;
    break;
  case 10:
    taken = (i&0x1000)? !(cc_Z || (cc_N ^ cc_V)) : !(cc_z || (cc_n ^ cc_v));
    break;
  case 11:
    taken = (i&0x1000)? !(cc_N ^ cc_V) : !(cc_n ^ cc_v);
    break;
  case 12:
    taken = (i&0x1000)? !(cc_C || cc_Z) : !(cc_c || cc_z);
    break;
  case 13:
    taken = (i&0x1000)? !cc_C : !cc_c;
    break;
  case 14:
    taken = (i&0x1000)? !cc_N : !cc_n;
    break;
  case 15:
    taken = (i&0x1000)? !cc_V : !cc_v;
    break;
  }
  if (taken) {
    switch(i&0x7f) {
    case 8: /* system call */
      switch (*m[1]) {
      case 1: /* exit */
	message("i_ticc: Program normal end.\n");
	return(1);
	break;
      case 3: /* read */
	*m[8] = read((int)*m[8], &mem[*m[9]], (int)*m[10]);
	break;
      case 4: /* write */
	fflush(stdout);
	*m[8] = write((int)*m[8], &mem[*m[9]], (int)*m[10]);
	break;
      case 5: /* open */
	*m[8] = open(&mem[*m[8]], (int)*m[9], (int)*m[10]);
	break;
      case 6: /* close */
	*m[8] = close((int)*m[8]);
	break;
      default:
	message("i_ticc: Undefined sys_call (g1=0x%08.8x_%08.8x)\n", (int)(*m[1]>>32), (int)*m[1]);
	return(1);
	break;
      }
      break;
    case 0x43: /* low-address-protection */
      message("i_ticc: Low-address-protection detected\n");
      return(1);
    default:
      message("i_ticc: Undefined sw_trap (DIAG=0x%08.8x)\n", i&0x7f);
      return(1);
    }
  }
  return(0);
}

int i_rdy(i) unsigned i;
{
  pc = npc;
  npc += 4;
  *m[i>>25&31] = y;
  *m[0] = 0;
  return(0);
}

int i_wry(i) unsigned i;
{
  pc = npc;
  npc += 4;
  y = (llu)(unsigned)(*m[i>>14&31] ^ ((i&0x2000)?(ll)((int)(i<<19)>>19):*m[i&31]));
  return(0);
}

int i_illtrap(i) unsigned i;
{
  pc = npc;
  npc += 4;
  message("i_illtrap: Illtrap instruction detected\n");
  return(1);
}

int i_flush(i) unsigned i;
{
  pc = npc;
  npc += 4;
  return(0);
}

int i_xxx(i) unsigned i;
{   
  pc = npc;     
  npc += 4;
  message("i_xxx: unimplemented instruction (%08.8x) detected\n", i);
  return(1);
}   

