
/* log2trace.c - for stsim on SPARC. 1996/7/23 by Y.Nakashima */

#include <stdio.h>

#if 1
unsigned int swap4(a) unsigned int a;
{ return (a); }
#endif

#if 0
unsigned int swap4(a) unsigned int a;
{ return (((a)<<24)|(((a)&0xff00)<<8)|(((a)&0xff0000)>>8)|((a)>>24)); }
#endif

#define BUF_LINE 2048
char	buf  [BUF_LINE];
 
main(argc, argv) int argc; char **argv;
{
  FILE	*fp = stdin;
  unsigned pc, insn, opad, opcd;
  char annul;
  struct record { /* big-endian-byte-order assumed */
    unsigned pc;
    unsigned insn;
    unsigned opad;
    unsigned opcd:8;
    unsigned flag:8;
    unsigned resv:16;
  } record;

  if (argc == 2 && (fp = fopen(argv[1], "r")) == NULL) {
    fprintf(stderr, "can't open %s\n", argv[1]);
    exit(1);
  }

  while (fgets(buf, BUF_LINE, fp) != NULL) {
    if (sscanf(buf, "  %*x_%x: %x [%*x_%x] %x %c", &pc, &insn, &opad, &opcd, &annul) == 5) {
      record.pc   = swap4(pc);
      record.insn = swap4(insn);
      record.opad = swap4(opad);
      record.opcd = opcd;
      record.flag = annul=='O'?0:2;
      record.resv = 0;
      write(1, &record, sizeof(struct record));
    }
  }
}
