
static char RcsId[] =
"$Id: ssim.c,v 1.9 1997/06/05 04:17:16 nakashim Exp nakashim $";

/* ssim.c 1996/3/22 */

/* SPARC Integer Instruction Simulator         */
/*       Copyright (C) 1995 by FUJITSU LIMITED */
/*                 Primary writer: Y.Nakashima */
/*          nakashim@pine.mfd.cs.fujitsu.co.jp */

#include "sdef.h"

ssim(trace)
  unsigned trace;
{
  extern struct sparc_op insn00[], insn01[], insn10[], insn11[];
  unsigned insn, i, retval;
  unsigned char *memp;
  struct sparc_op *sop;

  pc =0;
  npc = pc+4;

  for (;;) {
    opc = pc;
    if (pc >= SPARC_MEMSIZE) {
      message("Address too large: pc=%08.8x_%08.8x\n", (int)(pc>>32), (int)pc);
      return;
    }
    memp = &mem[pc];
    insn = *memp<<24 | *(memp+1)<<16 | *(memp+2)<<8 | *(memp+3);
    switch (insn >> 30) {
    case 0:
      sop = &insn00[insn>>22&7];
      break;
    case 1:
      sop = &insn01[0];
      break;
    case 2:
      sop = &insn10[insn>>19&63];
      break;
    case 3:
      sop = &insn11[insn>>19&63];
      break;
    }
    
    if (!annul) {
      sparc_step++;
      retval = (sop->func)(insn);
      if (trace) {
	message("  %08.8x_%08.8x: %08.8x", (int)(opc>>32), (int)opc, insn);
	message(" [%08.8x_%08.8x] %02.2x O %s\n",
                 (int)(opad>>32), (int)opad, (insn>>24&192)|(insn>>19&63), sop->name);
        if (m[8]) {
	  message("    o:%08.8x %08.8x %08.8x %08.8x",(int)*m[8],(int)*m[9],(int)*m[10],(int)*m[11]);
	  message(" %08.8x %08.8x %08.8x %08.8x\n",(int)*m[12],(int)*m[13],(int)*m[14],(int)*m[15]);
        }
        if (m[16]) {
	  message("    l:%08.8x %08.8x %08.8x %08.8x",(int)*m[16],(int)*m[17],(int)*m[18],(int)*m[19]);
	  message(" %08.8x %08.8x %08.8x %08.8x\n",(int)*m[20],(int)*m[21],(int)*m[22],(int)*m[23]);
        }
        if (m[24]) {
	  message("    i:%08.8x %08.8x %08.8x %08.8x",(int)*m[24],(int)*m[25],(int)*m[26],(int)*m[27]);
	  message(" %08.8x %08.8x %08.8x %08.8x\n",(int)*m[28],(int)*m[29],(int)*m[30],(int)*m[31]);
        }
      }
      if (retval)
        return;
    }
    else { /* nop */
      pc = npc;
      npc += 4;     
      annul = 0;
      if (trace) {
	message("  %08.8x_%08.8x: %08.8x", (int)(opc>>32), (int)opc, insn);
	message(" [%08.8x_%08.8x] %02.2x X %s\n",
                 (int)(opad>>32), (int)opad, (insn>>24&192)|(insn>>19&63), sop->name);
      }
    }
  }
}

