
static char RcsId[] =
"$Id: file.c,v 1.3 1996/03/23 09:59:57 nakashim Exp nakashim $";

/* SPARC Integer Instruction Simulator         */
/*       Copyright (C) 1995 by FUJITSU LIMITED */
/*                 Primary writer: Y.Nakashima */
/*          nakashim@pine.mfd.cs.fujitsu.co.jp */

/* file.c 1996/3/22 */

#include <stdio.h>
#include <elf.h>
#include "ssim.h"

void read_elf();

/*  A.OUT STRUCT */	

struct aout_head {
	unsigned short  a_info;
	unsigned short  a_magic;
	int 		a_text;
	int		a_data;
	int		a_bss;
	int		a_syms;
	int		a_entry;
	int		a_trsize;
	int		a_drsize;
};
struct aout_head Ahead;

struct rel {
	int		r_off;
	unsigned int    r_sym: 24,
			r_extern: 1,
			     : 2,
			r_type: 5;
	int 		r_addend;
};

struct sym {
	int		s_name;
	unsigned int	s_type: 8,
			      : 24;
	int		s_value;
};

struct rel *Drel;
struct rel *Trel;
struct sym *Sym;

/*  ELF  STRUCT  */

Elf32_Ehdr	Ehead;

Elf32_Rel	*E_textrel;
Elf32_Rel	*E_datarel;
Elf32_Sym	*E_sym;

Elf32_Phdr	Phead[3];
Elf32_Shdr	Shead[16];

/*  BUFFER  */

char *Text_p, *Data_p, *Textrel_p;
char *Datarel_p, *Sym_p, *Str_p;
char *Shstr_p;
int  len, count;
int  trsz_num, drsz_num;
int  textndx   = 0;
int  datandx   = 0;
int  bssndx    = 0;
int  symtabndx = 0;
int  strtabndx = 0;

int  baseaddr = 0;

#ifdef SPARC
unsigned swap1(a) unsigned char a;
{ return (a); }

unsigned swap2(a) unsigned short a;
{ return (a); }

unsigned swap3(a) unsigned a;
{ return (a); }

unsigned swap4(a) unsigned a;
{ return (a); }
#endif

#ifdef INTEL
unsigned swap1(a) unsigned char a;
{ return (a); }

unsigned swap2(a) unsigned short a;
{ return (((a&0xff)<<8)|(a>>8)); }

unsigned swap3(a) unsigned a;
{ return (((a&0xff)<<16)|(a&0xff00)|(a>>16)); }

unsigned swap4(a) unsigned a;
{ return ((a<<24)|((a&0xff00)<<8)|((a&0xff0000)>>8)|(a>>24)); }
#endif

/* READ_ELF() */
void read_elf(file)
     char *file;
{
  /* FILEOPEN */
  FILE *fp;
  int dummy[16], i, j;
  
  fp = fopen(file, "r");
  if (fp == NULL){
    printf("Can't open elf_file\n");
    exit(1);
  }
  
  /* READ ELF_HEADER */
  if (fread(&Ehead, 1, sizeof Ehead, fp) !=  (sizeof Ehead)){
    printf("Can't read elf_header\n");
    exit(1);
  }
  
  Ehead.e_type      = swap2(Ehead.e_type);      /****/
  Ehead.e_machine   = swap2(Ehead.e_machine);   /****/
  Ehead.e_version   = swap4(Ehead.e_version);   /****/
  Ehead.e_entry     = swap4(Ehead.e_entry);     /****/
  Ehead.e_phoff     = swap4(Ehead.e_phoff);     /****/
  Ehead.e_shoff     = swap4(Ehead.e_shoff);     /****/
  Ehead.e_flags     = swap4(Ehead.e_flags);     /****/
  Ehead.e_ehsize    = swap2(Ehead.e_ehsize);    /****/
  Ehead.e_phentsize = swap2(Ehead.e_phentsize); /****/
  Ehead.e_phnum     = swap2(Ehead.e_phnum);     /****/
  Ehead.e_shentsize = swap2(Ehead.e_shentsize); /****/
  Ehead.e_shnum     = swap2(Ehead.e_shnum);     /****/
  Ehead.e_shstrndx  = swap2(Ehead.e_shstrndx);  /****/
  
  fseek(fp, Ehead.e_shoff, 0);
  for (i=0; i<16 && i<Ehead.e_shnum; i++) {
    fread(&Shead[i], 1, Ehead.e_shentsize, fp);
    Shead[i].sh_name      = swap4(Shead[i].sh_name);      /****/
    Shead[i].sh_type      = swap4(Shead[i].sh_type);      /****/
    Shead[i].sh_flags     = swap4(Shead[i].sh_flags);     /****/
    Shead[i].sh_addr      = swap4(Shead[i].sh_addr);      /****/
    Shead[i].sh_offset    = swap4(Shead[i].sh_offset);    /****/
    Shead[i].sh_size      = swap4(Shead[i].sh_size);      /****/
    Shead[i].sh_link      = swap4(Shead[i].sh_link);      /****/
    Shead[i].sh_info      = swap4(Shead[i].sh_info);      /****/
    Shead[i].sh_addralign = swap4(Shead[i].sh_addralign); /****/
    Shead[i].sh_entsize   = swap4(Shead[i].sh_entsize);   /****/
  }
  
  Shstr_p = (char *)malloc(Shead[Ehead.e_shstrndx].sh_size);
  fseek(fp, Shead[Ehead.e_shstrndx].sh_offset, 0);
  if (fread(Shstr_p, 1, Shead[Ehead.e_shstrndx].sh_size, fp) != Shead[Ehead.e_shstrndx].sh_size) {
    printf("Can't read shstr\n");
    exit(1);
  }
  
  for (i=0; i<16 && i<Ehead.e_shnum; i++) {
    if      (!strcmp(Shstr_p+Shead[i].sh_name, ".text"))
      textndx = i;
    else if (!strcmp(Shstr_p+Shead[i].sh_name, ".data"))
      datandx = i;
    else if (!strcmp(Shstr_p+Shead[i].sh_name, ".bss"))
      bssndx = i;
    else if (!strcmp(Shstr_p+Shead[i].sh_name, ".symtab"))
      symtabndx = i;
    else if (!strcmp(Shstr_p+Shead[i].sh_name, ".strtab"))
      strtabndx = i;
  }
  
  printf(" ELF:text=%08.8x ", Shead[textndx].sh_size);
  printf("data=%08.8x ", Shead[datandx].sh_size);
  printf("bss=%08.8x ", Shead[bssndx].sh_size);
  printf("symt=%08.8x ", Shead[symtabndx].sh_size);
  printf("strt=%08.8x\n", Shead[strtabndx].sh_size-1);
  
  /* READ PROGRAM_HEADER */
  fseek(fp, Ehead.e_phoff, 0);
  if (fread(Phead, Ehead.e_phnum, sizeof *Phead, fp) !=  (sizeof *Phead)){
    printf("Can't read program_header\n");
    exit(1);
  }
  
  Phead[0].p_type   = swap4(Phead[0].p_type);   /****/
  Phead[0].p_offset = swap4(Phead[0].p_offset); /****/
  Phead[0].p_vaddr  = swap4(Phead[0].p_vaddr);  /****/
  Phead[0].p_paddr  = swap4(Phead[0].p_paddr);  /****/
  Phead[0].p_filesz = swap4(Phead[0].p_filesz); /****/
  Phead[0].p_memsz  = swap4(Phead[0].p_memsz);  /****/
  Phead[0].p_flags  = swap4(Phead[0].p_flags);  /****/
  Phead[0].p_align  = swap4(Phead[0].p_align);  /****/
  Phead[1].p_type   = swap4(Phead[1].p_type);   /****/
  Phead[1].p_offset = swap4(Phead[1].p_offset); /****/
  Phead[1].p_vaddr  = swap4(Phead[1].p_vaddr);  /****/
  Phead[1].p_paddr  = swap4(Phead[1].p_paddr);  /****/
  Phead[1].p_filesz = swap4(Phead[1].p_filesz); /****/
  Phead[1].p_memsz  = swap4(Phead[1].p_memsz);  /****/
  Phead[1].p_flags  = swap4(Phead[1].p_flags);  /****/
  Phead[1].p_align  = swap4(Phead[1].p_align);  /****/
  
  if (Shead[datandx].sh_size == 0) {
    /* MALLOC */
    if ((Text_p = (char *)malloc(Phead[0].p_memsz)) == NULL){
      printf("Can't malloc elf_text\n");
      exit(1);
    }
    memset(Text_p, 0, Phead[0].p_memsz-1);
  }
  else {
    /* MALLOC */
    if ((Text_p = (char *)malloc(Phead[1].p_vaddr-Phead[0].p_vaddr)) == NULL){
      printf("Can't malloc elf_text\n");
      exit(1);
    }
    memset(Text_p, 0, Phead[1].p_vaddr-Phead[0].p_vaddr);
    if ((Data_p = (char *)malloc((Phead[1].p_memsz-1|7)+1)) == NULL){
      printf("Can't malloc elf_data\n");
      exit(1);
    }
    memset(Data_p, 0, (Phead[1].p_memsz-1|7)+1);
  }
  
  /* READ (text, data) */
  if (Shead[textndx].sh_size) {
    fseek(fp, Phead[0].p_offset, 0);
    if (fread(Text_p, 1, Phead[0].p_filesz, fp) != Phead[0].p_filesz){
      printf("Can't read elf_text\n");
      exit(1);
    }
  }
  if (Shead[datandx].sh_size) {
    fseek(fp, Phead[1].p_offset, 0);
    if (fread(Data_p, 1, Phead[1].p_filesz, fp) != Phead[1].p_filesz){
      printf("Can't read elf_data\n");
      exit(1);
    }
  }
  
  fclose(fp);

/* CONV_DATA() */
  
  /* ELF_HEADER --> A.OUT_HEADER */
  if (Shead[datandx].sh_size == 0) {
    Ahead.a_info   = 0x00c8;
    Ahead.a_magic  = 0x0107;
    Ahead.a_text   = Shead[textndx].sh_size ? Phead[0].p_memsz:0;
    Ahead.a_data   = 0;
    Ahead.a_bss    = 0;
    Ahead.a_syms   = 0;
    Ahead.a_entry  = Phead[0].p_vaddr;
    Ahead.a_trsize = 0;
    Ahead.a_drsize = 0;
  }
  else {
    Ahead.a_info   = 0x00c8;
    Ahead.a_magic  = 0x0107;
    Ahead.a_text   = Phead[1].p_vaddr-Phead[0].p_vaddr;
    Ahead.a_data   = (Phead[1].p_memsz-1|7)+1;
    Ahead.a_bss    = 0;
    Ahead.a_syms   = 0;
    Ahead.a_entry  = Phead[0].p_vaddr;
    Ahead.a_trsize = 0;
    Ahead.a_drsize = 0;
  }
  
  printf(" BSD:text=%08.8x ", Ahead.a_text);
  printf("data=%08.8x ", Ahead.a_data);
  printf("bss=-------- ");
  printf("symt=-------- ");
  printf("strt=%08.8x\n", Shead[strtabndx].sh_size-1);

/* WRITE_AOUT() */

  if (Ahead.a_text + Ahead.a_data > MEMSIZE) {
    printf("Program too large\n");
    exit(1);
  }
  mofs = Ahead.a_entry;
  memcpy(&mem[           0], Text_p, Ahead.a_text);
  memcpy(&mem[Ahead.a_text], Data_p, Ahead.a_data);

  free(Text_p);
  free(Data_p);
  free(Shstr_p);
}

