
static char RcsId[] =
"$Id: ssim.c,v 1.9 1996/07/10 06:16:39 nakashim Exp nakashim $";

/* SPARC Integer Instruction Simulator         */
/*       Copyright (C) 1995 by FUJITSU LIMITED */
/*                 Primary writer: Y.Nakashima */
/*          nakashim@pine.mfd.cs.fujitsu.co.jp */

/* ssim.c 1996/3/22 */

#include "ssim.h"

unsigned char e2adump[] = {
 '.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.',
 '.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.',
 '.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.',
 '.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.',
 ' ','.','.','.','.','.','.','.','.','.','.','.','<','(','+','|',
 '&','.','.','.','.','.','.','.','.','.','!','$','*',')',';','^',
 '-','/','.','.','.','.','.','.','.','.','.',',','%','_','>','?',
 '.','.','.','.','.','.','.','.','.','.',':','#','@','\'','=','\"',/*"*/
 '.','a','b','c','d','e','f','g','h','i','.','.','.','.','.','.',
 '.','j','k','l','m','n','o','p','q','r','.','.','.','.','.','.',
 '.','~','s','t','u','v','w','x','y','z','.','.','.','[','.','.',
 '.','.','.','.','.','.','.','.','.','.','.','.','.',']','.','.',
 '{','A','B','C','D','E','F','G','H','I','.','.','.','.','.','.',
 '}','J','K','L','M','N','O','P','Q','R','.','.','.','.','.','.',
'\\','.','S','T','U','V','W','X','Y','Z','.','.','.','.','.','.',
 '0','1','2','3','4','5','6','7','8','9','.','.','.','.','.','.'};

main(argc, argv)
  int argc;
  char **argv;
{
  char *version();
  extern struct op insn00[], insn01[], insn10[], insn11[];
  unsigned insn, i;
  unsigned char *memp;
  struct op *sop;
  char *prog;

  for (argc--, argv++; argc; argc--, argv++) {
    if (**argv != '-') { /* regard as a file name */
      strcpy(prog = (char*)malloc(strlen(*argv) + 1), *argv);
      continue;
    }
    switch (*(*argv+1)) {
    case 'm':
      flag |= TRACE_M;
      break;
    case 's':
      flag |= TRACE_SPARC;
      break;
    default:
      printf("usage: ssim [-m] [-s] <object>\n");
      printf("       -m: trace m\n");
      printf("       -s: trace sparc\n");
      exit(1);
    }
  }

  printf("SPARC Integer Instruction Simulator\n");
  printf("Version %s\n", version());
  printf("trace_flag=0x%08.8x\n", flag);

  read_elf(prog);

  printf(" start_address=0x%08.8x\n", mofs);

  pc = mofs;
  npc = pc+4;
  for (i=0; i<8; i++)
    m[i] = &g[i];

  for (sparc_step=0LL;; sparc_step++) {
    opc = pc;
    if (pc - mofs >= MEMSIZE) {
      printf("Address too large: pc=0x%08.8x\n", pc);
      exit(1);
    }
    memp = &mem[pc - mofs];
    insn = *memp<<24 | *(memp+1)<<16 | *(memp+2)<<8 | *(memp+3);
    switch (insn >> 30) {
    case 0:
      sop = &insn00[insn>>22&7];
      break;
    case 1:
      sop = &insn01[0];
      break;
    case 2:
      sop = &insn10[insn>>19&63];
      break;
    case 3:
      sop = &insn11[insn>>19&63];
      break;
    }
    
    if (!annul) {
      (sop->func)(insn);
      if (flag & TRACE_SPARC)
	printf("SPARC:%08.8x [%08.8x]  %s\n", opc, addr, sop->name);
    }
    else { /* nop */
      pc = npc;
      npc += 4;     
      annul = 0;
      if (flag & TRACE_SPARC)
	printf("SPARC:%08.8x [%08.8x] (%s)\n", opc, addr, sop->name);
    }
  }
  
  exit(0);
}

char *
version()
{
  char *i;

  for (i=RcsId; *i && *i!=' '; i++);
  for (       ; *i && *i==' '; i++);
  for (       ; *i && *i!=' '; i++);
  for (       ; *i && *i==' '; i++);
  return(i);
}

