
static char svpcon_RcsId[] =
"$Id: svpcon.c,v 1.13 1996/11/29 12:35:23 nakashim Exp nakashim $";

/* M-on-RISC Dynamically Translating Simulator */
/*                                 SVP CONSOLE */
/*       Copyright (c) 1996 by FUJITSU LIMITED */
/*                 Primary writer: Y.Nakashima */
/*          nakashim@pine.mfd.cs.fujitsu.co.jp */

#include <stdio.h>
#include <errno.h>
#include <fcntl.h>
#include <sgtty.h>
#include <sys/signal.h>
#include "svpcon.h"

#ifdef SPARC
#include <sys/ttold.h>
unsigned int swap2(a) unsigned short a;
{ return (a); }

unsigned int swap3(a) unsigned int a;
{ return (a); }

unsigned int swap4(a) unsigned int a;
{ return (a); }
#endif

#ifdef INTEL
#include <termcap.h>
unsigned int swap2(a) unsigned short a;
{ return ((((a)&0xff)<<8)|((a)>>8)); }

unsigned int swap3(a) unsigned int a;
{ return ((((a)&0xff)<<16)|((a)&0xff00)|(a>>16)); }

unsigned int swap4(a) unsigned int a;
{ return (((a)<<24)|(((a)&0xff00)<<8)|(((a)&0xff0000)>>8)|((a)>>24)); }
#endif

char *
version()
{
  char *i;

  for (i=svpcon_RcsId; *i && *i!=' '; i++);
  for (              ; *i && *i==' '; i++);
  for (              ; *i && *i!=' '; i++);
  for (              ; *i && *i==' '; i++);
  return(i);
}

/* svpcon.c 1996/3/10 by Y.Nakashima */

typedef        long long unsigned llu;
void           onintr_sigwinch();
void           onintr_kbd();
void           onintr_emm();
char           *getenv();

#define        BUFFSIZE (1024)
unsigned char  cbuf[BUFFSIZE]; /* command buffer */
unsigned char  *cP;            /* pointer -> cbuf */
unsigned char  pbuf[BUFFSIZE]; /* pipe communication buffer */
unsigned char  *pP;            /* pointer -> pbuf */

struct ebuf {
  unsigned char  gst;          /* guest # */
  unsigned char  cpu;          /* cpu # */
  unsigned short cmd;          /* command */
  unsigned int   p1;           /* param 1 */
  unsigned int   p2;           /* param 2 */
  unsigned char  tc;           /* termination code */
  unsigned char  stat;         /* cpu status */
  unsigned short valid;        /* data validity */
  unsigned int   d[16];        /* data */
} ebufin, ebufout;             /* EMM communication buffer */

int	       pfd[2];	       /* PIPE */
int	       fd1, fd2;       /* coin, cout */
int            ppid;           /* parent process ID */
int            cpid;           /* child process ID */

char           logfile[32];    /* name of log_file */
FILE           *log_fp;        /* pointer -> logfile */
struct sgttyb  termiosArg;     /* termio arg */
struct sgttyb  termiosArg0;    /* termio arg */
struct sgttyb  termiosArg1;    /* termio arg */
int            sc_lines;       /* # of lines of terminal */
int            sc_noupdate;    /* redraw switch */
#ifdef IGNOREEOF
char           save_eofc;      /* old eofc */
#endif
int            sigwchint;      /* SIGWINCH interrupt */
int            kbdintr;        /* kbd interrupt */
int            emmrepl;        /* emm reply interrupt */

static unsigned char ascii[] = {
   0,  0,  0,  0,  0,'\t', 0,  0,  0,  0,  0,  0,  0,'\r', 0,  0,
   0,  0,  0,  0,  0,'\n', 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
  ' ', 0,  0,  0,  0,  0,  0,  0,  0,  0,  0, '.','<','(','+','|',
  '&', 0,  0,  0,  0,  0,  0,  0,  0,  0, '!','$','*',')',';','^',
  '-','/', 0,  0,  0,  0,  0,  0,  0,  0,  0, ',','%','_','>','?',
   0,  0,  0,  0,  0,  0,  0,  0,  0,  0, ':','#','@','\'','=','\"',/*"*/

   0, 'a','b','c','d','e','f','g','h','i', 0,  0,  0,  0,  0,  0,
   0, 'j','k','l','m','n','o','p','q','r', 0,  0,  0,  0,  0,  0,
   0, '~','s','t','u','v','w','x','y','z', 0,  0,  0, '[', 0,  0,
   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, ']', 0,  0,
  '{','A','B','C','D','E','F','G','H','I', 0,  0,  0,  0,  0,  0,
  '}','J','K','L','M','N','O','P','Q','R', 0,  0,  0,  0,  0,  0,
 '\\', 0, 'S','T','U','V','W','X','Y','Z', 0,  0,  0,  0,  0,  0,
  '0','1','2','3','4','5','6','7','8','9', 0,  0,  0,  0,  0,  0};

unsigned char e2adump[] = {
 '.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.',
 '.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.',
 '.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.',
 '.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.',
 ' ','.','.','.','.','.','.','.','.','.','.','.','<','(','+','|',
 '&','.','.','.','.','.','.','.','.','.','!','$','*',')',';','^',
 '-','/','.','.','.','.','.','.','.','.','.',',','%','_','>','?',
 '.','.','.','.','.','.','.','.','.','.',':','#','@','\'','=','\"',/*"*/
 '.','a','b','c','d','e','f','g','h','i','.','.','.','.','.','.',
 '.','j','k','l','m','n','o','p','q','r','.','.','.','.','.','.',
 '.','~','s','t','u','v','w','x','y','z','.','.','.','[','.','.',
 '.','.','.','.','.','.','.','.','.','.','.','.','.',']','.','.',
 '{','A','B','C','D','E','F','G','H','I','.','.','.','.','.','.',
 '}','J','K','L','M','N','O','P','Q','R','.','.','.','.','.','.',
'\\','.','S','T','U','V','W','X','Y','Z','.','.','.','.','.','.',
 '0','1','2','3','4','5','6','7','8','9','.','.','.','.','.','.'};

main(argc, argv)
     int  argc; 
     char **argv;
{
  switch (tgetent(cbuf, getenv("TERM"))) {
  case -1:
    fprintf(stderr, "can't read termcap\n");
    exit(1);
    break;
  case 0:
    fprintf(stderr, "can't find your terminal type in termcap\n");
    exit(1);
    break;
  default:
    sc_lines = tgetnum("li");
    break;
  }
  
  if (argc != 3) {
    fprintf(stderr, "usage: %s <in_file> <out_file>\n", argv[0]);
    exit(1);
  }
  if ((fd1=open(argv[1], O_RDONLY)) == -1) {
    fprintf(stderr, "can't open %s\n", argv[1]);
    exit(1);
  }
  if ((fd2=open(argv[2], O_WRONLY)) == -1) {
    fprintf(stderr, "can't open %s\n", argv[2]);
    exit(1);
  }
  if (pipe(pfd) == -1) {
    fprintf(stderr, "can't create pipe\n");
    exit(1);
  }
  sprintf(logfile ,"/tmp/.svplog%u", ppid = getpid());
  if ((log_fp = fopen(logfile, "w")) == NULL) {
    fprintf(stderr, "can't create \"%s\"\n", logfile);
    exit(1);
  }
  
  ioctl(fd1, TIOCGETP, &termiosArg);
  termiosArg.sg_flags |= RAW;
  termiosArg.sg_flags &= ~ECHO;
  termiosArg.sg_ispeed = B9600;
  ioctl(fd1, TIOCSETP, &termiosArg);

  ioctl(fd2, TIOCGETP, &termiosArg);
  termiosArg.sg_flags |= RAW;
  termiosArg.sg_flags &= ~ECHO;
  termiosArg.sg_ospeed = B9600;
  ioctl(fd2, TIOCSETP, &termiosArg);

  /* EMM communication process */
  if (cpid = fork()) {
    int i;

    signal(SIGWINCH, SIG_IGN);
    signal(SIGINT, SIG_IGN);
    signal(SIGUSR1, SIG_IGN);

    sleep(1);

    while (1) {
      for (i=0; i<sizeof(struct ebuf); i++) {
	if (read(fd1, (unsigned char *)&ebufin+i, 1) <= 0)
	  goto exit_read;
      }
      write(pfd[1], (unsigned char *)&ebufin, sizeof(struct ebuf));
      kill(cpid, SIGUSR1);
    }
exit_read:

    kill(cpid, SIGTERM);
    wait((union wait *)0);
  }

  /* KBD process */
  else {
    unsigned int  sw_amode=0; /* address mode 0:real,1<<31:virtual */
    unsigned int  sw_step, sw_disasm;
    unsigned int  addr, step, data, i, j;
    unsigned char c;

#ifdef IGNOREEOF
    ioctl(0, TIOCGETC, &TCHARS);
    save_eofc = TCHARS.t_eofc;
    TCHARS.t_eofc = 'w'-0x60;
    ioctl(0, TIOCSETC, &TCHARS);
#endif

    /* system("stty tabs"); */
    scr_setr(5);

#if sun
    sigset(SIGWINCH, onintr_sigwinch);
    sigset(SIGINT, onintr_kbd);   
    sigset(SIGUSR1, onintr_emm);
#else
    signal(SIGWINCH, onintr_sigwinch);
    signal(SIGINT, onintr_kbd);   
    signal(SIGUSR1, onintr_emm);
#endif    

    message("SVP CONSOLE Version %s\n", version());
    message(" logfile =\"%s\"\n", logfile);
    message(" SVP CONSOLE FULL-DUPLEX CONNECTION ESTABLISHED.\n");
      
    ebufout.gst = 0;
    ebufout.cpu = 0;
    addr = 0;
    step = 10;

    while (1) {
      sc_noupdate = 0;
      disp_stat();
      message("%01.1d.%01.1d%c-> ", ebufout.gst, ebufout.cpu, sw_amode?'V':'R');
      cbuf[0] = '\0';
      sigwchint = 0;
      kbdintr = 0;

      if (fgets(cP = cbuf, BUFFSIZE, stdin) == NULL) {
	if (!sigwchint)
	  goto exit_kbd;
      }
      log_output(cbuf);

      switch (*cP++) {
      case '\0':
      case '\r':
      case '\n':
      case ' ':
	break; /* do nothing */
	
      case 'h': /* help */
	message("^C ............... command stop\n");
	message("h ................ help\n");
	message("q ................ quit\n");
	message("l ................ display log\n");
	message("d [addr [step]] .. disassemble\n");
	message("m [addr [data]] .. dump/set guest memory\n");
	message("a [addr] ......... set IAR\n");
	message("g [addr] ......... go cpu\n");
	message("s [step] ......... step exec with no disasm\n");
	message("t [step] ......... step exec with disasm\n");
	message("k ................ stop cpu\n");
	message("\n");
	message("gst# cpu# ........ set current gst# cpu#\n");
	message("v [0|1] .......... set address mode [0:real,1:virtual]\n");
	message("c [num [data]] ... dump/set cr\n");
	message("b [num [addr]] ... dump/reset/set break-point\n");
	message("n [addr [data]] .. dump/set guest absolute memory\n");
	message("r ................ reset\n");
	message("R ................ clear reset\n");
	message("i [I/O addr] ..... ipl\n");
	message("I [I/O addr] ..... clear ipl\n");
	message("G ................ go guest\n");
	message("K ................ stop guest\n");
      break;

      case 'q': /* quit */
	goto exit_kbd;
	break;

      case 'l': /* display log */
	sprintf(cbuf, "lv '-P%%f(%%i of %%m) [line %%lb/%%L %%pB\\%%]$' +G %s", logfile);
	req_system(cbuf);
	break;
	
      case 'd': /* disassemble */
	sscanf(cP, "%x %d", &addr, &step);
	if (!step)
	  step = 1;
	for (i=0; i<step; i++) {
	  addr += disasm(sw_amode, addr);
	  if (kbdintr) {
	    message("!break\n");
	    kbdintr = 0;
	    break;
	  }
	}
	break;
	
      case 'm': /* dump/set guest memory */
	if (sscanf(cP, "%x %x", &addr, &data) == 2) {
	  if (emm_readmem(sw_amode|addr, 4))
	    break;
	  message("%06.6x: %08.8x -> %08.8x\n",
	 	  addr, swap4(ebufin.d[0]), data);
	  if (emm_writemem(sw_amode|addr, 4, &data))
	    break;
	}
	else {
	  if (emm_readmem(sw_amode|addr, 64))
	    break;
	  message("  addr +0 +1 +2 +3 +4 +5 +6 +7  ");
	  message("+8 +9 +a +b +c +d +e +f  ");
	  message("0123456789abcdef\n");
	  for (i = 0; i < 4; i++) {
	    message("%06.6x", addr);
	    for (j = 0; j < 16; j++) {
	      if (j == 8) message(" ");
	      message(" %02.2x", *((unsigned char *)&ebufin.d[0]+addr+j));
	    }
	    message("  ");
	    for (j = 0; j < 16; j++)
	      message("%c", e2adump[*((unsigned char *)&ebufin.d[0]+addr+j)]);
	    message("\n");
	    addr += 16;
	  }
	}
	break;

      case 'a': /* set IAR */
	if (sscanf(cP, "%x", &addr) == 1) {
	  if (emm_readenv())
	    break;
	  if (emm_writeenv(swap4(ebufin.d[0]), (swap4(ebufin.d[1])&0x80000000)|addr,
			   swap4(ebufin.d[2]), swap4(ebufin.d[3])))
	    break;
	}
	break;
	
      case 'g': /* go cpu */
      case 's': /* step exec with no disasm */
      case 't': /* step exec with disasm */
	if (*(cP-1) == 's' || *(cP-1) == 't')
	  sw_step = 1;
	else
	  sw_step = 0;
	if (*(cP-1) == 't')
	  sw_disasm = 1;
	else
	  sw_disasm = 0;
	if (sw_step) {
	  sscanf(cP, "%d", &step);
	  if (!step)
	    step = 1;
	  for (i=0; i<step; i++) {
	    if (sw_disasm) {
	      if (emm_readenv())
		break;
	      disasm(sw_amode, swap4(ebufin.d[1])&0x7fffffff);
	    }
	    emm_step(1);
	    disp_stat();
	    if (kbdintr) {
	      message("!break\n");
	      kbdintr = 0;
	      break;
	    }
	  }
	}
	else {
	  if (sscanf(cP, "%x", &addr) == 1) {
	    if (emm_readenv())
	      break;
	    if (emm_writeenv(swap4(ebufin.d[0]), (swap4(ebufin.d[1])&0x80000000)|addr,
			     swap4(ebufin.d[2]), swap4(ebufin.d[3])))
	      break;
	  }
	  emm_start();
	}
	break;
	
      case 'k': /* stop cpu */
        message("sending stop cpu request...");
        if (!emm_stop())
          message("...done\n");
	break;

      case '0': /* set current gst# cpu# */
      case '1':
      case '2':
      case '3':
	cP--;
	i = ebufout.gst;
	j = ebufout.cpu;
	sscanf(cP, "%d %d", &i, &j);
	ebufout.gst = i;
	ebufout.cpu = j;
	break;

      case 'v': /* set address mode [0:real,1:virtual] */
	sscanf(cP, "%d", &sw_amode);
	if (sw_amode)
	  sw_amode = 0x80000000;
	break;

      case 'c': /* dump/set cr */
	if (sscanf(cP, "%d %x", &addr, &data) == 2) {
	  if (emm_readcr())
	    break;
	  message("cr%-2d: %08.8x -> %08.8x\n",
	 	  addr&15, swap4(ebufin.d[addr&15]), data);
	  if (emm_writecr(addr&15, data))
	    break;
	}
	else {
	  if (emm_readcr())
	    break;
	  for (i = 0; i < 4; i++) {
	    message("cr%-2d: ", i*4);
	    for (j = 0; j < 4; j++)
	      message(" %08.8x", swap4(ebufin.d[i*4+j]));
	    message("\n");
	  }
	}
	break;

      case 'b': /* dump/reset/set break-point */
	switch (sscanf(cP, "%d %x", &addr, &data)) {
	case 1: /* reset break-point */
	  if (emm_dispbp())
	    break;
	  if (swap2(ebufin.valid)&(0x00008000 >> (addr&15)))
	    message("bp%-2d: %08.8x -> --------\n",
		    addr&15, swap4(ebufin.d[addr&15]));
	  else
	    message("bp%-2d: -------- -> --------\n",
		    addr&15);
	  if (emm_resetbp(addr&15))
	    break;
	  break;
	case 2: /* set break-point */
	  if (emm_dispbp())
	    break;
	  if (swap2(ebufin.valid)&(0x00008000 >> (addr&15)))
	    message("bp%-2d: %08.8x -> %08.8x\n",
		    addr&15, swap4(ebufin.d[addr&15]), data);
	  else
	    message("bp%-2d: -------- -> %08.8x\n",
		    addr&15, data);
	  if (emm_setbp(addr&15, sw_amode|data))
	    break;
	  break;
	default: /* dump break-point */
	  if (emm_dispbp())
	    break;
	  for (i = 0; i < 4; i++) {
	    message("bp%-2d: ", i*4);
	    for (j = 0; j < 4; j++) {
	      if (swap2(ebufin.valid)&(0x00008000 >> i*4+j))
		message(" %08.8x", swap4(ebufin.d[i*4+j]));
	      else
		message(" --------");
	    }
	    message("\n");
	  }
	  break;
	}
	break;

      case 'n': /* dump/set guest absolute memory */
	if (sscanf(cP, "%x %x", &addr, &data) == 2) {
	  if (emm_readabs(addr, 4))
	    break;
	  message("%06.6x: %08.8x -> %08.8x\n",
	 	  addr, swap4(ebufin.d[0]), data);
	  if (emm_writeabs(addr, 4, &data))
	    break;
	}
	else {
	  if (emm_readabs(addr, 64))
	    break;
	  message("  addr +0 +1 +2 +3 +4 +5 +6 +7  ");
	  message("+8 +9 +a +b +c +d +e +f  ");
	  message("0123456789abcdef\n");
	  for (i = 0; i < 4; i++) {
	    message("%06.6x", addr);
	    for (j = 0; j < 16; j++) {
	      if (j == 8) message(" ");
	      message(" %02.2x", *((unsigned char *)&ebufin.d[0]+addr+j));
	    }
	    message("  ");
	    for (j = 0; j < 16; j++)
	      message("%c", e2adump[*((unsigned char *)&ebufin.d[0]+addr+j)]);
	    message("\n");
	    addr += 16;
	  }
	}
	break;

      case 'r': /* reset */
	message("RESET starting...");
	if (!emm_reset(addr))
	  message("...done\n");
	break;

      case 'R': /* clear reset */
	message("CLEAR RESET starting...");
	if (!emm_resetclr(addr))
	  message("...done\n");
	break;

      case 'i': /* ipl */
	if (sscanf(cP, "%x", &addr) == 1) {
	  message("IPL (I/O addr=%04.4x) starting...", addr);
	  if (!emm_ipl(addr))
	    message("...done\n");
	}
	break;

      case 'I': /* clear ipl */
	if (sscanf(cP, "%x", &addr) == 1) {
	  message("CLEAR IPL (I/O addr=%04.4x) starting...", addr);
	  if (!emm_iplclr(addr))
	    message("...done\n");
	}
	break;

      case 'G': /* go guest */
	emm_startgst();
	break;

      case 'K': /* stop guest */
        message("sending stop guest request...");
        if (!emm_stopgst())
          message("...done\n");
	break;

      default:
	message("unknown command: \"%c\"\n", *(cP-1));
	break;
      }
    }
exit_kbd:

#ifdef IGNOREEOF
    TCHARS.t_eofc = save_eofc;
    ioctl(0, TIOCSETC, &TCHARS);
#endif
    /* system("stty -tabs"); */
    scr_reset();
    unlink(logfile);
    kill(ppid, SIGTERM);
  }

  exit(0);
}

disp_stat()
{
  int             i, j;
  unsigned        nm[16];
  llu             nf[8];
  llu             npsw;
  unsigned int    npx, nfcr;
  static unsigned m[16];
  static llu      f[8];

  if (emm_readgr())
    return;
  for (i=0; i<16; i++)
    nm[i] = swap4(ebufin.d[i]);

  if (emm_readfr())
    return;
  for (i=0; i<8; i++)
    nf[i] = (llu)swap4(ebufin.d[i*2])<<32|(llu)swap4(ebufin.d[i*2+1]);

  if (emm_readenv())
    return;
  npsw = (llu)swap4(ebufin.d[0])<<32|(llu)swap4(ebufin.d[1]);
  npx  = swap4(ebufin.d[2]);
  nfcr = swap4(ebufin.d[3]);

  if (!sc_noupdate || m[0] != nm[0] || m[1] != nm[1] || m[2] != nm[2] || m[3] != nm[3]
                   || f[0] != nf[0] || f[1] != nf[1]) {
    scr_move(1);
    fprintf(stderr, "m0: %08.8x %08.8x %08.8x %08.8x ",
	   nm[0], nm[1], nm[2], nm[3]);
    fprintf(stderr, "f0: %08.8x-%08.8x %08.8x-%08.8x",
	   (int)(nf[0]>>32), (int)nf[0],
	   (int)(nf[1]>>32), (int)nf[1]);
    scr_eol();
  }

  if (!sc_noupdate || m[4] != nm[4] || m[5] != nm[5] || m[6] != nm[6] || m[7] != nm[7]
                   || f[2] != nf[2] || f[3] != nf[3]) {
    scr_move(2);
    fprintf(stderr, "m4: %08.8x %08.8x %08.8x %08.8x ",
	   nm[4], nm[5], nm[6], nm[7]);
    fprintf(stderr, "f4: %08.8x-%08.8x %08.8x-%08.8x",
	   (int)(nf[2]>>32), (int)nf[2],
	   (int)(nf[3]>>32), (int)nf[3]);
    scr_eol();
  }

  if (!sc_noupdate || m[8] != nm[8] || m[9] != nm[9] || m[10] != nm[10] || m[11] != nm[11]
                   || f[4] != nf[4] || f[5] != nf[5]) {
    scr_move(3);
    fprintf(stderr, "m8: %08.8x %08.8x %08.8x %08.8x ",
	   nm[8], nm[9], nm[10], nm[11]);
    fprintf(stderr, "f8: %08.8x-%08.8x %08.8x-%08.8x",
	   (int)(nf[4]>>32), (int)nf[4],
	   (int)(nf[5]>>32), (int)nf[5]);
    scr_eol();
  }

  if (!sc_noupdate || m[12] != nm[12] || m[13] != nm[13] || m[14] != nm[14] || m[15] != nm[15]
                   || f[ 6] != nf[ 6] || f[ 7] != nf[ 7]) {
    scr_move(4);
    fprintf(stderr, "m12 %08.8x %08.8x %08.8x %08.8x ",
	   nm[12], nm[13], nm[14], nm[15]);
    fprintf(stderr, "f12 %08.8x-%08.8x %08.8x-%08.8x",
	   (int)(nf[6]>>32), (int)nf[6],
	   (int)(nf[7]>>32), (int)nf[7]);
    scr_eol();
  }

#ifdef SPECIALBOTTOM
  scr_move(sc_lines-1);
#else
  scr_move(sc_lines);
#endif
  fprintf(stderr, "\033[36;2mPSW=%08.8x-%08.8x PX=%08.8x FCR=%08.8x STAT=%02.2x\033[0;0m",
	 (int)(npsw>>32), (int)npsw, npx, nfcr, ebufin.stat);
  scr_eol();

  scr_bot();

  sc_noupdate = 1;
  for (i=0; i<16; i++)
    m[i] = nm[i];
  for (i=0; i<8; i++)
    f[i] = nf[i];
}

disasm(sw_amode, addr)
  unsigned sw_amode, addr;
{
  struct op        *optblp;
  unsigned char    opcd;
  char             *args;
  int              mlen;
  llu              insn;

  if (emm_readmem(sw_amode|addr, 8))
    return(2);

  optblp = optable;
  opcd = *(unsigned char *)&ebufin.d[0];

  if (optblp[opcd].optbl) {
    optblp = optblp[opcd].optbl;
    opcd = *((unsigned char *)&ebufin.d[0]+1);
  }

  args = optblp[opcd].args;
  mlen = optblp[opcd].mlen;
  insn = 0LL;

  switch (mlen) {
  case 6:
    insn |= (llu)*((unsigned char *)&ebufin.d[0]+5) << 16;
    insn |= (llu)*((unsigned char *)&ebufin.d[0]+4) << 24;
  case 4:
    insn |= (llu)*((unsigned char *)&ebufin.d[0]+3) << 32;
    insn |= (llu)*((unsigned char *)&ebufin.d[0]+2) << 40;
  case 2:
    insn |= (llu)*((unsigned char *)&ebufin.d[0]+1) << 48;
    insn |= (llu)*((unsigned char *)&ebufin.d[0]  ) << 56;
    break;
  default:
    message("internal error: optblp[0x%02.2x].mlen=%d\n", opcd, mlen);
    return(2);
    break;
  }

  switch (mlen) {
  case 6:
    message("%06.6x: %04.4x %04.4x %04.4x %-6s",
      addr,
      (int)((insn >> 48) & 0xffff),
      (int)((insn >> 32) & 0xffff),
      (int)((insn >> 16) & 0xffff),
      optblp[opcd].name);
    break;
  case 4:
    message("%06.6x: %04.4x %04.4x      %-6s",
      addr,
      (int)((insn >> 48) & 0xffff),
      (int)((insn >> 32) & 0xffff),
      optblp[opcd].name);
    break;
  case 2:
    message("%06.6x: %04.4x           %-6s",
      addr,
      (int)((insn >> 48) & 0xffff),
      optblp[opcd].name);
    break;
  }

  for(;;) {
    switch (*args++) {
    case '\0':
      message("\n");
      return(mlen);
      break;
    case ',':
      message(",");
      break;
    case '1': /* r1 */
      message("%d", (int)((insn >> 52) & 0xf));
      break;
    case '2': /* r2 */
      message("%d", (int)((insn >> 48) & 0xf));
      break;
    case '3': /* dxr-r1 */
      message("%d", (int)((insn >> 36) & 0xf));
      break;
    case '4': /* dxr-r2 */
      message("%d", (int)((insn >> 32) & 0xf));
      break;
    case 'a': /* d2(x2,b2) */
      message("%d(%d,%d)",
        (int)((insn >> 32) & 0xfff),
        (int)((insn >> 48) & 0xf),
        (int)((insn >> 44) & 0xf));
      break;
    case 'b': /* d1(b1)/d2(b2) */
      message("%d(%d)",
        (int)((insn >> 32) & 0xfff),
        (int)((insn >> 44) & 0xf));
      break;
    case 'c': /* d1(l,b1) */
      message("%d(%d,%d)",
        (int)((insn >> 32) & 0xfff),
        (int)((insn >> 48) & 0xff)+1,
        (int)((insn >> 44) & 0xf));
      break;
    case 'd': /* d2(b2) */
      message("%d(%d)",
        (int)((insn >> 16) & 0xfff),
        (int)((insn >> 28) & 0xf));
      break;
    case 'f': /* d1(l1,b1) */
      message("%d(%d,%d)",
        (int)((insn >> 32) & 0xfff),
        (int)((insn >> 52) & 0xf)+1,
        (int)((insn >> 44) & 0xf));
      break;
    case 'g': /* d2(l2,b2) */
      message("%d(%d,%d)",
        (int)((insn >> 16) & 0xfff),
        (int)((insn >> 48) & 0xf)+1,
        (int)((insn >> 28) & 0xf));
      break;
    case 'i': /* i2 */
      message("%d", (int)((insn >> 48) & 0xff));
      break;
    case 'j': /* i3 */
      message("%d", (int)((insn >> 48) & 0xf));
      break;
    case 'm': /* m1 */
      message("%d", (int)((insn >> 52) & 0xf));
      break;
    case 'n': /* m3 */
      message("%d", (int)((insn >> 48) & 0xf));
      break;
    case 'x': /* diagnose */
      message("%d", (int)((insn >> 32) & 0xffffff));
      break;
    default:
      message("internal error: optblp[0x%02.2x].args=\"%s\"\n", opcd, optblp[opcd].args);
      return(mlen);
      break;
    }
  }
}

log_output(s, i, j, k, l, m)
  char *s;
  int  i, j, k, l, m;
{
  fprintf(log_fp, s, i, j, k, l, m);
  fflush(log_fp);
}

message(s, i, j, k, l, m)
  char *s;
  int  i, j, k, l, m;
{
  log_output(s, i, j, k, l, m);
  fprintf(stderr, s, i, j, k, l, m);
}

scr_up()
{
  fprintf(stderr, "\033[%uH\n", sc_lines);
}

scr_eol()
{
  fprintf(stderr, "\033[K");
}

scr_move(r) {
  fprintf(stderr, "\033[%uH", r);
}

scr_setr(r)
{
  fprintf(stderr, "\033[%uH\033[K", sc_lines);
#ifdef SPECIALBOTTOM
  fprintf(stderr, "\033[%u;%ur", r, sc_lines-2);
#else
  fprintf(stderr, "\033[%u;%ur", r, sc_lines-1);
#endif
  scr_bot();
  scr_eol();
}

scr_reset()
{
  fprintf(stderr, "\033[1;%ur", sc_lines);
#ifdef SPECIALBOTTOM
  fprintf(stderr, "\033[%uH", sc_lines-1);
#else
  fprintf(stderr, "\033[%uH", sc_lines);
#endif
  fflush(stdout);
}

scr_bot()
{
#ifdef SPECIALBOTTOM
  fprintf(stderr, "\033[%uH", sc_lines-2);
#else
  fprintf(stderr, "\033[%uH", sc_lines-1);
#endif
  fflush(stdout);
}

req_system(s) char *s;
{     
  scr_reset();
  if (system(s) == -1)
    message("can't fork \"%s\"\n", s);
#ifdef SPECIALBOTTOM
  scr_up();
#endif
  scr_setr(5);
}         

void
onintr_sigwinch()
{
  struct winsize ws;

  if (ioctl (1, TIOCGWINSZ, &ws) != -1) {
    if (ws.ws_row != 0)
      sc_lines = ws.ws_row;
  }
  scr_reset();
  scr_setr(5);
  sigwchint = 1;
}

void
onintr_kbd()
{
  kbdintr = 1;
}

void
onintr_emm()
{
  int i;
  
  for (i=0; i<sizeof(struct ebuf); i++)
    read(pfd[0], (unsigned char *)&ebufin+i, 1);

  switch (ebufin.cmd) {      
  case 0x0001: /* asynchronous status change */
    message("%01.1d.%01.1d: cpu state -> %02.2x\n", ebufin.gst, ebufin.cpu, ebufin.stat);
    break;
  case 0x0002: /* asynchronous write console */
    for (i=0; i<64; i++)
      *((unsigned char *)&ebufin.d[0]+i) = ascii[*((unsigned char *)&ebufin.d[0]+i)];
    *((unsigned char *)&ebufin.d[0]+63) = (unsigned char)0;
    message("WRITE CONSOLE: %s\n", *((unsigned char *)&ebufin.d[0]+i));
    break;
  default:
    emmrepl = 1;
    break;
  }
}

emm_start()
{
  ebufout.cmd   = swap2(0x0011);
  ebufout.p1    = swap4(0);
  ebufout.p2    = swap4(0);
  ebufout.tc    = 0;
  ebufout.stat  = 0;
  ebufout.valid = swap2(0x0000);
  emmrepl = 0;
  write(fd2, (unsigned char *)&ebufout, sizeof(struct ebuf));
  while (!emmrepl);
  if (ebufin.tc)
    message("emm_start: tc=%d (error)\n", ebufin.tc);
  return((int)ebufin.tc);
}

emm_step(step)
     unsigned int step;
{
  ebufout.cmd   = swap2(0x0012);
  ebufout.p1    = swap4(step-1);
  ebufout.p2    = swap4(0);
  ebufout.tc    = 0;
  ebufout.stat  = 0;
  ebufout.valid = swap2(0x0000);
  emmrepl = 0;
  write(fd2, (unsigned char *)&ebufout, sizeof(struct ebuf));
  while (!emmrepl);
  if (ebufin.tc)
    message("emm_step: tc=%d (error)\n", ebufin.tc);
  return((int)ebufin.tc);
}

emm_stop()
{
  ebufout.cmd   = swap2(0x0013);
  ebufout.p1    = swap4(0);
  ebufout.p2    = swap4(0);
  ebufout.tc    = 0;
  ebufout.stat  = 0;
  ebufout.valid = swap2(0x0000);
  emmrepl = 0;
  write(fd2, (unsigned char *)&ebufout, sizeof(struct ebuf));
  while (!emmrepl);
  if (ebufin.tc)
    message("emm_stop: tc=%d (error)\n", ebufin.tc);
  return((int)ebufin.tc);
}

emm_setbp(id, addr)
     unsigned int id, addr;
{
  ebufout.cmd   = swap2(0x0014);
  ebufout.p1    = swap4(id);
  ebufout.p2    = swap4(addr);
  ebufout.tc    = 0;
  ebufout.stat  = 0;
  ebufout.valid = swap2(0x0000);
  emmrepl = 0;
  write(fd2, (unsigned char *)&ebufout, sizeof(struct ebuf));
  while (!emmrepl);
  if (ebufin.tc)
    message("emm_setbp: tc=%d (error)\n", ebufin.tc);
  return((int)ebufin.tc);
}

emm_resetbp(id)
     unsigned int id;
{
  ebufout.cmd   = swap2(0x0015);
  ebufout.p1    = swap4(id);
  ebufout.p2    = swap4(0);
  ebufout.tc    = 0;
  ebufout.stat  = 0;
  ebufout.valid = swap2(0x0000);
  emmrepl = 0;
  write(fd2, (unsigned char *)&ebufout, sizeof(struct ebuf));
  while (!emmrepl);
  if (ebufin.tc)
    message("emm_resetbp: tc=%d (error)\n", ebufin.tc);
  return((int)ebufin.tc);
}

emm_dispbp()
{
  ebufout.cmd   = swap2(0x0016);
  ebufout.p1    = swap4(0);
  ebufout.p2    = swap4(0);
  ebufout.tc    = 0;
  ebufout.stat  = 0;
  ebufout.valid = swap2(0x0000);
  emmrepl = 0;
  write(fd2, (unsigned char *)&ebufout, sizeof(struct ebuf));
  while (!emmrepl);
  if (ebufin.tc)
    message("emm_dispbp: tc=%d (error)\n", ebufin.tc);
  return((int)ebufin.tc);
}

emm_readmem(addr, len)
     unsigned int addr, len;
{
  ebufout.cmd   = swap2(0x0020);
  ebufout.p1    = swap4(addr);
  ebufout.p2    = swap4(len-1);
  ebufout.tc    = 0;
  ebufout.stat  = 0;
  ebufout.valid = swap2(0x0000);
  emmrepl = 0;
  write(fd2, (unsigned char *)&ebufout, sizeof(struct ebuf));
  while (!emmrepl);
  if (ebufin.tc)
    message("emm_readmem: tc=%d (error)\n", ebufin.tc);
  return((int)ebufin.tc);
}

emm_writemem(addr, len, d)
     unsigned int addr, len, d[];
{
  int i;
  int valid = 0xffff0000 >> (((len-1)>>2)+1);

  ebufout.cmd   = swap2(0x0021);
  ebufout.p1    = swap4(addr);
  ebufout.p2    = swap4(len-1);
  ebufout.tc    = 0;
  ebufout.stat  = 0;
  ebufout.valid = swap2(valid);
  for (i=0; i<((len-1)>>2)+1; i++)
    ebufout.d[i] = swap4(d[i]);
  emmrepl = 0;
  write(fd2, (unsigned char *)&ebufout, sizeof(struct ebuf));
  while (!emmrepl);
  if (ebufin.tc)
    message("emm_writemem: tc=%d (error)\n", ebufin.tc);
  return((int)ebufin.tc);
}

emm_readenv()
{
  ebufout.cmd   = swap2(0x0022);
  ebufout.p1    = swap4(0);
  ebufout.p2    = swap4(0);
  ebufout.tc    = 0;
  ebufout.stat  = 0;
  ebufout.valid = swap2(0x0000);
  emmrepl = 0;
  write(fd2, (unsigned char *)&ebufout, sizeof(struct ebuf));
  while (!emmrepl);
  if (ebufin.tc)
    message("emm_readenv: tc=%d (error)\n", ebufin.tc);
  return((int)ebufin.tc);
}

emm_writeenv(psw0, psw1, px, fcr)
     unsigned int psw0, psw1, px, fcr;
{
  ebufout.cmd   = swap2(0x0023);
  ebufout.p1    = swap4(0);
  ebufout.p2    = swap4(0);
  ebufout.tc    = 0;
  ebufout.stat  = 0;
  ebufout.valid = swap2(0xf000);
  ebufout.d[0]  = swap4(psw0);
  ebufout.d[1]  = swap4(psw1);
  ebufout.d[2]  = swap4(px);
  ebufout.d[3]  = swap4(fcr);
  emmrepl = 0;
  write(fd2, (unsigned char *)&ebufout, sizeof(struct ebuf));
  while (!emmrepl);
  if (ebufin.tc)
    message("emm_writeenv: tc=%d (error)\n", ebufin.tc);
  return((int)ebufin.tc);
}

emm_readcr()
{
  ebufout.cmd   = swap2(0x0024);
  ebufout.p1    = swap4(0);
  ebufout.p2    = swap4(0);
  ebufout.tc    = 0;
  ebufout.stat  = 0;
  ebufout.valid = swap2(0x0000);
  emmrepl = 0;
  write(fd2, (unsigned char *)&ebufout, sizeof(struct ebuf));
  while (!emmrepl);
  if (ebufin.tc)
    message("emm_readcr: tc=%d (error)\n", ebufin.tc);
  return((int)ebufin.tc);
}

emm_writecr(num, data)
     unsigned int num, data;
{
  int valid = 0x00008000 >> num;

  ebufout.cmd   = swap2(0x0025);
  ebufout.p1    = swap4(0);
  ebufout.p2    = swap4(0);
  ebufout.tc    = 0;
  ebufout.stat  = 0;
  ebufout.valid = swap2(valid);
  ebufout.d[num] = swap4(data);
  emmrepl = 0;
  write(fd2, (unsigned char *)&ebufout, sizeof(struct ebuf));
  while (!emmrepl);
  if (ebufin.tc)
    message("emm_writecr: tc=%d (error)\n", ebufin.tc);
  return((int)ebufin.tc);
}

emm_readgr()
{
  ebufout.cmd   = swap2(0x0026);
  ebufout.p1    = swap4(0);
  ebufout.p2    = swap4(0);
  ebufout.tc    = 0;
  ebufout.stat  = 0;
  ebufout.valid = swap2(0x0000);
  emmrepl = 0;
  write(fd2, (unsigned char *)&ebufout, sizeof(struct ebuf));
  while (!emmrepl);
  if (ebufin.tc)
    message("emm_readgr: tc=%d (error)\n", ebufin.tc);
  return((int)ebufin.tc);
}

emm_readfr()
{
  ebufout.cmd   = swap2(0x0028);
  ebufout.p1    = swap4(0);
  ebufout.p2    = swap4(0);
  ebufout.tc    = 0;
  ebufout.stat  = 0;
  ebufout.valid = swap2(0x0000);
  emmrepl = 0;
  write(fd2, (unsigned char *)&ebufout, sizeof(struct ebuf));
  while (!emmrepl);
  if (ebufin.tc)
    message("emm_readfr: tc=%d (error)\n", ebufin.tc);
  return((int)ebufin.tc);
}

emm_reset()
{
  ebufout.cmd   = swap2(0x0100);
  ebufout.p1    = swap4(0);
  ebufout.p2    = swap4(0);
  ebufout.tc    = 0;
  ebufout.stat  = 0;
  ebufout.valid = swap2(0x0000);
  emmrepl = 0;
  write(fd2, (unsigned char *)&ebufout, sizeof(struct ebuf));
  while (!emmrepl);
  if (ebufin.tc)
    message("emm_reset: tc=%d (error)\n", ebufin.tc);
  return((int)ebufin.tc);
}

emm_resetclr()
{
  ebufout.cmd   = swap2(0x0101);
  ebufout.p1    = swap4(0);
  ebufout.p2    = swap4(0);
  ebufout.tc    = 0;
  ebufout.stat  = 0;
  ebufout.valid = swap2(0x0000);
  emmrepl = 0;
  write(fd2, (unsigned char *)&ebufout, sizeof(struct ebuf));
  while (!emmrepl);
  if (ebufin.tc)
    message("emm_resetclr: tc=%d (error)\n", ebufin.tc);
  return((int)ebufin.tc);
}

emm_ipl(addr)
     unsigned int addr;
{
  ebufout.cmd   = swap2(0x0102);
  ebufout.p1    = swap4(addr);
  ebufout.p2    = swap4(0);
  ebufout.tc    = 0;
  ebufout.stat  = 0;
  ebufout.valid = swap2(0x0000);
  emmrepl = 0;
  write(fd2, (unsigned char *)&ebufout, sizeof(struct ebuf));
  while (!emmrepl);
  if (ebufin.tc)
    message("emm_ipl: tc=%d (error)\n", ebufin.tc);
  return((int)ebufin.tc);
}

emm_iplclr(addr)
     unsigned int addr;
{
  ebufout.cmd   = swap2(0x0103);
  ebufout.p1    = swap4(addr);
  ebufout.p2    = swap4(0);
  ebufout.tc    = 0;
  ebufout.stat  = 0;
  ebufout.valid = swap2(0x0000);
  emmrepl = 0;
  write(fd2, (unsigned char *)&ebufout, sizeof(struct ebuf));
  while (!emmrepl);
  if (ebufin.tc)
    message("emm_iplclr: tc=%d (error)\n", ebufin.tc);
  return((int)ebufin.tc);
}

emm_startgst()
{
  ebufout.cmd   = swap2(0x0111);
  ebufout.p1    = swap4();
  ebufout.p2    = swap4(0);
  ebufout.tc    = 0;
  ebufout.stat  = 0;
  ebufout.valid = swap2(0x0000);
  emmrepl = 0;
  write(fd2, (unsigned char *)&ebufout, sizeof(struct ebuf));
  while (!emmrepl);
  if (ebufin.tc)
    message("emm_startget: tc=%d (error)\n", ebufin.tc);
  return((int)ebufin.tc);
}

emm_stopgst()
{
  ebufout.cmd   = swap2(0x0113);
  ebufout.p1    = swap4();
  ebufout.p2    = swap4(0);
  ebufout.tc    = 0;
  ebufout.stat  = 0;
  ebufout.valid = swap2(0x0000);
  emmrepl = 0;
  write(fd2, (unsigned char *)&ebufout, sizeof(struct ebuf));
  while (!emmrepl);
  if (ebufin.tc)
    message("emm_stopget: tc=%d (error)\n", ebufin.tc);
  return((int)ebufin.tc);
}

emm_readabs(addr, len)
     unsigned int addr, len;
{
  ebufout.cmd   = swap2(0x0120);
  ebufout.p1    = swap4(addr);
  ebufout.p2    = swap4(len-1);
  ebufout.tc    = 0;
  ebufout.stat  = 0;
  ebufout.valid = swap2(0x0000);
  emmrepl = 0;
  write(fd2, (unsigned char *)&ebufout, sizeof(struct ebuf));
  while (!emmrepl);
  if (ebufin.tc)
    message("emm_readabs: tc=%d (error)\n", ebufin.tc);
  return((int)ebufin.tc);
}

emm_writeabs(addr, len, d)
     unsigned int addr, len, d[];
{
  int i;
  int valid = 0xffff0000 >> (((len-1)>>2)+1);

  ebufout.cmd   = swap2(0x0121);
  ebufout.p1    = swap4(addr);
  ebufout.p2    = swap4(len-1);
  ebufout.tc    = 0;
  ebufout.stat  = 0;
  ebufout.valid = swap2(valid);
  for (i=0; i<((len-1)>>2)+1; i++)
    ebufout.d[i] = swap4(d[i]);
  emmrepl = 0;
  write(fd2, (unsigned char *)&ebufout, sizeof(struct ebuf));
  while (!emmrepl);
  if (ebufin.tc)
    message("emm_writeabs: tc=%d (error)\n", ebufin.tc);
  return((int)ebufin.tc);
}
