
/* M-on-RISC Dynamically Translating Simulator */
/*                                 SVP CONSOLE */
/*	 Copyright (C) 1995 by FUJITSU LIMITED */
/*		   Primary writer: Y.Nakashima */
/*	    nakashim@pine.mfd.cs.fujitsu.co.jp */

/* dim.h 1995/7/18 */

/*  *args			  */
/*	1:	  r1		  */
/*	2:	  r2		  */
/*	3:	  dxr-r1	  */
/*	4:	  dxr-r2	  */
/*	a:	  d2(x2,b2)	  */
/*	b:	  d1(b1)/d2(b2)	  */
/*	c:	  d1(l,b1)	  */
/*	d:	  d2(b2)	  */
/*	f:	  d1(l1,b1)	  */
/*	g:	  d2(l2,b2)	  */
/*	i:	  i		  */
/*	j:	  i3		  */
/*	m:	  m1		  */
/*	n:	  m3		  */
/*	x:	  diagnose	  */

#define	opn_OPX2	"??"	/* 00 */
#define	opa_OPX2	""	/* 00 */
#define	opn_OPX4	"????"	/* 00 */
#define	opa_OPX4	""	/* 00 */
#define	opn_OPX6	"??????"/* 00 */
#define	opa_OPX6	""	/* 00 */

#define	opn_spm 	"SPM"	/* 04 */
#define	opa_spm 	"1"	/* 04 */
#define	opn_balr	"BALR"	/* 05 */
#define	opa_balr	"1,2"	/* 05 */
#define	opn_bctr	"BCTR"	/* 06 */
#define	opa_bctr	"1,2"	/* 06 */
#define	opn_bcr 	"BCR"	/* 07 */
#define	opa_bcr 	"m,2"	/* 07 */
#define	opn_ssk 	"SSK"	/* 08 */
#define	opa_ssk 	"1,2"	/* 08 */
#define	opn_isk 	"ISK"	/* 09 */
#define	opa_isk 	"1,2"	/* 09 */
#define	opn_svc 	"SVC"	/* 0a */
#define	opa_svc 	"i"	/* 0a */
#define	opn_bsm 	"BSM"	/* 0b */
#define	opa_bsm 	"1,2"	/* 0b */
#define	opn_bassm	"BASSM"	/* 0c */
#define	opa_bassm	"1,2"	/* 0c */
#define	opn_basr	"BASR"	/* 0d */
#define	opa_basr	"1,2"	/* 0d */
#define	opn_mvcl	"MVCL"	/* 0e */
#define	opa_mvcl	"1,2"	/* 0e */
#define	opn_clcl	"CLCL"	/* 0f */
#define	opa_clcl	"1,2"	/* 0f */

#define	opn_lpr 	"LPR"	/* 10 */
#define	opa_lpr 	"1,2"	/* 10 */
#define	opn_lnr 	"LNR"	/* 11 */
#define	opa_lnr 	"1,2"	/* 11 */
#define	opn_ltr 	"LTR"	/* 12 */
#define	opa_ltr 	"1,2"	/* 12 */
#define	opn_lcr 	"LCR"	/* 13 */
#define	opa_lcr 	"1,2"	/* 13 */
#define	opn_nr		"NR"	/* 14 */
#define	opa_nr		"1,2"	/* 14 */
#define	opn_clr 	"CLR"	/* 15 */
#define	opa_clr 	"1,2"	/* 15 */
#define	opn_or		"OR"	/* 16 */
#define	opa_or		"1,2"	/* 16 */
#define	opn_xr		"XR"	/* 17 */
#define	opa_xr		"1,2"	/* 17 */
#define	opn_lr		"LR"	/* 18 */
#define	opa_lr		"1,2"	/* 18 */
#define	opn_cr		"CR"	/* 19 */
#define	opa_cr		"1,2"	/* 19 */
#define	opn_ar		"AR"	/* 1a */
#define	opa_ar		"1,2"	/* 1a */
#define	opn_sr		"SR"	/* 1b */
#define	opa_sr		"1,2"	/* 1b */
#define	opn_mr		"MR"	/* 1c */
#define	opa_mr		"1,2"	/* 1c */
#define	opn_dr		"DR"	/* 1d */
#define	opa_dr		"1,2"	/* 1d */
#define	opn_alr 	"ALR"	/* 1e */
#define	opa_alr 	"1,2"	/* 1e */
#define	opn_slr 	"SLR"	/* 1f */
#define	opa_slr 	"1,2"	/* 1f */

#define	opn_lpdr	"LPDR"	/* 20 */
#define	opa_lpdr	"1,2"	/* 20 */
#define	opn_lndr	"LNDR"	/* 21 */
#define	opa_lndr	"1,2"	/* 21 */
#define	opn_ltdr	"LTDR"	/* 22 */
#define	opa_ltdr	"1,2"	/* 22 */
#define	opn_lcdr	"LCDR"	/* 23 */
#define	opa_lcdr	"1,2"	/* 23 */
#define	opn_hdr 	"HDR"	/* 24 */
#define	opa_hdr 	"1,2"	/* 24 */
#define	opn_lrdr	"LRDR"	/* 25 */
#define	opa_lrdr	"1,2"	/* 25 */
#define	opn_mxr 	"MXR"	/* 26 */
#define	opa_mxr 	"1,2"	/* 26 */
#define	opn_mxdr	"MXDR"	/* 27 */
#define	opa_mxdr	"1,2"	/* 27 */
#define	opn_ldr 	"LDR"	/* 28 */
#define	opa_ldr 	"1,2"	/* 28 */
#define	opn_cdr 	"CDR"	/* 29 */
#define	opa_cdr 	"1,2"	/* 29 */
#define	opn_adr 	"ADR"	/* 2a */
#define	opa_adr 	"1,2"	/* 2a */
#define	opn_sdr 	"SDR"	/* 2b */
#define	opa_sdr 	"1,2"	/* 2b */
#define	opn_mdr 	"MDR"	/* 2c */
#define	opa_mdr 	"1,2"	/* 2c */
#define	opn_ddr 	"DDR"	/* 2d */
#define	opa_ddr 	"1,2"	/* 2d */
#define	opn_awr 	"AWR"	/* 2e */
#define	opa_awr 	"1,2"	/* 2e */
#define	opn_swr 	"SWR"	/* 2f */
#define	opa_swr 	"1,2"	/* 2f */

#define	opn_lper	"LPER"	/* 30 */
#define	opa_lper	"1,2"	/* 30 */
#define	opn_lner	"LNER"	/* 31 */
#define	opa_lner	"1,2"	/* 31 */
#define	opn_lter	"LTER"	/* 32 */
#define	opa_lter	"1,2"	/* 32 */
#define	opn_lcer	"LCER"	/* 33 */
#define	opa_lcer	"1,2"	/* 33 */
#define	opn_her 	"HER"	/* 34 */
#define	opa_her 	"1,2"	/* 34 */
#define	opn_lrer	"LRER"	/* 35 */
#define	opa_lrer	"1,2"	/* 35 */
#define	opn_axr 	"AXR"	/* 36 */
#define	opa_axr 	"1,2"	/* 36 */
#define	opn_sxr 	"SXR"	/* 37 */
#define	opa_sxr 	"1,2"	/* 37 */
#define	opn_ler 	"LER"	/* 38 */
#define	opa_ler 	"1,2"	/* 38 */
#define	opn_cer 	"CER"	/* 39 */
#define	opa_cer 	"1,2"	/* 39 */
#define	opn_aer 	"AER"	/* 3a */
#define	opa_aer 	"1,2"	/* 3a */
#define	opn_ser 	"SER"	/* 3b */
#define	opa_ser 	"1,2"	/* 3b */
#define	opn_mer 	"MER"	/* 3c */
#define	opa_mer 	"1,2"	/* 3c */
#define	opn_der 	"DER"	/* 3d */
#define	opa_der 	"1,2"	/* 3d */
#define	opn_aur 	"AUR"	/* 3e */
#define	opa_aur 	"1,2"	/* 3e */
#define	opn_sur 	"SUR"	/* 3f */
#define	opa_sur 	"1,2"	/* 3f */

#define	opn_sth 	"STH"	/* 40 */
#define	opa_sth 	"1,a"	/* 40 */
#define	opn_la		"LA"	/* 41 */
#define	opa_la		"1,a"	/* 41 */
#define	opn_stc 	"STC"	/* 42 */
#define	opa_stc 	"1,a"	/* 42 */
#define	opn_ic		"IC"	/* 43 */
#define	opa_ic		"1,a"	/* 43 */
#define	opn_ex		"EX"	/* 44 */
#define	opa_ex		"1,a"	/* 44 */
#define	opn_bal 	"BAL"	/* 45 */
#define	opa_bal 	"1,a"	/* 45 */
#define	opn_bct 	"BCT"	/* 46 */
#define	opa_bct 	"1,a"	/* 46 */
#define	opn_bc		"BC"	/* 47 */
#define	opa_bc		"m,a"	/* 47 */
#define	opn_lh		"LH"	/* 48 */
#define	opa_lh		"1,a"	/* 48 */
#define	opn_ch		"CH"	/* 49 */
#define	opa_ch		"1,a"	/* 49 */
#define	opn_ah		"AH"	/* 4a */
#define	opa_ah		"1,a"	/* 4a */
#define	opn_sh		"SH"	/* 4b */
#define	opa_sh		"1,a"	/* 4b */
#define	opn_mh		"MH"	/* 4c */
#define	opa_mh		"1,a"	/* 4c */
#define	opn_bas 	"BAS"	/* 4d */
#define	opa_bas 	"1,a"	/* 4d */
#define	opn_cvd 	"CVD"	/* 4e */
#define	opa_cvd 	"1,a"	/* 4e */
#define	opn_cvb 	"CVB"	/* 4f */
#define	opa_cvb 	"1,a"	/* 4f */

#define	opn_st		"ST"	/* 50 */
#define	opa_st		"1,a"	/* 50 */
#define	opn_n		"N"	/* 54 */
#define	opa_n		"1,a"	/* 54 */
#define	opn_cl		"CL"	/* 55 */
#define	opa_cl		"1,a"	/* 55 */
#define	opn_o		"O"	/* 56 */
#define	opa_o		"1,a"	/* 56 */
#define	opn_x		"X"	/* 57 */
#define	opa_x		"1,a"	/* 57 */
#define	opn_l		"L"	/* 58 */
#define	opa_l		"1,a"	/* 58 */
#define	opn_c		"C"	/* 59 */
#define	opa_c		"1,a"	/* 59 */
#define	opn_a		"A"	/* 5a */
#define	opa_a		"1,a"	/* 5a */
#define	opn_s		"S"	/* 5b */
#define	opa_s		"1,a"	/* 5b */
#define	opn_m		"M"	/* 5c */
#define	opa_m		"1,a"	/* 5c */
#define	opn_d		"D"	/* 5d */
#define	opa_d		"1,a"	/* 5d */
#define	opn_al		"AL"	/* 5e */
#define	opa_al		"1,a"	/* 5e */
#define	opn_sl		"SL"	/* 5f */
#define	opa_sl		"1,a"	/* 5f */

#define	opn_std 	"STD"	/* 60 */
#define	opa_std 	"1,a"	/* 60 */
#define	opn_mxd 	"MXD"	/* 67 */
#define	opa_mxd 	"1,a"	/* 67 */
#define	opn_ld		"LD"	/* 68 */
#define	opa_ld		"1,a"	/* 68 */
#define	opn_cd		"CD"	/* 69 */
#define	opa_cd		"1,a"	/* 69 */
#define	opn_ad		"AD"	/* 6a */
#define	opa_ad		"1,a"	/* 6a */
#define	opn_sd		"SD"	/* 6b */
#define	opa_sd		"1,a"	/* 6b */
#define	opn_md		"MD"	/* 6c */
#define	opa_md		"1,a"	/* 6c */
#define	opn_dd		"DD"	/* 6d */
#define	opa_dd		"1,a"	/* 6d */
#define	opn_aw		"AW"	/* 6e */
#define	opa_aw		"1,a"	/* 6e */
#define	opn_sw		"SW"	/* 6f */
#define	opa_sw		"1,a"	/* 6f */

#define	opn_ste 	"STE"	/* 70 */
#define	opa_ste 	"1,a"	/* 70 */
#define	opn_le		"LE"	/* 78 */
#define	opa_le		"1,a"	/* 78 */
#define	opn_ce		"CE"	/* 79 */
#define	opa_ce		"1,a"	/* 79 */
#define	opn_ae		"AE"	/* 7a */
#define	opa_ae		"1,a"	/* 7a */
#define	opn_se		"SE"	/* 7b */
#define	opa_se		"1,a"	/* 7b */
#define	opn_me		"ME"	/* 7c */
#define	opa_me		"1,a"	/* 7c */
#define	opn_de		"DE"	/* 7d */
#define	opa_de		"1,a"	/* 7d */
#define	opn_au		"AU"	/* 7e */
#define	opa_au		"1,a"	/* 7e */
#define	opn_su		"SU"	/* 7f */
#define	opa_su		"1,a"	/* 7f */

#define	opn_ssm 	"SSM"	/* 80 */
#define	opa_ssm 	"b"	/* 80 */
#define	opn_lpsw	"LPSW"	/* 82 */
#define	opa_lpsw	"b"	/* 82 */
#define	opn_diag	"DIAG"	/* 83 */
#define	opa_diag	"x"	/* 83 */
#define	opn_bxh 	"BXH"	/* 86 */
#define	opa_bxh 	"1,2,b" /* 86 */
#define	opn_bxle	"BXLE"	/* 87 */
#define	opa_bxle	"1,2,b" /* 87 */
#define	opn_srl 	"SRL"	/* 88 */
#define	opa_srl 	"1,b"	/* 88 */
#define	opn_sll 	"SLL"	/* 89 */
#define	opa_sll 	"1,b"	/* 89 */
#define	opn_sra 	"SRA"	/* 8a */
#define	opa_sra 	"1,b"	/* 8a */
#define	opn_sla 	"SLA"	/* 8b */
#define	opa_sla 	"1,b"	/* 8b */
#define	opn_srdl	"SRDL"	/* 8c */
#define	opa_srdl	"1,b"	/* 8c */
#define	opn_sldl	"SLDL"	/* 8d */
#define	opa_sldl	"1,b"	/* 8d */
#define	opn_srda	"SRDA"	/* 8e */
#define	opa_srda	"1,b"	/* 8e */
#define	opn_slda	"SLDA"	/* 8f */
#define	opa_slda	"1,b"	/* 8f */

#define	opn_stm 	"STM"	/* 90 */
#define	opa_stm 	"1,2,b" /* 90 */
#define	opn_tm		"TM"	/* 91 */
#define	opa_tm		"b,i"	/* 91 */
#define	opn_mvi 	"MVI"	/* 92 */
#define	opa_mvi 	"b,i"	/* 92 */
#define	opn_ts		"TS"	/* 93 */
#define	opa_ts		"b"	/* 93 */
#define	opn_ni		"NI"	/* 94 */
#define	opa_ni		"b,i"	/* 94 */
#define	opn_cli 	"CLI"	/* 95 */
#define	opa_cli 	"b,i"	/* 95 */
#define	opn_oi		"OI"	/* 96 */
#define	opa_oi		"b,i"	/* 96 */
#define	opn_xi		"XI"	/* 97 */
#define	opa_xi		"b,i"	/* 97 */
#define	opn_lm		"LM"	/* 98 */
#define	opa_lm		"1,2,b" /* 98 */
#define	opn_9cxx	"9CXX"	/* 9cxx */
#define	opa_9cxx	"b"	/* 9cxx */
#define	opn_9dxx	"9DXX"	/* 9dxx */
#define	opa_9dxx	"b"	/* 9dxx */
#define	opn_9exx	"9EXX"	/* 9exx */
#define	opa_9exx	"b"	/* 9exx */
#define	opn_9fxx	"9FXX"	/* 9fxx */
#define	opa_9fxx	"b"	/* 9fxx */
	
#define	opn_stnsm	"STNSM" /* ac */
#define	opa_stnsm	"b,i"	/* ac */
#define	opn_stosm	"STOSM" /* ad */
#define	opa_stosm	"b,i"	/* ad */
#define	opn_sigp	"SIGP"	/* ae */
#define	opa_sigp	"1,2,b" /* ae */
#define	opn_mc		"MC"	/* af */
#define	opa_mc		"b,i"	/* af */

#define	opn_lra 	"LRA"	/* b1 */
#define	opa_lra 	"1,a"	/* b1 */
#define	opn_b2xx	"B2XX"	/* b2xx */
#define	opa_b2xx	"b"	/* b2xx */
#define	opn_dxr 	"DXR"	/* b22d */
#define	opa_dxr 	"3,4"	/* b22d */
#define	opn_stctl	"STCTL" /* b6 */
#define	opa_stctl	"1,2,b" /* b6 */
#define	opn_lctl	"LCTL"	/* b7 */
#define	opa_lctl	"1,2,b" /* b7 */
#define	opn_cs		"CS"	/* ba */
#define	opa_cs		"1,2,b" /* ba */
#define	opn_cds 	"CDS"	/* bb */
#define	opa_cds 	"1,2,b" /* bb */
#define	opn_bcxx	"BCXX"	/* bcxx */
#define	opa_bcxx	"b"	/* bcxx */
#define	opn_clm 	"CLM"	/* bd */
#define	opa_clm 	"1,n,b" /* bd */
#define	opn_stcm	"STCM"	/* be */
#define	opa_stcm	"1,n,b" /* be */
#define	opn_icm 	"ICM"	/* bf */
#define	opa_icm 	"1,n,b" /* bf */

#define	opn_mvn 	"MVN"	/* d1 */
#define	opa_mvn 	"c,d"	/* d1 */
#define	opn_mvc 	"MVC"	/* d2 */
#define	opa_mvc 	"c,d"	/* d2 */
#define	opn_mvz 	"MVZ"	/* d3 */
#define	opa_mvz 	"c,d"	/* d3 */
#define	opn_nc		"NC"	/* d4 */
#define	opa_nc		"c,d"	/* d4 */
#define	opn_clc 	"CLC"	/* d5 */
#define	opa_clc 	"c,d"	/* d5 */
#define	opn_oc		"OC"	/* d6 */
#define	opa_oc		"c,d"	/* d6 */
#define	opn_xc		"XC"	/* d7 */
#define	opa_xc		"c,d"	/* d7 */
#define	opn_tr		"TR"	/* dc */
#define	opa_tr		"c,d"	/* dc */
#define	opn_trt 	"TRT"	/* dd */
#define	opa_trt 	"c,d"	/* dd */
#define	opn_ed		"ED"	/* de */
#define	opa_ed		"c,d"	/* de */
#define	opn_edmk	"EDMK"	/* df */
#define	opa_edmk	"c,d"	/* df */

#define	opn_e5xx	"E5XX"	/* e5 */
#define	opa_e5xx	"b,d"	/* e5 */
#define	opn_mvcin	"MVCIN" /* e8 */
#define	opa_mvcin	"c,d"	/* e8 */

#define	opn_srp 	"SRP"	/* f0 */
#define	opa_srp 	"f,d,j" /* f0 */
#define	opn_mvo 	"MVO"	/* f1 */
#define	opa_mvo 	"f,g"	/* f1 */
#define	opn_pack	"PACK"	/* f2 */
#define	opa_pack	"f,g"	/* f2 */
#define	opn_unpk	"UNPK"	/* f3 */
#define	opa_unpk	"f,g"	/* f3 */
#define	opn_zap 	"ZAP"	/* f8 */
#define	opa_zap 	"f,g"	/* f8 */
#define	opn_cp		"CP"	/* f9 */
#define	opa_cp		"f,g"	/* f9 */
#define	opn_ap		"AP"	/* fa */
#define	opa_ap		"f,g"	/* fa */
#define	opn_sp		"SP"	/* fb */
#define	opa_sp		"f,g"	/* fb */
#define	opn_mp		"MP"	/* fc */
#define	opa_mp		"f,g"	/* fc */
#define	opn_dp		"DP"	/* fd */
#define	opa_dp		"f,g"	/* fd */

struct op {
  char *name;
  char *args;
  int  mlen;
  int  (*cfunc)();
  int  (*tfunc)();
  int  term; /* 0:continue, 1:terminate, 2:special */
  int  dummy1;
  struct op *optbl;
};

struct op optbl_b2xx[] = {
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b200 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b201 */
  {	opn_b2xx, opa_b2xx, 4,       0,        0, 0,0,0 }, /* b202 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b203 */
  {	opn_b2xx, opa_b2xx, 4,       0,        0, 0,0,0 }, /* b204 */
  {	opn_b2xx, opa_b2xx, 4,       0,        0, 0,0,0 }, /* b205 */
  {	opn_b2xx, opa_b2xx, 4,       0,        0, 0,0,0 }, /* b206 */
  {	opn_b2xx, opa_b2xx, 4,       0,        0, 0,0,0 }, /* b207 */
  {	opn_b2xx, opa_b2xx, 4,       0,        0, 0,0,0 }, /* b208 */
  {	opn_b2xx, opa_b2xx, 4,       0,        0, 0,0,0 }, /* b209 */
  {	opn_b2xx, opa_b2xx, 4,       0,        0, 0,0,0 }, /* b20a */
  {	opn_b2xx, opa_b2xx, 4,       0,        0, 0,0,0 }, /* b20b */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b20c */
  {	opn_b2xx, opa_b2xx, 4,       0,        0, 0,0,0 }, /* b20d */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b20e */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b20f */

  {	opn_b2xx, opa_b2xx, 4,       0,        0, 0,0,0 }, /* b210 */
  {	opn_b2xx, opa_b2xx, 4,       0,        0, 0,0,0 }, /* b211 */
  {	opn_b2xx, opa_b2xx, 4,       0,        0, 0,0,0 }, /* b212 */
  {	opn_b2xx, opa_b2xx, 4,       0,        0, 0,0,0 }, /* b213 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b214 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b215 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b216 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b217 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b218 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b219 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b21a */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b21b */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b21c */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b21d */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b21e */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b21f */

  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b220 */
  {	opn_b2xx, opa_b2xx, 4,       0,        0, 0,0,0 }, /* b221 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b222 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b223 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b224 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b225 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b226 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b227 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b228 */
  {	opn_b2xx, opa_b2xx, 4,       0,        0, 0,0,0 }, /* b229 */
  {	opn_b2xx, opa_b2xx, 4,       0,        0, 0,0,0 }, /* b22a */
  {	opn_b2xx, opa_b2xx, 4,       0,        0, 0,0,0 }, /* b22b */
  {	opn_b2xx, opa_b2xx, 4,       0,        0, 0,0,0 }, /* b22c */
  {	opn_dxr,  opa_dxr,  4,       0,        0, 0,0,0 }, /* b22d */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b22e */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b22f */

  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b230 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b231 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b232 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b233 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b234 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b235 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b236 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b237 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b238 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b239 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b23a */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b23b */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b23c */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b23d */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b23e */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b23f */

  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b240 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b241 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b242 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b243 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b244 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b245 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b246 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b247 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b248 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b249 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b24a */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b24b */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b24c */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b24d */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b24e */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b24f */

  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b250 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b251 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b252 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b253 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b254 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b255 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b256 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b257 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b258 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b259 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b25a */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b25b */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b25c */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b25d */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b25e */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b25f */

  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b260 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b261 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b262 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b263 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b264 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b265 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b266 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b267 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b268 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b269 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b26a */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b26b */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b26c */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b26d */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b26e */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b26f */

  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b270 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b271 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b272 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b273 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b274 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b275 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b276 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b277 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b278 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b279 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b27a */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b27b */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b27c */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b27d */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b27e */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b27f */

  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b280 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b281 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b282 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b283 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b284 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b285 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b286 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b287 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b288 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b289 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b28a */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b28b */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b28c */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b28d */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b28e */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b28f */

  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b290 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b291 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b292 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b293 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b294 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b295 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b296 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b297 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b298 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b299 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b29a */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b29b */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b29c */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b29d */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b29e */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b29f */

  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b2a0 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b2a1 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b2a2 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b2a3 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b2a4 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b2a5 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b2a6 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b2a7 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b2a8 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b2a9 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b2aa */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b2ab */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b2ac */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b2ad */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b2ae */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b2af */

  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b2b0 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b2b1 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b2b2 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b2b3 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b2b4 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b2b5 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b2b6 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b2b7 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b2b8 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b2b9 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b2ba */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b2bb */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b2bc */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b2bd */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b2be */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b2bf */

  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b2c0 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b2c1 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b2c2 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b2c3 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b2c4 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b2c5 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b2c6 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b2c7 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b2c8 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b2c9 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b2ca */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b2cb */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b2cc */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b2cd */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b2ce */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b2cf */

  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b2d0 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b2d1 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b2d2 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b2d3 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b2d4 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b2d5 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b2d6 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b2d7 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b2d8 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b2d9 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b2da */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b2db */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b2dc */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b2dd */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b2de */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b2df */

  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b2e0 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b2e1 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b2e2 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b2e3 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b2e4 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b2e5 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b2e6 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b2e7 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b2e8 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b2e9 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b2ea */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b2eb */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b2ec */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b2ed */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b2ee */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b2ef */

  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b2f0 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b2f1 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b2f2 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b2f3 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b2f4 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b2f5 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b2f6 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b2f7 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b2f8 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b2f9 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b2fa */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b2fb */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b2fc */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b2fd */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b2fe */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b2ff */
};

struct op optbl_bcxx[] = {
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc00 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc01 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc02 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc03 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc04 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc05 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc06 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc07 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc08 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc09 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc0a */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc0b */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc0c */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc0d */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc0e */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc0f */

  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc10 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc11 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc12 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc13 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc14 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc15 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc16 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc17 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc18 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc19 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc1a */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc1b */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc1c */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc1d */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc1e */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc1f */

  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc20 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc21 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc22 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc23 */
  {	opn_bcxx, opa_bcxx, 4,       0,        0, 0,0,0 }, /* bc24 */
  {	opn_bcxx, opa_bcxx, 4,       0,        0, 0,0,0 }, /* bc25 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc26 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc27 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc28 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc29 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc2a */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc2b */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc2c */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc2d */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc2e */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc2f */

  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc30 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc31 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc32 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc33 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc34 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc35 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc36 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc37 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc38 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc39 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc3a */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc3b */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc3c */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc3d */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc3e */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc3f */

  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc40 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc41 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc42 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc43 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc44 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc45 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc46 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc47 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc48 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc49 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc4a */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc4b */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc4c */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc4d */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc4e */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc4f */

  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc50 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc51 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc52 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc53 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc54 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc55 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc56 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc57 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc58 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc59 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc5a */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc5b */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc5c */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc5d */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc5e */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc5f */

  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc60 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc61 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc62 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc63 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc64 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc65 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc66 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc67 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc68 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc69 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc6a */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc6b */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc6c */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc6d */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc6e */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc6f */

  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc70 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc71 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc72 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc73 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc74 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc75 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc76 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc77 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc78 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc79 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc7a */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc7b */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc7c */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc7d */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc7e */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc7f */

  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc80 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc81 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc82 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc83 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc84 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc85 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc86 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc87 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc88 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc89 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc8a */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc8b */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc8c */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc8d */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc8e */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc8f */

  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc90 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc91 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc92 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc93 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc94 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc95 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc96 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc97 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc98 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc99 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc9a */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc9b */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc9c */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc9d */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc9e */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bc9f */

  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bca0 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bca1 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bca2 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bca3 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bca4 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bca5 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bca6 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bca7 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bca8 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bca9 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bcaa */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bcab */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bcac */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bcad */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bcae */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bcaf */

  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bcb0 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bcb1 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bcb2 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bcb3 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bcb4 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bcb5 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bcb6 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bcb7 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bcb8 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bcb9 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bcba */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bcbb */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bcbc */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bcbd */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bcbe */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bcbf */

  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bcc0 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bcc1 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bcc2 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bcc3 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bcc4 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bcc5 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bcc6 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bcc7 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bcc8 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bcc9 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bcca */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bccb */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bccc */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bccd */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bcce */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bccf */

  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bcd0 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bcd1 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bcd2 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bcd3 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bcd4 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bcd5 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bcd6 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bcd7 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bcd8 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bcd9 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bcda */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bcdb */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bcdc */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bcdd */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bcde */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bcdf */

  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bce0 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bce1 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bce2 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bce3 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bce4 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bce5 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bce6 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bce7 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bce8 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bce9 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bcea */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bceb */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bcec */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bced */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bcee */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bcef */

  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bcf0 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bcf1 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bcf2 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bcf3 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bcf4 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bcf5 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bcf6 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bcf7 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bcf8 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bcf9 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bcfa */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bcfb */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bcfc */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bcfd */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bcfe */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* bcff */
};

struct op optbl_e5xx[] = {
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e500 */
  {	opn_e5xx, opa_e5xx, 6,       0,        0, 0,0,0 }, /* e501 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e502 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e503 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e504 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e505 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e506 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e507 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e508 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e509 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e50a */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e50b */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e50c */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e50d */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e50e */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e50f */

  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e510 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e511 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e512 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e513 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e514 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e515 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e516 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e517 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e518 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e519 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e51a */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e51b */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e51c */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e51d */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e51e */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e51f */

  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e520 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e521 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e522 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e523 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e524 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e525 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e526 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e527 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e528 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e529 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e52a */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e52b */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e52c */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e52d */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e52e */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e52f */

  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e530 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e531 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e532 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e533 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e534 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e535 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e536 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e537 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e538 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e539 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e53a */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e53b */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e53c */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e53d */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e53e */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e53f */

  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e540 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e541 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e542 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e543 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e544 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e545 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e546 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e547 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e548 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e549 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e54a */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e54b */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e54c */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e54d */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e54e */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e54f */

  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e550 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e551 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e552 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e553 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e554 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e555 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e556 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e557 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e558 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e559 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e55a */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e55b */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e55c */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e55d */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e55e */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e55f */

  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e560 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e561 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e562 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e563 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e564 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e565 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e566 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e567 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e568 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e569 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e56a */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e56b */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e56c */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e56d */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e56e */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e56f */

  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e570 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e571 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e572 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e573 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e574 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e575 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e576 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e577 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e578 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e579 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e57a */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e57b */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e57c */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e57d */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e57e */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e57f */

  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e580 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e581 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e582 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e583 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e584 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e585 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e586 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e587 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e588 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e589 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e58a */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e58b */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e58c */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e58d */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e58e */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e58f */

  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e590 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e591 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e592 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e593 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e594 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e595 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e596 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e597 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e598 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e599 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e59a */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e59b */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e59c */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e59d */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e59e */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e59f */

  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e5a0 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e5a1 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e5a2 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e5a3 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e5a4 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e5a5 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e5a6 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e5a7 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e5a8 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e5a9 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e5aa */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e5ab */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e5ac */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e5ad */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e5ae */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e5af */

  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e5b0 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e5b1 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e5b2 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e5b3 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e5b4 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e5b5 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e5b6 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e5b7 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e5b8 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e5b9 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e5ba */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e5bb */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e5bc */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e5bd */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e5be */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e5bf */

  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e5c0 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e5c1 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e5c2 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e5c3 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e5c4 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e5c5 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e5c6 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e5c7 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e5c8 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e5c9 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e5ca */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e5cb */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e5cc */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e5cd */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e5ce */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e5cf */

  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e5d0 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e5d1 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e5d2 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e5d3 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e5d4 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e5d5 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e5d6 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e5d7 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e5d8 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e5d9 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e5da */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e5db */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e5dc */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e5dd */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e5de */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e5df */

  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e5e0 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e5e1 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e5e2 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e5e3 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e5e4 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e5e5 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e5e6 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e5e7 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e5e8 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e5e9 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e5ea */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e5eb */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e5ec */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e5ed */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e5ee */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e5ef */

  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e5f0 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e5f1 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e5f2 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e5f3 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e5f4 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e5f5 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e5f6 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e5f7 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e5f8 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e5f9 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e5fa */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e5fb */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e5fc */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e5fd */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e5fe */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e5ff */
};

struct op optable[] = {
  {	opn_OPX2, opa_OPX2, 2,       0,        0, 1,0,0 }, /* 00 */
  {	opn_OPX2, opa_OPX2, 2,       0,        0, 1,0,0 }, /* 01 */
  {	opn_OPX2, opa_OPX2, 2,       0,        0, 1,0,0 }, /* 02 */
  {	opn_OPX2, opa_OPX2, 2,       0,        0, 1,0,0 }, /* 03 */
  {	opn_spm,  opa_spm,  2,       0,        0, 0,0,0 }, /* 04 */
  {	opn_balr, opa_balr, 2,       0,        0, 1,0,0 }, /* 05 */
  {	opn_bctr, opa_bctr, 2,       0,        0, 1,0,0 }, /* 06 */
  {	opn_bcr,  opa_bcr,  2,       0,        0, 2,0,0 }, /* 07 */
  {	opn_ssk,  opa_ssk,  2,       0,        0, 0,0,0 }, /* 08 */
  {	opn_isk,  opa_isk,  2,       0,        0, 0,0,0 }, /* 09 */
  {	opn_svc,  opa_svc,  2,       0,        0, 0,0,0 }, /* 0a */
  {	opn_bsm,  opa_bsm,  2,       0,        0, 1,0,0 }, /* 0b */
  {	opn_bassm,opa_bassm,2,       0,        0, 1,0,0 }, /* 0c */
  {	opn_basr, opa_basr, 2,       0,        0, 1,0,0 }, /* 0d */
  {	opn_mvcl, opa_mvcl, 2,       0,        0, 0,0,0 }, /* 0e */
  {	opn_clcl, opa_clcl, 2,       0,        0, 0,0,0 }, /* 0f */
  
  {	opn_lpr,  opa_lpr,  2,       0,        0, 0,0,0 }, /* 10 */
  {	opn_lnr,  opa_lnr,  2,       0,        0, 0,0,0 }, /* 11 */
  {	opn_ltr,  opa_ltr,  2,       0,        0, 0,0,0 }, /* 12 */
  {	opn_lcr,  opa_lcr,  2,       0,        0, 0,0,0 }, /* 13 */
  {	opn_nr,	  opa_nr,   2,       0,        0, 0,0,0 }, /* 14 */
  {	opn_clr,  opa_clr,  2,       0,        0, 0,0,0 }, /* 15 */
  {	opn_or,	  opa_or,   2,       0,        0, 0,0,0 }, /* 16 */
  {	opn_xr,	  opa_xr,   2,       0,        0, 0,0,0 }, /* 17 */
  {	opn_lr,	  opa_lr,   2,       0,        0, 0,0,0 }, /* 18 */
  {	opn_cr,	  opa_cr,   2,       0,        0, 0,0,0 }, /* 19 */
  {	opn_ar,	  opa_ar,   2,       0,        0, 0,0,0 }, /* 1a */
  {	opn_sr,	  opa_sr,   2,       0,        0, 0,0,0 }, /* 1b */
  {	opn_mr,	  opa_mr,   2,       0,        0, 0,0,0 }, /* 1c */
  {	opn_dr,	  opa_dr,   2,       0,        0, 0,0,0 }, /* 1d */
  {	opn_alr,  opa_alr,  2,       0,        0, 0,0,0 }, /* 1e */
  {	opn_slr,  opa_slr,  2,       0,        0, 0,0,0 }, /* 1f */

  {	opn_lpdr, opa_lpdr, 2,       0,        0, 0,0,0 }, /* 20 */
  {	opn_lndr, opa_lndr, 2,       0,        0, 0,0,0 }, /* 21 */
  {	opn_ltdr, opa_ltdr, 2,       0,        0, 0,0,0 }, /* 22 */
  {	opn_lcdr, opa_lcdr, 2,       0,        0, 0,0,0 }, /* 23 */
  {	opn_hdr,  opa_hdr,  2,       0,        0, 0,0,0 }, /* 24 */
  {	opn_lrdr, opa_lrdr, 2,       0,        0, 0,0,0 }, /* 25 */
  {	opn_mxr,  opa_mxr,  2,       0,        0, 0,0,0 }, /* 26 */
  {	opn_mxdr, opa_mxdr, 2,       0,        0, 0,0,0 }, /* 27 */
  {	opn_ldr,  opa_ldr,  2,       0,        0, 0,0,0 }, /* 28 */
  {	opn_cdr,  opa_cdr,  2,       0,        0, 0,0,0 }, /* 29 */
  {	opn_adr,  opa_adr,  2,       0,        0, 0,0,0 }, /* 2a */
  {	opn_sdr,  opa_sdr,  2,       0,        0, 0,0,0 }, /* 2b */
  {	opn_mdr,  opa_mdr,  2,       0,        0, 0,0,0 }, /* 2c */
  {	opn_ddr,  opa_ddr,  2,       0,        0, 0,0,0 }, /* 2d */
  {	opn_awr,  opa_awr,  2,       0,        0, 0,0,0 }, /* 2e */
  {	opn_swr,  opa_swr,  2,       0,        0, 0,0,0 }, /* 2f */

  {	opn_lper, opa_lper, 2,       0,        0, 0,0,0 }, /* 30 */
  {	opn_lner, opa_lner, 2,       0,        0, 0,0,0 }, /* 31 */
  {	opn_lter, opa_lter, 2,       0,        0, 0,0,0 }, /* 32 */
  {	opn_lcer, opa_lcer, 2,       0,        0, 0,0,0 }, /* 33 */
  {	opn_her,  opa_her,  2,       0,        0, 0,0,0 }, /* 34 */
  {	opn_lrer, opa_lrer, 2,       0,        0, 0,0,0 }, /* 35 */
  {	opn_axr,  opa_axr,  2,       0,        0, 0,0,0 }, /* 36 */
  {	opn_sxr,  opa_sxr,  2,       0,        0, 0,0,0 }, /* 37 */
  {	opn_ler,  opa_ler,  2,       0,        0, 0,0,0 }, /* 38 */
  {	opn_cer,  opa_cer,  2,       0,        0, 0,0,0 }, /* 39 */
  {	opn_aer,  opa_aer,  2,       0,        0, 0,0,0 }, /* 3a */
  {	opn_ser,  opa_ser,  2,       0,        0, 0,0,0 }, /* 3b */
  {	opn_mer,  opa_mer,  2,       0,        0, 0,0,0 }, /* 3c */
  {	opn_der,  opa_der,  2,       0,        0, 0,0,0 }, /* 3d */
  {	opn_aur,  opa_aur,  2,       0,        0, 0,0,0 }, /* 3e */
  {	opn_sur,  opa_sur,  2,       0,        0, 0,0,0 }, /* 3f */

  {	opn_sth,  opa_sth,  4,       0,        0, 0,0,0 }, /* 40 */
  {	opn_la,	  opa_la,   4,       0,        0, 0,0,0 }, /* 41 */
  {	opn_stc,  opa_stc,  4,       0,        0, 0,0,0 }, /* 42 */
  {	opn_ic,	  opa_ic,   4,       0,        0, 0,0,0 }, /* 43 */
  {	opn_ex,	  opa_ex,   4,       0,        0, 1,0,0 }, /* 44 */
  {	opn_bal,  opa_bal,  4,       0,        0, 1,0,0 }, /* 45 */
  {	opn_bct,  opa_bct,  4,       0,        0, 1,0,0 }, /* 46 */
  {	opn_bc,	  opa_bc,   4,       0,        0, 2,0,0 }, /* 47 */
  {	opn_lh,	  opa_lh,   4,       0,        0, 0,0,0 }, /* 48 */
  {	opn_ch,	  opa_ch,   4,       0,        0, 0,0,0 }, /* 49 */
  {	opn_ah,	  opa_ah,   4,       0,        0, 0,0,0 }, /* 4a */
  {	opn_sh,	  opa_sh,   4,       0,        0, 0,0,0 }, /* 4b */
  {	opn_mh,	  opa_mh,   4,       0,        0, 0,0,0 }, /* 4c */
  {	opn_bas,  opa_bas,  4,       0,        0, 1,0,0 }, /* 4d */
  {	opn_cvd,  opa_cvd,  4,       0,        0, 0,0,0 }, /* 4e */
  {	opn_cvb,  opa_cvb,  4,       0,        0, 0,0,0 }, /* 4f */

  {	opn_st,	  opa_st,   4,       0,        0, 0,0,0 }, /* 50 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* 51 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* 52 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* 53 */
  {	opn_n,	  opa_n,    4,       0,        0, 0,0,0 }, /* 54 */
  {	opn_cl,	  opa_cl,   4,       0,        0, 0,0,0 }, /* 55 */
  {	opn_o,	  opa_o,    4,       0,        0, 0,0,0 }, /* 56 */
  {	opn_x,	  opa_x,    4,       0,        0, 0,0,0 }, /* 57 */
  {	opn_l,	  opa_l,    4,       0,        0, 0,0,0 }, /* 58 */
  {	opn_c,	  opa_c,    4,       0,        0, 0,0,0 }, /* 59 */
  {	opn_a,	  opa_a,    4,       0,        0, 0,0,0 }, /* 5a */
  {	opn_s,	  opa_s,    4,       0,        0, 0,0,0 }, /* 5b */
  {	opn_m,	  opa_m,    4,       0,        0, 0,0,0 }, /* 5c */
  {	opn_d,	  opa_d,    4,       0,        0, 0,0,0 }, /* 5d */
  {	opn_al,	  opa_al,   4,       0,        0, 0,0,0 }, /* 5e */
  {	opn_sl,	  opa_sl,   4,       0,        0, 0,0,0 }, /* 5f */

  {	opn_std,  opa_std,  4,       0,        0, 0,0,0 }, /* 60 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* 61 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* 62 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* 63 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* 64 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* 65 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* 66 */
  {	opn_mxd,  opa_mxd,  4,       0,        0, 0,0,0 }, /* 67 */
  {	opn_ld,	  opa_ld,   4,       0,        0, 0,0,0 }, /* 68 */
  {	opn_cd,	  opa_cd,   4,       0,        0, 0,0,0 }, /* 69 */
  {	opn_ad,	  opa_ad,   4,       0,        0, 0,0,0 }, /* 6a */
  {	opn_sd,	  opa_sd,   4,       0,        0, 0,0,0 }, /* 6b */
  {	opn_md,	  opa_md,   4,       0,        0, 0,0,0 }, /* 6c */
  {	opn_dd,	  opa_dd,   4,       0,        0, 0,0,0 }, /* 6d */
  {	opn_aw,	  opa_aw,   4,       0,        0, 0,0,0 }, /* 6e */
  {	opn_sw,	  opa_sw,   4,       0,        0, 0,0,0 }, /* 6f */

  {	opn_ste,  opa_ste,  4,       0,        0, 0,0,0 }, /* 70 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* 71 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* 72 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* 73 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* 74 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* 75 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* 76 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* 77 */
  {	opn_le,	  opa_le,   4,       0,        0, 0,0,0 }, /* 78 */
  {	opn_ce,	  opa_ce,   4,       0,        0, 0,0,0 }, /* 79 */
  {	opn_ae,	  opa_ae,   4,       0,        0, 0,0,0 }, /* 7a */
  {	opn_se,	  opa_se,   4,       0,        0, 0,0,0 }, /* 7b */
  {	opn_me,	  opa_me,   4,       0,        0, 0,0,0 }, /* 7c */
  {	opn_de,	  opa_de,   4,       0,        0, 0,0,0 }, /* 7d */
  {	opn_au,	  opa_au,   4,       0,        0, 0,0,0 }, /* 7e */
  {	opn_su,	  opa_su,   4,       0,        0, 0,0,0 }, /* 7f */

  {	opn_ssm,  opa_ssm,  4,       0,        0, 0,0,0 }, /* 80 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* 81 */
  {	opn_lpsw, opa_lpsw, 4,       0,        0, 0,0,0 }, /* 82 */
  {	opn_diag, opa_diag, 4,       0,        0, 1,0,0 }, /* 83 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* 84 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* 85 */
  {	opn_bxh,  opa_bxh,  4,       0,        0, 1,0,0 }, /* 86 */
  {	opn_bxle, opa_bxle, 4,       0,        0, 1,0,0 }, /* 87 */
  {	opn_srl,  opa_srl,  4,       0,        0, 0,0,0 }, /* 88 */
  {	opn_sll,  opa_sll,  4,       0,        0, 0,0,0 }, /* 89 */
  {	opn_sra,  opa_sra,  4,       0,        0, 0,0,0 }, /* 8a */
  {	opn_sla,  opa_sla,  4,       0,        0, 0,0,0 }, /* 8b */
  {	opn_srdl, opa_srdl, 4,       0,        0, 0,0,0 }, /* 8c */
  {	opn_sldl, opa_sldl, 4,       0,        0, 0,0,0 }, /* 8d */
  {	opn_srda, opa_srda, 4,       0,        0, 0,0,0 }, /* 8e */
  {	opn_slda, opa_slda, 4,       0,        0, 0,0,0 }, /* 8f */

  {	opn_stm,  opa_stm,  4,       0,        0, 0,0,0 }, /* 90 */
  {	opn_tm,	  opa_tm,   4,       0,        0, 0,0,0 }, /* 91 */
  {	opn_mvi,  opa_mvi,  4,       0,        0, 0,0,0 }, /* 92 */
  {	opn_ts,	  opa_ts,   4,       0,        0, 0,0,0 }, /* 93 */
  {	opn_ni,	  opa_ni,   4,       0,        0, 0,0,0 }, /* 94 */
  {	opn_cli,  opa_cli,  4,       0,        0, 0,0,0 }, /* 95 */
  {	opn_oi,	  opa_oi,   4,       0,        0, 0,0,0 }, /* 96 */
  {	opn_xi,	  opa_xi,   4,       0,        0, 0,0,0 }, /* 97 */
  {	opn_lm,	  opa_lm,   4,       0,        0, 0,0,0 }, /* 98 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* 99 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* 9a */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* 9b */
  {	opn_9cxx, opa_9cxx, 4,       0,        0, 0,0,0 }, /* 9c */
  {	opn_9dxx, opa_9dxx, 4,       0,        0, 0,0,0 }, /* 9d */
  {	opn_9exx, opa_9exx, 4,       0,        0, 0,0,0 }, /* 9e */
  {	opn_9fxx, opa_9fxx, 4,       0,        0, 0,0,0 }, /* 9f */

  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* a0 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* a1 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* a2 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* a3 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* a4 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* a5 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* a6 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* a7 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* a8 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* a9 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* aa */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* ab */
  {	opn_stnsm,opa_stnsm,4,       0,        0, 0,0,0 }, /* ac */
  {	opn_stosm,opa_stosm,4,       0,        0, 0,0,0 }, /* ad */
  {	opn_sigp, opa_sigp, 4,       0,        0, 0,0,0 }, /* ae */
  {	opn_mc,	  opa_mc,   4,       0,        0, 0,0,0 }, /* af */

  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b0 */
  {	opn_lra,  opa_lra,  4,       0,        0, 0,0,0 }, /* b1 */
  {	opn_b2xx, opa_b2xx, 4,       0,        0, 0,0,optbl_b2xx},
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b3 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b4 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b5 */
  {	opn_stctl,opa_stctl,4,       0,        0, 0,0,0 }, /* b6 */
  {	opn_lctl, opa_lctl, 4,       0,        0, 0,0,0 }, /* b7 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b8 */
  {	opn_OPX4, opa_OPX4, 4,       0,        0, 1,0,0 }, /* b9 */
  {	opn_cs,	  opa_cs,   4,       0,        0, 0,0,0 }, /* ba */
  {	opn_cds,  opa_cds,  4,       0,        0, 0,0,0 }, /* bb */
  {	opn_bcxx, opa_bcxx, 4,       0,        0, 0,0,optbl_bcxx},
  {	opn_clm,  opa_clm,  4,       0,        0, 0,0,0 }, /* bd */
  {	opn_stcm, opa_stcm, 4,       0,        0, 0,0,0 }, /* be */
  {	opn_icm,  opa_icm,  4,       0,        0, 0,0,0 }, /* bf */

  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* c0 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* c1 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* c2 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* c3 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* c4 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* c5 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* c6 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* c7 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* c8 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* c9 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* ca */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* cb */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* cc */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* cd */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* ce */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* cf */

  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* d0 */
  {	opn_mvn,  opa_mvn,  6,       0,        0, 0,0,0 }, /* d1 */
  {	opn_mvc,  opa_mvc,  6,       0,        0, 0,0,0 }, /* d2 */
  {	opn_mvz,  opa_mvz,  6,       0,        0, 0,0,0 }, /* d3 */
  {	opn_nc,	  opa_nc,   6,       0,        0, 0,0,0 }, /* d4 */
  {	opn_clc,  opa_clc,  6,       0,        0, 0,0,0 }, /* d5 */
  {	opn_oc,	  opa_oc,   6,       0,        0, 0,0,0 }, /* d6 */
  {	opn_xc,	  opa_xc,   6,       0,        0, 0,0,0 }, /* d7 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* d8 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* d9 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* da */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* db */
  {	opn_tr,	  opa_tr,   6,       0,        0, 0,0,0 }, /* dc */
  {	opn_trt,  opa_trt,  6,       0,        0, 0,0,0 }, /* dd */
  {	opn_ed,	  opa_ed,   6,       0,        0, 0,0,0 }, /* de */
  {	opn_edmk, opa_edmk, 6,       0,        0, 0,0,0 }, /* df */

  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e0 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e1 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e2 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e3 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e4 */
  {	opn_e5xx, opa_e5xx, 6,       0,        0, 0,0,optbl_e5xx},
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e6 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e7 */
  {	opn_mvcin,opa_mvcin,6,       0,        0, 0,0,0 }, /* e8 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* e9 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* ea */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* eb */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* ec */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* ed */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* ee */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* ef */

  {	opn_srp,  opa_srp,  6,       0,        0, 0,0,0 }, /* f0 */
  {	opn_mvo,  opa_mvo,  6,       0,        0, 0,0,0 }, /* f1 */
  {	opn_pack, opa_pack, 6,       0,        0, 0,0,0 }, /* f2 */
  {	opn_unpk, opa_unpk, 6,       0,        0, 0,0,0 }, /* f3 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* f4 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* f5 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* f6 */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* f7 */
  {	opn_zap,  opa_zap,  6,       0,        0, 0,0,0 }, /* f8 */
  {	opn_cp,	  opa_cp,   6,       0,        0, 0,0,0 }, /* f9 */
  {	opn_ap,	  opa_ap,   6,       0,        0, 0,0,0 }, /* fa */
  {	opn_sp,	  opa_sp,   6,       0,        0, 0,0,0 }, /* fb */
  {	opn_mp,	  opa_mp,   6,       0,        0, 0,0,0 }, /* fc */
  {	opn_dp,	  opa_dp,   6,       0,        0, 0,0,0 }, /* fd */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* fe */
  {	opn_OPX6, opa_OPX6, 6,       0,        0, 1,0,0 }, /* ff */
};

/**/
