
#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>


main(argc, argv)
     int argc;
     char **argv;
{
  int     fd, port;
  struct  sockaddr_in serv_addr;

  if (argc != 3) {
    fprintf(stderr, "usage: %s <port#> <ip_addr>\n", argv[0]);
    exit(1);
  }

  if (sscanf(argv[1], "%d", &port) != 1) {
    fprintf(stderr, "client: illegal port: %s\n", argv[1]);
    exit(1);
  }

  if ((fd = socket(AF_INET, SOCK_STREAM, 0)) < 0) {
    fprintf(stderr, "client: can't open stream socket\n");
    exit(1);
  }

  memset((char*)&serv_addr, 0, sizeof(serv_addr));
  serv_addr.sin_family = AF_INET;
  serv_addr.sin_addr.s_addr = inet_addr(argv[2]);
  serv_addr.sin_port = htons(port);
  
  if (connect(fd, (struct sockaddr*)&serv_addr, sizeof(serv_addr)) < 0) {
    fprintf(stderr, "client: can't connect to server\n");
    exit(1);
  }

  str_com(stdin, fd);
   
  close(fd);
  exit(0);
}

#define MAXLINE 512

str_com(fp, fd)
     FILE *fp;
     int fd;
{
  int n;
  char sbuf[MAXLINE], rbuf[MAXLINE];

  while(fgets(sbuf, MAXLINE, fp) != NULL) {
    n = strlen(sbuf);
    if (writen(fd, sbuf, n) != n) {
      fprintf(stderr, "str_com: writen error\n");
      exit(1);
    }
    n = readn(fd, rbuf, MAXLINE);
    if (n == 0)
      return;
    if (n < 0) {
      fprintf(stderr, "str_com: readn error\n");
      exit(1);
    }
    fputs(rbuf, stdout);
  }
  if (ferror(fp)) {
    fprintf(stderr, "str_com: error reading file\n");
    exit(1);
  }
}

int readn(fd, p, len)
     int fd;
     char *p;
     int len;
{
  int n, val;
  char c;
  
  for (n=0; n<len;) {
    if ((val = read(fd, &c, 1)) == 1) {
      *p++ = c;
      n++;
      if (c == '\n')
	break;
    }
    else if (val == 0)
      break;
    else {
      n = -1;
      break;
    }
  }
  *p = 0;
  return(n);
}

int writen(fd, p, len)
     int fd;
     char *p;
     int len;
{
  int n, val;
  
  for (n=len; n>0;) {
    if ((val = write(fd, p, n)) <= 0)
      return(val);
    n -= val;
    p += val;
  }
  return(len);
}
