
#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>

main(argc, argv)
     int argc;
     char **argv;
{
  int     fd1, fd2, port, clen, cpid;
  struct  sockaddr_in cli_addr, serv_addr;

  if (argc != 2) {
    fprintf(stderr, "usage: %s <port#>\n", argv[0]);
    exit(1);
  }

  if (sscanf(argv[1], "%d", &port) != 1) {
    fprintf(stderr, "client: illegal port: %s\n", argv[1]);        
    exit(1);
  } 

  if ((fd1 = socket(AF_INET, SOCK_STREAM, 0)) < 0) {
    fprintf(stderr, "server: can't open stream socket\n");
    exit(1);
  }

  memset((char*)&serv_addr, 0, sizeof(serv_addr));
  serv_addr.sin_family = AF_INET;
  serv_addr.sin_addr.s_addr = htonl(INADDR_ANY);
  serv_addr.sin_port = htons(port);

  if (bind(fd1, (struct sockaddr*)&serv_addr, sizeof(serv_addr)) < 0) {
    fprintf(stderr, "server: can't bind local address\n");
    exit(1);
  }

  listen(fd1, 5);

  while(1) {
    clen = sizeof(cli_addr);
    fd2 = accept(fd1, (struct sockaddr*)&cli_addr, &clen);

    if (fd2 < 0) {
      fprintf(stderr, "server: accept error\n");
      exit(1);
    }
   
    if ((cpid = fork()) < 0) {
      fprintf(stderr, "server: fork error\n");
      exit(1);
    }
    else if (cpid == 0) {
      close(fd1);
      str_rpl(fd2);
      exit(0);
    }
   
    close(fd2);
  }
}

#define MAXLINE 512

str_rpl(fd)
int fd;
{
  int n;
  char buf[MAXLINE];
  
  while(1) {
    n = readn(fd, buf, MAXLINE);
    if (n == 0)
      return;
    else if (n < 0) {
      fprintf(stderr, "str_rpl: readn error\n");
      exit(1);
    }
    if (writen(fd, buf, n) != n) {
      fprintf(stderr, "str_rpl: writen error\n");
      exit(1);
    }
  }
}

int readn(fd, p, len)
     int fd;
     char *p;
     int len;
{
  int n, val;
  char c;
  
  for (n=0; n<len;) {
    if ((val = read(fd, &c, 1)) == 1) {
      *p++ = c;
      n++;
      if (c == '\n')
	break;
    }
    else if (val == 0)
      break;
    else {
      n = -1;
      break;
    }
  }
  *p = 0;
  return(n);
}

int writen(fd, p, len)
     int fd;
     char *p;
     int len;
{
  int n, val;
  
  for (n=len; n>0;) {
    if ((val = write(fd, p, n)) <= 0)
      return(val);
    n -= val;
    p += val;
  }
  return(len);
}
