/*
 *  $Id: bht.c,v 1.5 1995/02/24 19:59:51 osone Exp $
 *  
 *  Copyright (c) 1994 HAL Computer Systems International, Ltd.
 *  All rights reserved.  Unpublished -- rights reserved under
 *  the Copyright Laws of the United States.  USE OF A COPYRIGHT
 *  NOTICE IS PRECAUTIONARY ONLY AND DOES NOT IMPLY PUBLICATION
 *  OR DISCLOSURE.
 *  
 *  THIS SOFTWARE CONTAINS CONFIDENTIAL INFORMATION AND TRADE
 *  SECRETS OF HAL COMPUTER SYSTEMS INTERNATIONAL, LTD.  USE,
 *  DISCLOSURE, OR REPRODUCTION IS PROHIBITED WITHOUT THE
 *  PRIOR EXPRESS WRITTEN PERMISSION OF HAL COMPUTER SYSTEMS
 *  INTERNATIONAL, LTD.
 *  
 *                          RESTRICTED RIGHTS LEGEND
 *  Use, duplication, or disclosure by the Government is subject
 *  to the restrictions as set forth in subparagraph (c)(l)(ii)
 *  of the Rights in Technical Data and Computer Software clause
 *  at DFARS 252.227-7013.
 *  
 *           HAL COMPUTER SYSTEMS INTERNATIONAL, LTD.
 *                   1315 Dell Avenue
 *                   Campbell, CA  95008
 */
#include "config_front_end.h"
#include "opcodes.h"
#include "globdef.h"

#define TableSize (64*1024)

extern unsigned long br_uncond_refs;
extern unsigned long br_cond_refs;
extern unsigned long br_cond_taken;
extern unsigned long br_corpred_on_mis;
extern unsigned long br_mispred_on_hit;
extern unsigned long br_mispred_on_mis;
typedef struct
  {
  unsigned long pc;         /* pc address of branch */
  unsigned long st;         /* two bit branch predict state */
  } Bht;
Bht BrHist[TableSize];
unsigned long BrSeq;

void InitBrHist(void)
  {
  int i;
  ;
  BrSeq = 0;
  for (i = 0; i < TableSize; i++)
    {
    BrHist[i].pc = 0;
    BrHist[i].st = 2;
    }
  }

int BrPred(unsigned long recode[], unsigned long pc, int taken)
  {
  unsigned int temp, index;
  int corpred = 0;
  int hit = 0;
  int state;
  ;
  switch (recode[0])  /* excluding unconditional branches */
    {
    case Bicc:
    case BiccP:
    case FBfcc:
    case FBfccP:
      if (((recode[1] >> 28) & 0x7) == 0)
        {
        br_uncond_refs++;
        return(1);
        }
      break;
    case BregP:
      if (((recode[1] >> 26) & 0x1f) == 0)
        {
        br_uncond_refs++;
        return(1);
        }
      break;
    default:
      break;
    }
  ;
  switch (recode[0])
    {
    case Bicc:
    case BiccP:
    case BregP:
    case FBfcc:
    case FBfccP:
      br_cond_refs++;
      br_cond_taken += taken;
      temp = pc >> 5;
      index = BrSeq ^ (((temp & 0x0001) << 15) |
                       ((temp & 0x0002) << 13) |
	               ((temp & 0x0004) << 11) |
	               ((temp & 0x0008) <<  9) |
	               ((temp & 0x0010) <<  7) |
	               ((temp & 0x0020) <<  5) |
	               ((temp & 0x0040) <<  3) |
	               ((temp & 0x0080) <<  1) |
	               ((temp & 0x0100) >>  1) |
	               ((temp & 0x0200) >>  3) |
	               ((temp & 0x0400) >>  5) |
	               ((temp & 0x0800) >>  7) |
	               ((temp & 0x1000) >>  9) |
	               ((temp & 0x2000) >> 11) |
	               ((temp & 0x4000) >> 13) |
	               ((temp & 0x8000) >> 15));
      state = BrHist[index].st;
      if ((taken && (state > 1)) || (!taken && (state < 2))) corpred = 1;
      if (pc == BrHist[index].pc) hit = 1;
      if ((corpred == 1) && (hit == 0)) br_corpred_on_mis++;
      if ((corpred == 0) && (hit == 1)) br_mispred_on_hit++;
      if ((corpred == 0) && (hit == 0)) br_mispred_on_mis++;
      if (taken && (state < 3))	BrHist[index].st++;
      if (!taken && (state > 0)) BrHist[index].st--;
      BrHist[index].pc = pc;
      BrSeq = ((BrSeq << 1) + taken) % TableSize;
      break;
    default:
      break;
    }
  return(corpred);
  }
