/*
 * $Id: dasm.h,v 1.1 1992/02/26 00:34:09 weiss Exp $
 *
 * Copyright (c) 1991 HaL Computer Systems, Inc.  All rights reserved.
 * UNPUBLISHED -- rights reserved under the Copyright Laws of the United
 * States.  Use of a copyright notice is precautionary only and does not
 * imply publication or disclosure.
 * 
 * This software contains confidential information and trade secrets of HaL
 * Computer Systems, Inc.  Use, disclosure, or reproduction is prohibited
 * without the prior express written permission of HaL Computer Systems, Inc.
 * 
 *                         RESTRICTED RIGHTS LEGEND
 * Use, duplication, or disclosure by the Government is subject to
 * restrictions as set forth in subparagraph (c)(l)(ii) of the Rights in
 * Technical Data and Computer Software clause at DFARS 252.227-7013.
 *                        HaL Computer Systems, Inc.
 *                  1315 Dell Avenue, Campbell, CA  95008
 * 
 */

#ifndef	INCLUDED_dasm_h

#define	INCLUDED_dasm_h
/*
**  Export char	*Instruction_Lookup(UINT instruction, UINT pc);
**
**	Instruction_Lookup will return a ptr to a static
**	character string containing a the dissasembled
**	32 bit instruction. The string must be copied before
**	the Instruction_Lookup is called again.
**	The pc should be a valid program counter value or -1.
**	This can be used for better symbolic references.
**	
**	
*/
Export char	*Instruction_Lookup();

/*
**  Export void	Instruction_Lookup_Init();
**
**	Instruction_Lookup_Init will initialize the decoding nary
**	tree that Instruction_Lookup() will use. Two levels of
**	debug are available:
**
**	    DEBUG=	1
**		Will lookup each instruction from the instruction
**		table and encode an instruction (using register %g0)
**		and call Instruction_Lookup().
**
**	    DEBUG=	2
**		All state associated with the Nary Trees aare printed
**		for some massive screw up.
*/
Export void	Instruction_Lookup_Init();


/*
**
**  Export void	Instruction_Register_Usage(UINT instruction)
**
**	Instruction_Register_Usage will track register usage
**	for this instruction
*/
Export void	Instruction_Register_Usage();

/*
**  Export void	Instruction_Register_Usage_Init()
**
**	Instruction_Register_Usage_Init initializes data structure
**	used by Instruction_Register_Usage();
**/
Export void	Instruction_Register_Usage_Init();


/*
**  Export void	Instruction_Register_Usage_Report(char *func)
**	
**	Report on register usage
*/
Export void	Instruction_Register_Usage_Report();


#endif	INCLUDED_dasm_h
