/*
 *  $Id: fe_config.c,v 1.8 1995/10/02 22:37:08 aiman Exp $
 *  
 *  Copyright (c) 1994 HAL Computer Systems International, Ltd.
 *  All rights reserved.  Unpublished -- rights reserved under
 *  the Copyright Laws of the United States.  USE OF A COPYRIGHT
 *  NOTICE IS PRECAUTIONARY ONLY AND DOES NOT IMPLY PUBLICATION
 *  OR DISCLOSURE.
 *  
 *  THIS SOFTWARE CONTAINS CONFIDENTIAL INFORMATION AND TRADE
 *  SECRETS OF HAL COMPUTER SYSTEMS INTERNATIONAL, LTD.  USE,
 *  DISCLOSURE, OR REPRODUCTION IS PROHIBITED WITHOUT THE
 *  PRIOR EXPRESS WRITTEN PERMISSION OF HAL COMPUTER SYSTEMS
 *  INTERNATIONAL, LTD.
 *  
 *                          RESTRICTED RIGHTS LEGEND
 *  Use, duplication, or disclosure by the Government is subject
 *  to the restrictions as set forth in subparagraph (c)(l)(ii)
 *  of the Rights in Technical Data and Computer Software clause
 *  at DFARS 252.227-7013.
 *  
 *           HAL COMPUTER SYSTEMS INTERNATIONAL, LTD.
 *                   1315 Dell Avenue
 *                   Campbell, CA  95008
 */
/**********************************************************************
  Initialize all caches, tlbs, and structures
  ***********************************************************************/
#include <stdio.h>
#include "globdef.h"
#include "config_front_end.h"
#include "u2.h"

extern gconf gl_conf;

void
fe_config (ipkt	 *fetch_p ,	/* instruction fetch packet array		*/
	   lspkt *ls_p )	/* load store packet array			*/
{

  int i,j,k,flag;
  unsigned temp;
  unsigned long index;

  ipkt  *fp ;
  lspkt	*lsp ;

  int    pkt_cnt ;
  
  fl_config();

  tp = (traceinfo *) malloc(TRACE_BUF_SIZE*sizeof(traceinfo));
  
  size = sizeof(traceinfo);

  icache = (i0_cache *) malloc(fl_conf.icache_size*sizeof(i0_cache)); 
  dcache = (d0_cache *) malloc(fl_conf.dcache_size*sizeof(d0_cache));
  tlb    = (main_tlb *) malloc(fl_conf.tlb_size*sizeof(main_tlb));
  mItlb = (micro_tlb *) malloc(fl_conf.mItlb_size*sizeof(micro_tlb));
  mDtlb = (micro_tlb *) malloc(fl_conf.mDtlb_size*sizeof(micro_tlb));
  wt_main_tlb = (wait_buffer *) malloc((fl_conf.max_ut_buf+1)*sizeof(wait_buffer));
  wt_unifd_cache = 
    (wait_buffer *) malloc((fl_conf.max_ut_buf+1)*sizeof(wait_buffer));

  wt_iu_cache = (wait_buffer *) malloc(2*sizeof(wait_buffer));

  wt_snoop_cache = 
    (wait_buffer *) malloc((2)*sizeof(wait_buffer));
  
  interleave = (unsigned *) malloc(fl_conf.no_int_lv*sizeof(wait_buffer));

  wt_ldst_req = 
    (wait_buffer *) malloc(gl_conf.no_of_ls_bufs*sizeof(wait_buffer));
	
  /* initialize wait buffers */

  for (i=0;i<fl_conf.no_int_lv;i++) {
    interleave[i] = 0;
  }
  
  for (i=0;i<(fl_conf.max_ut_buf+1);i++) { 
    wt_main_tlb[i].state = INVALID;
    wt_unifd_cache[i].state = INVALID;
  }

  for (i=0;i<(2);i++) { 
    wt_snoop_cache[i].state = INVALID;
  }

  for (i=0;i<gl_conf.no_of_ls_bufs;i++)
    wt_ldst_req[i].state = INVALID;
  
  /* initialize branch history table  */

  InitBrHist();

  /* initialize l1 cache */
  init_l1();
  
  /* initialize unified cache */
  init_u2();

  
  /* initialize main tlb */
  
  for (i=0;i<fl_conf.tlb_size;i++) {
    tlb[i].set[0] = 0;
    tlb[i].set[1] = 0;
    tlb[i].set[2] = 0;
    tlb[i].set[3] = 0;
    tlb[i].valid  = 0;
    tlb[i].repl   = 0x1b; /* the order 00 01 10 11 is 
			     stored in the byte */
  } 
  
  /* initialize micro tlbs */
  
  for (i=0;i<fl_conf.mItlb_size;i++) {
    mItlb[i].va = 0;
    mItlb[i].valid = 0;
  }
  
  for (i=0;i<fl_conf.mDtlb_size;i++) {
    mDtlb[i].va = 0;
    mDtlb[i].valid = 0;
  }

  /* initialize the fetch_p and ls_p */

  fp = fetch_p ;
  for (pkt_cnt = 0; pkt_cnt < MAX_IFETCH; pkt_cnt++) { 
    fp->valid = NOT_VALID ;
    fp++ ;
  }

  lsp = ls_p ;
  for (pkt_cnt = 0; pkt_cnt < MAX_LS_COMPL; pkt_cnt++) {
    lsp->valid = NOT_VALID ;
    lsp++ ;
  }

}







