/*
 *  $Id: fe_stats.c,v 1.7 1995/10/02 22:37:10 aiman Exp $
 *  
 *  Copyright (c) 1994 HAL Computer Systems International, Ltd.
 *  All rights reserved.  Unpublished -- rights reserved under
 *  the Copyright Laws of the United States.  USE OF A COPYRIGHT
 *  NOTICE IS PRECAUTIONARY ONLY AND DOES NOT IMPLY PUBLICATION
 *  OR DISCLOSURE.
 *  
 *  THIS SOFTWARE CONTAINS CONFIDENTIAL INFORMATION AND TRADE
 *  SECRETS OF HAL COMPUTER SYSTEMS INTERNATIONAL, LTD.  USE,
 *  DISCLOSURE, OR REPRODUCTION IS PROHIBITED WITHOUT THE
 *  PRIOR EXPRESS WRITTEN PERMISSION OF HAL COMPUTER SYSTEMS
 *  INTERNATIONAL, LTD.
 *  
 *                          RESTRICTED RIGHTS LEGEND
 *  Use, duplication, or disclosure by the Government is subject
 *  to the restrictions as set forth in subparagraph (c)(l)(ii)
 *  of the Rights in Technical Data and Computer Software clause
 *  at DFARS 252.227-7013.
 *  
 *           HAL COMPUTER SYSTEMS INTERNATIONAL, LTD.
 *                   1315 Dell Avenue
 *                   Campbell, CA  95008
 */
/*==============================================================================*/ 
/* Hal Denali Trace Driven Simulator						*/
/* Copyright (c) 1994 HaL Computer Systems, Inc.                      		*/
/*==============================================================================*/
/* fe_stats.c									*/
/*										*/
/*==============================================================================*/
/* Revision history								*/
/*										*/
/* Date	     Who	   	Description					*/ 
/* --------  -----------      	-----------					*/
/* 12/29/94  Nirmal Saxena  	Initial defintion				*/
/*										*/
/*==============================================================================*/

#include	<stdio.h>
#include	<string.h>

#include	"globdef.h"
#include        "config_front_end.h"

extern FILE *stats_file;
extern gstats global_stats;

/*==============================================================================*/

/* The print statistics routine will print out several levels of statistics data.
   The code will be added later. */

void fe_stats (void)
	
{
  fprintf(stats_file,"i0__refs   %u\n", icache_refs);
  fprintf(stats_file,"i0_miss    %u\n", icache_miss);
  fprintf(stats_file,"i0_repl    %u\n", icache_repl);
  fprintf(stats_file,"d0_refs    %u\n", dcache_refs);
  fprintf(stats_file,"stores     %u\n", dcache_st);
  fprintf(stats_file,"d0_miss    %u\n", dcache_miss);
  fprintf(stats_file,"d0_repl    %u\n", dcache_repl);
  fprintf(stats_file,"d0drepl    %u\n", dcache_drepl);
  fprintf(stats_file,"dirty_hits %u\n", drty_hits);
  fprintf(stats_file,"drty_flshs %u\n", drty_flshs);
  fprintf(stats_file,"line_brks  %u\n", ln_brks);
  fprintf(stats_file, "\n");

  /* U2 Cache statistics */
  fprintf(stats_file,"ucache_refs        %u\n", ucache_refs);
  fprintf(stats_file,"ucache_i_refs      %u\n", ucache_i_refs);
  fprintf(stats_file,"ucache_d_refs      %u\n", ucache_d_refs);
  fprintf(stats_file,"ucache_wb_refs     %u\n", ucache_wb_refs);
  fprintf(stats_file,"ucache_retag_refs  %u\n", ucache_retag_refs);
  fprintf(stats_file,"ucache_l1_snoops   %u\n", ucache_l1_snoops);
  fprintf(stats_file,"ucache_l1_dsnoops  %u\n", ucache_l1_dsnoops);
  fprintf(stats_file,"ucache_avg_refs    %.2f\n", 
	  (float) ucache_avg_refs/ucache_refs);
  fprintf(stats_file,"ucache_miss        %u\n", ucache_miss);
  fprintf(stats_file,"ucache_repl        %u\n", ucache_repl);
  fprintf(stats_file,"ucache_drepl       %u\n", ucache_drepl);
  fprintf(stats_file,"ucache_avg_misses  %.2f\n", 
	  (float) ucache_avg_misses/ucache_miss);
  fprintf(stats_file,"cpu_stall_imiss    %u\n", cpu_stall_imiss);
  fprintf(stats_file,"cpu_stall_dmiss    %u\n", cpu_stall_dmiss);
  fprintf(stats_file,"stream_buffer_hit  %u\n", stream_buffer_hit);
  fprintf(stats_file,"stream_buffer_miss %u\n", stream_buffer_miss);
  fprintf(stats_file, "\n");

  fprintf(stats_file,"Micro_I_tlb_refs   %u\n", mItlb_refs);
  fprintf(stats_file,"Micro_I_tlb_miss   %u\n", mItlb_miss);
  fprintf(stats_file,"Micro_I_tlb_repl   %u\n", mItlb_repl);
  fprintf(stats_file,"Micro_D_tlb_refs   %u\n", mDtlb_refs);
  fprintf(stats_file,"Micro_D_tlb_miss   %u\n", mDtlb_miss);
  fprintf(stats_file,"Micro_D_tlb_repl   %u\n", mDtlb_repl);
  fprintf(stats_file,"Main_tlb_refs      %u\n", tlb_refs);
  fprintf(stats_file,"Main_tlb_miss      %u\n", tlb_miss);
  fprintf(stats_file,"Main_tlb_repl      %u\n", tlb_repl);
  fprintf(stats_file,"jmpl_ret_refs      %u\n", jmpl_ret_refs);
  fprintf(stats_file,"jmpl_retl_refs     %u\n", jmpl_retl_refs);
  fprintf(stats_file,"jmpl_ret_np        %u\n", jmpl_ret_np);
  fprintf(stats_file,"jmpl_retl_np       %u\n", jmpl_retl_np);
  fprintf(stats_file,"jmpl_ret_mp        %u\n", jmpl_ret_mp);
  fprintf(stats_file,"jmpl_retl_mp       %u\n", jmpl_retl_mp);
  fprintf(stats_file,"call_refs          %u\n", call_refs);
  fprintf(stats_file,"jmpl_call_refs     %u\n", jmpl_call_refs);
  fprintf(stats_file,"stack_spill        %u\n", stack_spill);
  fprintf(stats_file,"branch uncond refs %u\n", br_uncond_refs);
  fprintf(stats_file,"branch cond refs   %u\n", br_cond_refs);
  fprintf(stats_file,"branch cond taken  %u\n", br_cond_taken);
  fprintf(stats_file,"branch table mis   %u\n", br_corpred_on_mis + br_mispred_on_mis);
  fprintf(stats_file,"branch mispred all %u\n", br_mispred_on_hit + br_mispred_on_mis);
  fprintf(stats_file,"branch mispred mis %u\n", br_mispred_on_mis);
  fprintf(stats_file,"branch freq(c+u)   %6.3f\n", (br_cond_refs + br_uncond_refs) * 100.0
                    / (global_stats.no_of_instructions - global_stats.no_of_annulled_insts));
  fprintf(stats_file,"branch freq(cond)  %6.3f\n", br_cond_refs * 100.0 
                    / (global_stats.no_of_instructions - global_stats.no_of_annulled_insts));
  fprintf(stats_file,"branch misprd rate %6.3f\n", (br_mispred_on_hit + br_mispred_on_mis)
	            * 100.0 / br_cond_refs);

} /* end fe_stats */

/*==============================================================================*/
