/*
 * $Id: opcodes.h,v 1.1 1994/12/17 00:28:38 saxena Exp $
 *
 * Copyright (c) 1993 HAL Computer Systems International, Ltd.
 * All rights reserved.  Unpublished -- rights reserved under
 * the Copyright Laws of the United States.  USE OF A COPYRIGHT
 * NOTICE IS PRECAUTIONARY ONLY AND DOES NOT IMPLY PUBLICATION
 * OR DISCLOSURE.
 * 
 * THIS SOFTWARE CONTAINS CONFIDENTIAL INFORMATION AND TRADE
 * SECRETS OF HAL COMPUTER SYSTEMS INTERNATIONAL, LTD.  USE,
 * DISCLOSURE, OR REPRODUCTION IS PROHIBITED WITHOUT THE
 * PRIOR EXPRESS WRITTEN PERMISSION OF HAL COMPUTER SYSTEMS
 * INTERNATIONAL, LTD.
 * 
 *                         RESTRICTED RIGHTS LEGEND
 * Use, duplication, or disclosure by the Government is subject
 * to the restrictions as set forth in subparagraph (c)(l)(ii)
 * of the Rights in Technical Data and Computer Software clause
 * at DFARS 252.227-7013.
 *
 *          HAL COMPUTER SYSTEMS INTERNATIONAL, LTD.
 *                  1315 Dell Avenue
 *                  Campbell, CA  95008
 * 
 */

/*
 * Added new macros to handle fp register encoding  saxena 1994/11/17
 * $Log: opcodes.h,v $
 * Revision 1.1  1994/12/17  00:28:38  saxena
 * @defects
 *
 * @comment
 * first addition to the repository
 *
 * Revision 1.8  1993/04/27  18:24:11  hudson
 * 4-state logical ops.
 *
 * Revision 1.7  1992/06/25  00:39:10  jaspal
 * Integrated new floating point code.
 *
 * Revision 1.6  1992/04/16  18:21:42  slice
 * Fixed F_disp16 macro.
 *
 * Revision 1.5  1992/03/20  23:27:54  rc
 * Upgrade from delta 3.1 to draft 0.5.
 *
 * Revision 1.4  1991/10/24  21:53:19  rc
 * Changes to bring simulator to SPARC-64 delta 3.1.
 *
 * Revision 1.3  1991/08/31  01:14:57  rc
 * Changed the (pseudo) opcode of CASX and CASXA to just above the real opcodes.
 *
 * Revision 1.2  1991/07/13  00:10:27  rc
 * Brought instruction set to delta 2.1 from delta 2.02.
 *
 * Revision 1.1  1991/06/13  19:37:55  rc
 * Initial revision
 *
 */

/*
** Logs kept prior to formal check-in to CVS
** Revision 0.2  1991/06/03  23:52:32  rc
** Added new and deleted decommitted opcodes based on SPARC-64 delta
** document 2.02.
**
** Revision 0.1  1991/05/11  01:30:19  rc
** Initial revision
**
*/
#ifndef OPCODES_H
#define OPCODES_H



/*
** HaL opcodes
*/

#define	UNIMP		0x00
#define BiccP		0x08
#define	Bicc		0x10
#define BregP		0x18
#define	SETHI		0x20
#define	FBfccP		0x28	
#define	FBfcc		0x30
#define	CALL		0x40

#define	ADD		0x80
#define	AND		0x81
#define	OR		0x82
#define	XOR		0x83
#define	SUB		0x84
#define	ANDN		0x85
#define	ORN		0x86
#define	XNOR		0x87
#define	ADDC		0x88
#define	MULX		0x89
#define	UMUL		0x8a
#define	SMUL		0x8b
#define	SUBC		0x8c
#define	UDIVX		0x8d
#define	UDIV		0x8e
#define	SDIV		0x8f
#define	ADDcc		0x90
#define	ANDcc		0x91
#define	ORcc		0x92
#define	XORcc		0x93
#define	SUBcc		0x94
#define	ANDNcc		0x95
#define	ORNcc		0x96
#define	XNORcc		0x97
#define	ADDCcc		0x98
#define	UMULcc		0x9a
#define	SMULcc		0x9b
#define	SUBCcc		0x9c
#define	UDIVcc		0x9e
#define	SDIVcc		0x9f
#define	TADDcc		0xa0
#define	TSUBcc		0xa1
#define	TADDccTV	0xa2
#define	TSUBccTV	0xa3
#define	MULScc		0xa4
#define	SLL		0xa5
#define	SRL		0xa6
#define	SRA		0xa7
#define	RDASR		0xa8
#define RDPR		0xaa
#define	FLUSHW		0xab
#define	MOVcc		0xac
#define SDIVX		0xad
#define	POPC		0xae
#define	MOVR		0xaf
#define	WRASR		0xb0
#define	SAVED		0xb1
#define WRPR		0xb2
#define	FPop1		0xb4
#define	FPop2		0xb5
#define IMPDEP1		0xb6
#define IMPDEP2		0xb7
#define	JMPL		0xb8
#define	RETURN		0xb9
#define	Tcc		0xba
#define	FLUSH		0xbb
#define	SAVE		0xbc
#define	RESTORE		0xbd
#define DONE		0xbe
#define	LDUW		0xc0
#define	LDUB		0xc1
#define	LDUH		0xc2
#define	LDD		0xc3
#define	STW		0xc4
#define	STB		0xc5
#define	STH		0xc6
#define	STD		0xc7
#define	LDSW		0xc8
#define	LDSB		0xc9
#define	LDSH		0xca
#define	LDX		0xcb
#define	LDSTUB		0xcd
#define	STX		0xce
#define	SWAP		0xcf
#define	LDUWA		0xd0
#define	LDUBA		0xd1
#define	LDUHA		0xd2
#define	LDDA		0xd3
#define	STWA		0xd4
#define	STBA		0xd5
#define	STHA		0xd6
#define	STDA		0xd7
#define	LDSWA		0xd8
#define	LDSBA		0xd9
#define	LDSHA		0xda
#define	LDXA		0xdb
#define	LDSTUBA		0xdd
#define	STXA		0xde
#define	SWAPA		0xdf
#define	LDF		0xe0
#define	LDFSR		0xe1
#define	LDQF		0xe2
#define	LDDF		0xe3
#define	STF		0xe4
#define	STFSR		0xe5
#define	STQF		0xe6
#define	STDF		0xe7
#define	CAS		0xec
#define	PREFETCH	0xed
#define	CASX		0xee
#define LDFA		0xf0
#define LDQFA		0xf2
#define LDDFA		0xf3
#define STFA		0xf4
#define STQFA		0xf6
#define STDFA		0xf7
#define	CASA		0xfc
#define	PREFETCHA	0xfd
#define	CASXA		0xfe
#define RETRY		0x100	/* psuedo opcode */
#define RESTORED	0x101	/* psuedo opcode */
#define LDXFSR		0x102	/* psuedo opcode */
#define	STXFSR		0x103	/* pseudo opcode */


/* 
** HaL floating point opcodes (opf field)
*/

/* FPop1 codes */
#define	FMOVs		0x01
#define	FMOVd		0x02
#define FMOVq		0x03
#define	FNEGs		0x05
#define	FNEGd		0x06
#define	FNEGq		0x07
#define	FABSs		0x09
#define	FABSd		0x0a
#define	FABSq		0x0b
#define	FSQRTs		0x29
#define	FSQRTd		0x2a
#define	FSQRTq		0x2b
#define	FADDs		0x41
#define	FADDd		0x42
#define FADDq		0x43
#define	FSUBs		0x45
#define	FSUBd		0x46
#define	FSUBq		0x47
#define	FMULs		0x49
#define	FMULd		0x4a
#define	FMULq		0x4b
#define	FDIVs		0x4d
#define	FDIVd		0x4e
#define	FDIVq		0x4f
#define	FsMULd		0x69
#define	FdMULq		0x6e
#define	FsTOx		0x81
#define	FdTOx		0x82
#define	FqTOx		0x83
#define	FxTOs		0x84
#define	FxTOd		0x88
#define	FxTOq		0x8c
#define	FiTOs		0xc4
#define	FdTOs		0xc6
#define	FqTOs		0xc7
#define	FiTOd		0xc8
#define	FsTOd		0xc9
#define	FqTOd		0xcb
#define	FiTOq		0xcc
#define	FsTOq		0xcd
#define	FdTOq		0xce
#define	FsTOi		0xd1
#define	FdTOi		0xd2
#define	FqTOi		0xd3


/* FPop2 codes */
#define	FCMPs		0x051
#define	FCMPd		0x052
#define	FCMPq		0x053
#define	FCMPEs		0x055
#define	FCMPEd		0x056
#define	FCMPEq		0x057
#define FMOVccS		0x01
#define FMOVccD		0x02
#define FMOVccQ		0x03
#define FMOVrcS1	(0x05+0x00)
#define FMOVrcS2	(0x05+0x20)
#define FMOVrcD1	(0x06+0x00)
#define FMOVrcD2	(0x06+0x20)
#define FMOVrcQ1	(0x07+0x00)
#define FMOVrcQ2	(0x07+0x20)


/* IMPDEP1 codes */
#define	FMADDs		0x1
#define	FMADDd		0x2
#define	FMADDq		0x3
#define	FMSUBs		0x5
#define	FMSUBd		0x6
#define	FMSUBq		0x7
#define	FNMSUBs		0x9
#define	FNMSUBd		0xa
#define	FNMSUBq		0xb
#define	FNMADDs		0xd
#define	FNMADDd		0xe
#define	FNMADDq		0xf

/* IMPDEP2 codes (4-state logical ops) */
#define AND4cc		0x0
#define OR4cc		0x1
#define XOR4cc		0x2
#define DOT4cc		0x3
#define TX4cc		0x4
#define WK4cc		0x5
#define TRI4cc		0x6
#define CMP4cc		0x7


/* macros to get at instruction fields
*/
#define F_op(i)		((i>>30)&0x3)
#define F_a(i)		((i>>29)&0x1)
#define F_fcc0(i)	((i>>25)&0x3)	
#define F_cond(i)	((i>>25)&0xf)	
#define F_rd(i)		((i>>25)&0x1f)
#define F_op2(i)	((i>>22)&0x7)
#define F_bcc(i)	((i>>20)&0x3)
#define F_fcc1(i)	((i>>20)&0x3)
#define F_op3(i)	((i>>19)&0x3f)
#define F_mcond(i)	((i>>14)&0xf)
#define F_rs1(i)	((i>>14)&0x1f)
#define F_rtstb(i)	((i>>14)&0x1f)
#define F_i(i)		((i>>13)&0x1)
#define F_tcc(i)	((i>>12)&0x1)
#define F_sh64(i)	((i>>12)&0x1)
#define F_rcond(i)	((i>>10)&0x7)
#define F_rtst(i)	((i>>9)&0x1f)
#define F_iorf(i)	((i>>8)&0x1)
#define F_rs3(i)	((i>>9)&0x1f)
#define F_asi(i)	((i>>5)&0xff)
#define F_opf(i)	((i>>5)&0x1ff)
#define	F_subop(i)	((i>>10)&0x7)
#define F_rs2(i)	(i&0x1f)
#define F_shcnt32(i)	(i&0x1f)
#define F_shcnt64(i)	(i&0x3f)
#define F_trapno(i)	(i&0x7f)
#define F_simm10(i)	(i&0x3ff)	
#define F_simm11(i)	(i&0x7ff)	
#define F_simm13(i)	(i&0x1fff)	
#define F_imm22(i)	(i&0x3fffff)
#define F_disp19(i)	(i&0x7ffff)
#define F_disp21(i)	(i&0x1fffff)
#define F_disp22(i)	(i&0x3fffff)
#define F_disp30(i)	(i&0x3fffffff)
#define F_ixfcc0(i)	(((i>>16)&0x4)|((i>>11)&0x3))
#define F_ixfcc1(i)	((i>>11)&0x7) 
#define F_disp16(i)	(((i>>6)&0xc000)|(i&0x3fff))
#define QUAD(i)		(((i&0x1)<<5)|(i&0x1c))
#define DOUBLE(i)	(((i&0x1)<<5)|(i&0x1e))

#endif	/* OPCODES_H */
