/*
 *  $Id: rpStack.c,v 1.1 1994/12/29 21:48:38 saxena Exp $
 *  
 *  Copyright (c) 1994 HAL Computer Systems International, Ltd.
 *  All rights reserved.  Unpublished -- rights reserved under
 *  the Copyright Laws of the United States.  USE OF A COPYRIGHT
 *  NOTICE IS PRECAUTIONARY ONLY AND DOES NOT IMPLY PUBLICATION
 *  OR DISCLOSURE.
 *  
 *  THIS SOFTWARE CONTAINS CONFIDENTIAL INFORMATION AND TRADE
 *  SECRETS OF HAL COMPUTER SYSTEMS INTERNATIONAL, LTD.  USE,
 *  DISCLOSURE, OR REPRODUCTION IS PROHIBITED WITHOUT THE
 *  PRIOR EXPRESS WRITTEN PERMISSION OF HAL COMPUTER SYSTEMS
 *  INTERNATIONAL, LTD.
 *  
 *                          RESTRICTED RIGHTS LEGEND
 *  Use, duplication, or disclosure by the Government is subject
 *  to the restrictions as set forth in subparagraph (c)(l)(ii)
 *  of the Rights in Technical Data and Computer Software clause
 *  at DFARS 252.227-7013.
 *  
 *           HAL COMPUTER SYSTEMS INTERNATIONAL, LTD.
 *                   1315 Dell Avenue
 *                   Campbell, CA  95008
 */
#include "opcodes.h"
#define StackDepth 8 
extern unsigned long jmpl_ret_refs;
extern unsigned long jmpl_retl_refs;
extern unsigned long jmpl_ret_np;
extern unsigned long jmpl_retl_np;
extern unsigned long jmpl_ret_mp;
extern unsigned long jmpl_retl_mp;
extern unsigned long call_refs;
extern unsigned long jmpl_call_refs;
extern unsigned long stack_spill;
static unsigned long stack[StackDepth];
static unsigned long pointer = 0; /* stack initialized as */
				  /* empty */
void push(unsigned long pc);
void pop(void);

int rpStack (unsigned long recode[],
	      unsigned long pc,
	      unsigned long ea)
{
  unsigned rd, rs1, imm;
  int pred=0;
  switch (recode[0]) {
  case CALL:
    push(pc+8);
    call_refs++;
    pred = 1;
    break;
  case JMPL:
    rd = (recode[1]>>14)&0x3f;
    switch (rd) {
    case 15: 
      push(pc+8);
      jmpl_call_refs++;
      break;
    case 0:
      rs1 = recode[1] >> 26;
      imm = recode[1]&0x3ff;	/* 2*simm13+i                   */
      if (imm==17) {		/* immediate field for ret retl */
	if (rs1 == 31) {	/* non leaf routine             */
	  jmpl_ret_refs++;
	  if (pointer == 0)
	    jmpl_ret_np++;
	  else {
	    if (ea != stack[0]) {
	      jmpl_ret_mp++;
	      pop();
	    }
	    else
	      pred=1;
	    pop();
	  }
	}
	if (rs1 == 15) {	/* leaf routine                 */
	  jmpl_retl_refs++;
	  if (pointer == 0)
	    jmpl_retl_np++;
	  else {
	    if (ea != stack[0]) {
	      jmpl_retl_mp++;
	      pop();
	    }
	    else
	      pred =1;
	    pop();
	  }
	}
      }
      break;
    default:
      break;
    }
    break;
  default:
    break;
  }
  return(pred); 
}

void push (unsigned long pc)
{
  int i;
  for (i=StackDepth-1;i>0;i--)
    stack[i] = stack[i-1];
  if (pointer < StackDepth)
    pointer++;
  else
    stack_spill++;
  stack[0] = pc;
}

void pop (void)
{
  int i;
  if (pointer > 0)
    pointer--;
  for (i=0;i<(StackDepth-1);i++)
    stack[i] = stack[i+1];
  stack[StackDepth] = 0;
}








