/*
 *  $Id: tsim.h,v 1.14 1995/10/02 22:37:55 aiman Exp $
 *  
 *  Copyright (c) 1994 HAL Computer Systems International, Ltd.
 *  All rights reserved.  Unpublished -- rights reserved under
 *  the Copyright Laws of the United States.  USE OF A COPYRIGHT
 *  NOTICE IS PRECAUTIONARY ONLY AND DOES NOT IMPLY PUBLICATION
 *  OR DISCLOSURE.
 *  
 *  THIS SOFTWARE CONTAINS CONFIDENTIAL INFORMATION AND TRADE
 *  SECRETS OF HAL COMPUTER SYSTEMS INTERNATIONAL, LTD.  USE,
 *  DISCLOSURE, OR REPRODUCTION IS PROHIBITED WITHOUT THE
 *  PRIOR EXPRESS WRITTEN PERMISSION OF HAL COMPUTER SYSTEMS
 *  INTERNATIONAL, LTD.
 *  
 *                          RESTRICTED RIGHTS LEGEND
 *  Use, duplication, or disclosure by the Government is subject
 *  to the restrictions as set forth in subparagraph (c)(l)(ii)
 *  of the Rights in Technical Data and Computer Software clause
 *  at DFARS 252.227-7013.
 *  
 *           HAL COMPUTER SYSTEMS INTERNATIONAL, LTD.
 *                   1315 Dell Avenue
 *                   Campbell, CA  95008
 */
/*==============================================================================*/ 
/* Hal Denali Trace Driven Simulator						*/
/* Copyright (c) 1994 HaL Computer Systems, Inc.                      		*/
/*==============================================================================*/
/* tsim.h									*/
/*										*/
/*==============================================================================*/
/* Revision history								*/
/*										*/
/* Date	     Who	   	Description					*/ 
/* --------  -----------      	-----------					*/
/* 10/30/94  Per Forssell  	Initial defintion				*/
/*										*/
/*==============================================================================*/
#include "config_front_end.h"
#include "u2.h"



/*==============================================================================*/
/* Global file pointers								*/
/*==============================================================================*/

FILE	*dump_file ;		/* pointer to the dump file			*/
FILE	*stats_file ;		/* pointer to the stats file			*/
FILE	*trace_file ;		/* pointer to the trace file			*/
FILE	*config_file ;		/* pointer to the config file			*/

/*==============================================================================*/
/* Global variable declarations							*/
/*==============================================================================*/

/* file names ------------------------------------------------------------------*/

char	config_file_name[MAX_FNAME] ;	/* processor configuration file	name	*/
char	stats_file_name[MAX_FNAME] ;	/* simulation statistics file name	*/
char	trace_file_name[MAX_FNAME] ;	/* simulation trace file name		*/
char	dump_file_name[MAX_FNAME] ;	/* simulation dump file name		*/
char	warmup_file_name[MAX_FNAME] ;	/* tsim warmup file name		*/

/* globally visible processor status registers ---------------------------------*/

int	pstate_reg = INIT_PSTATE;  /* processor status register			*/
int	cwp_reg    = INIT_CWP ;	   /* current window pointer			*/

/* instruction que pointers ----------------------------------------------------*/

qslot	*iq_head ;		/* first entry in the instruction que		*/
qslot	*iq_tail ;		/* last entry in the instruction que		*/
qslot	*lastv_qslot ;		/* last valid qslot				*/
qslot	*firstf_qslot ;		/* first free qslot				*/

/* global configuration --------------------------------------------------------*/

gconf	gl_conf ;		/* global configuration structure		*/

/* statistics ------------------------------------------------------------------*/

gstats	global_stats ;		/* global statistics summary			*/

/* execution flags -------------------------------------------------------------*/

int	dump_mode = 0 ;		/* trace mode flag				*/

/* clock and instruciton counters ----------------------------------------------*/

ulong	clk_cycle = 1 ;		/* current clock cycle				*/
ulong	c_inst_no = 1 ;		/* instruction sequence counter	in current 
				   clock cycle					*/
ulong	n_inst_no = 1 ;		/* instruction sequence counter	in next 
				   clock cycle					*/

/*==============================================================================*/



unsigned long          va;
cmd_type        command;
wait_buffer     *wt_main_tlb;
wait_buffer     *wt_unifd_cache;
wait_buffer     *wt_iu_cache;
wait_buffer     *wt_snoop_cache;
wait_buffer     *wt_ldst_req;
unsigned        *interleave;
unsigned               limit;
int                    size;
unsigned               icache_miss=0;
unsigned               icache_refs=0;
unsigned               icache_repl=0;
unsigned               dcache_miss=0;
unsigned               dcache_refs=0;
unsigned               dcache_st=0;
unsigned               dcache_repl=0;
unsigned               dcache_drepl=0;

unsigned               ucache_miss=0;
unsigned               ucache_refs=0;
unsigned               ucache_i_refs=0;
unsigned               ucache_d_refs=0;
unsigned               ucache_wb_refs=0;
unsigned               ucache_retag_refs=0;
unsigned               ucache_l1_snoops=0;
unsigned               ucache_l1_dsnoops=0;
unsigned               ucache_avg_refs=0;
unsigned               ucache_repl=0;
unsigned               ucache_drepl=0;
unsigned               ucache_avg_misses=0;
unsigned               cpu_stall_imiss=0;
unsigned               cpu_stall_dmiss=0;
unsigned               stream_buffer_hit=0;           
unsigned               stream_buffer_miss=0;           

unsigned               mItlb_miss=0;
unsigned               mItlb_refs=0;
unsigned               mItlb_repl=0;
unsigned               mDtlb_miss=0;
unsigned               mDtlb_refs=0;
unsigned               mDtlb_repl=0;
unsigned               tlb_miss=0;
unsigned               tlb_refs=0;
unsigned               tlb_repl=0;
unsigned               mItlb_pntr=0;
unsigned               mDtlb_pntr=0;
unsigned               drty_hits=0;
unsigned               drty_flshs=0;
unsigned               ln_brks=0;
i0_cache       *icache;
d0_cache       *dcache;
unified_cache  *ucache;
main_tlb       *tlb;
micro_tlb      *mItlb;
micro_tlb      *mDtlb;
traceinfo       *tp;
traceinfo       *mrkr = NULL;
int                    Imiss_flag, Dmiss_flag,
                        mImiss_flag, mDmiss_flag, Tmiss_flag, Umiss_flag;
int                    dirty_va, Dmiss_repl;
fconf    fl_conf;
unsigned long jmpl_ret_refs=0;
unsigned long jmpl_retl_refs=0;
unsigned long jmpl_ret_np=0;
unsigned long jmpl_retl_np=0;
unsigned long jmpl_ret_mp=0;
unsigned long jmpl_retl_mp=0;
unsigned long call_refs=0;
unsigned long jmpl_call_refs=0;
unsigned long stack_spill=0;
unsigned long br_uncond_refs=0;
unsigned long br_cond_refs=0;
unsigned long br_cond_taken=0;
unsigned long br_corpred_on_mis=0;
unsigned long br_mispred_on_hit=0;
unsigned long br_mispred_on_mis=0;
unsigned warmup_state=0;

/**************************************************************************************/


















