/*
 *  $Id: tview.h,v 1.2 1995/01/17 01:17:23 forssell Exp $
 *  
 *  Copyright (c) 1994 HAL Computer Systems International, Ltd.
 *  All rights reserved.  Unpublished -- rights reserved under
 *  the Copyright Laws of the United States.  USE OF A COPYRIGHT
 *  NOTICE IS PRECAUTIONARY ONLY AND DOES NOT IMPLY PUBLICATION
 *  OR DISCLOSURE.
 *  
 *  THIS SOFTWARE CONTAINS CONFIDENTIAL INFORMATION AND TRADE
 *  SECRETS OF HAL COMPUTER SYSTEMS INTERNATIONAL, LTD.  USE,
 *  DISCLOSURE, OR REPRODUCTION IS PROHIBITED WITHOUT THE
 *  PRIOR EXPRESS WRITTEN PERMISSION OF HAL COMPUTER SYSTEMS
 *  INTERNATIONAL, LTD.
 *  
 *                          RESTRICTED RIGHTS LEGEND
 *  Use, duplication, or disclosure by the Government is subject
 *  to the restrictions as set forth in subparagraph (c)(l)(ii)
 *  of the Rights in Technical Data and Computer Software clause
 *  at DFARS 252.227-7013.
 *  
 *           HAL COMPUTER SYSTEMS INTERNATIONAL, LTD.
 *                   1315 Dell Avenue
 *                   Campbell, CA  95008
 */
/*==============================================================================*/ 
/* Hal Denali Trace Driven Simulator						*/
/* Copyright (c) 1994 HaL Computer Systems, Inc.                      		*/
/*==============================================================================*/
/* tview.h									*/
/*										*/
/*==============================================================================*/
/* Revision history								*/
/*										*/
/* Date	     Who	   	Description					*/ 
/* --------  -----------      	-----------					*/
/* 10/30/94  Per Forssell  	Initial defintion				*/
/*										*/
/*==============================================================================*/

#define TVIEW_VERSION_NO	("1.00")	/* Version number		*/

/*==============================================================================*/
/* General definitions							     	*/
/*==============================================================================*/

#define	TRUE		(1)
#define FALSE		(0)
#define	EOL		("\0")

#define MAX_NAME       (32) /* max number of characters in names		*/
#define MAX_FNAME     (128) /* max number of characters in file names		*/
#define MAX_LINE      (512) /* max number of characters in a file input line	*/

#define	MAX_IQUE     (1024) /* max instruction que length			*/

/*==============================================================================*/
/* Global definitions								*/
/*==============================================================================*/

#define	DEF_CYCLES_PER_PAGE	(64)	/* number of clock cycles on a page	*/
#define MAX_CYCLES_PER_PAGE   (1024)    /* max number of clock cycles on a page */

/*==============================================================================*/
/* Global structure definitions							*/
/*==============================================================================*/

/* The view_line structure represents one line of view data. A page of view data
   is represented by a linked list of view_line's. */

typedef struct	view_line {
  long  inst_no ;		/* instruction number				*/
  char  inst_op[MAX_NAME] ;	/* dissasembled instruction			*/
  char  eu_name[MAX_NAME] ;	/* execution unit name				*/ 
  char	inst_hist[MAX_LINE] ;	/* instruction history for the clock cycles 
				   within the page. 				*/
  struct view_line *next_vline ;/* pointer to the next view line		*/
} vline ;

/*==============================================================================*/
/* Global function definitions							*/
/*==============================================================================*/

char    *Instruction_Lookup();	/* Function for dis-assembling and instruciton	*/

/*==============================================================================*/










