/*
 *  $Id: u2.h,v 1.4 1995/10/02 22:38:00 aiman Exp $
 *  
 *  Copyright (c) 1994 HAL Computer Systems International, Ltd.
 *  All rights reserved.  Unpublished -- rights reserved under
 *  the Copyright Laws of the United States.  USE OF A COPYRIGHT
 *  NOTICE IS PRECAUTIONARY ONLY AND DOES NOT IMPLY PUBLICATION
 *  OR DISCLOSURE.
 *  
 *  THIS SOFTWARE CONTAINS CONFIDENTIAL INFORMATION AND TRADE
 *  SECRETS OF HAL COMPUTER SYSTEMS INTERNATIONAL, LTD.  USE,
 *  DISCLOSURE, OR REPRODUCTION IS PROHIBITED WITHOUT THE
 *  PRIOR EXPRESS WRITTEN PERMISSION OF HAL COMPUTER SYSTEMS
 *  INTERNATIONAL, LTD.
 *  
 *                          RESTRICTED RIGHTS LEGEND
 *  Use, duplication, or disclosure by the Government is subject
 *  to the restrictions as set forth in subparagraph (c)(l)(ii)
 *  of the Rights in Technical Data and Computer Software clause
 *  at DFARS 252.227-7013.
 *  
 *           HAL COMPUTER SYSTEMS INTERNATIONAL, LTD.
 *                   1315 Dell Avenue
 *                   Campbell, CA  95008
 */

/**********************************************************************
  Program to evaluate benchmark programs on Denali. This portion of
  the simulator models the denali unified level 2 cache.
  
  Started 8/7/95, Aiman Kabakibo
  
 ***********************************************************************/

#define TAG_RQUEUE_SIZE     (fl_conf.ucache_pipestages+1)
#define TAG_WQUEUE_SIZE     4
#define WT_IU_CACHE_SIZE    2

/* Inclusion defines. Do not change since these values match what is
   specified in the that state_slam.u2 file */
#define NOINCL              0
#define I0INCL              1
#define D0INCL              2

#define STREAM_BUFFER_SIZE  10


typedef enum {TAG_INVALID,TAG_READ,TAG_WRITE, TAG_MISS} tag_req_type;
typedef enum {U2_HIT, U2_MISS, U2_MISS_W_WB, U2_RETAG} req_state;

typedef char boolean;

typedef struct {
  unsigned va;
  boolean  valid;
  boolean  dirty;
  boolean  inclusion;
} unified_cache;

typedef struct {
   wait_buffer * request;
   tag_req_type  type;
   unsigned      addr;
   unsigned      multi_cycle;
} tag_queue;


extern unified_cache *ucache;
extern tag_queue *tag_wqueue, *tag_rqueue, *tag_pipe, *miss_queue;
extern char warmup_file_name[];
extern void init_u2();
extern boolean access_u2();
extern unsigned u2_lru_repl();
extern boolean tag_unit();
extern void shift_queue(), push_queue();
extern boolean is_queue_full(), snoop_queue();
extern wait_buffer * pop_queue();
extern void assertion_error();
extern wait_buffer * is_completed_miss();
extern wait_buffer * get_request();
extern void update_misses();
extern wait_buffer * copy_request();
extern int count_ucache_miss_reqs(), count_ucache_wt_reqs();
extern boolean i_wt_match(), d_wt_match();



