
static char xspcon_RcsId[] =
"$Id: xspcon.c,v 1.55 1996/12/02 01:18:28 nakashim Exp nakashim $";

/* M-on-RISC Dynamically Translating Simulator */
/*                                 XSP CONSOLE */
/*       Copyright (c) 1996 by FUJITSU LIMITED */
/*                 Primary writer: Y.Nakashima */
/*          nakashim@pine.mfd.cs.fujitsu.co.jp */

#include <stdio.h>
#include <errno.h>
#include <fcntl.h>
#include <sgtty.h>
#include <time.h>
#include <sys/types.h>

/* xspcon.c 1996/3/10 by Y.Nakashima */

#define BUFFSIZE     (8192)
#define SCRMAXX      (79)
#define SCRMAXY      (23)
#define SCRIMAGE     ((SCRMAXX+1)*(SCRMAXY+1))
#define putstr(s)    {uwrite(0,s,strlen(s));}
#define putcha(i)    {*mbuf = (i)?(i):' ';uwrite(0,mbuf,1);}
#define locate(x,y)  {sprintf(mbuf,"\033[%d;%dH",(y)+1,(x)+1);putstr(mbuf);}

#define bputstr(s)   {strcat(bbuf,s);}
#define bputcha(i)   {*mbuf = (i)?(i):' ';strncat(bbuf,mbuf,1);}
#define bflush()     {uwrite(0,bbuf,strlen(bbuf));*bbuf = 0;}
#define blocate(x,y) {sprintf(mbuf,"\033[%d;%dH",(y)+1,(x)+1);bputstr(mbuf);}

#define savecurs()   {putstr("\0337");}
#define restcurs()   {putstr("\0338");}
#define clearscr()   {putstr("\033[1;1H\033[0J");}
#define clearmes()   {savecurs();putstr("\033[25;1H\033[K");messon=0;restcurs();}
#define message(a)   {savecurs();sprintf(mbuf,"\033[25;1H\033[K\033[0;1m%s\033[0m",a);putstr(mbuf);messon=1;restcurs();}
#define debug(a,v)   {savecurs();putstr("\033[26;1H\033[K\033[33;2m");sprintf(mbuf,a,v);putstr(mbuf);putstr("\033[34;0m");restcurs();}

char           *version();
int            kanji;            /* 0:EBCDIC, 1:JEF */
int	       lock;	         /* 0:unlocked, 1:locked */
int	       messon;	         /* 0:no message, 1:some message */
int            esc;              /* 0:normal, 1:ESC, 2:ESC[ */
int	       fd1, fd2, fd3;	 /* coin, cout, debug */
char           logfile[32];      /* name of log_file */

unsigned char  mbuf[BUFFSIZE];   /* message buffer */
unsigned char  bbuf[BUFFSIZE];   /* output buffer */
unsigned char  ebuf[BUFFSIZE];   /* emm communication buffer */
unsigned char  cbuf[BUFFSIZE];   /* command buffer */
unsigned char  *cp = (unsigned char*)cbuf;
unsigned char  scr[SCRIMAGE];	 /* SCR image */
unsigned char  atr[SCRIMAGE];	 /* ATR image */
unsigned char  sf[SCRIMAGE];	 /* SF image */
unsigned char  atr0;	         /* ATR0 */
unsigned char  wcc;              /* WCC */
unsigned char  aid;		 /* KBD attention */
char           curx, cury;	 /* cursor position */
char           bufx, bufy;	 /* buffer position */

static unsigned char ascii[] = {
   0,  0,  0,  0,  0,'\t', 0,  0,  0,  0,  0,  0,  0,'\r', 0,  0,
   0,  0,  0,  0,  0,'\n', 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
  ' ', 0,  0,  0,  0,  0,  0,  0,  0,  0,  0, '.','<','(','+','|',
  '&', 0,  0,  0,  0,  0,  0,  0,  0,  0, '!','$','*',')',';','^',
  '-','/', 0,  0,  0,  0,  0,  0,  0,  0,  0, ',','%','_','>','?',
   0,  0,  0,  0,  0,  0,  0,  0,  0,  0, ':','#','@','\'','=','\"',/*"*/

   0, 'a','b','c','d','e','f','g','h','i', 0,  0,  0,  0,  0,  0,
   0, 'j','k','l','m','n','o','p','q','r', 0,  0,  0,  0,  0,  0,
   0, '~','s','t','u','v','w','x','y','z', 0,  0,  0, '[', 0,  0,
   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, ']', 0,  0,
  '{','A','B','C','D','E','F','G','H','I', 0,  0,  0,  0,  0,  0,
  '}','J','K','L','M','N','O','P','Q','R', 0,  0,  0,  0,  0,  0,
 '\\', 0, 'S','T','U','V','W','X','Y','Z', 0,  0,  0,  0,  0,  0,
  '0','1','2','3','4','5','6','7','8','9', 0,  0,  0,  0,  0,  0};

static unsigned char ebcdic[] = {
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x40, 0x5a, 0x7f, 0x7b, 0x5b, 0x6c, 0x50, 0x7d,
  0x4d, 0x5d, 0x5c, 0x4e, 0x6b, 0x60, 0x4b, 0x61,
  0xf0, 0xf1, 0xf2, 0xf3, 0xf4, 0xf5, 0xf6, 0xf7,
  0xf8, 0xf9, 0x7a, 0x5e, 0x4c, 0x7e, 0x6e, 0x6f,
  0x7c, 0xc1, 0xc2, 0xc3, 0xc4, 0xc5, 0xc6, 0xc7,
  0xc8, 0xc9, 0xd1, 0xd2, 0xd3, 0xd4, 0xd5, 0xd6,
  0xd7, 0xd8, 0xd9, 0xe2, 0xe3, 0xe4, 0xe5, 0xe6,
  0xe7, 0xe8, 0xe9, 0xad, 0xe0, 0xbd, 0x5f, 0x6d,
  0x00, 0x81, 0x82, 0x83, 0x84, 0x85, 0x86, 0x87,
  0x88, 0x89, 0x91, 0x92, 0x93, 0x94, 0x95, 0x96,
  0x97, 0x98, 0x99, 0xa2, 0xa3, 0xa4, 0xa5, 0xa6,
  0xa7, 0xa8, 0xa9, 0xc0, 0x4f, 0xd0, 0xa1, 0x00,

  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00};

main(argc, argv)
     int argc; 
     char **argv;
{
  struct sgttyb termiosArg, termiosArg0, termiosArg1;
  fd_set fdset;
  int i;
  
#ifdef DEBUG_SEPARATE_TTY
  if (argc != 3) {
    fprintf(stderr, "usage: %s <in_file> <out_file>\n", argv[0]);
    exit(1);
  }
  if ((fd1=open(argv[1], O_RDONLY)) == -1) {
    fprintf(stderr, "can't open %s\n", argv[1]);
    exit(1);
  }
  if ((fd2=open(argv[2], O_WRONLY)) == -1) {
    fprintf(stderr, "can't open %s\n", argv[2]);
    exit(1);
  }
#else
  if (argc != 2) {
    fprintf(stderr, "usage: %s <in/out_file>\n", argv[0]);
    exit(1);
  }
  if ((fd1=fd2=open(argv[1], O_RDWR)) == -1) {
    fprintf(stderr, "can't open %s\n", argv[1]);
    exit(1);
  }
#endif
#ifdef DEBUG
  sprintf(logfile ,"/tmp/.xsplog%u", getpid());
  if ((fd3 = open(logfile, O_CREAT|O_WRONLY, 0777)) == -1) {
    fprintf(stderr, "can't create \"%s\"\n", logfile);
    exit(1);
  }
#endif

  ioctl(fd1, TIOCGETP, &termiosArg);
  termiosArg.sg_flags |= RAW;
  termiosArg.sg_flags &= ~ECHO;
  termiosArg.sg_ispeed = LINESPEED;
  ioctl(fd1, TIOCSETP, &termiosArg);

  ioctl(fd2, TIOCGETP, &termiosArg);
  termiosArg.sg_flags |= RAW;
  termiosArg.sg_flags &= ~ECHO;
  termiosArg.sg_ospeed = LINESPEED;
  ioctl(fd2, TIOCSETP, &termiosArg);

  ioctl(0,   TIOCGETP, &termiosArg);
  termiosArg0 = termiosArg;
  termiosArg.sg_flags |= RAW;
  termiosArg.sg_flags &= ~ECHO;
  ioctl(0,   TIOCSETP, &termiosArg);

  ioctl(1,   TIOCGETP, &termiosArg);
  termiosArg1 = termiosArg;
  termiosArg.sg_flags |= RAW;
  termiosArg.sg_flags &= ~ECHO;
  ioctl(1,   TIOCSETP, &termiosArg);
  
#ifdef RTSCTS
  rtscts(fd1);
  rtscts(fd2);
#endif

  for (i=0; i<SCRIMAGE; i++) {
    scr[i] = 0;
    atr[i] = 0;
    sf[i]  = 0;
  }
  clearscr();
  kanji = 0;
  lock = 0;
  aid  = 0;
  curx = 0;
  cury = 0;
  locate(0,0);

  putstr("XSP CONSOLE Version ");
  putstr(version());
  putstr("\n\r");
  putstr("Please resize kterm as 80x26\n\r");
  
  FD_ZERO(&fdset);
  FD_SET(0, &fdset);
  FD_SET(fd1, &fdset);

  message("XSP CONSOLE FULL-DUPLEX CONNECTION ESTABLISHED.");
  locate(0,0);

  while (select(fd1+1, &fdset, NULL, NULL, NULL) != -1) {
    if (FD_ISSET(0, &fdset)) {
      if (kbd_read())
        break;
      FD_SET(fd1, &fdset);
    }
    else if (FD_ISSET(fd1, &fdset)) {
      if (com_read())
	break;
      FD_SET(0, &fdset);
    }
  }

  message("XSP CONSOLE TERMINATED.");

  ioctl(0, TIOCSETP, &termiosArg0);
  ioctl(1, TIOCSETP, &termiosArg1);
  exit(1);
}

kbd_read()
{
  int i, j;

  if (read(0, cp = cbuf, 1) == -1)
    return(1);
  
  if (*cp == 'D'-'@') /* ^D...quit */
    return(1);
  
  if (lock) {
    message("XXXX LOCKED XXXX");
    return(0);
  }
  
  if (messon)
    clearmes();

  switch (esc) {
  case 0: /* normal */
    
    switch (*cp) {
    case '\033': /* ESC */
      esc = 1;
      break;
    case 'L'-'@': /* ^L...redraw */
      bflush();
      blocate(0,0);
      bputstr("\033[0;0m");
      atr0 = 0x20;
      for (i=0; i<SCRIMAGE; i++) {
	if ((atr0&0x20) && !(atr[i]&0x20)) {
	  bputstr("\033[0;37m");
	  atr0 = atr[i];
	}
	else if (!(atr0&0x20) && (atr[i]&0x20)) {
	  bputstr("\033[0;0m");
	  atr0 = atr[i];
	}
	bputcha(scr[i]);
      }
      bputstr("\033[0;0m");
      blocate(curx, cury);
      bflush();
      break;
    case 'I'-'@': /* ^I...TAB */
      i=curx+cury*(SCRMAXX+1);
      j=(i+1<SCRIMAGE)?i+1:0;
      if (!(atr[i]&0x20))
	for (; i!=j && !(atr[j]&0x20); j=(j+1<SCRIMAGE)?j+1:0);
      if (i != j) {
	for (; i!=j && (atr[j]&0x20); j=(j+1<SCRIMAGE)?j+1:0);
	if (i != j) {
	  curx = j % (SCRMAXX+1);
	  cury = j / (SCRMAXX+1);
	  locate(curx, cury);
	}
      }
      break;
    case 'H'-'@': /* BACK SPACE */
      if (--curx < 0) {
	curx = SCRMAXX;
	if (--cury < 0)
	  cury = SCRMAXY;
      }
      if (atr[curx+cury*(SCRMAXX+1)]&0x20) {
	message("XXXX PROTECTED FIELD XXXX");
	if (++curx > SCRMAXX) {
	  curx = 0;
	  if (++cury > SCRMAXY)
	    cury = 0;
	}
      }
      else {
	for (i=curx+cury*(SCRMAXX+1); i>=0 && !(atr[i]&0x20); i--)
	  atr[i] |= 1;
	for (i=curx+cury*(SCRMAXX+1); i<SCRIMAGE && !(atr[i]&0x20); i++)
	  atr[i] |= 1;
	locate(curx, cury);
	scr[curx+cury*(SCRMAXX+1)] = ' ';
	putstr("\033[0;37m");
	putcha(' ');
	putstr("\033[0;0m");
      }
      break;
    case 'K'-'@': /* ^K...eraseeol */
      locate(curx, cury);
      putstr("\033[0;37m");
      for (i=curx+cury*(SCRMAXX+1); i>=0 && !(atr[i]&0x20); i--)
	atr[i] |= 1;
      for (i=curx+cury*(SCRMAXX+1); i<SCRIMAGE && !(atr[i]&0x20); i++) {
	scr[i] = ' ';
	atr[i] |= 1;
	putcha(' ');
      }
      putstr("\033[0;0m");
      locate(curx, cury);
      break;
    case 'M'-'@': /* ^M...return */
      aid = 0x7d;
      goto attention;
    default: /* normal character */
      if (atr[curx+cury*(SCRMAXX+1)]&0x20)
	message("XXXX PROTECTED FIELD XXXX")
      else if (!ebcdic[*cp])
	message("XXXX NON EBCDIC KEY XXXX")
      else {
	for (i=curx+cury*(SCRMAXX+1); i>=0 && !(atr[i]&0x20); i--)
	  atr[i] |= 1;
	for (i=curx+cury*(SCRMAXX+1); i<SCRIMAGE && !(atr[i]&0x20); i++)
	  atr[i] |= 1;
	scr[curx+cury*(SCRMAXX+1)] = *cp;
	putstr("\033[0;37m");
	putcha(*cp);
	putstr("\033[0;0m");
	if (++curx > SCRMAXX) {
	  curx = 0;
	  if (++cury > SCRMAXY)
	    cury = 0;
	}
      }
      break;
    }
    break;
    
  case 2: /* ESC [ */
    
    esc = 0;
    switch (*cp) {
    case 'A': /* up */
      if (--cury < 0)
	cury = SCRMAXY;
      break;
    case 'B': /* down */
      if (++cury > SCRMAXY)
	cury = 0;
      break;
    case 'C': /* right */
      if (++curx > SCRMAXX) {
	curx = 0;
	if (++cury > SCRMAXY)
	  cury = 0;
      }
      break;
    case 'D': /* left */
      if (--curx < 0) {
	curx = SCRMAXX;
	if (--cury < 0)
	  cury = SCRMAXY;
      }
      break;
    default: /* undefined */
      break;
    }
    break;
    
  case 1: /* ESC */
    
    switch (*cp) {
    case '[':  /* ESC [ */
      esc = 2;
      break;
    case '\t': /* CURSEL */
      aid = 0x7e;
      goto attention;
    case 'q':  /* PA1 */
      aid = 0x6c;
      goto attention;
    case 'w':  /* PA2 */
      aid = 0x6e;
      goto attention;
    case 'e':  /* PA3 */
      aid = 0x6b;
      goto attention;
    case '1':  /* PF1 */
      aid = 0xf1;
      goto attention;
    case '2':  /* PF2 */
      aid = 0xf2;
      goto attention;
    case '3':  /* PF3 */
      aid = 0xf3;
      goto attention;
    case '4':  /* PF4 */
      aid = 0xf4;
      goto attention;
    case '5':  /* PF5 */
      aid = 0xf5;
      goto attention;
    case '6':  /* PF6 */
      aid = 0xf6;
      goto attention;
    case '7':  /* PF7 */
      aid = 0xf7;
      goto attention;
    case '8':  /* PF8 */
      aid = 0xf8;
      goto attention;
    case '9':  /* PF9 */
      aid = 0xf9;
      goto attention;
    case '0':  /* PF10 */
      aid = 0x7a;
      goto attention;
    case '-':  /* PF11 */
      aid = 0x7b;
      goto attention;
    case '^':  /* PF12 */
      aid = 0x7c;
      goto attention;
    case '!':  /* PF13 */
      aid = 0xc1;
      goto attention;
    case '\"': /*"PF14 */
      aid = 0xc2;
      goto attention;
    case '#':  /* PF15 */
      aid = 0xc3;
      goto attention;
    case '$':  /* PF16 */
      aid = 0xc4;
      goto attention;
    case '%':  /* PF17 */
      aid = 0xc5;
      goto attention;
    case '&':  /* PF18 */
      aid = 0xc6;
      goto attention;
    case '\'': /* PF19 */
      aid = 0xc7;
      goto attention;
    case '(':  /* PF20 */
      aid = 0xc8;
      goto attention;
    case ')':  /* PF21 */
      aid = 0xc9;
      goto attention;
    case '@':  /* PF22 */
      aid = 0x4a;
      goto attention;
    case '=':  /* PF23 */
      aid = 0x4b;
      goto attention;
    case '~':  /* PF24 */
      aid = 0x4c;
attention:
      esc = 0;
      lock = 1;
      uwrite(fd2, "\241\301\000\000\000\001", 6); /* "~A" in EBCDIC */
      uwrite(fd2, &aid, 1);
      break;
    default: /* undefined */
      esc = 0;
      break;
    }
    break;
  }
  locate(curx, cury);
  return(0);
}

com_read()
{
  int i, j, len;
  int cmd;
  unsigned char adr0, adr1;
  unsigned char c;
  unsigned char chain;
  
  if (uread(fd1, ebuf, 1) <= 0)
    return(1);

  if (uread(fd1, &chain, 1) <= 0)
    return(1);

  cmd = ebuf[0];

  uread(fd1, ebuf, 4);
  len = ebuf[0]<<24 | ebuf[1]<<16 | ebuf[2]<<8 | ebuf[3];

  ebuf[0] = 0x40; /* assume WCC=0x40 */
  if (uread(fd1, ebuf, len) != len) {
    uwrite(fd2, "\241\331\000\000\000\001\343", 7); /* TIMEOUT */
    return(0);
  }

  switch (cmd) {
  case 0x01: /* WRITE */
    uwrite(fd2, "\241\331\000\000\000\001\326", 7); /* OK */
    wcc = ebuf[0];
    
    if (wcc & 1) {
      for (i=0; i<SCRIMAGE; i++)
	atr[i] &= ~1;
    }
    lock = 0;
    aid  = 0;
    
write_common:

    bflush();
    for (i=1; i<len; i++) {
      switch (ebuf[i]) {
      case 0x11: /* SBA */
	bufx =  ((ebuf[i+1]<<6&0xfc0)|(ebuf[i+2]&0x3f))             %(SCRMAXX+1);
	bufy = (((ebuf[i+1]<<6&0xfc0)|(ebuf[i+2]&0x3f))/(SCRMAXX+1))%(SCRMAXY+1);
	for (j=bufx+bufy*(SCRMAXX+1); j>=0 && sf[j]==0; j--);
	atr0 = atr[j+1];
	i += 2;
	blocate(bufx, bufy);
	if (atr0&0x20)
	  bputstr("\033[0;0m")
	else
	  bputstr("\033[0;37m")
	break;
	
      case 0x13: /* IC */
	curx = bufx;
	cury = bufy;
	break;
	
      case 0x1D: /* SF */
	kanji = 0;
	bputstr("\033[0;0m");
	atr0 = ebuf[i+1];
	c = ' '; /* '|' */
	bputcha(c);
	scr[bufx+bufy*(SCRMAXX+1)] = ' '; /* '|' */
	atr[bufx+bufy*(SCRMAXX+1)] = 0x20;
	sf[bufx+bufy*(SCRMAXX+1)] = 1;
	if (++bufx > SCRMAXX) {
	  bufx = 0;
	  if (++bufy > SCRMAXY)
	    bufy = 0;
	}
	i++;
	blocate(bufx, bufy);
	if (!(atr0&0x20))
	  bputstr("\033[0;37m");
	break;

      case 0x0F: /* SFE */
	debug("DSC ORDER:%02.2x ignored", ebuf[i]);
	i += 1 + ebuf[i+1]*2; /* SFE ignored */
	break;
	
      case 0x3C: /* RA */
	adr0 =  ((ebuf[i+1]<<6&0xfc0)|(ebuf[i+2]&0x3f))             %(SCRMAXX+1);
	adr1 = (((ebuf[i+1]<<6&0xfc0)|(ebuf[i+2]&0x3f))/(SCRMAXX+1))%(SCRMAXY+1);
	if (kanji) {
	  while (1) {
	    c = ebuf[i+3];
	    bputcha(c);
	    scr[bufx+bufy*(SCRMAXX+1)] = c;
	    atr[bufx+bufy*(SCRMAXX+1)] = atr0;
	    sf[bufx+bufy*(SCRMAXX+1)] = 0;
	    if (++bufx > SCRMAXX) {
	      bufx = 0;
	      if (++bufy > SCRMAXY)
		bufy = 0;
	    }
	    if (bufx == adr0 && bufy == adr1)
	      break;
	    c = ebuf[i+4];
	    bputcha(c);
	    scr[bufx+bufy*(SCRMAXX+1)] = c;
	    atr[bufx+bufy*(SCRMAXX+1)] = atr0;
	    sf[bufx+bufy*(SCRMAXX+1)] = 0;
	    if (++bufx > SCRMAXX) {
	      bufx = 0;
	      if (++bufy > SCRMAXY)
		bufy = 0;
	    }
	    if (bufx == adr0 && bufy == adr1)
	      break;
	  }
	  i += 4;
	}
	else {
	  while (1) {
	    c = ascii[ebuf[i+3]];
	    bputcha(c);
	    scr[bufx+bufy*(SCRMAXX+1)] = c;
	    atr[bufx+bufy*(SCRMAXX+1)] = atr0;
	    sf[bufx+bufy*(SCRMAXX+1)] = 0;
	    if (++bufx > SCRMAXX) {
	      bufx = 0;
	      if (++bufy > SCRMAXY)
		bufy = 0;
	    }
	    if (bufx == adr0 && bufy == adr1)
	      break;
	  }
	  i += 3;
	}
	break;

      case 0x28: /* kanji on */
	kanji = 1;
	break;

      case 0x29: /* kanji off */
	kanji = 0;
	break;

      case 0x1B: /* SFE/F */
      case 0x2C: /* MF */
      case 0x0E: /* SA */
      case 0x05: /* PT */
      case 0x12: /* EUA */
      case 0x3A: /* LINS */
      case 0x39: /* LDEL */
	debug("DSC ORDER:%02.2x not supported", ebuf[i]);
	break;
	
      default: /* character */
	c = kanji ? ebuf[i] : ascii[ebuf[i]];
	bputcha(c);
	scr[bufx+bufy*(SCRMAXX+1)] = c;
	atr[bufx+bufy*(SCRMAXX+1)] = atr0;
	sf[bufx+bufy*(SCRMAXX+1)] = 0;
	if (++bufx > SCRMAXX) {
	  bufx = 0;
	  if (++bufy > SCRMAXY)
	    bufy = 0;
	}
	break;
      }
    }
    bputstr("\033[0;0m");
    blocate(curx, cury);
    bflush();
    clearmes();
    break;
    
  case 0x05: /* ERASE/WRITE */
    uwrite(fd2, "\241\331\000\000\000\001\326", 7); /* OK */
    wcc = ebuf[0];

    if (i > 0) {
      for (i=0; i<SCRIMAGE; i++) {
	scr[i] = 0;
	atr[i] = 0;
	sf[i] = 0;
      }
      clearscr();
    }
    
    if (wcc & 1) {
      for (i=0; i<SCRIMAGE; i++)
	atr[i] &= ~1;
    }
    lock = 0;
    aid  = 0;
    curx = 0;
    cury = 0;
    locate(0,0);
    
    goto write_common;
    break;
    
  case 0x06: /* READM */
    uwrite(fd2, "\241\331", 2); /* "~R" in EBCDIC */

    switch (aid) {
    case 0x6c: /* PA1 */
    case 0x6e: /* PA2 */
    case 0x6b: /* PA3 */
      uwrite(fd2, "\000\000\000\001", 4);
      uwrite(fd2, &aid, 1);
      break;
    default: /* other */
      for (i=chain?bufx+bufy*(SCRMAXX+1):0,j=3; i<SCRIMAGE; i++) {
	if ((atr[i]&1) && scr[i]) {
	  j += 3;
	  for (; i<SCRIMAGE && (atr[i]&1) && scr[i]; i++,j++);
	}
      }
      ebuf[0] = (j>>24) & 0xff;
      ebuf[1] = (j>>16) & 0xff;
      ebuf[2] = (j>> 8) & 0xff;
      ebuf[3] =  j      & 0xff;
      uwrite(fd2, ebuf, 4);
      uwrite(fd2, &aid, 1);
      i = curx+cury*(SCRMAXX+1);
      adr0 = i>>6 & 0x3f;
      adr1 = i    & 0x3f;
      if      (adr0 ==  0) adr0 |= 0x40;
      else if (adr0 <=  9) adr0 |= 0xc0;
      else if (adr0 <= 16) adr0 |= 0x40;
      else if (adr0 <= 25) adr0 |= 0xc0;
      else if (adr0 <= 33) adr0 |= 0x40;
      else if (adr0 <= 41) adr0 |= 0xc0;
      else if (adr0 <= 47) adr0 |= 0x40;
      else if (adr0 <= 58) adr0 |= 0xc0;
      else                 adr0 |= 0x40;
      if      (adr1 ==  0) adr1 |= 0x40;
      else if (adr1 <=  9) adr1 |= 0xc0;
      else if (adr1 <= 16) adr1 |= 0x40;
      else if (adr1 <= 25) adr1 |= 0xc0;
      else if (adr1 <= 33) adr1 |= 0x40;
      else if (adr1 <= 41) adr1 |= 0xc0;
      else if (adr1 <= 47) adr1 |= 0x40;
      else if (adr1 <= 58) adr1 |= 0xc0;
      else                 adr1 |= 0x40;
      uwrite(fd2, &adr0, 1); /* upper half */
      uwrite(fd2, &adr1, 1); /* lower half */
      for (i=chain?bufx+bufy*(SCRMAXX+1):0; i<SCRIMAGE; i++) {
	if ((atr[i]&1) && scr[i]) {
	  uwrite(fd2, "\021", 1); /* SBA */
	  adr0 = i>>6 & 0x3f;
	  adr1 = i    & 0x3f;
	  if      (adr0 ==  0) adr0 |= 0x40;
	  else if (adr0 <=  9) adr0 |= 0xc0;
	  else if (adr0 <= 16) adr0 |= 0x40;
	  else if (adr0 <= 25) adr0 |= 0xc0;
	  else if (adr0 <= 33) adr0 |= 0x40;
	  else if (adr0 <= 41) adr0 |= 0xc0;
	  else if (adr0 <= 47) adr0 |= 0x40;
	  else if (adr0 <= 58) adr0 |= 0xc0;
	  else                 adr0 |= 0x40;
	  if      (adr1 ==  0) adr1 |= 0x40;
	  else if (adr1 <=  9) adr1 |= 0xc0;
	  else if (adr1 <= 16) adr1 |= 0x40;
	  else if (adr1 <= 25) adr1 |= 0xc0;
	  else if (adr1 <= 33) adr1 |= 0x40;
	  else if (adr1 <= 41) adr1 |= 0xc0;
	  else if (adr1 <= 47) adr1 |= 0x40;
	  else if (adr1 <= 58) adr1 |= 0xc0;
	  else                 adr1 |= 0x40;
	  uwrite(fd2, &adr0, 1); /* upper half */
	  uwrite(fd2, &adr1, 1); /* lower half */
	  for (j=0; i<SCRIMAGE && (atr[i]&1) && scr[i]; i++,j++)
	    ebuf[j] = ebcdic[scr[i]];
	  uwrite(fd2, ebuf, j);
	}
      }
      break;
    }
    break;
    
  case 0x02: /* READB */
    uwrite(fd2, "\241\331", 2); /* "~R" in EBCDIC */
    for (i=chain?bufx+bufy*(SCRMAXX+1):0,j=3; i<SCRIMAGE; i++,j++) {
      if (sf[i])
	j += 2;
    }
    ebuf[0] = (j>>24) & 0xff;
    ebuf[1] = (j>>16) & 0xff;
    ebuf[2] = (j>> 8) & 0xff;
    ebuf[3] =  j      & 0xff;
    uwrite(fd2, ebuf, 4);
    uwrite(fd2, &aid, 1);
    i = curx+cury*(SCRMAXX+1);
    adr0 = i>>6 & 0x3f;
    adr1 = i    & 0x3f;
    if      (adr0 ==  0) adr0 |= 0x40;
    else if (adr0 <=  9) adr0 |= 0xc0;
    else if (adr0 <= 16) adr0 |= 0x40;
    else if (adr0 <= 25) adr0 |= 0xc0;
    else if (adr0 <= 33) adr0 |= 0x40;
    else if (adr0 <= 41) adr0 |= 0xc0;
    else if (adr0 <= 47) adr0 |= 0x40;
    else if (adr0 <= 58) adr0 |= 0xc0;
    else                 adr0 |= 0x40;
    if      (adr1 ==  0) adr1 |= 0x40;
    else if (adr1 <=  9) adr1 |= 0xc0;
    else if (adr1 <= 16) adr1 |= 0x40;
    else if (adr1 <= 25) adr1 |= 0xc0;
    else if (adr1 <= 33) adr1 |= 0x40;
    else if (adr1 <= 41) adr1 |= 0xc0;
    else if (adr1 <= 47) adr1 |= 0x40;
    else if (adr1 <= 58) adr1 |= 0xc0;
    else                 adr1 |= 0x40;
    uwrite(fd2, &adr0, 1); /* upper half */
    uwrite(fd2, &adr1, 1); /* lower half */
    for (i=chain?bufx+bufy*(SCRMAXX+1):0; i<SCRIMAGE;) {
      if (sf[i]) {
	ebuf[0] = 0x1d; /* SF */
	ebuf[1] = atr[i];
	ebuf[2] = ebcdic[scr[i]];
	uwrite(fd2, ebuf, 3);
	i++;
	for (j=0; i<SCRIMAGE && sf[i]==0; i++,j++)
	  ebuf[j] = ebcdic[scr[i]];
	uwrite(fd2, ebuf, j);
      }
      else {
	for (j=0; i<SCRIMAGE && sf[i]==0; i++,j++)
	  ebuf[j] = ebcdic[scr[i]];
	uwrite(fd2, ebuf, j);
      }
    }
    break;
    
  default:
    debug("DSC COMMAND:%02.2x not supported", cmd);
    uwrite(fd2, "\241\331\000\000\000\001\325", 7); /* NG */
    break;
  }

  return(0);
}

int
uread(fd, p, len)
     int fd;
     char *p;
     int len;
{
  int n, val;

  clrtime();

  for (n=len; n>0; n-=val) {
  again:
    switch (val = read(fd, p, n)) {
    case 0: /* EOF */
      debug("READ:EOF:left=%08.8x", n);
      return(0);
    case -1: /* EAGAIN */
      /* debug("READ:EAGAIN:left=%08.8x", n); */
      if (gettime() > 5) { /* 5sec */
	debug("READ:TIMEOUT:left=%08.8x", n);
	return(n);
      }
      else
	goto again;
    default:
      p += val;
      break;
    }
  }
#ifdef DEBUG
  uwrite(fd3, p-len, len);
#endif
  return(len);
}

int
uwrite(fd, p, len)
     int fd;
     char *p;
     int len;
{
  int n, val;
  
  for (n=len; n>0; n-=val) {
    while ((val = write(fd, p, n)) <= 0)
      debug("WRITE:EAGAIN:len=%08.8x", len);
    p += val;
  }
  return(len);
}

time_t tloc;
time_t tmsave;

clrtime()
{
  time(&tloc);
  tmsave = tloc;
}

gettime()
{
  time(&tloc);
  return(tloc-tmsave);
}

char *
version()
{
  char *i;

  for (i=xspcon_RcsId; *i && *i!=' '; i++);
  for (              ; *i && *i==' '; i++);
  for (              ; *i && *i!=' '; i++);
  for (              ; *i && *i==' '; i++);
  return(i);
}

