
/* dim1.s 1995/7/18 */

/* M-on-RISC Dynamically Translating Simulator */
/*	 Copyright (C) 1995 by FUJITSU LIMITED */
/*		   Primary writer: Y.Nakashima */
/*	    nakashim@pine.mfd.cs.fujitsu.co.jp */

	.file	"dim1.s"
	.section ".data"
	.align	8
	.global dim_RcsId
dim_RcsId:
	.asciz	"$Id: dim1.s,v 1.1 1998/07/01 01:44:58 nakashim Exp nakashim $"

!
! <SPARC stack frame>
!
! %fp-->  +-----------------------------------------+ ---
! %fp-off.|automatic var. not used  (%fp not used)  |  ^
!	  |-----------------------------------------|  |
! %sp+100 |%i7 is saved here			    |  size = 12
! %sp+96  |  (reserved)				    |  |
! %sp+92  |%i0 is saved here (struct *guest)	    |  v
!	  |-----------------------------------------| ---
! %sp+88  |1 word for calee			    |  ^
! %sp+84  |1 word for calee			    |  |
! %sp+80  |1 word for calee			    |  |
! %sp+76  |1 word for calee			    |  |
! %sp+72  |1 word for calee			    |  |
! %sp+68  |1 word for calee			    |  |
!	  |-----------------------------------------|  |
! %sp+off.|1 word hidden param			    |  size = 92
!	  |-----------------------------------------|  |
! %sp+off.|16 words for in,local (used by OS)	    |  v
! %sp-->  +-----------------------------------------+ ---
!
! <%g1-%g7 field assignment>
!					       2  2
!	  +-----------------------------------+--+--+
!    %g1  |	  M instruction counter	      |ILCCC|
!	  +-----------------------------------+--+--+
!		  M   : Number of Instructions Executed
!		  ILC : Instruction Length Code
!		  CC  : Condition Code
!	  +-----------------------------------------+
!    %g2  |	  Instruction address register 	    |
!	  +-----------------------------------------+
!    %g3  |	      Address mask (24/29)	    |
!	  +-----------+-----------------------------+
!    %g4  |   Offset  |00000000000000000000000000000| for M-space
!	  +-----------+-----------------------------+
!    %g5  |   Offset  |00000000000000000000000000000| for Table
!	  +-----------+-----------------------------+
!    %g6  |		M register #14		    |
!	  +--+---+-+Intr.code+-+-------+-+-+-+-+----+
!    %g7  |FC|re |S| loc-143 |r|0001000|I|C|I|A|PROG|
!	  |  |sv | |         |s|       |F|S|M|M|MASK|
!	  +--+---+-+---------+-+-------+-+-+-+-+----+
!	   -- --- - --------- - ------- - - - - ----
!	   r   0  r	r     0  const. r r r r	 r
!	   o	  w	o		o o w w	 w
!		  Interruption Flags
!			 bit 0- 1 : Function Code
!			   0x0: Program Exception or Step Execution(S=1)
!				param = bit 7-15
!			   0x1: reserved
!			   0x2: Special Instruction
!				param = guest->minsn
!			   0x3: Extended Function (emm call)
!				[BC 0,FED(0,0) ... 0x47000fed]
!				/* example */
!				switch (guest->m[0]) {
!				case 0xff0: NOP
!				case 0xff1: PRINTF
!				case 0xff2: SCANF
!				case 0xff3: TIME
!				case 0xffe: STACK OVERFLOW
!				case 0xfff: PROGRAM NORMAL END
!				default:    UNDEFINED (error)
!				}
!			 bit 2- 6 : reserved (0)
!			 bit 7	  : S (step execution)
!			 bit 8-15 : Interruption code (Program Exception)
!			 bit16    : reserved (0)
!			 bit17-23 : const. for conditional branch
!			 bit24    : IF (0:OP-Fetch 1:I-Fetch in progress)
!			 bit25    : CS (0:normal   1:CS/CDS in progress)
!			 bit26	  : IM (interpretive execution mode)
!			 bit27	  : AM (0:24bit-mode 1:31bit-mode)
!			 bit28	  : fixed-point overflow
!			 bit29	  : decimal overflow
!			 bit30	  : exponent underflow
!			 bit31	  : significance
!
!		  (sparc:	    always,   ba/bn	  )
!		  (sparc:icc.n:	    negative, bpos/bneg	  )
!		  (sparc:icc.z:	    zero,     bn[ze]/b[ze])
!		  (sparc:icc.v:	    overflow, bvc/bvs	  )
!		  (sparc:icc.c:	    carry,    bcc/bcs	  )
!
! <host_ibuf handshake>
!
!    Getting the address of current free ibuf.
!      Dim "call emm_ibufbpa" to get address of host_ibufpp[addr]+0x8.
!	   1st. param: struct guest *guest;
!	   2nd. param: unsigned M-addr;
!	   3rd. param: unsigned type (0:instruction, 1:	operand for CS/CDS)
!      If (retval == 1) then dim() returns with(1),
!                            emm must exec "MPOP_HSTPROT"
!      Dim loads ibufbpa and fetch first 4bytes(ibuf top address).
!      Dim loads ibufbpa and fetch next	 4bytes(ibuf lock flag).
!
!    Getting a new ibuf.
!      Dim "call emm_ibuf_alloc" to get a new ibuf.
!	   1st. param: struct guest *guest;
!	   2nd. param: unsigned M-addr;
!
! <exception handling>
!
!    M Instruction Fetch:
!      if M-PC is odd-address then
!	 Dim generate misalign-exception in host_imap[].
!	 Emm must simulate ILC=0,specification-exception.
!
!      if entering new instruction space then
!	 Dim generate page-fault in host_imap[].
!	 Emm must allocate new page against host_imap[].
!
!    M Instruction Execution:
!      if M-instruction jmp to middle of M-instruction then
!	 Dim enters logical 0x1,0x2 and generates misaligned I-fetch.
!	 Emm must generate emulation error.
!
!    M Operand Fetch:
!      if odd-address then
!	 Dim generate misalign-exception in guest_mem[].
!	 Emm must simulate load with load-byte.
!
!    M Operand Store:
!      if odd-address then
!	 Dim generate misalign-exception in guest_mem[].
!	 Emm must simulate store with store-byte.
!      if self-modify-code (i.e. host_imap[addr] != 0) then
!	 Emm must overwrite host_imap[]->ibuf with
!	   "sethi %hi(trans_main),%o0	 "
!	   "or	  %o0,%lo(trans_main),%o0"
!	   "jmpl  %o0,%g0		 "
!	   "nop				 "
!        Emm must overwrite host_imap[.+0,[.+1,][.+2]] with zero.
!
! <%o0-%o7,%l0-%l7,%i0-%i7 assignment>
!
!	  +----------------------------------------+
!    %o0  |		    Work		   |
!	  +----------------------------------------+
!    %o1  |		    Work		   |
!	  +----------------------------------------+
!    %o2  |		    Work		   |
!	  +----------------------------------------+
!    %o3  |		    Work		   |
!	  +----------------------------------------+
!    %o4  |		    Work		   |
!	  +----------------------------------------+
!    %o5  |		    Work		   |
!	  +----------------------------------------+
!    %sp  |		Stack pointer		   |
!	  +----------------------------------------+
!    %o7  |		    Work		   |
!	  +----------------------------------------+
!    %l0  |		M register #0		   |
!	  +----------------------------------------+
!    %l1  |		M register #1		   |
!	  +----------------------------------------+
!    %l2  |		M register #2		   |
!	  +----------------------------------------+
!    %l3  |		M register #3		   |
!	  +----------------------------------------+
!    %l4  |		M register #4		   |
!	  +----------------------------------------+
!    %l5  |		M register #5		   |
!	  +----------------------------------------+
!    %l6  |		M register #6		   |
!	  +----------------------------------------+
!    %l7  |		M register #7		   |
!	  +----------------------------------------+
!    %i0  |		M register #8		   |
!	  +----------------------------------------+
!    %i1  |		M register #9		   |
!	  +----------------------------------------+
!    %i2  |		M register #10		   |
!	  +----------------------------------------+
!    %i3  |		M register #11		   |
!	  +----------------------------------------+
!    %i4  |		M register #12		   |
!	  +----------------------------------------+
!    %i5  |		M register #13		   |
!	  +----------------------------------------+
!    %fp  |		Frame pointer		   |
!	  +----------------------------------------+
!    %i7  |		M register #15		   |
!	  +----------------------------------------+
!
! <guest structure>
!
!	  guest.g2
!	  +----------------------------------------+
!	  |	  Instruction address register	   |
!	  +-----------------------+--+-------+--+--+
!	   0			   19	      30 31
!			<------------------+--->
!			<-------+--->	   |
!				|	   |
!  +----------------------------+	   |
!  | +-------------------------------------+
!  | |
!  | |	  guest.host_imap
!  | |	  +----------------------------------------+
!  | |	  +----------------------------------------+
!  | +--->|	  Sparc instruction start address  |-----+
!  |	  +----------------------------------------+	 |
!  |	  +----------------------------------------+	 |
!  |	  * address: 0: not translated yet		 |
!  |		     1: +2 from translated instruction	 |
!  |		     2: +4 from translated instruction	 |
!  |		     3: reserved			 |
!  |		  else: start address			 |
!  |							 |
!  |	  guest.host_ibufpp				 |
!  |	  +----------------------------------------+	 |
!  |	  +----------------------------------------+	 |
!  +----->|	  Ibuf start page address	   |---+ |
!	  + - - - - - - - - - - - - - - - - - - - -+   | |
!	  |		 (reserved)		   |   | |
!emm_	  + - - - - - - - - - - - - - - - - - - - -+   | |
!ibufbpa->|	  Ibuf bottom page address	   |---|-|-+
!	  + - - - - + - - - - + - - - - + - - - - -+   | | |
!	  |Lock trns|Lock-ID  |Lock CS  |          |   | | |
!	  |00:unlock|10-7F:dim|00:unlock|(reserved)|   | | |
!	  |FF:locked|80-ff:emm|FF:locked|          |   | | |
!	  +---------+---------+---------+----------+   | | |
!	  +----------------------------------------+   | | |
!		     0x10:trans			       | | |
!  +---------------------------------------------------+ | |
!  |							 | |
!  |	  emm_ibuf_alloc(type, size)			 | |
!  |	  +----------------------------------------+	 | |   +--------+
!  +----->|	  Next ibuf start address or 0	   |-----|-+-->|  NULL	|
!	  +----------------------------------------+	 |     +--------+
!	  |	  Free bytes (0 .. 32KB-8-16)	   |	 |     |	|
!	  +----------------------------------------+	 |     +--------+
!	  |	  sethi %hi(epilog),%o0	   <+	   |	 |     |	|
!	  |	  or	%o0,%lo(epilog),%o0 | 16   |	 |     |	|
!	  |	  jmpl	%o0,%g0		    | bytes|	 |     |	|
!	  |	  nop			   <+	   |	 |     |	|
!	  +----------------------------------------+	 |     +--------+
!	  |					   |	 |     |	|
!	  |	  Sparc instruction area	   |<----+     |	|
!	  |					   |	       |	|
!	  +----------------------------------------+	       +--------+
!	X * Next ibuf start address = emm_ibuf_alloc(..);
!	X * Always next ibuf must be allocated.
!	X * That is current "next address" should be valid,
!	X   because "ba next_address+8" may be stored after
!	X   previous template to skip ibuf fragments.
!
! <dynamic translation flow>
!
!   [EMULATE STORE INSTRUCTION]
!     if (store is self modification) {
!   	if (host_imap[addr] != NULL) {
!   	  host_imap[addr]->ibuf = "sethi/or trans_main;jmpl [reg],%g0"
!   	  host_imap[addr  ]     = null;
!   	  host_imap[addr+1]     = null; /* if necessary */
!   	  host_imap[addr+2]     = null; /* if necessary */
!	}
!     }
!     trap by protection exception (dim does nothing)
!
!   [EX ENTRY]
!   trans_ex:
!  *c translate on interp_ibuf;
!     terminate interp_ibuf with "sethi/or trans_main;jmpl [reg],%g0";
!     override ILC=2,IAR+=2
!     goto interp_ibuf;
!
!   [START TRANSLATION ENTRY]
!   trans_main:
!     VIAR = IAR;
!     if (host_imap[VIAR] != NULL)
!	goto start_execution;
!
!   [TRANSLATION MAIN LOOP]
! +>trans_loop:
! |   if (ibufbp == NULL ||
! |*c	  ibufbp has no enough free bytes)
! |	emm_ibuf_alloc(VIAR, 32K); [free = 32KB-8]
! |*c translate;
! |   terminate ibuf with "sethi/or trans_main;jmpl [reg],%g0";#for intr.
! |	[But don't decrement ibuf[PAGE#].free.]
! |	[Next template override "sethi/or trans_main;jmpl [reg],%g0".]
! |   polling interruption;
! |   if (M[VIAR] != branch && host_imap[next VIAR] == NULL) {
! |	VIAR = next VIAR;
! +-	goto trans_loop;
!     }
!     else {
!	decrement ibuf[PAGE#].free
!	goto start_execution;
!     }
!
!   start_execution:
!     load host_imap[IAR];
!     jmpl [reg],%g0;
!

!
! Dynamically Translating Simulator Subsystem Entry Point
!
! dim() returns 0 if normal end.
!       returns 1 if MPOP_HSTPROT. ( emm_getibufbpa() returns 1 )
!
	.section ".text"
	.align	4
	.global dim
	.global dim_info
	.global dim_prog
	.global trans_main
dim:
!
! prolog
!
	ba	dim_prog	! skip dim_info
	nop			!
dim_info:
	.word	0x00000001	! %g reg-format version
	.word	optable		! ->optable
	.word	optb2xx		! ->optb2xx
	.word	pa_sinsn	! ->pa_sinsn
	.word	pa_pinsn	! ->pa_pinsn
dim_prog:
	save	%sp,-104,%sp	! 12 + 92
	st	%i0,[%sp+92]	! struct *guest (dim frame structure)
	st	%i7,[%sp+100]	! return addr.
	mov	%i0,%o7		!
				! *: 'C'caller should save/restore
			! %g0	! (wired-0)
	ld	[%o7+132],%g1	! *(temporary)	-> ILC,CC
	ld	[%o7+136],%g2	! *(global var.)-> IAR
	ld	[%o7+140],%g3	! *(global var.)-> addres mask(24/31)
	ld	[%o7+144],%g4	! *(global var.)-> key (operand)
	ld	[%o7+148],%g5	! *(reserved)	-> key (instruction)
	ld	[%o7+ 56],%g6	! *(reserved)	-> Mreg14
			! %g7	! *(reserved)	-> intr.flags.(loaded by main)
			! %o0	! (param0)	-> work -> param0/retval
			! %o1	! (param1)	-> work -> param1
			! %o2	! (param2)	-> work -> param2
			! %o3	! (param3)	-> work -> param3
			! %o4	! (param4)	-> work -> param4
			! %o5	! (param5)	-> work -> param5
			! %sp	! stack pointer -> stack pointer
			! %o7	! (temporary)	-> work -> return addr.
	ld	[%o7+  0],%l0	! (local0)	-> Mreg0
	ld	[%o7+  4],%l1	! (local1)	-> Mreg1
	ld	[%o7+  8],%l2	! (local2)	-> Mreg2
	ld	[%o7+ 12],%l3	! (local3)	-> Mreg3
	ld	[%o7+ 16],%l4	! (local4)	-> Mreg4
	ld	[%o7+ 20],%l5	! (local5)	-> Mreg5
	ld	[%o7+ 24],%l6	! (local6)	-> Mreg6
	ld	[%o7+ 28],%l7	! (local7)	-> Mreg7
	ld	[%o7+ 32],%i0	! param0/retval -> Mreg8
	ld	[%o7+ 36],%i1	! (param1)	-> Mreg9
	ld	[%o7+ 40],%i2	! (param2)	-> Mreg10
	ld	[%o7+ 44],%i3	! (param3)	-> Mreg11
	ld	[%o7+ 48],%i4	! (param4)	-> Mreg12
	ld	[%o7+ 52],%i5	! (param5)	-> Mreg13
			! %fp	! frame pointer -> frame pointer
	ld	[%o7+ 60],%i7	! return addr.	-> Mreg15
	ba	trans_main	!
	nop			!
!================================

!
! Dynamically Translating Simulator Subsystem EX Instruction Entry
!   %o1: param: or-value
!   %o2: param: target address
!
trans_ex:
	andcc	%o2,1,%g0	! if odd address then
	bz	trans_eavalid	!   specification exception
	sethi	%hi(0x00060000),%o0
	or	%g7,%o0,%g7	!
	ba,a	epilog0		!

trans_eavalid:
	ld	[%sp+92],%o7	! struct *guest
	st	%o1,[%o7+200]	! save or-value
	and	%o2,%g3,%o2	! mask address
	add	%g4,%o2,%o2	!
	ldub	[%o2],%o1	! load guest_mem[TARGET]
	subcc	%o1,0x44,%g0	! if OPCD==EX then
	bne	trans_eovalid	!   execute exception
	sethi	%hi(0x00030000),%o0
	or	%g7,%o0,%g7	!
	ba,a	epilog0		!

trans_eovalid:
	subcc	%o1,0xb2,%g0	! if 2byte opcd then
	be	trans_eb2xx	!
	sethi	%hi(optable),%o4!
	or	%o4,%lo(optable),%o4
	sll	%o1,5,%o1	!
	ba	trans_edecode	!
	add	%o4,%o1,%o4	! &optable[opcd]
trans_eb2xx:
	sethi	%hi(optb2xx),%o4!
	or	%o4,%lo(optb2xx),%o4
	ld	[%o7+200],%o3	! load or-value
	ldub	[%o2+1],%o1	! load guest_mem[TARGET+1]
	or	%o1,%o3,%o1	!
	sll	%o1,5,%o1	!
	add	%o4,%o1,%o4	! &optb2xx[opcd]
trans_edecode:	
	ld	[%o4+12],%o3	! load optable[opcd].cfunc
	st	%o3,[%o7+212]	! save optable[opcd].cfunc
	ld	[%o4+16],%o3	! load optable[opcd].tfunc
	st	%o3,[%o7+216]	! save optable[opcd].tfunc
	ld	[%o4+20],%o3	! load optable[opcd].term
	st	%o3,[%o7+220]	! save optable[opcd].term
	ld	[%o4+8],%o3	! load optable[opcd].mlen
	st	%o3,[%o7+208]	! save optable[opcd].mlen
	subcc	%o3,2,%g0	!
	bne	trans_eskip2	!
	nop			!
	lduh	[%o2],%o1	! 2 byte instruction
	ba	trans_etfunc	!
	sll	%o1,16,%o1	! store in upper half of %o1
trans_eskip2:
	subcc	%o3,4,%g0	!
	bne	trans_eskip4	!
	nop			!
	lduh	[%o2],%o1	! 4 byte instruction
	lduh	[%o2+2],%o3	!
	sll	%o1,16,%o1	!
	ba	trans_etfunc	!
	or	%o1,%o3,%o1	! store in %o1
trans_eskip4:
	lduh	[%o2],%o1	! 6 byte instruction
	lduh	[%o2+2],%o3	!
	lduh	[%o2+4],%o2	!
	sll	%o1,16,%o1	!
	or	%o1,%o3,%o1	! store in %o1
	sll	%o2,16,%o2	! store in upper half of %o2

trans_etfunc:
	ld	[%o7+200],%o0	! load or-value
	sll	%o0,16,%o0	! extract or-value as bit8-15
	or	%o1,%o0,%o1	!
	st	%o1,[%o7+200]	! store minsn (upper)
	st	%o2,[%o7+204]	! store minsn (lower)
	ld	[%o7+192],%o0	! get interp_ibuf start address
	add	%o0,24,%o0	!
	sethi	%hi(intrinsn),%o1
	or	%o1,%lo(intrinsn),%o1
	ld	[%o1],%o2	! fill ibuf with sethi;or;jmpl;nop;
	ld	[%o1+4],%o3	!
	ld	[%o1+8],%o4	!
	ld	[%o1+12],%o5	!
	st	%o2,[%o0-16]	!
	st	%o3,[%o0-12]	!
	st	%o4,[%o0-8]	!
	st	%o5,[%o0-4]	!
	!!flush	%o0-16		! drain store buffer(for ROSS)
	!!flush	%o0-8		! drain store buffer(for ROSS)
	!!flush	%o0-4		! drain store buffer(for ROSS)

	ld	[%o7+200],%o1	! load minsn (upper)
	ld	[%o7+204],%o2	! load minsn (lower)
	ld	[%o7+216],%o3	! load tfunc
	st	%o0,[%o7+232]	! flush address
	jmpl	%o3,%o7		! call tfunc()
	add	%g0,1,%o5	! flag=EXECUTE

	ld	[%sp+92],%o7	! struct *guest
	!!ld	[%o7+232],%o1	! flush address     (for ROSS)
trans_etflush:			!		    (for ROSS)
	!!flush	%o1		! drain store buffer(for ROSS)
	!!subcc	%o1,%o0,%g0	!		    (for ROSS)
	!!blu	trans_etflush	!		    (for ROSS)
	!!add	%o1,8,%o1	!		    (for ROSS)
	ld	[%o7+192],%o1	! get interp_ibuf start address
	ld	[%o0-8],%o3	! load "branch epilog"
	srl	%o3,22,%o3	! clear disp22
	sll	%o3,22,%o3	!
	sub	%o1,%o0,%o4	! get offset
	add	%o4,16,%o4	!
	sll	%o4,8,%o4	!
	srl	%o4,10,%o4	!
	or	%o3,%o4,%o3	!
	st	%o3,[%o0-8]	! store "branch epilog"
	!!flush	%o0-8		! drain store buffer(for ROSS)

	sethi	%hi(terminsn),%o1
	or	%o1,%lo(terminsn),%o1
	ld	[%o1],%o2	! terminate ibuf with sethi;or;jmpl;nop;
	ld	[%o1+4],%o3	!
	ld	[%o1+8],%o4	!
	ld	[%o1+12],%o5	!
	st	%o2,[%o0]	!
	st	%o3,[%o0+4]	!
	st	%o4,[%o0+8]	!
	st	%o5,[%o0+12]	!
	!!flush	%o0		! drain store buffer(for ROSS)
	!!flush	%o0+8		! drain store buffer(for ROSS)
	!!flush	%o0+12		! drain store buffer(for ROSS)

	ld	[%o7+192],%o0	! get interp_ibuf start address
	add	%o0,24,%o0	!
	sethi	%hi(headinsn),%o1
	or	%o1,%lo(headinsn),%o1
	ld	[%o1],%o2	! override ILC=2
	ld	[%o1+4],%o3	!
	ld	[%o1+8],%o4	! override IAR+=0
	st	%o2,[%o0]	!
	st	%o3,[%o0+4]	!
	st	%o4,[%o0+8]	!
	!!flush	%o0		! drain store buffer(for ROSS)
	!!flush	%o0+8		! drain store buffer(for ROSS)

	flush	%g0+0		! drain store buffer(for VIKING)
	jmpl	%o0,%g0		! jmp to interp_ibuf
	nop			!
!================================

!
! Dynamically Translating Simulator Subsystem Internal Main Entry
!
trans_main:
	and	%g2,%g3,%g2	! mask address
	andcc	%g7,0x20,%g0	! if IM=1 then
	bnz	trans_interp	!   skip cfunc,ibuf_alloc,limap
	sll	%g2,1,%o1	! IAR << 1
	ld	[%g5+%o1],%o0	! load host_imap[IAR]
	subcc	%o0,0,%g0	! if host_imap[IAR] == 0 then
	be	trans_prep	!   start translation
	nop			!
	jmpl	%o0,%g0		! jmp to host_ibuf
	nop			!
!================================

trans_prep:
	or	%g7,0x80,%g7	! --- M I-fetch start ---
	ldub	[%g4+%g2],%o1	! load guest_mem[VIAR]
	andn	%g7,0x80,%g7	! --- M I-fetch end ---
	sethi	%hi(optable),%o4!
	or	%o4,%lo(optable),%o4
	sll	%o1,5,%o1	!
	add	%o4,%o1,%o4	! &optable[opcd]
	ld	[%o4+8],%o3	! load optable[opcd].mlen
	sub	%o3,1,%o3	!
	add	%g2,%o3,%o3	! new VIAR-1
	xor	%g2,%o3,%o4	!
	andncc	%o4,0xfff,%g0	!
	bz	trans_ptfoi	! if new insn crosses page boundary
	nop			!   test fetch next page
! TEST fetch of next page (force page-in)
	or	%g7,0x80,%g7	! --- M I-fetch start ---
	ldub	[%g4+%o3],%g0	! load guest_mem[IAR]
	andn	%g7,0x80,%g7	! --- M I-fetch end ---
		
trans_ptfoi:	
	ld	[%sp+92],%o0	! struct *guest
	st	%g1,[%o0+132]	!
	st	%g2,[%o0+136]	! save IAR, %g2 is used as VIAR
	st	%g3,[%o0+140]	!
	st	%g4,[%o0+144]	!
	st	%i7,[%o0+60]	! save Mreg15
	ld	[%sp+100],%i7	! restore return addr.
	mov	%g2,%o1		! (FATAL if retval == NULL)
	call	emm_getibufbpa,0!
	add	%g0,0,%o2	! type = 0 (instruction)
	ld	[%sp+92],%o7	! struct *guest
	ld	[%o7+132],%g1	!
	ld	[%o7+136],%g2	!
	ld	[%o7+140],%g3	!
	ld	[%o7+144],%g4	!
	ld	[%o7+60],%i7	! restore Mreg15
	st	%o0,[%o7+236]	! store ibufbpa
	subcc	%o0,1,%g0	! if retval == 1 then return(1)
	be	epilog1		!
	nop			!
	
! LOCK for MP
trans_plock:			!			(MP PATCH)
	ldstub	[%o0+4],%o2	! try locking ibufbpa	(MP PATCH)
	subcc	%o2,0,%g0	!			(MP PATCH)
	be	trans_plout	!			(MP PATCH)
	nop			!			(MP PATCH)
trans_plwait:			!			(MP PATCH)
	ldub	[%o0+4],%o2	!			(MP PATCH)
	subcc	%o2,0,%g0	!			(MP PATCH)
	bne	trans_plwait	!			(MP PATCH)
	nop			!			(MP PATCH)
	ba,a	trans_plock	! retry locking ibufbpa (MP PATCH)
trans_plout:			!			(MP PATCH)
	add	%g0,0x10,%o2	! ID=trans		(MP PATCH)
	stb	%o2,[%o0+5]	!			(MP PATCH)
	
	sll	%g2,1,%o1	! IAR << 1
	ld	[%g5+%o1],%o0	! load host_imap[IAR]
	subcc	%o0,0,%g0	! if host_imap[IAR] != 0 then
	bnz	trans_lunlock	!   goto trans_lunlock
	nop			!

!
! Dynamically Translating Simulator Subsystem Main Loop
!
trans_loop:
	ld	[%sp+92],%o7	! struct *guest
	ld	[%o7+400],%o0	! pa_trans++
	add	%o0,1,%o0	!
	st	%o0,[%o7+400]	!
	add	%g4,%g2,%o2	! guest_mem[VIAR]
	or	%g7,0x80,%g7	! --- M I-fetch start ---
	ldub	[%o2],%o1	! load guest_mem[VIAR]
	subcc	%o1,0xb2,%g0	! if 2byte opcd then
	be	trans_lb2xx	!
	sethi	%hi(optable),%o4!
	or	%o4,%lo(optable),%o4
	sll	%o1,5,%o1	!
	ba	trans_ldecode	!
	add	%o4,%o1,%o4	! &optable[opcd]
trans_lb2xx:
	sethi	%hi(optb2xx),%o4!
	or	%o4,%lo(optb2xx),%o4
	ldub	[%o2+1],%o1	! load guest_mem[VIAR+1]
	sll	%o1,5,%o1	!
	add	%o4,%o1,%o4	! &optb2xx[opcd]
trans_ldecode:
	andn	%g7,0x80,%g7	! --- M I-fetch end ---
	ld	[%o4+12],%o3	! load optable[opcd].cfunc
	st	%o3,[%o7+212]	! save optable[opcd].cfunc
	ld	[%o4+16],%o3	! load optable[opcd].tfunc
	st	%o3,[%o7+216]	! save optable[opcd].tfunc
	ld	[%o4+20],%o3	! load optable[opcd].term
	st	%o3,[%o7+220]	! save optable[opcd].term
	ld	[%o4+8],%o3	! load optable[opcd].mlen
	st	%o3,[%o7+208]	! save optable[opcd].mlen
	subcc	%o3,2,%g0	!
	bne	trans_lskip2	!
	nop			!
	or	%g7,0x80,%g7	! --- M I-fetch start ---
	lduh	[%o2],%o1	! 2 byte instruction
	andn	%g7,0x80,%g7	! --- M I-fetch end ---
	ba	trans_lcfunc	!
	sll	%o1,16,%o1	! store in upper half of %o1
trans_lskip2:
	subcc	%o3,4,%g0	!
	bne	trans_lskip4	!
	nop			!
	or	%g7,0x80,%g7	! --- M I-fetch start ---
	lduh	[%o2],%o1	! 4 byte instruction
	lduh	[%o2+2],%o3	!
	andn	%g7,0x80,%g7	! --- M I-fetch end ---
	sll	%o1,16,%o1	!
	ba	trans_lcfunc	!
	or	%o1,%o3,%o1	! store in %o1
trans_lskip4:
	or	%g7,0x80,%g7	! --- M I-fetch start ---
	lduh	[%o2],%o1	! 6 byte instruction
	lduh	[%o2+2],%o3	!
	lduh	[%o2+4],%o2	!
	andn	%g7,0x80,%g7	! --- M I-fetch end ---
	sll	%o1,16,%o1	!
	or	%o1,%o3,%o1	! store in %o1
	sll	%o2,16,%o2	! store in upper half of %o2

trans_lcfunc:
	st	%o1,[%o7+200]	! store minsn (upper)
	st	%o2,[%o7+204]	! store minsn (lower)
	ld	[%o7+212],%o3	! load cfunc
	jmpl	%o3,%o7		! call cfunc()
	add	%g0,0,%o5	! flag=NON EXECUTE

	ld	[%sp+92],%o7	! struct *guest
	st	%o0,[%o7+224]	! store slen
	ld	[%o7+236],%o1	! load ibufbpa
	ld	[%o1],%o1	! load ibufbp
	subcc	%o1,0,%g0	! if ibufbp == 0 then
	be	trans_lalloc	!   allocate new host_ibuf
	nop			!
	ld	[%o1+4],%o2	! load ibufbp->free
	sub	%o2,32,%o3	! sethi;or;jmp;nop;sethi;or;jmp;nop
	subcc	%o3,%o0,%g0	! if ibufbp->free-32 >= slen then
	bge	trans_ltfunc	!   skip allocating new host_ibuf
	sub	%o2,16,%o2	!
	st	%o2,[%o1+4]	!
	sethi	%hi(32768),%o3	!
	sub	%o3,%o2,%o3	!
	add	%o1,%o3,%o0	! get bufp start address
	sethi	%hi(terminsn),%o1
	or	%o1,%lo(terminsn),%o1
	ld	[%o1],%o2	! terminate ibuf with sethi;or;jmpl;nop;
	ld	[%o1+4],%o3	!
	ld	[%o1+8],%o4	!
	ld	[%o1+12],%o5	!
	st	%o2,[%o0-16]	!
	st	%o3,[%o0-12]	!
	st	%o4,[%o0-8]	!
	st	%o5,[%o0-4]	!
	!!flush	%o0-16		! drain store buffer(for ROSS)
	!!flush	%o0-8		! drain store buffer(for ROSS)
	!!flush	%o0-4		! drain store buffer(for ROSS)

trans_lalloc:
	ld	[%sp+92],%o0	! struct *guest
	st	%g1,[%o0+132]	!
	st	%g2,[%o0+228]	! VIAR
	st	%g3,[%o0+140]	!
	st	%g4,[%o0+144]	!
	st	%i7,[%o0+60]	! save Mreg15
	ld	[%sp+100],%i7	! restore return addr.
	call	emm_ibuf_alloc,0!
	mov	%g2,%o1		! (FATAL if retval == NULL)
	ld	[%sp+92],%o7	! struct *guest
	ld	[%o7+132],%g1	!
	ld	[%o7+228],%g2	! VIAR
	ld	[%o7+140],%g3	!
	ld	[%o7+144],%g4	!
	ld	[%o7+60],%i7	! restore Mreg15
	st	%g0,[%o0]	! NULL -> next_P
	sethi	%hi(32768),%o1	!
	sub	%o1,24,%o1	!
	st	%o1,[%o0+4]	! IBUF_PAGESIZE - 8 - 16 -> free bytes
	sethi	%hi(intrinsn),%o1
	or	%o1,%lo(intrinsn),%o1
	ld	[%o1],%o2	! fill ibuf with sethi;or;jmpl;nop;
	ld	[%o1+4],%o3	!
	ld	[%o1+8],%o4	!
	ld	[%o1+12],%o5	!
	st	%o2,[%o0+8]	!
	st	%o3,[%o0+12]	!
	st	%o4,[%o0+16]	!
	st	%o5,[%o0+20]	!
	!!flush	%o0+8		! drain store buffer(for ROSS)
	!!flush	%o0+16		! drain store buffer(for ROSS)
	!!flush	%o0+20		! drain store buffer(for ROSS)

trans_ltfunc:
	ld	[%o7+236],%o1	! load ibufbpa
	ld	[%o1],%o1	! load ibufbp
	ld	[%o1+4],%o2	! load ibufbp->free
	sethi	%hi(32768),%o3	!
	sub	%o3,%o2,%o3	!
	add	%o1,%o3,%o0	! get bufp start address
	and	%g2,0xfff,%o4	! VIAR offset in 4KB-page
	sll	%o4,1,%o4	! VIAR << 1
	ld      [%o7+192],%o3	! use interp_ibuf[] as buffer
	add	%o3,%o4,%o3	! (don't use %g5 while translating)
	st	%o0,[%o3]	! store host_imap[VIAR]
	ld	[%o7+208],%o4	! load mlen
	subcc	%o4,2,%g0	!
	be	trans_limap	!
	add	%g0,1,%o1	! if mlen > 2 then store "1"
	st	%o1,[%o3+4]	!
	subcc	%o4,4,%g0	!
	be	trans_limap	!
	add	%g0,2,%o1	! if mlen > 4 then store "2"
	st	%o1,[%o3+8]	!
trans_limap:
	ld	[%o7+200],%o1	! load minsn (upper)
	ld	[%o7+204],%o2	! load minsn (lower)
	ld	[%o7+216],%o3	! load tfunc
	st	%o0,[%o7+232]	! flush address
	jmpl	%o3,%o7		! call tfunc()
	add	%g0,0,%o5	! flag=NON EXECUTE

	ld	[%sp+92],%o7	! struct *guest
	!!ld	[%o7+232],%o1	! flush address     (for ROSS)
trans_ltflush:			!		    (for ROSS)
	!!flush	%o1		! drain store buffer(for ROSS)
	!!subcc	%o1,%o0,%g0	!		    (for ROSS)
	!!blu	trans_ltflush	!		    (for ROSS)
	!!add	%o1,8,%o1	!		    (for ROSS)
	ld	[%o7+236],%o1	! load ibufbpa
	ld	[%o1],%o1	! load ibufbp
	ld	[%o1+4],%o2	! load ibufbp->free
	ld	[%o7+224],%o3	! load slen
	sub	%o2,%o3,%o2	! decrement ibufbp->free
	st	%o2,[%o1+4]	!

	ld	[%o0-8],%o3	! load "branch epilog"
	srl	%o3,22,%o3	! clear disp22
	sll	%o3,22,%o3	!
	sub	%o1,%o0,%o4	! get offset
	add	%o4,16,%o4	!
	sll	%o4,8,%o4	!
	srl	%o4,10,%o4	!
	or	%o3,%o4,%o3	!
	st	%o3,[%o0-8]	! store "branch epilog"
	!!flush	%o0-8		! drain store buffer(for ROSS)

	add	%g0,%g2,%o3	! old VIAR
	ld	[%o7+208],%o4	! load mlen
	add	%g2,%o4,%g2	! new VIAR
	and	%g2,%g3,%g2	! mask address
	xor	%g2,%o3,%o3	!
	andncc	%o3,0xfff,%g0	!
	bnz	trans_lterm2	! if new address is newpage then
	nop			!   terminate loop

	or	%g7,0x80,%g7	! --- M I-fetch start ---
	ldub	[%g4+%g2],%o1	! load guest_mem[VIAR]
	andn	%g7,0x80,%g7	! --- M I-fetch end ---
	sethi	%hi(optable),%o4!
	or	%o4,%lo(optable),%o4
	sll	%o1,5,%o1	!
	add	%o4,%o1,%o4	! &optable[opcd]
	ld	[%o4+8],%o3	! load optable[opcd].mlen
	sub	%o3,1,%o3	!
	add	%g2,%o3,%o3	! new VIAR-1
	xor	%g2,%o3,%o4	!
	andncc	%o4,0xfff,%g0	!
	bnz	trans_lterm2	! if new insn crosses page boundary
	nop			!   terminate loop

	ld	[%o7+220],%o3	! load term
	subcc	%o3,0,%g0	! if term == 0 then
	be	trans_lterm1	!   skip
	subcc	%o3,1,%g0	! if term == 1 then
	be	trans_lterm2	!   terminate loop
	ld	[%o7+200],%o4	! load minsn (upper)
	srl	%o4,20,%o4	! extract M
	and	%o4,0xf,%o4	!
	subcc	%o4,0xf,%g0	! if M == 0xf then
	bz	trans_lterm2	!   terminate loop
	nop			!

trans_lterm1:
	sll	%g2,1,%o4	! VIAR << 1
	ld	[%g5+%o4],%o3	! load host_imap[VIAR]
	subcc	%o3,0,%g0	! if host_imap[VIAR] != 0 then
	bnz	trans_lterm2	!   terminate loop
	andncc	%g7,0xfff,%g0	! if !interruption then
	bz	trans_loop	!   continue translation
	nop			!

trans_lterm2:
	ld	[%o7+236],%o1	! load ibufbpa
	ld	[%o1],%o1	! load ibufbp
	ld	[%o1+4],%o2	! load ibufbp->free
	sub	%o2,16,%o2	! decrement ibufbp->free more
	st	%o2,[%o1+4]	!
	sethi	%hi(terminsn),%o1
	or	%o1,%lo(terminsn),%o1
	ld	[%o1],%o2	! terminate ibuf with sethi;or;jmpl;nop;
	ld	[%o1+4],%o3	!
	ld	[%o1+8],%o4	!
	ld	[%o1+12],%o5	!
	st	%o2,[%o0]	!
	st	%o3,[%o0+4]	!
	st	%o4,[%o0+8]	!
	st	%o5,[%o0+12]	!
	!!flush	%o0		! drain store buffer(for ROSS)
	!!flush	%o0+8		! drain store buffer(for ROSS)
	!!flush	%o0+12		! drain store buffer(for ROSS)

	ld	[%o7+192],%o0	! use interp_ibuf[] as buffer
	sub	%g2,2,%o2	! get last translated address
	and	%o2,0xfff,%o3	! VIAR offset in 4KB-page
	sll	%o3,1,%o3	! get interp_ibuf index
	sll	%o2,1,%o2	! get host_imap index
	ld	[%o7+136],%g2	! get first translated address
	and	%g2,0xfff,%o1	! IAR offset in 4KB-page
	sll	%o1,1,%o1	! IAR << 1
	subcc	%o1,%o3,%g0	! if page-boundary is included
	sethi	%hi(0x00002000),%o4
	or	%o4,%lo(0x00002000),%o4
	bgu,a	trans_limapcp	!
	add	%o3,%o4,%o3	!   add 8KB to last address
trans_limapcp:
	ld	[%o0+%o3],%o4	! load interp_ibuf[VIAR] buffer
	subcc	%o1,%o3,%g0	!
	sub	%o3,4,%o3	!
	st	%o4,[%g5+%o2]	! store host_imap[VIAR]
	bne	trans_limapcp	!
	sub	%o2,4,%o2	!
	
trans_lunlock:
	flush	%g0+0		! drain store buffer(for VIKING)
	stbar			!			(MP PATCH)
	ld	[%o7+236],%o0	! restore ibufbpa	(MP PATCH)
	ba	trans_main	! start execution
	stb	%g0,[%o0+4]	! unlock ibufbpa	(MP PATCH)
!================================

!
! Interpretive Execution Entry (IM=1)
!
trans_interp:	
	ld	[%sp+92],%o7	! struct *guest
	ld	[%o7+400],%o0	! pa_trans++
	add	%o0,1,%o0	!
	st	%o0,[%o7+400]	!
	add	%g4,%g2,%o2	! guest_mem[IAR]
	or	%g7,0x80,%g7	! --- M I-fetch start ---
	ldub	[%o2],%o1	! load guest_mem[VIAR]
	andn	%g7,0x80,%g7	! --- M I-fetch end ---

	ld	[%o7+508],%o0	! get emmptr
	ld	[%o0+0x348],%o0	! get PSW
	srl	%o0,16,%o0	! test 'P'
	andcc	%o0,1,%g0	!
	ld	[%o7+404],%o4	! load pa_sinsn (supervisor)
	bnz,a	update_pa_insn	!
	ld	[%o7+408],%o4	! load pa_pinsn (problem)
update_pa_insn:
	sll	%o1,2,%o1	!
	ld	[%o4+%o1],%o0	!
	add	%o0,1,%o0	!
	st	%o0,[%o4+%o1]	!
	srl	%o1,2,%o1	!

	subcc	%o1,0xb2,%g0	! if 2byte opcd then
	be	trans_ib2xx	!
	sethi	%hi(optable),%o4!
	or	%o4,%lo(optable),%o4
	sll	%o1,5,%o1	!
	ba	trans_idecode	!
	add	%o4,%o1,%o4	! &optable[opcd]
trans_ib2xx:
	sethi	%hi(optb2xx),%o4!
	or	%o4,%lo(optb2xx),%o4
	or	%g7,0x80,%g7	! --- M I-fetch start ---
	ldub	[%o2+1],%o1	! load guest_mem[VIAR+1]
	andn	%g7,0x80,%g7	! --- M I-fetch end ---
	sll	%o1,5,%o1	!
	add	%o4,%o1,%o4	! &optb2xx[opcd]
trans_idecode:	
	ld	[%o4+12],%o3	! load optable[opcd].cfunc
	st	%o3,[%o7+212]	! save optable[opcd].cfunc
	ld	[%o4+16],%o3	! load optable[opcd].tfunc
	st	%o3,[%o7+216]	! save optable[opcd].tfunc
	ld	[%o4+20],%o3	! load optable[opcd].term
	st	%o3,[%o7+220]	! save optable[opcd].term
	ld	[%o4+8],%o3	! load optable[opcd].mlen
	st	%o3,[%o7+208]	! save optable[opcd].mlen
	subcc	%o3,2,%g0	!
	bne	trans_iskip2	!
	nop			!
	or	%g7,0x80,%g7	! --- M I-fetch start ---
	lduh	[%o2],%o1	! 2 byte instruction
	andn	%g7,0x80,%g7	! --- M I-fetch end ---
	ba	trans_itfunc	!
	sll	%o1,16,%o1	! store in upper half of %o1
trans_iskip2:
	subcc	%o3,4,%g0	!
	bne	trans_iskip4	!
	nop			!
	or	%g7,0x80,%g7	! --- M I-fetch start ---
	lduh	[%o2],%o1	! 4 byte instruction
	lduh	[%o2+2],%o3	!
	andn	%g7,0x80,%g7	! --- M I-fetch end ---
	sll	%o1,16,%o1	!
	ba	trans_itfunc	!
	or	%o1,%o3,%o1	! store in %o1
trans_iskip4:
	or	%g7,0x80,%g7	! --- M I-fetch start ---
	lduh	[%o2],%o1	! 6 byte instruction
	lduh	[%o2+2],%o3	!
	lduh	[%o2+4],%o2	!
	andn	%g7,0x80,%g7	! --- M I-fetch end ---
	sll	%o1,16,%o1	!
	or	%o1,%o3,%o1	! store in %o1
	sll	%o2,16,%o2	! store in upper half of %o2

trans_itfunc:
	st	%o1,[%o7+200]	! store minsn (upper)
	st	%o2,[%o7+204]	! store minsn (lower)
	ld	[%o7+192],%o0	! get interp_ibuf start address
	add	%o0,24,%o0	!
	sethi	%hi(intrinsn),%o1
	or	%o1,%lo(intrinsn),%o1
	ld	[%o1],%o2	! fill ibuf with sethi;or;jmpl;nop;
	ld	[%o1+4],%o3	!
	ld	[%o1+8],%o4	!
	ld	[%o1+12],%o5	!
	st	%o2,[%o0-16]	!
	st	%o3,[%o0-12]	!
	st	%o4,[%o0-8]	!
	st	%o5,[%o0-4]	!
	!!flush	%o0-16		! drain store buffer(for ROSS)
	!!flush	%o0-8		! drain store buffer(for ROSS)
	!!flush	%o0-4		! drain store buffer(for ROSS)

	ld	[%o7+200],%o1	! load minsn (upper)
	ld	[%o7+204],%o2	! load minsn (lower)
	ld	[%o7+216],%o3	! load tfunc
	st	%o0,[%o7+232]	! flush address
	jmpl	%o3,%o7		! call tfunc()
	add	%g0,0,%o5	! flag=NON EXECUTE

	ld	[%sp+92],%o7	! struct *guest
	!!ld	[%o7+232],%o1	! flush address     (for ROSS)
trans_itflush:			!		    (for ROSS)
	!!flush	%o1		! drain store buffer(for ROSS)
	!!subcc	%o1,%o0,%g0	!		    (for ROSS)
	!!blu	trans_itflush	!		    (for ROSS)
	!!add	%o1,8,%o1	!		    (for ROSS)
	ld	[%o7+192],%o1	! get interp_ibuf start address
	ld	[%o0-8],%o3	! load "branch epilog"
	srl	%o3,22,%o3	! clear disp22
	sll	%o3,22,%o3	!
	sub	%o1,%o0,%o4	! get offset
	add	%o4,16,%o4	!
	sll	%o4,8,%o4	!
	srl	%o4,10,%o4	!
	or	%o3,%o4,%o3	!
	st	%o3,[%o0-8]	! store "branch epilog"
	!!flush	%o0-8		! drain store buffer(for ROSS)

	sethi	%hi(terminsn),%o1
	or	%o1,%lo(terminsn),%o1
	ld	[%o1],%o2	! terminate ibuf with sethi;or;jmpl;nop;
	ld	[%o1+4],%o3	!
	ld	[%o1+8],%o4	!
	ld	[%o1+12],%o5	!
	st	%o2,[%o0]	!
	st	%o3,[%o0+4]	!
	st	%o4,[%o0+8]	!
	st	%o5,[%o0+12]	!
	!!flush	%o0		! drain store buffer(for ROSS)
	!!flush	%o0+8		! drain store buffer(for ROSS)
	!!flush	%o0+12		! drain store buffer(for ROSS)

	ld	[%o7+192],%o0	! get interp_ibuf start address
	add	%o0,24,%o0	!
	flush	%g0+0		! drain store buffer(for VIKING)
	jmpl	%o0,%g0		! jmp to interp_ibuf
	nop			!
!================================

!
! header instruction template
!
headinsn:
	andn	%g1,0xc,%g1	!
	or	%g1,0x8,%g1	!
	add	%g2,0x0,%g2	!
!================================

!
! terminal instruction template
!
terminsn:
	sethi	%hi(trans_main),%o0
	or	%o0,%lo(trans_main),%o0
	jmpl	%o0,%g0		!
	nop			!
!================================

!
! interruption instruction template
!
intrinsn:
	sethi	%hi(epilog0),%o0!
	or	%o0,%lo(epilog0),%o0
	jmpl	%o0,%g0		!
	nop			!
!================================

!
! eplilog
!
epilog0:
	add	%g0,0,%o0	!
epilog1:	
	and	%g2,%g3,%g2	! mask address
	ld	[%sp+92],%o1	! struct *guest
	st	%g1,[%o1+132]	! ILC,CC
	st	%g2,[%o1+136]	! IAR
	st	%g3,[%o1+140]	! addres mask(24/31)
	st	%g4,[%o1+144]	! key (operand)
	st	%g5,[%o1+148]	! key (instruction)
	st	%g6,[%o1+ 56]	! Mreg14
	st	%l0,[%o1+  0]	! Mreg0
	st	%l1,[%o1+  4]	! Mreg1
	st	%l2,[%o1+  8]	! Mreg2
	st	%l3,[%o1+ 12]	! Mreg3
	st	%l4,[%o1+ 16]	! Mreg4
	st	%l5,[%o1+ 20]	! Mreg5
	st	%l6,[%o1+ 24]	! Mreg6
	st	%l7,[%o1+ 28]	! Mreg7
	st	%i0,[%o1+ 32]	! Mreg8
	st	%i1,[%o1+ 36]	! Mreg9
	st	%i2,[%o1+ 40]	! Mreg10
	st	%i3,[%o1+ 44]	! Mreg11
	st	%i4,[%o1+ 48]	! Mreg12
	st	%i5,[%o1+ 52]	! Mreg13
	st	%i7,[%o1+ 60]	! Mreg15
	mov	%o0,%i0		!
	ld	[%sp+100],%i7	! return addr.
	ret			!
	restore			!
!================================

!
! templates
! cxx_xxx:
!   %o0: param: none
!	 retval:size of template
!   %o1: M instruction (upper 2 bytes)
!   %o2: work
!   %o3: work
!   %o4: work
!   %o5: flag(0:NON EXECUTE,1:EXECUTE)
! txx_xxx:
!   %o0: param: bufp start address
!	 retval:bufp next start address
!   %o1: M instruction (upper 2 bytes)
!   %o2: work
!   %o3: work
!   %o4: work
!   %o5: flag(0:NON EXECUTE,1:EXECUTE)
!
	.section ".text"
	.align	4
	.global ci2_OPX2,ti2_OPX2
ci2_OPX2:
	retl				!
	add	%g0,.OPX20e-.OPX20s,%o0	!
ti2_OPX2:
	sethi	%hi(.OPX20s),%o3	!
	or	%o3,%lo(.OPX20s),%o3	!
	or	%g0,.OPX20e-.OPX20s,%o4	!
    .OPX20cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.OPX20cp		!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,.OPX20e-.OPX20s,%o0	!
.OPX20s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x4,%g1	! CC=unchange & ILC=1
		add	%g2,0x2,%g2	! update IAR
		sethi	%hi(0x00010000),%o0
		or	%g7,%o0,%g7	! operation exception
		ba	.OPX20e		! return(TEMPLATE)
		add	%g1,0x10,%g1	!
.OPX20e:

	.section ".text"
	.align	4
	.global ci4_OPX4,ti4_OPX4
ci4_OPX4:
	retl				!
	add	%g0,.OPX40e-.OPX40s,%o0	!
ti4_OPX4:
	sethi	%hi(.OPX40s),%o3	!
	or	%o3,%lo(.OPX40s),%o3	!
	or	%g0,.OPX40e-.OPX40s,%o4	!
    .OPX40cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.OPX40cp		!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,.OPX40e-.OPX40s,%o0	!
.OPX40s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
		sethi	%hi(0x00010000),%o0
		or	%g7,%o0,%g7	! operation exception
		ba	.OPX40e		! return(TEMPLATE)
		add	%g1,0x10,%g1	!
.OPX40e:

	.section ".text"
	.align	4
	.global ci6_OPX6,ti6_OPX6
ci6_OPX6:
	retl				!
	add	%g0,.OPX60e-.OPX60s,%o0	!
ti6_OPX6:
	sethi	%hi(.OPX60s),%o3	!
	or	%o3,%lo(.OPX60s),%o3	!
	or	%g0,.OPX60e-.OPX60s,%o4	!
    .OPX60cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.OPX60cp		!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,.OPX60e-.OPX60s,%o0	!
.OPX60s:
		andn	%g1,0xc,%g1	!
		or	%g1,0xc,%g1	! CC=unchange & ILC=3
		add	%g2,0x6,%g2	! update IAR
		sethi	%hi(0x00010000),%o0
		or	%g7,%o0,%g7	! operation exception
		ba	.OPX60e		! return(TEMPLATE)
		add	%g1,0x10,%g1	!
.OPX60e:
!================================

!
! templates
! cxx_xxx:
!   %o0: param: none
!	 retval:size of template
!   %o1: M instruction (upper 2 bytes)
!   %o2: work
!   %o3: work
!   %o4: work
!   %o5: flag(0:NON EXECUTE,1:EXECUTE)
! txx_xxx:
!   %o0: param: bufp start address
!	 retval:bufp next start address
!   %o1: M instruction (upper 2 bytes)
!   %o2: work
!   %o3: work
!   %o4: work
!   %o5: flag(0:NON EXECUTE,1:EXECUTE)
!
	.section ".text"
	.align	4
	.global ci2_spm,ti2_spm
ci2_spm:
	retl				!
	add	%g0,.spm0e-.spm0s,%o0	!
ti2_spm:
	sethi	%hi(.spm0s),%o3		!
	or	%o3,%lo(.spm0s),%o3	!
	or	%g0,.spm0e-.spm0s,%o4	!
    .spm0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.spm0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.spm0t0-.spm0s],%o5!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+.spm0t0-.spm0s]!
	retl				!
	add	%o0,.spm0e-.spm0s,%o0	!
.spm0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x4,%g1	! CC=unchange & ILC=1
		add	%g2,0x2,%g2	! update IAR
    .spm0t0:	srl	%l0,24,%o0	! extract prog-mask
		and	%o0,0xf,%o1	!
		andn	%g7,0xf,%g7	!
		or	%g7,%o1,%g7	! set prog-mask
		srl	%o0,4,%o0	! extract CC
		and	%o0,3,%o0	!
		andn	%g1,3,%g1	!
		or	%g1,%o0,%g1	! set CC
		andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.spm0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.spm0e:

	.section ".text"
	.align	4
	.global ci2_balr,ti2_balr
ci2_balr:
	srl	%o1,16,%o3		! switch (R2)
	andcc	%o3,0xf,%g0		!
	bnz	.balr1c			!
	nop				!
    .balr0c:				!
	retl				! case 0:
	add	%g0,.balr0e-.balr0s,%o0 !
    .balr1c:				!
	retl				! case not 0:
	add	%g0,.balr1e-.balr1s,%o0 !
ti2_balr:
	srl	%o1,16,%o3		! switch (R2)
	andcc	%o3,0xf,%g0		!
	bnz	.balr1t			!
	nop				!
    .balr0t:				!
	sethi	%hi(.balr0s),%o3	!
	or	%o3,%lo(.balr0s),%o3	!
	or	%g0,.balr0e-.balr0s,%o4 !
    .balr0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.balr0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.balr0t0-.balr0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,25,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+.balr0t0-.balr0s]
	retl				!
	add	%o0,.balr0e-.balr0s,%o0 !
    .balr1t:				!
	sethi	%hi(.balr1s),%o3	!
	or	%o3,%lo(.balr1s),%o3	!
	or	%g0,.balr1e-.balr1s,%o4 !
    .balr1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.balr1cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.balr1t0-.balr1s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	st	%o5,[%o0+.balr1t0-.balr1s]
	ld	[%o0+.balr1t1-.balr1s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,25,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+.balr1t1-.balr1s]
	retl				!
	add	%o0,.balr1e-.balr1s,%o0 !
.balr0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x4,%g1	! CC=unchange & ILC=1
		add	%g2,0x2,%g2	! update IAR
		andcc	%g7,0x10,%g0	! if AM == 0 then
		bnz	.balr000	!
		sethi	%hi(0xff000000),%o1
		andn	%g2,%o1,%o2	!   24bit address
		and	%g1,0xf,%o1	!   ILC,CC
		sll	%o1,28,%o1	!
		or	%o1,%o2,%o2	!
		and	%g7,0xf,%o1	!   Prog-Mask
		ba	.balr0t0	!
		sll	%o1,24,%o1	!
    .balr000:	sethi	%hi(0x80000000),%o1
		andn	%g2,%o1,%o2	!   31bit address
    .balr0t0:	or	%o1,%o2,%l0	! ##TEMPLATE:%l0
		andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.balr0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.balr0e:
.balr1s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x4,%g1	! CC=unchange & ILC=1
		add	%g2,0x2,%g2	! update IAR
    .balr1t0:	add	%g0,%l0,%o0	! ##TEMPLATE:%l0
		andcc	%g7,0x10,%g0	! if AM == 0 then
		bnz	.balr100	!
		sethi	%hi(0xff000000),%o1
		andn	%g2,%o1,%o2	!   24bit address
		and	%g1,0xf,%o1	!   ILC,CC
		sll	%o1,28,%o1	!
		or	%o1,%o2,%o2	!
		and	%g7,0xf,%o1	!   Prog-Mask
		ba	.balr1t1	!
		sll	%o1,24,%o1	!
    .balr100:	sethi	%hi(0x80000000),%o1
		andn	%g2,%o1,%o2	!   31bit address
    .balr1t1:	or	%o1,%o2,%l0	! ##TEMPLATE:%l0
		add	%g0,%o0,%g2	!
		andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.balr1e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.balr1e:

	.section ".text"
	.align	4
	.global ci2_bctr,ti2_bctr
ci2_bctr:
	srl	%o1,16,%o3		! switch (R2)
	andcc	%o3,0xf,%g0		!
	bnz	.bctr1c			!
	nop				!
    .bctr0c:				!
	retl				! case 0:
	add	%g0,.bctr0e-.bctr0s,%o0 !
    .bctr1c:				!
	retl				! case not 0:
	add	%g0,.bctr1e-.bctr1s,%o0 !
ti2_bctr:
	srl	%o1,16,%o3		! switch (R2)
	andcc	%o3,0xf,%g0		!
	bnz	.bctr1t			!
	nop				!
    .bctr0t:				!
	sethi	%hi(.bctr0s),%o3	!
	or	%o3,%lo(.bctr0s),%o3	!
	or	%g0,.bctr0e-.bctr0s,%o4 !
    .bctr0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.bctr0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.bctr0t0-.bctr0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	sll	%o4,11,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+.bctr0t0-.bctr0s]
	retl				!
	add	%o0,.bctr0e-.bctr0s,%o0 !
    .bctr1t:				!
	sethi	%hi(.bctr1s),%o3	!
	or	%o3,%lo(.bctr1s),%o3	!
	or	%g0,.bctr1e-.bctr1s,%o4 !
    .bctr1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.bctr1cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.bctr1t0-.bctr1s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	st	%o5,[%o0+.bctr1t0-.bctr1s]
	ld	[%o0+.bctr1t1-.bctr1s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	sll	%o4,11,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+.bctr1t1-.bctr1s]
	retl				!
	add	%o0,.bctr1e-.bctr1s,%o0 !
.bctr0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x4,%g1	! CC=unchange & ILC=1
		add	%g2,0x2,%g2	! update IAR
    .bctr0t0:	subcc	%l0,1,%l0	! ##TEMPLATE:%l0,%l0
		andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.bctr0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.bctr0e:
.bctr1s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x4,%g1	! CC=unchange & ILC=1
		add	%g2,0x2,%g2	! update IAR
    .bctr1t0:	add	%g0,%l0,%o0	! ##TEMPLATE:%l0
    .bctr1t1:	subcc	%l0,1,%l0	! ##TEMPLATE:%l0,%l0
		bnz,a	.bctr100	! if %l0 != 0 then taken
		add	%g0,%o0,%g2	!
    .bctr100:	andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.bctr1e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.bctr1e:

	.section ".text"
	.align	4
	.global ci2_bcr,ti2_bcr
ci2_bcr:
	srl	%o1,16,%o3		! switch (R2)
	andcc	%o3,0xf,%g0		!
	bz	.bcr0c			!
	srl	%o1,20,%o3		! switch (M1)
	andcc	%o3,0xf,%o3		!
	bz	.bcr0c			!
	subcc	%o3,0xf,%g0		!
	bne	.bcr2c			!
	nop				!
    .bcr3c:				!
	retl				! case 15:
	add	%g0,.bcr3e-.bcr3s,%o0	!
    .bcr0c:				!
	retl				! case 0:
	add	%g0,.bcr0e-.bcr0s,%o0	!
    .bcr2c:				!
	retl				! case 1-14:
	add	%g0,.bcr2e-.bcr2s,%o0	!
ti2_bcr:
	srl	%o1,16,%o3		! switch (R2)
	andcc	%o3,0xf,%g0		!
	bz	.bcr0t			!
	srl	%o1,20,%o3		! switch (M1)
	andcc	%o3,0xf,%o3		!
	bz	.bcr0t			!
	subcc	%o3,0xf,%g0		!
	bne	.bcr2t			!
	nop				!
    .bcr3t:
	sethi	%hi(.bcr3s),%o3		!
	or	%o3,%lo(.bcr3s),%o3	!
	or	%g0,.bcr3e-.bcr3s,%o4	!
    .bcr3cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.bcr3cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.bcr3t0-.bcr3s],%o5!
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	st	%o5,[%o0+.bcr3t0-.bcr3s]!
	retl				!
	add	%o0,.bcr3e-.bcr3s,%o0	!
    .bcr0t:				!
	sethi	%hi(.bcr0s),%o3		!
	or	%o3,%lo(.bcr0s),%o3	!
	or	%g0,.bcr0e-.bcr0s,%o4	!
    .bcr0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.bcr0cp			!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,.bcr0e-.bcr0s,%o0	!
    .bcr2t:				!
	sethi	%hi(.bcr2s),%o3		!
	or	%o3,%lo(.bcr2s),%o3	!
	or	%g0,.bcr2e-.bcr2s,%o4	!
    .bcr2cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.bcr2cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.bcr2t0-.bcr2s],%o5!
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	st	%o5,[%o0+.bcr2t0-.bcr2s]!
	ld	[%o0+.bcr2t1-.bcr2s],%o5!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! M1
	sll	%o4,8,%o4		! |
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.bcr2t1-.bcr2s]!
	retl				!
	add	%o0,.bcr2e-.bcr2s,%o0	!
.bcr3s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x4,%g1	! CC=unchange & ILC=1
		add	%g2,0x2,%g2	! update IAR
    .bcr3t0:	add	%g0,%l0,%g2	! ##TEMPLATE:%l0
		andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.bcr3e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.bcr3e:
.bcr0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x4,%g1	! CC=unchange & ILC=1
		add	%g2,0x2,%g2	! update IAR
		andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.bcr0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.bcr0e:
/* TEMPLATE #1 */
/* BCR always returns to trans_main <optable[0x07].term must be 1> */
!.bcr2s:
!		andn	%g1,0xc,%g1	!
!		or	%g1,0x4,%g1	! CC=unchange & ILC=1
!		add	%g2,0x2,%g2	! update IAR
!		and	%g1,3,%o1	!
!		srl	%g7,%o1,%o1	! const.0b0001000XXXXXXXX >> %o1
!    .bcr2t1:	andcc	%o1,0,%g0	! ##TEMPLATE:imm0
!		bnz,a	.bcr200		! if CC is true then taken
!    .bcr2t0:	add	%g0,%l0,%g2	! ##TEMPLATE:%l0
!    .bcr200:	andncc	%g7,0xfff,%g0	! if interruption then
!		bnz	.bcr2e		!   return(TEMPLATE)
!		add	%g1,0x10,%g1	!
!.bcr2e:
/* TEMPLATE #2 */
/* BCR returns to trans_main only if taken <optable[0x07].term must be 2> */
.bcr2s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x4,%g1	! CC=unchange & ILC=1
		add	%g2,0x2,%g2	! update IAR
		and	%g1,3,%o1	!
		srl	%g7,%o1,%o1	! const.0b0001000XXXXXXXX >> %o1
    .bcr2t1:	andcc	%o1,0,%g0	! ##TEMPLATE:imm0
		bz	.bcr200		! if CC is true then taken
		andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.bcr200		!   return
    .bcr2t0:	add	%g0,%l0,%g2	! ##TEMPLATE:%l0
		sethi	%hi(trans_main),%o0
		or	%o0,%lo(trans_main),%o0
		jmpl	%o0,%g0		!
		add	%g1,0x10,%g1	!
    .bcr200:	bnz	.bcr2e		! return(TEMPLATE)
		add	%g1,0x10,%g1	!
.bcr2e:

	.section ".text"
	.align	4
	.global cc2_ssk,tc2_ssk
cc2_ssk:
	retl				!
	add	%g0,.ssk0e-.ssk0s,%o0	!
tc2_ssk:
	sethi	%hi(.ssk0s),%o3		!
	or	%o3,%lo(.ssk0s),%o3	!
	or	%g0,.ssk0e-.ssk0s,%o4	!
    .ssk0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.ssk0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.ssk0t0-.ssk0s],%o5!
	srl	%o1,10,%o4		!
	or	%o5,%o4,%o5		! simm22
	st	%o5,[%o0+.ssk0t0-.ssk0s]!
	ld	[%o0+.ssk0t1-.ssk0s],%o5!
	and	%o1,0xfff,%o4		!
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.ssk0t1-.ssk0s]!
	retl				!
	add	%o0,.ssk0e-.ssk0s,%o0	!
.ssk0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x4,%g1	! CC=unchange & ILC=1
		add	%g2,0x2,%g2	! update IAR
		ld	[%sp+92],%o7	! struct *guest
    .ssk0t0:	sethi	0,%o0		! ##TEMPLATE:imm
    .ssk0t1:	or	%o0,0,%o0	! ##TEMPLATE:imm
		st	%o0,[%o7+200]	! store minsn (upper)
		st	%g0,[%o7+204]	! store minsn (lower)
		sethi	%hi(0x80000000),%o0
		or	%g7,%o0,%g7	! Special Instruction (FC=2)
		ba	.ssk0e		! return(TEMPLATE)
		add	%g1,0x10,%g1	!
.ssk0e:

	.section ".text"
	.align	4
	.global cc2_isk,tc2_isk
cc2_isk:
	retl				!
	add	%g0,.isk0e-.isk0s,%o0	!
tc2_isk:
	sethi	%hi(.isk0s),%o3		!
	or	%o3,%lo(.isk0s),%o3	!
	or	%g0,.isk0e-.isk0s,%o4	!
    .isk0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.isk0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.isk0t0-.isk0s],%o5!
	srl	%o1,10,%o4		!
	or	%o5,%o4,%o5		! simm22
	st	%o5,[%o0+.isk0t0-.isk0s]!
	ld	[%o0+.isk0t1-.isk0s],%o5!
	and	%o1,0xfff,%o4		!
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.isk0t1-.isk0s]!
	retl				!
	add	%o0,.isk0e-.isk0s,%o0	!
.isk0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x4,%g1	! CC=unchange & ILC=1
		add	%g2,0x2,%g2	! update IAR
		ld	[%sp+92],%o7	! struct *guest
    .isk0t0:	sethi	0,%o0		! ##TEMPLATE:imm
    .isk0t1:	or	%o0,0,%o0	! ##TEMPLATE:imm
		st	%o0,[%o7+200]	! store minsn (upper)
		st	%g0,[%o7+204]	! store minsn (lower)
		sethi	%hi(0x80000000),%o0
		or	%g7,%o0,%g7	! Special Instruction (FC=2)
		ba	.isk0e		! return(TEMPLATE)
		add	%g1,0x10,%g1	!
.isk0e:

	.section ".text"
	.align	4
	.global ci2_svc,ti2_svc
ci2_svc:
	retl				!
	add	%g0,.svc0e-.svc0s,%o0	!
ti2_svc:
	sethi	%hi(.svc0s),%o3		!
	or	%o3,%lo(.svc0s),%o3	!
	or	%g0,.svc0e-.svc0s,%o4	!
    .svc0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.svc0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.svc0t0-.svc0s],%o5!
	srl	%o1,10,%o4		!
	or	%o5,%o4,%o5		! simm22
	st	%o5,[%o0+.svc0t0-.svc0s]!
	ld	[%o0+.svc0t1-.svc0s],%o5!
	and	%o1,0xfff,%o4		!
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.svc0t1-.svc0s]!
	retl				!
	add	%o0,.svc0e-.svc0s,%o0	!
.svc0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x4,%g1	! CC=unchange & ILC=1
		add	%g2,0x2,%g2	! update IAR
		ld	[%sp+92],%o7	! struct *guest
    .svc0t0:	sethi	0,%o0		! ##TEMPLATE:imm
    .svc0t1:	or	%o0,0,%o0	! ##TEMPLATE:imm
		st	%o0,[%o7+200]	! store minsn (upper)
		st	%g0,[%o7+204]	! store minsn (lower)
		sethi	%hi(0x80000000),%o0
		or	%g7,%o0,%g7	! Special Instruction (FC=2)
		ba	.svc0e		! return(TEMPLATE)
		add	%g1,0x10,%g1	!
.svc0e:

	.section ".text"
	.align	4
	.global ci2_bsm,ti2_bsm
ci2_bsm:
	srl	%o1,16,%o3		! switch (R2)
	andcc	%o3,0xf,%g0		!
	bnz	.bsm1c			!
	nop				!
    .bsm0c:				!
	retl				! case 0:
	add	%g0,.bsm0e-.bsm0s,%o0	!
    .bsm1c:				!
	retl				! case not 0:
	add	%g0,.bsm1e-.bsm1s,%o0	!
ti2_bsm:
	srl	%o1,16,%o3		! switch (R2)
	andcc	%o3,0xf,%g0		!
	bnz	.bsm1t			!
	nop				!
    .bsm0t:				!
	sethi	%hi(.bsm0s),%o3		!
	or	%o3,%lo(.bsm0s),%o3	!
	or	%g0,.bsm0e-.bsm0s,%o4	!
    .bsm0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.bsm0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.bsm0t0-.bsm0s],%o5!
	srl	%o1,20,%o4		!
	andcc	%o4,0xf,%o4		! R1
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	sll	%o4,11,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+.bsm0t0-.bsm0s]!
	ld	[%o0+.bsm0t1-.bsm0s],%o5!
	srl	%o1,20,%o4		!
	andcc	%o4,0xf,%o4		! R1
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	sll	%o4,11,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+.bsm0t1-.bsm0s]!
	retl				!
	add	%o0,.bsm0e-.bsm0s,%o0	!
    .bsm1t:				!
	sethi	%hi(.bsm1s),%o3		!
	or	%o3,%lo(.bsm1s),%o3	!
	or	%g0,.bsm1e-.bsm1s,%o4	!
    .bsm1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.bsm1cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.bsm1t0-.bsm1s],%o5!
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+.bsm1t0-.bsm1s]!
	ld	[%o0+.bsm1t1-.bsm1s],%o5!
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+.bsm1t1-.bsm1s]!
	ld	[%o0+.bsm1t2-.bsm1s],%o5!
	srl	%o1,20,%o4		!
	andcc	%o4,0xf,%o4		! R1
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	sll	%o4,11,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+.bsm1t2-.bsm1s]!
	ld	[%o0+.bsm1t3-.bsm1s],%o5!
	srl	%o1,20,%o4		!
	andcc	%o4,0xf,%o4		! R1
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	sll	%o4,11,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+.bsm1t3-.bsm1s]!
	retl				!
	add	%o0,.bsm1e-.bsm1s,%o0	!
.bsm0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x4,%g1	! CC=unchange & ILC=1
		add	%g2,0x2,%g2	! update IAR
		and	%g7,0x10,%o0	! extract AM-bit
		sll	%o0,27,%o0	!
		sethi	%hi(0x80000000),%o1
    .bsm0t0:	andn	%l0,%o1,%l0	! ##TEMPLATE:%l0,%l0
    .bsm0t1:	or	%l0,%o0,%l0	! ##TEMPLATE:%l0,%l0
		andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.bsm0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.bsm0e:
.bsm1s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x4,%g1	! CC=unchange & ILC=1
		add	%g2,0x2,%g2	! update IAR
		and	%g7,0x10,%o0	! extract AM-bit
		sll	%o0,27,%o0	!
		sethi	%hi(0x80000000),%o1
    .bsm1t0:	andcc	%l0,%o1,%g0	! ##TEMPLATE:%l0
		bnz	.bsm100		! if AM == 0 then
		sethi	%hi(0x00ffffff),%g3
		or	%g3,%lo(0x00ffffff),%g3
		andn	%g7,0x10,%g7	!   reset AM-bit
		ba,a	.bsm1t1		!
    .bsm100:	sethi	%hi(0x1fffffff),%g3
		or	%g3,%lo(0x1fffffff),%g3
		or	%g7,0x10,%g7	! else set AM-bit
    .bsm1t1:	andn	%l0,%o1,%g2	! ##TEMPLATE:%l0
    .bsm1t2:	andn	%l0,%o1,%l0	! ##TEMPLATE:%l0,%l0
    .bsm1t3:	or	%l0,%o0,%l0	! ##TEMPLATE:%l0,%l0
		andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.bsm1e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.bsm1e:

	.section ".text"
	.align	4
	.global ci2_bassm,ti2_bassm
ci2_bassm:
	srl	%o1,16,%o3		! switch (R2)
	andcc	%o3,0xf,%g0		!
	bnz	.bassm1c		!
	nop				!
    .bassm0c:				!
	retl				! case 0:
	add	%g0,.bassm0e-.bassm0s,%o0
    .bassm1c:				!
	retl				! case not 0:
	add	%g0,.bassm1e-.bassm1s,%o0
ti2_bassm:
	srl	%o1,16,%o3		! switch (R2)
	andcc	%o3,0xf,%g0		!
	bnz	.bassm1t		!
	nop				!
    .bassm0t:				!
	sethi	%hi(.bassm0s),%o3	!
	or	%o3,%lo(.bassm0s),%o3	!
	or	%g0,.bassm0e-.bassm0s,%o4
    .bassm0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.bassm0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.bassm0t0-.bassm0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,25,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+.bassm0t0-.bassm0s]
	retl				!
	add	%o0,.bassm0e-.bassm0s,%o0
    .bassm1t:				!
	sethi	%hi(.bassm1s),%o3	!
	or	%o3,%lo(.bassm1s),%o3	!
	or	%g0,.bassm1e-.bassm1s,%o4
    .bassm1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.bassm1cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.bassm1t0-.bassm1s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	st	%o5,[%o0+.bassm1t0-.bassm1s]
	ld	[%o0+.bassm1t1-.bassm1s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,25,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+.bassm1t1-.bassm1s]
	retl				!
	add	%o0,.bassm1e-.bassm1s,%o0
.bassm0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x4,%g1	! CC=unchange & ILC=1
		add	%g2,0x2,%g2	! update IAR
		and	%g7,0x10,%o1	! extract AM-bit
		sll	%o1,27,%o1	!
		sethi	%hi(0x80000000),%o2
		andn	%g2,%o2,%o3	!
    .bassm0t0:	or	%o1,%o3,%l0	! ##TEMPLATE:%l0
		andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.bassm0e	!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.bassm0e:
.bassm1s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x4,%g1	! CC=unchange & ILC=1
		add	%g2,0x2,%g2	! update IAR
    .bassm1t0:	add	%g0,%l0,%o0	! ##TEMPLATE:%l0
		and	%g7,0x10,%o1	! extract AM-bit
		sll	%o1,27,%o1	!
		sethi	%hi(0x80000000),%o2
		andn	%g2,%o2,%o3	!
    .bassm1t1:	or	%o1,%o3,%l0	! ##TEMPLATE:%l0
		add	%g0,%o0,%g2	!
		andcc	%o0,%o2,%g0	!
		bnz	.bassm100	! if AM == 0 then
		sethi	%hi(0x00ffffff),%g3
		or	%g3,%lo(0x00ffffff),%g3
		andn	%g7,0x10,%g7	!   reset AM-bit
		ba,a	.bassm101	!
    .bassm100:	sethi	%hi(0x1fffffff),%g3
		or	%g3,%lo(0x1fffffff),%g3
		or	%g7,0x10,%g7	! else set AM-bit
    .bassm101:	andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.bassm1e	!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.bassm1e:

	.section ".text"
	.align	4
	.global ci2_basr,ti2_basr
ci2_basr:
	srl	%o1,16,%o3		! switch (R2)
	andcc	%o3,0xf,%g0		!
	bnz	.basr1c			!
	nop				!
    .basr0c:				!
	retl				! case 0:
	add	%g0,.basr0e-.basr0s,%o0 !
    .basr1c:				!
	retl				! case not 0:
	add	%g0,.basr1e-.basr1s,%o0 !
ti2_basr:
	srl	%o1,16,%o3		! switch (R2)
	andcc	%o3,0xf,%g0		!
	bnz	.basr1t			!
	nop				!
    .basr0t:				!
	sethi	%hi(.basr0s),%o3	!
	or	%o3,%lo(.basr0s),%o3	!
	or	%g0,.basr0e-.basr0s,%o4 !
    .basr0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.basr0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.basr0t0-.basr0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,25,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+.basr0t0-.basr0s]
	ld	[%o0+.basr0t1-.basr0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,25,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+.basr0t1-.basr0s]
	retl				!
	add	%o0,.basr0e-.basr0s,%o0 !
    .basr1t:				!
	sethi	%hi(.basr1s),%o3	!
	or	%o3,%lo(.basr1s),%o3	!
	or	%g0,.basr1e-.basr1s,%o4 !
    .basr1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.basr1cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.basr1t0-.basr1s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	st	%o5,[%o0+.basr1t0-.basr1s]
	ld	[%o0+.basr1t1-.basr1s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,25,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+.basr1t1-.basr1s]
	ld	[%o0+.basr1t2-.basr1s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,25,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+.basr1t2-.basr1s]
	retl				!
	add	%o0,.basr1e-.basr1s,%o0 !
.basr0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x4,%g1	! CC=unchange & ILC=1
		add	%g2,0x2,%g2	! update IAR
		andcc	%g7,0x10,%g0	! if AM == 0 then
		bnz	.basr000	!   24bit address
		sethi	%hi(0xff000000),%o1
		ba	.basr001	!
    .basr0t0:	andn	%g2,%o1,%l0	! ##TEMPLATE:%l0
    .basr000:	sethi	%hi(0x80000000),%o1
		andn	%g2,%o1,%o2	!   31bit address
    .basr0t1:	or	%o1,%o2,%l0	! ##TEMPLATE:%l0
    .basr001:	andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.basr0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.basr0e:
.basr1s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x4,%g1	! CC=unchange & ILC=1
		add	%g2,0x2,%g2	! update IAR
    .basr1t0:	add	%g0,%l0,%o0	! ##TEMPLATE:%l0
		andcc	%g7,0x10,%g0	! if AM == 0 then
		bnz	.basr100	!
		sethi	%hi(0xff000000),%o1
		ba	.basr101	!
    .basr1t1:	andn	%g2,%o1,%l0	! ##TEMPLATE:%l0
    .basr100:	sethi	%hi(0x80000000),%o1
		andn	%g2,%o1,%o2	!   31bit address
    .basr1t2:	or	%o1,%o2,%l0	! ##TEMPLATE:%l0
    .basr101:	add	%g0,%o0,%g2	!
		andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.basr1e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.basr1e:

	.section ".text"
	.align	4
	.global ci2_mvcl,ti2_mvcl
ci2_mvcl:
	srl	%o1,20,%o3		! switch (R1,R2)
	srl	%o1,16,%o4		!
	or	%o3,%o4,%o3		!
	andcc	%o3,1,%g0		!
	bnz	.mvcl2c			!
	subcc	%o5,0,%g0		! if (NON EXECUTE) then ILC=4
	bnz	.mvcl1c			! if (EXECUTE) then ILC=2
	nop				!
    .mvcl0c:				!
	retl				!
	add	%g0,.mvcl0e-.mvcl0s,%o0 !
    .mvcl1c:				!
	retl				!
	add	%g0,.mvcl1e-.mvcl1s,%o0 !
    .mvcl2c:				!
	retl				!
	add	%g0,.mvcl2e-.mvcl2s,%o0 !
ti2_mvcl:
	srl	%o1,20,%o3		! switch (R1,R2)
	srl	%o1,16,%o4		!
	or	%o3,%o4,%o3		!
	andcc	%o3,1,%g0		!
	bnz	.mvcl2t			!
	subcc	%o5,0,%g0		! if (NON EXECUTE) then ILC=4
	bnz	.mvcl1t			! if (EXECUTE) then ILC=2
	nop				!
    .mvcl0t:				!
	sethi	%hi(.mvcl0s),%o3	!
	or	%o3,%lo(.mvcl0s),%o3	!
	or	%g0,.mvcl0e-.mvcl0s,%o4 !
    .mvcl0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.mvcl0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.mvcl0t0-.mvcl0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+.mvcl0t0-.mvcl0s]
	ld	[%o0+.mvcl0t1-.mvcl0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+.mvcl0t1-.mvcl0s]
	ld	[%o0+.mvcl0t2-.mvcl0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1+1
	add	%o4,1,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+.mvcl0t2-.mvcl0s]
	ld	[%o0+.mvcl0t3-.mvcl0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2+1
	add	%o4,1,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+.mvcl0t3-.mvcl0s]
	ld	[%o0+.mvcl0t4-.mvcl0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2+1
	add	%o4,1,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+.mvcl0t4-.mvcl0s]
	ld	[%o0+.mvcl0t5-.mvcl0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,25,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+.mvcl0t5-.mvcl0s]
	ld	[%o0+.mvcl0t6-.mvcl0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,25,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+.mvcl0t6-.mvcl0s]
	ld	[%o0+.mvcl0t7-.mvcl0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1+1
	add	%o4,1,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	sll	%o4,11,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+.mvcl0t7-.mvcl0s]
	ld	[%o0+.mvcl0t8-.mvcl0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1+1
	add	%o4,1,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	sll	%o4,11,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+.mvcl0t8-.mvcl0s]
	ld	[%o0+.mvcl0t9-.mvcl0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2+1
	add	%o4,1,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	sll	%o4,11,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+.mvcl0t9-.mvcl0s]
	ld	[%o0+.mvcl0ta-.mvcl0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2+1
	add	%o4,1,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	sll	%o4,11,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+.mvcl0ta-.mvcl0s]
	retl				!
	add	%o0,.mvcl0e-.mvcl0s,%o0 !
    .mvcl1t:				!
	sethi	%hi(.mvcl1s),%o3	!
	or	%o3,%lo(.mvcl1s),%o3	!
	or	%g0,.mvcl1e-.mvcl1s,%o4 !
    .mvcl1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.mvcl1cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.mvcl1t0-.mvcl1s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+.mvcl1t0-.mvcl1s]
	ld	[%o0+.mvcl1t1-.mvcl1s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+.mvcl1t1-.mvcl1s]
	ld	[%o0+.mvcl1t2-.mvcl1s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1+1
	add	%o4,1,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+.mvcl1t2-.mvcl1s]
	ld	[%o0+.mvcl1t3-.mvcl1s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2+1
	add	%o4,1,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+.mvcl1t3-.mvcl1s]
	ld	[%o0+.mvcl1t4-.mvcl1s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2+1
	add	%o4,1,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+.mvcl1t4-.mvcl1s]
	ld	[%o0+.mvcl1t5-.mvcl1s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,25,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+.mvcl1t5-.mvcl1s]
	ld	[%o0+.mvcl1t6-.mvcl1s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,25,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+.mvcl1t6-.mvcl1s]
	ld	[%o0+.mvcl1t7-.mvcl1s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1+1
	add	%o4,1,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	sll	%o4,11,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+.mvcl1t7-.mvcl1s]
	ld	[%o0+.mvcl1t8-.mvcl1s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1+1
	add	%o4,1,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	sll	%o4,11,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+.mvcl1t8-.mvcl1s]
	ld	[%o0+.mvcl1t9-.mvcl1s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2+1
	add	%o4,1,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	sll	%o4,11,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+.mvcl1t9-.mvcl1s]
	ld	[%o0+.mvcl1ta-.mvcl1s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2+1
	add	%o4,1,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	sll	%o4,11,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+.mvcl1ta-.mvcl1s]
	retl				!
	add	%o0,.mvcl1e-.mvcl1s,%o0 !
    .mvcl2t:				!
	sethi	%hi(.mvcl2s),%o3	!
	or	%o3,%lo(.mvcl2s),%o3	!
	or	%g0,.mvcl2e-.mvcl2s,%o4 !
    .mvcl2cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.mvcl2cp		!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,.mvcl2e-.mvcl2s,%o0 !
.mvcl0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x4,%g1	! CC=unchange & ILC=1
		add	%g2,0x2,%g2	! update IAR
		andn	%g1,0x3,%g1	! CC=0 (interruptible)
    .mvcl0t0:	and	%l0,%g3,%o1	! ##TEMPLATE:%l0
    .mvcl0t1:	and	%l0,%g3,%o2	! ##TEMPLATE:%l0
		sethi	%hi(0xff000000),%o0
    .mvcl0t2:	andn	%l0,%o0,%o3	! ##TEMPLATE:%l0
    .mvcl0t3:	andn	%l0,%o0,%o4	! ##TEMPLATE:%l0
    .mvcl0loop:	/* MAIN LOOP */
    .mvcl0t4:	srl	%l0,24,%o5	! ##TEMPLATE:%l0

		sethi	%hi(il_mvcl),%o7!
		or	%o7,%lo(il_mvcl),%o7
		jmpl	%o7,%o7		! call library in intlib.s
		nop			!

    .mvcl0t5:	add	%g0,%o1,%l0	! ##TEMPLATE:%l0
    .mvcl0t6:	add	%g0,%o2,%l0	! ##TEMPLATE:%l0
		sethi	%hi(0xff000000),%o0
    .mvcl0t7:	and	%l0,%o0,%l0	! ##TEMPLATE:%l0,%l0
    .mvcl0t8:	or	%l0,%o3,%l0	! ##TEMPLATE:%l0,%l0
    .mvcl0t9:	and	%l0,%o0,%l0	! ##TEMPLATE:%l0,%l0
    .mvcl0ta:	or	%l0,%o4,%l0	! ##TEMPLATE:%l0,%l0
		and	%g1,0x3,%o0	!
		subcc	%o0,0x3,%g0	! if CC=3 then
		bz	.mvcl071	!   exit
		subcc	%o3,0,%g0	! if mvcl completed then
		bz	.mvcl071	!   exit
		andncc	%g7,0xfff,%g0	! if intermediate intr. then
		bnz,a	.mvcl070	!   exit
		sub	%g2,0x2,%g2	!   rewind IAR
		ba,a	.mvcl0loop	! continue
    .mvcl070:	sub	%g1,0x10,%g1	! case intermediate intr.
    .mvcl071:	andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.mvcl0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.mvcl0e:
.mvcl1s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x4,%g1	! CC=unchange & ILC=1
		add	%g2,0x2,%g2	! update IAR
		andn	%g1,0x3,%g1	! CC=0 (interruptible)
    .mvcl1t0:	and	%l0,%g3,%o1	! ##TEMPLATE:%l0
    .mvcl1t1:	and	%l0,%g3,%o2	! ##TEMPLATE:%l0
		sethi	%hi(0xff000000),%o0
    .mvcl1t2:	andn	%l0,%o0,%o3	! ##TEMPLATE:%l0
    .mvcl1t3:	andn	%l0,%o0,%o4	! ##TEMPLATE:%l0
    .mvcl1loop:	/* MAIN LOOP */
    .mvcl1t4:	srl	%l0,24,%o5	! ##TEMPLATE:%l0

		sethi	%hi(il_mvcl),%o7!
		or	%o7,%lo(il_mvcl),%o7
		jmpl	%o7,%o7		! call library in intlib.s
		nop			!

    .mvcl1t5:	add	%g0,%o1,%l0	! ##TEMPLATE:%l0
    .mvcl1t6:	add	%g0,%o2,%l0	! ##TEMPLATE:%l0
		sethi	%hi(0xff000000),%o0
    .mvcl1t7:	and	%l0,%o0,%l0	! ##TEMPLATE:%l0,%l0
    .mvcl1t8:	or	%l0,%o3,%l0	! ##TEMPLATE:%l0,%l0
    .mvcl1t9:	and	%l0,%o0,%l0	! ##TEMPLATE:%l0,%l0
    .mvcl1ta:	or	%l0,%o4,%l0	! ##TEMPLATE:%l0,%l0
		and	%g1,0x3,%o0	!
		subcc	%o0,0x3,%g0	! if CC=3 then
		bz	.mvcl171	!   exit
		subcc	%o3,0,%g0	! if mvcl completed then
		bz	.mvcl171	!   exit
		andncc	%g7,0xfff,%g0	! if intermediate intr. then
		bnz,a	.mvcl170	!   exit
		sub	%g2,0x4,%g2	!   rewind IAR
		ba,a	.mvcl1loop	! continue
    .mvcl170:	sub	%g1,0x10,%g1	! case intermediate intr.
    .mvcl171:	andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.mvcl1e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.mvcl1e:
.mvcl2s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x4,%g1	! CC=unchange & ILC=1
		add	%g2,0x2,%g2	! update IAR
		sethi	%hi(0x00060000),%o0
		or	%g7,%o0,%g7	! specification exception
		ba	.mvcl2e		! retuen(TEMPLATE)
		add	%g1,0x10,%g1	!
.mvcl2e:

	.section ".text"
	.align	4
	.global ci2_clcl,ti2_clcl
ci2_clcl:
	srl	%o1,20,%o3		! switch (R1,R2)
	srl	%o1,16,%o4		!
	or	%o3,%o4,%o3		!
	andcc	%o3,1,%g0		!
	bnz	.clcl2c			!
	subcc	%o5,0,%g0		! if (NON EXECUTE) then ILC=4
	bnz	.clcl1c			! if (EXECUTE) then ILC=2
	nop				!
    .clcl0c:				!
	retl				!
	add	%g0,.clcl0e-.clcl0s,%o0 !
    .clcl1c:				!
	retl				!
	add	%g0,.clcl1e-.clcl1s,%o0 !
    .clcl2c:				!
	retl				!
	add	%g0,.clcl2e-.clcl2s,%o0 !
ti2_clcl:
	srl	%o1,20,%o3		! switch (R1,R2)
	srl	%o1,16,%o4		!
	or	%o3,%o4,%o3		!
	andcc	%o3,1,%g0		!
	bnz	.clcl2t			!
	subcc	%o5,0,%g0		! if (NON EXECUTE) then ILC=4
	bnz	.clcl1t			! if (EXECUTE) then ILC=2
	nop				!
    .clcl0t:				!
	sethi	%hi(.clcl0s),%o3	!
	or	%o3,%lo(.clcl0s),%o3	!
	or	%g0,.clcl0e-.clcl0s,%o4 !
    .clcl0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.clcl0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.clcl0t0-.clcl0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+.clcl0t0-.clcl0s]
	ld	[%o0+.clcl0t1-.clcl0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+.clcl0t1-.clcl0s]
	ld	[%o0+.clcl0t2-.clcl0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1+1
	add	%o4,1,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+.clcl0t2-.clcl0s]
	ld	[%o0+.clcl0t3-.clcl0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2+1
	add	%o4,1,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+.clcl0t3-.clcl0s]
	ld	[%o0+.clcl0t4-.clcl0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2+1
	add	%o4,1,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+.clcl0t4-.clcl0s]
	ld	[%o0+.clcl0t5-.clcl0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,25,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+.clcl0t5-.clcl0s]
	ld	[%o0+.clcl0t6-.clcl0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,25,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+.clcl0t6-.clcl0s]
	ld	[%o0+.clcl0t7-.clcl0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1+1
	add	%o4,1,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	sll	%o4,11,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+.clcl0t7-.clcl0s]
	ld	[%o0+.clcl0t8-.clcl0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1+1
	add	%o4,1,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	sll	%o4,11,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+.clcl0t8-.clcl0s]
	ld	[%o0+.clcl0t9-.clcl0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2+1
	add	%o4,1,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	sll	%o4,11,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+.clcl0t9-.clcl0s]
	ld	[%o0+.clcl0ta-.clcl0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2+1
	add	%o4,1,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	sll	%o4,11,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+.clcl0ta-.clcl0s]
	retl				!
	add	%o0,.clcl0e-.clcl0s,%o0 !
    .clcl1t:				!
	sethi	%hi(.clcl1s),%o3	!
	or	%o3,%lo(.clcl1s),%o3	!
	or	%g0,.clcl1e-.clcl1s,%o4 !
    .clcl1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.clcl1cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.clcl1t0-.clcl1s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+.clcl1t0-.clcl1s]
	ld	[%o0+.clcl1t1-.clcl1s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+.clcl1t1-.clcl1s]
	ld	[%o0+.clcl1t2-.clcl1s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1+1
	add	%o4,1,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+.clcl1t2-.clcl1s]
	ld	[%o0+.clcl1t3-.clcl1s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2+1
	add	%o4,1,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+.clcl1t3-.clcl1s]
	ld	[%o0+.clcl1t4-.clcl1s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2+1
	add	%o4,1,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+.clcl1t4-.clcl1s]
	ld	[%o0+.clcl1t5-.clcl1s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,25,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+.clcl1t5-.clcl1s]
	ld	[%o0+.clcl1t6-.clcl1s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,25,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+.clcl1t6-.clcl1s]
	ld	[%o0+.clcl1t7-.clcl1s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1+1
	add	%o4,1,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	sll	%o4,11,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+.clcl1t7-.clcl1s]
	ld	[%o0+.clcl1t8-.clcl1s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1+1
	add	%o4,1,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	sll	%o4,11,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+.clcl1t8-.clcl1s]
	ld	[%o0+.clcl1t9-.clcl1s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2+1
	add	%o4,1,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	sll	%o4,11,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+.clcl1t9-.clcl1s]
	ld	[%o0+.clcl1ta-.clcl1s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2+1
	add	%o4,1,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	sll	%o4,11,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+.clcl1ta-.clcl1s]
	retl				!
	add	%o0,.clcl1e-.clcl1s,%o0 !
    .clcl2t:				!
	sethi	%hi(.clcl2s),%o3	!
	or	%o3,%lo(.clcl2s),%o3	!
	or	%g0,.clcl2e-.clcl2s,%o4 !
    .clcl2cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.clcl2cp		!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,.clcl2e-.clcl2s,%o0 !
.clcl0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x4,%g1	! CC=unchange & ILC=1
		add	%g2,0x2,%g2	! update IAR
		andn	%g1,0x3,%g1	! CC=0 (interruptible)
    .clcl0t0:	and	%l0,%g3,%o1	! ##TEMPLATE:%l0
    .clcl0t1:	and	%l0,%g3,%o2	! ##TEMPLATE:%l0
		sethi	%hi(0xff000000),%o0
    .clcl0t2:	andn	%l0,%o0,%o3	! ##TEMPLATE:%l0
    .clcl0t3:	andn	%l0,%o0,%o4	! ##TEMPLATE:%l0
    .clcl0loop:	/* MAIN LOOP */
    .clcl0t4:	srl	%l0,24,%o5	! ##TEMPLATE:%l0

		sethi	%hi(il_clcl),%o7!
		or	%o7,%lo(il_clcl),%o7
		jmpl	%o7,%o7		! call library in intlib.s
		nop			!

    .clcl0t5:	add	%g0,%o1,%l0	! ##TEMPLATE:%l0
    .clcl0t6:	add	%g0,%o2,%l0	! ##TEMPLATE:%l0
		sethi	%hi(0xff000000),%o0
    .clcl0t7:	and	%l0,%o0,%l0	! ##TEMPLATE:%l0,%l0
    .clcl0t8:	or	%l0,%o3,%l0	! ##TEMPLATE:%l0,%l0
    .clcl0t9:	and	%l0,%o0,%l0	! ##TEMPLATE:%l0,%l0
    .clcl0ta:	or	%l0,%o4,%l0	! ##TEMPLATE:%l0,%l0
		andcc	%g1,0x3,%o0	! if CC!=0 then
		bnz	.clcl071	!   exit
		orcc	%o3,%o4,%g0	! if clcl completed then
		bz	.clcl071	!   exit
		andncc	%g7,0xfff,%g0	! if intermediate intr. then
		bnz,a	.clcl070	!   exit
		sub	%g2,0x2,%g2	!   rewind IAR
		ba,a	.clcl0loop	! continue
    .clcl070:	sub	%g1,0x10,%g1	! case intermediate intr.
    .clcl071:	andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.clcl0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.clcl0e:
.clcl1s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x4,%g1	! CC=unchange & ILC=1
		add	%g2,0x2,%g2	! update IAR
		andn	%g1,0x3,%g1	! CC=0 (interruptible)
    .clcl1t0:	and	%l0,%g3,%o1	! ##TEMPLATE:%l0
    .clcl1t1:	and	%l0,%g3,%o2	! ##TEMPLATE:%l0
		sethi	%hi(0xff000000),%o0
    .clcl1t2:	andn	%l0,%o0,%o3	! ##TEMPLATE:%l0
    .clcl1t3:	andn	%l0,%o0,%o4	! ##TEMPLATE:%l0
    .clcl1loop:	/* MAIN LOOP */
    .clcl1t4:	srl	%l0,24,%o5	! ##TEMPLATE:%l0

		sethi	%hi(il_clcl),%o7!
		or	%o7,%lo(il_clcl),%o7
		jmpl	%o7,%o7		! call library in intlib.s
		nop			!

    .clcl1t5:	add	%g0,%o1,%l0	! ##TEMPLATE:%l0
    .clcl1t6:	add	%g0,%o2,%l0	! ##TEMPLATE:%l0
		sethi	%hi(0xff000000),%o0
    .clcl1t7:	and	%l0,%o0,%l0	! ##TEMPLATE:%l0,%l0
    .clcl1t8:	or	%l0,%o3,%l0	! ##TEMPLATE:%l0,%l0
    .clcl1t9:	and	%l0,%o0,%l0	! ##TEMPLATE:%l0,%l0
    .clcl1ta:	or	%l0,%o4,%l0	! ##TEMPLATE:%l0,%l0
		andcc	%g1,0x3,%o0	! if CC!=0 then
		bnz	.clcl171	!   exit
		orcc	%o3,%o4,%g0	! if clcl completed then
		bz	.clcl171	!   exit
		andncc	%g7,0xfff,%g0	! if intermediate intr. then
		bnz,a	.clcl170	!   exit
		sub	%g2,0x4,%g2	!   rewind IAR
		ba,a	.clcl1loop	! continue
    .clcl170:	sub	%g1,0x10,%g1	! case intermediate intr.
    .clcl171:	andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.clcl1e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.clcl1e:
.clcl2s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x4,%g1	! CC=unchange & ILC=1
		add	%g2,0x2,%g2	! update IAR
		sethi	%hi(0x00060000),%o0
		or	%g7,%o0,%g7	! specification exception
		ba	.clcl2e		! retuen(TEMPLATE)
		add	%g1,0x10,%g1	!
.clcl2e:
!================================

!
! templates
! cxx_xxx:
!   %o0: param: none
!	 retval:size of template
!   %o1: M instruction (upper 2 bytes)
!   %o2: work
!   %o3: work
!   %o4: work
!   %o5: flag(0:NON EXECUTE,1:EXECUTE)
! txx_xxx:
!   %o0: param: bufp start address
!	 retval:bufp next start address
!   %o1: M instruction (upper 2 bytes)
!   %o2: work
!   %o3: work
!   %o4: work
!   %o5: flag(0:NON EXECUTE,1:EXECUTE)
!
	.section ".text"
	.align	4
	.global ci2_lpr,ti2_lpr
ci2_lpr:
	retl				!
	add	%g0,.lpr0e-.lpr0s,%o0	!
ti2_lpr:
	sethi	%hi(.lpr0s),%o3		!
	or	%o3,%lo(.lpr0s),%o3	!
	or	%g0,.lpr0e-.lpr0s,%o4	!
    .lpr0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.lpr0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.lpr0t0-.lpr0s],%o5!
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,25,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+.lpr0t0-.lpr0s]!
	ld	[%o0+.lpr0t1-.lpr0s],%o5!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R2
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	sll	%o4,25,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+.lpr0t1-.lpr0s]!
	retl				!
	add	%o0,.lpr0e-.lpr0s,%o0	!
.lpr0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x4,%g1	! CC=unchange & ILC=1
		add	%g2,0x2,%g2	! update IAR
		andn	%g1,0x3,%g1	! CC=0
    .lpr0t0:	addcc	%g0,%l0,%l0	! ##TEMPLATE:%l0,%l0
		bl,a	.lpr000		! if %l0 < 0 then negate;
    .lpr0t1:	subcc	%g0,%l0,%l0	! ##TEMPLATE:%l0,%l0
    .lpr000:	bnz,a	.lpr001		! if %l0 !=0 then
		or	%g1,0x2,%g1	!   CC=2
    .lpr001:	bvc	.lpr002		! if overflow then
		andcc	%g7,8,%g0	!   CC=3
		bz	.lpr002		!   if fixed-point overflow mask then
		or	%g1,0x3,%g1	!
		sethi	%hi(0x00080000),%o0
		or	%g7,%o0,%g7	!     fixed-point overflow
    .lpr002:	andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.lpr0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.lpr0e:

	.section ".text"
	.align	4
	.global ci2_lnr,ti2_lnr
ci2_lnr:
	retl				!
	add	%g0,.lnr0e-.lnr0s,%o0	!
ti2_lnr:
	sethi	%hi(.lnr0s),%o3		!
	or	%o3,%lo(.lnr0s),%o3	!
	or	%g0,.lnr0e-.lnr0s,%o4	!
    .lnr0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.lnr0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.lnr0t0-.lnr0s],%o5!
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,25,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+.lnr0t0-.lnr0s]!
	ld	[%o0+.lnr0t1-.lnr0s],%o5!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R2
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	sll	%o4,25,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+.lnr0t1-.lnr0s]!
	retl				!
	add	%o0,.lnr0e-.lnr0s,%o0	!
.lnr0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x4,%g1	! CC=unchange & ILC=1
		add	%g2,0x2,%g2	! update IAR
		andn	%g1,0x3,%g1	! CC=0
    .lnr0t0:	addcc	%g0,%l0,%l0	! ##TEMPLATE:%l0,%l0
		bg,a	.lnr000		! if %l0 > 0 then negate
    .lnr0t1:	subcc	%g0,%l0,%l0	! ##TEMPLATE:%l0,%l0
    .lnr000:	bnz,a	.lnr001		! if %l0 !=0 then
		or	%g1,0x1,%g1	!   CC=1
    .lnr001:	andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.lnr0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.lnr0e:

	.section ".text"
	.align	4
	.global ci2_ltr,ti2_ltr
ci2_ltr:
	retl				!
	add	%g0,.ltr0e-.ltr0s,%o0	!
ti2_ltr:
	sethi	%hi(.ltr0s),%o3		!
	or	%o3,%lo(.ltr0s),%o3	!
	or	%g0,.ltr0e-.ltr0s,%o4	!
    .ltr0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.ltr0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.ltr0t0-.ltr0s],%o5!
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,25,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+.ltr0t0-.ltr0s]!
	retl				!
	add	%o0,.ltr0e-.ltr0s,%o0	!
.ltr0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x4,%g1	! CC=unchange & ILC=1
		add	%g2,0x2,%g2	! update IAR
		andn	%g1,0x3,%g1	! CC=0
    .ltr0t0:	addcc	%g0,%l0,%l0	! ##TEMPLATE:%l0,%l0
		bg,a	.ltr001		! if %l0 > 0 then
		or	%g1,0x2,%g1	!   CC=2
		bl,a	.ltr001		! if %l0 < 0 then
		or	%g1,0x1,%g1	!   CC=1
    .ltr001:	andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.ltr0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.ltr0e:

	.section ".text"
	.align	4
	.global ci2_lcr,ti2_lcr
ci2_lcr:
	retl				!
	add	%g0,.lcr0e-.lcr0s,%o0	!
ti2_lcr:
	sethi	%hi(.lcr0s),%o3		!
	or	%o3,%lo(.lcr0s),%o3	!
	or	%g0,.lcr0e-.lcr0s,%o4	!
    .lcr0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.lcr0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.lcr0t0-.lcr0s],%o5!
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,25,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+.lcr0t0-.lcr0s]!
	retl				!
	add	%o0,.lcr0e-.lcr0s,%o0	!
.lcr0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x4,%g1	! CC=unchange & ILC=1
		add	%g2,0x2,%g2	! update IAR
		andn	%g1,0x3,%g1	! CC=0
    .lcr0t0:	subcc	%g0,%l0,%l0	! ##TEMPLATE:%l0,%l0
		bvc	.lcr000		! if overflow then
		nop			!
		andcc	%g7,8,%g0	!   CC=3
		bz	.lcr002		!   if fixed-point overflow mask then
		or	%g1,0x3,%g1	!
		sethi	%hi(0x00080000),%o0
		ba	.lcr002		!
		or	%g7,%o0,%g7	!     fixed-point overflow
    .lcr000:	bg,a	.lcr002		! if %l0 > 0 then
		or	%g1,0x2,%g1	!   CC=2
		bl,a	.lcr002		! if %l0 < 0 then
		or	%g1,0x1,%g1	!   CC=1
    .lcr002:	andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.lcr0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.lcr0e:

	.section ".text"
	.align	4
	.global ci2_nr,ti2_nr
ci2_nr:
	retl				!
	add	%g0,.nr0e-.nr0s,%o0	!
ti2_nr:
	sethi	%hi(.nr0s),%o3		!
	or	%o3,%lo(.nr0s),%o3	!
	or	%g0,.nr0e-.nr0s,%o4	!
    .nr0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.nr0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.nr0t0-.nr0s],%o5	!
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	sll	%o4,11,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+.nr0t0-.nr0s]	!
	retl				!
	add	%o0,.nr0e-.nr0s,%o0	!
.nr0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x4,%g1	! CC=unchange & ILC=1
		add	%g2,0x2,%g2	! update IAR
		andn	%g1,0x3,%g1	! CC=0
    .nr0t0:	andcc	%l0,%l0,%l0	! ##TEMPLATE:%l0,%l0,%l0
		bnz,a	.nr000		! if %l0 != 0 then
		or	%g1,0x1,%g1	!   CC=1
    .nr000:	andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.nr0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.nr0e:

	.section ".text"
	.align	4
	.global ci2_clr,ti2_clr
ci2_clr:
	retl				!
	add	%g0,.clr0e-.clr0s,%o0	!
ti2_clr:
	sethi	%hi(.clr0s),%o3		!
	or	%o3,%lo(.clr0s),%o3	!
	or	%g0,.clr0e-.clr0s,%o4	!
    .clr0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.clr0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.clr0t0-.clr0s],%o5!
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+.clr0t0-.clr0s]!
	retl				!
	add	%o0,.clr0e-.clr0s,%o0	!
.clr0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x4,%g1	! CC=unchange & ILC=1
		add	%g2,0x2,%g2	! update IAR
		andn	%g1,0x3,%g1	! CC=0
    .clr0t0:	subcc	%l0,%l0,%g0	! ##TEMPLATE:%l0,%l0
		bgu,a	.clr001		! if %l0 > 0 then
		or	%g1,0x2,%g1	!   CC=2
		bcs,a	.clr001		! if %l0 < 0 then
		or	%g1,0x1,%g1	!   CC=1
    .clr001:	andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.clr0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.clr0e:

	.section ".text"
	.align	4
	.global ci2_or,ti2_or
ci2_or:
	retl				!
	add	%g0,.or0e-.or0s,%o0	!
ti2_or:
	sethi	%hi(.or0s),%o3		!
	or	%o3,%lo(.or0s),%o3	!
	or	%g0,.or0e-.or0s,%o4	!
    .or0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.or0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.or0t0-.or0s],%o5	!
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	sll	%o4,11,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+.or0t0-.or0s]	!
	retl				!
	add	%o0,.or0e-.or0s,%o0	!
.or0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x4,%g1	! CC=unchange & ILC=1
		add	%g2,0x2,%g2	! update IAR
		andn	%g1,0x3,%g1	! CC=0
    .or0t0:	orcc	%l0,%l0,%l0	! ##TEMPLATE:%l0,%l0,%l0
		bnz,a	.or000		! if %l0 != 0 then
		or	%g1,0x1,%g1	!   CC=1
    .or000:	andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.or0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.or0e:

	.section ".text"
	.align	4
	.global ci2_xr,ti2_xr
ci2_xr:
	retl				!
	add	%g0,.xr0e-.xr0s,%o0	!
ti2_xr:
	sethi	%hi(.xr0s),%o3		!
	or	%o3,%lo(.xr0s),%o3	!
	or	%g0,.xr0e-.xr0s,%o4	!
    .xr0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.xr0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.xr0t0-.xr0s],%o5	!
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	sll	%o4,11,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+.xr0t0-.xr0s]	!
	retl				!
	add	%o0,.xr0e-.xr0s,%o0	!
.xr0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x4,%g1	! CC=unchange & ILC=1
		add	%g2,0x2,%g2	! update IAR
		andn	%g1,0x3,%g1	! CC=0
    .xr0t0:	xorcc	%l0,%l0,%l0	! ##TEMPLATE:%l0,%l0,%l0
		bnz,a	.xr000		! if %l0 != 0 then
		or	%g1,0x1,%g1	!   CC=1
    .xr000:	andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.xr0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.xr0e:

	.section ".text"
	.align	4
	.global ci2_lr,ti2_lr
ci2_lr:
	retl				!
	add	%g0,.lr0e-.lr0s,%o0	!
ti2_lr:
	sethi	%hi(.lr0s),%o3		!
	or	%o3,%lo(.lr0s),%o3	!
	or	%g0,.lr0e-.lr0s,%o4	!
    .lr0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.lr0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.lr0t0-.lr0s],%o5	!
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,25,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+.lr0t0-.lr0s]	!
	retl				!
	add	%o0,.lr0e-.lr0s,%o0	!
.lr0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x4,%g1	! CC=unchange & ILC=1
		add	%g2,0x2,%g2	! update IAR
    .lr0t0:	add	%g0,%l0,%l0	! ##TEMPLATE:%l0,%l0
		andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.lr0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.lr0e:

	.section ".text"
	.align	4
	.global ci2_cr,ti2_cr
ci2_cr:
	retl				!
	add	%g0,.cr0e-.cr0s,%o0	!
ti2_cr:
	sethi	%hi(.cr0s),%o3		!
	or	%o3,%lo(.cr0s),%o3	!
	or	%g0,.cr0e-.cr0s,%o4	!
    .cr0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.cr0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.cr0t0-.cr0s],%o5	!
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+.cr0t0-.cr0s]	!
	retl				!
	add	%o0,.cr0e-.cr0s,%o0	!
.cr0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x4,%g1	! CC=unchange & ILC=1
		add	%g2,0x2,%g2	! update IAR
		andn	%g1,0x3,%g1	! CC=0
    .cr0t0:	subcc	%l0,%l0,%g0	! ##TEMPLATE:%l0,%l0
		bg,a	.cr001		! if %l0 > 0 then
		or	%g1,0x2,%g1	!   CC=2
		bl,a	.cr001		! if %l0 < 0 then
		or	%g1,0x1,%g1	!   CC=1
    .cr001:	andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.cr0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.cr0e:

	.section ".text"
	.align	4
	.global ci2_ar,ti2_ar
ci2_ar:
	retl				!
	add	%g0,.ar0e-.ar0s,%o0	!
ti2_ar:
	sethi	%hi(.ar0s),%o3		!
	or	%o3,%lo(.ar0s),%o3	!
	or	%g0,.ar0e-.ar0s,%o4	!
    .ar0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.ar0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.ar0t0-.ar0s],%o5	!
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	sll	%o4,11,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+.ar0t0-.ar0s]	!
	retl				!
	add	%o0,.ar0e-.ar0s,%o0	!
.ar0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x4,%g1	! CC=unchange & ILC=1
		add	%g2,0x2,%g2	! update IAR
		andn	%g1,0x3,%g1	! CC=0
    .ar0t0:	addcc	%l0,%l0,%l0	! ##TEMPLATE:%l0,%l0,%l0
		bvc	.ar000		! if overflow then
		nop			!
		andcc	%g7,8,%g0	!   CC=3
		bz	.ar002		!   if fixed-point overflow mask then
		or	%g1,0x3,%g1	!
		sethi	%hi(0x00080000),%o0
		ba	.ar002		!
		or	%g7,%o0,%g7	!     fixed-point overflow
    .ar000:	bg,a	.ar002		! if %l0 > 0 then
		or	%g1,0x2,%g1	!   CC=2
		bl,a	.ar002		! if %l0 < 0 then
		or	%g1,0x1,%g1	!   CC=1
    .ar002:	andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.ar0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.ar0e:

	.section ".text"
	.align	4
	.global ci2_sr,ti2_sr
ci2_sr:
	retl				!
	add	%g0,.sr0e-.sr0s,%o0	!
ti2_sr:
	sethi	%hi(.sr0s),%o3		!
	or	%o3,%lo(.sr0s),%o3	!
	or	%g0,.sr0e-.sr0s,%o4	!
    .sr0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.sr0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.sr0t0-.sr0s],%o5	!
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	sll	%o4,11,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+.sr0t0-.sr0s]	!
	retl				!
	add	%o0,.sr0e-.sr0s,%o0	!
.sr0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x4,%g1	! CC=unchange & ILC=1
		add	%g2,0x2,%g2	! update IAR
		andn	%g1,0x3,%g1	! CC=0
    .sr0t0:	subcc	%l0,%l0,%l0	! ##TEMPLATE:%l0,%l0,%l0
		bvc	.sr000		! if overflow then
		nop			!
		andcc	%g7,8,%g0	!   CC=3
		bz	.sr002		!   if fixed-point overflow mask then
		or	%g1,0x3,%g1	!
		sethi	%hi(0x00080000),%o0
		ba	.sr002		!
		or	%g7,%o0,%g7	!     fixed-point overflow
    .sr000:	bg,a	.sr002		! if %l0 > 0 then
		or	%g1,0x2,%g1	!   CC=2
		bl,a	.sr002		! if %l0 < 0 then
		or	%g1,0x1,%g1	!   CC=1
    .sr002:	andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.sr0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.sr0e:

	.section ".text"
	.align	4
	.global ci2_mr,ti2_mr
ci2_mr:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	.mr1c			!
	nop				!
    .mr0c:				!
	retl				! case even:
	add	%g0,.mr0e-.mr0s,%o0	!
    .mr1c:				!
	retl				! case odd:
	add	%g0,.mr1e-.mr1s,%o0	!   specification exception
ti2_mr:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	.mr1t			!
	nop				!
    .mr0t:				!
	sethi	%hi(.mr0s),%o3		!
	or	%o3,%lo(.mr0s),%o3	!
	or	%g0,.mr0e-.mr0s,%o4	!
    .mr0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.mr0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.mr0t0-.mr0s],%o5	!
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1+1
	add	%o4,1,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	sll	%o4,11,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+.mr0t0-.mr0s]	!
	ld	[%o0+.mr0t1-.mr0s],%o5	!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,25,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+.mr0t1-.mr0s]	!
	retl				!
	add	%o0,.mr0e-.mr0s,%o0	!
    .mr1t:				!
	sethi	%hi(.mr1s),%o3		!
	or	%o3,%lo(.mr1s),%o3	!
	or	%g0,.mr1e-.mr1s,%o4	!
    .mr1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.mr1cp			!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,.mr1e-.mr1s,%o0	!
.mr0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x4,%g1	! CC=unchange & ILC=1
		add	%g2,0x2,%g2	! update IAR
    .mr0t0:	smul	%l0,%l0,%l0	! ##TEMPLATE:%l0,%l0,%l0
    .mr0t1:	rd	%y,%l0		! ##TEMPLATE:%l0
		andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.mr0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.mr0e:
.mr1s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x4,%g1	! CC=unchange & ILC=1
		add	%g2,0x2,%g2	! update IAR
		sethi	%hi(0x00060000),%o0
		or	%g7,%o0,%g7	! specification exception
		ba	.mr1e		! retuen(TEMPLATE)
		add	%g1,0x10,%g1	!
.mr1e:

	.section ".text"
	.align	4
	.global ci2_dr,ti2_dr
ci2_dr:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	.dr1c			!
	nop				!
    .dr0c:				!
	retl				! case even:
	add	%g0,.dr0e-.dr0s,%o0	!
    .dr1c:				!
	retl				! case odd:
	add	%g0,.dr1e-.dr1s,%o0	!   specification exception
ti2_dr:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	.dr1t			!
	nop				!
    .dr0t:				!
	sethi	%hi(.dr0s),%o3		!
	or	%o3,%lo(.dr0s),%o3	!
	or	%g0,.dr0e-.dr0s,%o4	!
    .dr0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.dr0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.dr0t0-.dr0s],%o5	!
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	st	%o5,[%o0+.dr0t0-.dr0s]	!
	ld	[%o0+.dr0t1-.dr0s],%o5	!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	st	%o5,[%o0+.dr0t1-.dr0s]	!
	ld	[%o0+.dr0t2-.dr0s],%o5	!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1+1
	add	%o4,1,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	st	%o5,[%o0+.dr0t2-.dr0s]	!
	ld	[%o0+.dr0t3-.dr0s],%o5	!
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	st	%o5,[%o0+.dr0t3-.dr0s]	!
	ld	[%o0+.dr0t4-.dr0s],%o5	!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1+1
	add	%o4,1,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,25,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+.dr0t4-.dr0s]	!
	ld	[%o0+.dr0t5-.dr0s],%o5	!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1+1
	add	%o4,1,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,25,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+.dr0t5-.dr0s]	!
	retl				!
	add	%o0,.dr0e-.dr0s,%o0	!
    .dr1t:				!
	sethi	%hi(.dr1s),%o3		!
	or	%o3,%lo(.dr1s),%o3	!
	or	%g0,.dr1e-.dr1s,%o4	!
    .dr1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.dr1cp			!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,.dr1e-.dr1s,%o0	!
.dr0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x4,%g1	! CC=unchange & ILC=1
		add	%g2,0x2,%g2	! update IAR
    .dr0t0:	addcc	%g0,%l0,%g0	! ##TEMPLATE:%l0     R2
		bz	.dr000		! if R2==0 then int-div. exception
    .dr0t1:	wr	%g0,%l0,%y	! ##TEMPLATE:%l0     R1
    .dr0t2:	sdivcc	%l0,%l0,%o1	! ##TEMPLATE:%l0,%l0 R1+1,R2
		bvs	.dr000		! if overflow then int-div.
    .dr0t3:	smul	%o1,%l0,%o2	! ##TEMPLATE:%l0     R2
    .dr0t4:	sub	%l0,%o2,%l0	! ##TEMPLATE:%l0,%l0 R1+1,R1
		ba	.dr001		!
    .dr0t5:	add	%g0,%o1,%l0	! ##TEMPLATE:%l0     R1+1
    .dr000:	sethi	%hi(0x00090000),%o0
		or	%g7,%o0,%g7	! int-div. exception
    .dr001:	andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.dr0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.dr0e:
.dr1s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x4,%g1	! CC=unchange & ILC=1
		add	%g2,0x2,%g2	! update IAR
		sethi	%hi(0x00060000),%o0
		or	%g7,%o0,%g7	! specification exception
		ba	.dr1e		! retuen(TEMPLATE)
		add	%g1,0x10,%g1	!
.dr1e:

	.section ".text"
	.align	4
	.global ci2_alr,ti2_alr
ci2_alr:
	retl				!
	add	%g0,.alr0e-.alr0s,%o0	!
ti2_alr:
	sethi	%hi(.alr0s),%o3		!
	or	%o3,%lo(.alr0s),%o3	!
	or	%g0,.alr0e-.alr0s,%o4	!
    .alr0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.alr0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.alr0t0-.alr0s],%o5!
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	sll	%o4,11,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+.alr0t0-.alr0s]!
	retl				!
	add	%o0,.alr0e-.alr0s,%o0	!
.alr0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x4,%g1	! CC=unchange & ILC=1
		add	%g2,0x2,%g2	! update IAR
		andn	%g1,0x3,%g1	! CC=0
    .alr0t0:	addcc	%l0,%l0,%l0	! ##TEMPLATE:%l0,%l0,%l0
		bcs,a	.alr000		! if carry then
		or	%g1,0x2,%g1	!   CC|=2 & skip
		bnz,a	.alr001		! if %l0 != 0 then
		or	%g1,0x1,%g1	!   CC=1
		ba	.alr001		!
		nop			!
    .alr000:	bnz,a	.alr001		! if %l0 != 0 then
		or	%g1,0x1,%g1	!   CC=3
    .alr001:	andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.alr0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.alr0e:

	.section ".text"
	.align	4
	.global ci2_slr,ti2_slr
ci2_slr:
	retl				!
	add	%g0,.slr0e-.slr0s,%o0	!
ti2_slr:
	sethi	%hi(.slr0s),%o3		!
	or	%o3,%lo(.slr0s),%o3	!
	or	%g0,.slr0e-.slr0s,%o4	!
    .slr0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.slr0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.slr0t0-.slr0s],%o5!
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	sll	%o4,11,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+.slr0t0-.slr0s]!
	retl				!
	add	%o0,.slr0e-.slr0s,%o0	!
.slr0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x4,%g1	! CC=unchange & ILC=1
		add	%g2,0x2,%g2	! update IAR
		andn	%g1,0x3,%g1	! CC=0
    .slr0t0:	subcc	%l0,%l0,%l0	! ##TEMPLATE:%l0,%l0,%l0
		bcc,a	.slr000		! if !carry then
		or	%g1,0x2,%g1	!   CC|=2 & skip
		bnz,a	.slr001		! if %l0 != 0 then
		or	%g1,0x1,%g1	!   CC=1
		ba	.slr001		!
		nop			!
    .slr000:	bnz,a	.slr001		! if %l0 != 0 then
		or	%g1,0x1,%g1	!   CC=3
    .slr001:	andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.slr0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.slr0e:
!================================

!
! templates
! cxx_xxx:
!   %o0: param: none
!	 retval:size of template
!   %o1: M instruction (upper 2 bytes)
!   %o2: work
!   %o3: work
!   %o4: work
!   %o5: flag(0:NON EXECUTE,1:EXECUTE)
! txx_xxx:
!   %o0: param: bufp start address
!	 retval:bufp next start address
!   %o1: M instruction (upper 2 bytes)
!   %o2: work
!   %o3: work
!   %o4: work
!   %o5: flag(0:NON EXECUTE,1:EXECUTE)
!
	.section ".text"
	.align	4
	.global cf2_lpdr,tf2_lpdr
cf2_lpdr:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	.lpdr1c			!
	nop				!
    .lpdr0c:				!
	retl				! case even:
	add	%g0,.lpdr0e-.lpdr0s,%o0 !
    .lpdr1c:				!
	retl				! case odd:
	add	%g0,.lpdr1e-.lpdr1s,%o0 !   specification exception
tf2_lpdr:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	.lpdr1t			!
	nop				!
    .lpdr0t:				!
	sethi	%hi(.lpdr0s),%o3	!
	or	%o3,%lo(.lpdr0s),%o3	!
	or	%g0,.lpdr0e-.lpdr0s,%o4 !
    .lpdr0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.lpdr0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.lpdr0t0-.lpdr0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+.lpdr0t0-.lpdr0s]
	ld	[%o0+.lpdr0t1-.lpdr0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+.lpdr0t1-.lpdr0s]
	retl				!
	add	%o0,.lpdr0e-.lpdr0s,%o0 !
    .lpdr1t:				!
	sethi	%hi(.lpdr1s),%o3	!
	or	%o3,%lo(.lpdr1s),%o3	!
	or	%g0,.lpdr1e-.lpdr1s,%o4 !
    .lpdr1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.lpdr1cp		!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,.lpdr1e-.lpdr1s,%o0 !
.lpdr0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x4,%g1	! CC=unchange & ILC=1
		add	%g2,0x2,%g2	! update IAR
		ld	[%sp+92],%o7	! struct *guest
		andn	%g1,0x3,%g1	! CC=0
    .lpdr0t0:	ldd	[%o7+64],%o0	! ##TEMPLATE:%imm
		sethi	%hi(0x80000000),%o2
		andn	%o0,%o2,%o0	! set sign
		sll	%o0,8,%o2	!
		orcc	%o2,%o1,%g0	! if fraction == 0 then
		bnz,a	.lpdr0t1	!      CC=0
		or	%g1,0x2,%g1	! else CC=2
    .lpdr0t1:	std	%o0,[%o7+64]	! ##TEMPLATE:%imm
		andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.lpdr0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.lpdr0e:
.lpdr1s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x4,%g1	! CC=unchange & ILC=1
		add	%g2,0x2,%g2	! update IAR
		sethi	%hi(0x00060000),%o0
		or	%g7,%o0,%g7	! specification exception
		ba	.lpdr1e		! retuen(TEMPLATE)
		add	%g1,0x10,%g1	!
.lpdr1e:

	.section ".text"
	.align	4
	.global cf2_lndr,tf2_lndr
cf2_lndr:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	.lndr1c			!
	nop				!
    .lndr0c:				!
	retl				! case even:
	add	%g0,.lndr0e-.lndr0s,%o0 !
    .lndr1c:				!
	retl				! case odd:
	add	%g0,.lndr1e-.lndr1s,%o0 !   specification exception
tf2_lndr:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	.lndr1t			!
	nop				!
    .lndr0t:				!
	sethi	%hi(.lndr0s),%o3	!
	or	%o3,%lo(.lndr0s),%o3	!
	or	%g0,.lndr0e-.lndr0s,%o4 !
    .lndr0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.lndr0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.lndr0t0-.lndr0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+.lndr0t0-.lndr0s]
	ld	[%o0+.lndr0t1-.lndr0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+.lndr0t1-.lndr0s]
	retl				!
	add	%o0,.lndr0e-.lndr0s,%o0 !
    .lndr1t:				!
	sethi	%hi(.lndr1s),%o3	!
	or	%o3,%lo(.lndr1s),%o3	!
	or	%g0,.lndr1e-.lndr1s,%o4 !
    .lndr1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.lndr1cp		!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,.lndr1e-.lndr1s,%o0 !
.lndr0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x4,%g1	! CC=unchange & ILC=1
		add	%g2,0x2,%g2	! update IAR
		ld	[%sp+92],%o7	! struct *guest
		andn	%g1,0x3,%g1	! CC=0
    .lndr0t0:	ldd	[%o7+64],%o0	! ##TEMPLATE:%imm
		sethi	%hi(0x80000000),%o2
		or	%o0,%o2,%o0	! set sign
		sll	%o0,8,%o2	!
		orcc	%o2,%o1,%g0	! if fraction == 0 then
		bnz,a	.lndr0t1	!      CC=0
		or	%g1,0x1,%g1	! else CC=1
    .lndr0t1:	std	%o0,[%o7+64]	! ##TEMPLATE:%imm
		andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.lndr0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.lndr0e:
.lndr1s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x4,%g1	! CC=unchange & ILC=1
		add	%g2,0x2,%g2	! update IAR
		sethi	%hi(0x00060000),%o0
		or	%g7,%o0,%g7	! specification exception
		ba	.lndr1e		! retuen(TEMPLATE)
		add	%g1,0x10,%g1	!
.lndr1e:

	.section ".text"
	.align	4
	.global cf2_ltdr,tf2_ltdr
cf2_ltdr:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	.ltdr1c			!
	nop				!
    .ltdr0c:				!
	retl				! case even:
	add	%g0,.ltdr0e-.ltdr0s,%o0 !
    .ltdr1c:				!
	retl				! case odd:
	add	%g0,.ltdr1e-.ltdr1s,%o0 !   specification exception
tf2_ltdr:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	.ltdr1t			!
	nop				!
    .ltdr0t:				!
	sethi	%hi(.ltdr0s),%o3	!
	or	%o3,%lo(.ltdr0s),%o3	!
	or	%g0,.ltdr0e-.ltdr0s,%o4 !
    .ltdr0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.ltdr0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.ltdr0t0-.ltdr0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+.ltdr0t0-.ltdr0s]
	ld	[%o0+.ltdr0t1-.ltdr0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+.ltdr0t1-.ltdr0s]
	retl				!
	add	%o0,.ltdr0e-.ltdr0s,%o0 !
    .ltdr1t:				!
	sethi	%hi(.ltdr1s),%o3	!
	or	%o3,%lo(.ltdr1s),%o3	!
	or	%g0,.ltdr1e-.ltdr1s,%o4 !
    .ltdr1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.ltdr1cp		!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,.ltdr1e-.ltdr1s,%o0 !
.ltdr0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x4,%g1	! CC=unchange & ILC=1
		add	%g2,0x2,%g2	! update IAR
		ld	[%sp+92],%o7	! struct *guest
		andn	%g1,0x3,%g1	! CC=0
    .ltdr0t0:	ldd	[%o7+64],%o0	! ##TEMPLATE:%imm
		sll	%o0,8,%o2	!
		orcc	%o2,%o1,%g0	!
		bz	.ltdr0t1	! if fraction == 0 then
		subcc	%o0,%g0,%g0	!      CC=0
		bpos,a	.ltdr0t1	! if %o0 >= 0 then
		or	%g1,0x2,%g1	!      CC=2
		or	%g1,0x1,%g1	! else CC=1
    .ltdr0t1:	std	%o0,[%o7+64]	! ##TEMPLATE:%imm
		andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.ltdr0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.ltdr0e:
.ltdr1s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x4,%g1	! CC=unchange & ILC=1
		add	%g2,0x2,%g2	! update IAR
		sethi	%hi(0x00060000),%o0
		or	%g7,%o0,%g7	! specification exception
		ba	.ltdr1e		! retuen(TEMPLATE)
		add	%g1,0x10,%g1	!
.ltdr1e:

	.section ".text"
	.align	4
	.global cf2_lcdr,tf2_lcdr
cf2_lcdr:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	.lcdr1c			!
	nop				!
    .lcdr0c:				!
	retl				! case even:
	add	%g0,.lcdr0e-.lcdr0s,%o0 !
    .lcdr1c:				!
	retl				! case odd:
	add	%g0,.lcdr1e-.lcdr1s,%o0 !   specification exception
tf2_lcdr:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	.lcdr1t			!
	nop				!
    .lcdr0t:				!
	sethi	%hi(.lcdr0s),%o3	!
	or	%o3,%lo(.lcdr0s),%o3	!
	or	%g0,.lcdr0e-.lcdr0s,%o4 !
    .lcdr0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.lcdr0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.lcdr0t0-.lcdr0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+.lcdr0t0-.lcdr0s]
	ld	[%o0+.lcdr0t1-.lcdr0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+.lcdr0t1-.lcdr0s]
	retl				!
	add	%o0,.lcdr0e-.lcdr0s,%o0 !
    .lcdr1t:				!
	sethi	%hi(.lcdr1s),%o3	!
	or	%o3,%lo(.lcdr1s),%o3	!
	or	%g0,.lcdr1e-.lcdr1s,%o4 !
    .lcdr1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.lcdr1cp		!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,.lcdr1e-.lcdr1s,%o0 !
.lcdr0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x4,%g1	! CC=unchange & ILC=1
		add	%g2,0x2,%g2	! update IAR
		ld	[%sp+92],%o7	! struct *guest
		andn	%g1,0x3,%g1	! CC=0
    .lcdr0t0:	ldd	[%o7+64],%o0	! ##TEMPLATE:%imm
		sethi	%hi(0x80000000),%o2
		xor	%o0,%o2,%o0	! invert sign
		sll	%o0,8,%o2	!
		orcc	%o2,%o1,%g0	!
		bz	.lcdr0t1	! if fraction == 0 then
		subcc	%o0,%g0,%g0	!      CC=0
		bpos,a	.lcdr0t1	! if %o0 >= 0 then
		or	%g1,0x2,%g1	!      CC=2
		or	%g1,0x1,%g1	! else CC=1
    .lcdr0t1:	std	%o0,[%o7+64]	! ##TEMPLATE:%imm
		andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.lcdr0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.lcdr0e:
.lcdr1s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x4,%g1	! CC=unchange & ILC=1
		add	%g2,0x2,%g2	! update IAR
		sethi	%hi(0x00060000),%o0
		or	%g7,%o0,%g7	! specification exception
		ba	.lcdr1e		! retuen(TEMPLATE)
		add	%g1,0x10,%g1	!
.lcdr1e:

	.section ".text"
	.align	4
	.global cf2_hdr,tf2_hdr
cf2_hdr:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	.hdr1c			!
	nop				!
    .hdr0c:				!
	retl				! case even:
	add	%g0,.hdr0e-.hdr0s,%o0	!
    .hdr1c:				!
	retl				! case odd:
	add	%g0,.hdr1e-.hdr1s,%o0	!   specification exception
tf2_hdr:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	.hdr1t			!
	nop				!
    .hdr0t:				!
	sethi	%hi(.hdr0s),%o3		!
	or	%o3,%lo(.hdr0s),%o3	!
	or	%g0,.hdr0e-.hdr0s,%o4	!
    .hdr0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.hdr0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.hdr0t0-.hdr0s],%o5!
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+.hdr0t0-.hdr0s]!
	ld	[%o0+.hdr0t1-.hdr0s],%o5!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+.hdr0t1-.hdr0s]!
	retl				!
	add	%o0,.hdr0e-.hdr0s,%o0	!
    .hdr1t:				!
	sethi	%hi(.hdr1s),%o3		!
	or	%o3,%lo(.hdr1s),%o3	!
	or	%g0,.hdr1e-.hdr1s,%o4	!
    .hdr1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.hdr1cp			!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,.hdr1e-.hdr1s,%o0	!
.hdr0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x4,%g1	! CC=unchange & ILC=1
		add	%g2,0x2,%g2	! update IAR
		ld	[%sp+92],%o0	! struct *guest
    .hdr0t0:	add	%o0,64,%o2	! ##TEMPLATE:%imm
    .hdr0t1:	add	%o0,64,%o1	! ##TEMPLATE:%imm
		and	%g7,0xf,%o3	! give Program Mask
		st	%g1,[%o0+132]	!
		st	%g2,[%o0+136]	!
		st	%g3,[%o0+140]	!
		st	%g4,[%o0+144]	!
		st	%i7,[%o0+60]	! save Mreg15
		ld	[%sp+100],%i7	! restore return addr.
		sethi	%hi(fl_halve_long),%o7
		or	%o7,%lo(fl_halve_long),%o7
		jmpl	%o7,%o7		! call library in fltlib.s
		nop			!
		ld	[%sp+92],%o7	! struct *guest
		ld	[%o7+132],%g1	!
		ld	[%o7+136],%g2	!
		ld	[%o7+140],%g3	!
		ld	[%o7+144],%g4	!
		ld	[%o7+60],%i7	! restore Mreg15
		or	%g7,%o0,%g7	! INTR-CODE=retval
		andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.hdr0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.hdr0e:
.hdr1s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x4,%g1	! CC=unchange & ILC=1
		add	%g2,0x2,%g2	! update IAR
		sethi	%hi(0x00060000),%o0
		or	%g7,%o0,%g7	! specification exception
		ba	.hdr1e		! retuen(TEMPLATE)
		add	%g1,0x10,%g1	!
.hdr1e:

	.section ".text"
	.align	4
	.global cf2_lrdr,tf2_lrdr
cf2_lrdr:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	.lrdr1c			!
	srl	%o1,16,%o4		! switch (R2)
	andcc	%o4,3,%g0		!
	bnz	.lrdr1c			!
	nop				!
    .lrdr0c:				!
	retl				! case even:
	add	%g0,.lrdr0e-.lrdr0s,%o0 !
    .lrdr1c:				!
	retl				! case odd:
	add	%g0,.lrdr1e-.lrdr1s,%o0 !   specification exception
tf2_lrdr:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	.lrdr1t			!
	srl	%o1,16,%o4		! switch (R2)
	andcc	%o4,3,%g0		!
	bnz	.lrdr1t			!
	nop				!
    .lrdr0t:				!
	sethi	%hi(.lrdr0s),%o3	!
	or	%o3,%lo(.lrdr0s),%o3	!
	or	%g0,.lrdr0e-.lrdr0s,%o4 !
    .lrdr0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.lrdr0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.lrdr0t0-.lrdr0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+.lrdr0t0-.lrdr0s]
	ld	[%o0+.lrdr0t1-.lrdr0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+.lrdr0t1-.lrdr0s]
	ld	[%o0+.lrdr0t2-.lrdr0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+.lrdr0t2-.lrdr0s]
	retl				!
	add	%o0,.lrdr0e-.lrdr0s,%o0 !
    .lrdr1t:				!
	sethi	%hi(.lrdr1s),%o3	!
	or	%o3,%lo(.lrdr1s),%o3	!
	or	%g0,.lrdr1e-.lrdr1s,%o4 !
    .lrdr1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.lrdr1cp		!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,.lrdr1e-.lrdr1s,%o0 !
.lrdr0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x4,%g1	! CC=unchange & ILC=1
		add	%g2,0x2,%g2	! update IAR
		ld	[%sp+92],%o7	! struct *guest
    .lrdr0t0:	ldd	[%o7+64],%o0	! ##TEMPLATE:%imm
    .lrdr0t1:	ld	[%o7+72],%o2	! ##TEMPLATE:%imm
		sll	%o2,8,%o2	!
		sethi	%hi(0x80000000),%o4
		addcc	%o2,%o4,%g0	! if no carry-in then
		bcc	.lrdr0t2	!   skip
		nop			!
		addcc	%o1,1,%o1	! add fraction(L) with 1
		bcc	.lrdr0t2	! if no carry-out(L) then
		sll	%o0,8,%o3	!   skip
		addcc	%o3,0x100,%g0	! if no carry-out(H) then
		bcc,a	.lrdr0t2	!   add fraction with 1
		add	%o0,1,%o0	!   skip
		sll	%o0,8,%o3	! add fraction with 1
		srl	%o3,8,%o3	!
		add	%o3,1,%o3	!
		srl	%o3,4,%o3	! shift fraction right 4bits
		srl	%o0,24,%o2	! add characteristic with 1
		sll	%o2,25,%o2	!
		sethi	%hi(0x02000000),%o4
		addcc	%o2,%o4,%o2	!
		srl	%o0,31,%o0	! extract sign bit
		sll	%o0,31,%o0	!
		srl	%o2,1,%o2	! extract characteristic
		or	%o0,%o2,%o0	! merge characteristic
		or	%o0,%o3,%o0	! merge fraction
		sethi	%hi(0x000C0000),%o4
		bcs,a	.lrdr0t2	! if characteristic overflow then
		or	%g7,%o4,%g7	!     exponent overflow
    .lrdr0t2:	std	%o0,[%o7+64]	! ##TEMPLATE:%imm
		andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.lrdr0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.lrdr0e:
.lrdr1s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x4,%g1	! CC=unchange & ILC=1
		add	%g2,0x2,%g2	! update IAR
		sethi	%hi(0x00060000),%o0
		or	%g7,%o0,%g7	! specification exception
		ba	.lrdr1e		! retuen(TEMPLATE)
		add	%g1,0x10,%g1	!
.lrdr1e:

	.section ".text"
	.align	4
	.global cf2_mxr,tf2_mxr
cf2_mxr:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,3,%g0		!
	bnz	.mxr1c			!
	nop				!
    .mxr0c:				!
	retl				! case even:
	add	%g0,.mxr0e-.mxr0s,%o0	!
    .mxr1c:				!
	retl				! case odd:
	add	%g0,.mxr1e-.mxr1s,%o0	!   specification exception
tf2_mxr:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,3,%g0		!
	bnz	.mxr1t			!
	nop				!
    .mxr0t:				!
	sethi	%hi(.mxr0s),%o3		!
	or	%o3,%lo(.mxr0s),%o3	!
	or	%g0,.mxr0e-.mxr0s,%o4	!
    .mxr0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.mxr0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.mxr0t0-.mxr0s],%o5!
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+.mxr0t0-.mxr0s]!
	ld	[%o0+.mxr0t1-.mxr0s],%o5!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+.mxr0t1-.mxr0s]!
	retl				!
	add	%o0,.mxr0e-.mxr0s,%o0	!
    .mxr1t:				!
	sethi	%hi(.mxr1s),%o3		!
	or	%o3,%lo(.mxr1s),%o3	!
	or	%g0,.mxr1e-.mxr1s,%o4	!
    .mxr1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.mxr1cp			!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,.mxr1e-.mxr1s,%o0	!
.mxr0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x4,%g1	! CC=unchange & ILC=1
		add	%g2,0x2,%g2	! update IAR
		ld	[%sp+92],%o0	! struct *guest
    .mxr0t0:	add	%o0,64,%o2	! ##TEMPLATE:%imm
    .mxr0t1:	add	%o0,64,%o1	! ##TEMPLATE:%imm
		and	%g7,0xf,%o3	! give Program Mask
		st	%g1,[%o0+132]	!
		st	%g2,[%o0+136]	!
		st	%g3,[%o0+140]	!
		st	%g4,[%o0+144]	!
		st	%i7,[%o0+60]	! save Mreg15
		ld	[%sp+100],%i7	! restore return addr.
		sethi	%hi(fl_mult_ext2ext),%o7
		or	%o7,%lo(fl_mult_ext2ext),%o7
		jmpl	%o7,%o7		! call library in fltlib.s
		nop			!
		ld	[%sp+92],%o7	! struct *guest
		ld	[%o7+132],%g1	!
		ld	[%o7+136],%g2	!
		ld	[%o7+140],%g3	!
		ld	[%o7+144],%g4	!
		ld	[%o7+60],%i7	! restore Mreg15
		or	%g7,%o0,%g7	! INTR-CODE=retval
		andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.mxr0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.mxr0e:
.mxr1s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x4,%g1	! CC=unchange & ILC=1
		add	%g2,0x2,%g2	! update IAR
		sethi	%hi(0x00060000),%o0
		or	%g7,%o0,%g7	! specification exception
		ba	.mxr1e		! retuen(TEMPLATE)
		add	%g1,0x10,%g1	!
.mxr1e:

	.section ".text"
	.align	4
	.global cf2_mxdr,tf2_mxdr
cf2_mxdr:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,3,%g0		!
	bnz	.mxdr1c			!
	srl	%o1,16,%o4		! switch (R2)
	andcc	%o4,1,%g0		!
	bnz	.mxdr1c			!
	nop				!
    .mxdr0c:				!
	retl				! case even:
	add	%g0,.mxdr0e-.mxdr0s,%o0 !
    .mxdr1c:				!
	retl				! case odd:
	add	%g0,.mxdr1e-.mxdr1s,%o0 !   specification exception
tf2_mxdr:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,3,%g0		!
	bnz	.mxdr1t			!
	srl	%o1,16,%o4		! switch (R2)
	andcc	%o4,1,%g0		!
	bnz	.mxdr1t			!
	nop				!
    .mxdr0t:				!
	sethi	%hi(.mxdr0s),%o3	!
	or	%o3,%lo(.mxdr0s),%o3	!
	or	%g0,.mxdr0e-.mxdr0s,%o4 !
    .mxdr0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.mxdr0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.mxdr0t0-.mxdr0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+.mxdr0t0-.mxdr0s]
	ld	[%o0+.mxdr0t1-.mxdr0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+.mxdr0t1-.mxdr0s]
	retl				!
	add	%o0,.mxdr0e-.mxdr0s,%o0 !
    .mxdr1t:				!
	sethi	%hi(.mxdr1s),%o3	!
	or	%o3,%lo(.mxdr1s),%o3	!
	or	%g0,.mxdr1e-.mxdr1s,%o4 !
    .mxdr1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.mxdr1cp		!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,.mxdr1e-.mxdr1s,%o0 !
.mxdr0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x4,%g1	! CC=unchange & ILC=1
		add	%g2,0x2,%g2	! update IAR
		ld	[%sp+92],%o0	! struct *guest
    .mxdr0t0:	add	%o0,64,%o2	! ##TEMPLATE:%imm
    .mxdr0t1:	add	%o0,64,%o1	! ##TEMPLATE:%imm
		and	%g7,0xf,%o3	! give Program Mask
		st	%g1,[%o0+132]	!
		st	%g2,[%o0+136]	!
		st	%g3,[%o0+140]	!
		st	%g4,[%o0+144]	!
		st	%i7,[%o0+60]	! save Mreg15
		ld	[%sp+100],%i7	! restore return addr.
		sethi	%hi(fl_mult_long2ext),%o7
		or	%o7,%lo(fl_mult_long2ext),%o7
		jmpl	%o7,%o7		! call library in fltlib.s
		nop			!
		ld	[%sp+92],%o7	! struct *guest
		ld	[%o7+132],%g1	!
		ld	[%o7+136],%g2	!
		ld	[%o7+140],%g3	!
		ld	[%o7+144],%g4	!
		ld	[%o7+60],%i7	! restore Mreg15
		or	%g7,%o0,%g7	! INTR-CODE=retval
		andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.mxdr0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.mxdr0e:
.mxdr1s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x4,%g1	! CC=unchange & ILC=1
		add	%g2,0x2,%g2	! update IAR
		sethi	%hi(0x00060000),%o0
		or	%g7,%o0,%g7	! specification exception
		ba	.mxdr1e		! retuen(TEMPLATE)
		add	%g1,0x10,%g1	!
.mxdr1e:

	.section ".text"
	.align	4
	.global cf2_ldr,tf2_ldr
cf2_ldr:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	.ldr1c			!
	nop				!
    .ldr0c:				!
	retl				! case even:
	add	%g0,.ldr0e-.ldr0s,%o0	!
    .ldr1c:				!
	retl				! case odd:
	add	%g0,.ldr1e-.ldr1s,%o0	!   specification exception
tf2_ldr:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	.ldr1t			!
	nop				!
    .ldr0t:				!
	sethi	%hi(.ldr0s),%o3		!
	or	%o3,%lo(.ldr0s),%o3	!
	or	%g0,.ldr0e-.ldr0s,%o4	!
    .ldr0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.ldr0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.ldr0t0-.ldr0s],%o5!
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+.ldr0t0-.ldr0s]!
	ld	[%o0+.ldr0t1-.ldr0s],%o5!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+.ldr0t1-.ldr0s]!
	retl				!
	add	%o0,.ldr0e-.ldr0s,%o0	!
    .ldr1t:				!
	sethi	%hi(.ldr1s),%o3		!
	or	%o3,%lo(.ldr1s),%o3	!
	or	%g0,.ldr1e-.ldr1s,%o4	!
    .ldr1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.ldr1cp			!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,.ldr1e-.ldr1s,%o0	!
.ldr0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x4,%g1	! CC=unchange & ILC=1
		add	%g2,0x2,%g2	! update IAR
		ld	[%sp+92],%o7	! struct *guest
    .ldr0t0:	ldd	[%o7+64],%o0	! ##TEMPLATE:%imm
    .ldr0t1:	std	%o0,[%o7+64]	! ##TEMPLATE:%imm
		andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.ldr0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.ldr0e:
.ldr1s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x4,%g1	! CC=unchange & ILC=1
		add	%g2,0x2,%g2	! update IAR
		sethi	%hi(0x00060000),%o0
		or	%g7,%o0,%g7	! specification exception
		ba	.ldr1e		! retuen(TEMPLATE)
		add	%g1,0x10,%g1	!
.ldr1e:

	.section ".text"
	.align	4
	.global cf2_cdr,tf2_cdr
cf2_cdr:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	.cdr1c			!
	nop				!
    .cdr0c:				!
	retl				! case even:
	add	%g0,.cdr0e-.cdr0s,%o0	!
    .cdr1c:				!
	retl				! case odd:
	add	%g0,.cdr1e-.cdr1s,%o0	!   specification exception
tf2_cdr:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	.cdr1t			!
	nop				!
    .cdr0t:				!
	sethi	%hi(.cdr0s),%o3		!
	or	%o3,%lo(.cdr0s),%o3	!
	or	%g0,.cdr0e-.cdr0s,%o4	!
    .cdr0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.cdr0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.cdr0t0-.cdr0s],%o5!
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+.cdr0t0-.cdr0s]!
	ld	[%o0+.cdr0t1-.cdr0s],%o5!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+.cdr0t1-.cdr0s]!
	retl				!
	add	%o0,.cdr0e-.cdr0s,%o0	!
    .cdr1t:				!
	sethi	%hi(.cdr1s),%o3		!
	or	%o3,%lo(.cdr1s),%o3	!
	or	%g0,.cdr1e-.cdr1s,%o4	!
    .cdr1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.cdr1cp			!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,.cdr1e-.cdr1s,%o0	!
.cdr0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x4,%g1	! CC=unchange & ILC=1
		add	%g2,0x2,%g2	! update IAR
		ld	[%sp+92],%o0	! struct *guest
    .cdr0t0:	add	%o0,64,%o2	! ##TEMPLATE:%imm
    .cdr0t1:	add	%o0,64,%o1	! ##TEMPLATE:%imm
		and	%g7,0xf,%o3	! give Program Mask
		st	%g1,[%o0+132]	!
		st	%g2,[%o0+136]	!
		st	%g3,[%o0+140]	!
		st	%g4,[%o0+144]	!
		st	%i7,[%o0+60]	! save Mreg15
		ld	[%sp+100],%i7	! restore return addr.
		sethi	%hi(fl_comp_long),%o7
		or	%o7,%lo(fl_comp_long),%o7
		jmpl	%o7,%o7		! call library in fltlib.s
		nop			!
		ld	[%sp+92],%o7	! struct *guest
		ld	[%o7+132],%g1	!
		ld	[%o7+136],%g2	!
		ld	[%o7+140],%g3	!
		ld	[%o7+144],%g4	!
		ld	[%o7+60],%i7	! restore Mreg15
		andn	%g1,0x3,%g1	! CC=0
		or	%g1,%o0,%g1	! CC=retval
		andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.cdr0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.cdr0e:
.cdr1s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x4,%g1	! CC=unchange & ILC=1
		add	%g2,0x2,%g2	! update IAR
		sethi	%hi(0x00060000),%o0
		or	%g7,%o0,%g7	! specification exception
		ba	.cdr1e		! retuen(TEMPLATE)
		add	%g1,0x10,%g1	!
.cdr1e:

	.section ".text"
	.align	4
	.global cf2_adr,tf2_adr
cf2_adr:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	.adr1c			!
	nop				!
    .adr0c:				!
	retl				! case even:
	add	%g0,.adr0e-.adr0s,%o0	!
    .adr1c:				!
	retl				! case odd:
	add	%g0,.adr1e-.adr1s,%o0	!   specification exception
tf2_adr:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	.adr1t			!
	nop				!
    .adr0t:				!
	sethi	%hi(.adr0s),%o3		!
	or	%o3,%lo(.adr0s),%o3	!
	or	%g0,.adr0e-.adr0s,%o4	!
    .adr0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.adr0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.adr0t0-.adr0s],%o5!
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+.adr0t0-.adr0s]!
	ld	[%o0+.adr0t1-.adr0s],%o5!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+.adr0t1-.adr0s]!
	retl				!
	add	%o0,.adr0e-.adr0s,%o0	!
    .adr1t:				!
	sethi	%hi(.adr1s),%o3		!
	or	%o3,%lo(.adr1s),%o3	!
	or	%g0,.adr1e-.adr1s,%o4	!
    .adr1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.adr1cp			!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,.adr1e-.adr1s,%o0	!
.adr0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x4,%g1	! CC=unchange & ILC=1
		add	%g2,0x2,%g2	! update IAR
		ld	[%sp+92],%o0	! struct *guest
    .adr0t0:	add	%o0,64,%o2	! ##TEMPLATE:%imm
    .adr0t1:	add	%o0,64,%o1	! ##TEMPLATE:%imm
		and	%g7,0xf,%o3	! give Program Mask
		st	%g1,[%o0+132]	!
		st	%g2,[%o0+136]	!
		st	%g3,[%o0+140]	!
		st	%g4,[%o0+144]	!
		st	%i7,[%o0+60]	! save Mreg15
		ld	[%sp+100],%i7	! restore return addr.
		sethi	%hi(fl_addsub_long_norm),%o7
		or	%o7,%lo(fl_addsub_long_norm),%o7
		jmpl	%o7,%o7		! call library in fltlib.s
		add	%g0,0,%o4	! param5=0(add)
		ld	[%sp+92],%o7	! struct *guest
		ld	[%o7+132],%g1	!
		ld	[%o7+136],%g2	!
		ld	[%o7+140],%g3	!
		ld	[%o7+144],%g4	!
		ld	[%o7+60],%i7	! restore Mreg15
		andn	%g1,0x3,%g1	! CC=0
		and	%o0,0x3,%o1	! extract CC
		or	%g1,%o1,%g1	! CC=retval
		sethi	%hi(0x00ff0000),%o1
		and	%o0,%o1,%o1	! extract exception
		or	%g7,%o1,%g7	! INTR-CODE=retval
		andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.adr0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.adr0e:
.adr1s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x4,%g1	! CC=unchange & ILC=1
		add	%g2,0x2,%g2	! update IAR
		sethi	%hi(0x00060000),%o0
		or	%g7,%o0,%g7	! specification exception
		ba	.adr1e		! retuen(TEMPLATE)
		add	%g1,0x10,%g1	!
.adr1e:

	.section ".text"
	.align	4
	.global cf2_sdr,tf2_sdr
cf2_sdr:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	.sdr1c			!
	nop				!
    .sdr0c:				!
	retl				! case even:
	add	%g0,.sdr0e-.sdr0s,%o0	!
    .sdr1c:				!
	retl				! case odd:
	add	%g0,.sdr1e-.sdr1s,%o0	!   specification exception
tf2_sdr:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	.sdr1t			!
	nop				!
    .sdr0t:				!
	sethi	%hi(.sdr0s),%o3		!
	or	%o3,%lo(.sdr0s),%o3	!
	or	%g0,.sdr0e-.sdr0s,%o4	!
    .sdr0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.sdr0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.sdr0t0-.sdr0s],%o5!
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+.sdr0t0-.sdr0s]!
	ld	[%o0+.sdr0t1-.sdr0s],%o5!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+.sdr0t1-.sdr0s]!
	retl				!
	add	%o0,.sdr0e-.sdr0s,%o0	!
    .sdr1t:				!
	sethi	%hi(.sdr1s),%o3		!
	or	%o3,%lo(.sdr1s),%o3	!
	or	%g0,.sdr1e-.sdr1s,%o4	!
    .sdr1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.sdr1cp			!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,.sdr1e-.sdr1s,%o0	!
.sdr0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x4,%g1	! CC=unchange & ILC=1
		add	%g2,0x2,%g2	! update IAR
		ld	[%sp+92],%o0	! struct *guest
    .sdr0t0:	add	%o0,64,%o2	! ##TEMPLATE:%imm
    .sdr0t1:	add	%o0,64,%o1	! ##TEMPLATE:%imm
		and	%g7,0xf,%o3	! give Program Mask
		st	%g1,[%o0+132]	!
		st	%g2,[%o0+136]	!
		st	%g3,[%o0+140]	!
		st	%g4,[%o0+144]	!
		st	%i7,[%o0+60]	! save Mreg15
		ld	[%sp+100],%i7	! restore return addr.
		sethi	%hi(fl_addsub_long_norm),%o7
		or	%o7,%lo(fl_addsub_long_norm),%o7
		jmpl	%o7,%o7		! call library in fltlib.s
		add	%g0,1,%o4	! param5=1(sub)
		ld	[%sp+92],%o7	! struct *guest
		ld	[%o7+132],%g1	!
		ld	[%o7+136],%g2	!
		ld	[%o7+140],%g3	!
		ld	[%o7+144],%g4	!
		ld	[%o7+60],%i7	! restore Mreg15
		andn	%g1,0x3,%g1	! CC=0
		and	%o0,0x3,%o1	! extract CC
		or	%g1,%o1,%g1	! CC=retval
		sethi	%hi(0x00ff0000),%o1
		and	%o0,%o1,%o1	! extract exception
		or	%g7,%o1,%g7	! INTR-CODE=retval
		andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.sdr0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.sdr0e:
.sdr1s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x4,%g1	! CC=unchange & ILC=1
		add	%g2,0x2,%g2	! update IAR
		sethi	%hi(0x00060000),%o0
		or	%g7,%o0,%g7	! specification exception
		ba	.sdr1e		! retuen(TEMPLATE)
		add	%g1,0x10,%g1	!
.sdr1e:

	.section ".text"
	.align	4
	.global cf2_mdr,tf2_mdr
cf2_mdr:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	.mdr1c			!
	nop				!
    .mdr0c:				!
	retl				! case even:
	add	%g0,.mdr0e-.mdr0s,%o0	!
    .mdr1c:				!
	retl				! case odd:
	add	%g0,.mdr1e-.mdr1s,%o0	!   specification exception
tf2_mdr:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	.mdr1t			!
	nop				!
    .mdr0t:				!
	sethi	%hi(.mdr0s),%o3		!
	or	%o3,%lo(.mdr0s),%o3	!
	or	%g0,.mdr0e-.mdr0s,%o4	!
    .mdr0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.mdr0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.mdr0t0-.mdr0s],%o5!
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+.mdr0t0-.mdr0s]!
	ld	[%o0+.mdr0t1-.mdr0s],%o5!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+.mdr0t1-.mdr0s]!
	retl				!
	add	%o0,.mdr0e-.mdr0s,%o0	!
    .mdr1t:				!
	sethi	%hi(.mdr1s),%o3		!
	or	%o3,%lo(.mdr1s),%o3	!
	or	%g0,.mdr1e-.mdr1s,%o4	!
    .mdr1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.mdr1cp			!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,.mdr1e-.mdr1s,%o0	!
.mdr0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x4,%g1	! CC=unchange & ILC=1
		add	%g2,0x2,%g2	! update IAR
		ld	[%sp+92],%o0	! struct *guest
    .mdr0t0:	add	%o0,64,%o2	! ##TEMPLATE:%imm
    .mdr0t1:	add	%o0,64,%o1	! ##TEMPLATE:%imm
		and	%g7,0xf,%o3	! give Program Mask
		st	%g1,[%o0+132]	!
		st	%g2,[%o0+136]	!
		st	%g3,[%o0+140]	!
		st	%g4,[%o0+144]	!
		st	%i7,[%o0+60]	! save Mreg15
		ld	[%sp+100],%i7	! restore return addr.
		sethi	%hi(fl_mult_long2long),%o7
		or	%o7,%lo(fl_mult_long2long),%o7
		jmpl	%o7,%o7		! call library in fltlib.s
		nop			!
		ld	[%sp+92],%o7	! struct *guest
		ld	[%o7+132],%g1	!
		ld	[%o7+136],%g2	!
		ld	[%o7+140],%g3	!
		ld	[%o7+144],%g4	!
		ld	[%o7+60],%i7	! restore Mreg15
		or	%g7,%o0,%g7	! INTR-CODE=retval
		andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.mdr0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.mdr0e:
.mdr1s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x4,%g1	! CC=unchange & ILC=1
		add	%g2,0x2,%g2	! update IAR
		sethi	%hi(0x00060000),%o0
		or	%g7,%o0,%g7	! specification exception
		ba	.mdr1e		! retuen(TEMPLATE)
		add	%g1,0x10,%g1	!
.mdr1e:

	.section ".text"
	.align	4
	.global cf2_ddr,tf2_ddr
cf2_ddr:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	.ddr1c			!
	nop				!
    .ddr0c:				!
	retl				! case even:
	add	%g0,.ddr0e-.ddr0s,%o0	!
    .ddr1c:				!
	retl				! case odd:
	add	%g0,.ddr1e-.ddr1s,%o0	!   specification exception
tf2_ddr:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	.ddr1t			!
	nop				!
    .ddr0t:				!
	sethi	%hi(.ddr0s),%o3		!
	or	%o3,%lo(.ddr0s),%o3	!
	or	%g0,.ddr0e-.ddr0s,%o4	!
    .ddr0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.ddr0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.ddr0t0-.ddr0s],%o5!
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+.ddr0t0-.ddr0s]!
	ld	[%o0+.ddr0t1-.ddr0s],%o5!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+.ddr0t1-.ddr0s]!
	retl				!
	add	%o0,.ddr0e-.ddr0s,%o0	!
    .ddr1t:				!
	sethi	%hi(.ddr1s),%o3		!
	or	%o3,%lo(.ddr1s),%o3	!
	or	%g0,.ddr1e-.ddr1s,%o4	!
    .ddr1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.ddr1cp			!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,.ddr1e-.ddr1s,%o0	!
.ddr0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x4,%g1	! CC=unchange & ILC=1
		add	%g2,0x2,%g2	! update IAR
		ld	[%sp+92],%o0	! struct *guest
    .ddr0t0:	add	%o0,64,%o2	! ##TEMPLATE:%imm
    .ddr0t1:	add	%o0,64,%o1	! ##TEMPLATE:%imm
		and	%g7,0xf,%o3	! give Program Mask
		st	%g1,[%o0+132]	!
		st	%g2,[%o0+136]	!
		st	%g3,[%o0+140]	!
		st	%g4,[%o0+144]	!
		st	%i7,[%o0+60]	! save Mreg15
		ld	[%sp+100],%i7	! restore return addr.
		sethi	%hi(fl_div_long),%o7
		or	%o7,%lo(fl_div_long),%o7
		jmpl	%o7,%o7		! call library in fltlib.s
		nop			!
		ld	[%sp+92],%o7	! struct *guest
		ld	[%o7+132],%g1	!
		ld	[%o7+136],%g2	!
		ld	[%o7+140],%g3	!
		ld	[%o7+144],%g4	!
		ld	[%o7+60],%i7	! restore Mreg15
		or	%g7,%o0,%g7	! INTR-CODE=retval
		andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.ddr0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.ddr0e:
.ddr1s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x4,%g1	! CC=unchange & ILC=1
		add	%g2,0x2,%g2	! update IAR
		sethi	%hi(0x00060000),%o0
		or	%g7,%o0,%g7	! specification exception
		ba	.ddr1e		! retuen(TEMPLATE)
		add	%g1,0x10,%g1	!
.ddr1e:

	.section ".text"
	.align	4
	.global cf2_awr,tf2_awr
cf2_awr:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	.awr1c			!
	nop				!
    .awr0c:				!
	retl				! case even:
	add	%g0,.awr0e-.awr0s,%o0	!
    .awr1c:				!
	retl				! case odd:
	add	%g0,.awr1e-.awr1s,%o0	!   specification exception
tf2_awr:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	.awr1t			!
	nop				!
    .awr0t:				!
	sethi	%hi(.awr0s),%o3		!
	or	%o3,%lo(.awr0s),%o3	!
	or	%g0,.awr0e-.awr0s,%o4	!
    .awr0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.awr0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.awr0t0-.awr0s],%o5!
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+.awr0t0-.awr0s]!
	ld	[%o0+.awr0t1-.awr0s],%o5!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+.awr0t1-.awr0s]!
	retl				!
	add	%o0,.awr0e-.awr0s,%o0	!
    .awr1t:				!
	sethi	%hi(.awr1s),%o3		!
	or	%o3,%lo(.awr1s),%o3	!
	or	%g0,.awr1e-.awr1s,%o4	!
    .awr1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.awr1cp			!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,.awr1e-.awr1s,%o0	!
.awr0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x4,%g1	! CC=unchange & ILC=1
		add	%g2,0x2,%g2	! update IAR
		ld	[%sp+92],%o0	! struct *guest
    .awr0t0:	add	%o0,64,%o2	! ##TEMPLATE:%imm
    .awr0t1:	add	%o0,64,%o1	! ##TEMPLATE:%imm
		and	%g7,0xf,%o3	! give Program Mask
		st	%g1,[%o0+132]	!
		st	%g2,[%o0+136]	!
		st	%g3,[%o0+140]	!
		st	%g4,[%o0+144]	!
		st	%i7,[%o0+60]	! save Mreg15
		ld	[%sp+100],%i7	! restore return addr.
		sethi	%hi(fl_addsub_long_unnorm),%o7
		or	%o7,%lo(fl_addsub_long_unnorm),%o7
		jmpl	%o7,%o7		! call library in fltlib.s
		add	%g0,0,%o4	! param5=0(add)
		ld	[%sp+92],%o7	! struct *guest
		ld	[%o7+132],%g1	!
		ld	[%o7+136],%g2	!
		ld	[%o7+140],%g3	!
		ld	[%o7+144],%g4	!
		ld	[%o7+60],%i7	! restore Mreg15
		andn	%g1,0x3,%g1	! CC=0
		and	%o0,0x3,%o1	! extract CC
		or	%g1,%o1,%g1	! CC=retval
		sethi	%hi(0x00ff0000),%o1
		and	%o0,%o1,%o1	! extract exception
		or	%g7,%o1,%g7	! INTR-CODE=retval
		andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.awr0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.awr0e:
.awr1s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x4,%g1	! CC=unchange & ILC=1
		add	%g2,0x2,%g2	! update IAR
		sethi	%hi(0x00060000),%o0
		or	%g7,%o0,%g7	! specification exception
		ba	.awr1e		! retuen(TEMPLATE)
		add	%g1,0x10,%g1	!
.awr1e:

	.section ".text"
	.align	4
	.global cf2_swr,tf2_swr
cf2_swr:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	.swr1c			!
	nop				!
    .swr0c:				!
	retl				! case even:
	add	%g0,.swr0e-.swr0s,%o0	!
    .swr1c:				!
	retl				! case odd:
	add	%g0,.swr1e-.swr1s,%o0	!   specification exception
tf2_swr:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	.swr1t			!
	nop				!
    .swr0t:				!
	sethi	%hi(.swr0s),%o3		!
	or	%o3,%lo(.swr0s),%o3	!
	or	%g0,.swr0e-.swr0s,%o4	!
    .swr0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.swr0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.swr0t0-.swr0s],%o5!
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+.swr0t0-.swr0s]!
	ld	[%o0+.swr0t1-.swr0s],%o5!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+.swr0t1-.swr0s]!
	retl				!
	add	%o0,.swr0e-.swr0s,%o0	!
    .swr1t:				!
	sethi	%hi(.swr1s),%o3		!
	or	%o3,%lo(.swr1s),%o3	!
	or	%g0,.swr1e-.swr1s,%o4	!
    .swr1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.swr1cp			!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,.swr1e-.swr1s,%o0	!
.swr0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x4,%g1	! CC=unchange & ILC=1
		add	%g2,0x2,%g2	! update IAR
		ld	[%sp+92],%o0	! struct *guest
    .swr0t0:	add	%o0,64,%o2	! ##TEMPLATE:%imm
    .swr0t1:	add	%o0,64,%o1	! ##TEMPLATE:%imm
		and	%g7,0xf,%o3	! give Program Mask
		st	%g1,[%o0+132]	!
		st	%g2,[%o0+136]	!
		st	%g3,[%o0+140]	!
		st	%g4,[%o0+144]	!
		st	%i7,[%o0+60]	! save Mreg15
		ld	[%sp+100],%i7	! restore return addr.
		sethi	%hi(fl_addsub_long_unnorm),%o7
		or	%o7,%lo(fl_addsub_long_unnorm),%o7
		jmpl	%o7,%o7		! call library in fltlib.s
		add	%g0,1,%o4	! param5=1(sub)
		ld	[%sp+92],%o7	! struct *guest
		ld	[%o7+132],%g1	!
		ld	[%o7+136],%g2	!
		ld	[%o7+140],%g3	!
		ld	[%o7+144],%g4	!
		ld	[%o7+60],%i7	! restore Mreg15
		andn	%g1,0x3,%g1	! CC=0
		and	%o0,0x3,%o1	! extract CC
		or	%g1,%o1,%g1	! CC=retval
		sethi	%hi(0x00ff0000),%o1
		and	%o0,%o1,%o1	! extract exception
		or	%g7,%o1,%g7	! INTR-CODE=retval
		andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.swr0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.swr0e:
.swr1s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x4,%g1	! CC=unchange & ILC=1
		add	%g2,0x2,%g2	! update IAR
		sethi	%hi(0x00060000),%o0
		or	%g7,%o0,%g7	! specification exception
		ba	.swr1e		! retuen(TEMPLATE)
		add	%g1,0x10,%g1	!
.swr1e:
!================================

!
! templates
! cxx_xxx:
!   %o0: param: none
!	 retval:size of template
!   %o1: M instruction (upper 2 bytes)
!   %o2: work
!   %o3: work
!   %o4: work
!   %o5: flag(0:NON EXECUTE,1:EXECUTE)
! txx_xxx:
!   %o0: param: bufp start address
!	 retval:bufp next start address
!   %o1: M instruction (upper 2 bytes)
!   %o2: work
!   %o3: work
!   %o4: work
!   %o5: flag(0:NON EXECUTE,1:EXECUTE)
!
	.section ".text"
	.align	4
	.global cf2_lper,tf2_lper
cf2_lper:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	.lper1c			!
	nop				!
    .lper0c:				!
	retl				! case even:
	add	%g0,.lper0e-.lper0s,%o0 !
    .lper1c:				!
	retl				! case odd:
	add	%g0,.lper1e-.lper1s,%o0 !   specification exception
tf2_lper:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	.lper1t			!
	nop				!
    .lper0t:				!
	sethi	%hi(.lper0s),%o3	!
	or	%o3,%lo(.lper0s),%o3	!
	or	%g0,.lper0e-.lper0s,%o4 !
    .lper0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.lper0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.lper0t0-.lper0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+.lper0t0-.lper0s]
	ld	[%o0+.lper0t1-.lper0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+.lper0t1-.lper0s]
	retl				!
	add	%o0,.lper0e-.lper0s,%o0 !
    .lper1t:				!
	sethi	%hi(.lper1s),%o3	!
	or	%o3,%lo(.lper1s),%o3	!
	or	%g0,.lper1e-.lper1s,%o4 !
    .lper1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.lper1cp		!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,.lper1e-.lper1s,%o0 !
.lper0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x4,%g1	! CC=unchange & ILC=1
		add	%g2,0x2,%g2	! update IAR
		ld	[%sp+92],%o7	! struct *guest
		andn	%g1,0x3,%g1	! CC=0
    .lper0t0:	ld	[%o7+64],%o0	! ##TEMPLATE:%imm
		sethi	%hi(0x80000000),%o2
		andn	%o0,%o2,%o0	! set sign
		sll	%o0,8,%o2	!
		orcc	%o2,%g0,%g0	! if fraction == 0 then
		bnz,a	.lper0t1	!      CC=0
		or	%g1,0x2,%g1	! else CC=2
    .lper0t1:	st	%o0,[%o7+64]	! ##TEMPLATE:%imm
		andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.lper0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.lper0e:
.lper1s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x4,%g1	! CC=unchange & ILC=1
		add	%g2,0x2,%g2	! update IAR
		sethi	%hi(0x00060000),%o0
		or	%g7,%o0,%g7	! specification exception
		ba	.lper1e		! retuen(TEMPLATE)
		add	%g1,0x10,%g1	!
.lper1e:

	.section ".text"
	.align	4
	.global cf2_lner,tf2_lner
cf2_lner:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	.lner1c			!
	nop				!
    .lner0c:				!
	retl				! case even:
	add	%g0,.lner0e-.lner0s,%o0 !
    .lner1c:				!
	retl				! case odd:
	add	%g0,.lner1e-.lner1s,%o0 !   specification exception
tf2_lner:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	.lner1t			!
	nop				!
    .lner0t:				!
	sethi	%hi(.lner0s),%o3	!
	or	%o3,%lo(.lner0s),%o3	!
	or	%g0,.lner0e-.lner0s,%o4 !
    .lner0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.lner0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.lner0t0-.lner0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+.lner0t0-.lner0s]
	ld	[%o0+.lner0t1-.lner0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+.lner0t1-.lner0s]
	retl				!
	add	%o0,.lner0e-.lner0s,%o0 !
    .lner1t:				!
	sethi	%hi(.lner1s),%o3	!
	or	%o3,%lo(.lner1s),%o3	!
	or	%g0,.lner1e-.lner1s,%o4 !
    .lner1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.lner1cp		!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,.lner1e-.lner1s,%o0 !
.lner0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x4,%g1	! CC=unchange & ILC=1
		add	%g2,0x2,%g2	! update IAR
		ld	[%sp+92],%o7	! struct *guest
		andn	%g1,0x3,%g1	! CC=0
    .lner0t0:	ld	[%o7+64],%o0	! ##TEMPLATE:%imm
		sethi	%hi(0x80000000),%o2
		or	%o0,%o2,%o0	! set sign
		sll	%o0,8,%o2	!
		orcc	%o2,%g0,%g0	! if fraction == 0 then
		bnz,a	.lner0t1	!      CC=0
		or	%g1,0x1,%g1	! else CC=1
    .lner0t1:	st	%o0,[%o7+64]	! ##TEMPLATE:%imm
		andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.lner0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.lner0e:
.lner1s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x4,%g1	! CC=unchange & ILC=1
		add	%g2,0x2,%g2	! update IAR
		sethi	%hi(0x00060000),%o0
		or	%g7,%o0,%g7	! specification exception
		ba	.lner1e		! retuen(TEMPLATE)
		add	%g1,0x10,%g1	!
.lner1e:

	.section ".text"
	.align	4
	.global cf2_lter,tf2_lter
cf2_lter:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	.lter1c			!
	nop				!
    .lter0c:				!
	retl				! case even:
	add	%g0,.lter0e-.lter0s,%o0 !
    .lter1c:				!
	retl				! case odd:
	add	%g0,.lter1e-.lter1s,%o0 !   specification exception
tf2_lter:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	.lter1t			!
	nop				!
    .lter0t:				!
	sethi	%hi(.lter0s),%o3	!
	or	%o3,%lo(.lter0s),%o3	!
	or	%g0,.lter0e-.lter0s,%o4 !
    .lter0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.lter0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.lter0t0-.lter0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+.lter0t0-.lter0s]
	ld	[%o0+.lter0t1-.lter0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+.lter0t1-.lter0s]
	retl				!
	add	%o0,.lter0e-.lter0s,%o0 !
    .lter1t:				!
	sethi	%hi(.lter1s),%o3	!
	or	%o3,%lo(.lter1s),%o3	!
	or	%g0,.lter1e-.lter1s,%o4 !
    .lter1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.lter1cp		!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,.lter1e-.lter1s,%o0 !
.lter0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x4,%g1	! CC=unchange & ILC=1
		add	%g2,0x2,%g2	! update IAR
		ld	[%sp+92],%o7	! struct *guest
		andn	%g1,0x3,%g1	! CC=0
    .lter0t0:	ld	[%o7+64],%o0	! ##TEMPLATE:%imm
		sll	%o0,8,%o2	!
		orcc	%o2,%g0,%g0	!
		bz	.lter0t1	! if fraction == 0 then
		subcc	%o0,%g0,%g0	!      CC=0
		bpos,a	.lter0t1	! if %o0 >= 0 then
		or	%g1,0x2,%g1	!      CC=2
		or	%g1,0x1,%g1	! else CC=1
    .lter0t1:	st	%o0,[%o7+64]	! ##TEMPLATE:%imm
		andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.lter0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.lter0e:
.lter1s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x4,%g1	! CC=unchange & ILC=1
		add	%g2,0x2,%g2	! update IAR
		sethi	%hi(0x00060000),%o0
		or	%g7,%o0,%g7	! specification exception
		ba	.lter1e		! retuen(TEMPLATE)
		add	%g1,0x10,%g1	!
.lter1e:

	.section ".text"
	.align	4
	.global cf2_lcer,tf2_lcer
cf2_lcer:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	.lcer1c			!
	nop				!
    .lcer0c:				!
	retl				! case even:
	add	%g0,.lcer0e-.lcer0s,%o0 !
    .lcer1c:				!
	retl				! case odd:
	add	%g0,.lcer1e-.lcer1s,%o0 !   specification exception
tf2_lcer:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	.lcer1t			!
	nop				!
    .lcer0t:				!
	sethi	%hi(.lcer0s),%o3	!
	or	%o3,%lo(.lcer0s),%o3	!
	or	%g0,.lcer0e-.lcer0s,%o4 !
    .lcer0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.lcer0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.lcer0t0-.lcer0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+.lcer0t0-.lcer0s]
	ld	[%o0+.lcer0t1-.lcer0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+.lcer0t1-.lcer0s]
	retl				!
	add	%o0,.lcer0e-.lcer0s,%o0 !
    .lcer1t:				!
	sethi	%hi(.lcer1s),%o3	!
	or	%o3,%lo(.lcer1s),%o3	!
	or	%g0,.lcer1e-.lcer1s,%o4 !
    .lcer1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.lcer1cp		!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,.lcer1e-.lcer1s,%o0 !
.lcer0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x4,%g1	! CC=unchange & ILC=1
		add	%g2,0x2,%g2	! update IAR
		ld	[%sp+92],%o7	! struct *guest
		andn	%g1,0x3,%g1	! CC=0
    .lcer0t0:	ld	[%o7+64],%o0	! ##TEMPLATE:%imm
		sethi	%hi(0x80000000),%o2
		xor	%o0,%o2,%o0	! invert sign
		sll	%o0,8,%o2	!
		orcc	%o2,%g0,%g0	!
		bz	.lcer0t1	! if fraction == 0 then
		subcc	%o0,%g0,%g0	!      CC=0
		bpos,a	.lcer0t1	! if %o0 >= 0 then
		or	%g1,0x2,%g1	!      CC=2
		or	%g1,0x1,%g1	! else CC=1
    .lcer0t1:	st	%o0,[%o7+64]	! ##TEMPLATE:%imm
		andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.lcer0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.lcer0e:
.lcer1s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x4,%g1	! CC=unchange & ILC=1
		add	%g2,0x2,%g2	! update IAR
		sethi	%hi(0x00060000),%o0
		or	%g7,%o0,%g7	! specification exception
		ba	.lcer1e		! retuen(TEMPLATE)
		add	%g1,0x10,%g1	!
.lcer1e:

	.section ".text"
	.align	4
	.global cf2_her,tf2_her
cf2_her:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	.her1c			!
	nop				!
    .her0c:				!
	retl				! case even:
	add	%g0,.her0e-.her0s,%o0	!
    .her1c:				!
	retl				! case odd:
	add	%g0,.her1e-.her1s,%o0	!   specification exception
tf2_her:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	.her1t			!
	nop				!
    .her0t:				!
	sethi	%hi(.her0s),%o3		!
	or	%o3,%lo(.her0s),%o3	!
	or	%g0,.her0e-.her0s,%o4	!
    .her0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.her0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.her0t0-.her0s],%o5!
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+.her0t0-.her0s]!
	ld	[%o0+.her0t1-.her0s],%o5!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+.her0t1-.her0s]!
	retl				!
	add	%o0,.her0e-.her0s,%o0	!
    .her1t:				!
	sethi	%hi(.her1s),%o3		!
	or	%o3,%lo(.her1s),%o3	!
	or	%g0,.her1e-.her1s,%o4	!
    .her1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.her1cp			!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,.her1e-.her1s,%o0	!
.her0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x4,%g1	! CC=unchange & ILC=1
		add	%g2,0x2,%g2	! update IAR
		ld	[%sp+92],%o0	! struct *guest
    .her0t0:	add	%o0,64,%o2	! ##TEMPLATE:%imm
    .her0t1:	add	%o0,64,%o1	! ##TEMPLATE:%imm
		and	%g7,0xf,%o3	! give Program Mask
		st	%g1,[%o0+132]	!
		st	%g2,[%o0+136]	!
		st	%g3,[%o0+140]	!
		st	%g4,[%o0+144]	!
		st	%i7,[%o0+60]	! save Mreg15
		ld	[%sp+100],%i7	! restore return addr.
		sethi	%hi(fl_halve_short),%o7
		or	%o7,%lo(fl_halve_short),%o7
		jmpl	%o7,%o7		! call library in fltlib.s
		nop			!
		ld	[%sp+92],%o7	! struct *guest
		ld	[%o7+132],%g1	!
		ld	[%o7+136],%g2	!
		ld	[%o7+140],%g3	!
		ld	[%o7+144],%g4	!
		ld	[%o7+60],%i7	! restore Mreg15
		or	%g7,%o0,%g7	! INTR-CODE=retval
		andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.her0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.her0e:
.her1s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x4,%g1	! CC=unchange & ILC=1
		add	%g2,0x2,%g2	! update IAR
		sethi	%hi(0x00060000),%o0
		or	%g7,%o0,%g7	! specification exception
		ba	.her1e		! retuen(TEMPLATE)
		add	%g1,0x10,%g1	!
.her1e:

	.section ".text"
	.align	4
	.global cf2_lrer,tf2_lrer
cf2_lrer:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	.lrer1c			!
	nop				!
    .lrer0c:				!
	retl				! case even:
	add	%g0,.lrer0e-.lrer0s,%o0 !
    .lrer1c:				!
	retl				! case odd:
	add	%g0,.lrer1e-.lrer1s,%o0 !   specification exception
tf2_lrer:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	.lrer1t			!
	nop				!
    .lrer0t:				!
	sethi	%hi(.lrer0s),%o3	!
	or	%o3,%lo(.lrer0s),%o3	!
	or	%g0,.lrer0e-.lrer0s,%o4 !
    .lrer0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.lrer0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.lrer0t0-.lrer0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+.lrer0t0-.lrer0s]
	ld	[%o0+.lrer0t1-.lrer0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+.lrer0t1-.lrer0s]
	retl				!
	add	%o0,.lrer0e-.lrer0s,%o0 !
    .lrer1t:				!
	sethi	%hi(.lrer1s),%o3	!
	or	%o3,%lo(.lrer1s),%o3	!
	or	%g0,.lrer1e-.lrer1s,%o4 !
    .lrer1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.lrer1cp		!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,.lrer1e-.lrer1s,%o0 !
.lrer0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x4,%g1	! CC=unchange & ILC=1
		add	%g2,0x2,%g2	! update IAR
		ld	[%sp+92],%o7	! struct *guest
    .lrer0t0:	ldd	[%o7+64],%o0	! ##TEMPLATE:%imm
		sethi	%hi(0x80000000),%o4
		addcc	%o1,%o4,%g0	! if no carry-in then
		bcc	.lrer0t1	!   skip
		sll	%o0,8,%o3	!
		addcc	%o3,0x100,%g0	! if no carry-out then
		bcc,a	.lrer0t1	!   add fraction with 1
		add	%o0,1,%o0	!   skip
		sll	%o0,8,%o3	! add fraction with 1
		srl	%o3,8,%o3	!
		add	%o3,1,%o3	!
		srl	%o3,4,%o3	! shift fraction right 4bits
		srl	%o0,24,%o2	! add characteristic with 1
		sll	%o2,25,%o2	!
		sethi	%hi(0x02000000),%o4
		addcc	%o2,%o4,%o2	!
		srl	%o0,31,%o0	! extract sign bit
		sll	%o0,31,%o0	!
		srl	%o2,1,%o2	! extract characteristic
		or	%o0,%o2,%o0	! merge characteristic
		or	%o0,%o3,%o0	! merge fraction
		sethi	%hi(0x000C0000),%o4
		bcs,a	.lrer0t1	! if characteristic overflow then
		or	%g7,%o4,%g7	!     exponent overflow
    .lrer0t1:	st	%o0,[%o7+64]	! ##TEMPLATE:%imm
		andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.lrer0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.lrer0e:
.lrer1s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x4,%g1	! CC=unchange & ILC=1
		add	%g2,0x2,%g2	! update IAR
		sethi	%hi(0x00060000),%o0
		or	%g7,%o0,%g7	! specification exception
		ba	.lrer1e		! retuen(TEMPLATE)
		add	%g1,0x10,%g1	!
.lrer1e:

	.section ".text"
	.align	4
	.global cf2_axr,tf2_axr
cf2_axr:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,3,%g0		!
	bnz	.axr1c			!
	nop				!
    .axr0c:				!
	retl				! case even:
	add	%g0,.axr0e-.axr0s,%o0	!
    .axr1c:				!
	retl				! case odd:
	add	%g0,.axr1e-.axr1s,%o0	!   specification exception
tf2_axr:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,3,%g0		!
	bnz	.axr1t			!
	nop				!
    .axr0t:				!
	sethi	%hi(.axr0s),%o3		!
	or	%o3,%lo(.axr0s),%o3	!
	or	%g0,.axr0e-.axr0s,%o4	!
    .axr0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.axr0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.axr0t0-.axr0s],%o5!
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+.axr0t0-.axr0s]!
	ld	[%o0+.axr0t1-.axr0s],%o5!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+.axr0t1-.axr0s]!
	retl				!
	add	%o0,.axr0e-.axr0s,%o0	!
    .axr1t:				!
	sethi	%hi(.axr1s),%o3		!
	or	%o3,%lo(.axr1s),%o3	!
	or	%g0,.axr1e-.axr1s,%o4	!
    .axr1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.axr1cp			!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,.axr1e-.axr1s,%o0	!
.axr0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x4,%g1	! CC=unchange & ILC=1
		add	%g2,0x2,%g2	! update IAR
		ld	[%sp+92],%o0	! struct *guest
    .axr0t0:	add	%o0,64,%o2	! ##TEMPLATE:%imm
    .axr0t1:	add	%o0,64,%o1	! ##TEMPLATE:%imm
		and	%g7,0xf,%o3	! give Program Mask
		st	%g1,[%o0+132]	!
		st	%g2,[%o0+136]	!
		st	%g3,[%o0+140]	!
		st	%g4,[%o0+144]	!
		st	%i7,[%o0+60]	! save Mreg15
		ld	[%sp+100],%i7	! restore return addr.
		sethi	%hi(fl_addsub_ext_norm),%o7
		or	%o7,%lo(fl_addsub_ext_norm),%o7
		jmpl	%o7,%o7		! call library in fltlib.s
		add	%g0,0,%o4	! param5=0(add)
		ld	[%sp+92],%o7	! struct *guest
		ld	[%o7+132],%g1	!
		ld	[%o7+136],%g2	!
		ld	[%o7+140],%g3	!
		ld	[%o7+144],%g4	!
		ld	[%o7+60],%i7	! restore Mreg15
		andn	%g1,0x3,%g1	! CC=0
		and	%o0,0x3,%o1	! extract CC
		or	%g1,%o1,%g1	! CC=retval
		sethi	%hi(0x00ff0000),%o1
		and	%o0,%o1,%o1	! extract exception
		or	%g7,%o1,%g7	! INTR-CODE=retval
		andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.axr0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.axr0e:
.axr1s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x4,%g1	! CC=unchange & ILC=1
		add	%g2,0x2,%g2	! update IAR
		sethi	%hi(0x00060000),%o0
		or	%g7,%o0,%g7	! specification exception
		ba	.axr1e		! retuen(TEMPLATE)
		add	%g1,0x10,%g1	!
.axr1e:

	.section ".text"
	.align	4
	.global cf2_sxr,tf2_sxr
cf2_sxr:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,3,%g0		!
	bnz	.sxr1c			!
	nop				!
    .sxr0c:				!
	retl				! case even:
	add	%g0,.sxr0e-.sxr0s,%o0	!
    .sxr1c:				!
	retl				! case odd:
	add	%g0,.sxr1e-.sxr1s,%o0	!   specification exception
tf2_sxr:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,3,%g0		!
	bnz	.sxr1t			!
	nop				!
    .sxr0t:				!
	sethi	%hi(.sxr0s),%o3		!
	or	%o3,%lo(.sxr0s),%o3	!
	or	%g0,.sxr0e-.sxr0s,%o4	!
    .sxr0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.sxr0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.sxr0t0-.sxr0s],%o5!
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+.sxr0t0-.sxr0s]!
	ld	[%o0+.sxr0t1-.sxr0s],%o5!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+.sxr0t1-.sxr0s]!
	retl				!
	add	%o0,.sxr0e-.sxr0s,%o0	!
    .sxr1t:				!
	sethi	%hi(.sxr1s),%o3		!
	or	%o3,%lo(.sxr1s),%o3	!
	or	%g0,.sxr1e-.sxr1s,%o4	!
    .sxr1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.sxr1cp			!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,.sxr1e-.sxr1s,%o0	!
.sxr0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x4,%g1	! CC=unchange & ILC=1
		add	%g2,0x2,%g2	! update IAR
		ld	[%sp+92],%o0	! struct *guest
    .sxr0t0:	add	%o0,64,%o2	! ##TEMPLATE:%imm
    .sxr0t1:	add	%o0,64,%o1	! ##TEMPLATE:%imm
		and	%g7,0xf,%o3	! give Program Mask
		st	%g1,[%o0+132]	!
		st	%g2,[%o0+136]	!
		st	%g3,[%o0+140]	!
		st	%g4,[%o0+144]	!
		st	%i7,[%o0+60]	! save Mreg15
		ld	[%sp+100],%i7	! restore return addr.
		sethi	%hi(fl_addsub_ext_norm),%o7
		or	%o7,%lo(fl_addsub_ext_norm),%o7
		jmpl	%o7,%o7		! call library in fltlib.s
		add	%g0,1,%o4	! param5=1(sub)
		ld	[%sp+92],%o7	! struct *guest
		ld	[%o7+132],%g1	!
		ld	[%o7+136],%g2	!
		ld	[%o7+140],%g3	!
		ld	[%o7+144],%g4	!
		ld	[%o7+60],%i7	! restore Mreg15
		andn	%g1,0x3,%g1	! CC=0
		and	%o0,0x3,%o1	! extract CC
		or	%g1,%o1,%g1	! CC=retval
		sethi	%hi(0x00ff0000),%o1
		and	%o0,%o1,%o1	! extract exception
		or	%g7,%o1,%g7	! INTR-CODE=retval
		andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.sxr0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.sxr0e:
.sxr1s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x4,%g1	! CC=unchange & ILC=1
		add	%g2,0x2,%g2	! update IAR
		sethi	%hi(0x00060000),%o0
		or	%g7,%o0,%g7	! specification exception
		ba	.sxr1e		! retuen(TEMPLATE)
		add	%g1,0x10,%g1	!
.sxr1e:

	.section ".text"
	.align	4
	.global cf2_ler,tf2_ler
cf2_ler:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	.ler1c			!
	nop				!
    .ler0c:				!
	retl				! case even:
	add	%g0,.ler0e-.ler0s,%o0	!
    .ler1c:				!
	retl				! case odd:
	add	%g0,.ler1e-.ler1s,%o0	!   specification exception
tf2_ler:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	.ler1t			!
	nop				!
    .ler0t:				!
	sethi	%hi(.ler0s),%o3		!
	or	%o3,%lo(.ler0s),%o3	!
	or	%g0,.ler0e-.ler0s,%o4	!
    .ler0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.ler0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.ler0t0-.ler0s],%o5!
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+.ler0t0-.ler0s]!
	ld	[%o0+.ler0t1-.ler0s],%o5!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+.ler0t1-.ler0s]!
	retl				!
	add	%o0,.ler0e-.ler0s,%o0	!
    .ler1t:				!
	sethi	%hi(.ler1s),%o3		!
	or	%o3,%lo(.ler1s),%o3	!
	or	%g0,.ler1e-.ler1s,%o4	!
    .ler1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.ler1cp			!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,.ler1e-.ler1s,%o0	!
.ler0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x4,%g1	! CC=unchange & ILC=1
		add	%g2,0x2,%g2	! update IAR
		ld	[%sp+92],%o7	! struct *guest
    .ler0t0:	ld	[%o7+64],%o0	! ##TEMPLATE:%imm
    .ler0t1:	st	%o0,[%o7+64]	! ##TEMPLATE:%imm
		andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.ler0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.ler0e:
.ler1s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x4,%g1	! CC=unchange & ILC=1
		add	%g2,0x2,%g2	! update IAR
		sethi	%hi(0x00060000),%o0
		or	%g7,%o0,%g7	! specification exception
		ba	.ler1e		! retuen(TEMPLATE)
		add	%g1,0x10,%g1	!
.ler1e:

	.section ".text"
	.align	4
	.global cf2_cer,tf2_cer
cf2_cer:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	.cer1c			!
	nop				!
    .cer0c:				!
	retl				! case even:
	add	%g0,.cer0e-.cer0s,%o0	!
    .cer1c:				!
	retl				! case odd:
	add	%g0,.cer1e-.cer1s,%o0	!   specification exception
tf2_cer:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	.cer1t			!
	nop				!
    .cer0t:				!
	sethi	%hi(.cer0s),%o3		!
	or	%o3,%lo(.cer0s),%o3	!
	or	%g0,.cer0e-.cer0s,%o4	!
    .cer0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.cer0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.cer0t0-.cer0s],%o5!
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+.cer0t0-.cer0s]!
	ld	[%o0+.cer0t1-.cer0s],%o5!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+.cer0t1-.cer0s]!
	retl				!
	add	%o0,.cer0e-.cer0s,%o0	!
    .cer1t:				!
	sethi	%hi(.cer1s),%o3		!
	or	%o3,%lo(.cer1s),%o3	!
	or	%g0,.cer1e-.cer1s,%o4	!
    .cer1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.cer1cp			!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,.cer1e-.cer1s,%o0	!
.cer0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x4,%g1	! CC=unchange & ILC=1
		add	%g2,0x2,%g2	! update IAR
		ld	[%sp+92],%o0	! struct *guest
    .cer0t0:	add	%o0,64,%o2	! ##TEMPLATE:%imm
    .cer0t1:	add	%o0,64,%o1	! ##TEMPLATE:%imm
		and	%g7,0xf,%o3	! give Program Mask
		st	%g1,[%o0+132]	!
		st	%g2,[%o0+136]	!
		st	%g3,[%o0+140]	!
		st	%g4,[%o0+144]	!
		st	%i7,[%o0+60]	! save Mreg15
		ld	[%sp+100],%i7	! restore return addr.
		sethi	%hi(fl_comp_short),%o7
		or	%o7,%lo(fl_comp_short),%o7
		jmpl	%o7,%o7		! call library in fltlib.s
		nop			!
		ld	[%sp+92],%o7	! struct *guest
		ld	[%o7+132],%g1	!
		ld	[%o7+136],%g2	!
		ld	[%o7+140],%g3	!
		ld	[%o7+144],%g4	!
		ld	[%o7+60],%i7	! restore Mreg15
		andn	%g1,0x3,%g1	! CC=0
		or	%g1,%o0,%g1	! CC=retval
		andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.cer0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.cer0e:
.cer1s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x4,%g1	! CC=unchange & ILC=1
		add	%g2,0x2,%g2	! update IAR
		sethi	%hi(0x00060000),%o0
		or	%g7,%o0,%g7	! specification exception
		ba	.cer1e		! retuen(TEMPLATE)
		add	%g1,0x10,%g1	!
.cer1e:

	.section ".text"
	.align	4
	.global cf2_aer,tf2_aer
cf2_aer:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	.aer1c			!
	nop				!
    .aer0c:				!
	retl				! case even:
	add	%g0,.aer0e-.aer0s,%o0	!
    .aer1c:				!
	retl				! case odd:
	add	%g0,.aer1e-.aer1s,%o0	!   specification exception
tf2_aer:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	.aer1t			!
	nop				!
    .aer0t:				!
	sethi	%hi(.aer0s),%o3		!
	or	%o3,%lo(.aer0s),%o3	!
	or	%g0,.aer0e-.aer0s,%o4	!
    .aer0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.aer0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.aer0t0-.aer0s],%o5!
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+.aer0t0-.aer0s]!
	ld	[%o0+.aer0t1-.aer0s],%o5!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+.aer0t1-.aer0s]!
	retl				!
	add	%o0,.aer0e-.aer0s,%o0	!
    .aer1t:				!
	sethi	%hi(.aer1s),%o3		!
	or	%o3,%lo(.aer1s),%o3	!
	or	%g0,.aer1e-.aer1s,%o4	!
    .aer1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.aer1cp			!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,.aer1e-.aer1s,%o0	!
.aer0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x4,%g1	! CC=unchange & ILC=1
		add	%g2,0x2,%g2	! update IAR
		ld	[%sp+92],%o0	! struct *guest
    .aer0t0:	add	%o0,64,%o2	! ##TEMPLATE:%imm
    .aer0t1:	add	%o0,64,%o1	! ##TEMPLATE:%imm
		and	%g7,0xf,%o3	! give Program Mask
		st	%g1,[%o0+132]	!
		st	%g2,[%o0+136]	!
		st	%g3,[%o0+140]	!
		st	%g4,[%o0+144]	!
		st	%i7,[%o0+60]	! save Mreg15
		ld	[%sp+100],%i7	! restore return addr.
		sethi	%hi(fl_addsub_short_norm),%o7
		or	%o7,%lo(fl_addsub_short_norm),%o7
		jmpl	%o7,%o7		! call library in fltlib.s
		add	%g0,0,%o4	! param5=0(add)
		ld	[%sp+92],%o7	! struct *guest
		ld	[%o7+132],%g1	!
		ld	[%o7+136],%g2	!
		ld	[%o7+140],%g3	!
		ld	[%o7+144],%g4	!
		ld	[%o7+60],%i7	! restore Mreg15
		andn	%g1,0x3,%g1	! CC=0
		and	%o0,0x3,%o1	! extract CC
		or	%g1,%o1,%g1	! CC=retval
		sethi	%hi(0x00ff0000),%o1
		and	%o0,%o1,%o1	! extract exception
		or	%g7,%o1,%g7	! INTR-CODE=retval
		andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.aer0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.aer0e:
.aer1s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x4,%g1	! CC=unchange & ILC=1
		add	%g2,0x2,%g2	! update IAR
		sethi	%hi(0x00060000),%o0
		or	%g7,%o0,%g7	! specification exception
		ba	.aer1e		! retuen(TEMPLATE)
		add	%g1,0x10,%g1	!
.aer1e:

	.section ".text"
	.align	4
	.global cf2_ser,tf2_ser
cf2_ser:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	.ser1c			!
	nop				!
    .ser0c:				!
	retl				! case even:
	add	%g0,.ser0e-.ser0s,%o0	!
    .ser1c:				!
	retl				! case odd:
	add	%g0,.ser1e-.ser1s,%o0	!   specification exception
tf2_ser:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	.ser1t			!
	nop				!
    .ser0t:				!
	sethi	%hi(.ser0s),%o3		!
	or	%o3,%lo(.ser0s),%o3	!
	or	%g0,.ser0e-.ser0s,%o4	!
    .ser0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.ser0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.ser0t0-.ser0s],%o5!
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+.ser0t0-.ser0s]!
	ld	[%o0+.ser0t1-.ser0s],%o5!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+.ser0t1-.ser0s]!
	retl				!
	add	%o0,.ser0e-.ser0s,%o0	!
    .ser1t:				!
	sethi	%hi(.ser1s),%o3		!
	or	%o3,%lo(.ser1s),%o3	!
	or	%g0,.ser1e-.ser1s,%o4	!
    .ser1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.ser1cp			!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,.ser1e-.ser1s,%o0	!
.ser0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x4,%g1	! CC=unchange & ILC=1
		add	%g2,0x2,%g2	! update IAR
		ld	[%sp+92],%o0	! struct *guest
    .ser0t0:	add	%o0,64,%o2	! ##TEMPLATE:%imm
    .ser0t1:	add	%o0,64,%o1	! ##TEMPLATE:%imm
		and	%g7,0xf,%o3	! give Program Mask
		st	%g1,[%o0+132]	!
		st	%g2,[%o0+136]	!
		st	%g3,[%o0+140]	!
		st	%g4,[%o0+144]	!
		st	%i7,[%o0+60]	! save Mreg15
		ld	[%sp+100],%i7	! restore return addr.
		sethi	%hi(fl_addsub_short_norm),%o7
		or	%o7,%lo(fl_addsub_short_norm),%o7
		jmpl	%o7,%o7		! call library in fltlib.s
		add	%g0,1,%o4	! param5=1(sub)
		ld	[%sp+92],%o7	! struct *guest
		ld	[%o7+132],%g1	!
		ld	[%o7+136],%g2	!
		ld	[%o7+140],%g3	!
		ld	[%o7+144],%g4	!
		ld	[%o7+60],%i7	! restore Mreg15
		andn	%g1,0x3,%g1	! CC=0
		and	%o0,0x3,%o1	! extract CC
		or	%g1,%o1,%g1	! CC=retval
		sethi	%hi(0x00ff0000),%o1
		and	%o0,%o1,%o1	! extract exception
		or	%g7,%o1,%g7	! INTR-CODE=retval
		andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.ser0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.ser0e:
.ser1s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x4,%g1	! CC=unchange & ILC=1
		add	%g2,0x2,%g2	! update IAR
		sethi	%hi(0x00060000),%o0
		or	%g7,%o0,%g7	! specification exception
		ba	.ser1e		! retuen(TEMPLATE)
		add	%g1,0x10,%g1	!
.ser1e:

	.section ".text"
	.align	4
	.global cf2_mer,tf2_mer
cf2_mer:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	.mer1c			!
	nop				!
    .mer0c:				!
	retl				! case even:
	add	%g0,.mer0e-.mer0s,%o0	!
    .mer1c:				!
	retl				! case odd:
	add	%g0,.mer1e-.mer1s,%o0	!   specification exception
tf2_mer:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	.mer1t			!
	nop				!
    .mer0t:				!
	sethi	%hi(.mer0s),%o3		!
	or	%o3,%lo(.mer0s),%o3	!
	or	%g0,.mer0e-.mer0s,%o4	!
    .mer0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.mer0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.mer0t0-.mer0s],%o5!
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+.mer0t0-.mer0s]!
	ld	[%o0+.mer0t1-.mer0s],%o5!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+.mer0t1-.mer0s]!
	retl				!
	add	%o0,.mer0e-.mer0s,%o0	!
    .mer1t:				!
	sethi	%hi(.mer1s),%o3		!
	or	%o3,%lo(.mer1s),%o3	!
	or	%g0,.mer1e-.mer1s,%o4	!
    .mer1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.mer1cp			!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,.mer1e-.mer1s,%o0	!
.mer0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x4,%g1	! CC=unchange & ILC=1
		add	%g2,0x2,%g2	! update IAR
		ld	[%sp+92],%o0	! struct *guest
    .mer0t0:	add	%o0,64,%o2	! ##TEMPLATE:%imm
    .mer0t1:	add	%o0,64,%o1	! ##TEMPLATE:%imm
		and	%g7,0xf,%o3	! give Program Mask
		st	%g1,[%o0+132]	!
		st	%g2,[%o0+136]	!
		st	%g3,[%o0+140]	!
		st	%g4,[%o0+144]	!
		st	%i7,[%o0+60]	! save Mreg15
		ld	[%sp+100],%i7	! restore return addr.
		sethi	%hi(fl_mult_short2long),%o7
		or	%o7,%lo(fl_mult_short2long),%o7
		jmpl	%o7,%o7		! call library in fltlib.s
		nop			!
		ld	[%sp+92],%o7	! struct *guest
		ld	[%o7+132],%g1	!
		ld	[%o7+136],%g2	!
		ld	[%o7+140],%g3	!
		ld	[%o7+144],%g4	!
		ld	[%o7+60],%i7	! restore Mreg15
		or	%g7,%o0,%g7	! INTR-CODE=retval
		andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.mer0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.mer0e:
.mer1s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x4,%g1	! CC=unchange & ILC=1
		add	%g2,0x2,%g2	! update IAR
		sethi	%hi(0x00060000),%o0
		or	%g7,%o0,%g7	! specification exception
		ba	.mer1e		! retuen(TEMPLATE)
		add	%g1,0x10,%g1	!
.mer1e:

	.section ".text"
	.align	4
	.global cf2_der,tf2_der
cf2_der:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	.der1c			!
	nop				!
    .der0c:				!
	retl				! case even:
	add	%g0,.der0e-.der0s,%o0	!
    .der1c:				!
	retl				! case odd:
	add	%g0,.der1e-.der1s,%o0	!   specification exception
tf2_der:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	.der1t			!
	nop				!
    .der0t:				!
	sethi	%hi(.der0s),%o3		!
	or	%o3,%lo(.der0s),%o3	!
	or	%g0,.der0e-.der0s,%o4	!
    .der0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.der0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.der0t0-.der0s],%o5!
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+.der0t0-.der0s]!
	ld	[%o0+.der0t1-.der0s],%o5!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+.der0t1-.der0s]!
	retl				!
	add	%o0,.der0e-.der0s,%o0	!
    .der1t:				!
	sethi	%hi(.der1s),%o3		!
	or	%o3,%lo(.der1s),%o3	!
	or	%g0,.der1e-.der1s,%o4	!
    .der1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.der1cp			!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,.der1e-.der1s,%o0	!
.der0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x4,%g1	! CC=unchange & ILC=1
		add	%g2,0x2,%g2	! update IAR
		ld	[%sp+92],%o0	! struct *guest
    .der0t0:	add	%o0,64,%o2	! ##TEMPLATE:%imm
    .der0t1:	add	%o0,64,%o1	! ##TEMPLATE:%imm
		and	%g7,0xf,%o3	! give Program Mask
		st	%g1,[%o0+132]	!
		st	%g2,[%o0+136]	!
		st	%g3,[%o0+140]	!
		st	%g4,[%o0+144]	!
		st	%i7,[%o0+60]	! save Mreg15
		ld	[%sp+100],%i7	! restore return addr.
		sethi	%hi(fl_div_short),%o7
		or	%o7,%lo(fl_div_short),%o7
		jmpl	%o7,%o7		! call library in fltlib.s
		nop			!
		ld	[%sp+92],%o7	! struct *guest
		ld	[%o7+132],%g1	!
		ld	[%o7+136],%g2	!
		ld	[%o7+140],%g3	!
		ld	[%o7+144],%g4	!
		ld	[%o7+60],%i7	! restore Mreg15
		or	%g7,%o0,%g7	! INTR-CODE=retval
		andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.der0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.der0e:
.der1s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x4,%g1	! CC=unchange & ILC=1
		add	%g2,0x2,%g2	! update IAR
		sethi	%hi(0x00060000),%o0
		or	%g7,%o0,%g7	! specification exception
		ba	.der1e		! retuen(TEMPLATE)
		add	%g1,0x10,%g1	!
.der1e:

	.section ".text"
	.align	4
	.global cf2_aur,tf2_aur
cf2_aur:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	.aur1c			!
	nop				!
    .aur0c:				!
	retl				! case even:
	add	%g0,.aur0e-.aur0s,%o0	!
    .aur1c:				!
	retl				! case odd:
	add	%g0,.aur1e-.aur1s,%o0	!   specification exception
tf2_aur:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	.aur1t			!
	nop				!
    .aur0t:				!
	sethi	%hi(.aur0s),%o3		!
	or	%o3,%lo(.aur0s),%o3	!
	or	%g0,.aur0e-.aur0s,%o4	!
    .aur0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.aur0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.aur0t0-.aur0s],%o5!
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+.aur0t0-.aur0s]!
	ld	[%o0+.aur0t1-.aur0s],%o5!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+.aur0t1-.aur0s]!
	retl				!
	add	%o0,.aur0e-.aur0s,%o0	!
    .aur1t:				!
	sethi	%hi(.aur1s),%o3		!
	or	%o3,%lo(.aur1s),%o3	!
	or	%g0,.aur1e-.aur1s,%o4	!
    .aur1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.aur1cp			!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,.aur1e-.aur1s,%o0	!
.aur0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x4,%g1	! CC=unchange & ILC=1
		add	%g2,0x2,%g2	! update IAR
		ld	[%sp+92],%o0	! struct *guest
    .aur0t0:	add	%o0,64,%o2	! ##TEMPLATE:%imm
    .aur0t1:	add	%o0,64,%o1	! ##TEMPLATE:%imm
		and	%g7,0xf,%o3	! give Program Mask
		st	%g1,[%o0+132]	!
		st	%g2,[%o0+136]	!
		st	%g3,[%o0+140]	!
		st	%g4,[%o0+144]	!
		st	%i7,[%o0+60]	! save Mreg15
		ld	[%sp+100],%i7	! restore return addr.
		sethi	%hi(fl_addsub_short_unnorm),%o7
		or	%o7,%lo(fl_addsub_short_unnorm),%o7
		jmpl	%o7,%o7		! call library in fltlib.s
		add	%g0,0,%o4	! param5=0(add)
		ld	[%sp+92],%o7	! struct *guest
		ld	[%o7+132],%g1	!
		ld	[%o7+136],%g2	!
		ld	[%o7+140],%g3	!
		ld	[%o7+144],%g4	!
		ld	[%o7+60],%i7	! restore Mreg15
		andn	%g1,0x3,%g1	! CC=0
		and	%o0,0x3,%o1	! extract CC
		or	%g1,%o1,%g1	! CC=retval
		sethi	%hi(0x00ff0000),%o1
		and	%o0,%o1,%o1	! extract exception
		or	%g7,%o1,%g7	! INTR-CODE=retval
		andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.aur0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.aur0e:
.aur1s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x4,%g1	! CC=unchange & ILC=1
		add	%g2,0x2,%g2	! update IAR
		sethi	%hi(0x00060000),%o0
		or	%g7,%o0,%g7	! specification exception
		ba	.aur1e		! retuen(TEMPLATE)
		add	%g1,0x10,%g1	!
.aur1e:

	.section ".text"
	.align	4
	.global cf2_sur,tf2_sur
cf2_sur:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	.sur1c			!
	nop				!
    .sur0c:				!
	retl				! case even:
	add	%g0,.sur0e-.sur0s,%o0	!
    .sur1c:				!
	retl				! case odd:
	add	%g0,.sur1e-.sur1s,%o0	!   specification exception
tf2_sur:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	.sur1t			!
	nop				!
    .sur0t:				!
	sethi	%hi(.sur0s),%o3		!
	or	%o3,%lo(.sur0s),%o3	!
	or	%g0,.sur0e-.sur0s,%o4	!
    .sur0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.sur0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.sur0t0-.sur0s],%o5!
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+.sur0t0-.sur0s]!
	ld	[%o0+.sur0t1-.sur0s],%o5!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+.sur0t1-.sur0s]!
	retl				!
	add	%o0,.sur0e-.sur0s,%o0	!
    .sur1t:				!
	sethi	%hi(.sur1s),%o3		!
	or	%o3,%lo(.sur1s),%o3	!
	or	%g0,.sur1e-.sur1s,%o4	!
    .sur1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.sur1cp			!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,.sur1e-.sur1s,%o0	!
.sur0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x4,%g1	! CC=unchange & ILC=1
		add	%g2,0x2,%g2	! update IAR
		ld	[%sp+92],%o0	! struct *guest
    .sur0t0:	add	%o0,64,%o2	! ##TEMPLATE:%imm
    .sur0t1:	add	%o0,64,%o1	! ##TEMPLATE:%imm
		and	%g7,0xf,%o3	! give Program Mask
		st	%g1,[%o0+132]	!
		st	%g2,[%o0+136]	!
		st	%g3,[%o0+140]	!
		st	%g4,[%o0+144]	!
		st	%i7,[%o0+60]	! save Mreg15
		ld	[%sp+100],%i7	! restore return addr.
		sethi	%hi(fl_addsub_short_unnorm),%o7
		or	%o7,%lo(fl_addsub_short_unnorm),%o7
		jmpl	%o7,%o7		! call library in fltlib.s
		add	%g0,1,%o4	! param5=1(sub)
		ld	[%sp+92],%o7	! struct *guest
		ld	[%o7+132],%g1	!
		ld	[%o7+136],%g2	!
		ld	[%o7+140],%g3	!
		ld	[%o7+144],%g4	!
		ld	[%o7+60],%i7	! restore Mreg15
		andn	%g1,0x3,%g1	! CC=0
		and	%o0,0x3,%o1	! extract CC
		or	%g1,%o1,%g1	! CC=retval
		sethi	%hi(0x00ff0000),%o1
		and	%o0,%o1,%o1	! extract exception
		or	%g7,%o1,%g7	! INTR-CODE=retval
		andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.sur0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.sur0e:
.sur1s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x4,%g1	! CC=unchange & ILC=1
		add	%g2,0x2,%g2	! update IAR
		sethi	%hi(0x00060000),%o0
		or	%g7,%o0,%g7	! specification exception
		ba	.sur1e		! retuen(TEMPLATE)
		add	%g1,0x10,%g1	!
.sur1e:
!================================

!
! templates
! cxx_xxx:
!   %o0: param: none
!	 retval:size of template
!   %o1: M instruction (4 bytes)
!   %o2: work
!   %o3: work
!   %o4: work
!   %o5: flag(0:NON EXECUTE,1:EXECUTE)
! txx_xxx:
!   %o0: param: bufp start address
!	 retval:bufp next start address
!   %o1: M instruction (4 bytes)
!   %o2: work
!   %o3: work
!   %o4: work
!   %o5: flag(0:NON EXECUTE,1:EXECUTE)
!
	.section ".text"
	.align	4
	.global ci4_sth,ti4_sth
ci4_sth:
	retl				!
	add	%g0,.sth0e-.sth0s,%o0	!
ti4_sth:
	sethi	%hi(.sth0s),%o3		!
	or	%o3,%lo(.sth0s),%o3	!
	or	%g0,.sth0e-.sth0s,%o4	!
    .sth0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.sth0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.sth0t0-.sth0s],%o5!
	srl	%o1,16,%o4		!
	andcc	%o4,0xf,%o4		! X2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+.sth0t0-.sth0s]!
	ld	[%o0+.sth0t1-.sth0s],%o5!
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.sth0t1-.sth0s]!
	ld	[%o0+.sth0t2-.sth0s],%o5!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,25,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+.sth0t2-.sth0s]!
	retl				!
	add	%o0,.sth0e-.sth0s,%o0	!
.sth0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
    .sth0t0:	add	%l0,%l0,%o0	! ##TEMPLATE:%l0,%l0
    .sth0t1:	add	%o0,0,%o0	! ##TEMPLATE:imm0
		and	%o0,%g3,%o0	! mask address
    .sth0t2:	sth	%l0,[%g4+%o0]	! ##TEMPLATE:%l0
		andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.sth0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.sth0e:

	.section ".text"
	.align	4
	.global ci4_la,ti4_la
ci4_la:
	retl				!
	add	%g0,.la0e-.la0s,%o0	!
ti4_la:
	sethi	%hi(.la0s),%o3		!
	or	%o3,%lo(.la0s),%o3	!
	or	%g0,.la0e-.la0s,%o4	!
    .la0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.la0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.la0t0-.la0s],%o5	!
	srl	%o1,16,%o4		!
	andcc	%o4,0xf,%o4		! X2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+.la0t0-.la0s]	!
	ld	[%o0+.la0t1-.la0s],%o5	!
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.la0t1-.la0s]	!
	ld	[%o0+.la0t2-.la0s],%o5	!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,25,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+.la0t2-.la0s]	!
	ld	[%o0+.la0t3-.la0s],%o5	!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,25,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+.la0t3-.la0s]	!
	retl				!
	add	%o0,.la0e-.la0s,%o0	!
.la0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
    .la0t0:	add	%l0,%l0,%o0	! ##TEMPLATE:%l0,%l0
    .la0t1:	add	%o0,0,%o0	! ##TEMPLATE:imm0
		andcc	%g7,0x10,%g0	! if AM == 0 then
		sethi	%hi(0x80000000),%o1
		bnz,a	.la000		!   extract lower 24bit
    .la0t2:	andn	%o0,%o1,%l0	! ##TEMPLATE:%l0
		sethi	%hi(0xff000000),%o2
    .la0t3:	andn	%o0,%o2,%l0	! ##TEMPLATE:%l0
    .la000:	andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.la0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.la0e:

	.section ".text"
	.align	4
	.global ci4_stc,ti4_stc
ci4_stc:
	retl				!
	add	%g0,.stc0e-.stc0s,%o0	!
ti4_stc:
	sethi	%hi(.stc0s),%o3		!
	or	%o3,%lo(.stc0s),%o3	!
	or	%g0,.stc0e-.stc0s,%o4	!
    .stc0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.stc0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.stc0t0-.stc0s],%o5!
	srl	%o1,16,%o4		!
	andcc	%o4,0xf,%o4		! X2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+.stc0t0-.stc0s]!
	ld	[%o0+.stc0t1-.stc0s],%o5!
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.stc0t1-.stc0s]!
	ld	[%o0+.stc0t2-.stc0s],%o5!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,25,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+.stc0t2-.stc0s]!
	retl				!
	add	%o0,.stc0e-.stc0s,%o0	!
.stc0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
    .stc0t0:	add	%l0,%l0,%o0	! ##TEMPLATE:%l0,%l0
    .stc0t1:	add	%o0,0,%o0	! ##TEMPLATE:imm0
		and	%o0,%g3,%o0	! mask address
    .stc0t2:	stb	%l0,[%g4+%o0]	! ##TEMPLATE:%l0
		andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.stc0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.stc0e:

	.section ".text"
	.align	4
	.global ci4_ic,ti4_ic
ci4_ic:
	retl				!
	add	%g0,.ic0e-.ic0s,%o0	!
ti4_ic:
	sethi	%hi(.ic0s),%o3		!
	or	%o3,%lo(.ic0s),%o3	!
	or	%g0,.ic0e-.ic0s,%o4	!
    .ic0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.ic0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.ic0t0-.ic0s],%o5	!
	srl	%o1,16,%o4		!
	andcc	%o4,0xf,%o4		! X2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+.ic0t0-.ic0s]	!
	ld	[%o0+.ic0t1-.ic0s],%o5	!
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.ic0t1-.ic0s]	!
	ld	[%o0+.ic0t2-.ic0s],%o5	!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+.ic0t2-.ic0s]	!
	ld	[%o0+.ic0t3-.ic0s],%o5	!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,25,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+.ic0t3-.ic0s]	!
	retl				!
	add	%o0,.ic0e-.ic0s,%o0	!
.ic0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
    .ic0t0:	add	%l0,%l0,%o0	! ##TEMPLATE:%l0,%l0
    .ic0t1:	add	%o0,0,%o0	! ##TEMPLATE:imm0
		and	%o0,%g3,%o0	! mask address
		ldub	[%g4+%o0],%o0	!
    .ic0t2:	andn	%l0,0xff,%o1	! ##TEMPLATE:%l0
    .ic0t3:	or	%o0,%o1,%l0	! ##TEMPLATE:%l0
		andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.ic0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.ic0e:

	.section ".text"
	.align	4
	.global ci4_ex,ti4_ex
ci4_ex:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,0xf,%g0		!
	bnz	.ex1c			!
	nop				!
    .ex0c:				!
	retl				! case 0:
	add	%g0,.ex0e-.ex0s,%o0	!
    .ex1c:				!
	retl				! case not 0:
	add	%g0,.ex1e-.ex1s,%o0	!
ti4_ex:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,0xf,%g0		!
	bnz	.ex1t			!
	nop				!
    .ex0t:				!
	sethi	%hi(.ex0s),%o3		!
	or	%o3,%lo(.ex0s),%o3	!
	or	%g0,.ex0e-.ex0s,%o4	!
    .ex0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.ex0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.ex0t0-.ex0s],%o5	!
	srl	%o1,16,%o4		!
	andcc	%o4,0xf,%o4		! X2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,12,%o4
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+.ex0t0-.ex0s]	!
	ld	[%o0+.ex0t1-.ex0s],%o5	!
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.ex0t1-.ex0s]	!
	retl				!
	add	%o0,.ex0e-.ex0s,%o0	!
    .ex1t:				!
	sethi	%hi(.ex1s),%o3		!
	or	%o3,%lo(.ex1s),%o3	!
	or	%g0,.ex1e-.ex1s,%o4	!
    .ex1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.ex1cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.ex1t0-.ex1s],%o5	!
	srl	%o1,16,%o4		!
	andcc	%o4,0xf,%o4		! X2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+.ex1t0-.ex1s]	!
	ld	[%o0+.ex1t1-.ex1s],%o5	!
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.ex1t1-.ex1s]	!
	ld	[%o0+.ex1t2-.ex1s],%o5	!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+.ex1t2-.ex1s]	!
	retl				!
	add	%o0,.ex1e-.ex1s,%o0	!
.ex0s:
	! retval:%o1:or-value		!
	!	 %o2:D2(X2,B2) address	!
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
    .ex0t0:	add	%l0,%l0,%o2	! ##TEMPLATE:%l0,%l0
    .ex0t1:	add	%o2,0,%o2	! ##TEMPLATE:imm0
		or	%g0,0,%o1	! or-value = 0
		sethi	%hi(trans_ex),%o0
		or	%o0,%lo(trans_ex),%o0
		jmpl	%o0,%g0		! jmp to trans_ex
		nop			!
		bn	.ex0e		! (dummy)
		nop			!
.ex0e:
.ex1s:
	! retval:%o1:or-value		!
	!	 %o2:D2(X2,B2) address	!
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
    .ex1t0:	add	%l0,%l0,%o2	! ##TEMPLATE:%l0,%l0
    .ex1t1:	add	%o2,0,%o2	! ##TEMPLATE:imm0
    .ex1t2:	and	%l0,0xff,%o1	! ##TEMPLATE:%l0
		sethi	%hi(trans_ex),%o0
		or	%o0,%lo(trans_ex),%o0
		jmpl	%o0,%g0		! jmp to trans_ex
		nop			!
		bn	.ex1e		! (dummy)
		nop			!
.ex1e:

	.section ".text"
	.align	4
	.global ci4_bal,ti4_bal
ci4_bal:
	retl				!
	add	%g0,.bal0e-.bal0s,%o0	!
ti4_bal:
	sethi	%hi(.bal0s),%o3		!
	or	%o3,%lo(.bal0s),%o3	!
	or	%g0,.bal0e-.bal0s,%o4	!
    .bal0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.bal0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.bal0t0-.bal0s],%o5!
	srl	%o1,16,%o4		!
	andcc	%o4,0xf,%o4		! X2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+.bal0t0-.bal0s]!
	ld	[%o0+.bal0t1-.bal0s],%o5!
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.bal0t1-.bal0s]!
	ld	[%o0+.bal0t2-.bal0s],%o5!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,25,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+.bal0t2-.bal0s]!
	retl				!
	add	%o0,.bal0e-.bal0s,%o0	!
.bal0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
    .bal0t0:	add	%l0,%l0,%o0	! ##TEMPLATE:%l0,%l0
    .bal0t1:	add	%o0,0,%o0	! ##TEMPLATE:imm0
		andcc	%g7,0x10,%g0	! if AM == 0 then
		bnz	.bal000		!
		sethi	%hi(0xff000000),%o1
		andn	%g2,%o1,%o2	!   24bit address
		and	%g1,0xf,%o1	!   ILC,CC
		sll	%o1,28,%o1	!
		or	%o1,%o2,%o2	!
		and	%g7,0xf,%o1	!   Prog-Mask
		ba	.bal0t2		!
		sll	%o1,24,%o1	!
    .bal000:	sethi	%hi(0x80000000),%o1
		andn	%g2,%o1,%o2	!   31bit address
    .bal0t2:	or	%o1,%o2,%l0	! ##TEMPLATE:%l0
		add	%g0,%o0,%g2	!
		andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.bal0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.bal0e:

	.section ".text"
	.align	4
	.global ci4_bct,ti4_bct
ci4_bct:
	retl				!
	add	%g0,.bct0e-.bct0s,%o0	!
ti4_bct:
	sethi	%hi(.bct0s),%o3		!
	or	%o3,%lo(.bct0s),%o3	!
	or	%g0,.bct0e-.bct0s,%o4	!
    .bct0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.bct0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.bct0t0-.bct0s],%o5!
	srl	%o1,16,%o4		!
	andcc	%o4,0xf,%o4		! X2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+.bct0t0-.bct0s]!
	ld	[%o0+.bct0t1-.bct0s],%o5!
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.bct0t1-.bct0s]!
	ld	[%o0+.bct0t2-.bct0s],%o5!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	sll	%o4,11,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+.bct0t2-.bct0s]!
	retl				!
	add	%o0,.bct0e-.bct0s,%o0	!
.bct0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
    .bct0t0:	add	%l0,%l0,%o0	! ##TEMPLATE:%l0,%l0
    .bct0t1:	add	%o0,0,%o0	! ##TEMPLATE:imm0
    .bct0t2:	subcc	%l0,1,%l0	! ##TEMPLATE:%l0,%l0
		bnz,a	.bct000		! if %l0 != 0 then taken
		add	%g0,%o0,%g2	!
    .bct000:	andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.bct0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.bct0e:

	.section ".text"
	.align	4
	.global ci4_bc,ti4_bc
ci4_bc:
	srl	%o1,20,%o3		! switch (M1)
	andcc	%o3,0xf,%o3		!
	bz	.bc0c			!
	subcc	%o3,0xf,%g0		!
	bne	.bc2c			!
	nop				!
    .bc3c:				!
	retl				! case 15:
	add	%g0,.bc3e-.bc3s,%o0	!
    .bc0c:				!
	sethi	%hi(0x47000fed),%o3	! case 0:
	or	%o3,%lo(0x47000fed),%o3	!
	subcc	%o1,%o3,%g0		!
	be	.bc1c			!
	nop				!
	retl				!   nop
	add	%g0,.bc0e-.bc0s,%o0	!
    .bc1c:				!
	retl				!   emm_call
	add	%g0,.bc1e-.bc1s,%o0	!
    .bc2c:				!
	retl				! case 1-14:
	add	%g0,.bc2e-.bc2s,%o0	!
ti4_bc:
	srl	%o1,20,%o3		! switch (M1)
	andcc	%o3,0xf,%o3		!
	bz	.bc0t			!
	subcc	%o3,0xf,%g0		!
	bne	.bc2t			!
	nop				!
    .bc3t:				!
	sethi	%hi(.bc3s),%o3		!
	or	%o3,%lo(.bc3s),%o3	!
	or	%g0,.bc3e-.bc3s,%o4	!
    .bc3cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.bc3cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.bc3t0-.bc3s],%o5	!
	srl	%o1,16,%o4		!
	andcc	%o4,0xf,%o4		! X2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+.bc3t0-.bc3s]	!
	ld	[%o0+.bc3t1-.bc3s],%o5	!
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.bc3t1-.bc3s]	!
	retl				!
	add	%o0,.bc3e-.bc3s,%o0	!
    .bc0t:				!
	sethi	%hi(0x47000fed),%o3	! case 0:
	or	%o3,%lo(0x47000fed),%o3	!
	subcc	%o1,%o3,%g0		!
	be	.bc1t			!
	nop				!
	sethi	%hi(.bc0s),%o3		!
	or	%o3,%lo(.bc0s),%o3	!
	or	%g0,.bc0e-.bc0s,%o4	!
    .bc0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.bc0cp			!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,.bc0e-.bc0s,%o0	!
    .bc1t:				!
	sethi	%hi(.bc1s),%o3		!
	or	%o3,%lo(.bc1s),%o3	!
	or	%g0,.bc1e-.bc1s,%o4	!
    .bc1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.bc1cp			!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,.bc1e-.bc1s,%o0	!
    .bc2t:				!
	sethi	%hi(.bc2s),%o3		!
	or	%o3,%lo(.bc2s),%o3	!
	or	%g0,.bc2e-.bc2s,%o4	!
    .bc2cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.bc2cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.bc2t0-.bc2s],%o5	!
	srl	%o1,16,%o4		!
	andcc	%o4,0xf,%o4		! X2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+.bc2t0-.bc2s]	!
	ld	[%o0+.bc2t1-.bc2s],%o5	!
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.bc2t1-.bc2s]	!
	ld	[%o0+.bc2t2-.bc2s],%o5	!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! M1
	sll	%o4,8,%o4		! |
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.bc2t2-.bc2s]	!
	retl				!
	add	%o0,.bc2e-.bc2s,%o0	!
.bc3s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
    .bc3t0:	add	%l0,%l0,%o0	! ##TEMPLATE:%l0,%l0
    .bc3t1:	add	%o0,0,%g2	! ##TEMPLATE:imm0
		andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.bc3e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.bc3e:
.bc0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
		andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.bc0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.bc0e:
.bc1s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
		sethi	%hi(0xc0000000),%o0
		or	%g7,%o0,%g7	! extended function (FC=3)
		ba	.bc1e		! return(TEMPLATE)
		add	%g1,0x10,%g1	!
.bc1e:
/* TEMPLATE #1 */
/* BC always returns to trans_main <optable[0x47].term must be 1> */
!.bc2s:
!		andn	%g1,0xc,%g1	!
!		or	%g1,0x8,%g1	! CC=unchange & ILC=2
!		add	%g2,0x4,%g2	! update IAR
!		and	%g1,3,%o1	!
!		srl	%g7,%o1,%o1	! const.0b0001000XXXXXXXX >> %o1
!    .bc2t2:	andcc	%o1,0,%g0	! ##TEMPLATE:imm0
!		bz	.bc200		! if CC is true then taken
!    .bc2t0:	add	%l0,%l0,%o0	! ##TEMPLATE:%l0,%l0
!    .bc2t1:	add	%o0,0,%g2	! ##TEMPLATE:imm0
!    .bc200:	andncc	%g7,0xfff,%g0	! if interruption then
!		bnz	.bc2e		!   return(TEMPLATE)
!		add	%g1,0x10,%g1	!
!.bc2e:
/* TEMPLATE #2 */
/* BC returns to trans_main only if taken <optable[0x47].term must be 2> */
.bc2s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
		and	%g1,3,%o1	!
		srl	%g7,%o1,%o1	! const.0b0001000XXXXXXXX >> %o1
    .bc2t2:	andcc	%o1,0,%g0	! ##TEMPLATE:imm0
		bz	.bc200		! if CC is true then taken
		andncc	%g7,0xfff,%g0	! if interruption then
    .bc2t0:	add	%l0,%l0,%o0	! ##TEMPLATE:%l0,%l0
		bnz	.bc200		!   return
    .bc2t1:	add	%o0,0,%g2	! ##TEMPLATE:imm0
		sethi	%hi(trans_main),%o0
		or	%o0,%lo(trans_main),%o0
		jmpl	%o0,%g0		!
		add	%g1,0x10,%g1	!
    .bc200:	bnz	.bc2e		! return(TEMPLATE)
		add	%g1,0x10,%g1	!
.bc2e:

	.section ".text"
	.align	4
	.global ci4_lh,ti4_lh
ci4_lh:
	retl				!
	add	%g0,.lh0e-.lh0s,%o0	!
ti4_lh:
	sethi	%hi(.lh0s),%o3		!
	or	%o3,%lo(.lh0s),%o3	!
	or	%g0,.lh0e-.lh0s,%o4	!
    .lh0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.lh0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.lh0t0-.lh0s],%o5	!
	srl	%o1,16,%o4		!
	andcc	%o4,0xf,%o4		! X2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+.lh0t0-.lh0s]	!
	ld	[%o0+.lh0t1-.lh0s],%o5	!
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.lh0t1-.lh0s]	!
	ld	[%o0+.lh0t2-.lh0s],%o5	!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,25,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+.lh0t2-.lh0s]	!
	retl				!
	add	%o0,.lh0e-.lh0s,%o0	!
.lh0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
    .lh0t0:	add	%l0,%l0,%o0	! ##TEMPLATE:%l0,%l0
    .lh0t1:	add	%o0,0,%o0	! ##TEMPLATE:imm0
		and	%o0,%g3,%o0	! mask address
    .lh0t2:	ldsh	[%g4+%o0],%l0	! ##TEMPLATE:%l0
		andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.lh0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.lh0e:

	.section ".text"
	.align	4
	.global ci4_ch,ti4_ch
ci4_ch:
	retl				!
	add	%g0,.ch0e-.ch0s,%o0	!
ti4_ch:
	sethi	%hi(.ch0s),%o3		!
	or	%o3,%lo(.ch0s),%o3	!
	or	%g0,.ch0e-.ch0s,%o4	!
    .ch0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.ch0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.ch0t0-.ch0s],%o5	!
	srl	%o1,16,%o4		!
	andcc	%o4,0xf,%o4		! X2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+.ch0t0-.ch0s]	!
	ld	[%o0+.ch0t1-.ch0s],%o5	!
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.ch0t1-.ch0s]	!
	ld	[%o0+.ch0t2-.ch0s],%o5	!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+.ch0t2-.ch0s]	!
	retl				!
	add	%o0,.ch0e-.ch0s,%o0	!
.ch0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
    .ch0t0:	add	%l0,%l0,%o0	! ##TEMPLATE:%l0,%l0
    .ch0t1:	add	%o0,0,%o0	! ##TEMPLATE:imm0
		and	%o0,%g3,%o0	! mask address
		ldsh	[%g4+%o0],%o0	!
		andn	%g1,0x3,%g1	! CC=0
    .ch0t2:	subcc	%l0,%o0,%g0	! ##TEMPLATE:%l0
		bg,a	.ch001		! if %l0 > 0 then
		or	%g1,0x2,%g1	!   CC=2
		bl,a	.ch001		! if %l0 < 0 then
		or	%g1,0x1,%g1	!   CC=1
    .ch001:	andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.ch0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.ch0e:

	.section ".text"
	.align	4
	.global ci4_ah,ti4_ah
ci4_ah:
	retl				!
	add	%g0,.ah0e-.ah0s,%o0	!
ti4_ah:
	sethi	%hi(.ah0s),%o3		!
	or	%o3,%lo(.ah0s),%o3	!
	or	%g0,.ah0e-.ah0s,%o4	!
    .ah0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.ah0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.ah0t0-.ah0s],%o5	!
	srl	%o1,16,%o4		!
	andcc	%o4,0xf,%o4		! X2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+.ah0t0-.ah0s]	!
	ld	[%o0+.ah0t1-.ah0s],%o5	!
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.ah0t1-.ah0s]	!
	ld	[%o0+.ah0t2-.ah0s],%o5	!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	sll	%o4,11,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+.ah0t2-.ah0s]	!
	retl				!
	add	%o0,.ah0e-.ah0s,%o0	!
.ah0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
    .ah0t0:	add	%l0,%l0,%o0	! ##TEMPLATE:%l0,%l0
    .ah0t1:	add	%o0,0,%o0	! ##TEMPLATE:imm0
		and	%o0,%g3,%o0	! mask address
		ldsh	[%g4+%o0],%o0	!
		andn	%g1,0x3,%g1	! CC=0
    .ah0t2:	addcc	%l0,%o0,%l0	! ##TEMPLATE:%l0,%l0
		bvc	.ah000		! if overflow then
		nop			!
		andcc	%g7,8,%g0	!   CC=3
		bz	.ah002		!   if fixed-point overflow mask then
		or	%g1,0x3,%g1	!
		sethi	%hi(0x00080000),%o0
		ba	.ah002		!
		or	%g7,%o0,%g7	!     fixed-point overflow
    .ah000:	bg,a	.ah002		! if %l0 > 0 then
		or	%g1,0x2,%g1	!   CC=2
		bl,a	.ah002		! if %l0 < 0 then
		or	%g1,0x1,%g1	!   CC=1
    .ah002:	andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.ah0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.ah0e:

	.section ".text"
	.align	4
	.global ci4_sh,ti4_sh
ci4_sh:
	retl				!
	add	%g0,.sh0e-.sh0s,%o0	!
ti4_sh:
	sethi	%hi(.sh0s),%o3		!
	or	%o3,%lo(.sh0s),%o3	!
	or	%g0,.sh0e-.sh0s,%o4	!
    .sh0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.sh0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.sh0t0-.sh0s],%o5	!
	srl	%o1,16,%o4		!
	andcc	%o4,0xf,%o4		! X2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+.sh0t0-.sh0s]	!
	ld	[%o0+.sh0t1-.sh0s],%o5	!
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.sh0t1-.sh0s]	!
	ld	[%o0+.sh0t2-.sh0s],%o5	!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	sll	%o4,11,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+.sh0t2-.sh0s]	!
	retl				!
	add	%o0,.sh0e-.sh0s,%o0	!
.sh0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
    .sh0t0:	add	%l0,%l0,%o0	! ##TEMPLATE:%l0,%l0
    .sh0t1:	add	%o0,0,%o0	! ##TEMPLATE:imm0
		and	%o0,%g3,%o0	! mask address
		ldsh	[%g4+%o0],%o0	!
		andn	%g1,0x3,%g1	! CC=0
    .sh0t2:	subcc	%l0,%o0,%l0	! ##TEMPLATE:%l0,%l0
		bvc	.sh000		! if overflow then
		nop			!
		andcc	%g7,8,%g0	!   CC=3
		bz	.sh002		!   if fixed-point overflow mask then
		or	%g1,0x3,%g1	!
		sethi	%hi(0x00080000),%o0
		ba	.sh002		!
		or	%g7,%o0,%g7	!     fixed-point overflow
    .sh000:	bg,a	.sh002		! if %l0 > 0 then
		or	%g1,0x2,%g1	!   CC=2
		bl,a	.sh002		! if %l0 < 0 then
		or	%g1,0x1,%g1	!   CC=1
    .sh002:	andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.sh0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.sh0e:

	.section ".text"
	.align	4
	.global ci4_mh,ti4_mh
ci4_mh:
	retl				!
	add	%g0,.mh0e-.mh0s,%o0	!
ti4_mh:
	sethi	%hi(.mh0s),%o3		!
	or	%o3,%lo(.mh0s),%o3	!
	or	%g0,.mh0e-.mh0s,%o4	!
    .mh0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.mh0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.mh0t0-.mh0s],%o5	!
	srl	%o1,16,%o4		!
	andcc	%o4,0xf,%o4		! X2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+.mh0t0-.mh0s]	!
	ld	[%o0+.mh0t1-.mh0s],%o5	!
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.mh0t1-.mh0s]	!
	ld	[%o0+.mh0t2-.mh0s],%o5	!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	sll	%o4,11,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+.mh0t2-.mh0s]	!
	retl				!
	add	%o0,.mh0e-.mh0s,%o0	!
.mh0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
    .mh0t0:	add	%l0,%l0,%o0	! ##TEMPLATE:%l0,%l0
    .mh0t1:	add	%o0,0,%o0	! ##TEMPLATE:imm0
		and	%o0,%g3,%o0	! mask address
		ldsh	[%g4+%o0],%o0	!
    .mh0t2:	smul	%l0,%o0,%l0	! ##TEMPLATE:%l0,%l0
		andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.mh0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.mh0e:

	.section ".text"
	.align	4
	.global ci4_bas,ti4_bas
ci4_bas:
	retl				!
	add	%g0,.bas0e-.bas0s,%o0	!
ti4_bas:
	sethi	%hi(.bas0s),%o3		!
	or	%o3,%lo(.bas0s),%o3	!
	or	%g0,.bas0e-.bas0s,%o4	!
    .bas0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.bas0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.bas0t0-.bas0s],%o5!
	srl	%o1,16,%o4		!
	andcc	%o4,0xf,%o4		! X2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+.bas0t0-.bas0s]!
	ld	[%o0+.bas0t1-.bas0s],%o5!
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.bas0t1-.bas0s]!
	ld	[%o0+.bas0t2-.bas0s],%o5!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,25,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+.bas0t2-.bas0s]!
	ld	[%o0+.bas0t3-.bas0s],%o5!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,25,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+.bas0t3-.bas0s]!
	retl				!
	add	%o0,.bas0e-.bas0s,%o0	!
.bas0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
    .bas0t0:	add	%l0,%l0,%o0	! ##TEMPLATE:%l0,%l0
    .bas0t1:	add	%o0,0,%o0	! ##TEMPLATE:imm0
		andcc	%g7,0x10,%g0	! if AM == 0 then
		bnz	.bas000		!   24bit address
		sethi	%hi(0xff000000),%o1
		ba	.bas001		!
    .bas0t2:	andn	%g2,%o1,%l0	! ##TEMPLATE:%l0
    .bas000:	sethi	%hi(0x80000000),%o1
		andn	%g2,%o1,%o2	!   31bit address
    .bas0t3:	or	%o1,%o2,%l0	! ##TEMPLATE:%l0
    .bas001:	add	%g0,%o0,%g2	!
		andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.bas0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.bas0e:

	.section ".text"
	.align	4
	.global ci4_cvd,ti4_cvd
ci4_cvd:
	retl				!
	add	%g0,.cvd0e-.cvd0s,%o0	!
ti4_cvd:
	sethi	%hi(.cvd0s),%o3		!
	or	%o3,%lo(.cvd0s),%o3	!
	or	%g0,.cvd0e-.cvd0s,%o4	!
    .cvd0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.cvd0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.cvd0t0-.cvd0s],%o5!
	srl	%o1,16,%o4		!
	andcc	%o4,0xf,%o4		! X2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+.cvd0t0-.cvd0s]!
	ld	[%o0+.cvd0t1-.cvd0s],%o5!
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.cvd0t1-.cvd0s]!
	ld	[%o0+.cvd0t2-.cvd0s],%o5!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	st	%o5,[%o0+.cvd0t2-.cvd0s]!
	retl				!
	add	%o0,.cvd0e-.cvd0s,%o0	!
.cvd0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
    .cvd0t0:	add	%l0,%l0,%o0	! ##TEMPLATE:%l0,%l0
    .cvd0t1:	add	%o0,0,%o0	! ##TEMPLATE:imm0
		and	%o0,%g3,%o0	! mask address
		add	%g4,%o0,%o0	!
		ldub	[%o0],%g0	! force PAGEIN
		ldub	[%o0+7],%g0	! force PAGEIN
		add	%g0,7,%o5	!
    .cvd0t2:	addcc	%g0,%l0,%o1	! ##TEMPLATE:%l0
		bneg,a	.cvd000		!
		sub	%g0,%o1,%o1	!
		add	%g0,0xc,%o4	!
		ba,a	.cvd001		!
    .cvd000:	add	%g0,0xd,%o4	!
    .cvd001:	wr	%g0,0,%y	!
		udiv	%o1,10,%o2	!
		umul	%o2,10,%o3	!
		sub	%o1,%o3,%o3	! remainder
		sll	%o3,4,%o3	!
		or	%o3,%o4,%o4	!
		stb	%o4,[%o0+%o5]	!
		wr	%g0,0,%y	!
		udiv	%o2,10,%o1	!
		umul	%o1,10,%o4	!
		sub	%o2,%o4,%o4	! remainder
		and	%o4,0xf,%o4	!
		subcc	%o1,%g0,%g0	!
		bnz	.cvd001		!
		sub	%o5,1,%o5	!
    .cvd002:	stb	%o4,[%o0+%o5]	!
		subcc	%o5,1,%o5	!
		bpos	.cvd002		!
		add	%g0,0,%o4	!
		andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.cvd0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.cvd0e:

	.section ".text"
	.align	4
	.global ci4_cvb,ti4_cvb
ci4_cvb:
	retl				!
	add	%g0,.cvb0e-.cvb0s,%o0	!
ti4_cvb:
	sethi	%hi(.cvb0s),%o3		!
	or	%o3,%lo(.cvb0s),%o3	!
	or	%g0,.cvb0e-.cvb0s,%o4	!
    .cvb0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.cvb0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.cvb0t0-.cvb0s],%o5!
	srl	%o1,16,%o4		!
	andcc	%o4,0xf,%o4		! X2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+.cvb0t0-.cvb0s]!
	ld	[%o0+.cvb0t1-.cvb0s],%o5!
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.cvb0t1-.cvb0s]!
	ld	[%o0+.cvb0t2-.cvb0s],%o5!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,25,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+.cvb0t2-.cvb0s]!
	retl				!
	add	%o0,.cvb0e-.cvb0s,%o0	!
.cvb0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
    .cvb0t0:	add	%l0,%l0,%o0	! ##TEMPLATE:%l0,%l0
    .cvb0t1:	add	%o0,0,%o0	! ##TEMPLATE:imm0
		and	%o0,%g3,%o0	! mask address
		add	%g4,%o0,%o0	!
		add	%g0,0,%o3	! counter
		add	%g0,0,%o4	! upper half of DIGIMAL NUM
		add	%g0,0,%o5	! lower half of DIGIMAL NUM
		add	%g0,0,%o7	! BINARY NUM
    .cvb000:	ldub	[%o0+%o3],%o1	!
		sll	%o4,8,%o4	!
		srl	%o5,24,%o2	!
		or	%o4,%o2,%o4	!
		sll	%o5,8,%o5	!
		or	%o5,%o1,%o5	! import right most byte
		srl	%o1,4,%o2	!
		umul	%o7,10,%o7	!
		add	%o7,%o2,%o7	!
		subcc	%o2,10,%g0	!
		sethi	%hi(0x00070000),%o2
		bge,a	.cvb004		!
		or	%g7,%o2,%g7	! data exception
		and	%o1,0xf,%o1	!
		subcc	%o3,7,%g0	!
		be,a	.cvb001		!
		andn	%o5,0xf,%o5	!
		umul	%o7,10,%o7	!
		add	%o7,%o1,%o7	!
		subcc	%o1,10,%g0	!
		sethi	%hi(0x00070000),%o2
		bge,a	.cvb004		!
		or	%g7,%o2,%g7	! data exception
		ba	.cvb000		!
		add	%o3,1,%o3	! ---
    .cvb001:	subcc	%o1,0xf,%g0	! if Sign == 0xf then
		bz	.cvb002		!   positive
		sethi	%hi(0x00070000),%o2
		subcc	%o1,0xa,%g0	! if Sign < 0xa then
		bl,a	.cvb004		!
		or	%g7,%o2,%g7	!   data exception
		andcc	%o1,1,%g0	!
    .cvb002:	sethi	%hi(0x00000214),%o0
		or	%o0,%lo(0x00000214),%o0
		sethi	%hi(0x74836400),%o1
		bz,a	.cvb003		! if Sign[31] == 0 then positive
		or	%o1,%lo(0x74836470),%o1
		sub	%g0,%o7,%o7	!		   else negative
		or	%o1,%lo(0x74836480),%o1
    .cvb003:	subcc	%o1,%o5,%g0	!
		subxcc	%o0,%o4,%g0	!
		sethi	%hi(0x00090000),%o2
		blu,a	.cvb0t2		!
		or	%g7,%o2,%g7	! integer-divide exception
    .cvb0t2:	add	%g0,%o7,%l0	! ##TEMPLATE:%l0
    .cvb004:	andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.cvb0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.cvb0e:
!================================

!
! templates
! cxx_xxx:
!   %o0: param: none
!	 retval:size of template
!   %o1: M instruction (4 bytes)
!   %o2: work
!   %o3: work
!   %o4: work
!   %o5: flag(0:NON EXECUTE,1:EXECUTE)
! txx_xxx:
!   %o0: param: bufp start address
!	 retval:bufp next start address
!   %o1: M instruction (4 bytes)
!   %o2: work
!   %o3: work
!   %o4: work
!   %o5: flag(0:NON EXECUTE,1:EXECUTE)
!
	.section ".text"
	.align	4
	.global ci4_st,ti4_st
ci4_st:
	retl				!
	add	%g0,.st0e-.st0s,%o0	!
ti4_st:
	sethi	%hi(.st0s),%o3		!
	or	%o3,%lo(.st0s),%o3	!
	or	%g0,.st0e-.st0s,%o4	!
    .st0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.st0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.st0t0-.st0s],%o5	!
	srl	%o1,16,%o4		!
	andcc	%o4,0xf,%o4		! X2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+.st0t0-.st0s]	!
	ld	[%o0+.st0t1-.st0s],%o5	!
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.st0t1-.st0s]	!
	ld	[%o0+.st0t2-.st0s],%o5	!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,25,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+.st0t2-.st0s]	!
	retl				!
	add	%o0,.st0e-.st0s,%o0	!
.st0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
    .st0t0:	add	%l0,%l0,%o0	! ##TEMPLATE:%l0,%l0
    .st0t1:	add	%o0,0,%o0	! ##TEMPLATE:imm0
		and	%o0,%g3,%o0	! mask address
    .st0t2:	st	%l0,[%g4+%o0]	! ##TEMPLATE:%l0
		andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.st0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.st0e:

	.section ".text"
	.align	4
	.global ci4_flm,ti4_flm
ci4_flm:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	.flm1c			!
	nop				!
    .flm0c:				!
	retl				! case even:
	add	%g0,.flm0e-.flm0s,%o0	!
    .flm1c:				!
	retl				! case odd:
	add	%g0,.flm1e-.flm1s,%o0	!   specification exception
ti4_flm:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	.flm1t			!
	nop				!
    .flm0t:				!
	sethi	%hi(.flm0s),%o3		!
	or	%o3,%lo(.flm0s),%o3	!
	or	%g0,.flm0e-.flm0s,%o4	!
    .flm0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.flm0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.flm0t0-.flm0s],%o5!
	srl	%o1,16,%o4		!
	andcc	%o4,0xf,%o4		! X2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+.flm0t0-.flm0s]!
	ld	[%o0+.flm0t1-.flm0s],%o5!
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.flm0t1-.flm0s]!
	ld	[%o0+.flm0t2-.flm0s],%o5!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1+1
	add	%o4,1,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,25,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+.flm0t2-.flm0s]!
	ld	[%o0+.flm0t3-.flm0s],%o5!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,25,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+.flm0t3-.flm0s]!
	retl				!
	add	%o0,.flm0e-.flm0s,%o0	!
    .flm1t:				!
	sethi	%hi(.flm1s),%o3		!
	or	%o3,%lo(.flm1s),%o3	!
	or	%g0,.flm1e-.flm1s,%o4	!
    .flm1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.flm1cp			!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,.flm1e-.flm1s,%o0	!
.flm0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
    .flm0t0:	add	%l0,%l0,%o0	! ##TEMPLATE:%l0,%l0
    .flm0t1:	add	%o0,0,%o0	! ##TEMPLATE:imm0
		and	%o0,%g3,%o0	! mask address
		ld	[%g4+%o0],%o0	!
		andn	%g1,0x3,%g1	! CC=0
		sethi	%hi(0x80000000),%o1
		add	%g0,0,%o2	! counter
    .flm000:	andcc	%o0,%o1,%g0	! test bit
		bnz,a	.flm0t2		! if 1 is set then
		or	%g1,0x2,%g1	!   CC=2
		srl	%o1,1,%o1	!
		subcc	%o1,0,%g0	!
		bnz	.flm000		! continue
		add	%o2,1,%o2	! update counter
    .flm0t2:	andn	%o0,%o1,%l0	! R1+1 = result
    .flm0t3:	add	%o2,0,%l0	! R1   = position
		andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.flm0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.flm0e:
.flm1s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
		sethi	%hi(0x00060000),%o0
		or	%g7,%o0,%g7	! specification exception
		ba	.flm1e		! retuen(TEMPLATE)
		add	%g1,0x10,%g1	!
.flm1e:

	.section ".text"
	.align	4
	.global ci4_n,ti4_n
ci4_n:
	retl				!
	add	%g0,.n0e-.n0s,%o0	!
ti4_n:
	sethi	%hi(.n0s),%o3		!
	or	%o3,%lo(.n0s),%o3	!
	or	%g0,.n0e-.n0s,%o4	!
    .n0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.n0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.n0t0-.n0s],%o5	!
	srl	%o1,16,%o4		!
	andcc	%o4,0xf,%o4		! X2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+.n0t0-.n0s]	!
	ld	[%o0+.n0t1-.n0s],%o5	!
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.n0t1-.n0s]	!
	ld	[%o0+.n0t2-.n0s],%o5	!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	sll	%o4,11,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+.n0t2-.n0s]	!
	retl				!
	add	%o0,.n0e-.n0s,%o0	!
.n0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
    .n0t0:	add	%l0,%l0,%o0	! ##TEMPLATE:%l0,%l0
    .n0t1:	add	%o0,0,%o0	! ##TEMPLATE:imm0
		and	%o0,%g3,%o0	! mask address
		ld	[%g4+%o0],%o0	!
		andn	%g1,0x3,%g1	! CC=0
    .n0t2:	andcc	%l0,%o0,%l0	! ##TEMPLATE:%l0,%l0
		bnz,a	.n000		! if %l0 != 0 then
		or	%g1,0x1,%g1	!   CC=1
    .n000:	andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.n0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.n0e:

	.section ".text"
	.align	4
	.global ci4_cl,ti4_cl
ci4_cl:
	retl				!
	add	%g0,.cl0e-.cl0s,%o0	!
ti4_cl:
	sethi	%hi(.cl0s),%o3		!
	or	%o3,%lo(.cl0s),%o3	!
	or	%g0,.cl0e-.cl0s,%o4	!
    .cl0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.cl0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.cl0t0-.cl0s],%o5	!
	srl	%o1,16,%o4		!
	andcc	%o4,0xf,%o4		! X2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+.cl0t0-.cl0s]	!
	ld	[%o0+.cl0t1-.cl0s],%o5	!
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.cl0t1-.cl0s]	!
	ld	[%o0+.cl0t2-.cl0s],%o5	!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+.cl0t2-.cl0s]	!
	retl				!
	add	%o0,.cl0e-.cl0s,%o0	!
.cl0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
    .cl0t0:	add	%l0,%l0,%o0	! ##TEMPLATE:%l0,%l0
    .cl0t1:	add	%o0,0,%o0	! ##TEMPLATE:imm0
		and	%o0,%g3,%o0	! mask address
		ld	[%g4+%o0],%o0	!
		andn	%g1,0x3,%g1	! CC=0
    .cl0t2:	subcc	%l0,%o0,%g0	! ##TEMPLATE:%l0
		bgu,a	.cl001		! if %l0 > 0 then
		or	%g1,0x2,%g1	!   CC=2
		bcs,a	.cl001		! if %l0 < 0 then
		or	%g1,0x1,%g1	!   CC=1
    .cl001:	andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.cl0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.cl0e:

	.section ".text"
	.align	4
	.global ci4_o,ti4_o
ci4_o:
	retl				!
	add	%g0,.o0e-.o0s,%o0	!
ti4_o:
	sethi	%hi(.o0s),%o3		!
	or	%o3,%lo(.o0s),%o3	!
	or	%g0,.o0e-.o0s,%o4	!
    .o0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.o0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.o0t0-.o0s],%o5	!
	srl	%o1,16,%o4		!
	andcc	%o4,0xf,%o4		! X2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+.o0t0-.o0s]	!
	ld	[%o0+.o0t1-.o0s],%o5	!
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.o0t1-.o0s]	!
	ld	[%o0+.o0t2-.o0s],%o5	!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	sll	%o4,11,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+.o0t2-.o0s]	!
	retl				!
	add	%o0,.o0e-.o0s,%o0	!
.o0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
    .o0t0:	add	%l0,%l0,%o0	! ##TEMPLATE:%l0,%l0
    .o0t1:	add	%o0,0,%o0	! ##TEMPLATE:imm0
		and	%o0,%g3,%o0	! mask address
		ld	[%g4+%o0],%o0	!
		andn	%g1,0x3,%g1	! CC=0
    .o0t2:	orcc	%l0,%o0,%l0	! ##TEMPLATE:%l0,%l0
		bnz,a	.o000		! if %l0 != 0 then
		or	%g1,0x1,%g1	!   CC=1
    .o000:	andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.o0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.o0e:

	.section ".text"
	.align	4
	.global ci4_x,ti4_x
ci4_x:
	retl				!
	add	%g0,.x0e-.x0s,%o0	!
ti4_x:
	sethi	%hi(.x0s),%o3		!
	or	%o3,%lo(.x0s),%o3	!
	or	%g0,.x0e-.x0s,%o4	!
    .x0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.x0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.x0t0-.x0s],%o5	!
	srl	%o1,16,%o4		!
	andcc	%o4,0xf,%o4		! X2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+.x0t0-.x0s]	!
	ld	[%o0+.x0t1-.x0s],%o5	!
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.x0t1-.x0s]	!
	ld	[%o0+.x0t2-.x0s],%o5	!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	sll	%o4,11,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+.x0t2-.x0s]	!
	retl				!
	add	%o0,.x0e-.x0s,%o0	!
.x0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
    .x0t0:	add	%l0,%l0,%o0	! ##TEMPLATE:%l0,%l0
    .x0t1:	add	%o0,0,%o0	! ##TEMPLATE:imm0
		and	%o0,%g3,%o0	! mask address
		ld	[%g4+%o0],%o0	!
		andn	%g1,0x3,%g1	! CC=0
    .x0t2:	xorcc	%l0,%o0,%l0	! ##TEMPLATE:%l0,%l0
		bnz,a	.x000		! if %l0 != 0 then
		or	%g1,0x1,%g1	!   CC=1
    .x000:	andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.x0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.x0e:

	.section ".text"
	.align	4
	.global ci4_l,ti4_l
ci4_l:
	retl				!
	add	%g0,.l0e-.l0s,%o0	!
ti4_l:
	sethi	%hi(.l0s),%o3		!
	or	%o3,%lo(.l0s),%o3	!
	or	%g0,.l0e-.l0s,%o4	!
    .l0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.l0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.l0t0-.l0s],%o5	!
	srl	%o1,16,%o4		!
	andcc	%o4,0xf,%o4		! X2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+.l0t0-.l0s]	!
	ld	[%o0+.l0t1-.l0s],%o5	!
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.l0t1-.l0s]	!
	ld	[%o0+.l0t2-.l0s],%o5	!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,25,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+.l0t2-.l0s]	!
	retl				!
	add	%o0,.l0e-.l0s,%o0	!
.l0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
    .l0t0:	add	%l0,%l0,%o0	! ##TEMPLATE:%l0,%l0
    .l0t1:	add	%o0,0,%o0	! ##TEMPLATE:imm0
		and	%o0,%g3,%o0	! mask address
    .l0t2:	ld	[%g4+%o0],%l0	! ##TEMPLATE:%l0
		andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.l0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.l0e:

	.section ".text"
	.align	4
	.global ci4_c,ti4_c
ci4_c:
	retl				!
	add	%g0,.c0e-.c0s,%o0	!
ti4_c:
	sethi	%hi(.c0s),%o3		!
	or	%o3,%lo(.c0s),%o3	!
	or	%g0,.c0e-.c0s,%o4	!
    .c0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.c0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.c0t0-.c0s],%o5	!
	srl	%o1,16,%o4		!
	andcc	%o4,0xf,%o4		! X2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+.c0t0-.c0s]	!
	ld	[%o0+.c0t1-.c0s],%o5	!
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.c0t1-.c0s]	!
	ld	[%o0+.c0t2-.c0s],%o5	!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+.c0t2-.c0s]	!
	retl				!
	add	%o0,.c0e-.c0s,%o0	!
.c0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
    .c0t0:	add	%l0,%l0,%o0	! ##TEMPLATE:%l0,%l0
    .c0t1:	add	%o0,0,%o0	! ##TEMPLATE:imm0
		and	%o0,%g3,%o0	! mask address
		ld	[%g4+%o0],%o0	!
		andn	%g1,0x3,%g1	! CC=0
    .c0t2:	subcc	%l0,%o0,%g0	! ##TEMPLATE:%l0
		bg,a	.c001		! if %l0 > 0 then
		or	%g1,0x2,%g1	!   CC=2
		bl,a	.c001		! if %l0 < 0 then
		or	%g1,0x1,%g1	!   CC=1
    .c001:	andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.c0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.c0e:

	.section ".text"
	.align	4
	.global ci4_a,ti4_a
ci4_a:
	retl				!
	add	%g0,.a0e-.a0s,%o0	!
ti4_a:
	sethi	%hi(.a0s),%o3		!
	or	%o3,%lo(.a0s),%o3	!
	or	%g0,.a0e-.a0s,%o4	!
    .a0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.a0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.a0t0-.a0s],%o5	!
	srl	%o1,16,%o4		!
	andcc	%o4,0xf,%o4		! X2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+.a0t0-.a0s]	!
	ld	[%o0+.a0t1-.a0s],%o5	!
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.a0t1-.a0s]	!
	ld	[%o0+.a0t2-.a0s],%o5	!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	sll	%o4,11,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+.a0t2-.a0s]	!
	retl				!
	add	%o0,.a0e-.a0s,%o0	!
.a0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
    .a0t0:	add	%l0,%l0,%o0	! ##TEMPLATE:%l0,%l0
    .a0t1:	add	%o0,0,%o0	! ##TEMPLATE:imm0
		and	%o0,%g3,%o0	! mask address
		ld	[%g4+%o0],%o0	!
		andn	%g1,0x3,%g1	! CC=0
    .a0t2:	addcc	%l0,%o0,%l0	! ##TEMPLATE:%l0,%l0
		bvc	.a000		! if overflow then
		nop			!
		andcc	%g7,8,%g0	!   CC=3
		bz	.a002		!   if fixed-point overflow mask then
		or	%g1,0x3,%g1	!
		sethi	%hi(0x00080000),%o0
		ba	.a002		!
		or	%g7,%o0,%g7	!     fixed-point overflow
    .a000:	bg,a	.a002		! if %l0 > 0 then
		or	%g1,0x2,%g1	!   CC=2
		bl,a	.a002		! if %l0 < 0 then
		or	%g1,0x1,%g1	!   CC=1
    .a002:	andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.a0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.a0e:

	.section ".text"
	.align	4
	.global ci4_s,ti4_s
ci4_s:
	retl				!
	add	%g0,.s0e-.s0s,%o0	!
ti4_s:
	sethi	%hi(.s0s),%o3		!
	or	%o3,%lo(.s0s),%o3	!
	or	%g0,.s0e-.s0s,%o4	!
    .s0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.s0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.s0t0-.s0s],%o5	!
	srl	%o1,16,%o4		!
	andcc	%o4,0xf,%o4		! X2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+.s0t0-.s0s]	!
	ld	[%o0+.s0t1-.s0s],%o5	!
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.s0t1-.s0s]	!
	ld	[%o0+.s0t2-.s0s],%o5	!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	sll	%o4,11,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+.s0t2-.s0s]	!
	retl				!
	add	%o0,.s0e-.s0s,%o0	!
.s0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
    .s0t0:	add	%l0,%l0,%o0	! ##TEMPLATE:%l0,%l0
    .s0t1:	add	%o0,0,%o0	! ##TEMPLATE:imm0
		and	%o0,%g3,%o0	! mask address
		ld	[%g4+%o0],%o0	!
		andn	%g1,0x3,%g1	! CC=0
    .s0t2:	subcc	%l0,%o0,%l0	! ##TEMPLATE:%l0,%l0
		bvc	.s000		! if overflow then
		nop			!
		andcc	%g7,8,%g0	!   CC=3
		bz	.s002		!   if fixed-point overflow mask then
		or	%g1,0x3,%g1	!
		sethi	%hi(0x00080000),%o0
		ba	.s002		!
		or	%g7,%o0,%g7	!     fixed-point overflow
    .s000:	bg,a	.s002		! if %l0 > 0 then
		or	%g1,0x2,%g1	!   CC=2
		bl,a	.s002		! if %l0 < 0 then
		or	%g1,0x1,%g1	!   CC=1
    .s002:	andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.s0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.s0e:

	.section ".text"
	.align	4
	.global ci4_m,ti4_m
ci4_m:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	.m1c			!
	nop				!
    .m0c:				!
	retl				! case even:
	add	%g0,.m0e-.m0s,%o0	!
    .m1c:				!
	retl				! case odd:
	add	%g0,.m1e-.m1s,%o0	!   specification exception
ti4_m:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	.m1t			!
	nop				!
    .m0t:				!
	sethi	%hi(.m0s),%o3		!
	or	%o3,%lo(.m0s),%o3	!
	or	%g0,.m0e-.m0s,%o4	!
    .m0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.m0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.m0t0-.m0s],%o5	!
	srl	%o1,16,%o4		!
	andcc	%o4,0xf,%o4		! X2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+.m0t0-.m0s]	!
	ld	[%o0+.m0t1-.m0s],%o5	!
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.m0t1-.m0s]	!
	ld	[%o0+.m0t2-.m0s],%o5	!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1+1
	add	%o4,1,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	sll	%o4,11,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+.m0t2-.m0s]	!
	ld	[%o0+.m0t3-.m0s],%o5	!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,25,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+.m0t3-.m0s]	!
	retl				!
	add	%o0,.m0e-.m0s,%o0	!
    .m1t:				!
	sethi	%hi(.m1s),%o3		!
	or	%o3,%lo(.m1s),%o3	!
	or	%g0,.m1e-.m1s,%o4	!
    .m1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.m1cp			!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,.m1e-.m1s,%o0	!
.m0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
    .m0t0:	add	%l0,%l0,%o0	! ##TEMPLATE:%l0,%l0
    .m0t1:	add	%o0,0,%o0	! ##TEMPLATE:imm0
		and	%o0,%g3,%o0	! mask address
		ld	[%g4+%o0],%o0	!
    .m0t2:	smul	%l0,%o0,%l0	! ##TEMPLATE:%l0,%l0
    .m0t3:	rd	%y,%l0		! ##TEMPLATE:%l0
		andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.m0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.m0e:
.m1s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
		sethi	%hi(0x00060000),%o0
		or	%g7,%o0,%g7	! specification exception
		ba	.m1e		! retuen(TEMPLATE)
		add	%g1,0x10,%g1	!
.m1e:

	.section ".text"
	.align	4
	.global ci4_d,ti4_d
ci4_d:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	.d1c			!
	nop				!
    .d0c:				!
	retl				! case even:
	add	%g0,.d0e-.d0s,%o0	!
    .d1c:				!
	retl				! case odd:
	add	%g0,.d1e-.d1s,%o0	!   specification exception
ti4_d:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	.d1t			!
	nop				!
    .d0t:				!
	sethi	%hi(.d0s),%o3		!
	or	%o3,%lo(.d0s),%o3	!
	or	%g0,.d0e-.d0s,%o4	!
    .d0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.d0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.d0t0-.d0s],%o5	!
	srl	%o1,16,%o4		!
	andcc	%o4,0xf,%o4		! X2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+.d0t0-.d0s]	!
	ld	[%o0+.d0t1-.d0s],%o5	!
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.d0t1-.d0s]	!
	ld	[%o0+.d0t2-.d0s],%o5	!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	st	%o5,[%o0+.d0t2-.d0s]	!
	ld	[%o0+.d0t3-.d0s],%o5	!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1+1
	add	%o4,1,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+.d0t3-.d0s]	!
	ld	[%o0+.d0t4-.d0s],%o5	!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1+1
	add	%o4,1,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,25,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+.d0t4-.d0s]	!
	ld	[%o0+.d0t5-.d0s],%o5	!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1+1
	add	%o4,1,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,25,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+.d0t5-.d0s]	!
	retl				!
	add	%o0,.d0e-.d0s,%o0	!
    .d1t:				!
	sethi	%hi(.d1s),%o3		!
	or	%o3,%lo(.d1s),%o3	!
	or	%g0,.d1e-.d1s,%o4	!
    .d1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.d1cp			!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,.d1e-.d1s,%o0	!
.d0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
    .d0t0:	add	%l0,%l0,%o0	! ##TEMPLATE:%l0,%l0
    .d0t1:	add	%o0,0,%o0	! ##TEMPLATE:imm0
		and	%o0,%g3,%o0	! mask address
		ld	[%g4+%o0],%o0	!
		addcc	%g0,%o0,%g0	!
		bz	.d000		! if R2==0 then int-div. exception
    .d0t2:	wr	%g0,%l0,%y	! ##TEMPLATE:%l0     R1
    .d0t3:	sdivcc	%l0,%o0,%o1	! ##TEMPLATE:%l0     R1+1
		bvs	.d000		! if overflow then int-div.
		smul	%o1,%o0,%o2	!
    .d0t4:	sub	%l0,%o2,%l0	! ##TEMPLATE:%l0,%l0 R1+1,R1
		ba	.d001		!
    .d0t5:	add	%g0,%o1,%l0	! ##TEMPLATE:%l0     R1+1
    .d000:	sethi	%hi(0x00090000),%o0
		or	%g7,%o0,%g7	! int-div. exception
    .d001:	andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.d0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.d0e:
.d1s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
		sethi	%hi(0x00060000),%o0
		or	%g7,%o0,%g7	! specification exception
		ba	.d1e		! retuen(TEMPLATE)
		add	%g1,0x10,%g1	!
.d1e:

	.section ".text"
	.align	4
	.global ci4_al,ti4_al
ci4_al:
	retl				!
	add	%g0,.al0e-.al0s,%o0	!
ti4_al:
	sethi	%hi(.al0s),%o3		!
	or	%o3,%lo(.al0s),%o3	!
	or	%g0,.al0e-.al0s,%o4	!
    .al0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.al0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.al0t0-.al0s],%o5	!
	srl	%o1,16,%o4		!
	andcc	%o4,0xf,%o4		! X2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+.al0t0-.al0s]	!
	ld	[%o0+.al0t1-.al0s],%o5	!
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.al0t1-.al0s]	!
	ld	[%o0+.al0t2-.al0s],%o5	!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	sll	%o4,11,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+.al0t2-.al0s]	!
	retl				!
	add	%o0,.al0e-.al0s,%o0	!
.al0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
    .al0t0:	add	%l0,%l0,%o0	! ##TEMPLATE:%l0,%l0
    .al0t1:	add	%o0,0,%o0	! ##TEMPLATE:imm0
		and	%o0,%g3,%o0	! mask address
		ld	[%g4+%o0],%o0	!
		andn	%g1,0x3,%g1	! CC=0
    .al0t2:	addcc	%l0,%o0,%l0	! ##TEMPLATE:%l0,%l0
		bcs,a	.al000		! if carry then
		or	%g1,0x2,%g1	!   CC|=2 & skip
		bnz,a	.al001		! if %l0 != 0 then
		or	%g1,0x1,%g1	!   CC=1
		ba	.al001		!
		nop			!
    .al000:	bnz,a	.al001		! if %l0 != 0 then
		or	%g1,0x1,%g1	!   CC=3
    .al001:	andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.al0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.al0e:

	.section ".text"
	.align	4
	.global ci4_sl,ti4_sl
ci4_sl:
	retl				!
	add	%g0,.sl0e-.sl0s,%o0	!
ti4_sl:
	sethi	%hi(.sl0s),%o3		!
	or	%o3,%lo(.sl0s),%o3	!
	or	%g0,.sl0e-.sl0s,%o4	!
    .sl0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.sl0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.sl0t0-.sl0s],%o5	!
	srl	%o1,16,%o4		!
	andcc	%o4,0xf,%o4		! X2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+.sl0t0-.sl0s]	!
	ld	[%o0+.sl0t1-.sl0s],%o5	!
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.sl0t1-.sl0s]	!
	ld	[%o0+.sl0t2-.sl0s],%o5	!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	sll	%o4,11,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+.sl0t2-.sl0s]	!
	retl				!
	add	%o0,.sl0e-.sl0s,%o0	!
.sl0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
    .sl0t0:	add	%l0,%l0,%o0	! ##TEMPLATE:%l0,%l0
    .sl0t1:	add	%o0,0,%o0	! ##TEMPLATE:imm0
		and	%o0,%g3,%o0	! mask address
		ld	[%g4+%o0],%o0	!
		andn	%g1,0x3,%g1	! CC=0
    .sl0t2:	subcc	%l0,%o0,%l0	! ##TEMPLATE:%l0,%l0
		bcc,a	.sl000		! if !carry then
		or	%g1,0x2,%g1	!   CC|=2 & skip
		bnz,a	.sl001		! if %l0 != 0 then
		or	%g1,0x1,%g1	!   CC=1
		ba	.sl001		!
		nop			!
    .sl000:	bnz,a	.sl001		! if %l0 != 0 then
		or	%g1,0x1,%g1	!   CC=3
    .sl001:	andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.sl0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.sl0e:
!================================

!
! templates
! cxx_xxx:
!   %o0: param: none
!	 retval:size of template
!   %o1: M instruction (4 bytes)
!   %o2: work
!   %o3: work
!   %o4: work
!   %o5: flag(0:NON EXECUTE,1:EXECUTE)
! txx_xxx:
!   %o0: param: bufp start address
!	 retval:bufp next start address
!   %o1: M instruction (4 bytes)
!   %o2: work
!   %o3: work
!   %o4: work
!   %o5: flag(0:NON EXECUTE,1:EXECUTE)
!
	.section ".text"
	.align	4
	.global cf4_std,tf4_std
cf4_std:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	.std1c			!
	nop				!
    .std0c:				!
	retl				! case even:
	add	%g0,.std0e-.std0s,%o0	!
    .std1c:				!
	retl				! case odd:
	add	%g0,.std1e-.std1s,%o0	!   specification exception
tf4_std:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	.std1t			!
	nop				!
    .std0t:				!
	sethi	%hi(.std0s),%o3		!
	or	%o3,%lo(.std0s),%o3	!
	or	%g0,.std0e-.std0s,%o4	!
    .std0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.std0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.std0t0-.std0s],%o5!
	srl	%o1,16,%o4		!
	andcc	%o4,0xf,%o4		! X2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+.std0t0-.std0s]!
	ld	[%o0+.std0t1-.std0s],%o5!
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.std0t1-.std0s]!
	ld	[%o0+.std0t2-.std0s],%o5!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+.std0t2-.std0s]!
	retl				!
	add	%o0,.std0e-.std0s,%o0	!
    .std1t:				!
	sethi	%hi(.std1s),%o3		!
	or	%o3,%lo(.std1s),%o3	!
	or	%g0,.std1e-.std1s,%o4	!
    .std1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.std1cp			!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,.std1e-.std1s,%o0	!
.std0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
		ld	[%sp+92],%o7	! struct *guest
    .std0t0:	add	%l0,%l0,%o0	! ##TEMPLATE:%l0,%l0
    .std0t1:	add	%o0,0,%o0	! ##TEMPLATE:imm0
		and	%o0,%g3,%o0	! mask address
    .std0t2:	ldd	[%o7+64],%o2	! ##TEMPLATE:%imm
		st	%o2,[%g4+%o0]	! store upper word
		add	%o0,4,%o0	!
		st	%o3,[%g4+%o0]	! store lower word
		andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.std0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.std0e:
.std1s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
		sethi	%hi(0x00060000),%o0
		or	%g7,%o0,%g7	! specification exception
		ba	.std1e		! retuen(TEMPLATE)
		add	%g1,0x10,%g1	!
.std1e:

	.section ".text"
	.align	4
	.global cf4_mxd,tf4_mxd
cf4_mxd:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,3,%g0		!
	bnz	.mxd1c			!
	nop				!
    .mxd0c:				!
	retl				! case even:
	add	%g0,.mxd0e-.mxd0s,%o0	!
    .mxd1c:				!
	retl				! case odd:
	add	%g0,.mxd1e-.mxd1s,%o0	!   specification exception
tf4_mxd:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,3,%g0		!
	bnz	.mxd1t			!
	nop				!
    .mxd0t:				!
	sethi	%hi(.mxd0s),%o3		!
	or	%o3,%lo(.mxd0s),%o3	!
	or	%g0,.mxd0e-.mxd0s,%o4	!
    .mxd0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.mxd0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.mxd0t0-.mxd0s],%o5!
	srl	%o1,16,%o4		!
	andcc	%o4,0xf,%o4		! X2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+.mxd0t0-.mxd0s]!
	ld	[%o0+.mxd0t1-.mxd0s],%o5!
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.mxd0t1-.mxd0s]!
	ld	[%o0+.mxd0t2-.mxd0s],%o5!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+.mxd0t2-.mxd0s]!
	retl				!
	add	%o0,.mxd0e-.mxd0s,%o0	!
    .mxd1t:				!
	sethi	%hi(.mxd1s),%o3		!
	or	%o3,%lo(.mxd1s),%o3	!
	or	%g0,.mxd1e-.mxd1s,%o4	!
    .mxd1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.mxd1cp			!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,.mxd1e-.mxd1s,%o0	!
.mxd0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
		ld	[%sp+92],%o0	! struct *guest
    .mxd0t0:	add	%l0,%l0,%o2	! ##TEMPLATE:%l0,%l0
    .mxd0t1:	add	%o2,0,%o2	! ##TEMPLATE:imm0
		and	%o2,%g3,%o2	! mask address
		add	%g4,%o2,%o2	!
    .mxd0t2:	add	%o0,64,%o1	! ##TEMPLATE:%imm
		and	%g7,0xf,%o3	! give Program Mask
		st	%g1,[%o0+132]	!
		st	%g2,[%o0+136]	!
		st	%g3,[%o0+140]	!
		st	%g4,[%o0+144]	!
		st	%i7,[%o0+60]	! save Mreg15
		ld	[%sp+100],%i7	! restore return addr.
		sethi	%hi(fl_mult_long2ext),%o7
		or	%o7,%lo(fl_mult_long2ext),%o7
		jmpl	%o7,%o7		! call library in fltlib.s
		nop			!
		ld	[%sp+92],%o7	! struct *guest
		ld	[%o7+132],%g1	!
		ld	[%o7+136],%g2	!
		ld	[%o7+140],%g3	!
		ld	[%o7+144],%g4	!
		ld	[%o7+60],%i7	! restore Mreg15
		or	%g7,%o0,%g7	! INTR-CODE=retval
		andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.mxd0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.mxd0e:
.mxd1s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
		sethi	%hi(0x00060000),%o0
		or	%g7,%o0,%g7	! specification exception
		ba	.mxd1e		! retuen(TEMPLATE)
		add	%g1,0x10,%g1	!
.mxd1e:

	.section ".text"
	.align	4
	.global cf4_ld,tf4_ld
cf4_ld:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	.ld1c			!
	nop				!
    .ld0c:				!
	retl				! case even:
	add	%g0,.ld0e-.ld0s,%o0	!
    .ld1c:				!
	retl				! case odd:
	add	%g0,.ld1e-.ld1s,%o0	!   specification exception
tf4_ld:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	.ld1t			!
	nop				!
    .ld0t:				!
	sethi	%hi(.ld0s),%o3		!
	or	%o3,%lo(.ld0s),%o3	!
	or	%g0,.ld0e-.ld0s,%o4	!
    .ld0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.ld0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.ld0t0-.ld0s],%o5	!
	srl	%o1,16,%o4		!
	andcc	%o4,0xf,%o4		! X2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+.ld0t0-.ld0s]	!
	ld	[%o0+.ld0t1-.ld0s],%o5	!
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.ld0t1-.ld0s]	!
	ld	[%o0+.ld0t2-.ld0s],%o5	!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+.ld0t2-.ld0s]	!
	retl				!
	add	%o0,.ld0e-.ld0s,%o0	!
    .ld1t:				!
	sethi	%hi(.ld1s),%o3		!
	or	%o3,%lo(.ld1s),%o3	!
	or	%g0,.ld1e-.ld1s,%o4	!
    .ld1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.ld1cp			!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,.ld1e-.ld1s,%o0	!
.ld0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
		ld	[%sp+92],%o7	! struct *guest
    .ld0t0:	add	%l0,%l0,%o0	! ##TEMPLATE:%l0,%l0
    .ld0t1:	add	%o0,0,%o0	! ##TEMPLATE:imm0
		and	%o0,%g3,%o0	! mask address
		ld	[%g4+%o0],%o2	! load upper word
		add	%o0,4,%o0	!
		ld	[%g4+%o0],%o3	! load lower word
    .ld0t2:	std	%o2,[%o7+64]	! ##TEMPLATE:%imm
		andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.ld0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.ld0e:
.ld1s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
		sethi	%hi(0x00060000),%o0
		or	%g7,%o0,%g7	! specification exception
		ba	.ld1e		! retuen(TEMPLATE)
		add	%g1,0x10,%g1	!
.ld1e:

	.section ".text"
	.align	4
	.global cf4_cd,tf4_cd
cf4_cd:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	.cd1c			!
	nop				!
    .cd0c:				!
	retl				! case even:
	add	%g0,.cd0e-.cd0s,%o0	!
    .cd1c:				!
	retl				! case odd:
	add	%g0,.cd1e-.cd1s,%o0	!   specification exception
tf4_cd:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	.cd1t			!
	nop				!
    .cd0t:				!
	sethi	%hi(.cd0s),%o3		!
	or	%o3,%lo(.cd0s),%o3	!
	or	%g0,.cd0e-.cd0s,%o4	!
    .cd0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.cd0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.cd0t0-.cd0s],%o5	!
	srl	%o1,16,%o4		!
	andcc	%o4,0xf,%o4		! X2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+.cd0t0-.cd0s]	!
	ld	[%o0+.cd0t1-.cd0s],%o5	!
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.cd0t1-.cd0s]	!
	ld	[%o0+.cd0t2-.cd0s],%o5	!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+.cd0t2-.cd0s]	!
	retl				!
	add	%o0,.cd0e-.cd0s,%o0	!
    .cd1t:				!
	sethi	%hi(.cd1s),%o3		!
	or	%o3,%lo(.cd1s),%o3	!
	or	%g0,.cd1e-.cd1s,%o4	!
    .cd1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.cd1cp			!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,.cd1e-.cd1s,%o0	!
.cd0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
		ld	[%sp+92],%o0	! struct *guest
    .cd0t0:	add	%l0,%l0,%o2	! ##TEMPLATE:%l0,%l0
    .cd0t1:	add	%o2,0,%o2	! ##TEMPLATE:imm0
		and	%o2,%g3,%o2	! mask address
		add	%g4,%o2,%o2	!
    .cd0t2:	add	%o0,64,%o1	! ##TEMPLATE:%imm
		and	%g7,0xf,%o3	! give Program Mask
		st	%g1,[%o0+132]	!
		st	%g2,[%o0+136]	!
		st	%g3,[%o0+140]	!
		st	%g4,[%o0+144]	!
		st	%i7,[%o0+60]	! save Mreg15
		ld	[%sp+100],%i7	! restore return addr.
		sethi	%hi(fl_comp_long),%o7
		or	%o7,%lo(fl_comp_long),%o7
		jmpl	%o7,%o7		! call library in fltlib.s
		nop			!
		ld	[%sp+92],%o7	! struct *guest
		ld	[%o7+132],%g1	!
		ld	[%o7+136],%g2	!
		ld	[%o7+140],%g3	!
		ld	[%o7+144],%g4	!
		ld	[%o7+60],%i7	! restore Mreg15
		andn	%g1,0x3,%g1	! CC=0
		or	%g1,%o0,%g1	! CC=retval
		andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.cd0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.cd0e:
.cd1s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
		sethi	%hi(0x00060000),%o0
		or	%g7,%o0,%g7	! specification exception
		ba	.cd1e		! retuen(TEMPLATE)
		add	%g1,0x10,%g1	!
.cd1e:

	.section ".text"
	.align	4
	.global cf4_ad,tf4_ad
cf4_ad:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	.ad1c			!
	nop				!
    .ad0c:				!
	retl				! case even:
	add	%g0,.ad0e-.ad0s,%o0	!
    .ad1c:				!
	retl				! case odd:
	add	%g0,.ad1e-.ad1s,%o0	!   specification exception
tf4_ad:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	.ad1t			!
	nop				!
    .ad0t:				!
	sethi	%hi(.ad0s),%o3		!
	or	%o3,%lo(.ad0s),%o3	!
	or	%g0,.ad0e-.ad0s,%o4	!
    .ad0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.ad0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.ad0t0-.ad0s],%o5	!
	srl	%o1,16,%o4		!
	andcc	%o4,0xf,%o4		! X2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+.ad0t0-.ad0s]	!
	ld	[%o0+.ad0t1-.ad0s],%o5	!
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.ad0t1-.ad0s]	!
	ld	[%o0+.ad0t2-.ad0s],%o5	!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+.ad0t2-.ad0s]	!
	retl				!
	add	%o0,.ad0e-.ad0s,%o0	!
    .ad1t:				!
	sethi	%hi(.ad1s),%o3		!
	or	%o3,%lo(.ad1s),%o3	!
	or	%g0,.ad1e-.ad1s,%o4	!
    .ad1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.ad1cp			!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,.ad1e-.ad1s,%o0	!
.ad0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
		ld	[%sp+92],%o0	! struct *guest
    .ad0t0:	add	%l0,%l0,%o2	! ##TEMPLATE:%l0,%l0
    .ad0t1:	add	%o2,0,%o2	! ##TEMPLATE:imm0
		and	%o2,%g3,%o2	! mask address
		add	%g4,%o2,%o2	!
    .ad0t2:	add	%o0,64,%o1	! ##TEMPLATE:%imm
		and	%g7,0xf,%o3	! give Program Mask
		st	%g1,[%o0+132]	!
		st	%g2,[%o0+136]	!
		st	%g3,[%o0+140]	!
		st	%g4,[%o0+144]	!
		st	%i7,[%o0+60]	! save Mreg15
		ld	[%sp+100],%i7	! restore return addr.
		sethi	%hi(fl_addsub_long_norm),%o7
		or	%o7,%lo(fl_addsub_long_norm),%o7
		jmpl	%o7,%o7		! call library in fltlib.s
		add	%g0,0,%o4	! param5=0(add)
		ld	[%sp+92],%o7	! struct *guest
		ld	[%o7+132],%g1	!
		ld	[%o7+136],%g2	!
		ld	[%o7+140],%g3	!
		ld	[%o7+144],%g4	!
		ld	[%o7+60],%i7	! restore Mreg15
		andn	%g1,0x3,%g1	! CC=0
		and	%o0,0x3,%o1	! extract CC
		or	%g1,%o1,%g1	! CC=retval
		sethi	%hi(0x00ff0000),%o1
		and	%o0,%o1,%o1	! extract exception
		or	%g7,%o1,%g7	! INTR-CODE=retval
		andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.ad0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.ad0e:
.ad1s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
		sethi	%hi(0x00060000),%o0
		or	%g7,%o0,%g7	! specification exception
		ba	.ad1e		! retuen(TEMPLATE)
		add	%g1,0x10,%g1	!
.ad1e:

	.section ".text"
	.align	4
	.global cf4_sd,tf4_sd
cf4_sd:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	.sd1c			!
	nop				!
    .sd0c:				!
	retl				! case even:
	add	%g0,.sd0e-.sd0s,%o0	!
    .sd1c:				!
	retl				! case odd:
	add	%g0,.sd1e-.sd1s,%o0	!   specification exception
tf4_sd:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	.sd1t			!
	nop				!
    .sd0t:				!
	sethi	%hi(.sd0s),%o3		!
	or	%o3,%lo(.sd0s),%o3	!
	or	%g0,.sd0e-.sd0s,%o4	!
    .sd0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.sd0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.sd0t0-.sd0s],%o5	!
	srl	%o1,16,%o4		!
	andcc	%o4,0xf,%o4		! X2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+.sd0t0-.sd0s]	!
	ld	[%o0+.sd0t1-.sd0s],%o5	!
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.sd0t1-.sd0s]	!
	ld	[%o0+.sd0t2-.sd0s],%o5	!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+.sd0t2-.sd0s]	!
	retl				!
	add	%o0,.sd0e-.sd0s,%o0	!
    .sd1t:				!
	sethi	%hi(.sd1s),%o3		!
	or	%o3,%lo(.sd1s),%o3	!
	or	%g0,.sd1e-.sd1s,%o4	!
    .sd1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.sd1cp			!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,.sd1e-.sd1s,%o0	!
.sd0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
		ld	[%sp+92],%o0	! struct *guest
    .sd0t0:	add	%l0,%l0,%o2	! ##TEMPLATE:%l0,%l0
    .sd0t1:	add	%o2,0,%o2	! ##TEMPLATE:imm0
		and	%o2,%g3,%o2	! mask address
		add	%g4,%o2,%o2	!
    .sd0t2:	add	%o0,64,%o1	! ##TEMPLATE:%imm
		and	%g7,0xf,%o3	! give Program Mask
		st	%g1,[%o0+132]	!
		st	%g2,[%o0+136]	!
		st	%g3,[%o0+140]	!
		st	%g4,[%o0+144]	!
		st	%i7,[%o0+60]	! save Mreg15
		ld	[%sp+100],%i7	! restore return addr.
		sethi	%hi(fl_addsub_long_norm),%o7
		or	%o7,%lo(fl_addsub_long_norm),%o7
		jmpl	%o7,%o7		! call library in fltlib.s
		add	%g0,1,%o4	! param5=1(sub)
		ld	[%sp+92],%o7	! struct *guest
		ld	[%o7+132],%g1	!
		ld	[%o7+136],%g2	!
		ld	[%o7+140],%g3	!
		ld	[%o7+144],%g4	!
		ld	[%o7+60],%i7	! restore Mreg15
		andn	%g1,0x3,%g1	! CC=0
		and	%o0,0x3,%o1	! extract CC
		or	%g1,%o1,%g1	! CC=retval
		sethi	%hi(0x00ff0000),%o1
		and	%o0,%o1,%o1	! extract exception
		or	%g7,%o1,%g7	! INTR-CODE=retval
		andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.sd0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.sd0e:
.sd1s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
		sethi	%hi(0x00060000),%o0
		or	%g7,%o0,%g7	! specification exception
		ba	.sd1e		! retuen(TEMPLATE)
		add	%g1,0x10,%g1	!
.sd1e:

	.section ".text"
	.align	4
	.global cf4_md,tf4_md
cf4_md:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	.md1c			!
	nop				!
    .md0c:				!
	retl				! case even:
	add	%g0,.md0e-.md0s,%o0	!
    .md1c:				!
	retl				! case odd:
	add	%g0,.md1e-.md1s,%o0	!   specification exception
tf4_md:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	.md1t			!
	nop				!
    .md0t:				!
	sethi	%hi(.md0s),%o3		!
	or	%o3,%lo(.md0s),%o3	!
	or	%g0,.md0e-.md0s,%o4	!
    .md0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.md0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.md0t0-.md0s],%o5	!
	srl	%o1,16,%o4		!
	andcc	%o4,0xf,%o4		! X2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+.md0t0-.md0s]	!
	ld	[%o0+.md0t1-.md0s],%o5	!
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.md0t1-.md0s]	!
	ld	[%o0+.md0t2-.md0s],%o5	!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+.md0t2-.md0s]	!
	retl				!
	add	%o0,.md0e-.md0s,%o0	!
    .md1t:				!
	sethi	%hi(.md1s),%o3		!
	or	%o3,%lo(.md1s),%o3	!
	or	%g0,.md1e-.md1s,%o4	!
    .md1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.md1cp			!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,.md1e-.md1s,%o0	!
.md0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
		ld	[%sp+92],%o0	! struct *guest
    .md0t0:	add	%l0,%l0,%o2	! ##TEMPLATE:%l0,%l0
    .md0t1:	add	%o2,0,%o2	! ##TEMPLATE:imm0
		and	%o2,%g3,%o2	! mask address
		add	%g4,%o2,%o2	!
    .md0t2:	add	%o0,64,%o1	! ##TEMPLATE:%imm
		and	%g7,0xf,%o3	! give Program Mask
		st	%g1,[%o0+132]	!
		st	%g2,[%o0+136]	!
		st	%g3,[%o0+140]	!
		st	%g4,[%o0+144]	!
		st	%i7,[%o0+60]	! save Mreg15
		ld	[%sp+100],%i7	! restore return addr.
		sethi	%hi(fl_mult_long2long),%o7
		or	%o7,%lo(fl_mult_long2long),%o7
		jmpl	%o7,%o7		! call library in fltlib.s
		nop			!
		ld	[%sp+92],%o7	! struct *guest
		ld	[%o7+132],%g1	!
		ld	[%o7+136],%g2	!
		ld	[%o7+140],%g3	!
		ld	[%o7+144],%g4	!
		ld	[%o7+60],%i7	! restore Mreg15
		or	%g7,%o0,%g7	! INTR-CODE=retval
		andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.md0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.md0e:
.md1s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
		sethi	%hi(0x00060000),%o0
		or	%g7,%o0,%g7	! specification exception
		ba	.md1e		! retuen(TEMPLATE)
		add	%g1,0x10,%g1	!
.md1e:

	.section ".text"
	.align	4
	.global cf4_dd,tf4_dd
cf4_dd:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	.dd1c			!
	nop				!
    .dd0c:				!
	retl				! case even:
	add	%g0,.dd0e-.dd0s,%o0	!
    .dd1c:				!
	retl				! case odd:
	add	%g0,.dd1e-.dd1s,%o0	!   specification exception
tf4_dd:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	.dd1t			!
	nop				!
    .dd0t:				!
	sethi	%hi(.dd0s),%o3		!
	or	%o3,%lo(.dd0s),%o3	!
	or	%g0,.dd0e-.dd0s,%o4	!
    .dd0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.dd0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.dd0t0-.dd0s],%o5	!
	srl	%o1,16,%o4		!
	andcc	%o4,0xf,%o4		! X2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+.dd0t0-.dd0s]	!
	ld	[%o0+.dd0t1-.dd0s],%o5	!
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.dd0t1-.dd0s]	!
	ld	[%o0+.dd0t2-.dd0s],%o5	!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+.dd0t2-.dd0s]	!
	retl				!
	add	%o0,.dd0e-.dd0s,%o0	!
    .dd1t:				!
	sethi	%hi(.dd1s),%o3		!
	or	%o3,%lo(.dd1s),%o3	!
	or	%g0,.dd1e-.dd1s,%o4	!
    .dd1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.dd1cp			!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,.dd1e-.dd1s,%o0	!
.dd0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
		ld	[%sp+92],%o0	! struct *guest
    .dd0t0:	add	%l0,%l0,%o2	! ##TEMPLATE:%l0,%l0
    .dd0t1:	add	%o2,0,%o2	! ##TEMPLATE:imm0
		and	%o2,%g3,%o2	! mask address
		add	%g4,%o2,%o2	!
    .dd0t2:	add	%o0,64,%o1	! ##TEMPLATE:%imm
		and	%g7,0xf,%o3	! give Program Mask
		st	%g1,[%o0+132]	!
		st	%g2,[%o0+136]	!
		st	%g3,[%o0+140]	!
		st	%g4,[%o0+144]	!
		st	%i7,[%o0+60]	! save Mreg15
		ld	[%sp+100],%i7	! restore return addr.
		sethi	%hi(fl_div_long),%o7
		or	%o7,%lo(fl_div_long),%o7
		jmpl	%o7,%o7		! call library in fltlib.s
		nop			!
		ld	[%sp+92],%o7	! struct *guest
		ld	[%o7+132],%g1	!
		ld	[%o7+136],%g2	!
		ld	[%o7+140],%g3	!
		ld	[%o7+144],%g4	!
		ld	[%o7+60],%i7	! restore Mreg15
		or	%g7,%o0,%g7	! INTR-CODE=retval
		andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.dd0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.dd0e:
.dd1s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
		sethi	%hi(0x00060000),%o0
		or	%g7,%o0,%g7	! specification exception
		ba	.dd1e		! retuen(TEMPLATE)
		add	%g1,0x10,%g1	!
.dd1e:

	.section ".text"
	.align	4
	.global cf4_aw,tf4_aw
cf4_aw:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	.aw1c			!
	nop				!
    .aw0c:				!
	retl				! case even:
	add	%g0,.aw0e-.aw0s,%o0	!
    .aw1c:				!
	retl				! case odd:
	add	%g0,.aw1e-.aw1s,%o0	!   specification exception
tf4_aw:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	.aw1t			!
	nop				!
    .aw0t:				!
	sethi	%hi(.aw0s),%o3		!
	or	%o3,%lo(.aw0s),%o3	!
	or	%g0,.aw0e-.aw0s,%o4	!
    .aw0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.aw0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.aw0t0-.aw0s],%o5	!
	srl	%o1,16,%o4		!
	andcc	%o4,0xf,%o4		! X2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+.aw0t0-.aw0s]	!
	ld	[%o0+.aw0t1-.aw0s],%o5	!
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.aw0t1-.aw0s]	!
	ld	[%o0+.aw0t2-.aw0s],%o5	!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+.aw0t2-.aw0s]	!
	retl				!
	add	%o0,.aw0e-.aw0s,%o0	!
    .aw1t:				!
	sethi	%hi(.aw1s),%o3		!
	or	%o3,%lo(.aw1s),%o3	!
	or	%g0,.aw1e-.aw1s,%o4	!
    .aw1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.aw1cp			!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,.aw1e-.aw1s,%o0	!
.aw0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
		ld	[%sp+92],%o0	! struct *guest
    .aw0t0:	add	%l0,%l0,%o2	! ##TEMPLATE:%l0,%l0
    .aw0t1:	add	%o2,0,%o2	! ##TEMPLATE:imm0
		and	%o2,%g3,%o2	! mask address
		add	%g4,%o2,%o2	!
    .aw0t2:	add	%o0,64,%o1	! ##TEMPLATE:%imm
		and	%g7,0xf,%o3	! give Program Mask
		st	%g1,[%o0+132]	!
		st	%g2,[%o0+136]	!
		st	%g3,[%o0+140]	!
		st	%g4,[%o0+144]	!
		st	%i7,[%o0+60]	! save Mreg15
		ld	[%sp+100],%i7	! restore return addr.
		sethi	%hi(fl_addsub_long_unnorm),%o7
		or	%o7,%lo(fl_addsub_long_unnorm),%o7
		jmpl	%o7,%o7		! call library in fltlib.s
		add	%g0,0,%o4	! param5=0(add)
		ld	[%sp+92],%o7	! struct *guest
		ld	[%o7+132],%g1	!
		ld	[%o7+136],%g2	!
		ld	[%o7+140],%g3	!
		ld	[%o7+144],%g4	!
		ld	[%o7+60],%i7	! restore Mreg15
		andn	%g1,0x3,%g1	! CC=0
		and	%o0,0x3,%o1	! extract CC
		or	%g1,%o1,%g1	! CC=retval
		sethi	%hi(0x00ff0000),%o1
		and	%o0,%o1,%o1	! extract exception
		or	%g7,%o1,%g7	! INTR-CODE=retval
		andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.aw0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.aw0e:
.aw1s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
		sethi	%hi(0x00060000),%o0
		or	%g7,%o0,%g7	! specification exception
		ba	.aw1e		! retuen(TEMPLATE)
		add	%g1,0x10,%g1	!
.aw1e:

	.section ".text"
	.align	4
	.global cf4_sw,tf4_sw
cf4_sw:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	.sw1c			!
	nop				!
    .sw0c:				!
	retl				! case even:
	add	%g0,.sw0e-.sw0s,%o0	!
    .sw1c:				!
	retl				! case odd:
	add	%g0,.sw1e-.sw1s,%o0	!   specification exception
tf4_sw:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	.sw1t			!
	nop				!
    .sw0t:				!
	sethi	%hi(.sw0s),%o3		!
	or	%o3,%lo(.sw0s),%o3	!
	or	%g0,.sw0e-.sw0s,%o4	!
    .sw0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.sw0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.sw0t0-.sw0s],%o5	!
	srl	%o1,16,%o4		!
	andcc	%o4,0xf,%o4		! X2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+.sw0t0-.sw0s]	!
	ld	[%o0+.sw0t1-.sw0s],%o5	!
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.sw0t1-.sw0s]	!
	ld	[%o0+.sw0t2-.sw0s],%o5	!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+.sw0t2-.sw0s]	!
	retl				!
	add	%o0,.sw0e-.sw0s,%o0	!
    .sw1t:				!
	sethi	%hi(.sw1s),%o3		!
	or	%o3,%lo(.sw1s),%o3	!
	or	%g0,.sw1e-.sw1s,%o4	!
    .sw1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.sw1cp			!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,.sw1e-.sw1s,%o0	!
.sw0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
		ld	[%sp+92],%o0	! struct *guest
    .sw0t0:	add	%l0,%l0,%o2	! ##TEMPLATE:%l0,%l0
    .sw0t1:	add	%o2,0,%o2	! ##TEMPLATE:imm0
		and	%o2,%g3,%o2	! mask address
		add	%g4,%o2,%o2	!
    .sw0t2:	add	%o0,64,%o1	! ##TEMPLATE:%imm
		and	%g7,0xf,%o3	! give Program Mask
		st	%g1,[%o0+132]	!
		st	%g2,[%o0+136]	!
		st	%g3,[%o0+140]	!
		st	%g4,[%o0+144]	!
		st	%i7,[%o0+60]	! save Mreg15
		ld	[%sp+100],%i7	! restore return addr.
		sethi	%hi(fl_addsub_long_unnorm),%o7
		or	%o7,%lo(fl_addsub_long_unnorm),%o7
		jmpl	%o7,%o7		! call library in fltlib.s
		add	%g0,1,%o4	! param5=1(sub)
		ld	[%sp+92],%o7	! struct *guest
		ld	[%o7+132],%g1	!
		ld	[%o7+136],%g2	!
		ld	[%o7+140],%g3	!
		ld	[%o7+144],%g4	!
		ld	[%o7+60],%i7	! restore Mreg15
		andn	%g1,0x3,%g1	! CC=0
		and	%o0,0x3,%o1	! extract CC
		or	%g1,%o1,%g1	! CC=retval
		sethi	%hi(0x00ff0000),%o1
		and	%o0,%o1,%o1	! extract exception
		or	%g7,%o1,%g7	! INTR-CODE=retval
		andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.sw0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.sw0e:
.sw1s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
		sethi	%hi(0x00060000),%o0
		or	%g7,%o0,%g7	! specification exception
		ba	.sw1e		! retuen(TEMPLATE)
		add	%g1,0x10,%g1	!
.sw1e:
!================================

!
! templates
! cxx_xxx:
!   %o0: param: none
!	 retval:size of template
!   %o1: M instruction (4 bytes)
!   %o2: work
!   %o3: work
!   %o4: work
!   %o5: flag(0:NON EXECUTE,1:EXECUTE)
! txx_xxx:
!   %o0: param: bufp start address
!	 retval:bufp next start address
!   %o1: M instruction (4 bytes)
!   %o2: work
!   %o3: work
!   %o4: work
!   %o5: flag(0:NON EXECUTE,1:EXECUTE)
!
	.section ".text"
	.align	4
	.global cf4_ste,tf4_ste
cf4_ste:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	.ste1c			!
	nop				!
    .ste0c:				!
	retl				! case even:
	add	%g0,.ste0e-.ste0s,%o0	!
    .ste1c:				!
	retl				! case odd:
	add	%g0,.ste1e-.ste1s,%o0	!   specification exception
tf4_ste:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	.ste1t			!
	nop				!
    .ste0t:				!
	sethi	%hi(.ste0s),%o3		!
	or	%o3,%lo(.ste0s),%o3	!
	or	%g0,.ste0e-.ste0s,%o4	!
    .ste0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.ste0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.ste0t0-.ste0s],%o5!
	srl	%o1,16,%o4		!
	andcc	%o4,0xf,%o4		! X2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+.ste0t0-.ste0s]!
	ld	[%o0+.ste0t1-.ste0s],%o5!
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.ste0t1-.ste0s]!
	ld	[%o0+.ste0t2-.ste0s],%o5!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+.ste0t2-.ste0s]!
	retl				!
	add	%o0,.ste0e-.ste0s,%o0	!
    .ste1t:				!
	sethi	%hi(.ste1s),%o3		!
	or	%o3,%lo(.ste1s),%o3	!
	or	%g0,.ste1e-.ste1s,%o4	!
    .ste1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.ste1cp			!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,.ste1e-.ste1s,%o0	!
.ste0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
		ld	[%sp+92],%o7	! struct *guest
    .ste0t0:	add	%l0,%l0,%o0	! ##TEMPLATE:%l0,%l0
    .ste0t1:	add	%o0,0,%o0	! ##TEMPLATE:imm0
		and	%o0,%g3,%o0	! mask address
    .ste0t2:	ld	[%o7+64],%o2	! ##TEMPLATE:%imm
		st	%o2,[%g4+%o0]	!
		andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.ste0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.ste0e:
.ste1s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
		sethi	%hi(0x00060000),%o0
		or	%g7,%o0,%g7	! specification exception
		ba	.ste1e		! retuen(TEMPLATE)
		add	%g1,0x10,%g1	!
.ste1e:

	.section ".text"
	.align	4
	.global cf4_le,tf4_le
cf4_le:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	.le1c			!
	nop				!
    .le0c:				!
	retl				! case even:
	add	%g0,.le0e-.le0s,%o0	!
    .le1c:				!
	retl				! case odd:
	add	%g0,.le1e-.le1s,%o0	!   specification exception
tf4_le:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	.le1t			!
	nop				!
    .le0t:				!
	sethi	%hi(.le0s),%o3		!
	or	%o3,%lo(.le0s),%o3	!
	or	%g0,.le0e-.le0s,%o4	!
    .le0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.le0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.le0t0-.le0s],%o5	!
	srl	%o1,16,%o4		!
	andcc	%o4,0xf,%o4		! X2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+.le0t0-.le0s]	!
	ld	[%o0+.le0t1-.le0s],%o5	!
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.le0t1-.le0s]	!
	ld	[%o0+.le0t2-.le0s],%o5	!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+.le0t2-.le0s]	!
	retl				!
	add	%o0,.le0e-.le0s,%o0	!
    .le1t:				!
	sethi	%hi(.le1s),%o3		!
	or	%o3,%lo(.le1s),%o3	!
	or	%g0,.le1e-.le1s,%o4	!
    .le1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.le1cp			!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,.le1e-.le1s,%o0	!
.le0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
		ld	[%sp+92],%o7	! struct *guest
    .le0t0:	add	%l0,%l0,%o0	! ##TEMPLATE:%l0,%l0
    .le0t1:	add	%o0,0,%o0	! ##TEMPLATE:imm0
		and	%o0,%g3,%o0	! mask address
		ld	[%g4+%o0],%o0	!
    .le0t2:	st	%o0,[%o7+64]	! ##TEMPLATE:%imm
		andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.le0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.le0e:
.le1s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
		sethi	%hi(0x00060000),%o0
		or	%g7,%o0,%g7	! specification exception
		ba	.le1e		! retuen(TEMPLATE)
		add	%g1,0x10,%g1	!
.le1e:

	.section ".text"
	.align	4
	.global cf4_ce,tf4_ce
cf4_ce:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	.ce1c			!
	nop				!
    .ce0c:				!
	retl				! case even:
	add	%g0,.ce0e-.ce0s,%o0	!
    .ce1c:				!
	retl				! case odd:
	add	%g0,.ce1e-.ce1s,%o0	!   specification exception
tf4_ce:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	.ce1t			!
	nop				!
    .ce0t:				!
	sethi	%hi(.ce0s),%o3		!
	or	%o3,%lo(.ce0s),%o3	!
	or	%g0,.ce0e-.ce0s,%o4	!
    .ce0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.ce0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.ce0t0-.ce0s],%o5	!
	srl	%o1,16,%o4		!
	andcc	%o4,0xf,%o4		! X2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+.ce0t0-.ce0s]	!
	ld	[%o0+.ce0t1-.ce0s],%o5	!
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.ce0t1-.ce0s]	!
	ld	[%o0+.ce0t2-.ce0s],%o5	!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+.ce0t2-.ce0s]	!
	retl				!
	add	%o0,.ce0e-.ce0s,%o0	!
    .ce1t:				!
	sethi	%hi(.ce1s),%o3		!
	or	%o3,%lo(.ce1s),%o3	!
	or	%g0,.ce1e-.ce1s,%o4	!
    .ce1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.ce1cp			!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,.ce1e-.ce1s,%o0	!
.ce0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
		ld	[%sp+92],%o0	! struct *guest
    .ce0t0:	add	%l0,%l0,%o2	! ##TEMPLATE:%l0,%l0
    .ce0t1:	add	%o2,0,%o2	! ##TEMPLATE:imm0
		and	%o2,%g3,%o2	! mask address
		add	%g4,%o2,%o2	!
    .ce0t2:	add	%o0,64,%o1	! ##TEMPLATE:%imm
		and	%g7,0xf,%o3	! give Program Mask
		st	%g1,[%o0+132]	!
		st	%g2,[%o0+136]	!
		st	%g3,[%o0+140]	!
		st	%g4,[%o0+144]	!
		st	%i7,[%o0+60]	! save Mreg15
		ld	[%sp+100],%i7	! restore return addr.
		sethi	%hi(fl_comp_short),%o7
		or	%o7,%lo(fl_comp_short),%o7
		jmpl	%o7,%o7		! call library in fltlib.s
		nop			!
		ld	[%sp+92],%o7	! struct *guest
		ld	[%o7+132],%g1	!
		ld	[%o7+136],%g2	!
		ld	[%o7+140],%g3	!
		ld	[%o7+144],%g4	!
		ld	[%o7+60],%i7	! restore Mreg15
		andn	%g1,0x3,%g1	! CC=0
		or	%g1,%o0,%g1	! CC=retval
		andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.ce0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.ce0e:
.ce1s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
		sethi	%hi(0x00060000),%o0
		or	%g7,%o0,%g7	! specification exception
		ba	.ce1e		! retuen(TEMPLATE)
		add	%g1,0x10,%g1	!
.ce1e:

	.section ".text"
	.align	4
	.global cf4_ae,tf4_ae
cf4_ae:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	.ae1c			!
	nop				!
    .ae0c:				!
	retl				! case even:
	add	%g0,.ae0e-.ae0s,%o0	!
    .ae1c:				!
	retl				! case odd:
	add	%g0,.ae1e-.ae1s,%o0	!   specification exception
tf4_ae:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	.ae1t			!
	nop				!
    .ae0t:				!
	sethi	%hi(.ae0s),%o3		!
	or	%o3,%lo(.ae0s),%o3	!
	or	%g0,.ae0e-.ae0s,%o4	!
    .ae0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.ae0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.ae0t0-.ae0s],%o5	!
	srl	%o1,16,%o4		!
	andcc	%o4,0xf,%o4		! X2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+.ae0t0-.ae0s]	!
	ld	[%o0+.ae0t1-.ae0s],%o5	!
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.ae0t1-.ae0s]	!
	ld	[%o0+.ae0t2-.ae0s],%o5	!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+.ae0t2-.ae0s]	!
	retl				!
	add	%o0,.ae0e-.ae0s,%o0	!
    .ae1t:				!
	sethi	%hi(.ae1s),%o3		!
	or	%o3,%lo(.ae1s),%o3	!
	or	%g0,.ae1e-.ae1s,%o4	!
    .ae1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.ae1cp			!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,.ae1e-.ae1s,%o0	!
.ae0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
		ld	[%sp+92],%o0	! struct *guest
    .ae0t0:	add	%l0,%l0,%o2	! ##TEMPLATE:%l0,%l0
    .ae0t1:	add	%o2,0,%o2	! ##TEMPLATE:imm0
		and	%o2,%g3,%o2	! mask address
		add	%g4,%o2,%o2	!
    .ae0t2:	add	%o0,64,%o1	! ##TEMPLATE:%imm
		and	%g7,0xf,%o3	! give Program Mask
		st	%g1,[%o0+132]	!
		st	%g2,[%o0+136]	!
		st	%g3,[%o0+140]	!
		st	%g4,[%o0+144]	!
		st	%i7,[%o0+60]	! save Mreg15
		ld	[%sp+100],%i7	! restore return addr.
		sethi	%hi(fl_addsub_short_norm),%o7
		or	%o7,%lo(fl_addsub_short_norm),%o7
		jmpl	%o7,%o7		! call library in fltlib.s
		add	%g0,0,%o4	! param5=0(add)
		ld	[%sp+92],%o7	! struct *guest
		ld	[%o7+132],%g1	!
		ld	[%o7+136],%g2	!
		ld	[%o7+140],%g3	!
		ld	[%o7+144],%g4	!
		ld	[%o7+60],%i7	! restore Mreg15
		andn	%g1,0x3,%g1	! CC=0
		and	%o0,0x3,%o1	! extract CC
		or	%g1,%o1,%g1	! CC=retval
		sethi	%hi(0x00ff0000),%o1
		and	%o0,%o1,%o1	! extract exception
		or	%g7,%o1,%g7	! INTR-CODE=retval
		andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.ae0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.ae0e:
.ae1s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
		sethi	%hi(0x00060000),%o0
		or	%g7,%o0,%g7	! specification exception
		ba	.ae1e		! retuen(TEMPLATE)
		add	%g1,0x10,%g1	!
.ae1e:

	.section ".text"
	.align	4
	.global cf4_se,tf4_se
cf4_se:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	.se1c			!
	nop				!
    .se0c:				!
	retl				! case even:
	add	%g0,.se0e-.se0s,%o0	!
    .se1c:				!
	retl				! case odd:
	add	%g0,.se1e-.se1s,%o0	!   specification exception
tf4_se:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	.se1t			!
	nop				!
    .se0t:				!
	sethi	%hi(.se0s),%o3		!
	or	%o3,%lo(.se0s),%o3	!
	or	%g0,.se0e-.se0s,%o4	!
    .se0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.se0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.se0t0-.se0s],%o5	!
	srl	%o1,16,%o4		!
	andcc	%o4,0xf,%o4		! X2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+.se0t0-.se0s]	!
	ld	[%o0+.se0t1-.se0s],%o5	!
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.se0t1-.se0s]	!
	ld	[%o0+.se0t2-.se0s],%o5	!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+.se0t2-.se0s]	!
	retl				!
	add	%o0,.se0e-.se0s,%o0	!
    .se1t:				!
	sethi	%hi(.se1s),%o3		!
	or	%o3,%lo(.se1s),%o3	!
	or	%g0,.se1e-.se1s,%o4	!
    .se1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.se1cp			!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,.se1e-.se1s,%o0	!
.se0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
		ld	[%sp+92],%o0	! struct *guest
    .se0t0:	add	%l0,%l0,%o2	! ##TEMPLATE:%l0,%l0
    .se0t1:	add	%o2,0,%o2	! ##TEMPLATE:imm0
		and	%o2,%g3,%o2	! mask address
		add	%g4,%o2,%o2	!
    .se0t2:	add	%o0,64,%o1	! ##TEMPLATE:%imm
		and	%g7,0xf,%o3	! give Program Mask
		st	%g1,[%o0+132]	!
		st	%g2,[%o0+136]	!
		st	%g3,[%o0+140]	!
		st	%g4,[%o0+144]	!
		st	%i7,[%o0+60]	! save Mreg15
		ld	[%sp+100],%i7	! restore return addr.
		sethi	%hi(fl_addsub_short_norm),%o7
		or	%o7,%lo(fl_addsub_short_norm),%o7
		jmpl	%o7,%o7		! call library in fltlib.s
		add	%g0,1,%o4	! param5=1(sub)
		ld	[%sp+92],%o7	! struct *guest
		ld	[%o7+132],%g1	!
		ld	[%o7+136],%g2	!
		ld	[%o7+140],%g3	!
		ld	[%o7+144],%g4	!
		ld	[%o7+60],%i7	! restore Mreg15
		andn	%g1,0x3,%g1	! CC=0
		and	%o0,0x3,%o1	! extract CC
		or	%g1,%o1,%g1	! CC=retval
		sethi	%hi(0x00ff0000),%o1
		and	%o0,%o1,%o1	! extract exception
		or	%g7,%o1,%g7	! INTR-CODE=retval
		andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.se0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.se0e:
.se1s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
		sethi	%hi(0x00060000),%o0
		or	%g7,%o0,%g7	! specification exception
		ba	.se1e		! retuen(TEMPLATE)
		add	%g1,0x10,%g1	!
.se1e:

	.section ".text"
	.align	4
	.global cf4_me,tf4_me
cf4_me:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	.me1c			!
	nop				!
    .me0c:				!
	retl				! case even:
	add	%g0,.me0e-.me0s,%o0	!
    .me1c:				!
	retl				! case odd:
	add	%g0,.me1e-.me1s,%o0	!   specification exception
tf4_me:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	.me1t			!
	nop				!
    .me0t:				!
	sethi	%hi(.me0s),%o3		!
	or	%o3,%lo(.me0s),%o3	!
	or	%g0,.me0e-.me0s,%o4	!
    .me0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.me0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.me0t0-.me0s],%o5	!
	srl	%o1,16,%o4		!
	andcc	%o4,0xf,%o4		! X2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+.me0t0-.me0s]	!
	ld	[%o0+.me0t1-.me0s],%o5	!
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.me0t1-.me0s]	!
	ld	[%o0+.me0t2-.me0s],%o5	!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+.me0t2-.me0s]	!
	retl				!
	add	%o0,.me0e-.me0s,%o0	!
    .me1t:				!
	sethi	%hi(.me1s),%o3		!
	or	%o3,%lo(.me1s),%o3	!
	or	%g0,.me1e-.me1s,%o4	!
    .me1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.me1cp			!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,.me1e-.me1s,%o0	!
.me0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
		ld	[%sp+92],%o0	! struct *guest
    .me0t0:	add	%l0,%l0,%o2	! ##TEMPLATE:%l0,%l0
    .me0t1:	add	%o2,0,%o2	! ##TEMPLATE:imm0
		and	%o2,%g3,%o2	! mask address
		add	%g4,%o2,%o2	!
    .me0t2:	add	%o0,64,%o1	! ##TEMPLATE:%imm
		and	%g7,0xf,%o3	! give Program Mask
		st	%g1,[%o0+132]	!
		st	%g2,[%o0+136]	!
		st	%g3,[%o0+140]	!
		st	%g4,[%o0+144]	!
		st	%i7,[%o0+60]	! save Mreg15
		ld	[%sp+100],%i7	! restore return addr.
		sethi	%hi(fl_mult_short2long),%o7
		or	%o7,%lo(fl_mult_short2long),%o7
		jmpl	%o7,%o7		! call library in fltlib.s
		nop			!
		ld	[%sp+92],%o7	! struct *guest
		ld	[%o7+132],%g1	!
		ld	[%o7+136],%g2	!
		ld	[%o7+140],%g3	!
		ld	[%o7+144],%g4	!
		ld	[%o7+60],%i7	! restore Mreg15
		or	%g7,%o0,%g7	! INTR-CODE=retval
		andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.me0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.me0e:
.me1s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
		sethi	%hi(0x00060000),%o0
		or	%g7,%o0,%g7	! specification exception
		ba	.me1e		! retuen(TEMPLATE)
		add	%g1,0x10,%g1	!
.me1e:

	.section ".text"
	.align	4
	.global cf4_de,tf4_de
cf4_de:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	.de1c			!
	nop				!
    .de0c:				!
	retl				! case even:
	add	%g0,.de0e-.de0s,%o0	!
    .de1c:				!
	retl				! case odd:
	add	%g0,.de1e-.de1s,%o0	!   specification exception
tf4_de:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	.de1t			!
	nop				!
    .de0t:				!
	sethi	%hi(.de0s),%o3		!
	or	%o3,%lo(.de0s),%o3	!
	or	%g0,.de0e-.de0s,%o4	!
    .de0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.de0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.de0t0-.de0s],%o5	!
	srl	%o1,16,%o4		!
	andcc	%o4,0xf,%o4		! X2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+.de0t0-.de0s]	!
	ld	[%o0+.de0t1-.de0s],%o5	!
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.de0t1-.de0s]	!
	ld	[%o0+.de0t2-.de0s],%o5	!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+.de0t2-.de0s]	!
	retl				!
	add	%o0,.de0e-.de0s,%o0	!
    .de1t:				!
	sethi	%hi(.de1s),%o3		!
	or	%o3,%lo(.de1s),%o3	!
	or	%g0,.de1e-.de1s,%o4	!
    .de1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.de1cp			!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,.de1e-.de1s,%o0	!
.de0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
		ld	[%sp+92],%o0	! struct *guest
    .de0t0:	add	%l0,%l0,%o2	! ##TEMPLATE:%l0,%l0
    .de0t1:	add	%o2,0,%o2	! ##TEMPLATE:imm0
		and	%o2,%g3,%o2	! mask address
		add	%g4,%o2,%o2	!
    .de0t2:	add	%o0,64,%o1	! ##TEMPLATE:%imm
		and	%g7,0xf,%o3	! give Program Mask
		st	%g1,[%o0+132]	!
		st	%g2,[%o0+136]	!
		st	%g3,[%o0+140]	!
		st	%g4,[%o0+144]	!
		st	%i7,[%o0+60]	! save Mreg15
		ld	[%sp+100],%i7	! restore return addr.
		sethi	%hi(fl_div_short),%o7
		or	%o7,%lo(fl_div_short),%o7
		jmpl	%o7,%o7		! call library in fltlib.s
		nop			!
		ld	[%sp+92],%o7	! struct *guest
		ld	[%o7+132],%g1	!
		ld	[%o7+136],%g2	!
		ld	[%o7+140],%g3	!
		ld	[%o7+144],%g4	!
		ld	[%o7+60],%i7	! restore Mreg15
		or	%g7,%o0,%g7	! INTR-CODE=retval
		andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.de0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.de0e:
.de1s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
		sethi	%hi(0x00060000),%o0
		or	%g7,%o0,%g7	! specification exception
		ba	.de1e		! retuen(TEMPLATE)
		add	%g1,0x10,%g1	!
.de1e:

	.section ".text"
	.align	4
	.global cf4_au,tf4_au
cf4_au:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	.au1c			!
	nop				!
    .au0c:				!
	retl				! case even:
	add	%g0,.au0e-.au0s,%o0	!
    .au1c:				!
	retl				! case odd:
	add	%g0,.au1e-.au1s,%o0	!   specification exception
tf4_au:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	.au1t			!
	nop				!
    .au0t:				!
	sethi	%hi(.au0s),%o3		!
	or	%o3,%lo(.au0s),%o3	!
	or	%g0,.au0e-.au0s,%o4	!
    .au0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.au0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.au0t0-.au0s],%o5	!
	srl	%o1,16,%o4		!
	andcc	%o4,0xf,%o4		! X2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+.au0t0-.au0s]	!
	ld	[%o0+.au0t1-.au0s],%o5	!
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.au0t1-.au0s]	!
	ld	[%o0+.au0t2-.au0s],%o5	!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+.au0t2-.au0s]	!
	retl				!
	add	%o0,.au0e-.au0s,%o0	!
    .au1t:				!
	sethi	%hi(.au1s),%o3		!
	or	%o3,%lo(.au1s),%o3	!
	or	%g0,.au1e-.au1s,%o4	!
    .au1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.au1cp			!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,.au1e-.au1s,%o0	!
.au0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
		ld	[%sp+92],%o0	! struct *guest
    .au0t0:	add	%l0,%l0,%o2	! ##TEMPLATE:%l0,%l0
    .au0t1:	add	%o2,0,%o2	! ##TEMPLATE:imm0
		and	%o2,%g3,%o2	! mask address
		add	%g4,%o2,%o2	!
    .au0t2:	add	%o0,64,%o1	! ##TEMPLATE:%imm
		and	%g7,0xf,%o3	! give Program Mask
		st	%g1,[%o0+132]	!
		st	%g2,[%o0+136]	!
		st	%g3,[%o0+140]	!
		st	%g4,[%o0+144]	!
		st	%i7,[%o0+60]	! save Mreg15
		ld	[%sp+100],%i7	! restore return addr.
		sethi	%hi(fl_addsub_short_unnorm),%o7
		or	%o7,%lo(fl_addsub_short_unnorm),%o7
		jmpl	%o7,%o7		! call library in fltlib.s
		add	%g0,0,%o4	! param5=0(add)
		ld	[%sp+92],%o7	! struct *guest
		ld	[%o7+132],%g1	!
		ld	[%o7+136],%g2	!
		ld	[%o7+140],%g3	!
		ld	[%o7+144],%g4	!
		ld	[%o7+60],%i7	! restore Mreg15
		andn	%g1,0x3,%g1	! CC=0
		and	%o0,0x3,%o1	! extract CC
		or	%g1,%o1,%g1	! CC=retval
		sethi	%hi(0x00ff0000),%o1
		and	%o0,%o1,%o1	! extract exception
		or	%g7,%o1,%g7	! INTR-CODE=retval
		andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.au0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.au0e:
.au1s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
		sethi	%hi(0x00060000),%o0
		or	%g7,%o0,%g7	! specification exception
		ba	.au1e		! retuen(TEMPLATE)
		add	%g1,0x10,%g1	!
.au1e:

	.section ".text"
	.align	4
	.global cf4_su,tf4_su
cf4_su:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	.su1c			!
	nop				!
    .su0c:				!
	retl				! case even:
	add	%g0,.su0e-.su0s,%o0	!
    .su1c:				!
	retl				! case odd:
	add	%g0,.su1e-.su1s,%o0	!   specification exception
tf4_su:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	.su1t			!
	nop				!
    .su0t:				!
	sethi	%hi(.su0s),%o3		!
	or	%o3,%lo(.su0s),%o3	!
	or	%g0,.su0e-.su0s,%o4	!
    .su0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.su0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.su0t0-.su0s],%o5	!
	srl	%o1,16,%o4		!
	andcc	%o4,0xf,%o4		! X2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+.su0t0-.su0s]	!
	ld	[%o0+.su0t1-.su0s],%o5	!
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.su0t1-.su0s]	!
	ld	[%o0+.su0t2-.su0s],%o5	!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+.su0t2-.su0s]	!
	retl				!
	add	%o0,.su0e-.su0s,%o0	!
    .su1t:				!
	sethi	%hi(.su1s),%o3		!
	or	%o3,%lo(.su1s),%o3	!
	or	%g0,.su1e-.su1s,%o4	!
    .su1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.su1cp			!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,.su1e-.su1s,%o0	!
.su0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
		ld	[%sp+92],%o0	! struct *guest
    .su0t0:	add	%l0,%l0,%o2	! ##TEMPLATE:%l0,%l0
    .su0t1:	add	%o2,0,%o2	! ##TEMPLATE:imm0
		and	%o2,%g3,%o2	! mask address
		add	%g4,%o2,%o2	!
    .su0t2:	add	%o0,64,%o1	! ##TEMPLATE:%imm
		and	%g7,0xf,%o3	! give Program Mask
		st	%g1,[%o0+132]	!
		st	%g2,[%o0+136]	!
		st	%g3,[%o0+140]	!
		st	%g4,[%o0+144]	!
		st	%i7,[%o0+60]	! save Mreg15
		ld	[%sp+100],%i7	! restore return addr.
		sethi	%hi(fl_addsub_short_unnorm),%o7
		or	%o7,%lo(fl_addsub_short_unnorm),%o7
		jmpl	%o7,%o7		! call library in fltlib.s
		add	%g0,1,%o4	! param5=1(sub)
		ld	[%sp+92],%o7	! struct *guest
		ld	[%o7+132],%g1	!
		ld	[%o7+136],%g2	!
		ld	[%o7+140],%g3	!
		ld	[%o7+144],%g4	!
		ld	[%o7+60],%i7	! restore Mreg15
		andn	%g1,0x3,%g1	! CC=0
		and	%o0,0x3,%o1	! extract CC
		or	%g1,%o1,%g1	! CC=retval
		sethi	%hi(0x00ff0000),%o1
		and	%o0,%o1,%o1	! extract exception
		or	%g7,%o1,%g7	! INTR-CODE=retval
		andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.su0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.su0e:
.su1s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
		sethi	%hi(0x00060000),%o0
		or	%g7,%o0,%g7	! specification exception
		ba	.su1e		! retuen(TEMPLATE)
		add	%g1,0x10,%g1	!
.su1e:
!================================

!
! templates
! cxx_xxx:
!   %o0: param: none
!	 retval:size of template
!   %o1: M instruction (4 bytes)
!   %o2: work
!   %o3: work
!   %o4: work
!   %o5: flag(0:NON EXECUTE,1:EXECUTE)
! txx_xxx:
!   %o0: param: bufp start address
!	 retval:bufp next start address
!   %o1: M instruction (4 bytes)
!   %o2: work
!   %o3: work
!   %o4: work
!   %o5: flag(0:NON EXECUTE,1:EXECUTE)
!
	.section ".text"
	.align	4
	.global cc4_ssm,tc4_ssm
cc4_ssm:
	retl				!
	add	%g0,.ssm0e-.ssm0s,%o0	!
tc4_ssm:
	sethi	%hi(.ssm0s),%o3		!
	or	%o3,%lo(.ssm0s),%o3	!
	or	%g0,.ssm0e-.ssm0s,%o4	!
    .ssm0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.ssm0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.ssm0t0-.ssm0s],%o5!
	srl	%o1,10,%o4		!
	or	%o5,%o4,%o5		! simm22
	st	%o5,[%o0+.ssm0t0-.ssm0s]!
	ld	[%o0+.ssm0t1-.ssm0s],%o5!
	and	%o1,0xfff,%o4		!
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.ssm0t1-.ssm0s]!
	retl				!
	add	%o0,.ssm0e-.ssm0s,%o0	!
.ssm0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
		ld	[%sp+92],%o7	! struct *guest
    .ssm0t0:	sethi	0,%o0		! ##TEMPLATE:imm
    .ssm0t1:	or	%o0,0,%o0	! ##TEMPLATE:imm
		st	%o0,[%o7+200]	! store minsn (upper)
		st	%g0,[%o7+204]	! store minsn (lower)
		sethi	%hi(0x80000000),%o0
		or	%g7,%o0,%g7	! Special Instruction (FC=2)
		ba	.ssm0e		! return(TEMPLATE)
		add	%g1,0x10,%g1	!
.ssm0e:

	.section ".text"
	.align	4
	.global cc4_lpsw,tc4_lpsw
cc4_lpsw:
	retl				!
	add	%g0,.lpsw0e-.lpsw0s,%o0 !
tc4_lpsw:
	sethi	%hi(.lpsw0s),%o3	!
	or	%o3,%lo(.lpsw0s),%o3	!
	or	%g0,.lpsw0e-.lpsw0s,%o4 !
    .lpsw0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.lpsw0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.lpsw0t0-.lpsw0s],%o5
	srl	%o1,10,%o4		!
	or	%o5,%o4,%o5		! simm22
	st	%o5,[%o0+.lpsw0t0-.lpsw0s]
	ld	[%o0+.lpsw0t1-.lpsw0s],%o5
	and	%o1,0xfff,%o4		!
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.lpsw0t1-.lpsw0s]
	retl				!
	add	%o0,.lpsw0e-.lpsw0s,%o0 !
.lpsw0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
		ld	[%sp+92],%o7	! struct *guest
    .lpsw0t0:	sethi	0,%o0		! ##TEMPLATE:imm
    .lpsw0t1:	or	%o0,0,%o0	! ##TEMPLATE:imm
		st	%o0,[%o7+200]	! store minsn (upper)
		st	%g0,[%o7+204]	! store minsn (lower)
		sethi	%hi(0x80000000),%o0
		or	%g7,%o0,%g7	! Special Instruction (FC=2)
		ba	.lpsw0e		! return(TEMPLATE)
		add	%g1,0x10,%g1	!
.lpsw0e:

	.section ".text"
	.align	4
	.global cc4_diag,tc4_diag
cc4_diag:
	retl				!
	add	%g0,.diag0e-.diag0s,%o0 !
tc4_diag:
	sethi	%hi(.diag0s),%o3	!
	or	%o3,%lo(.diag0s),%o3	!
	or	%g0,.diag0e-.diag0s,%o4 !
    .diag0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.diag0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.diag0t0-.diag0s],%o5
	srl	%o1,10,%o4		!
	or	%o5,%o4,%o5		! simm22
	st	%o5,[%o0+.diag0t0-.diag0s]
	ld	[%o0+.diag0t1-.diag0s],%o5
	and	%o1,0xfff,%o4		!
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.diag0t1-.diag0s]
	retl				!
	add	%o0,.diag0e-.diag0s,%o0 !
.diag0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
		ld	[%sp+92],%o7	! struct *guest
    .diag0t0:	sethi	0,%o0		! ##TEMPLATE:imm
    .diag0t1:	or	%o0,0,%o0	! ##TEMPLATE:imm
		st	%o0,[%o7+200]	! store minsn (upper)
		st	%g0,[%o7+204]	! store minsn (lower)
		sethi	%hi(0x80000000),%o0
		or	%g7,%o0,%g7	! Special Instruction (FC=2)
		ba	.diag0e		! return(TEMPLATE)
		add	%g1,0x10,%g1	!
.diag0e:

	.section ".text"
	.align	4
	.global ci4_bxh,ti4_bxh
ci4_bxh:
	srl	%o1,16,%o3		! switch (R3)
	andcc	%o3,1,%g0		!
	bnz	.bxh1c			!
	nop				!
    .bxh0c:				!
	retl				! case even:
	add	%g0,.bxh0e-.bxh0s,%o0	!   inc:R3, cmp:R3+1
    .bxh1c:				!
	retl				! case odd:
	add	%g0,.bxh1e-.bxh1s,%o0	!   inc:R3, cmp:R3
ti4_bxh:
	srl	%o1,16,%o3		! switch (R3)
	andcc	%o3,1,%g0		!
	bnz	.bxh1t			!
	nop				!
    .bxh0t:				!
	sethi	%hi(.bxh0s),%o3		!
	or	%o3,%lo(.bxh0s),%o3	!
	or	%g0,.bxh0e-.bxh0s,%o4	!
    .bxh0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.bxh0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.bxh0t0-.bxh0s],%o5!
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.bxh0t0-.bxh0s]!
	ld	[%o0+.bxh0t1-.bxh0s],%o5!
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R3+1
	add	%o4,1,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	st	%o5,[%o0+.bxh0t1-.bxh0s]!
	ld	[%o0+.bxh0t2-.bxh0s],%o5!
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R3
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	sll	%o4,11,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+.bxh0t2-.bxh0s]!
	ld	[%o0+.bxh0t3-.bxh0s],%o5!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+.bxh0t3-.bxh0s]!
	retl				!
	add	%o0,.bxh0e-.bxh0s,%o0	!
    .bxh1t:				!
	sethi	%hi(.bxh1s),%o3		!
	or	%o3,%lo(.bxh1s),%o3	!
	or	%g0,.bxh1e-.bxh1s,%o4	!
    .bxh1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.bxh1cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.bxh1t0-.bxh1s],%o5!
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.bxh1t0-.bxh1s]!
	ld	[%o0+.bxh1t1-.bxh1s],%o5!
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R3
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	st	%o5,[%o0+.bxh1t1-.bxh1s]!
	ld	[%o0+.bxh1t2-.bxh1s],%o5!
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R3
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	sll	%o4,11,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+.bxh1t2-.bxh1s]!
	ld	[%o0+.bxh1t3-.bxh1s],%o5!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+.bxh1t3-.bxh1s]!
	retl				!
	add	%o0,.bxh1e-.bxh1s,%o0	!
.bxh0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
    .bxh0t0:	add	%l0,0,%o0	! ##TEMPLATE:%l0,imm0
    .bxh0t1:	add	%g0,%l0,%o1	! ##TEMPLATE:%l0 R3+1
    .bxh0t2:	add	%l0,%l0,%l0	! ##TEMPLATE:%l0,%l0,%l0 R1,R3,R1
    .bxh0t3:	subcc	%l0,%o1,%g0	! ##TEMPLATE:%l0 R1
		bg,a	.bxh000		! if %l0 > %o1 then taken
		add	%g0,%o0,%g2	!
    .bxh000:	andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.bxh0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.bxh0e:
.bxh1s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
    .bxh1t0:	add	%l0,0,%o0	! ##TEMPLATE:%l0,imm0
    .bxh1t1:	add	%g0,%l0,%o1	! ##TEMPLATE:%l0 R3
    .bxh1t2:	add	%l0,%l0,%l0	! ##TEMPLATE:%l0,%l0,%l0 R1,R3,R1
    .bxh1t3:	subcc	%l0,%o1,%g0	! ##TEMPLATE:%l0 R1
		bg,a	.bxh100		! if %l0 > %o1 then taken
		add	%g0,%o0,%g2	!
    .bxh100:	andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.bxh1e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.bxh1e:

	.section ".text"
	.align	4
	.global ci4_bxle,ti4_bxle
ci4_bxle:
	srl	%o1,16,%o3		! switch (R3)
	andcc	%o3,1,%g0		!
	bnz	.bxle1c			!
	nop				!
    .bxle0c:				!
	retl				! case even:
	add	%g0,.bxle0e-.bxle0s,%o0 !   inc:R3, cmp:R3+1
    .bxle1c:				!
	retl				! case odd:
	add	%g0,.bxle1e-.bxle1s,%o0 !   inc:R3, cmp:R3
ti4_bxle:
	srl	%o1,16,%o3		! switch (R3)
	andcc	%o3,1,%g0		!
	bnz	.bxle1t			!
	nop				!
    .bxle0t:				!
	sethi	%hi(.bxle0s),%o3	!
	or	%o3,%lo(.bxle0s),%o3	!
	or	%g0,.bxle0e-.bxle0s,%o4 !
    .bxle0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.bxle0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.bxle0t0-.bxle0s],%o5
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.bxle0t0-.bxle0s]
	ld	[%o0+.bxle0t1-.bxle0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R3+1
	add	%o4,1,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	st	%o5,[%o0+.bxle0t1-.bxle0s]
	ld	[%o0+.bxle0t2-.bxle0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R3
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	sll	%o4,11,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+.bxle0t2-.bxle0s]
	ld	[%o0+.bxle0t3-.bxle0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+.bxle0t3-.bxle0s]
	retl				!
	add	%o0,.bxle0e-.bxle0s,%o0 !
    .bxle1t:				!
	sethi	%hi(.bxle1s),%o3	!
	or	%o3,%lo(.bxle1s),%o3	!
	or	%g0,.bxle1e-.bxle1s,%o4 !
    .bxle1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.bxle1cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.bxle1t0-.bxle1s],%o5
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.bxle1t0-.bxle1s]
	ld	[%o0+.bxle1t1-.bxle1s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R3
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	st	%o5,[%o0+.bxle1t1-.bxle1s]
	ld	[%o0+.bxle1t2-.bxle1s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R3
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	sll	%o4,11,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+.bxle1t2-.bxle1s]
	ld	[%o0+.bxle1t3-.bxle1s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+.bxle1t3-.bxle1s]
	retl				!
	add	%o0,.bxle1e-.bxle1s,%o0 !
.bxle0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
    .bxle0t0:	add	%l0,0,%o0	! ##TEMPLATE:%l0,imm0
    .bxle0t1:	add	%g0,%l0,%o1	! ##TEMPLATE:%l0 R3+1
    .bxle0t2:	add	%l0,%l0,%l0	! ##TEMPLATE:%l0,%l0,%l0 R1,R3,R1
    .bxle0t3:	subcc	%l0,%o1,%g0	! ##TEMPLATE:%l0 R1
		ble,a	.bxle000	! if %l0 <= %o1 then taken
		add	%g0,%o0,%g2	!
    .bxle000:	andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.bxle0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.bxle0e:
.bxle1s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
    .bxle1t0:	add	%l0,0,%o0	! ##TEMPLATE:%l0,imm0
    .bxle1t1:	add	%g0,%l0,%o1	! ##TEMPLATE:%l0 R3
    .bxle1t2:	add	%l0,%l0,%l0	! ##TEMPLATE:%l0,%l0,%l0 R1,R3,R1
    .bxle1t3:	subcc	%l0,%o1,%g0	! ##TEMPLATE:%l0 R1
		ble,a	.bxle100	! if %l0 <= %o1 then taken
		add	%g0,%o0,%g2	!
    .bxle100:	andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.bxle1e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.bxle1e:

	.section ".text"
	.align	4
	.global ci4_srl,ti4_srl
ci4_srl:
	retl				!
	add	%g0,.srl0e-.srl0s,%o0	!
ti4_srl:
	sethi	%hi(.srl0s),%o3		!
	or	%o3,%lo(.srl0s),%o3	!
	or	%g0,.srl0e-.srl0s,%o4	!
    .srl0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.srl0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.srl0t0-.srl0s],%o5!
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.srl0t0-.srl0s]!
	ld	[%o0+.srl0t1-.srl0s],%o5!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,25,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+.srl0t1-.srl0s]!
	ld	[%o0+.srl0t2-.srl0s],%o5!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	sll	%o4,11,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+.srl0t2-.srl0s]!
	retl				!
	add	%o0,.srl0e-.srl0s,%o0	!
.srl0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
    .srl0t0:	add	%l0,0,%o0	! ##TEMPLATE:%l0,imm0 B2,D2
		and	%o0,0x3f,%o0	!
		subcc	%o0,31,%g0	!
		bg,a	.srl0t2		!
    .srl0t1:	add	%g0,%g0,%l0	! ##TEMPLATE:%l0 R1
    .srl0t2:	srl	%l0,%o0,%l0	! ##TEMPLATE:%l0,%l0 R1,R1
		andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.srl0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.srl0e:

	.section ".text"
	.align	4
	.global ci4_sll,ti4_sll
ci4_sll:
	retl				!
	add	%g0,.sll0e-.sll0s,%o0	!
ti4_sll:
	sethi	%hi(.sll0s),%o3		!
	or	%o3,%lo(.sll0s),%o3	!
	or	%g0,.sll0e-.sll0s,%o4	!
    .sll0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.sll0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.sll0t0-.sll0s],%o5!
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.sll0t0-.sll0s]!
	ld	[%o0+.sll0t1-.sll0s],%o5!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,25,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+.sll0t1-.sll0s]!
	ld	[%o0+.sll0t2-.sll0s],%o5!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	sll	%o4,11,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+.sll0t2-.sll0s]!
	retl				!
	add	%o0,.sll0e-.sll0s,%o0	!
.sll0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
    .sll0t0:	add	%l0,0,%o0	! ##TEMPLATE:%l0,imm0 B2,D2
		and	%o0,0x3f,%o0	!
		subcc	%o0,31,%g0	!
		bg,a	.sll0t2		!
    .sll0t1:	add	%g0,%g0,%l0	! ##TEMPLATE:%l0 R1
    .sll0t2:	sll	%l0,%o0,%l0	! ##TEMPLATE:%l0,%l0 R1,R1
		andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.sll0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.sll0e:

	.section ".text"
	.align	4
	.global ci4_sra,ti4_sra
ci4_sra:
	retl				!
	add	%g0,.sra0e-.sra0s,%o0	!
ti4_sra:
	sethi	%hi(.sra0s),%o3		!
	or	%o3,%lo(.sra0s),%o3	!
	or	%g0,.sra0e-.sra0s,%o4	!
    .sra0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.sra0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.sra0t0-.sra0s],%o5!
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.sra0t0-.sra0s]!
	ld	[%o0+.sra0t1-.sra0s],%o5!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	sll	%o4,11,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+.sra0t1-.sra0s]!
	ld	[%o0+.sra0t2-.sra0s],%o5!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	st	%o5,[%o0+.sra0t2-.sra0s]!
	retl				!
	add	%o0,.sra0e-.sra0s,%o0	!
.sra0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
		andn	%g1,0x3,%g1	! CC=0
    .sra0t0:	add	%l0,0,%o0	! ##TEMPLATE:%l0,imm0 B2,D2
		and	%o0,0x3f,%o0	!
		subcc	%o0,31,%g0	!
		bg,a	.sra0t1		!
		add	%g0,31,%o0	!
    .sra0t1:	sra	%l0,%o0,%l0	! ##TEMPLATE:%l0,%l0 R1,R1
    .sra0t2:	addcc	%g0,%l0,%g0	! ##TEMPLATE:%l0 R1
		bg,a	.sra001		! if %l0 > 0 then
		or	%g1,0x2,%g1	!   CC=2
		bl,a	.sra001		! if %l0 < 0 then
		or	%g1,0x1,%g1	!   CC=1
    .sra001:	andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.sra0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.sra0e:

	.section ".text"
	.align	4
	.global ci4_sla,ti4_sla
ci4_sla:
	retl				!
	add	%g0,.sla0e-.sla0s,%o0	!
ti4_sla:
	sethi	%hi(.sla0s),%o3		!
	or	%o3,%lo(.sla0s),%o3	!
	or	%g0,.sla0e-.sla0s,%o4	!
    .sla0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.sla0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.sla0t0-.sla0s],%o5!
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.sla0t0-.sla0s]!
	ld	[%o0+.sla0t1-.sla0s],%o5!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	st	%o5,[%o0+.sla0t1-.sla0s]!
	ld	[%o0+.sla0t2-.sla0s],%o5!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,25,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+.sla0t2-.sla0s]!
	ld	[%o0+.sla0t3-.sla0s],%o5!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+.sla0t3-.sla0s]!
	ld	[%o0+.sla0t4-.sla0s],%o5!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	st	%o5,[%o0+.sla0t4-.sla0s]!
	retl				!
	add	%o0,.sla0e-.sla0s,%o0	!
.sla0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
		andn	%g1,0x3,%g1	! CC=0
    .sla0t0:	add	%l0,0,%o0	! ##TEMPLATE:%l0,imm0 B2,D2
		and	%o0,0x3f,%o0	!
		subcc	%o0,31,%g0	!
		bg,a	.sla0t1		!
		add	%g0,31,%o0	!
    .sla0t1:	add	%g0,%l0,%o1	! ##TEMPLATE:%l0 R1
		sethi	%hi(0x80000000),%o2
		and	%o1,%o2,%o3	! extract sign
		sll	%o1,%o0,%o4	!
		andn	%o4,%o2,%o2	!
    .sla0t2:	or	%o2,%o3,%l0	! ##TEMPLATE:%l0 R1
    .sla0t3:	sra	%l0,%o0,%o2	! ##TEMPLATE:%l0 R1
		subcc	%o2,%o1,%g0	!
		be	.sla0t4		! if overflow then
		andcc	%g7,8,%g0	!   CC=3
		bz	.sla001		!   if fixed-point overflow mask then
		or	%g1,0x3,%g1	!
		sethi	%hi(0x00080000),%o0
		ba	.sla001		!
		or	%g7,%o0,%g7	!     fixed-point overflow
    .sla0t4:	addcc	%g0,%l0,%g0	! ##TEMPLATE:%l0 R1
		bg,a	.sla001		! if %l0 > 0 then
		or	%g1,0x2,%g1	!   CC=2
		bl,a	.sla001		! if %l0 < 0 then
		or	%g1,0x1,%g1	!   CC=1
    .sla001:	andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.sla0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.sla0e:

	.section ".text"
	.align	4
	.global ci4_srdl,ti4_srdl
ci4_srdl:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	.srdl1c			!
	nop				!
    .srdl0c:				!
	retl				! case even:
	add	%g0,.srdl0e-.srdl0s,%o0 !
    .srdl1c:				!
	retl				! case odd:
	add	%g0,.srdl1e-.srdl1s,%o0 !   specification exception
ti4_srdl:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	.srdl1t			!
	nop				!
    .srdl0t:				!
	sethi	%hi(.srdl0s),%o3	!
	or	%o3,%lo(.srdl0s),%o3	!
	or	%g0,.srdl0e-.srdl0s,%o4 !
    .srdl0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.srdl0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.srdl0t0-.srdl0s],%o5
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.srdl0t0-.srdl0s]
	ld	[%o0+.srdl0t1-.srdl0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1+1
	add	%o4,1,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	sll	%o4,11,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+.srdl0t1-.srdl0s]
	ld	[%o0+.srdl0t2-.srdl0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+.srdl0t2-.srdl0s]
	ld	[%o0+.srdl0t3-.srdl0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1+1
	add	%o4,1,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	sll	%o4,11,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+.srdl0t3-.srdl0s]
	ld	[%o0+.srdl0t4-.srdl0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	sll	%o4,11,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+.srdl0t4-.srdl0s]
	ld	[%o0+.srdl0t5-.srdl0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1+1
	add	%o4,1,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,25,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+.srdl0t5-.srdl0s]
	ld	[%o0+.srdl0t6-.srdl0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,25,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+.srdl0t6-.srdl0s]
	retl				!
	add	%o0,.srdl0e-.srdl0s,%o0 !
    .srdl1t:				!
	sethi	%hi(.srdl1s),%o3	!
	or	%o3,%lo(.srdl1s),%o3	!
	or	%g0,.srdl1e-.srdl1s,%o4 !
    .srdl1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.srdl1cp		!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,.srdl1e-.srdl1s,%o0 !
.srdl0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
    .srdl0t0:	add	%l0,0,%o0	! ##TEMPLATE:%l0,imm0 B2,D2
		andcc	%o0,0x3f,%o0	!
		bz	.srdl000	! if SHIFT == 0 then do nothing
		subcc	%o0,31,%g0	!
		bg	.srdl0t5	! if SHIFT >= 32 then skip
		sub	%o0,32,%o1	!
		sub	%g0,%o1,%o1	!
    .srdl0t1:	srl	%l0,%o0,%l0	! ##TEMPLATE:%l0,%l0 R1+1,R1+1
    .srdl0t2:	sll	%l0,%o1,%o1	! ##TEMPLATE:%l0 R1
    .srdl0t3:	or	%l0,%o1,%l0	! ##TEMPLATE:%l0,%l0 R1+1,R1+1
		ba	.srdl000	!
    .srdl0t4:	srl	%l0,%o0,%l0	! ##TEMPLATE:%l0,%l0 R1,R1
    .srdl0t5:	srl	%l0,%o1,%l0	! ##TEMPLATE:%l0,%l0 R1,R1+1
    .srdl0t6:	add	%g0,%g0,%l0	! ##TEMPLATE:%l0 R1
    .srdl000:	andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.srdl0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.srdl0e:
.srdl1s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
		sethi	%hi(0x00060000),%o0
		or	%g7,%o0,%g7	! specification exception
		ba	.srdl1e		! retuen(TEMPLATE)
		add	%g1,0x10,%g1	!
.srdl1e:

	.section ".text"
	.align	4
	.global ci4_sldl,ti4_sldl
ci4_sldl:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	.sldl1c			!
	nop				!
    .sldl0c:				!
	retl				! case even:
	add	%g0,.sldl0e-.sldl0s,%o0 !
    .sldl1c:				!
	retl				! case odd:
	add	%g0,.sldl1e-.sldl1s,%o0 !   specification exception
ti4_sldl:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	.sldl1t			!
	nop				!
    .sldl0t:				!
	sethi	%hi(.sldl0s),%o3	!
	or	%o3,%lo(.sldl0s),%o3	!
	or	%g0,.sldl0e-.sldl0s,%o4 !
    .sldl0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.sldl0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.sldl0t0-.sldl0s],%o5
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.sldl0t0-.sldl0s]
	ld	[%o0+.sldl0t1-.sldl0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	sll	%o4,11,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+.sldl0t1-.sldl0s]
	ld	[%o0+.sldl0t2-.sldl0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1+1
	add	%o4,1,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+.sldl0t2-.sldl0s]
	ld	[%o0+.sldl0t3-.sldl0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	sll	%o4,11,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+.sldl0t3-.sldl0s]
	ld	[%o0+.sldl0t4-.sldl0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1+1
	add	%o4,1,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	sll	%o4,11,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+.sldl0t4-.sldl0s]
	ld	[%o0+.sldl0t5-.sldl0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1+1
	add	%o4,1,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,25,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+.sldl0t5-.sldl0s]
	ld	[%o0+.sldl0t6-.sldl0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1+1
	add	%o4,1,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,25,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+.sldl0t6-.sldl0s]
	retl				!
	add	%o0,.sldl0e-.sldl0s,%o0 !
    .sldl1t:				!
	sethi	%hi(.sldl1s),%o3	!
	or	%o3,%lo(.sldl1s),%o3	!
	or	%g0,.sldl1e-.sldl1s,%o4 !
    .sldl1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.sldl1cp		!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,.sldl1e-.sldl1s,%o0 !
.sldl0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
    .sldl0t0:	add	%l0,0,%o0	! ##TEMPLATE:%l0,imm0 B2,D2
		andcc	%o0,0x3f,%o0	!
		bz	.sldl000	! if SHIFT == 0 then do nothing
		subcc	%o0,31,%g0	!
		bg	.sldl0t5	! if SHIFT >= 32 then skip
		sub	%o0,32,%o1	!
		sub	%g0,%o1,%o1	!
    .sldl0t1:	sll	%l0,%o0,%l0	! ##TEMPLATE:%l0,%l0 R1,R1
    .sldl0t2:	srl	%l0,%o1,%o1	! ##TEMPLATE:%l0 R1+1
    .sldl0t3:	or	%l0,%o1,%l0	! ##TEMPLATE:%l0,%l0 R1,R1
		ba	.sldl000	!
    .sldl0t4:	sll	%l0,%o0,%l0	! ##TEMPLATE:%l0,%l0 R1+1,R1+1
    .sldl0t5:	sll	%l0,%o1,%l0	! ##TEMPLATE:%l0,%l0 R1+1,R1
    .sldl0t6:	add	%g0,%g0,%l0	! ##TEMPLATE:%l0 R1+1
    .sldl000:	andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.sldl0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.sldl0e:
.sldl1s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
		sethi	%hi(0x00060000),%o0
		or	%g7,%o0,%g7	! specification exception
		ba	.sldl1e		! retuen(TEMPLATE)
		add	%g1,0x10,%g1	!
.sldl1e:

	.section ".text"
	.align	4
	.global ci4_srda,ti4_srda
ci4_srda:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	.srda1c			!
	nop				!
    .srda0c:				!
	retl				! case even:
	add	%g0,.srda0e-.srda0s,%o0 !
    .srda1c:				!
	retl				! case odd:
	add	%g0,.srda1e-.srda1s,%o0 !   specification exception
ti4_srda:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	.srda1t			!
	nop				!
    .srda0t:				!
	sethi	%hi(.srda0s),%o3	!
	or	%o3,%lo(.srda0s),%o3	!
	or	%g0,.srda0e-.srda0s,%o4 !
    .srda0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.srda0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.srda0t0-.srda0s],%o5
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.srda0t0-.srda0s]
	ld	[%o0+.srda0t1-.srda0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1+1
	add	%o4,1,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	sll	%o4,11,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+.srda0t1-.srda0s]
	ld	[%o0+.srda0t2-.srda0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+.srda0t2-.srda0s]
	ld	[%o0+.srda0t3-.srda0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1+1
	add	%o4,1,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	sll	%o4,11,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+.srda0t3-.srda0s]
	ld	[%o0+.srda0t4-.srda0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	sll	%o4,11,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+.srda0t4-.srda0s]
	ld	[%o0+.srda0t5-.srda0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1+1
	add	%o4,1,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,25,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+.srda0t5-.srda0s]
	ld	[%o0+.srda0t6-.srda0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	sll	%o4,11,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+.srda0t6-.srda0s]
	ld	[%o0+.srda0t7-.srda0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	st	%o5,[%o0+.srda0t7-.srda0s]
	ld	[%o0+.srda0t8-.srda0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1+1
	add	%o4,1,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	st	%o5,[%o0+.srda0t8-.srda0s]
	retl				!
	add	%o0,.srda0e-.srda0s,%o0 !
    .srda1t:				!
	sethi	%hi(.srda1s),%o3	!
	or	%o3,%lo(.srda1s),%o3	!
	or	%g0,.srda1e-.srda1s,%o4 !
    .srda1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.srda1cp		!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,.srda1e-.srda1s,%o0 !
.srda0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
		andn	%g1,0x3,%g1	! CC=0
    .srda0t0:	add	%l0,0,%o0	! ##TEMPLATE:%l0,imm0 B2,D2
		andcc	%o0,0x3f,%o0	!
		bz	.srda0t7	! if SHIFT == 0 then do nothing
		subcc	%o0,31,%g0	!
		bg	.srda0t5	! if SHIFT >= 32 then skip
		sub	%o0,32,%o1	!
		sub	%g0,%o1,%o1	!
    .srda0t1:	srl	%l0,%o0,%l0	! ##TEMPLATE:%l0,%l0 R1+1,R1+1
    .srda0t2:	sll	%l0,%o1,%o1	! ##TEMPLATE:%l0 R1
    .srda0t3:	or	%l0,%o1,%l0	! ##TEMPLATE:%l0,%l0 R1+1,R1+1
		ba	.srda0t7	!
    .srda0t4:	sra	%l0,%o0,%l0	! ##TEMPLATE:%l0,%l0 R1,R1
    .srda0t5:	sra	%l0,%o1,%l0	! ##TEMPLATE:%l0,%l0 R1,R1+1
    .srda0t6:	sra	%l0,31,%l0	! ##TEMPLATE:%l0,%l0 R1,R1
    .srda0t7:	addcc	%g0,%l0,%g0	! ##TEMPLATE:%l0 R1
		bz,a	.srda001	!
    .srda0t8:	addcc	%g0,%l0,%g0	! ##TEMPLATE:%l0 R1+1
		bg,a	.srda002	! if %l0 > 0 then
		or	%g1,0x2,%g1	!   CC=2
		bl,a	.srda002	! if %l0 < 0 then
		or	%g1,0x1,%g1	!   CC=1
		ba	.srda002	!
		nop			!
    .srda001:	bnz,a	.srda002	! if %l0+1 != 0 then
		or	%g1,0x2,%g1	!   CC=2
    .srda002:	andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.srda0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.srda0e:
.srda1s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
		sethi	%hi(0x00060000),%o0
		or	%g7,%o0,%g7	! specification exception
		ba	.srda1e		! retuen(TEMPLATE)
		add	%g1,0x10,%g1	!
.srda1e:

	.section ".text"
	.align	4
	.global ci4_slda,ti4_slda
ci4_slda:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	.slda1c			!
	nop				!
    .slda0c:				!
	retl				! case even:
	add	%g0,.slda0e-.slda0s,%o0 !
    .slda1c:				!
	retl				! case odd:
	add	%g0,.slda1e-.slda1s,%o0 !   specification exception
ti4_slda:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	.slda1t			!
	nop				!
    .slda0t:				!
	sethi	%hi(.slda0s),%o3	!
	or	%o3,%lo(.slda0s),%o3	!
	or	%g0,.slda0e-.slda0s,%o4 !
    .slda0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.slda0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.slda0t0-.slda0s],%o5
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.slda0t0-.slda0s]
	ld	[%o0+.slda0t1-.slda0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	st	%o5,[%o0+.slda0t1-.slda0s]
	ld	[%o0+.slda0t2-.slda0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1+1
	add	%o4,1,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	st	%o5,[%o0+.slda0t2-.slda0s]
	ld	[%o0+.slda0t3-.slda0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,25,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+.slda0t3-.slda0s]
	ld	[%o0+.slda0t4-.slda0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1+1
	add	%o4,1,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	sll	%o4,11,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+.slda0t4-.slda0s]
	ld	[%o0+.slda0t5-.slda0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+.slda0t5-.slda0s]
	ld	[%o0+.slda0t6-.slda0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,25,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+.slda0t6-.slda0s]
	ld	[%o0+.slda0t7-.slda0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1+1
	add	%o4,1,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,25,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+.slda0t7-.slda0s]
	ld	[%o0+.slda0t8-.slda0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+.slda0t8-.slda0s]
	ld	[%o0+.slda0t9-.slda0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+.slda0t9-.slda0s]
	ld	[%o0+.slda0ta-.slda0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	st	%o5,[%o0+.slda0ta-.slda0s]
	ld	[%o0+.slda0tb-.slda0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1+1
	add	%o4,1,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	st	%o5,[%o0+.slda0tb-.slda0s]
	retl				!
	add	%o0,.slda0e-.slda0s,%o0 !
    .slda1t:				!
	sethi	%hi(.slda1s),%o3	!
	or	%o3,%lo(.slda1s),%o3	!
	or	%g0,.slda1e-.slda1s,%o4 !
    .slda1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.slda1cp		!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,.slda1e-.slda1s,%o0 !
.slda0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
		andn	%g1,0x3,%g1	! CC=0
    .slda0t0:	add	%l0,0,%o0	! ##TEMPLATE:%l0,imm0 B2,D2
		andcc	%o0,0x3f,%o0	!
		bz	.slda0ta	! if SHIFT == 0 then do nothing
    .slda0t1:	add	%g0,%l0,%o4	! ##TEMPLATE:%l0 R1
    .slda0t2:	add	%g0,%l0,%o5	! ##TEMPLATE:%l0 R1+1
		sethi	%hi(0x80000000),%o2
		and	%o4,%o2,%o3	! extract sign
		subcc	%o0,31,%g0	!
		bg	.slda000	! if SHIFT >= 32 then skip
		sub	%o0,32,%o1	!
		sub	%g0,%o1,%o1	!
		sll	%o4,%o0,%o7	!
		srl	%o5,%o1,%o1	!
		or	%o7,%o1,%o1	!
		andn	%o1,%o2,%o2	!
    .slda0t3:	or	%o2,%o3,%l0	! ##TEMPLATE:%l0 R1
    .slda0t4:	sll	%l0,%o0,%l0	! ##TEMPLATE:%l0,%l0 R1+1,R1+1
    .slda0t5:	sra	%l0,%o0,%o2	! ##TEMPLATE:%l0 R1
		add	%g0,%o5,%o3	!
		ba	.slda001	!
    .slda000:	sll	%o5,%o1,%o0	!
		andn	%o0,%o2,%o2	!
    .slda0t6:	or	%o2,%o3,%l0	! ##TEMPLATE:%l0 R1
    .slda0t7:	add	%g0,%g0,%l0	! ##TEMPLATE:%l0 R1+1
    .slda0t8:	sra	%l0,31,%o2	! ##TEMPLATE:%l0 R1
    .slda0t9:	sra	%l0,%o1,%o3	! ##TEMPLATE:%l0 R1
    .slda001:	subcc	%o2,%o4,%g0	!
		bne	.slda002	! if overflow then
		subcc	%o3,%o5,%g0	!
		be	.slda0ta	!
    .slda002:	andcc	%g7,8,%g0	!   CC=3
		bz	.slda005	!   if fixed-point overflow mask then
		or	%g1,0x3,%g1	!
		sethi	%hi(0x00080000),%o0
		ba	.slda005	!
		or	%g7,%o0,%g7	!     fixed-point overflow
    .slda0ta:	addcc	%g0,%l0,%g0	! ##TEMPLATE:%l0 R1
		bz,a	.slda004	!
    .slda0tb:	addcc	%g0,%l0,%g0	! ##TEMPLATE:%l0 R1+1
		bg,a	.slda005	! if %l0 > 0 then
		or	%g1,0x2,%g1	!   CC=2
		bl,a	.slda005	! if %l0 < 0 then
		or	%g1,0x1,%g1	!   CC=1
		ba	.slda005	!
		nop			!
    .slda004:	bnz,a	.slda005	! if %l0+1 != 0 then
		or	%g1,0x2,%g1	!   CC=2
    .slda005:	andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.slda0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.slda0e:
.slda1s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
		sethi	%hi(0x00060000),%o0
		or	%g7,%o0,%g7	! specification exception
		ba	.slda1e		! retuen(TEMPLATE)
		add	%g1,0x10,%g1	!
.slda1e:
!================================

!
! templates
! cxx_xxx:
!   %o0: param: none
!	 retval:size of template
!   %o1: M instruction (4 bytes)
!   %o2: work
!   %o3: work
!   %o4: work
!   %o5: flag(0:NON EXECUTE,1:EXECUTE)
! txx_xxx:
!   %o0: param: bufp start address
!	 retval:bufp next start address
!   %o1: M instruction (4 bytes)
!   %o2: work
!   %o3: work
!   %o4: work
!   %o5: flag(0:NON EXECUTE,1:EXECUTE)
!
	.section ".text"
	.align	4
	.global ci4_stm,ti4_stm
ci4_stm:
	srl	%o1,20,%o3		! R1
	and	%o3,0xf,%o3		!
	srl	%o1,16,%o4		! R3
	and	%o4,0xf,%o4		!
	sub	%o4,%o3,%o4		!
	and	%o4,0xf,%o4		! # of Regs.
	sll	%o4,2,%o4		!
	retl				!
	add	%o4,.stm0e-.stm0s,%o0	!
ti4_stm:
	sethi	%hi(.stm0s),%o3		!
	or	%o3,%lo(.stm0s),%o3	!
	or	%g0,.stm0m-.stm0s,%o4	!
    .stm0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.stm0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.stm0t0-.stm0s],%o5!
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.stm0t0-.stm0s]!
	srl	%o1,20,%o3		! R1
	and	%o3,0xf,%o3		!
	add	%g0,%g0,%o2		! address counter
    .stm0loop:				!
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		!
	subcc	%o3,%o4,%g0		!
	be	.stm0lend		!
	add	%o3,1,%o3		!
	and	%o3,0xf,%o3		!
	add	%o2,4,%o2		!
	ld	[%o0+.stm0t2-.stm0s],%o5!

	subcc	%o3,0xe,%g0		!
	bz,a	.+8			!
	add	%g0,0x16,%o3		!
	sll	%o3,25,%o3		!
	xor	%o5,%o3,%o5		!
	srl	%o3,25,%o3		!
	subcc	%o3,0x16,%g0		!
	bz,a	.+8			!
	add	%g0,0xe,%o3		!

	xor	%o5,%o2,%o5		!
	add	%o0,.stm0t2-.stm0s,%o4	!
	ba	.stm0loop		!
	st	%o5,[%o4+%o2]		!
    .stm0lend:				!
	ld	[%o0+.stm0t1-.stm0s],%o5!
	add	%o2,3,%o4		!
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.stm0t1-.stm0s]!
	ld	[%o0+.stm0t2-.stm0s],%o5!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,25,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+.stm0t2-.stm0s]!
	add	%o0,.stm0t2-.stm0s,%o0	!
	add	%o0,%o2,%o0		!
	sethi	%hi(.stm0m),%o3		!
	or	%o3,%lo(.stm0m),%o3	!
	ld	[%o3],%o5		! copy template to ibuf
	st	%o5,[%o0+4]		!
	ld	[%o3+4],%o5		! copy template to ibuf
	st	%o5,[%o0+8]		!
	ld	[%o3+8],%o5		! copy template to ibuf
	st	%o5,[%o0+12]		!
	retl				!
	add	%o0,16,%o0		!
.stm0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
    .stm0t0:	add	%l0,0,%o0	! ##TEMPLATE:%l0,imm0
		and	%o0,%g3,%o0	! mask address
		add	%g4,%o0,%o0	!
		ldub	[%o0],%g0	! force PAGEIN
    .stm0t1:	ldub	[%o0+0],%g0	! ##TEMPLATE:imm0
    .stm0t2:	st	%l0,[%o0+0]	! ##TEMPLATE:%l0
					! ##TEMPLATE:%l0,imm0
.stm0m:		andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.stm0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.stm0e:

	.section ".text"
	.align	4
	.global ci4_tm,ti4_tm
ci4_tm:
	retl				!
	add	%g0,.tm0e-.tm0s,%o0	!
ti4_tm:
	sethi	%hi(.tm0s),%o3		!
	or	%o3,%lo(.tm0s),%o3	!
	or	%g0,.tm0e-.tm0s,%o4	!
    .tm0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.tm0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.tm0t0-.tm0s],%o5	!
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B1
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	and	%o1,0xfff,%o4		! D1
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.tm0t0-.tm0s]	!
	ld	[%o0+.tm0t1-.tm0s],%o5	!
	srl	%o1,16,%o4		!
	and	%o4,0xff,%o4		! I
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.tm0t1-.tm0s]	!
	ld	[%o0+.tm0t2-.tm0s],%o5	!
	srl	%o1,16,%o4		!
	and	%o4,0xff,%o4		! I
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.tm0t2-.tm0s]	!
	retl				!
	add	%o0,.tm0e-.tm0s,%o0	!
.tm0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
    .tm0t0:	add	%l0,0,%o0	! ##TEMPLATE:%l0,imm0
		and	%o0,%g3,%o0	! mask address
		ldub	[%g4+%o0],%o0	!
		andn	%g1,0x3,%g1	! CC=0
    .tm0t1:	andcc	%o0,0,%o1	! ##TEMPLATE:imm0
		bz	.tm000		! if result == 0    then CC=0
    .tm0t2:	subcc	%o1,0,%g0	! ##TEMPLATE:imm0
		bnz,a	.tm000		!
		or	%g1,0x1,%g1	! if result != mask then CC=1
		or	%g1,0x3,%g1	! if result == mask then CC=3
    .tm000:	andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.tm0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.tm0e:

	.section ".text"
	.align	4
	.global ci4_mvi,ti4_mvi
ci4_mvi:
	retl				!
	add	%g0,.mvi0e-.mvi0s,%o0	!
ti4_mvi:
	sethi	%hi(.mvi0s),%o3		!
	or	%o3,%lo(.mvi0s),%o3	!
	or	%g0,.mvi0e-.mvi0s,%o4	!
    .mvi0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.mvi0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.mvi0t0-.mvi0s],%o5!
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B1
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	and	%o1,0xfff,%o4		! D1
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.mvi0t0-.mvi0s]!
	ld	[%o0+.mvi0t1-.mvi0s],%o5!
	srl	%o1,16,%o4		!
	and	%o4,0xff,%o4		! I
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.mvi0t1-.mvi0s]!
	retl				!
	add	%o0,.mvi0e-.mvi0s,%o0	!
.mvi0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
    .mvi0t0:	add	%l0,0,%o0	! ##TEMPLATE:%l0,imm0
		and	%o0,%g3,%o0	! mask address
    .mvi0t1:	add	%g0,0,%o1	! ##TEMPLATE:imm0
		stb	%o1,[%g4+%o0]	!
		andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.mvi0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.mvi0e:

	.section ".text"
	.align	4
	.global ci4_ts,ti4_ts
ci4_ts:
	retl				!
	add	%g0,.ts0e-.ts0s,%o0	!
ti4_ts:
	sethi	%hi(.ts0s),%o3		!
	or	%o3,%lo(.ts0s),%o3	!
	or	%g0,.ts0e-.ts0s,%o4	!
    .ts0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.ts0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.ts0t0-.ts0s],%o5	!
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B1
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	and	%o1,0xfff,%o4		! D1
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.ts0t0-.ts0s]	!
	retl				!
	add	%o0,.ts0e-.ts0s,%o0	!
.ts0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
    .ts0t0:	add	%l0,0,%o0	! ##TEMPLATE:%l0,imm0
		and	%o0,%g3,%o0	! mask address
		ldub	[%g4+%o0],%o1	!
		andn	%g1,0x3,%g1	! CC=0
		andcc	%o1,0x80,%g0	!
		add	%g0,0xff,%o1	!
		stb	%o1,[%g4+%o0]	! store 0xff
		bnz,a	.ts000		! if MSB == 1 then
		or	%g1,0x1,%g1	!   CC=1
    .ts000:	andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.ts0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.ts0e:

	.section ".text"
	.align	4
	.global ci4_ni,ti4_ni
ci4_ni:
	retl				!
	add	%g0,.ni0e-.ni0s,%o0	!
ti4_ni:
	sethi	%hi(.ni0s),%o3		!
	or	%o3,%lo(.ni0s),%o3	!
	or	%g0,.ni0e-.ni0s,%o4	!
    .ni0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.ni0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.ni0t0-.ni0s],%o5	!
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B1
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	and	%o1,0xfff,%o4		! D1
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.ni0t0-.ni0s]	!
	ld	[%o0+.ni0t1-.ni0s],%o5	!
	srl	%o1,16,%o4		!
	and	%o4,0xff,%o4		! I
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.ni0t1-.ni0s]	!
	retl				!
	add	%o0,.ni0e-.ni0s,%o0	!
.ni0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
    .ni0t0:	add	%l0,0,%o0	! ##TEMPLATE:%l0,imm0
		and	%o0,%g3,%o0	! mask address
		ldub	[%g4+%o0],%o1	!
		andn	%g1,0x3,%g1	! CC=0
    .ni0t1:	andcc	%o1,0,%o1	! ##TEMPLATE:imm0
		stb	%o1,[%g4+%o0]	!
		bnz,a	.ni000		! if result != 0 then
		or	%g1,0x1,%g1	!   CC=1
    .ni000:	andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.ni0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.ni0e:

	.section ".text"
	.align	4
	.global ci4_cli,ti4_cli
ci4_cli:
	retl				!
	add	%g0,.cli0e-.cli0s,%o0	!
ti4_cli:
	sethi	%hi(.cli0s),%o3		!
	or	%o3,%lo(.cli0s),%o3	!
	or	%g0,.cli0e-.cli0s,%o4	!
    .cli0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.cli0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.cli0t0-.cli0s],%o5!
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B1
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	and	%o1,0xfff,%o4		! D1
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.cli0t0-.cli0s]!
	ld	[%o0+.cli0t1-.cli0s],%o5!
	srl	%o1,16,%o4		!
	and	%o4,0xff,%o4		! I
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.cli0t1-.cli0s]!
	retl				!
	add	%o0,.cli0e-.cli0s,%o0	!
.cli0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
    .cli0t0:	add	%l0,0,%o0	! ##TEMPLATE:%l0,imm0
		and	%o0,%g3,%o0	! mask address
		ldub	[%g4+%o0],%o1	!
		andn	%g1,0x3,%g1	! CC=0
    .cli0t1:	subcc	%o1,0,%o1	! ##TEMPLATE:imm0
		bgu,a	.cli001		! if %l0 > 0 then
		or	%g1,0x2,%g1	!   CC=2
		bcs,a	.cli001		! if %l0 < 0 then
		or	%g1,0x1,%g1	!   CC=1
    .cli001:	andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.cli0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.cli0e:

	.section ".text"
	.align	4
	.global ci4_oi,ti4_oi
ci4_oi:
	retl				!
	add	%g0,.oi0e-.oi0s,%o0	!
ti4_oi:
	sethi	%hi(.oi0s),%o3		!
	or	%o3,%lo(.oi0s),%o3	!
	or	%g0,.oi0e-.oi0s,%o4	!
    .oi0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.oi0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.oi0t0-.oi0s],%o5	!
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B1
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	and	%o1,0xfff,%o4		! D1
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.oi0t0-.oi0s]	!
	ld	[%o0+.oi0t1-.oi0s],%o5	!
	srl	%o1,16,%o4		!
	and	%o4,0xff,%o4		! I
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.oi0t1-.oi0s]	!
	retl				!
	add	%o0,.oi0e-.oi0s,%o0	!
.oi0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
    .oi0t0:	add	%l0,0,%o0	! ##TEMPLATE:%l0,imm0
		and	%o0,%g3,%o0	! mask address
		ldub	[%g4+%o0],%o1	!
		andn	%g1,0x3,%g1	! CC=0
    .oi0t1:	orcc	%o1,0,%o1	! ##TEMPLATE:imm0
		stb	%o1,[%g4+%o0]	!
		bnz,a	.oi000		! if result != 0 then
		or	%g1,0x1,%g1	!   CC=1
    .oi000:	andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.oi0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.oi0e:

	.section ".text"
	.align	4
	.global ci4_xi,ti4_xi
ci4_xi:
	retl				!
	add	%g0,.xi0e-.xi0s,%o0	!
ti4_xi:
	sethi	%hi(.xi0s),%o3		!
	or	%o3,%lo(.xi0s),%o3	!
	or	%g0,.xi0e-.xi0s,%o4	!
    .xi0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.xi0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.xi0t0-.xi0s],%o5	!
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B1
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	and	%o1,0xfff,%o4		! D1
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.xi0t0-.xi0s]	!
	ld	[%o0+.xi0t1-.xi0s],%o5	!
	srl	%o1,16,%o4		!
	and	%o4,0xff,%o4		! I
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.xi0t1-.xi0s]	!
	retl				!
	add	%o0,.xi0e-.xi0s,%o0	!
.xi0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
    .xi0t0:	add	%l0,0,%o0	! ##TEMPLATE:%l0,imm0
		and	%o0,%g3,%o0	! mask address
		ldub	[%g4+%o0],%o1	!
		andn	%g1,0x3,%g1	! CC=0
    .xi0t1:	xorcc	%o1,0,%o1	! ##TEMPLATE:imm0
		stb	%o1,[%g4+%o0]	!
		bnz,a	.xi000		! if result != 0 then
		or	%g1,0x1,%g1	!   CC=1
    .xi000:	andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.xi0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.xi0e:

	.section ".text"
	.align	4
	.global ci4_lm,ti4_lm
ci4_lm:
	srl	%o1,20,%o3		! R1
	and	%o3,0xf,%o3		!
	srl	%o1,16,%o4		! R3
	and	%o4,0xf,%o4		!
	sub	%o4,%o3,%o4		!
	and	%o4,0xf,%o4		! # of Regs.
	sll	%o4,2,%o4		!
	retl				!
	add	%o4,.lm0e-.lm0s,%o0	!
ti4_lm:
	sethi	%hi(.lm0s),%o3		!
	or	%o3,%lo(.lm0s),%o3	!
	or	%g0,.lm0m-.lm0s,%o4	!
    .lm0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.lm0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.lm0t0-.lm0s],%o5	!
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.lm0t0-.lm0s]	!
	srl	%o1,20,%o3		! R1
	and	%o3,0xf,%o3		!
	add	%g0,%g0,%o2		! address counter
    .lm0loop:				!
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		!
	subcc	%o3,%o4,%g0		!
	be	.lm0lend		!
	add	%o3,1,%o3		!
	and	%o3,0xf,%o3		!
	add	%o2,4,%o2		!
	ld	[%o0+.lm0t2-.lm0s],%o5	!

	subcc	%o3,0xe,%g0		!
	bz,a	.+8			!
	add	%g0,0x16,%o3		!
	sll	%o3,25,%o3		!
	xor	%o5,%o3,%o5		!
	srl	%o3,25,%o3		!
	subcc	%o3,0x16,%g0		!
	bz,a	.+8			!
	add	%g0,0xe,%o3		!

	xor	%o5,%o2,%o5		!
	add	%o0,.lm0t2-.lm0s,%o4	!
	ba	.lm0loop		!
	st	%o5,[%o4+%o2]		!
    .lm0lend:				!
	ld	[%o0+.lm0t1-.lm0s],%o5	!
	add	%o2,3,%o4		!
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.lm0t1-.lm0s]	!
	ld	[%o0+.lm0t2-.lm0s],%o5	!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,25,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+.lm0t2-.lm0s]	!
	add	%o0,.lm0t2-.lm0s,%o0	!
	add	%o0,%o2,%o0		!
	sethi	%hi(.lm0m),%o3		!
	or	%o3,%lo(.lm0m),%o3	!
	ld	[%o3],%o5		! copy template to ibuf
	st	%o5,[%o0+4]		!
	ld	[%o3+4],%o5		! copy template to ibuf
	st	%o5,[%o0+8]		!
	ld	[%o3+8],%o5		! copy template to ibuf
	st	%o5,[%o0+12]		!
	retl				!
	add	%o0,16,%o0		!
.lm0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
    .lm0t0:	add	%l0,0,%o0	! ##TEMPLATE:%l0,imm0
		and	%o0,%g3,%o0	! mask address
		add	%g4,%o0,%o0	!
		ldub	[%o0],%g0	! force PAGEIN
    .lm0t1:	ldub	[%o0+0],%g0	! ##TEMPLATE:imm0
    .lm0t2:	ld	[%o0+0],%l0	! ##TEMPLATE:%l0
					! ##TEMPLATE:%l0,imm0
.lm0m:		andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.lm0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.lm0e:

	.section ".text"
	.align	4
	.global cc4_9cxx,tc4_9cxx
cc4_9cxx:
	retl				!
	add	%g0,.9cxx0e-.9cxx0s,%o0	!
tc4_9cxx:
	sethi	%hi(.9cxx0s),%o3	!
	or	%o3,%lo(.9cxx0s),%o3	!
	or	%g0,.9cxx0e-.9cxx0s,%o4	!
    .9cxx0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.9cxx0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.9cxx0t0-.9cxx0s],%o5
	srl	%o1,10,%o4		!
	or	%o5,%o4,%o5		! simm22
	st	%o5,[%o0+.9cxx0t0-.9cxx0s]
	ld	[%o0+.9cxx0t1-.9cxx0s],%o5
	and	%o1,0xfff,%o4		!
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.9cxx0t1-.9cxx0s]
	retl				!
	add	%o0,.9cxx0e-.9cxx0s,%o0	!
.9cxx0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
		ld	[%sp+92],%o7	! struct *guest
    .9cxx0t0:	sethi	0,%o0		! ##TEMPLATE:imm
    .9cxx0t1:	or	%o0,0,%o0	! ##TEMPLATE:imm
		st	%o0,[%o7+200]	! store minsn (upper)
		st	%g0,[%o7+204]	! store minsn (lower)
		sethi	%hi(0x80000000),%o0
		or	%g7,%o0,%g7	! Special Instruction (FC=2)
		ba	.9cxx0e		! return(TEMPLATE)
		add	%g1,0x10,%g1	!
.9cxx0e:
	
	.section ".text"
	.align	4
	.global cc4_9dxx,tc4_9dxx
cc4_9dxx:
	retl				!
	add	%g0,.9dxx0e-.9dxx0s,%o0	!
tc4_9dxx:
	sethi	%hi(.9dxx0s),%o3	!
	or	%o3,%lo(.9dxx0s),%o3	!
	or	%g0,.9dxx0e-.9dxx0s,%o4	!
    .9dxx0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.9dxx0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.9dxx0t0-.9dxx0s],%o5
	srl	%o1,10,%o4		!
	or	%o5,%o4,%o5		! simm22
	st	%o5,[%o0+.9dxx0t0-.9dxx0s]
	ld	[%o0+.9dxx0t1-.9dxx0s],%o5
	and	%o1,0xfff,%o4		!
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.9dxx0t1-.9dxx0s]
	retl				!
	add	%o0,.9dxx0e-.9dxx0s,%o0	!
.9dxx0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
		ld	[%sp+92],%o7	! struct *guest
    .9dxx0t0:	sethi	0,%o0		! ##TEMPLATE:imm
    .9dxx0t1:	or	%o0,0,%o0	! ##TEMPLATE:imm
		st	%o0,[%o7+200]	! store minsn (upper)
		st	%g0,[%o7+204]	! store minsn (lower)
		sethi	%hi(0x80000000),%o0
		or	%g7,%o0,%g7	! Special Instruction (FC=2)
		ba	.9dxx0e		! return(TEMPLATE)
		add	%g1,0x10,%g1	!
.9dxx0e:
	
	.section ".text"
	.align	4
	.global cc4_9exx,tc4_9exx
cc4_9exx:
	retl				!
	add	%g0,.9exx0e-.9exx0s,%o0	!
tc4_9exx:
	sethi	%hi(.9exx0s),%o3	!
	or	%o3,%lo(.9exx0s),%o3	!
	or	%g0,.9exx0e-.9exx0s,%o4	!
    .9exx0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.9exx0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.9exx0t0-.9exx0s],%o5
	srl	%o1,10,%o4		!
	or	%o5,%o4,%o5		! simm22
	st	%o5,[%o0+.9exx0t0-.9exx0s]
	ld	[%o0+.9exx0t1-.9exx0s],%o5
	and	%o1,0xfff,%o4		!
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.9exx0t1-.9exx0s]
	retl				!
	add	%o0,.9exx0e-.9exx0s,%o0	!
.9exx0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
		ld	[%sp+92],%o7	! struct *guest
    .9exx0t0:	sethi	0,%o0		! ##TEMPLATE:imm
    .9exx0t1:	or	%o0,0,%o0	! ##TEMPLATE:imm
		st	%o0,[%o7+200]	! store minsn (upper)
		st	%g0,[%o7+204]	! store minsn (lower)
		sethi	%hi(0x80000000),%o0
		or	%g7,%o0,%g7	! Special Instruction (FC=2)
		ba	.9exx0e		! return(TEMPLATE)
		add	%g1,0x10,%g1	!
.9exx0e:

	.section ".text"
	.align	4
	.global cc4_9fxx,tc4_9fxx
cc4_9fxx:
	retl				!
	add	%g0,.9fxx0e-.9fxx0s,%o0	!
tc4_9fxx:
	sethi	%hi(.9fxx0s),%o3	!
	or	%o3,%lo(.9fxx0s),%o3	!
	or	%g0,.9fxx0e-.9fxx0s,%o4	!
    .9fxx0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.9fxx0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.9fxx0t0-.9fxx0s],%o5
	srl	%o1,10,%o4		!
	or	%o5,%o4,%o5		! simm22
	st	%o5,[%o0+.9fxx0t0-.9fxx0s]
	ld	[%o0+.9fxx0t1-.9fxx0s],%o5
	and	%o1,0xfff,%o4		!
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.9fxx0t1-.9fxx0s]
	retl				!
	add	%o0,.9fxx0e-.9fxx0s,%o0	!
.9fxx0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
		ld	[%sp+92],%o7	! struct *guest
    .9fxx0t0:	sethi	0,%o0		! ##TEMPLATE:imm
    .9fxx0t1:	or	%o0,0,%o0	! ##TEMPLATE:imm
		st	%o0,[%o7+200]	! store minsn (upper)
		st	%g0,[%o7+204]	! store minsn (lower)
		sethi	%hi(0x80000000),%o0
		or	%g7,%o0,%g7	! Special Instruction (FC=2)
		ba	.9fxx0e		! return(TEMPLATE)
		add	%g1,0x10,%g1	!
.9fxx0e:
!================================

!
! templates
! cxx_xxx:
!   %o0: param: none
!	 retval:size of template
!   %o1: M instruction (4 bytes)
!   %o2: work
!   %o3: work
!   %o4: work
!   %o5: flag(0:NON EXECUTE,1:EXECUTE)
! txx_xxx:
!   %o0: param: bufp start address
!	 retval:bufp next start address
!   %o1: M instruction (4 bytes)
!   %o2: work
!   %o3: work
!   %o4: work
!   %o5: flag(0:NON EXECUTE,1:EXECUTE)
!
	.section ".text"
	.align	4
	.global ci4_ai,ti4_ai
ci4_ai:
	retl				!
	add	%g0,.ai0e-.ai0s,%o0	!
ti4_ai:
	sethi	%hi(.ai0s),%o3		!
	or	%o3,%lo(.ai0s),%o3	!
	or	%g0,.ai0e-.ai0s,%o4	!
    .ai0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.ai0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.ai0t0-.ai0s],%o5	!
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B1
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	and	%o1,0xfff,%o4		! D1
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.ai0t0-.ai0s]	!
	ld	[%o0+.ai0t1-.ai0s],%o5	!
	srl	%o1,16,%o4		!
	and	%o4,0xff,%o4		! I
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.ai0t1-.ai0s]	!
	retl				!
	add	%o0,.ai0e-.ai0s,%o0	!
.ai0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
    .ai0t0:	add	%l0,0,%o0	! ##TEMPLATE:%l0,imm0
		and	%o0,%g3,%o0	! mask address
		ldub	[%g4+%o0],%o1	!
		andn	%g1,0x3,%g1	! CC=0
    .ai0t1:	add	%o1,0,%o1	! ##TEMPLATE:imm0
		stb	%o1,[%g4+%o0]	!
		andcc	%o1,0xff,%g0	!	
		bnz,a	.ai000		! if result != 0 then
		or	%g1,0x1,%g1	!   CC=1,3
    .ai000:	andncc	%o1,0xff,%g0	!
		bnz,a	.ai001		! if carry then
		or	%g1,0x2,%g1	!   CC=2,4
    .ai001:	andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.ai0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.ai0e:

	.section ".text"
	.align	4
	.global cc4_stnsm,tc4_stnsm
cc4_stnsm:
	retl				!
	add	%g0,.stnsm0e-.stnsm0s,%o0
tc4_stnsm:
	sethi	%hi(.stnsm0s),%o3	!
	or	%o3,%lo(.stnsm0s),%o3	!
	or	%g0,.stnsm0e-.stnsm0s,%o4
    .stnsm0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.stnsm0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.stnsm0t0-.stnsm0s],%o5
	srl	%o1,10,%o4		!
	or	%o5,%o4,%o5		! simm22
	st	%o5,[%o0+.stnsm0t0-.stnsm0s]
	ld	[%o0+.stnsm0t1-.stnsm0s],%o5
	and	%o1,0xfff,%o4		!
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.stnsm0t1-.stnsm0s]
	retl				!
	add	%o0,.stnsm0e-.stnsm0s,%o0
.stnsm0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
		ld	[%sp+92],%o7	! struct *guest
    .stnsm0t0:	sethi	0,%o0		! ##TEMPLATE:imm
    .stnsm0t1:	or	%o0,0,%o0	! ##TEMPLATE:imm
		st	%o0,[%o7+200]	! store minsn (upper)
		st	%g0,[%o7+204]	! store minsn (lower)
		sethi	%hi(0x80000000),%o0
		or	%g7,%o0,%g7	! Special Instruction (FC=2)
		ba	.stnsm0e	! return(TEMPLATE)
		add	%g1,0x10,%g1	!
.stnsm0e:

	.section ".text"
	.align	4
	.global cc4_stosm,tc4_stosm
cc4_stosm:
	retl				!
	add	%g0,.stosm0e-.stosm0s,%o0
tc4_stosm:
	sethi	%hi(.stosm0s),%o3	!
	or	%o3,%lo(.stosm0s),%o3	!
	or	%g0,.stosm0e-.stosm0s,%o4
    .stosm0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.stosm0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.stosm0t0-.stosm0s],%o5
	srl	%o1,10,%o4		!
	or	%o5,%o4,%o5		! simm22
	st	%o5,[%o0+.stosm0t0-.stosm0s]
	ld	[%o0+.stosm0t1-.stosm0s],%o5
	and	%o1,0xfff,%o4		!
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.stosm0t1-.stosm0s]
	retl				!
	add	%o0,.stosm0e-.stosm0s,%o0
.stosm0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
		ld	[%sp+92],%o7	! struct *guest
    .stosm0t0:	sethi	0,%o0		! ##TEMPLATE:imm
    .stosm0t1:	or	%o0,0,%o0	! ##TEMPLATE:imm
		st	%o0,[%o7+200]	! store minsn (upper)
		st	%g0,[%o7+204]	! store minsn (lower)
		sethi	%hi(0x80000000),%o0
		or	%g7,%o0,%g7	! Special Instruction (FC=2)
		ba	.stosm0e	! return(TEMPLATE)
		add	%g1,0x10,%g1	!
.stosm0e:

	.section ".text"
	.align	4
	.global cc4_sigp,tc4_sigp
cc4_sigp:
	retl				!
	add	%g0,.sigp0e-.sigp0s,%o0 !
tc4_sigp:
	sethi	%hi(.sigp0s),%o3	!
	or	%o3,%lo(.sigp0s),%o3	!
	or	%g0,.sigp0e-.sigp0s,%o4 !
    .sigp0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.sigp0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.sigp0t0-.sigp0s],%o5
	srl	%o1,10,%o4		!
	or	%o5,%o4,%o5		! simm22
	st	%o5,[%o0+.sigp0t0-.sigp0s]
	ld	[%o0+.sigp0t1-.sigp0s],%o5
	and	%o1,0xfff,%o4		!
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.sigp0t1-.sigp0s]
	retl				!
	add	%o0,.sigp0e-.sigp0s,%o0 !
.sigp0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
		ld	[%sp+92],%o7	! struct *guest
    .sigp0t0:	sethi	0,%o0		! ##TEMPLATE:imm
    .sigp0t1:	or	%o0,0,%o0	! ##TEMPLATE:imm
		st	%o0,[%o7+200]	! store minsn (upper)
		st	%g0,[%o7+204]	! store minsn (lower)
		sethi	%hi(0x80000000),%o0
		or	%g7,%o0,%g7	! Special Instruction (FC=2)
		ba	.sigp0e		! return(TEMPLATE)
		add	%g1,0x10,%g1	!
.sigp0e:

	.section ".text"
	.align	4
	.global ci4_mc,ti4_mc
ci4_mc:
	srl	%o1,20,%o3		! switch (upper 4bit of I2)
	andcc	%o3,15,%g0		!
	bnz	.mc1c			!
	nop				!
    .mc0c:				!
	retl				! case 0:
	add	%g0,.mc0e-.mc0s,%o0	!
    .mc1c:				!
	retl				! case nonzero:
	add	%g0,.mc1e-.mc1s,%o0	!
ti4_mc:
	srl	%o1,20,%o3		! switch (upper 4bit of I2)
	andcc	%o3,15,%g0		!
	bnz	.mc1t			!
	nop				!
    .mc0t:				!
	sethi	%hi(.mc0s),%o3		!
	or	%o3,%lo(.mc0s),%o3	!
	or	%g0,.mc0e-.mc0s,%o4	!
    .mc0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.mc0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.mc0t0-.mc0s],%o5	!
	srl	%o1,10,%o4		!
	or	%o5,%o4,%o5		! simm22
	st	%o5,[%o0+.mc0t0-.mc0s]	!
	ld	[%o0+.mc0t1-.mc0s],%o5	!
	and	%o1,0xfff,%o4		!
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.mc0t1-.mc0s]	!
	retl				!
	add	%o0,.mc0e-.mc0s,%o0	!
    .mc1t:				!
	sethi	%hi(.mc1s),%o3		!
	or	%o3,%lo(.mc1s),%o3	!
	or	%g0,.mc1e-.mc1s,%o4	!
    .mc1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.mc1cp			!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,.mc1e-.mc1s,%o0	!
.mc0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
		ld	[%sp+92],%o7	! struct *guest
    .mc0t0:	sethi	0,%o0		! ##TEMPLATE:imm
    .mc0t1:	or	%o0,0,%o0	! ##TEMPLATE:imm
		st	%o0,[%o7+200]	! store minsn (upper)
		st	%g0,[%o7+204]	! store minsn (lower)
		sethi	%hi(0x80000000),%o0
		or	%g7,%o0,%g7	! Special Instruction (FC=2)
		ba	.mc0e		! return(TEMPLATE)
		add	%g1,0x10,%g1	!
.mc0e:
.mc1s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
		sethi	%hi(0x00060000),%o0
		or	%g7,%o0,%g7	! specification exception
		ba	.mc1e		! retuen(TEMPLATE)
		add	%g1,0x10,%g1	!
.mc1e:
!================================

!
! templates
! cxx_xxx:
!   %o0: param: none
!	 retval:size of template
!   %o1: M instruction (4 bytes)
!   %o2: work
!   %o3: work
!   %o4: work
!   %o5: flag(0:NON EXECUTE,1:EXECUTE)
! txx_xxx:
!   %o0: param: bufp start address
!	 retval:bufp next start address
!   %o1: M instruction (4 bytes)
!   %o2: work
!   %o3: work
!   %o4: work
!   %o5: flag(0:NON EXECUTE,1:EXECUTE)
!
	.section ".text"
	.align	4
	.global cc4_lra,tc4_lra
cc4_lra:
	retl				!
	add	%g0,.lra0e-.lra0s,%o0	!
tc4_lra:
	sethi	%hi(.lra0s),%o3		!
	or	%o3,%lo(.lra0s),%o3	!
	or	%g0,.lra0e-.lra0s,%o4	!
    .lra0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.lra0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.lra0t0-.lra0s],%o5!
	srl	%o1,10,%o4		!
	or	%o5,%o4,%o5		! simm22
	st	%o5,[%o0+.lra0t0-.lra0s]!
	ld	[%o0+.lra0t1-.lra0s],%o5!
	and	%o1,0xfff,%o4		!
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.lra0t1-.lra0s]!
	retl				!
	add	%o0,.lra0e-.lra0s,%o0	!
.lra0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
		ld	[%sp+92],%o7	! struct *guest
    .lra0t0:	sethi	0,%o0		! ##TEMPLATE:imm
    .lra0t1:	or	%o0,0,%o0	! ##TEMPLATE:imm
		st	%o0,[%o7+200]	! store minsn (upper)
		st	%g0,[%o7+204]	! store minsn (lower)
		sethi	%hi(0x80000000),%o0
		or	%g7,%o0,%g7	! Special Instruction (FC=2)
		ba	.lra0e		! return(TEMPLATE)
		add	%g1,0x10,%g1	!
.lra0e:

	.section ".text"
	.align	4
	.global cc4_b2xx,tc4_b2xx
cc4_b2xx:
	retl				!
	add	%g0,.b2xx0e-.b2xx0s,%o0 !
tc4_b2xx:
	sethi	%hi(.b2xx0s),%o3	!
	or	%o3,%lo(.b2xx0s),%o3	!
	or	%g0,.b2xx0e-.b2xx0s,%o4 !
    .b2xx0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.b2xx0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.b2xx0t0-.b2xx0s],%o5
	srl	%o1,10,%o4		!
	or	%o5,%o4,%o5		! simm22
	st	%o5,[%o0+.b2xx0t0-.b2xx0s]
	ld	[%o0+.b2xx0t1-.b2xx0s],%o5
	and	%o1,0xfff,%o4		!
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.b2xx0t1-.b2xx0s]
	retl				!
	add	%o0,.b2xx0e-.b2xx0s,%o0 !
.b2xx0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
		ld	[%sp+92],%o7	! struct *guest
    .b2xx0t0:	sethi	0,%o0		! ##TEMPLATE:imm
    .b2xx0t1:	or	%o0,0,%o0	! ##TEMPLATE:imm
		st	%o0,[%o7+200]	! store minsn (upper)
		st	%g0,[%o7+204]	! store minsn (lower)
		sethi	%hi(0x80000000),%o0
		or	%g7,%o0,%g7	! Special Instruction (FC=2)
		ba	.b2xx0e		! return(TEMPLATE)
		add	%g1,0x10,%g1	!
.b2xx0e:

	.section ".text"
	.align	4
	.global ci4_ipm,ti4_ipm
ci4_ipm:
	retl				!
	add	%g0,.ipm0e-.ipm0s,%o0	!
ti4_ipm:
	sethi	%hi(.ipm0s),%o3		!
	or	%o3,%lo(.ipm0s),%o3	!
	or	%g0,.ipm0e-.ipm0s,%o4	!
    .ipm0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.ipm0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.ipm0t0-.ipm0s],%o5!
	srl	%o1,4,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+.ipm0t0-.ipm0s]!
	ld	[%o0+.ipm0t1-.ipm0s],%o5!
	srl	%o1,4,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,25,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+.ipm0t1-.ipm0s]!
	retl				!
	add	%o0,.ipm0e-.ipm0s,%o0	!
.ipm0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
		sethi	%hi(0xff000000),%o1
    .ipm0t0:	andn	%l0,%o1,%o2	! ##TEMPLATE:%l0
		and	%g1,0x3,%o1	! CC
		sll	%o1,28,%o1	!
		or	%o1,%o2,%o2	!
		and	%g7,0xf,%o1	! Prog-Mask
		sll	%o1,24,%o1	!
    .ipm0t1:	or	%o1,%o2,%l0	! ##TEMPLATE:%l0
		andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.ipm0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.ipm0e:

	.section ".text"
	.align	4
	.global cf4_dxr,tf4_dxr
cf4_dxr:
	srl	%o1,4,%o3		! switch (R1)
	srl	%o1,0,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,3,%g0		!
	bnz	.dxr1c			!
	nop				!
    .dxr0c:				!
	retl				! case even:
	add	%g0,.dxr0e-.dxr0s,%o0	!
    .dxr1c:				!
	retl				! case odd:
	add	%g0,.dxr1e-.dxr1s,%o0	!   specification exception
tf4_dxr:
	srl	%o1,4,%o3		! switch (R1)
	srl	%o1,0,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,3,%g0		!
	bnz	.dxr1t			!
	nop				!
    .dxr0t:				!
	sethi	%hi(.dxr0s),%o3		!
	or	%o3,%lo(.dxr0s),%o3	!
	or	%g0,.dxr0e-.dxr0s,%o4	!
    .dxr0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.dxr0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.dxr0t0-.dxr0s],%o5!
	srl	%o1,0,%o4		!
	and	%o4,0xf,%o4		! R2
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+.dxr0t0-.dxr0s]!
	ld	[%o0+.dxr0t1-.dxr0s],%o5!
	srl	%o1,4,%o4		!
	and	%o4,0xf,%o4		! R1
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+.dxr0t1-.dxr0s]!
	retl				!
	add	%o0,.dxr0e-.dxr0s,%o0	!
    .dxr1t:				!
	sethi	%hi(.dxr1s),%o3		!
	or	%o3,%lo(.dxr1s),%o3	!
	or	%g0,.dxr1e-.dxr1s,%o4	!
    .dxr1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.dxr1cp			!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,.dxr1e-.dxr1s,%o0	!
.dxr0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
		ld	[%sp+92],%o0	! struct *guest
    .dxr0t0:	add	%o0,64,%o2	! ##TEMPLATE:%imm
    .dxr0t1:	add	%o0,64,%o1	! ##TEMPLATE:%imm
		and	%g7,0xf,%o3	! give Program Mask
		st	%g1,[%o0+132]	!
		st	%g2,[%o0+136]	!
		st	%g3,[%o0+140]	!
		st	%g4,[%o0+144]	!
		st	%i7,[%o0+60]	! save Mreg15
		ld	[%sp+100],%i7	! restore return addr.
		sethi	%hi(fl_div_ext),%o7
		or	%o7,%lo(fl_div_ext),%o7
		jmpl	%o7,%o7		! call library in fltlib.s
		nop			!
		ld	[%sp+92],%o7	! struct *guest
		ld	[%o7+132],%g1	!
		ld	[%o7+136],%g2	!
		ld	[%o7+140],%g3	!
		ld	[%o7+144],%g4	!
		ld	[%o7+60],%i7	! restore Mreg15
		or	%g7,%o0,%g7	! INTR-CODE=retval
		andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.dxr0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.dxr0e:
.dxr1s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
		sethi	%hi(0x00060000),%o0
		or	%g7,%o0,%g7	! specification exception
		ba	.dxr1e		! retuen(TEMPLATE)
		add	%g1,0x10,%g1	!
.dxr1e:
	
	.section ".text"
	.align	4
	.global cc4_stctl,tc4_stctl
cc4_stctl:
	retl				!
	add	%g0,.stctl0e-.stctl0s,%o0
tc4_stctl:
	sethi	%hi(.stctl0s),%o3	!
	or	%o3,%lo(.stctl0s),%o3	!
	or	%g0,.stctl0e-.stctl0s,%o4
    .stctl0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.stctl0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.stctl0t0-.stctl0s],%o5
	srl	%o1,10,%o4		!
	or	%o5,%o4,%o5		! simm22
	st	%o5,[%o0+.stctl0t0-.stctl0s]
	ld	[%o0+.stctl0t1-.stctl0s],%o5
	and	%o1,0xfff,%o4		!
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.stctl0t1-.stctl0s]
	retl				!
	add	%o0,.stctl0e-.stctl0s,%o0
.stctl0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
		ld	[%sp+92],%o7	! struct *guest
    .stctl0t0:	sethi	0,%o0		! ##TEMPLATE:imm
    .stctl0t1:	or	%o0,0,%o0	! ##TEMPLATE:imm
		st	%o0,[%o7+200]	! store minsn (upper)
		st	%g0,[%o7+204]	! store minsn (lower)
		sethi	%hi(0x80000000),%o0
		or	%g7,%o0,%g7	! Special Instruction (FC=2)
		ba	.stctl0e	! return(TEMPLATE)
		add	%g1,0x10,%g1	!
.stctl0e:

	.section ".text"
	.align	4
	.global cc4_lctl,tc4_lctl
cc4_lctl:
	retl				!
	add	%g0,.lctl0e-.lctl0s,%o0 !
tc4_lctl:
	sethi	%hi(.lctl0s),%o3	!
	or	%o3,%lo(.lctl0s),%o3	!
	or	%g0,.lctl0e-.lctl0s,%o4 !
    .lctl0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.lctl0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.lctl0t0-.lctl0s],%o5
	srl	%o1,10,%o4		!
	or	%o5,%o4,%o5		! simm22
	st	%o5,[%o0+.lctl0t0-.lctl0s]
	ld	[%o0+.lctl0t1-.lctl0s],%o5
	and	%o1,0xfff,%o4		!
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.lctl0t1-.lctl0s]
	retl				!
	add	%o0,.lctl0e-.lctl0s,%o0 !
.lctl0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
		ld	[%sp+92],%o7	! struct *guest
    .lctl0t0:	sethi	0,%o0		! ##TEMPLATE:imm
    .lctl0t1:	or	%o0,0,%o0	! ##TEMPLATE:imm
		st	%o0,[%o7+200]	! store minsn (upper)
		st	%g0,[%o7+204]	! store minsn (lower)
		sethi	%hi(0x80000000),%o0
		or	%g7,%o0,%g7	! Special Instruction (FC=2)
		ba	.lctl0e		! return(TEMPLATE)
		add	%g1,0x10,%g1	!
.lctl0e:

	.section ".text"
	.align	4
	.global ci4_cs,ti4_cs
ci4_cs:
	retl				!
	add	%g0,.cs0e-.cs0s,%o0	!
ti4_cs:
	sethi	%hi(.cs0s),%o3		!
	or	%o3,%lo(.cs0s),%o3	!
	or	%g0,.cs0e-.cs0s,%o4	!
    .cs0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.cs0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.cs0t0-.cs0s],%o5	!
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.cs0t0-.cs0s]	!
	ld	[%o0+.cs0t1-.cs0s],%o5	!
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.cs0t1-.cs0s]	!
	ld	[%o0+.cs0t2-.cs0s],%o5	!
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R3
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+.cs0t2-.cs0s]	!
	ld	[%o0+.cs0t3-.cs0s],%o5	!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+.cs0t3-.cs0s]	!
	ld	[%o0+.cs0t4-.cs0s],%o5	!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,25,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+.cs0t4-.cs0s]	!
	retl				!
	add	%o0,.cs0e-.cs0s,%o0	!
.cs0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
    .cs0t0:	add	%l0,0,%o1	! ##TEMPLATE:%l0,imm0
		and	%o1,%g3,%o1	! mask address
		andcc	%o1,3,%g0	!
		sethi	%hi(0x00060000),%o0
		bnz,a	.cs001		! if odd address then
		or	%g7,%o0,%g7	! specification exception
		ldub	[%g4+%o1],%g0	! force PAGEIN

		ld	[%sp+92],%o0	! struct *guest
		st	%g1,[%o0+132]	!
		st	%g2,[%o0+136]	!
		st	%g3,[%o0+140]	!
		st	%g4,[%o0+144]	!
		st	%i7,[%o0+60]	! save Mreg15
		ld	[%sp+100],%i7	! restore return addr.
		sethi	%hi(emm_getibufbpa),%o7
		or	%o7,%lo(emm_getibufbpa),%o7
		jmpl	%o7,%o7		! call emm_getibufbpa
		add	%g0,1,%o2	! type = 1 (CS/CDS)
		ld	[%sp+92],%o7	! struct *guest
		ld	[%o7+132],%g1	!
		ld	[%o7+136],%g2	!
		ld	[%o7+140],%g3	!
		ld	[%o7+144],%g4	!
		ld	[%o7+60],%i7	! restore Mreg15

    .cs0t1:	add	%l0,0,%o1	! ##TEMPLATE:%l0,imm0
		and	%o1,%g3,%o1	! mask address
		st	%o1,[%o7+196]	! cs address for emm
	
    .cslock:	ldstub	[%o0+6],%o4	! try locking ibufbpa
		subcc	%o4,0,%g0	!
		be	.cslout		!
		nop			!
    .cslwait:	ldub	[%o0+6],%o4	!
		subcc	%o4,0,%g0	!
		bne	.cslwait	!
		nop			!
		ba,a	.cslock		! retry locking ibufbpa

    .cslout:	or	%g7,0x40,%g7	! --- M CS start ---
		ld	[%g4+%o1],%o2	!
		andn	%g1,0x3,%g1	! CC=0
    .cs0t2:	add	%l0,%g0,%o4	! ##TEMPLATE:%l0
    .cs0t3:	subcc	%l0,%o2,%g0	! ##TEMPLATE:%l0
		be,a	.cs000		!
		st	%o4,[%g4+%o1]	!
    .cs0t4:	add	%o2,%g0,%l0	! ##TEMPLATE:%l0
		or	%g1,0x1,%g1	! CC=1
    .cs000:	andn	%g7,0x40,%g7	! --- M CS end ---

		stbar			!
		stb	%g0,[%o0+6]	! unlock ibufbpa
    .cs001:	andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.cs0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.cs0e:

	.section ".text"
	.align	4
	.global ci4_cds,ti4_cds
ci4_cds:
	srl	%o1,20,%o3		! switch (R1,R3)
	srl	%o1,16,%o4		!
	or	%o3,%o4,%o3		!
	andcc	%o3,1,%g0		!
	bnz	.cds1c			!
	nop				!
    .cds0c:				!
	retl				! case even:
	add	%g0,.cds0e-.cds0s,%o0	!
    .cds1c:				!
	retl				! case odd:
	add	%g0,.cds1e-.cds1s,%o0	!
ti4_cds:
	srl	%o1,20,%o3		! switch (R1,R3)
	srl	%o1,16,%o4		!
	or	%o3,%o4,%o3		!
	andcc	%o3,1,%g0		!
	bnz	.cds1t			!
	nop				!
    .cds0t:				!
	sethi	%hi(.cds0s),%o3		!
	or	%o3,%lo(.cds0s),%o3	!
	or	%g0,.cds0e-.cds0s,%o4	!
    .cds0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.cds0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.cds0t0-.cds0s],%o5!
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.cds0t0-.cds0s]!
	ld	[%o0+.cds0t1-.cds0s],%o5!
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.cds0t1-.cds0s]!
	ld	[%o0+.cds0t2-.cds0s],%o5!
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R3
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+.cds0t2-.cds0s]!
	ld	[%o0+.cds0t3-.cds0s],%o5!
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R3+1
	add	%o4,1,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+.cds0t3-.cds0s]!
	ld	[%o0+.cds0t4-.cds0s],%o5!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1+1
	add	%o4,1,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+.cds0t4-.cds0s]!
	ld	[%o0+.cds0t5-.cds0s],%o5!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+.cds0t5-.cds0s]!
	ld	[%o0+.cds0t6-.cds0s],%o5!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,25,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+.cds0t6-.cds0s]!
	ld	[%o0+.cds0t7-.cds0s],%o5!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1+1
	add	%o4,1,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,25,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+.cds0t7-.cds0s]!
	retl				!
	add	%o0,.cds0e-.cds0s,%o0	!
    .cds1t:				!
	sethi	%hi(.cds1s),%o3		!
	or	%o3,%lo(.cds1s),%o3	!
	or	%g0,.cds1e-.cds1s,%o4	!
    .cds1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.cds1cp			!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,.cds1e-.cds1s,%o0	!
.cds0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
    .cds0t0:	add	%l0,0,%o1	! ##TEMPLATE:%l0,imm0
		and	%o1,%g3,%o1	! mask address
		andcc	%o1,7,%g0	!
		sethi	%hi(0x00060000),%o0
		bnz,a	.cds001		! if odd address then
		or	%g7,%o0,%g7	! specification exception
		ldub	[%g4+%o1],%g0	! force PAGEIN

		ld	[%sp+92],%o0	! struct *guest
		st	%g1,[%o0+132]	!
		st	%g2,[%o0+136]	!
		st	%g3,[%o0+140]	!
		st	%g4,[%o0+144]	!
		st	%i7,[%o0+60]	! save Mreg15
		ld	[%sp+100],%i7	! restore return addr.
		sethi	%hi(emm_getibufbpa),%o7
		or	%o7,%lo(emm_getibufbpa),%o7
		jmpl	%o7,%o7		! call emm_getibufbpa
		add	%g0,1,%o2	! type = 1 (CS/CDS)
		ld	[%sp+92],%o7	! struct *guest
		ld	[%o7+132],%g1	!
		ld	[%o7+136],%g2	!
		ld	[%o7+140],%g3	!
		ld	[%o7+144],%g4	!
		ld	[%o7+60],%i7	! restore Mreg15

    .cds0t1:	add	%l0,0,%o1	! ##TEMPLATE:%l0,imm0
		and	%o1,%g3,%o1	! mask address
		st	%o1,[%o7+196]	! cs address for emm
	
    .cdslock:	ldstub	[%o0+6],%o4	! try locking ibufbpa
		subcc	%o4,0,%g0	!
		be	.cdslout	!
		nop			!
    .cdslwait:	ldub	[%o0+6],%o4	!
		subcc	%o4,0,%g0	!
		bne	.cdslwait	!
		nop			!
		ba,a	.cdslock	! retry locking ibufbpa

    .cdslout:	or	%g7,0x40,%g7	! --- M CS start ---
		ldd	[%g4+%o1],%o2	!
		andn	%g1,0x3,%g1	! CC=0
    .cds0t2:	add	%l0,%g0,%o4	! ##TEMPLATE:%l0
    .cds0t3:	add	%l0,%g0,%o5	! ##TEMPLATE:%l0+1
    .cds0t4:	subcc	%l0,%o3,%g0	! ##TEMPLATE:%l0+1
		bne	.cds0t6		!
    .cds0t5:	subcc	%l0,%o2,%g0	! ##TEMPLATE:%l0
		be,a	.cds000		!
		std	%o4,[%g4+%o1]	!
    .cds0t6:	add	%o2,%g0,%l0	! ##TEMPLATE:%l0
    .cds0t7:	add	%o3,%g0,%l0	! ##TEMPLATE:%l0+1
		or	%g1,0x1,%g1	! CC=1
    .cds000:	andn	%g7,0x40,%g7	! --- M CS end ---
	
		stbar			!
		stb	%g0,[%o0+6]	! unlock ibufbpa
    .cds001:	andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.cds0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.cds0e:
.cds1s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
		sethi	%hi(0x00060000),%o0
		or	%g7,%o0,%g7	! specification exception
		ba	.cds1e		! retuen(TEMPLATE)
		add	%g1,0x10,%g1	!
.cds1e:

	.section ".text"
	.align	4
	.global cc4_bcxx,tc4_bcxx
cc4_bcxx:
	retl				!
	add	%g0,.bcxx0e-.bcxx0s,%o0 !
tc4_bcxx:
	sethi	%hi(.bcxx0s),%o3	!
	or	%o3,%lo(.bcxx0s),%o3	!
	or	%g0,.bcxx0e-.bcxx0s,%o4 !
    .bcxx0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.bcxx0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.bcxx0t0-.bcxx0s],%o5
	srl	%o1,10,%o4		!
	or	%o5,%o4,%o5		! simm22
	st	%o5,[%o0+.bcxx0t0-.bcxx0s]
	ld	[%o0+.bcxx0t1-.bcxx0s],%o5
	and	%o1,0xfff,%o4		!
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.bcxx0t1-.bcxx0s]
	retl				!
	add	%o0,.bcxx0e-.bcxx0s,%o0 !
.bcxx0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
		ld	[%sp+92],%o7	! struct *guest
    .bcxx0t0:	sethi	0,%o0		! ##TEMPLATE:imm
    .bcxx0t1:	or	%o0,0,%o0	! ##TEMPLATE:imm
		st	%o0,[%o7+200]	! store minsn (upper)
		st	%g0,[%o7+204]	! store minsn (lower)
		sethi	%hi(0x80000000),%o0
		or	%g7,%o0,%g7	! Special Instruction (FC=2)
		ba	.bcxx0e		! return(TEMPLATE)
		add	%g1,0x10,%g1	!
.bcxx0e:

	.section ".text"
	.align	4
	.global ci4_clm,ti4_clm
ci4_clm:
	retl				!
	add	%g0,.clm0e-.clm0s,%o0	!
ti4_clm:
	sethi	%hi(.clm0s),%o3		!
	or	%o3,%lo(.clm0s),%o3	!
	or	%g0,.clm0e-.clm0s,%o4	!
    .clm0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.clm0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.clm0t0-.clm0s],%o5!
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.clm0t0-.clm0s]!
	ld	[%o0+.clm0t1-.clm0s],%o5!
	sethi	%hi(.clmtab),%o3	!
	or	%o3,%lo(.clmtab),%o3	!
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! M
	ldub	[%o3+%o4],%o4		! |
	xor	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.clm0t1-.clm0s]!
	ld	[%o0+.clm0t2-.clm0s],%o5!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	st	%o5,[%o0+.clm0t2-.clm0s]!
	ld	[%o0+.clm0t3-.clm0s],%o5!
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! M
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.clm0t3-.clm0s]!
	retl				!
	add	%o0,.clm0e-.clm0s,%o0	!
.clmtab:
	.byte	0,0,0,1,0,1,1,2,0,1,1,2,1,2,2,3
.clm0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
    .clm0t0:	add	%l0,0,%o0	! ##TEMPLATE:%l0,imm0
		and	%o0,%g3,%o0	! mask address
		add	%g4,%o0,%o0	!
		ldub	[%o0],%g0	! force PAGEIN
    .clm0t1:	ldub	[%o0+0],%g0	! ##TEMPLATE:imm0
		andn	%g1,0x3,%g1	! CC=0
    .clm0t2:	add	%g0,%l0,%o1	! ##TEMPLATE:%l0 R1
    .clm0t3:	add	%g0,0,%o2	! ##TEMPLATE:imm0 M
    .clm000:	andcc	%o2,0xf,%o2	!
		bz	.clm004		!
		andcc	%o2,8,%g0	!
		bz	.clm001		!
		srl	%o1,24,%o3	!
		ldub	[%o0],%o4	!
		subcc	%o3,%o4,%g0	!
		bne	.clm002		!
		add	%o0,1,%o0	!
    .clm001:	sll	%o1,8,%o1	!
		ba	.clm000		!
		sll	%o2,1,%o2	!
    .clm002:	bgu,a	.clm004		! if R1 > OP2 then
		or	%g1,0x2,%g1	!   CC=2
		bcs,a	.clm004		! if R1 < OP2 then
		or	%g1,0x1,%g1	!   CC=1
    .clm004:	andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.clm0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.clm0e:

	.section ".text"
	.align	4
	.global ci4_stcm,ti4_stcm
ci4_stcm:
	retl				!
	add	%g0,.stcm0e-.stcm0s,%o0 !
ti4_stcm:
	sethi	%hi(.stcm0s),%o3	!
	or	%o3,%lo(.stcm0s),%o3	!
	or	%g0,.stcm0e-.stcm0s,%o4 !
    .stcm0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.stcm0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.stcm0t0-.stcm0s],%o5
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.stcm0t0-.stcm0s]
	ld	[%o0+.stcm0t1-.stcm0s],%o5
	sethi	%hi(.stcmtab),%o3	!
	or	%o3,%lo(.stcmtab),%o3	!
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! M
	ldub	[%o3+%o4],%o4		! |
	xor	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.stcm0t1-.stcm0s]
	ld	[%o0+.stcm0t2-.stcm0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	st	%o5,[%o0+.stcm0t2-.stcm0s]
	ld	[%o0+.stcm0t3-.stcm0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! M
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.stcm0t3-.stcm0s]
	retl				!
	add	%o0,.stcm0e-.stcm0s,%o0 !
.stcmtab:
	.byte	0,0,0,1,0,1,1,2,0,1,1,2,1,2,2,3
.stcm0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
    .stcm0t0:	add	%l0,0,%o0	! ##TEMPLATE:%l0,imm0
		and	%o0,%g3,%o0	! mask address
		add	%g4,%o0,%o0	!
		ldub	[%o0],%g0	! force PAGEIN
    .stcm0t1:	ldub	[%o0+0],%g0	! ##TEMPLATE:imm0
    .stcm0t2:	add	%g0,%l0,%o1	! ##TEMPLATE:%l0 R1
    .stcm0t3:	add	%g0,0,%o2	! ##TEMPLATE:imm0 M
    .stcm000:	andcc	%o2,0xf,%o2	!
		bz	.stcm002	!
		andcc	%o2,8,%g0	!
		bz	.stcm001	!
		srl	%o1,24,%o3	!
		stb	%o3,[%o0]	!
		add	%o0,1,%o0	!
    .stcm001:	sll	%o1,8,%o1	!
		ba	.stcm000	!
		sll	%o2,1,%o2	!
    .stcm002:	andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.stcm0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.stcm0e:

	.section ".text"
	.align	4
	.global ci4_icm,ti4_icm
ci4_icm:
	retl				!
	add	%g0,.icm0e-.icm0s,%o0	!
ti4_icm:
	sethi	%hi(.icm0s),%o3		!
	or	%o3,%lo(.icm0s),%o3	!
	or	%g0,.icm0e-.icm0s,%o4	!
    .icm0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.icm0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.icm0t0-.icm0s],%o5!
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.icm0t0-.icm0s]!
	ld	[%o0+.icm0t1-.icm0s],%o5!
	sethi	%hi(.icmtab),%o3	!
	or	%o3,%lo(.icmtab),%o3	!
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! M
	ldub	[%o3+%o4],%o4		! |
	xor	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.icm0t1-.icm0s]!
	ld	[%o0+.icm0t2-.icm0s],%o5!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	st	%o5,[%o0+.icm0t2-.icm0s]!
	ld	[%o0+.icm0t3-.icm0s],%o5!
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! M
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.icm0t3-.icm0s]!
	ld	[%o0+.icm0t4-.icm0s],%o5!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,25,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+.icm0t4-.icm0s]!
	ld	[%o0+.icm0t5-.icm0s],%o5!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	sll	%o4,11,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+.icm0t5-.icm0s]!
	ld	[%o0+.icm0t6-.icm0s],%o5!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	sll	%o4,11,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+.icm0t6-.icm0s]!
	ld	[%o0+.icm0t7-.icm0s],%o5!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	sll	%o4,11,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+.icm0t7-.icm0s]!
	ld	[%o0+.icm0t8-.icm0s],%o5!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	sll	%o4,11,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+.icm0t8-.icm0s]!
	ld	[%o0+.icm0t9-.icm0s],%o5!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	sll	%o4,11,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+.icm0t9-.icm0s]!
	retl				!
	add	%o0,.icm0e-.icm0s,%o0	!
.icmtab:
	.byte	0,0,0,1,0,1,1,2,0,1,1,2,1,2,2,3
.icm0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0x8,%g1	! CC=unchange & ILC=2
		add	%g2,0x4,%g2	! update IAR
    .icm0t0:	add	%l0,0,%o0	! ##TEMPLATE:%l0,imm0
		and	%o0,%g3,%o0	! mask address
		add	%g4,%o0,%o0	!
		ldub	[%o0],%g0	! force PAGEIN
    .icm0t1:	ldub	[%o0+0],%g0	! ##TEMPLATE:imm0
		andn	%g1,0x3,%g1	! CC=0
    .icm0t2:	add	%g0,%l0,%o1	! ##TEMPLATE:%l0 R1
    .icm0t3:	add	%g0,0,%o2	! ##TEMPLATE:imm0 M
    .icm0t4:	add	%g0,0,%l0	! ##TEMPLATE:%l0 R1
		add	%g0,32,%o4	!
		add	%g0,32,%o5	!
		add	%g0,0,%o7	!
    .icm000:	andcc	%o2,0xf,%o2	!
		bz	.icm0t8		!
		andcc	%o2,8,%g0	!
		srl	%o1,24,%o3	!
    .icm0t5:	sll	%l0,8,%l0	! ##TEMPLATE:%l0,%l0 R1,R1
		bz,a	.icm001		!
    .icm0t6:	or	%l0,%o3,%l0	! ##TEMPLATE:%l0,%l0 R1,R1
		ldub	[%o0],%o3	!
    .icm0t7:	or	%l0,%o3,%l0	! ##TEMPLATE:%l0,%l0 R1,R1
		add	%o0,1,%o0	!
		sub	%o5,8,%o5	!
		sll	%o7,8,%o7	!
		or	%o7,%o3,%o7	!
    .icm001:	sll	%o1,8,%o1	!
		sll	%o2,1,%o2	!
		ba	.icm000		!
		sub	%o4,8,%o4	!
    .icm0t8:	sll	%l0,%o4,%l0	! ##TEMPLATE:%l0,%l0 R1,R1
		sub	%g0,%o4,%o4	!
		add	%o4,32,%o4	!
		srl	%o1,%o4,%o1	!
    .icm0t9:	or	%l0,%o1,%l0	! ##TEMPLATE:%l0,%l0 R1,R1
		sll	%o7,%o5,%o7	!
		subcc	%o7,0,%g0	!
		bg,a	.icm003		! if inserted bits > 0
		or	%g1,0x2,%g1	!   CC=2
		bl,a	.icm003		! if inserted bits < 0
		or	%g1,0x1,%g1	!   CC=1
    .icm003:	andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.icm0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.icm0e:
!================================

!
! templates
! cxx_xxx:
!   %o0: param: none
!	 retval:size of template
!   %o1: M instruction (6 bytes)
!   %o2: M instruction (lower 2bytes)
!   %o3: work
!   %o4: work
!   %o5: flag(0:NON EXECUTE,1:EXECUTE)
! txx_xxx:
!   %o0: param: bufp start address
!	 retval:bufp next start address
!   %o1: M instruction (6 bytes)
!   %o2: M instruction (lower 2bytes)
!   %o3: work
!   %o4: work
!   %o5: flag(0:NON EXECUTE,1:EXECUTE)
!
	.section ".text"
	.align	4
	.global ci6_mvn,ti6_mvn
ci6_mvn:
	retl				!
	add	%g0,.mvn0e-.mvn0s,%o0	!
ti6_mvn:
	sethi	%hi(.mvn0s),%o3		!
	or	%o3,%lo(.mvn0s),%o3	!
	or	%g0,.mvn0e-.mvn0s,%o4	!
    .mvn0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.mvn0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.mvn0t0-.mvn0s],%o5!
	srl	%o2,28,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	srl	%o2,16,%o4		!
	and	%o4,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.mvn0t0-.mvn0s]!
	ld	[%o0+.mvn0t1-.mvn0s],%o5!
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B1
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	and	%o1,0xfff,%o4		! D1
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.mvn0t1-.mvn0s]!
	ld	[%o0+.mvn0t2-.mvn0s],%o5!
	srl	%o1,16,%o4		!
	and	%o4,0xff,%o4		! L
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.mvn0t2-.mvn0s]!
	ld	[%o0+.mvn0t3-.mvn0s],%o5!
	srl	%o1,16,%o4		!
	and	%o4,0xff,%o4		! L
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.mvn0t3-.mvn0s]!
	ld	[%o0+.mvn0t4-.mvn0s],%o5!
	srl	%o1,16,%o4		!
	and	%o4,0xff,%o4		! L
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.mvn0t4-.mvn0s]!
	retl				!
	add	%o0,.mvn0e-.mvn0s,%o0	!
.mvn0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0xc,%g1	! CC=unchange & ILC=3
		add	%g2,0x6,%g2	! update IAR
    .mvn0t0:	add	%l0,0,%o0	! ##TEMPLATE:%l0,imm0
		and	%o0,%g3,%o0	! mask address
		add	%g4,%o0,%o0	!
    .mvn0t1:	add	%l0,0,%o1	! ##TEMPLATE:%l0,imm0
		and	%o1,%g3,%o1	! mask address
		add	%g4,%o1,%o1	!
		ldub	[%o0],%g0	! force PAGEIN
    .mvn0t2:	ldub	[%o0+0],%g0	! ##TEMPLATE:imm0 (L)
		ldub	[%o1],%g0	! force PAGEIN
    .mvn0t3:	ldub	[%o1+0],%g0	! ##TEMPLATE:imm0 (L)
		add	%g0,0,%o2	! counter
    .mvn000:	ldub	[%o0+%o2],%o3	!
		ldub	[%o1+%o2],%o4	!
    .mvn0t4:	subcc	%o2,0,%g0	! ##TEMPLATE:imm0 (L)
		and	%o3,0x0f,%o3	!
		and	%o4,0xf0,%o4	!
		or	%o3,%o4,%o3	!
		stb	%o3,[%o1+%o2]	!
		bne	.mvn000		!
		add	%o2,1,%o2	!
		andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.mvn0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.mvn0e:

	.section ".text"
	.align	4
	.global ci6_mvc,ti6_mvc
ci6_mvc:
	retl				!
	add	%g0,.mvc0e-.mvc0s,%o0	!
ti6_mvc:
	sethi	%hi(.mvc0s),%o3		!
	or	%o3,%lo(.mvc0s),%o3	!
	or	%g0,.mvc0e-.mvc0s,%o4	!
    .mvc0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.mvc0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.mvc0t0-.mvc0s],%o5!
	srl	%o2,28,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	srl	%o2,16,%o4		!
	and	%o4,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.mvc0t0-.mvc0s]!
	ld	[%o0+.mvc0t1-.mvc0s],%o5!
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B1
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	and	%o1,0xfff,%o4		! D1
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.mvc0t1-.mvc0s]!
	ld	[%o0+.mvc0t2-.mvc0s],%o5!
	srl	%o1,16,%o4		!
	and	%o4,0xff,%o4		! L
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.mvc0t2-.mvc0s]!
	ld	[%o0+.mvc0t3-.mvc0s],%o5!
	srl	%o1,16,%o4		!
	and	%o4,0xff,%o4		! L
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.mvc0t3-.mvc0s]!
	ld	[%o0+.mvc0t4-.mvc0s],%o5!
	srl	%o1,16,%o4		!
	and	%o4,0xff,%o4		!
	add	%o4,1,%o4		! L+1
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.mvc0t4-.mvc0s]!
	ld	[%o0+.mvc0t5-.mvc0s],%o5!
	srl	%o1,16,%o4		!
	and	%o4,0xff,%o4		! L
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.mvc0t5-.mvc0s]!
	ld	[%o0+.mvc0t6-.mvc0s],%o5!
	srl	%o1,16,%o4		!
	and	%o4,0xff,%o4		! L-3
	sub	%o4,3,%o4		! |
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.mvc0t6-.mvc0s]!
	retl				!
	add	%o0,.mvc0e-.mvc0s,%o0	!
.mvc0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0xc,%g1	! CC=unchange & ILC=3
		add	%g2,0x6,%g2	! update IAR
    .mvc0t0:	add	%l0,0,%o0	! ##TEMPLATE:%l0,imm0
		and	%o0,%g3,%o0	! mask address
		add	%g4,%o0,%o0	!
    .mvc0t1:	add	%l0,0,%o1	! ##TEMPLATE:%l0,imm0
		and	%o1,%g3,%o1	! mask address
		add	%g4,%o1,%o1	!
		ldub	[%o0],%g0	! force PAGEIN
    .mvc0t2:	ldub	[%o0+0],%g0	! ##TEMPLATE:imm0 (L)
		ldub	[%o1],%g0	! force PAGEIN
    .mvc0t3:	ldub	[%o1+0],%g0	! ##TEMPLATE:imm0 (L)
    .mvc0t4:	add	%g0,0,%o2	! ##TEMPLATE:imm0 (L+1)
		or	%o0,%o2,%o2	!
		or	%o1,%o2,%o2	!
		andcc	%o2,3,%g0	! if 4byte aligned
		bz	.mvc010		!   short cut
		add	%g0,0,%o2	! counter

    .mvc000:	ldub	[%o0+%o2],%o3	!
    .mvc0t5:	subcc	%o2,0,%g0	! ##TEMPLATE:imm0 (L)
		stb	%o3,[%o1+%o2]	!
		bne	.mvc000		!
		add	%o2,1,%o2	!
		ba,a	.mvc001		!

    .mvc010:	ld	[%o0+%o2],%o3	!
    .mvc0t6:	subcc	%o2,0,%g0	! ##TEMPLATE:imm0 (L-3)
		st	%o3,[%o1+%o2]	!
		bne	.mvc010		!
		add	%o2,4,%o2	!

    .mvc001:	andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.mvc0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.mvc0e:

	.section ".text"
	.align	4
	.global ci6_mvz,ti6_mvz
ci6_mvz:
	retl				!
	add	%g0,.mvz0e-.mvz0s,%o0	!
ti6_mvz:
	sethi	%hi(.mvz0s),%o3		!
	or	%o3,%lo(.mvz0s),%o3	!
	or	%g0,.mvz0e-.mvz0s,%o4	!
    .mvz0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.mvz0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.mvz0t0-.mvz0s],%o5!
	srl	%o2,28,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	srl	%o2,16,%o4		!
	and	%o4,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.mvz0t0-.mvz0s]!
	ld	[%o0+.mvz0t1-.mvz0s],%o5!
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B1
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	and	%o1,0xfff,%o4		! D1
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.mvz0t1-.mvz0s]!
	ld	[%o0+.mvz0t2-.mvz0s],%o5!
	srl	%o1,16,%o4		!
	and	%o4,0xff,%o4		! L
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.mvz0t2-.mvz0s]!
	ld	[%o0+.mvz0t3-.mvz0s],%o5!
	srl	%o1,16,%o4		!
	and	%o4,0xff,%o4		! L
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.mvz0t3-.mvz0s]!
	ld	[%o0+.mvz0t4-.mvz0s],%o5!
	srl	%o1,16,%o4		!
	and	%o4,0xff,%o4		! L
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.mvz0t4-.mvz0s]!
	retl				!
	add	%o0,.mvz0e-.mvz0s,%o0	!
.mvz0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0xc,%g1	! CC=unchange & ILC=3
		add	%g2,0x6,%g2	! update IAR
    .mvz0t0:	add	%l0,0,%o0	! ##TEMPLATE:%l0,imm0
		and	%o0,%g3,%o0	! mask address
		add	%g4,%o0,%o0	!
    .mvz0t1:	add	%l0,0,%o1	! ##TEMPLATE:%l0,imm0
		and	%o1,%g3,%o1	! mask address
		add	%g4,%o1,%o1	!
		ldub	[%o0],%g0	! force PAGEIN
    .mvz0t2:	ldub	[%o0+0],%g0	! ##TEMPLATE:imm0 (L)
		ldub	[%o1],%g0	! force PAGEIN
    .mvz0t3:	ldub	[%o1+0],%g0	! ##TEMPLATE:imm0 (L)
		add	%g0,0,%o2	! counter
    .mvz000:	ldub	[%o0+%o2],%o3	!
		ldub	[%o1+%o2],%o4	!
    .mvz0t4:	subcc	%o2,0,%g0	! ##TEMPLATE:imm0 (L)
		and	%o3,0xf0,%o3	!
		and	%o4,0x0f,%o4	!
		or	%o3,%o4,%o3	!
		stb	%o3,[%o1+%o2]	!
		bne	.mvz000		!
		add	%o2,1,%o2	!
		andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.mvz0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.mvz0e:

	.section ".text"
	.align	4
	.global ci6_nc,ti6_nc
ci6_nc:
	retl				!
	add	%g0,.nc0e-.nc0s,%o0	!
ti6_nc:
	sethi	%hi(.nc0s),%o3		!
	or	%o3,%lo(.nc0s),%o3	!
	or	%g0,.nc0e-.nc0s,%o4	!
    .nc0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.nc0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.nc0t0-.nc0s],%o5	!
	srl	%o2,28,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	srl	%o2,16,%o4		!
	and	%o4,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.nc0t0-.nc0s]	!
	ld	[%o0+.nc0t1-.nc0s],%o5	!
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B1
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	and	%o1,0xfff,%o4		! D1
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.nc0t1-.nc0s]	!
	ld	[%o0+.nc0t2-.nc0s],%o5	!
	srl	%o1,16,%o4		!
	and	%o4,0xff,%o4		! L
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.nc0t2-.nc0s]	!
	ld	[%o0+.nc0t3-.nc0s],%o5	!
	srl	%o1,16,%o4		!
	and	%o4,0xff,%o4		! L
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.nc0t3-.nc0s]	!
	ld	[%o0+.nc0t4-.nc0s],%o5	!
	srl	%o1,16,%o4		!
	and	%o4,0xff,%o4		! L
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.nc0t4-.nc0s]	!
	retl				!
	add	%o0,.nc0e-.nc0s,%o0	!
.nc0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0xc,%g1	! CC=unchange & ILC=3
		add	%g2,0x6,%g2	! update IAR
    .nc0t0:	add	%l0,0,%o0	! ##TEMPLATE:%l0,imm0
		and	%o0,%g3,%o0	! mask address
		add	%g4,%o0,%o0	!
    .nc0t1:	add	%l0,0,%o1	! ##TEMPLATE:%l0,imm0
		and	%o1,%g3,%o1	! mask address
		add	%g4,%o1,%o1	!
		ldub	[%o0],%g0	! force PAGEIN
    .nc0t2:	ldub	[%o0+0],%g0	! ##TEMPLATE:imm0 (L)
		ldub	[%o1],%g0	! force PAGEIN
    .nc0t3:	ldub	[%o1+0],%g0	! ##TEMPLATE:imm0 (L)
		andn	%g1,0x3,%g1	! CC=0
		add	%g0,0,%o2	! counter
		add	%g0,0,%o5	!
    .nc000:	ldub	[%o0+%o2],%o3	!
		ldub	[%o1+%o2],%o4	!
    .nc0t4:	subcc	%o2,0,%g0	! ##TEMPLATE:imm0 (L)
		and	%o3,%o4,%o3	!
		or	%o5,%o3,%o5	!
		stb	%o3,[%o1+%o2]	!
		bne	.nc000		!
		add	%o2,1,%o2	!
		subcc	%o5,0,%g0	!
		bnz,a	.nc001		! if Result != 0 then
		or	%g1,0x1,%g1	!   CC=1
    .nc001:	andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.nc0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.nc0e:

	.section ".text"
	.align	4
	.global ci6_clc,ti6_clc
ci6_clc:
	retl				!
	add	%g0,.clc0e-.clc0s,%o0	!
ti6_clc:
	sethi	%hi(.clc0s),%o3		!
	or	%o3,%lo(.clc0s),%o3	!
	or	%g0,.clc0e-.clc0s,%o4	!
    .clc0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.clc0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.clc0t0-.clc0s],%o5!
	srl	%o2,28,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	srl	%o2,16,%o4		!
	and	%o4,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.clc0t0-.clc0s]!
	ld	[%o0+.clc0t1-.clc0s],%o5!
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B1
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	and	%o1,0xfff,%o4		! D1
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.clc0t1-.clc0s]!
	ld	[%o0+.clc0t2-.clc0s],%o5!
	srl	%o1,16,%o4		!
	and	%o4,0xff,%o4		! L
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.clc0t2-.clc0s]!
	ld	[%o0+.clc0t3-.clc0s],%o5!
	srl	%o1,16,%o4		!
	and	%o4,0xff,%o4		! L
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.clc0t3-.clc0s]!
	ld	[%o0+.clc0t4-.clc0s],%o5!
	srl	%o1,16,%o4		!
	and	%o4,0xff,%o4		! L
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.clc0t4-.clc0s]!
	retl				!
	add	%o0,.clc0e-.clc0s,%o0	!
.clc0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0xc,%g1	! CC=unchange & ILC=3
		add	%g2,0x6,%g2	! update IAR
    .clc0t0:	add	%l0,0,%o0	! ##TEMPLATE:%l0,imm0
		and	%o0,%g3,%o0	! mask address
		add	%g4,%o0,%o0	!
    .clc0t1:	add	%l0,0,%o1	! ##TEMPLATE:%l0,imm0
		and	%o1,%g3,%o1	! mask address
		add	%g4,%o1,%o1	!
		ldub	[%o0],%g0	! force PAGEIN
    .clc0t2:	ldub	[%o0+0],%g0	! ##TEMPLATE:imm0 (L)
		ldub	[%o1],%g0	! force PAGEIN
    .clc0t3:	ldub	[%o1+0],%g0	! ##TEMPLATE:imm0 (L)
		andn	%g1,0x3,%g1	! CC=0
		add	%g0,0,%o2	! counter
		add	%g0,0,%o5	!
    .clc000:	ldub	[%o0+%o2],%o3	!
		ldub	[%o1+%o2],%o4	!
		subcc	%o4,%o3,%g0	!
		bne	.clc001		!
    .clc0t4:	subcc	%o2,0,%g0	! ##TEMPLATE:imm0 (L)
		bne	.clc000		!
		add	%o2,1,%o2	!
		ba,a	.clc003		!
    .clc001:	subcc	%o4,%o3,%g0	!
		bgu,a	.clc003		! if left > right then
		or	%g1,0x2,%g1	!   CC=2
		bcs,a	.clc003		! if left < right then
		or	%g1,0x1,%g1	!   CC=1
    .clc003:	andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.clc0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.clc0e:

	.section ".text"
	.align	4
	.global ci6_oc,ti6_oc
ci6_oc:
	retl				!
	add	%g0,.oc0e-.oc0s,%o0	!
ti6_oc:
	sethi	%hi(.oc0s),%o3		!
	or	%o3,%lo(.oc0s),%o3	!
	or	%g0,.oc0e-.oc0s,%o4	!
    .oc0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.oc0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.oc0t0-.oc0s],%o5	!
	srl	%o2,28,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	srl	%o2,16,%o4		!
	and	%o4,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.oc0t0-.oc0s]	!
	ld	[%o0+.oc0t1-.oc0s],%o5	!
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B1
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	and	%o1,0xfff,%o4		! D1
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.oc0t1-.oc0s]	!
	ld	[%o0+.oc0t2-.oc0s],%o5	!
	srl	%o1,16,%o4		!
	and	%o4,0xff,%o4		! L
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.oc0t2-.oc0s]	!
	ld	[%o0+.oc0t3-.oc0s],%o5	!
	srl	%o1,16,%o4		!
	and	%o4,0xff,%o4		! L
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.oc0t3-.oc0s]	!
	ld	[%o0+.oc0t4-.oc0s],%o5	!
	srl	%o1,16,%o4		!
	and	%o4,0xff,%o4		! L
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.oc0t4-.oc0s]	!
	retl				!
	add	%o0,.oc0e-.oc0s,%o0	!
.oc0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0xc,%g1	! CC=unchange & ILC=3
		add	%g2,0x6,%g2	! update IAR
    .oc0t0:	add	%l0,0,%o0	! ##TEMPLATE:%l0,imm0
		and	%o0,%g3,%o0	! mask address
		add	%g4,%o0,%o0	!
    .oc0t1:	add	%l0,0,%o1	! ##TEMPLATE:%l0,imm0
		and	%o1,%g3,%o1	! mask address
		add	%g4,%o1,%o1	!
		ldub	[%o0],%g0	! force PAGEIN
    .oc0t2:	ldub	[%o0+0],%g0	! ##TEMPLATE:imm0 (L)
		ldub	[%o1],%g0	! force PAGEIN
    .oc0t3:	ldub	[%o1+0],%g0	! ##TEMPLATE:imm0 (L)
		andn	%g1,0x3,%g1	! CC=0
		add	%g0,0,%o2	! counter
		add	%g0,0,%o5	!
    .oc000:	ldub	[%o0+%o2],%o3	!
		ldub	[%o1+%o2],%o4	!
    .oc0t4:	subcc	%o2,0,%g0	! ##TEMPLATE:imm0 (L)
		or	%o3,%o4,%o3	!
		or	%o5,%o3,%o5	!
		stb	%o3,[%o1+%o2]	!
		bne	.oc000		!
		add	%o2,1,%o2	!
		subcc	%o5,0,%g0	!
		bnz,a	.oc001		! if Result != 0 then
		or	%g1,0x1,%g1	!   CC=1
    .oc001:	andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.oc0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.oc0e:

	.section ".text"
	.align	4
	.global ci6_xc,ti6_xc
ci6_xc:
	retl				!
	add	%g0,.xc0e-.xc0s,%o0	!
ti6_xc:
	sethi	%hi(.xc0s),%o3		!
	or	%o3,%lo(.xc0s),%o3	!
	or	%g0,.xc0e-.xc0s,%o4	!
    .xc0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.xc0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.xc0t0-.xc0s],%o5	!
	srl	%o2,28,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	srl	%o2,16,%o4		!
	and	%o4,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.xc0t0-.xc0s]	!
	ld	[%o0+.xc0t1-.xc0s],%o5	!
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B1
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	and	%o1,0xfff,%o4		! D1
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.xc0t1-.xc0s]	!
	ld	[%o0+.xc0t2-.xc0s],%o5	!
	srl	%o1,16,%o4		!
	and	%o4,0xff,%o4		! L
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.xc0t2-.xc0s]	!
	ld	[%o0+.xc0t3-.xc0s],%o5	!
	srl	%o1,16,%o4		!
	and	%o4,0xff,%o4		! L
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.xc0t3-.xc0s]	!
	ld	[%o0+.xc0t4-.xc0s],%o5	!
	srl	%o1,16,%o4		!
	and	%o4,0xff,%o4		! L
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.xc0t4-.xc0s]	!
	ld	[%o0+.xc0t5-.xc0s],%o5	!
	srl	%o1,16,%o4		!
	and	%o4,0xff,%o4		! L
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.xc0t5-.xc0s]	!
	retl				!
	add	%o0,.xc0e-.xc0s,%o0	!
.xc0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0xc,%g1	! CC=unchange & ILC=3
		add	%g2,0x6,%g2	! update IAR
    .xc0t0:	add	%l0,0,%o0	! ##TEMPLATE:%l0,imm0
		and	%o0,%g3,%o0	! mask address
		add	%g4,%o0,%o0	!
    .xc0t1:	add	%l0,0,%o1	! ##TEMPLATE:%l0,imm0
		and	%o1,%g3,%o1	! mask address
		add	%g4,%o1,%o1	!
		ldub	[%o0],%g0	! force PAGEIN
    .xc0t2:	ldub	[%o0+0],%g0	! ##TEMPLATE:imm0 (L)
		ldub	[%o1],%g0	! force PAGEIN
    .xc0t3:	ldub	[%o1+0],%g0	! ##TEMPLATE:imm0 (L)
		andn	%g1,0x3,%g1	! CC=0
		subcc	%o0,%o1,%g0	! if R1 == R2 then
		be	.xc010		!   short cut
		add	%g0,0,%o2	! counter
		add	%g0,0,%o5	! zero flag

    .xc000:	ldub	[%o0+%o2],%o3	!
		ldub	[%o1+%o2],%o4	!
    .xc0t4:	subcc	%o2,0,%g0	! ##TEMPLATE:imm0 (L)
		xor	%o3,%o4,%o3	!
		or	%o5,%o3,%o5	!
		stb	%o3,[%o1+%o2]	!
		bne	.xc000		!
		add	%o2,1,%o2	!
		subcc	%o5,0,%g0	!
		bnz,a	.xc001		! if Result != 0 then
		or	%g1,0x1,%g1	!   CC=1
		ba,a	.xc001		!

    .xc010:	stb	%g0,[%o1+%o2]	!
    .xc0t5:	subcc	%o2,0,%g0	! ##TEMPLATE:imm0 (L)
		bne	.xc010		!
		add	%o2,1,%o2	! always CC=0

    .xc001:	andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.xc0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.xc0e:

	.section ".text"
	.align	4
	.global ci6_tr,ti6_tr
ci6_tr:
	retl				!
	add	%g0,.tr0e-.tr0s,%o0	!
ti6_tr:
	sethi	%hi(.tr0s),%o3		!
	or	%o3,%lo(.tr0s),%o3	!
	or	%g0,.tr0e-.tr0s,%o4	!
    .tr0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.tr0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.tr0t0-.tr0s],%o5	!
	srl	%o2,28,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	srl	%o2,16,%o4		!
	and	%o4,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.tr0t0-.tr0s]	!
	ld	[%o0+.tr0t1-.tr0s],%o5	!
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B1
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	and	%o1,0xfff,%o4		! D1
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.tr0t1-.tr0s]	!
	ld	[%o0+.tr0t2-.tr0s],%o5	!
	srl	%o1,16,%o4		!
	and	%o4,0xff,%o4		! L
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.tr0t2-.tr0s]	!
	ld	[%o0+.tr0t3-.tr0s],%o5	!
	srl	%o1,16,%o4		!
	and	%o4,0xff,%o4		! L
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.tr0t3-.tr0s]	!
	retl				!
	add	%o0,.tr0e-.tr0s,%o0	!
.tr0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0xc,%g1	! CC=unchange & ILC=3
		add	%g2,0x6,%g2	! update IAR
    .tr0t0:	add	%l0,0,%o0	! ##TEMPLATE:%l0,imm0
		and	%o0,%g3,%o0	! mask address
		add	%g4,%o0,%o0	!
    .tr0t1:	add	%l0,0,%o1	! ##TEMPLATE:%l0,imm0
		and	%o1,%g3,%o1	! mask address
		add	%g4,%o1,%o1	!
		add	%g0,0,%o2	! TRIAL-EXEC counter
    .tr000:	ldub	[%o1+%o2],%o4	! TRIAL-EXEC get index
		ldub	[%o0+%o4],%g0	! TRIAL-EXEC get indexed character
    .tr0t2:	subcc	%o2,0,%g0	! TRIAL-EXEC ##TEMPLATE:imm0 (L)
		bne	.tr000		! TRIAL-EXEC
		add	%o2,1,%o2	! TRIAL-EXEC
		add	%g0,0,%o2	! counter
    .tr001:	ldub	[%o1+%o2],%o4	! get index
		ldub	[%o0+%o4],%o3	! get indexed character
    .tr0t3:	subcc	%o2,0,%g0	! ##TEMPLATE:imm0 (L)
		stb	%o3,[%o1+%o2]	! store indexed character
		bne	.tr001		!
		add	%o2,1,%o2	!
		andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.tr0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.tr0e:

	.section ".text"
	.align	4
	.global ci6_trt,ti6_trt
ci6_trt:
	retl				!
	add	%g0,.trt0e-.trt0s,%o0	!
ti6_trt:
	sethi	%hi(.trt0s),%o3		!
	or	%o3,%lo(.trt0s),%o3	!
	or	%g0,.trt0e-.trt0s,%o4	!
    .trt0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.trt0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.trt0t0-.trt0s],%o5!
	srl	%o2,28,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	srl	%o2,16,%o4		!
	and	%o4,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.trt0t0-.trt0s]!
	ld	[%o0+.trt0t1-.trt0s],%o5!
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B1
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	and	%o1,0xfff,%o4		! D1
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.trt0t1-.trt0s]!
	ld	[%o0+.trt0t2-.trt0s],%o5!
	srl	%o1,16,%o4		!
	and	%o4,0xff,%o4		! L
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.trt0t2-.trt0s]!
	ld	[%o0+.trt0t3-.trt0s],%o5!
	srl	%o1,16,%o4		!
	and	%o4,0xff,%o4		! L
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.trt0t3-.trt0s]!
	ld	[%o0+.trt0t4-.trt0s],%o5!
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B1
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	and	%o1,0xfff,%o4		! D1
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.trt0t4-.trt0s]!
	ld	[%o0+.trt0t5-.trt0s],%o5!
	srl	%o1,16,%o4		!
	and	%o4,0xff,%o4		! L
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.trt0t5-.trt0s]!
	retl				!
	add	%o0,.trt0e-.trt0s,%o0	!
.trt0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0xc,%g1	! CC=unchange & ILC=3
		add	%g2,0x6,%g2	! update IAR
    .trt0t0:	add	%l0,0,%o0	! ##TEMPLATE:%l0,imm0
		and	%o0,%g3,%o0	! mask address
		add	%g4,%o0,%o0	!
    .trt0t1:	add	%l0,0,%o1	! ##TEMPLATE:%l0,imm0
		and	%o1,%g3,%o1	! mask address
		add	%g4,%o1,%o1	!
		add	%g0,0,%o2	! TRIAL-EXEC counter
    .trt000:	ldub	[%o1+%o2],%o4	! TRIAL-EXEC get index
		ldub	[%o0+%o4],%o3	! TRIAL-EXEC get indexed character
		subcc	%o3,0,%g0	! TRIAL-EXEC
		bnz	.trt001		! TRIAL-EXEC
    .trt0t2:	subcc	%o2,0,%g0	! TRIAL-EXEC ##TEMPLATE:imm0 (L)
		bne	.trt000		! TRIAL-EXEC
		add	%o2,1,%o2	! TRIAL-EXEC
    .trt001:	andn	%g1,0x3,%g1	! CC=0
		add	%g0,0,%o2	! counter
    .trt002:	ldub	[%o1+%o2],%o4	! get index
		ldub	[%o0+%o4],%o3	! get indexed character
		subcc	%o3,0,%g0	!
		bnz	.trt0t4		!
    .trt0t3:	subcc	%o2,0,%g0	! ##TEMPLATE:imm0 (L)
		bne	.trt002		!
		add	%o2,1,%o2	!
		ba,a	.trt006		!
    .trt0t4:	add	%l0,0,%o1	! ##TEMPLATE:%l0,imm0
		add	%o1,%o2,%o1	!
		andcc	%g7,0x10,%g0	! check AM(address mode)
		bnz	.trt003		!
		srl	%l1,24,%l1	!
		sll	%l1,24,%l1	!
		sll	%o1,8,%o1	!
		srl	%o1,8,%o1	!
		ba	.trt004		!
		or	%l1,%o1,%l1	! 24bit argument address
    .trt003:	sll	%o1,1,%o1	!
		srl	%o1,1,%l1	! 31bit argument address
    .trt004:	andn	%l2,0xff,%l2	!
		or	%l2,%o3,%l2	! function byte
    .trt0t5:	subcc	%o2,0,%g0	! ##TEMPLATE:imm0 (L)
		bne,a	.trt006		! if not last byte
		or	%g1,0x1,%g1	!   CC=1
		be,a	.trt006		! if last byte
		or	%g1,0x2,%g1	!   CC=2
    .trt006:	andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.trt0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.trt0e:

	.section ".text"
	.align	4
	.global cd6_ed,td6_ed
cd6_ed:
	retl				!
	add	%g0,.ed0e-.ed0s,%o0	!
td6_ed:
	sethi	%hi(.ed0s),%o3		!
	or	%o3,%lo(.ed0s),%o3	!
	or	%g0,.ed0e-.ed0s,%o4	!
    .ed0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.ed0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.ed0t0-.ed0s],%o5	!
	srl	%o2,28,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	srl	%o2,16,%o4		!
	and	%o4,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.ed0t0-.ed0s]	!
	ld	[%o0+.ed0t1-.ed0s],%o5	!
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B1
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	and	%o1,0xfff,%o4		! D1
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.ed0t1-.ed0s]	!
	ld	[%o0+.ed0t2-.ed0s],%o5	!
	srl	%o1,16,%o4		!
	and	%o4,0xff,%o4		! L
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.ed0t2-.ed0s]	!
	retl				!
	add	%o0,.ed0e-.ed0s,%o0	!
.ed0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0xc,%g1	! CC=unchange & ILC=3
		add	%g2,0x6,%g2	! update IAR
    .ed0t0:	add	%l0,0,%o2	! ##TEMPLATE:%l0,imm0
		and	%o2,%g3,%o2	! mask address
		add	%g4,%o2,%o2	!
    .ed0t1:	add	%l0,0,%o1	! ##TEMPLATE:%l0,imm0
		and	%o1,%g3,%o1	! mask address
		add	%g4,%o1,%o1	!
    .ed0t2:	add	%g0,0,%o3	! ##TEMPLATE:imm0 (L)
		ld	[%sp+92],%o0	! struct *guest
		st	%i7,[%o0+60]	! save Mreg15
		ld	[%sp+100],%i7	! restore return addr.
		sethi	%hi(il_ed),%o7	!
		or	%o7,%lo(il_ed),%o7
		jmpl	%o7,%o7		! call library in intlib.s
		nop			!
		ld	[%sp+92],%o7	! struct *guest
		ld	[%o7+60],%i7	! restore Mreg15
		andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.ed0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.ed0e:

	.section ".text"
	.align	4
	.global cd6_edmk,td6_edmk
cd6_edmk:
	retl				!
	add	%g0,.edmk0e-.edmk0s,%o0 !
td6_edmk:
	sethi	%hi(.edmk0s),%o3	!
	or	%o3,%lo(.edmk0s),%o3	!
	or	%g0,.edmk0e-.edmk0s,%o4 !
    .edmk0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.edmk0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.edmk0t0-.edmk0s],%o5
	srl	%o2,28,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	srl	%o2,16,%o4		!
	and	%o4,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.edmk0t0-.edmk0s]
	ld	[%o0+.edmk0t1-.edmk0s],%o5
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B1
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	and	%o1,0xfff,%o4		! D1
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.edmk0t1-.edmk0s]
	ld	[%o0+.edmk0t2-.edmk0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xff,%o4		! L
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.edmk0t2-.edmk0s]
	retl				!
	add	%o0,.edmk0e-.edmk0s,%o0 !
.edmk0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0xc,%g1	! CC=unchange & ILC=3
		add	%g2,0x6,%g2	! update IAR
    .edmk0t0:	add	%l0,0,%o2	! ##TEMPLATE:%l0,imm0
		and	%o2,%g3,%o2	! mask address
		add	%g4,%o2,%o2	!
    .edmk0t1:	add	%l0,0,%o1	! ##TEMPLATE:%l0,imm0
		and	%o1,%g3,%o4	! mask address(%o4:for Mreg1)
		add	%g4,%o4,%o1	!
    .edmk0t2:	add	%g0,0,%o3	! ##TEMPLATE:imm0 (L)
		ld	[%sp+92],%o0	! struct *guest
		st	%i7,[%o0+60]	! save Mreg15
		ld	[%sp+100],%i7	! restore return addr.
		add	%l1,%g0,%o5	! ##Mreg1 -> %o5
		sethi	%hi(il_edmk),%o7!
		or	%o7,%lo(il_edmk),%o7
		jmpl	%o7,%o7		! call library in intlib.s
		nop			!
		add	%o5,%g0,%l1	! ##%o5 -> Mreg1
		ld	[%sp+92],%o7	! struct *guest
		ld	[%o7+60],%i7	! restore Mreg15
		andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.edmk0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.edmk0e:
!================================

!
! templates
! cxx_xxx:
!   %o0: param: none
!	 retval:size of template
!   %o1: M instruction (6 bytes)
!   %o2: M instruction (lower 2bytes)
!   %o3: work
!   %o4: work
!   %o5: flag(0:NON EXECUTE,1:EXECUTE)
! txx_xxx:
!   %o0: param: bufp start address
!	 retval:bufp next start address
!   %o1: M instruction (6 bytes)
!   %o2: M instruction (lower 2bytes)
!   %o3: work
!   %o4: work
!   %o5: flag(0:NON EXECUTE,1:EXECUTE)
!
	.section ".text"
	.align	4
	.global cc6_e5xx,tc6_e5xx
cc6_e5xx:
	retl				!
	add	%g0,.e5xx0e-.e5xx0s,%o0 !
tc6_e5xx:
	sethi	%hi(.e5xx0s),%o3	!
	or	%o3,%lo(.e5xx0s),%o3	!
	or	%g0,.e5xx0e-.e5xx0s,%o4 !
    .e5xx0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.e5xx0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.e5xx0t0-.e5xx0s],%o5
	srl	%o1,10,%o4		!
	or	%o5,%o4,%o5		! simm22
	st	%o5,[%o0+.e5xx0t0-.e5xx0s]
	ld	[%o0+.e5xx0t1-.e5xx0s],%o5
	and	%o1,0xfff,%o4		!
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.e5xx0t1-.e5xx0s]
	ld	[%o0+.e5xx0t2-.e5xx0s],%o5
	srl	%o2,10,%o4		!
	or	%o5,%o4,%o5		! simm22
	st	%o5,[%o0+.e5xx0t2-.e5xx0s]
	ld	[%o0+.e5xx0t3-.e5xx0s],%o5
	and	%o2,0xfff,%o4		!
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.e5xx0t3-.e5xx0s]
	retl				!
	add	%o0,.e5xx0e-.e5xx0s,%o0 !
.e5xx0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0xc,%g1	! CC=unchange & ILC=3
		add	%g2,0x6,%g2	! update IAR
		ld	[%sp+92],%o7	! struct *guest
    .e5xx0t0:	sethi	0,%o0		! ##TEMPLATE:imm
    .e5xx0t1:	or	%o0,0,%o0	! ##TEMPLATE:imm
		st	%o0,[%o7+200]	! store minsn (upper)
    .e5xx0t2:	sethi	0,%o0		! ##TEMPLATE:imm
    .e5xx0t3:	or	%o0,0,%o0	! ##TEMPLATE:imm
		st	%o0,[%o7+204]	! store minsn (lower)
		sethi	%hi(0x80000000),%o0
		or	%g7,%o0,%g7	! Special Instruction (FC=2)
		ba	.e5xx0e		! return(TEMPLATE)
		add	%g1,0x10,%g1	!
.e5xx0e:

	.section ".text"
	.align	4
	.global ci6_mvcin,ti6_mvcin
ci6_mvcin:
	retl				!
	add	%g0,.mvcin0e-.mvcin0s,%o0
ti6_mvcin:
	sethi	%hi(.mvcin0s),%o3	!
	or	%o3,%lo(.mvcin0s),%o3	!
	or	%g0,.mvcin0e-.mvcin0s,%o4
    .mvcin0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.mvcin0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.mvcin0t0-.mvcin0s],%o5
	srl	%o2,28,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	srl	%o2,16,%o4		!
	and	%o4,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.mvcin0t0-.mvcin0s]
	ld	[%o0+.mvcin0t1-.mvcin0s],%o5
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B1
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	and	%o1,0xfff,%o4		! D1
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.mvcin0t1-.mvcin0s]
	ld	[%o0+.mvcin0t2-.mvcin0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xff,%o4		! -L
	sub	%g0,%o4,%o4		! |
	sll	%o4,19,%o4		! |
	srl	%o4,19,%o4		! |
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.mvcin0t2-.mvcin0s]
	ld	[%o0+.mvcin0t3-.mvcin0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xff,%o4		! L
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.mvcin0t3-.mvcin0s]
	ld	[%o0+.mvcin0t4-.mvcin0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xff,%o4		! L
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.mvcin0t4-.mvcin0s]
	retl				!
	add	%o0,.mvcin0e-.mvcin0s,%o0
.mvcin0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0xc,%g1	! CC=unchange & ILC=3
		add	%g2,0x6,%g2	! update IAR
    .mvcin0t0:	add	%l0,0,%o0	! ##TEMPLATE:%l0,imm0
		and	%o0,%g3,%o0	! mask address
		add	%g4,%o0,%o0	!
    .mvcin0t1:	add	%l0,0,%o1	! ##TEMPLATE:%l0,imm0
		and	%o1,%g3,%o1	! mask address
		add	%g4,%o1,%o1	!
		ldub	[%o0],%g0	! force PAGEIN
    .mvcin0t2:	ldub	[%o0-0],%g0	! ##TEMPLATE:imm0 (L)
		ldub	[%o1],%g0	! force PAGEIN
    .mvcin0t3:	ldub	[%o1+0],%g0	! ##TEMPLATE:imm0 (L)
		add	%g0,0,%o2	! counter--
		add	%g0,0,%o3	! counter++
    .mvcin000:	ldub	[%o0+%o2],%o4	!
    .mvcin0t4:	subcc	%o3,0,%g0	! ##TEMPLATE:imm0 (L)
		stb	%o4,[%o1+%o3]	!
		sub	%o2,1,%o2	!
		bne	.mvcin000	!
		add	%o3,1,%o3	!
		andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.mvcin0e	!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.mvcin0e:
!================================

!
! templates
! cxx_xxx:
!   %o0: param: none
!	 retval:size of template
!   %o1: M instruction (6 bytes)
!   %o2: M instruction (lower 2bytes)
!   %o3: work
!   %o4: work
!   %o5: flag(0:NON EXECUTE,1:EXECUTE)
! txx_xxx:
!   %o0: param: bufp start address
!	 retval:bufp next start address
!   %o1: M instruction (6 bytes)
!   %o2: M instruction (lower 2bytes)
!   %o3: work
!   %o4: work
!   %o5: flag(0:NON EXECUTE,1:EXECUTE)
!
	.section ".text"
	.align	4
	.global cd6_srp,td6_srp
cd6_srp:
	retl				!
	add	%g0,.srp0e-.srp0s,%o0	!
td6_srp:
	sethi	%hi(.srp0s),%o3		!
	or	%o3,%lo(.srp0s),%o3	!
	or	%g0,.srp0e-.srp0s,%o4	!
    .srp0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.srp0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.srp0t0-.srp0s],%o5!
	srl	%o2,28,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	srl	%o2,16,%o4		!
	and	%o4,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.srp0t0-.srp0s]!
	ld	[%o0+.srp0t1-.srp0s],%o5!
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B1
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	and	%o1,0xfff,%o4		! D1
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.srp0t1-.srp0s]!
	ld	[%o0+.srp0t2-.srp0s],%o5!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! L1
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.srp0t2-.srp0s]!
	ld	[%o0+.srp0t3-.srp0s],%o5!
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! L2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.srp0t3-.srp0s]!
	ld	[%o0+.srp0t4-.srp0s],%o5!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! L1
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.srp0t4-.srp0s]!
	retl				!
	add	%o0,.srp0e-.srp0s,%o0	!
.srp0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0xc,%g1	! CC=unchange & ILC=3
		add	%g2,0x6,%g2	! update IAR
    .srp0t0:	add	%l0,0,%o2	! ##TEMPLATE:%l0,imm0
    .srp0t1:	add	%l0,0,%o1	! ##TEMPLATE:%l0,imm0
		and	%o1,%g3,%o1	! mask address
		add	%g4,%o1,%o1	!
		ldub	[%o1],%g0	! force PAGEIN
    .srp0t2:	ldub	[%o1+0],%g0	! ##TEMPLATE:imm0 (L1)
    .srp0t3:	add	%g0,0,%o4	! ##TEMPLATE:imm0 (I3)
    .srp0t4:	add	%g0,0,%o3	! ##TEMPLATE:imm0 (L1)
		ld	[%sp+92],%o0	! struct *guest
		st	%i7,[%o0+60]	! save Mreg15
		ld	[%sp+100],%i7	! restore return addr.
		sethi	%hi(il_srp),%o7 !
		or	%o7,%lo(il_srp),%o7
		jmpl	%o7,%o7		! call library in intlib.s
		nop			!
		ld	[%sp+92],%o7	! struct *guest
		ld	[%o7+60],%i7	! restore Mreg15
		andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.srp0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.srp0e:

	.section ".text"
	.align	4
	.global ci6_mvo,ti6_mvo
ci6_mvo:
	srl	%o1,20,%o3		!
	and	%o3,0xf,%o3		! get L1
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! get L2
	subcc	%o3,%o4,%g0		!
	bg	.mvo1c			!
	nop				!
    .mvo0c:				!
	retl				! case L1 <= L2
	add	%g0,.mvo0e-.mvo0s,%o0	!
    .mvo1c:				!
	retl				! case L1 > L2
	add	%g0,.mvo1e-.mvo1s,%o0	!
ti6_mvo:
	srl	%o1,20,%o3		!
	and	%o3,0xf,%o3		! get L1
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! get L2
	subcc	%o3,%o4,%g0		!
	bg	.mvo1t			!
	nop				!
    .mvo0t:				!
	sethi	%hi(.mvo0s),%o3		!
	or	%o3,%lo(.mvo0s),%o3	!
	or	%g0,.mvo0e-.mvo0s,%o4	!
    .mvo0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.mvo0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.mvo0t0-.mvo0s],%o5!
	srl	%o2,28,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	srl	%o2,16,%o4		!
	and	%o4,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.mvo0t0-.mvo0s]!
	ld	[%o0+.mvo0t1-.mvo0s],%o5!
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B1
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	and	%o1,0xfff,%o4		! D1
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.mvo0t1-.mvo0s]!
	ld	[%o0+.mvo0t2-.mvo0s],%o5!
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! L2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.mvo0t2-.mvo0s]!
	ld	[%o0+.mvo0t3-.mvo0s],%o5!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! L1
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.mvo0t3-.mvo0s]!
	ld	[%o0+.mvo0t4-.mvo0s],%o5!
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! L2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.mvo0t4-.mvo0s]!
	ld	[%o0+.mvo0t5-.mvo0s],%o5!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! L1
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.mvo0t5-.mvo0s]!
	retl				!
	add	%o0,.mvo0e-.mvo0s,%o0	!
    .mvo1t:				!
	sethi	%hi(.mvo1s),%o3		!
	or	%o3,%lo(.mvo1s),%o3	!
	or	%g0,.mvo1e-.mvo1s,%o4	!
    .mvo1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.mvo1cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.mvo1t0-.mvo1s],%o5!
	srl	%o2,28,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	srl	%o2,16,%o4		!
	and	%o4,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.mvo1t0-.mvo1s]!
	ld	[%o0+.mvo1t1-.mvo1s],%o5!
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B1
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	and	%o1,0xfff,%o4		! D1
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.mvo1t1-.mvo1s]!
	ld	[%o0+.mvo1t2-.mvo1s],%o5!
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! L2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.mvo1t2-.mvo1s]!
	ld	[%o0+.mvo1t3-.mvo1s],%o5!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! L1
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.mvo1t3-.mvo1s]!
	ld	[%o0+.mvo1t4-.mvo1s],%o5!
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! L2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.mvo1t4-.mvo1s]!
	ld	[%o0+.mvo1t5-.mvo1s],%o5!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! L1
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.mvo1t5-.mvo1s]!
	retl				!
	add	%o0,.mvo1e-.mvo1s,%o0	!
.mvo0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0xc,%g1	! CC=unchange & ILC=3
		add	%g2,0x6,%g2	! update IAR
    .mvo0t0:	add	%l0,0,%o0	! ##TEMPLATE:%l0,imm0
		and	%o0,%g3,%o0	! mask address
		add	%g4,%o0,%o0	!
    .mvo0t1:	add	%l0,0,%o1	! ##TEMPLATE:%l0,imm0
		and	%o1,%g3,%o1	! mask address
		add	%g4,%o1,%o1	!
		ldub	[%o0],%g0	! force PAGEIN
    .mvo0t2:	ldub	[%o0+0],%g0	! ##TEMPLATE:imm0 (L2)
		ldub	[%o1],%g0	! force PAGEIN
    .mvo0t3:	ldub	[%o1+0],%g0	! ##TEMPLATE:imm0 (L1)
    .mvo0t4:	add	%g0,0,%o2	! ##TEMPLATE:imm0 (L2)
    .mvo0t5:	add	%g0,0,%o3	! ##TEMPLATE:imm0 (L1)
		ldub	[%o1+%o3],%o5	!
		and	%o5,0xf,%o5	!
    .mvo000:	ldub	[%o0+%o2],%o4	!
		sll	%o4,4,%o4	!
		or	%o5,%o4,%o5	!
		stb	%o5,[%o1+%o3]	!
		srl	%o4,8,%o5	!
		subcc	%o3,1,%o3	!
		bpos	.mvo000		!
		sub	%o2,1,%o2	!
		andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.mvo0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.mvo0e:
.mvo1s:
		andn	%g1,0xc,%g1	!
		or	%g1,0xc,%g1	! CC=unchange & ILC=3
		add	%g2,0x6,%g2	! update IAR
    .mvo1t0:	add	%l0,0,%o0	! ##TEMPLATE:%l0,imm0
		and	%o0,%g3,%o0	! mask address
		add	%g4,%o0,%o0	!
    .mvo1t1:	add	%l0,0,%o1	! ##TEMPLATE:%l0,imm0
		and	%o1,%g3,%o1	! mask address
		add	%g4,%o1,%o1	!
		ldub	[%o0],%g0	! force PAGEIN
    .mvo1t2:	ldub	[%o0+0],%g0	! ##TEMPLATE:imm0 (L2)
		ldub	[%o1],%g0	! force PAGEIN
    .mvo1t3:	ldub	[%o1+0],%g0	! ##TEMPLATE:imm0 (L1)
    .mvo1t4:	add	%g0,0,%o2	! ##TEMPLATE:imm0 (L2)
    .mvo1t5:	add	%g0,0,%o3	! ##TEMPLATE:imm0 (L1)
		ldub	[%o1+%o3],%o5	!
		and	%o5,0xf,%o5	!
    .mvo100:	ldub	[%o0+%o2],%o4	!
		sll	%o4,4,%o4	!
		or	%o5,%o4,%o5	!
		stb	%o5,[%o1+%o3]	!
		srl	%o4,8,%o5	!
		subcc	%o2,1,%o2	!
		bpos	.mvo100		!
		sub	%o3,1,%o3	!
    .mvo101:	stb	%o5,[%o1+%o3]	!
		subcc	%o3,1,%o3	!
		bpos	.mvo101		!
		add	%g0,0,%o5	!
		andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.mvo1e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.mvo1e:

	.section ".text"
	.align	4
	.global ci6_pack,ti6_pack
ci6_pack:
	srl	%o1,20,%o3		!
	and	%o3,0xf,%o3		! get L1
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! get L2
	add	%o4,1,%o4		!
	srl	%o4,1,%o4		!
	subcc	%o3,%o4,%g0		!
	bge	.pack1c			!
	nop				!
    .pack0c:				!
	retl				! case L1 <  (L2+1)/2
	add	%g0,.pack0e-.pack0s,%o0 !
    .pack1c:				!
	retl				! case L1 >= (L2+1)/2
	add	%g0,.pack1e-.pack1s,%o0 !
ti6_pack:
	srl	%o1,20,%o3		!
	and	%o3,0xf,%o3		! get L1
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! get L2
	add	%o4,1,%o4		!
	srl	%o4,1,%o4		!
	subcc	%o3,%o4,%g0		!
	bge	.pack1t			!
	nop				!
    .pack0t:				!
	sethi	%hi(.pack0s),%o3	!
	or	%o3,%lo(.pack0s),%o3	!
	or	%g0,.pack0e-.pack0s,%o4 !
    .pack0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.pack0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.pack0t0-.pack0s],%o5
	srl	%o2,28,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	srl	%o2,16,%o4		!
	and	%o4,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.pack0t0-.pack0s]
	ld	[%o0+.pack0t1-.pack0s],%o5
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B1
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	and	%o1,0xfff,%o4		! D1
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.pack0t1-.pack0s]
	ld	[%o0+.pack0t2-.pack0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! L2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.pack0t2-.pack0s]
	ld	[%o0+.pack0t3-.pack0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! L1
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.pack0t3-.pack0s]
	ld	[%o0+.pack0t4-.pack0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! L2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.pack0t4-.pack0s]
	ld	[%o0+.pack0t5-.pack0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! L1
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.pack0t5-.pack0s]
	retl				!
	add	%o0,.pack0e-.pack0s,%o0 !
    .pack1t:				!
	sethi	%hi(.pack1s),%o3	!
	or	%o3,%lo(.pack1s),%o3	!
	or	%g0,.pack1e-.pack1s,%o4 !
    .pack1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.pack1cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.pack1t0-.pack1s],%o5
	srl	%o2,28,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	srl	%o2,16,%o4		!
	and	%o4,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.pack1t0-.pack1s]
	ld	[%o0+.pack1t1-.pack1s],%o5
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B1
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	and	%o1,0xfff,%o4		! D1
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.pack1t1-.pack1s]
	ld	[%o0+.pack1t2-.pack1s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! L2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.pack1t2-.pack1s]
	ld	[%o0+.pack1t3-.pack1s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! L1
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.pack1t3-.pack1s]
	ld	[%o0+.pack1t4-.pack1s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! L2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.pack1t4-.pack1s]
	ld	[%o0+.pack1t5-.pack1s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! L1
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.pack1t5-.pack1s]
	retl				!
	add	%o0,.pack1e-.pack1s,%o0 !
.pack0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0xc,%g1	! CC=unchange & ILC=3
		add	%g2,0x6,%g2	! update IAR
    .pack0t0:	add	%l0,0,%o0	! ##TEMPLATE:%l0,imm0
		and	%o0,%g3,%o0	! mask address
		add	%g4,%o0,%o0	!
    .pack0t1:	add	%l0,0,%o1	! ##TEMPLATE:%l0,imm0
		and	%o1,%g3,%o1	! mask address
		add	%g4,%o1,%o1	!
		ldub	[%o0],%g0	! force PAGEIN
    .pack0t2:	ldub	[%o0+0],%g0	! ##TEMPLATE:imm0 (L2)
		ldub	[%o1],%g0	! force PAGEIN
    .pack0t3:	ldub	[%o1+0],%g0	! ##TEMPLATE:imm0 (L1)
    .pack0t4:	add	%g0,0,%o2	! ##TEMPLATE:imm0 (L2)
    .pack0t5:	add	%g0,0,%o3	! ##TEMPLATE:imm0 (L1)
		ldub	[%o0+%o2],%o4	!
		srl	%o4,4,%o5	!
		sll	%o4,4,%o4	!
		or	%o4,%o5,%o4	!
		stb	%o4,[%o1+%o3]	! store right most byte
		subcc	%o3,1,%o3	!
		bneg	.pack001	!
		sub	%o2,1,%o2	!
    .pack000:	ldub	[%o0+%o2],%o4	! load lower half
		and	%o4,0xf,%o4	!
		sub	%o2,1,%o2	!
		ldub	[%o0+%o2],%o5	! load upper half
		sll	%o5,4,%o5	!
		or	%o4,%o5,%o4	!
		stb	%o4,[%o1+%o3]	! store left bytes
		subcc	%o3,1,%o3	!
		bpos	.pack000	!
		sub	%o2,1,%o2	!
    .pack001:	andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.pack0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.pack0e:
.pack1s:
		andn	%g1,0xc,%g1	!
		or	%g1,0xc,%g1	! CC=unchange & ILC=3
		add	%g2,0x6,%g2	! update IAR
    .pack1t0:	add	%l0,0,%o0	! ##TEMPLATE:%l0,imm0
		and	%o0,%g3,%o0	! mask address
		add	%g4,%o0,%o0	!
    .pack1t1:	add	%l0,0,%o1	! ##TEMPLATE:%l0,imm0
		and	%o1,%g3,%o1	! mask address
		add	%g4,%o1,%o1	!
		ldub	[%o0],%g0	! force PAGEIN
    .pack1t2:	ldub	[%o0+0],%g0	! ##TEMPLATE:imm0 (L2)
		ldub	[%o1],%g0	! force PAGEIN
    .pack1t3:	ldub	[%o1+0],%g0	! ##TEMPLATE:imm0 (L1)
    .pack1t4:	add	%g0,0,%o2	! ##TEMPLATE:imm0 (L2)
    .pack1t5:	add	%g0,0,%o3	! ##TEMPLATE:imm0 (L1)
		ldub	[%o0+%o2],%o4	!
		srl	%o4,4,%o5	!
		sll	%o4,4,%o4	!
		or	%o4,%o5,%o4	!
		stb	%o4,[%o1+%o3]	! store right most byte
		subcc	%o2,1,%o2	!
		bneg	.pack102	!
		subcc	%o3,1,%o3	!
    .pack100:	ldub	[%o0+%o2],%o4	! load lower half
		subcc	%o2,1,%o2	!
		bneg	.pack101	!
		and	%o4,0xf,%o4	!
		ldub	[%o0+%o2],%o5	! load upper half
		sll	%o5,4,%o5	!
		or	%o4,%o5,%o4	!
    .pack101:	stb	%o4,[%o1+%o3]	! store left bytes
		subcc	%o2,1,%o2	!
		bpos	.pack100	!
		subcc	%o3,1,%o3	!
    .pack102:	bneg	.pack104	!
		nop			!
    .pack103:	stb	%g0,[%o1+%o3]	! fill with zero
		subcc	%o3,1,%o3	!
		bpos	.pack103	!
		nop			!
    .pack104:	andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.pack1e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.pack1e:

	.section ".text"
	.align	4
	.global ci6_unpk,ti6_unpk
ci6_unpk:
	srl	%o1,20,%o3		!
	and	%o3,0xf,%o3		! get L1
	srl	%o3,1,%o3		!
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! get L2
	subcc	%o3,%o4,%g0		!
	bge	.unpk1c			!
	nop				!
    .unpk0c:				!
	retl				! case L1/2 <  L2
	add	%g0,.unpk0e-.unpk0s,%o0 !
    .unpk1c:				!
	retl				! case L1/2 >= L2
	add	%g0,.unpk1e-.unpk1s,%o0 !
ti6_unpk:
	srl	%o1,20,%o3		!
	and	%o3,0xf,%o3		! get L1
	srl	%o3,1,%o3		!
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! get L2
	subcc	%o3,%o4,%g0		!
	bge	.unpk1t			!
	nop				!
    .unpk0t:				!
	sethi	%hi(.unpk0s),%o3	!
	or	%o3,%lo(.unpk0s),%o3	!
	or	%g0,.unpk0e-.unpk0s,%o4 !
    .unpk0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.unpk0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.unpk0t0-.unpk0s],%o5
	srl	%o2,28,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	srl	%o2,16,%o4		!
	and	%o4,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.unpk0t0-.unpk0s]
	ld	[%o0+.unpk0t1-.unpk0s],%o5
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B1
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	and	%o1,0xfff,%o4		! D1
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.unpk0t1-.unpk0s]
	ld	[%o0+.unpk0t2-.unpk0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! L2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.unpk0t2-.unpk0s]
	ld	[%o0+.unpk0t3-.unpk0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! L1
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.unpk0t3-.unpk0s]
	ld	[%o0+.unpk0t4-.unpk0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! L2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.unpk0t4-.unpk0s]
	ld	[%o0+.unpk0t5-.unpk0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! L1
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.unpk0t5-.unpk0s]
	retl				!
	add	%o0,.unpk0e-.unpk0s,%o0 !
    .unpk1t:				!
	sethi	%hi(.unpk1s),%o3	!
	or	%o3,%lo(.unpk1s),%o3	!
	or	%g0,.unpk1e-.unpk1s,%o4 !
    .unpk1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.unpk1cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.unpk1t0-.unpk1s],%o5
	srl	%o2,28,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	srl	%o2,16,%o4		!
	and	%o4,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.unpk1t0-.unpk1s]
	ld	[%o0+.unpk1t1-.unpk1s],%o5
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B1
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	and	%o1,0xfff,%o4		! D1
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.unpk1t1-.unpk1s]
	ld	[%o0+.unpk1t2-.unpk1s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! L2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.unpk1t2-.unpk1s]
	ld	[%o0+.unpk1t3-.unpk1s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! L1
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.unpk1t3-.unpk1s]
	ld	[%o0+.unpk1t4-.unpk1s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! L2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.unpk1t4-.unpk1s]
	ld	[%o0+.unpk1t5-.unpk1s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! L1
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.unpk1t5-.unpk1s]
	retl				!
	add	%o0,.unpk1e-.unpk1s,%o0 !
.unpk0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0xc,%g1	! CC=unchange & ILC=3
		add	%g2,0x6,%g2	! update IAR
    .unpk0t0:	add	%l0,0,%o0	! ##TEMPLATE:%l0,imm0
		and	%o0,%g3,%o0	! mask address
		add	%g4,%o0,%o0	!
    .unpk0t1:	add	%l0,0,%o1	! ##TEMPLATE:%l0,imm0
		and	%o1,%g3,%o1	! mask address
		add	%g4,%o1,%o1	!
		ldub	[%o0],%g0	! force PAGEIN
    .unpk0t2:	ldub	[%o0+0],%g0	! ##TEMPLATE:imm0 (L2)
		ldub	[%o1],%g0	! force PAGEIN
    .unpk0t3:	ldub	[%o1+0],%g0	! ##TEMPLATE:imm0 (L1)
    .unpk0t4:	add	%g0,0,%o2	! ##TEMPLATE:imm0 (L2)
    .unpk0t5:	add	%g0,0,%o3	! ##TEMPLATE:imm0 (L1)
		ldub	[%o0+%o2],%o4	!
		srl	%o4,4,%o5	!
		sll	%o4,4,%o4	!
		or	%o4,%o5,%o4	!
		stb	%o4,[%o1+%o3]	! store right most byte
		subcc	%o3,1,%o3	!
		bneg	.unpk001	!
		sub	%o2,1,%o2	!
    .unpk000:	ldub	[%o0+%o2],%o4	! load byte
		and	%o4,0xf,%o5	!
		or	%o5,0xf0,%o5	!
		stb	%o5,[%o1+%o3]	! store byte
		subcc	%o3,1,%o3	!
		bneg	.unpk001	!
		srl	%o4,4,%o5	!
		or	%o5,0xf0,%o5	!
		stb	%o5,[%o1+%o3]	! store byte
		subcc	%o3,1,%o3	!
		bpos	.unpk000	!
		sub	%o2,1,%o2	!
    .unpk001:	andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.unpk0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.unpk0e:
.unpk1s:
		andn	%g1,0xc,%g1	!
		or	%g1,0xc,%g1	! CC=unchange & ILC=3
		add	%g2,0x6,%g2	! update IAR
    .unpk1t0:	add	%l0,0,%o0	! ##TEMPLATE:%l0,imm0
		and	%o0,%g3,%o0	! mask address
		add	%g4,%o0,%o0	!
    .unpk1t1:	add	%l0,0,%o1	! ##TEMPLATE:%l0,imm0
		and	%o1,%g3,%o1	! mask address
		add	%g4,%o1,%o1	!
		ldub	[%o0],%g0	! force PAGEIN
    .unpk1t2:	ldub	[%o0+0],%g0	! ##TEMPLATE:imm0 (L2)
		ldub	[%o1],%g0	! force PAGEIN
    .unpk1t3:	ldub	[%o1+0],%g0	! ##TEMPLATE:imm0 (L1)
    .unpk1t4:	add	%g0,0,%o2	! ##TEMPLATE:imm0 (L2)
    .unpk1t5:	add	%g0,0,%o3	! ##TEMPLATE:imm0 (L1)
		ldub	[%o0+%o2],%o4	!
		srl	%o4,4,%o5	!
		sll	%o4,4,%o4	!
		or	%o4,%o5,%o4	!
		stb	%o4,[%o1+%o3]	! store right most byte
		subcc	%o2,1,%o2	!
		bneg	.unpk101	!
		subcc	%o3,1,%o3	!
    .unpk100:	ldub	[%o0+%o2],%o4	! load byte
		and	%o4,0xf,%o5	!
		or	%o5,0xf0,%o5	!
		stb	%o5,[%o1+%o3]	! store byte
		sub	%o3,1,%o3	!
		srl	%o4,4,%o5	!
		or	%o5,0xf0,%o5	!
		stb	%o5,[%o1+%o3]	! store byte
		subcc	%o2,1,%o2	!
		bpos	.unpk100	!
		subcc	%o3,1,%o3	!
    .unpk101:	bneg	.unpk103	!
		add	%g0,0xf0,%o5	!
    .unpk102:	stb	%o5,[%o1+%o3]	! fill with 0xf0
		subcc	%o3,1,%o3	!
		bpos	.unpk102	!
		nop			!
    .unpk103:	andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.unpk1e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.unpk1e:

	.section ".text"
	.align	4
	.global cd6_zap,td6_zap
cd6_zap:
	retl				!
	add	%g0,.zap0e-.zap0s,%o0	!
td6_zap:
	sethi	%hi(.zap0s),%o3		!
	or	%o3,%lo(.zap0s),%o3	!
	or	%g0,.zap0e-.zap0s,%o4	!
    .zap0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.zap0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.zap0t0-.zap0s],%o5!
	srl	%o2,28,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	srl	%o2,16,%o4		!
	and	%o4,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.zap0t0-.zap0s]!
	ld	[%o0+.zap0t1-.zap0s],%o5!
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B1
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	and	%o1,0xfff,%o4		! D1
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.zap0t1-.zap0s]!
	ld	[%o0+.zap0t2-.zap0s],%o5!
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! L2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.zap0t2-.zap0s]!
	ld	[%o0+.zap0t3-.zap0s],%o5!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! L1
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.zap0t3-.zap0s]!
	ld	[%o0+.zap0t4-.zap0s],%o5!
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! L2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.zap0t4-.zap0s]!
	ld	[%o0+.zap0t5-.zap0s],%o5!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! L1
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.zap0t5-.zap0s]!
	retl				!
	add	%o0,.zap0e-.zap0s,%o0	!
.zap0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0xc,%g1	! CC=unchange & ILC=3
		add	%g2,0x6,%g2	! update IAR
    .zap0t0:	add	%l0,0,%o2	! ##TEMPLATE:%l0,imm0
		and	%o2,%g3,%o2	! mask address
		add	%g4,%o2,%o2	!
    .zap0t1:	add	%l0,0,%o1	! ##TEMPLATE:%l0,imm0
		and	%o1,%g3,%o1	! mask address
		add	%g4,%o1,%o1	!
		ldub	[%o2],%g0	! force PAGEIN
    .zap0t2:	ldub	[%o2+0],%g0	! ##TEMPLATE:imm0 (L2)
		ldub	[%o1],%g0	! force PAGEIN
    .zap0t3:	ldub	[%o1+0],%g0	! ##TEMPLATE:imm0 (L1)
    .zap0t4:	add	%g0,0,%o4	! ##TEMPLATE:imm0 (L2)
    .zap0t5:	add	%g0,0,%o3	! ##TEMPLATE:imm0 (L1)
		ld	[%sp+92],%o0	! struct *guest
		st	%i7,[%o0+60]	! save Mreg15
		ld	[%sp+100],%i7	! restore return addr.
		sethi	%hi(il_zap),%o7 !
		or	%o7,%lo(il_zap),%o7
		jmpl	%o7,%o7		! call library in intlib.s
		nop			!
		ld	[%sp+92],%o7	! struct *guest
		ld	[%o7+60],%i7	! restore Mreg15
		andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.zap0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.zap0e:

	.section ".text"
	.align	4
	.global cd6_cp,td6_cp
cd6_cp:
	retl				!
	add	%g0,.cp0e-.cp0s,%o0	!
td6_cp:
	sethi	%hi(.cp0s),%o3		!
	or	%o3,%lo(.cp0s),%o3	!
	or	%g0,.cp0e-.cp0s,%o4	!
    .cp0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.cp0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.cp0t0-.cp0s],%o5	!
	srl	%o2,28,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	srl	%o2,16,%o4		!
	and	%o4,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.cp0t0-.cp0s]	!
	ld	[%o0+.cp0t1-.cp0s],%o5	!
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B1
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	and	%o1,0xfff,%o4		! D1
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.cp0t1-.cp0s]	!
	ld	[%o0+.cp0t2-.cp0s],%o5	!
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! L2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.cp0t2-.cp0s]	!
	ld	[%o0+.cp0t3-.cp0s],%o5	!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! L1
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.cp0t3-.cp0s]	!
	ld	[%o0+.cp0t4-.cp0s],%o5	!
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! L2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.cp0t4-.cp0s]	!
	ld	[%o0+.cp0t5-.cp0s],%o5	!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! L1
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.cp0t5-.cp0s]	!
	retl				!
	add	%o0,.cp0e-.cp0s,%o0	!
.cp0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0xc,%g1	! CC=unchange & ILC=3
		add	%g2,0x6,%g2	! update IAR
    .cp0t0:	add	%l0,0,%o2	! ##TEMPLATE:%l0,imm0
		and	%o2,%g3,%o2	! mask address
		add	%g4,%o2,%o2	!
    .cp0t1:	add	%l0,0,%o1	! ##TEMPLATE:%l0,imm0
		and	%o1,%g3,%o1	! mask address
		add	%g4,%o1,%o1	!
		ldub	[%o2],%g0	! force PAGEIN
    .cp0t2:	ldub	[%o2+0],%g0	! ##TEMPLATE:imm0 (L2)
		ldub	[%o1],%g0	! force PAGEIN
    .cp0t3:	ldub	[%o1+0],%g0	! ##TEMPLATE:imm0 (L1)
    .cp0t4:	add	%g0,0,%o4	! ##TEMPLATE:imm0 (L2)
    .cp0t5:	add	%g0,0,%o3	! ##TEMPLATE:imm0 (L1)
		ld	[%sp+92],%o0	! struct *guest
		st	%i7,[%o0+60]	! save Mreg15
		ld	[%sp+100],%i7	! restore return addr.
		sethi	%hi(il_cp),%o7	!
		or	%o7,%lo(il_cp),%o7
		jmpl	%o7,%o7		! call library in intlib.s
		nop			!
		ld	[%sp+92],%o7	! struct *guest
		ld	[%o7+60],%i7	! restore Mreg15
		andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.cp0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.cp0e:

	.section ".text"
	.align	4
	.global cd6_ap,td6_ap
cd6_ap:
	retl				!
	add	%g0,.ap0e-.ap0s,%o0	!
td6_ap:
	sethi	%hi(.ap0s),%o3		!
	or	%o3,%lo(.ap0s),%o3	!
	or	%g0,.ap0e-.ap0s,%o4	!
    .ap0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.ap0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.ap0t0-.ap0s],%o5	!
	srl	%o2,28,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	srl	%o2,16,%o4		!
	and	%o4,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.ap0t0-.ap0s]	!
	ld	[%o0+.ap0t1-.ap0s],%o5	!
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B1
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	and	%o1,0xfff,%o4		! D1
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.ap0t1-.ap0s]	!
	ld	[%o0+.ap0t2-.ap0s],%o5	!
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! L2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.ap0t2-.ap0s]	!
	ld	[%o0+.ap0t3-.ap0s],%o5	!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! L1
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.ap0t3-.ap0s]	!
	ld	[%o0+.ap0t4-.ap0s],%o5	!
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! L2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.ap0t4-.ap0s]	!
	ld	[%o0+.ap0t5-.ap0s],%o5	!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! L1
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.ap0t5-.ap0s]	!
	retl				!
	add	%o0,.ap0e-.ap0s,%o0	!
.ap0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0xc,%g1	! CC=unchange & ILC=3
		add	%g2,0x6,%g2	! update IAR
    .ap0t0:	add	%l0,0,%o2	! ##TEMPLATE:%l0,imm0
		and	%o2,%g3,%o2	! mask address
		add	%g4,%o2,%o2	!
    .ap0t1:	add	%l0,0,%o1	! ##TEMPLATE:%l0,imm0
		and	%o1,%g3,%o1	! mask address
		add	%g4,%o1,%o1	!
		ldub	[%o2],%g0	! force PAGEIN
    .ap0t2:	ldub	[%o2+0],%g0	! ##TEMPLATE:imm0 (L2)
		ldub	[%o1],%g0	! force PAGEIN
    .ap0t3:	ldub	[%o1+0],%g0	! ##TEMPLATE:imm0 (L1)
    .ap0t4:	add	%g0,0,%o4	! ##TEMPLATE:imm0 (L2)
    .ap0t5:	add	%g0,0,%o3	! ##TEMPLATE:imm0 (L1)
		ld	[%sp+92],%o0	! struct *guest
		st	%i7,[%o0+60]	! save Mreg15
		ld	[%sp+100],%i7	! restore return addr.
		sethi	%hi(il_ap),%o7	!
		or	%o7,%lo(il_ap),%o7
		jmpl	%o7,%o7		! call library in intlib.s
		nop			!
		ld	[%sp+92],%o7	! struct *guest
		ld	[%o7+60],%i7	! restore Mreg15
		andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.ap0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.ap0e:

	.section ".text"
	.align	4
	.global cd6_sp,td6_sp
cd6_sp:
	retl				!
	add	%g0,.sp0e-.sp0s,%o0	!
td6_sp:
	sethi	%hi(.sp0s),%o3		!
	or	%o3,%lo(.sp0s),%o3	!
	or	%g0,.sp0e-.sp0s,%o4	!
    .sp0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.sp0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.sp0t0-.sp0s],%o5	!
	srl	%o2,28,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	srl	%o2,16,%o4		!
	and	%o4,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.sp0t0-.sp0s]	!
	ld	[%o0+.sp0t1-.sp0s],%o5	!
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B1
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	and	%o1,0xfff,%o4		! D1
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.sp0t1-.sp0s]	!
	ld	[%o0+.sp0t2-.sp0s],%o5	!
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! L2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.sp0t2-.sp0s]	!
	ld	[%o0+.sp0t3-.sp0s],%o5	!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! L1
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.sp0t3-.sp0s]	!
	ld	[%o0+.sp0t4-.sp0s],%o5	!
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! L2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.sp0t4-.sp0s]	!
	ld	[%o0+.sp0t5-.sp0s],%o5	!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! L1
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.sp0t5-.sp0s]	!
	retl				!
	add	%o0,.sp0e-.sp0s,%o0	!
.sp0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0xc,%g1	! CC=unchange & ILC=3
		add	%g2,0x6,%g2	! update IAR
    .sp0t0:	add	%l0,0,%o2	! ##TEMPLATE:%l0,imm0
		and	%o2,%g3,%o2	! mask address
		add	%g4,%o2,%o2	!
    .sp0t1:	add	%l0,0,%o1	! ##TEMPLATE:%l0,imm0
		and	%o1,%g3,%o1	! mask address
		add	%g4,%o1,%o1	!
		ldub	[%o2],%g0	! force PAGEIN
    .sp0t2:	ldub	[%o2+0],%g0	! ##TEMPLATE:imm0 (L2)
		ldub	[%o1],%g0	! force PAGEIN
    .sp0t3:	ldub	[%o1+0],%g0	! ##TEMPLATE:imm0 (L1)
    .sp0t4:	add	%g0,0,%o4	! ##TEMPLATE:imm0 (L2)
    .sp0t5:	add	%g0,0,%o3	! ##TEMPLATE:imm0 (L1)
		ld	[%sp+92],%o0	! struct *guest
		st	%i7,[%o0+60]	! save Mreg15
		ld	[%sp+100],%i7	! restore return addr.
		sethi	%hi(il_sp),%o7	!
		or	%o7,%lo(il_sp),%o7
		jmpl	%o7,%o7		! call library in intlib.s
		nop			!
		ld	[%sp+92],%o7	! struct *guest
		ld	[%o7+60],%i7	! restore Mreg15
		andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.sp0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.sp0e:

	.section ".text"
	.align	4
	.global cd6_mp,td6_mp
cd6_mp:
	retl				!
	add	%g0,.mp0e-.mp0s,%o0	!
td6_mp:
	sethi	%hi(.mp0s),%o3		!
	or	%o3,%lo(.mp0s),%o3	!
	or	%g0,.mp0e-.mp0s,%o4	!
    .mp0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.mp0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.mp0t0-.mp0s],%o5	!
	srl	%o2,28,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	srl	%o2,16,%o4		!
	and	%o4,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.mp0t0-.mp0s]	!
	ld	[%o0+.mp0t1-.mp0s],%o5	!
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B1
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	and	%o1,0xfff,%o4		! D1
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.mp0t1-.mp0s]	!
	ld	[%o0+.mp0t2-.mp0s],%o5	!
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! L2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.mp0t2-.mp0s]	!
	ld	[%o0+.mp0t3-.mp0s],%o5	!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! L1
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.mp0t3-.mp0s]	!
	ld	[%o0+.mp0t4-.mp0s],%o5	!
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! L2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.mp0t4-.mp0s]	!
	ld	[%o0+.mp0t5-.mp0s],%o5	!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! L1
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.mp0t5-.mp0s]	!
	retl				!
	add	%o0,.mp0e-.mp0s,%o0	!
.mp0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0xc,%g1	! CC=unchange & ILC=3
		add	%g2,0x6,%g2	! update IAR
    .mp0t0:	add	%l0,0,%o2	! ##TEMPLATE:%l0,imm0
		and	%o2,%g3,%o2	! mask address
		add	%g4,%o2,%o2	!
    .mp0t1:	add	%l0,0,%o1	! ##TEMPLATE:%l0,imm0
		and	%o1,%g3,%o1	! mask address
		add	%g4,%o1,%o1	!
		ldub	[%o2],%g0	! force PAGEIN
    .mp0t2:	ldub	[%o2+0],%g0	! ##TEMPLATE:imm0 (L2)
		ldub	[%o1],%g0	! force PAGEIN
    .mp0t3:	ldub	[%o1+0],%g0	! ##TEMPLATE:imm0 (L1)
    .mp0t4:	add	%g0,0,%o4	! ##TEMPLATE:imm0 (L2)
    .mp0t5:	add	%g0,0,%o3	! ##TEMPLATE:imm0 (L1)
		ld	[%sp+92],%o0	! struct *guest
		st	%i7,[%o0+60]	! save Mreg15
		ld	[%sp+100],%i7	! restore return addr.
		sethi	%hi(il_mp),%o7	!
		or	%o7,%lo(il_mp),%o7
		jmpl	%o7,%o7		! call library in intlib.s
		nop			!
		ld	[%sp+92],%o7	! struct *guest
		ld	[%o7+60],%i7	! restore Mreg15
		andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.mp0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.mp0e:

	.section ".text"
	.align	4
	.global cd6_dp,td6_dp
cd6_dp:
	retl				!
	add	%g0,.dp0e-.dp0s,%o0	!
td6_dp:
	sethi	%hi(.dp0s),%o3		!
	or	%o3,%lo(.dp0s),%o3	!
	or	%g0,.dp0e-.dp0s,%o4	!
    .dp0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	.dp0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o0+.dp0t0-.dp0s],%o5	!
	srl	%o2,28,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	srl	%o2,16,%o4		!
	and	%o4,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.dp0t0-.dp0s]	!
	ld	[%o0+.dp0t1-.dp0s],%o5	!
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B1
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	and	%o1,0xfff,%o4		! D1
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.dp0t1-.dp0s]	!
	ld	[%o0+.dp0t2-.dp0s],%o5	!
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! L2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.dp0t2-.dp0s]	!
	ld	[%o0+.dp0t3-.dp0s],%o5	!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! L1
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.dp0t3-.dp0s]	!
	ld	[%o0+.dp0t4-.dp0s],%o5	!
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! L2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.dp0t4-.dp0s]	!
	ld	[%o0+.dp0t5-.dp0s],%o5	!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! L1
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+.dp0t5-.dp0s]	!
	retl				!
	add	%o0,.dp0e-.dp0s,%o0	!
.dp0s:
		andn	%g1,0xc,%g1	!
		or	%g1,0xc,%g1	! CC=unchange & ILC=3
		add	%g2,0x6,%g2	! update IAR
    .dp0t0:	add	%l0,0,%o2	! ##TEMPLATE:%l0,imm0
		and	%o2,%g3,%o2	! mask address
		add	%g4,%o2,%o2	!
    .dp0t1:	add	%l0,0,%o1	! ##TEMPLATE:%l0,imm0
		and	%o1,%g3,%o1	! mask address
		add	%g4,%o1,%o1	!
		ldub	[%o2],%g0	! force PAGEIN
    .dp0t2:	ldub	[%o2+0],%g0	! ##TEMPLATE:imm0 (L2)
		ldub	[%o1],%g0	! force PAGEIN
    .dp0t3:	ldub	[%o1+0],%g0	! ##TEMPLATE:imm0 (L1)
    .dp0t4:	add	%g0,0,%o4	! ##TEMPLATE:imm0 (L2)
    .dp0t5:	add	%g0,0,%o3	! ##TEMPLATE:imm0 (L1)
		ld	[%sp+92],%o0	! struct *guest
		st	%i7,[%o0+60]	! save Mreg15
		ld	[%sp+100],%i7	! restore return addr.
		sethi	%hi(il_dp),%o7	!
		or	%o7,%lo(il_dp),%o7
		jmpl	%o7,%o7		! call library in intlib.s
		nop			!
		ld	[%sp+92],%o7	! struct *guest
		ld	[%o7+60],%i7	! restore Mreg15
		andncc	%g7,0xfff,%g0	! if interruption then
		bnz	.dp0e		!   return(TEMPLATE)
		add	%g1,0x10,%g1	!
.dp0e:

!
! <M opcd counter>
!
	.section ".data"
	.align	8
	.global pa_sinsn
	.global pa_pinsn
pa_sinsn:
	.space	1024
pa_pinsn:
	.space	1024

!
! <M opcd table>
!
	.section ".data"
	.align	8
	.global optable
optable:
!
!     struct m_op {
!	char *name;
!	char *args;
!	int  mlen;
!	int  (*cfunc)();
!	int  (*tfunc)();
!	int  term; /* 0:continue, 1:terminate, 2:special */
!	int  dummy1;
!	int  dummy2;
!     };
!
	.word	opn_OPX2, opa_OPX2, 2,ci2_OPX2, ti2_OPX2, 1,0,0 /* 00 */
	.word	opn_OPX2, opa_OPX2, 2,ci2_OPX2, ti2_OPX2, 1,0,0 /* 01 */
	.word	opn_OPX2, opa_OPX2, 2,ci2_OPX2, ti2_OPX2, 1,0,0 /* 02 */
	.word	opn_OPX2, opa_OPX2, 2,ci2_OPX2, ti2_OPX2, 1,0,0 /* 03 */
	.word	opn_spm,  opa_spm,  2,ci2_spm,  ti2_spm,  0,0,0 /* 04 */
	.word	opn_balr, opa_balr, 2,ci2_balr, ti2_balr, 1,0,0 /* 05 */
	.word	opn_bctr, opa_bctr, 2,ci2_bctr, ti2_bctr, 1,0,0 /* 06 */
	.word	opn_bcr,  opa_bcr,  2,ci2_bcr,  ti2_bcr,  2,0,0 /* 07 */
		    /* BCR returns to trans_main only if taken ^ */
	.word	opn_ssk,  opa_ssk,  2,cc2_ssk,  tc2_ssk,  0,0,0 /* 08 */
	.word	opn_isk,  opa_isk,  2,cc2_isk,  tc2_isk,  0,0,0 /* 09 */
	.word	opn_svc,  opa_svc,  2,ci2_svc,  ti2_svc,  1,0,0 /* 0a */
	.word	opn_bsm,  opa_bsm,  2,ci2_bsm,  ti2_bsm,  1,0,0 /* 0b */
	.word	opn_bassm,opa_bassm,2,ci2_bassm,ti2_bassm,1,0,0 /* 0c */
	.word	opn_basr, opa_basr, 2,ci2_basr, ti2_basr, 1,0,0 /* 0d */
	.word	opn_mvcl, opa_mvcl, 2,ci2_mvcl, ti2_mvcl, 0,0,0 /* 0e */
	.word	opn_clcl, opa_clcl, 2,ci2_clcl, ti2_clcl, 0,0,0 /* 0f */

	.word	opn_lpr,  opa_lpr,  2,ci2_lpr,  ti2_lpr,  0,0,0 /* 10 */
	.word	opn_lnr,  opa_lnr,  2,ci2_lnr,  ti2_lnr,  0,0,0 /* 11 */
	.word	opn_ltr,  opa_ltr,  2,ci2_ltr,  ti2_ltr,  0,0,0 /* 12 */
	.word	opn_lcr,  opa_lcr,  2,ci2_lcr,  ti2_lcr,  0,0,0 /* 13 */
	.word	opn_nr,	  opa_nr,   2,ci2_nr,   ti2_nr,   0,0,0 /* 14 */
	.word	opn_clr,  opa_clr,  2,ci2_clr,  ti2_clr,  0,0,0 /* 15 */
	.word	opn_or,	  opa_or,   2,ci2_or,   ti2_or,   0,0,0 /* 16 */
	.word	opn_xr,	  opa_xr,   2,ci2_xr,   ti2_xr,   0,0,0 /* 17 */
	.word	opn_lr,	  opa_lr,   2,ci2_lr,   ti2_lr,   0,0,0 /* 18 */
	.word	opn_cr,	  opa_cr,   2,ci2_cr,   ti2_cr,   0,0,0 /* 19 */
	.word	opn_ar,	  opa_ar,   2,ci2_ar,   ti2_ar,   0,0,0 /* 1a */
	.word	opn_sr,	  opa_sr,   2,ci2_sr,   ti2_sr,   0,0,0 /* 1b */
	.word	opn_mr,	  opa_mr,   2,ci2_mr,   ti2_mr,   0,0,0 /* 1c */
	.word	opn_dr,	  opa_dr,   2,ci2_dr,   ti2_dr,   0,0,0 /* 1d */
	.word	opn_alr,  opa_alr,  2,ci2_alr,  ti2_alr,  0,0,0 /* 1e */
	.word	opn_slr,  opa_slr,  2,ci2_slr,  ti2_slr,  0,0,0 /* 1f */

	.word	opn_lpdr, opa_lpdr, 2,cf2_lpdr, tf2_lpdr, 0,0,0 /* 20 */
	.word	opn_lndr, opa_lndr, 2,cf2_lndr, tf2_lndr, 0,0,0 /* 21 */
	.word	opn_ltdr, opa_ltdr, 2,cf2_ltdr, tf2_ltdr, 0,0,0 /* 22 */
	.word	opn_lcdr, opa_lcdr, 2,cf2_lcdr, tf2_lcdr, 0,0,0 /* 23 */
	.word	opn_hdr,  opa_hdr,  2,cf2_hdr,  tf2_hdr,  0,0,0 /* 24 */
	.word	opn_lrdr, opa_lrdr, 2,cf2_lrdr, tf2_lrdr, 0,0,0 /* 25 */
	.word	opn_mxr,  opa_mxr,  2,cf2_mxr,  tf2_mxr,  0,0,0 /* 26 */
	.word	opn_mxdr, opa_mxdr, 2,cf2_mxdr, tf2_mxdr, 0,0,0 /* 27 */
	.word	opn_ldr,  opa_ldr,  2,cf2_ldr,  tf2_ldr,  0,0,0 /* 28 */
	.word	opn_cdr,  opa_cdr,  2,cf2_cdr,  tf2_cdr,  0,0,0 /* 29 */
	.word	opn_adr,  opa_adr,  2,cf2_adr,  tf2_adr,  0,0,0 /* 2a */
	.word	opn_sdr,  opa_sdr,  2,cf2_sdr,  tf2_sdr,  0,0,0 /* 2b */
	.word	opn_mdr,  opa_mdr,  2,cf2_mdr,  tf2_mdr,  0,0,0 /* 2c */
	.word	opn_ddr,  opa_ddr,  2,cf2_ddr,  tf2_ddr,  0,0,0 /* 2d */
	.word	opn_awr,  opa_awr,  2,cf2_awr,  tf2_awr,  0,0,0 /* 2e */
	.word	opn_swr,  opa_swr,  2,cf2_swr,  tf2_swr,  0,0,0 /* 2f */

	.word	opn_lper, opa_lper, 2,cf2_lper, tf2_lper, 0,0,0 /* 30 */
	.word	opn_lner, opa_lner, 2,cf2_lner, tf2_lner, 0,0,0 /* 31 */
	.word	opn_lter, opa_lter, 2,cf2_lter, tf2_lter, 0,0,0 /* 32 */
	.word	opn_lcer, opa_lcer, 2,cf2_lcer, tf2_lcer, 0,0,0 /* 33 */
	.word	opn_her,  opa_her,  2,cf2_her,  tf2_her,  0,0,0 /* 34 */
	.word	opn_lrer, opa_lrer, 2,cf2_lrer, tf2_lrer, 0,0,0 /* 35 */
	.word	opn_axr,  opa_axr,  2,cf2_axr,  tf2_axr,  0,0,0 /* 36 */
	.word	opn_sxr,  opa_sxr,  2,cf2_sxr,  tf2_sxr,  0,0,0 /* 37 */
	.word	opn_ler,  opa_ler,  2,cf2_ler,  tf2_ler,  0,0,0 /* 38 */
	.word	opn_cer,  opa_cer,  2,cf2_cer,  tf2_cer,  0,0,0 /* 39 */
	.word	opn_aer,  opa_aer,  2,cf2_aer,  tf2_aer,  0,0,0 /* 3a */
	.word	opn_ser,  opa_ser,  2,cf2_ser,  tf2_ser,  0,0,0 /* 3b */
	.word	opn_mer,  opa_mer,  2,cf2_mer,  tf2_mer,  0,0,0 /* 3c */
	.word	opn_der,  opa_der,  2,cf2_der,  tf2_der,  0,0,0 /* 3d */
	.word	opn_aur,  opa_aur,  2,cf2_aur,  tf2_aur,  0,0,0 /* 3e */
	.word	opn_sur,  opa_sur,  2,cf2_sur,  tf2_sur,  0,0,0 /* 3f */

	.word	opn_sth,  opa_sth,  4,ci4_sth,  ti4_sth,  0,0,0 /* 40 */
	.word	opn_la,	  opa_la,   4,ci4_la,   ti4_la,   0,0,0 /* 41 */
	.word	opn_stc,  opa_stc,  4,ci4_stc,  ti4_stc,  0,0,0 /* 42 */
	.word	opn_ic,	  opa_ic,   4,ci4_ic,   ti4_ic,   0,0,0 /* 43 */
	.word	opn_ex,	  opa_ex,   4,ci4_ex,   ti4_ex,   1,0,0 /* 44 */
	.word	opn_bal,  opa_bal,  4,ci4_bal,  ti4_bal,  1,0,0 /* 45 */
	.word	opn_bct,  opa_bct,  4,ci4_bct,  ti4_bct,  1,0,0 /* 46 */
	.word	opn_bc,	  opa_bc,   4,ci4_bc,   ti4_bc,   2,0,0 /* 47 */
		     /* BC returns to trans_main only if taken ^ */
	.word	opn_lh,	  opa_lh,   4,ci4_lh,   ti4_lh,   0,0,0 /* 48 */
	.word	opn_ch,	  opa_ch,   4,ci4_ch,   ti4_ch,   0,0,0 /* 49 */
	.word	opn_ah,	  opa_ah,   4,ci4_ah,   ti4_ah,   0,0,0 /* 4a */
	.word	opn_sh,	  opa_sh,   4,ci4_sh,   ti4_sh,   0,0,0 /* 4b */
	.word	opn_mh,	  opa_mh,   4,ci4_mh,   ti4_mh,   0,0,0 /* 4c */
	.word	opn_bas,  opa_bas,  4,ci4_bas,  ti4_bas,  1,0,0 /* 4d */
	.word	opn_cvd,  opa_cvd,  4,ci4_cvd,  ti4_cvd,  0,0,0 /* 4e */
	.word	opn_cvb,  opa_cvb,  4,ci4_cvb,  ti4_cvb,  0,0,0 /* 4f */

	.word	opn_st,	  opa_st,   4,ci4_st,   ti4_st,   0,0,0 /* 50 */
	.word	opn_flm,  opa_flm,  4,ci4_flm,  ti4_flm,  0,0,0 /* 51 */
	.word	opn_OPX4, opa_OPX4, 4,ci4_OPX4, ti4_OPX4, 1,0,0 /* 52 */
	.word	opn_OPX4, opa_OPX4, 4,ci4_OPX4, ti4_OPX4, 1,0,0 /* 53 */
	.word	opn_n,	  opa_n,    4,ci4_n,    ti4_n,    0,0,0 /* 54 */
	.word	opn_cl,	  opa_cl,   4,ci4_cl,   ti4_cl,   0,0,0 /* 55 */
	.word	opn_o,	  opa_o,    4,ci4_o,    ti4_o,    0,0,0 /* 56 */
	.word	opn_x,	  opa_x,    4,ci4_x,    ti4_x,    0,0,0 /* 57 */
	.word	opn_l,	  opa_l,    4,ci4_l,    ti4_l,    0,0,0 /* 58 */
	.word	opn_c,	  opa_c,    4,ci4_c,    ti4_c,    0,0,0 /* 59 */
	.word	opn_a,	  opa_a,    4,ci4_a,    ti4_a,    0,0,0 /* 5a */
	.word	opn_s,	  opa_s,    4,ci4_s,    ti4_s,    0,0,0 /* 5b */
	.word	opn_m,	  opa_m,    4,ci4_m,    ti4_m,    0,0,0 /* 5c */
	.word	opn_d,	  opa_d,    4,ci4_d,    ti4_d,    0,0,0 /* 5d */
	.word	opn_al,	  opa_al,   4,ci4_al,   ti4_al,   0,0,0 /* 5e */
	.word	opn_sl,	  opa_sl,   4,ci4_sl,   ti4_sl,   0,0,0 /* 5f */

	.word	opn_std,  opa_std,  4,cf4_std,  tf4_std,  0,0,0 /* 60 */
	.word	opn_OPX4, opa_OPX4, 4,ci4_OPX4, ti4_OPX4, 1,0,0 /* 61 */
	.word	opn_OPX4, opa_OPX4, 4,ci4_OPX4, ti4_OPX4, 1,0,0 /* 62 */
	.word	opn_OPX4, opa_OPX4, 4,ci4_OPX4, ti4_OPX4, 1,0,0 /* 63 */
	.word	opn_OPX4, opa_OPX4, 4,ci4_OPX4, ti4_OPX4, 1,0,0 /* 64 */
	.word	opn_OPX4, opa_OPX4, 4,ci4_OPX4, ti4_OPX4, 1,0,0 /* 65 */
	.word	opn_OPX4, opa_OPX4, 4,ci4_OPX4, ti4_OPX4, 1,0,0 /* 66 */
	.word	opn_mxd,  opa_mxd,  4,cf4_mxd,  tf4_mxd,  0,0,0 /* 67 */
	.word	opn_ld,	  opa_ld,   4,cf4_ld,   tf4_ld,   0,0,0 /* 68 */
	.word	opn_cd,	  opa_cd,   4,cf4_cd,   tf4_cd,   0,0,0 /* 69 */
	.word	opn_ad,	  opa_ad,   4,cf4_ad,   tf4_ad,   0,0,0 /* 6a */
	.word	opn_sd,	  opa_sd,   4,cf4_sd,   tf4_sd,   0,0,0 /* 6b */
	.word	opn_md,	  opa_md,   4,cf4_md,   tf4_md,   0,0,0 /* 6c */
	.word	opn_dd,	  opa_dd,   4,cf4_dd,   tf4_dd,   0,0,0 /* 6d */
	.word	opn_aw,	  opa_aw,   4,cf4_aw,   tf4_aw,   0,0,0 /* 6e */
	.word	opn_sw,	  opa_sw,   4,cf4_sw,   tf4_sw,   0,0,0 /* 6f */

	.word	opn_ste,  opa_ste,  4,cf4_ste,  tf4_ste,  0,0,0 /* 70 */
	.word	opn_OPX4, opa_OPX4, 4,ci4_OPX4, ti4_OPX4, 1,0,0 /* 71 */
	.word	opn_OPX4, opa_OPX4, 4,ci4_OPX4, ti4_OPX4, 1,0,0 /* 72 */
	.word	opn_OPX4, opa_OPX4, 4,ci4_OPX4, ti4_OPX4, 1,0,0 /* 73 */
	.word	opn_OPX4, opa_OPX4, 4,ci4_OPX4, ti4_OPX4, 1,0,0 /* 74 */
	.word	opn_OPX4, opa_OPX4, 4,ci4_OPX4, ti4_OPX4, 1,0,0 /* 75 */
	.word	opn_OPX4, opa_OPX4, 4,ci4_OPX4, ti4_OPX4, 1,0,0 /* 76 */
	.word	opn_OPX4, opa_OPX4, 4,ci4_OPX4, ti4_OPX4, 1,0,0 /* 77 */
	.word	opn_le,	  opa_le,   4,cf4_le,   tf4_le,   0,0,0 /* 78 */
	.word	opn_ce,	  opa_ce,   4,cf4_ce,   tf4_ce,   0,0,0 /* 79 */
	.word	opn_ae,	  opa_ae,   4,cf4_ae,   tf4_ae,   0,0,0 /* 7a */
	.word	opn_se,	  opa_se,   4,cf4_se,   tf4_se,   0,0,0 /* 7b */
	.word	opn_me,	  opa_me,   4,cf4_me,   tf4_me,   0,0,0 /* 7c */
	.word	opn_de,	  opa_de,   4,cf4_de,   tf4_de,   0,0,0 /* 7d */
	.word	opn_au,	  opa_au,   4,cf4_au,   tf4_au,   0,0,0 /* 7e */
	.word	opn_su,	  opa_su,   4,cf4_su,   tf4_su,   0,0,0 /* 7f */

	.word	opn_ssm,  opa_ssm,  4,cc4_ssm,  tc4_ssm,  0,0,0 /* 80 */
	.word	opn_OPX4, opa_OPX4, 4,ci4_OPX4, ti4_OPX4, 1,0,0 /* 81 */
	.word	opn_lpsw, opa_lpsw, 4,cc4_lpsw, tc4_lpsw, 1,0,0 /* 82 */
	.word	opn_diag, opa_diag, 4,cc4_diag, tc4_diag, 1,0,0 /* 83 */
	.word	opn_OPX4, opa_OPX4, 4,ci4_OPX4, ti4_OPX4, 1,0,0 /* 84 */
	.word	opn_OPX4, opa_OPX4, 4,ci4_OPX4, ti4_OPX4, 1,0,0 /* 85 */
	.word	opn_bxh,  opa_bxh,  4,ci4_bxh,  ti4_bxh,  1,0,0 /* 86 */
	.word	opn_bxle, opa_bxle, 4,ci4_bxle, ti4_bxle, 1,0,0 /* 87 */
	.word	opn_srl,  opa_srl,  4,ci4_srl,  ti4_srl,  0,0,0 /* 88 */
	.word	opn_sll,  opa_sll,  4,ci4_sll,  ti4_sll,  0,0,0 /* 89 */
	.word	opn_sra,  opa_sra,  4,ci4_sra,  ti4_sra,  0,0,0 /* 8a */
	.word	opn_sla,  opa_sla,  4,ci4_sla,  ti4_sla,  0,0,0 /* 8b */
	.word	opn_srdl, opa_srdl, 4,ci4_srdl, ti4_srdl, 0,0,0 /* 8c */
	.word	opn_sldl, opa_sldl, 4,ci4_sldl, ti4_sldl, 0,0,0 /* 8d */
	.word	opn_srda, opa_srda, 4,ci4_srda, ti4_srda, 0,0,0 /* 8e */
	.word	opn_slda, opa_slda, 4,ci4_slda, ti4_slda, 0,0,0 /* 8f */

	.word	opn_stm,  opa_stm,  4,ci4_stm,  ti4_stm,  0,0,0 /* 90 */
	.word	opn_tm,	  opa_tm,   4,ci4_tm,   ti4_tm,   0,0,0 /* 91 */
	.word	opn_mvi,  opa_mvi,  4,ci4_mvi,  ti4_mvi,  0,0,0 /* 92 */
	.word	opn_ts,	  opa_ts,   4,ci4_ts,   ti4_ts,   0,0,0 /* 93 */
	.word	opn_ni,	  opa_ni,   4,ci4_ni,   ti4_ni,   0,0,0 /* 94 */
	.word	opn_cli,  opa_cli,  4,ci4_cli,  ti4_cli,  0,0,0 /* 95 */
	.word	opn_oi,	  opa_oi,   4,ci4_oi,   ti4_oi,   0,0,0 /* 96 */
	.word	opn_xi,	  opa_xi,   4,ci4_xi,   ti4_xi,   0,0,0 /* 97 */
	.word	opn_lm,	  opa_lm,   4,ci4_lm,   ti4_lm,   0,0,0 /* 98 */
	.word	opn_OPX4, opa_OPX4, 4,ci4_OPX4, ti4_OPX4, 1,0,0 /* 99 */
	.word	opn_OPX4, opa_OPX4, 4,ci4_OPX4, ti4_OPX4, 1,0,0 /* 9a */
	.word	opn_OPX4, opa_OPX4, 4,ci4_OPX4, ti4_OPX4, 1,0,0 /* 9b */
	.word	opn_9cxx, opa_9cxx, 4,cc4_9cxx, tc4_9cxx, 0,0,0 /* 9c */
	.word	opn_9dxx, opa_9dxx, 4,cc4_9dxx, tc4_9dxx, 0,0,0 /* 9d */
	.word	opn_9exx, opa_9exx, 4,cc4_9exx, tc4_9exx, 0,0,0 /* 9e */
	.word	opn_9fxx, opa_9fxx, 4,cc4_9fxx, tc4_9fxx, 0,0,0 /* 9f */

	.word	opn_OPX4, opa_OPX4, 4,ci4_OPX4, ti4_OPX4, 1,0,0 /* a0 */
	.word	opn_ai,   opa_ai,   4,ci4_ai,   ti4_ai,   0,0,0 /* a1 */
	.word	opn_OPX4, opa_OPX4, 4,ci4_OPX4, ti4_OPX4, 1,0,0 /* a2 */
	.word	opn_OPX4, opa_OPX4, 4,ci4_OPX4, ti4_OPX4, 1,0,0 /* a3 */
	.word	opn_OPX4, opa_OPX4, 4,ci4_OPX4, ti4_OPX4, 1,0,0 /* a4 */
	.word	opn_OPX4, opa_OPX4, 4,ci4_OPX4, ti4_OPX4, 1,0,0 /* a5 */
	.word	opn_OPX4, opa_OPX4, 4,ci4_OPX4, ti4_OPX4, 1,0,0 /* a6 */
	.word	opn_OPX4, opa_OPX4, 4,ci4_OPX4, ti4_OPX4, 1,0,0 /* a7 */
	.word	opn_OPX4, opa_OPX4, 4,ci4_OPX4, ti4_OPX4, 1,0,0 /* a8 */
	.word	opn_OPX4, opa_OPX4, 4,ci4_OPX4, ti4_OPX4, 1,0,0 /* a9 */
	.word	opn_OPX4, opa_OPX4, 4,ci4_OPX4, ti4_OPX4, 1,0,0 /* aa */
	.word	opn_OPX4, opa_OPX4, 4,ci4_OPX4, ti4_OPX4, 1,0,0 /* ab */
	.word	opn_stnsm,opa_stnsm,4,cc4_stnsm,tc4_stnsm,0,0,0 /* ac */
	.word	opn_stosm,opa_stosm,4,cc4_stosm,tc4_stosm,0,0,0 /* ad */
	.word	opn_sigp, opa_sigp, 4,cc4_sigp, tc4_sigp, 0,0,0 /* ae */
	.word	opn_mc,	  opa_mc,   4,ci4_mc,   ti4_mc,   1,0,0 /* af */

	.word	opn_OPX4, opa_OPX4, 4,ci4_OPX4, ti4_OPX4, 1,0,0 /* b0 */
	.word	opn_lra,  opa_lra,  4,cc4_lra,  tc4_lra,  0,0,0 /* b1 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b2 */
	.word	opn_OPX4, opa_OPX4, 4,ci4_OPX4, ti4_OPX4, 1,0,0 /* b3 */
	.word	opn_OPX4, opa_OPX4, 4,ci4_OPX4, ti4_OPX4, 1,0,0 /* b4 */
	.word	opn_OPX4, opa_OPX4, 4,ci4_OPX4, ti4_OPX4, 1,0,0 /* b5 */
	.word	opn_stctl,opa_stctl,4,cc4_stctl,tc4_stctl,0,0,0 /* b6 */
	.word	opn_lctl, opa_lctl, 4,cc4_lctl, tc4_lctl, 0,0,0 /* b7 */
	.word	opn_OPX4, opa_OPX4, 4,ci4_OPX4, ti4_OPX4, 1,0,0 /* b8 */
	.word	opn_OPX4, opa_OPX4, 4,ci4_OPX4, ti4_OPX4, 1,0,0 /* b9 */
	.word	opn_cs,	  opa_cs,   4,ci4_cs,   ti4_cs,   0,0,0 /* ba */
	.word	opn_cds,  opa_cds,  4,ci4_cds,  ti4_cds,  0,0,0 /* bb */
	.word	opn_bcxx, opa_bcxx, 4,cc4_bcxx, tc4_bcxx, 0,0,0 /* bc */
	.word	opn_clm,  opa_clm,  4,ci4_clm,  ti4_clm,  0,0,0 /* bd */
	.word	opn_stcm, opa_stcm, 4,ci4_stcm, ti4_stcm, 0,0,0 /* be */
	.word	opn_icm,  opa_icm,  4,ci4_icm,  ti4_icm,  0,0,0 /* bf */

	.word	opn_OPX6, opa_OPX6, 6,ci6_OPX6, ti6_OPX6, 1,0,0 /* c0 */
	.word	opn_OPX6, opa_OPX6, 6,ci6_OPX6, ti6_OPX6, 1,0,0 /* c1 */
	.word	opn_OPX6, opa_OPX6, 6,ci6_OPX6, ti6_OPX6, 1,0,0 /* c2 */
	.word	opn_OPX6, opa_OPX6, 6,ci6_OPX6, ti6_OPX6, 1,0,0 /* c3 */
	.word	opn_OPX6, opa_OPX6, 6,ci6_OPX6, ti6_OPX6, 1,0,0 /* c4 */
	.word	opn_OPX6, opa_OPX6, 6,ci6_OPX6, ti6_OPX6, 1,0,0 /* c5 */
	.word	opn_OPX6, opa_OPX6, 6,ci6_OPX6, ti6_OPX6, 1,0,0 /* c6 */
	.word	opn_OPX6, opa_OPX6, 6,ci6_OPX6, ti6_OPX6, 1,0,0 /* c7 */
	.word	opn_OPX6, opa_OPX6, 6,ci6_OPX6, ti6_OPX6, 1,0,0 /* c8 */
	.word	opn_OPX6, opa_OPX6, 6,ci6_OPX6, ti6_OPX6, 1,0,0 /* c9 */
	.word	opn_OPX6, opa_OPX6, 6,ci6_OPX6, ti6_OPX6, 1,0,0 /* ca */
	.word	opn_OPX6, opa_OPX6, 6,ci6_OPX6, ti6_OPX6, 1,0,0 /* cb */
	.word	opn_OPX6, opa_OPX6, 6,ci6_OPX6, ti6_OPX6, 1,0,0 /* cc */
	.word	opn_OPX6, opa_OPX6, 6,ci6_OPX6, ti6_OPX6, 1,0,0 /* cd */
	.word	opn_OPX6, opa_OPX6, 6,ci6_OPX6, ti6_OPX6, 1,0,0 /* ce */
	.word	opn_OPX6, opa_OPX6, 6,ci6_OPX6, ti6_OPX6, 1,0,0 /* cf */

	.word	opn_OPX6, opa_OPX6, 6,ci6_OPX6, ti6_OPX6, 1,0,0 /* d0 */
	.word	opn_mvn,  opa_mvn,  6,ci6_mvn,  ti6_mvn,  0,0,0 /* d1 */
	.word	opn_mvc,  opa_mvc,  6,ci6_mvc,  ti6_mvc,  0,0,0 /* d2 */
	.word	opn_mvz,  opa_mvz,  6,ci6_mvz,  ti6_mvz,  0,0,0 /* d3 */
	.word	opn_nc,	  opa_nc,   6,ci6_nc,   ti6_nc,   0,0,0 /* d4 */
	.word	opn_clc,  opa_clc,  6,ci6_clc,  ti6_clc,  0,0,0 /* d5 */
	.word	opn_oc,	  opa_oc,   6,ci6_oc,   ti6_oc,   0,0,0 /* d6 */
	.word	opn_xc,	  opa_xc,   6,ci6_xc,   ti6_xc,   0,0,0 /* d7 */
	.word	opn_OPX6, opa_OPX6, 6,ci6_OPX6, ti6_OPX6, 1,0,0 /* d8 */
	.word	opn_OPX6, opa_OPX6, 6,ci6_OPX6, ti6_OPX6, 1,0,0 /* d9 */
	.word	opn_OPX6, opa_OPX6, 6,ci6_OPX6, ti6_OPX6, 1,0,0 /* da */
	.word	opn_OPX6, opa_OPX6, 6,ci6_OPX6, ti6_OPX6, 1,0,0 /* db */
	.word	opn_tr,	  opa_tr,   6,ci6_tr,   ti6_tr,   0,0,0 /* dc */
	.word	opn_trt,  opa_trt,  6,ci6_trt,  ti6_trt,  0,0,0 /* dd */
	.word	opn_ed,	  opa_ed,   6,cd6_ed,   td6_ed,   0,0,0 /* de */
	.word	opn_edmk, opa_edmk, 6,cd6_edmk, td6_edmk, 0,0,0 /* df */

	.word	opn_OPX6, opa_OPX6, 6,ci6_OPX6, ti6_OPX6, 1,0,0 /* e0 */
	.word	opn_OPX6, opa_OPX6, 6,ci6_OPX6, ti6_OPX6, 1,0,0 /* e1 */
	.word	opn_OPX6, opa_OPX6, 6,ci6_OPX6, ti6_OPX6, 1,0,0 /* e2 */
	.word	opn_OPX6, opa_OPX6, 6,ci6_OPX6, ti6_OPX6, 1,0,0 /* e3 */
	.word	opn_OPX6, opa_OPX6, 6,ci6_OPX6, ti6_OPX6, 1,0,0 /* e4 */
	.word	opn_e5xx, opa_e5xx, 6,cc6_e5xx, tc6_e5xx, 0,0,0 /* e5 */
	.word	opn_OPX6, opa_OPX6, 6,ci6_OPX6, ti6_OPX6, 1,0,0 /* e6 */
	.word	opn_OPX6, opa_OPX6, 6,ci6_OPX6, ti6_OPX6, 1,0,0 /* e7 */
	.word	opn_mvcin,opa_mvcin,6,ci6_mvcin,ti6_mvcin,0,0,0 /* e8 */
	.word	opn_OPX6, opa_OPX6, 6,ci6_OPX6, ti6_OPX6, 1,0,0 /* e9 */
	.word	opn_OPX6, opa_OPX6, 6,ci6_OPX6, ti6_OPX6, 1,0,0 /* ea */
	.word	opn_OPX6, opa_OPX6, 6,ci6_OPX6, ti6_OPX6, 1,0,0 /* eb */
	.word	opn_OPX6, opa_OPX6, 6,ci6_OPX6, ti6_OPX6, 1,0,0 /* ec */
	.word	opn_OPX6, opa_OPX6, 6,ci6_OPX6, ti6_OPX6, 1,0,0 /* ed */
	.word	opn_OPX6, opa_OPX6, 6,ci6_OPX6, ti6_OPX6, 1,0,0 /* ee */
	.word	opn_OPX6, opa_OPX6, 6,ci6_OPX6, ti6_OPX6, 1,0,0 /* ef */

	.word	opn_srp,  opa_srp,  6,cd6_srp,  td6_srp,  0,0,0 /* f0 */
	.word	opn_mvo,  opa_mvo,  6,ci6_mvo,  ti6_mvo,  0,0,0 /* f1 */
	.word	opn_pack, opa_pack, 6,ci6_pack, ti6_pack, 0,0,0 /* f2 */
	.word	opn_unpk, opa_unpk, 6,ci6_unpk, ti6_unpk, 0,0,0 /* f3 */
	.word	opn_OPX6, opa_OPX6, 6,ci6_OPX6, ti6_OPX6, 1,0,0 /* f4 */
	.word	opn_OPX6, opa_OPX6, 6,ci6_OPX6, ti6_OPX6, 1,0,0 /* f5 */
	.word	opn_OPX6, opa_OPX6, 6,ci6_OPX6, ti6_OPX6, 1,0,0 /* f6 */
	.word	opn_OPX6, opa_OPX6, 6,ci6_OPX6, ti6_OPX6, 1,0,0 /* f7 */
	.word	opn_zap,  opa_zap,  6,cd6_zap,  td6_zap,  0,0,0 /* f8 */
	.word	opn_cp,	  opa_cp,   6,cd6_cp,   td6_cp,   0,0,0 /* f9 */
	.word	opn_ap,	  opa_ap,   6,cd6_ap,   td6_ap,   0,0,0 /* fa */
	.word	opn_sp,	  opa_sp,   6,cd6_sp,   td6_sp,   0,0,0 /* fb */
	.word	opn_mp,	  opa_mp,   6,cd6_mp,   td6_mp,   0,0,0 /* fc */
	.word	opn_dp,	  opa_dp,   6,cd6_dp,   td6_dp,   0,0,0 /* fd */
	.word	opn_OPX6, opa_OPX6, 6,ci6_OPX6, ti6_OPX6, 1,0,0 /* fe */
	.word	opn_OPX6, opa_OPX6, 6,ci6_OPX6, ti6_OPX6, 1,0,0 /* ff */

!
! <M B2XX sub_opcd table>
!
	.section ".data"
	.align	8
	.global optb2xx
optb2xx:
!
!     struct m_op {
!	char *name;
!	char *args;
!	int  mlen;
!	int  (*cfunc)();
!	int  (*tfunc)();
!	int  term; /* 0:continue, 1:terminate, 2:special */
!	int  dummy1;
!	int  dummy2;
!     };
!
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b200 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b201 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b202 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b203 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b204 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b205 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b206 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b207 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b208 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b209 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b20a */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b20b */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b20c */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b20d */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b20e */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b20f */

	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b210 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b211 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b212 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b213 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b214 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b215 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b216 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b217 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b218 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b219 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b21a */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b21b */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b21c */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b21d */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b21e */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b21f */

	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b220 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b221 */
	.word	opn_ipm,  opa_ipm,  4,ci4_ipm,  ti4_ipm,  0,0,0 /* b222 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b223 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b224 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b225 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b226 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b227 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b228 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b229 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b22a */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b22b */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b22c */
	.word	opn_dxr,  opa_dxr,  4,cf4_dxr,  tf4_dxr,  0,0,0 /* b22d */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b22e */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b22f */

	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b230 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b231 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b232 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b233 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b234 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b235 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b236 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b237 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b238 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b239 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b23a */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b23b */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b23c */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b23d */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b23e */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b23f */

	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b240 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b241 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b242 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b243 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b244 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b245 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b246 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b247 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b248 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b249 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b24a */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b24b */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b24c */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b24d */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b24e */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b24f */

	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b250 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b251 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b252 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b253 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b254 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b255 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b256 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b257 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b258 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b259 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b25a */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b25b */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b25c */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b25d */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b25e */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b25f */

	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b260 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b261 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b262 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b263 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b264 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b265 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b266 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b267 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b268 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b269 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b26a */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b26b */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b26c */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b26d */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b26e */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b26f */

	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b270 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b271 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b272 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b273 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b274 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b275 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b276 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b277 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b278 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b279 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b27a */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b27b */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b27c */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b27d */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b27e */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b27f */

	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b280 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b281 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b282 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b283 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b284 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b285 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b286 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b287 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b288 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b289 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b28a */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b28b */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b28c */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b28d */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b28e */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b28f */

	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b290 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b291 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b292 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b293 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b294 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b295 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b296 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b297 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b298 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b299 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b29a */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b29b */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b29c */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b29d */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b29e */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b29f */

	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b2a0 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b2a1 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b2a2 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b2a3 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b2a4 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b2a5 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b2a6 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b2a7 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b2a8 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b2a9 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b2aa */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b2ab */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b2ac */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b2ad */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b2ae */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b2af */

	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b2b0 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b2b1 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b2b2 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b2b3 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b2b4 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b2b5 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b2b6 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b2b7 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b2b8 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b2b9 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b2ba */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b2bb */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b2bc */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b2bd */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b2be */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b2bf */

	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b2c0 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b2c1 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b2c2 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b2c3 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b2c4 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b2c5 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b2c6 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b2c7 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b2c8 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b2c9 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b2ca */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b2cb */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b2cc */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b2cd */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b2ce */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b2cf */

	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b2d0 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b2d1 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b2d2 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b2d3 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b2d4 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b2d5 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b2d6 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b2d7 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b2d8 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b2d9 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b2da */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b2db */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b2dc */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b2dd */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b2de */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b2df */

	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b2e0 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b2e1 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b2e2 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b2e3 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b2e4 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b2e5 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b2e6 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b2e7 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b2e8 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b2e9 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b2ea */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b2eb */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b2ec */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b2ed */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b2ee */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b2ef */

	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b2f0 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b2f1 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b2f2 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b2f3 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b2f4 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b2f5 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b2f6 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b2f7 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b2f8 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b2f9 */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b2fa */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b2fb */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b2fc */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b2fd */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b2fe */
	.word	opn_b2xx, opa_b2xx, 4,cc4_b2xx, tc4_b2xx, 0,0,0 /* b2ff */

!
! /*  *args			  */
! /*	1:	  r1		  */
! /*	2:	  r2		  */
! /*	3:	  ipm/dxr-r1	  */
! /*	4:	  dxr-r2	  */
! /*	a:	  d2(x2,b2)	  */
! /*	b:	  d1(b1)/d2(b2)	  */
! /*	c:	  d1(l,b1)	  */
! /*	d:	  d2(b2)	  */
! /*	f:	  d1(l1,b1)	  */
! /*	g:	  d2(l2,b2)	  */
! /*	i:	  i		  */
! /*	j:	  i3		  */
! /*	m:	  m1		  */
! /*	n:	  m3		  */
! /*	x:	  diagnose	  */
!
	opn_OPX2:	.asciz	"??"	/* 00 */
	opa_OPX2:	.asciz	""	/* 00 */
	opn_OPX4:	.asciz	"????"	/* 00 */
	opa_OPX4:	.asciz	""	/* 00 */
	opn_OPX6:	.asciz	"??????"/* 00 */
	opa_OPX6:	.asciz	""	/* 00 */

	opn_spm:	.asciz	"SPM"	/* 04 */
	opa_spm:	.asciz	"1"	/* 04 */
	opn_balr:	.asciz	"BALR"	/* 05 */
	opa_balr:	.asciz	"1,2"	/* 05 */
	opn_bctr:	.asciz	"BCTR"	/* 06 */
	opa_bctr:	.asciz	"1,2"	/* 06 */
	opn_bcr:	.asciz	"BCR"	/* 07 */
	opa_bcr:	.asciz	"m,2"	/* 07 */
	opn_ssk:	.asciz	"SSK"	/* 08 */
	opa_ssk:	.asciz	"1,2"	/* 08 */
	opn_isk:	.asciz	"ISK"	/* 09 */
	opa_isk:	.asciz	"1,2"	/* 09 */
	opn_svc:	.asciz	"SVC"	/* 0a */
	opa_svc:	.asciz	"i"	/* 0a */
	opn_bsm:	.asciz	"BSM"	/* 0b */
	opa_bsm:	.asciz	"1,2"	/* 0b */
	opn_bassm:	.asciz	"BASSM"	/* 0c */
	opa_bassm:	.asciz	"1,2"	/* 0c */
	opn_basr:	.asciz	"BASR"	/* 0d */
	opa_basr:	.asciz	"1,2"	/* 0d */
	opn_mvcl:	.asciz	"MVCL"	/* 0e */
	opa_mvcl:	.asciz	"1,2"	/* 0e */
	opn_clcl:	.asciz	"CLCL"	/* 0f */
	opa_clcl:	.asciz	"1,2"	/* 0f */

	opn_lpr:	.asciz	"LPR"	/* 10 */
	opa_lpr:	.asciz	"1,2"	/* 10 */
	opn_lnr:	.asciz	"LNR"	/* 11 */
	opa_lnr:	.asciz	"1,2"	/* 11 */
	opn_ltr:	.asciz	"LTR"	/* 12 */
	opa_ltr:	.asciz	"1,2"	/* 12 */
	opn_lcr:	.asciz	"LCR"	/* 13 */
	opa_lcr:	.asciz	"1,2"	/* 13 */
	opn_nr:		.asciz	"NR"	/* 14 */
	opa_nr:		.asciz	"1,2"	/* 14 */
	opn_clr:	.asciz	"CLR"	/* 15 */
	opa_clr:	.asciz	"1,2"	/* 15 */
	opn_or:		.asciz	"OR"	/* 16 */
	opa_or:		.asciz	"1,2"	/* 16 */
	opn_xr:		.asciz	"XR"	/* 17 */
	opa_xr:		.asciz	"1,2"	/* 17 */
	opn_lr:		.asciz	"LR"	/* 18 */
	opa_lr:		.asciz	"1,2"	/* 18 */
	opn_cr:		.asciz	"CR"	/* 19 */
	opa_cr:		.asciz	"1,2"	/* 19 */
	opn_ar:		.asciz	"AR"	/* 1a */
	opa_ar:		.asciz	"1,2"	/* 1a */
	opn_sr:		.asciz	"SR"	/* 1b */
	opa_sr:		.asciz	"1,2"	/* 1b */
	opn_mr:		.asciz	"MR"	/* 1c */
	opa_mr:		.asciz	"1,2"	/* 1c */
	opn_dr:		.asciz	"DR"	/* 1d */
	opa_dr:		.asciz	"1,2"	/* 1d */
	opn_alr:	.asciz	"ALR"	/* 1e */
	opa_alr:	.asciz	"1,2"	/* 1e */
	opn_slr:	.asciz	"SLR"	/* 1f */
	opa_slr:	.asciz	"1,2"	/* 1f */

	opn_lpdr:	.asciz	"LPDR"	/* 20 */
	opa_lpdr:	.asciz	"1,2"	/* 20 */
	opn_lndr:	.asciz	"LNDR"	/* 21 */
	opa_lndr:	.asciz	"1,2"	/* 21 */
	opn_ltdr:	.asciz	"LTDR"	/* 22 */
	opa_ltdr:	.asciz	"1,2"	/* 22 */
	opn_lcdr:	.asciz	"LCDR"	/* 23 */
	opa_lcdr:	.asciz	"1,2"	/* 23 */
	opn_hdr:	.asciz	"HDR"	/* 24 */
	opa_hdr:	.asciz	"1,2"	/* 24 */
	opn_lrdr:	.asciz	"LRDR"	/* 25 */
	opa_lrdr:	.asciz	"1,2"	/* 25 */
	opn_mxr:	.asciz	"MXR"	/* 26 */
	opa_mxr:	.asciz	"1,2"	/* 26 */
	opn_mxdr:	.asciz	"MXDR"	/* 27 */
	opa_mxdr:	.asciz	"1,2"	/* 27 */
	opn_ldr:	.asciz	"LDR"	/* 28 */
	opa_ldr:	.asciz	"1,2"	/* 28 */
	opn_cdr:	.asciz	"CDR"	/* 29 */
	opa_cdr:	.asciz	"1,2"	/* 29 */
	opn_adr:	.asciz	"ADR"	/* 2a */
	opa_adr:	.asciz	"1,2"	/* 2a */
	opn_sdr:	.asciz	"SDR"	/* 2b */
	opa_sdr:	.asciz	"1,2"	/* 2b */
	opn_mdr:	.asciz	"MDR"	/* 2c */
	opa_mdr:	.asciz	"1,2"	/* 2c */
	opn_ddr:	.asciz	"DDR"	/* 2d */
	opa_ddr:	.asciz	"1,2"	/* 2d */
	opn_awr:	.asciz	"AWR"	/* 2e */
	opa_awr:	.asciz	"1,2"	/* 2e */
	opn_swr:	.asciz	"SWR"	/* 2f */
	opa_swr:	.asciz	"1,2"	/* 2f */

	opn_lper:	.asciz	"LPER"	/* 30 */
	opa_lper:	.asciz	"1,2"	/* 30 */
	opn_lner:	.asciz	"LNER"	/* 31 */
	opa_lner:	.asciz	"1,2"	/* 31 */
	opn_lter:	.asciz	"LTER"	/* 32 */
	opa_lter:	.asciz	"1,2"	/* 32 */
	opn_lcer:	.asciz	"LCER"	/* 33 */
	opa_lcer:	.asciz	"1,2"	/* 33 */
	opn_her:	.asciz	"HER"	/* 34 */
	opa_her:	.asciz	"1,2"	/* 34 */
	opn_lrer:	.asciz	"LRER"	/* 35 */
	opa_lrer:	.asciz	"1,2"	/* 35 */
	opn_axr:	.asciz	"AXR"	/* 36 */
	opa_axr:	.asciz	"1,2"	/* 36 */
	opn_sxr:	.asciz	"SXR"	/* 37 */
	opa_sxr:	.asciz	"1,2"	/* 37 */
	opn_ler:	.asciz	"LER"	/* 38 */
	opa_ler:	.asciz	"1,2"	/* 38 */
	opn_cer:	.asciz	"CER"	/* 39 */
	opa_cer:	.asciz	"1,2"	/* 39 */
	opn_aer:	.asciz	"AER"	/* 3a */
	opa_aer:	.asciz	"1,2"	/* 3a */
	opn_ser:	.asciz	"SER"	/* 3b */
	opa_ser:	.asciz	"1,2"	/* 3b */
	opn_mer:	.asciz	"MER"	/* 3c */
	opa_mer:	.asciz	"1,2"	/* 3c */
	opn_der:	.asciz	"DER"	/* 3d */
	opa_der:	.asciz	"1,2"	/* 3d */
	opn_aur:	.asciz	"AUR"	/* 3e */
	opa_aur:	.asciz	"1,2"	/* 3e */
	opn_sur:	.asciz	"SUR"	/* 3f */
	opa_sur:	.asciz	"1,2"	/* 3f */

	opn_sth:	.asciz	"STH"	/* 40 */
	opa_sth:	.asciz	"1,a"	/* 40 */
	opn_la:		.asciz	"LA"	/* 41 */
	opa_la:		.asciz	"1,a"	/* 41 */
	opn_stc:	.asciz	"STC"	/* 42 */
	opa_stc:	.asciz	"1,a"	/* 42 */
	opn_ic:		.asciz	"IC"	/* 43 */
	opa_ic:		.asciz	"1,a"	/* 43 */
	opn_ex:		.asciz	"EX"	/* 44 */
	opa_ex:		.asciz	"1,a"	/* 44 */
	opn_bal:	.asciz	"BAL"	/* 45 */
	opa_bal:	.asciz	"1,a"	/* 45 */
	opn_bct:	.asciz	"BCT"	/* 46 */
	opa_bct:	.asciz	"1,a"	/* 46 */
	opn_bc:		.asciz	"BC"	/* 47 */
	opa_bc:		.asciz	"m,a"	/* 47 */
	opn_lh:		.asciz	"LH"	/* 48 */
	opa_lh:		.asciz	"1,a"	/* 48 */
	opn_ch:		.asciz	"CH"	/* 49 */
	opa_ch:		.asciz	"1,a"	/* 49 */
	opn_ah:		.asciz	"AH"	/* 4a */
	opa_ah:		.asciz	"1,a"	/* 4a */
	opn_sh:		.asciz	"SH"	/* 4b */
	opa_sh:		.asciz	"1,a"	/* 4b */
	opn_mh:		.asciz	"MH"	/* 4c */
	opa_mh:		.asciz	"1,a"	/* 4c */
	opn_bas:	.asciz	"BAS"	/* 4d */
	opa_bas:	.asciz	"1,a"	/* 4d */
	opn_cvd:	.asciz	"CVD"	/* 4e */
	opa_cvd:	.asciz	"1,a"	/* 4e */
	opn_cvb:	.asciz	"CVB"	/* 4f */
	opa_cvb:	.asciz	"1,a"	/* 4f */

	opn_st:		.asciz	"ST"	/* 50 */
	opa_st:		.asciz	"1,a"	/* 50 */
	opn_flm:	.asciz	"FLM"	/* 51 */
	opa_flm:	.asciz	"1,a"	/* 51 */
	opn_n:		.asciz	"N"	/* 54 */
	opa_n:		.asciz	"1,a"	/* 54 */
	opn_cl:		.asciz	"CL"	/* 55 */
	opa_cl:		.asciz	"1,a"	/* 55 */
	opn_o:		.asciz	"O"	/* 56 */
	opa_o:		.asciz	"1,a"	/* 56 */
	opn_x:		.asciz	"X"	/* 57 */
	opa_x:		.asciz	"1,a"	/* 57 */
	opn_l:		.asciz	"L"	/* 58 */
	opa_l:		.asciz	"1,a"	/* 58 */
	opn_c:		.asciz	"C"	/* 59 */
	opa_c:		.asciz	"1,a"	/* 59 */
	opn_a:		.asciz	"A"	/* 5a */
	opa_a:		.asciz	"1,a"	/* 5a */
	opn_s:		.asciz	"S"	/* 5b */
	opa_s:		.asciz	"1,a"	/* 5b */
	opn_m:		.asciz	"M"	/* 5c */
	opa_m:		.asciz	"1,a"	/* 5c */
	opn_d:		.asciz	"D"	/* 5d */
	opa_d:		.asciz	"1,a"	/* 5d */
	opn_al:		.asciz	"AL"	/* 5e */
	opa_al:		.asciz	"1,a"	/* 5e */
	opn_sl:		.asciz	"SL"	/* 5f */
	opa_sl:		.asciz	"1,a"	/* 5f */

	opn_std:	.asciz	"STD"	/* 60 */
	opa_std:	.asciz	"1,a"	/* 60 */
	opn_mxd:	.asciz	"MXD"	/* 67 */
	opa_mxd:	.asciz	"1,a"	/* 67 */
	opn_ld:		.asciz	"LD"	/* 68 */
	opa_ld:		.asciz	"1,a"	/* 68 */
	opn_cd:		.asciz	"CD"	/* 69 */
	opa_cd:		.asciz	"1,a"	/* 69 */
	opn_ad:		.asciz	"AD"	/* 6a */
	opa_ad:		.asciz	"1,a"	/* 6a */
	opn_sd:		.asciz	"SD"	/* 6b */
	opa_sd:		.asciz	"1,a"	/* 6b */
	opn_md:		.asciz	"MD"	/* 6c */
	opa_md:		.asciz	"1,a"	/* 6c */
	opn_dd:		.asciz	"DD"	/* 6d */
	opa_dd:		.asciz	"1,a"	/* 6d */
	opn_aw:		.asciz	"AW"	/* 6e */
	opa_aw:		.asciz	"1,a"	/* 6e */
	opn_sw:		.asciz	"SW"	/* 6f */
	opa_sw:		.asciz	"1,a"	/* 6f */

	opn_ste:	.asciz	"STE"	/* 70 */
	opa_ste:	.asciz	"1,a"	/* 70 */
	opn_le:		.asciz	"LE"	/* 78 */
	opa_le:		.asciz	"1,a"	/* 78 */
	opn_ce:		.asciz	"CE"	/* 79 */
	opa_ce:		.asciz	"1,a"	/* 79 */
	opn_ae:		.asciz	"AE"	/* 7a */
	opa_ae:		.asciz	"1,a"	/* 7a */
	opn_se:		.asciz	"SE"	/* 7b */
	opa_se:		.asciz	"1,a"	/* 7b */
	opn_me:		.asciz	"ME"	/* 7c */
	opa_me:		.asciz	"1,a"	/* 7c */
	opn_de:		.asciz	"DE"	/* 7d */
	opa_de:		.asciz	"1,a"	/* 7d */
	opn_au:		.asciz	"AU"	/* 7e */
	opa_au:		.asciz	"1,a"	/* 7e */
	opn_su:		.asciz	"SU"	/* 7f */
	opa_su:		.asciz	"1,a"	/* 7f */

	opn_ssm:	.asciz	"SSM"	/* 80 */
	opa_ssm:	.asciz	"b"	/* 80 */
	opn_lpsw:	.asciz	"LPSW"	/* 82 */
	opa_lpsw:	.asciz	"b"	/* 82 */
	opn_diag:	.asciz	"DIAG"	/* 83 */
	opa_diag:	.asciz	"x"	/* 83 */
	opn_bxh:	.asciz	"BXH"	/* 86 */
	opa_bxh:	.asciz	"1,2,b" /* 86 */
	opn_bxle:	.asciz	"BXLE"	/* 87 */
	opa_bxle:	.asciz	"1,2,b" /* 87 */
	opn_srl:	.asciz	"SRL"	/* 88 */
	opa_srl:	.asciz	"1,b"	/* 88 */
	opn_sll:	.asciz	"SLL"	/* 89 */
	opa_sll:	.asciz	"1,b"	/* 89 */
	opn_sra:	.asciz	"SRA"	/* 8a */
	opa_sra:	.asciz	"1,b"	/* 8a */
	opn_sla:	.asciz	"SLA"	/* 8b */
	opa_sla:	.asciz	"1,b"	/* 8b */
	opn_srdl:	.asciz	"SRDL"	/* 8c */
	opa_srdl:	.asciz	"1,b"	/* 8c */
	opn_sldl:	.asciz	"SLDL"	/* 8d */
	opa_sldl:	.asciz	"1,b"	/* 8d */
	opn_srda:	.asciz	"SRDA"	/* 8e */
	opa_srda:	.asciz	"1,b"	/* 8e */
	opn_slda:	.asciz	"SLDA"	/* 8f */
	opa_slda:	.asciz	"1,b"	/* 8f */

	opn_stm:	.asciz	"STM"	/* 90 */
	opa_stm:	.asciz	"1,2,b" /* 90 */
	opn_tm:		.asciz	"TM"	/* 91 */
	opa_tm:		.asciz	"b,i"	/* 91 */
	opn_mvi:	.asciz	"MVI"	/* 92 */
	opa_mvi:	.asciz	"b,i"	/* 92 */
	opn_ts:		.asciz	"TS"	/* 93 */
	opa_ts:		.asciz	"b"	/* 93 */
	opn_ni:		.asciz	"NI"	/* 94 */
	opa_ni:		.asciz	"b,i"	/* 94 */
	opn_cli:	.asciz	"CLI"	/* 95 */
	opa_cli:	.asciz	"b,i"	/* 95 */
	opn_oi:		.asciz	"OI"	/* 96 */
	opa_oi:		.asciz	"b,i"	/* 96 */
	opn_xi:		.asciz	"XI"	/* 97 */
	opa_xi:		.asciz	"b,i"	/* 97 */
	opn_lm:		.asciz	"LM"	/* 98 */
	opa_lm:		.asciz	"1,2,b" /* 98 */
	opn_9cxx:	.asciz	"9CXX"	/* 9cxx */
	opa_9cxx:	.asciz	"b"	/* 9cxx */
	opn_9dxx:	.asciz	"9DXX"	/* 9dxx */
	opa_9dxx:	.asciz	"b"	/* 9dxx */
	opn_9exx:	.asciz	"9EXX"	/* 9exx */
	opa_9exx:	.asciz	"b"	/* 9exx */
	opn_9fxx:	.asciz	"9FXX"	/* 9fxx */
	opa_9fxx:	.asciz	"b"	/* 9fxx */

	opn_ai:		.asciz	"AI"	/* a1 */
	opa_ai:		.asciz	"b,i"	/* a1 */
	opn_stnsm:	.asciz	"STNSM" /* ac */
	opa_stnsm:	.asciz	"b,i"	/* ac */
	opn_stosm:	.asciz	"STOSM" /* ad */
	opa_stosm:	.asciz	"b,i"	/* ad */
	opn_sigp:	.asciz	"SIGP"	/* ae */
	opa_sigp:	.asciz	"1,2,b" /* ae */
	opn_mc:		.asciz	"MC"	/* af */
	opa_mc:		.asciz	"b,i"	/* af */

	opn_lra:	.asciz	"LRA"	/* b1 */
	opa_lra:	.asciz	"1,a"	/* b1 */
	opn_b2xx:	.asciz	"B2XX"	/* b2xx */
	opa_b2xx:	.asciz	"b"	/* b2xx */
	opn_ipm:	.asciz	"IPM"	/* b222 */
	opa_ipm:	.asciz	"3"	/* b222 */
	opn_dxr:	.asciz	"DXR"	/* b22d */
	opa_dxr:	.asciz	"3,4"	/* b22d */
	opn_stctl:	.asciz	"STCTL" /* b6 */
	opa_stctl:	.asciz	"1,2,b" /* b6 */
	opn_lctl:	.asciz	"LCTL"	/* b7 */
	opa_lctl:	.asciz	"1,2,b" /* b7 */
	opn_cs:		.asciz	"CS"	/* ba */
	opa_cs:		.asciz	"1,2,b" /* ba */
	opn_cds:	.asciz	"CDS"	/* bb */
	opa_cds:	.asciz	"1,2,b" /* bb */
	opn_bcxx:	.asciz	"BCXX"	/* bcxx */
	opa_bcxx:	.asciz	"b"	/* bcxx */
	opn_clm:	.asciz	"CLM"	/* bd */
	opa_clm:	.asciz	"1,n,b" /* bd */
	opn_stcm:	.asciz	"STCM"	/* be */
	opa_stcm:	.asciz	"1,n,b" /* be */
	opn_icm:	.asciz	"ICM"	/* bf */
	opa_icm:	.asciz	"1,n,b" /* bf */

	opn_mvn:	.asciz	"MVN"	/* d1 */
	opa_mvn:	.asciz	"c,d"	/* d1 */
	opn_mvc:	.asciz	"MVC"	/* d2 */
	opa_mvc:	.asciz	"c,d"	/* d2 */
	opn_mvz:	.asciz	"MVZ"	/* d3 */
	opa_mvz:	.asciz	"c,d"	/* d3 */
	opn_nc:		.asciz	"NC"	/* d4 */
	opa_nc:		.asciz	"c,d"	/* d4 */
	opn_clc:	.asciz	"CLC"	/* d5 */
	opa_clc:	.asciz	"c,d"	/* d5 */
	opn_oc:		.asciz	"OC"	/* d6 */
	opa_oc:		.asciz	"c,d"	/* d6 */
	opn_xc:		.asciz	"XC"	/* d7 */
	opa_xc:		.asciz	"c,d"	/* d7 */
	opn_tr:		.asciz	"TR"	/* dc */
	opa_tr:		.asciz	"c,d"	/* dc */
	opn_trt:	.asciz	"TRT"	/* dd */
	opa_trt:	.asciz	"c,d"	/* dd */
	opn_ed:		.asciz	"ED"	/* de */
	opa_ed:		.asciz	"c,d"	/* de */
	opn_edmk:	.asciz	"EDMK"	/* df */
	opa_edmk:	.asciz	"c,d"	/* df */

	opn_e5xx:	.asciz	"E5XX"	/* e5 */
	opa_e5xx:	.asciz	"b,d"	/* e5 */
	opn_mvcin:	.asciz	"MVCIN" /* e8 */
	opa_mvcin:	.asciz	"c,d"	/* e8 */

	opn_srp:	.asciz	"SRP"	/* f0 */
	opa_srp:	.asciz	"f,d,j" /* f0 */
	opn_mvo:	.asciz	"MVO"	/* f1 */
	opa_mvo:	.asciz	"f,g"	/* f1 */
	opn_pack:	.asciz	"PACK"	/* f2 */
	opa_pack:	.asciz	"f,g"	/* f2 */
	opn_unpk:	.asciz	"UNPK"	/* f3 */
	opa_unpk:	.asciz	"f,g"	/* f3 */
	opn_zap:	.asciz	"ZAP"	/* f8 */
	opa_zap:	.asciz	"f,g"	/* f8 */
	opn_cp:		.asciz	"CP"	/* f9 */
	opa_cp:		.asciz	"f,g"	/* f9 */
	opn_ap:		.asciz	"AP"	/* fa */
	opa_ap:		.asciz	"f,g"	/* fa */
	opn_sp:		.asciz	"SP"	/* fb */
	opa_sp:		.asciz	"f,g"	/* fb */
	opn_mp:		.asciz	"MP"	/* fc */
	opa_mp:		.asciz	"f,g"	/* fc */
	opn_dp:		.asciz	"DP"	/* fd */
	opa_dp:		.asciz	"f,g"	/* fd */

/**/
