
/* dim3.s 1995/7/18 */

/* M-on-RISC Dynamically Translating Simulator */
/*	 Copyright (C) 1995 by FUJITSU LIMITED */
/*		   Primary writer: Y.Nakashima */
/*	    nakashim@pine.mfd.cs.fujitsu.co.jp */

	.file	"dim3.s"
	.section ".data"
	.align	8
	.global dim_RcsId
dim_RcsId:
	.asciz	"$Id: dim3.s,v 1.1 1998/07/01 01:46:00 nakashim Exp nakashim $"

!
! <SPARC stack frame>
!
! %fp-->  +-----------------------------------------+ ---
! %fp-off.|automatic var. not used  (%fp not used)  |  ^
!	  |-----------------------------------------|  |
! %sp+200 |%i7 is saved here			    |  size = 24
! %sp+192 |  (reserved)			            |  |
! %sp+184 |%i0 is saved here (struct *gcpu_s)	    |  v
!	  |-----------------------------------------| ---
! %sp+176 |1 double word for calee		    |  ^
! %sp+168 |1 double word for calee		    |  |
! %sp+160 |1 double word for calee		    |  |
! %sp+152 |1 double word for calee		    |  |
! %sp+144 |1 double word for calee		    |  |
! %sp+136 |1 double word for calee		    |  |
!	  |-----------------------------------------|  |
! %sp+off.|1 double word hidden param		    |  size = 184
!	  |-----------------------------------------|  |
! %sp+off.|16 double words for in,local (used by OS)|  v
! %sp-->  +-----------------------------------------+ ---
!

!
! <%g1-%g7 field assignment>
!						             2
!	  +------------------------------------------------+--+
!    %g1  |           reserved (0)                         |CC|
!	  +------------------------------------------------+--+
!    %g2  |	      Instruction address register 	      |
!	  +---------------------------------------------------+
!    %g3  |	      A-MASK(24/29)	                      |
!	  +---------------------+-----------------------------+
!    %g4  |           OP-BASE   |00000000000000000000000000000|
! 	  +---------------------+-----------------------------+
!    %g5  |           IF-BASE   |00000000000000000000000000000|
!	  +--------------------------+------------------------+
!    %g6  |           reserved (0)   |     M register #14     |
!	  +--------+--+-+-+-+-+Int.code+-+-------+-+-+-+-+----+
!    %g7  |        |FC|r|P|B|S|loc-143 |C|0001000|I|E|I|A|PROG|
!	  |        |  |s|R|H| |        |S|       |F|X|M|M|MASK|
!	  +--------+--+-+-+-+-+--------+-+-------+-+-+-+-+----+
!		    -- - - - - --------- - ------- - - - - ----
!		     r 0 r r r	  r     r  const. r r r r  r
!		     o   w w w	  o	o	  o o w w  w
!		  Interruption Flags
!		         bit 0-31 : reserved (0)
!			 bit32-33 : Function Code
!			   0x0: Program Exception or Step Execution(S=1)
!				param = bit 39-47
!			   0x1: reserved
!			   0x2: Special Instruction
!				param = gcpu_s->minsn
!			   0x3: Extended Function (emm call)
!				[BC 0,FED(0,0) ... 0x47000fed]
!				/* example */
!				switch (gcpu_s->m[0]) {
!				case 0xff0: NOP
!				case 0xff1: PRINTF
!				case 0xff2: SCANF
!				case 0xff3: TIME
!				case 0xffe: STACK OVERFLOW
!				case 0xfff: PROGRAM NORMAL END
!				default:    UNDEFINED (error)
!				}
!			 bit34-36 : reserved (0)
!			 bit37	  : PR (branch taken PER)
!			 bit38	  : BH (branch taken history)
!			 bit39	  : S  (step execution)
!			 bit40-47 : Interruption code (Program Exception)
!			 bit48    : CS (0:normal   1:CS/CDS in progress)
!			 bit49-55 : const. for conditional branch
!			 bit56    : IF (0:OP-Fetch 1:I-Fetch in progress)
!			 bit57    : EX (0:normal   1:EX in progress)
!			 bit58	  : IM (interpretive execution mode)
!			 bit59	  : AM (0:24bit-mode 1:31bit-mode)
!			 bit60	  : fixed-point overflow
!			 bit61	  : decimal overflow
!			 bit62	  : exponent underflow
!			 bit63	  : significance
!
!		  (sparc:	    always,   ba/bn	  )
!		  (sparc:icc.n:	    negative, bpos/bneg	  )
!		  (sparc:icc.z:	    zero,     bn[ze]/b[ze])
!		  (sparc:icc.v:	    overflow, bvc/bvs	  )
!		  (sparc:icc.c:	    carry,    bcc/bcs	  )
!

!
! <host_ibuf handshake>
!
!    Getting the address of current free ibuf.
!      Dim "call emm_ibufbpa" to get address of host_ibufpp[addr]+0x8.
!	   1st. param: struct gcpu_s *gcpu_s;
!	   2nd. param: unsigned M-addr;
!	   3rd. param: unsigned type (0:instruction, 1: operand for CS/CDS)
!      If (retval == 1) then dim() returns with(1),
!			     emm must exec "MPOP_HSTPROT"
!      Dim loads ibufbpa and fetch first 4bytes(ibuf top address).
!      Dim loads ibufbpa and fetch next	 4bytes(ibuf lock flag).
!
!    Getting a new ibuf.
!      Dim "call emm_ibuf_alloc" to get a new ibuf.
!	   1st. param: struct gcpu_s *gcpu_s;
!	   2nd. param: unsigned M-addr;
!

!
! <exception handling>
!
!    M Instruction Fetch:
!      if M-PC is odd-address then
!	 Dim generate misalign-exception in host_imap[].
!	 Emm must simulate ILC=0,specification-exception.
!
!      if entering new instruction space then
!	 Dim generate page-fault in host_imap[].
!	 Emm must allocate new page against host_imap[].
!
!    M Instruction Execution:
!      if M-instruction jmp to middle of M-instruction then
!	 Dim enters logical 0x1,0x2 and generates misaligned I-fetch.
!	 Emm must generate emulation error.
!
!    M Operand Fetch:
!      if odd-address then
!	 Dim generate misalign-exception in gmem[].
!	 Emm must simulate load with load-byte.
!
!    M Operand Store:
!      if odd-address then
!	 Dim generate misalign-exception in gmem[].
!	 Emm must simulate store with store-byte.
!      if self-modify-code (i.e. host_imap[addr] != 0) then
!	 Emm must overwrite host_imap[]->ibuf with
!	   "sethi %hi(trans_main),%o0	 "
!	   "or	  %o0,%lo(trans_main),%o0"
!	   "jmpl  %o0,%g0		 "
!	   "nop				 "
!	 Emm must overwrite host_imap[.+0,[.+1,][.+2]] with zero.
!

!
! <%o0-%o7,%l0-%l7,%i0-%i7 assignment>
!
!	  +---------------------------------------------------+
!    %o0  |		    Work		              |
!	  +---------------------------------------------------+
!    %o1  |		    Work		              |
!	  +---------------------------------------------------+
!    %o2  |		    Work		              |
!	  +---------------------------------------------------+
!    %o3  |		    Work		              |
!	  +---------------------------------------------------+
!    %o4  |		    Work		              |
!	  +---------------------------------------------------+
!    %o5  |		    Work		              |
!	  +---------------------------------------------------+
!    %sp  |		Stack pointer		              |
!	  +---------------------------------------------------+
!    %o7  |		    Work		              |
!	  +-------------------------+-------------------------+
!    %l0  |	reserved (0)        |    M register #0        |
!	  +-------------------------+-------------------------+
!    %l1  |	reserved (0)	    |    M register #1        |
!	  +-------------------------+-------------------------+
!    %l2  |	reserved (0)	    |    M register #2	      |
!	  +-------------------------+-------------------------+
!    %l3  |	reserved (0)	    |    M register #3	      |
!	  +-------------------------+-------------------------+
!    %l4  |	reserved (0)	    |    M register #4	      |
!	  +-------------------------+-------------------------+
!    %l5  |	reserved (0)	    |    M register #5	      |
!	  +-------------------------+-------------------------+
!    %l6  |	reserved (0)	    |    M register #6	      |
!	  +-------------------------+-------------------------+
!    %l7  |	reserved (0)	    |    M register #7	      |
!	  +-------------------------+-------------------------+
!    %i0  |	reserved (0)	    |    M register #8	      |
!	  +-------------------------+-------------------------+
!    %i1  |	reserved (0)	    |    M register #9	      |
!	  +-------------------------+-------------------------+
!    %i2  |	reserved (0)	    |    M register #10	      |
!	  +-------------------------+-------------------------+
!    %i3  |	reserved (0)	    |    M register #11	      |
!	  +-------------------------+-------------------------+
!    %i4  |	reserved (0)	    |    M register #12	      |
!	  +-------------------------+-------------------------+
!    %i5  |	reserved (0)        |	 M register #13	      |
!	  +-------------------------+-------------------------+
!    %fp  |		Frame pointer             	      |
!	  +-------------------------+-------------------------+
!    %i7  |	reserved (0)        |    M register #15	      |
!	  +-------------------------+-------------------------+
!

!
! <gcpu_s structure>
!
!	  gcpu_s.g2
!	  +----------------------------------------+
!	  |	  Instruction address register	   |
!	  +-----------------------+--+-------+--+--+
!	   0			   19	      30 31
!			<------------------+--->
!			<-------+--->	   |
!				|	   |
!  +----------------------------+	   |
!  | +-------------------------------------+
!  | |
!  | |	  gcpu_s.host_imap
!  | |	  +----------------------------------------+
!  | |	  +----------------------------------------+
!  | +--->|	  Sparc instruction start address  |-----+
!  |	  +----------------------------------------+	 |
!  |	  +----------------------------------------+	 |
!  |	  * address: 0: not translated yet		 |
!  |		     1: +2 from translated instruction	 |
!  |		     2: +4 from translated instruction	 |
!  |		     3: reserved			 |
!  |		  else: start address			 |
!  |							 |
!  |	  gcpu_s.host_ibufpp				 |
!  |	  +----------------------------------------+	 |
!  |	  +----------------------------------------+	 |
!  +----->|	  Ibuf start page address	   |---+ |
!	  + - - - - - - - - - - - - - - - - - - - -+   | |
!	  |		 (reserved)		   |   | |
!emm_	  + - - - - - - - - - - - - - - - - - - - -+   | |
!ibufbpa->|	  Ibuf bottom page address	   |---|-|-+
!	  + - - - - + - - - - + - - - - + - - - - -+   | | |
!	  |Lock trns|Lock-ID  |Lock CS	|	   |   | | |
!	  |00:unlock|10-7F:dim|00:unlock|(reserved)|   | | |
!	  |FF:locked|80-ff:emm|FF:locked|	   |   | | |
!	  +---------+---------+---------+----------+   | | |
!	  +----------------------------------------+   | | |
!		     0x10:trans			       | | |
!  +---------------------------------------------------+ | |
!  |							 | |
!  |	  emm_ibuf_alloc(type, size)			 | |
!  |	  +----------------------------------------+	 | |   +--------+
!  +----->|	  Next ibuf start address or 0	   |-----|-+-->|  NULL	|
!	  +----------------------------------------+	 |     +--------+
!	  |	  Free bytes (0 .. 32KB-8-120)	   |	 |     |	|
!	  +----------------------------------------+	 |     +--------+
!	  |				   <+	   |	 |     |	|
!	  |	  EMM work		    | 120  |	 |     |	|
!	  |	  			    | bytes|	 |     |	|
!	  |	  			   <+	   |	 |     |	|
!	  +----------------------------------------+	 |     +--------+
!	  |					   |	 |     |	|
!	  |	  Sparc instruction area	   |<----+     |	|
!	  |					   |	       |	|
!	  +----------------------------------------+	       +--------+
!	X * Next ibuf start address = emm_ibuf_alloc(..);
!	X * Always next ibuf must be allocated.
!	X * That is current "next address" should be valid,
!	X   because "ba next_address+8" may be stored after
!	X   previous template to skip ibuf fragments.
!

!
! <dynamic translation flow>
!
!   [EMULATE STORE INSTRUCTION]
!     if (store is self modification) {
!	if (host_imap[addr] != NULL) {
!	  host_imap[addr]->ibuf = "sethi/or trans_main;jmpl [reg],%g0"
!	  host_imap[addr  ]	= null;
!	  host_imap[addr+1]	= null; /* if necessary */
!	  host_imap[addr+2]	= null; /* if necessary */
!	}
!     }
!     trap by protection exception (dim does nothing)
!
!   [EX ENTRY]
!   trans_ex:
!  *c translate on interp_ibuf;
!     terminate interp_ibuf with "sethi/or trans_main;jmpl [reg],%g0";
!     override ILC=2,IAR+=2
!     goto interp_ibuf;
!
!   [START TRANSLATION ENTRY]
!   trans_main:
!     VIAR = IAR;
!     if (host_imap[VIAR] != NULL)
!	goto start_execution;
!
!   [TRANSLATION MAIN LOOP]
! +>trans_loop:
! |   if (ibufbp == NULL ||
! |*c	  ibufbp has no enough free bytes)
! |	emm_ibuf_alloc(VIAR, 32K); [free = 32KB-8]
! |*c translate;
! |   terminate ibuf with "sethi/or trans_main;jmpl [reg],%g0";#for intr.
! |	[But don't decrement ibuf[PAGE#].free.]
! |	[Next template override "sethi/or trans_main;jmpl [reg],%g0".]
! |   polling interruption;
! |   if (M[VIAR] != branch && host_imap[next VIAR] == NULL) {
! |	VIAR = next VIAR;
! +-	goto trans_loop;
!     }
!     else {
!	decrement ibuf[PAGE#].free
!	goto start_execution;
!     }
!
!   start_execution:
!     load host_imap[IAR];
!     jmpl [reg],%g0;
!

!
! Dynamically Translating Simulator Subsystem Entry Point
!
! dim() returns 0 if normal end.
!	returns 1 if MPOP_HSTPROT. ( emm_getibufbpa() returns 1 )
!
	.section ".text"
	.align	4
	.global dim
	.global dim_info
	.global dim_prog
	.global trans_main
	.global	trans_interp
dim:
!
! prolog
!
	ba	dim_prog	! skip dim_info
	nop			!
dim_info:
	.word	0x00000003	! %g reg-format version
	.word	optable		! ->optable
	.word	optb2xx		! ->optb2xx
	.word	pa_sinsn	! ->pa_sinsn
	.word	pa_pinsn	! ->pa_pinsn
	.word	br_hist_top	! ->br_hist_top
dim_prog:
	save	%sp,-208,%sp	! 12 + 92
	st	%i0,[%sp+184]	! struct *gcpu_s (dim frame structure)
	st	%i7,[%sp+200]	! return addr.
	mov	%i0,%o7		!
				! *: 'C'caller should save/restore
			! %g0	! (wired-0)
	ldx	[%o7+648],%g1	! *(temporary)	-> M-CC
	ldx	[%o7+656],%g2	! *(global var.)-> IAR
	ldx	[%o7+664],%g3	! *(global var.)-> A-MASK(24/31)
	ldx	[%o7+672],%g4	! *(global var.)-> OP-base
	ldx	[%o7+680],%g5	! *(reserved)	-> IF-base
			! %g7	! *(reserved)	-> intr.flags.(loaded by main)
			! %o0	! (param0)	-> work -> param0/retval
			! %o1	! (param1)	-> work -> param1
			! %o2	! (param2)	-> work -> param2
			! %o3	! (param3)	-> work -> param3
			! %o4	! (param4)	-> work -> param4
			! %o5	! (param5)	-> work -> param5
			! %sp	! stack pointer -> stack pointer
			! %o7	! (temporary)	-> work -> return addr.
			! %fp	! frame pointer -> frame pointer
	andcc	%g7,0x20,%g0	! if IM=1 then
	bnz	trans_interp	!   skip load M-GRs
	nop			!
	ld	[%o7+  0],%l0	! (local0)	-> Mreg0
	ld	[%o7+  4],%l1	! (local1)	-> Mreg1
	ld	[%o7+  8],%l2	! (local2)	-> Mreg2
	ld	[%o7+ 12],%l3	! (local3)	-> Mreg3
	ld	[%o7+ 16],%l4	! (local4)	-> Mreg4
	ld	[%o7+ 20],%l5	! (local5)	-> Mreg5
	ld	[%o7+ 24],%l6	! (local6)	-> Mreg6
	ld	[%o7+ 28],%l7	! (local7)	-> Mreg7
	ld	[%o7+ 32],%i0	! param0/retval -> Mreg8
	ld	[%o7+ 36],%i1	! (param1)	-> Mreg9
	ld	[%o7+ 40],%i2	! (param2)	-> Mreg10
	ld	[%o7+ 44],%i3	! (param3)	-> Mreg11
	ld	[%o7+ 48],%i4	! (param4)	-> Mreg12
	ld	[%o7+ 52],%i5	! (param5)	-> Mreg13
	ld	[%o7+ 60],%i7	! return addr.	-> Mreg15
	ld	[%o7+ 56],%g6	! *(reserved)	-> Mreg14
	ba	trans_main	!
	nop			!
!================================

!
! Dynamically Translating Simulator Subsystem EX Instruction Entry
!   %o1: param: or-value
!   %o2: param: target address
!
trans_ex:
	andcc	%o2,1,%g0	! if odd address then
	bz	trans_eavalid	!
	sethi	%hi(0x00060000),%o0
	ba	epilog0		!
	or	%g7,%o0,%g7	!   specification exception

trans_eavalid:
	ld	[%sp+184],%o7	! struct *gcpu_s
	st	%o1,[%o7+704]	! save or-value
	and	%o2,%g3,%o2	! mask address
	andcc	%g7,0x20,%g0	! if IM=1 then
	bnz	trans_xinterp	!   skip cfunc,ibuf_alloc,limap
	add	%g4,%o2,%o2	!
	ldub	[%o2],%o1	! load gmem[TARGET]
	subcc	%o1,0xb2,%g0	! if 2byte opcd then
	be	trans_eb2xx	!
	sethi	%hi(optable),%o4!
	or	%o4,%lo(optable),%o4
	sll	%o1,5,%o1	!
	ba	trans_edecode	!
	add	%o4,%o1,%o4	! &optable[opcd]
trans_eb2xx:
	sethi	%hi(optb2xx),%o4!
	or	%o4,%lo(optb2xx),%o4
	ld	[%o7+704],%o3	! load or-value
	ldub	[%o2+1],%o1	! load gmem[TARGET+1]
	or	%o1,%o3,%o1	!
	sll	%o1,5,%o1	!
	add	%o4,%o1,%o4	! &optb2xx[opcd]
trans_edecode:
	ld	[%o4+20],%o5	! load optable[opcd].tfunc
	ld	[%o4+0],%o3	! load optable[opcd].mlen
	subcc	%o3,2,%g0	!
	bne	trans_eskip2	!
	lduh	[%o2],%o1	! 2 byte instruction
	ba	trans_etfunc	!
	sll	%o1,16,%o1	! store in upper half of %o1
trans_eskip2:
	subcc	%o3,4,%g0	!
	bne	trans_eskip4	!
	lduh	[%o2+2],%o3	! 4 byte instruction
	sll	%o1,16,%o1	!
	ba	trans_etfunc	!
	or	%o1,%o3,%o1	! store in %o1
trans_eskip4:
	lduh	[%o2+4],%o2	! 6 byte instruction
	sll	%o1,16,%o1	!
	or	%o1,%o3,%o1	! store in %o1
	sll	%o2,16,%o2	! store in upper half of %o2

trans_etfunc:
	ld	[%o7+896],%o0	! get interp_ibuf start address
	add	%o0,128,%o0	!
	ld	[%o7+704],%o4	! load or-value
	sll	%o4,16,%o4	! extract or-value as bit8-15
	or	%o1,%o4,%o1	!
	jmpl	%o5,%o7		! call tfunc()
	or	%g7,0x40,%g7	! flag=EXECUTE

	sethi	%hi(terminsn),%o1
	or	%o1,%lo(terminsn),%o1
	ld	[%o1],%o2	! terminate ibuf with sethi;or;jmpl;nop;
	ld	[%o1+4],%o3	!
	ld	[%o1+8],%o4	!
	ld	[%o1+12],%o5	!
	st	%o2,[%o0]	!
	st	%o3,[%o0+4]	!
	st	%o4,[%o0+8]	!
	st	%o5,[%o0+12]	!
	add	%o0,16,%o0	!
	ld	[%sp+184],%o7	! struct *gcpu_s
	ld	[%o7+896],%o1	! get interp_ibuf start address
	add	%o1,128,%o1	! (for ULTRA/STINGRAY)
	sub	%o0,%o1,%o2	! (for ULTRA/STINGRAY)
	sub	%o2,4,%o2	! (for ULTRA/STINGRAY)
	flush	%o1+%o2		! (for ULTRA/STINGRAY)
trans_etflush:			! (for ULTRA/STINGRAY)
	subcc	%o2,32,%o2	! (for ULTRA/STINGRAY)
	bg,a	trans_etflush	! (for ULTRA/STINGRAY)
	flush	%o1+%o2		! (for ULTRA/STINGRAY)
	flush	%o1+0		! (for ULTRA/STINGRAY)
	jmpl	%o1,%g0		! jmp to interp_ibuf
	nop			!
!================================

!
! Interpretive Execution Entry (IM=1,EXECUTE)
!
trans_xinterp:
	ldub	[%o2],%o1	! load gmem[TARGET]
	subcc	%o1,0xb2,%g0	! if 2byte opcd then
	be	trans_xb2xx	!
	sethi	%hi(optable),%o4!
	or	%o4,%lo(optable),%o4
	sll	%o1,5,%o1	!
	ba	trans_xdecode	!
	add	%o4,%o1,%o4	! &optable[opcd]
trans_xb2xx:
	sethi	%hi(optb2xx),%o4!
	or	%o4,%lo(optb2xx),%o4
	ld	[%o7+704],%o3	! load or-value
	ldub	[%o2+1],%o1	! load gmem[TARGET+1]
	or	%o1,%o3,%o1	!
	sll	%o1,5,%o1	!
	add	%o4,%o1,%o4	! &optb2xx[opcd]
trans_xdecode:
	ld	[%o4+4],%o0	! load optable[opcd].ifunc
	ld	[%o4+0],%o3	! load optable[opcd].mlen
	subcc	%o3,2,%g0	!
	bne	trans_xskip2	!
	lduh	[%o2],%o1	! 2 byte instruction
	ba	trans_xtfunc	!
	sll	%o1,16,%o1	! store in upper half of %o1
trans_xskip2:
	subcc	%o3,4,%g0	!
	bne	trans_xskip4	!
	lduh	[%o2+2],%o3	! 4 byte instruction
	sll	%o1,16,%o1	!
	ba	trans_xtfunc	!
	or	%o1,%o3,%o1	! store in %o1
trans_xskip4:
	lduh	[%o2+4],%o2	! 6 byte instruction
	sll	%o1,16,%o1	!
	or	%o1,%o3,%o1	! store in %o1
	sll	%o2,16,%o2	! store in upper half of %o2

trans_xtfunc:
	ld	[%o7+704],%o4	! load or-value
	sll	%o4,16,%o4	! extract or-value as bit8-15
	or	%o1,%o4,%o1	!
	jmpl	%o0,%g0		! jmp to ifunc()
	or	%g7,0x40,%g7	! flag=EXECUTE
!================================

!
! break2 (for BRANCH TAKEN PER)
!
break2:
	andncc	%g7,0xfff,%g0	! if interruption then
	bnz	epilog2		!   return

!
! Dynamically Translating Simulator Subsystem Internal Main Entry
!
trans_main:
	and	%g2,%g3,%g2	! mask address
	sll	%g2,1,%o1	! IAR << 1
	ld	[%g5+%o1],%o0	! load host_imap[IAR]
	subcc	%o0,0,%g0	! if host_imap[IAR] == 0 then
	be	trans_prep	!   start translation
	nop			!
	jmpl	%o0,%g0		! jmp to host_ibuf
	andn	%g7,0x40,%g7	! flag=NON EXECUTE
!================================

trans_prep:
	or	%g7,0x80,%g7	! --- M I-fetch start ---
	ldub	[%g4+%g2],%o1	! load gmem[VIAR]
	andn	%g7,0x80,%g7	! --- M I-fetch end ---
	sethi	%hi(optable),%o4!
	or	%o4,%lo(optable),%o4
	sll	%o1,5,%o1	!
	add	%o4,%o1,%o4	! &optable[opcd]
	ld	[%o4+0],%o3	! load optable[opcd].mlen
	sub	%o3,1,%o3	!
	add	%g2,%o3,%o3	! new VIAR-1
	xor	%g2,%o3,%o4	!
	andncc	%o4,0xfff,%g0	!
	bz	trans_ptfoi	! if new insn crosses page boundary
	nop			!   test fetch next page
! TEST fetch of next page (force page-in)
	or	%g7,0x80,%g7	! --- M I-fetch start ---
	ldub	[%g4+%o3],%g0	! load gmem[IAR]
	andn	%g7,0x80,%g7	! --- M I-fetch end ---

trans_ptfoi:
	ld	[%sp+184],%o0	! struct *gcpu_s
	stx	%g1,[%o0+648]	!
	stx	%g2,[%o0+656]	! save IAR, %g2 is used as VIAR
	stx	%g3,[%o0+664]	!
	stx	%g4,[%o0+672]	!
	stx	%g5,[%o0+680]	!
	mov	%g2,%o1		! (FATAL if retval == NULL)
	call	emm_getibufbpa,0!
	add	%g0,0,%o2	! type = 0 (instruction)
	ld	[%sp+184],%o7	! struct *gcpu_s
	ldx	[%o7+648],%g1	!
	ldx	[%o7+656],%g2	!
	ldx	[%o7+664],%g3	!
	ldx	[%o7+672],%g4	!
	ldx	[%o7+680],%g5	!
	st	%o0,[%o7+856]	! store ibufbpa
	subcc	%o0,1,%g0	! if retval == 1 then return(1)
	be	epilog3		!
	nop			!

! LOCK for MP
trans_plock:			!			(MP PATCH)
	ldstub	[%o0+4],%o2	! try locking ibufbpa	(MP PATCH)
	subcc	%o2,0,%g0	!			(MP PATCH)
	be	trans_plout	!			(MP PATCH)
	nop			!			(MP PATCH)
trans_plwait:			!			(MP PATCH)
	ldub	[%o0+4],%o2	!			(MP PATCH)
	subcc	%o2,0,%g0	!			(MP PATCH)
	bne	trans_plwait	!			(MP PATCH)
	nop			!			(MP PATCH)
	ba,a	trans_plock	! retry locking ibufbpa (MP PATCH)
trans_plout:			!			(MP PATCH)
	add	%g0,0x10,%o2	! ID=trans		(MP PATCH)
	stb	%o2,[%o0+5]	!			(MP PATCH)

	sll	%g2,1,%o1	! IAR << 1
	ld	[%g5+%o1],%o0	! load host_imap[IAR]
	subcc	%o0,0,%g0	! if host_imap[IAR] != 0 then
	bnz	trans_lunlock	!   goto trans_lunlock
	nop			!

!
! Dynamically Translating Simulator Subsystem Main Loop
!
trans_loop:
	ld	[%sp+184],%o7	! struct *gcpu_s
	add	%g4,%g2,%o2	! gmem[VIAR]
	or	%g7,0x80,%g7	! --- M I-fetch start ---
	ldub	[%o2],%o1	! load gmem[VIAR]
	subcc	%o1,0xb2,%g0	! if 2byte opcd then
	be	trans_lb2xx	!
	sethi	%hi(optable),%o4!
	or	%o4,%lo(optable),%o4
	sll	%o1,5,%o1	!
	ba	trans_ldecode	!
	add	%o4,%o1,%o4	! &optable[opcd]
trans_lb2xx:
	sethi	%hi(optb2xx),%o4!
	or	%o4,%lo(optb2xx),%o4
	ldub	[%o2+1],%o1	! load gmem[VIAR+1]
	sll	%o1,5,%o1	!
	add	%o4,%o1,%o4	! &optb2xx[opcd]
trans_ldecode:
	andn	%g7,0x80,%g7	! --- M I-fetch end ---
	ld	[%o4+16],%o3	! load optable[opcd].cfunc
	st	%o3,[%o7+836]	! save optable[opcd].cfunc
	ld	[%o4+20],%o3	! load optable[opcd].tfunc
	st	%o3,[%o7+840]	! save optable[opcd].tfunc
	ld	[%o4+24],%o3	! load optable[opcd].type
	st	%o3,[%o7+844]	! save optable[opcd].type
	ld	[%o4+0],%o3	! load optable[opcd].mlen
	st	%o3,[%o7+832]	! save optable[opcd].mlen
	or	%g7,0x80,%g7	! --- M I-fetch start ---
	subcc	%o3,2,%g0	!
	bne	trans_lskip2	!
	lduh	[%o2],%o1	! 2 byte instruction
	ba	trans_lcfunc	!
	sll	%o1,16,%o1	! store in upper half of %o1
trans_lskip2:
	subcc	%o3,4,%g0	!
	bne	trans_lskip4	!
	lduh	[%o2+2],%o3	! 4 byte instruction
	sll	%o1,16,%o1	!
	ba	trans_lcfunc	!
	or	%o1,%o3,%o1	! store in %o1
trans_lskip4:
	lduh	[%o2+4],%o2	! 6 byte instruction
	sll	%o1,16,%o1	!
	or	%o1,%o3,%o1	! store in %o1
	sll	%o2,16,%o2	! store in upper half of %o2

trans_lcfunc:
	andn	%g7,0x80,%g7	! --- M I-fetch end ---
	st	%o1,[%o7+704]	! store minsn (upper)
	st	%o2,[%o7+708]	! store minsn (lower)
	ld	[%o7+836],%o3	! load cfunc
	jmpl	%o3,%o7		! call cfunc()
	andn	%g7,0x40,%g7	! flag=NON EXECUTE

	ld	[%sp+184],%o7	! struct *gcpu_s
	st	%o0,[%o7+848]	! store slen
	ld	[%o7+856],%o1	! load ibufbpa
	ld	[%o1],%o1	! load ibufbp
	subcc	%o1,0,%g0	! if ibufbp == 0 then
	be	trans_lalloc	!   allocate new host_ibuf
	nop			!
	ld	[%o1+4],%o2	! load ibufbp->free
	sub	%o2,32,%o3	! sethi;or;jmp;nop;sethi;or;jmp;nop
	subcc	%o3,%o0,%g0	! if ibufbp->free-32 >= slen then
	bge	trans_ltfunc	!   skip allocating new host_ibuf
	sub	%o2,16,%o2	!
	st	%o2,[%o1+4]	!
	sethi	%hi(32768),%o3	!
	sub	%o3,%o2,%o3	!
	add	%o1,%o3,%o0	! get bufp start address
	sethi	%hi(terminsn),%o1
	or	%o1,%lo(terminsn),%o1
	ld	[%o1],%o2	! terminate ibuf with sethi;or;jmpl;nop;
	ld	[%o1+4],%o3	!
	ld	[%o1+8],%o4	!
	ld	[%o1+12],%o5	!
	st	%o2,[%o0-16]	!
	st	%o3,[%o0-12]	!
	st	%o4,[%o0-8]	!
	st	%o5,[%o0-4]	!
	flush	%o0-16		! (for ULTRA/STINGRAY)
	flush	%o0-4		! (for ULTRA/STINGRAY)

trans_lalloc:
	ld	[%sp+184],%o0	! struct *gcpu_s
	stx	%g1,[%o0+648]	!
	stx	%g2,[%o0+656]	! VIAR
	stx	%g3,[%o0+664]	!
	stx	%g4,[%o0+672]	!
	stx	%g5,[%o0+680]	!
	call	emm_ibuf_alloc,0!
	mov	%g2,%o1		! (FATAL if retval == NULL)
	ld	[%sp+184],%o7	! struct *gcpu_s
	ldx	[%o7+648],%g1	!
	ldx	[%o7+656],%g2	! VIAR
	ldx	[%o7+664],%g3	!
	ldx	[%o7+672],%g4	!
	ldx	[%o7+680],%g5	!
	st	%g0,[%o0]	! NULL -> next_P
	sethi	%hi(32768),%o1	!
	sub	%o1,128,%o1	!
	st	%o1,[%o0+4]	! IBUF_PAGESIZE-8-120->free bytes

trans_ltfunc:
	ld	[%o7+856],%o1	! load ibufbpa
	ld	[%o1],%o1	! load ibufbp
	ld	[%o1+4],%o2	! load ibufbp->free
	sethi	%hi(32768),%o3	!
	sub	%o3,%o2,%o3	!
	add	%o1,%o3,%o0	! get bufp start address
	and	%g2,0xfff,%o4	! VIAR offset in 4KB-page
	sll	%o4,1,%o4	! VIAR << 1
	ld	[%o7+896],%o3	! use interp_ibuf[] as buffer
	add	%o3,%o4,%o3	! (don't use %g5 while translating)
	st	%o0,[%o3]	! store host_imap[VIAR]
	ld	[%o7+832],%o4	! load mlen
	subcc	%o4,2,%g0	!
	be	trans_limap	!
	add	%g0,1,%o1	! if mlen > 2 then store "1"
	st	%o1,[%o3+4]	!
	subcc	%o4,4,%g0	!
	be	trans_limap	!
	add	%g0,2,%o1	! if mlen > 4 then store "2"
	st	%o1,[%o3+8]	!
trans_limap:
	ld	[%o7+704],%o1	! load minsn (upper)
	ld	[%o7+708],%o2	! load minsn (lower)
	ld	[%o7+840],%o3	! load tfunc
	st	%o0,[%o7+852]	! flush address
	jmpl	%o3,%o7		! call tfunc()
	andn	%g7,0x40,%g7	! flag=NON EXECUTE

	ld	[%sp+184],%o7	! struct *gcpu_s
	ld	[%o7+852],%o1	! (for ULTRA/STINGRAY)
	sub	%o0,%o1,%o2	! (for ULTRA/STINGRAY)
	sub	%o2,4,%o2	! (for ULTRA/STINGRAY)
	flush	%o1+%o2		! (for ULTRA/STINGRAY)
trans_ltflush:			! (for ULTRA/STINGRAY)
	subcc	%o2,32,%o2	! (for ULTRA/STINGRAY)
	bg,a	trans_ltflush	! (for ULTRA/STINGRAY)
	flush	%o1+%o2		! (for ULTRA/STINGRAY)
	flush	%o1+0		! (for ULTRA/STINGRAY)
	ld	[%o7+856],%o1	! load ibufbpa
	ld	[%o1],%o1	! load ibufbp
	ld	[%o1+4],%o2	! load ibufbp->free
	ld	[%o7+848],%o3	! load slen
	sub	%o2,%o3,%o2	! decrement ibufbp->free
	st	%o2,[%o1+4]	!

	add	%g0,%g2,%o3	! old VIAR
	ld	[%o7+832],%o4	! load mlen
	add	%g2,%o4,%g2	! new VIAR
	and	%g2,%g3,%g2	! mask address
	xor	%g2,%o3,%o3	!
	andncc	%o3,0xfff,%g0	!
	bnz	trans_lterm3	! if new address is newpage then
	nop			!   terminate loop

	or	%g7,0x80,%g7	! --- M I-fetch start ---
	ldub	[%g4+%g2],%o1	! load gmem[VIAR]
	andn	%g7,0x80,%g7	! --- M I-fetch end ---
	sethi	%hi(optable),%o4!
	or	%o4,%lo(optable),%o4
	sll	%o1,5,%o1	!
	add	%o4,%o1,%o4	! &optable[opcd]
	ld	[%o4+0],%o3	! load optable[opcd].mlen
	sub	%o3,1,%o3	!
	add	%g2,%o3,%o3	! new VIAR-1
	xor	%g2,%o3,%o4	!
	andncc	%o4,0xfff,%g0	!
	bnz	trans_lterm3	! if new insn crosses page boundary
	nop			!   terminate loop

	ld	[%o7+844],%o3	! load type
	subcc	%o3,0,%g0	! if type == 0 then
	be	trans_lterm2	!   continue
	subcc	%o3,1,%g0	! if type == 1 then
	be	trans_lterm4	!   terminate loop
	subcc	%o3,4,%g0	! if type == 2 then
	be	trans_lterm1	!
	subcc	%o3,3,%g0	!
	be	trans_lterm0	!
	ld	[%o7+704],%o4	!   load minsn (upper)
	srl	%o4,20,%o4	!   extract M
	and	%o4,0xf,%o4	!
	subcc	%o4,0xf,%g0	!   if M == 0xf then
	bz	trans_lterm4	!     terminate loop
	nop			!
	ba,a	trans_lterm2	!   else continue

trans_lterm0:			! if type == 3 then
	srl	%o4,16,%o3	!   extract R2
	andcc	%o3,0xf,%o3	!   if R2 == 0 then
	bz	trans_lterm2	!     continue
	srl	%o4,20,%o4	!   extract M
	and	%o4,0xf,%o4	!
	subcc	%o4,0xf,%g0	!   if M == 0xf then
	bz	trans_lterm4	!     terminate loop
	nop			!
	ba,a	trans_lterm2	!   else continue

trans_lterm1:			! if type == 4 then
	ld	[%o7+704],%o4	!   load minsn (upper)
	srl	%o4,16,%o4	!   extract R2
	andcc	%o4,0xf,%g0	!   if R2 != 0 then
	bnz	trans_lterm4	!     terminate loop
	nop			!   else continue

trans_lterm2:
	sll	%g2,1,%o4	! VIAR << 1
	ld	[%g5+%o4],%o3	! load host_imap[VIAR]
	subcc	%o3,0,%g0	! if host_imap[VIAR] == 0 then
	bz	trans_loop	!   continue translation
	nop			!

trans_lterm3:
	ld	[%o7+856],%o1	! load ibufbpa
	ld	[%o1],%o1	! load ibufbp
	ld	[%o1+4],%o2	! load ibufbp->free
	sub	%o2,16,%o2	! decrement ibufbp->free more
	st	%o2,[%o1+4]	!
	sethi	%hi(terminsn),%o1
	or	%o1,%lo(terminsn),%o1
	ld	[%o1],%o2	! terminate ibuf with sethi;or;jmpl;nop;
	ld	[%o1+4],%o3	!
	ld	[%o1+8],%o4	!
	ld	[%o1+12],%o5	!
	st	%o2,[%o0]	!
	st	%o3,[%o0+4]	!
	st	%o4,[%o0+8]	!
	st	%o5,[%o0+12]	!
	flush	%o0		! (for ULTRA/STINGRAY)
	flush	%o0+12		! (for ULTRA/STINGRAY)

trans_lterm4:
	ld	[%o7+896],%o0	! use interp_ibuf[] as buffer
	sub	%g2,2,%o2	! get last translated address
	and	%o2,0xfff,%o3	! VIAR offset in 4KB-page
	sll	%o3,1,%o3	! get interp_ibuf index
	sll	%o2,1,%o2	! get host_imap index
	ldx	[%o7+656],%g2	! get first translated address
	and	%g2,0xfff,%o1	! IAR offset in 4KB-page
	sll	%o1,1,%o1	! IAR << 1
	subcc	%o1,%o3,%g0	! if page-boundary is included
	sethi	%hi(0x00002000),%o4
	or	%o4,%lo(0x00002000),%o4
	bgu,a	trans_limapcp	!
	add	%o3,%o4,%o3	!   add 8KB to last address
trans_limapcp:
	ld	[%o0+%o3],%o4	! load interp_ibuf[VIAR] buffer
	subcc	%o1,%o3,%g0	!
	sub	%o3,4,%o3	!
	st	%o4,[%g5+%o2]	! store host_imap[VIAR]
	bne	trans_limapcp	!
	sub	%o2,4,%o2	!

trans_lunlock:
	stbar			!			(MP PATCH)
	ld	[%o7+856],%o0	! restore ibufbpa	(MP PATCH)
	ba	trans_main	! start execution
	stb	%g0,[%o0+4]	! unlock ibufbpa	(MP PATCH)
!================================

!
! break1 (for BRANCH TAKEN PER)
!
break1:
	andncc	%g7,0xfff,%g0	! if interruption then
	bnz	epilog1		!   return

!
! break0 (step EXEC | intr.)
!
break0:
	andncc	%g7,0xfff,%g0	! if interruption then
	bnz	epilog0		!   return

!
! Interpretive Execution Entry (IM=1,NON EXECUTE)
!
trans_interp:
	and	%g2,%g3,%g2	! mask address
	ld	[%sp+184],%o7	! struct *gcpu_s
	add	%g4,%g2,%o2	! gmem[IAR]
	ld	[%o7+748],%o0	! PA_MSTEP
	add	%o0,1,%o0	! PA_MSTEP
	st	%o0,[%o7+748]	! PA_MSTEP
	or	%g7,0x80,%g7	! --- M I-fetch start ---
	ldub	[%o2],%o1	! load gmem[VIAR]
	subcc	%o1,0xb2,%g0	! if 2byte opcd then
	be	trans_ib2xx	!
	sethi	%hi(optable),%o4!
	or	%o4,%lo(optable),%o4
	sll	%o1,5,%o1	!
	ba	trans_idecode	!
	add	%o4,%o1,%o4	! &optable[opcd]
trans_ib2xx:
	sethi	%hi(optb2xx),%o4!
	or	%o4,%lo(optb2xx),%o4
	ldub	[%o2+1],%o1	! load gmem[VIAR+1]
	sll	%o1,5,%o1	!
	add	%o4,%o1,%o4	! &optb2xx[opcd]
trans_idecode:
	andn	%g7,0x80,%g7	! --- M I-fetch end ---
	ld	[%o4+4],%o0	! load optable[opcd].ifunc
	ld	[%o4+0],%o3	! load optable[opcd].mlen
	or	%g7,0x80,%g7	! --- M I-fetch start ---
	subcc	%o3,2,%g0	!
	bne	trans_iskip2	!
	lduh	[%o2],%o1	! 2 byte instruction
	ba	trans_itfunc	!
	sll	%o1,16,%o1	! store in upper half of %o1
trans_iskip2:
	subcc	%o3,4,%g0	!
	bne	trans_iskip4	!
	lduh	[%o2+2],%o3	! 4 byte instruction
	sll	%o1,16,%o1	!
	ba	trans_itfunc	!
	or	%o1,%o3,%o1	! store in %o1
trans_iskip4:
	lduh	[%o2+4],%o2	! 6 byte instruction
	sll	%o1,16,%o1	!
	or	%o1,%o3,%o1	! store in %o1
	sll	%o2,16,%o2	! store in upper half of %o2

trans_itfunc:
	andn	%g7,0x80,%g7	! --- M I-fetch end ---
	jmpl	%o0,%g0		! jmp to ifunc()
	andn	%g7,0x40,%g7	! flag=NON EXECUTE
!================================

!
! terminal instruction template
!
terminsn:
	sethi	%hi(trans_main),%o7
	jmpl	%o7+%lo(trans_main),%g0
	nop			!
	nop			!
!================================

!
! eplilog2 (for BRANCH TAKEN PER)
!
epilog2:
	sethi	%hi(0x02000000),%o0
	andcc	%g7,%o0,%g0	! if BH=1 then
	bz	ep2nobh		!
	nop			!
	ld	[%sp+184],%o7	! struct *gcpu_s
	ld	[%o7+764],%o1	! get br_hist_cp
	st	%o5,[%o1]	! store OLD PC
	st	%g2,[%o1+4]	! store NEW PC
	add	%o1,8,%o1	!
	ld	[%o7+760],%o2	! get br_hist_top
	add	%o2,1024,%o3	! get br_hist_bot
	subcc	%o1,%o3,%g0	!
	bge,a	ep2bhupd	!
	add	%o2,%g0,%o1	!
ep2bhupd:
	st	%o1,[%o7+764]	! update br_hist_cp
	sethi	%hi(0x07000000),%o0
	and	%g7,%o0,%o1	! if only BH=1 then
	sethi	%hi(0x02000000),%o0
	subcc	%o1,%o0,%g0	!
	be	trans_main	!   return to trans_main
ep2nobh:
	sethi	%hi(0x04000000),%o0
	andcc	%g7,%o0,%g0	! if PER=0 then
	bz	epilog0		!   do nothing (maybe intr.)
	sethi	%hi(0x00800000),%o0
	or	%g7,%o0,%g7	! PER intr.
	ba	epilog0		!
	nop			!

!
! eplilog1 (for BRANCH TAKEN PER)
!
epilog1:
	sethi	%hi(0x02000000),%o0
	andcc	%g7,%o0,%g0	! if BH=1 then
	bz	ep1nobh		!
	nop			!
	ld	[%sp+184],%o7	! struct *gcpu_s
	ld	[%o7+764],%o1	! get br_hist_cp
	st	%o5,[%o1]	! store OLD PC
	st	%g2,[%o1+4]	! store NEW PC
	add	%o1,8,%o1	!
	ld	[%o7+760],%o2	! get br_hist_top
	add	%o2,1024,%o3	! get br_hist_bot
	subcc	%o1,%o3,%g0	!
	bge,a	ep1bhupd	!
	add	%o2,%g0,%o1	!
ep1bhupd:
	st	%o1,[%o7+764]	! update br_hist_cp
	sethi	%hi(0x07000000),%o0
	and	%g7,%o0,%o1	! if only BH=1 then
	sethi	%hi(0x02000000),%o0
	subcc	%o1,%o0,%g0	!
	be	trans_interp	!   return to trans_interp
ep1nobh:
	sethi	%hi(0x04000000),%o0
	andcc	%g7,%o0,%g0	! if PER=0 then
	bz	epilog0		!   do nothing (maybe intr.)
	sethi	%hi(0x00800000),%o0
	or	%g7,%o0,%g7	! PER intr.

!
! eplilog0 (step EXEC | intr.)
!
epilog0:
	add	%g0,0,%o0	!
epilog3:
	and	%g2,%g3,%g2	! mask address (redundant)
	ld	[%sp+184],%o1	! struct *gcpu_s
	stx	%g1,[%o1+648]	! M-CC
	stx	%g2,[%o1+656]	! IAR
	stx	%g3,[%o1+664]	! A-MASK(24/31)
	stx	%g4,[%o1+672]	! OP-BASE
	stx	%g5,[%o1+680]	! IF-BASE
	andcc	%g7,0x20,%g0	! if IM=1 then
	bnz	epilog4		!   skip store M-GRs
	nop			!
	st	%l0,[%o1+  0]	! Mreg0
	st	%l1,[%o1+  4]	! Mreg1
	st	%l2,[%o1+  8]	! Mreg2
	st	%l3,[%o1+ 12]	! Mreg3
	st	%l4,[%o1+ 16]	! Mreg4
	st	%l5,[%o1+ 20]	! Mreg5
	st	%l6,[%o1+ 24]	! Mreg6
	st	%l7,[%o1+ 28]	! Mreg7
	st	%i0,[%o1+ 32]	! Mreg8
	st	%i1,[%o1+ 36]	! Mreg9
	st	%i2,[%o1+ 40]	! Mreg10
	st	%i3,[%o1+ 44]	! Mreg11
	st	%i4,[%o1+ 48]	! Mreg12
	st	%i5,[%o1+ 52]	! Mreg13
	st	%i7,[%o1+ 60]	! Mreg15
	st	%g6,[%o1+ 56]	! Mreg14
epilog4:
	mov	%o0,%i0		!
	ld	[%sp+200],%i7	! return addr.
	ret			!
	restore			!
!================================

!
! templates
! cxx_xxx:
!   %o0: param: none
!	 retval:size of template
!   %o1: M instruction (upper 2 bytes)
!   %o2: work
!   %o3: work
!   %o4: work
!   %o5: work
! txx_xxx:
!   %o0: param: bufp start address
!	 retval:bufp next start address
!   %o1: M instruction (upper 2 bytes)
!   %o2: work
!   %o3: work
!   %o4: work
!   %o5: work
!
	.section ".text"
	.align	4
	.global ci2_OPX2,ti2_OPX2,ii2_OPX2
ci2_OPX2:
	retl				!
	add	%g0,t.OPX20e-t.OPX20s,%o0
ti2_OPX2:
	sethi	%hi(t.OPX20s),%o3	!
	or	%o3,%lo(t.OPX20s),%o3	!
	or	%g0,t.OPX20e-t.OPX20s,%o4
    t.OPX20cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.OPX20cp		!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,t.OPX20e-t.OPX20s,%o0
ii2_OPX2:
t.OPX20s:
		sethi	%hi(0x00010000),%o0
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! operation exception
t.OPX20e:

	.section ".text"
	.align	4
	.global ci4_OPX4,ti4_OPX4,ii4_OPX4
ci4_OPX4:
	retl				!
	add	%g0,t.OPX40e-t.OPX40s,%o0
ti4_OPX4:
	sethi	%hi(t.OPX40s),%o3	!
	or	%o3,%lo(t.OPX40s),%o3	!
	or	%g0,t.OPX40e-t.OPX40s,%o4
    t.OPX40cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.OPX40cp		!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,t.OPX40e-t.OPX40s,%o0
ii4_OPX4:
t.OPX40s:
		sethi	%hi(0x00010000),%o0
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! operation exception
t.OPX40e:

	.section ".text"
	.align	4
	.global ci6_OPX6,ti6_OPX6,ii6_OPX6
ci6_OPX6:
	retl				!
	add	%g0,t.OPX60e-t.OPX60s,%o0
ti6_OPX6:
	sethi	%hi(t.OPX60s),%o3	!
	or	%o3,%lo(t.OPX60s),%o3	!
	or	%g0,t.OPX60e-t.OPX60s,%o4
    t.OPX60cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.OPX60cp		!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,t.OPX60e-t.OPX60s,%o0
ii6_OPX6:
t.OPX60s:
		sethi	%hi(0x00010000),%o0
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! operation exception
t.OPX60e:
!================================

!
! templates
! cxx_xxx:
!   %o0: param: none
!	 retval:size of template
!   %o1: M instruction (upper 2 bytes)
!   %o2: work
!   %o3: work
!   %o4: work
!   %o5: work
! txx_xxx:
!   %o0: param: bufp start address
!	 retval:bufp next start address
!   %o1: M instruction (upper 2 bytes)
!   %o2: work
!   %o3: work
!   %o4: work
!   %o5: work
!
	.section ".text"
	.align	4
	.global ci2_spm,ti2_spm,ii2_spm
ci2_spm:
	retl				!
	add	%g0,t.spm0e-t.spm0s,%o0	!
ti2_spm:
	sethi	%hi(t.spm0s),%o3	!
	or	%o3,%lo(t.spm0s),%o3	!
	or	%g0,t.spm0e-t.spm0s,%o4	!
    t.spm0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.spm0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.spm0o0-t.spm0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+t.spm0t0-t.spm0s]
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	ld	[%o3+t.spm0oy-t.spm0s],%o5
	bnz,a	.+8			! if EX=1 then IAR+=4
	ld	[%o3+t.spm0oz-t.spm0s],%o5
	st	%o5,[%o0+t.spm0tz-t.spm0s]
	retl				!
	add	%o0,t.spm0e-t.spm0s,%o0	!
ii2_spm:
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l0		! %l0
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	add	%g0,2,%l7		!
	bnz,a	.+8			! if EX=1 then IAR+=4
	add	%g0,4,%l7		!
t.spm0s:
    t.spm0t0:	srl	%l0,24,%o0	! extract prog-mask
		and	%o0,0xf,%o1	!
		andn	%g7,0xf,%g7	!
		or	%g7,%o1,%g7	! set prog-mask
		srl	%o0,4,%o0	! extract CC
		and	%o0,3,%g1	! set CC
    t.spm0tz:	add	%g2,%l7,%g2	! ##TEMPLATE:IAR
t.spm0e:
		ba	break0		!
		nop			!
    t.spm0o0:	srl	%l0,24,%o0	! extract prog-mask
    t.spm0oy:	add	%g2,2,%g2	! ##TEMPLATE:IAR
    t.spm0oz:	add	%g2,4,%g2	! ##TEMPLATE:IAR

	.section ".text"
	.align	4
	.global ci2_balr,ti2_balr,ii2_balr
ci2_balr:
	srl	%o1,16,%o3		! switch (R2)
	andcc	%o3,0xf,%g0		!
	bnz	c.balr1c		!
	nop				!
    c.balr0c:				!
	retl				! case 0:
	add	%g0,t.balr0e-t.balr0s,%o0
    c.balr1c:				!
	retl				! case not 0:
	add	%g0,t.balr1e-t.balr1s,%o0
ti2_balr:
	srl	%o1,16,%o3		! switch (R2)
	andcc	%o3,0xf,%g0		!
	bnz	t.balr1t		!
	nop				!
    t.balr0t:				!
	sethi	%hi(t.balr0s),%o3	!
	or	%o3,%lo(t.balr0s),%o3	!
	or	%g0,t.balr0e-t.balr0s,%o4
    t.balr0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.balr0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.balr0o0-t.balr0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,25,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+t.balr0t0-t.balr0s]
	ld	[%o3+t.balr0o1-t.balr0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,25,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+t.balr0t1-t.balr0s]
	andcc	%g7,0x40,%g0		! if EX=0 then ILC=2
	ld	[%o3+t.balr0ow-t.balr0s],%o5
	bnz,a	.+8			! if EX=1 then ILC=4
	ld	[%o3+t.balr0ox-t.balr0s],%o5
	st	%o5,[%o0+t.balr0tx-t.balr0s]
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	ld	[%o3+t.balr0oy-t.balr0s],%o5
	bnz,a	.+8			! if EX=1 then IAR+=4
	ld	[%o3+t.balr0oz-t.balr0s],%o5
	st	%o5,[%o0+t.balr0tz-t.balr0s]
	retl				!
	add	%o0,t.balr0e-t.balr0s,%o0
    t.balr1t:				!
	sethi	%hi(t.balr1s),%o3	!
	or	%o3,%lo(t.balr1s),%o3	!
	or	%g0,t.balr1e-t.balr1s,%o4
    t.balr1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.balr1cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.balr1o0-t.balr1s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	st	%o5,[%o0+t.balr1t0-t.balr1s]
	ld	[%o3+t.balr1o1-t.balr1s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,25,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+t.balr1t1-t.balr1s]
	ld	[%o3+t.balr1o2-t.balr1s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,25,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+t.balr1t2-t.balr1s]
	andcc	%g7,0x40,%g0		! if EX=0 then ILC=2
	ld	[%o3+t.balr1ow-t.balr1s],%o5
	bnz,a	.+8			! if EX=1 then ILC=4
	ld	[%o3+t.balr1ox-t.balr1s],%o5
	st	%o5,[%o0+t.balr1tx-t.balr1s]
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	ld	[%o3+t.balr1oy-t.balr1s],%o5
	bnz,a	.+8			! if EX=1 then IAR+=4
	ld	[%o3+t.balr1oz-t.balr1s],%o5
	st	%o5,[%o0+t.balr1tz-t.balr1s]
	retl				!
	add	%o0,t.balr1e-t.balr1s,%o0
t.balr0s:
    t.balr0tz:	add	%g2,%l7,%g2	! ##TEMPLATE:IAR
		andcc	%g7,0x10,%g0	! if 31bit address then
		sethi	%hi(0x80000000),%o1
		bnz,a	t.balr0e	!
    t.balr0t0:	or	%o1,%g2,%l0	! ##TEMPLATE:%l0
		sethi	%hi(0xff000000),%o1
		andn	%g2,%o1,%o2	! if 24bit address then
    t.balr0tx:	or	%g1,%l6,%o1	! ##TEMPLATE:ILC|CC
		sll	%o1,28,%o1	!
		or	%o1,%o2,%o2	!
		and	%g7,0xf,%o1	!   Prog-Mask
		sll	%o1,24,%o1	!
    t.balr0t1:	or	%o1,%o2,%l0	! ##TEMPLATE:%l0
t.balr0e:
		ba	break0		!
		st	%l0,[%o7+%i0]	! R1
    t.balr0o0:	or	%o1,%g2,%l0	! ##TEMPLATE:%l0
    t.balr0o1:	or	%o1,%o2,%l0	! ##TEMPLATE:%l0
    t.balr0ow:	or	%g1,4,%o1	! ##TEMPLATE:ILC|CC
    t.balr0ox:	or	%g1,8,%o1	! ##TEMPLATE:ILC|CC
    t.balr0oy:	add	%g2,2,%g2	! ##TEMPLATE:IAR
    t.balr0oz:	add	%g2,4,%g2	! ##TEMPLATE:IAR
t.balr1s:
		add	%g2,%g0,%o5	! save OPC
    t.balr1tz:	add	%g2,2,%g2	! ##TEMPLATE:IAR
    t.balr1t0:	add	%g0,%l0,%o0	! ##TEMPLATE:%l0
		andcc	%g7,0x10,%g0	! if 31bit address then
		sethi	%hi(0x80000000),%o1
		bnz,a	t.balr100	!
    t.balr1t1:	or	%o1,%g2,%l0	! ##TEMPLATE:%l0
		sethi	%hi(0xff000000),%o1
		andn	%g2,%o1,%o2	! if 24bit address then
    t.balr1tx:	or	%g1,4,%o1	! ##TEMPLATE:ILC|CC
		sll	%o1,28,%o1	!
		or	%o1,%o2,%o2	!
		and	%g7,0xf,%o1	!   Prog-Mask
		sll	%o1,24,%o1	!
    t.balr1t2:	or	%o1,%o2,%l0	! ##TEMPLATE:%l0
    t.balr100:	sethi	%hi(break2),%o7	! BRANCH TAKEN
		jmpl	%o7+%lo(break2),%g0
		add	%g0,%o0,%g2	!
t.balr1e:
    t.balr1o0:	add	%g0,%l0,%o0	! ##TEMPLATE:%l0
    t.balr1o1:	or	%o1,%g2,%l0	! ##TEMPLATE:%l0
    t.balr1o2:	or	%o1,%o2,%l0	! ##TEMPLATE:%l0
    t.balr1ow:	or	%g1,4,%o1	! ##TEMPLATE:ILC|CC
    t.balr1ox:	or	%g1,8,%o1	! ##TEMPLATE:ILC|CC
    t.balr1oy:	add	%g2,2,%g2	! ##TEMPLATE:IAR
    t.balr1oz:	add	%g2,4,%g2	! ##TEMPLATE:IAR
ii2_balr:
	srl	%o1,16,%o3		! switch (R2)
	andcc	%o3,0xf,%g0		!
	bnz	i.balr1t		!
	nop				!
    i.balr0t:				!
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%i0		! save as %i0
	andcc	%g7,0x40,%g0		! if EX=0 then ILC=2
	add	%g0,4,%l6		!
	bnz,a	.+8			! if EX=1 then ILC=4
	add	%g0,8,%l6		!
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	add	%g0,2,%l7		!
	bnz,a	.+8			! if EX=1 then IAR+=4
	add	%g0,4,%l7		!
	ba	t.balr0s		!
	nop				!
    i.balr1t:				!
	srl	%o1,16,%o4		! R2
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l2		! %l2
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%i0		! save as %i0
	andcc	%g7,0x40,%g0		! if EX=0 then ILC=2
	add	%g0,4,%l6		!
	bnz,a	.+8			! if EX=1 then ILC=4
	add	%g0,8,%l6		!
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	add	%g0,2,%l7		!
	bnz,a	.+8			! if EX=1 then IAR+=4
	add	%g0,4,%l7		!
i.balr1s:
		add	%g2,%g0,%o5	! save OPC
    i.balr1tz:	add	%g2,%l7,%g2	! ##TEMPLATE:IAR
    i.balr1t0:	add	%g0,%l2,%o0	! ##TEMPLATE:%l0
		andcc	%g7,0x10,%g0	! if 31bit address then
		sethi	%hi(0x80000000),%o1
		bnz,a	i.balr100	!
    i.balr1t1:	or	%o1,%g2,%l0	! ##TEMPLATE:%l0
		sethi	%hi(0xff000000),%o1
		andn	%g2,%o1,%o2	! if 24bit address then
    i.balr1tx:	or	%g1,%l6,%o1	! ##TEMPLATE:ILC|CC
		sll	%o1,28,%o1	!
		or	%o1,%o2,%o2	!
		and	%g7,0xf,%o1	!   Prog-Mask
		sll	%o1,24,%o1	!
    i.balr1t2:	or	%o1,%o2,%l0	! ##TEMPLATE:%l0
    i.balr100:	st	%l0,[%o7+%i0]	! R1
		ba	break1		! BRANCH TAKEN
		add	%g0,%o0,%g2	!
i.balr1e:

	.section ".text"
	.align	4
	.global ci2_bctr,ti2_bctr,ii2_bctr
ci2_bctr:
	srl	%o1,16,%o3		! switch (R2)
	andcc	%o3,0xf,%g0		!
	bnz	c.bctr1c		!
	nop				!
    c.bctr0c:				!
	retl				! case 0:
	add	%g0,t.bctr0e-t.bctr0s,%o0
    c.bctr1c:				!
	retl				! case not 0:
	add	%g0,t.bctr1e-t.bctr1s,%o0
ti2_bctr:
	srl	%o1,16,%o3		! switch (R2)
	andcc	%o3,0xf,%g0		!
	bnz	t.bctr1t		!
	nop				!
    t.bctr0t:				!
	sethi	%hi(t.bctr0s),%o3	!
	or	%o3,%lo(t.bctr0s),%o3	!
	or	%g0,t.bctr0e-t.bctr0s,%o4
    t.bctr0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.bctr0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.bctr0o0-t.bctr0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	sll	%o4,11,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+t.bctr0t0-t.bctr0s]
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	ld	[%o3+t.bctr0oy-t.bctr0s],%o5
	bnz,a	.+8			! if EX=1 then IAR+=4
	ld	[%o3+t.bctr0oz-t.bctr0s],%o5
	st	%o5,[%o0+t.bctr0tz-t.bctr0s]
	retl				!
	add	%o0,t.bctr0e-t.bctr0s,%o0
    t.bctr1t:				!
	sethi	%hi(t.bctr1s),%o3	!
	or	%o3,%lo(t.bctr1s),%o3	!
	or	%g0,t.bctr1e-t.bctr1s,%o4
    t.bctr1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.bctr1cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.bctr1o0-t.bctr1s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	st	%o5,[%o0+t.bctr1t0-t.bctr1s]
	ld	[%o3+t.bctr1o1-t.bctr1s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	sll	%o4,11,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+t.bctr1t1-t.bctr1s]
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	ld	[%o3+t.bctr1oy-t.bctr1s],%o5
	bnz,a	.+8			! if EX=1 then IAR+=4
	ld	[%o3+t.bctr1oz-t.bctr1s],%o5
	st	%o5,[%o0+t.bctr1tz-t.bctr1s]
	retl				!
	add	%o0,t.bctr1e-t.bctr1s,%o0
t.bctr0s:
    t.bctr0t0:	sub	%l0,1,%l0	! ##TEMPLATE:%l0,%l0
    t.bctr0tz:	add	%g2,%l7,%g2	! ##TEMPLATE:IAR
t.bctr0e:
		ba	break0		!
		st	%l0,[%o7+%i0]	! R1
    t.bctr0o0:	sub	%l0,1,%l0	! ##TEMPLATE:%l0,%l0
    t.bctr0oy:	add	%g2,2,%g2	! ##TEMPLATE:IAR
    t.bctr0oz:	add	%g2,4,%g2	! ##TEMPLATE:IAR
t.bctr1s:
    t.bctr1t0:	add	%g0,%l0,%o0	! ##TEMPLATE:%l0
    t.bctr1t1:	subcc	%l0,1,%l0	! ##TEMPLATE:%l0,%l0
		bz,a	t.bctr1e	! if %l0 != 0 then taken
    t.bctr1tz:	add	%g2,2,%g2	! ##TEMPLATE:IAR
		add	%g2,%g0,%o5	! save OPC
		sethi	%hi(break2),%o7	! BRANCH TAKEN
		jmpl	%o7+%lo(break2),%g0
		add	%g0,%o0,%g2	!
t.bctr1e:
    t.bctr1o0:	add	%g0,%l0,%o0	! ##TEMPLATE:%l0
    t.bctr1o1:	subcc	%l0,1,%l0	! ##TEMPLATE:%l0,%l0
    t.bctr1oy:	add	%g2,2,%g2	! ##TEMPLATE:IAR
    t.bctr1oz:	add	%g2,4,%g2	! ##TEMPLATE:IAR
ii2_bctr:
	srl	%o1,16,%o3		! switch (R2)
	andcc	%o3,0xf,%g0		!
	bnz	i.bctr1t		!
	nop				!
    i.bctr0t:				!
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%i0		! save as %i0
	ld	[%o7+%i0],%l0		! %l0
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	add	%g0,2,%l7		!
	bnz,a	.+8			! if EX=1 then IAR+=4
	add	%g0,4,%l7		!
	ba	t.bctr0s		!
	nop				!
    i.bctr1t:				!
	srl	%o1,16,%o4		! R2
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l2		! %l2
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%i0		! save as %i0
	ld	[%o7+%i0],%l0		! %l0
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	add	%g0,2,%l7		!
	bnz,a	.+8			! if EX=1 then IAR+=4
	add	%g0,4,%l7		!
i.bctr1s:
    i.bctr1t0:	add	%g0,%l2,%o0	! ##TEMPLATE:%l0
    i.bctr1t1:	subcc	%l0,1,%l0	! ##TEMPLATE:%l0,%l0
		st	%l0,[%o7+%i0]	! R1
		bz,a	break0		! if %l0 != 0 then taken
    i.bctr1tz:	add	%g2,%l7,%g2	! ##TEMPLATE:IAR
		add	%g2,%g0,%o5	! save OPC
		ba	break1		! BRANCH TAKEN
		add	%g0,%o0,%g2	!
i.bctr1e:

	.section ".text"
	.align	4
	.global ci2_bcr,ti2_bcr,ii2_bcr
ci2_bcr:
	srl	%o1,16,%o3		! switch (R2)
	andcc	%o3,0xf,%g0		!
	bz	c.bcr0c			!
	srl	%o1,20,%o3		! switch (M1)
	andcc	%o3,0xf,%o3		!
	bz	c.bcr0c			!
	subcc	%o3,0xf,%g0		!
	bne	c.bcr2c			!
	nop				!
    c.bcr3c:				!
	retl				! case 15:
	add	%g0,t.bcr3e-t.bcr3s,%o0	!
    c.bcr0c:				!
	retl				! case 0:
	add	%g0,t.bcr0e-t.bcr0s,%o0	!
    c.bcr2c:				!
	retl				! case 1-14:
	add	%g0,t.bcr2e-t.bcr2s,%o0	!
ti2_bcr:
	srl	%o1,16,%o3		! switch (R2)
	andcc	%o3,0xf,%g0		!
	bz	t.bcr0t			!
	srl	%o1,20,%o3		! switch (M1)
	andcc	%o3,0xf,%o3		!
	bz	t.bcr0t			!
	subcc	%o3,0xf,%g0		!
	bne	t.bcr2t			!
	nop				!
    t.bcr3t:
	sethi	%hi(t.bcr3s),%o3	!
	or	%o3,%lo(t.bcr3s),%o3	!
	or	%g0,t.bcr3e-t.bcr3s,%o4	!
    t.bcr3cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.bcr3cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.bcr3o0-t.bcr3s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	st	%o5,[%o0+t.bcr3t0-t.bcr3s]
	retl				!
	add	%o0,t.bcr3e-t.bcr3s,%o0	!
    t.bcr0t:				!
	sethi	%hi(t.bcr0s),%o3	!
	or	%o3,%lo(t.bcr0s),%o3	!
	or	%g0,t.bcr0e-t.bcr0s,%o4	!
    t.bcr0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.bcr0cp		!
	st	%o5,[%o0+%o4]		!
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	ld	[%o3+t.bcr0oy-t.bcr0s],%o5
	bnz,a	.+8			! if EX=1 then IAR+=4
	ld	[%o3+t.bcr0oz-t.bcr0s],%o5
	st	%o5,[%o0+t.bcr0tz-t.bcr0s]
	retl				!
	add	%o0,t.bcr0e-t.bcr0s,%o0	!
    t.bcr2t:				!
	sethi	%hi(t.bcr2s),%o3	!
	or	%o3,%lo(t.bcr2s),%o3	!
	or	%g0,t.bcr2e-t.bcr2s,%o4	!
    t.bcr2cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.bcr2cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.bcr2o0-t.bcr2s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! M1
	sll	%o4,8,%o4		! |
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.bcr2t0-t.bcr2s]
	ld	[%o3+t.bcr2o1-t.bcr2s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	st	%o5,[%o0+t.bcr2t1-t.bcr2s]
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	ld	[%o3+t.bcr2oy-t.bcr2s],%o5
	bnz,a	.+8			! if EX=1 then IAR+=4
	ld	[%o3+t.bcr2oz-t.bcr2s],%o5
	st	%o5,[%o0+t.bcr2tz-t.bcr2s]
	retl				!
	add	%o0,t.bcr2e-t.bcr2s,%o0	!
t.bcr3s:
		add	%g2,%g0,%o5	! save OPC
		sethi	%hi(break2),%o7	! BRANCH TAKEN
		jmpl	%o7+%lo(break2),%g0
    t.bcr3t0:	add	%g0,%l0,%g2	! ##TEMPLATE:%l0
t.bcr3e:
    t.bcr3o0:	add	%g0,%l0,%g2	! ##TEMPLATE:%l0
t.bcr0s:
    t.bcr0tz:	add	%g2,2,%g2	! ##TEMPLATE:IAR
t.bcr0e:
    t.bcr0oy:	add	%g2,2,%g2	! ##TEMPLATE:IAR
    t.bcr0oz:	add	%g2,4,%g2	! ##TEMPLATE:IAR
t.bcr2s:
		srl	%g7,%g1,%o1	! const.0b0001000XXXXXXXX >> %o1
    t.bcr2t0:	andcc	%o1,0,%g0	! ##TEMPLATE:imm0
		bz,a	t.bcr2e		! if CC is true then taken
    t.bcr2tz:	add	%g2,2,%g2	! ##TEMPLATE:IAR
		add	%g2,%g0,%o5	! save OPC
		sethi	%hi(break2),%o7	! BRANCH TAKEN
		jmpl	%o7+%lo(break2),%g0
    t.bcr2t1:	add	%g0,%l0,%g2	! ##TEMPLATE:%l0
t.bcr2e:
    t.bcr2o0:	andcc	%o1,0,%g0	! ##TEMPLATE:imm0
    t.bcr2o1:	add	%g0,%l0,%g2	! ##TEMPLATE:%l0
    t.bcr2oy:	add	%g2,2,%g2	! ##TEMPLATE:IAR
    t.bcr2oz:	add	%g2,4,%g2	! ##TEMPLATE:IAR
ii2_bcr:
	srl	%o1,16,%o3		! switch (R2)
	andcc	%o3,0xf,%g0		!
	bz	i.bcr0t			!
	srl	%o1,20,%o3		! switch (M1)
	andcc	%o3,0xf,%o3		!
	bz	i.bcr0t			!
	subcc	%o3,0xf,%g0		!
	bne	i.bcr2t			!
	nop				!
    i.bcr3t:
	srl	%o1,16,%o4		! R2
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l2		! %l2
	add	%g2,%g0,%o5		! save OPC
	ba	break1			!
	add	%g0,%l2,%g2		! ##TEMPLATE:%l0
    i.bcr0t:				!
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	add	%g0,2,%l7		!
	bnz,a	.+8			! if EX=1 then IAR+=4
	add	%g0,4,%l7		!
	ba	break0			!
	add	%g2,%l7,%g2		! ##TEMPLATE:IAR
    i.bcr2t:				!
	srl	%o1,20,%o4		! M1
	and	%o4,0xf,%o4		! |
	sll	%o4,8,%l0		! %l0
	srl	%o1,16,%o4		! R2
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l2		! %l2
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	add	%g0,2,%l7		!
	bnz,a	.+8			! if EX=1 then IAR+=4
	add	%g0,4,%l7		!
i.bcr2s:
		srl	%g7,%g1,%o1	! consi.0b0001000XXXXXXXX >> %o1
    i.bcr2t0:	andcc	%o1,%l0,%g0	! ##TEMPLATE:imm0
		bz,a	break0		! if CC is true then taken
    i.bcr2tz:	add	%g2,%l7,%g2	! ##TEMPLATE:IAR
		add	%g2,%g0,%o5	! save OPC
		ba	break1		! BRANCH TAKEN
    i.bcr2t1:	add	%g0,%l2,%g2	! ##TEMPLATE:%l0
i.bcr2e:

	.section ".text"
	.align	4
	.global cc2_ssk,tc2_ssk,ic2_ssk
cc2_ssk:
	retl				!
	add	%g0,t.ssk0e-t.ssk0s,%o0	!
tc2_ssk:
	sethi	%hi(t.ssk0s),%o3	!
	or	%o3,%lo(t.ssk0s),%o3	!
	or	%g0,t.ssk0e-t.ssk0s,%o4	!
    t.ssk0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.ssk0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.ssk0o0-t.ssk0s],%o5
	srl	%o1,10,%o4		!
	or	%o5,%o4,%o5		! simm22
	st	%o5,[%o0+t.ssk0t0-t.ssk0s]
	ld	[%o3+t.ssk0o1-t.ssk0s],%o5
	and	%o1,0xfff,%o4		!
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.ssk0t1-t.ssk0s]
	retl				!
	add	%o0,t.ssk0e-t.ssk0s,%o0	!
ic2_ssk:
t.ssk0s:
		ld	[%sp+184],%o7	! struct *gcpu_s
    t.ssk0t0:	sethi	0,%o0		! ##TEMPLATE:imm
    t.ssk0t1:	or	%o1,0,%o0	! ##TEMPLATE:imm
		st	%o0,[%o7+704]	! store minsn (upper)
		st	%g0,[%o7+708]	! store minsn (lower)
		sethi	%hi(0x80000000),%o0
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! Special Instruction (FC=2)
t.ssk0e:
    t.ssk0o0:	sethi	0,%o0		! ##TEMPLATE:imm
    t.ssk0o1:	or	%o0,0,%o0	! ##TEMPLATE:imm

	.section ".text"
	.align	4
	.global cc2_isk,tc2_isk,ic2_isk
cc2_isk:
	retl				!
	add	%g0,t.isk0e-t.isk0s,%o0	!
tc2_isk:
	sethi	%hi(t.isk0s),%o3	!
	or	%o3,%lo(t.isk0s),%o3	!
	or	%g0,t.isk0e-t.isk0s,%o4	!
    t.isk0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.isk0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.isk0o0-t.isk0s],%o5
	srl	%o1,10,%o4		!
	or	%o5,%o4,%o5		! simm22
	st	%o5,[%o0+t.isk0t0-t.isk0s]
	ld	[%o3+t.isk0o1-t.isk0s],%o5
	and	%o1,0xfff,%o4		!
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.isk0t1-t.isk0s]
	retl				!
	add	%o0,t.isk0e-t.isk0s,%o0	!
ic2_isk:
t.isk0s:
		ld	[%sp+184],%o7	! struct *gcpu_s
    t.isk0t0:	sethi	0,%o0		! ##TEMPLATE:imm
    t.isk0t1:	or	%o1,0,%o0	! ##TEMPLATE:imm
		st	%o0,[%o7+704]	! store minsn (upper)
		st	%g0,[%o7+708]	! store minsn (lower)
		sethi	%hi(0x80000000),%o0
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! Special Instruction (FC=2)
t.isk0e:
    t.isk0o0:	sethi	0,%o0		! ##TEMPLATE:imm
    t.isk0o1:	or	%o0,0,%o0	! ##TEMPLATE:imm

	.section ".text"
	.align	4
	.global ci2_svc,ti2_svc,ii2_svc
ci2_svc:
	retl				!
	add	%g0,t.svc0e-t.svc0s,%o0	!
ti2_svc:
	sethi	%hi(t.svc0s),%o3	!
	or	%o3,%lo(t.svc0s),%o3	!
	or	%g0,t.svc0e-t.svc0s,%o4	!
    t.svc0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.svc0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.svc0o0-t.svc0s],%o5
	srl	%o1,10,%o4		!
	or	%o5,%o4,%o5		! simm22
	st	%o5,[%o0+t.svc0t0-t.svc0s]
	ld	[%o3+t.svc0o1-t.svc0s],%o5
	and	%o1,0xfff,%o4		!
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.svc0t1-t.svc0s]
	retl				!
	add	%o0,t.svc0e-t.svc0s,%o0	!
ii2_svc:
t.svc0s:
		ld	[%sp+184],%o7	! struct *gcpu_s
    t.svc0t0:	sethi	0,%o0		! ##TEMPLATE:imm
    t.svc0t1:	or	%o1,0,%o0	! ##TEMPLATE:imm
		st	%o0,[%o7+704]	! store minsn (upper)
		st	%g0,[%o7+708]	! store minsn (lower)
		sethi	%hi(0x80000000),%o0
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! Special Instruction (FC=2)
t.svc0e:
    t.svc0o0:	sethi	0,%o0		! ##TEMPLATE:imm
    t.svc0o1:	or	%o0,0,%o0	! ##TEMPLATE:imm

	.section ".text"
	.align	4
	.global ci2_bsm,ti2_bsm,ii2_bsm
ci2_bsm:
	srl	%o1,16,%o3		! switch (R2)
	andcc	%o3,0xf,%g0		!
	bnz	c.bsm1c			!
	nop				!
    c.bsm0c:				!
	retl				! case 0:
	add	%g0,t.bsm0e-t.bsm0s,%o0	!
    c.bsm1c:				!
	retl				! case not 0:
	add	%g0,t.bsm1e-t.bsm1s,%o0	!
ti2_bsm:
	srl	%o1,16,%o3		! switch (R2)
	andcc	%o3,0xf,%g0		!
	bnz	t.bsm1t			!
	nop				!
    t.bsm0t:				!
	sethi	%hi(t.bsm0s),%o3	!
	or	%o3,%lo(t.bsm0s),%o3	!
	or	%g0,t.bsm0e-t.bsm0s,%o4	!
    t.bsm0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.bsm0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.bsm0o0-t.bsm0s],%o5
	srl	%o1,20,%o4		!
	andcc	%o4,0xf,%o4		! R1
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+t.bsm0t0-t.bsm0s]
	ld	[%o3+t.bsm0o1-t.bsm0s],%o5
	srl	%o1,20,%o4		!
	andcc	%o4,0xf,%o4		! R1
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,25,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+t.bsm0t1-t.bsm0s]
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	ld	[%o3+t.bsm0oy-t.bsm0s],%o5
	bnz,a	.+8			! if EX=1 then IAR+=4
	ld	[%o3+t.bsm0oz-t.bsm0s],%o5
	st	%o5,[%o0+t.bsm0tz-t.bsm0s]
	retl				!
	add	%o0,t.bsm0e-t.bsm0s,%o0	!
    t.bsm1t:				!
	sethi	%hi(t.bsm1s),%o3	!
	or	%o3,%lo(t.bsm1s),%o3	!
	or	%g0,t.bsm1e-t.bsm1s,%o4	!
    t.bsm1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.bsm1cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.bsm1o0-t.bsm1s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	st	%o5,[%o0+t.bsm1t0-t.bsm1s]
	ld	[%o3+t.bsm1o1-t.bsm1s],%o5
	srl	%o1,20,%o4		!
	andcc	%o4,0xf,%o4		! R1
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+t.bsm1t1-t.bsm1s]
	ld	[%o3+t.bsm1o2-t.bsm1s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	st	%o5,[%o0+t.bsm1t2-t.bsm1s]
	ld	[%o3+t.bsm1o3-t.bsm1s],%o5
	srl	%o1,20,%o4		!
	andcc	%o4,0xf,%o4		! R1
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,25,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+t.bsm1t3-t.bsm1s]
	retl				!
	add	%o0,t.bsm1e-t.bsm1s,%o0	!
t.bsm0s:
		and	%g7,0x10,%o1	! extract AM-bit
		sll	%o1,27,%o1	!
		sethi	%hi(0x80000000),%o2
    t.bsm0t0:	andn	%l0,%o2,%o3	! ##TEMPLATE:%l0
    t.bsm0t1:	or	%o1,%o3,%l0	! ##TEMPLATE:%l0
    t.bsm0tz:	add	%g2,%l7,%g2	! ##TEMPLATE:IAR
t.bsm0e:
		subcc	%i0,0,%g0	! if R1=0
		bz	break0		!   don't save R1
		nop			!
		ba	break0		!
		st	%l0,[%o7+%i0]	! R1
    t.bsm0o0:	andn	%l0,%o2,%o3	! ##TEMPLATE:%l0
    t.bsm0o1:	or	%o1,%o3,%l0	! ##TEMPLATE:%l0
    t.bsm0oy:	add	%g2,2,%g2	! ##TEMPLATE:IAR
    t.bsm0oz:	add	%g2,4,%g2	! ##TEMPLATE:IAR
t.bsm1s:
		and	%g7,0x10,%o1	! extract AM-bit
		sll	%o1,27,%o1	!
		sethi	%hi(0x80000000),%o2
    t.bsm1t0:	andcc	%o2,%l0,%g0	! ##TEMPLATE:%l0
		bnz	t.bsm100	! if AM == 0 then
		sethi	%hi(0x00ffffff),%g3
		or	%g3,%lo(0x00ffffff),%g3
		ba	t.bsm1t1	!
		andn	%g7,0x10,%g7	!   reset AM-bit
    t.bsm100:	sethi	%hi(0x1fffffff),%g3
		or	%g3,%lo(0x1fffffff),%g3
		or	%g7,0x10,%g7	! else set AM-bit
    t.bsm1t1:	andn	%l0,%o2,%o3	! ##TEMPLATE:%l0
		add	%g2,%g0,%o5	! save OPC
    t.bsm1t2:	add	%g0,%l0,%g2	! ##TEMPLATE:%l0
		sethi	%hi(break2),%o7	! BRANCH TAKEN
		jmpl	%o7+%lo(break2),%g0
    t.bsm1t3:	or	%o1,%o3,%l0	! ##TEMPLATE:%l0
t.bsm1e:
    t.bsm1o0:	andcc	%o2,%l0,%g0	! ##TEMPLATE:%l0
    t.bsm1o1:	andn	%l0,%o2,%o3	! ##TEMPLATE:%l0
    t.bsm1o2:	add	%g0,%l0,%g2	! ##TEMPLATE:%l0
    t.bsm1o3:	or	%o1,%o3,%l0	! ##TEMPLATE:%l0
ii2_bsm:
	srl	%o1,16,%o3		! switch (R2)
	andcc	%o3,0xf,%g0		!
	bnz	i.bsm1t			!
	nop				!
    i.bsm0t:				!
	srl	%o1,20,%o4		! R1
	andcc	%o4,0xf,%o4		! |
	sll	%o4,2,%i0		! save as %i0
	bz,a	.+12			! |
	add	%g0,%g0,%l0		! |
	ld	[%o7+%i0],%l0		! %l0
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	add	%g0,2,%l7		!
	bnz,a	.+8			! if EX=1 then IAR+=4
	add	%g0,4,%l7		!
	ba	t.bsm0s			!
	nop				!
    i.bsm1t:				!
	srl	%o1,16,%o4		! R2
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l2		! %l2
	srl	%o1,20,%o4		! R1
	andcc	%o4,0xf,%o4		! |
	sll	%o4,2,%i0		! save as %i0
	bz,a	.+12			! |
	add	%g0,%g0,%l0		! |
	ld	[%o7+%i0],%l0		! %l0
i.bsm1s:
		and	%g7,0x10,%o1	! extract AM-bit
		sll	%o1,27,%o1	!
		sethi	%hi(0x80000000),%o2
    i.bsm1t0:	andcc	%o2,%l2,%g0	! ##TEMPLATE:%l0
		bnz	i.bsm100	! if AM == 0 then
		sethi	%hi(0x00ffffff),%g3
		or	%g3,%lo(0x00ffffff),%g3
		ba	i.bsm1t1	!
		andn	%g7,0x10,%g7	!   reset AM-bit
    i.bsm100:	sethi	%hi(0x1fffffff),%g3
		or	%g3,%lo(0x1fffffff),%g3
		or	%g7,0x10,%g7	! else set AM-bit
    i.bsm1t1:	andn	%l0,%o2,%o3	! ##TEMPLATE:%l0
		add	%g2,%g0,%o5	! save OPC
    i.bsm1t2:	add	%g0,%l2,%g2	! ##TEMPLATE:%l0
    i.bsm1t3:	or	%o1,%o3,%l0	! ##TEMPLATE:%l0
		subcc	%i0,0,%g0	! if R1=0
		bz	break1		! BRANCH TAKEN
		nop			!   don't save R1
		ba	break1		! BRANCH TAKEN
		st	%l0,[%o7+%i0]	! R1
i.bsm1e:

	.section ".text"
	.align	4
	.global ci2_bassm1,ti2_bassm,ii2_bassm
ci2_bassm:
	srl	%o1,16,%o3		! switch (R2)
	andcc	%o3,0xf,%g0		!
	bnz	c.bassm1c		!
	nop				!
    c.bassm0c:				!
	retl				! case 0:
	add	%g0,t.bassm0e-t.bassm0s,%o0
    c.bassm1c:				!
	retl				! case not 0:
	add	%g0,t.bassm1e-t.bassm1s,%o0
ti2_bassm:
	srl	%o1,16,%o3		! switch (R2)
	andcc	%o3,0xf,%g0		!
	bnz	t.bassm1t		!
	nop				!
    t.bassm0t:				!
	sethi	%hi(t.bassm0s),%o3	!
	or	%o3,%lo(t.bassm0s),%o3	!
	or	%g0,t.bassm0e-t.bassm0s,%o4
    t.bassm0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.bassm0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.bassm0o0-t.bassm0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,25,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+t.bassm0t0-t.bassm0s]
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	ld	[%o3+t.bassm0oy-t.bassm0s],%o5
	bnz,a	.+8			! if EX=1 then IAR+=4
	ld	[%o3+t.bassm0oz-t.bassm0s],%o5
	st	%o5,[%o0+t.bassm0tz-t.bassm0s]
	retl				!
	add	%o0,t.bassm0e-t.bassm0s,%o0
    t.bassm1t:				!
	sethi	%hi(t.bassm1s),%o3	!
	or	%o3,%lo(t.bassm1s),%o3	!
	or	%g0,t.bassm1e-t.bassm1s,%o4
    t.bassm1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.bassm1cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.bassm1o0-t.bassm1s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	st	%o5,[%o0+t.bassm1t0-t.bassm1s]
	ld	[%o3+t.bassm1o2-t.bassm1s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	st	%o5,[%o0+t.bassm1t2-t.bassm1s]
	ld	[%o3+t.bassm1o3-t.bassm1s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,25,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+t.bassm1t3-t.bassm1s]
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	ld	[%o3+t.bassm1oy-t.bassm1s],%o5
	bnz,a	.+8			! if EX=1 then IAR+=4
	ld	[%o3+t.bassm1oz-t.bassm1s],%o5
	st	%o5,[%o0+t.bassm1tz-t.bassm1s]
	retl				!
	add	%o0,t.bassm1e-t.bassm1s,%o0
t.bassm0s:
    t.bassm0tz:	add	%g2,%l7,%g2	! ##TEMPLATE:IAR
		and	%g7,0x10,%o1	! extract AM-bit
		sll	%o1,27,%o1	!
		sethi	%hi(0x80000000),%o2
		andn	%g2,%o2,%o3	!
    t.bassm0t0:	or	%o1,%o3,%l0	! ##TEMPLATE:%l0
t.bassm0e:
		ba	break0		!
		st	%l0,[%o7+%i0]	! R1
    t.bassm0o0:	or	%o1,%o3,%l0	! ##TEMPLATE:%l0
    t.bassm0oy:	add	%g2,2,%g2	! ##TEMPLATE:IAR
    t.bassm0oz:	add	%g2,4,%g2	! ##TEMPLATE:IAR
t.bassm1s:
		add	%g2,%g0,%o5	! save OPC
    t.bassm1tz:	add	%g2,2,%g2	! ##TEMPLATE:IAR
		and	%g7,0x10,%o1	! extract AM-bit
		sll	%o1,27,%o1	!
		sethi	%hi(0x80000000),%o2
    t.bassm1t0:	andcc	%o2,%l0,%g0	! ##TEMPLATE:%l0
		bnz	t.bassm100	! if AM == 0 then
		sethi	%hi(0x00ffffff),%g3
		or	%g3,%lo(0x00ffffff),%g3
		ba	t.bassm101	!
		andn	%g7,0x10,%g7	!   reset AM-bit
    t.bassm100:	sethi	%hi(0x1fffffff),%g3
		or	%g3,%lo(0x1fffffff),%g3
		or	%g7,0x10,%g7	! else set AM-bit
    t.bassm101:	andn	%g2,%o2,%o3	!
    t.bassm1t2:	add	%g0,%l0,%g2	! ##TEMPLATE:%l0
		sethi	%hi(break2),%o7	! BRANCH TAKEN
		jmpl	%o7+%lo(break2),%g0
    t.bassm1t3:	or	%o1,%o3,%l0	! ##TEMPLATE:%l0
t.bassm1e:
    t.bassm1o0:	andcc	%o2,%l0,%g0	! ##TEMPLATE:%l0
    t.bassm1o2:	add	%g0,%l0,%g2	! ##TEMPLATE:%l0
    t.bassm1o3:	or	%o1,%o3,%l0	! ##TEMPLATE:%l0
    t.bassm1oy:	add	%g2,2,%g2	! ##TEMPLATE:IAR
    t.bassm1oz:	add	%g2,4,%g2	! ##TEMPLATE:IAR
ii2_bassm:
	srl	%o1,16,%o3		! switch (R2)
	andcc	%o3,0xf,%g0		!
	bnz	i.bassm1t		!
	nop				!
    i.bassm0t:				!
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%i0		! save as %i0
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	add	%g0,2,%l7		!
	bnz,a	.+8			! if EX=1 then IAR+=4
	add	%g0,4,%l7		!
	ba	t.bassm0s		!
	nop				!
    i.bassm1t:				!
	srl	%o1,16,%o4		! R2
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l2		! %l2
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%i0		! save as %i0
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	add	%g0,2,%l7		!
	bnz,a	.+8			! if EX=1 then IAR+=4
	add	%g0,4,%l7		!
i.bassm1s:
		add	%g2,%g0,%o5	! save OPC
    i.bassm1tz:	add	%g2,%l7,%g2	! ##TEMPLATE:IAR
		and	%g7,0x10,%o1	! extract AM-bit
		sll	%o1,27,%o1	!
		sethi	%hi(0x80000000),%o2
    i.bassm1t0:	andcc	%o2,%l2,%g0	! ##TEMPLATE:%l0
		bnz	i.bassm100	! if AM == 0 then
		sethi	%hi(0x00ffffff),%g3
		or	%g3,%lo(0x00ffffff),%g3
		ba	i.bassm101	!
		andn	%g7,0x10,%g7	!   reset AM-bit
    i.bassm100:	sethi	%hi(0x1fffffff),%g3
		or	%g3,%lo(0x1fffffff),%g3
		or	%g7,0x10,%g7	! else set AM-bit
    i.bassm101:	andn	%g2,%o2,%o3	!
    i.bassm1t2:	add	%g0,%l2,%g2	! ##TEMPLATE:%l0
    i.bassm1t3:	or	%o1,%o3,%l0	! ##TEMPLATE:%l0
		ba	break1		! BRANCH TAKEN
		st	%l0,[%o7+%i0]	! R1
i.bassm1e:

	.section ".text"
	.align	4
	.global ci2_basr,ti2_basr,ii2_basr
ci2_basr:
	srl	%o1,16,%o3		! switch (R2)
	andcc	%o3,0xf,%g0		!
	bnz	c.basr1c		!
	nop				!
    c.basr0c:				!
	retl				! case 0:
	add	%g0,t.basr0e-t.basr0s,%o0
    c.basr1c:				!
	retl				! case not 0:
	add	%g0,t.basr1e-t.basr1s,%o0
ti2_basr:
	srl	%o1,16,%o3		! switch (R2)
	andcc	%o3,0xf,%g0		!
	bnz	t.basr1t		!
	nop				!
    t.basr0t:				!
	sethi	%hi(t.basr0s),%o3	!
	or	%o3,%lo(t.basr0s),%o3	!
	or	%g0,t.basr0e-t.basr0s,%o4
    t.basr0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.basr0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.basr0o0-t.basr0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,25,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+t.basr0t0-t.basr0s]
	ld	[%o3+t.basr0o1-t.basr0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,25,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+t.basr0t1-t.basr0s]
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	ld	[%o3+t.basr0oy-t.basr0s],%o5
	bnz,a	.+8			! if EX=1 then IAR+=4
	ld	[%o3+t.basr0oz-t.basr0s],%o5
	st	%o5,[%o0+t.basr0tz-t.basr0s]
	retl				!
	add	%o0,t.basr0e-t.basr0s,%o0
    t.basr1t:				!
	sethi	%hi(t.basr1s),%o3	!
	or	%o3,%lo(t.basr1s),%o3	!
	or	%g0,t.basr1e-t.basr1s,%o4
    t.basr1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.basr1cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.basr1o0-t.basr1s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	st	%o5,[%o0+t.basr1t0-t.basr1s]
	ld	[%o3+t.basr1o1-t.basr1s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,25,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+t.basr1t1-t.basr1s]
	ld	[%o3+t.basr1o2-t.basr1s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,25,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+t.basr1t2-t.basr1s]
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	ld	[%o3+t.basr1oy-t.basr1s],%o5
	bnz,a	.+8			! if EX=1 then IAR+=4
	ld	[%o3+t.basr1oz-t.basr1s],%o5
	st	%o5,[%o0+t.basr1tz-t.basr1s]
	retl				!
	add	%o0,t.basr1e-t.basr1s,%o0
t.basr0s:
    t.basr0tz:	add	%g2,%l7,%g2	! ##TEMPLATE:IAR
		andcc	%g7,0x10,%g0	! if 31bit address then
		sethi	%hi(0x80000000),%o1
		bnz,a	t.basr0e	!
    t.basr0t0:	or	%o1,%g2,%l0	! ##TEMPLATE:%l0
		sethi	%hi(0xff000000),%o1
    t.basr0t1:	andn	%g2,%o1,%l0	! ##TEMPLATE:%l0
t.basr0e:
		ba	break0		!
		st	%l0,[%o7+%i0]	! R1
    t.basr0o0:	or	%o1,%g2,%l0	! ##TEMPLATE:%l0
    t.basr0o1:	andn	%g2,%o1,%l0	! ##TEMPLATE:%l0
    t.basr0oy:	add	%g2,2,%g2	! ##TEMPLATE:IAR
    t.basr0oz:	add	%g2,4,%g2	! ##TEMPLATE:IAR
t.basr1s:
		add	%g2,%g0,%o5	! save OPC
    t.basr1tz:	add	%g2,2,%g2	! ##TEMPLATE:IAR
    t.basr1t0:	add	%g0,%l0,%o0	! ##TEMPLATE:%l0
		andcc	%g7,0x10,%g0	! if 31bit address then
		sethi	%hi(0x80000000),%o1
		bnz,a	t.basr100	!
    t.basr1t1:	or	%o1,%g2,%l0	! ##TEMPLATE:%l0
		sethi	%hi(0xff000000),%o1
    t.basr1t2:	andn	%g2,%o1,%l0	! ##TEMPLATE:%l0
    t.basr100:	sethi	%hi(break2),%o7	! BRANCH TAKEN
		jmpl	%o7+%lo(break2),%g0
		add	%g0,%o0,%g2	!
t.basr1e:
    t.basr1o0:	add	%g0,%l0,%o0	! ##TEMPLATE:%l0
    t.basr1o1:	or	%o1,%g2,%l0	! ##TEMPLATE:%l0
    t.basr1o2:	andn	%g2,%o1,%l0	! ##TEMPLATE:%l0
    t.basr1oy:	add	%g2,2,%g2	! ##TEMPLATE:IAR
    t.basr1oz:	add	%g2,4,%g2	! ##TEMPLATE:IAR
ii2_basr:
	srl	%o1,16,%o3		! switch (R2)
	andcc	%o3,0xf,%g0		!
	bnz	i.basr1t		!
	nop				!
    i.basr0t:				!
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%i0		! save as %i0
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	add	%g0,2,%l7		!
	bnz,a	.+8			! if EX=1 then IAR+=4
	add	%g0,4,%l7		!
	ba	t.basr0s		!
	nop				!
    i.basr1t:				!
	srl	%o1,16,%o4		! R2
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l2		! %l2
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%i0		! save as %i0
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	add	%g0,2,%l7		!
	bnz,a	.+8			! if EX=1 then IAR+=4
	add	%g0,4,%l7		!
i.basr1s:
		add	%g2,%g0,%o5	! save OPC
    i.basr1tz:	add	%g2,%l7,%g2	! ##TEMPLATE:IAR
    i.basr1t0:	add	%g0,%l2,%o0	! ##TEMPLATE:%l0
		andcc	%g7,0x10,%g0	! if 31bit address then
		sethi	%hi(0x80000000),%o1
		bnz,a	i.basr100	!
    i.basr1t1:	or	%o1,%g2,%l0	! ##TEMPLATE:%l0
		sethi	%hi(0xff000000),%o1
    i.basr1t2:	andn	%g2,%o1,%l0	! ##TEMPLATE:%l0
    i.basr100:	st	%l0,[%o7+%i0]	! R1
		ba	break1		! BRANCH TAKEN
		add	%g0,%o0,%g2	!
i.basr1e:

	.section ".text"
	.align	4
	.global ci2_mvcl,ti2_mvcl,ii2_mvcl
ci2_mvcl:
	srl	%o1,20,%o3		! switch (R1,R2)
	srl	%o1,16,%o4		!
	or	%o3,%o4,%o3		!
	andcc	%o3,1,%g0		!
	bnz	c.mvcl1c		!
	nop				!
    c.mvcl0c:				!
	retl				!
	add	%g0,t.mvcl0e-t.mvcl0s,%o0
    c.mvcl1c:				!
	retl				!
	add	%g0,t.mvcl1e-t.mvcl1s,%o0
ti2_mvcl:
	srl	%o1,20,%o3		! switch (R1,R2)
	srl	%o1,16,%o4		!
	or	%o3,%o4,%o3		!
	andcc	%o3,1,%g0		!
	bnz	t.mvcl1t		!
	nop				!
    t.mvcl0t:				!
	sethi	%hi(t.mvcl0s),%o3	!
	or	%o3,%lo(t.mvcl0s),%o3	!
	or	%g0,t.mvcl0e-t.mvcl0s,%o4
    t.mvcl0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.mvcl0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.mvcl0o0-t.mvcl0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+t.mvcl0t0-t.mvcl0s]
	ld	[%o3+t.mvcl0o1-t.mvcl0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+t.mvcl0t1-t.mvcl0s]
	ld	[%o3+t.mvcl0o2-t.mvcl0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1+1
	add	%o4,1,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+t.mvcl0t2-t.mvcl0s]
	ld	[%o3+t.mvcl0o3-t.mvcl0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2+1
	add	%o4,1,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+t.mvcl0t3-t.mvcl0s]
	ld	[%o3+t.mvcl0o4-t.mvcl0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2+1
	add	%o4,1,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+t.mvcl0t4-t.mvcl0s]
	ld	[%o3+t.mvcl0o5-t.mvcl0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,25,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+t.mvcl0t5-t.mvcl0s]
	ld	[%o3+t.mvcl0o6-t.mvcl0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,25,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+t.mvcl0t6-t.mvcl0s]
	ld	[%o3+t.mvcl0o7-t.mvcl0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1+1
	add	%o4,1,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	sll	%o4,11,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+t.mvcl0t7-t.mvcl0s]
	ld	[%o3+t.mvcl0o8-t.mvcl0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1+1
	add	%o4,1,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	sll	%o4,11,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+t.mvcl0t8-t.mvcl0s]
	ld	[%o3+t.mvcl0o9-t.mvcl0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2+1
	add	%o4,1,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	sll	%o4,11,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+t.mvcl0t9-t.mvcl0s]
	ld	[%o3+t.mvcl0oa-t.mvcl0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2+1
	add	%o4,1,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	sll	%o4,11,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+t.mvcl0ta-t.mvcl0s]
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	ld	[%o3+t.mvcl0oy-t.mvcl0s],%o5
	bnz,a	.+8			! if EX=1 then IAR+=4
	ld	[%o3+t.mvcl0oz-t.mvcl0s],%o5
	st	%o5,[%o0+t.mvcl0tz-t.mvcl0s]
	retl				!
	add	%o0,t.mvcl0e-t.mvcl0s,%o0
    t.mvcl1t:				!
	sethi	%hi(t.mvcl1s),%o3	!
	or	%o3,%lo(t.mvcl1s),%o3	!
	or	%g0,t.mvcl1e-t.mvcl1s,%o4
    t.mvcl1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.mvcl1cp		!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,t.mvcl1e-t.mvcl1s,%o0
t.mvcl0s:
		andn	%g1,3,%g1	! CC=0 (interruptible)
    t.mvcl0t0:	and	%l0,%g3,%o1	! ##TEMPLATE:%l0
    t.mvcl0t1:	and	%l0,%g3,%o2	! ##TEMPLATE:%l0
		sethi	%hi(0xff000000),%o0
    t.mvcl0t2:	andn	%l0,%o0,%o3	! ##TEMPLATE:%l0
    t.mvcl0t3:	andn	%l0,%o0,%o4	! ##TEMPLATE:%l0
    t.mvcl0loop: /* MAIN LOOP */
    t.mvcl0t4:	srl	%l0,24,%o5	! ##TEMPLATE:%l0
		sethi	%hi(il_mvcl),%o7!
		jmpl	%o7+%lo(il_mvcl),%o7
		nop			! call library in intlib.s
    t.mvcl0t5:	add	%g0,%o1,%l0	! ##TEMPLATE:%l0
    t.mvcl0t6:	add	%g0,%o2,%l0	! ##TEMPLATE:%l0
		sethi	%hi(0xff000000),%o0
    t.mvcl0t7:	and	%l0,%o0,%l0	! ##TEMPLATE:%l0,%l0
    t.mvcl0t8:	or	%l0,%o3,%l0	! ##TEMPLATE:%l0,%l0
    t.mvcl0t9:	and	%l0,%o0,%l0	! ##TEMPLATE:%l0,%l0
    t.mvcl0ta:	or	%l0,%o4,%l0	! ##TEMPLATE:%l0,%l0
		subcc	%g1,3,%g0	! if CC=3 then
		bz	t.mvcl0tz	!   exit
		subcc	%o3,0,%g0	! if mvcl completed then
		bz	t.mvcl0tz	!   exit
		andncc	%g7,0xfff,%g0	! if intermediate intr. then
		bz	t.mvcl0loop	!   exit
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		nop			!
    t.mvcl0tz:	add	%g2,2,%g2	! ##TEMPLATE:IAR
t.mvcl0e:
    t.mvcl0o0:	and	%l0,%g3,%o1	! ##TEMPLATE:%l0
    t.mvcl0o1:	and	%l0,%g3,%o2	! ##TEMPLATE:%l0
    t.mvcl0o2:	andn	%l0,%o0,%o3	! ##TEMPLATE:%l0
    t.mvcl0o3:	andn	%l0,%o0,%o4	! ##TEMPLATE:%l0
    t.mvcl0o4:	srl	%l0,24,%o5	! ##TEMPLATE:%l0
    t.mvcl0o5:	add	%g0,%o1,%l0	! ##TEMPLATE:%l0
    t.mvcl0o6:	add	%g0,%o2,%l0	! ##TEMPLATE:%l0
    t.mvcl0o7:	and	%l0,%o0,%l0	! ##TEMPLATE:%l0,%l0
    t.mvcl0o8:	or	%l0,%o3,%l0	! ##TEMPLATE:%l0,%l0
    t.mvcl0o9:	and	%l0,%o0,%l0	! ##TEMPLATE:%l0,%l0
    t.mvcl0oa:	or	%l0,%o4,%l0	! ##TEMPLATE:%l0,%l0
    t.mvcl0oy:	add	%g2,2,%g2	! ##TEMPLATE:IAR
    t.mvcl0oz:	add	%g2,4,%g2	! ##TEMPLATE:IAR
t.mvcl1s:
		sethi	%hi(0x00060000),%o0
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! specification exception
t.mvcl1e:
ii2_mvcl:
	srl	%o1,20,%o3		! switch (R1,R2)
	srl	%o1,16,%o4		!
	or	%o3,%o4,%o3		!
	andcc	%o3,1,%g0		!
	bnz	t.mvcl1s		!
	nop				!
    i.mvcl0t:				!
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%i0		! save as %i0
	ld	[%o7+%i0],%l0		! %l0
	srl	%o1,20,%o4		! R1+1
	and	%o4,0xf,%o4		! |
	add	%o4,1,%o4		! |
	sll	%o4,2,%i1		! save as %i1
	ld	[%o7+%i1],%l1		! %l1
	srl	%o1,16,%o4		! R2
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%i2		! save as %i2
	ld	[%o7+%i2],%l2		! %l2
	srl	%o1,16,%o4		! R2+1
	and	%o4,0xf,%o4		! |
	add	%o4,1,%o4		! |
	sll	%o4,2,%i3		! save as %i3
	ld	[%o7+%i3],%l3		! %l3
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	add	%g0,2,%l7		!
	bnz,a	.+8			! if EX=1 then IAR+=4
	add	%g0,4,%l7		!
i.mvcl0s:
		andn	%g1,3,%g1	! CC=0 (interruptible)
    i.mvcl0t0:	and	%l0,%g3,%o1	! ##TEMPLATE:%l0
    i.mvcl0t1:	and	%l2,%g3,%o2	! ##TEMPLATE:%l0
		sethi	%hi(0xff000000),%o0
    i.mvcl0t2:	andn	%l1,%o0,%o3	! ##TEMPLATE:%l0
    i.mvcl0t3:	andn	%l3,%o0,%o4	! ##TEMPLATE:%l0
    i.mvcl0loop: /* MAIN LOOP */
    i.mvcl0t4:	srl	%l3,24,%o5	! ##TEMPLATE:%l0
		call	il_mvcl		!
		nop			! call library in intlib.s
		ld	[%sp+184],%o7	! struct *gcpu_s
    i.mvcl0t5:	add	%g0,%o1,%l0	! ##TEMPLATE:%l0
		st	%l0,[%o7+%i0]	! R1
    i.mvcl0t6:	add	%g0,%o2,%l2	! ##TEMPLATE:%l0
		st	%l2,[%o7+%i2]	! R2
		sethi	%hi(0xff000000),%o0
    i.mvcl0t7:	and	%l1,%o0,%l1	! ##TEMPLATE:%l0,%l0
    i.mvcl0t8:	or	%l1,%o3,%l1	! ##TEMPLATE:%l0,%l0
		st	%l1,[%o7+%i1]	! R1+1
    i.mvcl0t9:	and	%l3,%o0,%l3	! ##TEMPLATE:%l0,%l0
    i.mvcl0ta:	or	%l3,%o4,%l3	! ##TEMPLATE:%l0,%l0
		st	%l3,[%o7+%i3]	! R2+1
		subcc	%g1,3,%g0	! if CC=3 then
		bz	i.mvcl0tz	!   exit
		subcc	%o3,0,%g0	! if mvcl completed then
		bz	i.mvcl0tz	!   exit
		andncc	%g7,0xfff,%g0	! if intermediate intr. then
		bz	i.mvcl0loop	!   exit
		nop			!
		ba	epilog0		!
		nop			!
    i.mvcl0tz:	ba	break0		!
		add	%g2,%l7,%g2	! ##TEMPLATE:IAR
i.mvcl0e:

	.section ".text"
	.align	4
	.global ci2_clcl,ti2_clcl,ii2_clcl
ci2_clcl:
	srl	%o1,20,%o3		! switch (R1,R2)
	srl	%o1,16,%o4		!
	or	%o3,%o4,%o3		!
	andcc	%o3,1,%g0		!
	bnz	c.clcl1c		!
	nop				!
    c.clcl0c:				!
	retl				!
	add	%g0,t.clcl0e-t.clcl0s,%o0
    c.clcl1c:				!
	retl				!
	add	%g0,t.clcl1e-t.clcl1s,%o0
ti2_clcl:
	srl	%o1,20,%o3		! switch (R1,R2)
	srl	%o1,16,%o4		!
	or	%o3,%o4,%o3		!
	andcc	%o3,1,%g0		!
	bnz	t.clcl1t		!
	nop				!
    t.clcl0t:				!
	sethi	%hi(t.clcl0s),%o3	!
	or	%o3,%lo(t.clcl0s),%o3	!
	or	%g0,t.clcl0e-t.clcl0s,%o4
    t.clcl0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.clcl0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.clcl0o0-t.clcl0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+t.clcl0t0-t.clcl0s]
	ld	[%o3+t.clcl0o1-t.clcl0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+t.clcl0t1-t.clcl0s]
	ld	[%o3+t.clcl0o2-t.clcl0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1+1
	add	%o4,1,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+t.clcl0t2-t.clcl0s]
	ld	[%o3+t.clcl0o3-t.clcl0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2+1
	add	%o4,1,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+t.clcl0t3-t.clcl0s]
	ld	[%o3+t.clcl0o4-t.clcl0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2+1
	add	%o4,1,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+t.clcl0t4-t.clcl0s]
	ld	[%o3+t.clcl0o5-t.clcl0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,25,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+t.clcl0t5-t.clcl0s]
	ld	[%o3+t.clcl0o6-t.clcl0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,25,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+t.clcl0t6-t.clcl0s]
	ld	[%o3+t.clcl0o7-t.clcl0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1+1
	add	%o4,1,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	sll	%o4,11,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+t.clcl0t7-t.clcl0s]
	ld	[%o3+t.clcl0o8-t.clcl0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1+1
	add	%o4,1,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	sll	%o4,11,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+t.clcl0t8-t.clcl0s]
	ld	[%o3+t.clcl0o9-t.clcl0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2+1
	add	%o4,1,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	sll	%o4,11,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+t.clcl0t9-t.clcl0s]
	ld	[%o3+t.clcl0oa-t.clcl0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2+1
	add	%o4,1,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	sll	%o4,11,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+t.clcl0ta-t.clcl0s]
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	ld	[%o3+t.clcl0oy-t.clcl0s],%o5
	bnz,a	.+8			! if EX=1 then IAR+=4
	ld	[%o3+t.clcl0oz-t.clcl0s],%o5
	st	%o5,[%o0+t.clcl0tz-t.clcl0s]
	retl				!
	add	%o0,t.clcl0e-t.clcl0s,%o0
    t.clcl1t:				!
	sethi	%hi(t.clcl1s),%o3	!
	or	%o3,%lo(t.clcl1s),%o3	!
	or	%g0,t.clcl1e-t.clcl1s,%o4
    t.clcl1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.clcl1cp		!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,t.clcl1e-t.clcl1s,%o0
t.clcl0s:
		andn	%g1,3,%g1	! CC=0 (interruptible)
    t.clcl0t0:	and	%l0,%g3,%o1	! ##TEMPLATE:%l0
    t.clcl0t1:	and	%l0,%g3,%o2	! ##TEMPLATE:%l0
		sethi	%hi(0xff000000),%o0
    t.clcl0t2:	andn	%l0,%o0,%o3	! ##TEMPLATE:%l0
    t.clcl0t3:	andn	%l0,%o0,%o4	! ##TEMPLATE:%l0
    t.clcl0loop: /* MAIN LOOP */
    t.clcl0t4:	srl	%l0,24,%o5	! ##TEMPLATE:%l0
		sethi	%hi(il_clcl),%o7!
		jmpl	%o7+%lo(il_clcl),%o7
		nop			! call library in intlib.s
    t.clcl0t5:	add	%g0,%o1,%l0	! ##TEMPLATE:%l0
    t.clcl0t6:	add	%g0,%o2,%l0	! ##TEMPLATE:%l0
		sethi	%hi(0xff000000),%o0
    t.clcl0t7:	and	%l0,%o0,%l0	! ##TEMPLATE:%l0,%l0
    t.clcl0t8:	or	%l0,%o3,%l0	! ##TEMPLATE:%l0,%l0
    t.clcl0t9:	and	%l0,%o0,%l0	! ##TEMPLATE:%l0,%l0
    t.clcl0ta:	or	%l0,%o4,%l0	! ##TEMPLATE:%l0,%l0
		subcc	%g1,0,%g0	! if CC!=0 then
		bnz	t.clcl0tz	!   exit
		orcc	%o3,%o4,%g0	! if clcl completed then
		bz	t.clcl0tz	!   exit
		andncc	%g7,0xfff,%g0	! if intermediate intr. then
		bz	t.clcl0loop	!   exit
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		nop			!
    t.clcl0tz:	add	%g2,2,%g2	! ##TEMPLATE:IAR
t.clcl0e:
    t.clcl0o0:	and	%l0,%g3,%o1	! ##TEMPLATE:%l0
    t.clcl0o1:	and	%l0,%g3,%o2	! ##TEMPLATE:%l0
    t.clcl0o2:	andn	%l0,%o0,%o3	! ##TEMPLATE:%l0
    t.clcl0o3:	andn	%l0,%o0,%o4	! ##TEMPLATE:%l0
    t.clcl0o4:	srl	%l0,24,%o5	! ##TEMPLATE:%l0
    t.clcl0o5:	add	%g0,%o1,%l0	! ##TEMPLATE:%l0
    t.clcl0o6:	add	%g0,%o2,%l0	! ##TEMPLATE:%l0
    t.clcl0o7:	and	%l0,%o0,%l0	! ##TEMPLATE:%l0,%l0
    t.clcl0o8:	or	%l0,%o3,%l0	! ##TEMPLATE:%l0,%l0
    t.clcl0o9:	and	%l0,%o0,%l0	! ##TEMPLATE:%l0,%l0
    t.clcl0oa:	or	%l0,%o4,%l0	! ##TEMPLATE:%l0,%l0
    t.clcl0oy:	add	%g2,2,%g2	! ##TEMPLATE:IAR
    t.clcl0oz:	add	%g2,4,%g2	! ##TEMPLATE:IAR
t.clcl1s:
		sethi	%hi(0x00060000),%o0
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! specification exception
t.clcl1e:
ii2_clcl:
	srl	%o1,20,%o3		! switch (R1,R2)
	srl	%o1,16,%o4		!
	or	%o3,%o4,%o3		!
	andcc	%o3,1,%g0		!
	bnz	t.clcl1s		!
	nop				!
    i.clcl0t:				!
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%i0		! save as %i0
	ld	[%o7+%i0],%l0		! %l0
	srl	%o1,20,%o4		! R1+1
	and	%o4,0xf,%o4		! |
	add	%o4,1,%o4		! |
	sll	%o4,2,%i1		! save as %i1
	ld	[%o7+%i1],%l1		! %l1
	srl	%o1,16,%o4		! R2
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%i2		! save as %i2
	ld	[%o7+%i2],%l2		! %l2
	srl	%o1,16,%o4		! R2+1
	and	%o4,0xf,%o4		! |
	add	%o4,1,%o4		! |
	sll	%o4,2,%i3		! save as %i3
	ld	[%o7+%i3],%l3		! %l3
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	add	%g0,2,%l7		!
	bnz,a	.+8			! if EX=1 then IAR+=4
	add	%g0,4,%l7		!
i.clcl0s:
		andn	%g1,3,%g1	! CC=0 (interruptible)
    i.clcl0t0:	and	%l0,%g3,%o1	! ##TEMPLATE:%l0
    i.clcl0t1:	and	%l2,%g3,%o2	! ##TEMPLATE:%l0
		sethi	%hi(0xff000000),%o0
    i.clcl0t2:	andn	%l1,%o0,%o3	! ##TEMPLATE:%l0
    i.clcl0t3:	andn	%l3,%o0,%o4	! ##TEMPLATE:%l0
    i.clcl0loop: /* MAIN LOOP */
    i.clcl0t4:	srl	%l3,24,%o5	! ##TEMPLATE:%l0
		call	il_clcl		!
		nop			! call library in intlib.s
		ld	[%sp+184],%o7	! struct *gcpu_s
    i.clcl0t5:	add	%g0,%o1,%l0	! ##TEMPLATE:%l0
		st	%l0,[%o7+%i0]	! R1
    i.clcl0t6:	add	%g0,%o2,%l2	! ##TEMPLATE:%l0
		st	%l2,[%o7+%i2]	! R2
		sethi	%hi(0xff000000),%o0
    i.clcl0t7:	and	%l1,%o0,%l1	! ##TEMPLATE:%l0,%l0
    i.clcl0t8:	or	%l1,%o3,%l1	! ##TEMPLATE:%l0,%l0
		st	%l1,[%o7+%i1]	! R1+1
    i.clcl0t9:	and	%l3,%o0,%l3	! ##TEMPLATE:%l0,%l0
    i.clcl0ta:	or	%l3,%o4,%l3	! ##TEMPLATE:%l0,%l0
		st	%l3,[%o7+%i3]	! R2+1
		subcc	%g1,0,%g0	! if CC!=0 then
		bnz	i.clcl0tz	!   exit
		orcc	%o3,%o4,%g0	! if clcl completed then
		bz	i.clcl0tz	!   exit
		andncc	%g7,0xfff,%g0	! if intermediate intr. then
		bz	i.clcl0loop	!   exit
		nop			!
		ba	epilog0		!
		nop			!
    i.clcl0tz:	ba	break0		!
		add	%g2,%l7,%g2	! ##TEMPLATE:IAR
i.clcl0e:
!================================

!
! templates
! cxx_xxx:
!   %o0: param: none
!	 retval:size of template
!   %o1: M instruction (upper 2 bytes)
!   %o2: work
!   %o3: work
!   %o4: work
!   %o5: work
! txx_xxx:
!   %o0: param: bufp start address
!	 retval:bufp next start address
!   %o1: M instruction (upper 2 bytes)
!   %o2: work
!   %o3: work
!   %o4: work
!   %o5: work
!
	.section ".text"
	.align	4
	.global ci2_lpr,ti2_lpr,ii2_lpr
ci2_lpr:
	retl				!
	add	%g0,t.lpr0e-t.lpr0s,%o0	!
ti2_lpr:
	sethi	%hi(t.lpr0s),%o3	!
	or	%o3,%lo(t.lpr0s),%o3	!
	or	%g0,t.lpr0e-t.lpr0s,%o4	!
    t.lpr0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.lpr0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.lpr0o0-t.lpr0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,25,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+t.lpr0t0-t.lpr0s]
	ld	[%o3+t.lpr0o1-t.lpr0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	sll	%o4,25,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+t.lpr0t1-t.lpr0s]
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	ld	[%o3+t.lpr0oy-t.lpr0s],%o5
	bnz,a	.+8			! if EX=1 then IAR+=4
	ld	[%o3+t.lpr0oz-t.lpr0s],%o5
	st	%o5,[%o0+t.lpr0tz-t.lpr0s]
	retl				!
	add	%o0,t.lpr0e-t.lpr0s,%o0	!
t.lpr0s:
		andn	%g1,3,%g1	! CC=0
    t.lpr0t0:	addcc	%g0,%l0,%l0	! ##TEMPLATE:%l0,%l0
		bl,a	t.lpr000	! if %l0 < 0 then negate;
    t.lpr0t1:	subcc	%g0,%l0,%l0	! ##TEMPLATE:%l0,%l0
    t.lpr000:	bnz,a	t.lpr001	! if %l0 !=0 then
		or	%g1,2,%g1	!   CC=2
    t.lpr001:	bvc	t.lpr0tz	! if overflow then
		andcc	%g7,8,%g0	!   CC=3
		bz	t.lpr0tz	!   if fixed-point overflow mask then
		or	%g1,3,%g1	!
		sethi	%hi(0x00080000),%o0
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	!     fixed-point overflow
    t.lpr0tz:	add	%g2,2,%g2	! ##TEMPLATE:IAR
t.lpr0e:
    t.lpr0o0:	addcc	%g0,%l0,%l0	! ##TEMPLATE:%l0,%l0
    t.lpr0o1:	subcc	%g0,%l0,%l0	! ##TEMPLATE:%l0,%l0
    t.lpr0oy:	add	%g2,2,%g2	! ##TEMPLATE:IAR
    t.lpr0oz:	add	%g2,4,%g2	! ##TEMPLATE:IAR
ii2_lpr:
	srl	%o1,16,%o4		! R2
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l2		! %l2
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%i0		! save as %i0
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	add	%g0,2,%l7		!
	bnz,a	.+8			! if EX=1 then IAR+=4
	add	%g0,4,%l7		!
i.lpr0s:
		andn	%g1,3,%g1	! CC=0
    i.lpr0t0:	addcc	%g0,%l2,%l0	! ##TEMPLATE:%l0,%l0
		bl,a	i.lpr000	! if %l0 < 0 then negate;
    i.lpr0t1:	subcc	%g0,%l0,%l0	! ##TEMPLATE:%l0,%l0
    i.lpr000:	st	%l0,[%o7+%i0]	! R1
		bnz,a	i.lpr001	! if %l0 !=0 then
		or	%g1,2,%g1	!   CC=2
    i.lpr001:	bvc	i.lpr0tz	! if overflow then
		andcc	%g7,8,%g0	!   CC=3
		bz	i.lpr0tz	!   if fixed-point overflow mask then
		or	%g1,3,%g1	!
		sethi	%hi(0x00080000),%o0
		ba	epilog0		!
		or	%g7,%o0,%g7	!     fixed-point overflow
    i.lpr0tz:	ba	break0		!
		add	%g2,%l7,%g2	! ##TEMPLATE:IAR
i.lpr0e:

	.section ".text"
	.align	4
	.global ci2_lnr,ti2_lnr,ii2_lnr
ci2_lnr:
	retl				!
	add	%g0,t.lnr0e-t.lnr0s,%o0	!
ti2_lnr:
	sethi	%hi(t.lnr0s),%o3	!
	or	%o3,%lo(t.lnr0s),%o3	!
	or	%g0,t.lnr0e-t.lnr0s,%o4	!
    t.lnr0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.lnr0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.lnr0o0-t.lnr0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,25,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+t.lnr0t0-t.lnr0s]
	ld	[%o3+t.lnr0o1-t.lnr0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	sll	%o4,25,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+t.lnr0t1-t.lnr0s]
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	ld	[%o3+t.lnr0oy-t.lnr0s],%o5
	bnz,a	.+8			! if EX=1 then IAR+=4
	ld	[%o3+t.lnr0oz-t.lnr0s],%o5
	st	%o5,[%o0+t.lnr0tz-t.lnr0s]
	retl				!
	add	%o0,t.lnr0e-t.lnr0s,%o0	!
ii2_lnr:
	srl	%o1,16,%o4		! R2
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l2		! %l2
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%i0		! save as %i0
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	add	%g0,2,%l7		!
	bnz,a	.+8			! if EX=1 then IAR+=4
	add	%g0,4,%l7		!
t.lnr0s:
		andn	%g1,3,%g1	! CC=0
    t.lnr0t0:	addcc	%g0,%l2,%l0	! ##TEMPLATE:%l0,%l0
		bg,a	t.lnr000	! if %l0 > 0 then negate
    t.lnr0t1:	subcc	%g0,%l0,%l0	! ##TEMPLATE:%l0,%l0
    t.lnr000:	bnz,a	t.lnr0tz	! if %l0 !=0 then
		or	%g1,1,%g1	!   CC=1
    t.lnr0tz:	add	%g2,%l7,%g2	! ##TEMPLATE:IAR
t.lnr0e:
		ba	break0		!
		st	%l0,[%o7+%i0]	! R1
    t.lnr0o0:	addcc	%g0,%l0,%l0	! ##TEMPLATE:%l0,%l0
    t.lnr0o1:	subcc	%g0,%l0,%l0	! ##TEMPLATE:%l0,%l0
    t.lnr0oy:	add	%g2,2,%g2	! ##TEMPLATE:IAR
    t.lnr0oz:	add	%g2,4,%g2	! ##TEMPLATE:IAR

	.section ".text"
	.align	4
	.global ci2_ltr,ti2_ltr,ii2_ltr
ci2_ltr:
	retl				!
	add	%g0,t.ltr0e-t.ltr0s,%o0	!
ti2_ltr:
	sethi	%hi(t.ltr0s),%o3	!
	or	%o3,%lo(t.ltr0s),%o3	!
	or	%g0,t.ltr0e-t.ltr0s,%o4	!
    t.ltr0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.ltr0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.ltr0o0-t.ltr0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,25,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+t.ltr0t0-t.ltr0s]
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	ld	[%o3+t.ltr0oy-t.ltr0s],%o5
	bnz,a	.+8			! if EX=1 then IAR+=4
	ld	[%o3+t.ltr0oz-t.ltr0s],%o5
	st	%o5,[%o0+t.ltr0tz-t.ltr0s]
	retl				!
	add	%o0,t.ltr0e-t.ltr0s,%o0	!
ii2_ltr:
	srl	%o1,16,%o4		! R2
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l2		! %l2
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%i0		! save as %i0
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	add	%g0,2,%l7		!
	bnz,a	.+8			! if EX=1 then IAR+=4
	add	%g0,4,%l7		!
t.ltr0s:
		andn	%g1,3,%g1	! CC=0
    t.ltr0t0:	addcc	%g0,%l2,%l0	! ##TEMPLATE:%l0,%l0
		bg,a	t.ltr0tz	! if %l0 > 0 then
		or	%g1,2,%g1	!   CC=2
		bl,a	t.ltr0tz	! if %l0 < 0 then
		or	%g1,1,%g1	!   CC=1
    t.ltr0tz:	add	%g2,%l7,%g2	! ##TEMPLATE:IAR
t.ltr0e:
		ba	break0		!
		st	%l0,[%o7+%i0]	! R1
    t.ltr0o0:	addcc	%g0,%l0,%l0	! ##TEMPLATE:%l0,%l0
    t.ltr0oy:	add	%g2,2,%g2	! ##TEMPLATE:IAR
    t.ltr0oz:	add	%g2,4,%g2	! ##TEMPLATE:IAR

	.section ".text"
	.align	4
	.global ci2_lcr,ti2_lcr,ii2_lcr
ci2_lcr:
	retl				!
	add	%g0,t.lcr0e-t.lcr0s,%o0	!
ti2_lcr:
	sethi	%hi(t.lcr0s),%o3	!
	or	%o3,%lo(t.lcr0s),%o3	!
	or	%g0,t.lcr0e-t.lcr0s,%o4	!
    t.lcr0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.lcr0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.lcr0o0-t.lcr0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,25,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+t.lcr0t0-t.lcr0s]
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	ld	[%o3+t.lcr0oy-t.lcr0s],%o5
	bnz,a	.+8			! if EX=1 then IAR+=4
	ld	[%o3+t.lcr0oz-t.lcr0s],%o5
	st	%o5,[%o0+t.lcr0tz-t.lcr0s]
	retl				!
	add	%o0,t.lcr0e-t.lcr0s,%o0	!
t.lcr0s:
		andn	%g1,3,%g1	! CC=0
    t.lcr0t0:	subcc	%g0,%l0,%l0	! ##TEMPLATE:%l0,%l0
		bvc	t.lcr000	! if overflow then
		nop			!
		andcc	%g7,8,%g0	!   CC=3
		bz	t.lcr0tz	!   if fixed-point overflow mask then
		or	%g1,3,%g1	!
		sethi	%hi(0x00080000),%o0
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	!     fixed-point overflow
    t.lcr000:	bg,a	t.lcr0tz	! if %l0 > 0 then
		or	%g1,2,%g1	!   CC=2
		bl,a	t.lcr0tz	! if %l0 < 0 then
		or	%g1,1,%g1	!   CC=1
    t.lcr0tz:	add	%g2,2,%g2	! ##TEMPLATE:IAR
t.lcr0e:
    t.lcr0o0:	subcc	%g0,%l0,%l0	! ##TEMPLATE:%l0,%l0
    t.lcr0oy:	add	%g2,2,%g2	! ##TEMPLATE:IAR
    t.lcr0oz:	add	%g2,4,%g2	! ##TEMPLATE:IAR
ii2_lcr:
	srl	%o1,16,%o4		! R2
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l2		! %l2
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%i0		! save as %i0
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	add	%g0,2,%l7		!
	bnz,a	.+8			! if EX=1 then IAR+=4
	add	%g0,4,%l7		!
i.lcr0s:
		andn	%g1,3,%g1	! CC=0
    i.lcr0t0:	subcc	%g0,%l2,%l0	! ##TEMPLATE:%l0,%l0
		st	%l0,[%o7+%i0]	! R1
		bvc	i.lcr000	! if overflow then
		nop			!
		andcc	%g7,8,%g0	!   CC=3
		bz	i.lcr0tz	!   if fixed-point overflow mask then
		or	%g1,3,%g1	!
		sethi	%hi(0x00080000),%o0
		ba	epilog0		!
		or	%g7,%o0,%g7	!     fixed-point overflow
    i.lcr000:	bg,a	i.lcr0tz	! if %l0 > 0 then
		or	%g1,2,%g1	!   CC=2
		bl,a	i.lcr0tz	! if %l0 < 0 then
		or	%g1,1,%g1	!   CC=1
    i.lcr0tz:	ba	break0		!
		add	%g2,%l7,%g2	! ##TEMPLATE:IAR
i.lcr0e:

	.section ".text"
	.align	4
	.global ci2_nr,ti2_nr,ii2_nr
ci2_nr:
	retl				!
	add	%g0,t.nr0e-t.nr0s,%o0	!
ti2_nr:
	sethi	%hi(t.nr0s),%o3		!
	or	%o3,%lo(t.nr0s),%o3	!
	or	%g0,t.nr0e-t.nr0s,%o4	!
    t.nr0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.nr0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.nr0o0-t.nr0s],%o5!
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	sll	%o4,11,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+t.nr0t0-t.nr0s]!
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	ld	[%o3+t.nr0oy-t.nr0s],%o5!
	bnz,a	.+8			! if EX=1 then IAR+=4
	ld	[%o3+t.nr0oz-t.nr0s],%o5!
	st	%o5,[%o0+t.nr0tz-t.nr0s]!
	retl				!
	add	%o0,t.nr0e-t.nr0s,%o0	!
ii2_nr:
	srl	%o1,16,%o4		! R2
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l2		! %l2
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%i0		! save as %i0
	ld	[%o7+%i0],%l0		! %l0
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	add	%g0,2,%l7		!
	bnz,a	.+8			! if EX=1 then IAR+=4
	add	%g0,4,%l7		!
t.nr0s:
		andn	%g1,3,%g1	! CC=0
    t.nr0t0:	andcc	%l0,%l2,%l0	! ##TEMPLATE:%l0,%l0,%l0
		bnz,a	t.nr0tz		! if %l0 != 0 then
		or	%g1,1,%g1	!   CC=1
    t.nr0tz:	add	%g2,%l7,%g2	! ##TEMPLATE:IAR
t.nr0e:
		ba	break0		!
		st	%l0,[%o7+%i0]	! R1
    t.nr0o0:	andcc	%l0,%l0,%l0	! ##TEMPLATE:%l0,%l0,%l0
    t.nr0oy:	add	%g2,2,%g2	! ##TEMPLATE:IAR
    t.nr0oz:	add	%g2,4,%g2	! ##TEMPLATE:IAR

	.section ".text"
	.align	4
	.global ci2_clr,ti2_clr,ii2_clr
ci2_clr:
	retl				!
	add	%g0,t.clr0e-t.clr0s,%o0	!
ti2_clr:
	sethi	%hi(t.clr0s),%o3	!
	or	%o3,%lo(t.clr0s),%o3	!
	or	%g0,t.clr0e-t.clr0s,%o4	!
    t.clr0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.clr0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.clr0o0-t.clr0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+t.clr0t0-t.clr0s]
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	ld	[%o3+t.clr0oy-t.clr0s],%o5
	bnz,a	.+8			! if EX=1 then IAR+=4
	ld	[%o3+t.clr0oz-t.clr0s],%o5
	st	%o5,[%o0+t.clr0tz-t.clr0s]
	retl				!
	add	%o0,t.clr0e-t.clr0s,%o0	!
ii2_clr:
	srl	%o1,16,%o4		! R2
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l2		! %l2
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l0		! %l0
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	add	%g0,2,%l7		!
	bnz,a	.+8			! if EX=1 then IAR+=4
	add	%g0,4,%l7		!
t.clr0s:
		andn	%g1,3,%g1	! CC=0
    t.clr0t0:	subcc	%l0,%l2,%g0	! ##TEMPLATE:%l0,%l0
		bgu,a	t.clr0tz	! if %l0 > 0 then
		or	%g1,2,%g1	!   CC=2
		bcs,a	t.clr0tz	! if %l0 < 0 then
		or	%g1,1,%g1	!   CC=1
    t.clr0tz:	add	%g2,%l7,%g2	! ##TEMPLATE:IAR
t.clr0e:
		ba	break0		!
		nop			!
    t.clr0o0:	subcc	%l0,%l0,%g0	! ##TEMPLATE:%l0,%l0
    t.clr0oy:	add	%g2,2,%g2	! ##TEMPLATE:IAR
    t.clr0oz:	add	%g2,4,%g2	! ##TEMPLATE:IAR

	.section ".text"
	.align	4
	.global ci2_or,ti2_or,ii2_or
ci2_or:
	retl				!
	add	%g0,t.or0e-t.or0s,%o0	!
ti2_or:
	sethi	%hi(t.or0s),%o3		!
	or	%o3,%lo(t.or0s),%o3	!
	or	%g0,t.or0e-t.or0s,%o4	!
    t.or0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.or0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.or0o0-t.or0s],%o5!
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	sll	%o4,11,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+t.or0t0-t.or0s]!
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	ld	[%o3+t.or0oy-t.or0s],%o5!
	bnz,a	.+8			! if EX=1 then IAR+=4
	ld	[%o3+t.or0oz-t.or0s],%o5!
	st	%o5,[%o0+t.or0tz-t.or0s]!
	retl				!
	add	%o0,t.or0e-t.or0s,%o0	!
ii2_or:
	srl	%o1,16,%o4		! R2
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l2		! %l2
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%i0		! save as %i0
	ld	[%o7+%i0],%l0		! %l0
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	add	%g0,2,%l7		!
	bnz,a	.+8			! if EX=1 then IAR+=4
	add	%g0,4,%l7		!
t.or0s:
		andn	%g1,3,%g1	! CC=0
    t.or0t0:	orcc	%l0,%l2,%l0	! ##TEMPLATE:%l0,%l0,%l0
		bnz,a	t.or0tz		! if %l0 != 0 then
		or	%g1,1,%g1	!   CC=1
    t.or0tz:	add	%g2,%l7,%g2	! ##TEMPLATE:IAR
t.or0e:
		ba	break0		!
		st	%l0,[%o7+%i0]	! R1
    t.or0o0:	orcc	%l0,%l0,%l0	! ##TEMPLATE:%l0,%l0,%l0
    t.or0oy:	add	%g2,2,%g2	! ##TEMPLATE:IAR
    t.or0oz:	add	%g2,4,%g2	! ##TEMPLATE:IAR

	.section ".text"
	.align	4
	.global ci2_xr,ti2_xr,ii2_xr
ci2_xr:
	retl				!
	add	%g0,t.xr0e-t.xr0s,%o0	!
ti2_xr:
	sethi	%hi(t.xr0s),%o3		!
	or	%o3,%lo(t.xr0s),%o3	!
	or	%g0,t.xr0e-t.xr0s,%o4	!
    t.xr0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.xr0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.xr0o0-t.xr0s],%o5!
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	sll	%o4,11,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+t.xr0t0-t.xr0s]!
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	ld	[%o3+t.xr0oy-t.xr0s],%o5!
	bnz,a	.+8			! if EX=1 then IAR+=4
	ld	[%o3+t.xr0oz-t.xr0s],%o5!
	st	%o5,[%o0+t.xr0tz-t.xr0s]!
	retl				!
	add	%o0,t.xr0e-t.xr0s,%o0	!
ii2_xr:
	srl	%o1,16,%o4		! R2
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l2		! %l2
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%i0		! save as %i0
	ld	[%o7+%i0],%l0		! %l0
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	add	%g0,2,%l7		!
	bnz,a	.+8			! if EX=1 then IAR+=4
	add	%g0,4,%l7		!
t.xr0s:
		andn	%g1,3,%g1	! CC=0
    t.xr0t0:	xorcc	%l0,%l2,%l0	! ##TEMPLATE:%l0,%l0,%l0
		bnz,a	t.xr0tz		! if %l0 != 0 then
		or	%g1,1,%g1	!   CC=1
    t.xr0tz:	add	%g2,%l7,%g2	! ##TEMPLATE:IAR
t.xr0e:
		ba	break0		!
		st	%l0,[%o7+%i0]	! R1
    t.xr0o0:	xorcc	%l0,%l0,%l0	! ##TEMPLATE:%l0,%l0,%l0
    t.xr0oy:	add	%g2,2,%g2	! ##TEMPLATE:IAR
    t.xr0oz:	add	%g2,4,%g2	! ##TEMPLATE:IAR

	.section ".text"
	.align	4
	.global ci2_lr,ti2_lr,ii2_lr
ci2_lr:
	retl				!
	add	%g0,t.lr0e-t.lr0s,%o0	!
ti2_lr:
	sethi	%hi(t.lr0s),%o3		!
	or	%o3,%lo(t.lr0s),%o3	!
	or	%g0,t.lr0e-t.lr0s,%o4	!
    t.lr0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.lr0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.lr0o0-t.lr0s],%o5!
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,25,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+t.lr0t0-t.lr0s]!
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	ld	[%o3+t.lr0oy-t.lr0s],%o5!
	bnz,a	.+8			! if EX=1 then IAR+=4
	ld	[%o3+t.lr0oz-t.lr0s],%o5!
	st	%o5,[%o0+t.lr0tz-t.lr0s]!
	retl				!
	add	%o0,t.lr0e-t.lr0s,%o0	!
ii2_lr:
	srl	%o1,16,%o4		! R2
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l2		! %l2
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%i0		! save as %i0
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	add	%g0,2,%l7		!
	bnz,a	.+8			! if EX=1 then IAR+=4
	add	%g0,4,%l7		!
t.lr0s:
    t.lr0t0:	add	%g0,%l2,%l0	! ##TEMPLATE:%l0,%l0
    t.lr0tz:	add	%g2,%l7,%g2	! ##TEMPLATE:IAR
t.lr0e:
		ba	break0		!
		st	%l0,[%o7+%i0]	! R1
    t.lr0o0:	add	%g0,%l0,%l0	! ##TEMPLATE:%l0,%l0
    t.lr0oy:	add	%g2,2,%g2	! ##TEMPLATE:IAR
    t.lr0oz:	add	%g2,4,%g2	! ##TEMPLATE:IAR

	.section ".text"
	.align	4
	.global ci2_cr,ti2_cr,ii2_cr
ci2_cr:
	retl				!
	add	%g0,t.cr0e-t.cr0s,%o0	!
ti2_cr:
	sethi	%hi(t.cr0s),%o3		!
	or	%o3,%lo(t.cr0s),%o3	!
	or	%g0,t.cr0e-t.cr0s,%o4	!
    t.cr0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.cr0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.cr0o0-t.cr0s],%o5!
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+t.cr0t0-t.cr0s]!
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	ld	[%o3+t.cr0oy-t.cr0s],%o5!
	bnz,a	.+8			! if EX=1 then IAR+=4
	ld	[%o3+t.cr0oz-t.cr0s],%o5!
	st	%o5,[%o0+t.cr0tz-t.cr0s]!
	retl				!
	add	%o0,t.cr0e-t.cr0s,%o0	!
ii2_cr:
	srl	%o1,16,%o4		! R2
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l2		! %l2
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l0		! %l0
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	add	%g0,2,%l7		!
	bnz,a	.+8			! if EX=1 then IAR+=4
	add	%g0,4,%l7		!
t.cr0s:
		andn	%g1,3,%g1	! CC=0
    t.cr0t0:	subcc	%l0,%l2,%g0	! ##TEMPLATE:%l0,%l0
		bg,a	t.cr0tz		! if %l0 > 0 then
		or	%g1,2,%g1	!   CC=2
		bl,a	t.cr0tz		! if %l0 < 0 then
		or	%g1,1,%g1	!   CC=1
    t.cr0tz:	add	%g2,%l7,%g2	! ##TEMPLATE:IAR
t.cr0e:
		ba	break0		!
		nop			!
    t.cr0o0:	subcc	%l0,%l0,%g0	! ##TEMPLATE:%l0,%l0
    t.cr0oy:	add	%g2,2,%g2	! ##TEMPLATE:IAR
    t.cr0oz:	add	%g2,4,%g2	! ##TEMPLATE:IAR

	.section ".text"
	.align	4
	.global ci2_ar,ti2_ar,ii2_ar
ci2_ar:
	retl				!
	add	%g0,t.ar0e-t.ar0s,%o0	!
ti2_ar:
	sethi	%hi(t.ar0s),%o3		!
	or	%o3,%lo(t.ar0s),%o3	!
	or	%g0,t.ar0e-t.ar0s,%o4	!
    t.ar0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.ar0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.ar0o0-t.ar0s],%o5!
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	sll	%o4,11,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+t.ar0t0-t.ar0s]!
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	ld	[%o3+t.ar0oy-t.ar0s],%o5!
	bnz,a	.+8			! if EX=1 then IAR+=4
	ld	[%o3+t.ar0oz-t.ar0s],%o5!
	st	%o5,[%o0+t.ar0tz-t.ar0s]!
	retl				!
	add	%o0,t.ar0e-t.ar0s,%o0	!
t.ar0s:
		andn	%g1,3,%g1	! CC=0
    t.ar0t0:	addcc	%l0,%l0,%l0	! ##TEMPLATE:%l0,%l0,%l0
		bvc	t.ar000		! if overflow then
		nop			!
		andcc	%g7,8,%g0	!   CC=3
		bz	t.ar0tz		!   if fixed-point overflow mask then
		or	%g1,3,%g1	!
		sethi	%hi(0x00080000),%o0
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	!     fixed-point overflow
    t.ar000:	bg,a	t.ar0tz		! if %l0 > 0 then
		or	%g1,2,%g1	!   CC=2
		bl,a	t.ar0tz		! if %l0 < 0 then
		or	%g1,1,%g1	!   CC=1
    t.ar0tz:	add	%g2,2,%g2	! ##TEMPLATE:IAR
t.ar0e:
    t.ar0o0:	addcc	%l0,%l0,%l0	! ##TEMPLATE:%l0,%l0,%l0
    t.ar0oy:	add	%g2,2,%g2	! ##TEMPLATE:IAR
    t.ar0oz:	add	%g2,4,%g2	! ##TEMPLATE:IAR
ii2_ar:
	srl	%o1,16,%o4		! R2
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l2		! %l2
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%i0		! save as %i0
	ld	[%o7+%i0],%l0		! %l0
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	add	%g0,2,%l7		!
	bnz,a	.+8			! if EX=1 then IAR+=4
	add	%g0,4,%l7		!
i.ar0s:
		andn	%g1,3,%g1	! CC=0
    i.ar0t0:	addcc	%l0,%l2,%l0	! ##TEMPLATE:%l0,%l0,%l0
		st	%l0,[%o7+%i0]	! R1
		bvc	i.ar000		! if overflow then
		nop			!
		andcc	%g7,8,%g0	!   CC=3
		bz	i.ar0tz		!   if fixed-point overflow mask then
		or	%g1,3,%g1	!
		sethi	%hi(0x00080000),%o0
		ba	epilog0		!
		or	%g7,%o0,%g7	!     fixed-point overflow
    i.ar000:	bg,a	i.ar0tz		! if %l0 > 0 then
		or	%g1,2,%g1	!   CC=2
		bl,a	i.ar0tz		! if %l0 < 0 then
		or	%g1,1,%g1	!   CC=1
    i.ar0tz:	ba	break0		!
		add	%g2,%l7,%g2	! ##TEMPLATE:IAR
i.ar0e:

	.section ".text"
	.align	4
	.global ci2_sr,ti2_sr,ii2_sr
ci2_sr:
	retl				!
	add	%g0,t.sr0e-t.sr0s,%o0	!
ti2_sr:
	sethi	%hi(t.sr0s),%o3		!
	or	%o3,%lo(t.sr0s),%o3	!
	or	%g0,t.sr0e-t.sr0s,%o4	!
    t.sr0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.sr0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.sr0o0-t.sr0s],%o5!
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	sll	%o4,11,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+t.sr0t0-t.sr0s]!
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	ld	[%o3+t.sr0oy-t.sr0s],%o5!
	bnz,a	.+8			! if EX=1 then IAR+=4
	ld	[%o3+t.sr0oz-t.sr0s],%o5!
	st	%o5,[%o0+t.sr0tz-t.sr0s]!
	retl				!
	add	%o0,t.sr0e-t.sr0s,%o0	!
t.sr0s:
		andn	%g1,3,%g1	! CC=0
    t.sr0t0:	subcc	%l0,%l0,%l0	! ##TEMPLATE:%l0,%l0,%l0
		bvc	t.sr000		! if overflow then
		nop			!
		andcc	%g7,8,%g0	!   CC=3
		bz	t.sr0tz		!   if fixed-point overflow mask then
		or	%g1,3,%g1	!
		sethi	%hi(0x00080000),%o0
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	!     fixed-point overflow
    t.sr000:	bg,a	t.sr0tz		! if %l0 > 0 then
		or	%g1,2,%g1	!   CC=2
		bl,a	t.sr0tz		! if %l0 < 0 then
		or	%g1,1,%g1	!   CC=1
    t.sr0tz:	add	%g2,2,%g2	! ##TEMPLATE:IAR
t.sr0e:
    t.sr0o0:	subcc	%l0,%l0,%l0	! ##TEMPLATE:%l0,%l0,%l0
    t.sr0oy:	add	%g2,2,%g2	! ##TEMPLATE:IAR
    t.sr0oz:	add	%g2,4,%g2	! ##TEMPLATE:IAR
ii2_sr:
	srl	%o1,16,%o4		! R2
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l2		! %l2
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%i0		! save as %i0
	ld	[%o7+%i0],%l0		! %l0
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	add	%g0,2,%l7		!
	bnz,a	.+8			! if EX=1 then IAR+=4
	add	%g0,4,%l7		!
i.sr0s:
		andn	%g1,3,%g1	! CC=0
    i.sr0t0:	subcc	%l0,%l2,%l0	! ##TEMPLATE:%l0,%l0,%l0
		st	%l0,[%o7+%i0]	! R1
		bvc	i.sr000		! if overflow then
		nop			!
		andcc	%g7,8,%g0	!   CC=3
		bz	i.sr0tz		!   if fixed-point overflow mask then
		or	%g1,3,%g1	!
		sethi	%hi(0x00080000),%o0
		ba	epilog0		!
		or	%g7,%o0,%g7	!     fixed-point overflow
    i.sr000:	bg,a	i.sr0tz		! if %l0 > 0 then
		or	%g1,2,%g1	!   CC=2
		bl,a	i.sr0tz		! if %l0 < 0 then
		or	%g1,1,%g1	!   CC=1
    i.sr0tz:	ba	break0		!
		add	%g2,%l7,%g2	! ##TEMPLATE:IAR
i.sr0e:

	.section ".text"
	.align	4
	.global ci2_mr,ti2_mr,ii2_mr
ci2_mr:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	c.mr1c			!
	nop				!
    c.mr0c:				!
	retl				! case even:
	add	%g0,t.mr0e-t.mr0s,%o0	!
    c.mr1c:				!
	retl				! case odd:
	add	%g0,t.mr1e-t.mr1s,%o0	!   specification exception
ti2_mr:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	t.mr1t			!
	nop				!
    t.mr0t:				!
	sethi	%hi(t.mr0s),%o3		!
	or	%o3,%lo(t.mr0s),%o3	!
	or	%g0,t.mr0e-t.mr0s,%o4	!
    t.mr0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.mr0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.mr0o0-t.mr0s],%o5!
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1+1
	add	%o4,1,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	sll	%o4,11,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+t.mr0t0-t.mr0s]!
	ld	[%o3+t.mr0o1-t.mr0s],%o5!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,25,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+t.mr0t1-t.mr0s]!
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	ld	[%o3+t.mr0oy-t.mr0s],%o5!
	bnz,a	.+8			! if EX=1 then IAR+=4
	ld	[%o3+t.mr0oz-t.mr0s],%o5!
	st	%o5,[%o0+t.mr0tz-t.mr0s]!
	retl				!
	add	%o0,t.mr0e-t.mr0s,%o0	!
    t.mr1t:				!
	sethi	%hi(t.mr1s),%o3		!
	or	%o3,%lo(t.mr1s),%o3	!
	or	%g0,t.mr1e-t.mr1s,%o4	!
    t.mr1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.mr1cp			!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,t.mr1e-t.mr1s,%o0	!
ii2_mr:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	t.mr1s			!
	nop				!
    i.mr0t:				!
	srl	%o1,16,%o4		! R2
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l2		! %l2
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%i0		! save as %i0
	srl	%o1,20,%o4		! R1+1
	and	%o4,0xf,%o4		! |
	add	%o4,1,%o4		! |
	sll	%o4,2,%i1		! save as %i1
	ld	[%o7+%i1],%l1		! %l1
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	add	%g0,2,%l7		!
	bnz,a	.+8			! if EX=1 then IAR+=4
	add	%g0,4,%l7		!
t.mr0s:
    t.mr0t0:	smul	%l1,%l2,%l1	! ##TEMPLATE:%l0,%l0,%l0
    t.mr0t1:	rd	%y,%l0		! ##TEMPLATE:%l0
    t.mr0tz:	add	%g2,%l7,%g2	! ##TEMPLATE:IAR
t.mr0e:
		st	%l0,[%o7+%i0]	! R1
		ba	break0		!
		st	%l1,[%o7+%i1]	! R1+1
    t.mr0o0:	smul	%l0,%l0,%l0	! ##TEMPLATE:%l0,%l0,%l0
    t.mr0o1:	rd	%y,%l0		! ##TEMPLATE:%l0
    t.mr0oy:	add	%g2,2,%g2	! ##TEMPLATE:IAR
    t.mr0oz:	add	%g2,4,%g2	! ##TEMPLATE:IAR
t.mr1s:
		sethi	%hi(0x00060000),%o0
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! specification exception
t.mr1e:

	.section ".text"
	.align	4
	.global ci2_dr,ti2_dr,ii2_dr
ci2_dr:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	c.dr1c			!
	nop				!
    c.dr0c:				!
	retl				! case even:
	add	%g0,t.dr0e-t.dr0s,%o0	!
    c.dr1c:				!
	retl				! case odd:
	add	%g0,t.dr1e-t.dr1s,%o0	!   specification exception
ti2_dr:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	t.dr1t			!
	nop				!
    t.dr0t:				!
	sethi	%hi(t.dr0s),%o3		!
	or	%o3,%lo(t.dr0s),%o3	!
	or	%g0,t.dr0e-t.dr0s,%o4	!
    t.dr0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.dr0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.dr0o0-t.dr0s],%o5!
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	st	%o5,[%o0+t.dr0t0-t.dr0s]!
	ld	[%o3+t.dr0o1-t.dr0s],%o5!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	st	%o5,[%o0+t.dr0t1-t.dr0s]!
	ld	[%o3+t.dr0o2-t.dr0s],%o5!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1+1
	add	%o4,1,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	st	%o5,[%o0+t.dr0t2-t.dr0s]!
	ld	[%o3+t.dr0o3-t.dr0s],%o5!
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	st	%o5,[%o0+t.dr0t3-t.dr0s]!
	ld	[%o3+t.dr0o4-t.dr0s],%o5!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1+1
	add	%o4,1,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,25,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+t.dr0t4-t.dr0s]!
	ld	[%o3+t.dr0o5-t.dr0s],%o5!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1+1
	add	%o4,1,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,25,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+t.dr0t5-t.dr0s]!
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	ld	[%o3+t.dr0oy-t.dr0s],%o5!
	bnz,a	.+8			! if EX=1 then IAR+=4
	ld	[%o3+t.dr0oz-t.dr0s],%o5!
	st	%o5,[%o0+t.dr0tz-t.dr0s]!
	retl				!
	add	%o0,t.dr0e-t.dr0s,%o0	!
    t.dr1t:				!
	sethi	%hi(t.dr1s),%o3		!
	or	%o3,%lo(t.dr1s),%o3	!
	or	%g0,t.dr1e-t.dr1s,%o4	!
    t.dr1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.dr1cp			!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,t.dr1e-t.dr1s,%o0	!
t.dr0s:
    t.dr0t0:	addcc	%g0,%l0,%g0	! ##TEMPLATE:%l0     R2
		bz	t.dr000		! if R2==0 then int-div. exception
    t.dr0t1:	wr	%g0,%l0,%y	! ##TEMPLATE:%l0     R1
    t.dr0t2:	sdivcc	%l0,%l0,%o1	! ##TEMPLATE:%l0,%l0 R1+1,R2
		bvs	t.dr000		! if overflow then int-div.
    t.dr0t3:	smul	%o1,%l0,%o2	! ##TEMPLATE:%l0     R2
    t.dr0t4:	sub	%l0,%o2,%l0	! ##TEMPLATE:%l0,%l0 R1+1,R1
    t.dr0t5:	add	%g0,%o1,%l0	! ##TEMPLATE:%l0     R1+1
		ba	t.dr0e		!
    t.dr0tz:	add	%g2,2,%g2	! ##TEMPLATE:IAR
    t.dr000:	sethi	%hi(0x00090000),%o0
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! int-div. exception
t.dr0e:
    t.dr0o0:	addcc	%g0,%l0,%g0	! ##TEMPLATE:%l0     R2
    t.dr0o1:	wr	%g0,%l0,%y	! ##TEMPLATE:%l0     R1
    t.dr0o2:	sdivcc	%l0,%l0,%o1	! ##TEMPLATE:%l0,%l0 R1+1,R2
    t.dr0o3:	smul	%o1,%l0,%o2	! ##TEMPLATE:%l0     R2
    t.dr0o4:	sub	%l0,%o2,%l0	! ##TEMPLATE:%l0,%l0 R1+1,R1
    t.dr0o5:	add	%g0,%o1,%l0	! ##TEMPLATE:%l0     R1+1
    t.dr0oy:	add	%g2,2,%g2	! ##TEMPLATE:IAR
    t.dr0oz:	add	%g2,4,%g2	! ##TEMPLATE:IAR
t.dr1s:
		sethi	%hi(0x00060000),%o0
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! specification exception
t.dr1e:
ii2_dr:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	t.dr1s			!
	nop				!
    i.dr0t:				!
	srl	%o1,16,%o4		! R2
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l2		! %l2
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%i0		! save as %i0
	ld	[%o7+%i0],%l0		! %l1
	srl	%o1,20,%o4		! R1+1
	and	%o4,0xf,%o4		! |
	add	%o4,1,%o4		! |
	sll	%o4,2,%i1		! save as %i1
	ld	[%o7+%i1],%l1		! %l1
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	add	%g0,2,%l7		!
	bnz,a	.+8			! if EX=1 then IAR+=4
	add	%g0,4,%l7		!
i.dr0s:
    i.dr0t0:	addcc	%g0,%l2,%g0	! ##TEMPLATE:%l0     R2
		bz	i.dr000		! if R2==0 then int-div. exception
    i.dr0t1:	wr	%g0,%l0,%y	! ##TEMPLATE:%l0     R1
    i.dr0t2:	sdivcc	%l1,%l2,%o1	! ##TEMPLATE:%l0,%l0 R1+1,R2
		bvs	i.dr000		! if overflow then int-div.
    i.dr0t3:	smul	%o1,%l2,%o2	! ##TEMPLATE:%l0     R2
    i.dr0t4:	sub	%l1,%o2,%l0	! ##TEMPLATE:%l0,%l0 R1+1,R1
		st	%l0,[%o7+%i0]	! R1
    i.dr0t5:	add	%g0,%o1,%l1	! ##TEMPLATE:%l0     R1+1
		st	%l1,[%o7+%i1]	! R1+1
		ba	break0		!
    i.dr0tz:	add	%g2,%l7,%g2	! ##TEMPLATE:IAR
    i.dr000:	sethi	%hi(0x00090000),%o0
		ba	epilog0		!
		or	%g7,%o0,%g7	! int-div. exception
i.dr0e:

	.section ".text"
	.align	4
	.global ci2_alr,ti2_alr,ii2_alr
ci2_alr:
	retl				!
	add	%g0,t.alr0e-t.alr0s,%o0	!
ti2_alr:
	sethi	%hi(t.alr0s),%o3	!
	or	%o3,%lo(t.alr0s),%o3	!
	or	%g0,t.alr0e-t.alr0s,%o4	!
    t.alr0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.alr0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.alr0o0-t.alr0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	sll	%o4,11,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+t.alr0t0-t.alr0s]
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	ld	[%o3+t.alr0oy-t.alr0s],%o5
	bnz,a	.+8			! if EX=1 then IAR+=4
	ld	[%o3+t.alr0oz-t.alr0s],%o5
	st	%o5,[%o0+t.alr0tz-t.alr0s]
	retl				!
	add	%o0,t.alr0e-t.alr0s,%o0	!
ii2_alr:
	srl	%o1,16,%o4		! R2
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l2		! %l2
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%i0		! save as %i0
	ld	[%o7+%i0],%l0		! %l0
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	add	%g0,2,%l7		!
	bnz,a	.+8			! if EX=1 then IAR+=4
	add	%g0,4,%l7		!
t.alr0s:
		andn	%g1,3,%g1	! CC=0
    t.alr0t0:	addcc	%l0,%l2,%l0	! ##TEMPLATE:%l0,%l0,%l0
		bcs,a	t.alr000	! if carry then
		or	%g1,2,%g1	!   CC|=2 & skip
		bnz,a	t.alr0tz	! if %l0 != 0 then
		or	%g1,1,%g1	!   CC=1
		ba	t.alr0tz	!
		nop			!
    t.alr000:	bnz,a	t.alr0tz	! if %l0 != 0 then
		or	%g1,1,%g1	!   CC=3
    t.alr0tz:	add	%g2,%l7,%g2	! ##TEMPLATE:IAR
t.alr0e:
		ba	break0		!
		st	%l0,[%o7+%i0]	! R1
    t.alr0o0:	addcc	%l0,%l0,%l0	! ##TEMPLATE:%l0,%l0,%l0
    t.alr0oy:	add	%g2,2,%g2	! ##TEMPLATE:IAR
    t.alr0oz:	add	%g2,4,%g2	! ##TEMPLATE:IAR

	.section ".text"
	.align	4
	.global ci2_slr,ti2_slr,ii2_slr
ci2_slr:
	retl				!
	add	%g0,t.slr0e-t.slr0s,%o0	!
ti2_slr:
	sethi	%hi(t.slr0s),%o3	!
	or	%o3,%lo(t.slr0s),%o3	!
	or	%g0,t.slr0e-t.slr0s,%o4	!
    t.slr0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.slr0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.slr0o0-t.slr0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	sll	%o4,11,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+t.slr0t0-t.slr0s]
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	ld	[%o3+t.slr0oy-t.slr0s],%o5
	bnz,a	.+8			! if EX=1 then IAR+=4
	ld	[%o3+t.slr0oz-t.slr0s],%o5
	st	%o5,[%o0+t.slr0tz-t.slr0s]
	retl				!
	add	%o0,t.slr0e-t.slr0s,%o0	!
ii2_slr:
	srl	%o1,16,%o4		! R2
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l2		! %l2
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%i0		! save as %i0
	ld	[%o7+%i0],%l0		! %l0
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	add	%g0,2,%l7		!
	bnz,a	.+8			! if EX=1 then IAR+=4
	add	%g0,4,%l7		!
t.slr0s:
		andn	%g1,3,%g1	! CC=0
    t.slr0t0:	subcc	%l0,%l2,%l0	! ##TEMPLATE:%l0,%l0,%l0
		bcc,a	t.slr000	! if !carry then
		or	%g1,2,%g1	!   CC|=2 & skip
		bnz,a	t.slr0tz	! if %l0 != 0 then
		or	%g1,1,%g1	!   CC=1
		ba	t.slr0tz	!
		nop			!
    t.slr000:	bnz,a	t.slr0tz	! if %l0 != 0 then
		or	%g1,1,%g1	!   CC=3
    t.slr0tz:	add	%g2,%l7,%g2	! ##TEMPLATE:IAR
t.slr0e:
		ba	break0		!
		st	%l0,[%o7+%i0]	! R1
    t.slr0o0:	subcc	%l0,%l0,%l0	! ##TEMPLATE:%l0,%l0,%l0
    t.slr0oy:	add	%g2,2,%g2	! ##TEMPLATE:IAR
    t.slr0oz:	add	%g2,4,%g2	! ##TEMPLATE:IAR
!================================

!
! templates
! cxx_xxx:
!   %o0: param: none
!	 retval:size of template
!   %o1: M instruction (upper 2 bytes)
!   %o2: work
!   %o3: work
!   %o4: work
!   %o5: work
! txx_xxx:
!   %o0: param: bufp start address
!	 retval:bufp next start address
!   %o1: M instruction (upper 2 bytes)
!   %o2: work
!   %o3: work
!   %o4: work
!   %o5: work
!
	.section ".text"
	.align	4
	.global cf2_lpdr,tf2_lpdr,if2_lpdr
cf2_lpdr:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	c.lpdr1c		!
	nop				!
    c.lpdr0c:				!
	retl				! case even:
	add	%g0,t.lpdr0e-t.lpdr0s,%o0
    c.lpdr1c:				!
	retl				! case odd:
	add	%g0,t.lpdr1e-t.lpdr1s,%o0
tf2_lpdr:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	t.lpdr1t		!
	nop				!
    t.lpdr0t:				!
	sethi	%hi(t.lpdr0s),%o3	!
	or	%o3,%lo(t.lpdr0s),%o3	!
	or	%g0,t.lpdr0e-t.lpdr0s,%o4
    t.lpdr0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.lpdr0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.lpdr0o0-t.lpdr0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+t.lpdr0t0-t.lpdr0s]
	ld	[%o3+t.lpdr0o1-t.lpdr0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+t.lpdr0t1-t.lpdr0s]
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	ld	[%o3+t.lpdr0oy-t.lpdr0s],%o5
	bnz,a	.+8			! if EX=1 then IAR+=4
	ld	[%o3+t.lpdr0oz-t.lpdr0s],%o5
	st	%o5,[%o0+t.lpdr0tz-t.lpdr0s]
	retl				!
	add	%o0,t.lpdr0e-t.lpdr0s,%o0
    t.lpdr1t:				!
	sethi	%hi(t.lpdr1s),%o3	!
	or	%o3,%lo(t.lpdr1s),%o3	!
	or	%g0,t.lpdr1e-t.lpdr1s,%o4
    t.lpdr1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.lpdr1cp		!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,t.lpdr1e-t.lpdr1s,%o0
if2_lpdr:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	t.lpdr1s		!
	nop				!
    i.lpdr0t:				!
	srl	%o1,16,%o4		! R2
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	add	%o4,64,%i2		! %i2
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	add	%o4,64,%i0		! %i0
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	add	%g0,2,%l7		!
	bnz,a	.+8			! if EX=1 then IAR+=4
	add	%g0,4,%l7		!
t.lpdr0s:
		ld	[%sp+184],%o7	! struct *gcpu_s
		andn	%g1,3,%g1	! CC=0
    t.lpdr0t0:	ldd	[%o7+%i2],%o0	! ##TEMPLATE:%imm
		sethi	%hi(0x80000000),%o2
		andn	%o0,%o2,%o0	! set sign
		sll	%o0,8,%o2	!
		orcc	%o2,%o1,%g0	! if fraction == 0 then
		bnz,a	t.lpdr0t1	!      CC=0
		or	%g1,2,%g1	! else CC=2
    t.lpdr0t1:	std	%o0,[%o7+%i0]	! ##TEMPLATE:%imm
    t.lpdr0tz:	add	%g2,%l7,%g2	! ##TEMPLATE:IAR
t.lpdr0e:
		ba	break0		!
		nop			!
    t.lpdr0o0:	ldd	[%o7+64],%o0	! ##TEMPLATE:%imm
    t.lpdr0o1:	std	%o0,[%o7+64]	! ##TEMPLATE:%imm
    t.lpdr0oy:	add	%g2,2,%g2	! ##TEMPLATE:IAR
    t.lpdr0oz:	add	%g2,4,%g2	! ##TEMPLATE:IAR
t.lpdr1s:
		sethi	%hi(0x00060000),%o0
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! specification exception
t.lpdr1e:

	.section ".text"
	.align	4
	.global cf2_lndr,tf2_lndr,if2_lndr
cf2_lndr:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	c.lndr1c		!
	nop				!
    c.lndr0c:				!
	retl				! case even:
	add	%g0,t.lndr0e-t.lndr0s,%o0
    c.lndr1c:				!
	retl				! case odd:
	add	%g0,t.lndr1e-t.lndr1s,%o0
tf2_lndr:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	t.lndr1t		!
	nop				!
    t.lndr0t:				!
	sethi	%hi(t.lndr0s),%o3	!
	or	%o3,%lo(t.lndr0s),%o3	!
	or	%g0,t.lndr0e-t.lndr0s,%o4
    t.lndr0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.lndr0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.lndr0o0-t.lndr0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+t.lndr0t0-t.lndr0s]
	ld	[%o3+t.lndr0o1-t.lndr0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+t.lndr0t1-t.lndr0s]
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	ld	[%o3+t.lndr0oy-t.lndr0s],%o5
	bnz,a	.+8			! if EX=1 then IAR+=4
	ld	[%o3+t.lndr0oz-t.lndr0s],%o5
	st	%o5,[%o0+t.lndr0tz-t.lndr0s]
	retl				!
	add	%o0,t.lndr0e-t.lndr0s,%o0
    t.lndr1t:				!
	sethi	%hi(t.lndr1s),%o3	!
	or	%o3,%lo(t.lndr1s),%o3	!
	or	%g0,t.lndr1e-t.lndr1s,%o4
    t.lndr1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.lndr1cp		!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,t.lndr1e-t.lndr1s,%o0
if2_lndr:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	t.lndr1s		!
	nop				!
    i.lndr0t:				!
	srl	%o1,16,%o4		! R2
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	add	%o4,64,%i2		! %i2
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	add	%o4,64,%i0		! %i0
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	add	%g0,2,%l7		!
	bnz,a	.+8			! if EX=1 then IAR+=4
	add	%g0,4,%l7		!
t.lndr0s:
		ld	[%sp+184],%o7	! struct *gcpu_s
		andn	%g1,3,%g1	! CC=0
    t.lndr0t0:	ldd	[%o7+%i2],%o0	! ##TEMPLATE:%imm
		sethi	%hi(0x80000000),%o2
		or	%o0,%o2,%o0	! set sign
		sll	%o0,8,%o2	!
		orcc	%o2,%o1,%g0	! if fraction == 0 then
		bnz,a	t.lndr0t1	!      CC=0
		or	%g1,1,%g1	! else CC=1
    t.lndr0t1:	std	%o0,[%o7+%i0]	! ##TEMPLATE:%imm
    t.lndr0tz:	add	%g2,%l7,%g2	! ##TEMPLATE:IAR
t.lndr0e:
		ba	break0		!
		nop			!
    t.lndr0o0:	ldd	[%o7+64],%o0	! ##TEMPLATE:%imm
    t.lndr0o1:	std	%o0,[%o7+64]	! ##TEMPLATE:%imm
    t.lndr0oy:	add	%g2,2,%g2	! ##TEMPLATE:IAR
    t.lndr0oz:	add	%g2,4,%g2	! ##TEMPLATE:IAR
t.lndr1s:
		sethi	%hi(0x00060000),%o0
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! specification exception
t.lndr1e:

	.section ".text"
	.align	4
	.global cf2_ltdr,tf2_ltdr,if2_ltdr
cf2_ltdr:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	c.ltdr1c		!
	nop				!
    c.ltdr0c:				!
	retl				! case even:
	add	%g0,t.ltdr0e-t.ltdr0s,%o0
    c.ltdr1c:				!
	retl				! case odd:
	add	%g0,t.ltdr1e-t.ltdr1s,%o0
tf2_ltdr:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	t.ltdr1t		!
	nop				!
    t.ltdr0t:				!
	sethi	%hi(t.ltdr0s),%o3	!
	or	%o3,%lo(t.ltdr0s),%o3	!
	or	%g0,t.ltdr0e-t.ltdr0s,%o4
    t.ltdr0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.ltdr0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.ltdr0o0-t.ltdr0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+t.ltdr0t0-t.ltdr0s]
	ld	[%o3+t.ltdr0o1-t.ltdr0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+t.ltdr0t1-t.ltdr0s]
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	ld	[%o3+t.ltdr0oy-t.ltdr0s],%o5
	bnz,a	.+8			! if EX=1 then IAR+=4
	ld	[%o3+t.ltdr0oz-t.ltdr0s],%o5
	st	%o5,[%o0+t.ltdr0tz-t.ltdr0s]
	retl				!
	add	%o0,t.ltdr0e-t.ltdr0s,%o0
    t.ltdr1t:				!
	sethi	%hi(t.ltdr1s),%o3	!
	or	%o3,%lo(t.ltdr1s),%o3	!
	or	%g0,t.ltdr1e-t.ltdr1s,%o4
    t.ltdr1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.ltdr1cp		!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,t.ltdr1e-t.ltdr1s,%o0
if2_ltdr:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	t.ltdr1s		!
	nop				!
    i.ltdr0t:				!
	srl	%o1,16,%o4		! R2
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	add	%o4,64,%i2		! %i2
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	add	%o4,64,%i0		! %i0
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	add	%g0,2,%l7		!
	bnz,a	.+8			! if EX=1 then IAR+=4
	add	%g0,4,%l7		!
t.ltdr0s:
		ld	[%sp+184],%o7	! struct *gcpu_s
		andn	%g1,3,%g1	! CC=0
    t.ltdr0t0:	ldd	[%o7+%i2],%o0	! ##TEMPLATE:%imm
		sll	%o0,8,%o2	!
		orcc	%o2,%o1,%g0	!
		bz	t.ltdr0t1	! if fraction == 0 then
		subcc	%o0,%g0,%g0	!      CC=0
		bpos,a	t.ltdr0t1	! if %o0 >= 0 then
		or	%g1,2,%g1	!      CC=2
		or	%g1,1,%g1	! else CC=1
    t.ltdr0t1:	std	%o0,[%o7+%i0]	! ##TEMPLATE:%imm
    t.ltdr0tz:	add	%g2,%l7,%g2	! ##TEMPLATE:IAR
t.ltdr0e:
		ba	break0		!
		nop			!
    t.ltdr0o0:	ldd	[%o7+64],%o0	! ##TEMPLATE:%imm
    t.ltdr0o1:	std	%o0,[%o7+64]	! ##TEMPLATE:%imm
    t.ltdr0oy:	add	%g2,2,%g2	! ##TEMPLATE:IAR
    t.ltdr0oz:	add	%g2,4,%g2	! ##TEMPLATE:IAR
t.ltdr1s:
		sethi	%hi(0x00060000),%o0
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! specification exception
t.ltdr1e:

	.section ".text"
	.align	4
	.global cf2_lcdr,tf2_lcdr,if2_lcdr
cf2_lcdr:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	c.lcdr1c		!
	nop				!
    c.lcdr0c:				!
	retl				! case even:
	add	%g0,t.lcdr0e-t.lcdr0s,%o0
    c.lcdr1c:				!
	retl				! case odd:
	add	%g0,t.lcdr1e-t.lcdr1s,%o0
tf2_lcdr:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	t.lcdr1t		!
	nop				!
    t.lcdr0t:				!
	sethi	%hi(t.lcdr0s),%o3	!
	or	%o3,%lo(t.lcdr0s),%o3	!
	or	%g0,t.lcdr0e-t.lcdr0s,%o4
    t.lcdr0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.lcdr0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.lcdr0o0-t.lcdr0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+t.lcdr0t0-t.lcdr0s]
	ld	[%o3+t.lcdr0o1-t.lcdr0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+t.lcdr0t1-t.lcdr0s]
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	ld	[%o3+t.lcdr0oy-t.lcdr0s],%o5
	bnz,a	.+8			! if EX=1 then IAR+=4
	ld	[%o3+t.lcdr0oz-t.lcdr0s],%o5
	st	%o5,[%o0+t.lcdr0tz-t.lcdr0s]
	retl				!
	add	%o0,t.lcdr0e-t.lcdr0s,%o0
    t.lcdr1t:				!
	sethi	%hi(t.lcdr1s),%o3	!
	or	%o3,%lo(t.lcdr1s),%o3	!
	or	%g0,t.lcdr1e-t.lcdr1s,%o4
    t.lcdr1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.lcdr1cp		!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,t.lcdr1e-t.lcdr1s,%o0
if2_lcdr:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	t.lcdr1s		!
	nop				!
    i.lcdr0t:				!
	srl	%o1,16,%o4		! R2
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	add	%o4,64,%i2		! %i2
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	add	%o4,64,%i0		! %i0
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	add	%g0,2,%l7		!
	bnz,a	.+8			! if EX=1 then IAR+=4
	add	%g0,4,%l7		!
t.lcdr0s:
		ld	[%sp+184],%o7	! struct *gcpu_s
		andn	%g1,3,%g1	! CC=0
    t.lcdr0t0:	ldd	[%o7+%i2],%o0	! ##TEMPLATE:%imm
		sethi	%hi(0x80000000),%o2
		xor	%o0,%o2,%o0	! invert sign
		sll	%o0,8,%o2	!
		orcc	%o2,%o1,%g0	!
		bz	t.lcdr0t1	! if fraction == 0 then
		subcc	%o0,%g0,%g0	!      CC=0
		bpos,a	t.lcdr0t1	! if %o0 >= 0 then
		or	%g1,2,%g1	!      CC=2
		or	%g1,1,%g1	! else CC=1
    t.lcdr0t1:	std	%o0,[%o7+%i0]	! ##TEMPLATE:%imm
    t.lcdr0tz:	add	%g2,%l7,%g2	! ##TEMPLATE:IAR
t.lcdr0e:
		ba	break0		!
		nop			!
    t.lcdr0o0:	ldd	[%o7+64],%o0	! ##TEMPLATE:%imm
    t.lcdr0o1:	std	%o0,[%o7+64]	! ##TEMPLATE:%imm
    t.lcdr0oy:	add	%g2,2,%g2	! ##TEMPLATE:IAR
    t.lcdr0oz:	add	%g2,4,%g2	! ##TEMPLATE:IAR
t.lcdr1s:
		sethi	%hi(0x00060000),%o0
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! specification exception
t.lcdr1e:

	.section ".text"
	.align	4
	.global cf2_hdr,tf2_hdr,if2_hdr
cf2_hdr:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	c.hdr1c			!
	nop				!
    c.hdr0c:				!
	retl				! case even:
	add	%g0,t.hdr0e-t.hdr0s,%o0	!
    c.hdr1c:				!
	retl				! case odd:
	add	%g0,t.hdr1e-t.hdr1s,%o0	!   specification exception
tf2_hdr:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	t.hdr1t			!
	nop				!
    t.hdr0t:				!
	sethi	%hi(t.hdr0s),%o3	!
	or	%o3,%lo(t.hdr0s),%o3	!
	or	%g0,t.hdr0e-t.hdr0s,%o4	!
    t.hdr0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.hdr0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.hdr0o0-t.hdr0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+t.hdr0t0-t.hdr0s]
	ld	[%o3+t.hdr0o1-t.hdr0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+t.hdr0t1-t.hdr0s]
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	ld	[%o3+t.hdr0oy-t.hdr0s],%o5
	bnz,a	.+8			! if EX=1 then IAR+=4
	ld	[%o3+t.hdr0oz-t.hdr0s],%o5
	st	%o5,[%o0+t.hdr0tz-t.hdr0s]
	retl				!
	add	%o0,t.hdr0e-t.hdr0s,%o0	!
    t.hdr1t:				!
	sethi	%hi(t.hdr1s),%o3	!
	or	%o3,%lo(t.hdr1s),%o3	!
	or	%g0,t.hdr1e-t.hdr1s,%o4	!
    t.hdr1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.hdr1cp		!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,t.hdr1e-t.hdr1s,%o0	!
if2_hdr:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	t.hdr1s			!
	nop				!
    i.hdr0t:				!
	srl	%o1,16,%o4		! R2
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	add	%o4,64,%i2		! %i2
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	add	%o4,64,%i0		! %i0
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	add	%g0,2,%l7		!
	bnz,a	.+8			! if EX=1 then IAR+=4
	add	%g0,4,%l7		!
t.hdr0s:
		ld	[%sp+184],%o0	! struct *gcpu_s
    t.hdr0t0:	add	%o0,%i2,%o2	! ##TEMPLATE:%imm
    t.hdr0t1:	add	%o0,%i0,%o1	! ##TEMPLATE:%imm
		and	%g7,0xf,%o3	! give Program Mask
		stx	%g1,[%o0+648]	!
		stx	%g2,[%o0+656]	!
		stx	%g3,[%o0+664]	!
		stx	%g4,[%o0+672]	!
		stx	%g5,[%o0+680]	!
		sethi	%hi(fl_halve_long),%o7
		jmpl	%o7+%lo(fl_halve_long),%o7
		nop			! call library in fltlib.s
		ld	[%sp+184],%o7	! struct *gcpu_s
		ldx	[%o7+648],%g1	!
		ldx	[%o7+656],%g2	!
		ldx	[%o7+664],%g3	!
		ldx	[%o7+672],%g4	!
		ldx	[%o7+680],%g5	!
		sethi	%hi(0x00ff0000),%o1
		andcc	%o0,%o1,%o0	! extract exception
		bz,a	t.hdr0e		!   exit
    t.hdr0tz:	add	%g2,%l7,%g2	! ##TEMPLATE:IAR
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! INTR-CODE=retval
t.hdr0e:
		ba	break0		!
		nop			!
    t.hdr0o0:	add	%o0,64,%o2	! ##TEMPLATE:%imm
    t.hdr0o1:	add	%o0,64,%o1	! ##TEMPLATE:%imm
    t.hdr0oy:	add	%g2,2,%g2	! ##TEMPLATE:IAR
    t.hdr0oz:	add	%g2,4,%g2	! ##TEMPLATE:IAR
t.hdr1s:
		sethi	%hi(0x00060000),%o0
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! specification exception
t.hdr1e:

	.section ".text"
	.align	4
	.global cf2_lrdr,tf2_lrdr,if2_lrdr
cf2_lrdr:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	c.lrdr1c		!
	srl	%o1,16,%o4		! switch (R2)
	andcc	%o4,3,%g0		!
	bnz	c.lrdr1c		!
	nop				!
    c.lrdr0c:				!
	retl				! case even:
	add	%g0,t.lrdr0e-t.lrdr0s,%o0
    c.lrdr1c:				!
	retl				! case odd:
	add	%g0,t.lrdr1e-t.lrdr1s,%o0
tf2_lrdr:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	t.lrdr1t		!
	srl	%o1,16,%o4		! switch (R2)
	andcc	%o4,3,%g0		!
	bnz	t.lrdr1t		!
	nop				!
    t.lrdr0t:				!
	sethi	%hi(t.lrdr0s),%o3	!
	or	%o3,%lo(t.lrdr0s),%o3	!
	or	%g0,t.lrdr0e-t.lrdr0s,%o4
    t.lrdr0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.lrdr0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.lrdr0o0-t.lrdr0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+t.lrdr0t0-t.lrdr0s]
	ld	[%o3+t.lrdr0o1-t.lrdr0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+t.lrdr0t1-t.lrdr0s]
	ld	[%o3+t.lrdr0o2-t.lrdr0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+t.lrdr0t2-t.lrdr0s]
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	ld	[%o3+t.lrdr0oy-t.lrdr0s],%o5
	bnz,a	.+8			! if EX=1 then IAR+=4
	ld	[%o3+t.lrdr0oz-t.lrdr0s],%o5
	st	%o5,[%o0+t.lrdr0tz-t.lrdr0s]
	retl				!
	add	%o0,t.lrdr0e-t.lrdr0s,%o0
    t.lrdr1t:				!
	sethi	%hi(t.lrdr1s),%o3	!
	or	%o3,%lo(t.lrdr1s),%o3	!
	or	%g0,t.lrdr1e-t.lrdr1s,%o4
    t.lrdr1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.lrdr1cp		!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,t.lrdr1e-t.lrdr1s,%o0
if2_lrdr:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	t.lrdr1s		!
	srl	%o1,16,%o4		! switch (R2)
	andcc	%o4,3,%g0		!
	bnz	t.lrdr1s		!
	nop				!
    i.lrdr0t:				!
	srl	%o1,16,%o4		! R2
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	add	%o4,64,%i2		! %i2
	add	%i2,8,%i3		! %i3
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	add	%o4,64,%i0		! %i0
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	add	%g0,2,%l7		!
	bnz,a	.+8			! if EX=1 then IAR+=4
	add	%g0,4,%l7		!
t.lrdr0s:
		ld	[%sp+184],%o7	! struct *gcpu_s
    t.lrdr0t0:	ldd	[%o7+%i2],%o0	! ##TEMPLATE:%imm
    t.lrdr0t1:	ld	[%o7+%i3],%o2	! ##TEMPLATE:%imm
		sll	%o2,8,%o2	!
		sethi	%hi(0x80000000),%o4
		addcc	%o2,%o4,%g0	! if no carry-in then
		bcc	t.lrdr0t2	!   skip
		nop			!
		addcc	%o1,1,%o1	! add fraction(L) with 1
		bcc	t.lrdr0t2	! if no carry-out(L) then
		sll	%o0,8,%o3	!   skip
		addcc	%o3,0x100,%g0	! if no carry-out(H) then
		bcc,a	t.lrdr0t2	!   add fraction with 1
		add	%o0,1,%o0	!   skip
		sll	%o0,8,%o3	! add fraction with 1
		srl	%o3,8,%o3	!
		add	%o3,1,%o3	!
		srl	%o3,4,%o3	! shift fraction right 4bits
		srl	%o0,24,%o2	! add characteristic with 1
		sll	%o2,25,%o2	!
		sethi	%hi(0x02000000),%o4
		addcc	%o2,%o4,%o2	!
		srl	%o0,31,%o0	! extract sign bit
		sll	%o0,31,%o0	!
		srl	%o2,1,%o2	! extract characteristic
		or	%o0,%o2,%o0	! merge characteristic
		or	%o0,%o3,%o0	! merge fraction
    t.lrdr0t2:	std	%o0,[%o7+%i0]	! ##TEMPLATE:%imm
		bcc,a	t.lrdr0e	! if characteristic overflow then
    t.lrdr0tz:	add	%g2,%l7,%g2	! ##TEMPLATE:IAR
		sethi	%hi(0x000C0000),%o0
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	!     exponent overflow
t.lrdr0e:
		ba	break0		!
		nop			!
    t.lrdr0o0:	ldd	[%o7+64],%o0	! ##TEMPLATE:%imm
    t.lrdr0o1:	ld	[%o7+72],%o2	! ##TEMPLATE:%imm
    t.lrdr0o2:	std	%o0,[%o7+64]	! ##TEMPLATE:%imm
    t.lrdr0oy:	add	%g2,2,%g2	! ##TEMPLATE:IAR
    t.lrdr0oz:	add	%g2,4,%g2	! ##TEMPLATE:IAR
t.lrdr1s:
		sethi	%hi(0x00060000),%o0
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! specification exception
t.lrdr1e:

	.section ".text"
	.align	4
	.global cf2_mxr,tf2_mxr,if2_mxr
cf2_mxr:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,3,%g0		!
	bnz	c.mxr1c			!
	nop				!
    c.mxr0c:				!
	retl				! case even:
	add	%g0,t.mxr0e-t.mxr0s,%o0	!
    c.mxr1c:				!
	retl				! case odd:
	add	%g0,t.mxr1e-t.mxr1s,%o0	!   specification exception
tf2_mxr:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,3,%g0		!
	bnz	t.mxr1t			!
	nop				!
    t.mxr0t:				!
	sethi	%hi(t.mxr0s),%o3	!
	or	%o3,%lo(t.mxr0s),%o3	!
	or	%g0,t.mxr0e-t.mxr0s,%o4	!
    t.mxr0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.mxr0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.mxr0o0-t.mxr0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+t.mxr0t0-t.mxr0s]
	ld	[%o3+t.mxr0o1-t.mxr0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+t.mxr0t1-t.mxr0s]
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	ld	[%o3+t.mxr0oy-t.mxr0s],%o5
	bnz,a	.+8			! if EX=1 then IAR+=4
	ld	[%o3+t.mxr0oz-t.mxr0s],%o5
	st	%o5,[%o0+t.mxr0tz-t.mxr0s]
	retl				!
	add	%o0,t.mxr0e-t.mxr0s,%o0	!
    t.mxr1t:				!
	sethi	%hi(t.mxr1s),%o3	!
	or	%o3,%lo(t.mxr1s),%o3	!
	or	%g0,t.mxr1e-t.mxr1s,%o4	!
    t.mxr1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.mxr1cp		!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,t.mxr1e-t.mxr1s,%o0	!
if2_mxr:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,3,%g0		!
	bnz	t.mxr1s			!
	nop				!
    i.mxr0t:				!
	srl	%o1,16,%o4		! R2
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	add	%o4,64,%i2		! %i2
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	add	%o4,64,%i0		! %i0
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	add	%g0,2,%l7		!
	bnz,a	.+8			! if EX=1 then IAR+=4
	add	%g0,4,%l7		!
t.mxr0s:
		ld	[%sp+184],%o0	! struct *gcpu_s
    t.mxr0t0:	add	%o0,%i2,%o2	! ##TEMPLATE:%imm
    t.mxr0t1:	add	%o0,%i0,%o1	! ##TEMPLATE:%imm
		and	%g7,0xf,%o3	! give Program Mask
		stx	%g1,[%o0+648]	!
		stx	%g2,[%o0+656]	!
		stx	%g3,[%o0+664]	!
		stx	%g4,[%o0+672]	!
		stx	%g5,[%o0+680]	!
		sethi	%hi(fl_mult_ext2ext),%o7
		jmpl	%o7+%lo(fl_mult_ext2ext),%o7
		nop			! call library in fltlib.s
		ld	[%sp+184],%o7	! struct *gcpu_s
		ldx	[%o7+648],%g1	!
		ldx	[%o7+656],%g2	!
		ldx	[%o7+664],%g3	!
		ldx	[%o7+672],%g4	!
		ldx	[%o7+680],%g5	!
		sethi	%hi(0x00ff0000),%o1
		andcc	%o0,%o1,%o0	! extract exception
		bz,a	t.mxr0e		!   exit
    t.mxr0tz:	add	%g2,%l7,%g2	! ##TEMPLATE:IAR
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! INTR-CODE=retval
t.mxr0e:
		ba	break0		!
		nop			!
    t.mxr0o0:	add	%o0,64,%o2	! ##TEMPLATE:%imm
    t.mxr0o1:	add	%o0,64,%o1	! ##TEMPLATE:%imm
    t.mxr0oy:	add	%g2,2,%g2	! ##TEMPLATE:IAR
    t.mxr0oz:	add	%g2,4,%g2	! ##TEMPLATE:IAR
t.mxr1s:
		sethi	%hi(0x00060000),%o0
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! specification exception
t.mxr1e:

	.section ".text"
	.align	4
	.global cf2_mxdr,tf2_mxdr,if2_mxdr
cf2_mxdr:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,3,%g0		!
	bnz	c.mxdr1c		!
	srl	%o1,16,%o4		! switch (R2)
	andcc	%o4,1,%g0		!
	bnz	c.mxdr1c		!
	nop				!
    c.mxdr0c:				!
	retl				! case even:
	add	%g0,t.mxdr0e-t.mxdr0s,%o0
    c.mxdr1c:				!
	retl				! case odd:
	add	%g0,t.mxdr1e-t.mxdr1s,%o0
tf2_mxdr:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,3,%g0		!
	bnz	t.mxdr1t		!
	srl	%o1,16,%o4		! switch (R2)
	andcc	%o4,1,%g0		!
	bnz	t.mxdr1t		!
	nop				!
    t.mxdr0t:				!
	sethi	%hi(t.mxdr0s),%o3	!
	or	%o3,%lo(t.mxdr0s),%o3	!
	or	%g0,t.mxdr0e-t.mxdr0s,%o4
    t.mxdr0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.mxdr0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.mxdr0o0-t.mxdr0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+t.mxdr0t0-t.mxdr0s]
	ld	[%o3+t.mxdr0o1-t.mxdr0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+t.mxdr0t1-t.mxdr0s]
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	ld	[%o3+t.mxdr0oy-t.mxdr0s],%o5
	bnz,a	.+8			! if EX=1 then IAR+=4
	ld	[%o3+t.mxdr0oz-t.mxdr0s],%o5
	st	%o5,[%o0+t.mxdr0tz-t.mxdr0s]
	retl				!
	add	%o0,t.mxdr0e-t.mxdr0s,%o0
    t.mxdr1t:				!
	sethi	%hi(t.mxdr1s),%o3	!
	or	%o3,%lo(t.mxdr1s),%o3	!
	or	%g0,t.mxdr1e-t.mxdr1s,%o4
    t.mxdr1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.mxdr1cp		!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,t.mxdr1e-t.mxdr1s,%o0
if2_mxdr:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,3,%g0		!
	bnz	t.mxdr1s		!
	srl	%o1,16,%o4		! switch (R2)
	andcc	%o4,1,%g0		!
	bnz	t.mxdr1s		!
	nop				!
    i.mxdr0t:				!
	srl	%o1,16,%o4		! R2
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	add	%o4,64,%i2		! %i2
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	add	%o4,64,%i0		! %i0
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	add	%g0,2,%l7		!
	bnz,a	.+8			! if EX=1 then IAR+=4
	add	%g0,4,%l7		!
t.mxdr0s:
		ld	[%sp+184],%o0	! struct *gcpu_s
    t.mxdr0t0:	add	%o0,%i2,%o2	! ##TEMPLATE:%imm
    t.mxdr0t1:	add	%o0,%i0,%o1	! ##TEMPLATE:%imm
		and	%g7,0xf,%o3	! give Program Mask
		stx	%g1,[%o0+648]	!
		stx	%g2,[%o0+656]	!
		stx	%g3,[%o0+664]	!
		stx	%g4,[%o0+672]	!
		stx	%g5,[%o0+680]	!
		sethi	%hi(fl_mult_long2ext),%o7
		jmpl	%o7+%lo(fl_mult_long2ext),%o7
		nop			! call library in fltlib.s
		ld	[%sp+184],%o7	! struct *gcpu_s
		ldx	[%o7+648],%g1	!
		ldx	[%o7+656],%g2	!
		ldx	[%o7+664],%g3	!
		ldx	[%o7+672],%g4	!
		ldx	[%o7+680],%g5	!
		sethi	%hi(0x00ff0000),%o1
		andcc	%o0,%o1,%o0	! extract exception
		bz,a	t.mxdr0e	!   exit
    t.mxdr0tz:	add	%g2,%l7,%g2	! ##TEMPLATE:IAR
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! INTR-CODE=retval
t.mxdr0e:
		ba	break0		!
		nop			!
    t.mxdr0o0:	add	%o0,64,%o2	! ##TEMPLATE:%imm
    t.mxdr0o1:	add	%o0,64,%o1	! ##TEMPLATE:%imm
    t.mxdr0oy:	add	%g2,2,%g2	! ##TEMPLATE:IAR
    t.mxdr0oz:	add	%g2,4,%g2	! ##TEMPLATE:IAR
t.mxdr1s:
		sethi	%hi(0x00060000),%o0
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! specification exception
t.mxdr1e:

	.section ".text"
	.align	4
	.global cf2_ldr,tf2_ldr,if2_ldr
cf2_ldr:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	c.ldr1c			!
	nop				!
    c.ldr0c:				!
	retl				! case even:
	add	%g0,t.ldr0e-t.ldr0s,%o0	!
    c.ldr1c:				!
	retl				! case odd:
	add	%g0,t.ldr1e-t.ldr1s,%o0	!   specification exception
tf2_ldr:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	t.ldr1t			!
	nop				!
    t.ldr0t:				!
	sethi	%hi(t.ldr0s),%o3	!
	or	%o3,%lo(t.ldr0s),%o3	!
	or	%g0,t.ldr0e-t.ldr0s,%o4	!
    t.ldr0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.ldr0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.ldr0o0-t.ldr0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+t.ldr0t0-t.ldr0s]
	ld	[%o3+t.ldr0o1-t.ldr0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+t.ldr0t1-t.ldr0s]
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	ld	[%o3+t.ldr0oy-t.ldr0s],%o5
	bnz,a	.+8			! if EX=1 then IAR+=4
	ld	[%o3+t.ldr0oz-t.ldr0s],%o5
	st	%o5,[%o0+t.ldr0tz-t.ldr0s]
	retl				!
	add	%o0,t.ldr0e-t.ldr0s,%o0	!
    t.ldr1t:				!
	sethi	%hi(t.ldr1s),%o3	!
	or	%o3,%lo(t.ldr1s),%o3	!
	or	%g0,t.ldr1e-t.ldr1s,%o4	!
    t.ldr1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.ldr1cp		!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,t.ldr1e-t.ldr1s,%o0	!
if2_ldr:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	t.ldr1s			!
	nop				!
    i.ldr0t:				!
	srl	%o1,16,%o4		! R2
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	add	%o4,64,%i2		! %i2
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	add	%o4,64,%i0		! %i0
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	add	%g0,2,%l7		!
	bnz,a	.+8			! if EX=1 then IAR+=4
	add	%g0,4,%l7		!
t.ldr0s:
		ld	[%sp+184],%o7	! struct *gcpu_s
    t.ldr0t0:	ldd	[%o7+%i2],%o0	! ##TEMPLATE:%imm
    t.ldr0t1:	std	%o0,[%o7+%i0]	! ##TEMPLATE:%imm
    t.ldr0tz:	add	%g2,%l7,%g2	! ##TEMPLATE:IAR
t.ldr0e:
		ba	break0		!
		nop			!
    t.ldr0o0:	ldd	[%o7+64],%o0	! ##TEMPLATE:%imm
    t.ldr0o1:	std	%o0,[%o7+64]	! ##TEMPLATE:%imm
    t.ldr0oy:	add	%g2,2,%g2	! ##TEMPLATE:IAR
    t.ldr0oz:	add	%g2,4,%g2	! ##TEMPLATE:IAR
t.ldr1s:
		sethi	%hi(0x00060000),%o0
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! specification exception
t.ldr1e:

	.section ".text"
	.align	4
	.global cf2_cdr,tf2_cdr,if2_cdr
cf2_cdr:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	c.cdr1c			!
	nop				!
    c.cdr0c:				!
	retl				! case even:
	add	%g0,t.cdr0e-t.cdr0s,%o0	!
    c.cdr1c:				!
	retl				! case odd:
	add	%g0,t.cdr1e-t.cdr1s,%o0	!   specification exception
tf2_cdr:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	t.cdr1t			!
	nop				!
    t.cdr0t:				!
	sethi	%hi(t.cdr0s),%o3	!
	or	%o3,%lo(t.cdr0s),%o3	!
	or	%g0,t.cdr0e-t.cdr0s,%o4	!
    t.cdr0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.cdr0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.cdr0o0-t.cdr0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+t.cdr0t0-t.cdr0s]
	ld	[%o3+t.cdr0o1-t.cdr0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+t.cdr0t1-t.cdr0s]
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	ld	[%o3+t.cdr0oy-t.cdr0s],%o5
	bnz,a	.+8			! if EX=1 then IAR+=4
	ld	[%o3+t.cdr0oz-t.cdr0s],%o5
	st	%o5,[%o0+t.cdr0tz-t.cdr0s]
	retl				!
	add	%o0,t.cdr0e-t.cdr0s,%o0	!
    t.cdr1t:				!
	sethi	%hi(t.cdr1s),%o3	!
	or	%o3,%lo(t.cdr1s),%o3	!
	or	%g0,t.cdr1e-t.cdr1s,%o4	!
    t.cdr1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.cdr1cp		!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,t.cdr1e-t.cdr1s,%o0	!
if2_cdr:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	t.cdr1s			!
	nop				!
    i.cdr0t:				!
	srl	%o1,16,%o4		! R2
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	add	%o4,64,%i2		! %i2
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	add	%o4,64,%i0		! %i0
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	add	%g0,2,%l7		!
	bnz,a	.+8			! if EX=1 then IAR+=4
	add	%g0,4,%l7		!
t.cdr0s:
		ld	[%sp+184],%o0	! struct *gcpu_s
    t.cdr0t0:	add	%o0,%i2,%o2	! ##TEMPLATE:%imm
    t.cdr0t1:	add	%o0,%i0,%o1	! ##TEMPLATE:%imm
		and	%g7,0xf,%o3	! give Program Mask
		stx	%g1,[%o0+648]	!
		stx	%g2,[%o0+656]	!
		stx	%g3,[%o0+664]	!
		stx	%g4,[%o0+672]	!
		stx	%g5,[%o0+680]	!
		sethi	%hi(fl_comp_long),%o7
		jmpl	%o7+%lo(fl_comp_long),%o7
		nop			! call library in fltlib.s
		ld	[%sp+184],%o7	! struct *gcpu_s
		ldx	[%o7+648],%g1	!
		ldx	[%o7+656],%g2	!
		ldx	[%o7+664],%g3	!
		ldx	[%o7+672],%g4	!
		ldx	[%o7+680],%g5	!
		and	%o0,3,%g1	! CC=retval
    t.cdr0tz:	add	%g2,%l7,%g2	! ##TEMPLATE:IAR
t.cdr0e:
		ba	break0		!
		nop			!
    t.cdr0o0:	add	%o0,64,%o2	! ##TEMPLATE:%imm
    t.cdr0o1:	add	%o0,64,%o1	! ##TEMPLATE:%imm
    t.cdr0oy:	add	%g2,2,%g2	! ##TEMPLATE:IAR
    t.cdr0oz:	add	%g2,4,%g2	! ##TEMPLATE:IAR
t.cdr1s:
		sethi	%hi(0x00060000),%o0
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! specification exception
t.cdr1e:

	.section ".text"
	.align	4
	.global cf2_adr,tf2_adr,if2_adr
cf2_adr:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	c.adr1c			!
	nop				!
    c.adr0c:				!
	retl				! case even:
	add	%g0,t.adr0e-t.adr0s,%o0	!
    c.adr1c:				!
	retl				! case odd:
	add	%g0,t.adr1e-t.adr1s,%o0	!   specification exception
tf2_adr:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	t.adr1t			!
	nop				!
    t.adr0t:				!
	sethi	%hi(t.adr0s),%o3	!
	or	%o3,%lo(t.adr0s),%o3	!
	or	%g0,t.adr0e-t.adr0s,%o4	!
    t.adr0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.adr0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.adr0o0-t.adr0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+t.adr0t0-t.adr0s]
	ld	[%o3+t.adr0o1-t.adr0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+t.adr0t1-t.adr0s]
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	ld	[%o3+t.adr0oy-t.adr0s],%o5
	bnz,a	.+8			! if EX=1 then IAR+=4
	ld	[%o3+t.adr0oz-t.adr0s],%o5
	st	%o5,[%o0+t.adr0tz-t.adr0s]
	retl				!
	add	%o0,t.adr0e-t.adr0s,%o0	!
    t.adr1t:				!
	sethi	%hi(t.adr1s),%o3	!
	or	%o3,%lo(t.adr1s),%o3	!
	or	%g0,t.adr1e-t.adr1s,%o4	!
    t.adr1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.adr1cp		!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,t.adr1e-t.adr1s,%o0	!
if2_adr:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	t.adr1s			!
	nop				!
    i.adr0t:				!
	srl	%o1,16,%o4		! R2
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	add	%o4,64,%i2		! %i2
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	add	%o4,64,%i0		! %i0
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	add	%g0,2,%l7		!
	bnz,a	.+8			! if EX=1 then IAR+=4
	add	%g0,4,%l7		!
t.adr0s:
		ld	[%sp+184],%o0	! struct *gcpu_s
    t.adr0t0:	add	%o0,%i2,%o2	! ##TEMPLATE:%imm
    t.adr0t1:	add	%o0,%i0,%o1	! ##TEMPLATE:%imm
		and	%g7,0xf,%o3	! give Program Mask
		stx	%g1,[%o0+648]	!
		stx	%g2,[%o0+656]	!
		stx	%g3,[%o0+664]	!
		stx	%g4,[%o0+672]	!
		stx	%g5,[%o0+680]	!
		sethi	%hi(fl_addsub_long_norm),%o7
		jmpl	%o7+%lo(fl_addsub_long_norm),%o7
		add	%g0,0,%o4	! call library in fltlib.s
		ld	[%sp+184],%o7	! struct *gcpu_s
		ldx	[%o7+648],%g1	!
		ldx	[%o7+656],%g2	!
		ldx	[%o7+664],%g3	!
		ldx	[%o7+672],%g4	!
		ldx	[%o7+680],%g5	!
		and	%o0,3,%g1	! CC=retval
		sethi	%hi(0x00ff0000),%o1
		andcc	%o0,%o1,%o0	! extract exception
		bz,a	t.adr0e		!   exit
    t.adr0tz:	add	%g2,%l7,%g2	! ##TEMPLATE:IAR
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! INTR-CODE=retval
t.adr0e:
		ba	break0		!
		nop			!
    t.adr0o0:	add	%o0,64,%o2	! ##TEMPLATE:%imm
    t.adr0o1:	add	%o0,64,%o1	! ##TEMPLATE:%imm
    t.adr0oy:	add	%g2,2,%g2	! ##TEMPLATE:IAR
    t.adr0oz:	add	%g2,4,%g2	! ##TEMPLATE:IAR
t.adr1s:
		sethi	%hi(0x00060000),%o0
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! specification exception
t.adr1e:

	.section ".text"
	.align	4
	.global cf2_sdr,tf2_sdr,if2_sdr
cf2_sdr:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	c.sdr1c			!
	nop				!
    c.sdr0c:				!
	retl				! case even:
	add	%g0,t.sdr0e-t.sdr0s,%o0	!
    c.sdr1c:				!
	retl				! case odd:
	add	%g0,t.sdr1e-t.sdr1s,%o0	!   specification exception
tf2_sdr:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	t.sdr1t			!
	nop				!
    t.sdr0t:				!
	sethi	%hi(t.sdr0s),%o3	!
	or	%o3,%lo(t.sdr0s),%o3	!
	or	%g0,t.sdr0e-t.sdr0s,%o4	!
    t.sdr0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.sdr0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.sdr0o0-t.sdr0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+t.sdr0t0-t.sdr0s]
	ld	[%o3+t.sdr0o1-t.sdr0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+t.sdr0t1-t.sdr0s]
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	ld	[%o3+t.sdr0oy-t.sdr0s],%o5
	bnz,a	.+8			! if EX=1 then IAR+=4
	ld	[%o3+t.sdr0oz-t.sdr0s],%o5
	st	%o5,[%o0+t.sdr0tz-t.sdr0s]
	retl				!
	add	%o0,t.sdr0e-t.sdr0s,%o0	!
    t.sdr1t:				!
	sethi	%hi(t.sdr1s),%o3	!
	or	%o3,%lo(t.sdr1s),%o3	!
	or	%g0,t.sdr1e-t.sdr1s,%o4	!
    t.sdr1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.sdr1cp		!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,t.sdr1e-t.sdr1s,%o0	!
if2_sdr:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	t.sdr1s			!
	nop				!
    i.sdr0t:				!
	srl	%o1,16,%o4		! R2
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	add	%o4,64,%i2		! %i2
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	add	%o4,64,%i0		! %i0
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	add	%g0,2,%l7		!
	bnz,a	.+8			! if EX=1 then IAR+=4
	add	%g0,4,%l7		!
t.sdr0s:
		ld	[%sp+184],%o0	! struct *gcpu_s
    t.sdr0t0:	add	%o0,%i2,%o2	! ##TEMPLATE:%imm
    t.sdr0t1:	add	%o0,%i0,%o1	! ##TEMPLATE:%imm
		and	%g7,0xf,%o3	! give Program Mask
		stx	%g1,[%o0+648]	!
		stx	%g2,[%o0+656]	!
		stx	%g3,[%o0+664]	!
		stx	%g4,[%o0+672]	!
		stx	%g5,[%o0+680]	!
		sethi	%hi(fl_addsub_long_norm),%o7
		jmpl	%o7+%lo(fl_addsub_long_norm),%o7
		add	%g0,1,%o4	! call library in fltlib.s
		ld	[%sp+184],%o7	! struct *gcpu_s
		ldx	[%o7+648],%g1	!
		ldx	[%o7+656],%g2	!
		ldx	[%o7+664],%g3	!
		ldx	[%o7+672],%g4	!
		ldx	[%o7+680],%g5	!
		and	%o0,3,%g1	! CC=retval
		sethi	%hi(0x00ff0000),%o1
		andcc	%o0,%o1,%o0	! extract exception
		bz,a	t.sdr0e		!   exit
    t.sdr0tz:	add	%g2,%l7,%g2	! ##TEMPLATE:IAR
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! INTR-CODE=retval
t.sdr0e:
		ba	break0		!
		nop			!
    t.sdr0o0:	add	%o0,64,%o2	! ##TEMPLATE:%imm
    t.sdr0o1:	add	%o0,64,%o1	! ##TEMPLATE:%imm
    t.sdr0oy:	add	%g2,2,%g2	! ##TEMPLATE:IAR
    t.sdr0oz:	add	%g2,4,%g2	! ##TEMPLATE:IAR
t.sdr1s:
		sethi	%hi(0x00060000),%o0
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! specification exception
t.sdr1e:

	.section ".text"
	.align	4
	.global cf2_mdr,tf2_mdr,if2_mdr
cf2_mdr:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	c.mdr1c			!
	nop				!
    c.mdr0c:				!
	retl				! case even:
	add	%g0,t.mdr0e-t.mdr0s,%o0	!
    c.mdr1c:				!
	retl				! case odd:
	add	%g0,t.mdr1e-t.mdr1s,%o0	!   specification exception
tf2_mdr:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	t.mdr1t			!
	nop				!
    t.mdr0t:				!
	sethi	%hi(t.mdr0s),%o3	!
	or	%o3,%lo(t.mdr0s),%o3	!
	or	%g0,t.mdr0e-t.mdr0s,%o4	!
    t.mdr0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.mdr0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.mdr0o0-t.mdr0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+t.mdr0t0-t.mdr0s]
	ld	[%o3+t.mdr0o1-t.mdr0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+t.mdr0t1-t.mdr0s]
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	ld	[%o3+t.mdr0oy-t.mdr0s],%o5
	bnz,a	.+8			! if EX=1 then IAR+=4
	ld	[%o3+t.mdr0oz-t.mdr0s],%o5
	st	%o5,[%o0+t.mdr0tz-t.mdr0s]
	retl				!
	add	%o0,t.mdr0e-t.mdr0s,%o0	!
    t.mdr1t:				!
	sethi	%hi(t.mdr1s),%o3	!
	or	%o3,%lo(t.mdr1s),%o3	!
	or	%g0,t.mdr1e-t.mdr1s,%o4	!
    t.mdr1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.mdr1cp		!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,t.mdr1e-t.mdr1s,%o0	!
if2_mdr:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	t.mdr1s			!
	nop				!
    i.mdr0t:				!
	srl	%o1,16,%o4		! R2
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	add	%o4,64,%i2		! %i2
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	add	%o4,64,%i0		! %i0
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	add	%g0,2,%l7		!
	bnz,a	.+8			! if EX=1 then IAR+=4
	add	%g0,4,%l7		!
t.mdr0s:
		ld	[%sp+184],%o0	! struct *gcpu_s
    t.mdr0t0:	add	%o0,%i2,%o2	! ##TEMPLATE:%imm
    t.mdr0t1:	add	%o0,%i0,%o1	! ##TEMPLATE:%imm
		and	%g7,0xf,%o3	! give Program Mask
		stx	%g1,[%o0+648]	!
		stx	%g2,[%o0+656]	!
		stx	%g3,[%o0+664]	!
		stx	%g4,[%o0+672]	!
		stx	%g5,[%o0+680]	!
		sethi	%hi(fl_mult_long2long),%o7
		jmpl	%o7+%lo(fl_mult_long2long),%o7
		nop			! call library in fltlib.s
		ld	[%sp+184],%o7	! struct *gcpu_s
		ldx	[%o7+648],%g1	!
		ldx	[%o7+656],%g2	!
		ldx	[%o7+664],%g3	!
		ldx	[%o7+672],%g4	!
		ldx	[%o7+680],%g5	!
		sethi	%hi(0x00ff0000),%o1
		andcc	%o0,%o1,%o0	! extract exception
		bz,a	t.mdr0e		!   exit
    t.mdr0tz:	add	%g2,%l7,%g2	! ##TEMPLATE:IAR
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! INTR-CODE=retval
t.mdr0e:
		ba	break0		!
		nop			!
    t.mdr0o0:	add	%o0,64,%o2	! ##TEMPLATE:%imm
    t.mdr0o1:	add	%o0,64,%o1	! ##TEMPLATE:%imm
    t.mdr0oy:	add	%g2,2,%g2	! ##TEMPLATE:IAR
    t.mdr0oz:	add	%g2,4,%g2	! ##TEMPLATE:IAR
t.mdr1s:
		sethi	%hi(0x00060000),%o0
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! specification exception
t.mdr1e:

	.section ".text"
	.align	4
	.global cf2_ddr,tf2_ddr,if2_ddr
cf2_ddr:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	c.ddr1c			!
	nop				!
    c.ddr0c:				!
	retl				! case even:
	add	%g0,t.ddr0e-t.ddr0s,%o0	!
    c.ddr1c:				!
	retl				! case odd:
	add	%g0,t.ddr1e-t.ddr1s,%o0	!   specification exception
tf2_ddr:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	t.ddr1t			!
	nop				!
    t.ddr0t:				!
	sethi	%hi(t.ddr0s),%o3	!
	or	%o3,%lo(t.ddr0s),%o3	!
	or	%g0,t.ddr0e-t.ddr0s,%o4	!
    t.ddr0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.ddr0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.ddr0o0-t.ddr0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+t.ddr0t0-t.ddr0s]
	ld	[%o3+t.ddr0o1-t.ddr0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+t.ddr0t1-t.ddr0s]
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	ld	[%o3+t.ddr0oy-t.ddr0s],%o5
	bnz,a	.+8			! if EX=1 then IAR+=4
	ld	[%o3+t.ddr0oz-t.ddr0s],%o5
	st	%o5,[%o0+t.ddr0tz-t.ddr0s]
	retl				!
	add	%o0,t.ddr0e-t.ddr0s,%o0	!
    t.ddr1t:				!
	sethi	%hi(t.ddr1s),%o3	!
	or	%o3,%lo(t.ddr1s),%o3	!
	or	%g0,t.ddr1e-t.ddr1s,%o4	!
    t.ddr1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.ddr1cp		!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,t.ddr1e-t.ddr1s,%o0	!
if2_ddr:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	t.ddr1s			!
	nop				!
    i.ddr0t:				!
	srl	%o1,16,%o4		! R2
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	add	%o4,64,%i2		! %i2
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	add	%o4,64,%i0		! %i0
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	add	%g0,2,%l7		!
	bnz,a	.+8			! if EX=1 then IAR+=4
	add	%g0,4,%l7		!
t.ddr0s:
		ld	[%sp+184],%o0	! struct *gcpu_s
    t.ddr0t0:	add	%o0,%i2,%o2	! ##TEMPLATE:%imm
    t.ddr0t1:	add	%o0,%i0,%o1	! ##TEMPLATE:%imm
		and	%g7,0xf,%o3	! give Program Mask
		stx	%g1,[%o0+648]	!
		stx	%g2,[%o0+656]	!
		stx	%g3,[%o0+664]	!
		stx	%g4,[%o0+672]	!
		stx	%g5,[%o0+680]	!
		sethi	%hi(fl_div_long),%o7
		jmpl	%o7+%lo(fl_div_long),%o7
		nop			! call library in fltlib.s
		ld	[%sp+184],%o7	! struct *gcpu_s
		ldx	[%o7+648],%g1	!
		ldx	[%o7+656],%g2	!
		ldx	[%o7+664],%g3	!
		ldx	[%o7+672],%g4	!
		ldx	[%o7+680],%g5	!
		sethi	%hi(0x00ff0000),%o1
		andcc	%o0,%o1,%o0	! extract exception
		bz,a	t.ddr0e		!   exit
    t.ddr0tz:	add	%g2,%l7,%g2	! ##TEMPLATE:IAR
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! INTR-CODE=retval
t.ddr0e:
		ba	break0		!
		nop			!
    t.ddr0o0:	add	%o0,64,%o2	! ##TEMPLATE:%imm
    t.ddr0o1:	add	%o0,64,%o1	! ##TEMPLATE:%imm
    t.ddr0oy:	add	%g2,2,%g2	! ##TEMPLATE:IAR
    t.ddr0oz:	add	%g2,4,%g2	! ##TEMPLATE:IAR
t.ddr1s:
		sethi	%hi(0x00060000),%o0
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! specification exception
t.ddr1e:

	.section ".text"
	.align	4
	.global cf2_awr,tf2_awr,if2_awr
cf2_awr:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	c.awr1c			!
	nop				!
    c.awr0c:				!
	retl				! case even:
	add	%g0,t.awr0e-t.awr0s,%o0	!
    c.awr1c:				!
	retl				! case odd:
	add	%g0,t.awr1e-t.awr1s,%o0	!   specification exception
tf2_awr:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	t.awr1t			!
	nop				!
    t.awr0t:				!
	sethi	%hi(t.awr0s),%o3	!
	or	%o3,%lo(t.awr0s),%o3	!
	or	%g0,t.awr0e-t.awr0s,%o4	!
    t.awr0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.awr0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.awr0o0-t.awr0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+t.awr0t0-t.awr0s]
	ld	[%o3+t.awr0o1-t.awr0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+t.awr0t1-t.awr0s]
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	ld	[%o3+t.awr0oy-t.awr0s],%o5
	bnz,a	.+8			! if EX=1 then IAR+=4
	ld	[%o3+t.awr0oz-t.awr0s],%o5
	st	%o5,[%o0+t.awr0tz-t.awr0s]
	retl				!
	add	%o0,t.awr0e-t.awr0s,%o0	!
    t.awr1t:				!
	sethi	%hi(t.awr1s),%o3	!
	or	%o3,%lo(t.awr1s),%o3	!
	or	%g0,t.awr1e-t.awr1s,%o4	!
    t.awr1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.awr1cp		!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,t.awr1e-t.awr1s,%o0	!
if2_awr:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	t.awr1s			!
	nop				!
    i.awr0t:				!
	srl	%o1,16,%o4		! R2
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	add	%o4,64,%i2		! %i2
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	add	%o4,64,%i0		! %i0
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	add	%g0,2,%l7		!
	bnz,a	.+8			! if EX=1 then IAR+=4
	add	%g0,4,%l7		!
t.awr0s:
		ld	[%sp+184],%o0	! struct *gcpu_s
    t.awr0t0:	add	%o0,%i2,%o2	! ##TEMPLATE:%imm
    t.awr0t1:	add	%o0,%i0,%o1	! ##TEMPLATE:%imm
		and	%g7,0xf,%o3	! give Program Mask
		stx	%g1,[%o0+648]	!
		stx	%g2,[%o0+656]	!
		stx	%g3,[%o0+664]	!
		stx	%g4,[%o0+672]	!
		stx	%g5,[%o0+680]	!
		sethi	%hi(fl_addsub_long_unnorm),%o7
		jmpl	%o7+%lo(fl_addsub_long_unnorm),%o7
		add	%g0,0,%o4	! call library in fltlib.s
		ld	[%sp+184],%o7	! struct *gcpu_s
		ldx	[%o7+648],%g1	!
		ldx	[%o7+656],%g2	!
		ldx	[%o7+664],%g3	!
		ldx	[%o7+672],%g4	!
		ldx	[%o7+680],%g5	!
		and	%o0,3,%g1	! CC=retval
		sethi	%hi(0x00ff0000),%o1
		andcc	%o0,%o1,%o0	! extract exception
		bz,a	t.awr0e		!   exit
    t.awr0tz:	add	%g2,%l7,%g2	! ##TEMPLATE:IAR
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! INTR-CODE=retval
t.awr0e:
		ba	break0		!
		nop			!
    t.awr0o0:	add	%o0,64,%o2	! ##TEMPLATE:%imm
    t.awr0o1:	add	%o0,64,%o1	! ##TEMPLATE:%imm
    t.awr0oy:	add	%g2,2,%g2	! ##TEMPLATE:IAR
    t.awr0oz:	add	%g2,4,%g2	! ##TEMPLATE:IAR
t.awr1s:
		sethi	%hi(0x00060000),%o0
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! specification exception
t.awr1e:

	.section ".text"
	.align	4
	.global cf2_swr,tf2_swr,if2_swr
cf2_swr:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	c.swr1c			!
	nop				!
    c.swr0c:				!
	retl				! case even:
	add	%g0,t.swr0e-t.swr0s,%o0	!
    c.swr1c:				!
	retl				! case odd:
	add	%g0,t.swr1e-t.swr1s,%o0	!   specification exception
tf2_swr:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	t.swr1t			!
	nop				!
    t.swr0t:				!
	sethi	%hi(t.swr0s),%o3	!
	or	%o3,%lo(t.swr0s),%o3	!
	or	%g0,t.swr0e-t.swr0s,%o4	!
    t.swr0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.swr0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.swr0o0-t.swr0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+t.swr0t0-t.swr0s]
	ld	[%o3+t.swr0o1-t.swr0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+t.swr0t1-t.swr0s]
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	ld	[%o3+t.swr0oy-t.swr0s],%o5
	bnz,a	.+8			! if EX=1 then IAR+=4
	ld	[%o3+t.swr0oz-t.swr0s],%o5
	st	%o5,[%o0+t.swr0tz-t.swr0s]
	retl				!
	add	%o0,t.swr0e-t.swr0s,%o0	!
    t.swr1t:				!
	sethi	%hi(t.swr1s),%o3	!
	or	%o3,%lo(t.swr1s),%o3	!
	or	%g0,t.swr1e-t.swr1s,%o4	!
    t.swr1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.swr1cp		!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,t.swr1e-t.swr1s,%o0	!
if2_swr:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	t.swr1s			!
	nop				!
    i.swr0t:				!
	srl	%o1,16,%o4		! R2
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	add	%o4,64,%i2		! %i2
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	add	%o4,64,%i0		! %i0
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	add	%g0,2,%l7		!
	bnz,a	.+8			! if EX=1 then IAR+=4
	add	%g0,4,%l7		!
t.swr0s:
		ld	[%sp+184],%o0	! struct *gcpu_s
    t.swr0t0:	add	%o0,%i2,%o2	! ##TEMPLATE:%imm
    t.swr0t1:	add	%o0,%i0,%o1	! ##TEMPLATE:%imm
		and	%g7,0xf,%o3	! give Program Mask
		stx	%g1,[%o0+648]	!
		stx	%g2,[%o0+656]	!
		stx	%g3,[%o0+664]	!
		stx	%g4,[%o0+672]	!
		stx	%g5,[%o0+680]	!
		sethi	%hi(fl_addsub_long_unnorm),%o7
		jmpl	%o7+%lo(fl_addsub_long_unnorm),%o7
		add	%g0,1,%o4	! call library in fltlib.s
		ld	[%sp+184],%o7	! struct *gcpu_s
		ldx	[%o7+648],%g1	!
		ldx	[%o7+656],%g2	!
		ldx	[%o7+664],%g3	!
		ldx	[%o7+672],%g4	!
		ldx	[%o7+680],%g5	!
		and	%o0,3,%g1	! CC=retval
		sethi	%hi(0x00ff0000),%o1
		andcc	%o0,%o1,%o0	! extract exception
		bz,a	t.swr0e		!   exit
    t.swr0tz:	add	%g2,%l7,%g2	! ##TEMPLATE:IAR
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! INTR-CODE=retval
t.swr0e:
		ba	break0		!
		nop			!
    t.swr0o0:	add	%o0,64,%o2	! ##TEMPLATE:%imm
    t.swr0o1:	add	%o0,64,%o1	! ##TEMPLATE:%imm
    t.swr0oy:	add	%g2,2,%g2	! ##TEMPLATE:IAR
    t.swr0oz:	add	%g2,4,%g2	! ##TEMPLATE:IAR
t.swr1s:
		sethi	%hi(0x00060000),%o0
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! specification exception
t.swr1e:
!================================

!
! templates
! cxx_xxx:
!   %o0: param: none
!	 retval:size of template
!   %o1: M instruction (upper 2 bytes)
!   %o2: work
!   %o3: work
!   %o4: work
!   %o5: work
! txx_xxx:
!   %o0: param: bufp start address
!	 retval:bufp next start address
!   %o1: M instruction (upper 2 bytes)
!   %o2: work
!   %o3: work
!   %o4: work
!   %o5: work
!
	.section ".text"
	.align	4
	.global cf2_lper,tf2_lper,if2_lper
cf2_lper:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	c.lper1c		!
	nop				!
    c.lper0c:				!
	retl				! case even:
	add	%g0,t.lper0e-t.lper0s,%o0
    c.lper1c:				!
	retl				! case odd:
	add	%g0,t.lper1e-t.lper1s,%o0
tf2_lper:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	t.lper1t		!
	nop				!
    t.lper0t:				!
	sethi	%hi(t.lper0s),%o3	!
	or	%o3,%lo(t.lper0s),%o3	!
	or	%g0,t.lper0e-t.lper0s,%o4
    t.lper0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.lper0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.lper0o0-t.lper0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+t.lper0t0-t.lper0s]
	ld	[%o3+t.lper0o1-t.lper0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+t.lper0t1-t.lper0s]
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	ld	[%o3+t.lper0oy-t.lper0s],%o5
	bnz,a	.+8			! if EX=1 then IAR+=4
	ld	[%o3+t.lper0oz-t.lper0s],%o5
	st	%o5,[%o0+t.lper0tz-t.lper0s]
	retl				!
	add	%o0,t.lper0e-t.lper0s,%o0
    t.lper1t:				!
	sethi	%hi(t.lper1s),%o3	!
	or	%o3,%lo(t.lper1s),%o3	!
	or	%g0,t.lper1e-t.lper1s,%o4
    t.lper1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.lper1cp		!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,t.lper1e-t.lper1s,%o0
if2_lper:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	t.lper1s		!
	nop				!
    i.lper0t:				!
	srl	%o1,16,%o4		! R2
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	add	%o4,64,%i2		! %i2
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	add	%o4,64,%i0		! %i0
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	add	%g0,2,%l7		!
	bnz,a	.+8			! if EX=1 then IAR+=4
	add	%g0,4,%l7		!
t.lper0s:
		ld	[%sp+184],%o7	! struct *gcpu_s
		andn	%g1,3,%g1	! CC=0
    t.lper0t0:	ld	[%o7+%i2],%o0	! ##TEMPLATE:%imm
		sethi	%hi(0x80000000),%o2
		andn	%o0,%o2,%o0	! set sign
		sll	%o0,8,%o2	!
		orcc	%o2,%g0,%g0	! if fraction == 0 then
		bnz,a	t.lper0t1	!      CC=0
		or	%g1,2,%g1	! else CC=2
    t.lper0t1:	st	%o0,[%o7+%i0]	! ##TEMPLATE:%imm
    t.lper0tz:	add	%g2,%l7,%g2	! ##TEMPLATE:IAR
t.lper0e:
		ba	break0		!
		nop			!
    t.lper0o0:	ld	[%o7+64],%o0	! ##TEMPLATE:%imm
    t.lper0o1:	st	%o0,[%o7+64]	! ##TEMPLATE:%imm
    t.lper0oy:	add	%g2,2,%g2	! ##TEMPLATE:IAR
    t.lper0oz:	add	%g2,4,%g2	! ##TEMPLATE:IAR
t.lper1s:
		sethi	%hi(0x00060000),%o0
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! specification exception
t.lper1e:

	.section ".text"
	.align	4
	.global cf2_lner,tf2_lner,if2_lner
cf2_lner:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	c.lner1c		!
	nop				!
    c.lner0c:				!
	retl				! case even:
	add	%g0,t.lner0e-t.lner0s,%o0
    c.lner1c:				!
	retl				! case odd:
	add	%g0,t.lner1e-t.lner1s,%o0
tf2_lner:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	t.lner1t		!
	nop				!
    t.lner0t:				!
	sethi	%hi(t.lner0s),%o3	!
	or	%o3,%lo(t.lner0s),%o3	!
	or	%g0,t.lner0e-t.lner0s,%o4
    t.lner0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.lner0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.lner0o0-t.lner0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+t.lner0t0-t.lner0s]
	ld	[%o3+t.lner0o1-t.lner0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+t.lner0t1-t.lner0s]
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	ld	[%o3+t.lner0oy-t.lner0s],%o5
	bnz,a	.+8			! if EX=1 then IAR+=4
	ld	[%o3+t.lner0oz-t.lner0s],%o5
	st	%o5,[%o0+t.lner0tz-t.lner0s]
	retl				!
	add	%o0,t.lner0e-t.lner0s,%o0
    t.lner1t:				!
	sethi	%hi(t.lner1s),%o3	!
	or	%o3,%lo(t.lner1s),%o3	!
	or	%g0,t.lner1e-t.lner1s,%o4
    t.lner1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.lner1cp		!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,t.lner1e-t.lner1s,%o0
if2_lner:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	t.lner1s		!
	nop				!
    i.lner0t:				!
	srl	%o1,16,%o4		! R2
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	add	%o4,64,%i2		! %i2
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	add	%o4,64,%i0		! %i0
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	add	%g0,2,%l7		!
	bnz,a	.+8			! if EX=1 then IAR+=4
	add	%g0,4,%l7		!
t.lner0s:
		ld	[%sp+184],%o7	! struct *gcpu_s
		andn	%g1,3,%g1	! CC=0
    t.lner0t0:	ld	[%o7+%i2],%o0	! ##TEMPLATE:%imm
		sethi	%hi(0x80000000),%o2
		or	%o0,%o2,%o0	! set sign
		sll	%o0,8,%o2	!
		orcc	%o2,%g0,%g0	! if fraction == 0 then
		bnz,a	t.lner0t1	!      CC=0
		or	%g1,1,%g1	! else CC=1
    t.lner0t1:	st	%o0,[%o7+%i0]	! ##TEMPLATE:%imm
    t.lner0tz:	add	%g2,%l7,%g2	! ##TEMPLATE:IAR
t.lner0e:
		ba	break0		!
		nop			!
    t.lner0o0:	ld	[%o7+64],%o0	! ##TEMPLATE:%imm
    t.lner0o1:	st	%o0,[%o7+64]	! ##TEMPLATE:%imm
    t.lner0oy:	add	%g2,2,%g2	! ##TEMPLATE:IAR
    t.lner0oz:	add	%g2,4,%g2	! ##TEMPLATE:IAR
t.lner1s:
		sethi	%hi(0x00060000),%o0
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! specification exception
t.lner1e:

	.section ".text"
	.align	4
	.global cf2_lter,tf2_lter,if2_lter
cf2_lter:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	c.lter1c		!
	nop				!
    c.lter0c:				!
	retl				! case even:
	add	%g0,t.lter0e-t.lter0s,%o0
    c.lter1c:				!
	retl				! case odd:
	add	%g0,t.lter1e-t.lter1s,%o0
tf2_lter:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	t.lter1t		!
	nop				!
    t.lter0t:				!
	sethi	%hi(t.lter0s),%o3	!
	or	%o3,%lo(t.lter0s),%o3	!
	or	%g0,t.lter0e-t.lter0s,%o4
    t.lter0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.lter0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.lter0o0-t.lter0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+t.lter0t0-t.lter0s]
	ld	[%o3+t.lter0o1-t.lter0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+t.lter0t1-t.lter0s]
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	ld	[%o3+t.lter0oy-t.lter0s],%o5
	bnz,a	.+8			! if EX=1 then IAR+=4
	ld	[%o3+t.lter0oz-t.lter0s],%o5
	st	%o5,[%o0+t.lter0tz-t.lter0s]
	retl				!
	add	%o0,t.lter0e-t.lter0s,%o0
    t.lter1t:				!
	sethi	%hi(t.lter1s),%o3	!
	or	%o3,%lo(t.lter1s),%o3	!
	or	%g0,t.lter1e-t.lter1s,%o4
    t.lter1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.lter1cp		!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,t.lter1e-t.lter1s,%o0
if2_lter:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	t.lter1s		!
	nop				!
    i.lter0t:				!
	srl	%o1,16,%o4		! R2
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	add	%o4,64,%i2		! %i2
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	add	%o4,64,%i0		! %i0
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	add	%g0,2,%l7		!
	bnz,a	.+8			! if EX=1 then IAR+=4
	add	%g0,4,%l7		!
t.lter0s:
		ld	[%sp+184],%o7	! struct *gcpu_s
		andn	%g1,3,%g1	! CC=0
    t.lter0t0:	ld	[%o7+%i2],%o0	! ##TEMPLATE:%imm
		sll	%o0,8,%o2	!
		orcc	%o2,%g0,%g0	!
		bz	t.lter0t1	! if fraction == 0 then
		subcc	%o0,%g0,%g0	!      CC=0
		bpos,a	t.lter0t1	! if %o0 >= 0 then
		or	%g1,2,%g1	!      CC=2
		or	%g1,1,%g1	! else CC=1
    t.lter0t1:	st	%o0,[%o7+%i0]	! ##TEMPLATE:%imm
    t.lter0tz:	add	%g2,%l7,%g2	! ##TEMPLATE:IAR
t.lter0e:
		ba	break0		!
		nop			!
    t.lter0o0:	ld	[%o7+64],%o0	! ##TEMPLATE:%imm
    t.lter0o1:	st	%o0,[%o7+64]	! ##TEMPLATE:%imm
    t.lter0oy:	add	%g2,2,%g2	! ##TEMPLATE:IAR
    t.lter0oz:	add	%g2,4,%g2	! ##TEMPLATE:IAR
t.lter1s:
		sethi	%hi(0x00060000),%o0
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! specification exception
t.lter1e:

	.section ".text"
	.align	4
	.global cf2_lcer,tf2_lcer,if2_lcer
cf2_lcer:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	c.lcer1c		!
	nop				!
    c.lcer0c:				!
	retl				! case even:
	add	%g0,t.lcer0e-t.lcer0s,%o0
    c.lcer1c:				!
	retl				! case odd:
	add	%g0,t.lcer1e-t.lcer1s,%o0
tf2_lcer:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	t.lcer1t		!
	nop				!
    t.lcer0t:				!
	sethi	%hi(t.lcer0s),%o3	!
	or	%o3,%lo(t.lcer0s),%o3	!
	or	%g0,t.lcer0e-t.lcer0s,%o4
    t.lcer0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.lcer0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.lcer0o0-t.lcer0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+t.lcer0t0-t.lcer0s]
	ld	[%o3+t.lcer0o1-t.lcer0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+t.lcer0t1-t.lcer0s]
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	ld	[%o3+t.lcer0oy-t.lcer0s],%o5
	bnz,a	.+8			! if EX=1 then IAR+=4
	ld	[%o3+t.lcer0oz-t.lcer0s],%o5
	st	%o5,[%o0+t.lcer0tz-t.lcer0s]
	retl				!
	add	%o0,t.lcer0e-t.lcer0s,%o0
    t.lcer1t:				!
	sethi	%hi(t.lcer1s),%o3	!
	or	%o3,%lo(t.lcer1s),%o3	!
	or	%g0,t.lcer1e-t.lcer1s,%o4
    t.lcer1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.lcer1cp		!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,t.lcer1e-t.lcer1s,%o0
if2_lcer:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	t.lcer1s		!
	nop				!
    i.lcer0t:				!
	srl	%o1,16,%o4		! R2
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	add	%o4,64,%i2		! %i2
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	add	%o4,64,%i0		! %i0
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	add	%g0,2,%l7		!
	bnz,a	.+8			! if EX=1 then IAR+=4
	add	%g0,4,%l7		!
t.lcer0s:
		ld	[%sp+184],%o7	! struct *gcpu_s
		andn	%g1,3,%g1	! CC=0
    t.lcer0t0:	ld	[%o7+%i2],%o0	! ##TEMPLATE:%imm
		sethi	%hi(0x80000000),%o2
		xor	%o0,%o2,%o0	! invert sign
		sll	%o0,8,%o2	!
		orcc	%o2,%g0,%g0	!
		bz	t.lcer0t1	! if fraction == 0 then
		subcc	%o0,%g0,%g0	!      CC=0
		bpos,a	t.lcer0t1	! if %o0 >= 0 then
		or	%g1,2,%g1	!      CC=2
		or	%g1,1,%g1	! else CC=1
    t.lcer0t1:	st	%o0,[%o7+%i0]	! ##TEMPLATE:%imm
    t.lcer0tz:	add	%g2,%l7,%g2	! ##TEMPLATE:IAR
t.lcer0e:
		ba	break0		!
		nop			!
    t.lcer0o0:	ld	[%o7+64],%o0	! ##TEMPLATE:%imm
    t.lcer0o1:	st	%o0,[%o7+64]	! ##TEMPLATE:%imm
    t.lcer0oy:	add	%g2,2,%g2	! ##TEMPLATE:IAR
    t.lcer0oz:	add	%g2,4,%g2	! ##TEMPLATE:IAR
t.lcer1s:
		sethi	%hi(0x00060000),%o0
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! specification exception
t.lcer1e:

	.section ".text"
	.align	4
	.global cf2_her,tf2_her,if2_her
cf2_her:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	c.her1c			!
	nop				!
    c.her0c:				!
	retl				! case even:
	add	%g0,t.her0e-t.her0s,%o0	!
    c.her1c:				!
	retl				! case odd:
	add	%g0,t.her1e-t.her1s,%o0	!   specification exception
tf2_her:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	t.her1t			!
	nop				!
    t.her0t:				!
	sethi	%hi(t.her0s),%o3	!
	or	%o3,%lo(t.her0s),%o3	!
	or	%g0,t.her0e-t.her0s,%o4	!
    t.her0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.her0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.her0o0-t.her0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+t.her0t0-t.her0s]
	ld	[%o3+t.her0o1-t.her0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+t.her0t1-t.her0s]
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	ld	[%o3+t.her0oy-t.her0s],%o5
	bnz,a	.+8			! if EX=1 then IAR+=4
	ld	[%o3+t.her0oz-t.her0s],%o5
	st	%o5,[%o0+t.her0tz-t.her0s]
	retl				!
	add	%o0,t.her0e-t.her0s,%o0	!
    t.her1t:				!
	sethi	%hi(t.her1s),%o3	!
	or	%o3,%lo(t.her1s),%o3	!
	or	%g0,t.her1e-t.her1s,%o4	!
    t.her1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.her1cp		!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,t.her1e-t.her1s,%o0	!
if2_her:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	t.her1s			!
	nop				!
    i.her0t:				!
	srl	%o1,16,%o4		! R2
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	add	%o4,64,%i2		! %i2
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	add	%o4,64,%i0		! %i0
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	add	%g0,2,%l7		!
	bnz,a	.+8			! if EX=1 then IAR+=4
	add	%g0,4,%l7		!
t.her0s:
		ld	[%sp+184],%o0	! struct *gcpu_s
    t.her0t0:	add	%o0,%i2,%o2	! ##TEMPLATE:%imm
    t.her0t1:	add	%o0,%i0,%o1	! ##TEMPLATE:%imm
		and	%g7,0xf,%o3	! give Program Mask
		stx	%g1,[%o0+648]	!
		stx	%g2,[%o0+656]	!
		stx	%g3,[%o0+664]	!
		stx	%g4,[%o0+672]	!
		stx	%g5,[%o0+680]	!
		sethi	%hi(fl_halve_short),%o7
		jmpl	%o7+%lo(fl_halve_short),%o7
		nop			! call library in fltlib.s
		ld	[%sp+184],%o7	! struct *gcpu_s
		ldx	[%o7+648],%g1	!
		ldx	[%o7+656],%g2	!
		ldx	[%o7+664],%g3	!
		ldx	[%o7+672],%g4	!
		ldx	[%o7+680],%g5	!
		sethi	%hi(0x00ff0000),%o1
		andcc	%o0,%o1,%o0	! extract exception
		bz,a	t.her0e		!   exit
    t.her0tz:	add	%g2,%l7,%g2	! ##TEMPLATE:IAR
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! INTR-CODE=retval
t.her0e:
		ba	break0		!
		nop			!
    t.her0o0:	add	%o0,64,%o2	! ##TEMPLATE:%imm
    t.her0o1:	add	%o0,64,%o1	! ##TEMPLATE:%imm
    t.her0oy:	add	%g2,2,%g2	! ##TEMPLATE:IAR
    t.her0oz:	add	%g2,4,%g2	! ##TEMPLATE:IAR
t.her1s:
		sethi	%hi(0x00060000),%o0
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! specification exception
t.her1e:

	.section ".text"
	.align	4
	.global cf2_lrer,tf2_lrer,if2_lrer
cf2_lrer:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	c.lrer1c		!
	nop				!
    c.lrer0c:				!
	retl				! case even:
	add	%g0,t.lrer0e-t.lrer0s,%o0
    c.lrer1c:				!
	retl				! case odd:
	add	%g0,t.lrer1e-t.lrer1s,%o0
tf2_lrer:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	t.lrer1t		!
	nop				!
    t.lrer0t:				!
	sethi	%hi(t.lrer0s),%o3	!
	or	%o3,%lo(t.lrer0s),%o3	!
	or	%g0,t.lrer0e-t.lrer0s,%o4
    t.lrer0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.lrer0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.lrer0o0-t.lrer0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+t.lrer0t0-t.lrer0s]
	ld	[%o3+t.lrer0o1-t.lrer0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+t.lrer0t1-t.lrer0s]
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	ld	[%o3+t.lrer0oy-t.lrer0s],%o5
	bnz,a	.+8			! if EX=1 then IAR+=4
	ld	[%o3+t.lrer0oz-t.lrer0s],%o5
	st	%o5,[%o0+t.lrer0tz-t.lrer0s]
	retl				!
	add	%o0,t.lrer0e-t.lrer0s,%o0
    t.lrer1t:				!
	sethi	%hi(t.lrer1s),%o3	!
	or	%o3,%lo(t.lrer1s),%o3	!
	or	%g0,t.lrer1e-t.lrer1s,%o4
    t.lrer1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.lrer1cp		!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,t.lrer1e-t.lrer1s,%o0
if2_lrer:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	t.lrer1s		!
	nop				!
    i.lrer0t:				!
	srl	%o1,16,%o4		! R2
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	add	%o4,64,%i2		! %i2
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	add	%o4,64,%i0		! %i0
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	add	%g0,2,%l7		!
	bnz,a	.+8			! if EX=1 then IAR+=4
	add	%g0,4,%l7		!
t.lrer0s:
		ld	[%sp+184],%o7	! struct *gcpu_s
    t.lrer0t0:	ldd	[%o7+%i2],%o0	! ##TEMPLATE:%imm
		sethi	%hi(0x80000000),%o4
		addcc	%o1,%o4,%g0	! if no carry-in then
		bcc	t.lrer0t1	!   skip
		sll	%o0,8,%o3	!
		addcc	%o3,0x100,%g0	! if no carry-out then
		bcc,a	t.lrer0t1	!   add fraction with 1
		add	%o0,1,%o0	!   skip
		sll	%o0,8,%o3	! add fraction with 1
		srl	%o3,8,%o3	!
		add	%o3,1,%o3	!
		srl	%o3,4,%o3	! shift fraction right 4bits
		srl	%o0,24,%o2	! add characteristic with 1
		sll	%o2,25,%o2	!
		sethi	%hi(0x02000000),%o4
		addcc	%o2,%o4,%o2	!
		srl	%o0,31,%o0	! extract sign bit
		sll	%o0,31,%o0	!
		srl	%o2,1,%o2	! extract characteristic
		or	%o0,%o2,%o0	! merge characteristic
		or	%o0,%o3,%o0	! merge fraction
    t.lrer0t1:	st	%o0,[%o7+%i0]	! ##TEMPLATE:%imm
		bcc,a	t.lrer0e	! if characteristic overflow then
    t.lrer0tz:	add	%g2,%l7,%g2	! ##TEMPLATE:IAR
		sethi	%hi(0x000C0000),%o0
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	!     exponent overflow
t.lrer0e:
		ba	break0		!
		nop			!
    t.lrer0o0:	ldd	[%o7+64],%o0	! ##TEMPLATE:%imm
    t.lrer0o1:	st	%o0,[%o7+64]	! ##TEMPLATE:%imm
    t.lrer0oy:	add	%g2,2,%g2	! ##TEMPLATE:IAR
    t.lrer0oz:	add	%g2,4,%g2	! ##TEMPLATE:IAR
t.lrer1s:
		sethi	%hi(0x00060000),%o0
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! specification exception
t.lrer1e:

	.section ".text"
	.align	4
	.global cf2_axr,tf2_axr,if2_axr
cf2_axr:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,3,%g0		!
	bnz	c.axr1c			!
	nop				!
    c.axr0c:				!
	retl				! case even:
	add	%g0,t.axr0e-t.axr0s,%o0	!
    c.axr1c:				!
	retl				! case odd:
	add	%g0,t.axr1e-t.axr1s,%o0	!   specification exception
tf2_axr:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,3,%g0		!
	bnz	t.axr1t			!
	nop				!
    t.axr0t:				!
	sethi	%hi(t.axr0s),%o3	!
	or	%o3,%lo(t.axr0s),%o3	!
	or	%g0,t.axr0e-t.axr0s,%o4	!
    t.axr0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.axr0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.axr0o0-t.axr0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+t.axr0t0-t.axr0s]
	ld	[%o3+t.axr0o1-t.axr0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+t.axr0t1-t.axr0s]
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	ld	[%o3+t.axr0oy-t.axr0s],%o5
	bnz,a	.+8			! if EX=1 then IAR+=4
	ld	[%o3+t.axr0oz-t.axr0s],%o5
	st	%o5,[%o0+t.axr0tz-t.axr0s]
	retl				!
	add	%o0,t.axr0e-t.axr0s,%o0	!
    t.axr1t:				!
	sethi	%hi(t.axr1s),%o3	!
	or	%o3,%lo(t.axr1s),%o3	!
	or	%g0,t.axr1e-t.axr1s,%o4	!
    t.axr1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.axr1cp		!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,t.axr1e-t.axr1s,%o0	!
if2_axr:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,3,%g0		!
	bnz	t.axr1s			!
	nop				!
    i.axr0t:				!
	srl	%o1,16,%o4		! R2
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	add	%o4,64,%i2		! %i2
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	add	%o4,64,%i0		! %i0
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	add	%g0,2,%l7		!
	bnz,a	.+8			! if EX=1 then IAR+=4
	add	%g0,4,%l7		!
t.axr0s:
		ld	[%sp+184],%o0	! struct *gcpu_s
    t.axr0t0:	add	%o0,%i2,%o2	! ##TEMPLATE:%imm
    t.axr0t1:	add	%o0,%i0,%o1	! ##TEMPLATE:%imm
		and	%g7,0xf,%o3	! give Program Mask
		stx	%g1,[%o0+648]	!
		stx	%g2,[%o0+656]	!
		stx	%g3,[%o0+664]	!
		stx	%g4,[%o0+672]	!
		stx	%g5,[%o0+680]	!
		sethi	%hi(fl_addsub_ext_norm),%o7
		jmpl	%o7+%lo(fl_addsub_ext_norm),%o7
		add	%g0,0,%o4	! call library in fltlib.s
		ld	[%sp+184],%o7	! struct *gcpu_s
		ldx	[%o7+648],%g1	!
		ldx	[%o7+656],%g2	!
		ldx	[%o7+664],%g3	!
		ldx	[%o7+672],%g4	!
		ldx	[%o7+680],%g5	!
		and	%o0,3,%g1	! CC=retval
		sethi	%hi(0x00ff0000),%o1
		andcc	%o0,%o1,%o0	! extract exception
		bz,a	t.axr0e		!   exit
    t.axr0tz:	add	%g2,%l7,%g2	! ##TEMPLATE:IAR
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! INTR-CODE=retval
t.axr0e:
		ba	break0		!
		nop			!
    t.axr0o0:	add	%o0,64,%o2	! ##TEMPLATE:%imm
    t.axr0o1:	add	%o0,64,%o1	! ##TEMPLATE:%imm
    t.axr0oy:	add	%g2,2,%g2	! ##TEMPLATE:IAR
    t.axr0oz:	add	%g2,4,%g2	! ##TEMPLATE:IAR
t.axr1s:
		sethi	%hi(0x00060000),%o0
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! specification exception
t.axr1e:

	.section ".text"
	.align	4
	.global cf2_sxr,tf2_sxr,if2_sxr
cf2_sxr:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,3,%g0		!
	bnz	c.sxr1c			!
	nop				!
    c.sxr0c:				!
	retl				! case even:
	add	%g0,t.sxr0e-t.sxr0s,%o0	!
    c.sxr1c:				!
	retl				! case odd:
	add	%g0,t.sxr1e-t.sxr1s,%o0	!   specification exception
tf2_sxr:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,3,%g0		!
	bnz	t.sxr1t			!
	nop				!
    t.sxr0t:				!
	sethi	%hi(t.sxr0s),%o3	!
	or	%o3,%lo(t.sxr0s),%o3	!
	or	%g0,t.sxr0e-t.sxr0s,%o4	!
    t.sxr0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.sxr0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.sxr0o0-t.sxr0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+t.sxr0t0-t.sxr0s]
	ld	[%o3+t.sxr0o1-t.sxr0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+t.sxr0t1-t.sxr0s]
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	ld	[%o3+t.sxr0oy-t.sxr0s],%o5
	bnz,a	.+8			! if EX=1 then IAR+=4
	ld	[%o3+t.sxr0oz-t.sxr0s],%o5
	st	%o5,[%o0+t.sxr0tz-t.sxr0s]
	retl				!
	add	%o0,t.sxr0e-t.sxr0s,%o0	!
    t.sxr1t:				!
	sethi	%hi(t.sxr1s),%o3	!
	or	%o3,%lo(t.sxr1s),%o3	!
	or	%g0,t.sxr1e-t.sxr1s,%o4	!
    t.sxr1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.sxr1cp		!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,t.sxr1e-t.sxr1s,%o0	!
if2_sxr:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,3,%g0		!
	bnz	t.sxr1s			!
	nop				!
    i.sxr0t:				!
	srl	%o1,16,%o4		! R2
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	add	%o4,64,%i2		! %i2
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	add	%o4,64,%i0		! %i0
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	add	%g0,2,%l7		!
	bnz,a	.+8			! if EX=1 then IAR+=4
	add	%g0,4,%l7		!
t.sxr0s:
		ld	[%sp+184],%o0	! struct *gcpu_s
    t.sxr0t0:	add	%o0,%i2,%o2	! ##TEMPLATE:%imm
    t.sxr0t1:	add	%o0,%i0,%o1	! ##TEMPLATE:%imm
		and	%g7,0xf,%o3	! give Program Mask
		stx	%g1,[%o0+648]	!
		stx	%g2,[%o0+656]	!
		stx	%g3,[%o0+664]	!
		stx	%g4,[%o0+672]	!
		stx	%g5,[%o0+680]	!
		sethi	%hi(fl_addsub_ext_norm),%o7
		jmpl	%o7+%lo(fl_addsub_ext_norm),%o7
		add	%g0,1,%o4	! call library in fltlib.s
		ld	[%sp+184],%o7	! struct *gcpu_s
		ldx	[%o7+648],%g1	!
		ldx	[%o7+656],%g2	!
		ldx	[%o7+664],%g3	!
		ldx	[%o7+672],%g4	!
		ldx	[%o7+680],%g5	!
		and	%o0,3,%g1	! CC=retval
		sethi	%hi(0x00ff0000),%o1
		andcc	%o0,%o1,%o0	! extract exception
		bz,a	t.sxr0e		!   exit
    t.sxr0tz:	add	%g2,%l7,%g2	! ##TEMPLATE:IAR
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! INTR-CODE=retval
t.sxr0e:
		ba	break0		!
		nop			!
    t.sxr0o0:	add	%o0,64,%o2	! ##TEMPLATE:%imm
    t.sxr0o1:	add	%o0,64,%o1	! ##TEMPLATE:%imm
    t.sxr0oy:	add	%g2,2,%g2	! ##TEMPLATE:IAR
    t.sxr0oz:	add	%g2,4,%g2	! ##TEMPLATE:IAR
t.sxr1s:
		sethi	%hi(0x00060000),%o0
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! specification exception
t.sxr1e:

	.section ".text"
	.align	4
	.global cf2_ler,tf2_ler,if2_ler
cf2_ler:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	c.ler1c			!
	nop				!
    c.ler0c:				!
	retl				! case even:
	add	%g0,t.ler0e-t.ler0s,%o0	!
    c.ler1c:				!
	retl				! case odd:
	add	%g0,t.ler1e-t.ler1s,%o0	!   specification exception
tf2_ler:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	t.ler1t			!
	nop				!
    t.ler0t:				!
	sethi	%hi(t.ler0s),%o3	!
	or	%o3,%lo(t.ler0s),%o3	!
	or	%g0,t.ler0e-t.ler0s,%o4	!
    t.ler0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.ler0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.ler0o0-t.ler0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+t.ler0t0-t.ler0s]
	ld	[%o3+t.ler0o1-t.ler0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+t.ler0t1-t.ler0s]
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	ld	[%o3+t.ler0oy-t.ler0s],%o5
	bnz,a	.+8			! if EX=1 then IAR+=4
	ld	[%o3+t.ler0oz-t.ler0s],%o5
	st	%o5,[%o0+t.ler0tz-t.ler0s]
	retl				!
	add	%o0,t.ler0e-t.ler0s,%o0	!
    t.ler1t:				!
	sethi	%hi(t.ler1s),%o3	!
	or	%o3,%lo(t.ler1s),%o3	!
	or	%g0,t.ler1e-t.ler1s,%o4	!
    t.ler1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.ler1cp		!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,t.ler1e-t.ler1s,%o0	!
if2_ler:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	t.ler1s			!
	nop				!
    i.ler0t:				!
	srl	%o1,16,%o4		! R2
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	add	%o4,64,%i2		! %i2
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	add	%o4,64,%i0		! %i0
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	add	%g0,2,%l7		!
	bnz,a	.+8			! if EX=1 then IAR+=4
	add	%g0,4,%l7		!
t.ler0s:
		ld	[%sp+184],%o7	! struct *gcpu_s
    t.ler0t0:	ld	[%o7+%i2],%o0	! ##TEMPLATE:%imm
    t.ler0t1:	st	%o0,[%o7+%i0]	! ##TEMPLATE:%imm
    t.ler0tz:	add	%g2,%l7,%g2	! ##TEMPLATE:IAR
t.ler0e:
		ba	break0		!
		nop			!
    t.ler0o0:	ld	[%o7+64],%o0	! ##TEMPLATE:%imm
    t.ler0o1:	st	%o0,[%o7+64]	! ##TEMPLATE:%imm
    t.ler0oy:	add	%g2,2,%g2	! ##TEMPLATE:IAR
    t.ler0oz:	add	%g2,4,%g2	! ##TEMPLATE:IAR
t.ler1s:
		sethi	%hi(0x00060000),%o0
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! specification exception
t.ler1e:

	.section ".text"
	.align	4
	.global cf2_cer,tf2_cer,if2_cer
cf2_cer:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	c.cer1c			!
	nop				!
    c.cer0c:				!
	retl				! case even:
	add	%g0,t.cer0e-t.cer0s,%o0	!
    c.cer1c:				!
	retl				! case odd:
	add	%g0,t.cer1e-t.cer1s,%o0	!   specification exception
tf2_cer:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	t.cer1t			!
	nop				!
    t.cer0t:				!
	sethi	%hi(t.cer0s),%o3	!
	or	%o3,%lo(t.cer0s),%o3	!
	or	%g0,t.cer0e-t.cer0s,%o4	!
    t.cer0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.cer0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.cer0o0-t.cer0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+t.cer0t0-t.cer0s]
	ld	[%o3+t.cer0o1-t.cer0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+t.cer0t1-t.cer0s]
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	ld	[%o3+t.cer0oy-t.cer0s],%o5
	bnz,a	.+8			! if EX=1 then IAR+=4
	ld	[%o3+t.cer0oz-t.cer0s],%o5
	st	%o5,[%o0+t.cer0tz-t.cer0s]
	retl				!
	add	%o0,t.cer0e-t.cer0s,%o0	!
    t.cer1t:				!
	sethi	%hi(t.cer1s),%o3	!
	or	%o3,%lo(t.cer1s),%o3	!
	or	%g0,t.cer1e-t.cer1s,%o4	!
    t.cer1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.cer1cp		!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,t.cer1e-t.cer1s,%o0	!
if2_cer:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	t.cer1s			!
	nop				!
    i.cer0t:				!
	srl	%o1,16,%o4		! R2
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	add	%o4,64,%i2		! %i2
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	add	%o4,64,%i0		! %i0
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	add	%g0,2,%l7		!
	bnz,a	.+8			! if EX=1 then IAR+=4
	add	%g0,4,%l7		!
t.cer0s:
		ld	[%sp+184],%o0	! struct *gcpu_s
    t.cer0t0:	add	%o0,%i2,%o2	! ##TEMPLATE:%imm
    t.cer0t1:	add	%o0,%i0,%o1	! ##TEMPLATE:%imm
		and	%g7,0xf,%o3	! give Program Mask
		stx	%g1,[%o0+648]	!
		stx	%g2,[%o0+656]	!
		stx	%g3,[%o0+664]	!
		stx	%g4,[%o0+672]	!
		stx	%g5,[%o0+680]	!
		sethi	%hi(fl_comp_short),%o7
		jmpl	%o7+%lo(fl_comp_short),%o7
		nop			! call library in fltlib.s
		ld	[%sp+184],%o7	! struct *gcpu_s
		ldx	[%o7+648],%g1	!
		ldx	[%o7+656],%g2	!
		ldx	[%o7+664],%g3	!
		ldx	[%o7+672],%g4	!
		ldx	[%o7+680],%g5	!
		and	%o0,3,%g1	! CC=retval
    t.cer0tz:	add	%g2,%l7,%g2	! ##TEMPLATE:IAR
t.cer0e:
		ba	break0		!
		nop			!
    t.cer0o0:	add	%o0,64,%o2	! ##TEMPLATE:%imm
    t.cer0o1:	add	%o0,64,%o1	! ##TEMPLATE:%imm
    t.cer0oy:	add	%g2,2,%g2	! ##TEMPLATE:IAR
    t.cer0oz:	add	%g2,4,%g2	! ##TEMPLATE:IAR
t.cer1s:
		sethi	%hi(0x00060000),%o0
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! specification exception
t.cer1e:

	.section ".text"
	.align	4
	.global cf2_aer,tf2_aer,if2_aer
cf2_aer:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	c.aer1c			!
	nop				!
    c.aer0c:				!
	retl				! case even:
	add	%g0,t.aer0e-t.aer0s,%o0	!
    c.aer1c:				!
	retl				! case odd:
	add	%g0,t.aer1e-t.aer1s,%o0	!   specification exception
tf2_aer:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	t.aer1t			!
	nop				!
    t.aer0t:				!
	sethi	%hi(t.aer0s),%o3	!
	or	%o3,%lo(t.aer0s),%o3	!
	or	%g0,t.aer0e-t.aer0s,%o4	!
    t.aer0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.aer0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.aer0o0-t.aer0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+t.aer0t0-t.aer0s]
	ld	[%o3+t.aer0o1-t.aer0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+t.aer0t1-t.aer0s]
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	ld	[%o3+t.aer0oy-t.aer0s],%o5
	bnz,a	.+8			! if EX=1 then IAR+=4
	ld	[%o3+t.aer0oz-t.aer0s],%o5
	st	%o5,[%o0+t.aer0tz-t.aer0s]
	retl				!
	add	%o0,t.aer0e-t.aer0s,%o0	!
    t.aer1t:				!
	sethi	%hi(t.aer1s),%o3	!
	or	%o3,%lo(t.aer1s),%o3	!
	or	%g0,t.aer1e-t.aer1s,%o4	!
    t.aer1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.aer1cp		!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,t.aer1e-t.aer1s,%o0	!
if2_aer:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	t.aer1s			!
	nop				!
    i.aer0t:				!
	srl	%o1,16,%o4		! R2
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	add	%o4,64,%i2		! %i2
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	add	%o4,64,%i0		! %i0
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	add	%g0,2,%l7		!
	bnz,a	.+8			! if EX=1 then IAR+=4
	add	%g0,4,%l7		!
t.aer0s:
		ld	[%sp+184],%o0	! struct *gcpu_s
    t.aer0t0:	add	%o0,%i2,%o2	! ##TEMPLATE:%imm
    t.aer0t1:	add	%o0,%i0,%o1	! ##TEMPLATE:%imm
		and	%g7,0xf,%o3	! give Program Mask
		stx	%g1,[%o0+648]	!
		stx	%g2,[%o0+656]	!
		stx	%g3,[%o0+664]	!
		stx	%g4,[%o0+672]	!
		stx	%g5,[%o0+680]	!
		sethi	%hi(fl_addsub_short_norm),%o7
		jmpl	%o7+%lo(fl_addsub_short_norm),%o7
		add	%g0,0,%o4	! call library in fltlib.s
		ld	[%sp+184],%o7	! struct *gcpu_s
		ldx	[%o7+648],%g1	!
		ldx	[%o7+656],%g2	!
		ldx	[%o7+664],%g3	!
		ldx	[%o7+672],%g4	!
		ldx	[%o7+680],%g5	!
		and	%o0,3,%g1	! CC=retval
		sethi	%hi(0x00ff0000),%o1
		andcc	%o0,%o1,%o0	! extract exception
		bz,a	t.aer0e		!   exit
    t.aer0tz:	add	%g2,%l7,%g2	! ##TEMPLATE:IAR
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! INTR-CODE=retval
t.aer0e:
		ba	break0		!
		nop			!
    t.aer0o0:	add	%o0,64,%o2	! ##TEMPLATE:%imm
    t.aer0o1:	add	%o0,64,%o1	! ##TEMPLATE:%imm
    t.aer0oy:	add	%g2,2,%g2	! ##TEMPLATE:IAR
    t.aer0oz:	add	%g2,4,%g2	! ##TEMPLATE:IAR
t.aer1s:
		sethi	%hi(0x00060000),%o0
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! specification exception
t.aer1e:

	.section ".text"
	.align	4
	.global cf2_ser,tf2_ser,if2_ser
cf2_ser:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	c.ser1c			!
	nop				!
    c.ser0c:				!
	retl				! case even:
	add	%g0,t.ser0e-t.ser0s,%o0	!
    c.ser1c:				!
	retl				! case odd:
	add	%g0,t.ser1e-t.ser1s,%o0	!   specification exception
tf2_ser:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	t.ser1t			!
	nop				!
    t.ser0t:				!
	sethi	%hi(t.ser0s),%o3	!
	or	%o3,%lo(t.ser0s),%o3	!
	or	%g0,t.ser0e-t.ser0s,%o4	!
    t.ser0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.ser0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.ser0o0-t.ser0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+t.ser0t0-t.ser0s]
	ld	[%o3+t.ser0o1-t.ser0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+t.ser0t1-t.ser0s]
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	ld	[%o3+t.ser0oy-t.ser0s],%o5
	bnz,a	.+8			! if EX=1 then IAR+=4
	ld	[%o3+t.ser0oz-t.ser0s],%o5
	st	%o5,[%o0+t.ser0tz-t.ser0s]
	retl				!
	add	%o0,t.ser0e-t.ser0s,%o0	!
    t.ser1t:				!
	sethi	%hi(t.ser1s),%o3	!
	or	%o3,%lo(t.ser1s),%o3	!
	or	%g0,t.ser1e-t.ser1s,%o4	!
    t.ser1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.ser1cp		!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,t.ser1e-t.ser1s,%o0	!
if2_ser:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	t.ser1s			!
	nop				!
    i.ser0t:				!
	srl	%o1,16,%o4		! R2
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	add	%o4,64,%i2		! %i2
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	add	%o4,64,%i0		! %i0
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	add	%g0,2,%l7		!
	bnz,a	.+8			! if EX=1 then IAR+=4
	add	%g0,4,%l7		!
t.ser0s:
		ld	[%sp+184],%o0	! struct *gcpu_s
    t.ser0t0:	add	%o0,%i2,%o2	! ##TEMPLATE:%imm
    t.ser0t1:	add	%o0,%i0,%o1	! ##TEMPLATE:%imm
		and	%g7,0xf,%o3	! give Program Mask
		stx	%g1,[%o0+648]	!
		stx	%g2,[%o0+656]	!
		stx	%g3,[%o0+664]	!
		stx	%g4,[%o0+672]	!
		stx	%g5,[%o0+680]	!
		sethi	%hi(fl_addsub_short_norm),%o7
		jmpl	%o7+%lo(fl_addsub_short_norm),%o7
		add	%g0,1,%o4	! call library in fltlib.s
		ld	[%sp+184],%o7	! struct *gcpu_s
		ldx	[%o7+648],%g1	!
		ldx	[%o7+656],%g2	!
		ldx	[%o7+664],%g3	!
		ldx	[%o7+672],%g4	!
		ldx	[%o7+680],%g5	!
		and	%o0,3,%g1	! CC=retval
		sethi	%hi(0x00ff0000),%o1
		andcc	%o0,%o1,%o0	! extract exception
		bz,a	t.ser0e		!   exit
    t.ser0tz:	add	%g2,%l7,%g2	! ##TEMPLATE:IAR
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! INTR-CODE=retval
t.ser0e:
		ba	break0		!
		nop			!
    t.ser0o0:	add	%o0,64,%o2	! ##TEMPLATE:%imm
    t.ser0o1:	add	%o0,64,%o1	! ##TEMPLATE:%imm
    t.ser0oy:	add	%g2,2,%g2	! ##TEMPLATE:IAR
    t.ser0oz:	add	%g2,4,%g2	! ##TEMPLATE:IAR
t.ser1s:
		sethi	%hi(0x00060000),%o0
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! specification exception
t.ser1e:

	.section ".text"
	.align	4
	.global cf2_mer,tf2_mer,if2_mer
cf2_mer:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	c.mer1c			!
	nop				!
    c.mer0c:				!
	retl				! case even:
	add	%g0,t.mer0e-t.mer0s,%o0	!
    c.mer1c:				!
	retl				! case odd:
	add	%g0,t.mer1e-t.mer1s,%o0	!   specification exception
tf2_mer:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	t.mer1t			!
	nop				!
    t.mer0t:				!
	sethi	%hi(t.mer0s),%o3	!
	or	%o3,%lo(t.mer0s),%o3	!
	or	%g0,t.mer0e-t.mer0s,%o4	!
    t.mer0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.mer0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.mer0o0-t.mer0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+t.mer0t0-t.mer0s]
	ld	[%o3+t.mer0o1-t.mer0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+t.mer0t1-t.mer0s]
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	ld	[%o3+t.mer0oy-t.mer0s],%o5
	bnz,a	.+8			! if EX=1 then IAR+=4
	ld	[%o3+t.mer0oz-t.mer0s],%o5
	st	%o5,[%o0+t.mer0tz-t.mer0s]
	retl				!
	add	%o0,t.mer0e-t.mer0s,%o0	!
    t.mer1t:				!
	sethi	%hi(t.mer1s),%o3	!
	or	%o3,%lo(t.mer1s),%o3	!
	or	%g0,t.mer1e-t.mer1s,%o4	!
    t.mer1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.mer1cp		!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,t.mer1e-t.mer1s,%o0	!
if2_mer:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	t.mer1s			!
	nop				!
    i.mer0t:				!
	srl	%o1,16,%o4		! R2
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	add	%o4,64,%i2		! %i2
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	add	%o4,64,%i0		! %i0
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	add	%g0,2,%l7		!
	bnz,a	.+8			! if EX=1 then IAR+=4
	add	%g0,4,%l7		!
t.mer0s:
		ld	[%sp+184],%o0	! struct *gcpu_s
    t.mer0t0:	add	%o0,%i2,%o2	! ##TEMPLATE:%imm
    t.mer0t1:	add	%o0,%i0,%o1	! ##TEMPLATE:%imm
		and	%g7,0xf,%o3	! give Program Mask
		stx	%g1,[%o0+648]	!
		stx	%g2,[%o0+656]	!
		stx	%g3,[%o0+664]	!
		stx	%g4,[%o0+672]	!
		stx	%g5,[%o0+680]	!
		sethi	%hi(fl_mult_short2long),%o7
		jmpl	%o7+%lo(fl_mult_short2long),%o7
		nop			! call library in fltlib.s
		ld	[%sp+184],%o7	! struct *gcpu_s
		ldx	[%o7+648],%g1	!
		ldx	[%o7+656],%g2	!
		ldx	[%o7+664],%g3	!
		ldx	[%o7+672],%g4	!
		ldx	[%o7+680],%g5	!
		sethi	%hi(0x00ff0000),%o1
		andcc	%o0,%o1,%o0	! extract exception
		bz,a	t.mer0e		!   exit
    t.mer0tz:	add	%g2,%l7,%g2	! ##TEMPLATE:IAR
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! INTR-CODE=retval
t.mer0e:
		ba	break0		!
		nop			!
    t.mer0o0:	add	%o0,64,%o2	! ##TEMPLATE:%imm
    t.mer0o1:	add	%o0,64,%o1	! ##TEMPLATE:%imm
    t.mer0oy:	add	%g2,2,%g2	! ##TEMPLATE:IAR
    t.mer0oz:	add	%g2,4,%g2	! ##TEMPLATE:IAR
t.mer1s:
		sethi	%hi(0x00060000),%o0
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! specification exception
t.mer1e:

	.section ".text"
	.align	4
	.global cf2_der,tf2_der,if2_der
cf2_der:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	c.der1c			!
	nop				!
    c.der0c:				!
	retl				! case even:
	add	%g0,t.der0e-t.der0s,%o0	!
    c.der1c:				!
	retl				! case odd:
	add	%g0,t.der1e-t.der1s,%o0	!   specification exception
tf2_der:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	t.der1t			!
	nop				!
    t.der0t:				!
	sethi	%hi(t.der0s),%o3	!
	or	%o3,%lo(t.der0s),%o3	!
	or	%g0,t.der0e-t.der0s,%o4	!
    t.der0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.der0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.der0o0-t.der0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+t.der0t0-t.der0s]
	ld	[%o3+t.der0o1-t.der0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+t.der0t1-t.der0s]
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	ld	[%o3+t.der0oy-t.der0s],%o5
	bnz,a	.+8			! if EX=1 then IAR+=4
	ld	[%o3+t.der0oz-t.der0s],%o5
	st	%o5,[%o0+t.der0tz-t.der0s]
	retl				!
	add	%o0,t.der0e-t.der0s,%o0	!
    t.der1t:				!
	sethi	%hi(t.der1s),%o3	!
	or	%o3,%lo(t.der1s),%o3	!
	or	%g0,t.der1e-t.der1s,%o4	!
    t.der1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.der1cp		!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,t.der1e-t.der1s,%o0	!
if2_der:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	t.der1s			!
	nop				!
    i.der0t:				!
	srl	%o1,16,%o4		! R2
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	add	%o4,64,%i2		! %i2
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	add	%o4,64,%i0		! %i0
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	add	%g0,2,%l7		!
	bnz,a	.+8			! if EX=1 then IAR+=4
	add	%g0,4,%l7		!
t.der0s:
		ld	[%sp+184],%o0	! struct *gcpu_s
    t.der0t0:	add	%o0,%i2,%o2	! ##TEMPLATE:%imm
    t.der0t1:	add	%o0,%i0,%o1	! ##TEMPLATE:%imm
		and	%g7,0xf,%o3	! give Program Mask
		stx	%g1,[%o0+648]	!
		stx	%g2,[%o0+656]	!
		stx	%g3,[%o0+664]	!
		stx	%g4,[%o0+672]	!
		stx	%g5,[%o0+680]	!
		sethi	%hi(fl_div_short),%o7
		jmpl	%o7+%lo(fl_div_short),%o7
		nop			! call library in fltlib.s
		ld	[%sp+184],%o7	! struct *gcpu_s
		ldx	[%o7+648],%g1	!
		ldx	[%o7+656],%g2	!
		ldx	[%o7+664],%g3	!
		ldx	[%o7+672],%g4	!
		ldx	[%o7+680],%g5	!
		sethi	%hi(0x00ff0000),%o1
		andcc	%o0,%o1,%o0	! extract exception
		bz,a	t.der0e		!   exit
    t.der0tz:	add	%g2,%l7,%g2	! ##TEMPLATE:IAR
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! INTR-CODE=retval
t.der0e:
		ba	break0		!
		nop			!
    t.der0o0:	add	%o0,64,%o2	! ##TEMPLATE:%imm
    t.der0o1:	add	%o0,64,%o1	! ##TEMPLATE:%imm
    t.der0oy:	add	%g2,2,%g2	! ##TEMPLATE:IAR
    t.der0oz:	add	%g2,4,%g2	! ##TEMPLATE:IAR
t.der1s:
		sethi	%hi(0x00060000),%o0
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! specification exception
t.der1e:

	.section ".text"
	.align	4
	.global cf2_aur,tf2_aur,if2_aur
cf2_aur:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	c.aur1c			!
	nop				!
    c.aur0c:				!
	retl				! case even:
	add	%g0,t.aur0e-t.aur0s,%o0	!
    c.aur1c:				!
	retl				! case odd:
	add	%g0,t.aur1e-t.aur1s,%o0	!   specification exception
tf2_aur:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	t.aur1t			!
	nop				!
    t.aur0t:				!
	sethi	%hi(t.aur0s),%o3	!
	or	%o3,%lo(t.aur0s),%o3	!
	or	%g0,t.aur0e-t.aur0s,%o4	!
    t.aur0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.aur0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.aur0o0-t.aur0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+t.aur0t0-t.aur0s]
	ld	[%o3+t.aur0o1-t.aur0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+t.aur0t1-t.aur0s]
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	ld	[%o3+t.aur0oy-t.aur0s],%o5
	bnz,a	.+8			! if EX=1 then IAR+=4
	ld	[%o3+t.aur0oz-t.aur0s],%o5
	st	%o5,[%o0+t.aur0tz-t.aur0s]
	retl				!
	add	%o0,t.aur0e-t.aur0s,%o0	!
    t.aur1t:				!
	sethi	%hi(t.aur1s),%o3	!
	or	%o3,%lo(t.aur1s),%o3	!
	or	%g0,t.aur1e-t.aur1s,%o4	!
    t.aur1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.aur1cp		!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,t.aur1e-t.aur1s,%o0	!
if2_aur:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	t.aur1s			!
	nop				!
    i.aur0t:				!
	srl	%o1,16,%o4		! R2
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	add	%o4,64,%i2		! %i2
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	add	%o4,64,%i0		! %i0
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	add	%g0,2,%l7		!
	bnz,a	.+8			! if EX=1 then IAR+=4
	add	%g0,4,%l7		!
t.aur0s:
		ld	[%sp+184],%o0	! struct *gcpu_s
    t.aur0t0:	add	%o0,%i2,%o2	! ##TEMPLATE:%imm
    t.aur0t1:	add	%o0,%i0,%o1	! ##TEMPLATE:%imm
		and	%g7,0xf,%o3	! give Program Mask
		stx	%g1,[%o0+648]	!
		stx	%g2,[%o0+656]	!
		stx	%g3,[%o0+664]	!
		stx	%g4,[%o0+672]	!
		stx	%g5,[%o0+680]	!
		sethi	%hi(fl_addsub_short_unnorm),%o7
		jmpl	%o7+%lo(fl_addsub_short_unnorm),%o7
		add	%g0,0,%o4	! call library in fltlib.s
		ld	[%sp+184],%o7	! struct *gcpu_s
		ldx	[%o7+648],%g1	!
		ldx	[%o7+656],%g2	!
		ldx	[%o7+664],%g3	!
		ldx	[%o7+672],%g4	!
		ldx	[%o7+680],%g5	!
		and	%o0,3,%g1	! CC=retval
		sethi	%hi(0x00ff0000),%o1
		andcc	%o0,%o1,%o0	! extract exception
		bz,a	t.aur0e		!   exit
    t.aur0tz:	add	%g2,%l7,%g2	! ##TEMPLATE:IAR
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! INTR-CODE=retval
t.aur0e:
		ba	break0		!
		nop			!
    t.aur0o0:	add	%o0,64,%o2	! ##TEMPLATE:%imm
    t.aur0o1:	add	%o0,64,%o1	! ##TEMPLATE:%imm
    t.aur0oy:	add	%g2,2,%g2	! ##TEMPLATE:IAR
    t.aur0oz:	add	%g2,4,%g2	! ##TEMPLATE:IAR
t.aur1s:
		sethi	%hi(0x00060000),%o0
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! specification exception
t.aur1e:

	.section ".text"
	.align	4
	.global cf2_sur,tf2_sur,if2_sur
cf2_sur:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	c.sur1c			!
	nop				!
    c.sur0c:				!
	retl				! case even:
	add	%g0,t.sur0e-t.sur0s,%o0	!
    c.sur1c:				!
	retl				! case odd:
	add	%g0,t.sur1e-t.sur1s,%o0	!   specification exception
tf2_sur:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	t.sur1t			!
	nop				!
    t.sur0t:				!
	sethi	%hi(t.sur0s),%o3	!
	or	%o3,%lo(t.sur0s),%o3	!
	or	%g0,t.sur0e-t.sur0s,%o4	!
    t.sur0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.sur0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.sur0o0-t.sur0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R2
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+t.sur0t0-t.sur0s]
	ld	[%o3+t.sur0o1-t.sur0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+t.sur0t1-t.sur0s]
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	ld	[%o3+t.sur0oy-t.sur0s],%o5
	bnz,a	.+8			! if EX=1 then IAR+=4
	ld	[%o3+t.sur0oz-t.sur0s],%o5
	st	%o5,[%o0+t.sur0tz-t.sur0s]
	retl				!
	add	%o0,t.sur0e-t.sur0s,%o0	!
    t.sur1t:				!
	sethi	%hi(t.sur1s),%o3	!
	or	%o3,%lo(t.sur1s),%o3	!
	or	%g0,t.sur1e-t.sur1s,%o4	!
    t.sur1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.sur1cp		!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,t.sur1e-t.sur1s,%o0	!
if2_sur:
	srl	%o1,20,%o3		! switch (R1)
	srl	%o1,16,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,1,%g0		!
	bnz	t.sur1s			!
	nop				!
    i.sur0t:				!
	srl	%o1,16,%o4		! R2
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	add	%o4,64,%i2		! %i2
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	add	%o4,64,%i0		! %i0
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	add	%g0,2,%l7		!
	bnz,a	.+8			! if EX=1 then IAR+=4
	add	%g0,4,%l7		!
t.sur0s:
		ld	[%sp+184],%o0	! struct *gcpu_s
    t.sur0t0:	add	%o0,%i2,%o2	! ##TEMPLATE:%imm
    t.sur0t1:	add	%o0,%i0,%o1	! ##TEMPLATE:%imm
		and	%g7,0xf,%o3	! give Program Mask
		stx	%g1,[%o0+648]	!
		stx	%g2,[%o0+656]	!
		stx	%g3,[%o0+664]	!
		stx	%g4,[%o0+672]	!
		stx	%g5,[%o0+680]	!
		sethi	%hi(fl_addsub_short_unnorm),%o7
		jmpl	%o7+%lo(fl_addsub_short_unnorm),%o7
		add	%g0,1,%o4	! call library in fltlib.s
		ld	[%sp+184],%o7	! struct *gcpu_s
		ldx	[%o7+648],%g1	!
		ldx	[%o7+656],%g2	!
		ldx	[%o7+664],%g3	!
		ldx	[%o7+672],%g4	!
		ldx	[%o7+680],%g5	!
		and	%o0,3,%g1	! CC=retval
		sethi	%hi(0x00ff0000),%o1
		andcc	%o0,%o1,%o0	! extract exception
		bz,a	t.sur0e		!   exit
    t.sur0tz:	add	%g2,%l7,%g2	! ##TEMPLATE:IAR
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! INTR-CODE=retval
t.sur0e:
		ba	break0		!
		nop			!
    t.sur0o0:	add	%o0,64,%o2	! ##TEMPLATE:%imm
    t.sur0o1:	add	%o0,64,%o1	! ##TEMPLATE:%imm
    t.sur0oy:	add	%g2,2,%g2	! ##TEMPLATE:IAR
    t.sur0oz:	add	%g2,4,%g2	! ##TEMPLATE:IAR
t.sur1s:
		sethi	%hi(0x00060000),%o0
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! specification exception
t.sur1e:
!================================

!
! templates
! cxx_xxx:
!   %o0: param: none
!	 retval:size of template
!   %o1: M instruction (4 bytes)
!   %o2: work
!   %o3: work
!   %o4: work
!   %o5: work
! txx_xxx:
!   %o0: param: bufp start address
!	 retval:bufp next start address
!   %o1: M instruction (4 bytes)
!   %o2: work
!   %o3: work
!   %o4: work
!   %o5: work
!
	.section ".text"
	.align	4
	.global ci4_sth,ti4_sth,ii4_sth
ci4_sth:
	retl				!
	add	%g0,t.sth0e-t.sth0s,%o0	!
ti4_sth:
	sethi	%hi(t.sth0s),%o3	!
	or	%o3,%lo(t.sth0s),%o3	!
	or	%g0,t.sth0e-t.sth0s,%o4	!
    t.sth0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.sth0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.sth0o0-t.sth0s],%o5
	srl	%o1,16,%o4		!
	andcc	%o4,0xf,%o4		! X2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+t.sth0t0-t.sth0s]
	ld	[%o3+t.sth0o1-t.sth0s],%o5
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.sth0t1-t.sth0s]
	ld	[%o3+t.sth0o2-t.sth0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,25,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+t.sth0t2-t.sth0s]
	retl				!
	add	%o0,t.sth0e-t.sth0s,%o0	!
ii4_sth:
	srl	%o1,16,%o4		! X2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l2		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l2		! %l2
	srl	%o1,12,%o4		! B2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l3		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l3		! %l3
	and	%o1,0xfff,%l4		! D2
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l0		! %l0
t.sth0s:
    t.sth0t0:	add	%l2,%l3,%o0	! ##TEMPLATE:%l0,%l0
    t.sth0t1:	add	%o0,%l4,%o0	! ##TEMPLATE:imm0
		and	%o0,%g3,%o0	! mask address
    t.sth0t2:	sth	%l0,[%g4+%o0]	! ##TEMPLATE:%l0
		add	%g2,4,%g2	! update IAR
t.sth0e:
		ba	break0		!
		nop			!
    t.sth0o0:	add	%l0,%l0,%o0	! ##TEMPLATE:%l0,%l0
    t.sth0o1:	add	%o0,0,%o0	! ##TEMPLATE:imm0
    t.sth0o2:	sth	%l0,[%g4+%o0]	! ##TEMPLATE:%l0

	.section ".text"
	.align	4
	.global ci4_la,ti4_la,ii4_la
ci4_la:
	retl				!
	add	%g0,t.la0e-t.la0s,%o0	!
ti4_la:
	sethi	%hi(t.la0s),%o3		!
	or	%o3,%lo(t.la0s),%o3	!
	or	%g0,t.la0e-t.la0s,%o4	!
    t.la0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.la0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.la0o0-t.la0s],%o5!
	srl	%o1,16,%o4		!
	andcc	%o4,0xf,%o4		! X2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+t.la0t0-t.la0s]!
	ld	[%o3+t.la0o1-t.la0s],%o5!
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.la0t1-t.la0s]!
	ld	[%o3+t.la0o2-t.la0s],%o5!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,25,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+t.la0t2-t.la0s]!
	ld	[%o3+t.la0o3-t.la0s],%o5!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,25,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+t.la0t3-t.la0s]!
	retl				!
	add	%o0,t.la0e-t.la0s,%o0	!
ii4_la:
	srl	%o1,16,%o4		! X2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l2		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l2		! %l2
	srl	%o1,12,%o4		! B2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l3		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l3		! %l3
	and	%o1,0xfff,%l4		! D2
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%i0		! save as %i0
t.la0s:
    t.la0t0:	add	%l2,%l3,%o0	! ##TEMPLATE:%l0,%l0
    t.la0t1:	add	%o0,%l4,%o0	! ##TEMPLATE:imm0
		andcc	%g7,0x10,%g0	! if AM == 0 then
		sethi	%hi(0x80000000),%o1
		bnz,a	t.la000		!   extract lower 24bit
    t.la0t2:	andn	%o0,%o1,%l0	! ##TEMPLATE:%l0
		sethi	%hi(0xff000000),%o2
    t.la0t3:	andn	%o0,%o2,%l0	! ##TEMPLATE:%l0
    t.la000:	add	%g2,4,%g2	! update IAR
t.la0e:
		ba	break0		!
		st	%l0,[%o7+%i0]	! R1
    t.la0o0:	add	%l0,%l0,%o0	! ##TEMPLATE:%l0,%l0
    t.la0o1:	add	%o0,0,%o0	! ##TEMPLATE:imm0
    t.la0o2:	andn	%o0,%o1,%l0	! ##TEMPLATE:%l0
    t.la0o3:	andn	%o0,%o2,%l0	! ##TEMPLATE:%l0

	.section ".text"
	.align	4
	.global ci4_stc,ti4_stc,ii4_stc
ci4_stc:
	retl				!
	add	%g0,t.stc0e-t.stc0s,%o0	!
ti4_stc:
	sethi	%hi(t.stc0s),%o3	!
	or	%o3,%lo(t.stc0s),%o3	!
	or	%g0,t.stc0e-t.stc0s,%o4	!
    t.stc0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.stc0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.stc0o0-t.stc0s],%o5
	srl	%o1,16,%o4		!
	andcc	%o4,0xf,%o4		! X2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+t.stc0t0-t.stc0s]
	ld	[%o3+t.stc0o1-t.stc0s],%o5
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.stc0t1-t.stc0s]
	ld	[%o3+t.stc0o2-t.stc0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,25,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+t.stc0t2-t.stc0s]
	retl				!
	add	%o0,t.stc0e-t.stc0s,%o0	!
ii4_stc:
	srl	%o1,16,%o4		! X2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l2		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l2		! %l2
	srl	%o1,12,%o4		! B2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l3		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l3		! %l3
	and	%o1,0xfff,%l4		! D2
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l0		! %l0
t.stc0s:
    t.stc0t0:	add	%l2,%l3,%o0	! ##TEMPLATE:%l0,%l0
    t.stc0t1:	add	%o0,%l4,%o0	! ##TEMPLATE:imm0
		and	%o0,%g3,%o0	! mask address
    t.stc0t2:	stb	%l0,[%g4+%o0]	! ##TEMPLATE:%l0
		add	%g2,4,%g2	! update IAR
t.stc0e:
		ba	break0		!
		nop			!
    t.stc0o0:	add	%l0,%l0,%o0	! ##TEMPLATE:%l0,%l0
    t.stc0o1:	add	%o0,0,%o0	! ##TEMPLATE:imm0
    t.stc0o2:	stb	%l0,[%g4+%o0]	! ##TEMPLATE:%l0

	.section ".text"
	.align	4
	.global ci4_ic,ti4_ic,ii4_ic
ci4_ic:
	retl				!
	add	%g0,t.ic0e-t.ic0s,%o0	!
ti4_ic:
	sethi	%hi(t.ic0s),%o3		!
	or	%o3,%lo(t.ic0s),%o3	!
	or	%g0,t.ic0e-t.ic0s,%o4	!
    t.ic0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.ic0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.ic0o0-t.ic0s],%o5!
	srl	%o1,16,%o4		!
	andcc	%o4,0xf,%o4		! X2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+t.ic0t0-t.ic0s]!
	ld	[%o3+t.ic0o1-t.ic0s],%o5!
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.ic0t1-t.ic0s]!
	ld	[%o3+t.ic0o2-t.ic0s],%o5!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+t.ic0t2-t.ic0s]!
	ld	[%o3+t.ic0o3-t.ic0s],%o5!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,25,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+t.ic0t3-t.ic0s]!
	retl				!
	add	%o0,t.ic0e-t.ic0s,%o0	!
ii4_ic:
	srl	%o1,16,%o4		! X2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l2		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l2		! %l2
	srl	%o1,12,%o4		! B2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l3		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l3		! %l3
	and	%o1,0xfff,%l4		! D2
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%i0		! save as %i0
	ld	[%o7+%i0],%l0		! %l0
t.ic0s:
    t.ic0t0:	add	%l2,%l3,%o0	! ##TEMPLATE:%l0,%l0
    t.ic0t1:	add	%o0,%l4,%o0	! ##TEMPLATE:imm0
		and	%o0,%g3,%o0	! mask address
		ldub	[%g4+%o0],%o0	!
    t.ic0t2:	andn	%l0,0xff,%o1	! ##TEMPLATE:%l0
    t.ic0t3:	or	%o0,%o1,%l0	! ##TEMPLATE:%l0
		add	%g2,4,%g2	! update IAR
t.ic0e:
		ba	break0		!
		st	%l0,[%o7+%i0]	! R1
    t.ic0o0:	add	%l0,%l0,%o0	! ##TEMPLATE:%l0,%l0
    t.ic0o1:	add	%o0,0,%o0	! ##TEMPLATE:imm0
    t.ic0o2:	andn	%l0,0xff,%o1	! ##TEMPLATE:%l0
    t.ic0o3:	or	%o0,%o1,%l0	! ##TEMPLATE:%l0

	.section ".text"
	.align	4
	.global ci4_ex,ti4_ex,ii4_ex
ci4_ex:
	andcc	%g7,0x40,%g0		! if EX EX then
	bnz	c.ex2c			!   execute exception
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,0xf,%g0		!
	bnz	c.ex1c			!
	nop				!
    c.ex0c:				!
	retl				! case 0:
	add	%g0,t.ex0e-t.ex0s,%o0	!
    c.ex1c:				!
	retl				! case not 0:
	add	%g0,t.ex1e-t.ex1s,%o0	!
    c.ex2c:				!
	retl				! case execute exception
	add	%g0,t.ex2e-t.ex2s,%o0	!
ti4_ex:
	andcc	%g7,0x40,%g0		! if EX EX then
	bnz	t.ex2t			!   execute exception
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,0xf,%g0		!
	bnz	t.ex1t			!
	nop				!
    t.ex0t:				!
	sethi	%hi(t.ex0s),%o3		!
	or	%o3,%lo(t.ex0s),%o3	!
	or	%g0,t.ex0e-t.ex0s,%o4	!
    t.ex0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.ex0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.ex0o0-t.ex0s],%o5!
	srl	%o1,16,%o4		!
	andcc	%o4,0xf,%o4		! X2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,12,%o4
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+t.ex0t0-t.ex0s]!
	ld	[%o3+t.ex0o1-t.ex0s],%o5!
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.ex0t1-t.ex0s]!
	retl				!
	add	%o0,t.ex0e-t.ex0s,%o0	!
    t.ex1t:				!
	sethi	%hi(t.ex1s),%o3		!
	or	%o3,%lo(t.ex1s),%o3	!
	or	%g0,t.ex1e-t.ex1s,%o4	!
    t.ex1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.ex1cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.ex1o0-t.ex1s],%o5!
	srl	%o1,16,%o4		!
	andcc	%o4,0xf,%o4		! X2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+t.ex1t0-t.ex1s]!
	ld	[%o3+t.ex1o1-t.ex1s],%o5!
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.ex1t1-t.ex1s]!
	ld	[%o3+t.ex1o2-t.ex1s],%o5!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+t.ex1t2-t.ex1s]!
	retl				!
	add	%o0,t.ex1e-t.ex1s,%o0	!
    t.ex2t:				!
	sethi	%hi(t.ex2s),%o3		!
	or	%o3,%lo(t.ex2s),%o3	!
	or	%g0,t.ex2e-t.ex2s,%o4	!
    t.ex2cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.ex2cp			!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,t.ex2e-t.ex2s,%o0	!
ii4_ex:
	andcc	%g7,0x40,%g0		! if EX EX then
	bnz	t.ex2s			!   execute exception
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,0xf,%g0		!
	bnz	i.ex1t			!
	nop				!
    i.ex0t:				!
	srl	%o1,16,%o4		! X2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l2		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l2		! %l2
	srl	%o1,12,%o4		! B2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l3		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l3		! %l3
	and	%o1,0xfff,%l4		! D2
	ba	t.ex0s			!
	nop				!
    i.ex1t:				!
	srl	%o1,16,%o4		! X2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l2		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l2		! %l2
	srl	%o1,12,%o4		! B2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l3		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l3		! %l3
	and	%o1,0xfff,%l4		! D2
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l0		! %l0
	ba	t.ex1s			!
	nop				!
t.ex0s:
	! retval:%o1:or-value		!
	!	 %o2:D2(X2,B2) address	!
    t.ex0t0:	add	%l2,%l3,%o2	! ##TEMPLATE:%l0,%l0
    t.ex0t1:	add	%o2,%l4,%o2	! ##TEMPLATE:imm0
		sethi	%hi(trans_ex),%o0
		jmpl	%o0+%lo(trans_ex),%g0
		or	%g0,0,%o1	! or-value = 0
t.ex0e:
    t.ex0o0:	add	%l0,%l0,%o2	! ##TEMPLATE:%l0,%l0
    t.ex0o1:	add	%o2,0,%o2	! ##TEMPLATE:imm0
t.ex1s:
	! retval:%o1:or-value		!
	!	 %o2:D2(X2,B2) address	!
    t.ex1t0:	add	%l2,%l3,%o2	! ##TEMPLATE:%l0,%l0
    t.ex1t1:	add	%o2,%l4,%o2	! ##TEMPLATE:imm0
		sethi	%hi(trans_ex),%o0
		jmpl	%o0+%lo(trans_ex),%g0
    t.ex1t2:	and	%l0,0xff,%o1	! ##TEMPLATE:%l0
t.ex1e:
    t.ex1o0:	add	%l0,%l0,%o2	! ##TEMPLATE:%l0,%l0
    t.ex1o1:	add	%o2,0,%o2	! ##TEMPLATE:imm0
    t.ex1o2:	and	%l0,0xff,%o1	! ##TEMPLATE:%l0
t.ex2s:
		sethi	%hi(0x00030000),%o0
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! execute exception
t.ex2e:

	.section ".text"
	.align	4
	.global ci4_bal,ti4_bal,ii4_bal
ci4_bal:
	retl				!
	add	%g0,t.bal0e-t.bal0s,%o0	!
ti4_bal:
	sethi	%hi(t.bal0s),%o3	!
	or	%o3,%lo(t.bal0s),%o3	!
	or	%g0,t.bal0e-t.bal0s,%o4	!
    t.bal0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.bal0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.bal0o0-t.bal0s],%o5
	srl	%o1,16,%o4		!
	andcc	%o4,0xf,%o4		! X2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+t.bal0t0-t.bal0s]
	ld	[%o3+t.bal0o1-t.bal0s],%o5
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.bal0t1-t.bal0s]
	ld	[%o3+t.bal0o2-t.bal0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,25,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+t.bal0t2-t.bal0s]
	ld	[%o3+t.bal0o3-t.bal0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,25,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+t.bal0t3-t.bal0s]
	retl				!
	add	%o0,t.bal0e-t.bal0s,%o0	!
t.bal0s:
		add	%g2,%g0,%o5	! save OPC
		add	%g2,4,%g2	! update IAR
    t.bal0t0:	add	%l0,%l0,%o0	! ##TEMPLATE:%l0,%l0
    t.bal0t1:	add	%o0,0,%o0	! ##TEMPLATE:imm0
		andcc	%g7,0x10,%g0	! if 31bit address then
		sethi	%hi(0x80000000),%o1
		bnz,a	t.bal000	!
    t.bal0t2:	or	%o1,%g2,%l0	! ##TEMPLATE:%l0
		sethi	%hi(0xff000000),%o1
		andn	%g2,%o1,%o2	! if 24bit address then
		or	%g1,8,%o1	!   ILC|CC
		sll	%o1,28,%o1	!
		or	%o1,%o2,%o2	!
		and	%g7,0xf,%o1	!   Prog-Mask
		sll	%o1,24,%o1	!
    t.bal0t3:	or	%o1,%o2,%l0	! ##TEMPLATE:%l0
    t.bal000:	sethi	%hi(break2),%o7	! BRANCH TAKEN
		jmpl	%o7+%lo(break2),%g0
		add	%g0,%o0,%g2	!
t.bal0e:
    t.bal0o0:	add	%l0,%l0,%o0	! ##TEMPLATE:%l0,%l0
    t.bal0o1:	add	%o0,0,%o0	! ##TEMPLATE:imm0
    t.bal0o2:	or	%o1,%g2,%l0	! ##TEMPLATE:%l0
    t.bal0o3:	or	%o1,%o2,%l0	! ##TEMPLATE:%l0
ii4_bal:
	srl	%o1,16,%o4		! X2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l2		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l2		! %l2
	srl	%o1,12,%o4		! B2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l3		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l3		! %l3
	and	%o1,0xfff,%l4		! D2
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%i0		! save as %i0
i.bal0s:
		add	%g2,%g0,%o5	! save OPC
		add	%g2,4,%g2	! update IAR
    i.bal0t0:	add	%l2,%l3,%o0	! ##TEMPLATE:%l0,%l0
    i.bal0t1:	add	%o0,%l4,%o0	! ##TEMPLATE:imm0
		andcc	%g7,0x10,%g0	! if 31bit address then
		sethi	%hi(0x80000000),%o1
		bnz,a	i.bal000	!
    i.bal0t2:	or	%o1,%g2,%l0	! ##TEMPLATE:%l0
		sethi	%hi(0xff000000),%o1
		andn	%g2,%o1,%o2	! if 24bit address then
		or	%g1,8,%o1	!   ILC|CC
		sll	%o1,28,%o1	!
		or	%o1,%o2,%o2	!
		and	%g7,0xf,%o1	!   Prog-Mask
		sll	%o1,24,%o1	!
    i.bal0t3:	or	%o1,%o2,%l0	! ##TEMPLATE:%l0
    i.bal000:	st	%l0,[%o7+%i0]	! R1
		ba	break1		! BRANCH TAKEN
		add	%g0,%o0,%g2	!
i.bal0e:

	.section ".text"
	.align	4
	.global ci4_bct,ti4_bct,ii4_bct
ci4_bct:
	retl				!
	add	%g0,t.bct0e-t.bct0s,%o0	!
ti4_bct:
	sethi	%hi(t.bct0s),%o3	!
	or	%o3,%lo(t.bct0s),%o3	!
	or	%g0,t.bct0e-t.bct0s,%o4	!
    t.bct0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.bct0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.bct0o0-t.bct0s],%o5
	srl	%o1,16,%o4		!
	andcc	%o4,0xf,%o4		! X2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+t.bct0t0-t.bct0s]
	ld	[%o3+t.bct0o1-t.bct0s],%o5
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.bct0t1-t.bct0s]
	ld	[%o3+t.bct0o2-t.bct0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	sll	%o4,11,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+t.bct0t2-t.bct0s]
	retl				!
	add	%o0,t.bct0e-t.bct0s,%o0	!
t.bct0s:
    t.bct0t0:	add	%l0,%l0,%o0	! ##TEMPLATE:%l0,%l0
    t.bct0t1:	add	%o0,0,%o0	! ##TEMPLATE:imm0
    t.bct0t2:	subcc	%l0,1,%l0	! ##TEMPLATE:%l0,%l0
		bz,a	t.bct0e		! if %l0 != 0 then taken
		add	%g2,4,%g2	! update IAR
		add	%g2,%g0,%o5	! save OPC
		sethi	%hi(break2),%o7	! BRANCH TAKEN
		jmpl	%o7+%lo(break2),%g0
		add	%g0,%o0,%g2	!
t.bct0e:
    t.bct0o0:	add	%l0,%l0,%o0	! ##TEMPLATE:%l0,%l0
    t.bct0o1:	add	%o0,0,%o0	! ##TEMPLATE:imm0
    t.bct0o2:	subcc	%l0,1,%l0	! ##TEMPLATE:%l0,%l0
ii4_bct:
	srl	%o1,16,%o4		! X2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l2		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l2		! %l2
	srl	%o1,12,%o4		! B2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l3		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l3		! %l3
	and	%o1,0xfff,%l4		! D2
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%i0		! save as %i0
	ld	[%o7+%i0],%l0		! %l0
i.bct0s:
    i.bct0t0:	add	%l2,%l3,%o0	! ##TEMPLATE:%l0,%l0
    i.bct0t1:	add	%o0,%l4,%o0	! ##TEMPLATE:imm0
    i.bct0t2:	subcc	%l0,1,%l0	! ##TEMPLATE:%l0,%l0
		st	%l0,[%o7+%i0]	! R1
		bz,a	break0		! if %l0 != 0 then taken
		add	%g2,4,%g2	! update IAR
		add	%g2,%g0,%o5	! save OPC
		ba	break1		! BRANCH TAKEN
		add	%g0,%o0,%g2	!
i.bct0e:

	.section ".text"
	.align	4
	.global ci4_bc,ti4_bc,ii4_bc
ci4_bc:
	srl	%o1,20,%o3		! switch (M1)
	andcc	%o3,0xf,%o3		!
	bz	c.bc0c			!
	subcc	%o3,0xf,%g0		!
	bne	c.bc2c			!
	nop				!
    c.bc3c:				!
	retl				! case 15:
	add	%g0,t.bc3e-t.bc3s,%o0	!
    c.bc0c:				!
	sethi	%hi(0x47000fed),%o3	! case 0:
	or	%o3,%lo(0x47000fed),%o3 !
	subcc	%o1,%o3,%g0		!
	be	c.bc1c			!
	nop				!
	retl				!   nop
	add	%g0,t.bc0e-t.bc0s,%o0	!
    c.bc1c:				!
	retl				!   emm_call
	add	%g0,t.bc1e-t.bc1s,%o0	!
    c.bc2c:				!
	retl				! case 1-14:
	add	%g0,t.bc2e-t.bc2s,%o0	!
ti4_bc:
	srl	%o1,20,%o3		! switch (M1)
	andcc	%o3,0xf,%o3		!
	bz	t.bc0t			!
	subcc	%o3,0xf,%g0		!
	bne	t.bc2t			!
	nop				!
    t.bc3t:				!
	sethi	%hi(t.bc3s),%o3		!
	or	%o3,%lo(t.bc3s),%o3	!
	or	%g0,t.bc3e-t.bc3s,%o4	!
    t.bc3cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.bc3cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.bc3o0-t.bc3s],%o5!
	srl	%o1,16,%o4		!
	andcc	%o4,0xf,%o4		! X2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+t.bc3t0-t.bc3s]!
	ld	[%o3+t.bc3o1-t.bc3s],%o5!
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.bc3t1-t.bc3s]!
	retl				!
	add	%o0,t.bc3e-t.bc3s,%o0	!
    t.bc0t:				!
	sethi	%hi(0x47000fed),%o3	! case 0:
	or	%o3,%lo(0x47000fed),%o3 !
	subcc	%o1,%o3,%g0		!
	be	t.bc1t			!
	nop				!
	sethi	%hi(t.bc0s),%o3		!
	or	%o3,%lo(t.bc0s),%o3	!
	or	%g0,t.bc0e-t.bc0s,%o4	!
    t.bc0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.bc0cp			!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,t.bc0e-t.bc0s,%o0	!
    t.bc1t:				!
	sethi	%hi(t.bc1s),%o3		!
	or	%o3,%lo(t.bc1s),%o3	!
	or	%g0,t.bc1e-t.bc1s,%o4	!
    t.bc1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.bc1cp			!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,t.bc1e-t.bc1s,%o0	!
    t.bc2t:				!
	sethi	%hi(t.bc2s),%o3		!
	or	%o3,%lo(t.bc2s),%o3	!
	or	%g0,t.bc2e-t.bc2s,%o4	!
    t.bc2cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.bc2cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.bc2o0-t.bc2s],%o5!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! M1
	sll	%o4,8,%o4		! |
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.bc2t0-t.bc2s]!
	ld	[%o3+t.bc2o1-t.bc2s],%o5!
	srl	%o1,16,%o4		!
	andcc	%o4,0xf,%o4		! X2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+t.bc2t1-t.bc2s]!
	ld	[%o3+t.bc2o2-t.bc2s],%o5!
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.bc2t2-t.bc2s]!
	retl				!
	add	%o0,t.bc2e-t.bc2s,%o0	!
t.bc3s:
    t.bc3t0:	add	%l0,%l0,%o0	! ##TEMPLATE:%l0,%l0
		add	%g2,%g0,%o5	! save OPC
		sethi	%hi(break2),%o7	! BRANCH TAKEN
		jmpl	%o7+%lo(break2),%g0
    t.bc3t1:	add	%o0,0,%g2	! ##TEMPLATE:imm0
t.bc3e:
    t.bc3o0:	add	%l0,%l0,%o0	! ##TEMPLATE:%l0,%l0
    t.bc3o1:	add	%o0,0,%g2	! ##TEMPLATE:imm0
t.bc0s:
		add	%g2,4,%g2	! update IAR
t.bc0e:
t.bc1s:
		sethi	%hi(0xc0000000),%o0
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! extended function (FC=3)
t.bc1e:
t.bc2s:
		srl	%g7,%g1,%o1	! const.0b0001000XXXXXXXX >> %o1
    t.bc2t0:	andcc	%o1,0,%g0	! ##TEMPLATE:imm0
		bz,a	t.bc2e		! if CC is true then taken
		add	%g2,4,%g2	! update IAR
    t.bc2t1:	add	%l0,%l0,%o0	! ##TEMPLATE:%l0,%l0
		add	%g2,%g0,%o5	! save OPC
		sethi	%hi(break2),%o7	! BRANCH TAKEN
		jmpl	%o7+%lo(break2),%g0
    t.bc2t2:	add	%o0,0,%g2	! ##TEMPLATE:imm0
t.bc2e:
    t.bc2o0:	andcc	%o1,0,%g0	! ##TEMPLATE:imm0
    t.bc2o1:	add	%l0,%l0,%o0	! ##TEMPLATE:%l0,%l0
    t.bc2o2:	add	%o0,0,%g2	! ##TEMPLATE:imm0
ii4_bc:
	srl	%o1,20,%o3		! switch (M1)
	andcc	%o3,0xf,%o3		!
	bz	i.bc0t			!
	subcc	%o3,0xf,%g0		!
	bne	i.bc2t			!
	nop				!
    i.bc3t:				!
	srl	%o1,16,%o4		! X2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l2		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l2		! %l2
	srl	%o1,12,%o4		! B2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l3		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l3		! %l3
	and	%o1,0xfff,%l4		! D2
	add	%l2,%l3,%o0		! ##TEMPLATE:%l0,%l0
	add	%g2,%g0,%o5		! save OPC
	ba	break1			! BRANCH TAKEN
	add	%o0,%l4,%g2		! ##TEMPLATE:imm0
    i.bc0t:				!
	sethi	%hi(0x47000fed),%o3	! case 0:
	or	%o3,%lo(0x47000fed),%o3 !
	subcc	%o1,%o3,%g0		!
	be	i.bc1t			!
	nop				!
	ba	break0			!
	add	%g2,4,%g2		! update IAR
    i.bc1t:				!
	sethi	%hi(0xc0000000),%o0	!
	ba	epilog0			!
	or	%g7,%o0,%g7		! extended function (FC=3)
    i.bc2t:				!
	srl	%o1,20,%o4		! M1
	and	%o4,0xf,%o4		! |
	sll	%o4,8,%l0		! %l0
	srl	%o1,16,%o4		! X2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l2		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l2		! %l2
	srl	%o1,12,%o4		! B2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l3		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l3		! %l3
	and	%o1,0xfff,%l4		! D2
i.bc2s:
		srl	%g7,%g1,%o1	! consi.0b0001000XXXXXXXX >> %o1
    i.bc2t0:	andcc	%o1,%l0,%g0	! ##TEMPLATE:imm0
		bz,a	break0		! if CC is true then taken
		add	%g2,4,%g2	! update IAR
    i.bc2t1:	add	%l2,%l3,%o0	! ##TEMPLATE:%l0,%l0
		add	%g2,%g0,%o5	! save OPC
		ba	break1		! BRANCH TAKEN
    i.bc2t2:	add	%o0,%l4,%g2	! ##TEMPLATE:imm0
i.bc2e:

	.section ".text"
	.align	4
	.global ci4_lh,ti4_lh,ii4_lh
ci4_lh:
	retl				!
	add	%g0,t.lh0e-t.lh0s,%o0	!
ti4_lh:
	sethi	%hi(t.lh0s),%o3		!
	or	%o3,%lo(t.lh0s),%o3	!
	or	%g0,t.lh0e-t.lh0s,%o4	!
    t.lh0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.lh0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.lh0o0-t.lh0s],%o5!
	srl	%o1,16,%o4		!
	andcc	%o4,0xf,%o4		! X2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+t.lh0t0-t.lh0s]!
	ld	[%o3+t.lh0o1-t.lh0s],%o5!
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.lh0t1-t.lh0s]!
	ld	[%o3+t.lh0o2-t.lh0s],%o5!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,25,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+t.lh0t2-t.lh0s]!
	retl				!
	add	%o0,t.lh0e-t.lh0s,%o0	!
ii4_lh:
	srl	%o1,16,%o4		! X2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l2		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l2		! %l2
	srl	%o1,12,%o4		! B2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l3		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l3		! %l3
	and	%o1,0xfff,%l4		! D2
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%i0		! save as %i0
t.lh0s:
    t.lh0t0:	add	%l2,%l3,%o0	! ##TEMPLATE:%l0,%l0
    t.lh0t1:	add	%o0,%l4,%o0	! ##TEMPLATE:imm0
		and	%o0,%g3,%o0	! mask address
    t.lh0t2:	ldsh	[%g4+%o0],%l0	! ##TEMPLATE:%l0
		add	%g2,4,%g2	! update IAR
t.lh0e:
		ba	break0		!
		st	%l0,[%o7+%i0]	! R1
    t.lh0o0:	add	%l0,%l0,%o0	! ##TEMPLATE:%l0,%l0
    t.lh0o1:	add	%o0,0,%o0	! ##TEMPLATE:imm0
    t.lh0o2:	ldsh	[%g4+%o0],%l0	! ##TEMPLATE:%l0

	.section ".text"
	.align	4
	.global ci4_ch,ti4_ch,ii4_ch
ci4_ch:
	retl				!
	add	%g0,t.ch0e-t.ch0s,%o0	!
ti4_ch:
	sethi	%hi(t.ch0s),%o3		!
	or	%o3,%lo(t.ch0s),%o3	!
	or	%g0,t.ch0e-t.ch0s,%o4	!
    t.ch0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.ch0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.ch0o0-t.ch0s],%o5!
	srl	%o1,16,%o4		!
	andcc	%o4,0xf,%o4		! X2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+t.ch0t0-t.ch0s]!
	ld	[%o3+t.ch0o1-t.ch0s],%o5!
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.ch0t1-t.ch0s]!
	ld	[%o3+t.ch0o2-t.ch0s],%o5!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+t.ch0t2-t.ch0s]!
	retl				!
	add	%o0,t.ch0e-t.ch0s,%o0	!
ii4_ch:
	srl	%o1,16,%o4		! X2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l2		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l2		! %l2
	srl	%o1,12,%o4		! B2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l3		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l3		! %l3
	and	%o1,0xfff,%l4		! D2
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l0		! %l0
t.ch0s:
    t.ch0t0:	add	%l2,%l3,%o0	! ##TEMPLATE:%l0,%l0
    t.ch0t1:	add	%o0,%l4,%o0	! ##TEMPLATE:imm0
		and	%o0,%g3,%o0	! mask address
		ldsh	[%g4+%o0],%o0	!
		andn	%g1,3,%g1	! CC=0
    t.ch0t2:	subcc	%l0,%o0,%g0	! ##TEMPLATE:%l0
		bg,a	t.ch001		! if %l0 > 0 then
		or	%g1,2,%g1	!   CC=2
		bl,a	t.ch001		! if %l0 < 0 then
		or	%g1,1,%g1	!   CC=1
    t.ch001:	add	%g2,4,%g2	! update IAR
t.ch0e:
		ba	break0		!
		nop			!
    t.ch0o0:	add	%l0,%l0,%o0	! ##TEMPLATE:%l0,%l0
    t.ch0o1:	add	%o0,0,%o0	! ##TEMPLATE:imm0
    t.ch0o2:	subcc	%l0,%o0,%g0	! ##TEMPLATE:%l0

	.section ".text"
	.align	4
	.global ci4_ah,ti4_ah,ii4_ah
ci4_ah:
	retl				!
	add	%g0,t.ah0e-t.ah0s,%o0	!
ti4_ah:
	sethi	%hi(t.ah0s),%o3		!
	or	%o3,%lo(t.ah0s),%o3	!
	or	%g0,t.ah0e-t.ah0s,%o4	!
    t.ah0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.ah0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.ah0o0-t.ah0s],%o5!
	srl	%o1,16,%o4		!
	andcc	%o4,0xf,%o4		! X2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+t.ah0t0-t.ah0s]!
	ld	[%o3+t.ah0o1-t.ah0s],%o5!
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.ah0t1-t.ah0s]!
	ld	[%o3+t.ah0o2-t.ah0s],%o5!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	sll	%o4,11,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+t.ah0t2-t.ah0s]!
	retl				!
	add	%o0,t.ah0e-t.ah0s,%o0	!
t.ah0s:
    t.ah0t0:	add	%l0,%l0,%o0	! ##TEMPLATE:%l0,%l0
    t.ah0t1:	add	%o0,0,%o0	! ##TEMPLATE:imm0
		and	%o0,%g3,%o0	! mask address
		ldsh	[%g4+%o0],%o0	!
		andn	%g1,3,%g1	! CC=0
    t.ah0t2:	addcc	%l0,%o0,%l0	! ##TEMPLATE:%l0,%l0
		bvc	t.ah000		! if overflow then
		nop			!
		andcc	%g7,8,%g0	!   CC=3
		bz	t.ah002		!   if fixed-point overflow mask then
		or	%g1,3,%g1	!
		sethi	%hi(0x00080000),%o0
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	!     fixed-point overflow
    t.ah000:	bg,a	t.ah002		! if %l0 > 0 then
		or	%g1,2,%g1	!   CC=2
		bl,a	t.ah002		! if %l0 < 0 then
		or	%g1,1,%g1	!   CC=1
    t.ah002:	add	%g2,4,%g2	! update IAR
t.ah0e:
    t.ah0o0:	add	%l0,%l0,%o0	! ##TEMPLATE:%l0,%l0
    t.ah0o1:	add	%o0,0,%o0	! ##TEMPLATE:imm0
    t.ah0o2:	addcc	%l0,%o0,%l0	! ##TEMPLATE:%l0,%l0
ii4_ah:
	srl	%o1,16,%o4		! X2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l2		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l2		! %l2
	srl	%o1,12,%o4		! B2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l3		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l3		! %l3
	and	%o1,0xfff,%l4		! D2
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%i0		! save as %i0
	ld	[%o7+%i0],%l0		! %l0
i.ah0s:
    i.ah0t0:	add	%l2,%l3,%o0	! ##TEMPLATE:%l0,%l0
    i.ah0t1:	add	%o0,%l4,%o0	! ##TEMPLATE:imm0
		and	%o0,%g3,%o0	! mask address
		ldsh	[%g4+%o0],%o0	!
		andn	%g1,3,%g1	! CC=0
    i.ah0t2:	addcc	%l0,%o0,%l0	! ##TEMPLATE:%l0,%l0
		st	%l0,[%o7+%i0]	! R1
		bvc	i.ah000		! if overflow then
		nop			!
		andcc	%g7,8,%g0	!   CC=3
		bz	i.ah002		!   if fixed-point overflow mask then
		or	%g1,3,%g1	!
		sethi	%hi(0x00080000),%o0
		ba	epilog0		!
		or	%g7,%o0,%g7	!     fixed-point overflow
    i.ah000:	bg,a	i.ah002		! if %l0 > 0 then
		or	%g1,2,%g1	!   CC=2
		bl,a	i.ah002		! if %l0 < 0 then
		or	%g1,1,%g1	!   CC=1
    i.ah002:	ba	break0		!
		add	%g2,4,%g2	! update IAR
i.ah0e:

	.section ".text"
	.align	4
	.global ci4_sh,ti4_sh,ii4_sh
ci4_sh:
	retl				!
	add	%g0,t.sh0e-t.sh0s,%o0	!
ti4_sh:
	sethi	%hi(t.sh0s),%o3		!
	or	%o3,%lo(t.sh0s),%o3	!
	or	%g0,t.sh0e-t.sh0s,%o4	!
    t.sh0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.sh0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.sh0o0-t.sh0s],%o5!
	srl	%o1,16,%o4		!
	andcc	%o4,0xf,%o4		! X2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+t.sh0t0-t.sh0s]!
	ld	[%o3+t.sh0o1-t.sh0s],%o5!
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.sh0t1-t.sh0s]!
	ld	[%o3+t.sh0o2-t.sh0s],%o5!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	sll	%o4,11,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+t.sh0t2-t.sh0s]!
	retl				!
	add	%o0,t.sh0e-t.sh0s,%o0	!
t.sh0s:
    t.sh0t0:	add	%l0,%l0,%o0	! ##TEMPLATE:%l0,%l0
    t.sh0t1:	add	%o0,0,%o0	! ##TEMPLATE:imm0
		and	%o0,%g3,%o0	! mask address
		ldsh	[%g4+%o0],%o0	!
		andn	%g1,3,%g1	! CC=0
    t.sh0t2:	subcc	%l0,%o0,%l0	! ##TEMPLATE:%l0,%l0
		bvc	t.sh000		! if overflow then
		nop			!
		andcc	%g7,8,%g0	!   CC=3
		bz	t.sh002		!   if fixed-point overflow mask then
		or	%g1,3,%g1	!
		sethi	%hi(0x00080000),%o0
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	!     fixed-point overflow
    t.sh000:	bg,a	t.sh002		! if %l0 > 0 then
		or	%g1,2,%g1	!   CC=2
		bl,a	t.sh002		! if %l0 < 0 then
		or	%g1,1,%g1	!   CC=1
    t.sh002:	add	%g2,4,%g2	! update IAR
t.sh0e:
    t.sh0o0:	add	%l0,%l0,%o0	! ##TEMPLATE:%l0,%l0
    t.sh0o1:	add	%o0,0,%o0	! ##TEMPLATE:imm0
    t.sh0o2:	subcc	%l0,%o0,%l0	! ##TEMPLATE:%l0,%l0
ii4_sh:
	srl	%o1,16,%o4		! X2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l2		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l2		! %l2
	srl	%o1,12,%o4		! B2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l3		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l3		! %l3
	and	%o1,0xfff,%l4		! D2
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%i0		! save as %i0
	ld	[%o7+%i0],%l0		! %l0
i.sh0s:
    i.sh0t0:	add	%l2,%l3,%o0	! ##TEMPLATE:%l0,%l0
    i.sh0t1:	add	%o0,%l4,%o0	! ##TEMPLATE:imm0
		and	%o0,%g3,%o0	! mask address
		ldsh	[%g4+%o0],%o0	!
		andn	%g1,3,%g1	! CC=0
    i.sh0t2:	subcc	%l0,%o0,%l0	! ##TEMPLATE:%l0,%l0
		st	%l0,[%o7+%i0]	! R1
		bvc	i.sh000		! if overflow then
		nop			!
		andcc	%g7,8,%g0	!   CC=3
		bz	i.sh002		!   if fixed-point overflow mask then
		or	%g1,3,%g1	!
		sethi	%hi(0x00080000),%o0
		ba	epilog0		!
		or	%g7,%o0,%g7	!     fixed-point overflow
    i.sh000:	bg,a	i.sh002		! if %l0 > 0 then
		or	%g1,2,%g1	!   CC=2
		bl,a	i.sh002		! if %l0 < 0 then
		or	%g1,1,%g1	!   CC=1
    i.sh002:	ba	break0		!
		add	%g2,4,%g2	! update IAR
i.sh0e:

	.section ".text"
	.align	4
	.global ci4_mh,ti4_mh,ii4_mh
ci4_mh:
	retl				!
	add	%g0,t.mh0e-t.mh0s,%o0	!
ti4_mh:
	sethi	%hi(t.mh0s),%o3		!
	or	%o3,%lo(t.mh0s),%o3	!
	or	%g0,t.mh0e-t.mh0s,%o4	!
    t.mh0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.mh0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.mh0o0-t.mh0s],%o5!
	srl	%o1,16,%o4		!
	andcc	%o4,0xf,%o4		! X2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+t.mh0t0-t.mh0s]!
	ld	[%o3+t.mh0o1-t.mh0s],%o5!
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.mh0t1-t.mh0s]!
	ld	[%o3+t.mh0o2-t.mh0s],%o5!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	sll	%o4,11,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+t.mh0t2-t.mh0s]!
	retl				!
	add	%o0,t.mh0e-t.mh0s,%o0	!
ii4_mh:
	srl	%o1,16,%o4		! X2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l2		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l2		! %l2
	srl	%o1,12,%o4		! B2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l3		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l3		! %l3
	and	%o1,0xfff,%l4		! D2
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%i0		! save as %i0
	ld	[%o7+%i0],%l0		! %l0
t.mh0s:
    t.mh0t0:	add	%l2,%l3,%o0	! ##TEMPLATE:%l0,%l0
    t.mh0t1:	add	%o0,%l4,%o0	! ##TEMPLATE:imm0
		and	%o0,%g3,%o0	! mask address
		ldsh	[%g4+%o0],%o0	!
    t.mh0t2:	smul	%l0,%o0,%l0	! ##TEMPLATE:%l0,%l0
		add	%g2,4,%g2	! update IAR
t.mh0e:
		ba	break0		!
		st	%l0,[%o7+%i0]	! R1
    t.mh0o0:	add	%l0,%l0,%o0	! ##TEMPLATE:%l0,%l0
    t.mh0o1:	add	%o0,0,%o0	! ##TEMPLATE:imm0
    t.mh0o2:	smul	%l0,%o0,%l0	! ##TEMPLATE:%l0,%l0

	.section ".text"
	.align	4
	.global ci4_bas,ti4_bas,ii4_bas
ci4_bas:
	retl				!
	add	%g0,t.bas0e-t.bas0s,%o0	!
ti4_bas:
	sethi	%hi(t.bas0s),%o3	!
	or	%o3,%lo(t.bas0s),%o3	!
	or	%g0,t.bas0e-t.bas0s,%o4	!
    t.bas0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.bas0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.bas0o0-t.bas0s],%o5
	srl	%o1,16,%o4		!
	andcc	%o4,0xf,%o4		! X2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+t.bas0t0-t.bas0s]
	ld	[%o3+t.bas0o1-t.bas0s],%o5
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.bas0t1-t.bas0s]
	ld	[%o3+t.bas0o2-t.bas0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,25,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+t.bas0t2-t.bas0s]
	ld	[%o3+t.bas0o3-t.bas0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,25,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+t.bas0t3-t.bas0s]
	retl				!
	add	%o0,t.bas0e-t.bas0s,%o0	!
t.bas0s:
		add	%g2,%g0,%o5	! save OPC
		add	%g2,4,%g2	! update IAR
    t.bas0t0:	add	%l0,%l0,%o0	! ##TEMPLATE:%l0,%l0
    t.bas0t1:	add	%o0,0,%o0	! ##TEMPLATE:imm0
		andcc	%g7,0x10,%g0	! if 31bit address then
		sethi	%hi(0x80000000),%o1
		bnz,a	t.bas000	!
    t.bas0t2:	or	%o1,%g2,%l0	! ##TEMPLATE:%l0
		sethi	%hi(0xff000000),%o1
    t.bas0t3:	andn	%g2,%o1,%l0	! ##TEMPLATE:%l0
    t.bas000:	sethi	%hi(break2),%o7	! BRANCH TAKEN
		jmpl	%o7+%lo(break2),%g0
		add	%g0,%o0,%g2	!
t.bas0e:
    t.bas0o0:	add	%l0,%l0,%o0	! ##TEMPLATE:%l0,%l0
    t.bas0o1:	add	%o0,0,%o0	! ##TEMPLATE:imm0
    t.bas0o2:	or	%o1,%g2,%l0	! ##TEMPLATE:%l0
    t.bas0o3:	andn	%g2,%o1,%l0	! ##TEMPLATE:%l0
ii4_bas:
	srl	%o1,16,%o4		! X2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l2		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l2		! %l2
	srl	%o1,12,%o4		! B2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l3		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l3		! %l3
	and	%o1,0xfff,%l4		! D2
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%i0		! save as %i0
i.bas0s:
		add	%g2,%g0,%o5	! save OPC
		add	%g2,4,%g2	! update IAR
    i.bas0t0:	add	%l2,%l3,%o0	! ##TEMPLATE:%l0,%l0
    i.bas0t1:	add	%o0,%l4,%o0	! ##TEMPLATE:imm0
		andcc	%g7,0x10,%g0	! if 31bit address then
		sethi	%hi(0x80000000),%o1
		bnz,a	i.bas000	!
    i.bas0t2:	or	%o1,%g2,%l0	! ##TEMPLATE:%l0
		sethi	%hi(0xff000000),%o1
    i.bas0t3:	andn	%g2,%o1,%l0	! ##TEMPLATE:%l0
    i.bas000:	st	%l0,[%o7+%i0]	! R1
		ba	break1		! BRANCH TAKEN
		add	%g0,%o0,%g2	!
i.bas0e:

	.section ".text"
	.align	4
	.global ci4_cvd,ti4_cvd,ii4_cvd
ci4_cvd:
	retl				!
	add	%g0,t.cvd0e-t.cvd0s,%o0	!
ti4_cvd:
	sethi	%hi(t.cvd0s),%o3	!
	or	%o3,%lo(t.cvd0s),%o3	!
	or	%g0,t.cvd0e-t.cvd0s,%o4	!
    t.cvd0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.cvd0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.cvd0o0-t.cvd0s],%o5
	srl	%o1,16,%o4		!
	andcc	%o4,0xf,%o4		! X2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+t.cvd0t0-t.cvd0s]
	ld	[%o3+t.cvd0o1-t.cvd0s],%o5
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.cvd0t1-t.cvd0s]
	ld	[%o3+t.cvd0o2-t.cvd0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	st	%o5,[%o0+t.cvd0t2-t.cvd0s]
	retl				!
	add	%o0,t.cvd0e-t.cvd0s,%o0	!
ii4_cvd:
	srl	%o1,16,%o4		! X2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l2		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l2		! %l2
	srl	%o1,12,%o4		! B2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l3		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l3		! %l3
	and	%o1,0xfff,%l4		! D2
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l0		! %l0
t.cvd0s:
    t.cvd0t0:	add	%l2,%l3,%o0	! ##TEMPLATE:%l0,%l0
    t.cvd0t1:	add	%o0,%l4,%o0	! ##TEMPLATE:imm0
		and	%o0,%g3,%o0	! mask address
		add	%g4,%o0,%o0	!
		ldub	[%o0],%g0	! force PAGEIN
		ldub	[%o0+7],%g0	! force PAGEIN
		add	%g0,7,%o5	!
    t.cvd0t2:	addcc	%g0,%l0,%o1	! ##TEMPLATE:%l0
		bneg,a	t.cvd000	!
		sub	%g0,%o1,%o1	!
		add	%g0,0xc,%o4	!
		ba,a	t.cvd001	!
    t.cvd000:	add	%g0,0xd,%o4	!
    t.cvd001:	wr	%g0,0,%y	!
		udiv	%o1,10,%o2	!
		umul	%o2,10,%o3	!
		sub	%o1,%o3,%o3	! remainder
		sll	%o3,4,%o3	!
		or	%o3,%o4,%o4	!
		stb	%o4,[%o0+%o5]	!
		wr	%g0,0,%y	!
		udiv	%o2,10,%o1	!
		umul	%o1,10,%o4	!
		sub	%o2,%o4,%o4	! remainder
		and	%o4,0xf,%o4	!
		subcc	%o1,%g0,%g0	!
		bnz	t.cvd001	!
		sub	%o5,1,%o5	!
    t.cvd002:	stb	%o4,[%o0+%o5]	!
		subcc	%o5,1,%o5	!
		bpos	t.cvd002	!
		add	%g0,0,%o4	!
		add	%g2,4,%g2	! update IAR
t.cvd0e:
		ba	break0		!
		nop			!
    t.cvd0o0:	add	%l0,%l0,%o0	! ##TEMPLATE:%l0,%l0
    t.cvd0o1:	add	%o0,0,%o0	! ##TEMPLATE:imm0
    t.cvd0o2:	addcc	%g0,%l0,%o1	! ##TEMPLATE:%l0

	.section ".text"
	.align	4
	.global ci4_cvb,ti4_cvb,ii4_cvb
ci4_cvb:
	retl				!
	add	%g0,t.cvb0e-t.cvb0s,%o0	!
ti4_cvb:
	sethi	%hi(t.cvb0s),%o3	!
	or	%o3,%lo(t.cvb0s),%o3	!
	or	%g0,t.cvb0e-t.cvb0s,%o4	!
    t.cvb0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.cvb0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.cvb0o0-t.cvb0s],%o5
	srl	%o1,16,%o4		!
	andcc	%o4,0xf,%o4		! X2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+t.cvb0t0-t.cvb0s]
	ld	[%o3+t.cvb0o1-t.cvb0s],%o5
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.cvb0t1-t.cvb0s]
	ld	[%o3+t.cvb0o2-t.cvb0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,25,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+t.cvb0t2-t.cvb0s]
	retl				!
	add	%o0,t.cvb0e-t.cvb0s,%o0	!
t.cvb0s:
    t.cvb0t0:	add	%l0,%l0,%o0	! ##TEMPLATE:%l0,%l0
    t.cvb0t1:	add	%o0,0,%o0	! ##TEMPLATE:imm0
		and	%o0,%g3,%o0	! mask address
		add	%g4,%o0,%o0	!
		add	%g0,0,%o3	! counter
		add	%g0,0,%o4	! upper half of DIGIMAL NUM
		add	%g0,0,%o5	! lower half of DIGIMAL NUM
		add	%g0,0,%o7	! BINARY NUM
    t.cvb000:	ldub	[%o0+%o3],%o1	!
		sll	%o4,8,%o4	!
		srl	%o5,24,%o2	!
		or	%o4,%o2,%o4	!
		sll	%o5,8,%o5	!
		or	%o5,%o1,%o5	! import right most byte
		srl	%o1,4,%o2	!
		umul	%o7,10,%o7	!
		add	%o7,%o2,%o7	!
		subcc	%o2,10,%g0	!
		bge,a	t.cvb004	! data exception
		sethi	%hi(0x00070000),%o0
		and	%o1,0xf,%o1	!
		subcc	%o3,7,%g0	!
		be,a	t.cvb001	!
		andn	%o5,0xf,%o5	!
		umul	%o7,10,%o7	!
		add	%o7,%o1,%o7	!
		subcc	%o1,10,%g0	!
		bge,a	t.cvb004	! data exception
		sethi	%hi(0x00070000),%o0
		ba	t.cvb000	!
		add	%o3,1,%o3	! ---
    t.cvb001:	subcc	%o1,0xf,%g0	! if Sign == 0xf then
		bz	t.cvb002	!   positive
		nop			!
		subcc	%o1,0xa,%g0	! if Sign < 0xa then
		bl,a	t.cvb004	!   data exception
		sethi	%hi(0x00070000),%o0
		andcc	%o1,1,%g0	!
    t.cvb002:	sethi	%hi(0x00000214),%o0
		or	%o0,%lo(0x00000214),%o0
		sethi	%hi(0x74836400),%o1
		bz,a	t.cvb0t2	! if Sign[31] == 0 then positive
		or	%o1,%lo(0x74836470),%o1
		sub	%g0,%o7,%o7	!		   else negative
		or	%o1,%lo(0x74836480),%o1
    t.cvb0t2:	add	%g0,%o7,%l0	! ##TEMPLATE:%l0
		subcc	%o1,%o5,%g0	!
		subxcc	%o0,%o4,%g0	!
		bgeu,a	t.cvb0e		! integer-divide exception
		add	%g2,4,%g2	! update IAR
		sethi	%hi(0x00090000),%o0
    t.cvb004:	sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	!
t.cvb0e:
    t.cvb0o0:	add	%l0,%l0,%o0	! ##TEMPLATE:%l0,%l0
    t.cvb0o1:	add	%o0,0,%o0	! ##TEMPLATE:imm0
    t.cvb0o2:	add	%g0,%o7,%l0	! ##TEMPLATE:%l0
ii4_cvb:
	srl	%o1,16,%o4		! X2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l2		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l2		! %l2
	srl	%o1,12,%o4		! B2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l3		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l3		! %l3
	and	%o1,0xfff,%l4		! D2
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%i0		! save as %i0
i.cvb0s:
    i.cvb0t0:	add	%l2,%l3,%o0	! ##TEMPLATE:%l0,%l0
    i.cvb0t1:	add	%o0,%l4,%o0	! ##TEMPLATE:imm0
		and	%o0,%g3,%o0	! mask address
		add	%g4,%o0,%o0	!
		add	%g0,0,%o3	! counter
		add	%g0,0,%o4	! upper half of DIGIMAL NUM
		add	%g0,0,%o5	! lower half of DIGIMAL NUM
		add	%g0,0,%o7	! BINARY NUM
    i.cvb000:	ldub	[%o0+%o3],%o1	!
		sll	%o4,8,%o4	!
		srl	%o5,24,%o2	!
		or	%o4,%o2,%o4	!
		sll	%o5,8,%o5	!
		or	%o5,%o1,%o5	! import right most byte
		srl	%o1,4,%o2	!
		umul	%o7,10,%o7	!
		add	%o7,%o2,%o7	!
		subcc	%o2,10,%g0	!
		bge,a	i.cvb004	! data exception
		sethi	%hi(0x00070000),%o0
		and	%o1,0xf,%o1	!
		subcc	%o3,7,%g0	!
		be,a	i.cvb001	!
		andn	%o5,0xf,%o5	!
		umul	%o7,10,%o7	!
		add	%o7,%o1,%o7	!
		subcc	%o1,10,%g0	!
		bge,a	i.cvb004	! data exception
		sethi	%hi(0x00070000),%o0
		ba	i.cvb000	!
		add	%o3,1,%o3	! ---
    i.cvb001:	subcc	%o1,0xf,%g0	! if Sign == 0xf then
		bz	i.cvb002	!   positive
		nop			!
		subcc	%o1,0xa,%g0	! if Sign < 0xa then
		bl,a	i.cvb004	!   data exception
		sethi	%hi(0x00070000),%o0
		andcc	%o1,1,%g0	!
    i.cvb002:	sethi	%hi(0x00000214),%o0
		or	%o0,%lo(0x00000214),%o0
		sethi	%hi(0x74836400),%o1
		bz,a	i.cvb0t2	! if Sign[31] == 0 then positive
		or	%o1,%lo(0x74836470),%o1
		sub	%g0,%o7,%o7	!		   else negative
		or	%o1,%lo(0x74836480),%o1
    i.cvb0t2:	add	%g0,%o7,%l0	! ##TEMPLATE:%l0
		ld	[%sp+184],%o7	! struct *gcpu_s
		st	%l0,[%o7+%i0]	! R1
		subcc	%o1,%o5,%g0	!
		subxcc	%o0,%o4,%g0	!
		bgeu,a	break0		! integer-divide exception
		add	%g2,4,%g2	! update IAR
		sethi	%hi(0x00090000),%o0
    i.cvb004:	ba	epilog0		!
		or	%g7,%o0,%g7	!
i.cvb0e:
!================================

!
! templates
! cxx_xxx:
!   %o0: param: none
!	 retval:size of template
!   %o1: M instruction (4 bytes)
!   %o2: work
!   %o3: work
!   %o4: work
!   %o5: work
! txx_xxx:
!   %o0: param: bufp start address
!	 retval:bufp next start address
!   %o1: M instruction (4 bytes)
!   %o2: work
!   %o3: work
!   %o4: work
!   %o5: work
!
	.section ".text"
	.align	4
	.global ci4_st,ti4_st,ii4_st
ci4_st:
	retl				!
	add	%g0,t.st0e-t.st0s,%o0	!
ti4_st:
	sethi	%hi(t.st0s),%o3		!
	or	%o3,%lo(t.st0s),%o3	!
	or	%g0,t.st0e-t.st0s,%o4	!
    t.st0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.st0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.st0o0-t.st0s],%o5!
	srl	%o1,16,%o4		!
	andcc	%o4,0xf,%o4		! X2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+t.st0t0-t.st0s]!
	ld	[%o3+t.st0o1-t.st0s],%o5!
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.st0t1-t.st0s]!
	ld	[%o3+t.st0o2-t.st0s],%o5!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,25,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+t.st0t2-t.st0s]!
	retl				!
	add	%o0,t.st0e-t.st0s,%o0	!
ii4_st:
	srl	%o1,16,%o4		! X2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l2		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l2		! %l2
	srl	%o1,12,%o4		! B2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l3		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l3		! %l3
	and	%o1,0xfff,%l4		! D2
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l0		! %l0
t.st0s:
    t.st0t0:	add	%l2,%l3,%o0	! ##TEMPLATE:%l0,%l0
    t.st0t1:	add	%o0,%l4,%o0	! ##TEMPLATE:imm0
		and	%o0,%g3,%o0	! mask address
    t.st0t2:	st	%l0,[%g4+%o0]	! ##TEMPLATE:%l0
		add	%g2,4,%g2	! update IAR
t.st0e:
		ba	break0		!
		nop			!
    t.st0o0:	add	%l0,%l0,%o0	! ##TEMPLATE:%l0,%l0
    t.st0o1:	add	%o0,0,%o0	! ##TEMPLATE:imm0
    t.st0o2:	st	%l0,[%g4+%o0]	! ##TEMPLATE:%l0

	.section ".text"
	.align	4
	.global ci4_flm,ti4_flm,ii4_flm
ci4_flm:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	c.flm1c			!
	nop				!
    c.flm0c:				!
	retl				! case even:
	add	%g0,t.flm0e-t.flm0s,%o0	!
    c.flm1c:				!
	retl				! case odd:
	add	%g0,t.flm1e-t.flm1s,%o0	!   specification exception
ti4_flm:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	t.flm1t			!
	nop				!
    t.flm0t:				!
	sethi	%hi(t.flm0s),%o3	!
	or	%o3,%lo(t.flm0s),%o3	!
	or	%g0,t.flm0e-t.flm0s,%o4	!
    t.flm0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.flm0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.flm0o0-t.flm0s],%o5
	srl	%o1,16,%o4		!
	andcc	%o4,0xf,%o4		! X2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+t.flm0t0-t.flm0s]
	ld	[%o3+t.flm0o1-t.flm0s],%o5
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.flm0t1-t.flm0s]
	ld	[%o3+t.flm0o2-t.flm0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1+1
	add	%o4,1,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,25,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+t.flm0t2-t.flm0s]
	ld	[%o3+t.flm0o3-t.flm0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,25,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+t.flm0t3-t.flm0s]
	retl				!
	add	%o0,t.flm0e-t.flm0s,%o0	!
    t.flm1t:				!
	sethi	%hi(t.flm1s),%o3	!
	or	%o3,%lo(t.flm1s),%o3	!
	or	%g0,t.flm1e-t.flm1s,%o4	!
    t.flm1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.flm1cp		!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,t.flm1e-t.flm1s,%o0	!
ii4_flm:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	t.flm1s			!
	nop				!
    i.flm0t:				!
	srl	%o1,16,%o4		! X2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l2		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l2		! %l2
	srl	%o1,12,%o4		! B2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l3		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l3		! %l3
	and	%o1,0xfff,%l4		! D2
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%i0		! save as %i0
	srl	%o1,20,%o4		! R1+1
	and	%o4,0xf,%o4		! |
	add	%o4,1,%o4		! |
	sll	%o4,2,%i1		! save as %i1
t.flm0s:
    t.flm0t0:	add	%l2,%l3,%o0	! ##TEMPLATE:%l0,%l0
    t.flm0t1:	add	%o0,%l4,%o0	! ##TEMPLATE:imm0
		and	%o0,%g3,%o0	! mask address
		ld	[%g4+%o0],%o0	!
		andn	%g1,3,%g1	! CC=0
		sethi	%hi(0x80000000),%o1
		add	%g0,0,%o2	! counter
    t.flm000:	andcc	%o0,%o1,%g0	! test bit
		bnz,a	t.flm0t2	! if 1 is set then
		or	%g1,2,%g1	!   CC=2
		srl	%o1,1,%o1	!
		subcc	%o1,0,%g0	!
		bnz	t.flm000	! continue
		add	%o2,1,%o2	! update counter
    t.flm0t2:	andn	%o0,%o1,%l1	! R1+1 = result
    t.flm0t3:	add	%o2,0,%l0	! R1   = position
		add	%g2,4,%g2	! update IAR
t.flm0e:
		st	%l0,[%o7+%i0]	! R1
		ba	break0		!
		st	%l1,[%o7+%i1]	! R1+1
    t.flm0o0:	add	%l0,%l0,%o0	! ##TEMPLATE:%l0,%l0
    t.flm0o1:	add	%o0,0,%o0	! ##TEMPLATE:imm0
    t.flm0o2:	andn	%o0,%o1,%l0	! R1+1 = result
    t.flm0o3:	add	%o2,0,%l0	! R1   = position
t.flm1s:
		sethi	%hi(0x00060000),%o0
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! specification exception
t.flm1e:

	.section ".text"
	.align	4
	.global ci4_n,ti4_n,ii4_n
ci4_n:
	retl				!
	add	%g0,t.n0e-t.n0s,%o0	!
ti4_n:
	sethi	%hi(t.n0s),%o3		!
	or	%o3,%lo(t.n0s),%o3	!
	or	%g0,t.n0e-t.n0s,%o4	!
    t.n0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.n0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.n0o0-t.n0s],%o5	!
	srl	%o1,16,%o4		!
	andcc	%o4,0xf,%o4		! X2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+t.n0t0-t.n0s]	!
	ld	[%o3+t.n0o1-t.n0s],%o5	!
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.n0t1-t.n0s]	!
	ld	[%o3+t.n0o2-t.n0s],%o5	!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	sll	%o4,11,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+t.n0t2-t.n0s]	!
	retl				!
	add	%o0,t.n0e-t.n0s,%o0	!
ii4_n:
	srl	%o1,16,%o4		! X2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l2		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l2		! %l2
	srl	%o1,12,%o4		! B2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l3		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l3		! %l3
	and	%o1,0xfff,%l4		! D2
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%i0		! save as %i0
	ld	[%o7+%i0],%l0		! %l0
t.n0s:
    t.n0t0:	add	%l2,%l3,%o0	! ##TEMPLATE:%l0,%l0
    t.n0t1:	add	%o0,%l4,%o0	! ##TEMPLATE:imm0
		and	%o0,%g3,%o0	! mask address
		ld	[%g4+%o0],%o0	!
		andn	%g1,3,%g1	! CC=0
    t.n0t2:	andcc	%l0,%o0,%l0	! ##TEMPLATE:%l0,%l0
		bnz,a	t.n000		! if %l0 != 0 then
		or	%g1,1,%g1	!   CC=1
    t.n000:	add	%g2,4,%g2	! update IAR
t.n0e:
		ba	break0		!
		st	%l0,[%o7+%i0]	! R1
    t.n0o0:	add	%l0,%l0,%o0	! ##TEMPLATE:%l0,%l0
    t.n0o1:	add	%o0,0,%o0	! ##TEMPLATE:imm0
    t.n0o2:	andcc	%l0,%o0,%l0	! ##TEMPLATE:%l0,%l0

	.section ".text"
	.align	4
	.global ci4_cl,ti4_cl,ii4_cl
ci4_cl:
	retl				!
	add	%g0,t.cl0e-t.cl0s,%o0	!
ti4_cl:
	sethi	%hi(t.cl0s),%o3		!
	or	%o3,%lo(t.cl0s),%o3	!
	or	%g0,t.cl0e-t.cl0s,%o4	!
    t.cl0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.cl0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.cl0o0-t.cl0s],%o5!
	srl	%o1,16,%o4		!
	andcc	%o4,0xf,%o4		! X2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+t.cl0t0-t.cl0s]!
	ld	[%o3+t.cl0o1-t.cl0s],%o5!
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.cl0t1-t.cl0s]!
	ld	[%o3+t.cl0o2-t.cl0s],%o5!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+t.cl0t2-t.cl0s]!
	retl				!
	add	%o0,t.cl0e-t.cl0s,%o0	!
ii4_cl:
	srl	%o1,16,%o4		! X2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l2		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l2		! %l2
	srl	%o1,12,%o4		! B2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l3		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l3		! %l3
	and	%o1,0xfff,%l4		! D2
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l0		! %l0
t.cl0s:
    t.cl0t0:	add	%l2,%l3,%o0	! ##TEMPLATE:%l0,%l0
    t.cl0t1:	add	%o0,%l4,%o0	! ##TEMPLATE:imm0
		and	%o0,%g3,%o0	! mask address
		ld	[%g4+%o0],%o0	!
		andn	%g1,3,%g1	! CC=0
    t.cl0t2:	subcc	%l0,%o0,%g0	! ##TEMPLATE:%l0
		bgu,a	t.cl001		! if %l0 > 0 then
		or	%g1,2,%g1	!   CC=2
		bcs,a	t.cl001		! if %l0 < 0 then
		or	%g1,1,%g1	!   CC=1
    t.cl001:	add	%g2,4,%g2	! update IAR
t.cl0e:
		ba	break0		!
		nop			!
    t.cl0o0:	add	%l0,%l0,%o0	! ##TEMPLATE:%l0,%l0
    t.cl0o1:	add	%o0,0,%o0	! ##TEMPLATE:imm0
    t.cl0o2:	subcc	%l0,%o0,%g0	! ##TEMPLATE:%l0

	.section ".text"
	.align	4
	.global ci4_o,ti4_o,ii4_o
ci4_o:
	retl				!
	add	%g0,t.o0e-t.o0s,%o0	!
ti4_o:
	sethi	%hi(t.o0s),%o3		!
	or	%o3,%lo(t.o0s),%o3	!
	or	%g0,t.o0e-t.o0s,%o4	!
    t.o0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.o0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.o0o0-t.o0s],%o5	!
	srl	%o1,16,%o4		!
	andcc	%o4,0xf,%o4		! X2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+t.o0t0-t.o0s]	!
	ld	[%o3+t.o0o1-t.o0s],%o5	!
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.o0t1-t.o0s]	!
	ld	[%o3+t.o0o2-t.o0s],%o5	!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	sll	%o4,11,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+t.o0t2-t.o0s]	!
	retl				!
	add	%o0,t.o0e-t.o0s,%o0	!
ii4_o:
	srl	%o1,16,%o4		! X2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l2		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l2		! %l2
	srl	%o1,12,%o4		! B2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l3		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l3		! %l3
	and	%o1,0xfff,%l4		! D2
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%i0		! save as %i0
	ld	[%o7+%i0],%l0		! %l0
t.o0s:
    t.o0t0:	add	%l2,%l3,%o0	! ##TEMPLATE:%l0,%l0
    t.o0t1:	add	%o0,%l4,%o0	! ##TEMPLATE:imm0
		and	%o0,%g3,%o0	! mask address
		ld	[%g4+%o0],%o0	!
		andn	%g1,3,%g1	! CC=0
    t.o0t2:	orcc	%l0,%o0,%l0	! ##TEMPLATE:%l0,%l0
		bnz,a	t.o000		! if %l0 != 0 then
		or	%g1,1,%g1	!   CC=1
    t.o000:	add	%g2,4,%g2	! update IAR
t.o0e:
		ba	break0		!
		st	%l0,[%o7+%i0]	! R1
    t.o0o0:	add	%l0,%l0,%o0	! ##TEMPLATE:%l0,%l0
    t.o0o1:	add	%o0,0,%o0	! ##TEMPLATE:imm0
    t.o0o2:	orcc	%l0,%o0,%l0	! ##TEMPLATE:%l0,%l0

	.section ".text"
	.align	4
	.global ci4_x,ti4_x,ii4_x
ci4_x:
	retl				!
	add	%g0,t.x0e-t.x0s,%o0	!
ti4_x:
	sethi	%hi(t.x0s),%o3		!
	or	%o3,%lo(t.x0s),%o3	!
	or	%g0,t.x0e-t.x0s,%o4	!
    t.x0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.x0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.x0o0-t.x0s],%o5	!
	srl	%o1,16,%o4		!
	andcc	%o4,0xf,%o4		! X2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+t.x0t0-t.x0s]	!
	ld	[%o3+t.x0o1-t.x0s],%o5	!
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.x0t1-t.x0s]	!
	ld	[%o3+t.x0o2-t.x0s],%o5	!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	sll	%o4,11,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+t.x0t2-t.x0s]	!
	retl				!
	add	%o0,t.x0e-t.x0s,%o0	!
ii4_x:
	srl	%o1,16,%o4		! X2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l2		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l2		! %l2
	srl	%o1,12,%o4		! B2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l3		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l3		! %l3
	and	%o1,0xfff,%l4		! D2
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%i0		! save as %i0
	ld	[%o7+%i0],%l0		! %l0
t.x0s:
    t.x0t0:	add	%l2,%l3,%o0	! ##TEMPLATE:%l0,%l0
    t.x0t1:	add	%o0,%l4,%o0	! ##TEMPLATE:imm0
		and	%o0,%g3,%o0	! mask address
		ld	[%g4+%o0],%o0	!
		andn	%g1,3,%g1	! CC=0
    t.x0t2:	xorcc	%l0,%o0,%l0	! ##TEMPLATE:%l0,%l0
		bnz,a	t.x000		! if %l0 != 0 then
		or	%g1,1,%g1	!   CC=1
    t.x000:	add	%g2,4,%g2	! update IAR
t.x0e:
		ba	break0		!
		st	%l0,[%o7+%i0]	! R1
    t.x0o0:	add	%l0,%l0,%o0	! ##TEMPLATE:%l0,%l0
    t.x0o1:	add	%o0,0,%o0	! ##TEMPLATE:imm0
    t.x0o2:	xorcc	%l0,%o0,%l0	! ##TEMPLATE:%l0,%l0

	.section ".text"
	.align	4
	.global ci4_l,ti4_l,ii4_l
ci4_l:
	retl				!
	add	%g0,t.l0e-t.l0s,%o0	!
ti4_l:
	sethi	%hi(t.l0s),%o3		!
	or	%o3,%lo(t.l0s),%o3	!
	or	%g0,t.l0e-t.l0s,%o4	!
    t.l0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.l0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.l0o0-t.l0s],%o5	!
	srl	%o1,16,%o4		!
	andcc	%o4,0xf,%o4		! X2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+t.l0t0-t.l0s]	!
	ld	[%o3+t.l0o1-t.l0s],%o5	!
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.l0t1-t.l0s]	!
	ld	[%o3+t.l0o2-t.l0s],%o5	!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,25,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+t.l0t2-t.l0s]	!
	retl				!
	add	%o0,t.l0e-t.l0s,%o0	!
ii4_l:
	srl	%o1,16,%o4		! X2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l2		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l2		! %l2
	srl	%o1,12,%o4		! B2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l3		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l3		! %l3
	and	%o1,0xfff,%l4		! D2
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%i0		! save as %i0
t.l0s:
    t.l0t0:	add	%l2,%l3,%o0	! ##TEMPLATE:%l0,%l0
    t.l0t1:	add	%o0,%l4,%o0	! ##TEMPLATE:imm0
		and	%o0,%g3,%o0	! mask address
    t.l0t2:	ld	[%g4+%o0],%l0	! ##TEMPLATE:%l0
		add	%g2,4,%g2	! update IAR
t.l0e:
		ba	break0		!
		st	%l0,[%o7+%i0]	! R1
    t.l0o0:	add	%l0,%l0,%o0	! ##TEMPLATE:%l0,%l0
    t.l0o1:	add	%o0,0,%o0	! ##TEMPLATE:imm0
    t.l0o2:	ld	[%g4+%o0],%l0	! ##TEMPLATE:%l0

	.section ".text"
	.align	4
	.global ci4_c,ti4_c,ii4_c
ci4_c:
	retl				!
	add	%g0,t.c0e-t.c0s,%o0	!
ti4_c:
	sethi	%hi(t.c0s),%o3		!
	or	%o3,%lo(t.c0s),%o3	!
	or	%g0,t.c0e-t.c0s,%o4	!
    t.c0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.c0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.c0o0-t.c0s],%o5	!
	srl	%o1,16,%o4		!
	andcc	%o4,0xf,%o4		! X2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+t.c0t0-t.c0s]	!
	ld	[%o3+t.c0o1-t.c0s],%o5	!
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.c0t1-t.c0s]	!
	ld	[%o3+t.c0o2-t.c0s],%o5	!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+t.c0t2-t.c0s]	!
	retl				!
	add	%o0,t.c0e-t.c0s,%o0	!
ii4_c:
	srl	%o1,16,%o4		! X2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l2		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l2		! %l2
	srl	%o1,12,%o4		! B2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l3		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l3		! %l3
	and	%o1,0xfff,%l4		! D2
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l0		! %l0
t.c0s:
    t.c0t0:	add	%l2,%l3,%o0	! ##TEMPLATE:%l0,%l0
    t.c0t1:	add	%o0,%l4,%o0	! ##TEMPLATE:imm0
		and	%o0,%g3,%o0	! mask address
		ld	[%g4+%o0],%o0	!
		andn	%g1,3,%g1	! CC=0
    t.c0t2:	subcc	%l0,%o0,%g0	! ##TEMPLATE:%l0
		bg,a	t.c001		! if %l0 > 0 then
		or	%g1,2,%g1	!   CC=2
		bl,a	t.c001		! if %l0 < 0 then
		or	%g1,1,%g1	!   CC=1
    t.c001:	add	%g2,4,%g2	! update IAR
t.c0e:
		ba	break0		!
		nop			!
    t.c0o0:	add	%l0,%l0,%o0	! ##TEMPLATE:%l0,%l0
    t.c0o1:	add	%o0,0,%o0	! ##TEMPLATE:imm0
    t.c0o2:	subcc	%l0,%o0,%g0	! ##TEMPLATE:%l0

	.section ".text"
	.align	4
	.global ci4_a,ti4_a,ii4_a
ci4_a:
	retl				!
	add	%g0,t.a0e-t.a0s,%o0	!
ti4_a:
	sethi	%hi(t.a0s),%o3		!
	or	%o3,%lo(t.a0s),%o3	!
	or	%g0,t.a0e-t.a0s,%o4	!
    t.a0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.a0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.a0o0-t.a0s],%o5	!
	srl	%o1,16,%o4		!
	andcc	%o4,0xf,%o4		! X2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+t.a0t0-t.a0s]	!
	ld	[%o3+t.a0o1-t.a0s],%o5	!
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.a0t1-t.a0s]	!
	ld	[%o3+t.a0o2-t.a0s],%o5	!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	sll	%o4,11,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+t.a0t2-t.a0s]	!
	retl				!
	add	%o0,t.a0e-t.a0s,%o0	!
t.a0s:
    t.a0t0:	add	%l0,%l0,%o0	! ##TEMPLATE:%l0,%l0
    t.a0t1:	add	%o0,0,%o0	! ##TEMPLATE:imm0
		and	%o0,%g3,%o0	! mask address
		ld	[%g4+%o0],%o0	!
		andn	%g1,3,%g1	! CC=0
    t.a0t2:	addcc	%l0,%o0,%l0	! ##TEMPLATE:%l0,%l0
		bvc	t.a000		! if overflow then
		nop			!
		andcc	%g7,8,%g0	!   CC=3
		bz	t.a002		!   if fixed-point overflow mask then
		or	%g1,3,%g1	!
		sethi	%hi(0x00080000),%o0
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	!     fixed-point overflow
    t.a000:	bg,a	t.a002		! if %l0 > 0 then
		or	%g1,2,%g1	!   CC=2
		bl,a	t.a002		! if %l0 < 0 then
		or	%g1,1,%g1	!   CC=1
    t.a002:	add	%g2,4,%g2	! update IAR
t.a0e:
    t.a0o0:	add	%l0,%l0,%o0	! ##TEMPLATE:%l0,%l0
    t.a0o1:	add	%o0,0,%o0	! ##TEMPLATE:imm0
    t.a0o2:	addcc	%l0,%o0,%l0	! ##TEMPLATE:%l0,%l0
ii4_a:
	srl	%o1,16,%o4		! X2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l2		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l2		! %l2
	srl	%o1,12,%o4		! B2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l3		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l3		! %l3
	and	%o1,0xfff,%l4		! D2
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%i0		! save as %i0
	ld	[%o7+%i0],%l0		! %l0
i.a0s:
    i.a0t0:	add	%l2,%l3,%o0	! ##TEMPLATE:%l0,%l0
    i.a0t1:	add	%o0,%l4,%o0	! ##TEMPLATE:imm0
		and	%o0,%g3,%o0	! mask address
		ld	[%g4+%o0],%o0	!
		andn	%g1,3,%g1	! CC=0
    i.a0t2:	addcc	%l0,%o0,%l0	! ##TEMPLATE:%l0,%l0
		st	%l0,[%o7+%i0]	! R1
		bvc	i.a000		! if overflow then
		nop			!
		andcc	%g7,8,%g0	!   CC=3
		bz	i.a002		!   if fixed-point overflow mask then
		or	%g1,3,%g1	!
		sethi	%hi(0x00080000),%o0
		ba	epilog0		!
		or	%g7,%o0,%g7	!     fixed-point overflow
    i.a000:	bg,a	i.a002		! if %l0 > 0 then
		or	%g1,2,%g1	!   CC=2
		bl,a	i.a002		! if %l0 < 0 then
		or	%g1,1,%g1	!   CC=1
    i.a002:	ba	break0		!
		add	%g2,4,%g2	! update IAR
i.a0e:

	.section ".text"
	.align	4
	.global ci4_s,ti4_s,ii4_s
ci4_s:
	retl				!
	add	%g0,t.s0e-t.s0s,%o0	!
ti4_s:
	sethi	%hi(t.s0s),%o3		!
	or	%o3,%lo(t.s0s),%o3	!
	or	%g0,t.s0e-t.s0s,%o4	!
    t.s0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.s0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.s0o0-t.s0s],%o5	!
	srl	%o1,16,%o4		!
	andcc	%o4,0xf,%o4		! X2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+t.s0t0-t.s0s]	!
	ld	[%o3+t.s0o1-t.s0s],%o5	!
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.s0t1-t.s0s]	!
	ld	[%o3+t.s0o2-t.s0s],%o5	!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	sll	%o4,11,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+t.s0t2-t.s0s]	!
	retl				!
	add	%o0,t.s0e-t.s0s,%o0	!
t.s0s:
    t.s0t0:	add	%l0,%l0,%o0	! ##TEMPLATE:%l0,%l0
    t.s0t1:	add	%o0,0,%o0	! ##TEMPLATE:imm0
		and	%o0,%g3,%o0	! mask address
		ld	[%g4+%o0],%o0	!
		andn	%g1,3,%g1	! CC=0
    t.s0t2:	subcc	%l0,%o0,%l0	! ##TEMPLATE:%l0,%l0
		bvc	t.s000		! if overflow then
		nop			!
		andcc	%g7,8,%g0	!   CC=3
		bz	t.s002		!   if fixed-point overflow mask then
		or	%g1,3,%g1	!
		sethi	%hi(0x00080000),%o0
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	!     fixed-point overflow
    t.s000:	bg,a	t.s002		! if %l0 > 0 then
		or	%g1,2,%g1	!   CC=2
		bl,a	t.s002		! if %l0 < 0 then
		or	%g1,1,%g1	!   CC=1
    t.s002:	add	%g2,4,%g2	! update IAR
t.s0e:
    t.s0o0:	add	%l0,%l0,%o0	! ##TEMPLATE:%l0,%l0
    t.s0o1:	add	%o0,0,%o0	! ##TEMPLATE:imm0
    t.s0o2:	subcc	%l0,%o0,%l0	! ##TEMPLATE:%l0,%l0
ii4_s:
	srl	%o1,16,%o4		! X2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l2		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l2		! %l2
	srl	%o1,12,%o4		! B2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l3		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l3		! %l3
	and	%o1,0xfff,%l4		! D2
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%i0		! save as %i0
	ld	[%o7+%i0],%l0		! %l0
i.s0s:
    i.s0t0:	add	%l2,%l3,%o0	! ##TEMPLATE:%l0,%l0
    i.s0t1:	add	%o0,%l4,%o0	! ##TEMPLATE:imm0
		and	%o0,%g3,%o0	! mask address
		ld	[%g4+%o0],%o0	!
		andn	%g1,3,%g1	! CC=0
    i.s0t2:	subcc	%l0,%o0,%l0	! ##TEMPLATE:%l0,%l0
		st	%l0,[%o7+%i0]	! R1
		bvc	i.s000		! if overflow then
		nop			!
		andcc	%g7,8,%g0	!   CC=3
		bz	i.s002		!   if fixed-point overflow mask then
		or	%g1,3,%g1	!
		sethi	%hi(0x00080000),%o0
		ba	epilog0		!
		or	%g7,%o0,%g7	!     fixed-point overflow
    i.s000:	bg,a	i.s002		! if %l0 > 0 then
		or	%g1,2,%g1	!   CC=2
		bl,a	i.s002		! if %l0 < 0 then
		or	%g1,1,%g1	!   CC=1
    i.s002:	ba	break0		!
		add	%g2,4,%g2	! update IAR
i.s0e:

	.section ".text"
	.align	4
	.global ci4_m,ti4_m,ii4_m
ci4_m:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	c.m1c			!
	nop				!
    c.m0c:				!
	retl				! case even:
	add	%g0,t.m0e-t.m0s,%o0	!
    c.m1c:				!
	retl				! case odd:
	add	%g0,t.m1e-t.m1s,%o0	!   specification exception
ti4_m:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	t.m1t			!
	nop				!
    t.m0t:				!
	sethi	%hi(t.m0s),%o3		!
	or	%o3,%lo(t.m0s),%o3	!
	or	%g0,t.m0e-t.m0s,%o4	!
    t.m0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.m0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.m0o0-t.m0s],%o5	!
	srl	%o1,16,%o4		!
	andcc	%o4,0xf,%o4		! X2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+t.m0t0-t.m0s]	!
	ld	[%o3+t.m0o1-t.m0s],%o5	!
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.m0t1-t.m0s]	!
	ld	[%o3+t.m0o2-t.m0s],%o5	!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1+1
	add	%o4,1,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	sll	%o4,11,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+t.m0t2-t.m0s]	!
	ld	[%o3+t.m0o3-t.m0s],%o5	!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,25,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+t.m0t3-t.m0s]	!
	retl				!
	add	%o0,t.m0e-t.m0s,%o0	!
    t.m1t:				!
	sethi	%hi(t.m1s),%o3		!
	or	%o3,%lo(t.m1s),%o3	!
	or	%g0,t.m1e-t.m1s,%o4	!
    t.m1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.m1cp			!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,t.m1e-t.m1s,%o0	!
ii4_m:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	t.m1s			!
	nop				!
    i.m0t:				!
	srl	%o1,16,%o4		! X2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l2		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l2		! %l2
	srl	%o1,12,%o4		! B2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l3		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l3		! %l3
	and	%o1,0xfff,%l4		! D2
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%i0		! save as %i0
	srl	%o1,20,%o4		! R1+1
	and	%o4,0xf,%o4		! |
	add	%o4,1,%o4		! |
	sll	%o4,2,%i1		! save as %i1
	ld	[%o7+%i1],%l1		! %l1
t.m0s:
    t.m0t0:	add	%l2,%l3,%o0	! ##TEMPLATE:%l0,%l0
    t.m0t1:	add	%o0,%l4,%o0	! ##TEMPLATE:imm0
		and	%o0,%g3,%o0	! mask address
		ld	[%g4+%o0],%o0	!
    t.m0t2:	smul	%l1,%o0,%l1	! ##TEMPLATE:%l0,%l0
    t.m0t3:	rd	%y,%l0		! ##TEMPLATE:%l0
		add	%g2,4,%g2	! update IAR
t.m0e:
		st	%l0,[%o7+%i0]	! R1
		ba	break0		!
		st	%l1,[%o7+%i1]	! R1+1
    t.m0o0:	add	%l0,%l0,%o0	! ##TEMPLATE:%l0,%l0
    t.m0o1:	add	%o0,0,%o0	! ##TEMPLATE:imm0
    t.m0o2:	smul	%l0,%o0,%l0	! ##TEMPLATE:%l0,%l0
    t.m0o3:	rd	%y,%l0		! ##TEMPLATE:%l0
t.m1s:
		sethi	%hi(0x00060000),%o0
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! specification exception
t.m1e:

	.section ".text"
	.align	4
	.global ci4_d,ti4_d,ii4_d
ci4_d:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	c.d1c			!
	nop				!
    c.d0c:				!
	retl				! case even:
	add	%g0,t.d0e-t.d0s,%o0	!
    c.d1c:				!
	retl				! case odd:
	add	%g0,t.d1e-t.d1s,%o0	!   specification exception
ti4_d:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	t.d1t			!
	nop				!
    t.d0t:				!
	sethi	%hi(t.d0s),%o3		!
	or	%o3,%lo(t.d0s),%o3	!
	or	%g0,t.d0e-t.d0s,%o4	!
    t.d0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.d0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.d0o0-t.d0s],%o5	!
	srl	%o1,16,%o4		!
	andcc	%o4,0xf,%o4		! X2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+t.d0t0-t.d0s]	!
	ld	[%o3+t.d0o1-t.d0s],%o5	!
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.d0t1-t.d0s]	!
	ld	[%o3+t.d0o2-t.d0s],%o5	!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	st	%o5,[%o0+t.d0t2-t.d0s]	!
	ld	[%o3+t.d0o3-t.d0s],%o5	!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1+1
	add	%o4,1,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+t.d0t3-t.d0s]	!
	ld	[%o3+t.d0o4-t.d0s],%o5	!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1+1
	add	%o4,1,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,25,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+t.d0t4-t.d0s]	!
	ld	[%o3+t.d0o5-t.d0s],%o5	!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1+1
	add	%o4,1,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,25,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+t.d0t5-t.d0s]	!
	retl				!
	add	%o0,t.d0e-t.d0s,%o0	!
    t.d1t:				!
	sethi	%hi(t.d1s),%o3		!
	or	%o3,%lo(t.d1s),%o3	!
	or	%g0,t.d1e-t.d1s,%o4	!
    t.d1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.d1cp			!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,t.d1e-t.d1s,%o0	!
t.d0s:
    t.d0t0:	add	%l0,%l0,%o0	! ##TEMPLATE:%l0,%l0
    t.d0t1:	add	%o0,0,%o0	! ##TEMPLATE:imm0
		and	%o0,%g3,%o0	! mask address
		ld	[%g4+%o0],%o0	!
		addcc	%g0,%o0,%g0	!
		bz	t.d000		! if R2==0 then int-div. exception
    t.d0t2:	wr	%g0,%l0,%y	! ##TEMPLATE:%l0     R1
    t.d0t3:	sdivcc	%l0,%o0,%o1	! ##TEMPLATE:%l0     R1+1
		bvs	t.d000		! if overflow then int-div.
		smul	%o1,%o0,%o2	!
    t.d0t4:	sub	%l0,%o2,%l0	! ##TEMPLATE:%l0,%l0 R1+1,R1
    t.d0t5:	add	%g0,%o1,%l0	! ##TEMPLATE:%l0     R1+1
		ba	t.d0e		!
		add	%g2,4,%g2	! update IAR
    t.d000:	sethi	%hi(0x00090000),%o0
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! int-div. exception
t.d0e:
    t.d0o0:	add	%l0,%l0,%o0	! ##TEMPLATE:%l0,%l0
    t.d0o1:	add	%o0,0,%o0	! ##TEMPLATE:imm0
    t.d0o2:	wr	%g0,%l0,%y	! ##TEMPLATE:%l0     R1
    t.d0o3:	sdivcc	%l0,%o0,%o1	! ##TEMPLATE:%l0     R1+1
    t.d0o4:	sub	%l0,%o2,%l0	! ##TEMPLATE:%l0,%l0 R1+1,R1
    t.d0o5:	add	%g0,%o1,%l0	! ##TEMPLATE:%l0     R1+1
t.d1s:
		sethi	%hi(0x00060000),%o0
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! specification exception
t.d1e:
ii4_d:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	t.d1s			!
	nop				!
    i.d0t:				!
	srl	%o1,16,%o4		! X2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l2		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l2		! %l2
	srl	%o1,12,%o4		! B2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l3		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l3		! %l3
	and	%o1,0xfff,%l4		! D2
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%i0		! save as %i0
	ld	[%o7+%i0],%l0		! %l1
	srl	%o1,20,%o4		! R1+1
	and	%o4,0xf,%o4		! |
	add	%o4,1,%o4		! |
	sll	%o4,2,%i1		! save as %i1
	ld	[%o7+%i1],%l1		! %l1
i.d0s:
    i.d0t0:	add	%l2,%l3,%o0	! ##TEMPLATE:%l0,%l0
    i.d0t1:	add	%o0,%l4,%o0	! ##TEMPLATE:imm0
		and	%o0,%g3,%o0	! mask address
		ld	[%g4+%o0],%o0	!
		addcc	%g0,%o0,%g0	!
		bz	i.d000		! if R2==0 then int-div. exception
    i.d0t2:	wr	%g0,%l0,%y	! ##TEMPLATE:%l0     R1
    i.d0t3:	sdivcc	%l1,%o0,%o1	! ##TEMPLATE:%l0     R1+1
		bvs	i.d000		! if overflow then int-div.
		smul	%o1,%o0,%o2	!
    i.d0t4:	sub	%l1,%o2,%l0	! ##TEMPLATE:%l0,%l0 R1+1,R1
		st	%l0,[%o7+%i0]	! R1
    i.d0t5:	add	%g0,%o1,%l1	! ##TEMPLATE:%l0     R1+1
		st	%l1,[%o7+%i1]	! R1+1
		ba	break0		!
		add	%g2,4,%g2	! update IAR
    i.d000:	sethi	%hi(0x00090000),%o0
		ba	epilog0		!
		or	%g7,%o0,%g7	! int-div. exception
i.d0e:

	.section ".text"
	.align	4
	.global ci4_al,ti4_al,ii4_al
ci4_al:
	retl				!
	add	%g0,t.al0e-t.al0s,%o0	!
ti4_al:
	sethi	%hi(t.al0s),%o3		!
	or	%o3,%lo(t.al0s),%o3	!
	or	%g0,t.al0e-t.al0s,%o4	!
    t.al0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.al0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.al0o0-t.al0s],%o5!
	srl	%o1,16,%o4		!
	andcc	%o4,0xf,%o4		! X2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+t.al0t0-t.al0s]!
	ld	[%o3+t.al0o1-t.al0s],%o5!
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.al0t1-t.al0s]!
	ld	[%o3+t.al0o2-t.al0s],%o5!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	sll	%o4,11,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+t.al0t2-t.al0s]!
	retl				!
	add	%o0,t.al0e-t.al0s,%o0	!
ii4_al:
	srl	%o1,16,%o4		! X2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l2		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l2		! %l2
	srl	%o1,12,%o4		! B2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l3		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l3		! %l3
	and	%o1,0xfff,%l4		! D2
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%i0		! save as %i0
	ld	[%o7+%i0],%l0		! %l0
t.al0s:
    t.al0t0:	add	%l2,%l3,%o0	! ##TEMPLATE:%l0,%l0
    t.al0t1:	add	%o0,%l4,%o0	! ##TEMPLATE:imm0
		and	%o0,%g3,%o0	! mask address
		ld	[%g4+%o0],%o0	!
		andn	%g1,3,%g1	! CC=0
    t.al0t2:	addcc	%l0,%o0,%l0	! ##TEMPLATE:%l0,%l0
		bcs,a	t.al000		! if carry then
		or	%g1,2,%g1	!   CC|=2 & skip
		bnz,a	t.al001		! if %l0 != 0 then
		or	%g1,1,%g1	!   CC=1
		ba	t.al001		!
		nop			!
    t.al000:	bnz,a	t.al001		! if %l0 != 0 then
		or	%g1,1,%g1	!   CC=3
    t.al001:	add	%g2,4,%g2	! update IAR
t.al0e:
		ba	break0		!
		st	%l0,[%o7+%i0]	! R1
    t.al0o0:	add	%l0,%l0,%o0	! ##TEMPLATE:%l0,%l0
    t.al0o1:	add	%o0,0,%o0	! ##TEMPLATE:imm0
    t.al0o2:	addcc	%l0,%o0,%l0	! ##TEMPLATE:%l0,%l0

	.section ".text"
	.align	4
	.global ci4_sl,ti4_sl,ii4_sl
ci4_sl:
	retl				!
	add	%g0,t.sl0e-t.sl0s,%o0	!
ti4_sl:
	sethi	%hi(t.sl0s),%o3		!
	or	%o3,%lo(t.sl0s),%o3	!
	or	%g0,t.sl0e-t.sl0s,%o4	!
    t.sl0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.sl0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.sl0o0-t.sl0s],%o5!
	srl	%o1,16,%o4		!
	andcc	%o4,0xf,%o4		! X2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+t.sl0t0-t.sl0s]!
	ld	[%o3+t.sl0o1-t.sl0s],%o5!
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.sl0t1-t.sl0s]!
	ld	[%o3+t.sl0o2-t.sl0s],%o5!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	sll	%o4,11,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+t.sl0t2-t.sl0s]!
	retl				!
	add	%o0,t.sl0e-t.sl0s,%o0	!
ii4_sl:
	srl	%o1,16,%o4		! X2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l2		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l2		! %l2
	srl	%o1,12,%o4		! B2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l3		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l3		! %l3
	and	%o1,0xfff,%l4		! D2
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%i0		! save as %i0
	ld	[%o7+%i0],%l0		! %l0
t.sl0s:
    t.sl0t0:	add	%l2,%l3,%o0	! ##TEMPLATE:%l0,%l0
    t.sl0t1:	add	%o0,%l4,%o0	! ##TEMPLATE:imm0
		and	%o0,%g3,%o0	! mask address
		ld	[%g4+%o0],%o0	!
		andn	%g1,3,%g1	! CC=0
    t.sl0t2:	subcc	%l0,%o0,%l0	! ##TEMPLATE:%l0,%l0
		bcc,a	t.sl000		! if !carry then
		or	%g1,2,%g1	!   CC|=2 & skip
		bnz,a	t.sl001		! if %l0 != 0 then
		or	%g1,1,%g1	!   CC=1
		ba	t.sl001		!
		nop			!
    t.sl000:	bnz,a	t.sl001		! if %l0 != 0 then
		or	%g1,1,%g1	!   CC=3
    t.sl001:	add	%g2,4,%g2	! update IAR
t.sl0e:
		ba	break0		!
		st	%l0,[%o7+%i0]	! R1
    t.sl0o0:	add	%l0,%l0,%o0	! ##TEMPLATE:%l0,%l0
    t.sl0o1:	add	%o0,0,%o0	! ##TEMPLATE:imm0
    t.sl0o2:	subcc	%l0,%o0,%l0	! ##TEMPLATE:%l0,%l0
!================================

!
! templates
! cxx_xxx:
!   %o0: param: none
!	 retval:size of template
!   %o1: M instruction (4 bytes)
!   %o2: work
!   %o3: work
!   %o4: work
!   %o5: work
! txx_xxx:
!   %o0: param: bufp start address
!	 retval:bufp next start address
!   %o1: M instruction (4 bytes)
!   %o2: work
!   %o3: work
!   %o4: work
!   %o5: work
!
	.section ".text"
	.align	4
	.global cf4_std,tf4_std,if4_std
cf4_std:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	c.std1c			!
	nop				!
    c.std0c:				!
	retl				! case even:
	add	%g0,t.std0e-t.std0s,%o0	!
    c.std1c:				!
	retl				! case odd:
	add	%g0,t.std1e-t.std1s,%o0	!   specification exception
tf4_std:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	t.std1t			!
	nop				!
    t.std0t:				!
	sethi	%hi(t.std0s),%o3	!
	or	%o3,%lo(t.std0s),%o3	!
	or	%g0,t.std0e-t.std0s,%o4	!
    t.std0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.std0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.std0o0-t.std0s],%o5
	srl	%o1,16,%o4		!
	andcc	%o4,0xf,%o4		! X2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+t.std0t0-t.std0s]
	ld	[%o3+t.std0o1-t.std0s],%o5
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.std0t1-t.std0s]
	ld	[%o3+t.std0o2-t.std0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+t.std0t2-t.std0s]
	retl				!
	add	%o0,t.std0e-t.std0s,%o0	!
    t.std1t:				!
	sethi	%hi(t.std1s),%o3	!
	or	%o3,%lo(t.std1s),%o3	!
	or	%g0,t.std1e-t.std1s,%o4	!
    t.std1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.std1cp		!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,t.std1e-t.std1s,%o0	!
if4_std:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	t.std1s			!
	nop				!
    i.std0t:				!
	srl	%o1,16,%o4		! X2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l2		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l2		! %l2
	srl	%o1,12,%o4		! B2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l3		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l3		! %l3
	and	%o1,0xfff,%l4		! D2
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	add	%o4,64,%i0		! %i0
t.std0s:
		ld	[%sp+184],%o7	! struct *gcpu_s
    t.std0t0:	add	%l2,%l3,%o0	! ##TEMPLATE:%l0,%l0
    t.std0t1:	add	%o0,%l4,%o0	! ##TEMPLATE:imm0
		and	%o0,%g3,%o0	! mask address
    t.std0t2:	ldd	[%o7+%i0],%o2	! ##TEMPLATE:%imm
		st	%o2,[%g4+%o0]	! store upper word
		add	%o0,4,%o0	!
		st	%o3,[%g4+%o0]	! store lower word
		add	%g2,4,%g2	! update IAR
t.std0e:
		ba	break0		!
		nop			!
    t.std0o0:	add	%l0,%l0,%o0	! ##TEMPLATE:%l0,%l0
    t.std0o1:	add	%o0,0,%o0	! ##TEMPLATE:imm0
    t.std0o2:	ldd	[%o7+64],%o2	! ##TEMPLATE:%imm
t.std1s:
		sethi	%hi(0x00060000),%o0
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! specification exception
t.std1e:

	.section ".text"
	.align	4
	.global cf4_mxd,tf4_mxd,if4_mxd
cf4_mxd:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,3,%g0		!
	bnz	c.mxd1c			!
	nop				!
    c.mxd0c:				!
	retl				! case even:
	add	%g0,t.mxd0e-t.mxd0s,%o0	!
    c.mxd1c:				!
	retl				! case odd:
	add	%g0,t.mxd1e-t.mxd1s,%o0	!   specification exception
tf4_mxd:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,3,%g0		!
	bnz	t.mxd1t			!
	nop				!
    t.mxd0t:				!
	sethi	%hi(t.mxd0s),%o3	!
	or	%o3,%lo(t.mxd0s),%o3	!
	or	%g0,t.mxd0e-t.mxd0s,%o4	!
    t.mxd0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.mxd0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.mxd0o0-t.mxd0s],%o5
	srl	%o1,16,%o4		!
	andcc	%o4,0xf,%o4		! X2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+t.mxd0t0-t.mxd0s]
	ld	[%o3+t.mxd0o1-t.mxd0s],%o5
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.mxd0t1-t.mxd0s]
	ld	[%o3+t.mxd0o2-t.mxd0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+t.mxd0t2-t.mxd0s]
	retl				!
	add	%o0,t.mxd0e-t.mxd0s,%o0	!
    t.mxd1t:				!
	sethi	%hi(t.mxd1s),%o3	!
	or	%o3,%lo(t.mxd1s),%o3	!
	or	%g0,t.mxd1e-t.mxd1s,%o4	!
    t.mxd1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.mxd1cp		!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,t.mxd1e-t.mxd1s,%o0	!
if4_mxd:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,3,%g0		!
	bnz	t.mxd1s			!
	nop				!
    i.mxd0t:				!
	srl	%o1,16,%o4		! X2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l2		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l2		! %l2
	srl	%o1,12,%o4		! B2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l3		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l3		! %l3
	and	%o1,0xfff,%l4		! D2
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	add	%o4,64,%i0		! %i0
t.mxd0s:
		ld	[%sp+184],%o0	! struct *gcpu_s
    t.mxd0t0:	add	%l2,%l3,%o2	! ##TEMPLATE:%l0,%l0
    t.mxd0t1:	add	%o2,%l4,%o2	! ##TEMPLATE:imm0
		and	%o2,%g3,%o2	! mask address
		add	%g4,%o2,%o2	!
		ld	[%o2],%o4	! get op#2
		ld	[%o2+4],%o5	! get op#2
		std	%o4,[%o0+768]	! store op#2
		add	%o0,768,%o2	!
    t.mxd0t2:	add	%o0,%i0,%o1	! ##TEMPLATE:%imm
		and	%g7,0xf,%o3	! give Program Mask
		stx	%g1,[%o0+648]	!
		stx	%g2,[%o0+656]	!
		stx	%g3,[%o0+664]	!
		stx	%g4,[%o0+672]	!
		stx	%g5,[%o0+680]	!
		sethi	%hi(fl_mult_long2ext),%o7
		jmpl	%o7+%lo(fl_mult_long2ext),%o7
		nop			! call library in fltlib.s
		ld	[%sp+184],%o7	! struct *gcpu_s
		ldx	[%o7+648],%g1	!
		ldx	[%o7+656],%g2	!
		ldx	[%o7+664],%g3	!
		ldx	[%o7+672],%g4	!
		ldx	[%o7+680],%g5	!
		sethi	%hi(0x00ff0000),%o1
		andcc	%o0,%o1,%o0	! extract exception
		bz,a	t.mxd0e		!   exit
		add	%g2,4,%g2	! update IAR
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! INTR-CODE=retval
t.mxd0e:
		ba	break0		!
		nop			!
    t.mxd0o0:	add	%l0,%l0,%o2	! ##TEMPLATE:%l0,%l0
    t.mxd0o1:	add	%o2,0,%o2	! ##TEMPLATE:imm0
    t.mxd0o2:	add	%o0,64,%o1	! ##TEMPLATE:%imm
t.mxd1s:
		sethi	%hi(0x00060000),%o0
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! specification exception
t.mxd1e:

	.section ".text"
	.align	4
	.global cf4_ld,tf4_ld,if4_ld
cf4_ld:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	c.ld1c			!
	nop				!
    c.ld0c:				!
	retl				! case even:
	add	%g0,t.ld0e-t.ld0s,%o0	!
    c.ld1c:				!
	retl				! case odd:
	add	%g0,t.ld1e-t.ld1s,%o0	!   specification exception
tf4_ld:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	t.ld1t			!
	nop				!
    t.ld0t:				!
	sethi	%hi(t.ld0s),%o3		!
	or	%o3,%lo(t.ld0s),%o3	!
	or	%g0,t.ld0e-t.ld0s,%o4	!
    t.ld0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.ld0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.ld0o0-t.ld0s],%o5!
	srl	%o1,16,%o4		!
	andcc	%o4,0xf,%o4		! X2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+t.ld0t0-t.ld0s]!
	ld	[%o3+t.ld0o1-t.ld0s],%o5!
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.ld0t1-t.ld0s]!
	ld	[%o3+t.ld0o2-t.ld0s],%o5!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+t.ld0t2-t.ld0s]!
	retl				!
	add	%o0,t.ld0e-t.ld0s,%o0	!
    t.ld1t:				!
	sethi	%hi(t.ld1s),%o3		!
	or	%o3,%lo(t.ld1s),%o3	!
	or	%g0,t.ld1e-t.ld1s,%o4	!
    t.ld1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.ld1cp			!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,t.ld1e-t.ld1s,%o0	!
if4_ld:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	t.ld1s			!
	nop				!
    i.ld0t:				!
	srl	%o1,16,%o4		! X2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l2		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l2		! %l2
	srl	%o1,12,%o4		! B2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l3		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l3		! %l3
	and	%o1,0xfff,%l4		! D2
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	add	%o4,64,%i0		! %i0
t.ld0s:
		ld	[%sp+184],%o7	! struct *gcpu_s
    t.ld0t0:	add	%l2,%l3,%o0	! ##TEMPLATE:%l0,%l0
    t.ld0t1:	add	%o0,%l4,%o0	! ##TEMPLATE:imm0
		and	%o0,%g3,%o0	! mask address
		ld	[%g4+%o0],%o2	! load upper word
		add	%o0,4,%o0	!
		ld	[%g4+%o0],%o3	! load lower word
    t.ld0t2:	std	%o2,[%o7+%i0]	! ##TEMPLATE:%imm
		add	%g2,4,%g2	! update IAR
t.ld0e:
		ba	break0		!
		nop			!
    t.ld0o0:	add	%l0,%l0,%o0	! ##TEMPLATE:%l0,%l0
    t.ld0o1:	add	%o0,0,%o0	! ##TEMPLATE:imm0
    t.ld0o2:	std	%o2,[%o7+64]	! ##TEMPLATE:%imm
t.ld1s:
		sethi	%hi(0x00060000),%o0
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! specification exception
t.ld1e:

	.section ".text"
	.align	4
	.global cf4_cd,tf4_cd,if4_cd
cf4_cd:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	c.cd1c			!
	nop				!
    c.cd0c:				!
	retl				! case even:
	add	%g0,t.cd0e-t.cd0s,%o0	!
    c.cd1c:				!
	retl				! case odd:
	add	%g0,t.cd1e-t.cd1s,%o0	!   specification exception
tf4_cd:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	t.cd1t			!
	nop				!
    t.cd0t:				!
	sethi	%hi(t.cd0s),%o3		!
	or	%o3,%lo(t.cd0s),%o3	!
	or	%g0,t.cd0e-t.cd0s,%o4	!
    t.cd0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.cd0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.cd0o0-t.cd0s],%o5!
	srl	%o1,16,%o4		!
	andcc	%o4,0xf,%o4		! X2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+t.cd0t0-t.cd0s]!
	ld	[%o3+t.cd0o1-t.cd0s],%o5!
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.cd0t1-t.cd0s]!
	ld	[%o3+t.cd0o2-t.cd0s],%o5!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+t.cd0t2-t.cd0s]!
	retl				!
	add	%o0,t.cd0e-t.cd0s,%o0	!
    t.cd1t:				!
	sethi	%hi(t.cd1s),%o3		!
	or	%o3,%lo(t.cd1s),%o3	!
	or	%g0,t.cd1e-t.cd1s,%o4	!
    t.cd1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.cd1cp			!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,t.cd1e-t.cd1s,%o0	!
if4_cd:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	t.cd1s			!
	nop				!
    i.cd0t:				!
	srl	%o1,16,%o4		! X2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l2		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l2		! %l2
	srl	%o1,12,%o4		! B2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l3		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l3		! %l3
	and	%o1,0xfff,%l4		! D2
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	add	%o4,64,%i0		! %i0
t.cd0s:
		ld	[%sp+184],%o0	! struct *gcpu_s
    t.cd0t0:	add	%l2,%l3,%o2	! ##TEMPLATE:%l0,%l0
    t.cd0t1:	add	%o2,%l4,%o2	! ##TEMPLATE:imm0
		and	%o2,%g3,%o2	! mask address
		add	%g4,%o2,%o2	!
		ld	[%o2],%o4	! get op#2
		ld	[%o2+4],%o5	! get op#2
		std	%o4,[%o0+768]	! store op#2
		add	%o0,768,%o2	!
    t.cd0t2:	add	%o0,%i0,%o1	! ##TEMPLATE:%imm
		and	%g7,0xf,%o3	! give Program Mask
		stx	%g1,[%o0+648]	!
		stx	%g2,[%o0+656]	!
		stx	%g3,[%o0+664]	!
		stx	%g4,[%o0+672]	!
		stx	%g5,[%o0+680]	!
		sethi	%hi(fl_comp_long),%o7
		jmpl	%o7+%lo(fl_comp_long),%o7
		nop			! call library in fltlib.s
		ld	[%sp+184],%o7	! struct *gcpu_s
		ldx	[%o7+648],%g1	!
		ldx	[%o7+656],%g2	!
		ldx	[%o7+664],%g3	!
		ldx	[%o7+672],%g4	!
		ldx	[%o7+680],%g5	!
		and	%o0,3,%g1	! CC=retval
		add	%g2,4,%g2	! update IAR
t.cd0e:
		ba	break0		!
		nop			!
    t.cd0o0:	add	%l0,%l0,%o2	! ##TEMPLATE:%l0,%l0
    t.cd0o1:	add	%o2,0,%o2	! ##TEMPLATE:imm0
    t.cd0o2:	add	%o0,64,%o1	! ##TEMPLATE:%imm
t.cd1s:
		sethi	%hi(0x00060000),%o0
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! specification exception
t.cd1e:

	.section ".text"
	.align	4
	.global cf4_ad,tf4_ad,if4_ad
cf4_ad:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	c.ad1c			!
	nop				!
    c.ad0c:				!
	retl				! case even:
	add	%g0,t.ad0e-t.ad0s,%o0	!
    c.ad1c:				!
	retl				! case odd:
	add	%g0,t.ad1e-t.ad1s,%o0	!   specification exception
tf4_ad:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	t.ad1t			!
	nop				!
    t.ad0t:				!
	sethi	%hi(t.ad0s),%o3		!
	or	%o3,%lo(t.ad0s),%o3	!
	or	%g0,t.ad0e-t.ad0s,%o4	!
    t.ad0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.ad0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.ad0o0-t.ad0s],%o5!
	srl	%o1,16,%o4		!
	andcc	%o4,0xf,%o4		! X2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+t.ad0t0-t.ad0s]!
	ld	[%o3+t.ad0o1-t.ad0s],%o5!
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.ad0t1-t.ad0s]!
	ld	[%o3+t.ad0o2-t.ad0s],%o5!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+t.ad0t2-t.ad0s]!
	retl				!
	add	%o0,t.ad0e-t.ad0s,%o0	!
    t.ad1t:				!
	sethi	%hi(t.ad1s),%o3		!
	or	%o3,%lo(t.ad1s),%o3	!
	or	%g0,t.ad1e-t.ad1s,%o4	!
    t.ad1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.ad1cp			!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,t.ad1e-t.ad1s,%o0	!
if4_ad:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	t.ad1s			!
	nop				!
    i.ad0t:				!
	srl	%o1,16,%o4		! X2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l2		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l2		! %l2
	srl	%o1,12,%o4		! B2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l3		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l3		! %l3
	and	%o1,0xfff,%l4		! D2
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	add	%o4,64,%i0		! %i0
t.ad0s:
		ld	[%sp+184],%o0	! struct *gcpu_s
    t.ad0t0:	add	%l2,%l3,%o2	! ##TEMPLATE:%l0,%l0
    t.ad0t1:	add	%o2,%l4,%o2	! ##TEMPLATE:imm0
		and	%o2,%g3,%o2	! mask address
		add	%g4,%o2,%o2	!
		ld	[%o2],%o4	! get op#2
		ld	[%o2+4],%o5	! get op#2
		std	%o4,[%o0+768]	! store op#2
		add	%o0,768,%o2	!
    t.ad0t2:	add	%o0,%i0,%o1	! ##TEMPLATE:%imm
		and	%g7,0xf,%o3	! give Program Mask
		stx	%g1,[%o0+648]	!
		stx	%g2,[%o0+656]	!
		stx	%g3,[%o0+664]	!
		stx	%g4,[%o0+672]	!
		stx	%g5,[%o0+680]	!
		sethi	%hi(fl_addsub_long_norm),%o7
		jmpl	%o7+%lo(fl_addsub_long_norm),%o7
		add	%g0,0,%o4	! call library in fltlib.s
		ld	[%sp+184],%o7	! struct *gcpu_s
		ldx	[%o7+648],%g1	!
		ldx	[%o7+656],%g2	!
		ldx	[%o7+664],%g3	!
		ldx	[%o7+672],%g4	!
		ldx	[%o7+680],%g5	!
		and	%o0,3,%g1	! CC=retval
		sethi	%hi(0x00ff0000),%o1
		andcc	%o0,%o1,%o0	! extract exception
		bz,a	t.ad0e		!   exit
		add	%g2,4,%g2	! update IAR
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! INTR-CODE=retval
t.ad0e:
		ba	break0		!
		nop			!
    t.ad0o0:	add	%l0,%l0,%o2	! ##TEMPLATE:%l0,%l0
    t.ad0o1:	add	%o2,0,%o2	! ##TEMPLATE:imm0
    t.ad0o2:	add	%o0,64,%o1	! ##TEMPLATE:%imm
t.ad1s:
		sethi	%hi(0x00060000),%o0
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! specification exception
t.ad1e:

	.section ".text"
	.align	4
	.global cf4_sd,tf4_sd,if4_sd
cf4_sd:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	c.sd1c			!
	nop				!
    c.sd0c:				!
	retl				! case even:
	add	%g0,t.sd0e-t.sd0s,%o0	!
    c.sd1c:				!
	retl				! case odd:
	add	%g0,t.sd1e-t.sd1s,%o0	!   specification exception
tf4_sd:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	t.sd1t			!
	nop				!
    t.sd0t:				!
	sethi	%hi(t.sd0s),%o3		!
	or	%o3,%lo(t.sd0s),%o3	!
	or	%g0,t.sd0e-t.sd0s,%o4	!
    t.sd0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.sd0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.sd0o0-t.sd0s],%o5!
	srl	%o1,16,%o4		!
	andcc	%o4,0xf,%o4		! X2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+t.sd0t0-t.sd0s]!
	ld	[%o3+t.sd0o1-t.sd0s],%o5!
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.sd0t1-t.sd0s]!
	ld	[%o3+t.sd0o2-t.sd0s],%o5!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+t.sd0t2-t.sd0s]!
	retl				!
	add	%o0,t.sd0e-t.sd0s,%o0	!
    t.sd1t:				!
	sethi	%hi(t.sd1s),%o3		!
	or	%o3,%lo(t.sd1s),%o3	!
	or	%g0,t.sd1e-t.sd1s,%o4	!
    t.sd1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.sd1cp			!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,t.sd1e-t.sd1s,%o0	!
if4_sd:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	t.sd1s			!
	nop				!
    i.sd0t:				!
	srl	%o1,16,%o4		! X2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l2		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l2		! %l2
	srl	%o1,12,%o4		! B2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l3		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l3		! %l3
	and	%o1,0xfff,%l4		! D2
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	add	%o4,64,%i0		! %i0
t.sd0s:
		ld	[%sp+184],%o0	! struct *gcpu_s
    t.sd0t0:	add	%l2,%l3,%o2	! ##TEMPLATE:%l0,%l0
    t.sd0t1:	add	%o2,%l4,%o2	! ##TEMPLATE:imm0
		and	%o2,%g3,%o2	! mask address
		add	%g4,%o2,%o2	!
		ld	[%o2],%o4	! get op#2
		ld	[%o2+4],%o5	! get op#2
		std	%o4,[%o0+768]	! store op#2
		add	%o0,768,%o2	!
    t.sd0t2:	add	%o0,%i0,%o1	! ##TEMPLATE:%imm
		and	%g7,0xf,%o3	! give Program Mask
		stx	%g1,[%o0+648]	!
		stx	%g2,[%o0+656]	!
		stx	%g3,[%o0+664]	!
		stx	%g4,[%o0+672]	!
		stx	%g5,[%o0+680]	!
		sethi	%hi(fl_addsub_long_norm),%o7
		jmpl	%o7+%lo(fl_addsub_long_norm),%o7
		add	%g0,1,%o4	! call library in fltlib.s
		ld	[%sp+184],%o7	! struct *gcpu_s
		ldx	[%o7+648],%g1	!
		ldx	[%o7+656],%g2	!
		ldx	[%o7+664],%g3	!
		ldx	[%o7+672],%g4	!
		ldx	[%o7+680],%g5	!
		and	%o0,3,%g1	! CC=retval
		sethi	%hi(0x00ff0000),%o1
		andcc	%o0,%o1,%o0	! extract exception
		bz,a	t.sd0e		!   exit
		add	%g2,4,%g2	! update IAR
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! INTR-CODE=retval
t.sd0e:
		ba	break0		!
		nop			!
    t.sd0o0:	add	%l0,%l0,%o2	! ##TEMPLATE:%l0,%l0
    t.sd0o1:	add	%o2,0,%o2	! ##TEMPLATE:imm0
    t.sd0o2:	add	%o0,64,%o1	! ##TEMPLATE:%imm
t.sd1s:
		sethi	%hi(0x00060000),%o0
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! specification exception
t.sd1e:

	.section ".text"
	.align	4
	.global cf4_md,tf4_md,if4_md
cf4_md:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	c.md1c			!
	nop				!
    c.md0c:				!
	retl				! case even:
	add	%g0,t.md0e-t.md0s,%o0	!
    c.md1c:				!
	retl				! case odd:
	add	%g0,t.md1e-t.md1s,%o0	!   specification exception
tf4_md:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	t.md1t			!
	nop				!
    t.md0t:				!
	sethi	%hi(t.md0s),%o3		!
	or	%o3,%lo(t.md0s),%o3	!
	or	%g0,t.md0e-t.md0s,%o4	!
    t.md0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.md0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.md0o0-t.md0s],%o5!
	srl	%o1,16,%o4		!
	andcc	%o4,0xf,%o4		! X2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+t.md0t0-t.md0s]!
	ld	[%o3+t.md0o1-t.md0s],%o5!
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.md0t1-t.md0s]!
	ld	[%o3+t.md0o2-t.md0s],%o5!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+t.md0t2-t.md0s]!
	retl				!
	add	%o0,t.md0e-t.md0s,%o0	!
    t.md1t:				!
	sethi	%hi(t.md1s),%o3		!
	or	%o3,%lo(t.md1s),%o3	!
	or	%g0,t.md1e-t.md1s,%o4	!
    t.md1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.md1cp			!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,t.md1e-t.md1s,%o0	!
if4_md:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	t.md1s			!
	nop				!
    i.md0t:				!
	srl	%o1,16,%o4		! X2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l2		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l2		! %l2
	srl	%o1,12,%o4		! B2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l3		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l3		! %l3
	and	%o1,0xfff,%l4		! D2
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	add	%o4,64,%i0		! %i0
t.md0s:
		ld	[%sp+184],%o0	! struct *gcpu_s
    t.md0t0:	add	%l2,%l3,%o2	! ##TEMPLATE:%l0,%l0
    t.md0t1:	add	%o2,%l4,%o2	! ##TEMPLATE:imm0
		and	%o2,%g3,%o2	! mask address
		add	%g4,%o2,%o2	!
		ld	[%o2],%o4	! get op#2
		ld	[%o2+4],%o5	! get op#2
		std	%o4,[%o0+768]	! store op#2
		add	%o0,768,%o2	!
    t.md0t2:	add	%o0,%i0,%o1	! ##TEMPLATE:%imm
		and	%g7,0xf,%o3	! give Program Mask
		stx	%g1,[%o0+648]	!
		stx	%g2,[%o0+656]	!
		stx	%g3,[%o0+664]	!
		stx	%g4,[%o0+672]	!
		stx	%g5,[%o0+680]	!
		sethi	%hi(fl_mult_long2long),%o7
		jmpl	%o7+%lo(fl_mult_long2long),%o7
		nop			! call library in fltlib.s
		ld	[%sp+184],%o7	! struct *gcpu_s
		ldx	[%o7+648],%g1	!
		ldx	[%o7+656],%g2	!
		ldx	[%o7+664],%g3	!
		ldx	[%o7+672],%g4	!
		ldx	[%o7+680],%g5	!
		sethi	%hi(0x00ff0000),%o1
		andcc	%o0,%o1,%o0	! extract exception
		bz,a	t.md0e		!   exit
		add	%g2,4,%g2	! update IAR
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! INTR-CODE=retval
t.md0e:
		ba	break0		!
		nop			!
    t.md0o0:	add	%l0,%l0,%o2	! ##TEMPLATE:%l0,%l0
    t.md0o1:	add	%o2,0,%o2	! ##TEMPLATE:imm0
    t.md0o2:	add	%o0,64,%o1	! ##TEMPLATE:%imm
t.md1s:
		sethi	%hi(0x00060000),%o0
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! specification exception
t.md1e:

	.section ".text"
	.align	4
	.global cf4_dd,tf4_dd,if4_dd
cf4_dd:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	c.dd1c			!
	nop				!
    c.dd0c:				!
	retl				! case even:
	add	%g0,t.dd0e-t.dd0s,%o0	!
    c.dd1c:				!
	retl				! case odd:
	add	%g0,t.dd1e-t.dd1s,%o0	!   specification exception
tf4_dd:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	t.dd1t			!
	nop				!
    t.dd0t:				!
	sethi	%hi(t.dd0s),%o3		!
	or	%o3,%lo(t.dd0s),%o3	!
	or	%g0,t.dd0e-t.dd0s,%o4	!
    t.dd0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.dd0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.dd0o0-t.dd0s],%o5!
	srl	%o1,16,%o4		!
	andcc	%o4,0xf,%o4		! X2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+t.dd0t0-t.dd0s]!
	ld	[%o3+t.dd0o1-t.dd0s],%o5!
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.dd0t1-t.dd0s]!
	ld	[%o3+t.dd0o2-t.dd0s],%o5!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+t.dd0t2-t.dd0s]!
	retl				!
	add	%o0,t.dd0e-t.dd0s,%o0	!
    t.dd1t:				!
	sethi	%hi(t.dd1s),%o3		!
	or	%o3,%lo(t.dd1s),%o3	!
	or	%g0,t.dd1e-t.dd1s,%o4	!
    t.dd1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.dd1cp			!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,t.dd1e-t.dd1s,%o0	!
if4_dd:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	t.dd1s			!
	nop				!
    i.dd0t:				!
	srl	%o1,16,%o4		! X2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l2		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l2		! %l2
	srl	%o1,12,%o4		! B2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l3		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l3		! %l3
	and	%o1,0xfff,%l4		! D2
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	add	%o4,64,%i0		! %i0
t.dd0s:
		ld	[%sp+184],%o0	! struct *gcpu_s
    t.dd0t0:	add	%l2,%l3,%o2	! ##TEMPLATE:%l0,%l0
    t.dd0t1:	add	%o2,%l4,%o2	! ##TEMPLATE:imm0
		and	%o2,%g3,%o2	! mask address
		add	%g4,%o2,%o2	!
		ld	[%o2],%o4	! get op#2
		ld	[%o2+4],%o5	! get op#2
		std	%o4,[%o0+768]	! store op#2
		add	%o0,768,%o2	!
    t.dd0t2:	add	%o0,%i0,%o1	! ##TEMPLATE:%imm
		and	%g7,0xf,%o3	! give Program Mask
		stx	%g1,[%o0+648]	!
		stx	%g2,[%o0+656]	!
		stx	%g3,[%o0+664]	!
		stx	%g4,[%o0+672]	!
		stx	%g5,[%o0+680]	!
		sethi	%hi(fl_div_long),%o7
		jmpl	%o7+%lo(fl_div_long),%o7
		nop			! call library in fltlib.s
		ld	[%sp+184],%o7	! struct *gcpu_s
		ldx	[%o7+648],%g1	!
		ldx	[%o7+656],%g2	!
		ldx	[%o7+664],%g3	!
		ldx	[%o7+672],%g4	!
		ldx	[%o7+680],%g5	!
		sethi	%hi(0x00ff0000),%o1
		andcc	%o0,%o1,%o0	! extract exception
		bz,a	t.dd0e		!   exit
		add	%g2,4,%g2	! update IAR
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! INTR-CODE=retval
t.dd0e:
		ba	break0		!
		nop			!
    t.dd0o0:	add	%l0,%l0,%o2	! ##TEMPLATE:%l0,%l0
    t.dd0o1:	add	%o2,0,%o2	! ##TEMPLATE:imm0
    t.dd0o2:	add	%o0,64,%o1	! ##TEMPLATE:%imm
t.dd1s:
		sethi	%hi(0x00060000),%o0
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! specification exception
t.dd1e:

	.section ".text"
	.align	4
	.global cf4_aw,tf4_aw,if4_aw
cf4_aw:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	c.aw1c			!
	nop				!
    c.aw0c:				!
	retl				! case even:
	add	%g0,t.aw0e-t.aw0s,%o0	!
    c.aw1c:				!
	retl				! case odd:
	add	%g0,t.aw1e-t.aw1s,%o0	!   specification exception
tf4_aw:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	t.aw1t			!
	nop				!
    t.aw0t:				!
	sethi	%hi(t.aw0s),%o3		!
	or	%o3,%lo(t.aw0s),%o3	!
	or	%g0,t.aw0e-t.aw0s,%o4	!
    t.aw0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.aw0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.aw0o0-t.aw0s],%o5!
	srl	%o1,16,%o4		!
	andcc	%o4,0xf,%o4		! X2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+t.aw0t0-t.aw0s]!
	ld	[%o3+t.aw0o1-t.aw0s],%o5!
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.aw0t1-t.aw0s]!
	ld	[%o3+t.aw0o2-t.aw0s],%o5!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+t.aw0t2-t.aw0s]!
	retl				!
	add	%o0,t.aw0e-t.aw0s,%o0	!
    t.aw1t:				!
	sethi	%hi(t.aw1s),%o3		!
	or	%o3,%lo(t.aw1s),%o3	!
	or	%g0,t.aw1e-t.aw1s,%o4	!
    t.aw1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.aw1cp			!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,t.aw1e-t.aw1s,%o0	!
if4_aw:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	t.aw1s			!
	nop				!
    i.aw0t:				!
	srl	%o1,16,%o4		! X2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l2		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l2		! %l2
	srl	%o1,12,%o4		! B2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l3		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l3		! %l3
	and	%o1,0xfff,%l4		! D2
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	add	%o4,64,%i0		! %i0
t.aw0s:
		ld	[%sp+184],%o0	! struct *gcpu_s
    t.aw0t0:	add	%l2,%l3,%o2	! ##TEMPLATE:%l0,%l0
    t.aw0t1:	add	%o2,%l4,%o2	! ##TEMPLATE:imm0
		and	%o2,%g3,%o2	! mask address
		add	%g4,%o2,%o2	!
		ld	[%o2],%o4	! get op#2
		ld	[%o2+4],%o5	! get op#2
		std	%o4,[%o0+768]	! store op#2
		add	%o0,768,%o2	!
    t.aw0t2:	add	%o0,%i0,%o1	! ##TEMPLATE:%imm
		and	%g7,0xf,%o3	! give Program Mask
		stx	%g1,[%o0+648]	!
		stx	%g2,[%o0+656]	!
		stx	%g3,[%o0+664]	!
		stx	%g4,[%o0+672]	!
		stx	%g5,[%o0+680]	!
		sethi	%hi(fl_addsub_long_unnorm),%o7
		jmpl	%o7+%lo(fl_addsub_long_unnorm),%o7
		add	%g0,0,%o4	! call library in fltlib.s
		ld	[%sp+184],%o7	! struct *gcpu_s
		ldx	[%o7+648],%g1	!
		ldx	[%o7+656],%g2	!
		ldx	[%o7+664],%g3	!
		ldx	[%o7+672],%g4	!
		ldx	[%o7+680],%g5	!
		and	%o0,3,%g1	! CC=retval
		sethi	%hi(0x00ff0000),%o1
		andcc	%o0,%o1,%o0	! extract exception
		bz,a	t.aw0e		!   exit
		add	%g2,4,%g2	! update IAR
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! INTR-CODE=retval
t.aw0e:
		ba	break0		!
		nop			!
    t.aw0o0:	add	%l0,%l0,%o2	! ##TEMPLATE:%l0,%l0
    t.aw0o1:	add	%o2,0,%o2	! ##TEMPLATE:imm0
    t.aw0o2:	add	%o0,64,%o1	! ##TEMPLATE:%imm
t.aw1s:
		sethi	%hi(0x00060000),%o0
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! specification exception
t.aw1e:

	.section ".text"
	.align	4
	.global cf4_sw,tf4_sw,if4_sw
cf4_sw:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	c.sw1c			!
	nop				!
    c.sw0c:				!
	retl				! case even:
	add	%g0,t.sw0e-t.sw0s,%o0	!
    c.sw1c:				!
	retl				! case odd:
	add	%g0,t.sw1e-t.sw1s,%o0	!   specification exception
tf4_sw:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	t.sw1t			!
	nop				!
    t.sw0t:				!
	sethi	%hi(t.sw0s),%o3		!
	or	%o3,%lo(t.sw0s),%o3	!
	or	%g0,t.sw0e-t.sw0s,%o4	!
    t.sw0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.sw0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.sw0o0-t.sw0s],%o5!
	srl	%o1,16,%o4		!
	andcc	%o4,0xf,%o4		! X2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+t.sw0t0-t.sw0s]!
	ld	[%o3+t.sw0o1-t.sw0s],%o5!
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.sw0t1-t.sw0s]!
	ld	[%o3+t.sw0o2-t.sw0s],%o5!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+t.sw0t2-t.sw0s]!
	retl				!
	add	%o0,t.sw0e-t.sw0s,%o0	!
    t.sw1t:				!
	sethi	%hi(t.sw1s),%o3		!
	or	%o3,%lo(t.sw1s),%o3	!
	or	%g0,t.sw1e-t.sw1s,%o4	!
    t.sw1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.sw1cp			!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,t.sw1e-t.sw1s,%o0	!
if4_sw:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	t.sw1s			!
	nop				!
    i.sw0t:				!
	srl	%o1,16,%o4		! X2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l2		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l2		! %l2
	srl	%o1,12,%o4		! B2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l3		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l3		! %l3
	and	%o1,0xfff,%l4		! D2
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	add	%o4,64,%i0		! %i0
t.sw0s:
		ld	[%sp+184],%o0	! struct *gcpu_s
    t.sw0t0:	add	%l2,%l3,%o2	! ##TEMPLATE:%l0,%l0
    t.sw0t1:	add	%o2,%l4,%o2	! ##TEMPLATE:imm0
		and	%o2,%g3,%o2	! mask address
		add	%g4,%o2,%o2	!
		ld	[%o2],%o4	! get op#2
		ld	[%o2+4],%o5	! get op#2
		std	%o4,[%o0+768]	! store op#2
		add	%o0,768,%o2	!
    t.sw0t2:	add	%o0,%i0,%o1	! ##TEMPLATE:%imm
		and	%g7,0xf,%o3	! give Program Mask
		stx	%g1,[%o0+648]	!
		stx	%g2,[%o0+656]	!
		stx	%g3,[%o0+664]	!
		stx	%g4,[%o0+672]	!
		stx	%g5,[%o0+680]	!
		sethi	%hi(fl_addsub_long_unnorm),%o7
		jmpl	%o7+%lo(fl_addsub_long_unnorm),%o7
		add	%g0,1,%o4	! call library in fltlib.s
		ld	[%sp+184],%o7	! struct *gcpu_s
		ldx	[%o7+648],%g1	!
		ldx	[%o7+656],%g2	!
		ldx	[%o7+664],%g3	!
		ldx	[%o7+672],%g4	!
		ldx	[%o7+680],%g5	!
		and	%o0,3,%g1	! CC=retval
		sethi	%hi(0x00ff0000),%o1
		andcc	%o0,%o1,%o0	! extract exception
		bz,a	t.sw0e		!   exit
		add	%g2,4,%g2	! update IAR
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! INTR-CODE=retval
t.sw0e:
		ba	break0		!
		nop			!
    t.sw0o0:	add	%l0,%l0,%o2	! ##TEMPLATE:%l0,%l0
    t.sw0o1:	add	%o2,0,%o2	! ##TEMPLATE:imm0
    t.sw0o2:	add	%o0,64,%o1	! ##TEMPLATE:%imm
t.sw1s:
		sethi	%hi(0x00060000),%o0
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! specification exception
t.sw1e:
!================================

!
! templates
! cxx_xxx:
!   %o0: param: none
!	 retval:size of template
!   %o1: M instruction (4 bytes)
!   %o2: work
!   %o3: work
!   %o4: work
!   %o5: work
! txx_xxx:
!   %o0: param: bufp start address
!	 retval:bufp next start address
!   %o1: M instruction (4 bytes)
!   %o2: work
!   %o3: work
!   %o4: work
!   %o5: work
!
	.section ".text"
	.align	4
	.global cf4_ste,tf4_ste,if4_ste
cf4_ste:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	c.ste1c			!
	nop				!
    c.ste0c:				!
	retl				! case even:
	add	%g0,t.ste0e-t.ste0s,%o0	!
    c.ste1c:				!
	retl				! case odd:
	add	%g0,t.ste1e-t.ste1s,%o0	!   specification exception
tf4_ste:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	t.ste1t			!
	nop				!
    t.ste0t:				!
	sethi	%hi(t.ste0s),%o3	!
	or	%o3,%lo(t.ste0s),%o3	!
	or	%g0,t.ste0e-t.ste0s,%o4	!
    t.ste0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.ste0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.ste0o0-t.ste0s],%o5
	srl	%o1,16,%o4		!
	andcc	%o4,0xf,%o4		! X2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+t.ste0t0-t.ste0s]
	ld	[%o3+t.ste0o1-t.ste0s],%o5
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.ste0t1-t.ste0s]
	ld	[%o3+t.ste0o2-t.ste0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+t.ste0t2-t.ste0s]
	retl				!
	add	%o0,t.ste0e-t.ste0s,%o0	!
    t.ste1t:				!
	sethi	%hi(t.ste1s),%o3	!
	or	%o3,%lo(t.ste1s),%o3	!
	or	%g0,t.ste1e-t.ste1s,%o4	!
    t.ste1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.ste1cp		!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,t.ste1e-t.ste1s,%o0	!
if4_ste:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	t.ste1s			!
	nop				!
    i.ste0t:				!
	srl	%o1,16,%o4		! X2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l2		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l2		! %l2
	srl	%o1,12,%o4		! B2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l3		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l3		! %l3
	and	%o1,0xfff,%l4		! D2
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	add	%o4,64,%i0		! %i0
t.ste0s:
		ld	[%sp+184],%o7	! struct *gcpu_s
    t.ste0t0:	add	%l2,%l3,%o0	! ##TEMPLATE:%l0,%l0
    t.ste0t1:	add	%o0,%l4,%o0	! ##TEMPLATE:imm0
		and	%o0,%g3,%o0	! mask address
    t.ste0t2:	ld	[%o7+%i0],%o2	! ##TEMPLATE:%imm
		st	%o2,[%g4+%o0]	!
		add	%g2,4,%g2	! update IAR
t.ste0e:
		ba	break0		!
		nop			!
    t.ste0o0:	add	%l0,%l0,%o0	! ##TEMPLATE:%l0,%l0
    t.ste0o1:	add	%o0,0,%o0	! ##TEMPLATE:imm0
    t.ste0o2:	ld	[%o7+64],%o2	! ##TEMPLATE:%imm
t.ste1s:
		sethi	%hi(0x00060000),%o0
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! specification exception
t.ste1e:

	.section ".text"
	.align	4
	.global cf4_cei,tf4_cei,if4_cei
cf4_cei:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	c.cei1c			!
	nop				!
    c.cei0c:				!
	retl				! case even:
	add	%g0,t.cei0e-t.cei0s,%o0	!
    c.cei1c:				!
	retl				! case odd:
	add	%g0,t.cei1e-t.cei1s,%o0	!   specification exception
tf4_cei:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	t.cei1t			!
	nop				!
    t.cei0t:				!
	sethi	%hi(t.cei0s),%o3	!
	or	%o3,%lo(t.cei0s),%o3	!
	or	%g0,t.cei0e-t.cei0s,%o4	!
    t.cei0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.cei0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.cei0o0-t.cei0s],%o5
	srl	%o1,16,%o4		!
	andcc	%o4,0xf,%o4		! X2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+t.cei0t0-t.cei0s]
	ld	[%o3+t.cei0o1-t.cei0s],%o5
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.cei0t1-t.cei0s]
	ld	[%o3+t.cei0o2-t.cei0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+t.cei0t2-t.cei0s]
	retl				!
	add	%o0,t.cei0e-t.cei0s,%o0	!
    t.cei1t:				!
	sethi	%hi(t.cei1s),%o3	!
	or	%o3,%lo(t.cei1s),%o3	!
	or	%g0,t.cei1e-t.cei1s,%o4	!
    t.cei1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.cei1cp		!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,t.cei1e-t.cei1s,%o0	!
if4_cei:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	t.cei1s			!
	nop				!
    i.cei0t:				!
	srl	%o1,16,%o4		! X2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l2		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l2		! %l2
	srl	%o1,12,%o4		! B2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l3		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l3		! %l3
	and	%o1,0xfff,%l4		! D2
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	add	%o4,64,%i0		! %i0
t.cei0s:
		ld	[%sp+184],%o0	! struct *guest
		add	%o0,768,%o1	! call library in fltlib.s
    t.cei0t2:	ld	[%o0+%i0],%o2	! ##TEMPLATE:%imm
		add	%g0,0,%o3	!
		stx	%g1,[%o0+648]	!
		stx	%g2,[%o0+656]	!
		stx	%g3,[%o0+664]	!
		stx	%g4,[%o0+672]	!
		stx	%g5,[%o0+680]	!
		sethi	%hi(fl_conv_float2int),%o7
		jmpl	%o7+%lo(fl_conv_float2int),%o7
		and	%g7,0xf,%o4	! give Program Mask
		ld	[%sp+184],%o7	! struct *guest
		ldx	[%o7+648],%g1	!
		ldx	[%o7+656],%g2	!
		ldx	[%o7+664],%g3	!
		ldx	[%o7+672],%g4	!
		ldx	[%o7+680],%g5	!
		ld	[%o7+768],%o1	!
    t.cei0t0:	add	%l2,%l3,%o2	! ##TEMPLATE:%l0,%l0
    t.cei0t1:	add	%o2,%l4,%o2	! ##TEMPLATE:imm0
		and	%o2,%g3,%o2	! mask address
		st	%o1,[%g4+%o2]	! store integer
		and	%o0,3,%g1	! CC=retval
		sethi	%hi(0x00ff0000),%o1
		andcc	%o0,%o1,%o0	! extract exception
		bz,a	t.cei0e		!   exit
		add	%g2,4,%g2	! update IAR
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! INTR-CODE=retval
t.cei0e:
		ba	break0		!
		nop			!
    t.cei0o0:	add	%l0,%l0,%o2	! ##TEMPLATE:%l0,%l0
    t.cei0o1:	add	%o2,0,%o2	! ##TEMPLATE:imm0
    t.cei0o2:	ld	[%o0+64],%o2	! ##TEMPLATE:%imm
t.cei1s:
		sethi	%hi(0x00060000),%o0
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! specification exception
t.cei1e:

	.section ".text"
	.align	4
	.global cf4_cdi,tf4_cdi,if4_cdi
cf4_cdi:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	c.cdi1c			!
	nop				!
    c.cdi0c:				!
	retl				! case even:
	add	%g0,t.cdi0e-t.cdi0s,%o0	!
    c.cdi1c:				!
	retl				! case odd:
	add	%g0,t.cdi1e-t.cdi1s,%o0	!   specification exception
tf4_cdi:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	t.cdi1t			!
	nop				!
    t.cdi0t:				!
	sethi	%hi(t.cdi0s),%o3	!
	or	%o3,%lo(t.cdi0s),%o3	!
	or	%g0,t.cdi0e-t.cdi0s,%o4	!
    t.cdi0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.cdi0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.cdi0o0-t.cdi0s],%o5
	srl	%o1,16,%o4		!
	andcc	%o4,0xf,%o4		! X2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+t.cdi0t0-t.cdi0s]
	ld	[%o3+t.cdi0o1-t.cdi0s],%o5
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.cdi0t1-t.cdi0s]
	ld	[%o3+t.cdi0o2-t.cdi0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+t.cdi0t2-t.cdi0s]
	retl				!
	add	%o0,t.cdi0e-t.cdi0s,%o0	!
    t.cdi1t:				!
	sethi	%hi(t.cdi1s),%o3	!
	or	%o3,%lo(t.cdi1s),%o3	!
	or	%g0,t.cdi1e-t.cdi1s,%o4	!
    t.cdi1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.cdi1cp		!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,t.cdi1e-t.cdi1s,%o0	!
if4_cdi:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	t.cdi1s			!
	nop				!
    i.cdi0t:				!
	srl	%o1,16,%o4		! X2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l2		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l2		! %l2
	srl	%o1,12,%o4		! B2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l3		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l3		! %l3
	and	%o1,0xfff,%l4		! D2
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	add	%o4,64,%i0		! %i0
t.cdi0s:
		ld	[%sp+184],%o0	! struct *guest
		add	%o0,768,%o1	! call library in fltlib.s
    t.cdi0t2:	ldd	[%o0+%i0],%o2	! ##TEMPLATE:%imm
		stx	%g1,[%o0+648]	!
		stx	%g2,[%o0+656]	!
		stx	%g3,[%o0+664]	!
		stx	%g4,[%o0+672]	!
		stx	%g5,[%o0+680]	!
		sethi	%hi(fl_conv_float2int),%o7
		jmpl	%o7+%lo(fl_conv_float2int),%o7
		and	%g7,0xf,%o4	! give Program Mask
		ld	[%sp+184],%o7	! struct *guest
		ldx	[%o7+648],%g1	!
		ldx	[%o7+656],%g2	!
		ldx	[%o7+664],%g3	!
		ldx	[%o7+672],%g4	!
		ldx	[%o7+680],%g5	!
		ld	[%o7+768],%o1	!
    t.cdi0t0:	add	%l2,%l3,%o2	! ##TEMPLATE:%l0,%l0
    t.cdi0t1:	add	%o2,%l4,%o2	! ##TEMPLATE:imm0
		and	%o2,%g3,%o2	! mask address
		st	%o1,[%g4+%o2]	! store integer
		and	%o0,3,%g1	! CC=retval
		sethi	%hi(0x00ff0000),%o1
		andcc	%o0,%o1,%o0	! extract exception
		bz,a	t.cdi0e		!   exit
		add	%g2,4,%g2	! update IAR
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! INTR-CODE=retval
t.cdi0e:
		ba	break0		!
		nop			!
    t.cdi0o0:	add	%l0,%l0,%o2	! ##TEMPLATE:%l0,%l0
    t.cdi0o1:	add	%o2,0,%o2	! ##TEMPLATE:imm0
    t.cdi0o2:	ldd	[%o0+64],%o2	! ##TEMPLATE:%imm
t.cdi1s:
		sethi	%hi(0x00060000),%o0
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! specification exception
t.cdi1e:

	.section ".text"
	.align	4
	.global cf4_cie,tf4_cie,if4_cie
cf4_cie:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	c.cie1c			!
	nop				!
    c.cie0c:				!
	retl				! case even:
	add	%g0,t.cie0e-t.cie0s,%o0	!
    c.cie1c:				!
	retl				! case odd:
	add	%g0,t.cie1e-t.cie1s,%o0	!   specification exception
tf4_cie:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	t.cie1t			!
	nop				!
    t.cie0t:				!
	sethi	%hi(t.cie0s),%o3	!
	or	%o3,%lo(t.cie0s),%o3	!
	or	%g0,t.cie0e-t.cie0s,%o4	!
    t.cie0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.cie0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.cie0o0-t.cie0s],%o5
	srl	%o1,16,%o4		!
	andcc	%o4,0xf,%o4		! X2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+t.cie0t0-t.cie0s]
	ld	[%o3+t.cie0o1-t.cie0s],%o5
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.cie0t1-t.cie0s]
	ld	[%o3+t.cie0o2-t.cie0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+t.cie0t2-t.cie0s]
	retl				!
	add	%o0,t.cie0e-t.cie0s,%o0	!
    t.cie1t:				!
	sethi	%hi(t.cie1s),%o3	!
	or	%o3,%lo(t.cie1s),%o3	!
	or	%g0,t.cie1e-t.cie1s,%o4	!
    t.cie1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.cie1cp		!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,t.cie1e-t.cie1s,%o0	!
if4_cie:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	t.cie1s			!
	nop				!
    i.cie0t:				!
	srl	%o1,16,%o4		! X2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l2		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l2		! %l2
	srl	%o1,12,%o4		! B2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l3		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l3		! %l3
	and	%o1,0xfff,%l4		! D2
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	add	%o4,64,%i0		! %i0
t.cie0s:
		ld	[%sp+184],%o0	! struct *guest
    t.cie0t0:	add	%l2,%l3,%o1	! ##TEMPLATE:%l0,%l0
    t.cie0t1:	add	%o1,%l4,%o1	! ##TEMPLATE:imm0
		and	%o1,%g3,%o1	! mask address
		ld	[%g4+%o1],%o1	! load integer
		stx	%g1,[%o0+648]	!
		stx	%g2,[%o0+656]	!
		stx	%g3,[%o0+664]	!
		stx	%g4,[%o0+672]	!
		stx	%g5,[%o0+680]	!
		sethi	%hi(fl_conv_int2float),%o7
		jmpl	%o7+%lo(fl_conv_int2float),%o7
		add	%o0,768,%o2	! call library in fltlib.s
		ld	[%sp+184],%o7	! struct *guest
		ldx	[%o7+648],%g1	!
		ldx	[%o7+656],%g2	!
		ldx	[%o7+664],%g3	!
		ldx	[%o7+672],%g4	!
		ldx	[%o7+680],%g5	!
		ld	[%o7+768],%o2	!
    t.cie0t2:	st	%o2,[%o7+%i0]	! ##TEMPLATE:%imm
		and	%o0,3,%g1	! CC=retval
		add	%g2,4,%g2	! update IAR
t.cie0e:
		ba	break0		!
		nop			!
    t.cie0o0:	add	%l0,%l0,%o1	! ##TEMPLATE:%l0,%l0
    t.cie0o1:	add	%o1,0,%o1	! ##TEMPLATE:imm0
    t.cie0o2:	st	%o2,[%o7+64]	! ##TEMPLATE:%imm
t.cie1s:
		sethi	%hi(0x00060000),%o0
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! specification exception
t.cie1e:

	.section ".text"
	.align	4
	.global cf4_cid,tf4_cid,if4_cid
cf4_cid:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	c.cid1c			!
	nop				!
    c.cid0c:				!
	retl				! case even:
	add	%g0,t.cid0e-t.cid0s,%o0	!
    c.cid1c:				!
	retl				! case odd:
	add	%g0,t.cid1e-t.cid1s,%o0	!   specification exception
tf4_cid:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	t.cid1t			!
	nop				!
    t.cid0t:				!
	sethi	%hi(t.cid0s),%o3	!
	or	%o3,%lo(t.cid0s),%o3	!
	or	%g0,t.cid0e-t.cid0s,%o4	!
    t.cid0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.cid0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.cid0o0-t.cid0s],%o5
	srl	%o1,16,%o4		!
	andcc	%o4,0xf,%o4		! X2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+t.cid0t0-t.cid0s]
	ld	[%o3+t.cid0o1-t.cid0s],%o5
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.cid0t1-t.cid0s]
	ld	[%o3+t.cid0o2-t.cid0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+t.cid0t2-t.cid0s]
	retl				!
	add	%o0,t.cid0e-t.cid0s,%o0	!
    t.cid1t:				!
	sethi	%hi(t.cid1s),%o3	!
	or	%o3,%lo(t.cid1s),%o3	!
	or	%g0,t.cid1e-t.cid1s,%o4	!
    t.cid1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.cid1cp		!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,t.cid1e-t.cid1s,%o0	!
if4_cid:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	t.cid1s			!
	nop				!
    i.cid0t:				!
	srl	%o1,16,%o4		! X2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l2		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l2		! %l2
	srl	%o1,12,%o4		! B2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l3		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l3		! %l3
	and	%o1,0xfff,%l4		! D2
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	add	%o4,64,%i0		! %i0
t.cid0s:
		ld	[%sp+184],%o0	! struct *guest
    t.cid0t0:	add	%l2,%l3,%o1	! ##TEMPLATE:%l0,%l0
    t.cid0t1:	add	%o1,%l4,%o1	! ##TEMPLATE:imm0
		and	%o1,%g3,%o1	! mask address
		ld	[%g4+%o1],%o1	! load integer
		stx	%g1,[%o0+648]	!
		stx	%g2,[%o0+656]	!
		stx	%g3,[%o0+664]	!
		stx	%g4,[%o0+672]	!
		stx	%g5,[%o0+680]	!
		sethi	%hi(fl_conv_int2float),%o7
		jmpl	%o7+%lo(fl_conv_int2float),%o7
		add	%o0,768,%o2	! call library in fltlib.s
		ld	[%sp+184],%o7	! struct *guest
		ldx	[%o7+648],%g1	!
		ldx	[%o7+656],%g2	!
		ldx	[%o7+664],%g3	!
		ldx	[%o7+672],%g4	!
		ldx	[%o7+680],%g5	!
		ldd	[%o7+768],%o2	!
    t.cid0t2:	std	%o2,[%o7+%i0]	! ##TEMPLATE:%imm
		and	%o0,3,%g1	! CC=retval
		add	%g2,4,%g2	! update IAR
t.cid0e:
		ba	break0		!
		nop			!
    t.cid0o0:	add	%l0,%l0,%o1	! ##TEMPLATE:%l0,%l0
    t.cid0o1:	add	%o1,0,%o1	! ##TEMPLATE:imm0
    t.cid0o2:	std	%o2,[%o7+64]	! ##TEMPLATE:%imm
t.cid1s:
		sethi	%hi(0x00060000),%o0
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! specification exception
t.cid1e:

	.section ".text"
	.align	4
	.global cf4_le,tf4_le,if4_le
cf4_le:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	c.le1c			!
	nop				!
    c.le0c:				!
	retl				! case even:
	add	%g0,t.le0e-t.le0s,%o0	!
    c.le1c:				!
	retl				! case odd:
	add	%g0,t.le1e-t.le1s,%o0	!   specification exception
tf4_le:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	t.le1t			!
	nop				!
    t.le0t:				!
	sethi	%hi(t.le0s),%o3		!
	or	%o3,%lo(t.le0s),%o3	!
	or	%g0,t.le0e-t.le0s,%o4	!
    t.le0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.le0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.le0o0-t.le0s],%o5!
	srl	%o1,16,%o4		!
	andcc	%o4,0xf,%o4		! X2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+t.le0t0-t.le0s]!
	ld	[%o3+t.le0o1-t.le0s],%o5!
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.le0t1-t.le0s]!
	ld	[%o3+t.le0o2-t.le0s],%o5!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+t.le0t2-t.le0s]!
	retl				!
	add	%o0,t.le0e-t.le0s,%o0	!
    t.le1t:				!
	sethi	%hi(t.le1s),%o3		!
	or	%o3,%lo(t.le1s),%o3	!
	or	%g0,t.le1e-t.le1s,%o4	!
    t.le1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.le1cp			!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,t.le1e-t.le1s,%o0	!
if4_le:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	t.le1s			!
	nop				!
    i.le0t:				!
	srl	%o1,16,%o4		! X2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l2		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l2		! %l2
	srl	%o1,12,%o4		! B2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l3		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l3		! %l3
	and	%o1,0xfff,%l4		! D2
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	add	%o4,64,%i0		! %i0
t.le0s:
		ld	[%sp+184],%o7	! struct *gcpu_s
    t.le0t0:	add	%l2,%l3,%o0	! ##TEMPLATE:%l0,%l0
    t.le0t1:	add	%o0,%l4,%o0	! ##TEMPLATE:imm0
		and	%o0,%g3,%o0	! mask address
		ld	[%g4+%o0],%o0	!
    t.le0t2:	st	%o0,[%o7+%i0]	! ##TEMPLATE:%imm
		add	%g2,4,%g2	! update IAR
t.le0e:
		ba	break0		!
		nop			!
    t.le0o0:	add	%l0,%l0,%o0	! ##TEMPLATE:%l0,%l0
    t.le0o1:	add	%o0,0,%o0	! ##TEMPLATE:imm0
    t.le0o2:	st	%o0,[%o7+64]	! ##TEMPLATE:%imm
t.le1s:
		sethi	%hi(0x00060000),%o0
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! specification exception
t.le1e:

	.section ".text"
	.align	4
	.global cf4_ce,tf4_ce,if4_ce
cf4_ce:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	c.ce1c			!
	nop				!
    c.ce0c:				!
	retl				! case even:
	add	%g0,t.ce0e-t.ce0s,%o0	!
    c.ce1c:				!
	retl				! case odd:
	add	%g0,t.ce1e-t.ce1s,%o0	!   specification exception
tf4_ce:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	t.ce1t			!
	nop				!
    t.ce0t:				!
	sethi	%hi(t.ce0s),%o3		!
	or	%o3,%lo(t.ce0s),%o3	!
	or	%g0,t.ce0e-t.ce0s,%o4	!
    t.ce0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.ce0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.ce0o0-t.ce0s],%o5!
	srl	%o1,16,%o4		!
	andcc	%o4,0xf,%o4		! X2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+t.ce0t0-t.ce0s]!
	ld	[%o3+t.ce0o1-t.ce0s],%o5!
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.ce0t1-t.ce0s]!
	ld	[%o3+t.ce0o2-t.ce0s],%o5!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+t.ce0t2-t.ce0s]!
	retl				!
	add	%o0,t.ce0e-t.ce0s,%o0	!
    t.ce1t:				!
	sethi	%hi(t.ce1s),%o3		!
	or	%o3,%lo(t.ce1s),%o3	!
	or	%g0,t.ce1e-t.ce1s,%o4	!
    t.ce1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.ce1cp			!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,t.ce1e-t.ce1s,%o0	!
if4_ce:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	t.ce1s			!
	nop				!
    i.ce0t:				!
	srl	%o1,16,%o4		! X2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l2		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l2		! %l2
	srl	%o1,12,%o4		! B2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l3		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l3		! %l3
	and	%o1,0xfff,%l4		! D2
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	add	%o4,64,%i0		! %i0
t.ce0s:
		ld	[%sp+184],%o0	! struct *gcpu_s
    t.ce0t0:	add	%l2,%l3,%o2	! ##TEMPLATE:%l0,%l0
    t.ce0t1:	add	%o2,%l4,%o2	! ##TEMPLATE:imm0
		and	%o2,%g3,%o2	! mask address
		add	%g4,%o2,%o2	!
		ld	[%o2],%o4	! get op#2
		st	%o4,[%o0+768]	! store op#2
		add	%o0,768,%o2	!
    t.ce0t2:	add	%o0,%i0,%o1	! ##TEMPLATE:%imm
		and	%g7,0xf,%o3	! give Program Mask
		stx	%g1,[%o0+648]	!
		stx	%g2,[%o0+656]	!
		stx	%g3,[%o0+664]	!
		stx	%g4,[%o0+672]	!
		stx	%g5,[%o0+680]	!
		sethi	%hi(fl_comp_short),%o7
		jmpl	%o7+%lo(fl_comp_short),%o7
		nop			! call library in fltlib.s
		ld	[%sp+184],%o7	! struct *gcpu_s
		ldx	[%o7+648],%g1	!
		ldx	[%o7+656],%g2	!
		ldx	[%o7+664],%g3	!
		ldx	[%o7+672],%g4	!
		ldx	[%o7+680],%g5	!
		and	%o0,3,%g1	! CC=retval
		add	%g2,4,%g2	! update IAR
t.ce0e:
		ba	break0		!
		nop			!
    t.ce0o0:	add	%l0,%l0,%o2	! ##TEMPLATE:%l0,%l0
    t.ce0o1:	add	%o2,0,%o2	! ##TEMPLATE:imm0
    t.ce0o2:	add	%o0,64,%o1	! ##TEMPLATE:%imm
t.ce1s:
		sethi	%hi(0x00060000),%o0
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! specification exception
t.ce1e:

	.section ".text"
	.align	4
	.global cf4_ae,tf4_ae,if4_ae
cf4_ae:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	c.ae1c			!
	nop				!
    c.ae0c:				!
	retl				! case even:
	add	%g0,t.ae0e-t.ae0s,%o0	!
    c.ae1c:				!
	retl				! case odd:
	add	%g0,t.ae1e-t.ae1s,%o0	!   specification exception
tf4_ae:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	t.ae1t			!
	nop				!
    t.ae0t:				!
	sethi	%hi(t.ae0s),%o3		!
	or	%o3,%lo(t.ae0s),%o3	!
	or	%g0,t.ae0e-t.ae0s,%o4	!
    t.ae0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.ae0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.ae0o0-t.ae0s],%o5!
	srl	%o1,16,%o4		!
	andcc	%o4,0xf,%o4		! X2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+t.ae0t0-t.ae0s]!
	ld	[%o3+t.ae0o1-t.ae0s],%o5!
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.ae0t1-t.ae0s]!
	ld	[%o3+t.ae0o2-t.ae0s],%o5!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+t.ae0t2-t.ae0s]!
	retl				!
	add	%o0,t.ae0e-t.ae0s,%o0	!
    t.ae1t:				!
	sethi	%hi(t.ae1s),%o3		!
	or	%o3,%lo(t.ae1s),%o3	!
	or	%g0,t.ae1e-t.ae1s,%o4	!
    t.ae1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.ae1cp			!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,t.ae1e-t.ae1s,%o0	!
if4_ae:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	t.ae1s			!
	nop				!
    i.ae0t:				!
	srl	%o1,16,%o4		! X2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l2		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l2		! %l2
	srl	%o1,12,%o4		! B2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l3		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l3		! %l3
	and	%o1,0xfff,%l4		! D2
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	add	%o4,64,%i0		! %i0
t.ae0s:
		ld	[%sp+184],%o0	! struct *gcpu_s
    t.ae0t0:	add	%l2,%l3,%o2	! ##TEMPLATE:%l0,%l0
    t.ae0t1:	add	%o2,%l4,%o2	! ##TEMPLATE:imm0
		and	%o2,%g3,%o2	! mask address
		add	%g4,%o2,%o2	!
		ld	[%o2],%o4	! get op#2
		st	%o4,[%o0+768]	! store op#2
		add	%o0,768,%o2	!
    t.ae0t2:	add	%o0,%i0,%o1	! ##TEMPLATE:%imm
		and	%g7,0xf,%o3	! give Program Mask
		stx	%g1,[%o0+648]	!
		stx	%g2,[%o0+656]	!
		stx	%g3,[%o0+664]	!
		stx	%g4,[%o0+672]	!
		stx	%g5,[%o0+680]	!
		sethi	%hi(fl_addsub_short_norm),%o7
		jmpl	%o7+%lo(fl_addsub_short_norm),%o7
		add	%g0,0,%o4	! call library in fltlib.s
		ld	[%sp+184],%o7	! struct *gcpu_s
		ldx	[%o7+648],%g1	!
		ldx	[%o7+656],%g2	!
		ldx	[%o7+664],%g3	!
		ldx	[%o7+672],%g4	!
		ldx	[%o7+680],%g5	!
		and	%o0,3,%g1	! CC=retval
		sethi	%hi(0x00ff0000),%o1
		andcc	%o0,%o1,%o0	! extract exception
		bz,a	t.ae0e		!   exit
		add	%g2,4,%g2	! update IAR
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! INTR-CODE=retval
t.ae0e:
		ba	break0		!
		nop			!
    t.ae0o0:	add	%l0,%l0,%o2	! ##TEMPLATE:%l0,%l0
    t.ae0o1:	add	%o2,0,%o2	! ##TEMPLATE:imm0
    t.ae0o2:	add	%o0,64,%o1	! ##TEMPLATE:%imm
t.ae1s:
		sethi	%hi(0x00060000),%o0
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! specification exception
t.ae1e:

	.section ".text"
	.align	4
	.global cf4_se,tf4_se,if4_se
cf4_se:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	c.se1c			!
	nop				!
    c.se0c:				!
	retl				! case even:
	add	%g0,t.se0e-t.se0s,%o0	!
    c.se1c:				!
	retl				! case odd:
	add	%g0,t.se1e-t.se1s,%o0	!   specification exception
tf4_se:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	t.se1t			!
	nop				!
    t.se0t:				!
	sethi	%hi(t.se0s),%o3		!
	or	%o3,%lo(t.se0s),%o3	!
	or	%g0,t.se0e-t.se0s,%o4	!
    t.se0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.se0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.se0o0-t.se0s],%o5!
	srl	%o1,16,%o4		!
	andcc	%o4,0xf,%o4		! X2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+t.se0t0-t.se0s]!
	ld	[%o3+t.se0o1-t.se0s],%o5!
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.se0t1-t.se0s]!
	ld	[%o3+t.se0o2-t.se0s],%o5!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+t.se0t2-t.se0s]!
	retl				!
	add	%o0,t.se0e-t.se0s,%o0	!
    t.se1t:				!
	sethi	%hi(t.se1s),%o3		!
	or	%o3,%lo(t.se1s),%o3	!
	or	%g0,t.se1e-t.se1s,%o4	!
    t.se1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.se1cp			!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,t.se1e-t.se1s,%o0	!
if4_se:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	t.se1s			!
	nop				!
    i.se0t:				!
	srl	%o1,16,%o4		! X2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l2		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l2		! %l2
	srl	%o1,12,%o4		! B2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l3		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l3		! %l3
	and	%o1,0xfff,%l4		! D2
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	add	%o4,64,%i0		! %i0
t.se0s:
		ld	[%sp+184],%o0	! struct *gcpu_s
    t.se0t0:	add	%l2,%l3,%o2	! ##TEMPLATE:%l0,%l0
    t.se0t1:	add	%o2,%l4,%o2	! ##TEMPLATE:imm0
		and	%o2,%g3,%o2	! mask address
		add	%g4,%o2,%o2	!
		ld	[%o2],%o4	! get op#2
		st	%o4,[%o0+768]	! store op#2
		add	%o0,768,%o2	!
    t.se0t2:	add	%o0,%i0,%o1	! ##TEMPLATE:%imm
		and	%g7,0xf,%o3	! give Program Mask
		stx	%g1,[%o0+648]	!
		stx	%g2,[%o0+656]	!
		stx	%g3,[%o0+664]	!
		stx	%g4,[%o0+672]	!
		stx	%g5,[%o0+680]	!
		sethi	%hi(fl_addsub_short_norm),%o7
		jmpl	%o7+%lo(fl_addsub_short_norm),%o7
		add	%g0,1,%o4	! call library in fltlib.s
		ld	[%sp+184],%o7	! struct *gcpu_s
		ldx	[%o7+648],%g1	!
		ldx	[%o7+656],%g2	!
		ldx	[%o7+664],%g3	!
		ldx	[%o7+672],%g4	!
		ldx	[%o7+680],%g5	!
		and	%o0,3,%g1	! CC=retval
		sethi	%hi(0x00ff0000),%o1
		andcc	%o0,%o1,%o0	! extract exception
		bz,a	t.se0e		!   exit
		add	%g2,4,%g2	! update IAR
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! INTR-CODE=retval
t.se0e:
		ba	break0		!
		nop			!
    t.se0o0:	add	%l0,%l0,%o2	! ##TEMPLATE:%l0,%l0
    t.se0o1:	add	%o2,0,%o2	! ##TEMPLATE:imm0
    t.se0o2:	add	%o0,64,%o1	! ##TEMPLATE:%imm
t.se1s:
		sethi	%hi(0x00060000),%o0
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! specification exception
t.se1e:

	.section ".text"
	.align	4
	.global cf4_me,tf4_me,if4_me
cf4_me:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	c.me1c			!
	nop				!
    c.me0c:				!
	retl				! case even:
	add	%g0,t.me0e-t.me0s,%o0	!
    c.me1c:				!
	retl				! case odd:
	add	%g0,t.me1e-t.me1s,%o0	!   specification exception
tf4_me:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	t.me1t			!
	nop				!
    t.me0t:				!
	sethi	%hi(t.me0s),%o3		!
	or	%o3,%lo(t.me0s),%o3	!
	or	%g0,t.me0e-t.me0s,%o4	!
    t.me0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.me0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.me0o0-t.me0s],%o5!
	srl	%o1,16,%o4		!
	andcc	%o4,0xf,%o4		! X2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+t.me0t0-t.me0s]!
	ld	[%o3+t.me0o1-t.me0s],%o5!
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.me0t1-t.me0s]!
	ld	[%o3+t.me0o2-t.me0s],%o5!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+t.me0t2-t.me0s]!
	retl				!
	add	%o0,t.me0e-t.me0s,%o0	!
    t.me1t:				!
	sethi	%hi(t.me1s),%o3		!
	or	%o3,%lo(t.me1s),%o3	!
	or	%g0,t.me1e-t.me1s,%o4	!
    t.me1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.me1cp			!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,t.me1e-t.me1s,%o0	!
if4_me:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	t.me1s			!
	nop				!
    i.me0t:				!
	srl	%o1,16,%o4		! X2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l2		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l2		! %l2
	srl	%o1,12,%o4		! B2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l3		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l3		! %l3
	and	%o1,0xfff,%l4		! D2
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	add	%o4,64,%i0		! %i0
t.me0s:
		ld	[%sp+184],%o0	! struct *gcpu_s
    t.me0t0:	add	%l2,%l3,%o2	! ##TEMPLATE:%l0,%l0
    t.me0t1:	add	%o2,%l4,%o2	! ##TEMPLATE:imm0
		and	%o2,%g3,%o2	! mask address
		add	%g4,%o2,%o2	!
		ld	[%o2],%o4	! get op#2
		st	%o4,[%o0+768]	! store op#2
		add	%o0,768,%o2	!
    t.me0t2:	add	%o0,%i0,%o1	! ##TEMPLATE:%imm
		and	%g7,0xf,%o3	! give Program Mask
		stx	%g1,[%o0+648]	!
		stx	%g2,[%o0+656]	!
		stx	%g3,[%o0+664]	!
		stx	%g4,[%o0+672]	!
		stx	%g5,[%o0+680]	!
		sethi	%hi(fl_mult_short2long),%o7
		jmpl	%o7+%lo(fl_mult_short2long),%o7
		nop			! call library in fltlib.s
		ld	[%sp+184],%o7	! struct *gcpu_s
		ldx	[%o7+648],%g1	!
		ldx	[%o7+656],%g2	!
		ldx	[%o7+664],%g3	!
		ldx	[%o7+672],%g4	!
		ldx	[%o7+680],%g5	!
		sethi	%hi(0x00ff0000),%o1
		andcc	%o0,%o1,%o0	! extract exception
		bz,a	t.me0e		!   exit
		add	%g2,4,%g2	! update IAR
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! INTR-CODE=retval
t.me0e:
		ba	break0		!
		nop			!
    t.me0o0:	add	%l0,%l0,%o2	! ##TEMPLATE:%l0,%l0
    t.me0o1:	add	%o2,0,%o2	! ##TEMPLATE:imm0
    t.me0o2:	add	%o0,64,%o1	! ##TEMPLATE:%imm
t.me1s:
		sethi	%hi(0x00060000),%o0
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! specification exception
t.me1e:

	.section ".text"
	.align	4
	.global cf4_de,tf4_de,if4_de
cf4_de:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	c.de1c			!
	nop				!
    c.de0c:				!
	retl				! case even:
	add	%g0,t.de0e-t.de0s,%o0	!
    c.de1c:				!
	retl				! case odd:
	add	%g0,t.de1e-t.de1s,%o0	!   specification exception
tf4_de:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	t.de1t			!
	nop				!
    t.de0t:				!
	sethi	%hi(t.de0s),%o3		!
	or	%o3,%lo(t.de0s),%o3	!
	or	%g0,t.de0e-t.de0s,%o4	!
    t.de0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.de0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.de0o0-t.de0s],%o5!
	srl	%o1,16,%o4		!
	andcc	%o4,0xf,%o4		! X2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+t.de0t0-t.de0s]!
	ld	[%o3+t.de0o1-t.de0s],%o5!
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.de0t1-t.de0s]!
	ld	[%o3+t.de0o2-t.de0s],%o5!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+t.de0t2-t.de0s]!
	retl				!
	add	%o0,t.de0e-t.de0s,%o0	!
    t.de1t:				!
	sethi	%hi(t.de1s),%o3		!
	or	%o3,%lo(t.de1s),%o3	!
	or	%g0,t.de1e-t.de1s,%o4	!
    t.de1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.de1cp			!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,t.de1e-t.de1s,%o0	!
if4_de:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	t.de1s			!
	nop				!
    i.de0t:				!
	srl	%o1,16,%o4		! X2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l2		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l2		! %l2
	srl	%o1,12,%o4		! B2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l3		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l3		! %l3
	and	%o1,0xfff,%l4		! D2
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	add	%o4,64,%i0		! %i0
t.de0s:
		ld	[%sp+184],%o0	! struct *gcpu_s
    t.de0t0:	add	%l2,%l3,%o2	! ##TEMPLATE:%l0,%l0
    t.de0t1:	add	%o2,%l4,%o2	! ##TEMPLATE:imm0
		and	%o2,%g3,%o2	! mask address
		add	%g4,%o2,%o2	!
		ld	[%o2],%o4	! get op#2
		st	%o4,[%o0+768]	! store op#2
		add	%o0,768,%o2	!
    t.de0t2:	add	%o0,%i0,%o1	! ##TEMPLATE:%imm
		and	%g7,0xf,%o3	! give Program Mask
		stx	%g1,[%o0+648]	!
		stx	%g2,[%o0+656]	!
		stx	%g3,[%o0+664]	!
		stx	%g4,[%o0+672]	!
		stx	%g5,[%o0+680]	!
		sethi	%hi(fl_div_short),%o7
		jmpl	%o7+%lo(fl_div_short),%o7
		nop			! call library in fltlib.s
		ld	[%sp+184],%o7	! struct *gcpu_s
		ldx	[%o7+648],%g1	!
		ldx	[%o7+656],%g2	!
		ldx	[%o7+664],%g3	!
		ldx	[%o7+672],%g4	!
		ldx	[%o7+680],%g5	!
		sethi	%hi(0x00ff0000),%o1
		andcc	%o0,%o1,%o0	! extract exception
		bz,a	t.de0e		!   exit
		add	%g2,4,%g2	! update IAR
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! INTR-CODE=retval
t.de0e:
		ba	break0		!
		nop			!
    t.de0o0:	add	%l0,%l0,%o2	! ##TEMPLATE:%l0,%l0
    t.de0o1:	add	%o2,0,%o2	! ##TEMPLATE:imm0
    t.de0o2:	add	%o0,64,%o1	! ##TEMPLATE:%imm
t.de1s:
		sethi	%hi(0x00060000),%o0
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! specification exception
t.de1e:

	.section ".text"
	.align	4
	.global cf4_au,tf4_au,if4_au
cf4_au:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	c.au1c			!
	nop				!
    c.au0c:				!
	retl				! case even:
	add	%g0,t.au0e-t.au0s,%o0	!
    c.au1c:				!
	retl				! case odd:
	add	%g0,t.au1e-t.au1s,%o0	!   specification exception
tf4_au:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	t.au1t			!
	nop				!
    t.au0t:				!
	sethi	%hi(t.au0s),%o3		!
	or	%o3,%lo(t.au0s),%o3	!
	or	%g0,t.au0e-t.au0s,%o4	!
    t.au0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.au0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.au0o0-t.au0s],%o5!
	srl	%o1,16,%o4		!
	andcc	%o4,0xf,%o4		! X2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+t.au0t0-t.au0s]!
	ld	[%o3+t.au0o1-t.au0s],%o5!
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.au0t1-t.au0s]!
	ld	[%o3+t.au0o2-t.au0s],%o5!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+t.au0t2-t.au0s]!
	retl				!
	add	%o0,t.au0e-t.au0s,%o0	!
    t.au1t:				!
	sethi	%hi(t.au1s),%o3		!
	or	%o3,%lo(t.au1s),%o3	!
	or	%g0,t.au1e-t.au1s,%o4	!
    t.au1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.au1cp			!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,t.au1e-t.au1s,%o0	!
if4_au:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	t.au1s			!
	nop				!
    i.au0t:				!
	srl	%o1,16,%o4		! X2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l2		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l2		! %l2
	srl	%o1,12,%o4		! B2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l3		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l3		! %l3
	and	%o1,0xfff,%l4		! D2
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	add	%o4,64,%i0		! %i0
t.au0s:
		ld	[%sp+184],%o0	! struct *gcpu_s
    t.au0t0:	add	%l2,%l3,%o2	! ##TEMPLATE:%l0,%l0
    t.au0t1:	add	%o2,%l4,%o2	! ##TEMPLATE:imm0
		and	%o2,%g3,%o2	! mask address
		add	%g4,%o2,%o2	!
		ld	[%o2],%o4	! get op#2
		st	%o4,[%o0+768]	! store op#2
		add	%o0,768,%o2	!
    t.au0t2:	add	%o0,%i0,%o1	! ##TEMPLATE:%imm
		and	%g7,0xf,%o3	! give Program Mask
		stx	%g1,[%o0+648]	!
		stx	%g2,[%o0+656]	!
		stx	%g3,[%o0+664]	!
		stx	%g4,[%o0+672]	!
		stx	%g5,[%o0+680]	!
		sethi	%hi(fl_addsub_short_unnorm),%o7
		jmpl	%o7+%lo(fl_addsub_short_unnorm),%o7
		add	%g0,0,%o4	! call library in fltlib.s
		ld	[%sp+184],%o7	! struct *gcpu_s
		ldx	[%o7+648],%g1	!
		ldx	[%o7+656],%g2	!
		ldx	[%o7+664],%g3	!
		ldx	[%o7+672],%g4	!
		ldx	[%o7+680],%g5	!
		and	%o0,3,%g1	! CC=retval
		sethi	%hi(0x00ff0000),%o1
		andcc	%o0,%o1,%o0	! extract exception
		bz,a	t.au0e		!   exit
		add	%g2,4,%g2	! update IAR
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! INTR-CODE=retval
t.au0e:
		ba	break0		!
		nop			!
    t.au0o0:	add	%l0,%l0,%o2	! ##TEMPLATE:%l0,%l0
    t.au0o1:	add	%o2,0,%o2	! ##TEMPLATE:imm0
    t.au0o2:	add	%o0,64,%o1	! ##TEMPLATE:%imm
t.au1s:
		sethi	%hi(0x00060000),%o0
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! specification exception
t.au1e:

	.section ".text"
	.align	4
	.global cf4_su,tf4_su,if4_su
cf4_su:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	c.su1c			!
	nop				!
    c.su0c:				!
	retl				! case even:
	add	%g0,t.su0e-t.su0s,%o0	!
    c.su1c:				!
	retl				! case odd:
	add	%g0,t.su1e-t.su1s,%o0	!   specification exception
tf4_su:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	t.su1t			!
	nop				!
    t.su0t:				!
	sethi	%hi(t.su0s),%o3		!
	or	%o3,%lo(t.su0s),%o3	!
	or	%g0,t.su0e-t.su0s,%o4	!
    t.su0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.su0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.su0o0-t.su0s],%o5!
	srl	%o1,16,%o4		!
	andcc	%o4,0xf,%o4		! X2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+t.su0t0-t.su0s]!
	ld	[%o3+t.su0o1-t.su0s],%o5!
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.su0t1-t.su0s]!
	ld	[%o3+t.su0o2-t.su0s],%o5!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+t.su0t2-t.su0s]!
	retl				!
	add	%o0,t.su0e-t.su0s,%o0	!
    t.su1t:				!
	sethi	%hi(t.su1s),%o3		!
	or	%o3,%lo(t.su1s),%o3	!
	or	%g0,t.su1e-t.su1s,%o4	!
    t.su1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.su1cp			!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,t.su1e-t.su1s,%o0	!
if4_su:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	t.su1s			!
	nop				!
    i.su0t:				!
	srl	%o1,16,%o4		! X2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l2		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l2		! %l2
	srl	%o1,12,%o4		! B2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l3		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l3		! %l3
	and	%o1,0xfff,%l4		! D2
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	add	%o4,64,%i0		! %i0
t.su0s:
		ld	[%sp+184],%o0	! struct *gcpu_s
    t.su0t0:	add	%l2,%l3,%o2	! ##TEMPLATE:%l0,%l0
    t.su0t1:	add	%o2,%l4,%o2	! ##TEMPLATE:imm0
		and	%o2,%g3,%o2	! mask address
		add	%g4,%o2,%o2	!
		ld	[%o2],%o4	! get op#2
		st	%o4,[%o0+768]	! store op#2
		add	%o0,768,%o2	!
    t.su0t2:	add	%o0,%i0,%o1	! ##TEMPLATE:%imm
		and	%g7,0xf,%o3	! give Program Mask
		stx	%g1,[%o0+648]	!
		stx	%g2,[%o0+656]	!
		stx	%g3,[%o0+664]	!
		stx	%g4,[%o0+672]	!
		stx	%g5,[%o0+680]	!
		sethi	%hi(fl_addsub_short_unnorm),%o7
		jmpl	%o7+%lo(fl_addsub_short_unnorm),%o7
		add	%g0,1,%o4	! call library in fltlib.s
		ld	[%sp+184],%o7	! struct *gcpu_s
		ldx	[%o7+648],%g1	!
		ldx	[%o7+656],%g2	!
		ldx	[%o7+664],%g3	!
		ldx	[%o7+672],%g4	!
		ldx	[%o7+680],%g5	!
		and	%o0,3,%g1	! CC=retval
		sethi	%hi(0x00ff0000),%o1
		andcc	%o0,%o1,%o0	! extract exception
		bz,a	t.su0e		!   exit
		add	%g2,4,%g2	! update IAR
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! INTR-CODE=retval
t.su0e:
		ba	break0		!
		nop			!
    t.su0o0:	add	%l0,%l0,%o2	! ##TEMPLATE:%l0,%l0
    t.su0o1:	add	%o2,0,%o2	! ##TEMPLATE:imm0
    t.su0o2:	add	%o0,64,%o1	! ##TEMPLATE:%imm
t.su1s:
		sethi	%hi(0x00060000),%o0
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! specification exception
t.su1e:
!================================

!
! templates
! cxx_xxx:
!   %o0: param: none
!	 retval:size of template
!   %o1: M instruction (4 bytes)
!   %o2: work
!   %o3: work
!   %o4: work
!   %o5: work
! txx_xxx:
!   %o0: param: bufp start address
!	 retval:bufp next start address
!   %o1: M instruction (4 bytes)
!   %o2: work
!   %o3: work
!   %o4: work
!   %o5: work
!
	.section ".text"
	.align	4
	.global cc4_ssm,tc4_ssm,ic4_ssm
cc4_ssm:
	retl				!
	add	%g0,t.ssm0e-t.ssm0s,%o0	!
tc4_ssm:
	sethi	%hi(t.ssm0s),%o3	!
	or	%o3,%lo(t.ssm0s),%o3	!
	or	%g0,t.ssm0e-t.ssm0s,%o4	!
    t.ssm0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.ssm0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.ssm0o0-t.ssm0s],%o5
	srl	%o1,10,%o4		!
	or	%o5,%o4,%o5		! simm22
	st	%o5,[%o0+t.ssm0t0-t.ssm0s]
	ld	[%o3+t.ssm0o1-t.ssm0s],%o5
	and	%o1,0xfff,%o4		!
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.ssm0t1-t.ssm0s]
	retl				!
	add	%o0,t.ssm0e-t.ssm0s,%o0	!
ic4_ssm:
t.ssm0s:
		ld	[%sp+184],%o7	! struct *gcpu_s
    t.ssm0t0:	sethi	0,%o0		! ##TEMPLATE:imm
    t.ssm0t1:	or	%o1,0,%o0	! ##TEMPLATE:imm
		st	%o0,[%o7+704]	! store minsn (upper)
		st	%g0,[%o7+708]	! store minsn (lower)
		sethi	%hi(0x80000000),%o0
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! Special Instruction (FC=2)
t.ssm0e:
    t.ssm0o0:	sethi	0,%o0		! ##TEMPLATE:imm
    t.ssm0o1:	or	%o0,0,%o0	! ##TEMPLATE:imm

	.section ".text"
	.align	4
	.global cc4_lpsw,tc4_lpsw,ic4_lpsw
cc4_lpsw:
	retl				!
	add	%g0,t.lpsw0e-t.lpsw0s,%o0
tc4_lpsw:
	sethi	%hi(t.lpsw0s),%o3	!
	or	%o3,%lo(t.lpsw0s),%o3	!
	or	%g0,t.lpsw0e-t.lpsw0s,%o4
    t.lpsw0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.lpsw0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.lpsw0o0-t.lpsw0s],%o5
	srl	%o1,10,%o4		!
	or	%o5,%o4,%o5		! simm22
	st	%o5,[%o0+t.lpsw0t0-t.lpsw0s]
	ld	[%o3+t.lpsw0o1-t.lpsw0s],%o5
	and	%o1,0xfff,%o4		!
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.lpsw0t1-t.lpsw0s]
	retl				!
	add	%o0,t.lpsw0e-t.lpsw0s,%o0
ic4_lpsw:
t.lpsw0s:
		ld	[%sp+184],%o7	! struct *gcpu_s
    t.lpsw0t0:	sethi	0,%o0		! ##TEMPLATE:imm
    t.lpsw0t1:	or	%o1,0,%o0	! ##TEMPLATE:imm
		st	%o0,[%o7+704]	! store minsn (upper)
		st	%g0,[%o7+708]	! store minsn (lower)
		sethi	%hi(0x80000000),%o0
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! Special Instruction (FC=2)
t.lpsw0e:
    t.lpsw0o0:	sethi	0,%o0		! ##TEMPLATE:imm
    t.lpsw0o1:	or	%o0,0,%o0	! ##TEMPLATE:imm

	.section ".text"
	.align	4
	.global cc4_diag,tc4_diag,ic4_diag
cc4_diag:
	retl				!
	add	%g0,t.diag0e-t.diag0s,%o0
tc4_diag:
	sethi	%hi(t.diag0s),%o3	!
	or	%o3,%lo(t.diag0s),%o3	!
	or	%g0,t.diag0e-t.diag0s,%o4
    t.diag0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.diag0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.diag0o0-t.diag0s],%o5
	srl	%o1,10,%o4		!
	or	%o5,%o4,%o5		! simm22
	st	%o5,[%o0+t.diag0t0-t.diag0s]
	ld	[%o3+t.diag0o1-t.diag0s],%o5
	and	%o1,0xfff,%o4		!
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.diag0t1-t.diag0s]
	retl				!
	add	%o0,t.diag0e-t.diag0s,%o0
ic4_diag:
t.diag0s:
		ld	[%sp+184],%o7	! struct *gcpu_s
    t.diag0t0:	sethi	0,%o0		! ##TEMPLATE:imm
    t.diag0t1:	or	%o1,0,%o0	! ##TEMPLATE:imm
		st	%o0,[%o7+704]	! store minsn (upper)
		st	%g0,[%o7+708]	! store minsn (lower)
		sethi	%hi(0x80000000),%o0
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! Special Instruction (FC=2)
t.diag0e:
    t.diag0o0:	sethi	0,%o0		! ##TEMPLATE:imm
    t.diag0o1:	or	%o0,0,%o0	! ##TEMPLATE:imm

	.section ".text"
	.align	4
	.global ci4_bxh,ti4_bxh,ii4_bxh
ci4_bxh:
	srl	%o1,16,%o3		! switch (R3)
	andcc	%o3,1,%g0		!
	bnz	c.bxh1c			!
	nop				!
    c.bxh0c:				!
	retl				! case even:
	add	%g0,t.bxh0e-t.bxh0s,%o0	!   inc:R3, cmp:R3+1
    c.bxh1c:				!
	retl				! case odd:
	add	%g0,t.bxh1e-t.bxh1s,%o0	!   inc:R3, cmp:R3
ti4_bxh:
	srl	%o1,16,%o3		! switch (R3)
	andcc	%o3,1,%g0		!
	bnz	t.bxh1t			!
	nop				!
    t.bxh0t:				!
	sethi	%hi(t.bxh0s),%o3	!
	or	%o3,%lo(t.bxh0s),%o3	!
	or	%g0,t.bxh0e-t.bxh0s,%o4	!
    t.bxh0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.bxh0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.bxh0o0-t.bxh0s],%o5
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.bxh0t0-t.bxh0s]
	ld	[%o3+t.bxh0o1-t.bxh0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R3+1
	add	%o4,1,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	st	%o5,[%o0+t.bxh0t1-t.bxh0s]
	ld	[%o3+t.bxh0o2-t.bxh0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R3
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	sll	%o4,11,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+t.bxh0t2-t.bxh0s]
	ld	[%o3+t.bxh0o3-t.bxh0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+t.bxh0t3-t.bxh0s]
	retl				!
	add	%o0,t.bxh0e-t.bxh0s,%o0	!
    t.bxh1t:				!
	sethi	%hi(t.bxh1s),%o3	!
	or	%o3,%lo(t.bxh1s),%o3	!
	or	%g0,t.bxh1e-t.bxh1s,%o4	!
    t.bxh1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.bxh1cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.bxh1o0-t.bxh1s],%o5
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.bxh1t0-t.bxh1s]
	ld	[%o3+t.bxh1o1-t.bxh1s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R3
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	st	%o5,[%o0+t.bxh1t1-t.bxh1s]
	ld	[%o3+t.bxh1o2-t.bxh1s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R3
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	sll	%o4,11,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+t.bxh1t2-t.bxh1s]
	ld	[%o3+t.bxh1o3-t.bxh1s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+t.bxh1t3-t.bxh1s]
	retl				!
	add	%o0,t.bxh1e-t.bxh1s,%o0	!
t.bxh0s:
    t.bxh0t0:	add	%l0,0,%o0	! ##TEMPLATE:%l0,imm0
    t.bxh0t1:	add	%g0,%l0,%o1	! ##TEMPLATE:%l0 R3+1
    t.bxh0t2:	add	%l0,%l0,%l0	! ##TEMPLATE:%l0,%l0,%l0 R1,R3,R1
    t.bxh0t3:	subcc	%l0,%o1,%g0	! ##TEMPLATE:%l0 R1
		ble,a	t.bxh0e		! if %l0 > %o1 then taken
		add	%g2,4,%g2	! update IAR
		add	%g2,%g0,%o5	! save OPC
		sethi	%hi(break2),%o7	! BRANCH TAKEN
		jmpl	%o7+%lo(break2),%g0
		add	%g0,%o0,%g2	!
t.bxh0e:
    t.bxh0o0:	add	%l0,0,%o0	! ##TEMPLATE:%l0,imm0
    t.bxh0o1:	add	%g0,%l0,%o1	! ##TEMPLATE:%l0 R3+1
    t.bxh0o2:	add	%l0,%l0,%l0	! ##TEMPLATE:%l0,%l0,%l0 R1,R3,R1
    t.bxh0o3:	subcc	%l0,%o1,%g0	! ##TEMPLATE:%l0 R1
t.bxh1s:
    t.bxh1t0:	add	%l0,0,%o0	! ##TEMPLATE:%l0,imm0
    t.bxh1t1:	add	%g0,%l0,%o1	! ##TEMPLATE:%l0 R3
    t.bxh1t2:	add	%l0,%l0,%l0	! ##TEMPLATE:%l0,%l0,%l0 R1,R3,R1
    t.bxh1t3:	subcc	%l0,%o1,%g0	! ##TEMPLATE:%l0 R1
		ble,a	t.bxh1e		! if %l0 > %o1 then taken
		add	%g2,4,%g2	! update IAR
		add	%g2,%g0,%o5	! save OPC
		sethi	%hi(break2),%o7	! BRANCH TAKEN
		jmpl	%o7+%lo(break2),%g0
		add	%g0,%o0,%g2	!
t.bxh1e:
    t.bxh1o0:	add	%l0,0,%o0	! ##TEMPLATE:%l0,imm0
    t.bxh1o1:	add	%g0,%l0,%o1	! ##TEMPLATE:%l0 R3
    t.bxh1o2:	add	%l0,%l0,%l0	! ##TEMPLATE:%l0,%l0,%l0 R1,R3,R1
    t.bxh1o3:	subcc	%l0,%o1,%g0	! ##TEMPLATE:%l0 R1
ii4_bxh:
	srl	%o1,16,%o3		! switch (R3)
	andcc	%o3,1,%g0		!
	bnz	i.bxh1t			!
	nop				!
    i.bxh0t:				!
	srl	%o1,12,%o4		! B2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l3		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l3		! %l3
	and	%o1,0xfff,%l4		! D2
	srl	%o1,16,%o4		! R3
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l1		! %l1
	srl	%o1,16,%o4		! R3+1
	and	%o4,0xf,%o4		! |
	add	%o4,1,%o4		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l2		! %l2
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%i0		! save as %i0
	ld	[%o7+%i0],%l0		! %l0
	ba	i.bxh0s			!
	nop				!
    i.bxh1t:				!
	srl	%o1,12,%o4		! B2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l3		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l3		! %l3
	and	%o1,0xfff,%l4		! D2
	srl	%o1,16,%o4		! R3
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l1		! %l1
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%i0		! save as %i0
	ld	[%o7+%i0],%l0		! %l0
	ba	i.bxh1s			!
	nop				!
i.bxh0s:
    i.bxh0t0:	add	%l3,%l4,%o0	! ##TEMPLATE:%l0,imm0
    i.bxh0t1:	add	%g0,%l2,%o1	! ##TEMPLATE:%l0 R3+1
    i.bxh0t2:	add	%l0,%l1,%l0	! ##TEMPLATE:%l0,%l0,%l0 R1,R3,R1
		st	%l0,[%o7+%i0]	! R1
    i.bxh0t3:	subcc	%l0,%o1,%g0	! ##TEMPLATE:%l0 R1
		ble,a	break0		! if %l0 > %o1 then taken
		add	%g2,4,%g2	! update IAR
		add	%g2,%g0,%o5	! save OPC
		ba	break1		! BRANCH TAKEN
		add	%g0,%o0,%g2	!
i.bxh0e:
i.bxh1s:
    i.bxh1t0:	add	%l3,%l4,%o0	! ##TEMPLATE:%l0,imm0
    i.bxh1t1:	add	%g0,%l1,%o1	! ##TEMPLATE:%l0 R3
    i.bxh1t2:	add	%l0,%l1,%l0	! ##TEMPLATE:%l0,%l0,%l0 R1,R3,R1
		st	%l0,[%o7+%i0]	! R1
    i.bxh1t3:	subcc	%l0,%o1,%g0	! ##TEMPLATE:%l0 R1
		ble,a	break0		! if %l0 > %o1 then taken
		add	%g2,4,%g2	! update IAR
		add	%g2,%g0,%o5	! save OPC
		ba	break1		! BRANCH TAKEN
		add	%g0,%o0,%g2	!
i.bxh1e:

	.section ".text"
	.align	4
	.global ci4_bxle,ti4_bxle,ii4_bxle
ci4_bxle:
	srl	%o1,16,%o3		! switch (R3)
	andcc	%o3,1,%g0		!
	bnz	c.bxle1c		!
	nop				!
    c.bxle0c:				!
	retl				! case even:
	add	%g0,t.bxle0e-t.bxle0s,%o0
    c.bxle1c:				!
	retl				! case odd:
	add	%g0,t.bxle1e-t.bxle1s,%o0
ti4_bxle:
	srl	%o1,16,%o3		! switch (R3)
	andcc	%o3,1,%g0		!
	bnz	t.bxle1t		!
	nop				!
    t.bxle0t:				!
	sethi	%hi(t.bxle0s),%o3	!
	or	%o3,%lo(t.bxle0s),%o3	!
	or	%g0,t.bxle0e-t.bxle0s,%o4
    t.bxle0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.bxle0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.bxle0o0-t.bxle0s],%o5
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.bxle0t0-t.bxle0s]
	ld	[%o3+t.bxle0o1-t.bxle0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R3+1
	add	%o4,1,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	st	%o5,[%o0+t.bxle0t1-t.bxle0s]
	ld	[%o3+t.bxle0o2-t.bxle0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R3
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	sll	%o4,11,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+t.bxle0t2-t.bxle0s]
	ld	[%o3+t.bxle0o3-t.bxle0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+t.bxle0t3-t.bxle0s]
	retl				!
	add	%o0,t.bxle0e-t.bxle0s,%o0
    t.bxle1t:				!
	sethi	%hi(t.bxle1s),%o3	!
	or	%o3,%lo(t.bxle1s),%o3	!
	or	%g0,t.bxle1e-t.bxle1s,%o4
    t.bxle1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.bxle1cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.bxle1o0-t.bxle1s],%o5
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.bxle1t0-t.bxle1s]
	ld	[%o3+t.bxle1o1-t.bxle1s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R3
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	st	%o5,[%o0+t.bxle1t1-t.bxle1s]
	ld	[%o3+t.bxle1o2-t.bxle1s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R3
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	sll	%o4,11,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+t.bxle1t2-t.bxle1s]
	ld	[%o3+t.bxle1o3-t.bxle1s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+t.bxle1t3-t.bxle1s]
	retl				!
	add	%o0,t.bxle1e-t.bxle1s,%o0
t.bxle0s:
    t.bxle0t0:	add	%l0,0,%o0	! ##TEMPLATE:%l0,imm0
    t.bxle0t1:	add	%g0,%l0,%o1	! ##TEMPLATE:%l0 R3+1
    t.bxle0t2:	add	%l0,%l0,%l0	! ##TEMPLATE:%l0,%l0,%l0 R1,R3,R1
    t.bxle0t3:	subcc	%l0,%o1,%g0	! ##TEMPLATE:%l0 R1
		bg,a	t.bxle0e	! if %l0 <= %o1 then taken
		add	%g2,4,%g2	! update IAR
		add	%g2,%g0,%o5	! save OPC
		sethi	%hi(break2),%o7	! BRANCH TAKEN
		jmpl	%o7+%lo(break2),%g0
		add	%g0,%o0,%g2	!
t.bxle0e:
    t.bxle0o0:	add	%l0,0,%o0	! ##TEMPLATE:%l0,imm0
    t.bxle0o1:	add	%g0,%l0,%o1	! ##TEMPLATE:%l0 R3+1
    t.bxle0o2:	add	%l0,%l0,%l0	! ##TEMPLATE:%l0,%l0,%l0 R1,R3,R1
    t.bxle0o3:	subcc	%l0,%o1,%g0	! ##TEMPLATE:%l0 R1
t.bxle1s:
    t.bxle1t0:	add	%l0,0,%o0	! ##TEMPLATE:%l0,imm0
    t.bxle1t1:	add	%g0,%l0,%o1	! ##TEMPLATE:%l0 R3
    t.bxle1t2:	add	%l0,%l0,%l0	! ##TEMPLATE:%l0,%l0,%l0 R1,R3,R1
    t.bxle1t3:	subcc	%l0,%o1,%g0	! ##TEMPLATE:%l0 R1
		bg,a	t.bxle1e	! if %l0 <= %o1 then taken
		add	%g2,4,%g2	! update IAR
		add	%g2,%g0,%o5	! save OPC
		sethi	%hi(break2),%o7	! BRANCH TAKEN
		jmpl	%o7+%lo(break2),%g0
		add	%g0,%o0,%g2	!
t.bxle1e:
    t.bxle1o0:	add	%l0,0,%o0	! ##TEMPLATE:%l0,imm0
    t.bxle1o1:	add	%g0,%l0,%o1	! ##TEMPLATE:%l0 R3
    t.bxle1o2:	add	%l0,%l0,%l0	! ##TEMPLATE:%l0,%l0,%l0 R1,R3,R1
    t.bxle1o3:	subcc	%l0,%o1,%g0	! ##TEMPLATE:%l0 R1
ii4_bxle:
	srl	%o1,16,%o3		! switch (R3)
	andcc	%o3,1,%g0		!
	bnz	i.bxle1t		!
	nop				!
    i.bxle0t:				!
	srl	%o1,12,%o4		! B2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l3		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l3		! %l3
	and	%o1,0xfff,%l4		! D2
	srl	%o1,16,%o4		! R3
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l1		! %l1
	srl	%o1,16,%o4		! R3+1
	and	%o4,0xf,%o4		! |
	add	%o4,1,%o4		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l2		! %l2
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%i0		! save as %i0
	ld	[%o7+%i0],%l0		! %l0
	ba	i.bxle0s		!
	nop				!
    i.bxle1t:				!
	srl	%o1,12,%o4		! B2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l3		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l3		! %l3
	and	%o1,0xfff,%l4		! D2
	srl	%o1,16,%o4		! R3
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l1		! %l1
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%i0		! save as %i0
	ld	[%o7+%i0],%l0		! %l0
	ba	i.bxle1s		!
	nop				!
i.bxle0s:
    i.bxle0t0:	add	%l3,%l4,%o0	! ##TEMPLATE:%l0,imm0
    i.bxle0t1:	add	%g0,%l2,%o1	! ##TEMPLATE:%l0 R3+1
    i.bxle0t2:	add	%l0,%l1,%l0	! ##TEMPLATE:%l0,%l0,%l0 R1,R3,R1
		st	%l0,[%o7+%i0]	! R1
    i.bxle0t3:	subcc	%l0,%o1,%g0	! ##TEMPLATE:%l0 R1
		bg,a	break0		! if %l0 <= %o1 then taken
		add	%g2,4,%g2	! update IAR
		add	%g2,%g0,%o5	! save OPC
		ba	break1		! BRANCH TAKEN
		add	%g0,%o0,%g2	!
i.bxle0e:
i.bxle1s:
    i.bxle1t0:	add	%l3,%l4,%o0	! ##TEMPLATE:%l0,imm0
    i.bxle1t1:	add	%g0,%l1,%o1	! ##TEMPLATE:%l0 R3
    i.bxle1t2:	add	%l0,%l1,%l0	! ##TEMPLATE:%l0,%l0,%l0 R1,R3,R1
		st	%l0,[%o7+%i0]	! R1
    i.bxle1t3:	subcc	%l0,%o1,%g0	! ##TEMPLATE:%l0 R1
		bg,a	break0		! if %l0 <= %o1 then taken
		add	%g2,4,%g2	! update IAR
		add	%g2,%g0,%o5	! save OPC
		ba	break1		! BRANCH TAKEN
		add	%g0,%o0,%g2	!
i.bxle1e:

	.section ".text"
	.align	4
	.global ci4_srl,ti4_srl,ii4_srl
ci4_srl:
	retl				!
	add	%g0,t.srl0e-t.srl0s,%o0	!
ti4_srl:
	sethi	%hi(t.srl0s),%o3	!
	or	%o3,%lo(t.srl0s),%o3	!
	or	%g0,t.srl0e-t.srl0s,%o4	!
    t.srl0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.srl0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.srl0o0-t.srl0s],%o5
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.srl0t0-t.srl0s]
	ld	[%o3+t.srl0o1-t.srl0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,25,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+t.srl0t1-t.srl0s]
	ld	[%o3+t.srl0o2-t.srl0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	sll	%o4,11,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+t.srl0t2-t.srl0s]
	retl				!
	add	%o0,t.srl0e-t.srl0s,%o0	!
ii4_srl:
	srl	%o1,12,%o4		! B2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l3		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l3		! %l3
	and	%o1,0xfff,%l4		! D2
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%i0		! save as %i0
	ld	[%o7+%i0],%l0		! %l0
t.srl0s:
    t.srl0t0:	add	%l3,%l4,%o0	! ##TEMPLATE:%l0,imm0 B2,D2
		and	%o0,0x3f,%o0	!
		subcc	%o0,31,%g0	!
		bg,a	t.srl000	!
    t.srl0t1:	add	%g0,%g0,%l0	! ##TEMPLATE:%l0 R1
    t.srl0t2:	srl	%l0,%o0,%l0	! ##TEMPLATE:%l0,%l0 R1,R1
    t.srl000:	add	%g2,4,%g2	! update IAR
t.srl0e:
		ba	break0		!
		st	%l0,[%o7+%i0]	! R1
    t.srl0o0:	add	%l0,0,%o0	! ##TEMPLATE:%l0,imm0 B2,D2
    t.srl0o1:	add	%g0,%g0,%l0	! ##TEMPLATE:%l0 R1
    t.srl0o2:	srl	%l0,%o0,%l0	! ##TEMPLATE:%l0,%l0 R1,R1

	.section ".text"
	.align	4
	.global ci4_sll,ti4_sll,ii4_sll
ci4_sll:
	retl				!
	add	%g0,t.sll0e-t.sll0s,%o0	!
ti4_sll:
	sethi	%hi(t.sll0s),%o3	!
	or	%o3,%lo(t.sll0s),%o3	!
	or	%g0,t.sll0e-t.sll0s,%o4	!
    t.sll0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.sll0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.sll0o0-t.sll0s],%o5
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.sll0t0-t.sll0s]
	ld	[%o3+t.sll0o1-t.sll0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,25,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+t.sll0t1-t.sll0s]
	ld	[%o3+t.sll0o2-t.sll0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	sll	%o4,11,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+t.sll0t2-t.sll0s]
	retl				!
	add	%o0,t.sll0e-t.sll0s,%o0	!
ii4_sll:
	srl	%o1,12,%o4		! B2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l3		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l3		! %l3
	and	%o1,0xfff,%l4		! D2
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%i0		! save as %i0
	ld	[%o7+%i0],%l0		! %l0
t.sll0s:
    t.sll0t0:	add	%l3,%l4,%o0	! ##TEMPLATE:%l0,imm0 B2,D2
		and	%o0,0x3f,%o0	!
		subcc	%o0,31,%g0	!
		bg,a	t.sll000	!
    t.sll0t1:	add	%g0,%g0,%l0	! ##TEMPLATE:%l0 R1
    t.sll0t2:	sll	%l0,%o0,%l0	! ##TEMPLATE:%l0,%l0 R1,R1
    t.sll000:	add	%g2,4,%g2	! update IAR
t.sll0e:
		ba	break0		!
		st	%l0,[%o7+%i0]	! R1
    t.sll0o0:	add	%l0,0,%o0	! ##TEMPLATE:%l0,imm0 B2,D2
    t.sll0o1:	add	%g0,%g0,%l0	! ##TEMPLATE:%l0 R1
    t.sll0o2:	sll	%l0,%o0,%l0	! ##TEMPLATE:%l0,%l0 R1,R1

	.section ".text"
	.align	4
	.global ci4_sra,ti4_sra,ii4_sra
ci4_sra:
	retl				!
	add	%g0,t.sra0e-t.sra0s,%o0	!
ti4_sra:
	sethi	%hi(t.sra0s),%o3	!
	or	%o3,%lo(t.sra0s),%o3	!
	or	%g0,t.sra0e-t.sra0s,%o4	!
    t.sra0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.sra0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.sra0o0-t.sra0s],%o5
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.sra0t0-t.sra0s]
	ld	[%o3+t.sra0o1-t.sra0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	sll	%o4,11,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+t.sra0t1-t.sra0s]
	ld	[%o3+t.sra0o2-t.sra0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	st	%o5,[%o0+t.sra0t2-t.sra0s]
	retl				!
	add	%o0,t.sra0e-t.sra0s,%o0	!
ii4_sra:
	srl	%o1,12,%o4		! B2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l3		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l3		! %l3
	and	%o1,0xfff,%l4		! D2
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%i0		! save as %i0
	ld	[%o7+%i0],%l0		! %l0
t.sra0s:
		andn	%g1,3,%g1	! CC=0
    t.sra0t0:	add	%l3,%l4,%o0	! ##TEMPLATE:%l0,imm0 B2,D2
		and	%o0,0x3f,%o0	!
		subcc	%o0,31,%g0	!
		bg,a	t.sra0t1	!
		add	%g0,31,%o0	!
    t.sra0t1:	sra	%l0,%o0,%l0	! ##TEMPLATE:%l0,%l0 R1,R1
    t.sra0t2:	addcc	%g0,%l0,%g0	! ##TEMPLATE:%l0 R1
		bg,a	t.sra001	! if %l0 > 0 then
		or	%g1,2,%g1	!   CC=2
		bl,a	t.sra001	! if %l0 < 0 then
		or	%g1,1,%g1	!   CC=1
    t.sra001:	add	%g2,4,%g2	! update IAR
t.sra0e:
		ba	break0		!
		st	%l0,[%o7+%i0]	! R1
    t.sra0o0:	add	%l0,0,%o0	! ##TEMPLATE:%l0,imm0 B2,D2
    t.sra0o1:	sra	%l0,%o0,%l0	! ##TEMPLATE:%l0,%l0 R1,R1
    t.sra0o2:	addcc	%g0,%l0,%g0	! ##TEMPLATE:%l0 R1

	.section ".text"
	.align	4
	.global ci4_sla,ti4_sla,ii4_sla
ci4_sla:
	retl				!
	add	%g0,t.sla0e-t.sla0s,%o0	!
ti4_sla:
	sethi	%hi(t.sla0s),%o3	!
	or	%o3,%lo(t.sla0s),%o3	!
	or	%g0,t.sla0e-t.sla0s,%o4	!
    t.sla0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.sla0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.sla0o0-t.sla0s],%o5
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.sla0t0-t.sla0s]
	ld	[%o3+t.sla0o1-t.sla0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	st	%o5,[%o0+t.sla0t1-t.sla0s]
	ld	[%o3+t.sla0o2-t.sla0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,25,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+t.sla0t2-t.sla0s]
	ld	[%o3+t.sla0o3-t.sla0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+t.sla0t3-t.sla0s]
	ld	[%o3+t.sla0o4-t.sla0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	st	%o5,[%o0+t.sla0t4-t.sla0s]
	retl				!
	add	%o0,t.sla0e-t.sla0s,%o0	!
t.sla0s:
		andn	%g1,3,%g1	! CC=0
    t.sla0t0:	add	%l0,0,%o0	! ##TEMPLATE:%l0,imm0 B2,D2
		and	%o0,0x3f,%o0	!
		subcc	%o0,31,%g0	!
		bg,a	t.sla0t1	!
		add	%g0,31,%o0	!
    t.sla0t1:	add	%g0,%l0,%o1	! ##TEMPLATE:%l0 R1
		sethi	%hi(0x80000000),%o2
		and	%o1,%o2,%o3	! extract sign
		sll	%o1,%o0,%o4	!
		andn	%o4,%o2,%o2	!
    t.sla0t2:	or	%o2,%o3,%l0	! ##TEMPLATE:%l0 R1
    t.sla0t3:	sra	%l0,%o0,%o2	! ##TEMPLATE:%l0 R1
		subcc	%o2,%o1,%g0	!
		be	t.sla0t4	! if overflow then
		andcc	%g7,8,%g0	!   CC=3
		bz	t.sla001	!   if fixed-point overflow mask then
		or	%g1,3,%g1	!
		sethi	%hi(0x00080000),%o0
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	!     fixed-point overflow
    t.sla0t4:	addcc	%g0,%l0,%g0	! ##TEMPLATE:%l0 R1
		bg,a	t.sla001	! if %l0 > 0 then
		or	%g1,2,%g1	!   CC=2
		bl,a	t.sla001	! if %l0 < 0 then
		or	%g1,1,%g1	!   CC=1
    t.sla001:	add	%g2,4,%g2	! update IAR
t.sla0e:
    t.sla0o0:	add	%l0,0,%o0	! ##TEMPLATE:%l0,imm0 B2,D2
    t.sla0o1:	add	%g0,%l0,%o1	! ##TEMPLATE:%l0 R1
    t.sla0o2:	or	%o2,%o3,%l0	! ##TEMPLATE:%l0 R1
    t.sla0o3:	sra	%l0,%o0,%o2	! ##TEMPLATE:%l0 R1
    t.sla0o4:	addcc	%g0,%l0,%g0	! ##TEMPLATE:%l0 R1
ii4_sla:
	srl	%o1,12,%o4		! B2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l3		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l3		! %l3
	and	%o1,0xfff,%l4		! D2
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%i0		! save as %i0
	ld	[%o7+%i0],%l0		! %l0
i.sla0s:
		andn	%g1,3,%g1	! CC=0
    i.sla0t0:	add	%l3,%l4,%o0	! ##TEMPLATE:%l0,imm0 B2,D2
		and	%o0,0x3f,%o0	!
		subcc	%o0,31,%g0	!
		bg,a	i.sla0t1	!
		add	%g0,31,%o0	!
    i.sla0t1:	add	%g0,%l0,%o1	! ##TEMPLATE:%l0 R1
		sethi	%hi(0x80000000),%o2
		and	%o1,%o2,%o3	! extract sign
		sll	%o1,%o0,%o4	!
		andn	%o4,%o2,%o2	!
    i.sla0t2:	or	%o2,%o3,%l0	! ##TEMPLATE:%l0 R1
		st	%l0,[%o7+%i0]	! R1
    i.sla0t3:	sra	%l0,%o0,%o2	! ##TEMPLATE:%l0 R1
		subcc	%o2,%o1,%g0	!
		be	i.sla0t4	! if overflow then
		andcc	%g7,8,%g0	!   CC=3
		bz	i.sla001	!   if fixed-point overflow mask then
		or	%g1,3,%g1	!
		sethi	%hi(0x00080000),%o0
		ba	epilog0		!
		or	%g7,%o0,%g7	!     fixed-point overflow
    i.sla0t4:	addcc	%g0,%l0,%g0	! ##TEMPLATE:%l0 R1
		bg,a	i.sla001	! if %l0 > 0 then
		or	%g1,2,%g1	!   CC=2
		bl,a	i.sla001	! if %l0 < 0 then
		or	%g1,1,%g1	!   CC=1
    i.sla001:	ba	break0		!
		add	%g2,4,%g2	! update IAR
i.sla0e:

	.section ".text"
	.align	4
	.global ci4_srdl,ti4_srdl,ii4_srdl
ci4_srdl:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	c.srdl1c		!
	nop				!
    c.srdl0c:				!
	retl				! case even:
	add	%g0,t.srdl0e-t.srdl0s,%o0
    c.srdl1c:				!
	retl				! case odd:
	add	%g0,t.srdl1e-t.srdl1s,%o0
ti4_srdl:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	t.srdl1t		!
	nop				!
    t.srdl0t:				!
	sethi	%hi(t.srdl0s),%o3	!
	or	%o3,%lo(t.srdl0s),%o3	!
	or	%g0,t.srdl0e-t.srdl0s,%o4
    t.srdl0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.srdl0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.srdl0o0-t.srdl0s],%o5
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.srdl0t0-t.srdl0s]
	ld	[%o3+t.srdl0o1-t.srdl0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1+1
	add	%o4,1,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	sll	%o4,11,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+t.srdl0t1-t.srdl0s]
	ld	[%o3+t.srdl0o2-t.srdl0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+t.srdl0t2-t.srdl0s]
	ld	[%o3+t.srdl0o3-t.srdl0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1+1
	add	%o4,1,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	sll	%o4,11,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+t.srdl0t3-t.srdl0s]
	ld	[%o3+t.srdl0o4-t.srdl0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	sll	%o4,11,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+t.srdl0t4-t.srdl0s]
	ld	[%o3+t.srdl0o5-t.srdl0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1+1
	add	%o4,1,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,25,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+t.srdl0t5-t.srdl0s]
	ld	[%o3+t.srdl0o6-t.srdl0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,25,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+t.srdl0t6-t.srdl0s]
	retl				!
	add	%o0,t.srdl0e-t.srdl0s,%o0
    t.srdl1t:				!
	sethi	%hi(t.srdl1s),%o3	!
	or	%o3,%lo(t.srdl1s),%o3	!
	or	%g0,t.srdl1e-t.srdl1s,%o4
    t.srdl1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.srdl1cp		!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,t.srdl1e-t.srdl1s,%o0
ii4_srdl:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	t.srdl1s		!
	nop				!
    i.srdl0t:				!
	srl	%o1,12,%o4		! B2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l3		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l3		! %l3
	and	%o1,0xfff,%l4		! D2
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%i0		! save as %i0
	ld	[%o7+%i0],%l0		! %l0
	srl	%o1,20,%o4		! R1+1
	and	%o4,0xf,%o4		! |
	add	%o4,1,%o4		! |
	sll	%o4,2,%i1		! save as %i1
	ld	[%o7+%i1],%l1		! %l1
t.srdl0s:
    t.srdl0t0:	add	%l3,%l4,%o0	! ##TEMPLATE:%l0,imm0 B2,D2
		andcc	%o0,0x3f,%o0	!
		bz	t.srdl000	! if SHIFT == 0 then do nothing
		subcc	%o0,31,%g0	!
		bg	t.srdl0t5	! if SHIFT >= 32 then skip
		sub	%o0,32,%o1	!
		sub	%g0,%o1,%o1	!
    t.srdl0t1:	srl	%l1,%o0,%l1	! ##TEMPLATE:%l0,%l0 R1+1,R1+1
    t.srdl0t2:	sll	%l0,%o1,%o1	! ##TEMPLATE:%l0 R1
    t.srdl0t3:	or	%l1,%o1,%l1	! ##TEMPLATE:%l0,%l0 R1+1,R1+1
		ba	t.srdl000	!
    t.srdl0t4:	srl	%l0,%o0,%l0	! ##TEMPLATE:%l0,%l0 R1,R1
    t.srdl0t5:	srl	%l0,%o1,%l1	! ##TEMPLATE:%l0,%l0 R1,R1+1
    t.srdl0t6:	add	%g0,%g0,%l0	! ##TEMPLATE:%l0 R1
    t.srdl000:	add	%g2,4,%g2	! update IAR
t.srdl0e:
		st	%l0,[%o7+%i0]	! R1
		ba	break0		!
		st	%l1,[%o7+%i1]	! R1+1
    t.srdl0o0:	add	%l0,0,%o0	! ##TEMPLATE:%l0,imm0 B2,D2
    t.srdl0o1:	srl	%l0,%o0,%l0	! ##TEMPLATE:%l0,%l0 R1+1,R1+1
    t.srdl0o2:	sll	%l0,%o1,%o1	! ##TEMPLATE:%l0 R1
    t.srdl0o3:	or	%l0,%o1,%l0	! ##TEMPLATE:%l0,%l0 R1+1,R1+1
    t.srdl0o4:	srl	%l0,%o0,%l0	! ##TEMPLATE:%l0,%l0 R1,R1
    t.srdl0o5:	srl	%l0,%o1,%l0	! ##TEMPLATE:%l0,%l0 R1,R1+1
    t.srdl0o6:	add	%g0,%g0,%l0	! ##TEMPLATE:%l0 R1
t.srdl1s:
		sethi	%hi(0x00060000),%o0
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! specification exception
t.srdl1e:

	.section ".text"
	.align	4
	.global ci4_sldl,ti4_sldl,ii4_sldl
ci4_sldl:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	c.sldl1c		!
	nop				!
    c.sldl0c:				!
	retl				! case even:
	add	%g0,t.sldl0e-t.sldl0s,%o0
    c.sldl1c:				!
	retl				! case odd:
	add	%g0,t.sldl1e-t.sldl1s,%o0
ti4_sldl:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	t.sldl1t		!
	nop				!
    t.sldl0t:				!
	sethi	%hi(t.sldl0s),%o3	!
	or	%o3,%lo(t.sldl0s),%o3	!
	or	%g0,t.sldl0e-t.sldl0s,%o4
    t.sldl0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.sldl0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.sldl0o0-t.sldl0s],%o5
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.sldl0t0-t.sldl0s]
	ld	[%o3+t.sldl0o1-t.sldl0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	sll	%o4,11,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+t.sldl0t1-t.sldl0s]
	ld	[%o3+t.sldl0o2-t.sldl0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1+1
	add	%o4,1,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+t.sldl0t2-t.sldl0s]
	ld	[%o3+t.sldl0o3-t.sldl0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	sll	%o4,11,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+t.sldl0t3-t.sldl0s]
	ld	[%o3+t.sldl0o4-t.sldl0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1+1
	add	%o4,1,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	sll	%o4,11,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+t.sldl0t4-t.sldl0s]
	ld	[%o3+t.sldl0o5-t.sldl0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1+1
	add	%o4,1,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,25,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+t.sldl0t5-t.sldl0s]
	ld	[%o3+t.sldl0o6-t.sldl0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1+1
	add	%o4,1,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,25,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+t.sldl0t6-t.sldl0s]
	retl				!
	add	%o0,t.sldl0e-t.sldl0s,%o0
    t.sldl1t:				!
	sethi	%hi(t.sldl1s),%o3	!
	or	%o3,%lo(t.sldl1s),%o3	!
	or	%g0,t.sldl1e-t.sldl1s,%o4
    t.sldl1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.sldl1cp		!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,t.sldl1e-t.sldl1s,%o0
ii4_sldl:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	t.sldl1s		!
	nop				!
    i.sldl0t:				!
	srl	%o1,12,%o4		! B2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l3		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l3		! %l3
	and	%o1,0xfff,%l4		! D2
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%i0		! save as %i0
	ld	[%o7+%i0],%l0		! %l0
	srl	%o1,20,%o4		! R1+1
	and	%o4,0xf,%o4		! |
	add	%o4,1,%o4		! |
	sll	%o4,2,%i1		! save as %i1
	ld	[%o7+%i1],%l1		! %l1
t.sldl0s:
    t.sldl0t0:	add	%l3,%l4,%o0	! ##TEMPLATE:%l0,imm0 B2,D2
		andcc	%o0,0x3f,%o0	!
		bz	t.sldl000	! if SHIFT == 0 then do nothing
		subcc	%o0,31,%g0	!
		bg	t.sldl0t5	! if SHIFT >= 32 then skip
		sub	%o0,32,%o1	!
		sub	%g0,%o1,%o1	!
    t.sldl0t1:	sll	%l0,%o0,%l0	! ##TEMPLATE:%l0,%l0 R1,R1
    t.sldl0t2:	srl	%l1,%o1,%o1	! ##TEMPLATE:%l0 R1+1
    t.sldl0t3:	or	%l0,%o1,%l0	! ##TEMPLATE:%l0,%l0 R1,R1
		ba	t.sldl000	!
    t.sldl0t4:	sll	%l1,%o0,%l1	! ##TEMPLATE:%l0,%l0 R1+1,R1+1
    t.sldl0t5:	sll	%l1,%o1,%l0	! ##TEMPLATE:%l0,%l0 R1+1,R1
    t.sldl0t6:	add	%g0,%g0,%l1	! ##TEMPLATE:%l0 R1+1
    t.sldl000:	add	%g2,4,%g2	! update IAR
t.sldl0e:
		st	%l0,[%o7+%i0]	! R1
		ba	break0		!
		st	%l1,[%o7+%i1]	! R1+1
    t.sldl0o0:	add	%l0,0,%o0	! ##TEMPLATE:%l0,imm0 B2,D2
    t.sldl0o1:	sll	%l0,%o0,%l0	! ##TEMPLATE:%l0,%l0 R1,R1
    t.sldl0o2:	srl	%l0,%o1,%o1	! ##TEMPLATE:%l0 R1+1
    t.sldl0o3:	or	%l0,%o1,%l0	! ##TEMPLATE:%l0,%l0 R1,R1
    t.sldl0o4:	sll	%l0,%o0,%l0	! ##TEMPLATE:%l0,%l0 R1+1,R1+1
    t.sldl0o5:	sll	%l0,%o1,%l0	! ##TEMPLATE:%l0,%l0 R1+1,R1
    t.sldl0o6:	add	%g0,%g0,%l0	! ##TEMPLATE:%l0 R1+1
t.sldl1s:
		sethi	%hi(0x00060000),%o0
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! specification exception
t.sldl1e:

	.section ".text"
	.align	4
	.global ci4_srda,ti4_srda,ii4_srda
ci4_srda:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	c.srda1c		!
	nop				!
    c.srda0c:				!
	retl				! case even:
	add	%g0,t.srda0e-t.srda0s,%o0
    c.srda1c:				!
	retl				! case odd:
	add	%g0,t.srda1e-t.srda1s,%o0
ti4_srda:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	t.srda1t		!
	nop				!
    t.srda0t:				!
	sethi	%hi(t.srda0s),%o3	!
	or	%o3,%lo(t.srda0s),%o3	!
	or	%g0,t.srda0e-t.srda0s,%o4
    t.srda0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.srda0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.srda0o0-t.srda0s],%o5
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.srda0t0-t.srda0s]
	ld	[%o3+t.srda0o1-t.srda0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1+1
	add	%o4,1,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	sll	%o4,11,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+t.srda0t1-t.srda0s]
	ld	[%o3+t.srda0o2-t.srda0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+t.srda0t2-t.srda0s]
	ld	[%o3+t.srda0o3-t.srda0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1+1
	add	%o4,1,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	sll	%o4,11,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+t.srda0t3-t.srda0s]
	ld	[%o3+t.srda0o4-t.srda0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	sll	%o4,11,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+t.srda0t4-t.srda0s]
	ld	[%o3+t.srda0o5-t.srda0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1+1
	add	%o4,1,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,25,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+t.srda0t5-t.srda0s]
	ld	[%o3+t.srda0o6-t.srda0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	sll	%o4,11,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+t.srda0t6-t.srda0s]
	ld	[%o3+t.srda0o7-t.srda0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	st	%o5,[%o0+t.srda0t7-t.srda0s]
	ld	[%o3+t.srda0o8-t.srda0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1+1
	add	%o4,1,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	st	%o5,[%o0+t.srda0t8-t.srda0s]
	retl				!
	add	%o0,t.srda0e-t.srda0s,%o0
    t.srda1t:				!
	sethi	%hi(t.srda1s),%o3	!
	or	%o3,%lo(t.srda1s),%o3	!
	or	%g0,t.srda1e-t.srda1s,%o4
    t.srda1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.srda1cp		!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,t.srda1e-t.srda1s,%o0
ii4_srda:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	t.srda1s		!
	nop				!
    i.srda0t:				!
	srl	%o1,12,%o4		! B2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l3		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l3		! %l3
	and	%o1,0xfff,%l4		! D2
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%i0		! save as %i0
	ld	[%o7+%i0],%l0		! %l0
	srl	%o1,20,%o4		! R1+1
	and	%o4,0xf,%o4		! |
	add	%o4,1,%o4		! |
	sll	%o4,2,%i1		! save as %i1
	ld	[%o7+%i1],%l1		! %l1
t.srda0s:
		andn	%g1,3,%g1	! CC=0
    t.srda0t0:	add	%l3,%l4,%o0	! ##TEMPLATE:%l0,imm0 B2,D2
		andcc	%o0,0x3f,%o0	!
		bz	t.srda0t7	! if SHIFT == 0 then do nothing
		subcc	%o0,31,%g0	!
		bg	t.srda0t5	! if SHIFT >= 32 then skip
		sub	%o0,32,%o1	!
		sub	%g0,%o1,%o1	!
    t.srda0t1:	srl	%l1,%o0,%l1	! ##TEMPLATE:%l0,%l0 R1+1,R1+1
    t.srda0t2:	sll	%l0,%o1,%o1	! ##TEMPLATE:%l0 R1
    t.srda0t3:	or	%l1,%o1,%l1	! ##TEMPLATE:%l0,%l0 R1+1,R1+1
		ba	t.srda0t7	!
    t.srda0t4:	sra	%l0,%o0,%l0	! ##TEMPLATE:%l0,%l0 R1,R1
    t.srda0t5:	sra	%l0,%o1,%l1	! ##TEMPLATE:%l0,%l0 R1,R1+1
    t.srda0t6:	sra	%l0,31,%l0	! ##TEMPLATE:%l0,%l0 R1,R1
    t.srda0t7:	addcc	%g0,%l0,%g0	! ##TEMPLATE:%l0 R1
		bz,a	t.srda001	!
    t.srda0t8:	addcc	%g0,%l1,%g0	! ##TEMPLATE:%l0 R1+1
		bg,a	t.srda002	! if %l0 > 0 then
		or	%g1,2,%g1	!   CC=2
		bl,a	t.srda002	! if %l0 < 0 then
		or	%g1,1,%g1	!   CC=1
		ba	t.srda002	!
		nop			!
    t.srda001:	bnz,a	t.srda002	! if %l0+1 != 0 then
		or	%g1,2,%g1	!   CC=2
    t.srda002:	add	%g2,4,%g2	! update IAR
t.srda0e:
		st	%l0,[%o7+%i0]	! R1
		ba	break0		!
		st	%l1,[%o7+%i1]	! R1+1
    t.srda0o0:	add	%l0,0,%o0	! ##TEMPLATE:%l0,imm0 B2,D2
    t.srda0o1:	srl	%l0,%o0,%l0	! ##TEMPLATE:%l0,%l0 R1+1,R1+1
    t.srda0o2:	sll	%l0,%o1,%o1	! ##TEMPLATE:%l0 R1
    t.srda0o3:	or	%l0,%o1,%l0	! ##TEMPLATE:%l0,%l0 R1+1,R1+1
    t.srda0o4:	sra	%l0,%o0,%l0	! ##TEMPLATE:%l0,%l0 R1,R1
    t.srda0o5:	sra	%l0,%o1,%l0	! ##TEMPLATE:%l0,%l0 R1,R1+1
    t.srda0o6:	sra	%l0,31,%l0	! ##TEMPLATE:%l0,%l0 R1,R1
    t.srda0o7:	addcc	%g0,%l0,%g0	! ##TEMPLATE:%l0 R1
    t.srda0o8:	addcc	%g0,%l0,%g0	! ##TEMPLATE:%l0 R1+1
t.srda1s:
		sethi	%hi(0x00060000),%o0
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! specification exception
t.srda1e:

	.section ".text"
	.align	4
	.global ci4_slda,ti4_slda,ii4_slda
ci4_slda:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	c.slda1c		!
	nop				!
    c.slda0c:				!
	retl				! case even:
	add	%g0,t.slda0e-t.slda0s,%o0
    c.slda1c:				!
	retl				! case odd:
	add	%g0,t.slda1e-t.slda1s,%o0
ti4_slda:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	t.slda1t		!
	nop				!
    t.slda0t:				!
	sethi	%hi(t.slda0s),%o3	!
	or	%o3,%lo(t.slda0s),%o3	!
	or	%g0,t.slda0e-t.slda0s,%o4
    t.slda0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.slda0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.slda0o0-t.slda0s],%o5
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.slda0t0-t.slda0s]
	ld	[%o3+t.slda0o1-t.slda0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	st	%o5,[%o0+t.slda0t1-t.slda0s]
	ld	[%o3+t.slda0o2-t.slda0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1+1
	add	%o4,1,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	st	%o5,[%o0+t.slda0t2-t.slda0s]
	ld	[%o3+t.slda0o3-t.slda0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,25,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+t.slda0t3-t.slda0s]
	ld	[%o3+t.slda0o4-t.slda0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1+1
	add	%o4,1,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	sll	%o4,11,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+t.slda0t4-t.slda0s]
	ld	[%o3+t.slda0o5-t.slda0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+t.slda0t5-t.slda0s]
	ld	[%o3+t.slda0o6-t.slda0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,25,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+t.slda0t6-t.slda0s]
	ld	[%o3+t.slda0o7-t.slda0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1+1
	add	%o4,1,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,25,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+t.slda0t7-t.slda0s]
	ld	[%o3+t.slda0o8-t.slda0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+t.slda0t8-t.slda0s]
	ld	[%o3+t.slda0o9-t.slda0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+t.slda0t9-t.slda0s]
	ld	[%o3+t.slda0oa-t.slda0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	st	%o5,[%o0+t.slda0ta-t.slda0s]
	ld	[%o3+t.slda0ob-t.slda0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1+1
	add	%o4,1,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	st	%o5,[%o0+t.slda0tb-t.slda0s]
	retl				!
	add	%o0,t.slda0e-t.slda0s,%o0
    t.slda1t:				!
	sethi	%hi(t.slda1s),%o3	!
	or	%o3,%lo(t.slda1s),%o3	!
	or	%g0,t.slda1e-t.slda1s,%o4
    t.slda1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.slda1cp		!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,t.slda1e-t.slda1s,%o0
t.slda0s:
		andn	%g1,3,%g1	! CC=0
    t.slda0t0:	add	%l0,0,%o0	! ##TEMPLATE:%l0,imm0 B2,D2
		andcc	%o0,0x3f,%o0	!
		bz	t.slda0ta	! if SHIFT == 0 then do nothing
    t.slda0t1:	add	%g0,%l0,%o4	! ##TEMPLATE:%l0 R1
    t.slda0t2:	add	%g0,%l0,%o5	! ##TEMPLATE:%l0 R1+1
		sethi	%hi(0x80000000),%o2
		and	%o4,%o2,%o3	! extract sign
		subcc	%o0,31,%g0	!
		bg	t.slda000	! if SHIFT >= 32 then skip
		sub	%o0,32,%o1	!
		sub	%g0,%o1,%o1	!
		sll	%o4,%o0,%o7	!
		srl	%o5,%o1,%o1	!
		or	%o7,%o1,%o1	!
		andn	%o1,%o2,%o2	!
    t.slda0t3:	or	%o2,%o3,%l0	! ##TEMPLATE:%l0 R1
    t.slda0t4:	sll	%l0,%o0,%l0	! ##TEMPLATE:%l0,%l0 R1+1,R1+1
    t.slda0t5:	sra	%l0,%o0,%o2	! ##TEMPLATE:%l0 R1
		add	%g0,%o5,%o3	!
		ba	t.slda001	!
    t.slda000:	sll	%o5,%o1,%o0	!
		andn	%o0,%o2,%o2	!
    t.slda0t6:	or	%o2,%o3,%l0	! ##TEMPLATE:%l0 R1
    t.slda0t7:	add	%g0,%g0,%l0	! ##TEMPLATE:%l0 R1+1
    t.slda0t8:	sra	%l0,31,%o2	! ##TEMPLATE:%l0 R1
    t.slda0t9:	sra	%l0,%o1,%o3	! ##TEMPLATE:%l0 R1
    t.slda001:	subcc	%o2,%o4,%g0	!
		bne	t.slda002	! if overflow then
		subcc	%o3,%o5,%g0	!
		be	t.slda0ta	!
    t.slda002:	andcc	%g7,8,%g0	!   CC=3
		bz	t.slda005	!   if fixed-point overflow mask then
		or	%g1,3,%g1	!
		sethi	%hi(0x00080000),%o0
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	!     fixed-point overflow
    t.slda0ta:	addcc	%g0,%l0,%g0	! ##TEMPLATE:%l0 R1
		bz,a	t.slda004	!
    t.slda0tb:	addcc	%g0,%l0,%g0	! ##TEMPLATE:%l0 R1+1
		bg,a	t.slda005	! if %l0 > 0 then
		or	%g1,2,%g1	!   CC=2
		bl,a	t.slda005	! if %l0 < 0 then
		or	%g1,1,%g1	!   CC=1
		ba	t.slda005	!
		nop			!
    t.slda004:	bnz,a	t.slda005	! if %l0+1 != 0 then
		or	%g1,2,%g1	!   CC=2
    t.slda005:	add	%g2,4,%g2	! update IAR
t.slda0e:
    t.slda0o0:	add	%l0,0,%o0	! ##TEMPLATE:%l0,imm0 B2,D2
    t.slda0o1:	add	%g0,%l0,%o4	! ##TEMPLATE:%l0 R1
    t.slda0o2:	add	%g0,%l0,%o5	! ##TEMPLATE:%l0 R1+1
    t.slda0o3:	or	%o2,%o3,%l0	! ##TEMPLATE:%l0 R1
    t.slda0o4:	sll	%l0,%o0,%l0	! ##TEMPLATE:%l0,%l0 R1+1,R1+1
    t.slda0o5:	sra	%l0,%o0,%o2	! ##TEMPLATE:%l0 R1
    t.slda0o6:	or	%o2,%o3,%l0	! ##TEMPLATE:%l0 R1
    t.slda0o7:	add	%g0,%g0,%l0	! ##TEMPLATE:%l0 R1+1
    t.slda0o8:	sra	%l0,31,%o2	! ##TEMPLATE:%l0 R1
    t.slda0o9:	sra	%l0,%o1,%o3	! ##TEMPLATE:%l0 R1
    t.slda0oa:	addcc	%g0,%l0,%g0	! ##TEMPLATE:%l0 R1
    t.slda0ob:	addcc	%g0,%l0,%g0	! ##TEMPLATE:%l0 R1+1
t.slda1s:
		sethi	%hi(0x00060000),%o0
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! specification exception
t.slda1e:
ii4_slda:
	srl	%o1,20,%o3		! switch (R1)
	andcc	%o3,1,%g0		!
	bnz	t.slda1s		!
	nop				!
    i.slda0t:				!
	srl	%o1,12,%o4		! B2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l3		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l3		! %l3
	and	%o1,0xfff,%l4		! D2
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%i0		! save as %i0
	ld	[%o7+%i0],%l0		! %l0
	srl	%o1,20,%o4		! R1+1
	and	%o4,0xf,%o4		! |
	add	%o4,1,%o4		! |
	sll	%o4,2,%i1		! save as %i1
	ld	[%o7+%i1],%l1		! %l1
i.slda0s:
		andn	%g1,3,%g1	! CC=0
    i.slda0t0:	add	%l3,%l4,%o0	! ##TEMPLATE:%l0,imm0 B2,D2
		andcc	%o0,0x3f,%o0	!
		bz	i.slda0ta	! if SHIFT == 0 then do nothing
    i.slda0t1:	add	%g0,%l0,%o4	! ##TEMPLATE:%l0 R1
    i.slda0t2:	add	%g0,%l1,%o5	! ##TEMPLATE:%l0 R1+1
		sethi	%hi(0x80000000),%o2
		and	%o4,%o2,%o3	! extract sign
		subcc	%o0,31,%g0	!
		bg	i.slda000	! if SHIFT >= 32 then skip
		sub	%o0,32,%o1	!
		sub	%g0,%o1,%o1	!
		sll	%o4,%o0,%o7	!
		srl	%o5,%o1,%o1	!
		or	%o7,%o1,%o1	!
		andn	%o1,%o2,%o2	!
    i.slda0t3:	or	%o2,%o3,%l0	! ##TEMPLATE:%l0 R1
    i.slda0t4:	sll	%l1,%o0,%l1	! ##TEMPLATE:%l0,%l0 R1+1,R1+1
    i.slda0t5:	sra	%l0,%o0,%o2	! ##TEMPLATE:%l0 R1
		add	%g0,%o5,%o3	!
		ba	i.slda001	!
    i.slda000:	sll	%o5,%o1,%o0	!
		andn	%o0,%o2,%o2	!
    i.slda0t6:	or	%o2,%o3,%l0	! ##TEMPLATE:%l0 R1
    i.slda0t7:	add	%g0,%g0,%l1	! ##TEMPLATE:%l0 R1+1
    i.slda0t8:	sra	%l0,31,%o2	! ##TEMPLATE:%l0 R1
    i.slda0t9:	sra	%l0,%o1,%o3	! ##TEMPLATE:%l0 R1
    i.slda001:	ld	[%sp+184],%o7	! struct *gcpu_s
		st	%l0,[%o7+%i0]	! R1
		st	%l1,[%o7+%i1]	! R1+1
		subcc	%o2,%o4,%g0	!
		bne	i.slda002	! if overflow then
		subcc	%o3,%o5,%g0	!
		be	i.slda0ta	!
    i.slda002:	andcc	%g7,8,%g0	!   CC=3
		bz	i.slda005	!   if fixed-point overflow mask then
		or	%g1,3,%g1	!
		sethi	%hi(0x00080000),%o0
		ba	epilog0		!
		or	%g7,%o0,%g7	!     fixed-point overflow
    i.slda0ta:	addcc	%g0,%l0,%g0	! ##TEMPLATE:%l0 R1
		bz,a	i.slda004	!
    i.slda0tb:	addcc	%g0,%l1,%g0	! ##TEMPLATE:%l0 R1+1
		bg,a	i.slda005	! if %l0 > 0 then
		or	%g1,2,%g1	!   CC=2
		bl,a	i.slda005	! if %l0 < 0 then
		or	%g1,1,%g1	!   CC=1
		ba	i.slda005	!
		nop			!
    i.slda004:	bnz,a	i.slda005	! if %l0+1 != 0 then
		or	%g1,2,%g1	!   CC=2
    i.slda005:	ba	break0		!
		add	%g2,4,%g2	! update IAR
i.slda0e:
!================================

!
! templates
! cxx_xxx:
!   %o0: param: none
!	 retval:size of template
!   %o1: M instruction (4 bytes)
!   %o2: work
!   %o3: work
!   %o4: work
!   %o5: work
! txx_xxx:
!   %o0: param: bufp start address
!	 retval:bufp next start address
!   %o1: M instruction (4 bytes)
!   %o2: work
!   %o3: work
!   %o4: work
!   %o5: work
!
	.section ".text"
	.align	4
	.global ci4_stm,ti4_stm,ii4_stm
ci4_stm:
	srl	%o1,20,%o3		! R1
	and	%o3,0xf,%o3		!
	srl	%o1,16,%o4		! R3
	and	%o4,0xf,%o4		!
	sub	%o4,%o3,%o4		!
	and	%o4,0xf,%o4		! # of Regs.
	sll	%o4,2,%o4		!
	retl				!
	add	%o4,t.stm0e-t.stm0s,%o0	!
ti4_stm:
	sethi	%hi(t.stm0s),%o3	!
	or	%o3,%lo(t.stm0s),%o3	!
	or	%g0,t.stm0e-t.stm0s,%o4	!
    t.stm0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.stm0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.stm0o0-t.stm0s],%o5
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.stm0t0-t.stm0s]

	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		!
	add	%g0,%g0,%o2		! address counter
    t.stm0loop:				!
	ld	[%o3+t.stm0o2-t.stm0s],%o5
	subcc	%o4,0xe,%g0		!
	bz,a	.+8			!
	add	%g0,0x16,%o4		!
	sll	%o4,25,%o4		!
	xor	%o5,%o4,%o5		!
	srl	%o4,25,%o4		!
	subcc	%o4,0x16,%g0		!
	bz,a	.+8			!
	add	%g0,0xe,%o4		!
	xor	%o5,%o2,%o5		!
	add	%o0,t.stm0t2-t.stm0s,%o0!
	st	%o5,[%o0+%o2]		! store st insn
	sub	%o0,t.stm0t2-t.stm0s,%o0!
	srl	%o1,16,%o5		!
	and	%o5,0xf,%o5		!
	subcc	%o4,%o5,%g0		!
	be	t.stm0lend		!
	add	%o4,1,%o4		!
	and	%o4,0xf,%o4		!
	add	%o2,4,%o2		!
	ba,a	t.stm0loop		!
    t.stm0lend:				!
	ld	[%o3+t.stm0o1-t.stm0s],%o5
	add	%o2,3,%o4		!
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.stm0t1-t.stm0s]

	ld	[%o3+t.stm0o3-t.stm0s],%o5
	add	%o0,t.stm0t2+4-t.stm0s,%o0
	st	%o5,[%o0+%o2]		! store "add %g2,4,%g2"
	sub	%o0,t.stm0t2+4-t.stm0s,%o0
	add	%o0,t.stm0e-t.stm0s,%o0	!
	retl				!
	add	%o0,%o2,%o0		!
t.stm0s:
    t.stm0t0:	add	%l0,0,%o0	! ##TEMPLATE:%l0,imm0
		and	%o0,%g3,%o0	! mask address
		add	%g4,%o0,%o0	!
		ldub	[%o0],%g0	! force PAGEIN
    t.stm0t1:	ldub	[%o0+0],%g0	! ##TEMPLATE:imm0
    t.stm0t2:	st	%l0,[%o0+0]	! ##TEMPLATE:%l0
		add	%g2,4,%g2	! update IAR
t.stm0e:
    t.stm0o0:	add	%l0,0,%o0	! ##TEMPLATE:%l0,imm0
    t.stm0o1:	ldub	[%o0+0],%g0	! ##TEMPLATE:imm0
    t.stm0o2:	st	%l0,[%o0+0]	! ##TEMPLATE:%l0
    t.stm0o3:	add	%g2,4,%g2	! ##TEMPLATE:IAR
ii4_stm:
	srl	%o1,12,%o4		! B2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l3		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l3		! %l3
	and	%o1,0xfff,%l4		! D2
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%i0		! %i0
	srl	%o1,16,%o4		! R3-R1+3
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	sub	%o4,%i0,%o4		! |
	and	%o4,0x3f,%o4		! length-1
	add	%o4,3,%i1		! %i1
i.stm0s:
    i.stm0t0:	add	%l3,%l4,%o0	! ##TEMPLATE:%l0,imm0
		and	%o0,%g3,%o0	! mask address
		add	%g4,%o0,%o0	!
		ldub	[%o0],%g0	! force PAGEIN
    i.stm0t1:	ldub	[%o0+%i1],%g0	! ##TEMPLATE:imm0
		add	%g0,%g0,%o1	!
    i.stm0t2:	ld	[%o7+%i0],%l0	! R1->R3
		add	%i0,4,%i0	!
		st	%l0,[%o0+%o1]	! ##TEMPLATE:%l0
		add	%o1,4,%o1	!
		subcc	%o1,%i1,%g0	!
		bl	i.stm0t2	!
		and	%i0,0x3f,%i0	!
		ba	break0		!
		add	%g2,4,%g2	! update IAR
i.stm0e:

	.section ".text"
	.align	4
	.global ci4_tm,ti4_tm,ii4_tm
ci4_tm:
	retl				!
	add	%g0,t.tm0e-t.tm0s,%o0	!
ti4_tm:
	sethi	%hi(t.tm0s),%o3		!
	or	%o3,%lo(t.tm0s),%o3	!
	or	%g0,t.tm0e-t.tm0s,%o4	!
    t.tm0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.tm0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.tm0o0-t.tm0s],%o5!
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B1
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	and	%o1,0xfff,%o4		! D1
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.tm0t0-t.tm0s]!
	ld	[%o3+t.tm0o1-t.tm0s],%o5!
	srl	%o1,16,%o4		!
	and	%o4,0xff,%o4		! I
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.tm0t1-t.tm0s]!
	ld	[%o3+t.tm0o2-t.tm0s],%o5!
	srl	%o1,16,%o4		!
	and	%o4,0xff,%o4		! I
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.tm0t2-t.tm0s]!
	retl				!
	add	%o0,t.tm0e-t.tm0s,%o0	!
ii4_tm:
	srl	%o1,12,%o4		! B2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l3		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l3		! %l3
	and	%o1,0xfff,%l4		! D2
	srl	%o1,16,%o4		! I
	and	%o4,0xff,%l1		! %l1
t.tm0s:
    t.tm0t0:	add	%l3,%l4,%o0	! ##TEMPLATE:%l0,imm0
		and	%o0,%g3,%o0	! mask address
		ldub	[%g4+%o0],%o0	!
		andn	%g1,3,%g1	! CC=0
    t.tm0t1:	andcc	%o0,%l1,%o1	! ##TEMPLATE:imm0
		bz	t.tm000		! if result == 0    then CC=0
    t.tm0t2:	subcc	%o1,%l1,%g0	! ##TEMPLATE:imm0
		bnz,a	t.tm000		!
		or	%g1,1,%g1	! if result != mask then CC=1
		or	%g1,3,%g1	! if result == mask then CC=3
    t.tm000:	add	%g2,4,%g2	! update IAR
t.tm0e:
		ba	break0		!
		nop			!
    t.tm0o0:	add	%l0,0,%o0	! ##TEMPLATE:%l0,imm0
    t.tm0o1:	andcc	%o0,0,%o1	! ##TEMPLATE:imm0
    t.tm0o2:	subcc	%o1,0,%g0	! ##TEMPLATE:imm0

	.section ".text"
	.align	4
	.global ci4_mvi,ti4_mvi,ii4_mvi
ci4_mvi:
	retl				!
	add	%g0,t.mvi0e-t.mvi0s,%o0	!
ti4_mvi:
	sethi	%hi(t.mvi0s),%o3	!
	or	%o3,%lo(t.mvi0s),%o3	!
	or	%g0,t.mvi0e-t.mvi0s,%o4	!
    t.mvi0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.mvi0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.mvi0o0-t.mvi0s],%o5
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B1
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	and	%o1,0xfff,%o4		! D1
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.mvi0t0-t.mvi0s]
	ld	[%o3+t.mvi0o1-t.mvi0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xff,%o4		! I
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.mvi0t1-t.mvi0s]
	retl				!
	add	%o0,t.mvi0e-t.mvi0s,%o0	!
ii4_mvi:
	srl	%o1,12,%o4		! B2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l3		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l3		! %l3
	and	%o1,0xfff,%l4		! D2
	srl	%o1,16,%o4		! I
	and	%o4,0xff,%l1		! %l1
t.mvi0s:
    t.mvi0t0:	add	%l3,%l4,%o0	! ##TEMPLATE:%l0,imm0
		and	%o0,%g3,%o0	! mask address
    t.mvi0t1:	add	%g0,%l1,%o1	! ##TEMPLATE:imm0
		stb	%o1,[%g4+%o0]	!
		add	%g2,4,%g2	! update IAR
t.mvi0e:
		ba	break0		!
		nop			!
    t.mvi0o0:	add	%l0,0,%o0	! ##TEMPLATE:%l0,imm0
    t.mvi0o1:	add	%g0,0,%o1	! ##TEMPLATE:imm0

	.section ".text"
	.align	4
	.global ci4_ts,ti4_ts,ii4_ts
ci4_ts:
	retl				!
	add	%g0,t.ts0e-t.ts0s,%o0	!
ti4_ts:
	sethi	%hi(t.ts0s),%o3		!
	or	%o3,%lo(t.ts0s),%o3	!
	or	%g0,t.ts0e-t.ts0s,%o4	!
    t.ts0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.ts0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.ts0o0-t.ts0s],%o5!
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B1
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	and	%o1,0xfff,%o4		! D1
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.ts0t0-t.ts0s]!
	retl				!
	add	%o0,t.ts0e-t.ts0s,%o0	!
ii4_ts:
	srl	%o1,12,%o4		! B2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l3		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l3		! %l3
	and	%o1,0xfff,%l4		! D2
t.ts0s:
    t.ts0t0:	add	%l3,%l4,%o0	! ##TEMPLATE:%l0,imm0
		and	%o0,%g3,%o0	! mask address
		ldub	[%g4+%o0],%o1	!
		andn	%g1,3,%g1	! CC=0
		andcc	%o1,0x80,%g0	!
		add	%g0,0xff,%o1	!
		stb	%o1,[%g4+%o0]	! store 0xff
		bnz,a	t.ts000		! if MSB == 1 then
		or	%g1,1,%g1	!   CC=1
    t.ts000:	add	%g2,4,%g2	! update IAR
t.ts0e:
		ba	break0		!
		nop			!
    t.ts0o0:	add	%l0,0,%o0	! ##TEMPLATE:%l0,imm0

	.section ".text"
	.align	4
	.global ci4_ni,ti4_ni,ii4_ni
ci4_ni:
	retl				!
	add	%g0,t.ni0e-t.ni0s,%o0	!
ti4_ni:
	sethi	%hi(t.ni0s),%o3		!
	or	%o3,%lo(t.ni0s),%o3	!
	or	%g0,t.ni0e-t.ni0s,%o4	!
    t.ni0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.ni0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.ni0o0-t.ni0s],%o5!
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B1
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	and	%o1,0xfff,%o4		! D1
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.ni0t0-t.ni0s]!
	ld	[%o3+t.ni0o1-t.ni0s],%o5!
	srl	%o1,16,%o4		!
	and	%o4,0xff,%o4		! I
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.ni0t1-t.ni0s]!
	retl				!
	add	%o0,t.ni0e-t.ni0s,%o0	!
ii4_ni:
	srl	%o1,12,%o4		! B2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l3		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l3		! %l3
	and	%o1,0xfff,%l4		! D2
	srl	%o1,16,%o4		! I
	and	%o4,0xff,%l1		! %l1
t.ni0s:
    t.ni0t0:	add	%l3,%l4,%o0	! ##TEMPLATE:%l0,imm0
		and	%o0,%g3,%o0	! mask address
		ldub	[%g4+%o0],%o1	!
		andn	%g1,3,%g1	! CC=0
    t.ni0t1:	andcc	%o1,%l1,%o1	! ##TEMPLATE:imm0
		stb	%o1,[%g4+%o0]	!
		bnz,a	t.ni000		! if result != 0 then
		or	%g1,1,%g1	!   CC=1
    t.ni000:	add	%g2,4,%g2	! update IAR
t.ni0e:
		ba	break0		!
		nop			!
    t.ni0o0:	add	%l0,0,%o0	! ##TEMPLATE:%l0,imm0
    t.ni0o1:	andcc	%o1,0,%o1	! ##TEMPLATE:imm0

	.section ".text"
	.align	4
	.global ci4_cli,ti4_cli,ii4_cli
ci4_cli:
	retl				!
	add	%g0,t.cli0e-t.cli0s,%o0	!
ti4_cli:
	sethi	%hi(t.cli0s),%o3	!
	or	%o3,%lo(t.cli0s),%o3	!
	or	%g0,t.cli0e-t.cli0s,%o4	!
    t.cli0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.cli0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.cli0o0-t.cli0s],%o5
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B1
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	and	%o1,0xfff,%o4		! D1
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.cli0t0-t.cli0s]
	ld	[%o3+t.cli0o1-t.cli0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xff,%o4		! I
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.cli0t1-t.cli0s]
	retl				!
	add	%o0,t.cli0e-t.cli0s,%o0	!
ii4_cli:
	srl	%o1,12,%o4		! B2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l3		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l3		! %l3
	and	%o1,0xfff,%l4		! D2
	srl	%o1,16,%o4		! I
	and	%o4,0xff,%l1		! %l1
t.cli0s:
    t.cli0t0:	add	%l3,%l4,%o0	! ##TEMPLATE:%l0,imm0
		and	%o0,%g3,%o0	! mask address
		ldub	[%g4+%o0],%o1	!
		andn	%g1,3,%g1	! CC=0
    t.cli0t1:	subcc	%o1,%l1,%o1	! ##TEMPLATE:imm0
		bgu,a	t.cli001	! if %l0 > 0 then
		or	%g1,2,%g1	!   CC=2
		bcs,a	t.cli001	! if %l0 < 0 then
		or	%g1,1,%g1	!   CC=1
    t.cli001:	add	%g2,4,%g2	! update IAR
t.cli0e:
		ba	break0		!
		nop			!
    t.cli0o0:	add	%l0,0,%o0	! ##TEMPLATE:%l0,imm0
    t.cli0o1:	subcc	%o1,0,%o1	! ##TEMPLATE:imm0

	.section ".text"
	.align	4
	.global ci4_oi,ti4_oi,ii4_oi
ci4_oi:
	retl				!
	add	%g0,t.oi0e-t.oi0s,%o0	!
ti4_oi:
	sethi	%hi(t.oi0s),%o3		!
	or	%o3,%lo(t.oi0s),%o3	!
	or	%g0,t.oi0e-t.oi0s,%o4	!
    t.oi0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.oi0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.oi0o0-t.oi0s],%o5!
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B1
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	and	%o1,0xfff,%o4		! D1
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.oi0t0-t.oi0s]!
	ld	[%o3+t.oi0o1-t.oi0s],%o5!
	srl	%o1,16,%o4		!
	and	%o4,0xff,%o4		! I
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.oi0t1-t.oi0s]!
	retl				!
	add	%o0,t.oi0e-t.oi0s,%o0	!
ii4_oi:
	srl	%o1,12,%o4		! B2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l3		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l3		! %l3
	and	%o1,0xfff,%l4		! D2
	srl	%o1,16,%o4		! I
	and	%o4,0xff,%l1		! %l1
t.oi0s:
    t.oi0t0:	add	%l3,%l4,%o0	! ##TEMPLATE:%l0,imm0
		and	%o0,%g3,%o0	! mask address
		ldub	[%g4+%o0],%o1	!
		andn	%g1,3,%g1	! CC=0
    t.oi0t1:	orcc	%o1,%l1,%o1	! ##TEMPLATE:imm0
		stb	%o1,[%g4+%o0]	!
		bnz,a	t.oi000		! if result != 0 then
		or	%g1,1,%g1	!   CC=1
    t.oi000:	add	%g2,4,%g2	! update IAR
t.oi0e:
		ba	break0		!
		nop			!
    t.oi0o0:	add	%l0,0,%o0	! ##TEMPLATE:%l0,imm0
    t.oi0o1:	orcc	%o1,0,%o1	! ##TEMPLATE:imm0

	.section ".text"
	.align	4
	.global ci4_xi,ti4_xi,ii4_xi
ci4_xi:
	retl				!
	add	%g0,t.xi0e-t.xi0s,%o0	!
ti4_xi:
	sethi	%hi(t.xi0s),%o3		!
	or	%o3,%lo(t.xi0s),%o3	!
	or	%g0,t.xi0e-t.xi0s,%o4	!
    t.xi0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.xi0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.xi0o0-t.xi0s],%o5!
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B1
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	and	%o1,0xfff,%o4		! D1
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.xi0t0-t.xi0s]!
	ld	[%o3+t.xi0o1-t.xi0s],%o5!
	srl	%o1,16,%o4		!
	and	%o4,0xff,%o4		! I
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.xi0t1-t.xi0s]!
	retl				!
	add	%o0,t.xi0e-t.xi0s,%o0	!
ii4_xi:
	srl	%o1,12,%o4		! B2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l3		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l3		! %l3
	and	%o1,0xfff,%l4		! D2
	srl	%o1,16,%o4		! I
	and	%o4,0xff,%l1		! %l1
t.xi0s:
    t.xi0t0:	add	%l3,%l4,%o0	! ##TEMPLATE:%l0,imm0
		and	%o0,%g3,%o0	! mask address
		ldub	[%g4+%o0],%o1	!
		andn	%g1,3,%g1	! CC=0
    t.xi0t1:	xorcc	%o1,%l1,%o1	! ##TEMPLATE:imm0
		stb	%o1,[%g4+%o0]	!
		bnz,a	t.xi000		! if result != 0 then
		or	%g1,1,%g1	!   CC=1
    t.xi000:	add	%g2,4,%g2	! update IAR
t.xi0e:
		ba	break0		!
		nop			!
    t.xi0o0:	add	%l0,0,%o0	! ##TEMPLATE:%l0,imm0
    t.xi0o1:	xorcc	%o1,0,%o1	! ##TEMPLATE:imm0

	.section ".text"
	.align	4
	.global ci4_lm,ti4_lm,ii4_lm
ci4_lm:
	srl	%o1,20,%o3		! R1
	and	%o3,0xf,%o3		!
	srl	%o1,16,%o4		! R3
	and	%o4,0xf,%o4		!
	sub	%o4,%o3,%o4		!
	and	%o4,0xf,%o4		! # of Regs.
	sll	%o4,2,%o4		!
	retl				!
	add	%o4,t.lm0e-t.lm0s,%o0	!
ti4_lm:
	sethi	%hi(t.lm0s),%o3		!
	or	%o3,%lo(t.lm0s),%o3	!
	or	%g0,t.lm0e-t.lm0s,%o4	!
    t.lm0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.lm0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.lm0o0-t.lm0s],%o5!
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.lm0t0-t.lm0s]!

	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		!
	add	%g0,%g0,%o2		! address counter
    t.lm0loop:				!
	ld	[%o3+t.lm0o2-t.lm0s],%o5! get ld template
	subcc	%o4,0xe,%g0		!
	bz,a	.+8			!
	add	%g0,0x16,%o4		!
	sll	%o4,25,%o4		!
	xor	%o5,%o4,%o5		!
	srl	%o4,25,%o4		!
	subcc	%o4,0x16,%g0		!
	bz,a	.+8			!
	add	%g0,0xe,%o4		!
	xor	%o5,%o2,%o5		!
	add	%o0,t.lm0t2-t.lm0s,%o0	!
	st	%o5,[%o0+%o2]		! store ld insn
	sub	%o0,t.lm0t2-t.lm0s,%o0	!
	srl	%o1,16,%o5		!
	and	%o5,0xf,%o5		!
	subcc	%o4,%o5,%g0		!
	be	t.lm0lend		!
	add	%o4,1,%o4		!
	and	%o4,0xf,%o4		!
	add	%o2,4,%o2		!
	ba,a	t.lm0loop		!
    t.lm0lend:				!
	ld	[%o3+t.lm0o1-t.lm0s],%o5!
	add	%o2,3,%o4		!
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.lm0t1-t.lm0s]!

	ld	[%o3+t.lm0o3-t.lm0s],%o5! get template
	add	%o0,t.lm0t2+4-t.lm0s,%o0!
	st	%o5,[%o0+%o2]		! store "add %g2,4,%g2"
	sub	%o0,t.lm0t2+4-t.lm0s,%o0!
	add	%o0,t.lm0e-t.lm0s,%o0	!
	retl				!
	add	%o0,%o2,%o0		!
t.lm0s:
    t.lm0t0:	add	%l0,0,%o0	! ##TEMPLATE:%l0,imm0
		and	%o0,%g3,%o0	! mask address
		add	%g4,%o0,%o0	!
		ldub	[%o0],%g0	! force PAGEIN
    t.lm0t1:	ldub	[%o0+0],%g0	! ##TEMPLATE:imm0
    t.lm0t2:	ld	[%o0+0],%l0	! ##TEMPLATE:%l0
		add	%g2,4,%g2	! update IAR
t.lm0e:
    t.lm0o0:	add	%l0,0,%o0	! ##TEMPLATE:%l0,imm0
    t.lm0o1:	ldub	[%o0+0],%g0	! ##TEMPLATE:imm0
    t.lm0o2:	ld	[%o0+0],%l0	! ##TEMPLATE:%l0
    t.lm0o3:	add	%g2,4,%g2	! ##TEMPLATE:IAR
ii4_lm:
	srl	%o1,12,%o4		! B2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l3		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l3		! %l3
	and	%o1,0xfff,%l4		! D2
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%i0		! %i0
	srl	%o1,16,%o4		! R3-R1+3
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	sub	%o4,%i0,%o4		! |
	and	%o4,0x3f,%o4		! length-1
	add	%o4,3,%i1		! %i1
i.lm0s:
    i.lm0t0:	add	%l3,%l4,%o0	! ##TEMPLATE:%l0,imm0
		and	%o0,%g3,%o0	! mask address
		add	%g4,%o0,%o0	!
		ldub	[%o0],%g0	! force PAGEIN
    i.lm0t1:	ldub	[%o0+%i1],%g0	! ##TEMPLATE:imm0
		add	%g0,%g0,%o1	!
    i.lm0t2:	ld	[%o0+%o1],%l0	! ##TEMPLATE:%l0
		add	%o1,4,%o1	!
		subcc	%o1,%i1,%g0	!
		st	%l0,[%o7+%i0]	! R1->R3
		add	%i0,4,%i0	!
		bl	i.lm0t2		!
		and	%i0,0x3f,%i0	!
		ba	break0		!
		add	%g2,4,%g2	! update IAR
i.lm0e:

	.section ".text"
	.align	4
	.global cc4_9cxx,tc4_9cxx,ic4_9cxx
cc4_9cxx:
	retl				!
	add	%g0,t.9cxx0e-t.9cxx0s,%o0
tc4_9cxx:
	sethi	%hi(t.9cxx0s),%o3	!
	or	%o3,%lo(t.9cxx0s),%o3	!
	or	%g0,t.9cxx0e-t.9cxx0s,%o4
    t.9cxx0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.9cxx0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.9cxx0o0-t.9cxx0s],%o5
	srl	%o1,10,%o4		!
	or	%o5,%o4,%o5		! simm22
	st	%o5,[%o0+t.9cxx0t0-t.9cxx0s]
	ld	[%o3+t.9cxx0o1-t.9cxx0s],%o5
	and	%o1,0xfff,%o4		!
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.9cxx0t1-t.9cxx0s]
	retl				!
	add	%o0,t.9cxx0e-t.9cxx0s,%o0
ic4_9cxx:
t.9cxx0s:
		ld	[%sp+184],%o7	! struct *gcpu_s
    t.9cxx0t0:	sethi	0,%o0		! ##TEMPLATE:imm
    t.9cxx0t1:	or	%o1,0,%o0	! ##TEMPLATE:imm
		st	%o0,[%o7+704]	! store minsn (upper)
		st	%g0,[%o7+708]	! store minsn (lower)
		sethi	%hi(0x80000000),%o0
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! Special Instruction (FC=2)
t.9cxx0e:
    t.9cxx0o0:	sethi	0,%o0		! ##TEMPLATE:imm
    t.9cxx0o1:	or	%o0,0,%o0	! ##TEMPLATE:imm

	.section ".text"
	.align	4
	.global cc4_9dxx,tc4_9dxx,ic4_9dxx
cc4_9dxx:
	retl				!
	add	%g0,t.9dxx0e-t.9dxx0s,%o0
tc4_9dxx:
	sethi	%hi(t.9dxx0s),%o3	!
	or	%o3,%lo(t.9dxx0s),%o3	!
	or	%g0,t.9dxx0e-t.9dxx0s,%o4
    t.9dxx0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.9dxx0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.9dxx0o0-t.9dxx0s],%o5
	srl	%o1,10,%o4		!
	or	%o5,%o4,%o5		! simm22
	st	%o5,[%o0+t.9dxx0t0-t.9dxx0s]
	ld	[%o3+t.9dxx0o1-t.9dxx0s],%o5
	and	%o1,0xfff,%o4		!
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.9dxx0t1-t.9dxx0s]
	retl				!
	add	%o0,t.9dxx0e-t.9dxx0s,%o0
ic4_9dxx:
t.9dxx0s:
		ld	[%sp+184],%o7	! struct *gcpu_s
    t.9dxx0t0:	sethi	0,%o0		! ##TEMPLATE:imm
    t.9dxx0t1:	or	%o1,0,%o0	! ##TEMPLATE:imm
		st	%o0,[%o7+704]	! store minsn (upper)
		st	%g0,[%o7+708]	! store minsn (lower)
		sethi	%hi(0x80000000),%o0
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! Special Instruction (FC=2)
t.9dxx0e:
    t.9dxx0o0:	sethi	0,%o0		! ##TEMPLATE:imm
    t.9dxx0o1:	or	%o0,0,%o0	! ##TEMPLATE:imm

	.section ".text"
	.align	4
	.global cc4_9exx,tc4_9exx,ic4_9exx
cc4_9exx:
	retl				!
	add	%g0,t.9exx0e-t.9exx0s,%o0
tc4_9exx:
	sethi	%hi(t.9exx0s),%o3	!
	or	%o3,%lo(t.9exx0s),%o3	!
	or	%g0,t.9exx0e-t.9exx0s,%o4
    t.9exx0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.9exx0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.9exx0o0-t.9exx0s],%o5
	srl	%o1,10,%o4		!
	or	%o5,%o4,%o5		! simm22
	st	%o5,[%o0+t.9exx0t0-t.9exx0s]
	ld	[%o3+t.9exx0o1-t.9exx0s],%o5
	and	%o1,0xfff,%o4		!
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.9exx0t1-t.9exx0s]
	retl				!
	add	%o0,t.9exx0e-t.9exx0s,%o0
ic4_9exx:
t.9exx0s:
		ld	[%sp+184],%o7	! struct *gcpu_s
    t.9exx0t0:	sethi	0,%o0		! ##TEMPLATE:imm
    t.9exx0t1:	or	%o1,0,%o0	! ##TEMPLATE:imm
		st	%o0,[%o7+704]	! store minsn (upper)
		st	%g0,[%o7+708]	! store minsn (lower)
		sethi	%hi(0x80000000),%o0
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! Special Instruction (FC=2)
t.9exx0e:
    t.9exx0o0:	sethi	0,%o0		! ##TEMPLATE:imm
    t.9exx0o1:	or	%o0,0,%o0	! ##TEMPLATE:imm

	.section ".text"
	.align	4
	.global cc4_9fxx,tc4_9fxx,ic4_9fxx
cc4_9fxx:
	retl				!
	add	%g0,t.9fxx0e-t.9fxx0s,%o0
tc4_9fxx:
	sethi	%hi(t.9fxx0s),%o3	!
	or	%o3,%lo(t.9fxx0s),%o3	!
	or	%g0,t.9fxx0e-t.9fxx0s,%o4
    t.9fxx0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.9fxx0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.9fxx0o0-t.9fxx0s],%o5
	srl	%o1,10,%o4		!
	or	%o5,%o4,%o5		! simm22
	st	%o5,[%o0+t.9fxx0t0-t.9fxx0s]
	ld	[%o3+t.9fxx0o1-t.9fxx0s],%o5
	and	%o1,0xfff,%o4		!
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.9fxx0t1-t.9fxx0s]
	retl				!
	add	%o0,t.9fxx0e-t.9fxx0s,%o0
ic4_9fxx:
t.9fxx0s:
		ld	[%sp+184],%o7	! struct *gcpu_s
    t.9fxx0t0:	sethi	0,%o0		! ##TEMPLATE:imm
    t.9fxx0t1:	or	%o1,0,%o0	! ##TEMPLATE:imm
		st	%o0,[%o7+704]	! store minsn (upper)
		st	%g0,[%o7+708]	! store minsn (lower)
		sethi	%hi(0x80000000),%o0
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! Special Instruction (FC=2)
t.9fxx0e:
    t.9fxx0o0:	sethi	0,%o0		! ##TEMPLATE:imm
    t.9fxx0o1:	or	%o0,0,%o0	! ##TEMPLATE:imm
!================================

!
! templates
! cxx_xxx:
!   %o0: param: none
!	 retval:size of template
!   %o1: M instruction (4 bytes)
!   %o2: work
!   %o3: work
!   %o4: work
!   %o5: work
! txx_xxx:
!   %o0: param: bufp start address
!	 retval:bufp next start address
!   %o1: M instruction (4 bytes)
!   %o2: work
!   %o3: work
!   %o4: work
!   %o5: work
!
	.section ".text"
	.align	4
	.global ci4_ai,ti4_ai,ii4_ai
ci4_ai:
	retl				!
	add	%g0,t.ai0e-t.ai0s,%o0	!
ti4_ai:
	sethi	%hi(t.ai0s),%o3		!
	or	%o3,%lo(t.ai0s),%o3	!
	or	%g0,t.ai0e-t.ai0s,%o4	!
    t.ai0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.ai0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.ai0o0-t.ai0s],%o5!
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B1
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	and	%o1,0xfff,%o4		! D1
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.ai0t0-t.ai0s]!
	ld	[%o3+t.ai0o1-t.ai0s],%o5!
	srl	%o1,16,%o4		!
	and	%o4,0xff,%o4		! I
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.ai0t1-t.ai0s]!
	retl				!
	add	%o0,t.ai0e-t.ai0s,%o0	!
ii4_ai:
	srl	%o1,12,%o4		! B2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l3		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l3		! %l3
	and	%o1,0xfff,%l4		! D2
	srl	%o1,16,%o4		! I
	and	%o4,0xff,%l1		! %l1
t.ai0s:
    t.ai0t0:	add	%l3,%l4,%o0	! ##TEMPLATE:%l0,imm0
		and	%o0,%g3,%o0	! mask address
		ldub	[%g4+%o0],%o1	!
		andn	%g1,3,%g1	! CC=0
    t.ai0t1:	add	%o1,%l1,%o1	! ##TEMPLATE:imm0
		stb	%o1,[%g4+%o0]	!
		andcc	%o1,0xff,%g0	!
		bnz,a	t.ai000		! if result != 0 then
		or	%g1,1,%g1	!   CC=1,3
    t.ai000:	andncc	%o1,0xff,%g0	!
		bnz,a	t.ai001		! if carry then
		or	%g1,2,%g1	!   CC=2,4
    t.ai001:	add	%g2,4,%g2	! update IAR
t.ai0e:
		ba	break0		!
		nop			!
    t.ai0o0:	add	%l0,0,%o0	! ##TEMPLATE:%l0,imm0
    t.ai0o1:	add	%o1,0,%o1	! ##TEMPLATE:imm0

	.section ".text"
	.align	4
	.global ci4_stext,ti4_stext,ii4_stext
ci4_stext:
	retl				!
	add	%g0,t.stext0e-t.stext0s,%o0
ti4_stext:
	sethi	%hi(t.stext0s),%o3	!
	or	%o3,%lo(t.stext0s),%o3	!
	or	%g0,t.stext0e-t.stext0s,%o4
    t.stext0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.stext0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.stext0o0-t.stext0s],%o5
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.stext0t0-t.stext0s]
	ld	[%o3+t.stext0o1-t.stext0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R3
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+t.stext0t1-t.stext0s]
	ld	[%o3+t.stext0o2-t.stext0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R3
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	st	%o5,[%o0+t.stext0t2-t.stext0s]
	retl				!
	add	%o0,t.stext0e-t.stext0s,%o0
ii4_stext:
	srl	%o1,12,%o4		! B2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l3		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l3		! %l3
	and	%o1,0xfff,%l4		! D2
	srl	%o1,16,%o4		! R3
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l2		! %l2
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l0		! %l0
t.stext0s:
    t.stext0t0:	add	%l3,%l4,%o0	! ##TEMPLATE:%l0,imm0
		and	%o0,%g3,%o0	! mask address
		ld	[%g4+%o0],%o1	!
    t.stext0t1:	and	%l0,%l2,%o2	! ##TEMPLATE:%l0,%l0
    t.stext0t2:	andn	%o1,%l2,%o1	! ##TEMPLATE:%l0
		or	%o1,%o2,%o1	!
		st	%o1,[%g4+%o0]	!
		add	%g2,4,%g2	! update IAR
t.stext0e:
		ba	break0		!
		nop			!
    t.stext0o0:	add	%l0,0,%o0	! ##TEMPLATE:%l0,imm0
    t.stext0o1:	and	%l0,%l0,%o2	! ##TEMPLATE:%l0,%l0
    t.stext0o2:	andn	%o1,%l0,%o1	! ##TEMPLATE:%l0

	.section ".text"
	.align	4
	.global ci4_svg,ti4_svg,ii4_svg
ci4_svg:
	srl	%o1,20,%o3		! R1
	and	%o3,0xf,%o3		!
	srl	%o1,16,%o4		! R3
	and	%o4,0xf,%o4		!	
	sub	%o4,%o3,%o5		!
	and	%o5,0xf,%o5		! # of Regs.
	sub	%o4,13,%o4		!
	and	%o4,0xf,%o4		! # of Regs. after #13
	subcc	%o5,%o4,%g0		!
	bge	c.svg1c			!
	nop				!
    c.svg0c:				!
	sll	%o5,2,%o5		!
	retl				!
	add	%o5,t.svg0e-t.svg0s,%o0	! #13 will not be saved
    c.svg1c:				!
	retl				!
	add	%g0,t.svg1e-t.svg1s,%o0	! #13 will be saved
ti4_svg:
	srl	%o1,20,%o3		! R1
	and	%o3,0xf,%o3		!
	srl	%o1,16,%o4		! R3
	and	%o4,0xf,%o4		!	
	sub	%o4,%o3,%o5		!
	and	%o5,0xf,%o5		! # of Regs.
	sub	%o4,13,%o4		!
	and	%o4,0xf,%o4		! # of Regs. after #13
	subcc	%o5,%o4,%g0		!
	bge	t.svg1t			!
	nop				!
    t.svg0t:				!
	sethi	%hi(t.svg0s),%o3	!
	or	%o3,%lo(t.svg0s),%o3	!
	or	%g0,t.svg0e-t.svg0s,%o4	!
    t.svg0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.svg0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.svg0o0-t.svg0s],%o5
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.svg0t0-t.svg0s]

	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		!
	add	%g0,%g0,%o2		! address counter
    t.svg0loop:				!
	ld	[%o3+t.svg0o2-t.svg0s],%o5
	subcc	%o4,0xe,%g0		!
	bz,a	.+8			!
	add	%g0,0x16,%o4		!
	sll	%o4,25,%o4		!
	xor	%o5,%o4,%o5		!
	srl	%o4,25,%o4		!
	subcc	%o4,0x16,%g0		!
	bz,a	.+8			!
	add	%g0,0xe,%o4		!
	sub	%o4,14,%o4		! 14,15,0,1,2,....,12
	and	%o4,0xf,%o4		! get store offset in %o4
	sll	%o4,2,%o4		!
	add	%o4,12,%o4		!
	xor	%o5,%o4,%o5		! 
	sub	%o4,12,%o4		! restore %o4
	srl	%o4,2,%o4		!
	add	%o4,14,%o4		!
	and	%o4,0xf,%o4		! %o4 restored 
	add	%o0,t.svg0t2-t.svg0s,%o0!
	st	%o5,[%o0+%o2]		! store st insn
	sub	%o0,t.svg0t2-t.svg0s,%o0!
	srl	%o1,16,%o5		!
	and	%o5,0xf,%o5		!
	subcc	%o4,%o5,%g0		!
	be	t.svg0lend		!
	nop				!
	add	%o4,1,%o4		!
	and	%o4,0xf,%o4		!
	add	%o2,4,%o2		!
	ba,a	t.svg0loop		!
    t.svg0lend:				!
	ld	[%o3+t.svg0o1-t.svg0s],%o5
	sub	%o4,14,%o4		! 14,15,0,1,2,....,12
	and	%o4,0xf,%o4		! get store offset in %o4
	sll	%o4,2,%o4		!
	add	%o4,15,%o4		!
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.svg0t1-t.svg0s]

	ld	[%o3+t.svg0o3-t.svg0s],%o5
	add	%o0,t.svg0t2+4-t.svg0s,%o0
	st	%o5,[%o0+%o2]		! store "st %i5,[%o1+4]"
	sub	%o0,t.svg0t2+4-t.svg0s,%o0
	ld	[%o3+t.svg0o4-t.svg0s],%o5
	add	%o0,t.svg0t2+8-t.svg0s,%o0
	st	%o5,[%o0+%o2]		! store "add %o1,%g0,%i5"
	sub	%o0,t.svg0t2+8-t.svg0s,%o0
	ld	[%o3+t.svg0o5-t.svg0s],%o5
	add	%o0,t.svg0t2+12-t.svg0s,%o0
	st	%o5,[%o0+%o2]		! store "add %g2,4,%g2"
	sub	%o0,t.svg0t2+12-t.svg0s,%o0
	add	%o0,t.svg0e-t.svg0s,%o0	!
	retl				!
	add	%o0,%o2,%o0		!
    t.svg1t:				!
	sethi	%hi(t.svg1s),%o3	!
	or	%o3,%lo(t.svg1s),%o3	!
	or	%g0,t.svg1e-t.svg1s,%o4	!
    t.svg1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.svg1cp		!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,t.svg1e-t.svg1s,%o0	!
t.svg0s:
		sethi	%hi(0xff000000),%o0
		andn	%i5,%o0,%o0	!
		add	%g4,%o0,%o0	!
		ldub	[%o0+8],%g0	! force PAGEIN
    t.svg0t1:	ldub	[%o0+0],%g0	! ##TEMPLATE:imm0
    t.svg0t0:	add	%l0,0,%o1	! ##TEMPLATE:%l0,imm0
		and	%o1,%g3,%o2	! mask address
		add	%g4,%o2,%o2	!
		ldub	[%o2+4],%g0	! force PAGEIN
		ldub	[%o2+7],%g0	! force PAGEIN
		st	%o1,[%o0+8]	! store OP2
    t.svg0t2:	st	%l0,[%o0+0]	! ##TEMPLATE:%l0
		st	%i5,[%o2+4]	! store old #13
		add	%o1,%g0,%i5	! move OP2 to #13
		add	%g2,4,%g2	! update IAR
t.svg0e:
    t.svg0o0:	add	%l0,0,%o1	! ##TEMPLATE:%l0,imm0
    t.svg0o1:	ldub	[%o0+0],%g0	! ##TEMPLATE:imm0
    t.svg0o2:	st	%l0,[%o0+0]	! ##TEMPLATE:%l0
    t.svg0o3:	st	%i5,[%o2+4]	! ##TEMPLATE:#13
    t.svg0o4:	add	%o1,%g0,%i5	! ##TEMPLATE:#13
    t.svg0o5:	add	%g2,4,%g2	! ##TEMPLATE:IAR
t.svg1s:
		sethi	%hi(0x00060000),%o0
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! specification exception
t.svg1e:
ii4_svg:
	srl	%o1,20,%o3		! R1
	and	%o3,0xf,%o3		!
	srl	%o1,16,%o4		! R3
	and	%o4,0xf,%o4		!	
	sub	%o4,%o3,%o5		!
	and	%o5,0xf,%o5		! # of Regs.
	sub	%o4,13,%o4		!
	and	%o4,0xf,%o4		! # of Regs. after #13
	subcc	%o5,%o4,%g0		!
	bge	t.svg1s			!
	nop				!
    i.svg0t:				!
	srl	%o1,12,%o4		! B2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l3		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l3		! %l3
	and	%o1,0xfff,%l4		! D2
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%i0		! %i0
	srl	%o1,16,%o4		! R3
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%i1		! %i1
i.svg0s:
		sethi	%hi(0xff000000),%o0
		ld	[%o7+52],%i5	! load #13
		andn	%i5,%o0,%o0	!
		add	%g4,%o0,%o0	!
		ldub	[%o0+8],%g0	! force PAGEIN
		sub	%i1,56,%l1	!
		and	%l1,0x3f,%l1	!
		add	%l1,15,%l1	!
		ldub	[%o0+%l1],%g0	! force PAGEIN
    i.svg0t0:	add	%l3,%l4,%o1	! ##TEMPLATE:%l0,imm0
		and	%o1,%g3,%o2	! mask address
		add	%g4,%o2,%o2	!
		ldub	[%o2+4],%g0	! force PAGEIN
		ldub	[%o2+7],%g0	! force PAGEIN
		st	%o1,[%o0+8]	! store OP2
    i.svg0t2:	ld	[%o7+%i0],%l0	! R1->R3
		sub	%i0,56,%l2	!
		and	%l2,0x3f,%l2	!
		add	%l2,12,%l2	!
		st	%l0,[%o0+%l2]	!
		subcc	%i0,%i1,%g0	!
		add	%i0,4,%i0	!
		bne	i.svg0t2	!
		and	%i0,0x3f,%i0	!
		st	%i5,[%o2+4]	! store old #13
		st	%o1,[%o7+52]	! move OP2 to #13
		ba	break0		!
		add	%g2,4,%g2	! update IAR
i.svg0e:

	.section ".text"
	.align	4
	.global cc4_stnsm,tc4_stnsm,ic4_stnsm
cc4_stnsm:
	retl				!
	add	%g0,t.stnsm0e-t.stnsm0s,%o0
tc4_stnsm:
	sethi	%hi(t.stnsm0s),%o3	!
	or	%o3,%lo(t.stnsm0s),%o3	!
	or	%g0,t.stnsm0e-t.stnsm0s,%o4
    t.stnsm0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.stnsm0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.stnsm0o0-t.stnsm0s],%o5
	srl	%o1,10,%o4		!
	or	%o5,%o4,%o5		! simm22
	st	%o5,[%o0+t.stnsm0t0-t.stnsm0s]
	ld	[%o3+t.stnsm0o1-t.stnsm0s],%o5
	and	%o1,0xfff,%o4		!
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.stnsm0t1-t.stnsm0s]
	retl				!
	add	%o0,t.stnsm0e-t.stnsm0s,%o0
ic4_stnsm:
t.stnsm0s:
		ld	[%sp+184],%o7	! struct *gcpu_s
    t.stnsm0t0:	sethi	0,%o0		! ##TEMPLATE:imm
    t.stnsm0t1:	or	%o1,0,%o0	! ##TEMPLATE:imm
		st	%o0,[%o7+704]	! store minsn (upper)
		st	%g0,[%o7+708]	! store minsn (lower)
		sethi	%hi(0x80000000),%o0
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! Special Instruction (FC=2)
t.stnsm0e:
    t.stnsm0o0:	sethi	0,%o0		! ##TEMPLATE:imm
    t.stnsm0o1:	or	%o0,0,%o0	! ##TEMPLATE:imm

	.section ".text"
	.align	4
	.global cc4_stosm,tc4_stosm,ic4_stosm
cc4_stosm:
	retl				!
	add	%g0,t.stosm0e-t.stosm0s,%o0
tc4_stosm:
	sethi	%hi(t.stosm0s),%o3	!
	or	%o3,%lo(t.stosm0s),%o3	!
	or	%g0,t.stosm0e-t.stosm0s,%o4
    t.stosm0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.stosm0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.stosm0o0-t.stosm0s],%o5
	srl	%o1,10,%o4		!
	or	%o5,%o4,%o5		! simm22
	st	%o5,[%o0+t.stosm0t0-t.stosm0s]
	ld	[%o3+t.stosm0o1-t.stosm0s],%o5
	and	%o1,0xfff,%o4		!
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.stosm0t1-t.stosm0s]
	retl				!
	add	%o0,t.stosm0e-t.stosm0s,%o0
ic4_stosm:
t.stosm0s:
		ld	[%sp+184],%o7	! struct *gcpu_s
    t.stosm0t0:	sethi	0,%o0		! ##TEMPLATE:imm
    t.stosm0t1:	or	%o1,0,%o0	! ##TEMPLATE:imm
		st	%o0,[%o7+704]	! store minsn (upper)
		st	%g0,[%o7+708]	! store minsn (lower)
		sethi	%hi(0x80000000),%o0
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! Special Instruction (FC=2)
t.stosm0e:
    t.stosm0o0:	sethi	0,%o0		! ##TEMPLATE:imm
    t.stosm0o1:	or	%o0,0,%o0	! ##TEMPLATE:imm

	.section ".text"
	.align	4
	.global cc4_sigp,tc4_sigp,ic4_sigp
cc4_sigp:
	retl				!
	add	%g0,t.sigp0e-t.sigp0s,%o0
tc4_sigp:
	sethi	%hi(t.sigp0s),%o3	!
	or	%o3,%lo(t.sigp0s),%o3	!
	or	%g0,t.sigp0e-t.sigp0s,%o4
    t.sigp0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.sigp0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.sigp0o0-t.sigp0s],%o5
	srl	%o1,10,%o4		!
	or	%o5,%o4,%o5		! simm22
	st	%o5,[%o0+t.sigp0t0-t.sigp0s]
	ld	[%o3+t.sigp0o1-t.sigp0s],%o5
	and	%o1,0xfff,%o4		!
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.sigp0t1-t.sigp0s]
	retl				!
	add	%o0,t.sigp0e-t.sigp0s,%o0
ic4_sigp:
t.sigp0s:
		ld	[%sp+184],%o7	! struct *gcpu_s
    t.sigp0t0:	sethi	0,%o0		! ##TEMPLATE:imm
    t.sigp0t1:	or	%o1,0,%o0	! ##TEMPLATE:imm
		st	%o0,[%o7+704]	! store minsn (upper)
		st	%g0,[%o7+708]	! store minsn (lower)
		sethi	%hi(0x80000000),%o0
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! Special Instruction (FC=2)
t.sigp0e:
    t.sigp0o0:	sethi	0,%o0		! ##TEMPLATE:imm
    t.sigp0o1:	or	%o0,0,%o0	! ##TEMPLATE:imm

	.section ".text"
	.align	4
	.global ci4_mc,ti4_mc,ii4_mc
ci4_mc:
	srl	%o1,20,%o3		! switch (upper 4bit of I2)
	andcc	%o3,15,%g0		!
	bnz	c.mc1c			!
	nop				!
    c.mc0c:				!
	retl				! case 0:
	add	%g0,t.mc0e-t.mc0s,%o0	!
    c.mc1c:				!
	retl				! case nonzero:
	add	%g0,t.mc1e-t.mc1s,%o0	!   specification exception
ti4_mc:
	srl	%o1,20,%o3		! switch (upper 4bit of I2)
	andcc	%o3,15,%g0		!
	bnz	t.mc1t			!
	nop				!
    t.mc0t:				!
	sethi	%hi(t.mc0s),%o3		!
	or	%o3,%lo(t.mc0s),%o3	!
	or	%g0,t.mc0e-t.mc0s,%o4	!
    t.mc0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.mc0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.mc0o0-t.mc0s],%o5!
	srl	%o1,10,%o4		!
	or	%o5,%o4,%o5		! simm22
	st	%o5,[%o0+t.mc0t0-t.mc0s]!
	ld	[%o3+t.mc0o1-t.mc0s],%o5!
	and	%o1,0xfff,%o4		!
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.mc0t1-t.mc0s]!
	retl				!
	add	%o0,t.mc0e-t.mc0s,%o0	!
    t.mc1t:				!
	sethi	%hi(t.mc1s),%o3		!
	or	%o3,%lo(t.mc1s),%o3	!
	or	%g0,t.mc1e-t.mc1s,%o4	!
    t.mc1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.mc1cp			!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,t.mc1e-t.mc1s,%o0	!
ii4_mc:
	srl	%o1,20,%o3		! switch (upper 4bit of I2)
	andcc	%o3,15,%g0		!
	bnz	t.mc1s			!
	nop				!
t.mc0s:
		ld	[%sp+184],%o7	! struct *gcpu_s
		lduh	[%o0+226],%o0	! get CR8.[16-31]
		subcc	%o0,%g0,%g0	!
		bz,a	t.mc0e		!
		add	%g2,4,%g2	!
    t.mc0t0:	sethi	0,%o0		! ##TEMPLATE:imm
    t.mc0t1:	or	%o1,0,%o0	! ##TEMPLATE:imm
		st	%o0,[%o7+704]	! store minsn (upper)
		st	%g0,[%o7+708]	! store minsn (lower)
		sethi	%hi(0x80000000),%o0
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! Special Instruction (FC=2)
t.mc0e:
		ba	break0		!
		nop			!
    t.mc0o0:	sethi	0,%o0		! ##TEMPLATE:imm
    t.mc0o1:	or	%o0,0,%o0	! ##TEMPLATE:imm
t.mc1s:
		sethi	%hi(0x00060000),%o0
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! specification exception
t.mc1e:
!================================

!
! templates
! cxx_xxx:
!   %o0: param: none
!	 retval:size of template
!   %o1: M instruction (4 bytes)
!   %o2: work
!   %o3: work
!   %o4: work
!   %o5: work
! txx_xxx:
!   %o0: param: bufp start address
!	 retval:bufp next start address
!   %o1: M instruction (4 bytes)
!   %o2: work
!   %o3: work
!   %o4: work
!   %o5: work
!
	.section ".text"
	.align	4
	.global cc4_lra,tc4_lra,ic4_lra
cc4_lra:
	retl				!
	add	%g0,t.lra0e-t.lra0s,%o0	!
tc4_lra:
	sethi	%hi(t.lra0s),%o3	!
	or	%o3,%lo(t.lra0s),%o3	!
	or	%g0,t.lra0e-t.lra0s,%o4	!
    t.lra0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.lra0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.lra0o0-t.lra0s],%o5
	srl	%o1,10,%o4		!
	or	%o5,%o4,%o5		! simm22
	st	%o5,[%o0+t.lra0t0-t.lra0s]
	ld	[%o3+t.lra0o1-t.lra0s],%o5
	and	%o1,0xfff,%o4		!
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.lra0t1-t.lra0s]
	retl				!
	add	%o0,t.lra0e-t.lra0s,%o0	!
ic4_lra:
t.lra0s:
		ld	[%sp+184],%o7	! struct *gcpu_s
    t.lra0t0:	sethi	0,%o0		! ##TEMPLATE:imm
    t.lra0t1:	or	%o1,0,%o0	! ##TEMPLATE:imm
		st	%o0,[%o7+704]	! store minsn (upper)
		st	%g0,[%o7+708]	! store minsn (lower)
		sethi	%hi(0x80000000),%o0
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! Special Instruction (FC=2)
t.lra0e:
    t.lra0o0:	sethi	0,%o0		! ##TEMPLATE:imm
    t.lra0o1:	or	%o0,0,%o0	! ##TEMPLATE:imm

	.section ".text"
	.align	4
	.global cc4_b2xx,tc4_b2xx,ic4_b2xx
cc4_b2xx:
	retl				!
	add	%g0,t.b2xx0e-t.b2xx0s,%o0
tc4_b2xx:
	sethi	%hi(t.b2xx0s),%o3	!
	or	%o3,%lo(t.b2xx0s),%o3	!
	or	%g0,t.b2xx0e-t.b2xx0s,%o4
    t.b2xx0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.b2xx0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.b2xx0o0-t.b2xx0s],%o5
	srl	%o1,10,%o4		!
	or	%o5,%o4,%o5		! simm22
	st	%o5,[%o0+t.b2xx0t0-t.b2xx0s]
	ld	[%o3+t.b2xx0o1-t.b2xx0s],%o5
	and	%o1,0xfff,%o4		!
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.b2xx0t1-t.b2xx0s]
	retl				!
	add	%o0,t.b2xx0e-t.b2xx0s,%o0
ic4_b2xx:
t.b2xx0s:
		ld	[%sp+184],%o7	! struct *gcpu_s
    t.b2xx0t0:	sethi	0,%o0		! ##TEMPLATE:imm
    t.b2xx0t1:	or	%o1,0,%o0	! ##TEMPLATE:imm
		st	%o0,[%o7+704]	! store minsn (upper)
		st	%g0,[%o7+708]	! store minsn (lower)
		sethi	%hi(0x80000000),%o0
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! Special Instruction (FC=2)
t.b2xx0e:
    t.b2xx0o0:	sethi	0,%o0		! ##TEMPLATE:imm
    t.b2xx0o1:	or	%o0,0,%o0	! ##TEMPLATE:imm

	.section ".text"
	.align	4
	.global ci4_ipm,ti4_ipm,ii4_ipm
ci4_ipm:
	retl				!
	add	%g0,t.ipm0e-t.ipm0s,%o0	!
ti4_ipm:
	sethi	%hi(t.ipm0s),%o3	!
	or	%o3,%lo(t.ipm0s),%o3	!
	or	%g0,t.ipm0e-t.ipm0s,%o4	!
    t.ipm0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.ipm0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.ipm0o0-t.ipm0s],%o5
	srl	%o1,4,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+t.ipm0t0-t.ipm0s]
	ld	[%o3+t.ipm0o1-t.ipm0s],%o5
	srl	%o1,4,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,25,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+t.ipm0t1-t.ipm0s]
	retl				!
	add	%o0,t.ipm0e-t.ipm0s,%o0	!
ii4_ipm:
	srl	%o1,4,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%i0		! save as %i0
	ld	[%o7+%i0],%l0		! %l0
t.ipm0s:
		sethi	%hi(0xff000000),%o1
    t.ipm0t0:	andn	%l0,%o1,%o2	! ##TEMPLATE:%l0
		sll	%g1,28,%o1	! CC
		or	%o1,%o2,%o2	!
		and	%g7,0xf,%o1	! Prog-Mask
		sll	%o1,24,%o1	!
    t.ipm0t1:	or	%o1,%o2,%l0	! ##TEMPLATE:%l0
		add	%g2,4,%g2	! update IAR
t.ipm0e:
		ba	break0		!
		st	%l0,[%o7+%i0]	! R1
    t.ipm0o0:	andn	%l0,%o1,%o2	! ##TEMPLATE:%l0
    t.ipm0o1:	or	%o1,%o2,%l0	! ##TEMPLATE:%l0

	.section ".text"
	.align	4
	.global cf4_dxr,tf4_dxr,if4_dxr
cf4_dxr:
	srl	%o1,4,%o3		! switch (R1)
	srl	%o1,0,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,3,%g0		!
	bnz	c.dxr1c			!
	nop				!
    c.dxr0c:				!
	retl				! case even:
	add	%g0,t.dxr0e-t.dxr0s,%o0	!
    c.dxr1c:				!
	retl				! case odd:
	add	%g0,t.dxr1e-t.dxr1s,%o0	!   specification exception
tf4_dxr:
	srl	%o1,4,%o3		! switch (R1)
	srl	%o1,0,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,3,%g0		!
	bnz	t.dxr1t			!
	nop				!
    t.dxr0t:				!
	sethi	%hi(t.dxr0s),%o3	!
	or	%o3,%lo(t.dxr0s),%o3	!
	or	%g0,t.dxr0e-t.dxr0s,%o4	!
    t.dxr0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.dxr0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.dxr0o0-t.dxr0s],%o5
	srl	%o1,0,%o4		!
	and	%o4,0xf,%o4		! R2
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+t.dxr0t0-t.dxr0s]
	ld	[%o3+t.dxr0o1-t.dxr0s],%o5
	srl	%o1,4,%o4		!
	and	%o4,0xf,%o4		! R1
	sll	%o4,2,%o4		! |
	or	%o5,%o4,%o5		! imm6
	st	%o5,[%o0+t.dxr0t1-t.dxr0s]
	retl				!
	add	%o0,t.dxr0e-t.dxr0s,%o0	!
    t.dxr1t:				!
	sethi	%hi(t.dxr1s),%o3	!
	or	%o3,%lo(t.dxr1s),%o3	!
	or	%g0,t.dxr1e-t.dxr1s,%o4	!
    t.dxr1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.dxr1cp		!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,t.dxr1e-t.dxr1s,%o0	!
if4_dxr:
	srl	%o1,4,%o3		! switch (R1)
	srl	%o1,0,%o4		! switch (R2)
	or	%o3,%o4,%o5		!
	andcc	%o5,3,%g0		!
	bnz	t.dxr1s			!
	nop				!
    i.dxr0t:				!
	srl	%o1,0,%o4		! R2
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	add	%o4,64,%i2		! %i2
	srl	%o1,4,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	add	%o4,64,%i0		! %i0
t.dxr0s:
		ld	[%sp+184],%o0	! struct *gcpu_s
    t.dxr0t0:	add	%o0,%i2,%o2	! ##TEMPLATE:%imm
    t.dxr0t1:	add	%o0,%i0,%o1	! ##TEMPLATE:%imm
		and	%g7,0xf,%o3	! give Program Mask
		stx	%g1,[%o0+648]	!
		stx	%g2,[%o0+656]	!
		stx	%g3,[%o0+664]	!
		stx	%g4,[%o0+672]	!
		stx	%g5,[%o0+680]	!
		sethi	%hi(fl_div_ext),%o7
		jmpl	%o7+%lo(fl_div_ext),%o7
		nop			! call library in fltlib.s
		ld	[%sp+184],%o7	! struct *gcpu_s
		ldx	[%o7+648],%g1	!
		ldx	[%o7+656],%g2	!
		ldx	[%o7+664],%g3	!
		ldx	[%o7+672],%g4	!
		ldx	[%o7+680],%g5	!
		sethi	%hi(0x00ff0000),%o1
		andcc	%o0,%o1,%o0	! extract exception
		bz,a	t.dxr0e		!   exit
		add	%g2,4,%g2	! update IAR
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! INTR-CODE=retval
t.dxr0e:
		ba	break0		!
		nop			!
    t.dxr0o0:	add	%o0,64,%o2	! ##TEMPLATE:%imm
    t.dxr0o1:	add	%o0,64,%o1	! ##TEMPLATE:%imm
t.dxr1s:
		sethi	%hi(0x00060000),%o0
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! specification exception
t.dxr1e:

	.section ".text"
	.align	4
	.global cc4_stctl,tc4_stctl,ic4_stctl
cc4_stctl:
	retl				!
	add	%g0,t.stctl0e-t.stctl0s,%o0
tc4_stctl:
	sethi	%hi(t.stctl0s),%o3	!
	or	%o3,%lo(t.stctl0s),%o3	!
	or	%g0,t.stctl0e-t.stctl0s,%o4
    t.stctl0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.stctl0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.stctl0o0-t.stctl0s],%o5
	srl	%o1,10,%o4		!
	or	%o5,%o4,%o5		! simm22
	st	%o5,[%o0+t.stctl0t0-t.stctl0s]
	ld	[%o3+t.stctl0o1-t.stctl0s],%o5
	and	%o1,0xfff,%o4		!
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.stctl0t1-t.stctl0s]
	retl				!
	add	%o0,t.stctl0e-t.stctl0s,%o0
ic4_stctl:
t.stctl0s:
		ld	[%sp+184],%o7	! struct *gcpu_s
    t.stctl0t0:	sethi	0,%o0		! ##TEMPLATE:imm
    t.stctl0t1:	or	%o1,0,%o0	! ##TEMPLATE:imm
		st	%o0,[%o7+704]	! store minsn (upper)
		st	%g0,[%o7+708]	! store minsn (lower)
		sethi	%hi(0x80000000),%o0
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! Special Instruction (FC=2)
t.stctl0e:
    t.stctl0o0:	sethi	0,%o0		! ##TEMPLATE:imm
    t.stctl0o1:	or	%o0,0,%o0	! ##TEMPLATE:imm

	.section ".text"
	.align	4
	.global cc4_lctl,tc4_lctl,ic4_lctl
cc4_lctl:
	retl				!
	add	%g0,t.lctl0e-t.lctl0s,%o0
tc4_lctl:
	sethi	%hi(t.lctl0s),%o3	!
	or	%o3,%lo(t.lctl0s),%o3	!
	or	%g0,t.lctl0e-t.lctl0s,%o4
    t.lctl0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.lctl0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.lctl0o0-t.lctl0s],%o5
	srl	%o1,10,%o4		!
	or	%o5,%o4,%o5		! simm22
	st	%o5,[%o0+t.lctl0t0-t.lctl0s]
	ld	[%o3+t.lctl0o1-t.lctl0s],%o5
	and	%o1,0xfff,%o4		!
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.lctl0t1-t.lctl0s]
	retl				!
	add	%o0,t.lctl0e-t.lctl0s,%o0
ic4_lctl:
t.lctl0s:
		ld	[%sp+184],%o7	! struct *gcpu_s
    t.lctl0t0:	sethi	0,%o0		! ##TEMPLATE:imm
    t.lctl0t1:	or	%o1,0,%o0	! ##TEMPLATE:imm
		st	%o0,[%o7+704]	! store minsn (upper)
		st	%g0,[%o7+708]	! store minsn (lower)
		sethi	%hi(0x80000000),%o0
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! Special Instruction (FC=2)
t.lctl0e:
    t.lctl0o0:	sethi	0,%o0		! ##TEMPLATE:imm
    t.lctl0o1:	or	%o0,0,%o0	! ##TEMPLATE:imm

	.section ".text"
	.align	4
	.global ci4_cs,ti4_cs,ii4_cs
ci4_cs:
	retl				!
	add	%g0,t.cs0e-t.cs0s,%o0	!
ti4_cs:
	sethi	%hi(t.cs0s),%o3		!
	or	%o3,%lo(t.cs0s),%o3	!
	or	%g0,t.cs0e-t.cs0s,%o4	!
    t.cs0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.cs0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.cs0o0-t.cs0s],%o5!
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.cs0t0-t.cs0s]!
	ld	[%o3+t.cs0o2-t.cs0s],%o5!
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R3
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+t.cs0t2-t.cs0s]!
	ld	[%o3+t.cs0o3-t.cs0s],%o5!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+t.cs0t3-t.cs0s]!
	ld	[%o3+t.cs0o4-t.cs0s],%o5!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,25,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+t.cs0t4-t.cs0s]!
	retl				!
	add	%o0,t.cs0e-t.cs0s,%o0	!
ii4_cs:
	srl	%o1,12,%o4		! B2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l3		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l3		! %l3
	and	%o1,0xfff,%l4		! D2
	srl	%o1,16,%o4		! R3
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l5		! %l5
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%i0		! save as %i0
	ld	[%o7+%i0],%l0		! %l0
t.cs0s:
    t.cs0t0:	add	%l3,%l4,%o1	! ##TEMPLATE:%l0,imm0
		and	%o1,%g3,%o1	! mask address
		andcc	%o1,3,%g0	!
		bz,a	t.cs000		! if odd address then
		ldub	[%g4+%o1],%g0	! force PAGEIN
		sethi	%hi(0x00060000),%o0
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! specification exception

    t.cs000:	ld	[%sp+184],%o7	! struct *gcpu_s
		st	%o1,[%o7+712]	! cs address for emm
		ld	[%o7+716],%o0	! get cslocka

    t.cslock:	ldstub	[%o0],%o4	! try locking ibufbpa
		subcc	%o4,0,%g0	!
		be	t.cslout	!
		nop			!
    t.cslwait:	ldub	[%o0],%o4	!
		subcc	%o4,0,%g0	!
		bne	t.cslwait	!
		nop			!
		ba,a	t.cslock	! retry locking ibufbpa

    t.cslout:	sethi	%hi(0x00008000),%o7
		or	%g7,%o7,%g7	! --- M CS start ---
		ld	[%g4+%o1],%o2	!
		andn	%g1,3,%g1	! CC=0
    t.cs0t2:	add	%l5,%g0,%o4	! ##TEMPLATE:%l0
    t.cs0t3:	subcc	%l0,%o2,%g0	! ##TEMPLATE:%l0
		be,a	t.cs001		!
		st	%o4,[%g4+%o1]	!
    t.cs0t4:	add	%o2,%g0,%l0	! ##TEMPLATE:%l0
		or	%g1,1,%g1	! CC=1
    t.cs001:	andn	%g7,%o7,%g7	! --- M CS end ---
		stbar			!
		stb	%g0,[%o0]	! unlock ibufbpa
		add	%g2,4,%g2	! update IAR
t.cs0e:
		ld	[%sp+184],%o7	! struct *gcpu_s
		ba	break0		!
		st	%l0,[%o7+%i0]	! R1
    t.cs0o0:	add	%l0,0,%o1	! ##TEMPLATE:%l0,imm0
    t.cs0o2:	add	%l0,%g0,%o4	! ##TEMPLATE:%l0
    t.cs0o3:	subcc	%l0,%o2,%g0	! ##TEMPLATE:%l0
    t.cs0o4:	add	%o2,%g0,%l0	! ##TEMPLATE:%l0

	.section ".text"
	.align	4
	.global ci4_cds,ti4_cds,ii4_cds
ci4_cds:
	srl	%o1,20,%o3		! switch (R1,R3)
	srl	%o1,16,%o4		!
	or	%o3,%o4,%o3		!
	andcc	%o3,1,%g0		!
	bnz	c.cds1c			!
	nop				!
    c.cds0c:				!
	retl				! case even:
	add	%g0,t.cds0e-t.cds0s,%o0	!
    c.cds1c:				!
	retl				! case odd:
	add	%g0,t.cds1e-t.cds1s,%o0	!
ti4_cds:
	srl	%o1,20,%o3		! switch (R1,R3)
	srl	%o1,16,%o4		!
	or	%o3,%o4,%o3		!
	andcc	%o3,1,%g0		!
	bnz	t.cds1t			!
	nop				!
    t.cds0t:				!
	sethi	%hi(t.cds0s),%o3	!
	or	%o3,%lo(t.cds0s),%o3	!
	or	%g0,t.cds0e-t.cds0s,%o4	!
    t.cds0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.cds0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.cds0o0-t.cds0s],%o5
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.cds0t0-t.cds0s]
	ld	[%o3+t.cds0o2-t.cds0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R3
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+t.cds0t2-t.cds0s]
	ld	[%o3+t.cds0o3-t.cds0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! R3+1
	add	%o4,1,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+t.cds0t3-t.cds0s]
	ld	[%o3+t.cds0o4-t.cds0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1+1
	add	%o4,1,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+t.cds0t4-t.cds0s]
	ld	[%o3+t.cds0o5-t.cds0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	st	%o5,[%o0+t.cds0t5-t.cds0s]
	ld	[%o3+t.cds0o6-t.cds0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,25,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+t.cds0t6-t.cds0s]
	ld	[%o3+t.cds0o7-t.cds0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1+1
	add	%o4,1,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,25,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+t.cds0t7-t.cds0s]
	retl				!
	add	%o0,t.cds0e-t.cds0s,%o0	!
    t.cds1t:				!
	sethi	%hi(t.cds1s),%o3	!
	or	%o3,%lo(t.cds1s),%o3	!
	or	%g0,t.cds1e-t.cds1s,%o4	!
    t.cds1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.cds1cp		!
	st	%o5,[%o0+%o4]		!
	retl				!
	add	%o0,t.cds1e-t.cds1s,%o0	!
ii4_cds:
	srl	%o1,20,%o3		! switch (R1,R3)
	srl	%o1,16,%o4		!
	or	%o3,%o4,%o3		!
	andcc	%o3,1,%g0		!
	bnz	t.cds1s			!
	nop				!
    i.cds0t:				!
	srl	%o1,12,%o4		! B2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l3		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l3		! %l3
	and	%o1,0xfff,%l4		! D2
	srl	%o1,16,%o4		! R3
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l5		! %l5
	srl	%o1,16,%o4		! R3+1
	and	%o4,0xf,%o4		! |
	add	%o4,1,%o4		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l6		! %l6
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%i0		! save as %i0
	ld	[%o7+%i0],%l0		! %l0
	srl	%o1,20,%o4		! R1+1
	and	%o4,0xf,%o4		! |
	add	%o4,1,%o4		! |
	sll	%o4,2,%i1		! save as %i1
	ld	[%o7+%i1],%l1		! %l1
t.cds0s:
    t.cds0t0:	add	%l3,%l4,%o1	! ##TEMPLATE:%l0,imm0
		and	%o1,%g3,%o1	! mask address
		andcc	%o1,7,%g0	!
		bz,a	t.cds000	! if odd address then
		ldub	[%g4+%o1],%g0	! force PAGEIN
		sethi	%hi(0x00060000),%o0
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! specification exception

    t.cds000:	ld	[%sp+184],%o7	! struct *gcpu_s
		st	%o1,[%o7+712]	! cs address for emm
		ld	[%o7+716],%o0	! get cslocka

    t.cdslock:	ldstub	[%o0],%o4	! try locking ibufbpa
		subcc	%o4,0,%g0	!
		be	t.cdslout	!
		nop			!
    t.cdslwait:	ldub	[%o0],%o4	!
		subcc	%o4,0,%g0	!
		bne	t.cdslwait	!
		nop			!
		ba,a	t.cdslock	! retry locking ibufbpa

    t.cdslout:	sethi	%hi(0x00008000),%o7
		or	%g7,%o7,%g7	! --- M CS start ---
		ldd	[%g4+%o1],%o2	!
		andn	%g1,3,%g1	! CC=0
    t.cds0t2:	add	%l5,%g0,%o4	! ##TEMPLATE:%l0
    t.cds0t3:	add	%l6,%g0,%o5	! ##TEMPLATE:%l0+1
    t.cds0t4:	subcc	%l1,%o3,%g0	! ##TEMPLATE:%l0+1
		bne	t.cds0t6	!
    t.cds0t5:	subcc	%l0,%o2,%g0	! ##TEMPLATE:%l0
		be,a	t.cds001	!
		std	%o4,[%g4+%o1]	!
    t.cds0t6:	add	%o2,%g0,%l0	! ##TEMPLATE:%l0
    t.cds0t7:	add	%o3,%g0,%l1	! ##TEMPLATE:%l0+1
		or	%g1,1,%g1	! CC=1
    t.cds001:	andn	%g7,%o7,%g7	! --- M CS end ---
		stbar			!
		stb	%g0,[%o0]	! unlock ibufbpa
		add	%g2,4,%g2	! update IAR
t.cds0e:
		ld	[%sp+184],%o7	! struct *gcpu_s
		st	%l0,[%o7+%i0]	! R1
		ba	break0		!
		st	%l1,[%o7+%i1]	! R1+1
    t.cds0o0:	add	%l0,0,%o1	! ##TEMPLATE:%l0,imm0
    t.cds0o2:	add	%l0,%g0,%o4	! ##TEMPLATE:%l0
    t.cds0o3:	add	%l0,%g0,%o5	! ##TEMPLATE:%l0+1
    t.cds0o4:	subcc	%l0,%o3,%g0	! ##TEMPLATE:%l0+1
    t.cds0o5:	subcc	%l0,%o2,%g0	! ##TEMPLATE:%l0
    t.cds0o6:	add	%o2,%g0,%l0	! ##TEMPLATE:%l0
    t.cds0o7:	add	%o3,%g0,%l0	! ##TEMPLATE:%l0+1
t.cds1s:
		sethi	%hi(0x00060000),%o0
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! specification exception
t.cds1e:

	.section ".text"
	.align	4
	.global cc4_bcxx,tc4_bcxx,ic4_bcxx
cc4_bcxx:
	retl				!
	add	%g0,t.bcxx0e-t.bcxx0s,%o0
tc4_bcxx:
	sethi	%hi(t.bcxx0s),%o3	!
	or	%o3,%lo(t.bcxx0s),%o3	!
	or	%g0,t.bcxx0e-t.bcxx0s,%o4
    t.bcxx0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.bcxx0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.bcxx0o0-t.bcxx0s],%o5
	srl	%o1,10,%o4		!
	or	%o5,%o4,%o5		! simm22
	st	%o5,[%o0+t.bcxx0t0-t.bcxx0s]
	ld	[%o3+t.bcxx0o1-t.bcxx0s],%o5
	and	%o1,0xfff,%o4		!
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.bcxx0t1-t.bcxx0s]
	retl				!
	add	%o0,t.bcxx0e-t.bcxx0s,%o0
ic4_bcxx:
t.bcxx0s:
		ld	[%sp+184],%o7	! struct *gcpu_s
    t.bcxx0t0:	sethi	0,%o0		! ##TEMPLATE:imm
    t.bcxx0t1:	or	%o1,0,%o0	! ##TEMPLATE:imm
		st	%o0,[%o7+704]	! store minsn (upper)
		st	%g0,[%o7+708]	! store minsn (lower)
		sethi	%hi(0x80000000),%o0
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! Special Instruction (FC=2)
t.bcxx0e:
    t.bcxx0o0:	sethi	0,%o0		! ##TEMPLATE:imm
    t.bcxx0o1:	or	%o0,0,%o0	! ##TEMPLATE:imm

	.section ".text"
	.align	4
	.global ci4_clm,ti4_clm,ii4_clm
ci4_clm:
	retl				!
	add	%g0,t.clm0e-t.clm0s,%o0	!
ti4_clm:
	sethi	%hi(t.clm0s),%o3	!
	or	%o3,%lo(t.clm0s),%o3	!
	or	%g0,t.clm0e-t.clm0s,%o4	!
    t.clm0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.clm0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.clm0o0-t.clm0s],%o5
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.clm0t0-t.clm0s]
	ld	[%o3+t.clm0o1-t.clm0s],%o5
	sethi	%hi(t.clmtab),%o2	!
	or	%o2,%lo(t.clmtab),%o2	!
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! M3
	ldub	[%o2+%o4],%o4		! |
	xor	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.clm0t1-t.clm0s]
	ld	[%o3+t.clm0o2-t.clm0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	st	%o5,[%o0+t.clm0t2-t.clm0s]
	ld	[%o3+t.clm0o3-t.clm0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! M3
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.clm0t3-t.clm0s]
	retl				!
	add	%o0,t.clm0e-t.clm0s,%o0	!
ii4_clm:
	srl	%o1,12,%o4		! B2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l3		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l3		! %l3
	and	%o1,0xfff,%l4		! D2
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l0		! %l0
	sethi	%hi(t.clmtab),%o2	! M3
	or	%o2,%lo(t.clmtab),%o2	! |
	srl	%o1,16,%o4		! |
	and	%o4,0xf,%l1		! %l1
	ldub	[%o2+%l1],%l2		! %l2
t.clm0s:
    t.clm0t0:	add	%l3,%l4,%o0	! ##TEMPLATE:%l0,imm0
		and	%o0,%g3,%o0	! mask address
		add	%g4,%o0,%o0	!
		ldub	[%o0],%g0	! force PAGEIN
    t.clm0t1:	ldub	[%o0+%l2],%g0	! ##TEMPLATE:imm0
		andn	%g1,3,%g1	! CC=0
    t.clm0t2:	add	%g0,%l0,%o1	! ##TEMPLATE:%l0 R1
    t.clm0t3:	add	%g0,%l1,%o2	! ##TEMPLATE:imm0 M3
    t.clm000:	andcc	%o2,0xf,%o2	!
		bz	t.clm004	!
		andcc	%o2,8,%g0	!
		bz	t.clm001	!
		srl	%o1,24,%o3	!
		ldub	[%o0],%o4	!
		subcc	%o3,%o4,%g0	!
		bne	t.clm002	!
		add	%o0,1,%o0	!
    t.clm001:	sll	%o1,8,%o1	!
		ba	t.clm000	!
		sll	%o2,1,%o2	!
    t.clm002:	bgu,a	t.clm004	! if R1 > OP2 then
		or	%g1,2,%g1	!   CC=2
		bcs,a	t.clm004	! if R1 < OP2 then
		or	%g1,1,%g1	!   CC=1
    t.clm004:	add	%g2,4,%g2	! update IAR
t.clm0e:
		ba	break0		!
		nop			!
    t.clm0o0:	add	%l0,0,%o0	! ##TEMPLATE:%l0,imm0
    t.clm0o1:	ldub	[%o0+0],%g0	! ##TEMPLATE:imm0
    t.clm0o2:	add	%g0,%l0,%o1	! ##TEMPLATE:%l0 R1
    t.clm0o3:	add	%g0,0,%o2	! ##TEMPLATE:imm0 M3
t.clmtab:
	.byte	0,0,0,1,0,1,1,2,0,1,1,2,1,2,2,3

	.section ".text"
	.align	4
	.global ci4_stcm,ti4_stcm,ii4_stcm
ci4_stcm:
	retl				!
	add	%g0,t.stcm0e-t.stcm0s,%o0
ti4_stcm:
	sethi	%hi(t.stcm0s),%o3	!
	or	%o3,%lo(t.stcm0s),%o3	!
	or	%g0,t.stcm0e-t.stcm0s,%o4
    t.stcm0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.stcm0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.stcm0o0-t.stcm0s],%o5
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.stcm0t0-t.stcm0s]
	ld	[%o3+t.stcm0o1-t.stcm0s],%o5
	sethi	%hi(t.stcmtab),%o2	!
	or	%o2,%lo(t.stcmtab),%o2	!
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! M3
	ldub	[%o2+%o4],%o4		! |
	xor	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.stcm0t1-t.stcm0s]
	ld	[%o3+t.stcm0o2-t.stcm0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	st	%o5,[%o0+t.stcm0t2-t.stcm0s]
	ld	[%o3+t.stcm0o3-t.stcm0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! M3
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.stcm0t3-t.stcm0s]
	retl				!
	add	%o0,t.stcm0e-t.stcm0s,%o0
ii4_stcm:
	srl	%o1,12,%o4		! B2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l3		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l3		! %l3
	and	%o1,0xfff,%l4		! D2
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l0		! %l0
	sethi	%hi(t.stcmtab),%o2	! M3
	or	%o2,%lo(t.stcmtab),%o2	! |
	srl	%o1,16,%o4		! |
	and	%o4,0xf,%l1		! %l1
	ldub	[%o2+%l1],%l2		! %l2
t.stcm0s:
    t.stcm0t0:	add	%l3,%l4,%o0	! ##TEMPLATE:%l0,imm0
		and	%o0,%g3,%o0	! mask address
		add	%g4,%o0,%o0	!
		ldub	[%o0],%g0	! force PAGEIN
    t.stcm0t1:	ldub	[%o0+%l2],%g0	! ##TEMPLATE:imm0
    t.stcm0t2:	add	%g0,%l0,%o1	! ##TEMPLATE:%l0 R1
    t.stcm0t3:	add	%g0,%l1,%o2	! ##TEMPLATE:imm0 M3
    t.stcm000:	andcc	%o2,0xf,%o2	!
		bz	t.stcm002	!
		andcc	%o2,8,%g0	!
		bz	t.stcm001	!
		srl	%o1,24,%o3	!
		stb	%o3,[%o0]	!
		add	%o0,1,%o0	!
    t.stcm001:	sll	%o1,8,%o1	!
		ba	t.stcm000	!
		sll	%o2,1,%o2	!
    t.stcm002:	add	%g2,4,%g2	! update IAR
t.stcm0e:
		ba	break0		!
		nop			!
    t.stcm0o0:	add	%l0,0,%o0	! ##TEMPLATE:%l0,imm0
    t.stcm0o1:	ldub	[%o0+0],%g0	! ##TEMPLATE:imm0
    t.stcm0o2:	add	%g0,%l0,%o1	! ##TEMPLATE:%l0 R1
    t.stcm0o3:	add	%g0,0,%o2	! ##TEMPLATE:imm0 M3
t.stcmtab:
	.byte	0,0,0,1,0,1,1,2,0,1,1,2,1,2,2,3

	.section ".text"
	.align	4
	.global ci4_icm,ti4_icm,ii4_icm
ci4_icm:
	retl				!
	add	%g0,t.icm0e-t.icm0s,%o0	!
ti4_icm:
	sethi	%hi(t.icm0s),%o3	!
	or	%o3,%lo(t.icm0s),%o3	!
	or	%g0,t.icm0e-t.icm0s,%o4	!
    t.icm0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.icm0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.icm0o0-t.icm0s],%o5
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	and	%o1,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.icm0t0-t.icm0s]
	ld	[%o3+t.icm0o1-t.icm0s],%o5
	sethi	%hi(t.icmtab),%o2	!
	or	%o2,%lo(t.icmtab),%o2	!
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! M3
	ldub	[%o2+%o4],%o4		! |
	xor	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.icm0t1-t.icm0s]
	ld	[%o3+t.icm0o2-t.icm0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	xor	%o5,%o4,%o5		! rs2
	st	%o5,[%o0+t.icm0t2-t.icm0s]
	ld	[%o3+t.icm0o3-t.icm0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! M3
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.icm0t3-t.icm0s]
	ld	[%o3+t.icm0o4-t.icm0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,25,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+t.icm0t4-t.icm0s]
	ld	[%o3+t.icm0o5-t.icm0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	sll	%o4,11,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+t.icm0t5-t.icm0s]
	ld	[%o3+t.icm0o6-t.icm0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	sll	%o4,11,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+t.icm0t6-t.icm0s]
	ld	[%o3+t.icm0o7-t.icm0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	sll	%o4,11,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+t.icm0t7-t.icm0s]
	ld	[%o3+t.icm0o8-t.icm0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	sll	%o4,11,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+t.icm0t8-t.icm0s]
	ld	[%o3+t.icm0o9-t.icm0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! R1
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	sll	%o4,11,%o4		! |
	xor	%o5,%o4,%o5		! rd
	st	%o5,[%o0+t.icm0t9-t.icm0s]
	retl				!
	add	%o0,t.icm0e-t.icm0s,%o0	!
ii4_icm:
	srl	%o1,12,%o4		! B2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l3		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l3		! %l3
	and	%o1,0xfff,%l4		! D2
	srl	%o1,20,%o4		! R1
	and	%o4,0xf,%o4		! |
	sll	%o4,2,%i0		! save as %i0
	ld	[%o7+%i0],%l0		! %l0
	sethi	%hi(t.icmtab),%o2	! M3
	or	%o2,%lo(t.icmtab),%o2	! |
	srl	%o1,16,%o4		! |
	and	%o4,0xf,%l1		! %l1
	ldub	[%o2+%l1],%l2		! %l2
t.icm0s:
    t.icm0t0:	add	%l3,%l4,%o0	! ##TEMPLATE:%l0,imm0
		and	%o0,%g3,%o0	! mask address
		add	%g4,%o0,%o0	!
		ldub	[%o0],%g0	! force PAGEIN
    t.icm0t1:	ldub	[%o0+%l2],%g0	! ##TEMPLATE:imm0
		andn	%g1,3,%g1	! CC=0
    t.icm0t2:	add	%g0,%l0,%o1	! ##TEMPLATE:%l0 R1
    t.icm0t3:	add	%g0,%l1,%o2	! ##TEMPLATE:imm0 M3
    t.icm0t4:	add	%g0,0,%l0	! ##TEMPLATE:%l0 R1
		add	%g0,32,%o4	!
		add	%g0,32,%o5	!
		add	%g0,0,%o7	!
    t.icm000:	andcc	%o2,0xf,%o2	!
		bz	t.icm0t8	!
		andcc	%o2,8,%g0	!
		srl	%o1,24,%o3	!
    t.icm0t5:	sll	%l0,8,%l0	! ##TEMPLATE:%l0,%l0 R1,R1
		bz,a	t.icm001	!
    t.icm0t6:	or	%l0,%o3,%l0	! ##TEMPLATE:%l0,%l0 R1,R1
		ldub	[%o0],%o3	!
    t.icm0t7:	or	%l0,%o3,%l0	! ##TEMPLATE:%l0,%l0 R1,R1
		add	%o0,1,%o0	!
		sub	%o5,8,%o5	!
		sll	%o7,8,%o7	!
		or	%o7,%o3,%o7	!
    t.icm001:	sll	%o1,8,%o1	!
		sll	%o2,1,%o2	!
		ba	t.icm000	!
		sub	%o4,8,%o4	!
    t.icm0t8:	sll	%l0,%o4,%l0	! ##TEMPLATE:%l0,%l0 R1,R1
		sub	%g0,%o4,%o4	!
		add	%o4,32,%o4	!
		srl	%o1,%o4,%o1	!
    t.icm0t9:	or	%l0,%o1,%l0	! ##TEMPLATE:%l0,%l0 R1,R1
		sll	%o7,%o5,%o7	!
		subcc	%o7,0,%g0	!
		bg,a	t.icm003	! if inserted bits > 0
		or	%g1,2,%g1	!   CC=2
		bl,a	t.icm003	! if inserted bits < 0
		or	%g1,1,%g1	!   CC=1
    t.icm003:	add	%g2,4,%g2	! update IAR
t.icm0e:
		ld	[%sp+184],%o7	! struct *gcpu_s
		ba	break0		!
		st	%l0,[%o7+%i0]	! R1
    t.icm0o0:	add	%l0,0,%o0	! ##TEMPLATE:%l0,imm0
    t.icm0o1:	ldub	[%o0+0],%g0	! ##TEMPLATE:imm0
    t.icm0o2:	add	%g0,%l0,%o1	! ##TEMPLATE:%l0 R1
    t.icm0o3:	add	%g0,0,%o2	! ##TEMPLATE:imm0 M3
    t.icm0o4:	add	%g0,0,%l0	! ##TEMPLATE:%l0 R1
    t.icm0o5:	sll	%l0,8,%l0	! ##TEMPLATE:%l0,%l0 R1,R1
    t.icm0o6:	or	%l0,%o3,%l0	! ##TEMPLATE:%l0,%l0 R1,R1
    t.icm0o7:	or	%l0,%o3,%l0	! ##TEMPLATE:%l0,%l0 R1,R1
    t.icm0o8:	sll	%l0,%o4,%l0	! ##TEMPLATE:%l0,%l0 R1,R1
    t.icm0o9:	or	%l0,%o1,%l0	! ##TEMPLATE:%l0,%l0 R1,R1
t.icmtab:
	.byte	0,0,0,1,0,1,1,2,0,1,1,2,1,2,2,3
!================================

!
! templates
! cxx_xxx:
!   %o0: param: none
!	 retval:size of template
!   %o1: M instruction (6 bytes)
!   %o2: M instruction (lower 2bytes)
!   %o3: work
!   %o4: work
!   %o5: work
! txx_xxx:
!   %o0: param: bufp start address
!	 retval:bufp next start address
!   %o1: M instruction (6 bytes)
!   %o2: M instruction (lower 2bytes)
!   %o3: work
!   %o4: work
!   %o5: work
!
	.section ".text"
	.align	4
	.global ci6_mvn,ti6_mvn,ii6_mvn
ci6_mvn:
	retl				!
	add	%g0,t.mvn0e-t.mvn0s,%o0	!
ti6_mvn:
	sethi	%hi(t.mvn0s),%o3	!
	or	%o3,%lo(t.mvn0s),%o3	!
	or	%g0,t.mvn0e-t.mvn0s,%o4	!
    t.mvn0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.mvn0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.mvn0o0-t.mvn0s],%o5
	srl	%o2,28,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	srl	%o2,16,%o4		!
	and	%o4,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.mvn0t0-t.mvn0s]
	ld	[%o3+t.mvn0o1-t.mvn0s],%o5
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B1
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	and	%o1,0xfff,%o4		! D1
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.mvn0t1-t.mvn0s]
	ld	[%o3+t.mvn0o2-t.mvn0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xff,%o4		! L
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.mvn0t2-t.mvn0s]
	ld	[%o3+t.mvn0o3-t.mvn0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xff,%o4		! L
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.mvn0t3-t.mvn0s]
	ld	[%o3+t.mvn0o4-t.mvn0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xff,%o4		! L
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.mvn0t4-t.mvn0s]
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=6
	ld	[%o3+t.mvn0oy-t.mvn0s],%o5
	bnz,a	.+8			! if EX=1 then IAR+=4
	ld	[%o3+t.mvn0oz-t.mvn0s],%o5
	st	%o5,[%o0+t.mvn0tz-t.mvn0s]
	retl				!
	add	%o0,t.mvn0e-t.mvn0s,%o0	!
ii6_mvn:
	srl	%o2,28,%o4		! B2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l3		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l3		! %l3
	srl	%o2,16,%o4		! D2
	and	%o4,0xfff,%l4		! %l4
	srl	%o1,12,%o4		! B1
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l1		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l1		! %l1
	and	%o1,0xfff,%l2		! D1
	srl	%o1,16,%o4		! L
	and	%o4,0xff,%l5		! %l5
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=6
	add	%g0,6,%l7		!
	bnz,a	.+8			! if EX=1 then IAR+=4
	add	%g0,4,%l7		!
t.mvn0s:
    t.mvn0t0:	add	%l3,%l4,%o0	! ##TEMPLATE:%l0,imm0
		and	%o0,%g3,%o0	! mask address
		add	%g4,%o0,%o0	!
    t.mvn0t1:	add	%l1,%l2,%o1	! ##TEMPLATE:%l0,imm0
		and	%o1,%g3,%o1	! mask address
		add	%g4,%o1,%o1	!
		ldub	[%o0],%g0	! force PAGEIN
    t.mvn0t2:	ldub	[%o0+%l5],%g0	! ##TEMPLATE:imm0 (L)
		ldub	[%o1],%g0	! force PAGEIN
    t.mvn0t3:	ldub	[%o1+%l5],%g0	! ##TEMPLATE:imm0 (L)
		add	%g0,0,%o2	! counter
    t.mvn000:	ldub	[%o0+%o2],%o3	!
		ldub	[%o1+%o2],%o4	!
    t.mvn0t4:	subcc	%o2,%l5,%g0	! ##TEMPLATE:imm0 (L)
		and	%o3,0x0f,%o3	!
		and	%o4,0xf0,%o4	!
		or	%o3,%o4,%o3	!
		stb	%o3,[%o1+%o2]	!
		bne	t.mvn000	!
		add	%o2,1,%o2	!
    t.mvn0tz:	add	%g2,%l7,%g2	! ##TEMPLATE:IAR
t.mvn0e:
		ba	break0		!
		nop			!
    t.mvn0o0:	add	%l0,0,%o0	! ##TEMPLATE:%l0,imm0
    t.mvn0o1:	add	%l0,0,%o1	! ##TEMPLATE:%l0,imm0
    t.mvn0o2:	ldub	[%o0+0],%g0	! ##TEMPLATE:imm0 (L)
    t.mvn0o3:	ldub	[%o1+0],%g0	! ##TEMPLATE:imm0 (L)
    t.mvn0o4:	subcc	%o2,0,%g0	! ##TEMPLATE:imm0 (L)
    t.mvn0oy:	add	%g2,6,%g2	! ##TEMPLATE:IAR
    t.mvn0oz:	add	%g2,4,%g2	! ##TEMPLATE:IAR

	.section ".text"
	.align	4
	.global ci6_mvc,ti6_mvc,ii6_mvc
ci6_mvc:
	retl				!
	add	%g0,t.mvc0e-t.mvc0s,%o0	!
ti6_mvc:
	sethi	%hi(t.mvc0s),%o3	!
	or	%o3,%lo(t.mvc0s),%o3	!
	or	%g0,t.mvc0e-t.mvc0s,%o4	!
    t.mvc0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.mvc0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.mvc0o0-t.mvc0s],%o5
	srl	%o2,28,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	srl	%o2,16,%o4		!
	and	%o4,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.mvc0t0-t.mvc0s]
	ld	[%o3+t.mvc0o1-t.mvc0s],%o5
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B1
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	and	%o1,0xfff,%o4		! D1
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.mvc0t1-t.mvc0s]
	ld	[%o3+t.mvc0o2-t.mvc0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xff,%o4		! L
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.mvc0t2-t.mvc0s]
	ld	[%o3+t.mvc0o3-t.mvc0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xff,%o4		! L
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.mvc0t3-t.mvc0s]
	ld	[%o3+t.mvc0o4-t.mvc0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xff,%o4		!
	add	%o4,1,%o4		! L+1
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.mvc0t4-t.mvc0s]
	ld	[%o3+t.mvc0o5-t.mvc0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xff,%o4		! L
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.mvc0t5-t.mvc0s]
	ld	[%o3+t.mvc0o6-t.mvc0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xff,%o4		! L-3
	sub	%o4,3,%o4		! |
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.mvc0t6-t.mvc0s]
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=6
	ld	[%o3+t.mvc0oy-t.mvc0s],%o5
	bnz,a	.+8			! if EX=1 then IAR+=4
	ld	[%o3+t.mvc0oz-t.mvc0s],%o5
	st	%o5,[%o0+t.mvc0tz-t.mvc0s]
	retl				!
	add	%o0,t.mvc0e-t.mvc0s,%o0	!
ii6_mvc:
	srl	%o2,28,%o4		! B2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l3		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l3		! %l3
	srl	%o2,16,%o4		! D2
	and	%o4,0xfff,%l4		! %l4
	srl	%o1,12,%o4		! B1
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l1		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l1		! %l1
	and	%o1,0xfff,%l2		! D1
	srl	%o1,16,%o4		! L
	and	%o4,0xff,%l5		! %l5
	add	%l5,1,%l6		! %l6
	sub	%l5,3,%l0		! %l0
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=6
	add	%g0,6,%l7		!
	bnz,a	.+8			! if EX=1 then IAR+=4
	add	%g0,4,%l7		!
t.mvc0s:
    t.mvc0t0:	add	%l3,%l4,%o0	! ##TEMPLATE:%l0,imm0
		and	%o0,%g3,%o0	! mask address
		add	%g4,%o0,%o0	!
    t.mvc0t1:	add	%l1,%l2,%o1	! ##TEMPLATE:%l0,imm0
		and	%o1,%g3,%o1	! mask address
		add	%g4,%o1,%o1	!
		ldub	[%o0],%g0	! force PAGEIN
    t.mvc0t2:	ldub	[%o0+%l5],%g0	! ##TEMPLATE:imm0 (L)
		ldub	[%o1],%g0	! force PAGEIN
    t.mvc0t3:	ldub	[%o1+%l5],%g0	! ##TEMPLATE:imm0 (L)
    t.mvc0t4:	add	%g0,%l6,%o2	! ##TEMPLATE:imm0 (L+1)
		or	%o0,%o2,%o2	!
		or	%o1,%o2,%o2	!
		andcc	%o2,3,%g0	! if 4byte aligned
		bz	t.mvc010	!   short cut
		add	%g0,0,%o2	! counter

    t.mvc000:	ldub	[%o0+%o2],%o3	!
    t.mvc0t5:	subcc	%o2,%l5,%g0	! ##TEMPLATE:imm0 (L)
		stb	%o3,[%o1+%o2]	!
		bne	t.mvc000	!
		add	%o2,1,%o2	!
		ba,a	t.mvc0tz	!

    t.mvc010:	ld	[%o0+%o2],%o3	!
    t.mvc0t6:	subcc	%o2,%l0,%g0	! ##TEMPLATE:imm0 (L-3)
		st	%o3,[%o1+%o2]	!
		bne	t.mvc010	!
		add	%o2,4,%o2	!

    t.mvc0tz:	add	%g2,%l7,%g2	! ##TEMPLATE:IAR
t.mvc0e:
		ba	break0		!
		nop			!
    t.mvc0o0:	add	%l0,0,%o0	! ##TEMPLATE:%l0,imm0
    t.mvc0o1:	add	%l0,0,%o1	! ##TEMPLATE:%l0,imm0
    t.mvc0o2:	ldub	[%o0+0],%g0	! ##TEMPLATE:imm0 (L)
    t.mvc0o3:	ldub	[%o1+0],%g0	! ##TEMPLATE:imm0 (L)
    t.mvc0o4:	add	%g0,0,%o2	! ##TEMPLATE:imm0 (L+1)
    t.mvc0o5:	subcc	%o2,0,%g0	! ##TEMPLATE:imm0 (L)
    t.mvc0o6:	subcc	%o2,0,%g0	! ##TEMPLATE:imm0 (L-3)
    t.mvc0oy:	add	%g2,6,%g2	! ##TEMPLATE:IAR
    t.mvc0oz:	add	%g2,4,%g2	! ##TEMPLATE:IAR

	.section ".text"
	.align	4
	.global ci6_mvz,ti6_mvz,ii6_mvz
ci6_mvz:
	retl				!
	add	%g0,t.mvz0e-t.mvz0s,%o0	!
ti6_mvz:
	sethi	%hi(t.mvz0s),%o3	!
	or	%o3,%lo(t.mvz0s),%o3	!
	or	%g0,t.mvz0e-t.mvz0s,%o4	!
    t.mvz0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.mvz0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.mvz0o0-t.mvz0s],%o5
	srl	%o2,28,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	srl	%o2,16,%o4		!
	and	%o4,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.mvz0t0-t.mvz0s]
	ld	[%o3+t.mvz0o1-t.mvz0s],%o5
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B1
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	and	%o1,0xfff,%o4		! D1
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.mvz0t1-t.mvz0s]
	ld	[%o3+t.mvz0o2-t.mvz0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xff,%o4		! L
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.mvz0t2-t.mvz0s]
	ld	[%o3+t.mvz0o3-t.mvz0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xff,%o4		! L
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.mvz0t3-t.mvz0s]
	ld	[%o3+t.mvz0o4-t.mvz0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xff,%o4		! L
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.mvz0t4-t.mvz0s]
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=6
	ld	[%o3+t.mvz0oy-t.mvz0s],%o5
	bnz,a	.+8			! if EX=1 then IAR+=4
	ld	[%o3+t.mvz0oz-t.mvz0s],%o5
	st	%o5,[%o0+t.mvz0tz-t.mvz0s]
	retl				!
	add	%o0,t.mvz0e-t.mvz0s,%o0	!
ii6_mvz:
	srl	%o2,28,%o4		! B2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l3		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l3		! %l3
	srl	%o2,16,%o4		! D2
	and	%o4,0xfff,%l4		! %l4
	srl	%o1,12,%o4		! B1
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l1		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l1		! %l1
	and	%o1,0xfff,%l2		! D1
	srl	%o1,16,%o4		! L
	and	%o4,0xff,%l5		! %l5
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=6
	add	%g0,6,%l7		!
	bnz,a	.+8			! if EX=1 then IAR+=4
	add	%g0,4,%l7		!
t.mvz0s:
    t.mvz0t0:	add	%l3,%l4,%o0	! ##TEMPLATE:%l0,imm0
		and	%o0,%g3,%o0	! mask address
		add	%g4,%o0,%o0	!
    t.mvz0t1:	add	%l1,%l2,%o1	! ##TEMPLATE:%l0,imm0
		and	%o1,%g3,%o1	! mask address
		add	%g4,%o1,%o1	!
		ldub	[%o0],%g0	! force PAGEIN
    t.mvz0t2:	ldub	[%o0+%l5],%g0	! ##TEMPLATE:imm0 (L)
		ldub	[%o1],%g0	! force PAGEIN
    t.mvz0t3:	ldub	[%o1+%l5],%g0	! ##TEMPLATE:imm0 (L)
		add	%g0,0,%o2	! counter
    t.mvz000:	ldub	[%o0+%o2],%o3	!
		ldub	[%o1+%o2],%o4	!
    t.mvz0t4:	subcc	%o2,%l5,%g0	! ##TEMPLATE:imm0 (L)
		and	%o3,0xf0,%o3	!
		and	%o4,0x0f,%o4	!
		or	%o3,%o4,%o3	!
		stb	%o3,[%o1+%o2]	!
		bne	t.mvz000	!
		add	%o2,1,%o2	!
    t.mvz0tz:	add	%g2,%l7,%g2	! ##TEMPLATE:IAR
t.mvz0e:
		ba	break0		!
		nop			!
    t.mvz0o0:	add	%l0,0,%o0	! ##TEMPLATE:%l0,imm0
    t.mvz0o1:	add	%l0,0,%o1	! ##TEMPLATE:%l0,imm0
    t.mvz0o2:	ldub	[%o0+0],%g0	! ##TEMPLATE:imm0 (L)
    t.mvz0o3:	ldub	[%o1+0],%g0	! ##TEMPLATE:imm0 (L)
    t.mvz0o4:	subcc	%o2,0,%g0	! ##TEMPLATE:imm0 (L)
    t.mvz0oy:	add	%g2,6,%g2	! ##TEMPLATE:IAR
    t.mvz0oz:	add	%g2,4,%g2	! ##TEMPLATE:IAR

	.section ".text"
	.align	4
	.global ci6_nc,ti6_nc,ii6_nc
ci6_nc:
	retl				!
	add	%g0,t.nc0e-t.nc0s,%o0	!
ti6_nc:
	sethi	%hi(t.nc0s),%o3		!
	or	%o3,%lo(t.nc0s),%o3	!
	or	%g0,t.nc0e-t.nc0s,%o4	!
    t.nc0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.nc0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.nc0o0-t.nc0s],%o5!
	srl	%o2,28,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	srl	%o2,16,%o4		!
	and	%o4,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.nc0t0-t.nc0s]!
	ld	[%o3+t.nc0o1-t.nc0s],%o5!
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B1
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	and	%o1,0xfff,%o4		! D1
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.nc0t1-t.nc0s]!
	ld	[%o3+t.nc0o2-t.nc0s],%o5!
	srl	%o1,16,%o4		!
	and	%o4,0xff,%o4		! L
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.nc0t2-t.nc0s]!
	ld	[%o3+t.nc0o3-t.nc0s],%o5!
	srl	%o1,16,%o4		!
	and	%o4,0xff,%o4		! L
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.nc0t3-t.nc0s]!
	ld	[%o3+t.nc0o4-t.nc0s],%o5!
	srl	%o1,16,%o4		!
	and	%o4,0xff,%o4		! L
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.nc0t4-t.nc0s]!
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=6
	ld	[%o3+t.nc0oy-t.nc0s],%o5!
	bnz,a	.+8			! if EX=1 then IAR+=4
	ld	[%o3+t.nc0oz-t.nc0s],%o5!
	st	%o5,[%o0+t.nc0tz-t.nc0s]!
	retl				!
	add	%o0,t.nc0e-t.nc0s,%o0	!
ii6_nc:
	srl	%o2,28,%o4		! B2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l3		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l3		! %l3
	srl	%o2,16,%o4		! D2
	and	%o4,0xfff,%l4		! %l4
	srl	%o1,12,%o4		! B1
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l1		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l1		! %l1
	and	%o1,0xfff,%l2		! D1
	srl	%o1,16,%o4		! L
	and	%o4,0xff,%l5		! %l5
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=6
	add	%g0,6,%l7		!
	bnz,a	.+8			! if EX=1 then IAR+=4
	add	%g0,4,%l7		!
t.nc0s:
    t.nc0t0:	add	%l3,%l4,%o0	! ##TEMPLATE:%l0,imm0
		and	%o0,%g3,%o0	! mask address
		add	%g4,%o0,%o0	!
    t.nc0t1:	add	%l1,%l2,%o1	! ##TEMPLATE:%l0,imm0
		and	%o1,%g3,%o1	! mask address
		add	%g4,%o1,%o1	!
		ldub	[%o0],%g0	! force PAGEIN
    t.nc0t2:	ldub	[%o0+%l5],%g0	! ##TEMPLATE:imm0 (L)
		ldub	[%o1],%g0	! force PAGEIN
    t.nc0t3:	ldub	[%o1+%l5],%g0	! ##TEMPLATE:imm0 (L)
		andn	%g1,3,%g1	! CC=0
		add	%g0,0,%o2	! counter
		add	%g0,0,%o5	!
    t.nc000:	ldub	[%o0+%o2],%o3	!
		ldub	[%o1+%o2],%o4	!
    t.nc0t4:	subcc	%o2,%l5,%g0	! ##TEMPLATE:imm0 (L)
		and	%o3,%o4,%o3	!
		or	%o5,%o3,%o5	!
		stb	%o3,[%o1+%o2]	!
		bne	t.nc000		!
		add	%o2,1,%o2	!
		subcc	%o5,0,%g0	!
		bnz,a	t.nc0tz		! if Result != 0 then
		or	%g1,1,%g1	!   CC=1
    t.nc0tz:	add	%g2,%l7,%g2	! ##TEMPLATE:IAR
t.nc0e:
		ba	break0		!
		nop			!
    t.nc0o0:	add	%l0,0,%o0	! ##TEMPLATE:%l0,imm0
    t.nc0o1:	add	%l0,0,%o1	! ##TEMPLATE:%l0,imm0
    t.nc0o2:	ldub	[%o0+0],%g0	! ##TEMPLATE:imm0 (L)
    t.nc0o3:	ldub	[%o1+0],%g0	! ##TEMPLATE:imm0 (L)
    t.nc0o4:	subcc	%o2,0,%g0	! ##TEMPLATE:imm0 (L)
    t.nc0oy:	add	%g2,6,%g2	! ##TEMPLATE:IAR
    t.nc0oz:	add	%g2,4,%g2	! ##TEMPLATE:IAR

	.section ".text"
	.align	4
	.global ci6_clc,ti6_clc,ii6_clc
ci6_clc:
	retl				!
	add	%g0,t.clc0e-t.clc0s,%o0	!
ti6_clc:
	sethi	%hi(t.clc0s),%o3	!
	or	%o3,%lo(t.clc0s),%o3	!
	or	%g0,t.clc0e-t.clc0s,%o4	!
    t.clc0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.clc0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.clc0o0-t.clc0s],%o5
	srl	%o2,28,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	srl	%o2,16,%o4		!
	and	%o4,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.clc0t0-t.clc0s]
	ld	[%o3+t.clc0o1-t.clc0s],%o5
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B1
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	and	%o1,0xfff,%o4		! D1
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.clc0t1-t.clc0s]
	ld	[%o3+t.clc0o2-t.clc0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xff,%o4		! L
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.clc0t2-t.clc0s]
	ld	[%o3+t.clc0o3-t.clc0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xff,%o4		! L
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.clc0t3-t.clc0s]
	ld	[%o3+t.clc0o4-t.clc0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xff,%o4		! L
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.clc0t4-t.clc0s]
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=6
	ld	[%o3+t.clc0oy-t.clc0s],%o5
	bnz,a	.+8			! if EX=1 then IAR+=4
	ld	[%o3+t.clc0oz-t.clc0s],%o5
	st	%o5,[%o0+t.clc0tz-t.clc0s]
	retl				!
	add	%o0,t.clc0e-t.clc0s,%o0	!
ii6_clc:
	srl	%o2,28,%o4		! B2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l3		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l3		! %l3
	srl	%o2,16,%o4		! D2
	and	%o4,0xfff,%l4		! %l4
	srl	%o1,12,%o4		! B1
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l1		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l1		! %l1
	and	%o1,0xfff,%l2		! D1
	srl	%o1,16,%o4		! L
	and	%o4,0xff,%l5		! %l5
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=6
	add	%g0,6,%l7		!
	bnz,a	.+8			! if EX=1 then IAR+=4
	add	%g0,4,%l7		!
t.clc0s:
    t.clc0t0:	add	%l3,%l4,%o0	! ##TEMPLATE:%l0,imm0
		and	%o0,%g3,%o0	! mask address
		add	%g4,%o0,%o0	!
    t.clc0t1:	add	%l1,%l2,%o1	! ##TEMPLATE:%l0,imm0
		and	%o1,%g3,%o1	! mask address
		add	%g4,%o1,%o1	!
		ldub	[%o0],%g0	! force PAGEIN
    t.clc0t2:	ldub	[%o0+%l5],%g0	! ##TEMPLATE:imm0 (L)
		ldub	[%o1],%g0	! force PAGEIN
    t.clc0t3:	ldub	[%o1+%l5],%g0	! ##TEMPLATE:imm0 (L)
		andn	%g1,3,%g1	! CC=0
		add	%g0,0,%o2	! counter
		add	%g0,0,%o5	!
    t.clc000:	ldub	[%o0+%o2],%o3	!
		ldub	[%o1+%o2],%o4	!
		subcc	%o4,%o3,%g0	!
		bne	t.clc001	!
    t.clc0t4:	subcc	%o2,%l5,%g0	! ##TEMPLATE:imm0 (L)
		bne	t.clc000	!
		add	%o2,1,%o2	!
		ba,a	t.clc0tz	!
    t.clc001:	subcc	%o4,%o3,%g0	!
		bgu,a	t.clc0tz	! if left > right then
		or	%g1,2,%g1	!   CC=2
		bcs,a	t.clc0tz	! if left < right then
		or	%g1,1,%g1	!   CC=1
    t.clc0tz:	add	%g2,%l7,%g2	! ##TEMPLATE:IAR
t.clc0e:
		ba	break0		!
		nop			!
    t.clc0o0:	add	%l0,0,%o0	! ##TEMPLATE:%l0,imm0
    t.clc0o1:	add	%l0,0,%o1	! ##TEMPLATE:%l0,imm0
    t.clc0o2:	ldub	[%o0+0],%g0	! ##TEMPLATE:imm0 (L)
    t.clc0o3:	ldub	[%o1+0],%g0	! ##TEMPLATE:imm0 (L)
    t.clc0o4:	subcc	%o2,0,%g0	! ##TEMPLATE:imm0 (L)
    t.clc0oy:	add	%g2,6,%g2	! ##TEMPLATE:IAR
    t.clc0oz:	add	%g2,4,%g2	! ##TEMPLATE:IAR

	.section ".text"
	.align	4
	.global ci6_oc,ti6_oc,ii6_oc
ci6_oc:
	retl				!
	add	%g0,t.oc0e-t.oc0s,%o0	!
ti6_oc:
	sethi	%hi(t.oc0s),%o3		!
	or	%o3,%lo(t.oc0s),%o3	!
	or	%g0,t.oc0e-t.oc0s,%o4	!
    t.oc0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.oc0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.oc0o0-t.oc0s],%o5!
	srl	%o2,28,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	srl	%o2,16,%o4		!
	and	%o4,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.oc0t0-t.oc0s]!
	ld	[%o3+t.oc0o1-t.oc0s],%o5!
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B1
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	and	%o1,0xfff,%o4		! D1
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.oc0t1-t.oc0s]!
	ld	[%o3+t.oc0o2-t.oc0s],%o5!
	srl	%o1,16,%o4		!
	and	%o4,0xff,%o4		! L
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.oc0t2-t.oc0s]!
	ld	[%o3+t.oc0o3-t.oc0s],%o5!
	srl	%o1,16,%o4		!
	and	%o4,0xff,%o4		! L
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.oc0t3-t.oc0s]!
	ld	[%o3+t.oc0o4-t.oc0s],%o5!
	srl	%o1,16,%o4		!
	and	%o4,0xff,%o4		! L
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.oc0t4-t.oc0s]!
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=6
	ld	[%o3+t.oc0oy-t.oc0s],%o5!
	bnz,a	.+8			! if EX=1 then IAR+=4
	ld	[%o3+t.oc0oz-t.oc0s],%o5!
	st	%o5,[%o0+t.oc0tz-t.oc0s]!
	retl				!
	add	%o0,t.oc0e-t.oc0s,%o0	!
ii6_oc:
	srl	%o2,28,%o4		! B2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l3		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l3		! %l3
	srl	%o2,16,%o4		! D2
	and	%o4,0xfff,%l4		! %l4
	srl	%o1,12,%o4		! B1
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l1		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l1		! %l1
	and	%o1,0xfff,%l2		! D1
	srl	%o1,16,%o4		! L
	and	%o4,0xff,%l5		! %l5
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=6
	add	%g0,6,%l7		!
	bnz,a	.+8			! if EX=1 then IAR+=4
	add	%g0,4,%l7		!
t.oc0s:
    t.oc0t0:	add	%l3,%l4,%o0	! ##TEMPLATE:%l0,imm0
		and	%o0,%g3,%o0	! mask address
		add	%g4,%o0,%o0	!
    t.oc0t1:	add	%l1,%l2,%o1	! ##TEMPLATE:%l0,imm0
		and	%o1,%g3,%o1	! mask address
		add	%g4,%o1,%o1	!
		ldub	[%o0],%g0	! force PAGEIN
    t.oc0t2:	ldub	[%o0+%l5],%g0	! ##TEMPLATE:imm0 (L)
		ldub	[%o1],%g0	! force PAGEIN
    t.oc0t3:	ldub	[%o1+%l5],%g0	! ##TEMPLATE:imm0 (L)
		andn	%g1,3,%g1	! CC=0
		add	%g0,0,%o2	! counter
		add	%g0,0,%o5	!
    t.oc000:	ldub	[%o0+%o2],%o3	!
		ldub	[%o1+%o2],%o4	!
    t.oc0t4:	subcc	%o2,%l5,%g0	! ##TEMPLATE:imm0 (L)
		or	%o3,%o4,%o3	!
		or	%o5,%o3,%o5	!
		stb	%o3,[%o1+%o2]	!
		bne	t.oc000		!
		add	%o2,1,%o2	!
		subcc	%o5,0,%g0	!
		bnz,a	t.oc0tz		! if Result != 0 then
		or	%g1,1,%g1	!   CC=1
    t.oc0tz:	add	%g2,%l7,%g2	! ##TEMPLATE:IAR
t.oc0e:
		ba	break0		!
		nop			!
    t.oc0o0:	add	%l0,0,%o0	! ##TEMPLATE:%l0,imm0
    t.oc0o1:	add	%l0,0,%o1	! ##TEMPLATE:%l0,imm0
    t.oc0o2:	ldub	[%o0+0],%g0	! ##TEMPLATE:imm0 (L)
    t.oc0o3:	ldub	[%o1+0],%g0	! ##TEMPLATE:imm0 (L)
    t.oc0o4:	subcc	%o2,0,%g0	! ##TEMPLATE:imm0 (L)
    t.oc0oy:	add	%g2,6,%g2	! ##TEMPLATE:IAR
    t.oc0oz:	add	%g2,4,%g2	! ##TEMPLATE:IAR

	.section ".text"
	.align	4
	.global ci6_xc,ti6_xc,ii6_xc
ci6_xc:
	retl				!
	add	%g0,t.xc0e-t.xc0s,%o0	!
ti6_xc:
	sethi	%hi(t.xc0s),%o3		!
	or	%o3,%lo(t.xc0s),%o3	!
	or	%g0,t.xc0e-t.xc0s,%o4	!
    t.xc0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.xc0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.xc0o0-t.xc0s],%o5!
	srl	%o2,28,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	srl	%o2,16,%o4		!
	and	%o4,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.xc0t0-t.xc0s]!
	ld	[%o3+t.xc0o1-t.xc0s],%o5!
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B1
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	and	%o1,0xfff,%o4		! D1
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.xc0t1-t.xc0s]!
	ld	[%o3+t.xc0o2-t.xc0s],%o5!
	srl	%o1,16,%o4		!
	and	%o4,0xff,%o4		! L
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.xc0t2-t.xc0s]!
	ld	[%o3+t.xc0o3-t.xc0s],%o5!
	srl	%o1,16,%o4		!
	and	%o4,0xff,%o4		! L
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.xc0t3-t.xc0s]!
	ld	[%o3+t.xc0o4-t.xc0s],%o5!
	srl	%o1,16,%o4		!
	and	%o4,0xff,%o4		! L
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.xc0t4-t.xc0s]!
	ld	[%o3+t.xc0o5-t.xc0s],%o5!
	srl	%o1,16,%o4		!
	and	%o4,0xff,%o4		! L
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.xc0t5-t.xc0s]!
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=6
	ld	[%o3+t.xc0oy-t.xc0s],%o5!
	bnz,a	.+8			! if EX=1 then IAR+=4
	ld	[%o3+t.xc0oz-t.xc0s],%o5!
	st	%o5,[%o0+t.xc0tz-t.xc0s]!
	retl				!
	add	%o0,t.xc0e-t.xc0s,%o0	!
ii6_xc:
	srl	%o2,28,%o4		! B2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l3		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l3		! %l3
	srl	%o2,16,%o4		! D2
	and	%o4,0xfff,%l4		! %l4
	srl	%o1,12,%o4		! B1
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l1		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l1		! %l1
	and	%o1,0xfff,%l2		! D1
	srl	%o1,16,%o4		! L
	and	%o4,0xff,%l5		! %l5
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=6
	add	%g0,6,%l7		!
	bnz,a	.+8			! if EX=1 then IAR+=4
	add	%g0,4,%l7		!
t.xc0s:
    t.xc0t0:	add	%l3,%l4,%o0	! ##TEMPLATE:%l0,imm0
		and	%o0,%g3,%o0	! mask address
		add	%g4,%o0,%o0	!
    t.xc0t1:	add	%l1,%l2,%o1	! ##TEMPLATE:%l0,imm0
		and	%o1,%g3,%o1	! mask address
		add	%g4,%o1,%o1	!
		ldub	[%o0],%g0	! force PAGEIN
    t.xc0t2:	ldub	[%o0+%l5],%g0	! ##TEMPLATE:imm0 (L)
		ldub	[%o1],%g0	! force PAGEIN
    t.xc0t3:	ldub	[%o1+%l5],%g0	! ##TEMPLATE:imm0 (L)
		andn	%g1,3,%g1	! CC=0
		subcc	%o0,%o1,%g0	! if R1 == R2 then
		be	t.xc010		!   short cut
		add	%g0,0,%o2	! counter
		add	%g0,0,%o5	! zero flag
    t.xc000:	ldub	[%o0+%o2],%o3	!
		ldub	[%o1+%o2],%o4	!
    t.xc0t4:	subcc	%o2,%l5,%g0	! ##TEMPLATE:imm0 (L)
		xor	%o3,%o4,%o3	!
		or	%o5,%o3,%o5	!
		stb	%o3,[%o1+%o2]	!
		bne	t.xc000		!
		add	%o2,1,%o2	!
		subcc	%o5,0,%g0	!
		bnz,a	t.xc0tz		! if Result != 0 then
		or	%g1,1,%g1	!   CC=1
		ba,a	t.xc0tz		!
    t.xc010:	stb	%g0,[%o1+%o2]	!
    t.xc0t5:	subcc	%o2,%l5,%g0	! ##TEMPLATE:imm0 (L)
		bne	t.xc010		!
		add	%o2,1,%o2	! always CC=0
    t.xc0tz:	add	%g2,%l7,%g2	! ##TEMPLATE:IAR
t.xc0e:
		ba	break0		!
		nop			!
    t.xc0o0:	add	%l0,0,%o0	! ##TEMPLATE:%l0,imm0
    t.xc0o1:	add	%l0,0,%o1	! ##TEMPLATE:%l0,imm0
    t.xc0o2:	ldub	[%o0+0],%g0	! ##TEMPLATE:imm0 (L)
    t.xc0o3:	ldub	[%o1+0],%g0	! ##TEMPLATE:imm0 (L)
    t.xc0o4:	subcc	%o2,0,%g0	! ##TEMPLATE:imm0 (L)
    t.xc0o5:	subcc	%o2,0,%g0	! ##TEMPLATE:imm0 (L)
    t.xc0oy:	add	%g2,6,%g2	! ##TEMPLATE:IAR
    t.xc0oz:	add	%g2,4,%g2	! ##TEMPLATE:IAR

	.section ".text"
	.align	4
	.global ci6_tr,ti6_tr,ii6_tr
ci6_tr:
	retl				!
	add	%g0,t.tr0e-t.tr0s,%o0	!
ti6_tr:
	sethi	%hi(t.tr0s),%o3		!
	or	%o3,%lo(t.tr0s),%o3	!
	or	%g0,t.tr0e-t.tr0s,%o4	!
    t.tr0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.tr0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.tr0o0-t.tr0s],%o5!
	srl	%o2,28,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	srl	%o2,16,%o4		!
	and	%o4,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.tr0t0-t.tr0s]!
	ld	[%o3+t.tr0o1-t.tr0s],%o5!
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B1
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	and	%o1,0xfff,%o4		! D1
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.tr0t1-t.tr0s]!
	ld	[%o3+t.tr0o2-t.tr0s],%o5!
	srl	%o1,16,%o4		!
	and	%o4,0xff,%o4		! L
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.tr0t2-t.tr0s]!
	ld	[%o3+t.tr0o3-t.tr0s],%o5!
	srl	%o1,16,%o4		!
	and	%o4,0xff,%o4		! L
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.tr0t3-t.tr0s]!
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=6
	ld	[%o3+t.tr0oy-t.tr0s],%o5!
	bnz,a	.+8			! if EX=1 then IAR+=4
	ld	[%o3+t.tr0oz-t.tr0s],%o5!
	st	%o5,[%o0+t.tr0tz-t.tr0s]!
	retl				!
	add	%o0,t.tr0e-t.tr0s,%o0	!
ii6_tr:
	srl	%o2,28,%o4		! B2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l3		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l3		! %l3
	srl	%o2,16,%o4		! D2
	and	%o4,0xfff,%l4		! %l4
	srl	%o1,12,%o4		! B1
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l1		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l1		! %l1
	and	%o1,0xfff,%l2		! D1
	srl	%o1,16,%o4		! L
	and	%o4,0xff,%l5		! %l5
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=6
	add	%g0,6,%l7		!
	bnz,a	.+8			! if EX=1 then IAR+=4
	add	%g0,4,%l7		!
t.tr0s:
    t.tr0t0:	add	%l3,%l4,%o0	! ##TEMPLATE:%l0,imm0
		and	%o0,%g3,%o0	! mask address
		add	%g4,%o0,%o0	!
    t.tr0t1:	add	%l1,%l2,%o1	! ##TEMPLATE:%l0,imm0
		and	%o1,%g3,%o1	! mask address
		add	%g4,%o1,%o1	!
		add	%g0,0,%o2	! TRIAL-EXEC counter
    t.tr000:	ldub	[%o1+%o2],%o4	! TRIAL-EXEC get index
		ldub	[%o0+%o4],%g0	! TRIAL-EXEC get indexed character
    t.tr0t2:	subcc	%o2,%l5,%g0	! TRIAL-EXEC ##TEMPLATE:imm0 (L)
		bne	t.tr000		! TRIAL-EXEC
		add	%o2,1,%o2	! TRIAL-EXEC
		add	%g0,0,%o2	! counter
    t.tr001:	ldub	[%o1+%o2],%o4	! get index
		ldub	[%o0+%o4],%o3	! get indexed character
    t.tr0t3:	subcc	%o2,%l5,%g0	! ##TEMPLATE:imm0 (L)
		stb	%o3,[%o1+%o2]	! store indexed character
		bne	t.tr001		!
		add	%o2,1,%o2	!
    t.tr0tz:	add	%g2,%l7,%g2	! ##TEMPLATE:IAR
t.tr0e:
		ba	break0		!
		nop			!
    t.tr0o0:	add	%l0,0,%o0	! ##TEMPLATE:%l0,imm0
    t.tr0o1:	add	%l0,0,%o1	! ##TEMPLATE:%l0,imm0
    t.tr0o2:	subcc	%o2,0,%g0	! TRIAL-EXEC ##TEMPLATE:imm0 (L)
    t.tr0o3:	subcc	%o2,0,%g0	! ##TEMPLATE:imm0 (L)
    t.tr0oy:	add	%g2,6,%g2	! ##TEMPLATE:IAR
    t.tr0oz:	add	%g2,4,%g2	! ##TEMPLATE:IAR

	.section ".text"
	.align	4
	.global ci6_trt,ti6_trt,ii6_trt
ci6_trt:
	retl				!
	add	%g0,t.trt0e-t.trt0s,%o0	!
ti6_trt:
	sethi	%hi(t.trt0s),%o3	!
	or	%o3,%lo(t.trt0s),%o3	!
	or	%g0,t.trt0e-t.trt0s,%o4	!
    t.trt0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.trt0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.trt0o0-t.trt0s],%o5
	srl	%o2,28,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	srl	%o2,16,%o4		!
	and	%o4,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.trt0t0-t.trt0s]
	ld	[%o3+t.trt0o1-t.trt0s],%o5
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B1
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	and	%o1,0xfff,%o4		! D1
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.trt0t1-t.trt0s]
	ld	[%o3+t.trt0o2-t.trt0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xff,%o4		! L
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.trt0t2-t.trt0s]
	ld	[%o3+t.trt0o3-t.trt0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xff,%o4		! L
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.trt0t3-t.trt0s]
	ld	[%o3+t.trt0o4-t.trt0s],%o5
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B1
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	and	%o1,0xfff,%o4		! D1
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.trt0t4-t.trt0s]
	ld	[%o3+t.trt0o5-t.trt0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xff,%o4		! L
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.trt0t5-t.trt0s]
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=6
	ld	[%o3+t.trt0oy-t.trt0s],%o5
	bnz,a	.+8			! if EX=1 then IAR+=4
	ld	[%o3+t.trt0oz-t.trt0s],%o5
	st	%o5,[%o0+t.trt0tz-t.trt0s]
	retl				!
	add	%o0,t.trt0e-t.trt0s,%o0	!
t.trt0s:
    t.trt0t0:	add	%l0,0,%o0	! ##TEMPLATE:%l0,imm0
		and	%o0,%g3,%o0	! mask address
		add	%g4,%o0,%o0	!
    t.trt0t1:	add	%l0,0,%o1	! ##TEMPLATE:%l0,imm0
		and	%o1,%g3,%o1	! mask address
		add	%g4,%o1,%o1	!
		add	%g0,0,%o2	! TRIAL-EXEC counter
    t.trt000:	ldub	[%o1+%o2],%o4	! TRIAL-EXEC get index
		ldub	[%o0+%o4],%o3	! TRIAL-EXEC get indexed character
		subcc	%o3,0,%g0	! TRIAL-EXEC
		bnz	t.trt001	! TRIAL-EXEC
    t.trt0t2:	subcc	%o2,0,%g0	! TRIAL-EXEC ##TEMPLATE:imm0 (L)
		bne	t.trt000	! TRIAL-EXEC
		add	%o2,1,%o2	! TRIAL-EXEC
    t.trt001:	andn	%g1,3,%g1	! CC=0
		add	%g0,0,%o2	! counter
    t.trt002:	ldub	[%o1+%o2],%o4	! get index
		ldub	[%o0+%o4],%o3	! get indexed character
		subcc	%o3,0,%g0	!
		bnz	t.trt0t4	!
    t.trt0t3:	subcc	%o2,0,%g0	! ##TEMPLATE:imm0 (L)
		bne	t.trt002	!
		add	%o2,1,%o2	!
		ba,a	t.trt0tz	!
    t.trt0t4:	add	%l0,0,%o1	! ##TEMPLATE:%l0,imm0
		add	%o1,%o2,%o1	!
		andcc	%g7,0x10,%g0	! check AM(address mode)
		bnz	t.trt003	!
		srl	%l1,24,%l1	!
		sll	%l1,24,%l1	!
		sll	%o1,8,%o1	!
		srl	%o1,8,%o1	!
		ba	t.trt004	!
		or	%l1,%o1,%l1	! 24bit argument address
    t.trt003:	sll	%o1,1,%o1	!
		srl	%o1,1,%l1	! 31bit argument address
    t.trt004:	andn	%l2,0xff,%l2	!
		or	%l2,%o3,%l2	! function byte
    t.trt0t5:	subcc	%o2,0,%g0	! ##TEMPLATE:imm0 (L)
		bne,a	t.trt0tz	! if not last byte
		or	%g1,1,%g1	!   CC=1
		be,a	t.trt0tz	! if last byte
		or	%g1,2,%g1	!   CC=2
    t.trt0tz:	add	%g2,6,%g2	! ##TEMPLATE:IAR
t.trt0e:
    t.trt0o0:	add	%l0,0,%o0	! ##TEMPLATE:%l0,imm0
    t.trt0o1:	add	%l0,0,%o1	! ##TEMPLATE:%l0,imm0
    t.trt0o2:	subcc	%o2,0,%g0	! TRIAL-EXEC ##TEMPLATE:imm0 (L)
    t.trt0o3:	subcc	%o2,0,%g0	! ##TEMPLATE:imm0 (L)
    t.trt0o4:	add	%l0,0,%o1	! ##TEMPLATE:%l0,imm0
    t.trt0o5:	subcc	%o2,0,%g0	! ##TEMPLATE:imm0 (L)
    t.trt0oy:	add	%g2,6,%g2	! ##TEMPLATE:IAR
    t.trt0oz:	add	%g2,4,%g2	! ##TEMPLATE:IAR
ii6_trt:
	srl	%o2,28,%o4		! B2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l3		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l3		! %l3
	srl	%o2,16,%o4		! D2
	and	%o4,0xfff,%l4		! %l4
	srl	%o1,12,%o4		! B1
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l1		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l1		! %l1
	and	%o1,0xfff,%l2		! D1
	srl	%o1,16,%o4		! L
	and	%o4,0xff,%l5		! %l5
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=6
	add	%g0,6,%l7		!
	bnz,a	.+8			! if EX=1 then IAR+=4
	add	%g0,4,%l7		!
i.trt0s:
    i.trt0t0:	add	%l3,%l4,%o0	! ##TEMPLATE:%l0,imm0
		and	%o0,%g3,%o0	! mask address
		add	%g4,%o0,%o0	!
    i.trt0t1:	add	%l1,%l2,%o1	! ##TEMPLATE:%l0,imm0
		and	%o1,%g3,%o1	! mask address
		add	%g4,%o1,%o1	!
		add	%g0,0,%o2	! TRIAL-EXEC counter
    i.trt000:	ldub	[%o1+%o2],%o4	! TRIAL-EXEC get index
		ldub	[%o0+%o4],%o3	! TRIAL-EXEC get indexed character
		subcc	%o3,0,%g0	! TRIAL-EXEC
		bnz	i.trt001	! TRIAL-EXEC
    i.trt0t2:	subcc	%o2,%l5,%g0	! TRIAL-EXEC ##TEMPLATE:imm0 (L)
		bne	i.trt000	! TRIAL-EXEC
		add	%o2,1,%o2	! TRIAL-EXEC
    i.trt001:	ld	[%o7+4],%i1	! ##Mreg1 -> %i1
		ld	[%o7+8],%i2	! ##Mreg2 -> %i2
		andn	%g1,3,%g1	! CC=0
		add	%g0,0,%o2	! counter
    i.trt002:	ldub	[%o1+%o2],%o4	! get index
		ldub	[%o0+%o4],%o3	! get indexed character
		subcc	%o3,0,%g0	!
		bnz	i.trt0t4	!
    i.trt0t3:	subcc	%o2,%l5,%g0	! ##TEMPLATE:imm0 (L)
		bne	i.trt002	!
		add	%o2,1,%o2	!
		ba,a	i.trt0tz	!
    i.trt0t4:	add	%l1,%l2,%o1	! ##TEMPLATE:%l0,imm0
		add	%o1,%o2,%o1	!
		andcc	%g7,0x10,%g0	! check AM(address mode)
		bnz	i.trt003	!
		srl	%i1,24,%i1	!
		sll	%i1,24,%i1	!
		sll	%o1,8,%o1	!
		srl	%o1,8,%o1	!
		ba	i.trt004	!
		or	%i1,%o1,%i1	! 24bit argument address
    i.trt003:	sll	%o1,1,%o1	!
		srl	%o1,1,%i1	! 31bit argument address
    i.trt004:	andn	%i2,0xff,%i2	!
		or	%i2,%o3,%i2	! function byte
    i.trt0t5:	subcc	%o2,%l5,%g0	! ##TEMPLATE:imm0 (L)
		bne,a	i.trt0tz	! if not last byte
		or	%g1,1,%g1	!   CC=1
		be,a	i.trt0tz	! if last byte
		or	%g1,2,%g1	!   CC=2
    i.trt0tz:	st	%i1,[%o7+4]	!
		st	%i2,[%o7+8]	!
		ba	break0		!
		add	%g2,%l7,%g2	! ##TEMPLATE:IAR
i.trt0e:

	.section ".text"
	.align	4
	.global cd6_ed,td6_ed,id6_ed
cd6_ed:
	retl				!
	add	%g0,t.ed0e-t.ed0s,%o0	!
td6_ed:
	sethi	%hi(t.ed0s),%o3		!
	or	%o3,%lo(t.ed0s),%o3	!
	or	%g0,t.ed0e-t.ed0s,%o4	!
    t.ed0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.ed0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.ed0o0-t.ed0s],%o5!
	srl	%o2,28,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	srl	%o2,16,%o4		!
	and	%o4,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.ed0t0-t.ed0s]!
	ld	[%o3+t.ed0o1-t.ed0s],%o5!
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B1
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	and	%o1,0xfff,%o4		! D1
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.ed0t1-t.ed0s]!
	ld	[%o3+t.ed0o2-t.ed0s],%o5!
	srl	%o1,16,%o4		!
	and	%o4,0xff,%o4		! L
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.ed0t2-t.ed0s]!
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=6
	ld	[%o3+t.ed0oy-t.ed0s],%o5!
	bnz,a	.+8			! if EX=1 then IAR+=4
	ld	[%o3+t.ed0oz-t.ed0s],%o5!
	st	%o5,[%o0+t.ed0tz-t.ed0s]!
	retl				!
	add	%o0,t.ed0e-t.ed0s,%o0	!
id6_ed:
	srl	%o2,28,%o4		! B2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l3		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l3		! %l3
	srl	%o2,16,%o4		! D2
	and	%o4,0xfff,%l4		! %l4
	srl	%o1,12,%o4		! B1
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l1		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l1		! %l1
	and	%o1,0xfff,%l2		! D1
	srl	%o1,16,%o4		! L
	and	%o4,0xff,%l5		! %l5
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=6
	add	%g0,6,%l7		!
	bnz,a	.+8			! if EX=1 then IAR+=4
	add	%g0,4,%l7		!
t.ed0s:
    t.ed0t0:	add	%l3,%l4,%o2	! ##TEMPLATE:%l0,imm0
		and	%o2,%g3,%o2	! mask address
		add	%g4,%o2,%o2	!
    t.ed0t1:	add	%l1,%l2,%o1	! ##TEMPLATE:%l0,imm0
		and	%o1,%g3,%o1	! mask address
		add	%g4,%o1,%o1	!
    t.ed0t2:	add	%g0,%l5,%o3	! ##TEMPLATE:imm0 (L)
		ld	[%sp+184],%o0	! struct *gcpu_s
		sethi	%hi(il_ed),%o7	!
		jmpl	%o7+%lo(il_ed),%o7
		nop			! call library in intlib.s
		sethi	%hi(0x00ff0000),%o1
		andcc	%g7,%o1,%g0	! if intermediate intr. then
		bz,a	t.ed0e		!   exit
    t.ed0tz:	add	%g2,%l7,%g2	! ##TEMPLATE:IAR
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		nop			!
t.ed0e:
		ba	break0		!
		nop			!
    t.ed0o0:	add	%l0,0,%o2	! ##TEMPLATE:%l0,imm0
    t.ed0o1:	add	%l0,0,%o1	! ##TEMPLATE:%l0,imm0
    t.ed0o2:	add	%g0,0,%o3	! ##TEMPLATE:imm0 (L)
    t.ed0oy:	add	%g2,6,%g2	! ##TEMPLATE:IAR
    t.ed0oz:	add	%g2,4,%g2	! ##TEMPLATE:IAR

	.section ".text"
	.align	4
	.global cd6_edmk,td6_edmk,id6_edmk
cd6_edmk:
	retl				!
	add	%g0,t.edmk0e-t.edmk0s,%o0
td6_edmk:
	sethi	%hi(t.edmk0s),%o3	!
	or	%o3,%lo(t.edmk0s),%o3	!
	or	%g0,t.edmk0e-t.edmk0s,%o4
    t.edmk0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.edmk0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.edmk0o0-t.edmk0s],%o5
	srl	%o2,28,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	srl	%o2,16,%o4		!
	and	%o4,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.edmk0t0-t.edmk0s]
	ld	[%o3+t.edmk0o1-t.edmk0s],%o5
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B1
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	and	%o1,0xfff,%o4		! D1
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.edmk0t1-t.edmk0s]
	ld	[%o3+t.edmk0o2-t.edmk0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xff,%o4		! L
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.edmk0t2-t.edmk0s]
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=6
	ld	[%o3+t.edmk0oy-t.edmk0s],%o5
	bnz,a	.+8			! if EX=1 then IAR+=4
	ld	[%o3+t.edmk0oz-t.edmk0s],%o5
	st	%o5,[%o0+t.edmk0tz-t.edmk0s]
	retl				!
	add	%o0,t.edmk0e-t.edmk0s,%o0
t.edmk0s:
    t.edmk0t0:	add	%l0,0,%o2	! ##TEMPLATE:%l0,imm0
		and	%o2,%g3,%o2	! mask address
		add	%g4,%o2,%o2	!
    t.edmk0t1:	add	%l0,0,%o1	! ##TEMPLATE:%l0,imm0
		and	%o1,%g3,%o4	! mask address(%o4:for Mreg1)
		add	%g4,%o4,%o1	!
    t.edmk0t2:	add	%g0,0,%o3	! ##TEMPLATE:imm0 (L)
		ld	[%sp+184],%o0	! struct *gcpu_s
		add	%l1,%g0,%o5	! ##Mreg1 -> %o5
		sethi	%hi(il_edmk),%o7!
		jmpl	%o7+%lo(il_edmk),%o7
		nop			! call library in intlib.s
		add	%o5,%g0,%l1	! ##%o5 -> Mreg1
		sethi	%hi(0x00ff0000),%o1
		andcc	%g7,%o1,%g0	! if intermediate intr. then
		bz,a	t.edmk0e	!   exit
    t.edmk0tz:	add	%g2,6,%g2	! ##TEMPLATE:IAR
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		nop			!
t.edmk0e:
    t.edmk0o0:	add	%l0,0,%o2	! ##TEMPLATE:%l0,imm0
    t.edmk0o1:	add	%l0,0,%o1	! ##TEMPLATE:%l0,imm0
    t.edmk0o2:	add	%g0,0,%o3	! ##TEMPLATE:imm0 (L)
    t.edmk0oy:	add	%g2,6,%g2	! ##TEMPLATE:IAR
    t.edmk0oz:	add	%g2,4,%g2	! ##TEMPLATE:IAR
id6_edmk:
	srl	%o2,28,%o4		! B2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l3		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l3		! %l3
	srl	%o2,16,%o4		! D2
	and	%o4,0xfff,%l4		! %l4
	srl	%o1,12,%o4		! B1
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l1		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l1		! %l1
	and	%o1,0xfff,%l2		! D1
	srl	%o1,16,%o4		! L
	and	%o4,0xff,%l5		! %l5
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=6
	add	%g0,6,%l7		!
	bnz,a	.+8			! if EX=1 then IAR+=4
	add	%g0,4,%l7		!
i.edmk0s:
    i.edmk0t0:	add	%l3,%l4,%o2	! ##TEMPLATE:%l0,imm0
		and	%o2,%g3,%o2	! mask address
		add	%g4,%o2,%o2	!
    i.edmk0t1:	add	%l1,%l2,%o1	! ##TEMPLATE:%l0,imm0
		and	%o1,%g3,%o4	! mask address(%o4:for Mreg1)
		add	%g4,%o4,%o1	!
    i.edmk0t2:	add	%g0,%l5,%o3	! ##TEMPLATE:imm0 (L)
		ld	[%sp+184],%o0	! struct *gcpu_s
		ld	[%o0+4],%o5	! ##Mreg1 -> %o5
		call	il_edmk		!
		nop			! call library in intlib.s
		ld	[%sp+184],%o7	! struct *gcpu_s
		st	%o5,[%o7+4]	! ##%o5 -> Mreg1
		sethi	%hi(0x00ff0000),%o1
		andcc	%g7,%o1,%g0	! if intermediate intr. then
		bz,a	break0		!   exit
    i.edmk0tz:	add	%g2,%l7,%g2	! ##TEMPLATE:IAR
		ba	epilog0		!
		nop			!
i.edmk0e:
!================================

!
! templates
! cxx_xxx:
!   %o0: param: none
!	 retval:size of template
!   %o1: M instruction (6 bytes)
!   %o2: M instruction (lower 2bytes)
!   %o3: work
!   %o4: work
!   %o5: work
! txx_xxx:
!   %o0: param: bufp start address
!	 retval:bufp next start address
!   %o1: M instruction (6 bytes)
!   %o2: M instruction (lower 2bytes)
!   %o3: work
!   %o4: work
!   %o5: work
!
	.section ".text"
	.align	4
	.global cc6_e5xx,tc6_e5xx,ic6_e5xx
cc6_e5xx:
	retl				!
	add	%g0,t.e5xx0e-t.e5xx0s,%o0
tc6_e5xx:
	sethi	%hi(t.e5xx0s),%o3	!
	or	%o3,%lo(t.e5xx0s),%o3	!
	or	%g0,t.e5xx0e-t.e5xx0s,%o4
    t.e5xx0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.e5xx0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.e5xx0o0-t.e5xx0s],%o5
	srl	%o1,10,%o4		!
	or	%o5,%o4,%o5		! simm22
	st	%o5,[%o0+t.e5xx0t0-t.e5xx0s]
	ld	[%o3+t.e5xx0o1-t.e5xx0s],%o5
	and	%o1,0xfff,%o4		!
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.e5xx0t1-t.e5xx0s]
	ld	[%o3+t.e5xx0o2-t.e5xx0s],%o5
	srl	%o2,10,%o4		!
	or	%o5,%o4,%o5		! simm22
	st	%o5,[%o0+t.e5xx0t2-t.e5xx0s]
	ld	[%o3+t.e5xx0o3-t.e5xx0s],%o5
	and	%o2,0xfff,%o4		!
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.e5xx0t3-t.e5xx0s]
	retl				!
	add	%o0,t.e5xx0e-t.e5xx0s,%o0
ic6_e5xx:
t.e5xx0s:
		ld	[%sp+184],%o7	! struct *gcpu_s
    t.e5xx0t0:	sethi	0,%o0		! ##TEMPLATE:imm
    t.e5xx0t1:	or	%o1,0,%o0	! ##TEMPLATE:imm
		st	%o0,[%o7+704]	! store minsn (upper)
    t.e5xx0t2:	sethi	0,%o0		! ##TEMPLATE:imm
    t.e5xx0t3:	or	%o2,0,%o0	! ##TEMPLATE:imm
		st	%o0,[%o7+708]	! store minsn (lower)
		sethi	%hi(0x80000000),%o0
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		or	%g7,%o0,%g7	! Special Instruction (FC=2)
t.e5xx0e:
    t.e5xx0o0:	sethi	0,%o0		! ##TEMPLATE:imm
    t.e5xx0o1:	or	%o0,0,%o0	! ##TEMPLATE:imm
    t.e5xx0o2:	sethi	0,%o0		! ##TEMPLATE:imm
    t.e5xx0o3:	or	%o0,0,%o0	! ##TEMPLATE:imm

	.section ".text"
	.align	4
	.global ci6_mvcin,ti6_mvcin,ii6_mvcin
ci6_mvcin:
	retl				!
	add	%g0,t.mvcin0e-t.mvcin0s,%o0
ti6_mvcin:
	sethi	%hi(t.mvcin0s),%o3	!
	or	%o3,%lo(t.mvcin0s),%o3	!
	or	%g0,t.mvcin0e-t.mvcin0s,%o4
    t.mvcin0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.mvcin0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.mvcin0o0-t.mvcin0s],%o5
	srl	%o2,28,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	srl	%o2,16,%o4		!
	and	%o4,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.mvcin0t0-t.mvcin0s]
	ld	[%o3+t.mvcin0o1-t.mvcin0s],%o5
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B1
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	and	%o1,0xfff,%o4		! D1
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.mvcin0t1-t.mvcin0s]
	ld	[%o3+t.mvcin0o2-t.mvcin0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xff,%o4		! -L
	sub	%g0,%o4,%o4		! |
	sll	%o4,19,%o4		! |
	srl	%o4,19,%o4		! |
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.mvcin0t2-t.mvcin0s]
	ld	[%o3+t.mvcin0o3-t.mvcin0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xff,%o4		! L
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.mvcin0t3-t.mvcin0s]
	ld	[%o3+t.mvcin0o4-t.mvcin0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xff,%o4		! L
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.mvcin0t4-t.mvcin0s]
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=6
	ld	[%o3+t.mvcin0oy-t.mvcin0s],%o5
	bnz,a	.+8			! if EX=1 then IAR+=4
	ld	[%o3+t.mvcin0oz-t.mvcin0s],%o5
	st	%o5,[%o0+t.mvcin0tz-t.mvcin0s]
	retl				!
	add	%o0,t.mvcin0e-t.mvcin0s,%o0
ii6_mvcin:
	srl	%o2,28,%o4		! B2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l3		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l3		! %l3
	srl	%o2,16,%o4		! D2
	and	%o4,0xfff,%l4		! %l4
	srl	%o1,12,%o4		! B1
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l1		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l1		! %l1
	and	%o1,0xfff,%l2		! D1
	srl	%o1,16,%o4		! L
	and	%o4,0xff,%l5		! %l5
	sub	%g0,%l5,%l6		! %l6
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=6
	add	%g0,6,%l7		!
	bnz,a	.+8			! if EX=1 then IAR+=4
	add	%g0,4,%l7		!
t.mvcin0s:
    t.mvcin0t0:	add	%l3,%l4,%o0	! ##TEMPLATE:%l0,imm0
		and	%o0,%g3,%o0	! mask address
		add	%g4,%o0,%o0	!
    t.mvcin0t1:	add	%l1,%l2,%o1	! ##TEMPLATE:%l0,imm0
		and	%o1,%g3,%o1	! mask address
		add	%g4,%o1,%o1	!
		ldub	[%o0],%g0	! force PAGEIN
    t.mvcin0t2:	ldub	[%o0+%l6],%g0	! ##TEMPLATE:imm0 (L)
		ldub	[%o1],%g0	! force PAGEIN
    t.mvcin0t3:	ldub	[%o1+%l5],%g0	! ##TEMPLATE:imm0 (L)
		add	%g0,0,%o2	! counter--
		add	%g0,0,%o3	! counter++
    t.mvcin000:	ldub	[%o0+%o2],%o4	!
    t.mvcin0t4:	subcc	%o3,%l5,%g0	! ##TEMPLATE:imm0 (L)
		stb	%o4,[%o1+%o3]	!
		sub	%o2,1,%o2	!
		bne	t.mvcin000	!
		add	%o3,1,%o3	!
    t.mvcin0tz:	add	%g2,%l7,%g2	! ##TEMPLATE:IAR
t.mvcin0e:
		ba	break0		!
		nop			!
    t.mvcin0o0:	add	%l0,0,%o0	! ##TEMPLATE:%l0,imm0
    t.mvcin0o1:	add	%l0,0,%o1	! ##TEMPLATE:%l0,imm0
    t.mvcin0o2:	ldub	[%o0-0],%g0	! ##TEMPLATE:imm0 (L)
    t.mvcin0o3:	ldub	[%o1+0],%g0	! ##TEMPLATE:imm0 (L)
    t.mvcin0o4:	subcc	%o3,0,%g0	! ##TEMPLATE:imm0 (L)
    t.mvcin0oy:	add	%g2,6,%g2	! ##TEMPLATE:IAR
    t.mvcin0oz:	add	%g2,4,%g2	! ##TEMPLATE:IAR
!================================

!
! templates
! cxx_xxx:
!   %o0: param: none
!	 retval:size of template
!   %o1: M instruction (6 bytes)
!   %o2: M instruction (lower 2bytes)
!   %o3: work
!   %o4: work
!   %o5: work
! txx_xxx:
!   %o0: param: bufp start address
!	 retval:bufp next start address
!   %o1: M instruction (6 bytes)
!   %o2: M instruction (lower 2bytes)
!   %o3: work
!   %o4: work
!   %o5: work
!
	.section ".text"
	.align	4
	.global cd6_srp,td6_srp,id6_srp
cd6_srp:
	retl				!
	add	%g0,t.srp0e-t.srp0s,%o0	!
td6_srp:
	sethi	%hi(t.srp0s),%o3	!
	or	%o3,%lo(t.srp0s),%o3	!
	or	%g0,t.srp0e-t.srp0s,%o4	!
    t.srp0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.srp0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.srp0o0-t.srp0s],%o5
	srl	%o2,28,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	srl	%o2,16,%o4		!
	and	%o4,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.srp0t0-t.srp0s]
	ld	[%o3+t.srp0o1-t.srp0s],%o5
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B1
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	and	%o1,0xfff,%o4		! D1
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.srp0t1-t.srp0s]
	ld	[%o3+t.srp0o2-t.srp0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! L1
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.srp0t2-t.srp0s]
	ld	[%o3+t.srp0o3-t.srp0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! I3
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.srp0t3-t.srp0s]
	ld	[%o3+t.srp0o4-t.srp0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! L1
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.srp0t4-t.srp0s]
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=6
	ld	[%o3+t.srp0oy-t.srp0s],%o5
	bnz,a	.+8			! if EX=1 then IAR+=4
	ld	[%o3+t.srp0oz-t.srp0s],%o5
	st	%o5,[%o0+t.srp0tz-t.srp0s]
	retl				!
	add	%o0,t.srp0e-t.srp0s,%o0	!
id6_srp:
	srl	%o2,28,%o4		! B2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l3		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l3		! %l3
	srl	%o2,16,%o4		! D2
	and	%o4,0xfff,%l4		! %l4
	srl	%o1,12,%o4		! B1
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l1		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l1		! %l1
	and	%o1,0xfff,%l2		! D1
	srl	%o1,16,%o4		! I3
	and	%o4,0xf,%l6		! %l6
	srl	%o1,20,%o4		! L1
	and	%o4,0xf,%l5		! %l5
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=6
	add	%g0,6,%l7		!
	bnz,a	.+8			! if EX=1 then IAR+=4
	add	%g0,4,%l7		!
t.srp0s:
    t.srp0t0:	add	%l3,%l4,%o2	! ##TEMPLATE:%l0,imm0
    t.srp0t1:	add	%l1,%l2,%o1	! ##TEMPLATE:%l0,imm0
		and	%o1,%g3,%o1	! mask address
		add	%g4,%o1,%o1	!
		ldub	[%o1],%g0	! force PAGEIN
    t.srp0t2:	ldub	[%o1+%l5],%g0	! ##TEMPLATE:imm0 (L1)
    t.srp0t3:	add	%g0,%l6,%o4	! ##TEMPLATE:imm0 (I3)
    t.srp0t4:	add	%g0,%l5,%o3	! ##TEMPLATE:imm0 (L1)
		ld	[%sp+184],%o0	! struct *gcpu_s
		sethi	%hi(il_srp),%o7 !
		jmpl	%o7+%lo(il_srp),%o7
		nop			! call library in intlib.s
		sethi	%hi(0x00ff0000),%o1
		andcc	%g7,%o1,%g0	! if intermediate intr. then
		bz,a	t.srp0e		!   exit
    t.srp0tz:	add	%g2,%l7,%g2	! ##TEMPLATE:IAR
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		nop			!
t.srp0e:
		ba	break0		!
		nop			!
    t.srp0o0:	add	%l0,0,%o2	! ##TEMPLATE:%l0,imm0
    t.srp0o1:	add	%l0,0,%o1	! ##TEMPLATE:%l0,imm0
    t.srp0o2:	ldub	[%o1+0],%g0	! ##TEMPLATE:imm0 (L1)
    t.srp0o3:	add	%g0,0,%o4	! ##TEMPLATE:imm0 (I3)
    t.srp0o4:	add	%g0,0,%o3	! ##TEMPLATE:imm0 (L1)
    t.srp0oy:	add	%g2,6,%g2	! ##TEMPLATE:IAR
    t.srp0oz:	add	%g2,4,%g2	! ##TEMPLATE:IAR

	.section ".text"
	.align	4
	.global ci6_mvo,ti6_mvo,ii6_mvo
ci6_mvo:
	srl	%o1,20,%o3		!
	and	%o3,0xf,%o3		! get L1
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! get L2
	subcc	%o3,%o4,%g0		!
	bg	c.mvo1c			!
	nop				!
    c.mvo0c:				!
	retl				! case L1 <= L2
	add	%g0,t.mvo0e-t.mvo0s,%o0	!
    c.mvo1c:				!
	retl				! case L1 > L2
	add	%g0,t.mvo1e-t.mvo1s,%o0	!
ti6_mvo:
	srl	%o1,20,%o3		!
	and	%o3,0xf,%o3		! get L1
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! get L2
	subcc	%o3,%o4,%g0		!
	bg	t.mvo1t			!
	nop				!
    t.mvo0t:				!
	sethi	%hi(t.mvo0s),%o3	!
	or	%o3,%lo(t.mvo0s),%o3	!
	or	%g0,t.mvo0e-t.mvo0s,%o4	!
    t.mvo0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.mvo0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.mvo0o0-t.mvo0s],%o5
	srl	%o2,28,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	srl	%o2,16,%o4		!
	and	%o4,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.mvo0t0-t.mvo0s]
	ld	[%o3+t.mvo0o1-t.mvo0s],%o5
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B1
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	and	%o1,0xfff,%o4		! D1
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.mvo0t1-t.mvo0s]
	ld	[%o3+t.mvo0o2-t.mvo0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! L2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.mvo0t2-t.mvo0s]
	ld	[%o3+t.mvo0o3-t.mvo0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! L1
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.mvo0t3-t.mvo0s]
	ld	[%o3+t.mvo0o4-t.mvo0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! L2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.mvo0t4-t.mvo0s]
	ld	[%o3+t.mvo0o5-t.mvo0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! L1
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.mvo0t5-t.mvo0s]
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=6
	ld	[%o3+t.mvo0oy-t.mvo0s],%o5
	bnz,a	.+8			! if EX=1 then IAR+=4
	ld	[%o3+t.mvo0oz-t.mvo0s],%o5
	st	%o5,[%o0+t.mvo0tz-t.mvo0s]
	retl				!
	add	%o0,t.mvo0e-t.mvo0s,%o0	!
    t.mvo1t:				!
	sethi	%hi(t.mvo1s),%o3	!
	or	%o3,%lo(t.mvo1s),%o3	!
	or	%g0,t.mvo1e-t.mvo1s,%o4	!
    t.mvo1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.mvo1cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.mvo1o0-t.mvo1s],%o5
	srl	%o2,28,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	srl	%o2,16,%o4		!
	and	%o4,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.mvo1t0-t.mvo1s]
	ld	[%o3+t.mvo1o1-t.mvo1s],%o5
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B1
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	and	%o1,0xfff,%o4		! D1
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.mvo1t1-t.mvo1s]
	ld	[%o3+t.mvo1o2-t.mvo1s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! L2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.mvo1t2-t.mvo1s]
	ld	[%o3+t.mvo1o3-t.mvo1s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! L1
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.mvo1t3-t.mvo1s]
	ld	[%o3+t.mvo1o4-t.mvo1s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! L2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.mvo1t4-t.mvo1s]
	ld	[%o3+t.mvo1o5-t.mvo1s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! L1
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.mvo1t5-t.mvo1s]
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=6
	ld	[%o3+t.mvo1oy-t.mvo1s],%o5
	bnz,a	.+8			! if EX=1 then IAR+=4
	ld	[%o3+t.mvo1oz-t.mvo1s],%o5
	st	%o5,[%o0+t.mvo1tz-t.mvo1s]
	retl				!
	add	%o0,t.mvo1e-t.mvo1s,%o0	!
ii6_mvo:
	srl	%o2,28,%o4		! B2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l3		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l3		! %l3
	srl	%o2,16,%o4		! D2
	and	%o4,0xfff,%l4		! %l4
	srl	%o1,12,%o4		! B1
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l1		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l1		! %l1
	and	%o1,0xfff,%l2		! D1
	srl	%o1,16,%o4		! L2
	and	%o4,0xf,%l6		! %l6
	srl	%o1,20,%o4		! L1
	and	%o4,0xf,%l5		! %l5
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=6
	add	%g0,6,%l7		!
	bnz,a	.+8			! if EX=1 then IAR+=4
	add	%g0,4,%l7		!
					!
	srl	%o1,20,%o3		!
	and	%o3,0xf,%o3		! get L1
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! get L2
	subcc	%o3,%o4,%g0		!
	bg	t.mvo1s			!
	nop				!
t.mvo0s:
    t.mvo0t0:	add	%l3,%l4,%o0	! ##TEMPLATE:%l0,imm0
		and	%o0,%g3,%o0	! mask address
		add	%g4,%o0,%o0	!
    t.mvo0t1:	add	%l1,%l2,%o1	! ##TEMPLATE:%l0,imm0
		and	%o1,%g3,%o1	! mask address
		add	%g4,%o1,%o1	!
		ldub	[%o0],%g0	! force PAGEIN
    t.mvo0t2:	ldub	[%o0+%l6],%g0	! ##TEMPLATE:imm0 (L2)
		ldub	[%o1],%g0	! force PAGEIN
    t.mvo0t3:	ldub	[%o1+%l5],%g0	! ##TEMPLATE:imm0 (L1)
    t.mvo0t4:	add	%g0,%l6,%o2	! ##TEMPLATE:imm0 (L2)
    t.mvo0t5:	add	%g0,%l5,%o3	! ##TEMPLATE:imm0 (L1)
		ldub	[%o1+%o3],%o5	!
		and	%o5,0xf,%o5	!
    t.mvo000:	ldub	[%o0+%o2],%o4	!
		sll	%o4,4,%o4	!
		or	%o5,%o4,%o5	!
		stb	%o5,[%o1+%o3]	!
		srl	%o4,8,%o5	!
		subcc	%o3,1,%o3	!
		bpos	t.mvo000	!
		sub	%o2,1,%o2	!
    t.mvo0tz:	add	%g2,%l7,%g2	! ##TEMPLATE:IAR
t.mvo0e:
		ba	break0		!
		nop			!
    t.mvo0o0:	add	%l0,0,%o0	! ##TEMPLATE:%l0,imm0
    t.mvo0o1:	add	%l0,0,%o1	! ##TEMPLATE:%l0,imm0
    t.mvo0o2:	ldub	[%o0+0],%g0	! ##TEMPLATE:imm0 (L2)
    t.mvo0o3:	ldub	[%o1+0],%g0	! ##TEMPLATE:imm0 (L1)
    t.mvo0o4:	add	%g0,0,%o2	! ##TEMPLATE:imm0 (L2)
    t.mvo0o5:	add	%g0,0,%o3	! ##TEMPLATE:imm0 (L1)
    t.mvo0oy:	add	%g2,6,%g2	! ##TEMPLATE:IAR
    t.mvo0oz:	add	%g2,4,%g2	! ##TEMPLATE:IAR
t.mvo1s:
    t.mvo1t0:	add	%l3,%l4,%o0	! ##TEMPLATE:%l0,imm0
		and	%o0,%g3,%o0	! mask address
		add	%g4,%o0,%o0	!
    t.mvo1t1:	add	%l1,%l2,%o1	! ##TEMPLATE:%l0,imm0
		and	%o1,%g3,%o1	! mask address
		add	%g4,%o1,%o1	!
		ldub	[%o0],%g0	! force PAGEIN
    t.mvo1t2:	ldub	[%o0+%l6],%g0	! ##TEMPLATE:imm0 (L2)
		ldub	[%o1],%g0	! force PAGEIN
    t.mvo1t3:	ldub	[%o1+%l5],%g0	! ##TEMPLATE:imm0 (L1)
    t.mvo1t4:	add	%g0,%l6,%o2	! ##TEMPLATE:imm0 (L2)
    t.mvo1t5:	add	%g0,%l5,%o3	! ##TEMPLATE:imm0 (L1)
		ldub	[%o1+%o3],%o5	!
		and	%o5,0xf,%o5	!
    t.mvo100:	ldub	[%o0+%o2],%o4	!
		sll	%o4,4,%o4	!
		or	%o5,%o4,%o5	!
		stb	%o5,[%o1+%o3]	!
		srl	%o4,8,%o5	!
		subcc	%o2,1,%o2	!
		bpos	t.mvo100	!
		sub	%o3,1,%o3	!
    t.mvo101:	stb	%o5,[%o1+%o3]	!
		subcc	%o3,1,%o3	!
		bpos	t.mvo101	!
		add	%g0,0,%o5	!
    t.mvo1tz:	add	%g2,%l7,%g2	! ##TEMPLATE:IAR
t.mvo1e:
		ba	break0		!
		nop			!
    t.mvo1o0:	add	%l0,0,%o0	! ##TEMPLATE:%l0,imm0
    t.mvo1o1:	add	%l0,0,%o1	! ##TEMPLATE:%l0,imm0
    t.mvo1o2:	ldub	[%o0+0],%g0	! ##TEMPLATE:imm0 (L2)
    t.mvo1o3:	ldub	[%o1+0],%g0	! ##TEMPLATE:imm0 (L1)
    t.mvo1o4:	add	%g0,0,%o2	! ##TEMPLATE:imm0 (L2)
    t.mvo1o5:	add	%g0,0,%o3	! ##TEMPLATE:imm0 (L1)
    t.mvo1oy:	add	%g2,6,%g2	! ##TEMPLATE:IAR
    t.mvo1oz:	add	%g2,4,%g2	! ##TEMPLATE:IAR

	.section ".text"
	.align	4
	.global ci6_pack,ti6_pack,ii6_pack
ci6_pack:
	srl	%o1,20,%o3		!
	and	%o3,0xf,%o3		! get L1
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! get L2
	add	%o4,1,%o4		!
	srl	%o4,1,%o4		!
	subcc	%o3,%o4,%g0		!
	bge	c.pack1c		!
	nop				!
    c.pack0c:				!
	retl				! case L1 <  (L2+1)/2
	add	%g0,t.pack0e-t.pack0s,%o0
    c.pack1c:				!
	retl				! case L1 >= (L2+1)/2
	add	%g0,t.pack1e-t.pack1s,%o0
ti6_pack:
	srl	%o1,20,%o3		!
	and	%o3,0xf,%o3		! get L1
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! get L2
	add	%o4,1,%o4		!
	srl	%o4,1,%o4		!
	subcc	%o3,%o4,%g0		!
	bge	t.pack1t		!
	nop				!
    t.pack0t:				!
	sethi	%hi(t.pack0s),%o3	!
	or	%o3,%lo(t.pack0s),%o3	!
	or	%g0,t.pack0e-t.pack0s,%o4
    t.pack0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.pack0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.pack0o0-t.pack0s],%o5
	srl	%o2,28,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	srl	%o2,16,%o4		!
	and	%o4,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.pack0t0-t.pack0s]
	ld	[%o3+t.pack0o1-t.pack0s],%o5
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B1
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	and	%o1,0xfff,%o4		! D1
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.pack0t1-t.pack0s]
	ld	[%o3+t.pack0o2-t.pack0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! L2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.pack0t2-t.pack0s]
	ld	[%o3+t.pack0o3-t.pack0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! L1
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.pack0t3-t.pack0s]
	ld	[%o3+t.pack0o4-t.pack0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! L2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.pack0t4-t.pack0s]
	ld	[%o3+t.pack0o5-t.pack0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! L1
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.pack0t5-t.pack0s]
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=6
	ld	[%o3+t.pack0oy-t.pack0s],%o5
	bnz,a	.+8			! if EX=1 then IAR+=4
	ld	[%o3+t.pack0oz-t.pack0s],%o5
	st	%o5,[%o0+t.pack0tz-t.pack0s]
	retl				!
	add	%o0,t.pack0e-t.pack0s,%o0
    t.pack1t:				!
	sethi	%hi(t.pack1s),%o3	!
	or	%o3,%lo(t.pack1s),%o3	!
	or	%g0,t.pack1e-t.pack1s,%o4
    t.pack1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.pack1cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.pack1o0-t.pack1s],%o5
	srl	%o2,28,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	srl	%o2,16,%o4		!
	and	%o4,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.pack1t0-t.pack1s]
	ld	[%o3+t.pack1o1-t.pack1s],%o5
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B1
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	and	%o1,0xfff,%o4		! D1
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.pack1t1-t.pack1s]
	ld	[%o3+t.pack1o2-t.pack1s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! L2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.pack1t2-t.pack1s]
	ld	[%o3+t.pack1o3-t.pack1s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! L1
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.pack1t3-t.pack1s]
	ld	[%o3+t.pack1o4-t.pack1s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! L2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.pack1t4-t.pack1s]
	ld	[%o3+t.pack1o5-t.pack1s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! L1
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.pack1t5-t.pack1s]
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=6
	ld	[%o3+t.pack1oy-t.pack1s],%o5
	bnz,a	.+8			! if EX=1 then IAR+=4
	ld	[%o3+t.pack1oz-t.pack1s],%o5
	st	%o5,[%o0+t.pack1tz-t.pack1s]
	retl				!
	add	%o0,t.pack1e-t.pack1s,%o0
ii6_pack:
	srl	%o2,28,%o4		! B2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l3		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l3		! %l3
	srl	%o2,16,%o4		! D2
	and	%o4,0xfff,%l4		! %l4
	srl	%o1,12,%o4		! B1
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l1		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l1		! %l1
	and	%o1,0xfff,%l2		! D1
	srl	%o1,16,%o4		! L2
	and	%o4,0xf,%l6		! %l6
	srl	%o1,20,%o4		! L1
	and	%o4,0xf,%l5		! %l5
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=6
	add	%g0,6,%l7		!
	bnz,a	.+8			! if EX=1 then IAR+=4
	add	%g0,4,%l7		!
					!
	srl	%o1,20,%o3		!
	and	%o3,0xf,%o3		! get L1
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! get L2
	add	%o4,1,%o4		!
	srl	%o4,1,%o4		!
	subcc	%o3,%o4,%g0		!
	bge	t.pack1s		!
	nop				!
t.pack0s:
    t.pack0t0:	add	%l3,%l4,%o0	! ##TEMPLATE:%l0,imm0
		and	%o0,%g3,%o0	! mask address
		add	%g4,%o0,%o0	!
    t.pack0t1:	add	%l1,%l2,%o1	! ##TEMPLATE:%l0,imm0
		and	%o1,%g3,%o1	! mask address
		add	%g4,%o1,%o1	!
		ldub	[%o0],%g0	! force PAGEIN
    t.pack0t2:	ldub	[%o0+%l6],%g0	! ##TEMPLATE:imm0 (L2)
		ldub	[%o1],%g0	! force PAGEIN
    t.pack0t3:	ldub	[%o1+%l5],%g0	! ##TEMPLATE:imm0 (L1)
    t.pack0t4:	add	%g0,%l6,%o2	! ##TEMPLATE:imm0 (L2)
    t.pack0t5:	add	%g0,%l5,%o3	! ##TEMPLATE:imm0 (L1)
		ldub	[%o0+%o2],%o4	!
		srl	%o4,4,%o5	!
		sll	%o4,4,%o4	!
		or	%o4,%o5,%o4	!
		stb	%o4,[%o1+%o3]	! store right most byte
		subcc	%o3,1,%o3	!
		bneg	t.pack0tz	!
		sub	%o2,1,%o2	!
    t.pack000:	ldub	[%o0+%o2],%o4	! load lower half
		and	%o4,0xf,%o4	!
		sub	%o2,1,%o2	!
		ldub	[%o0+%o2],%o5	! load upper half
		sll	%o5,4,%o5	!
		or	%o4,%o5,%o4	!
		stb	%o4,[%o1+%o3]	! store left bytes
		subcc	%o3,1,%o3	!
		bpos	t.pack000	!
		sub	%o2,1,%o2	!
    t.pack0tz:	add	%g2,%l7,%g2	! ##TEMPLATE:IAR
t.pack0e:
		ba	break0		!
		nop			!
    t.pack0o0:	add	%l0,0,%o0	! ##TEMPLATE:%l0,imm0
    t.pack0o1:	add	%l0,0,%o1	! ##TEMPLATE:%l0,imm0
    t.pack0o2:	ldub	[%o0+0],%g0	! ##TEMPLATE:imm0 (L2)
    t.pack0o3:	ldub	[%o1+0],%g0	! ##TEMPLATE:imm0 (L1)
    t.pack0o4:	add	%g0,0,%o2	! ##TEMPLATE:imm0 (L2)
    t.pack0o5:	add	%g0,0,%o3	! ##TEMPLATE:imm0 (L1)
    t.pack0oy:	add	%g2,6,%g2	! ##TEMPLATE:IAR
    t.pack0oz:	add	%g2,4,%g2	! ##TEMPLATE:IAR
t.pack1s:
    t.pack1t0:	add	%l3,%l4,%o0	! ##TEMPLATE:%l0,imm0
		and	%o0,%g3,%o0	! mask address
		add	%g4,%o0,%o0	!
    t.pack1t1:	add	%l1,%l2,%o1	! ##TEMPLATE:%l0,imm0
		and	%o1,%g3,%o1	! mask address
		add	%g4,%o1,%o1	!
		ldub	[%o0],%g0	! force PAGEIN
    t.pack1t2:	ldub	[%o0+%l6],%g0	! ##TEMPLATE:imm0 (L2)
		ldub	[%o1],%g0	! force PAGEIN
    t.pack1t3:	ldub	[%o1+%l5],%g0	! ##TEMPLATE:imm0 (L1)
    t.pack1t4:	add	%g0,%l6,%o2	! ##TEMPLATE:imm0 (L2)
    t.pack1t5:	add	%g0,%l5,%o3	! ##TEMPLATE:imm0 (L1)
		ldub	[%o0+%o2],%o4	!
		srl	%o4,4,%o5	!
		sll	%o4,4,%o4	!
		or	%o4,%o5,%o4	!
		stb	%o4,[%o1+%o3]	! store right most byte
		subcc	%o2,1,%o2	!
		bneg	t.pack102	!
		subcc	%o3,1,%o3	!
    t.pack100:	ldub	[%o0+%o2],%o4	! load lower half
		subcc	%o2,1,%o2	!
		bneg	t.pack101	!
		and	%o4,0xf,%o4	!
		ldub	[%o0+%o2],%o5	! load upper half
		sll	%o5,4,%o5	!
		or	%o4,%o5,%o4	!
    t.pack101:	stb	%o4,[%o1+%o3]	! store left bytes
		subcc	%o2,1,%o2	!
		bpos	t.pack100	!
		subcc	%o3,1,%o3	!
    t.pack102:	bneg	t.pack1tz	!
		nop			!
    t.pack103:	stb	%g0,[%o1+%o3]	! fill with zero
		subcc	%o3,1,%o3	!
		bpos	t.pack103	!
		nop			!
    t.pack1tz:	add	%g2,%l7,%g2	! ##TEMPLATE:IAR
t.pack1e:
		ba	break0		!
		nop			!
    t.pack1o0:	add	%l0,0,%o0	! ##TEMPLATE:%l0,imm0
    t.pack1o1:	add	%l0,0,%o1	! ##TEMPLATE:%l0,imm0
    t.pack1o2:	ldub	[%o0+0],%g0	! ##TEMPLATE:imm0 (L2)
    t.pack1o3:	ldub	[%o1+0],%g0	! ##TEMPLATE:imm0 (L1)
    t.pack1o4:	add	%g0,0,%o2	! ##TEMPLATE:imm0 (L2)
    t.pack1o5:	add	%g0,0,%o3	! ##TEMPLATE:imm0 (L1)
    t.pack1oy:	add	%g2,6,%g2	! ##TEMPLATE:IAR
    t.pack1oz:	add	%g2,4,%g2	! ##TEMPLATE:IAR

	.section ".text"
	.align	4
	.global ci6_unpk,ti6_unpk,ii6_unpk
ci6_unpk:
	srl	%o1,20,%o3		!
	and	%o3,0xf,%o3		! get L1
	srl	%o3,1,%o3		!
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! get L2
	subcc	%o3,%o4,%g0		!
	bge	c.unpk1c		!
	nop				!
    c.unpk0c:				!
	retl				! case L1/2 <  L2
	add	%g0,t.unpk0e-t.unpk0s,%o0
    c.unpk1c:				!
	retl				! case L1/2 >= L2
	add	%g0,t.unpk1e-t.unpk1s,%o0
ti6_unpk:
	srl	%o1,20,%o3		!
	and	%o3,0xf,%o3		! get L1
	srl	%o3,1,%o3		!
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! get L2
	subcc	%o3,%o4,%g0		!
	bge	t.unpk1t		!
	nop				!
    t.unpk0t:				!
	sethi	%hi(t.unpk0s),%o3	!
	or	%o3,%lo(t.unpk0s),%o3	!
	or	%g0,t.unpk0e-t.unpk0s,%o4
    t.unpk0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.unpk0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.unpk0o0-t.unpk0s],%o5
	srl	%o2,28,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	srl	%o2,16,%o4		!
	and	%o4,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.unpk0t0-t.unpk0s]
	ld	[%o3+t.unpk0o1-t.unpk0s],%o5
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B1
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	and	%o1,0xfff,%o4		! D1
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.unpk0t1-t.unpk0s]
	ld	[%o3+t.unpk0o2-t.unpk0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! L2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.unpk0t2-t.unpk0s]
	ld	[%o3+t.unpk0o3-t.unpk0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! L1
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.unpk0t3-t.unpk0s]
	ld	[%o3+t.unpk0o4-t.unpk0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! L2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.unpk0t4-t.unpk0s]
	ld	[%o3+t.unpk0o5-t.unpk0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! L1
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.unpk0t5-t.unpk0s]
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=6
	ld	[%o3+t.unpk0oy-t.unpk0s],%o5
	bnz,a	.+8			! if EX=1 then IAR+=4
	ld	[%o3+t.unpk0oz-t.unpk0s],%o5
	st	%o5,[%o0+t.unpk0tz-t.unpk0s]
	retl				!
	add	%o0,t.unpk0e-t.unpk0s,%o0
    t.unpk1t:				!
	sethi	%hi(t.unpk1s),%o3	!
	or	%o3,%lo(t.unpk1s),%o3	!
	or	%g0,t.unpk1e-t.unpk1s,%o4
    t.unpk1cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.unpk1cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.unpk1o0-t.unpk1s],%o5
	srl	%o2,28,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	srl	%o2,16,%o4		!
	and	%o4,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.unpk1t0-t.unpk1s]
	ld	[%o3+t.unpk1o1-t.unpk1s],%o5
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B1
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	and	%o1,0xfff,%o4		! D1
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.unpk1t1-t.unpk1s]
	ld	[%o3+t.unpk1o2-t.unpk1s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! L2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.unpk1t2-t.unpk1s]
	ld	[%o3+t.unpk1o3-t.unpk1s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! L1
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.unpk1t3-t.unpk1s]
	ld	[%o3+t.unpk1o4-t.unpk1s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! L2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.unpk1t4-t.unpk1s]
	ld	[%o3+t.unpk1o5-t.unpk1s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! L1
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.unpk1t5-t.unpk1s]
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=6
	ld	[%o3+t.unpk1oy-t.unpk1s],%o5
	bnz,a	.+8			! if EX=1 then IAR+=4
	ld	[%o3+t.unpk1oz-t.unpk1s],%o5
	st	%o5,[%o0+t.unpk1tz-t.unpk1s]
	retl				!
	add	%o0,t.unpk1e-t.unpk1s,%o0
ii6_unpk:
	srl	%o2,28,%o4		! B2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l3		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l3		! %l3
	srl	%o2,16,%o4		! D2
	and	%o4,0xfff,%l4		! %l4
	srl	%o1,12,%o4		! B1
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l1		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l1		! %l1
	and	%o1,0xfff,%l2		! D1
	srl	%o1,16,%o4		! L2
	and	%o4,0xf,%l6		! %l6
	srl	%o1,20,%o4		! L1
	and	%o4,0xf,%l5		! %l5
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=6
	add	%g0,6,%l7		!
	bnz,a	.+8			! if EX=1 then IAR+=4
	add	%g0,4,%l7		!
					!
	srl	%o1,20,%o3		!
	and	%o3,0xf,%o3		! get L1
	srl	%o3,1,%o3		!
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! get L2
	subcc	%o3,%o4,%g0		!
	bge	t.unpk1s		!
	nop				!
t.unpk0s:
    t.unpk0t0:	add	%l3,%l4,%o0	! ##TEMPLATE:%l0,imm0
		and	%o0,%g3,%o0	! mask address
		add	%g4,%o0,%o0	!
    t.unpk0t1:	add	%l1,%l2,%o1	! ##TEMPLATE:%l0,imm0
		and	%o1,%g3,%o1	! mask address
		add	%g4,%o1,%o1	!
		ldub	[%o0],%g0	! force PAGEIN
    t.unpk0t2:	ldub	[%o0+%l6],%g0	! ##TEMPLATE:imm0 (L2)
		ldub	[%o1],%g0	! force PAGEIN
    t.unpk0t3:	ldub	[%o1+%l5],%g0	! ##TEMPLATE:imm0 (L1)
    t.unpk0t4:	add	%g0,%l6,%o2	! ##TEMPLATE:imm0 (L2)
    t.unpk0t5:	add	%g0,%l5,%o3	! ##TEMPLATE:imm0 (L1)
		ldub	[%o0+%o2],%o4	!
		srl	%o4,4,%o5	!
		sll	%o4,4,%o4	!
		or	%o4,%o5,%o4	!
		stb	%o4,[%o1+%o3]	! store right most byte
		subcc	%o3,1,%o3	!
		bneg	t.unpk0tz	!
		sub	%o2,1,%o2	!
    t.unpk000:	ldub	[%o0+%o2],%o4	! load byte
		and	%o4,0xf,%o5	!
		or	%o5,0xf0,%o5	!
		stb	%o5,[%o1+%o3]	! store byte
		subcc	%o3,1,%o3	!
		bneg	t.unpk0tz	!
		srl	%o4,4,%o5	!
		or	%o5,0xf0,%o5	!
		stb	%o5,[%o1+%o3]	! store byte
		subcc	%o3,1,%o3	!
		bpos	t.unpk000	!
		sub	%o2,1,%o2	!
    t.unpk0tz:	add	%g2,%l7,%g2	! ##TEMPLATE:IAR
t.unpk0e:
		ba	break0		!
		nop			!
    t.unpk0o0:	add	%l0,0,%o0	! ##TEMPLATE:%l0,imm0
    t.unpk0o1:	add	%l0,0,%o1	! ##TEMPLATE:%l0,imm0
    t.unpk0o2:	ldub	[%o0+0],%g0	! ##TEMPLATE:imm0 (L2)
    t.unpk0o3:	ldub	[%o1+0],%g0	! ##TEMPLATE:imm0 (L1)
    t.unpk0o4:	add	%g0,0,%o2	! ##TEMPLATE:imm0 (L2)
    t.unpk0o5:	add	%g0,0,%o3	! ##TEMPLATE:imm0 (L1)
    t.unpk0oy:	add	%g2,6,%g2	! ##TEMPLATE:IAR
    t.unpk0oz:	add	%g2,4,%g2	! ##TEMPLATE:IAR
t.unpk1s:
    t.unpk1t0:	add	%l3,%l4,%o0	! ##TEMPLATE:%l0,imm0
		and	%o0,%g3,%o0	! mask address
		add	%g4,%o0,%o0	!
    t.unpk1t1:	add	%l1,%l2,%o1	! ##TEMPLATE:%l0,imm0
		and	%o1,%g3,%o1	! mask address
		add	%g4,%o1,%o1	!
		ldub	[%o0],%g0	! force PAGEIN
    t.unpk1t2:	ldub	[%o0+%l6],%g0	! ##TEMPLATE:imm0 (L2)
		ldub	[%o1],%g0	! force PAGEIN
    t.unpk1t3:	ldub	[%o1+%l5],%g0	! ##TEMPLATE:imm0 (L1)
    t.unpk1t4:	add	%g0,%l6,%o2	! ##TEMPLATE:imm0 (L2)
    t.unpk1t5:	add	%g0,%l5,%o3	! ##TEMPLATE:imm0 (L1)
		ldub	[%o0+%o2],%o4	!
		srl	%o4,4,%o5	!
		sll	%o4,4,%o4	!
		or	%o4,%o5,%o4	!
		stb	%o4,[%o1+%o3]	! store right most byte
		subcc	%o2,1,%o2	!
		bneg	t.unpk101	!
		subcc	%o3,1,%o3	!
    t.unpk100:	ldub	[%o0+%o2],%o4	! load byte
		and	%o4,0xf,%o5	!
		or	%o5,0xf0,%o5	!
		stb	%o5,[%o1+%o3]	! store byte
		sub	%o3,1,%o3	!
		srl	%o4,4,%o5	!
		or	%o5,0xf0,%o5	!
		stb	%o5,[%o1+%o3]	! store byte
		subcc	%o2,1,%o2	!
		bpos	t.unpk100	!
		subcc	%o3,1,%o3	!
    t.unpk101:	bneg	t.unpk1tz	!
		add	%g0,0xf0,%o5	!
    t.unpk102:	stb	%o5,[%o1+%o3]	! fill with 0xf0
		subcc	%o3,1,%o3	!
		bpos	t.unpk102	!
		nop			!
    t.unpk1tz:	add	%g2,%l7,%g2	! ##TEMPLATE:IAR
t.unpk1e:
		ba	break0		!
		nop			!
    t.unpk1o0:	add	%l0,0,%o0	! ##TEMPLATE:%l0,imm0
    t.unpk1o1:	add	%l0,0,%o1	! ##TEMPLATE:%l0,imm0
    t.unpk1o2:	ldub	[%o0+0],%g0	! ##TEMPLATE:imm0 (L2)
    t.unpk1o3:	ldub	[%o1+0],%g0	! ##TEMPLATE:imm0 (L1)
    t.unpk1o4:	add	%g0,0,%o2	! ##TEMPLATE:imm0 (L2)
    t.unpk1o5:	add	%g0,0,%o3	! ##TEMPLATE:imm0 (L1)
    t.unpk1oy:	add	%g2,6,%g2	! ##TEMPLATE:IAR
    t.unpk1oz:	add	%g2,4,%g2	! ##TEMPLATE:IAR

	.section ".text"
	.align	4
	.global cd6_zap,td6_zap,id6_zap
cd6_zap:
	retl				!
	add	%g0,t.zap0e-t.zap0s,%o0	!
td6_zap:
	sethi	%hi(t.zap0s),%o3	!
	or	%o3,%lo(t.zap0s),%o3	!
	or	%g0,t.zap0e-t.zap0s,%o4	!
    t.zap0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.zap0cp		!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.zap0o0-t.zap0s],%o5
	srl	%o2,28,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	srl	%o2,16,%o4		!
	and	%o4,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.zap0t0-t.zap0s]
	ld	[%o3+t.zap0o1-t.zap0s],%o5
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B1
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	and	%o1,0xfff,%o4		! D1
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.zap0t1-t.zap0s]
	ld	[%o3+t.zap0o2-t.zap0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! L2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.zap0t2-t.zap0s]
	ld	[%o3+t.zap0o3-t.zap0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! L1
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.zap0t3-t.zap0s]
	ld	[%o3+t.zap0o4-t.zap0s],%o5
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! L2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.zap0t4-t.zap0s]
	ld	[%o3+t.zap0o5-t.zap0s],%o5
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! L1
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.zap0t5-t.zap0s]
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=6
	ld	[%o3+t.zap0oy-t.zap0s],%o5
	bnz,a	.+8			! if EX=1 then IAR+=4
	ld	[%o3+t.zap0oz-t.zap0s],%o5
	st	%o5,[%o0+t.zap0tz-t.zap0s]
	retl				!
	add	%o0,t.zap0e-t.zap0s,%o0	!
id6_zap:
	srl	%o2,28,%o4		! B2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l3		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l3		! %l3
	srl	%o2,16,%o4		! D2
	and	%o4,0xfff,%l4		! %l4
	srl	%o1,12,%o4		! B1
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l1		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l1		! %l1
	and	%o1,0xfff,%l2		! D1
	srl	%o1,16,%o4		! L2
	and	%o4,0xf,%l6		! %l6
	srl	%o1,20,%o4		! L1
	and	%o4,0xf,%l5		! %l5
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=6
	add	%g0,6,%l7		!
	bnz,a	.+8			! if EX=1 then IAR+=4
	add	%g0,4,%l7		!
t.zap0s:
    t.zap0t0:	add	%l3,%l4,%o2	! ##TEMPLATE:%l0,imm0
		and	%o2,%g3,%o2	! mask address
		add	%g4,%o2,%o2	!
    t.zap0t1:	add	%l1,%l2,%o1	! ##TEMPLATE:%l0,imm0
		and	%o1,%g3,%o1	! mask address
		add	%g4,%o1,%o1	!
		ldub	[%o2],%g0	! force PAGEIN
    t.zap0t2:	ldub	[%o2+%l6],%g0	! ##TEMPLATE:imm0 (L2)
		ldub	[%o1],%g0	! force PAGEIN
    t.zap0t3:	ldub	[%o1+%l5],%g0	! ##TEMPLATE:imm0 (L1)
    t.zap0t4:	add	%g0,%l6,%o4	! ##TEMPLATE:imm0 (L2)
    t.zap0t5:	add	%g0,%l5,%o3	! ##TEMPLATE:imm0 (L1)
		ld	[%sp+184],%o0	! struct *gcpu_s
		sethi	%hi(il_zap),%o7 !
		jmpl	%o7+%lo(il_zap),%o7
		nop			! call library in intlib.s
		sethi	%hi(0x00ff0000),%o1
		andcc	%g7,%o1,%g0	! if intermediate intr. then
		bz,a	t.zap0e		!   exit
    t.zap0tz:	add	%g2,%l7,%g2	! ##TEMPLATE:IAR
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		nop			!
t.zap0e:
		ba	break0		!
		nop			!
    t.zap0o0:	add	%l0,0,%o2	! ##TEMPLATE:%l0,imm0
    t.zap0o1:	add	%l0,0,%o1	! ##TEMPLATE:%l0,imm0
    t.zap0o2:	ldub	[%o2+0],%g0	! ##TEMPLATE:imm0 (L2)
    t.zap0o3:	ldub	[%o1+0],%g0	! ##TEMPLATE:imm0 (L1)
    t.zap0o4:	add	%g0,0,%o4	! ##TEMPLATE:imm0 (L2)
    t.zap0o5:	add	%g0,0,%o3	! ##TEMPLATE:imm0 (L1)
    t.zap0oy:	add	%g2,6,%g2	! ##TEMPLATE:IAR
    t.zap0oz:	add	%g2,4,%g2	! ##TEMPLATE:IAR

	.section ".text"
	.align	4
	.global cd6_cp,td6_cp,id6_cp
cd6_cp:
	retl				!
	add	%g0,t.cp0e-t.cp0s,%o0	!
td6_cp:
	sethi	%hi(t.cp0s),%o3		!
	or	%o3,%lo(t.cp0s),%o3	!
	or	%g0,t.cp0e-t.cp0s,%o4	!
    t.cp0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.cp0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.cp0o0-t.cp0s],%o5!
	srl	%o2,28,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	srl	%o2,16,%o4		!
	and	%o4,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.cp0t0-t.cp0s]!
	ld	[%o3+t.cp0o1-t.cp0s],%o5!
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B1
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	and	%o1,0xfff,%o4		! D1
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.cp0t1-t.cp0s]!
	ld	[%o3+t.cp0o2-t.cp0s],%o5!
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! L2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.cp0t2-t.cp0s]!
	ld	[%o3+t.cp0o3-t.cp0s],%o5!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! L1
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.cp0t3-t.cp0s]!
	ld	[%o3+t.cp0o4-t.cp0s],%o5!
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! L2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.cp0t4-t.cp0s]!
	ld	[%o3+t.cp0o5-t.cp0s],%o5!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! L1
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.cp0t5-t.cp0s]!
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=6
	ld	[%o3+t.cp0oy-t.cp0s],%o5!
	bnz,a	.+8			! if EX=1 then IAR+=4
	ld	[%o3+t.cp0oz-t.cp0s],%o5!
	st	%o5,[%o0+t.cp0tz-t.cp0s]!
	retl				!
	add	%o0,t.cp0e-t.cp0s,%o0	!
id6_cp:
	srl	%o2,28,%o4		! B2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l3		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l3		! %l3
	srl	%o2,16,%o4		! D2
	and	%o4,0xfff,%l4		! %l4
	srl	%o1,12,%o4		! B1
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l1		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l1		! %l1
	and	%o1,0xfff,%l2		! D1
	srl	%o1,16,%o4		! L2
	and	%o4,0xf,%l6		! %l6
	srl	%o1,20,%o4		! L1
	and	%o4,0xf,%l5		! %l5
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=6
	add	%g0,6,%l7		!
	bnz,a	.+8			! if EX=1 then IAR+=4
	add	%g0,4,%l7		!
t.cp0s:
    t.cp0t0:	add	%l3,%l4,%o2	! ##TEMPLATE:%l0,imm0
		and	%o2,%g3,%o2	! mask address
		add	%g4,%o2,%o2	!
    t.cp0t1:	add	%l1,%l2,%o1	! ##TEMPLATE:%l0,imm0
		and	%o1,%g3,%o1	! mask address
		add	%g4,%o1,%o1	!
		ldub	[%o2],%g0	! force PAGEIN
    t.cp0t2:	ldub	[%o2+%l6],%g0	! ##TEMPLATE:imm0 (L2)
		ldub	[%o1],%g0	! force PAGEIN
    t.cp0t3:	ldub	[%o1+%l5],%g0	! ##TEMPLATE:imm0 (L1)
    t.cp0t4:	add	%g0,%l6,%o4	! ##TEMPLATE:imm0 (L2)
    t.cp0t5:	add	%g0,%l5,%o3	! ##TEMPLATE:imm0 (L1)
		ld	[%sp+184],%o0	! struct *gcpu_s
		sethi	%hi(il_cp),%o7	!
		jmpl	%o7+%lo(il_cp),%o7
		nop			! call library in intlib.s
		sethi	%hi(0x00ff0000),%o1
		andcc	%g7,%o1,%g0	! if intermediate intr. then
		bz,a	t.cp0e		!   exit
    t.cp0tz:	add	%g2,%l7,%g2	! ##TEMPLATE:IAR
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		nop			!
t.cp0e:
		ba	break0		!
		nop			!
    t.cp0o0:	add	%l0,0,%o2	! ##TEMPLATE:%l0,imm0
    t.cp0o1:	add	%l0,0,%o1	! ##TEMPLATE:%l0,imm0
    t.cp0o2:	ldub	[%o2+0],%g0	! ##TEMPLATE:imm0 (L2)
    t.cp0o3:	ldub	[%o1+0],%g0	! ##TEMPLATE:imm0 (L1)
    t.cp0o4:	add	%g0,0,%o4	! ##TEMPLATE:imm0 (L2)
    t.cp0o5:	add	%g0,0,%o3	! ##TEMPLATE:imm0 (L1)
    t.cp0oy:	add	%g2,6,%g2	! ##TEMPLATE:IAR
    t.cp0oz:	add	%g2,4,%g2	! ##TEMPLATE:IAR

	.section ".text"
	.align	4
	.global cd6_ap,td6_ap,id6_ap
cd6_ap:
	retl				!
	add	%g0,t.ap0e-t.ap0s,%o0	!
td6_ap:
	sethi	%hi(t.ap0s),%o3		!
	or	%o3,%lo(t.ap0s),%o3	!
	or	%g0,t.ap0e-t.ap0s,%o4	!
    t.ap0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.ap0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.ap0o0-t.ap0s],%o5!
	srl	%o2,28,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	srl	%o2,16,%o4		!
	and	%o4,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.ap0t0-t.ap0s]!
	ld	[%o3+t.ap0o1-t.ap0s],%o5!
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B1
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	and	%o1,0xfff,%o4		! D1
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.ap0t1-t.ap0s]!
	ld	[%o3+t.ap0o2-t.ap0s],%o5!
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! L2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.ap0t2-t.ap0s]!
	ld	[%o3+t.ap0o3-t.ap0s],%o5!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! L1
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.ap0t3-t.ap0s]!
	ld	[%o3+t.ap0o4-t.ap0s],%o5!
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! L2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.ap0t4-t.ap0s]!
	ld	[%o3+t.ap0o5-t.ap0s],%o5!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! L1
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.ap0t5-t.ap0s]!
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=6
	ld	[%o3+t.ap0oy-t.ap0s],%o5!
	bnz,a	.+8			! if EX=1 then IAR+=4
	ld	[%o3+t.ap0oz-t.ap0s],%o5!
	st	%o5,[%o0+t.ap0tz-t.ap0s]!
	retl				!
	add	%o0,t.ap0e-t.ap0s,%o0	!
id6_ap:
	srl	%o2,28,%o4		! B2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l3		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l3		! %l3
	srl	%o2,16,%o4		! D2
	and	%o4,0xfff,%l4		! %l4
	srl	%o1,12,%o4		! B1
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l1		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l1		! %l1
	and	%o1,0xfff,%l2		! D1
	srl	%o1,16,%o4		! L2
	and	%o4,0xf,%l6		! %l6
	srl	%o1,20,%o4		! L1
	and	%o4,0xf,%l5		! %l5
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=6
	add	%g0,6,%l7		!
	bnz,a	.+8			! if EX=1 then IAR+=4
	add	%g0,4,%l7		!
t.ap0s:
    t.ap0t0:	add	%l3,%l4,%o2	! ##TEMPLATE:%l0,imm0
		and	%o2,%g3,%o2	! mask address
		add	%g4,%o2,%o2	!
    t.ap0t1:	add	%l1,%l2,%o1	! ##TEMPLATE:%l0,imm0
		and	%o1,%g3,%o1	! mask address
		add	%g4,%o1,%o1	!
		ldub	[%o2],%g0	! force PAGEIN
    t.ap0t2:	ldub	[%o2+%l6],%g0	! ##TEMPLATE:imm0 (L2)
		ldub	[%o1],%g0	! force PAGEIN
    t.ap0t3:	ldub	[%o1+%l5],%g0	! ##TEMPLATE:imm0 (L1)
    t.ap0t4:	add	%g0,%l6,%o4	! ##TEMPLATE:imm0 (L2)
    t.ap0t5:	add	%g0,%l5,%o3	! ##TEMPLATE:imm0 (L1)
		ld	[%sp+184],%o0	! struct *gcpu_s
		sethi	%hi(il_ap),%o7	!
		jmpl	%o7+%lo(il_ap),%o7
		nop			! call library in intlib.s
		sethi	%hi(0x00ff0000),%o1
		andcc	%g7,%o1,%g0	! if intermediate intr. then
		bz,a	t.ap0e		!   exit
    t.ap0tz:	add	%g2,%l7,%g2	! ##TEMPLATE:IAR
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		nop			!
t.ap0e:
		ba	break0		!
		nop			!
    t.ap0o0:	add	%l0,0,%o2	! ##TEMPLATE:%l0,imm0
    t.ap0o1:	add	%l0,0,%o1	! ##TEMPLATE:%l0,imm0
    t.ap0o2:	ldub	[%o2+0],%g0	! ##TEMPLATE:imm0 (L2)
    t.ap0o3:	ldub	[%o1+0],%g0	! ##TEMPLATE:imm0 (L1)
    t.ap0o4:	add	%g0,0,%o4	! ##TEMPLATE:imm0 (L2)
    t.ap0o5:	add	%g0,0,%o3	! ##TEMPLATE:imm0 (L1)
    t.ap0oy:	add	%g2,6,%g2	! ##TEMPLATE:IAR
    t.ap0oz:	add	%g2,4,%g2	! ##TEMPLATE:IAR

	.section ".text"
	.align	4
	.global cd6_sp,td6_sp,id6_sp
cd6_sp:
	retl				!
	add	%g0,t.sp0e-t.sp0s,%o0	!
td6_sp:
	sethi	%hi(t.sp0s),%o3		!
	or	%o3,%lo(t.sp0s),%o3	!
	or	%g0,t.sp0e-t.sp0s,%o4	!
    t.sp0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.sp0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.sp0o0-t.sp0s],%o5!
	srl	%o2,28,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	srl	%o2,16,%o4		!
	and	%o4,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.sp0t0-t.sp0s]!
	ld	[%o3+t.sp0o1-t.sp0s],%o5!
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B1
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	and	%o1,0xfff,%o4		! D1
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.sp0t1-t.sp0s]!
	ld	[%o3+t.sp0o2-t.sp0s],%o5!
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! L2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.sp0t2-t.sp0s]!
	ld	[%o3+t.sp0o3-t.sp0s],%o5!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! L1
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.sp0t3-t.sp0s]!
	ld	[%o3+t.sp0o4-t.sp0s],%o5!
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! L2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.sp0t4-t.sp0s]!
	ld	[%o3+t.sp0o5-t.sp0s],%o5!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! L1
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.sp0t5-t.sp0s]!
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=6
	ld	[%o3+t.sp0oy-t.sp0s],%o5!
	bnz,a	.+8			! if EX=1 then IAR+=4
	ld	[%o3+t.sp0oz-t.sp0s],%o5!
	st	%o5,[%o0+t.sp0tz-t.sp0s]!
	retl				!
	add	%o0,t.sp0e-t.sp0s,%o0	!
id6_sp:
	srl	%o2,28,%o4		! B2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l3		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l3		! %l3
	srl	%o2,16,%o4		! D2
	and	%o4,0xfff,%l4		! %l4
	srl	%o1,12,%o4		! B1
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l1		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l1		! %l1
	and	%o1,0xfff,%l2		! D1
	srl	%o1,16,%o4		! L2
	and	%o4,0xf,%l6		! %l6
	srl	%o1,20,%o4		! L1
	and	%o4,0xf,%l5		! %l5
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=6
	add	%g0,6,%l7		!
	bnz,a	.+8			! if EX=1 then IAR+=4
	add	%g0,4,%l7		!
t.sp0s:
    t.sp0t0:	add	%l3,%l4,%o2	! ##TEMPLATE:%l0,imm0
		and	%o2,%g3,%o2	! mask address
		add	%g4,%o2,%o2	!
    t.sp0t1:	add	%l1,%l2,%o1	! ##TEMPLATE:%l0,imm0
		and	%o1,%g3,%o1	! mask address
		add	%g4,%o1,%o1	!
		ldub	[%o2],%g0	! force PAGEIN
    t.sp0t2:	ldub	[%o2+%l6],%g0	! ##TEMPLATE:imm0 (L2)
		ldub	[%o1],%g0	! force PAGEIN
    t.sp0t3:	ldub	[%o1+%l5],%g0	! ##TEMPLATE:imm0 (L1)
    t.sp0t4:	add	%g0,%l6,%o4	! ##TEMPLATE:imm0 (L2)
    t.sp0t5:	add	%g0,%l5,%o3	! ##TEMPLATE:imm0 (L1)
		ld	[%sp+184],%o0	! struct *gcpu_s
		sethi	%hi(il_sp),%o7	!
		jmpl	%o7+%lo(il_sp),%o7
		nop			! call library in intlib.s
		sethi	%hi(0x00ff0000),%o1
		andcc	%g7,%o1,%g0	! if intermediate intr. then
		bz,a	t.sp0e		!   exit
    t.sp0tz:	add	%g2,%l7,%g2	! ##TEMPLATE:IAR
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		nop			!
t.sp0e:
		ba	break0		!
		nop			!
    t.sp0o0:	add	%l0,0,%o2	! ##TEMPLATE:%l0,imm0
    t.sp0o1:	add	%l0,0,%o1	! ##TEMPLATE:%l0,imm0
    t.sp0o2:	ldub	[%o2+0],%g0	! ##TEMPLATE:imm0 (L2)
    t.sp0o3:	ldub	[%o1+0],%g0	! ##TEMPLATE:imm0 (L1)
    t.sp0o4:	add	%g0,0,%o4	! ##TEMPLATE:imm0 (L2)
    t.sp0o5:	add	%g0,0,%o3	! ##TEMPLATE:imm0 (L1)
    t.sp0oy:	add	%g2,6,%g2	! ##TEMPLATE:IAR
    t.sp0oz:	add	%g2,4,%g2	! ##TEMPLATE:IAR

	.section ".text"
	.align	4
	.global cd6_mp,td6_mp,id6_mp
cd6_mp:
	retl				!
	add	%g0,t.mp0e-t.mp0s,%o0	!
td6_mp:
	sethi	%hi(t.mp0s),%o3		!
	or	%o3,%lo(t.mp0s),%o3	!
	or	%g0,t.mp0e-t.mp0s,%o4	!
    t.mp0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.mp0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.mp0o0-t.mp0s],%o5!
	srl	%o2,28,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	srl	%o2,16,%o4		!
	and	%o4,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.mp0t0-t.mp0s]!
	ld	[%o3+t.mp0o1-t.mp0s],%o5!
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B1
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	and	%o1,0xfff,%o4		! D1
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.mp0t1-t.mp0s]!
	ld	[%o3+t.mp0o2-t.mp0s],%o5!
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! L2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.mp0t2-t.mp0s]!
	ld	[%o3+t.mp0o3-t.mp0s],%o5!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! L1
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.mp0t3-t.mp0s]!
	ld	[%o3+t.mp0o4-t.mp0s],%o5!
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! L2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.mp0t4-t.mp0s]!
	ld	[%o3+t.mp0o5-t.mp0s],%o5!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! L1
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.mp0t5-t.mp0s]!
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=6
	ld	[%o3+t.mp0oy-t.mp0s],%o5!
	bnz,a	.+8			! if EX=1 then IAR+=4
	ld	[%o3+t.mp0oz-t.mp0s],%o5!
	st	%o5,[%o0+t.mp0tz-t.mp0s]!
	retl				!
	add	%o0,t.mp0e-t.mp0s,%o0	!
id6_mp:
	srl	%o2,28,%o4		! B2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l3		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l3		! %l3
	srl	%o2,16,%o4		! D2
	and	%o4,0xfff,%l4		! %l4
	srl	%o1,12,%o4		! B1
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l1		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l1		! %l1
	and	%o1,0xfff,%l2		! D1
	srl	%o1,16,%o4		! L2
	and	%o4,0xf,%l6		! %l6
	srl	%o1,20,%o4		! L1
	and	%o4,0xf,%l5		! %l5
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=6
	add	%g0,6,%l7		!
	bnz,a	.+8			! if EX=1 then IAR+=4
	add	%g0,4,%l7		!
t.mp0s:
    t.mp0t0:	add	%l3,%l4,%o2	! ##TEMPLATE:%l0,imm0
		and	%o2,%g3,%o2	! mask address
		add	%g4,%o2,%o2	!
    t.mp0t1:	add	%l1,%l2,%o1	! ##TEMPLATE:%l0,imm0
		and	%o1,%g3,%o1	! mask address
		add	%g4,%o1,%o1	!
		ldub	[%o2],%g0	! force PAGEIN
    t.mp0t2:	ldub	[%o2+%l6],%g0	! ##TEMPLATE:imm0 (L2)
		ldub	[%o1],%g0	! force PAGEIN
    t.mp0t3:	ldub	[%o1+%l5],%g0	! ##TEMPLATE:imm0 (L1)
    t.mp0t4:	add	%g0,%l6,%o4	! ##TEMPLATE:imm0 (L2)
    t.mp0t5:	add	%g0,%l5,%o3	! ##TEMPLATE:imm0 (L1)
		ld	[%sp+184],%o0	! struct *gcpu_s
		sethi	%hi(il_mp),%o7	!
		jmpl	%o7+%lo(il_mp),%o7
		nop			! call library in intlib.s
		sethi	%hi(0x00ff0000),%o1
		andcc	%g7,%o1,%g0	! if intermediate intr. then
		bz,a	t.mp0e		!   exit
    t.mp0tz:	add	%g2,%l7,%g2	! ##TEMPLATE:IAR
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		nop			!
t.mp0e:
		ba	break0		!
		nop			!
    t.mp0o0:	add	%l0,0,%o2	! ##TEMPLATE:%l0,imm0
    t.mp0o1:	add	%l0,0,%o1	! ##TEMPLATE:%l0,imm0
    t.mp0o2:	ldub	[%o2+0],%g0	! ##TEMPLATE:imm0 (L2)
    t.mp0o3:	ldub	[%o1+0],%g0	! ##TEMPLATE:imm0 (L1)
    t.mp0o4:	add	%g0,0,%o4	! ##TEMPLATE:imm0 (L2)
    t.mp0o5:	add	%g0,0,%o3	! ##TEMPLATE:imm0 (L1)
    t.mp0oy:	add	%g2,6,%g2	! ##TEMPLATE:IAR
    t.mp0oz:	add	%g2,4,%g2	! ##TEMPLATE:IAR

	.section ".text"
	.align	4
	.global cd6_dp,td6_dp,id6_dp
cd6_dp:
	retl				!
	add	%g0,t.dp0e-t.dp0s,%o0	!
td6_dp:
	sethi	%hi(t.dp0s),%o3		!
	or	%o3,%lo(t.dp0s),%o3	!
	or	%g0,t.dp0e-t.dp0s,%o4	!
    t.dp0cp:				!
	subcc	%o4,4,%o4		!
	ld	[%o3+%o4],%o5		! copy template to ibuf
	bnz	t.dp0cp			!
	st	%o5,[%o0+%o4]		!
	ld	[%o3+t.dp0o0-t.dp0s],%o5!
	srl	%o2,28,%o4		!
	andcc	%o4,0xf,%o4		! B2
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	srl	%o2,16,%o4		!
	and	%o4,0xfff,%o4		! D2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.dp0t0-t.dp0s]!
	ld	[%o3+t.dp0o1-t.dp0s],%o5!
	srl	%o1,12,%o4		!
	andcc	%o4,0xf,%o4		! B1
	bz,a	.+8			! |
	add	%g0,0x10,%o4		! |
	subcc	%o4,0xe,%g0		! |
	be,a	.+8			! |
	add	%g0,0x16,%o4		! |
	sll	%o4,14,%o4		! |
	xor	%o5,%o4,%o5		! rs1
	and	%o1,0xfff,%o4		! D1
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.dp0t1-t.dp0s]!
	ld	[%o3+t.dp0o2-t.dp0s],%o5!
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! L2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.dp0t2-t.dp0s]!
	ld	[%o3+t.dp0o3-t.dp0s],%o5!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! L1
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.dp0t3-t.dp0s]!
	ld	[%o3+t.dp0o4-t.dp0s],%o5!
	srl	%o1,16,%o4		!
	and	%o4,0xf,%o4		! L2
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.dp0t4-t.dp0s]!
	ld	[%o3+t.dp0o5-t.dp0s],%o5!
	srl	%o1,20,%o4		!
	and	%o4,0xf,%o4		! L1
	or	%o5,%o4,%o5		! simm13
	st	%o5,[%o0+t.dp0t5-t.dp0s]!
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=6
	ld	[%o3+t.dp0oy-t.dp0s],%o5!
	bnz,a	.+8			! if EX=1 then IAR+=4
	ld	[%o3+t.dp0oz-t.dp0s],%o5!
	st	%o5,[%o0+t.dp0tz-t.dp0s]!
	retl				!
	add	%o0,t.dp0e-t.dp0s,%o0	!
id6_dp:
	srl	%o2,28,%o4		! B2
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l3		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l3		! %l3
	srl	%o2,16,%o4		! D2
	and	%o4,0xfff,%l4		! %l4
	srl	%o1,12,%o4		! B1
	andcc	%o4,0xf,%o4		! |
	bz,a	.+16			! |
	add	%g0,%g0,%l1		! |
	sll	%o4,2,%o4		! |
	ld	[%o7+%o4],%l1		! %l1
	and	%o1,0xfff,%l2		! D1
	srl	%o1,16,%o4		! L2
	and	%o4,0xf,%l6		! %l6
	srl	%o1,20,%o4		! L1
	and	%o4,0xf,%l5		! %l5
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=6
	add	%g0,6,%l7		!
	bnz,a	.+8			! if EX=1 then IAR+=4
	add	%g0,4,%l7		!
t.dp0s:
    t.dp0t0:	add	%l3,%l4,%o2	! ##TEMPLATE:%l0,imm0
		and	%o2,%g3,%o2	! mask address
		add	%g4,%o2,%o2	!
    t.dp0t1:	add	%l1,%l2,%o1	! ##TEMPLATE:%l0,imm0
		and	%o1,%g3,%o1	! mask address
		add	%g4,%o1,%o1	!
		ldub	[%o2],%g0	! force PAGEIN
    t.dp0t2:	ldub	[%o2+%l6],%g0	! ##TEMPLATE:imm0 (L2)
		ldub	[%o1],%g0	! force PAGEIN
    t.dp0t3:	ldub	[%o1+%l5],%g0	! ##TEMPLATE:imm0 (L1)
    t.dp0t4:	add	%g0,%l6,%o4	! ##TEMPLATE:imm0 (L2)
    t.dp0t5:	add	%g0,%l5,%o3	! ##TEMPLATE:imm0 (L1)
		ld	[%sp+184],%o0	! struct *gcpu_s
		sethi	%hi(il_dp),%o7	!
		jmpl	%o7+%lo(il_dp),%o7
		nop			! call library in intlib.s
		sethi	%hi(0x00ff0000),%o1
		andcc	%g7,%o1,%g0	! if intermediate intr. then
		bz,a	t.dp0e		!   exit
    t.dp0tz:	add	%g2,%l7,%g2	! ##TEMPLATE:IAR
		sethi	%hi(epilog0),%o7!
		jmpl	%o7+%lo(epilog0),%g0
		nop			!
t.dp0e:
		ba	break0		!
		nop			!
    t.dp0o0:	add	%l0,0,%o2	! ##TEMPLATE:%l0,imm0
    t.dp0o1:	add	%l0,0,%o1	! ##TEMPLATE:%l0,imm0
    t.dp0o2:	ldub	[%o2+0],%g0	! ##TEMPLATE:imm0 (L2)
    t.dp0o3:	ldub	[%o1+0],%g0	! ##TEMPLATE:imm0 (L1)
    t.dp0o4:	add	%g0,0,%o4	! ##TEMPLATE:imm0 (L2)
    t.dp0o5:	add	%g0,0,%o3	! ##TEMPLATE:imm0 (L1)
    t.dp0oy:	add	%g2,6,%g2	! ##TEMPLATE:IAR
    t.dp0oz:	add	%g2,4,%g2	! ##TEMPLATE:IAR

!
! <M CC translation table>
!
	.section ".data"
	.align	8
	.global cctable
cctable:
!
!     last-cc-setter
!	0: direct M-CC
!	1: CC=SPARC-CC(bit logical)
!		0:=zero
!		1:!zero
!	2: CC=SPARC-CC(compare)
!		0:equal
!		1:R1<R2
!		2:R1>R2
!	3: CC=SPARC-CC(arithmetic)
!		0:=zero
!		1:<zero
!		2:>zero
!		3:overflow
!	4: CC=SPARC-CC(add logical)
!		0:=zero no carry
!		1:!zero no carry
!		2:=zero	   carry
!		3:!zero	   carry
!	5: CC=SPARC-CC(sub logical)
!		1:!zero no carry
!		2:=zero	   carry
!		3:!zero	   carry
!
!				N N N N N N N N
!			Z Z Z Z		Z Z Z Z
!		    V V	    V V	    V V	    V V
!		  C   C	  C   C	  C   C	  C   C
!               -------------------------------
!	ba	O O O O O O O O O O O O O O O O
!	bn      . . . . . . . . . . . . . . . .
!	bne	O O O O . . . . O O O O . . . .
!	be	. . . . O O O O . . . . O O O O
!	bg	O O . . . . . . . . O O . . . .
!	ble	. . O O O O O O O O . . O O O O
!	bge	O O . . O O . . . . O O . . O O
!	bl	. . O O . . O O O O . . O O . .
!	bgu	O . O . . . . . O . O . . . . .
!	bleu	. O . O O O O O . O . O O O O O
!	bcc|geu	O . O . O . O . O . O . O . O .
!	bcs|lu	. O . O . O . O . O . O . O . O
!	bpos	O O O O O O O O . . . . . . . .
!	bneg	. . . . . . . . O O O O O O O O
!	bvc	O O . . O O . . O O . . O O . .
!	bvs	. . O O . . O O . . O O . . O O
!
	.byte	0,1,2,3,8,8,8,8,8,8,8,8,8,8,8,8 ! last-cc-setter=0
	.byte	8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8 ! last-cc-setter=1
	.byte	8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8 ! last-cc-setter=2
	.byte	8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8 ! last-cc-setter=3
	.byte	8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8 ! last-cc-setter=4
	.byte	8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8 ! last-cc-setter=5

!
! <M opcd table>
!
	.section ".data"
	.align	8
	.global optable
optable:
!
!   struct m_op {
!	int      mlen;
!	unsigned ifunc;
!	unsigned *name;
!	unsigned *args;
!	unsigned cfunc;
!	unsigned tfunc;
!	int      type;
!	unsigned rsv1;
!   };
!
	.word	2,ii2_OPX2, opn_OPX2, opa_OPX2, ci2_OPX2, ti2_OPX2, 1,0 /* 00 */
	.word	2,ii2_OPX2, opn_OPX2, opa_OPX2, ci2_OPX2, ti2_OPX2, 1,0 /* 01 */
	.word	2,ii2_OPX2, opn_OPX2, opa_OPX2, ci2_OPX2, ti2_OPX2, 1,0 /* 02 */
	.word	2,ii2_OPX2, opn_OPX2, opa_OPX2, ci2_OPX2, ti2_OPX2, 1,0 /* 03 */
	.word	2,ii2_spm,  opn_spm,  opa_spm,  ci2_spm,  ti2_spm,  0,0 /* 04 */
	.word	2,ii2_balr, opn_balr, opa_balr, ci2_balr, ti2_balr, 4,0 /* 05 */
	.word	2,ii2_bctr, opn_bctr, opa_bctr, ci2_bctr, ti2_bctr, 0,0 /* 06 */
	.word	2,ii2_bcr,  opn_bcr,  opa_bcr,  ci2_bcr,  ti2_bcr,  3,0 /* 07 */
	.word	2,ic2_ssk,  opn_ssk,  opa_ssk,  cc2_ssk,  tc2_ssk,  0,0 /* 08 */
	.word	2,ic2_isk,  opn_isk,  opa_isk,  cc2_isk,  tc2_isk,  0,0 /* 09 */
	.word	2,ii2_svc,  opn_svc,  opa_svc,  ci2_svc,  ti2_svc,  1,0 /* 0a */
	.word	2,ii2_bsm,  opn_bsm,  opa_bsm,  ci2_bsm,  ti2_bsm,  4,0 /* 0b */
	.word	2,ii2_bassm,opn_bassm,opa_bassm,ci2_bassm,ti2_bassm,4,0 /* 0c */
	.word	2,ii2_basr, opn_basr, opa_basr, ci2_basr, ti2_basr, 4,0 /* 0d */
	.word	2,ii2_mvcl, opn_mvcl, opa_mvcl, ci2_mvcl, ti2_mvcl, 0,0 /* 0e */
	.word	2,ii2_clcl, opn_clcl, opa_clcl, ci2_clcl, ti2_clcl, 0,0 /* 0f */

	.word	2,ii2_lpr,  opn_lpr,  opa_lpr,  ci2_lpr,  ti2_lpr,  0,0 /* 10 */
	.word	2,ii2_lnr,  opn_lnr,  opa_lnr,  ci2_lnr,  ti2_lnr,  0,0 /* 11 */
	.word	2,ii2_ltr,  opn_ltr,  opa_ltr,  ci2_ltr,  ti2_ltr,  0,0 /* 12 */
	.word	2,ii2_lcr,  opn_lcr,  opa_lcr,  ci2_lcr,  ti2_lcr,  0,0 /* 13 */
	.word	2,ii2_nr,   opn_nr,   opa_nr,   ci2_nr,	  ti2_nr,   0,0 /* 14 */
	.word	2,ii2_clr,  opn_clr,  opa_clr,  ci2_clr,  ti2_clr,  0,0 /* 15 */
	.word	2,ii2_or,   opn_or,   opa_or,   ci2_or,	  ti2_or,   0,0 /* 16 */
	.word	2,ii2_xr,   opn_xr,   opa_xr,   ci2_xr,	  ti2_xr,   0,0 /* 17 */
	.word	2,ii2_lr,   opn_lr,   opa_lr,   ci2_lr,	  ti2_lr,   0,0 /* 18 */
	.word	2,ii2_cr,   opn_cr,   opa_cr,   ci2_cr,	  ti2_cr,   0,0 /* 19 */
	.word	2,ii2_ar,   opn_ar,   opa_ar,   ci2_ar,	  ti2_ar,   0,0 /* 1a */
	.word	2,ii2_sr,   opn_sr,   opa_sr,   ci2_sr,	  ti2_sr,   0,0 /* 1b */
	.word	2,ii2_mr,   opn_mr,   opa_mr,   ci2_mr,	  ti2_mr,   0,0 /* 1c */
	.word	2,ii2_dr,   opn_dr,   opa_dr,   ci2_dr,	  ti2_dr,   0,0 /* 1d */
	.word	2,ii2_alr,  opn_alr,  opa_alr,  ci2_alr,  ti2_alr,  0,0 /* 1e */
	.word	2,ii2_slr,  opn_slr,  opa_slr,  ci2_slr,  ti2_slr,  0,0 /* 1f */

	.word	2,if2_lpdr, opn_lpdr, opa_lpdr, cf2_lpdr, tf2_lpdr, 0,0 /* 20 */
	.word	2,if2_lndr, opn_lndr, opa_lndr, cf2_lndr, tf2_lndr, 0,0 /* 21 */
	.word	2,if2_ltdr, opn_ltdr, opa_ltdr, cf2_ltdr, tf2_ltdr, 0,0 /* 22 */
	.word	2,if2_lcdr, opn_lcdr, opa_lcdr, cf2_lcdr, tf2_lcdr, 0,0 /* 23 */
	.word	2,if2_hdr,  opn_hdr,  opa_hdr,  cf2_hdr,  tf2_hdr,  0,0 /* 24 */
	.word	2,if2_lrdr, opn_lrdr, opa_lrdr, cf2_lrdr, tf2_lrdr, 0,0 /* 25 */
	.word	2,if2_mxr,  opn_mxr,  opa_mxr,  cf2_mxr,  tf2_mxr,  0,0 /* 26 */
	.word	2,if2_mxdr, opn_mxdr, opa_mxdr, cf2_mxdr, tf2_mxdr, 0,0 /* 27 */
	.word	2,if2_ldr,  opn_ldr,  opa_ldr,  cf2_ldr,  tf2_ldr,  0,0 /* 28 */
	.word	2,if2_cdr,  opn_cdr,  opa_cdr,  cf2_cdr,  tf2_cdr,  0,0 /* 29 */
	.word	2,if2_adr,  opn_adr,  opa_adr,  cf2_adr,  tf2_adr,  0,0 /* 2a */
	.word	2,if2_sdr,  opn_sdr,  opa_sdr,  cf2_sdr,  tf2_sdr,  0,0 /* 2b */
	.word	2,if2_mdr,  opn_mdr,  opa_mdr,  cf2_mdr,  tf2_mdr,  0,0 /* 2c */
	.word	2,if2_ddr,  opn_ddr,  opa_ddr,  cf2_ddr,  tf2_ddr,  0,0 /* 2d */
	.word	2,if2_awr,  opn_awr,  opa_awr,  cf2_awr,  tf2_awr,  0,0 /* 2e */
	.word	2,if2_swr,  opn_swr,  opa_swr,  cf2_swr,  tf2_swr,  0,0 /* 2f */

	.word	2,if2_lper, opn_lper, opa_lper, cf2_lper, tf2_lper, 0,0 /* 30 */
	.word	2,if2_lner, opn_lner, opa_lner, cf2_lner, tf2_lner, 0,0 /* 31 */
	.word	2,if2_lter, opn_lter, opa_lter, cf2_lter, tf2_lter, 0,0 /* 32 */
	.word	2,if2_lcer, opn_lcer, opa_lcer, cf2_lcer, tf2_lcer, 0,0 /* 33 */
	.word	2,if2_her,  opn_her,  opa_her,  cf2_her,  tf2_her,  0,0 /* 34 */
	.word	2,if2_lrer, opn_lrer, opa_lrer, cf2_lrer, tf2_lrer, 0,0 /* 35 */
	.word	2,if2_axr,  opn_axr,  opa_axr,  cf2_axr,  tf2_axr,  0,0 /* 36 */
	.word	2,if2_sxr,  opn_sxr,  opa_sxr,  cf2_sxr,  tf2_sxr,  0,0 /* 37 */
	.word	2,if2_ler,  opn_ler,  opa_ler,  cf2_ler,  tf2_ler,  0,0 /* 38 */
	.word	2,if2_cer,  opn_cer,  opa_cer,  cf2_cer,  tf2_cer,  0,0 /* 39 */
	.word	2,if2_aer,  opn_aer,  opa_aer,  cf2_aer,  tf2_aer,  0,0 /* 3a */
	.word	2,if2_ser,  opn_ser,  opa_ser,  cf2_ser,  tf2_ser,  0,0 /* 3b */
	.word	2,if2_mer,  opn_mer,  opa_mer,  cf2_mer,  tf2_mer,  0,0 /* 3c */
	.word	2,if2_der,  opn_der,  opa_der,  cf2_der,  tf2_der,  0,0 /* 3d */
	.word	2,if2_aur,  opn_aur,  opa_aur,  cf2_aur,  tf2_aur,  0,0 /* 3e */
	.word	2,if2_sur,  opn_sur,  opa_sur,  cf2_sur,  tf2_sur,  0,0 /* 3f */

	.word	4,ii4_sth,  opn_sth,  opa_sth,  ci4_sth,  ti4_sth,  0,0 /* 40 */
	.word	4,ii4_la,   opn_la,   opa_la,   ci4_la,	  ti4_la,   0,0 /* 41 */
	.word	4,ii4_stc,  opn_stc,  opa_stc,  ci4_stc,  ti4_stc,  0,0 /* 42 */
	.word	4,ii4_ic,   opn_ic,   opa_ic,   ci4_ic,	  ti4_ic,   0,0 /* 43 */
	.word	4,ii4_ex,   opn_ex,   opa_ex,   ci4_ex,	  ti4_ex,   1,0 /* 44 */
	.word	4,ii4_bal,  opn_bal,  opa_bal,  ci4_bal,  ti4_bal,  1,0 /* 45 */
	.word	4,ii4_bct,  opn_bct,  opa_bct,  ci4_bct,  ti4_bct,  0,0 /* 46 */
	.word	4,ii4_bc,   opn_bc,   opa_bc,   ci4_bc,	  ti4_bc,   2,0 /* 47 */
	.word	4,ii4_lh,   opn_lh,   opa_lh,   ci4_lh,	  ti4_lh,   0,0 /* 48 */
	.word	4,ii4_ch,   opn_ch,   opa_ch,   ci4_ch,	  ti4_ch,   0,0 /* 49 */
	.word	4,ii4_ah,   opn_ah,   opa_ah,   ci4_ah,	  ti4_ah,   0,0 /* 4a */
	.word	4,ii4_sh,   opn_sh,   opa_sh,   ci4_sh,	  ti4_sh,   0,0 /* 4b */
	.word	4,ii4_mh,   opn_mh,   opa_mh,   ci4_mh,	  ti4_mh,   0,0 /* 4c */
	.word	4,ii4_bas,  opn_bas,  opa_bas,  ci4_bas,  ti4_bas,  1,0 /* 4d */
	.word	4,ii4_cvd,  opn_cvd,  opa_cvd,  ci4_cvd,  ti4_cvd,  0,0 /* 4e */
	.word	4,ii4_cvb,  opn_cvb,  opa_cvb,  ci4_cvb,  ti4_cvb,  0,0 /* 4f */

	.word	4,ii4_st,   opn_st,   opa_st,   ci4_st,	  ti4_st,   0,0 /* 50 */
	.word	4,ii4_flm,  opn_flm,  opa_flm,  ci4_flm,  ti4_flm,  0,0 /* 51 */
	.word	4,ii4_OPX4, opn_OPX4, opa_OPX4, ci4_OPX4, ti4_OPX4, 1,0 /* 52 */
	.word	4,ii4_OPX4, opn_OPX4, opa_OPX4, ci4_OPX4, ti4_OPX4, 1,0 /* 53 */
	.word	4,ii4_n,    opn_n,    opa_n,    ci4_n,	  ti4_n,    0,0 /* 54 */
	.word	4,ii4_cl,   opn_cl,   opa_cl,   ci4_cl,	  ti4_cl,   0,0 /* 55 */
	.word	4,ii4_o,    opn_o,    opa_o,    ci4_o,	  ti4_o,    0,0 /* 56 */
	.word	4,ii4_x,    opn_x,    opa_x,    ci4_x,	  ti4_x,    0,0 /* 57 */
	.word	4,ii4_l,    opn_l,    opa_l,    ci4_l,	  ti4_l,    0,0 /* 58 */
	.word	4,ii4_c,    opn_c,    opa_c,    ci4_c,	  ti4_c,    0,0 /* 59 */
	.word	4,ii4_a,    opn_a,    opa_a,    ci4_a,	  ti4_a,    0,0 /* 5a */
	.word	4,ii4_s,    opn_s,    opa_s,    ci4_s,	  ti4_s,    0,0 /* 5b */
	.word	4,ii4_m,    opn_m,    opa_m,    ci4_m,	  ti4_m,    0,0 /* 5c */
	.word	4,ii4_d,    opn_d,    opa_d,    ci4_d,	  ti4_d,    0,0 /* 5d */
	.word	4,ii4_al,   opn_al,   opa_al,   ci4_al,	  ti4_al,   0,0 /* 5e */
	.word	4,ii4_sl,   opn_sl,   opa_sl,   ci4_sl,	  ti4_sl,   0,0 /* 5f */

	.word	4,if4_std,  opn_std,  opa_std,  cf4_std,  tf4_std,  0,0 /* 60 */
	.word	4,ii4_OPX4, opn_OPX4, opa_OPX4, ci4_OPX4, ti4_OPX4, 1,0 /* 61 */
	.word	4,ii4_OPX4, opn_OPX4, opa_OPX4, ci4_OPX4, ti4_OPX4, 1,0 /* 62 */
	.word	4,ii4_OPX4, opn_OPX4, opa_OPX4, ci4_OPX4, ti4_OPX4, 1,0 /* 63 */
	.word	4,ii4_OPX4, opn_OPX4, opa_OPX4, ci4_OPX4, ti4_OPX4, 1,0 /* 64 */
	.word	4,ii4_OPX4, opn_OPX4, opa_OPX4, ci4_OPX4, ti4_OPX4, 1,0 /* 65 */
	.word	4,ii4_OPX4, opn_OPX4, opa_OPX4, ci4_OPX4, ti4_OPX4, 1,0 /* 66 */
	.word	4,if4_mxd,  opn_mxd,  opa_mxd,  cf4_mxd,  tf4_mxd,  0,0 /* 67 */
	.word	4,if4_ld,   opn_ld,   opa_ld,   cf4_ld,	  tf4_ld,   0,0 /* 68 */
	.word	4,if4_cd,   opn_cd,   opa_cd,   cf4_cd,	  tf4_cd,   0,0 /* 69 */
	.word	4,if4_ad,   opn_ad,   opa_ad,   cf4_ad,	  tf4_ad,   0,0 /* 6a */
	.word	4,if4_sd,   opn_sd,   opa_sd,   cf4_sd,	  tf4_sd,   0,0 /* 6b */
	.word	4,if4_md,   opn_md,   opa_md,   cf4_md,	  tf4_md,   0,0 /* 6c */
	.word	4,if4_dd,   opn_dd,   opa_dd,   cf4_dd,	  tf4_dd,   0,0 /* 6d */
	.word	4,if4_aw,   opn_aw,   opa_aw,   cf4_aw,	  tf4_aw,   0,0 /* 6e */
	.word	4,if4_sw,   opn_sw,   opa_sw,   cf4_sw,	  tf4_sw,   0,0 /* 6f */

	.word	4,if4_ste,  opn_ste,  opa_ste,  cf4_ste,  tf4_ste,  0,0 /* 70 */
	.word	4,ii4_OPX4, opn_OPX4, opa_OPX4, ci4_OPX4, ti4_OPX4, 1,0 /* 71 */
	.word	4,if4_cei,  opn_cei,  opa_cei,  cf4_cei,  tf4_cei,  0,0 /* 72 */
	.word	4,if4_cdi,  opn_cdi,  opa_cdi,  cf4_cdi,  tf4_cdi,  0,0 /* 73 */
	.word	4,if4_cie,  opn_cie,  opa_cie,  cf4_cie,  tf4_cie,  0,0 /* 74 */
	.word	4,if4_cid,  opn_cid,  opa_cid,  cf4_cid,  tf4_cid,  0,0 /* 75 */
	.word	4,ii4_OPX4, opn_OPX4, opa_OPX4, ci4_OPX4, ti4_OPX4, 1,0 /* 76 */
	.word	4,ii4_OPX4, opn_OPX4, opa_OPX4, ci4_OPX4, ti4_OPX4, 1,0 /* 77 */
	.word	4,if4_le,   opn_le,   opa_le,   cf4_le,	  tf4_le,   0,0 /* 78 */
	.word	4,if4_ce,   opn_ce,   opa_ce,   cf4_ce,	  tf4_ce,   0,0 /* 79 */
	.word	4,if4_ae,   opn_ae,   opa_ae,   cf4_ae,	  tf4_ae,   0,0 /* 7a */
	.word	4,if4_se,   opn_se,   opa_se,   cf4_se,	  tf4_se,   0,0 /* 7b */
	.word	4,if4_me,   opn_me,   opa_me,   cf4_me,	  tf4_me,   0,0 /* 7c */
	.word	4,if4_de,   opn_de,   opa_de,   cf4_de,	  tf4_de,   0,0 /* 7d */
	.word	4,if4_au,   opn_au,   opa_au,   cf4_au,	  tf4_au,   0,0 /* 7e */
	.word	4,if4_su,   opn_su,   opa_su,   cf4_su,	  tf4_su,   0,0 /* 7f */

	.word	4,ic4_ssm,  opn_ssm,  opa_ssm,  cc4_ssm,  tc4_ssm,  0,0 /* 80 */
	.word	4,ii4_OPX4, opn_OPX4, opa_OPX4, ci4_OPX4, ti4_OPX4, 1,0 /* 81 */
	.word	4,ic4_lpsw, opn_lpsw, opa_lpsw, cc4_lpsw, tc4_lpsw, 1,0 /* 82 */
	.word	4,ic4_diag, opn_diag, opa_diag, cc4_diag, tc4_diag, 1,0 /* 83 */
	.word	4,ii4_OPX4, opn_OPX4, opa_OPX4, ci4_OPX4, ti4_OPX4, 1,0 /* 84 */
	.word	4,ii4_OPX4, opn_OPX4, opa_OPX4, ci4_OPX4, ti4_OPX4, 1,0 /* 85 */
	.word	4,ii4_bxh,  opn_bxh,  opa_bxh,  ci4_bxh,  ti4_bxh,  0,0 /* 86 */
	.word	4,ii4_bxle, opn_bxle, opa_bxle, ci4_bxle, ti4_bxle, 0,0 /* 87 */
	.word	4,ii4_srl,  opn_srl,  opa_srl,  ci4_srl,  ti4_srl,  0,0 /* 88 */
	.word	4,ii4_sll,  opn_sll,  opa_sll,  ci4_sll,  ti4_sll,  0,0 /* 89 */
	.word	4,ii4_sra,  opn_sra,  opa_sra,  ci4_sra,  ti4_sra,  0,0 /* 8a */
	.word	4,ii4_sla,  opn_sla,  opa_sla,  ci4_sla,  ti4_sla,  0,0 /* 8b */
	.word	4,ii4_srdl, opn_srdl, opa_srdl, ci4_srdl, ti4_srdl, 0,0 /* 8c */
	.word	4,ii4_sldl, opn_sldl, opa_sldl, ci4_sldl, ti4_sldl, 0,0 /* 8d */
	.word	4,ii4_srda, opn_srda, opa_srda, ci4_srda, ti4_srda, 0,0 /* 8e */
	.word	4,ii4_slda, opn_slda, opa_slda, ci4_slda, ti4_slda, 0,0 /* 8f */

	.word	4,ii4_stm,  opn_stm,  opa_stm,  ci4_stm,  ti4_stm,  0,0 /* 90 */
	.word	4,ii4_tm,   opn_tm,   opa_tm,   ci4_tm,	  ti4_tm,   0,0 /* 91 */
	.word	4,ii4_mvi,  opn_mvi,  opa_mvi,  ci4_mvi,  ti4_mvi,  0,0 /* 92 */
	.word	4,ii4_ts,   opn_ts,   opa_ts,   ci4_ts,	  ti4_ts,   0,0 /* 93 */
	.word	4,ii4_ni,   opn_ni,   opa_ni,   ci4_ni,	  ti4_ni,   0,0 /* 94 */
	.word	4,ii4_cli,  opn_cli,  opa_cli,  ci4_cli,  ti4_cli,  0,0 /* 95 */
	.word	4,ii4_oi,   opn_oi,   opa_oi,   ci4_oi,	  ti4_oi,   0,0 /* 96 */
	.word	4,ii4_xi,   opn_xi,   opa_xi,   ci4_xi,	  ti4_xi,   0,0 /* 97 */
	.word	4,ii4_lm,   opn_lm,   opa_lm,   ci4_lm,	  ti4_lm,   0,0 /* 98 */
	.word	4,ii4_OPX4, opn_OPX4, opa_OPX4, ci4_OPX4, ti4_OPX4, 1,0 /* 99 */
	.word	4,ii4_OPX4, opn_OPX4, opa_OPX4, ci4_OPX4, ti4_OPX4, 1,0 /* 9a */
	.word	4,ii4_OPX4, opn_OPX4, opa_OPX4, ci4_OPX4, ti4_OPX4, 1,0 /* 9b */
	.word	4,ic4_9cxx, opn_9cxx, opa_9cxx, cc4_9cxx, tc4_9cxx, 0,0 /* 9c */
	.word	4,ic4_9dxx, opn_9dxx, opa_9dxx, cc4_9dxx, tc4_9dxx, 0,0 /* 9d */
	.word	4,ic4_9exx, opn_9exx, opa_9exx, cc4_9exx, tc4_9exx, 0,0 /* 9e */
	.word	4,ic4_9fxx, opn_9fxx, opa_9fxx, cc4_9fxx, tc4_9fxx, 0,0 /* 9f */

	.word	4,ii4_OPX4, opn_OPX4, opa_OPX4, ci4_OPX4, ti4_OPX4, 1,0 /* a0 */
	.word	4,ii4_ai,   opn_ai,   opa_ai,   ci4_ai,	  ti4_ai,   0,0 /* a1 */
	.word	4,ii4_stext,opn_stext,opa_stext,ci4_stext,ti4_stext,0,0 /* a2 */
	.word	4,ii4_svg,  opn_svg,  opa_svg,  ci4_svg,  ti4_svg,  0,0 /* a3 */
	.word	4,ii4_OPX4, opn_OPX4, opa_OPX4, ci4_OPX4, ti4_OPX4, 1,0 /* a4 */
	.word	4,ii4_OPX4, opn_OPX4, opa_OPX4, ci4_OPX4, ti4_OPX4, 1,0 /* a5 */
	.word	4,ii4_OPX4, opn_OPX4, opa_OPX4, ci4_OPX4, ti4_OPX4, 1,0 /* a6 */
	.word	4,ii4_OPX4, opn_OPX4, opa_OPX4, ci4_OPX4, ti4_OPX4, 1,0 /* a7 */
	.word	4,ii4_OPX4, opn_OPX4, opa_OPX4, ci4_OPX4, ti4_OPX4, 1,0 /* a8 */
	.word	4,ii4_OPX4, opn_OPX4, opa_OPX4, ci4_OPX4, ti4_OPX4, 1,0 /* a9 */
	.word	4,ii4_OPX4, opn_OPX4, opa_OPX4, ci4_OPX4, ti4_OPX4, 1,0 /* aa */
	.word	4,ii4_OPX4, opn_OPX4, opa_OPX4, ci4_OPX4, ti4_OPX4, 1,0 /* ab */
	.word	4,ic4_stnsm,opn_stnsm,opa_stnsm,cc4_stnsm,tc4_stnsm,0,0 /* ac */
	.word	4,ic4_stosm,opn_stosm,opa_stosm,cc4_stosm,tc4_stosm,0,0 /* ad */
	.word	4,ic4_sigp, opn_sigp, opa_sigp, cc4_sigp, tc4_sigp, 0,0 /* ae */
	.word	4,ii4_mc,   opn_mc,   opa_mc,   ci4_mc,	  ti4_mc,   0,0 /* af */

	.word	4,ii4_OPX4, opn_OPX4, opa_OPX4, ci4_OPX4, ti4_OPX4, 1,0 /* b0 */
	.word	4,ic4_lra,  opn_lra,  opa_lra,  cc4_lra,  tc4_lra,  0,0 /* b1 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b2 */
	.word	4,ii4_OPX4, opn_OPX4, opa_OPX4, ci4_OPX4, ti4_OPX4, 1,0 /* b3 */
	.word	4,ii4_OPX4, opn_OPX4, opa_OPX4, ci4_OPX4, ti4_OPX4, 1,0 /* b4 */
	.word	4,ii4_OPX4, opn_OPX4, opa_OPX4, ci4_OPX4, ti4_OPX4, 1,0 /* b5 */
	.word	4,ic4_stctl,opn_stctl,opa_stctl,cc4_stctl,tc4_stctl,0,0 /* b6 */
	.word	4,ic4_lctl, opn_lctl, opa_lctl, cc4_lctl, tc4_lctl, 0,0 /* b7 */
	.word	4,ii4_OPX4, opn_OPX4, opa_OPX4, ci4_OPX4, ti4_OPX4, 1,0 /* b8 */
	.word	4,ii4_OPX4, opn_OPX4, opa_OPX4, ci4_OPX4, ti4_OPX4, 1,0 /* b9 */
	.word	4,ii4_cs,   opn_cs,   opa_cs,   ci4_cs,	  ti4_cs,   0,0 /* ba */
	.word	4,ii4_cds,  opn_cds,  opa_cds,  ci4_cds,  ti4_cds,  0,0 /* bb */
	.word	4,ic4_bcxx, opn_bcxx, opa_bcxx, cc4_bcxx, tc4_bcxx, 0,0 /* bc */
	.word	4,ii4_clm,  opn_clm,  opa_clm,  ci4_clm,  ti4_clm,  0,0 /* bd */
	.word	4,ii4_stcm, opn_stcm, opa_stcm, ci4_stcm, ti4_stcm, 0,0 /* be */
	.word	4,ii4_icm,  opn_icm,  opa_icm,  ci4_icm,  ti4_icm,  0,0 /* bf */

	.word	6,ii6_OPX6, opn_OPX6, opa_OPX6, ci6_OPX6, ti6_OPX6, 1,0 /* c0 */
	.word	6,ii6_OPX6, opn_OPX6, opa_OPX6, ci6_OPX6, ti6_OPX6, 1,0 /* c1 */
	.word	6,ii6_OPX6, opn_OPX6, opa_OPX6, ci6_OPX6, ti6_OPX6, 1,0 /* c2 */
	.word	6,ii6_OPX6, opn_OPX6, opa_OPX6, ci6_OPX6, ti6_OPX6, 1,0 /* c3 */
	.word	6,ii6_OPX6, opn_OPX6, opa_OPX6, ci6_OPX6, ti6_OPX6, 1,0 /* c4 */
	.word	6,ii6_OPX6, opn_OPX6, opa_OPX6, ci6_OPX6, ti6_OPX6, 1,0 /* c5 */
	.word	6,ii6_OPX6, opn_OPX6, opa_OPX6, ci6_OPX6, ti6_OPX6, 1,0 /* c6 */
	.word	6,ii6_OPX6, opn_OPX6, opa_OPX6, ci6_OPX6, ti6_OPX6, 1,0 /* c7 */
	.word	6,ii6_OPX6, opn_OPX6, opa_OPX6, ci6_OPX6, ti6_OPX6, 1,0 /* c8 */
	.word	6,ii6_OPX6, opn_OPX6, opa_OPX6, ci6_OPX6, ti6_OPX6, 1,0 /* c9 */
	.word	6,ii6_OPX6, opn_OPX6, opa_OPX6, ci6_OPX6, ti6_OPX6, 1,0 /* ca */
	.word	6,ii6_OPX6, opn_OPX6, opa_OPX6, ci6_OPX6, ti6_OPX6, 1,0 /* cb */
	.word	6,ii6_OPX6, opn_OPX6, opa_OPX6, ci6_OPX6, ti6_OPX6, 1,0 /* cc */
	.word	6,ii6_OPX6, opn_OPX6, opa_OPX6, ci6_OPX6, ti6_OPX6, 1,0 /* cd */
	.word	6,ii6_OPX6, opn_OPX6, opa_OPX6, ci6_OPX6, ti6_OPX6, 1,0 /* ce */
	.word	6,ii6_OPX6, opn_OPX6, opa_OPX6, ci6_OPX6, ti6_OPX6, 1,0 /* cf */

	.word	6,ii6_OPX6, opn_OPX6, opa_OPX6, ci6_OPX6, ti6_OPX6, 1,0 /* d0 */
	.word	6,ii6_mvn,  opn_mvn,  opa_mvn,  ci6_mvn,  ti6_mvn,  0,0 /* d1 */
	.word	6,ii6_mvc,  opn_mvc,  opa_mvc,  ci6_mvc,  ti6_mvc,  0,0 /* d2 */
	.word	6,ii6_mvz,  opn_mvz,  opa_mvz,  ci6_mvz,  ti6_mvz,  0,0 /* d3 */
	.word	6,ii6_nc,   opn_nc,   opa_nc,   ci6_nc,   ti6_nc,   0,0 /* d4 */
	.word	6,ii6_clc,  opn_clc,  opa_clc,  ci6_clc,  ti6_clc,  0,0 /* d5 */
	.word	6,ii6_oc,   opn_oc,   opa_oc,   ci6_oc,	  ti6_oc,   0,0 /* d6 */
	.word	6,ii6_xc,   opn_xc,   opa_xc,   ci6_xc,	  ti6_xc,   0,0 /* d7 */
	.word	6,ii6_OPX6, opn_OPX6, opa_OPX6, ci6_OPX6, ti6_OPX6, 1,0 /* d8 */
	.word	6,ii6_OPX6, opn_OPX6, opa_OPX6, ci6_OPX6, ti6_OPX6, 1,0 /* d9 */
	.word	6,ii6_OPX6, opn_OPX6, opa_OPX6, ci6_OPX6, ti6_OPX6, 1,0 /* da */
	.word	6,ii6_OPX6, opn_OPX6, opa_OPX6, ci6_OPX6, ti6_OPX6, 1,0 /* db */
	.word	6,ii6_tr,   opn_tr,   opa_tr,   ci6_tr,	  ti6_tr,   0,0 /* dc */
	.word	6,ii6_trt,  opn_trt,  opa_trt,  ci6_trt,  ti6_trt,  0,0 /* dd */
	.word	6,id6_ed,   opn_ed,   opa_ed,   cd6_ed,   td6_ed,   0,0 /* de */
	.word	6,id6_edmk, opn_edmk, opa_edmk, cd6_edmk, td6_edmk, 0,0 /* df */

	.word	6,ii6_OPX6, opn_OPX6, opa_OPX6, ci6_OPX6, ti6_OPX6, 1,0 /* e0 */
	.word	6,ii6_OPX6, opn_OPX6, opa_OPX6, ci6_OPX6, ti6_OPX6, 1,0 /* e1 */
	.word	6,ii6_OPX6, opn_OPX6, opa_OPX6, ci6_OPX6, ti6_OPX6, 1,0 /* e2 */
	.word	6,ii6_OPX6, opn_OPX6, opa_OPX6, ci6_OPX6, ti6_OPX6, 1,0 /* e3 */
	.word	6,ii6_OPX6, opn_OPX6, opa_OPX6, ci6_OPX6, ti6_OPX6, 1,0 /* e4 */
	.word	6,ic6_e5xx, opn_e5xx, opa_e5xx, cc6_e5xx, tc6_e5xx, 0,0 /* e5 */
	.word	6,ii6_OPX6, opn_OPX6, opa_OPX6, ci6_OPX6, ti6_OPX6, 1,0 /* e6 */
	.word	6,ii6_OPX6, opn_OPX6, opa_OPX6, ci6_OPX6, ti6_OPX6, 1,0 /* e7 */
	.word	6,ii6_mvcin,opn_mvcin,opa_mvcin,ci6_mvcin,ti6_mvcin,0,0 /* e8 */
	.word	6,ii6_OPX6, opn_OPX6, opa_OPX6, ci6_OPX6, ti6_OPX6, 1,0 /* e9 */
	.word	6,ii6_OPX6, opn_OPX6, opa_OPX6, ci6_OPX6, ti6_OPX6, 1,0 /* ea */
	.word	6,ii6_OPX6, opn_OPX6, opa_OPX6, ci6_OPX6, ti6_OPX6, 1,0 /* eb */
	.word	6,ii6_OPX6, opn_OPX6, opa_OPX6, ci6_OPX6, ti6_OPX6, 1,0 /* ec */
	.word	6,ii6_OPX6, opn_OPX6, opa_OPX6, ci6_OPX6, ti6_OPX6, 1,0 /* ed */
	.word	6,ii6_OPX6, opn_OPX6, opa_OPX6, ci6_OPX6, ti6_OPX6, 1,0 /* ee */
	.word	6,ii6_OPX6, opn_OPX6, opa_OPX6, ci6_OPX6, ti6_OPX6, 1,0 /* ef */

	.word	6,id6_srp,  opn_srp,  opa_srp,  cd6_srp,  td6_srp,  0,0 /* f0 */
	.word	6,ii6_mvo,  opn_mvo,  opa_mvo,  ci6_mvo,  ti6_mvo,  0,0 /* f1 */
	.word	6,ii6_pack, opn_pack, opa_pack, ci6_pack, ti6_pack, 0,0 /* f2 */
	.word	6,ii6_unpk, opn_unpk, opa_unpk, ci6_unpk, ti6_unpk, 0,0 /* f3 */
	.word	6,ii6_OPX6, opn_OPX6, opa_OPX6, ci6_OPX6, ti6_OPX6, 1,0 /* f4 */
	.word	6,ii6_OPX6, opn_OPX6, opa_OPX6, ci6_OPX6, ti6_OPX6, 1,0 /* f5 */
	.word	6,ii6_OPX6, opn_OPX6, opa_OPX6, ci6_OPX6, ti6_OPX6, 1,0 /* f6 */
	.word	6,ii6_OPX6, opn_OPX6, opa_OPX6, ci6_OPX6, ti6_OPX6, 1,0 /* f7 */
	.word	6,id6_zap,  opn_zap,  opa_zap,  cd6_zap,  td6_zap,  0,0 /* f8 */
	.word	6,id6_cp,   opn_cp,   opa_cp,   cd6_cp,   td6_cp,   0,0 /* f9 */
	.word	6,id6_ap,   opn_ap,   opa_ap,   cd6_ap,   td6_ap,   0,0 /* fa */
	.word	6,id6_sp,   opn_sp,   opa_sp,   cd6_sp,   td6_sp,   0,0 /* fb */
	.word	6,id6_mp,   opn_mp,   opa_mp,   cd6_mp,   td6_mp,   0,0 /* fc */
	.word	6,id6_dp,   opn_dp,   opa_dp,   cd6_dp,   td6_dp,   0,0 /* fd */
	.word	6,ii6_OPX6, opn_OPX6, opa_OPX6, ci6_OPX6, ti6_OPX6, 1,0 /* fe */
	.word	6,ii6_OPX6, opn_OPX6, opa_OPX6, ci6_OPX6, ti6_OPX6, 1,0 /* ff */

!
! <M B2XX sub_opcd table>
!
	.section ".data"
	.align	8
	.global optb2xx
optb2xx:
!
!   struct m_op {
!	int      mlen;
!	unsigned ifunc;
!	unsigned *name;
!	unsigned *args;
!	unsigned cfunc;
!	unsigned tfunc;
!	int      type;
!	unsigned rsv1;
!   };
!
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b200 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b201 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b202 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b203 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b204 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b205 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b206 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b207 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b208 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b209 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b20a */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b20b */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b20c */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b20d */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b20e */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b20f */

	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b210 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b211 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b212 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b213 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b214 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b215 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b216 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b217 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b218 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b219 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b21a */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b21b */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b21c */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b21d */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b21e */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b21f */

	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b220 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b221 */
	.word	4,ii4_ipm,  opn_ipm,  opa_ipm,  ci4_ipm,  ti4_ipm,  0,0 /* b222 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b223 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b224 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b225 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b226 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b227 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b228 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b229 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b22a */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b22b */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b22c */
	.word	4,if4_dxr,  opn_dxr,  opa_dxr,  cf4_dxr,  tf4_dxr,  0,0 /* b22d */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b22e */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b22f */

	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b230 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b231 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b232 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b233 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b234 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b235 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b236 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b237 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b238 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b239 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b23a */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b23b */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b23c */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b23d */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b23e */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b23f */

	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b240 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b241 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b242 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b243 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b244 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b245 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b246 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b247 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b248 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b249 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b24a */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b24b */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b24c */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b24d */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b24e */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b24f */

	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b250 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b251 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b252 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b253 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b254 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b255 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b256 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b257 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b258 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b259 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b25a */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b25b */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b25c */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b25d */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b25e */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b25f */

	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b260 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b261 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b262 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b263 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b264 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b265 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b266 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b267 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b268 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b269 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b26a */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b26b */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b26c */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b26d */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b26e */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b26f */

	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b270 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b271 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b272 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b273 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b274 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b275 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b276 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b277 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b278 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b279 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b27a */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b27b */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b27c */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b27d */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b27e */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b27f */

	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b280 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b281 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b282 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b283 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b284 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b285 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b286 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b287 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b288 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b289 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b28a */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b28b */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b28c */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b28d */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b28e */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b28f */

	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b290 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b291 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b292 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b293 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b294 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b295 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b296 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b297 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b298 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b299 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b29a */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b29b */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b29c */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b29d */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b29e */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b29f */

	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b2a0 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b2a1 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b2a2 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b2a3 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b2a4 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b2a5 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b2a6 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b2a7 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b2a8 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b2a9 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b2aa */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b2ab */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b2ac */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b2ad */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b2ae */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b2af */

	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b2b0 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b2b1 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b2b2 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b2b3 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b2b4 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b2b5 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b2b6 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b2b7 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b2b8 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b2b9 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b2ba */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b2bb */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b2bc */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b2bd */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b2be */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b2bf */

	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b2c0 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b2c1 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b2c2 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b2c3 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b2c4 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b2c5 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b2c6 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b2c7 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b2c8 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b2c9 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b2ca */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b2cb */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b2cc */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b2cd */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b2ce */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b2cf */

	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b2d0 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b2d1 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b2d2 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b2d3 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b2d4 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b2d5 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b2d6 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b2d7 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b2d8 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b2d9 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b2da */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b2db */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b2dc */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b2dd */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b2de */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b2df */

	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b2e0 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b2e1 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b2e2 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b2e3 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b2e4 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b2e5 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b2e6 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b2e7 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b2e8 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b2e9 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b2ea */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b2eb */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b2ec */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b2ed */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b2ee */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b2ef */

	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b2f0 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b2f1 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b2f2 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b2f3 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b2f4 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b2f5 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b2f6 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b2f7 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b2f8 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b2f9 */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b2fa */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b2fb */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b2fc */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b2fd */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b2fe */
	.word	4,ic4_b2xx, opn_b2xx, opa_b2xx, cc4_b2xx, tc4_b2xx, 0,0 /* b2ff */

!
! /*  *args			  */
! /*	1:	  r1		  */
! /*	2:	  r2		  */
! /*	3:	  ipm/dxr-r1	  */
! /*	4:	  dxr-r2	  */
! /*	a:	  d2(x2,b2)	  */
! /*	b:	  d1(b1)/d2(b2)	  */
! /*	c:	  d1(l,b1)	  */
! /*	d:	  d2(b2)	  */
! /*	f:	  d1(l1,b1)	  */
! /*	g:	  d2(l2,b2)	  */
! /*	i:	  i		  */
! /*	j:	  i3		  */
! /*	m:	  m1		  */
! /*	n:	  m3		  */
! /*	x:	  diagnose	  */
!
	opn_OPX2:	.asciz	"??"	/* 00 */
	opa_OPX2:	.asciz	""	/* 00 */
	opn_OPX4:	.asciz	"????"	/* 00 */
	opa_OPX4:	.asciz	""	/* 00 */
	opn_OPX6:	.asciz	"??????"/* 00 */
	opa_OPX6:	.asciz	""	/* 00 */

	opn_spm:	.asciz	"SPM"	/* 04 */
	opa_spm:	.asciz	"1"	/* 04 */
	opn_balr:	.asciz	"BALR"	/* 05 */
	opa_balr:	.asciz	"1,2"	/* 05 */
	opn_bctr:	.asciz	"BCTR"	/* 06 */
	opa_bctr:	.asciz	"1,2"	/* 06 */
	opn_bcr:	.asciz	"BCR"	/* 07 */
	opa_bcr:	.asciz	"m,2"	/* 07 */
	opn_ssk:	.asciz	"SSK"	/* 08 */
	opa_ssk:	.asciz	"1,2"	/* 08 */
	opn_isk:	.asciz	"ISK"	/* 09 */
	opa_isk:	.asciz	"1,2"	/* 09 */
	opn_svc:	.asciz	"SVC"	/* 0a */
	opa_svc:	.asciz	"i"	/* 0a */
	opn_bsm:	.asciz	"BSM"	/* 0b */
	opa_bsm:	.asciz	"1,2"	/* 0b */
	opn_bassm:	.asciz	"BASSM" /* 0c */
	opa_bassm:	.asciz	"1,2"	/* 0c */
	opn_basr:	.asciz	"BASR"	/* 0d */
	opa_basr:	.asciz	"1,2"	/* 0d */
	opn_mvcl:	.asciz	"MVCL"	/* 0e */
	opa_mvcl:	.asciz	"1,2"	/* 0e */
	opn_clcl:	.asciz	"CLCL"	/* 0f */
	opa_clcl:	.asciz	"1,2"	/* 0f */

	opn_lpr:	.asciz	"LPR"	/* 10 */
	opa_lpr:	.asciz	"1,2"	/* 10 */
	opn_lnr:	.asciz	"LNR"	/* 11 */
	opa_lnr:	.asciz	"1,2"	/* 11 */
	opn_ltr:	.asciz	"LTR"	/* 12 */
	opa_ltr:	.asciz	"1,2"	/* 12 */
	opn_lcr:	.asciz	"LCR"	/* 13 */
	opa_lcr:	.asciz	"1,2"	/* 13 */
	opn_nr:		.asciz	"NR"	/* 14 */
	opa_nr:		.asciz	"1,2"	/* 14 */
	opn_clr:	.asciz	"CLR"	/* 15 */
	opa_clr:	.asciz	"1,2"	/* 15 */
	opn_or:		.asciz	"OR"	/* 16 */
	opa_or:		.asciz	"1,2"	/* 16 */
	opn_xr:		.asciz	"XR"	/* 17 */
	opa_xr:		.asciz	"1,2"	/* 17 */
	opn_lr:		.asciz	"LR"	/* 18 */
	opa_lr:		.asciz	"1,2"	/* 18 */
	opn_cr:		.asciz	"CR"	/* 19 */
	opa_cr:		.asciz	"1,2"	/* 19 */
	opn_ar:		.asciz	"AR"	/* 1a */
	opa_ar:		.asciz	"1,2"	/* 1a */
	opn_sr:		.asciz	"SR"	/* 1b */
	opa_sr:		.asciz	"1,2"	/* 1b */
	opn_mr:		.asciz	"MR"	/* 1c */
	opa_mr:		.asciz	"1,2"	/* 1c */
	opn_dr:		.asciz	"DR"	/* 1d */
	opa_dr:		.asciz	"1,2"	/* 1d */
	opn_alr:	.asciz	"ALR"	/* 1e */
	opa_alr:	.asciz	"1,2"	/* 1e */
	opn_slr:	.asciz	"SLR"	/* 1f */
	opa_slr:	.asciz	"1,2"	/* 1f */

	opn_lpdr:	.asciz	"LPDR"	/* 20 */
	opa_lpdr:	.asciz	"1,2"	/* 20 */
	opn_lndr:	.asciz	"LNDR"	/* 21 */
	opa_lndr:	.asciz	"1,2"	/* 21 */
	opn_ltdr:	.asciz	"LTDR"	/* 22 */
	opa_ltdr:	.asciz	"1,2"	/* 22 */
	opn_lcdr:	.asciz	"LCDR"	/* 23 */
	opa_lcdr:	.asciz	"1,2"	/* 23 */
	opn_hdr:	.asciz	"HDR"	/* 24 */
	opa_hdr:	.asciz	"1,2"	/* 24 */
	opn_lrdr:	.asciz	"LRDR"	/* 25 */
	opa_lrdr:	.asciz	"1,2"	/* 25 */
	opn_mxr:	.asciz	"MXR"	/* 26 */
	opa_mxr:	.asciz	"1,2"	/* 26 */
	opn_mxdr:	.asciz	"MXDR"	/* 27 */
	opa_mxdr:	.asciz	"1,2"	/* 27 */
	opn_ldr:	.asciz	"LDR"	/* 28 */
	opa_ldr:	.asciz	"1,2"	/* 28 */
	opn_cdr:	.asciz	"CDR"	/* 29 */
	opa_cdr:	.asciz	"1,2"	/* 29 */
	opn_adr:	.asciz	"ADR"	/* 2a */
	opa_adr:	.asciz	"1,2"	/* 2a */
	opn_sdr:	.asciz	"SDR"	/* 2b */
	opa_sdr:	.asciz	"1,2"	/* 2b */
	opn_mdr:	.asciz	"MDR"	/* 2c */
	opa_mdr:	.asciz	"1,2"	/* 2c */
	opn_ddr:	.asciz	"DDR"	/* 2d */
	opa_ddr:	.asciz	"1,2"	/* 2d */
	opn_awr:	.asciz	"AWR"	/* 2e */
	opa_awr:	.asciz	"1,2"	/* 2e */
	opn_swr:	.asciz	"SWR"	/* 2f */
	opa_swr:	.asciz	"1,2"	/* 2f */

	opn_lper:	.asciz	"LPER"	/* 30 */
	opa_lper:	.asciz	"1,2"	/* 30 */
	opn_lner:	.asciz	"LNER"	/* 31 */
	opa_lner:	.asciz	"1,2"	/* 31 */
	opn_lter:	.asciz	"LTER"	/* 32 */
	opa_lter:	.asciz	"1,2"	/* 32 */
	opn_lcer:	.asciz	"LCER"	/* 33 */
	opa_lcer:	.asciz	"1,2"	/* 33 */
	opn_her:	.asciz	"HER"	/* 34 */
	opa_her:	.asciz	"1,2"	/* 34 */
	opn_lrer:	.asciz	"LRER"	/* 35 */
	opa_lrer:	.asciz	"1,2"	/* 35 */
	opn_axr:	.asciz	"AXR"	/* 36 */
	opa_axr:	.asciz	"1,2"	/* 36 */
	opn_sxr:	.asciz	"SXR"	/* 37 */
	opa_sxr:	.asciz	"1,2"	/* 37 */
	opn_ler:	.asciz	"LER"	/* 38 */
	opa_ler:	.asciz	"1,2"	/* 38 */
	opn_cer:	.asciz	"CER"	/* 39 */
	opa_cer:	.asciz	"1,2"	/* 39 */
	opn_aer:	.asciz	"AER"	/* 3a */
	opa_aer:	.asciz	"1,2"	/* 3a */
	opn_ser:	.asciz	"SER"	/* 3b */
	opa_ser:	.asciz	"1,2"	/* 3b */
	opn_mer:	.asciz	"MER"	/* 3c */
	opa_mer:	.asciz	"1,2"	/* 3c */
	opn_der:	.asciz	"DER"	/* 3d */
	opa_der:	.asciz	"1,2"	/* 3d */
	opn_aur:	.asciz	"AUR"	/* 3e */
	opa_aur:	.asciz	"1,2"	/* 3e */
	opn_sur:	.asciz	"SUR"	/* 3f */
	opa_sur:	.asciz	"1,2"	/* 3f */

	opn_sth:	.asciz	"STH"	/* 40 */
	opa_sth:	.asciz	"1,a"	/* 40 */
	opn_la:		.asciz	"LA"	/* 41 */
	opa_la:		.asciz	"1,a"	/* 41 */
	opn_stc:	.asciz	"STC"	/* 42 */
	opa_stc:	.asciz	"1,a"	/* 42 */
	opn_ic:		.asciz	"IC"	/* 43 */
	opa_ic:		.asciz	"1,a"	/* 43 */
	opn_ex:		.asciz	"EX"	/* 44 */
	opa_ex:		.asciz	"1,a"	/* 44 */
	opn_bal:	.asciz	"BAL"	/* 45 */
	opa_bal:	.asciz	"1,a"	/* 45 */
	opn_bct:	.asciz	"BCT"	/* 46 */
	opa_bct:	.asciz	"1,a"	/* 46 */
	opn_bc:		.asciz	"BC"	/* 47 */
	opa_bc:		.asciz	"m,a"	/* 47 */
	opn_lh:		.asciz	"LH"	/* 48 */
	opa_lh:		.asciz	"1,a"	/* 48 */
	opn_ch:		.asciz	"CH"	/* 49 */
	opa_ch:		.asciz	"1,a"	/* 49 */
	opn_ah:		.asciz	"AH"	/* 4a */
	opa_ah:		.asciz	"1,a"	/* 4a */
	opn_sh:		.asciz	"SH"	/* 4b */
	opa_sh:		.asciz	"1,a"	/* 4b */
	opn_mh:		.asciz	"MH"	/* 4c */
	opa_mh:		.asciz	"1,a"	/* 4c */
	opn_bas:	.asciz	"BAS"	/* 4d */
	opa_bas:	.asciz	"1,a"	/* 4d */
	opn_cvd:	.asciz	"CVD"	/* 4e */
	opa_cvd:	.asciz	"1,a"	/* 4e */
	opn_cvb:	.asciz	"CVB"	/* 4f */
	opa_cvb:	.asciz	"1,a"	/* 4f */

	opn_st:		.asciz	"ST"	/* 50 */
	opa_st:		.asciz	"1,a"	/* 50 */
	opn_flm:	.asciz	"FLM"	/* 51 */
	opa_flm:	.asciz	"1,a"	/* 51 */
	opn_n:		.asciz	"N"	/* 54 */
	opa_n:		.asciz	"1,a"	/* 54 */
	opn_cl:		.asciz	"CL"	/* 55 */
	opa_cl:		.asciz	"1,a"	/* 55 */
	opn_o:		.asciz	"O"	/* 56 */
	opa_o:		.asciz	"1,a"	/* 56 */
	opn_x:		.asciz	"X"	/* 57 */
	opa_x:		.asciz	"1,a"	/* 57 */
	opn_l:		.asciz	"L"	/* 58 */
	opa_l:		.asciz	"1,a"	/* 58 */
	opn_c:		.asciz	"C"	/* 59 */
	opa_c:		.asciz	"1,a"	/* 59 */
	opn_a:		.asciz	"A"	/* 5a */
	opa_a:		.asciz	"1,a"	/* 5a */
	opn_s:		.asciz	"S"	/* 5b */
	opa_s:		.asciz	"1,a"	/* 5b */
	opn_m:		.asciz	"M"	/* 5c */
	opa_m:		.asciz	"1,a"	/* 5c */
	opn_d:		.asciz	"D"	/* 5d */
	opa_d:		.asciz	"1,a"	/* 5d */
	opn_al:		.asciz	"AL"	/* 5e */
	opa_al:		.asciz	"1,a"	/* 5e */
	opn_sl:		.asciz	"SL"	/* 5f */
	opa_sl:		.asciz	"1,a"	/* 5f */

	opn_std:	.asciz	"STD"	/* 60 */
	opa_std:	.asciz	"1,a"	/* 60 */
	opn_mxd:	.asciz	"MXD"	/* 67 */
	opa_mxd:	.asciz	"1,a"	/* 67 */
	opn_ld:		.asciz	"LD"	/* 68 */
	opa_ld:		.asciz	"1,a"	/* 68 */
	opn_cd:		.asciz	"CD"	/* 69 */
	opa_cd:		.asciz	"1,a"	/* 69 */
	opn_ad:		.asciz	"AD"	/* 6a */
	opa_ad:		.asciz	"1,a"	/* 6a */
	opn_sd:		.asciz	"SD"	/* 6b */
	opa_sd:		.asciz	"1,a"	/* 6b */
	opn_md:		.asciz	"MD"	/* 6c */
	opa_md:		.asciz	"1,a"	/* 6c */
	opn_dd:		.asciz	"DD"	/* 6d */
	opa_dd:		.asciz	"1,a"	/* 6d */
	opn_aw:		.asciz	"AW"	/* 6e */
	opa_aw:		.asciz	"1,a"	/* 6e */
	opn_sw:		.asciz	"SW"	/* 6f */
	opa_sw:		.asciz	"1,a"	/* 6f */

	opn_ste:	.asciz	"STE"	/* 70 */
	opa_ste:	.asciz	"1,a"	/* 70 */
	opn_cei:	.asciz	"CEI"	/* 72 */
	opa_cei:	.asciz	"1,a"	/* 72 */
	opn_cdi:	.asciz	"CDI"	/* 73 */
	opa_cdi:	.asciz	"1,a"	/* 73 */
	opn_cie:	.asciz	"CIE"	/* 74 */
	opa_cie:	.asciz	"1,a"	/* 74 */
	opn_cid:	.asciz	"CID"	/* 75 */
	opa_cid:	.asciz	"1,a"	/* 75 */
	opn_le:		.asciz	"LE"	/* 78 */
	opa_le:		.asciz	"1,a"	/* 78 */
	opn_ce:		.asciz	"CE"	/* 79 */
	opa_ce:		.asciz	"1,a"	/* 79 */
	opn_ae:		.asciz	"AE"	/* 7a */
	opa_ae:		.asciz	"1,a"	/* 7a */
	opn_se:		.asciz	"SE"	/* 7b */
	opa_se:		.asciz	"1,a"	/* 7b */
	opn_me:		.asciz	"ME"	/* 7c */
	opa_me:		.asciz	"1,a"	/* 7c */
	opn_de:		.asciz	"DE"	/* 7d */
	opa_de:		.asciz	"1,a"	/* 7d */
	opn_au:		.asciz	"AU"	/* 7e */
	opa_au:		.asciz	"1,a"	/* 7e */
	opn_su:		.asciz	"SU"	/* 7f */
	opa_su:		.asciz	"1,a"	/* 7f */

	opn_ssm:	.asciz	"SSM"	/* 80 */
	opa_ssm:	.asciz	"b"	/* 80 */
	opn_lpsw:	.asciz	"LPSW"	/* 82 */
	opa_lpsw:	.asciz	"b"	/* 82 */
	opn_diag:	.asciz	"DIAG"	/* 83 */
	opa_diag:	.asciz	"x"	/* 83 */
	opn_bxh:	.asciz	"BXH"	/* 86 */
	opa_bxh:	.asciz	"1,2,b" /* 86 */
	opn_bxle:	.asciz	"BXLE"	/* 87 */
	opa_bxle:	.asciz	"1,2,b" /* 87 */
	opn_srl:	.asciz	"SRL"	/* 88 */
	opa_srl:	.asciz	"1,b"	/* 88 */
	opn_sll:	.asciz	"SLL"	/* 89 */
	opa_sll:	.asciz	"1,b"	/* 89 */
	opn_sra:	.asciz	"SRA"	/* 8a */
	opa_sra:	.asciz	"1,b"	/* 8a */
	opn_sla:	.asciz	"SLA"	/* 8b */
	opa_sla:	.asciz	"1,b"	/* 8b */
	opn_srdl:	.asciz	"SRDL"	/* 8c */
	opa_srdl:	.asciz	"1,b"	/* 8c */
	opn_sldl:	.asciz	"SLDL"	/* 8d */
	opa_sldl:	.asciz	"1,b"	/* 8d */
	opn_srda:	.asciz	"SRDA"	/* 8e */
	opa_srda:	.asciz	"1,b"	/* 8e */
	opn_slda:	.asciz	"SLDA"	/* 8f */
	opa_slda:	.asciz	"1,b"	/* 8f */

	opn_stm:	.asciz	"STM"	/* 90 */
	opa_stm:	.asciz	"1,2,b" /* 90 */
	opn_tm:		.asciz	"TM"	/* 91 */
	opa_tm:		.asciz	"b,i"	/* 91 */
	opn_mvi:	.asciz	"MVI"	/* 92 */
	opa_mvi:	.asciz	"b,i"	/* 92 */
	opn_ts:		.asciz	"TS"	/* 93 */
	opa_ts:		.asciz	"b"	/* 93 */
	opn_ni:		.asciz	"NI"	/* 94 */
	opa_ni:		.asciz	"b,i"	/* 94 */
	opn_cli:	.asciz	"CLI"	/* 95 */
	opa_cli:	.asciz	"b,i"	/* 95 */
	opn_oi:		.asciz	"OI"	/* 96 */
	opa_oi:		.asciz	"b,i"	/* 96 */
	opn_xi:		.asciz	"XI"	/* 97 */
	opa_xi:		.asciz	"b,i"	/* 97 */
	opn_lm:		.asciz	"LM"	/* 98 */
	opa_lm:		.asciz	"1,2,b" /* 98 */
	opn_9cxx:	.asciz	"9CXX"	/* 9cxx */
	opa_9cxx:	.asciz	"b"	/* 9cxx */
	opn_9dxx:	.asciz	"9DXX"	/* 9dxx */
	opa_9dxx:	.asciz	"b"	/* 9dxx */
	opn_9exx:	.asciz	"9EXX"	/* 9exx */
	opa_9exx:	.asciz	"b"	/* 9exx */
	opn_9fxx:	.asciz	"9FXX"	/* 9fxx */
	opa_9fxx:	.asciz	"b"	/* 9fxx */

	opn_ai:		.asciz	"AI"	/* a1 */
	opa_ai:		.asciz	"b,i"	/* a1 */
	opn_stext:	.asciz	"STEXT"	/* a2 */
	opa_stext:	.asciz	"1,2,b" /* a2 */
	opn_svg:	.asciz	"SVG"	/* a3 */
	opa_svg:	.asciz	"1,2,b" /* a3 */
	opn_stnsm:	.asciz	"STNSM" /* ac */
	opa_stnsm:	.asciz	"b,i"	/* ac */
	opn_stosm:	.asciz	"STOSM" /* ad */
	opa_stosm:	.asciz	"b,i"	/* ad */
	opn_sigp:	.asciz	"SIGP"	/* ae */
	opa_sigp:	.asciz	"1,2,b" /* ae */
	opn_mc:		.asciz	"MC"	/* af */
	opa_mc:		.asciz	"b,i"	/* af */

	opn_lra:	.asciz	"LRA"	/* b1 */
	opa_lra:	.asciz	"1,a"	/* b1 */
	opn_b2xx:	.asciz	"B2XX"	/* b2xx */
	opa_b2xx:	.asciz	"b"	/* b2xx */
	opn_ipm:	.asciz	"IPM"	/* b222 */
	opa_ipm:	.asciz	"3"	/* b222 */
	opn_dxr:	.asciz	"DXR"	/* b22d */
	opa_dxr:	.asciz	"3,4"	/* b22d */
	opn_stctl:	.asciz	"STCTL" /* b6 */
	opa_stctl:	.asciz	"1,2,b" /* b6 */
	opn_lctl:	.asciz	"LCTL"	/* b7 */
	opa_lctl:	.asciz	"1,2,b" /* b7 */
	opn_cs:		.asciz	"CS"	/* ba */
	opa_cs:		.asciz	"1,2,b" /* ba */
	opn_cds:	.asciz	"CDS"	/* bb */
	opa_cds:	.asciz	"1,2,b" /* bb */
	opn_bcxx:	.asciz	"BCXX"	/* bcxx */
	opa_bcxx:	.asciz	"b"	/* bcxx */
	opn_clm:	.asciz	"CLM"	/* bd */
	opa_clm:	.asciz	"1,n,b" /* bd */
	opn_stcm:	.asciz	"STCM"	/* be */
	opa_stcm:	.asciz	"1,n,b" /* be */
	opn_icm:	.asciz	"ICM"	/* bf */
	opa_icm:	.asciz	"1,n,b" /* bf */

	opn_mvn:	.asciz	"MVN"	/* d1 */
	opa_mvn:	.asciz	"c,d"	/* d1 */
	opn_mvc:	.asciz	"MVC"	/* d2 */
	opa_mvc:	.asciz	"c,d"	/* d2 */
	opn_mvz:	.asciz	"MVZ"	/* d3 */
	opa_mvz:	.asciz	"c,d"	/* d3 */
	opn_nc:		.asciz	"NC"	/* d4 */
	opa_nc:		.asciz	"c,d"	/* d4 */
	opn_clc:	.asciz	"CLC"	/* d5 */
	opa_clc:	.asciz	"c,d"	/* d5 */
	opn_oc:		.asciz	"OC"	/* d6 */
	opa_oc:		.asciz	"c,d"	/* d6 */
	opn_xc:		.asciz	"XC"	/* d7 */
	opa_xc:		.asciz	"c,d"	/* d7 */
	opn_tr:		.asciz	"TR"	/* dc */
	opa_tr:		.asciz	"c,d"	/* dc */
	opn_trt:	.asciz	"TRT"	/* dd */
	opa_trt:	.asciz	"c,d"	/* dd */
	opn_ed:		.asciz	"ED"	/* de */
	opa_ed:		.asciz	"c,d"	/* de */
	opn_edmk:	.asciz	"EDMK"	/* df */
	opa_edmk:	.asciz	"c,d"	/* df */

	opn_e5xx:	.asciz	"E5XX"	/* e5 */
	opa_e5xx:	.asciz	"b,d"	/* e5 */
	opn_mvcin:	.asciz	"MVCIN" /* e8 */
	opa_mvcin:	.asciz	"c,d"	/* e8 */

	opn_srp:	.asciz	"SRP"	/* f0 */
	opa_srp:	.asciz	"f,d,j" /* f0 */
	opn_mvo:	.asciz	"MVO"	/* f1 */
	opa_mvo:	.asciz	"f,g"	/* f1 */
	opn_pack:	.asciz	"PACK"	/* f2 */
	opa_pack:	.asciz	"f,g"	/* f2 */
	opn_unpk:	.asciz	"UNPK"	/* f3 */
	opa_unpk:	.asciz	"f,g"	/* f3 */
	opn_zap:	.asciz	"ZAP"	/* f8 */
	opa_zap:	.asciz	"f,g"	/* f8 */
	opn_cp:		.asciz	"CP"	/* f9 */
	opa_cp:		.asciz	"f,g"	/* f9 */
	opn_ap:		.asciz	"AP"	/* fa */
	opa_ap:		.asciz	"f,g"	/* fa */
	opn_sp:		.asciz	"SP"	/* fb */
	opa_sp:		.asciz	"f,g"	/* fb */
	opn_mp:		.asciz	"MP"	/* fc */
	opa_mp:		.asciz	"f,g"	/* fc */
	opn_dp:		.asciz	"DP"	/* fd */
	opa_dp:		.asciz	"f,g"	/* fd */

!
! <M opcd counter>
!
	.section ".data"
	.align	8
	.global pa_sinsn
	.global pa_pinsn
pa_sinsn:
	.space	1024
pa_pinsn:
	.space	1024

!
! <M branch history>
!
	.section ".data"
	.align	1024
	.global br_hist_top
br_hist_top:
	.space	1024

/**/
