
/* dim4.s 1997/05/01 */

/* M-on-RISC DAT equipped Instruction Simulator            */
/* All Rights Reserved, Copyright (C) Fujitsu Limited 1997 */
/*   Licensed Material Program Property of Fujitsu Limited */
/*		               Primary writer: Y.Nakashima */
/*	                         nakashim@cs.fujitsu.co.jp */

	.file	"dim4.s"
	.section ".data"
	.align	16
	.global dim_RcsId
dim_RcsId:
	.asciz	"$Id: dim4.s,v 1.1 1998/07/01 01:46:00 nakashim Exp nakashim $"

!
! DAT equipped Instruction Simulator Subsystem Entry Point
!   dim() returns 0 if normal end.
!
	.section ".text"
	.align	16
	.global dim
	.global dim_info
	.global dim_prog
dim:
!
! prolog
!   %i0: struct gcpu_s*
!
	ba,a	%icc,dim_prog	! skip dim_info
	nop			!
dim_info:
	.word	0x00000004	! %g reg-format version
	.word	optable		! ->optable
	.word	optb2xx		! ->optb2xx
	.word	pa_sinsn	! ->pa_sinsn
	.word	pa_pinsn	! ->pa_pinsn
	.word	br_hist_top	! ->br_hist_top
dim_prog:
	save	%sp,-208,%sp	! 12 + 92
	st	%i0,[%sp+184]	! struct gcpu_s* (dim frame structure)
	st	%i7,[%sp+200]	! return addr.
	ldx	[%i0+648],%g1	! *(temporary)	-> M-CC
	ldx	[%i0+656],%g2	! *(global var.)-> IAR
	ldx	[%i0+664],%g3	! *(global var.)-> A-MASK(24/31)
	ldx	[%i0+672],%g4	! *(global var.)-> IF0-TLB
	ldx	[%i0+680],%g5	! *(global var.)-> LD0-TLB
	ldx	[%i0+688],%g6	! *(reserved)	-> ST0-TLB
			! %g7	! *(reserved)	-> intr.flags.(loaded by main)
	ba,a	%icc,trans_interp
	nop			!
!================================

!
! break1 (for BRANCH TAKEN PER)
!
break1:
	andncc	%g7,0xfff,%g0	! if interruption then
	bnz,pn	%icc,epilog1	!   return

!
! break0 (step EXEC | intr.)
!
break0:
	andncc	%g7,0xfff,%g0	! if interruption then
	bnz,pn	%icc,epilog0	!   return

!
! Interpretive Execution Entry (NON EXECUTE)
!
trans_interp:
	and	%g2,%g3,%g2	! mask address
	stx	%g2,[%i0+656]	! IAR
	ld	[%i0+748],%i1	! PA_MSTEP
	add	%i1,1,%i1	! PA_MSTEP
	st	%i1,[%i0+748]	! PA_MSTEP
	or	%g7,0x80,%g7	! --- M I-fetch start ---

	andn	%g2,0xfff,%o1	! IF0-GS-TLB
	subcc	%g4,%o1,%g0	!
	be,a,pt	%icc,.+16	!
	srlx	%g4,32,%o0	!
	call	if1_gs_tlb	! %o0:DS-LA
	mov	%i0,%o0		!
	and	%g2,0xfff,%o1	!

	lduh	[%o0+%o1],%i1	! load gmem[IAR]
	srl	%i1,8,%i2	!
	sll	%i2,5,%i2	!
	sethi	%hi(optable),%o7! 1024 aligned
	ldd	[%o7+%i2],%i4	! load optable[opcd].mlen,ifunc

	subcc	%i4,2,%g0	!
	bne,pt	%icc,trans_iskip2
	sll	%i1,16,%i3	! store in upper half of %i3
	jmpl	%i5,%g0		! jmp to ifunc()
	andn	%g7,0xc0,%g7	! --- M I-fetch end,flag=NON EXECUTE

trans_iskip2:
	add	%g2,2,%l2	!
	and	%l2,%g3,%l2	! mask address
	andn	%l2,0xfff,%o1	! IF0-GS-TLB
	subcc	%g4,%o1,%g0	!
	be,a,pt	%icc,.+16	!
	srlx	%g4,32,%o0	!
	call	if1_gs_tlb	! %o0:DS-LA
	mov	%i0,%o0		!
	and	%l2,0xfff,%o1	!

	lduh	[%o0+%o1],%i1	! load gmem[IAR+2]
	subcc	%i4,4,%g0	!
	bne,pn	%icc,trans_iskip4
	or	%i3,%i1,%i3	! store in %i3
	jmpl	%i5,%g0		! jmp to ifunc()
	andn	%g7,0xc0,%g7	! --- M I-fetch end,flag=NON EXECUTE

trans_iskip4:
	add	%g2,4,%l2	!
	and	%l2,%g3,%l2	! mask address
	andn	%l2,0xfff,%o1	! IF0-GS-TLB
	subcc	%g4,%o1,%g0	!
	be,a,pt	%icc,.+16	!
	srlx	%g4,32,%o0	!
	call	if1_gs_tlb	! %o0:DS-LA
	mov	%i0,%o0		!
	and	%l2,0xfff,%o1	!

	lduh	[%o0+%o1],%i1	! 6 byte instruction
	sll	%i1,16,%i4	! store in upper half of %i4
	jmpl	%i5,%g0		! jmp to ifunc()
	andn	%g7,0xc0,%g7	! --- M I-fetch end,flag=NON EXECUTE
!================================

!
! common specification exception entries
!
spec_exception:
	sethi	%hi(0x00060000),%o7
	ba	%icc,epilog0	!
	or	%g7,%o7,%g7	! specification exception
!================================

!
! eplilog1 (for BRANCH TAKEN PER)
!   %i2: OPC
!
epilog1:
	sethi	%hi(0x02000000),%o7
	andcc	%g7,%o7,%g0	! if BH=1 then
	bz,pt	%icc,ep1nobh	!
	nop			!
	ld	[%i0+764],%i1	! get br_hist_cp
	st	%i2,[%i1+0]	! store OLD PC
	st	%g2,[%i1+4]	! store NEW PC
	andn	%i1,1023,%i2	! cyclic by 1024
	add	%i1,8,%i1	!
	and	%i1,1023,%i1	!
	or	%i2,%i1,%i1	!
	st	%i1,[%i0+764]	! update br_hist_cp
	andn	%g7,0xfff,%i1	! if only BH=1 then
	sethi	%hi(0x02000000),%o7
	subcc	%i1,%o7,%g0	!
	be,pt	%icc,trans_interp
ep1nobh:
	sethi	%hi(0x04000000),%o7
	andcc	%g7,%o7,%g0	! if PER=0 then
	bz,pt	%icc,epilog0	!   do nothing (maybe intr.)
	sethi	%hi(0x00800000),%o7
	or	%g7,%o7,%g7	! PER intr.

!
! eplilog0 (step EXEC | intr.)
!
epilog0:
	andn	%g7,0xfff,%i1	! if only BH=1 then
	sethi	%hi(0x02000000),%o7
	subcc	%i1,%o7,%g0	!
	be,pn	%icc,trans_interp
	and	%g2,%g3,%g2	! mask address (redundant)
	stx	%g1,[%i0+648]	! M-CC
	stx	%g2,[%i0+656]	! IAR
	stx	%g3,[%i0+664]	! A-MASK(24/31)
	stx	%g4,[%i0+672]	! IF0-TLB
	stx	%g5,[%i0+680]	! LD0-TLB
	stx	%g6,[%i0+688]	! ST0-TLB
	ld	[%sp+200],%i7	! return addr.
	mov	0,%i0		!
	ret			!
	restore			!
!================================

!
! IF1-GS-TLB
!   %i0: struct gcpu_s*
!   %i1: gs_logical(0..19)
!
	.section ".text"
	.align	16
	.global if1_gs_tlb
if1_gs_tlb:	
	save	%sp,-208,%sp	! 12 + 92
	ldd	[%i0+904],%l0	! %l0:sta_key,%l1:acc_mask
	srl	%i1,12,%l7	! TLB index
	and	%l7,0x3ff,%l7	!
	sll	%l7,5,%l7	!
	add	%i0,%l7,%l7	!
	ldd	[%l7+1024],%l2	! get TLB[index]

	srl	%i1,22,%l4	! GS-LA
	or	%l0,%l4,%l0	! sta_key
	xor	%l0,%l2,%l0	! L1-GS-TLB tag
	and	%l0,%l3,%l0	! L1-GS-TLB mask
	andcc	%l0,%l1,%g0	! acc_mask
	bz,a,pt	%icc,if1_gs_tlb_found
	ld	[%l7+1032],%o0	!
	stx	%g1,[%i0+648]	!
	stx	%g2,[%i0+656]	!
	stx	%g3,[%i0+664]	!
	stx	%g4,[%i0+672]	!
	stx	%g5,[%i0+680]	!
	stx	%g6,[%i0+688]	!
	mov	%i0,%o0		!
	mov	%i1,%o1		!
	call	GCPU_gsdat	!
	mov	0x301,%o2	! flag=IF
	ldx	[%i0+648],%g1	!
	ldx	[%i0+656],%g2	!
	ldx	[%i0+664],%g3	!
	ldx	[%i0+672],%g4	!
	ldx	[%i0+680],%g5	!
	ldx	[%i0+688],%g6	!

if1_gs_tlb_found:
	sllx	%o0,32,%g4	! L0-GS-TLB
	or	%g4,%i1,%g4	!
	mov	%o0,%i0		!
	ret			!
	restore			!
!================================

!
! LD1-GS-TLB
!   %i0: struct gcpu_s*
!   %i1: gs_logical(0..19)
!
	.section ".text"
	.align	16
	.global ld1_gs_tlb
ld1_gs_tlb:	
	save	%sp,-208,%sp	! 12 + 92
	ldd	[%i0+904],%l0	! %l0:sta_key,%l1:acc_mask
	srl	%i1,12,%l7	! TLB index
	and	%l7,0x3ff,%l7	!
	sll	%l7,5,%l7	!
	add	%i0,%l7,%l7	!
	ldd	[%l7+1040],%l2	! get TLB[index]

	srl	%i1,22,%l4	! GS-LA
	or	%l0,%l4,%l0	! sta_key
	xor	%l0,%l2,%l0	! L1-GS-TLB tag
	and	%l0,%l3,%l0	! L1-GS-TLB mask
	andcc	%l0,%l1,%g0	! acc_mask
	bz,a,pt	%icc,ld1_gs_tlb_found
	ld	[%l7+1036],%o0	!
	stx	%g1,[%i0+648]	!
	stx	%g2,[%i0+656]	!
	stx	%g3,[%i0+664]	!
	stx	%g4,[%i0+672]	!
	stx	%g5,[%i0+680]	!
	stx	%g6,[%i0+688]	!
	mov	%i0,%o0		!
	mov	%i1,%o1		!
	call	GCPU_gsdat	!
	mov	0x300,%o2	! flag=LD
	ldx	[%i0+648],%g1	!
	ldx	[%i0+656],%g2	!
	ldx	[%i0+664],%g3	!
	ldx	[%i0+672],%g4	!
	ldx	[%i0+680],%g5	!
	ldx	[%i0+688],%g6	!

ld1_gs_tlb_found:
	sllx	%o0,32,%g5	! L0-GS-TLB
	or	%g5,%i1,%g5	!
	mov	%o0,%i0		!
	ret			!
	restore			!
!================================

!
! ST1-GS-TLB
!   %i0: struct gcpu_s*
!   %i1: gs_logical(0..19)
!
	.section ".text"
	.align	16
	.global st1_gs_tlb
st1_gs_tlb:	
	save	%sp,-208,%sp	! 12 + 92
	ldd	[%i0+904],%l0	! %l0:sta_key,%l1:acc_mask
	srl	%i1,12,%l7	! TLB index
	and	%l7,0x3ff,%l7	!
	sll	%l7,5,%l7	!
	add	%i0,%l7,%l7	!
	ldd	[%l7+1048],%l2	! get TLB[index]

	srl	%i1,22,%l4	! GS-LA
	or	%l0,%l4,%l0	! sta_key
	xor	%l0,%l2,%l0	! L1-GS-TLB tag
	and	%l0,%l3,%l0	! L1-GS-TLB mask
	andcc	%l0,%l1,%g0	! acc_mask
	bz,a,pt	%icc,st1_gs_tlb_found
	ld	[%l7+1036],%o0	!
	stx	%g1,[%i0+648]	!
	stx	%g2,[%i0+656]	!
	stx	%g3,[%i0+664]	!
	stx	%g4,[%i0+672]	!
	stx	%g5,[%i0+680]	!
	stx	%g6,[%i0+688]	!
	mov	%i0,%o0		!
	mov	%i1,%o1		!
	call	GCPU_gsdat	!
	mov	0x700,%o2	! flag=ST
	ldx	[%i0+648],%g1	!
	ldx	[%i0+656],%g2	!
	ldx	[%i0+664],%g3	!
	ldx	[%i0+672],%g4	!
	ldx	[%i0+680],%g5	!
	ldx	[%i0+688],%g6	!

st1_gs_tlb_found:
	sllx	%o0,32,%g6	! L0-GS-TLB
	or	%g6,%i1,%g6	!
	mov	%o0,%i0		!
	ret			!
	restore			!
!================================

!
! templates
!   %i0: struct gcpu_s*
!   %i3: M instruction (upper 4 bytes)
!   %i4: M instruction (lower 2 bytes)
!
	.section ".text"
	.align	4
	.global ii2_OPX2
ii2_OPX2:
i.OPX20s:
		st	%i3,[%i0+704]	! store minsn (upper)
		st	%g0,[%i0+708]	! store minsn (lower)
		sethi	%hi(0x80000000),%o7
		ba	%icc,epilog0	!
		or	%g7,%o7,%g7	! Special Instruction (FC=2)
i.OPX20e:

	.section ".text"
	.align	4
	.global ii4_OPX4
ii4_OPX4:
i.OPX40s:
		st	%i3,[%i0+704]	! store minsn (upper)
		st	%g0,[%i0+708]	! store minsn (lower)
		sethi	%hi(0x80000000),%o7
		ba	%icc,epilog0	!
		or	%g7,%o7,%g7	! Special Instruction (FC=2)
i.OPX40e:

	.section ".text"
	.align	4
	.global ii6_OPX6
ii6_OPX6:
i.OPX60s:
		st	%i3,[%i0+704]	! store minsn (upper)
		st	%i4,[%i0+708]	! store minsn (lower)
		sethi	%hi(0x80000000),%o7
		ba	%icc,epilog0	!
		or	%g7,%o7,%g7	! Special Instruction (FC=2)
i.OPX60e:
!================================

!
! templates
!   %i0: struct gcpu_s*
!   %i3: M instruction (upper 2 bytes)
!
	.section ".text"
	.align	4
	.global ii2_spm
ii2_spm:
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l0		! %l0
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	add	%g0,2,%l7		!
	movnz	%icc,4,%l7		! if EX=1 then IAR+=4
i.spm0s:
		srl	%l0,24,%l0	! extract prog-mask
		and	%l0,0xf,%l1	!
		andn	%g7,0xf,%g7	!
		or	%g7,%l1,%g7	! set prog-mask
		srl	%l0,4,%l0	! extract CC
		and	%l0,3,%g1	! set CC
		ba	%icc,break0	!
		add	%g2,%l7,%g2	! ##TEMPLATE:IAR
i.spm0e:

	.section ".text"
	.align	4
	.global ii2_balr
ii2_balr:
	srl	%i3,16,%i5		! switch (R2)
	andcc	%i5,0xf,%g0		!
	bnz	%icc,i.balr1t		!
	nop				!
    i.balr0t:				!
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i1		! save as %i1
	andcc	%g7,0x40,%g0		! if EX=0 then ILC=2
	add	%g0,4,%l6		!
	movnz	%icc,8,%l6		! if EX=1 then ILC=4
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	add	%g0,2,%l7		!
	movnz	%icc,4,%l7		! if EX=1 then IAR+=4
i.balr0s:
		add	%g2,%l7,%g2	! ##TEMPLATE:IAR
		andcc	%g7,0x10,%g0	! if 31bit address then
		bnz,a,pt %icc,i.balr000	!
		orn	%g2,%g3,%l0	! ##TEMPLATE:%l0
		and	%g2,%g3,%l0	! if 24bit address then
		or	%g1,%l6,%l1	! ##TEMPLATE:ILC|CC
		sll	%l1,28,%l1	!
		or	%l1,%l0,%l0	!
		and	%g7,0xf,%l1	!   Prog-Mask
		sll	%l1,24,%l1	!
		or	%l1,%l0,%l0	! ##TEMPLATE:%l0
    i.balr000:	ba	%icc,break0	!
		st	%l0,[%i0+%i1]	! R1
i.balr0e:
    i.balr1t:				!
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i1		! save as %i1
	srl	%i3,16,%i5		! R2
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l2		! %l2
	andcc	%g7,0x40,%g0		! if EX=0 then ILC=2
	add	%g0,4,%l6		!
	movnz	%icc,8,%l6		! if EX=1 then ILC=4
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	add	%g0,2,%l7		!
	movnz	%icc,4,%l7		! if EX=1 then IAR+=4
i.balr1s:
		add	%g2,%g0,%i2	! save OPC
		add	%g2,%l7,%g2	! ##TEMPLATE:IAR
		andcc	%g7,0x10,%g0	! if 31bit address then
		bnz,a,pt %icc,i.balr100	!
		orn	%g2,%g3,%l0	! ##TEMPLATE:%l0
		and	%g2,%g3,%l0	! if 24bit address then
		or	%g1,%l6,%l1	! ##TEMPLATE:ILC|CC
		sll	%l1,28,%l1	!
		or	%l1,%l0,%l0	!
		and	%g7,0xf,%l1	!   Prog-Mask
		sll	%l1,24,%l1	!
		or	%l1,%l0,%l0	! ##TEMPLATE:%l0
    i.balr100:	st	%l0,[%i0+%i1]	! R1
		ba	%icc,break1	! BRANCH TAKEN
		add	%g0,%l2,%g2	!
i.balr1e:

	.section ".text"
	.align	4
	.global ii2_bctr
ii2_bctr:
	srl	%i3,16,%i5		! switch (R2)
	andcc	%i5,0xf,%g0		!
	bnz	%icc,i.bctr1t		!
	nop				!
    i.bctr0t:				!
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i1		! save as %i1
	ld	[%i0+%i1],%l0		! %l0
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	add	%g0,2,%l7		!
	movnz	%icc,4,%l7		! if EX=1 then IAR+=4
i.bctr0s:
		sub	%l0,1,%l0	! ##TEMPLATE:%l0,%l0
		st	%l0,[%i0+%i1]	! R1
		ba	%icc,break0	!
		add	%g2,%l7,%g2	! ##TEMPLATE:IAR
i.bctr0e:
    i.bctr1t:				!
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i1		! save as %i1
	ld	[%i0+%i1],%l0		! %l0
	srl	%i3,16,%i5		! R2
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l2		! %l2
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	add	%g0,2,%l7		!
	movnz	%icc,4,%l7		! if EX=1 then IAR+=4
i.bctr1s:
		subcc	%l0,1,%l0	! ##TEMPLATE:%l0,%l0
		st	%l0,[%i0+%i1]	! R1
		bz,a,pn	%icc,break0	! if %l0 != 0 then taken
		add	%g2,%l7,%g2	! ##TEMPLATE:IAR
		add	%g2,%g0,%i2	! save OPC
		ba	%icc,break1	! BRANCH TAKEN
		add	%g0,%l2,%g2	!
i.bctr1e:

	.section ".text"
	.align	4
	.global ii2_bcr
ii2_bcr:
	srl	%i3,16,%i5		! switch (R2)
	andcc	%i5,0xf,%g0		!
	bz	%icc,i.bcr0t		!
	srl	%i3,20,%i5		! switch (M1)
	andcc	%i5,0xf,%i5		!
	bz	%icc,i.bcr0t		!
	subcc	%i5,0xf,%g0		!
	bne	%icc,i.bcr2t		!
	nop				!
    i.bcr3t:
	srl	%i3,16,%i5		! R2
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l2		! %l2
i.bcr3s:
		add	%g2,%g0,%i2	! save OPC
		ba	%icc,break1	!
		add	%g0,%l2,%g2	! ##TEMPLATE:%l0
i.bcr3e:
    i.bcr0t:				!
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	add	%g0,2,%l7		!
	movnz	%icc,4,%l7		! if EX=1 then IAR+=4
i.bcr0s:
		ba	%icc,break0	!
		add	%g2,%l7,%g2	! ##TEMPLATE:IAR
i.bcr0e:
    i.bcr2t:				!
	srl	%i3,20,%i5		! M1
	and	%i5,0xf,%i5		! |
	sll	%i5,8,%l0		! %l0
	srl	%i3,16,%i5		! R2
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l2		! %l2
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	add	%g0,2,%l7		!
	movnz	%icc,4,%l7		! if EX=1 then IAR+=4
i.bcr2s:
		srl	%g7,%g1,%l1	! consi.0b0001000XXXXXXXX >> %l1
		andcc	%l1,%l0,%g0	! ##TEMPLATE:imm0
		bz,a	%icc,break0	! if CC is true then taken
		add	%g2,%l7,%g2	! ##TEMPLATE:IAR
		add	%g2,%g0,%i2	! save OPC
		ba	%icc,break1	! BRANCH TAKEN
		add	%g0,%l2,%g2	! ##TEMPLATE:%l0
i.bcr2e:

	.section ".text"
	.align	4
	.global ic2_ssk
ic2_ssk:
i.ssk0s:
		st	%i3,[%i0+704]	! store minsn (upper)
		st	%g0,[%i0+708]	! store minsn (lower)
		sethi	%hi(0x80000000),%o7
		ba	%icc,epilog0	!
		or	%g7,%o7,%g7	! Special Instruction (FC=2)
i.ssk0e:

	.section ".text"
	.align	4
	.global ic2_isk
ic2_isk:
i.isk0s:
		st	%i3,[%i0+704]	! store minsn (upper)
		st	%g0,[%i0+708]	! store minsn (lower)
		sethi	%hi(0x80000000),%o7
		ba	%icc,epilog0	!
		or	%g7,%o7,%g7	! Special Instruction (FC=2)
i.isk0e:

	.section ".text"
	.align	4
	.global ii2_svc
ii2_svc:
i.svc0s:
		st	%i3,[%i0+704]	! store minsn (upper)
		st	%g0,[%i0+708]	! store minsn (lower)
		sethi	%hi(0x80000000),%o7
		ba	%icc,epilog0	!
		or	%g7,%o7,%g7	! Special Instruction (FC=2)
i.svc0e:

	.section ".text"
	.align	4
	.global	ii2_bsm
ii2_bsm:
	srl	%i3,16,%i5		! switch (R2)
	andcc	%i5,0xf,%g0		!
	bnz	%icc,i.bsm1t		!
	nop				!
    i.bsm0t:				!
	srl	%i3,20,%i5		! R1
	andcc	%i5,0xf,%i5		! |
	sll	%i5,2,%i1		! save as %i1
	bz,a	%icc,.+12		! |
	add	%g0,%g0,%l0		! |
	ld	[%i0+%i1],%l0		! %l0
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	add	%g0,2,%l7		!
	movnz	%icc,4,%l7		! if EX=1 then IAR+=4
i.bsm0s:
		and	%g7,0x10,%l1	! extract AM-bit
		sll	%l1,27,%l1	!
		sethi	%hi(0x80000000),%o7
		andn	%l0,%o7,%l3	! ##TEMPLATE:%l0
		or	%l1,%l3,%l0	! ##TEMPLATE:%l0
		subcc	%i1,0,%g0	! if R1=0
		bnz,a	%icc,.+8	!   don't save R1
		st	%l0,[%i0+%i1]	! R1
		ba	%icc,break0	!
		add	%g2,%l7,%g2	! ##TEMPLATE:IAR
i.bsm0e:
    i.bsm1t:				!
	srl	%i3,20,%i5		! R1
	andcc	%i5,0xf,%i5		! |
	sll	%i5,2,%i1		! save as %i1
	bz,a	%icc,.+12		! |
	add	%g0,%g0,%l0		! |
	ld	[%i0+%i1],%l0		! %l0
	srl	%i3,16,%i5		! R2
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l2		! %l2
i.bsm1s:
		add	%g2,%g0,%i2	! save OPC
		and	%g7,0x10,%l1	! extract AM-bit
		sll	%l1,27,%l1	!
		sethi	%hi(0x80000000),%o7
		andcc	%o7,%l2,%g0	! ##TEMPLATE:%l0
		bnz	%icc,i.bsm100	! if AM == 0 then
		sethi	%hi(0x00ffffff),%g3
		or	%g3,%lo(0x00ffffff),%g3
		ba	%icc,i.bsm101	!
		andn	%g7,0x10,%g7	!   reset AM-bit
    i.bsm100:	sethi	%hi(0x7fffffff),%g3
		or	%g3,%lo(0x7fffffff),%g3
		or	%g7,0x10,%g7	! else set AM-bit
    i.bsm101:	andn	%l0,%o7,%l3	! ##TEMPLATE:%l0
		or	%l1,%l3,%l0	! ##TEMPLATE:%l0
		subcc	%i1,0,%g0	! if R1=0
		bnz,a	%icc,.+8	!   don't save R1
		st	%l0,[%i0+%i1]	! R1
		ba	%icc,break1	! BRANCH TAKEN
		add	%g0,%l2,%g2	! ##TEMPLATE:%l0
i.bsm1e:

	.section ".text"
	.align	4
	.global ii2_bassm
ii2_bassm:
	srl	%i3,16,%i5		! switch (R2)
	andcc	%i5,0xf,%g0		!
	bnz	%icc,i.bassm1t		!
	nop				!
    i.bassm0t:				!
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i1		! save as %i1
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	add	%g0,2,%l7		!
	movnz	%icc,4,%l7		! if EX=1 then IAR+=4
i.bassm0s:
		add	%g2,%l7,%g2	! ##TEMPLATE:IAR
		and	%g7,0x10,%l1	! extract AM-bit
		sll	%l1,27,%l1	!
		sethi	%hi(0x80000000),%o7
		andn	%g2,%o7,%l3	!
		or	%l1,%l3,%l0	! ##TEMPLATE:%l0
		ba	%icc,break0	!
		st	%l0,[%i0+%i1]	! R1
i.bassm0e:
    i.bassm1t:				!
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i1		! save as %i1
	srl	%i3,16,%i5		! R2
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l2		! %l2
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	add	%g0,2,%l7		!
	movnz	%icc,4,%l7		! if EX=1 then IAR+=4
i.bassm1s:
		add	%g2,%g0,%i2	! save OPC
		add	%g2,%l7,%g2	! ##TEMPLATE:IAR
		and	%g7,0x10,%l1	! extract AM-bit
		sll	%l1,27,%l1	!
		sethi	%hi(0x80000000),%o7
		andcc	%o7,%l2,%g0	! ##TEMPLATE:%l0
		bnz	%icc,i.bassm100	! if AM == 0 then
		sethi	%hi(0x00ffffff),%g3
		or	%g3,%lo(0x00ffffff),%g3
		ba	%icc,i.bassm101	!
		andn	%g7,0x10,%g7	!   reset AM-bit
    i.bassm100:	sethi	%hi(0x7fffffff),%g3
		or	%g3,%lo(0x7fffffff),%g3
		or	%g7,0x10,%g7	! else set AM-bit
    i.bassm101:	andn	%g2,%o7,%l3	!
		or	%l1,%l3,%l0	! ##TEMPLATE:%l0
		st	%l0,[%i0+%i1]	! R1
		ba	%icc,break1	! BRANCH TAKEN
		add	%g0,%l2,%g2	! ##TEMPLATE:%l0
i.bassm1e:

	.section ".text"
	.align	4
	.global ii2_basr
ii2_basr:
	srl	%i3,16,%i5		! switch (R2)
	andcc	%i5,0xf,%g0		!
	bnz	%icc,i.basr1t		!
	nop				!
    i.basr0t:				!
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i1		! save as %i1
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	add	%g0,2,%l7		!
	movnz	%icc,4,%l7		! if EX=1 then IAR+=4
i.basr0s:
		add	%g2,%l7,%g2	! ##TEMPLATE:IAR
		andcc	%g7,0x10,%g0	! if 31bit address then
		bnz,a,pt %icc,i.basr000	!
		orn	%g2,%g3,%l0	! ##TEMPLATE:%l0
		and	%g2,%g3,%l0	! ##TEMPLATE:%l0
    i.basr000:	ba	%icc,break0	!
		st	%l0,[%i0+%i1]	! R1
i.basr0e:
    i.basr1t:				!
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i1		! save as %i1
	srl	%i3,16,%i5		! R2
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l2		! %l2
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	add	%g0,2,%l7		!
	movnz	%icc,4,%l7		! if EX=1 then IAR+=4
i.basr1s:
		add	%g2,%g0,%i2	! save OPC
		add	%g2,%l7,%g2	! ##TEMPLATE:IAR
		andcc	%g7,0x10,%g0	! if 31bit address then
		bnz,a,pt %icc,i.basr101	!
		orn	%g2,%g3,%l0	! ##TEMPLATE:%l0
		and	%g2,%g3,%l0	! ##TEMPLATE:%l0
    i.basr101:	st	%l0,[%i0+%i1]	! R1
		ba	%icc,break1	! BRANCH TAKEN
		add	%g0,%l2,%g2	!
i.basr1e:

	.section ".text"
	.align	4
	.global ii2_mvcl
ii2_mvcl:
	srl	%i3,20,%i4		! switch (R1,R2)
	srl	%i3,16,%i5		!
	or	%i4,%i5,%i5		!
	andcc	%i5,1,%g0		!
	bnz,pn	%icc,spec_exception	!
	nop				!
    i.mvcl0t:				!
	mov	%i3,%i7			!
	srl	%i7,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i1		! save as %i1
	ld	[%i0+%i1],%l0		! %l0
	srl	%i7,20,%i5		! R1+1
	and	%i5,0xf,%i5		! |
	add	%i5,1,%i5		! |
	sll	%i5,2,%i2		! save as %i2
	ld	[%i0+%i2],%l1		! %l1
	srl	%i7,16,%i5		! R2
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i3		! save as %i3
	ld	[%i0+%i3],%l2		! %l2
	srl	%i7,16,%i5		! R2+1
	and	%i5,0xf,%i5		! |
	add	%i5,1,%i5		! |
	sll	%i5,2,%i4		! save as %i4
	ld	[%i0+%i4],%l3		! %l3
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	add	%g0,2,%l7		!
	movnz	%icc,4,%l7		! if EX=1 then IAR+=4
i.mvcl0s:
		mov	0,%g1		! CC=0 (interruptible)
		srl	%l3,24,%l4	! PADDING
		sll	%l4,8,%l5	!
		or	%l4,%l5,%l4	!
		sll	%l4,16,%l5	!
		or	%l4,%l5,%l4	! create PAD|PAD|PAD|PAD
		sethi	%hi(0xff000000),%o7
		andn	%l1,%o7,%l1	! L1 length
		andn	%l3,%o7,%l3	! L2 length
    i.mvcl0lp:	/* MAIN LOOP */
		and	%l0,%g3,%l0	! R1 address
		and	%l2,%g3,%l2	! R2 address
	! %i0: struct gcpu_s*
	! %i1: #R1
	! %i2: #R1+1
	! %i3: #R2
	! %i4: #R2+1
	! %l0: R1
	! %l1: L1
	! %l2: R2
	! %l3: L2
	! %l4: PAD|PAD|PAD|PAD
		subcc	%l1,0,%g0	!
		bnz	%icc,_mvcl000	! if L1==0 then
		subcc	%l3,0,%g0	!
		ba	%icc,_mvclexit	!   if L1==0 && L2==0 CC=0
		movnz	%icc,1,%g1	!   if L1==0 && L2!=0 CC=1
    _mvcl000:	bnz	%icc,_mvcl010	! if L1!=0 then
		subcc	%l0,%l2,%g0	!
		mov	2,%g1		!   if L1!=0 && L2==0 CC=2

		andncc	%l0,0x1ff,%g0	! check LAP
		bnz,pt	%icc,.+12	!
		andcc	%g7,0x20,%g0	!
		tnz	%icc,0x43	! LAP exception
					!
		andn	%l0,0xfff,%o1	! ST0-GS-TLB
		subcc	%g6,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g6,32,%o0	!
		call	st1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l0,0xfff,%o1	!

		sethi	%hi(0x00001000),%o7
		sub	%o7,%o1,%o4	! Until 4K PAGE Boundary
		subcc	%l1,%o4,%g0	! if L1 >= UPB length = UPB
		movl	%icc,%l1,%o4	! else         length = L1
		sethi	%hi(0x00000800),%o7
		subcc	%o4,%o7,%g0	! length must <= 2K
		movg	%icc,%o7,%o4	!

		/* START COPY (L1 != 0 && L2 == 0) */
	! %o0: store base
	! %o1: store offset
	! %o4: counter
	! %l4: PAD|PAD|PAD|PAD
		add	%l0,%o4,%l0	! update R1
		sub	%l1,%o4,%l1	! update L1
		or	%o1,%o4,%o5	! test align
		andcc	%o5,3,%g0	! if not word aligned then skip
		bnz	%icc,_mvclpd2	!
		nop			!
    _mvclpd1:	st	%l4,[%o0+%o1]	! padding (word aligned)
		subcc	%o4,4,%o4	! update counter
		bnz	%icc,_mvclpd1	!
		add	%o1,4,%o1	! update offset
		ba,a	%icc,_mvclexit	!
		nop			!
    _mvclpd2:	stb	%l4,[%o0+%o1]	! padding (not word aligned)
		subcc	%o4,1,%o4	! update counter
		bnz	%icc,_mvclpd2	!
		add	%o1,1,%o1	! update offset
		ba,a	%icc,_mvclexit	!
		nop			!
		/* STOP COPY (L1 != 0 && L2 == 0) */

    _mvcl010:	bleu	%icc,_mvcl020	! if R1 <= R2 then skip
		add	%l2,%l3,%l5	!
		subcc	%l0,%l5,%g0	!
		bcs,a	%icc,_mvclexit	! if R1 >= R2+L2 then skip
		mov	3,%g1		! else CC=3
    _mvcl020:	subcc	%l1,%l3,%g0	! if L1==L2 CC=0
		movgu	%icc,2,%g1	! if L1> L2 CC=2
		movcs	%icc,1,%g1	! if L1< L2 CC=1

		andn	%l2,0xfff,%o1	! LD0-GS-TLB
		subcc	%g5,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g5,32,%o0	!
		call	ld1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l2,0xfff,%o1	!
		mov	%o0,%l5		! save base
		mov	%o1,%l6		! save offset

		andncc	%l0,0x1ff,%g0	! check LAP
		bnz,pt	%icc,.+12	!
		andcc	%g7,0x20,%g0	!
		tnz	%icc,0x43	! LAP exception
					!
		andn	%l0,0xfff,%o1	! ST0-GS-TLB
		subcc	%g6,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g6,32,%o0	!
		call	st1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l0,0xfff,%o1	!
		mov	%l5,%o2		! restore base
		mov	%l6,%o3		! restore offset

		sethi	%hi(0x00001000),%o7
		sub	%o7,%o1,%o4	! Until 4K PAGE Boundary
		subcc	%l1,%o4,%g0	! if L1 >= UPB length = UPB
		movl	%icc,%l1,%o4	! else         length = L1
		sethi	%hi(0x00000800),%o7
		subcc	%o4,%o7,%g0	! length must <= 2K
		movg	%icc,%o7,%o4	!

		sethi	%hi(0x00001000),%o7
		sub	%o7,%o3,%o5	! Until 4K PAGE Boundary
		subcc	%l3,%o5,%g0	! if L2 >= UPB length = UPB
		movl	%icc,%l3,%o5	! else         length = L2
		sethi	%hi(0x00000800),%o7
		subcc	%o5,%o7,%g0	! length must <= 2K
		movg	%icc,%o7,%o5	!

		subcc	%o4,%o5,%g0	! compare length
		movgu	%icc,%o5,%o4	! select shorter one

		/* START COPY (L1 != 0 && L2 != 0) */
	! %o0: store base
	! %o1: store offset
	! %o2: load base
	! %o3: load offset
	! %o4: counter
	! %l4: PAD|PAD|PAD|PAD
		add	%l0,%o4,%l0	! update R1
		sub	%l1,%o4,%l1	! update L1
		add	%l2,%o4,%l2	! update R2
		sub	%l3,%o4,%l3	! update L2
		or	%o1,%o3,%o5	! test align
		or	%o4,%o5,%o5	! test align
		andcc	%o5,3,%g0	! if not word aligned then skip
		bnz	%icc,_mvclcp2	!
		nop			!
    _mvclcp1:	ld	[%o2+%o3],%l5	! get word (word aligned)
		add	%o3,4,%o3	! update offset
		subcc	%o4,4,%o4	! update counter
		st	%l5,[%o0+%o1]	! store word
		bnz	%icc,_mvclcp1	!
		add	%o1,4,%o1	! update offset
		ba,a	%icc,_mvclexit	!
		nop			!
    _mvclcp2:	ldub	[%o2+%o3],%l5	! get byte (not word aligned)
		add	%o3,1,%o3	! update offset
		subcc	%o4,1,%o4	! update counter
		stb	%l5,[%o0+%o1]	! store byte
		bnz	%icc,_mvclcp2	!
		add	%o1,1,%o1	! update offset
		/* STOP COPY (L1 != 0 && L2 != 0) */

    _mvclexit:	/* BREAK */
		st	%l0,[%i0+%i1]	! R1
		st	%l2,[%i0+%i3]	! R2
		sethi	%hi(0xff000000),%o7
		ld	[%i0+%i2],%l5	!
		and	%l5,%o7,%l5	! ##TEMPLATE:%l0,%l0
		or	%l5,%l1,%l5	! ##TEMPLATE:%l0,%l0
		st	%l5,[%i0+%i2]	! R1+1
		ld	[%i0+%i4],%l5	!
		and	%l5,%o7,%l5	! ##TEMPLATE:%l0,%l0
		or	%l5,%l3,%l5	! ##TEMPLATE:%l0,%l0
		st	%l5,[%i0+%i4]	! R2+1
		subcc	%g1,3,%g0	! if CC=3 then
		bz,a	%icc,break0	!   exit
		add	%g2,%l7,%g2	! ##TEMPLATE:IAR
		subcc	%l1,0,%g0	! if mvcl completed then
		bz,a	%icc,break0	!   exit
		add	%g2,%l7,%g2	! ##TEMPLATE:IAR
		andncc	%g7,0xfff,%g0	! if intermediate intr. then
		bz	%icc,i.mvcl0lp	!   exit
		nop			!
		ba,a	%icc,epilog0	!
		nop			!
i.mvcl0e:

	.section ".text"
	.align	4
	.global ii2_clcl
ii2_clcl:
	srl	%i3,20,%i4		! switch (R1,R2)
	srl	%i3,16,%i5		!
	or	%i4,%i5,%i5		!
	andcc	%i5,1,%g0		!
	bnz,pn	%icc,spec_exception	!
	nop				!
    i.clcl0t:				!
	mov	%i3,%i7			!
	srl	%i7,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i1		! save as %i1
	ld	[%i0+%i1],%l0		! %l0
	srl	%i7,20,%i5		! R1+1
	and	%i5,0xf,%i5		! |
	add	%i5,1,%i5		! |
	sll	%i5,2,%i2		! save as %i2
	ld	[%i0+%i2],%l1		! %l1
	srl	%i7,16,%i5		! R2
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i3		! save as %i3
	ld	[%i0+%i3],%l2		! %l2
	srl	%i7,16,%i5		! R2+1
	and	%i5,0xf,%i5		! |
	add	%i5,1,%i5		! |
	sll	%i5,2,%i4		! save as %i4
	ld	[%i0+%i4],%l3		! %l3
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	add	%g0,2,%l7		!
	movnz	%icc,4,%l7		! if EX=1 then IAR+=4
i.clcl0s:
		mov	0,%g1		! CC=0 (interruptible)
		srl	%l3,24,%l4	! PADDING
		sll	%l4,8,%l5	!
		or	%l4,%l5,%l4	!
		sll	%l4,16,%l5	!
		or	%l4,%l5,%l4	! create PAD|PAD|PAD|PAD
		sethi	%hi(0xff000000),%o7
		andn	%l1,%o7,%l1	! L1 length
		andn	%l3,%o7,%l3	! L2 length
    i.clcl0lp:	/* MAIN LOOP */
		and	%l0,%g3,%l0	! R1 address
		and	%l2,%g3,%l2	! R2 address
	! %i0: struct gcpu_s*
	! %i1: #R1
	! %i2: #R1+1
	! %i3: #R2
	! %i4: #R2+1
	! %l0: R1
	! %l1: L1
	! %l2: R2
	! %l3: L2
	! %l4: PAD|PAD|PAD|PAD
		orcc	%l1,%l3,%g0	!
		bz	%icc,_clclexit	! if L1==0 && L2==0 CC=0
		subcc	%l1,0,%g0	!
    _clcl000:	bnz	%icc,_clcl010	! if L1==0 && L2!=0 then
		subcc	%l3,0,%g0	!

		andn	%l2,0xfff,%o1	! LD0-GS-TLB
		subcc	%g5,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g5,32,%o0	!
		call	ld1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l2,0xfff,%o1	!

		sethi	%hi(0x00001000),%o7
		sub	%o7,%o1,%o4	! Until 4K PAGE Boundary
		subcc	%l3,%o4,%g0	! if L2 >= UPB length = UPB
		movl	%icc,%l3,%o4	! else         length = L2
		sethi	%hi(0x00000800),%o7
		subcc	%o4,%o7,%g0	! length must <= 2K
		movg	%icc,%o7,%o4	!

		/* START COMPARE (L1 == 0 && L2 != 0) */
	! %o0: load base
	! %o1: load offset
	! %o4: counter
	! %l4: PAD|PAD|PAD|PAD
		add	%l2,%o4,%l2	! update R2
		sub	%l3,%o4,%l3	! update L2
		or	%o1,%o4,%o5	! test align
		andcc	%o5,3,%g0	! if not word aligned then skip
		bnz,a	%icc,_clclpd2	!
		and	%l4,0xff,%l5	! create PAD
    _clclpd1:	ld	[%o0+%o1],%l6	!
		subcc	%l4,%l6,%g0	!
		bne,a	%icc,_clclpd2	!
		and	%l4,0xff,%l5	! create PAD
		subcc	%o4,4,%o4	! update counter
		bnz	%icc,_clclpd1	!
		add	%o1,4,%o1	! update offset
		ba,a	%icc,_clclexit	!
		nop			!
    _clclpd2:	ldub	[%o0+%o1],%l6	!
		subcc	%l5,%l6,%g0	!
		bne	%icc,_clcldiff2	!
		nop			!
		subcc	%o4,1,%o4	! update counter
		bnz	%icc,_clclpd2	!
		add	%o1,1,%o1	! update offset
		ba,a	%icc,_clclexit	!
		nop			!
		/* STOP COMPARE (L1 == 0 && L2 != 0) */

    _clcl010:	bnz	%icc,_clcl020	! if L1!=0 && L2==0 then
		nop			!

		andn	%l0,0xfff,%o1	! LD0-GS-TLB
		subcc	%g5,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g5,32,%o0	!
		call	ld1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l0,0xfff,%o1	!

		sethi	%hi(0x00001000),%o7
		sub	%o7,%o1,%o4	! Until 4K PAGE Boundary
		subcc	%l1,%o4,%g0	! if L1 >= UPB length = UPB
		movl	%icc,%l1,%o4	! else         length = L1
		sethi	%hi(0x00000800),%o7
		subcc	%o4,%o7,%g0	! length must <= 2K
		movg	%icc,%o7,%o4	!

		/* START COMPARE (L1 != 0 && L2 == 0) */
	! %o0: load base
	! %o1: load offset
	! %o4: counter
	! %l4: PAD|PAD|PAD|PAD
		add	%l0,%o4,%l0	! update R1
		sub	%l1,%o4,%l1	! update L1
		or	%o1,%o4,%o5	! test align
		andcc	%o5,3,%g0	! if not word aligned then skip
		bnz,a	%icc,_clclpd4	!
		and	%l4,0xff,%l5	! create PAD
    _clclpd3:	ld	[%o0+%o1],%l6	!
		subcc	%l6,%l4,%g0	!
		bne,a	%icc,_clclpd4	!
		and	%l4,0xff,%l5	! create PAD
		subcc	%o4,4,%o4	! update counter
		bnz	%icc,_clclpd3	!
		add	%o1,4,%o1	! update offset
		ba,a	%icc,_clclexit	!
		nop			!
    _clclpd4:	ldub	[%o0+%o1],%l6	!
		subcc	%l6,%l5,%g0	!
		bne	%icc,_clcldiff1	!
		nop			!
		subcc	%o4,1,%o4	! update counter
		bnz	%icc,_clclpd4	!
		add	%o1,1,%o1	! update offset
		ba,a	%icc,_clclexit	!
		nop			!
		/* STOP COMPARE (L1 != 0 && L2 == 0) */

    _clcl020:	andn	%l2,0xfff,%o1	! LD0-GS-TLB
		subcc	%g5,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g5,32,%o0	!
		call	ld1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l2,0xfff,%o1	!
		mov	%o0,%l5		! save base
		mov	%o1,%l6		! save offset

		andn	%l0,0xfff,%o1	! LD0-GS-TLB
		subcc	%g5,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g5,32,%o0	!
		call	ld1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l0,0xfff,%o1	!
		mov	%l5,%o2		! restore base
		mov	%l6,%o3		! restore offset

		sethi	%hi(0x00001000),%o7
		sub	%o7,%o1,%o4	! Until 4K PAGE Boundary
		subcc	%l1,%o4,%g0	! if L1 >= UPB length = UPB
		movl	%icc,%l1,%o4	! else         length = L1
		sethi	%hi(0x00000800),%o7
		subcc	%o4,%o7,%g0	! length must <= 2K
		movg	%icc,%o7,%o4	!

		sethi	%hi(0x00001000),%o7
		sub	%o7,%o3,%o5	! Until 4K PAGE Boundary
		subcc	%l3,%o5,%g0	! if L2 >= UPB length = UPB
		movl	%icc,%l3,%o5	! else         length = L2
		sethi	%hi(0x00000800),%o7
		subcc	%o5,%o7,%g0	! length must <= 2K
		movg	%icc,%o7,%o5	!

		subcc	%o4,%o5,%g0	! compare length
		movgu	%icc,%o5,%o4	! select shorter one

		/* START COMPARE (L1 != 0 && L2 != 0) */
	! %o0: load base
	! %o1: load offset
	! %o2: load base
	! %o3: load offset
	! %o4: counter
	! %l4: PAD|PAD|PAD|PAD
		add	%l0,%o4,%l0	! update R1
		sub	%l1,%o4,%l1	! update L1
		add	%l2,%o4,%l2	! update R2
		sub	%l3,%o4,%l3	! update L2
		or	%o1,%o3,%o5	! test align
		or	%o4,%o5,%o5	! test align
		andcc	%o5,3,%g0	! if not word aligned then skip
		bnz	%icc,_clclcp2	!
		nop			!
    _clclcp1:	ld	[%o0+%o1],%l5	!
		ld	[%o2+%o3],%l6	!
		subcc	%l5,%l6,%g0	!
		bne	%icc,_clclcp2	!
		nop			!
		subcc	%o4,4,%o4	! update counter
		add	%o1,4,%o1	! update offset
		bnz	%icc,_clclcp1	!
		add	%o3,4,%o3	! update offset
		ba,a	%icc,_clclexit	!
		nop			!
    _clclcp2:	ldub	[%o0+%o1],%l5	!
		ldub	[%o2+%o3],%l6	!
		subcc	%l5,%l6,%g0	!
		bne	%icc,_clcldiff3	!
		nop			!
		subcc	%o4,1,%o4	! update counter
		add	%o1,1,%o1	! update offset
		bnz	%icc,_clclcp2	!
		add	%o3,1,%o3	! update offset
		ba,a	%icc,_clclexit	!
		nop			!
		/* STOP COMPARE (L1 != 0 && L2 != 0) */

    _clcldiff1:	sub	%l0,%o4,%l0	! fix R1
		ba	%icc,_clcldiff	!
		add	%l1,%o4,%l1	! fix L1
    _clcldiff3:	sub	%l0,%o4,%l0	! fix R1
		add	%l1,%o4,%l1	! fix L1
    _clcldiff2:	sub	%l2,%o4,%l2	! fix R2
		add	%l3,%o4,%l3	! fix L2
    _clcldiff:	movl	%icc,1,%g1	! CC=1
		movg	%icc,2,%g1	! CC=2

    _clclexit:	/* BREAK */
		st	%l0,[%i0+%i1]	! R1
		st	%l2,[%i0+%i3]	! R2
		sethi	%hi(0xff000000),%o7
		ld	[%i0+%i2],%l5	!
		and	%l5,%o7,%l5	! ##TEMPLATE:%l0,%l0
		or	%l5,%l1,%l5	! ##TEMPLATE:%l0,%l0
		st	%l5,[%i0+%i2]	! R1+1
		ld	[%i0+%i4],%l5	!
		and	%l5,%o7,%l5	! ##TEMPLATE:%l0,%l0
		or	%l5,%l3,%l5	! ##TEMPLATE:%l0,%l0
		st	%l5,[%i0+%i4]	! R2+1
		subcc	%g1,0,%g0	! if CC!=0 then
		bnz,a	%icc,break0	!   exit
		add	%g2,%l7,%g2	! ##TEMPLATE:IAR
		orcc	%l1,%l3,%g0	! if clcl completed then
		bz,a	%icc,break0	!   exit
		add	%g2,%l7,%g2	! ##TEMPLATE:IAR
		andncc	%g7,0xfff,%g0	! if intermediate intr. then
		bz	%icc,i.clcl0lp	!   exit
		nop			!
		ba,a	%icc,epilog0	!
		nop			!
i.clcl0e:
!================================

!
! templates
!   %i0: struct gcpu_s*
!   %i3: M instruction (upper 2 bytes)
!
	.section ".text"
	.align	4
	.global ii2_lpr
ii2_lpr:
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i1		! save as %i1
	srl	%i3,16,%i5		! R2
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l2		! %l2
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	add	%g0,2,%l7		!
	movnz	%icc,4,%l7		! if EX=1 then IAR+=4
i.lpr0s:
		mov	0,%g1		! CC=0
		subcc	%g0,%l2,%l0	! ##TEMPLATE:%l0,%l0
		movg	%icc,%l0,%l2	! if %l2 < 0 then negate;
		st	%l2,[%i0+%i1]	! R1
		movnz	%icc,2,%g1	! if %l2 !=0 then CC=2
		bvc,a,pt %icc,break0	! if overflow then CC=3
		add	%g2,%l7,%g2	! ##TEMPLATE:IAR
		mov	3,%g1		!
		andcc	%g7,8,%g0	!
		bz,a	%icc,break0	!   if fixed-point overflow mask then
		add	%g2,%l7,%g2	! ##TEMPLATE:IAR
		sethi	%hi(0x00080000),%o7
		ba	%icc,epilog0	!
		or	%g7,%o7,%g7	!     fixed-point overflow
i.lpr0e:

	.section ".text"
	.align	4
	.global ii2_lnr
ii2_lnr:
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i1		! save as %i1
	srl	%i3,16,%i5		! R2
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l2		! %l2
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	add	%g0,2,%l7		!
	movnz	%icc,4,%l7		! if EX=1 then IAR+=4
i.lnr0s:
		mov	0,%g1		! CC=0
		subcc	%g0,%l2,%l0	! ##TEMPLATE:%l0,%l0
		movl	%icc,%l0,%l2	! if %l2 > 0 then negate
		st	%l2,[%i0+%i1]	! R1
		movnz	%icc,1,%g1	! if %l2 !=0 then CC=1
		ba	%icc,break0	!
		add	%g2,%l7,%g2	! ##TEMPLATE:IAR
i.lnr0e:

	.section ".text"
	.align	4
	.global ii2_ltr
ii2_ltr:
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i1		! save as %i1
	srl	%i3,16,%i5		! R2
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l2		! %l2
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	add	%g0,2,%l7		!
	movnz	%icc,4,%l7		! if EX=1 then IAR+=4
i.ltr0s:
		mov	0,%g1		! CC=0
		st	%l2,[%i0+%i1]	! R1
		subcc	%l2,%g0,%g0	! ##TEMPLATE:%l0,%l0
		movg	%icc,2,%g1	! if %l2 > 0 then CC=2
		movl	%icc,1,%g1	! if %l2 < 0 then CC=1
		ba	%icc,break0	!
		add	%g2,%l7,%g2	! ##TEMPLATE:IAR
i.ltr0e:

	.section ".text"
	.align	4
	.global ii2_lcr
ii2_lcr:
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i1		! save as %i1
	srl	%i3,16,%i5		! R2
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l2		! %l2
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	add	%g0,2,%l7		!
	movnz	%icc,4,%l7		! if EX=1 then IAR+=4
i.lcr0s:
		mov	0,%g1		! CC=0
		subcc	%g0,%l2,%l2	! ##TEMPLATE:%l0,%l0
		st	%l2,[%i0+%i1]	! R1
		movg	%icc,2,%g1	! if %l2 > 0 then CC=2
		movl	%icc,1,%g1	! if %l2 < 0 then CC=1
		bvc,a,pt %icc,break0	! if overflow then
		add	%g2,%l7,%g2	! ##TEMPLATE:IAR
		mov	3,%g1		!
		andcc	%g7,8,%g0	!   CC=3
		bz,a	%icc,break0	!   if fixed-point overflow mask then
		add	%g2,%l7,%g2	! ##TEMPLATE:IAR
		sethi	%hi(0x00080000),%o7
		ba	%icc,epilog0	!
		or	%g7,%o7,%g7	!     fixed-point overflow
i.lcr0e:

	.section ".text"
	.align	4
	.global ii2_nr
ii2_nr:
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i1		! save as %i1
	ld	[%i0+%i1],%l0		! %l0
	srl	%i3,16,%i5		! R2
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l2		! %l2
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	add	%g0,2,%l7		!
	movnz	%icc,4,%l7		! if EX=1 then IAR+=4
i.nr0s:
		mov	0,%g1		! CC=0
		andcc	%l0,%l2,%l0	! ##TEMPLATE:%l0,%l0,%l0
		st	%l0,[%i0+%i1]	! R1
		movnz	%icc,1,%g1	! if %l0 != 0 then CC=1
		ba	%icc,break0	!
		add	%g2,%l7,%g2	! ##TEMPLATE:IAR
i.nr0e:

	.section ".text"
	.align	4
	.global ii2_clr
ii2_clr:
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l0		! %l0
	srl	%i3,16,%i5		! R2
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l2		! %l2
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	add	%g0,2,%l7		!
	movnz	%icc,4,%l7		! if EX=1 then IAR+=4
i.clr0s:
		mov	0,%g1		! CC=0
		subcc	%l0,%l2,%g0	! ##TEMPLATE:%l0,%l0
		movgu	%icc,2,%g1	! if %l0 > %l2 then CC=2
		movcs	%icc,1,%g1	! if %l0 < %l2 then CC=1
		ba	%icc,break0	!
		add	%g2,%l7,%g2	! ##TEMPLATE:IAR
i.clr0e:

	.section ".text"
	.align	4
	.global ii2_or
ii2_or:
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i1		! save as %i1
	ld	[%i0+%i1],%l0		! %l0
	srl	%i3,16,%i5		! R2
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l2		! %l2
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	add	%g0,2,%l7		!
	movnz	%icc,4,%l7		! if EX=1 then IAR+=4
i.or0s:
		mov	0,%g1		! CC=0
		orcc	%l0,%l2,%l0	! ##TEMPLATE:%l0,%l0,%l0
		st	%l0,[%i0+%i1]	! R1
		movnz	%icc,1,%g1	! if %l0 != 0 then CC=1
		ba	%icc,break0	!
		add	%g2,%l7,%g2	! ##TEMPLATE:IAR
i.or0e:

	.section ".text"
	.align	4
	.global	ii2_xr
ii2_xr:
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i1		! save as %i1
	ld	[%i0+%i1],%l0		! %l0
	srl	%i3,16,%i5		! R2
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l2		! %l2
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	add	%g0,2,%l7		!
	movnz	%icc,4,%l7		! if EX=1 then IAR+=4
i.xr0s:
		mov	0,%g1		! CC=0
		xorcc	%l0,%l2,%l0	! ##TEMPLATE:%l0,%l0,%l0
		st	%l0,[%i0+%i1]	! R1
		movnz	%icc,1,%g1	! if %l0 != 0 then CC=1
		ba	%icc,break0	!
		add	%g2,%l7,%g2	! ##TEMPLATE:IAR
i.xr0e:

	.section ".text"
	.align	4
	.global ii2_lr
ii2_lr:
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i1		! save as %i1
	srl	%i3,16,%i5		! R2
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l2		! %l2
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	add	%g0,2,%l7		!
	movnz	%icc,4,%l7		! if EX=1 then IAR+=4
i.lr0s:
		st	%l2,[%i0+%i1]	! R1
		ba	%icc,break0	!
		add	%g2,%l7,%g2	! ##TEMPLATE:IAR
i.lr0e:

	.section ".text"
	.align	4
	.global ii2_cr
ii2_cr:
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l0		! %l0
	srl	%i3,16,%i5		! R2
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l2		! %l2
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	add	%g0,2,%l7		!
	movnz	%icc,4,%l7		! if EX=1 then IAR+=4
i.cr0s:
		mov	0,%g1		! CC=0
		subcc	%l0,%l2,%g0	! ##TEMPLATE:%l0,%l0
		movg	%icc,2,%g1	! if %l0 > %l2 then CC=2
		movl	%icc,1,%g1	! if %l0 < %l2 then CC=1
		ba	%icc,break0	!
		add	%g2,%l7,%g2	! ##TEMPLATE:IAR
i.cr0e:

	.section ".text"
	.align	4
	.global ii2_ar
ii2_ar:
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i1		! save as %i1
	ld	[%i0+%i1],%l0		! %l0
	srl	%i3,16,%i5		! R2
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l2		! %l2
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	add	%g0,2,%l7		!
	movnz	%icc,4,%l7		! if EX=1 then IAR+=4
i.ar0s:
		mov	0,%g1		! CC=0
		addcc	%l0,%l2,%l0	! ##TEMPLATE:%l0,%l0,%l0
		st	%l0,[%i0+%i1]	! R1
		movg	%icc,2,%g1	! if %l0 > 0 then CC=2
		movl	%icc,1,%g1	! if %l0 < 0 then CC=1
		bvc,a,pt %icc,break0	! if overflow then
		add	%g2,%l7,%g2	! ##TEMPLATE:IAR
		mov	3,%g1		!
		andcc	%g7,8,%g0	!   CC=3
		bz,a	%icc,break0	!   if fixed-point overflow mask then
		add	%g2,%l7,%g2	! ##TEMPLATE:IAR
		sethi	%hi(0x00080000),%o7
		ba	%icc,epilog0	!
		or	%g7,%o7,%g7	!     fixed-point overflow
i.ar0e:

	.section ".text"
	.align	4
	.global ii2_sr
ii2_sr:
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i1		! save as %i1
	ld	[%i0+%i1],%l0		! %l0
	srl	%i3,16,%i5		! R2
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l2		! %l2
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	add	%g0,2,%l7		!
	movnz	%icc,4,%l7		! if EX=1 then IAR+=4
i.sr0s:
		mov	0,%g1		! CC=0
		subcc	%l0,%l2,%l0	! ##TEMPLATE:%l0,%l0,%l0
		st	%l0,[%i0+%i1]	! R1
		movg	%icc,2,%g1	! if %l0 > 0 then CC=2
		movl	%icc,1,%g1	! if %l0 < 0 then CC=1
		bvc,a,pt %icc,break0	! if overflow then
		add	%g2,%l7,%g2	! ##TEMPLATE:IAR
		mov	3,%g1		!
		andcc	%g7,8,%g0	!   CC=3
		bz,a	%icc,break0	!   if fixed-point overflow mask then
		add	%g2,%l7,%g2	! ##TEMPLATE:IAR
		sethi	%hi(0x00080000),%o7
		ba	%icc,epilog0	!
		or	%g7,%o7,%g7	!     fixed-point overflow
i.sr0e:

	.section ".text"
	.align	4
	.global ii2_mr
ii2_mr:
	srl	%i3,20,%i5		! switch (R1)
	andcc	%i5,1,%g0		!
	bnz,pn	%icc,spec_exception	!
	nop				!
    i.mr0t:				!
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i1		! save as %i1
	srl	%i3,20,%i5		! R1+1
	and	%i5,0xf,%i5		! |
	add	%i5,1,%i5		! |
	sll	%i5,2,%i2		! save as %i2
	ld	[%i0+%i2],%l1		! %l1
	srl	%i3,16,%i5		! R2
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l2		! %l2
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	add	%g0,2,%l7		!
	movnz	%icc,4,%l7		! if EX=1 then IAR+=4
i.mr0s:
		smul	%l1,%l2,%l1	! ##TEMPLATE:%l0,%l0,%l0
		rd	%y,%l0		! ##TEMPLATE:%l0
		st	%l0,[%i0+%i1]	! R1
		st	%l1,[%i0+%i2]	! R1+1
		ba	%icc,break0	!
		add	%g2,%l7,%g2	! ##TEMPLATE:IAR
i.mr0e:

	.section ".text"
	.align	4
	.global ii2_dr
ii2_dr:
	srl	%i3,20,%i5		! switch (R1)
	andcc	%i5,1,%g0		!
	bnz,pn	%icc,spec_exception	!
	nop				!
    i.dr0t:				!
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i1		! save as %i1
	ld	[%i0+%i1],%l0		! %l0
	srl	%i3,20,%i5		! R1+1
	and	%i5,0xf,%i5		! |
	add	%i5,1,%i5		! |
	sll	%i5,2,%i2		! save as %i2
	ld	[%i0+%i2],%l1		! %l1
	srl	%i3,16,%i5		! R2
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l2		! %l2
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	add	%g0,2,%l7		!
	movnz	%icc,4,%l7		! if EX=1 then IAR+=4
i.dr0s:
		subcc	%l2,%g0,%g0	! ##TEMPLATE:%l0     R2
		bz,pn	%icc,i.dr000	! if R2==0 then int-div. exception
		wr	%l0,%g0,%y	! ##TEMPLATE:%l0     R1
		sdivcc	%l1,%l2,%l0	! ##TEMPLATE:%l0,%l0 R1+1,R2
		bvs,pn	%icc,i.dr000	! if overflow then int-div.
		smul	%l0,%l2,%l2	! ##TEMPLATE:%l0     R2
		sub	%l1,%l2,%l1	! ##TEMPLATE:%l0,%l0 R1+1,R1
		st	%l1,[%i0+%i1]	! R1
		st	%l0,[%i0+%i2]	! R1+1
		ba	%icc,break0	!
		add	%g2,%l7,%g2	! ##TEMPLATE:IAR
    i.dr000:	sethi	%hi(0x00090000),%o7
		ba	%icc,epilog0	!
		or	%g7,%o7,%g7	! int-div. exception
i.dr0e:

	.section ".text"
	.align	4
	.global ii2_alr
ii2_alr:
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i1		! save as %i1
	ld	[%i0+%i1],%l0		! %l0
	srl	%i3,16,%i5		! R2
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l2		! %l2
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	add	%g0,2,%l7		!
	movnz	%icc,4,%l7		! if EX=1 then IAR+=4
i.alr0s:
		mov	0,%g1		! CC=0
		addcc	%l0,%l2,%l0	! ##TEMPLATE:%l0,%l0,%l0
		st	%l0,[%i0+%i1]	! R1
		bcs,a,pn %icc,i.alr000	! if carry then
		mov	2,%g1		!   CC|=2 & skip
		movnz	%icc,1,%g1	! if %l0 != 0 then CC=1
		ba	%icc,break0	!
		add	%g2,%l7,%g2	! ##TEMPLATE:IAR
    i.alr000:	movnz	%icc,3,%g1	! if %l0 != 0 then CC=3
		ba	%icc,break0	!
		add	%g2,%l7,%g2	! ##TEMPLATE:IAR
i.alr0e:

	.section ".text"
	.align	4
	.global ii2_slr
ii2_slr:
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i1		! save as %i1
	ld	[%i0+%i1],%l0		! %l0
	srl	%i3,16,%i5		! R2
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l2		! %l2
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	add	%g0,2,%l7		!
	movnz	%icc,4,%l7		! if EX=1 then IAR+=4
i.slr0s:
		mov	0,%g1		! CC=0
		subcc	%l0,%l2,%l0	! ##TEMPLATE:%l0,%l0,%l0
		st	%l0,[%i0+%i1]	! R1
		bcc,a,pn %icc,i.slr000	! if !carry then
		mov	2,%g1		!   CC|=2 & skip
		movnz	%icc,1,%g1	! if %l0 != 0 then CC=1
		ba	%icc,break0	!
		add	%g2,%l7,%g2	! ##TEMPLATE:IAR
    i.slr000:	movnz	%icc,3,%g1	! if %l0 != 0 then CC=3
		ba	%icc,break0	!
		add	%g2,%l7,%g2	! ##TEMPLATE:IAR
i.slr0e:
!================================

!
! templates
!   %i0: struct gcpu_s*
!   %i3: M instruction (upper 4 bytes)
!
	.section ".text"
	.align	4
	.global ii4_sth
ii4_sth:
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l0		! %l0
	srl	%i3,16,%i5		! X2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l2		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l2		! %l2
	srl	%i3,12,%i5		! B2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l3		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l3		! %l3
	and	%i3,0xfff,%l4		! D2
i.sth0s:
		add	%l2,%l3,%l2	! ##TEMPLATE:%l0,%l0
		add	%l2,%l4,%l2	! ##TEMPLATE:imm0
		and	%l2,%g3,%l2	! mask address

		andncc	%l2,0x1ff,%g0	! check LAP
		bnz,pt	%icc,.+12	!
		andcc	%g7,0x20,%g0	!
		tnz	%icc,0x43	! LAP exception
					!
		andn	%l2,0xfff,%o1	! ST0-GS-TLB
		subcc	%g6,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g6,32,%o0	!
		call	st1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l2,0xfff,%o1	!

		sth	%l0,[%o0+%o1]	! ##TEMPLATE:%l0
		ba	%icc,break0	!
		add	%g2,4,%g2	! update IAR
i.sth0e:

	.section ".text"
	.align	4
	.global	ii4_la
ii4_la:
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i1		! save as %i1
	srl	%i3,16,%i5		! X2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l2		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l2		! %l2
	srl	%i3,12,%i5		! B2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l3		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l3		! %l3
	and	%i3,0xfff,%l4		! D2
i.la0s:
		add	%l2,%l3,%l2	! ##TEMPLATE:%l0,%l0
		add	%l2,%l4,%l2	! ##TEMPLATE:imm0
		and	%l2,%g3,%l2	! ##TEMPLATE:%l0
		st	%l2,[%i0+%i1]	! R1
		ba	%icc,break0	!
		add	%g2,4,%g2	! update IAR
i.la0e:

	.section ".text"
	.align	4
	.global ii4_stc
ii4_stc:
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l0		! %l0
	srl	%i3,16,%i5		! X2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l2		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l2		! %l2
	srl	%i3,12,%i5		! B2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l3		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l3		! %l3
	and	%i3,0xfff,%l4		! D2
i.stc0s:
		add	%l2,%l3,%l2	! ##TEMPLATE:%l0,%l0
		add	%l2,%l4,%l2	! ##TEMPLATE:imm0
		and	%l2,%g3,%l2	! mask address

		andncc	%l2,0x1ff,%g0	! check LAP
		bnz,pt	%icc,.+12	!
		andcc	%g7,0x20,%g0	!
		tnz	%icc,0x43	! LAP exception
					!
		andn	%l2,0xfff,%o1	! ST0-GS-TLB
		subcc	%g6,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g6,32,%o0	!
		call	st1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l2,0xfff,%o1	!

		stb	%l0,[%o0+%o1]	! ##TEMPLATE:%l0
		ba	%icc,break0	!
		add	%g2,4,%g2	! update IAR
i.stc0e:

	.section ".text"
	.align	4
	.global ii4_ic
ii4_ic:
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i1		! save as %i1
	ld	[%i0+%i1],%l0		! %l0
	srl	%i3,16,%i5		! X2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l2		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l2		! %l2
	srl	%i3,12,%i5		! B2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l3		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l3		! %l3
	and	%i3,0xfff,%l4		! D2
i.ic0s:
		add	%l2,%l3,%l2	! ##TEMPLATE:%l0,%l0
		add	%l2,%l4,%l2	! ##TEMPLATE:imm0
		and	%l2,%g3,%l2	! mask address

		andn	%l2,0xfff,%o1	! LD0-GS-TLB
		subcc	%g5,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g5,32,%o0	!
		call	ld1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l2,0xfff,%o1	!

		ldub	[%o0+%o1],%l2	!
		andn	%l0,0xff,%l0	! ##TEMPLATE:%l0
		or	%l0,%l2,%l0	! ##TEMPLATE:%l0
		st	%l0,[%i0+%i1]	! R1
		ba	%icc,break0	!
		add	%g2,4,%g2	! update IAR
i.ic0e:

	.section ".text"
	.align	4
	.global ii4_ex
ii4_ex:
	andcc	%g7,0x40,%g0		! if EX EX then
	bnz	%icc,i.ex2s		!   execute exception
	srl	%i3,20,%i5		! switch (R1)
	andcc	%i5,0xf,%g0		!
	bnz	%icc,i.ex1t		!
	nop				!
    i.ex0t:				!
	srl	%i3,16,%i5		! X2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l2		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l2		! %l2
	srl	%i3,12,%i5		! B2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l3		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l3		! %l3
	and	%i3,0xfff,%l4		! D2
	ba,a	%icc,i.ex0s		!
	nop				!
    i.ex1t:				!
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l0		! %l0
	srl	%i3,16,%i5		! X2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l2		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l2		! %l2
	srl	%i3,12,%i5		! B2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l3		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l3		! %l3
	and	%i3,0xfff,%l4		! D2
	ba,a	%icc,i.ex1s		!
	nop				!
i.ex0s:
	! %l1: or-value			!
	! %l2: D2(X2,B2) address	!
		add	%l2,%l3,%l2	! ##TEMPLATE:%l0,%l0
		add	%l2,%l4,%l2	! ##TEMPLATE:imm0
		andcc	%l2,1,%g0	! if odd address then
		bnz,pn	%icc,spec_exception
		nop			! specification exception
		ba	%icc,i.ex100	!
		and	%g0,0,%l1	! or-value = 0
i.ex0e:
i.ex1s:
	! %l1: or-value			!
	! %l2: D2(X2,B2) address	!
		add	%l2,%l3,%l2	! ##TEMPLATE:%l0,%l0
		add	%l2,%l4,%l2	! ##TEMPLATE:imm0
		andcc	%l2,1,%g0	! if even address then
		bnz,pn	%icc,spec_exception
		nop			! specification exception
		and	%l0,0xff,%l1	! ##TEMPLATE:%l0

    i.ex100:	and	%l2,%g3,%l2	! mask address
		andn	%l2,0xfff,%o1	! LD0-GS-TLB
		subcc	%g5,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g5,32,%o0	!
		call	ld1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l2,0xfff,%o1	!

		lduh	[%o0+%o1],%i1	! load gmem[IAR]
		or	%i1,%l1,%i1	! or-value
		srl	%i1,8,%i2	!
		sll	%i2,5,%i2	!
		sethi	%hi(optable),%o7! 1024 aligned
		ldd	[%o7+%i2],%i4	! load optable[opcd].mlen,ifunc

		subcc	%i4,2,%g0	!
		bne,pt	%icc,i.ex101	!
		sll	%i1,16,%i3	! store in upper half of %i3
		jmpl	%i5,%g0		! jmp to ifunc()
		or	%g7,0x40,%g7	! flag=EXECUTE

    i.ex101:	add	%l2,2,%l2	!
		and	%l2,%g3,%l2	! mask address
		andn	%l2,0xfff,%o1	! LD0-GS-TLB
		subcc	%g5,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g5,32,%o0	!
		call	ld1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l2,0xfff,%o1	!

		lduh	[%o0+%o1],%i1	! load gmem[IAR+2]
		subcc	%i4,4,%g0	!
		bne,pn	%icc,i.ex102	!
		or	%i3,%i1,%i3	! store in %i3
		jmpl	%i5,%g0		! jmp to ifunc()
		or	%g7,0x40,%g7	! flag=EXECUTE

    i.ex102:	add	%l2,2,%l2	!
		and	%l2,%g3,%l2	! mask address
		andn	%l2,0xfff,%o1	! LD0-GS-TLB
		subcc	%g5,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g5,32,%o0	!
		call	ld1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l2,0xfff,%o1	!

		lduh	[%o0+%o1],%i1	! 6 byte instruction
		sll	%i1,16,%i4	! store in upper half of %i4
		jmpl	%i5,%g0		! jmp to ifunc()
		or	%g7,0x40,%g7	! flag=EXECUTE
i.ex1e:
i.ex2s:
		sethi	%hi(0x00030000),%o7
		ba	%icc,epilog0	!
		or	%g7,%o7,%g7	! execute exception
i.ex2e:

	.section ".text"
	.align	4
	.global ii4_bal
ii4_bal:
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i1		! save as %i1
	srl	%i3,16,%i5		! X2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l2		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l2		! %l2
	srl	%i3,12,%i5		! B2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l3		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l3		! %l3
	and	%i3,0xfff,%l4		! D2
i.bal0s:
		add	%g2,%g0,%i2	! save OPC
		add	%g2,4,%g2	! update IAR
		add	%l2,%l3,%l2	! ##TEMPLATE:%l0,%l0
		andcc	%g7,0x10,%g0	! if 31bit address then
		bnz,a,pt %icc,i.bal000	!
		orn	%g2,%g3,%l0	! ##TEMPLATE:%l0
		and	%g2,%g3,%l0	! if 24bit address then
		or	%g1,8,%l1	!   ILC|CC
		sll	%l1,28,%l1	!
		or	%l1,%l0,%l0	!
		and	%g7,0xf,%l1	!   Prog-Mask
		sll	%l1,24,%l1	!
		or	%l1,%l0,%l0	! ##TEMPLATE:%l0
    i.bal000:	st	%l0,[%i0+%i1]	! R1
		ba	%icc,break1	! BRANCH TAKEN
		add	%l2,%l4,%g2	!
i.bal0e:

	.section ".text"
	.align	4
	.global ii4_bct
ii4_bct:
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i1		! save as %i1
	ld	[%i0+%i1],%l0		! %l0
	srl	%i3,16,%i5		! X2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l2		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l2		! %l2
	srl	%i3,12,%i5		! B2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l3		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l3		! %l3
	and	%i3,0xfff,%l4		! D2
i.bct0s:
		subcc	%l0,1,%l0	! ##TEMPLATE:%l0,%l0
		st	%l0,[%i0+%i1]	! R1
		bz,a,pn	%icc,break0	! if %l0 != 0 then taken
		add	%g2,4,%g2	! update IAR
		add	%g2,%g0,%i2	! save OPC
		add	%l2,%l3,%l2	! ##TEMPLATE:%l0,%l0
		ba	%icc,break1	! BRANCH TAKEN
		add	%l2,%l4,%g2	!
i.bct0e:

	.section ".text"
	.align	4
	.global ii4_bc
ii4_bc:
	srl	%i3,20,%i5		! switch (M1)
	andcc	%i5,0xf,%i5		!
	bz	%icc,i.bc0t		!
	subcc	%i5,0xf,%g0		!
	bne	%icc,i.bc2t		!
	nop				!
    i.bc3t:				!
	srl	%i3,16,%i5		! X2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l2		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l2		! %l2
	srl	%i3,12,%i5		! B2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l3		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l3		! %l3
	and	%i3,0xfff,%l4		! D2
i.bc3s:
		add	%g2,%g0,%i2	! save OPC
		add	%l2,%l3,%l2	! ##TEMPLATE:%l0,%l0
		ba	%icc,break1	! BRANCH TAKEN
		add	%l2,%l4,%g2	! ##TEMPLATE:imm0
i.bc3e:
    i.bc0t:				!
	sethi	%hi(0x47000fed),%o7	! case 0:
	or	%o7,%lo(0x47000fed),%o7 !
	subcc	%i3,%o7,%g0		!
	be	%icc,i.bc1t		!
	nop				!
i.bc0s:
		ba	%icc,break0	!
		add	%g2,4,%g2	! update IAR
i.bc0e:
    i.bc1t:				!
i.bc1s:
		sethi	%hi(0xc0000000),%o7
		ba	%icc,epilog0	!
		or	%g7,%o7,%g7	! extended function (FC=3)
i.bc1e:
    i.bc2t:				!
	srl	%i3,20,%i5		! M1
	and	%i5,0xf,%i5		! |
	sll	%i5,8,%l0		! %l0
	srl	%i3,16,%i5		! X2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l2		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l2		! %l2
	srl	%i3,12,%i5		! B2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l3		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l3		! %l3
	and	%i3,0xfff,%l4		! D2
i.bc2s:
		srl	%g7,%g1,%l1	! consi.0b0001000XXXXXXXX >> %l1
		andcc	%l1,%l0,%g0	! ##TEMPLATE:imm0
		bz,a	%icc,break0	! if CC is true then taken
		add	%g2,4,%g2	! update IAR
		add	%g2,%g0,%i2	! save OPC
		add	%l2,%l3,%l2	! ##TEMPLATE:%l0,%l0
		ba	%icc,break1	! BRANCH TAKEN
		add	%l2,%l4,%g2	! ##TEMPLATE:imm0
i.bc2e:

	.section ".text"
	.align	4
	.global ii4_lh
ii4_lh:
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i1		! save as %i1
	srl	%i3,16,%i5		! X2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l2		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l2		! %l2
	srl	%i3,12,%i5		! B2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l3		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l3		! %l3
	and	%i3,0xfff,%l4		! D2
i.lh0s:
		add	%l2,%l3,%l2	! ##TEMPLATE:%l0,%l0
		add	%l2,%l4,%l2	! ##TEMPLATE:imm0
		and	%l2,%g3,%l2	! mask address

		andn	%l2,0xfff,%o1	! LD0-GS-TLB
		subcc	%g5,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g5,32,%o0	!
		call	ld1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l2,0xfff,%o1	!

		ldsh	[%o0+%o1],%l0	! ##TEMPLATE:%l0
		st	%l0,[%i0+%i1]	! R1
		ba	%icc,break0	!
		add	%g2,4,%g2	! update IAR
i.lh0e:

	.section ".text"
	.align	4
	.global ii4_ch
ii4_ch:
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l0		! %l0
	srl	%i3,16,%i5		! X2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l2		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l2		! %l2
	srl	%i3,12,%i5		! B2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l3		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l3		! %l3
	and	%i3,0xfff,%l4		! D2
i.ch0s:
		add	%l2,%l3,%l2	! ##TEMPLATE:%l0,%l0
		add	%l2,%l4,%l2	! ##TEMPLATE:imm0
		and	%l2,%g3,%l2	! mask address

		andn	%l2,0xfff,%o1	! LD0-GS-TLB
		subcc	%g5,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g5,32,%o0	!
		call	ld1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l2,0xfff,%o1	!

		ldsh	[%o0+%o1],%l2	!
		mov	0,%g1		! CC=0
		subcc	%l0,%l2,%g0	! ##TEMPLATE:%l0
		movg	%icc,2,%g1	! if %l0 > 0 then CC=2
		movl	%icc,1,%g1	! if %l0 < 0 then CC=1
		ba	%icc,break0	!
		add	%g2,4,%g2	! update IAR
i.ch0e:

	.section ".text"
	.align	4
	.global ii4_ah
ii4_ah:
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i1		! save as %i1
	ld	[%i0+%i1],%l0		! %l0
	srl	%i3,16,%i5		! X2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l2		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l2		! %l2
	srl	%i3,12,%i5		! B2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l3		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l3		! %l3
	and	%i3,0xfff,%l4		! D2
i.ah0s:
		add	%l2,%l3,%l2	! ##TEMPLATE:%l0,%l0
		add	%l2,%l4,%l2	! ##TEMPLATE:imm0
		and	%l2,%g3,%l2	! mask address

		andn	%l2,0xfff,%o1	! LD0-GS-TLB
		subcc	%g5,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g5,32,%o0	!
		call	ld1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l2,0xfff,%o1	!

		ldsh	[%o0+%o1],%l2	!
		mov	0,%g1		! CC=0
		addcc	%l0,%l2,%l0	! ##TEMPLATE:%l0,%l0
		st	%l0,[%i0+%i1]	! R1
		movg	%icc,2,%g1	! if %l0 > 0 then CC=2
		movl	%icc,1,%g1	! if %l0 < 0 then CC=1
		bvc,a,pt %icc,break0	! if overflow then
		add	%g2,4,%g2	! update IAR
		mov	3,%g1		!
		andcc	%g7,8,%g0	!   CC=3
		bz,a	%icc,break0	!   if fixed-point overflow mask then
		add	%g2,4,%g2	! update IAR
		sethi	%hi(0x00080000),%o7
		ba	%icc,epilog0	!
		or	%g7,%o7,%g7	!     fixed-point overflow
i.ah0e:

	.section ".text"
	.align	4
	.global ii4_sh
ii4_sh:
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i1		! save as %i1
	ld	[%i0+%i1],%l0		! %l0
	srl	%i3,16,%i5		! X2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l2		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l2		! %l2
	srl	%i3,12,%i5		! B2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l3		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l3		! %l3
	and	%i3,0xfff,%l4		! D2
i.sh0s:
		add	%l2,%l3,%l2	! ##TEMPLATE:%l0,%l0
		add	%l2,%l4,%l2	! ##TEMPLATE:imm0
		and	%l2,%g3,%l2	! mask address

		andn	%l2,0xfff,%o1	! LD0-GS-TLB
		subcc	%g5,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g5,32,%o0	!
		call	ld1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l2,0xfff,%o1	!

		ldsh	[%o0+%o1],%l2	!
		mov	0,%g1		! CC=0
		subcc	%l0,%l2,%l0	! ##TEMPLATE:%l0,%l0
		st	%l0,[%i0+%i1]	! R1
		movg	%icc,2,%g1	! if %l0 > 0 then CC=2
		movl	%icc,1,%g1	! if %l0 < 0 then CC=1
		bvc,a,pt %icc,break0	! if overflow then
		add	%g2,4,%g2	! update IAR
		mov	3,%g1		!
		andcc	%g7,8,%g0	!   CC=3
		bz,a	%icc,break0	!   if fixed-point overflow mask then
		add	%g2,4,%g2	! update IAR
		sethi	%hi(0x00080000),%o7
		ba	%icc,epilog0	!
		or	%g7,%o7,%g7	!     fixed-point overflow
i.sh0e:

	.section ".text"
	.align	4
	.global	ii4_mh
ii4_mh:
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i1		! save as %i1
	ld	[%i0+%i1],%l0		! %l0
	srl	%i3,16,%i5		! X2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l2		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l2		! %l2
	srl	%i3,12,%i5		! B2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l3		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l3		! %l3
	and	%i3,0xfff,%l4		! D2
i.mh0s:
		add	%l2,%l3,%l2	! ##TEMPLATE:%l0,%l0
		add	%l2,%l4,%l2	! ##TEMPLATE:imm0
		and	%l2,%g3,%l2	! mask address

		andn	%l2,0xfff,%o1	! LD0-GS-TLB
		subcc	%g5,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g5,32,%o0	!
		call	ld1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l2,0xfff,%o1	!

		ldsh	[%o0+%o1],%l2	!
		smul	%l0,%l2,%l0	! ##TEMPLATE:%l0,%l0
		st	%l0,[%i0+%i1]	! R1
		ba	%icc,break0	!
		add	%g2,4,%g2	! update IAR
i.mh0e:

	.section ".text"
	.align	4
	.global ii4_bas
ii4_bas:
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i1		! save as %i1
	srl	%i3,16,%i5		! X2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l2		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l2		! %l2
	srl	%i3,12,%i5		! B2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l3		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l3		! %l3
	and	%i3,0xfff,%l4		! D2
i.bas0s:
		add	%g2,%g0,%i2	! save OPC
		add	%g2,4,%g2	! update IAR
		add	%l2,%l3,%l2	! ##TEMPLATE:%l0,%l0
		andcc	%g7,0x10,%g0	! if 31bit address then
		bnz,a,pt %icc,i.bas000	!
		orn	%g2,%g3,%l0	! ##TEMPLATE:%l0
		and	%g2,%g3,%l0	! ##TEMPLATE:%l0
    i.bas000:	st	%l0,[%i0+%i1]	! R1
		ba	%icc,break1	! BRANCH TAKEN
		add	%l2,%l4,%g2	!
i.bas0e:

	.section ".text"
	.align	4
	.global ii4_cvd
ii4_cvd:
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l0		! %l0
	srl	%i3,16,%i5		! X2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l2		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l2		! %l2
	srl	%i3,12,%i5		! B2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l3		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l3		! %l3
	and	%i3,0xfff,%l4		! D2
i.cvd0s:
		add	%l2,%l3,%l2	! ##TEMPLATE:%l0,%l0
		add	%l2,%l4,%l2	! ##TEMPLATE:imm0
		and	%l2,%g3,%l2	! mask address
		add	%l2,7,%l3	!		
		and	%l3,%g3,%l3	! mask address

		andncc	%l2,0x1ff,%g0	! check LAP
		bnz,pt	%icc,.+12	!
		andcc	%g7,0x20,%g0	!
		tnz	%icc,0x43	! LAP exception
					!
		andn	%l2,0xfff,%o1	! ST0-GS-TLB
		subcc	%g6,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g6,32,%o0	!
		call	st1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l2,0xfff,%o1	!
		mov	%o0,%l2		! save base0

		andncc	%l3,0x1ff,%g0	! check LAP
		bnz,pt	%icc,.+12	!
		andcc	%g7,0x20,%g0	!
		tnz	%icc,0x43	! LAP exception
					!
		andn	%l3,0xfff,%o1	! ST0-GS-TLB
		subcc	%g6,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g6,32,%o0	!
		call	st1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l3,0xfff,%o1	!
		mov	%o0,%o2		!
		mov	%l2,%o0		! restore base0
	! %o0: base0
	! %o1: offset1
	! %o2: base1
		mov	7,%l4		! counter
		subcc	%l0,%g0,%g0	! ##TEMPLATE:%l0
		bneg,a	%icc,i.cvd000	!
		sub	%g0,%l0,%l0	!
    i.cvd000:	movpos	%icc,0xc,%l1	!
		movneg	%icc,0xd,%l1	!
    i.cvd001:	wr	%g0,0,%y	!
		udiv	%l0,10,%l2	!
		umul	%l2,10,%l3	!
		sub	%l0,%l3,%l3	! remainder
		sll	%l3,4,%l3	!
		or	%l3,%l1,%l1	!
		stb	%l1,[%o2+%o1]	!
		sub	%o1,1,%o1	!
		subcc	%o1,0xfff,%g0	! if page cross
		movgu	%icc,%o0,%o2	!   base0-> base1
		and	%o1,0xfff,%o1	!
		wr	%g0,0,%y	!
		udiv	%l2,10,%l0	!
		umul	%l0,10,%l1	!
		sub	%l2,%l1,%l1	! remainder
		and	%l1,0xf,%l1	!
		subcc	%l0,%g0,%g0	!
		bnz	%icc,i.cvd001	!
		sub	%l4,1,%l4	!
    i.cvd002:	stb	%l1,[%o2+%o1]	!
		sub	%o1,1,%o1	!
		subcc	%o1,0xfff,%g0	! if page cross
		movgu	%icc,%o0,%o2	!   base0-> base1
		and	%o1,0xfff,%o1	!
		subcc	%l4,1,%l4	!
		bpos	%icc,i.cvd002	!
		mov	0,%l1		!
		ba	%icc,break0	!
		add	%g2,4,%g2	! update IAR
i.cvd0e:

	.section ".text"
	.align	4
	.global ii4_cvb
ii4_cvb:
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i1		! save as %i1
	srl	%i3,16,%i5		! X2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l2		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l2		! %l2
	srl	%i3,12,%i5		! B2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l3		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l3		! %l3
	and	%i3,0xfff,%l4		! D2
i.cvb0s:
		add	%l2,%l3,%l2	! ##TEMPLATE:%l0,%l0
		add	%l2,%l4,%l2	! ##TEMPLATE:imm0
		and	%l2,%g3,%l2	! mask address
		add	%l2,7,%l3	!		
		and	%l3,%g3,%l3	! mask address
	
		andn	%l3,0xfff,%o1	! LD0-GS-TLB
		subcc	%g5,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g5,32,%o0	!
		call	ld1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l3,0xfff,%o1	!
		mov	%o0,%l3		! save base1

		andn	%l2,0xfff,%o1	! LD0-GS-TLB
		subcc	%g5,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g5,32,%o0	!
		call	ld1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l2,0xfff,%o1	!
		mov	%l3,%o2		! restore base1
	! %o0: base0
	! %o1: offset0
	! %o2: base1
		add	%g0,0,%l4	! counter
		add	%g0,0,%l2	! upper half of DIGIMAL NUM
		add	%g0,0,%l3	! lower half of DIGIMAL NUM
		add	%g0,0,%l0	! BINARY NUM
    i.cvb000:	ldub	[%o0+%o1],%l1	!
		add	%o1,1,%o1	!
		subcc	%o1,0xfff,%g0	! if page cross
		movgu	%icc,%o2,%o0	!   base1 -> base0
		and	%o1,0xfff,%o1	!
		sll	%l2,8,%l2	!
		srl	%l3,24,%l5	!
		or	%l2,%l5,%l2	!
		sll	%l3,8,%l3	!
		or	%l3,%l1,%l3	! import right most byte
		srl	%l1,4,%l5	!
		umul	%l0,10,%l0	!
		add	%l0,%l5,%l0	!
		subcc	%l5,10,%g0	!
		bge,a	%icc,i.cvb004	! data exception
		sethi	%hi(0x00070000),%o7
		and	%l1,0xf,%l1	!
		subcc	%l4,7,%g0	!
		be,a	%icc,i.cvb001	!
		andn	%l3,0xf,%l3	!
		umul	%l0,10,%l0	!
		add	%l0,%l1,%l0	!
		subcc	%l1,10,%g0	!
		bge,a	%icc,i.cvb004	! data exception
		sethi	%hi(0x00070000),%o7
		ba	%icc,i.cvb000	!
		add	%l4,1,%l4	! ---
    i.cvb001:	subcc	%l1,0xf,%g0	! if Sign == 0xf then
		bz	%icc,i.cvb002	!   positive
		nop			!
		subcc	%l1,0xa,%g0	! if Sign < 0xa then
		bl,a	%icc,i.cvb004	!   data exception
		sethi	%hi(0x00070000),%o7
		andcc	%l1,1,%g0	!
    i.cvb002:	sethi	%hi(0x00000214),%o7
		or	%o7,%lo(0x00000214),%o7
		sethi	%hi(0x74836400),%l1
		bz,a	%icc,i.cvb003	! if Sign[31] == 0 then positive
		or	%l1,%lo(0x74836470),%l1
		sub	%g0,%l0,%l0	!		   else negative
		or	%l1,%lo(0x74836480),%l1
    i.cvb003:	st	%l0,[%i0+%i1]	! R1
		subcc	%l1,%l3,%g0	!
		subxcc	%o7,%l2,%g0	!
		bgeu,a	%icc,break0	! integer-divide exception
		add	%g2,4,%g2	! update IAR
		sethi	%hi(0x00090000),%o7
    i.cvb004:	ba	%icc,epilog0	!
		or	%g7,%o7,%g7	!
i.cvb0e:
!================================

!
! templates
!   %i0: struct gcpu_s*
!   %i3: M instruction (upper 4 bytes)
!
	.section ".text"
	.align	4
	.global ii4_st
ii4_st:
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l0		! %l0
	srl	%i3,16,%i5		! X2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l2		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l2		! %l2
	srl	%i3,12,%i5		! B2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l3		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l3		! %l3
	and	%i3,0xfff,%l4		! D2
i.st0s:
		add	%l2,%l3,%l2	! ##TEMPLATE:%l0,%l0
		add	%l2,%l4,%l2	! ##TEMPLATE:imm0
		and	%l2,%g3,%l2	! mask address

		andncc	%l2,0x1ff,%g0	! check LAP
		bnz,pt	%icc,.+12	!
		andcc	%g7,0x20,%g0	!
		tnz	%icc,0x43	! LAP exception
					!
		andn	%l2,0xfff,%o1	! ST0-GS-TLB
		subcc	%g6,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g6,32,%o0	!
		call	st1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l2,0xfff,%o1	!

		st	%l0,[%o0+%o1]	! ##TEMPLATE:%l0
		ba	%icc,break0	!
		add	%g2,4,%g2	! update IAR
i.st0e:

	.section ".text"
	.align	4
	.global ii4_flm
ii4_flm:
	srl	%i3,20,%i5		! switch (R1)
	andcc	%i5,1,%g0		!
	bnz,pn	%icc,spec_exception	!
	nop				!
    i.flm0t:				!
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i1		! %i1
	srl	%i3,20,%i5		! R1+1
	and	%i5,0xf,%i5		! |
	add	%i5,1,%i5		! |
	sll	%i5,2,%i2		! %i2
	srl	%i3,16,%i5		! X2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l2		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l2		! %l2
	srl	%i3,12,%i5		! B2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l3		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l3		! %l3
	and	%i3,0xfff,%l4		! D2
i.flm0s:
		add	%l2,%l3,%l2	! ##TEMPLATE:%l0,%l0
		add	%l2,%l4,%l2	! ##TEMPLATE:imm0
		and	%l2,%g3,%l2	! mask address

		andn	%l2,0xfff,%o1	! LD0-GS-TLB
		subcc	%g5,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g5,32,%o0	!
		call	ld1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l2,0xfff,%o1	!

		ld	[%o0+%o1],%l2	!
		mov	0,%g1		! CC=0
		sethi	%hi(0x80000000),%o7
		add	%g0,0,%l0	! counter
    i.flm000:	andcc	%l2,%o7,%g0	! test bit
		bnz,a	%icc,i.flm001	! if 1 is set then
		mov	2,%g1		!   CC=2
		srl	%o7,1,%o7	!
		subcc	%o7,0,%g0	!
		bnz	%icc,i.flm000	! continue
		add	%l0,1,%l0	! update counter
    i.flm001:	andn	%l2,%o7,%l2	! R1+1 = result
		st	%l0,[%i0+%i1]	! R1   = position
		st	%l2,[%i0+%i2]	! R1+1
		ba	%icc,break0	!
		add	%g2,4,%g2	! update IAR
i.flm0e:

	.section ".text"
	.align	4
	.global ii4_n
ii4_n:
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i1		! save as %i1
	ld	[%i0+%i1],%l0		! %l0
	srl	%i3,16,%i5		! X2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l2		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l2		! %l2
	srl	%i3,12,%i5		! B2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l3		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l3		! %l3
	and	%i3,0xfff,%l4		! D2
i.n0s:
		add	%l2,%l3,%l2	! ##TEMPLATE:%l0,%l0
		add	%l2,%l4,%l2	! ##TEMPLATE:imm0
		and	%l2,%g3,%l2	! mask address

		andn	%l2,0xfff,%o1	! LD0-GS-TLB
		subcc	%g5,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g5,32,%o0	!
		call	ld1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l2,0xfff,%o1	!

		ld	[%o0+%o1],%l2	!
		mov	0,%g1		! CC=0
		andcc	%l0,%l2,%l0	! ##TEMPLATE:%l0,%l0
		st	%l0,[%i0+%i1]	! R1
		movnz	%icc,1,%g1	! if %l0 != 0 then CC=1
		ba	%icc,break0	!
		add	%g2,4,%g2	! update IAR
i.n0e:

	.section ".text"
	.align	4
	.global ii4_cl
ii4_cl:
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l0		! %l0
	srl	%i3,16,%i5		! X2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l2		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l2		! %l2
	srl	%i3,12,%i5		! B2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l3		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l3		! %l3
	and	%i3,0xfff,%l4		! D2
i.cl0s:
		add	%l2,%l3,%l2	! ##TEMPLATE:%l0,%l0
		add	%l2,%l4,%l2	! ##TEMPLATE:imm0
		and	%l2,%g3,%l2	! mask address

		andn	%l2,0xfff,%o1	! LD0-GS-TLB
		subcc	%g5,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g5,32,%o0	!
		call	ld1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l2,0xfff,%o1	!

		ld	[%o0+%o1],%l2	!
		mov	0,%g1		! CC=0
		subcc	%l0,%l2,%g0	! ##TEMPLATE:%l0
		movgu	%icc,2,%g1	! if %l0 > 0 then CC=2
		movcs	%icc,1,%g1	! if %l0 < 0 then CC=1
		ba	%icc,break0	!
		add	%g2,4,%g2	! update IAR
i.cl0e:

	.section ".text"
	.align	4
	.global ii4_o
ii4_o:
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i1		! save as %i1
	ld	[%i0+%i1],%l0		! %l0
	srl	%i3,16,%i5		! X2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l2		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l2		! %l2
	srl	%i3,12,%i5		! B2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l3		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l3		! %l3
	and	%i3,0xfff,%l4		! D2
i.o0s:
		add	%l2,%l3,%l2	! ##TEMPLATE:%l0,%l0
		add	%l2,%l4,%l2	! ##TEMPLATE:imm0
		and	%l2,%g3,%l2	! mask address

		andn	%l2,0xfff,%o1	! LD0-GS-TLB
		subcc	%g5,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g5,32,%o0	!
		call	ld1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l2,0xfff,%o1	!

		ld	[%o0+%o1],%l2	!
		mov	0,%g1		! CC=0
		orcc	%l0,%l2,%l0	! ##TEMPLATE:%l0,%l0
		st	%l0,[%i0+%i1]	! R1
		movnz	%icc,1,%g1	! if %l0 != 0 then CC=1
		ba	%icc,break0	!
		add	%g2,4,%g2	! update IAR
i.o0e:

	.section ".text"
	.align	4
	.global ii4_x
ii4_x:
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i1		! save as %i1
	ld	[%i0+%i1],%l0		! %l0
	srl	%i3,16,%i5		! X2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l2		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l2		! %l2
	srl	%i3,12,%i5		! B2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l3		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l3		! %l3
	and	%i3,0xfff,%l4		! D2
i.x0s:
		add	%l2,%l3,%l2	! ##TEMPLATE:%l0,%l0
		add	%l2,%l4,%l2	! ##TEMPLATE:imm0
		and	%l2,%g3,%l2	! mask address

		andn	%l2,0xfff,%o1	! LD0-GS-TLB
		subcc	%g5,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g5,32,%o0	!
		call	ld1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l2,0xfff,%o1	!

		ld	[%o0+%o1],%l2	!
		mov	0,%g1		! CC=0
		xorcc	%l0,%l2,%l0	! ##TEMPLATE:%l0,%l0
		st	%l0,[%i0+%i1]	! R1
		movnz	%icc,1,%g1	! if %l0 != 0 then CC=1
		ba	%icc,break0	!
		add	%g2,4,%g2	! update IAR
i.x0e:

	.section ".text"
	.align	4
	.global ii4_l
ii4_l:
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i1		! save as %i1
	srl	%i3,16,%i5		! X2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l2		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l2		! %l2
	srl	%i3,12,%i5		! B2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l3		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l3		! %l3
	and	%i3,0xfff,%l4		! D2
i.l0s:
		add	%l2,%l3,%l2	! ##TEMPLATE:%l0,%l0
		add	%l2,%l4,%l2	! ##TEMPLATE:imm0
		and	%l2,%g3,%l2	! mask address

		andn	%l2,0xfff,%o1	! LD0-GS-TLB
		subcc	%g5,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g5,32,%o0	!
		call	ld1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l2,0xfff,%o1	!

		ld	[%o0+%o1],%l0	! ##TEMPLATE:%l0
		st	%l0,[%i0+%i1]	! R1
		ba	%icc,break0	!
		add	%g2,4,%g2	! update IAR
i.l0e:

	.section ".text"
	.align	4
	.global ii4_c
ii4_c:
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l0		! %l0
	srl	%i3,16,%i5		! X2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l2		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l2		! %l2
	srl	%i3,12,%i5		! B2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l3		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l3		! %l3
	and	%i3,0xfff,%l4		! D2
i.c0s:
		add	%l2,%l3,%l2	! ##TEMPLATE:%l0,%l0
		add	%l2,%l4,%l2	! ##TEMPLATE:imm0
		and	%l2,%g3,%l2	! mask address

		andn	%l2,0xfff,%o1	! LD0-GS-TLB
		subcc	%g5,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g5,32,%o0	!
		call	ld1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l2,0xfff,%o1	!

		ld	[%o0+%o1],%l2	!
		mov	0,%g1		! CC=0
		subcc	%l0,%l2,%g0	! ##TEMPLATE:%l0
		movg	%icc,2,%g1	! if %l0 > 0 then CC=2
		movl	%icc,1,%g1	! if %l0 < 0 then CC=1
		ba	%icc,break0	!
		add	%g2,4,%g2	! update IAR
i.c0e:

	.section ".text"
	.align	4
	.global ii4_a
ii4_a:
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i1		! save as %i1
	ld	[%i0+%i1],%l0		! %l0
	srl	%i3,16,%i5		! X2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l2		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l2		! %l2
	srl	%i3,12,%i5		! B2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l3		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l3		! %l3
	and	%i3,0xfff,%l4		! D2
i.a0s:
		add	%l2,%l3,%l2	! ##TEMPLATE:%l0,%l0
		add	%l2,%l4,%l2	! ##TEMPLATE:imm0
		and	%l2,%g3,%l2	! mask address

		andn	%l2,0xfff,%o1	! LD0-GS-TLB
		subcc	%g5,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g5,32,%o0	!
		call	ld1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l2,0xfff,%o1	!

		ld	[%o0+%o1],%l2	!
		mov	0,%g1		! CC=0
		addcc	%l0,%l2,%l0	! ##TEMPLATE:%l0,%l0
		st	%l0,[%i0+%i1]	! R1
		movg	%icc,2,%g1	! if %l0 > 0 then CC=2
		movl	%icc,1,%g1	! if %l0 < 0 then CC=1
		bvc,a,pt %icc,break0	! if overflow then
		add	%g2,4,%g2	! update IAR
		mov	3,%g1		!
		andcc	%g7,8,%g0	!   CC=3
		bz,a	%icc,break0	!   if fixed-point overflow mask then
		add	%g2,4,%g2	! update IAR
		sethi	%hi(0x00080000),%o7
		ba	%icc,epilog0	!
		or	%g7,%o7,%g7	!     fixed-point overflow
i.a0e:

	.section ".text"
	.align	4
	.global ii4_s
ii4_s:
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i1		! save as %i1
	ld	[%i0+%i1],%l0		! %l0
	srl	%i3,16,%i5		! X2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l2		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l2		! %l2
	srl	%i3,12,%i5		! B2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l3		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l3		! %l3
	and	%i3,0xfff,%l4		! D2
i.s0s:
		add	%l2,%l3,%l2	! ##TEMPLATE:%l0,%l0
		add	%l2,%l4,%l2	! ##TEMPLATE:imm0
		and	%l2,%g3,%l2	! mask address

		andn	%l2,0xfff,%o1	! LD0-GS-TLB
		subcc	%g5,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g5,32,%o0	!
		call	ld1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l2,0xfff,%o1	!

		ld	[%o0+%o1],%l2	!
		mov	0,%g1		! CC=0
		subcc	%l0,%l2,%l0	! ##TEMPLATE:%l0,%l0
		st	%l0,[%i0+%i1]	! R1
		movg	%icc,2,%g1	! if %l0 > 0 then CC=2
		movl	%icc,1,%g1	! if %l0 < 0 then CC=1
		bvc,a,pt %icc,break0	! if overflow then
		add	%g2,4,%g2	! update IAR
		mov	3,%g1		!
		andcc	%g7,8,%g0	!   CC=3
		bz,a	%icc,break0	!   if fixed-point overflow mask then
		add	%g2,4,%g2	! update IAR
		sethi	%hi(0x00080000),%o7
		ba	%icc,epilog0	!
		or	%g7,%o7,%g7	!     fixed-point overflow
i.s0e:

	.section ".text"
	.align	4
	.global ii4_m
ii4_m:
	srl	%i3,20,%i5		! switch (R1)
	andcc	%i5,1,%g0		!
	bnz,pn	%icc,spec_exception	!
	nop				!
    i.m0t:				!
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i1		! save as %i1
	srl	%i3,20,%i5		! R1+1
	and	%i5,0xf,%i5		! |
	add	%i5,1,%i5		! |
	sll	%i5,2,%i2		! save as %i2
	ld	[%i0+%i2],%l1		! %l1
	srl	%i3,16,%i5		! X2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l2		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l2		! %l2
	srl	%i3,12,%i5		! B2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l3		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l3		! %l3
	and	%i3,0xfff,%l4		! D2
i.m0s:
		add	%l2,%l3,%l2	! ##TEMPLATE:%l0,%l0
		add	%l2,%l4,%l2	! ##TEMPLATE:imm0
		and	%l2,%g3,%l2	! mask address

		andn	%l2,0xfff,%o1	! LD0-GS-TLB
		subcc	%g5,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g5,32,%o0	!
		call	ld1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l2,0xfff,%o1	!

		ld	[%o0+%o1],%l2	!
		smul	%l1,%l2,%l1	! ##TEMPLATE:%l0,%l0
		rd	%y,%l0		! ##TEMPLATE:%l0
		st	%l0,[%i0+%i1]	! R1
		st	%l1,[%i0+%i2]	! R1+1
		ba	%icc,break0	!
		add	%g2,4,%g2	! update IAR
i.m0e:

	.section ".text"
	.align	4
	.global ii4_d
ii4_d:
	srl	%i3,20,%i5		! switch (R1)
	andcc	%i5,1,%g0		!
	bnz,pn	%icc,spec_exception	!
	nop				!
    i.d0t:				!
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i1		! save as %i1
	ld	[%i0+%i1],%l0		! %l0
	srl	%i3,20,%i5		! R1+1
	and	%i5,0xf,%i5		! |
	add	%i5,1,%i5		! |
	sll	%i5,2,%i2		! save as %i2
	ld	[%i0+%i2],%l1		! %l1
	srl	%i3,16,%i5		! X2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l2		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l2		! %l2
	srl	%i3,12,%i5		! B2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l3		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l3		! %l3
	and	%i3,0xfff,%l4		! D2
i.d0s:
		add	%l2,%l3,%l2	! ##TEMPLATE:%l0,%l0
		add	%l2,%l4,%l2	! ##TEMPLATE:imm0
		and	%l2,%g3,%l2	! mask address

		andn	%l2,0xfff,%o1	! LD0-GS-TLB
		subcc	%g5,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g5,32,%o0	!
		call	ld1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l2,0xfff,%o1	!

		ld	[%o0+%o1],%l2	!
		subcc	%l2,%g0,%g0	!
		bz,pn	%icc,i.d000	! if R2==0 then int-div. exception
		wr	%g0,%l0,%y	! ##TEMPLATE:%l0     R1
		sdivcc	%l1,%l2,%l0	! ##TEMPLATE:%l0     R1+1
		bvs,pn	%icc,i.d000	! if overflow then int-div.
		smul	%l0,%l2,%l2	!
		sub	%l1,%l2,%l1	! ##TEMPLATE:%l0,%l0 R1+1,R1
		st	%l1,[%i0+%i1]	! R1
		st	%l0,[%i0+%i2]	! R1+1
		ba	%icc,break0	!
		add	%g2,4,%g2	! update IAR
    i.d000:	sethi	%hi(0x00090000),%o7
		ba	%icc,epilog0	!
		or	%g7,%o7,%g7	! int-div. exception
i.d0e:

	.section ".text"
	.align	4
	.global ii4_al
ii4_al:
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i1		! save as %i1
	ld	[%i0+%i1],%l0		! %l0
	srl	%i3,16,%i5		! X2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l2		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l2		! %l2
	srl	%i3,12,%i5		! B2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l3		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l3		! %l3
	and	%i3,0xfff,%l4		! D2
i.al0s:
		add	%l2,%l3,%l2	! ##TEMPLATE:%l0,%l0
		add	%l2,%l4,%l2	! ##TEMPLATE:imm0
		and	%l2,%g3,%l2	! mask address

		andn	%l2,0xfff,%o1	! LD0-GS-TLB
		subcc	%g5,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g5,32,%o0	!
		call	ld1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l2,0xfff,%o1	!

		ld	[%o0+%o1],%l2	!
		mov	0,%g1		! CC=0
		addcc	%l0,%l2,%l0	! ##TEMPLATE:%l0,%l0
		st	%l0,[%i0+%i1]	! R1
		bcs,a,pn %icc,i.al000	! if carry then
		mov	2,%g1		!   CC|=2 & skip
		movnz	%icc,1,%g1	! if %l0 != 0 then CC=1
		ba	%icc,break0	!
		add	%g2,4,%g2	! update IAR
    i.al000:	movnz	%icc,3,%g1	! if %l0 != 0 then CC=3
		ba	%icc,break0	!
		add	%g2,4,%g2	! update IAR
i.al0e:

	.section ".text"
	.align	4
	.global ii4_sl
ii4_sl:
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i1		! save as %i1
	ld	[%i0+%i1],%l0		! %l0
	srl	%i3,16,%i5		! X2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l2		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l2		! %l2
	srl	%i3,12,%i5		! B2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l3		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l3		! %l3
	and	%i3,0xfff,%l4		! D2
i.sl0s:
		add	%l2,%l3,%l2	! ##TEMPLATE:%l0,%l0
		add	%l2,%l4,%l2	! ##TEMPLATE:imm0
		and	%l2,%g3,%l2	! mask address

		andn	%l2,0xfff,%o1	! LD0-GS-TLB
		subcc	%g5,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g5,32,%o0	!
		call	ld1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l2,0xfff,%o1	!

		ld	[%o0+%o1],%l2	!
		mov	0,%g1		! CC=0
		subcc	%l0,%l2,%l0	! ##TEMPLATE:%l0,%l0
		st	%l0,[%i0+%i1]	! R1
		bcc,a,pn %icc,i.sl000	! if !carry then
		mov	2,%g1		!   CC|=2 & skip
		movnz	%icc,1,%g1	! if %l0 != 0 then CC=1
		ba	%icc,break0	!
		add	%g2,4,%g2	! update IAR
    i.sl000:	movnz	%icc,3,%g1	! if %l0 != 0 then CC=3
		ba	%icc,break0	!
		add	%g2,4,%g2	! update IAR
i.sl0e:
!================================

!
! templates
!   %i0: struct gcpu_s*
!   %i3: M instruction (upper 4 bytes)
!
	.section ".text"
	.align	4
	.global ic4_ssm
ic4_ssm:
i.ssm0s:
		st	%i3,[%i0+704]	! store minsn (upper)
		st	%g0,[%i0+708]	! store minsn (lower)
		sethi	%hi(0x80000000),%o7
		ba	%icc,epilog0	!
		or	%g7,%o7,%g7	! Special Instruction (FC=2)
i.ssm0e:

	.section ".text"
	.align	4
	.global ic4_lpsw
ic4_lpsw:
i.lpsw0s:
		st	%i3,[%i0+704]	! store minsn (upper)
		st	%g0,[%i0+708]	! store minsn (lower)
		sethi	%hi(0x80000000),%o7
		ba	%icc,epilog0	!
		or	%g7,%o7,%g7	! Special Instruction (FC=2)
i.lpsw0e:

	.section ".text"
	.align	4
	.global ic4_diag
ic4_diag:
i.diag0s:
		st	%i3,[%i0+704]	! store minsn (upper)
		st	%g0,[%i0+708]	! store minsn (lower)
		sethi	%hi(0x80000000),%o7
		ba	%icc,epilog0	!
		or	%g7,%o7,%g7	! Special Instruction (FC=2)
i.diag0e:

	.section ".text"
	.align	4
	.global ii4_bxh
ii4_bxh:
	srl	%i3,16,%i5		! switch (R3)
	andcc	%i5,1,%g0		!
	bnz	%icc,i.bxh1t		!
	nop				!
    i.bxh0t:				!
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i1		! save as %i1
	ld	[%i0+%i1],%l0		! %l0
	srl	%i3,16,%i5		! R3
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l1		! %l1
	srl	%i3,16,%i5		! R3+1
	and	%i5,0xf,%i5		! |
	add	%i5,1,%i5		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l2		! %l2
	srl	%i3,12,%i5		! B2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l3		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l3		! %l3
	and	%i3,0xfff,%l4		! D2
	ba,a	%icc,i.bxh0s		!
	nop				!
    i.bxh1t:				!
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i1		! save as %i1
	ld	[%i0+%i1],%l0		! %l0
	srl	%i3,16,%i5		! R3
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l1		! %l1
	srl	%i3,12,%i5		! B2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l3		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l3		! %l3
	and	%i3,0xfff,%l4		! D2
	ba,a	%icc,i.bxh1s		!
	nop				!
i.bxh0s:
		add	%l0,%l1,%l0	! ##TEMPLATE:%l0,%l0,%l0 R1,R3,R1
		st	%l0,[%i0+%i1]	! R1
		subcc	%l0,%l2,%g0	! ##TEMPLATE:%l0 R1
		ble,a	%icc,break0	! if %l0 > %l2 then taken
		add	%g2,4,%g2	! update IAR
		add	%g2,%g0,%i2	! save OPC
		ba	%icc,break1	! BRANCH TAKEN
		add	%l3,%l4,%g2	!
i.bxh0e:
i.bxh1s:
		add	%l0,%l1,%l0	! ##TEMPLATE:%l0,%l0,%l0 R1,R3,R1
		st	%l0,[%i0+%i1]	! R1
		subcc	%l0,%l1,%g0	! ##TEMPLATE:%l0 R1
		ble,a	%icc,break0	! if %l0 > %l2 then taken
		add	%g2,4,%g2	! update IAR
		add	%g2,%g0,%i2	! save OPC
		ba	%icc,break1	! BRANCH TAKEN
		add	%l3,%l4,%g2	!
i.bxh1e:

	.section ".text"
	.align	4
	.global ii4_bxle
ii4_bxle:
	srl	%i3,16,%i5		! switch (R3)
	andcc	%i5,1,%g0		!
	bnz	%icc,i.bxle1t		!
	nop				!
    i.bxle0t:				!
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i1		! save as %i1
	ld	[%i0+%i1],%l0		! %l0
	srl	%i3,16,%i5		! R3
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l1		! %l1
	srl	%i3,16,%i5		! R3+1
	and	%i5,0xf,%i5		! |
	add	%i5,1,%i5		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l2		! %l2
	srl	%i3,12,%i5		! B2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l3		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l3		! %l3
	and	%i3,0xfff,%l4		! D2
	ba,a	%icc,i.bxle0s		!
	nop				!
    i.bxle1t:				!
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i1		! save as %i1
	ld	[%i0+%i1],%l0		! %l0
	srl	%i3,16,%i5		! R3
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l1		! %l1
	srl	%i3,12,%i5		! B2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l3		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l3		! %l3
	and	%i3,0xfff,%l4		! D2
	ba,a	%icc,i.bxle1s		!
	nop				!
i.bxle0s:
		add	%l0,%l1,%l0	! ##TEMPLATE:%l0,%l0,%l0 R1,R3,R1
		st	%l0,[%i0+%i1]	! R1
		subcc	%l0,%l2,%g0	! ##TEMPLATE:%l0 R1
		bg,a	%icc,break0	! if %l0 <= %l2 then taken
		add	%g2,4,%g2	! update IAR
		add	%g2,%g0,%i2	! save OPC
		ba	%icc,break1	! BRANCH TAKEN
		add	%l3,%l4,%g2	!
i.bxle0e:
i.bxle1s:
		add	%l0,%l1,%l0	! ##TEMPLATE:%l0,%l0,%l0 R1,R3,R1
		st	%l0,[%i0+%i1]	! R1
		subcc	%l0,%l1,%g0	! ##TEMPLATE:%l0 R1
		bg,a	%icc,break0	! if %l0 <= %l2 then taken
		add	%g2,4,%g2	! update IAR
		add	%g2,%g0,%i2	! save OPC
		ba	%icc,break1	! BRANCH TAKEN
		add	%l3,%l4,%g2	!
i.bxle1e:

	.section ".text"
	.align	4
	.global ii4_srl
ii4_srl:
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i1		! save as %i1
	ld	[%i0+%i1],%l0		! %l0
	srl	%i3,12,%i5		! B2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l3		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l3		! %l3
	and	%i3,0xfff,%l4		! D2
i.srl0s:
		add	%l3,%l4,%l2	! ##TEMPLATE:%l0,imm0 B2,D2
		and	%l2,0x3f,%l2	!
		srl	%l0,%l2,%l0	! ##TEMPLATE:%l0,%l0 R1,R1
		subcc	%l2,31,%g0	!
		movg	%icc,0,%l0	!
		st	%l0,[%i0+%i1]	! R1
		ba	%icc,break0	!
		add	%g2,4,%g2	! update IAR
i.srl0e:

	.section ".text"
	.align	4
	.global ii4_sll
ii4_sll:
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i1		! save as %i1
	ld	[%i0+%i1],%l0		! %l0
	srl	%i3,12,%i5		! B2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l3		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l3		! %l3
	and	%i3,0xfff,%l4		! D2
i.sll0s:
		add	%l3,%l4,%l2	! ##TEMPLATE:%l0,imm0 B2,D2
		and	%l2,0x3f,%l2	!
		sll	%l0,%l2,%l0	! ##TEMPLATE:%l0,%l0 R1,R1
		subcc	%l2,31,%g0	!
		movg	%icc,0,%l0	!
		st	%l0,[%i0+%i1]	! R1
		ba	%icc,break0	!
		add	%g2,4,%g2	! update IAR
i.sll0e:

	.section ".text"
	.align	4
	.global ii4_sra
ii4_sra:
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i1		! save as %i1
	ld	[%i0+%i1],%l0		! %l0
	srl	%i3,12,%i5		! B2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l3		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l3		! %l3
	and	%i3,0xfff,%l4		! D2
i.sra0s:
		mov	0,%g1		! CC=0
		add	%l3,%l4,%l2	! ##TEMPLATE:%l0,imm0 B2,D2
		and	%l2,0x3f,%l2	!
		subcc	%l2,31,%g0	!
		movg	%icc,31,%l2	!
		sra	%l0,%l2,%l0	! ##TEMPLATE:%l0,%l0 R1,R1
		st	%l0,[%i0+%i1]	! R1
		subcc	%l0,%g0,%g0	! ##TEMPLATE:%l0 R1
		movg	%icc,2,%g1	! if %l0 > 0 then CC=2
		movl	%icc,1,%g1	! if %l0 < 0 then CC=1
		ba	%icc,break0	!
		add	%g2,4,%g2	! update IAR
i.sra0e:

	.section ".text"
	.align	4
	.global ii4_sla
ii4_sla:
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i1		! save as %i1
	ld	[%i0+%i1],%l0		! %l0
	srl	%i3,12,%i5		! B2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l3		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l3		! %l3
	and	%i3,0xfff,%l4		! D2
i.sla0s:
		mov	0,%g1		! CC=0
		add	%l3,%l4,%l2	! ##TEMPLATE:%l0,imm0 B2,D2
		and	%l2,0x3f,%l2	!
		subcc	%l2,31,%g0	!
		movg	%icc,31,%l2	!
		sethi	%hi(0x80000000),%o7
		and	%l0,%o7,%l4	! extract sign
		sll	%l0,%l2,%l5	!
		andn	%l5,%o7,%l5	!
		or	%l4,%l5,%l4	! ##TEMPLATE:%l0 R1
		st	%l4,[%i0+%i1]	! R1
		subcc	%l4,%g0,%g0	! ##TEMPLATE:%l0 R1
		movg	%icc,2,%g1	! if %l0 > 0 then CC=2
		movl	%icc,1,%g1	! if %l0 < 0 then CC=1
		sra	%l4,%l2,%l2	! ##TEMPLATE:%l0 R1
		subcc	%l0,%l2,%g0	!
		be,a,pt %icc,break0	! if overflow then
		add	%g2,4,%g2	! update IAR
		mov	3,%g1		!
		andcc	%g7,8,%g0	!   CC=3
		bz,a	%icc,break0	!   if fixed-point overflow mask then
		add	%g2,4,%g2	! update IAR
		sethi	%hi(0x00080000),%o7
		ba	%icc,epilog0	!
		or	%g7,%o7,%g7	!     fixed-point overflow
i.sla0e:

	.section ".text"
	.align	4
	.global	ii4_srdl
ii4_srdl:
	srl	%i3,20,%i5		! switch (R1)
	andcc	%i5,1,%g0		!
	bnz,pn	%icc,spec_exception	!
	nop				!
    i.srdl0t:				!
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i1		! save as %i1
	ld	[%i0+%i1],%l0		! %l0
	srl	%i3,20,%i5		! R1+1
	and	%i5,0xf,%i5		! |
	add	%i5,1,%i5		! |
	sll	%i5,2,%i2		! save as %i2
	ld	[%i0+%i2],%l1		! %l1
	srl	%i3,12,%i5		! B2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l3		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l3		! %l3
	and	%i3,0xfff,%l4		! D2
i.srdl0s:
		add	%l3,%l4,%l2	! ##TEMPLATE:%l0,imm0 B2,D2
		andcc	%l2,0x3f,%l2	!
		bz,pn	%icc,i.srdl000	! if SHIFT == 0 then do nothing
		subcc	%l2,31,%g0	!
		bg,pn	%icc,i.srdl001	! if SHIFT >= 32 then skip
		sub	%l2,32,%l3	!
		sub	%g0,%l3,%l3	!
		srl	%l1,%l2,%l1	! ##TEMPLATE:%l0,%l0 R1+1,R1+1
		sll	%l0,%l3,%l3	! ##TEMPLATE:%l0 R1
		or	%l1,%l3,%l1	! ##TEMPLATE:%l0,%l0 R1+1,R1+1
		ba	%icc,i.srdl000	!
		srl	%l0,%l2,%l0	! ##TEMPLATE:%l0,%l0 R1,R1
    i.srdl001:	srl	%l0,%l3,%l1	! ##TEMPLATE:%l0,%l0 R1,R1+1
		mov	0,%l0		! ##TEMPLATE:%l0 R1
    i.srdl000:	st	%l0,[%i0+%i1]	! R1
		st	%l1,[%i0+%i2]	! R1+1
		ba	%icc,break0	!
		add	%g2,4,%g2	! update IAR
i.srdl0e:

	.section ".text"
	.align	4
	.global ii4_sldl
ii4_sldl:
	srl	%i3,20,%i5		! switch (R1)
	andcc	%i5,1,%g0		!
	bnz,pn	%icc,spec_exception	!
	nop				!
    i.sldl0t:				!
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i1		! save as %i1
	ld	[%i0+%i1],%l0		! %l0
	srl	%i3,20,%i5		! R1+1
	and	%i5,0xf,%i5		! |
	add	%i5,1,%i5		! |
	sll	%i5,2,%i2		! save as %i2
	ld	[%i0+%i2],%l1		! %l1
	srl	%i3,12,%i5		! B2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l3		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l3		! %l3
	and	%i3,0xfff,%l4		! D2
i.sldl0s:
		add	%l3,%l4,%l2	! ##TEMPLATE:%l0,imm0 B2,D2
		andcc	%l2,0x3f,%l2	!
		bz,pn	%icc,i.sldl000	! if SHIFT == 0 then do nothing
		subcc	%l2,31,%g0	!
		bg,pn	%icc,i.sldl001	! if SHIFT >= 32 then skip
		sub	%l2,32,%l3	!
		sub	%g0,%l3,%l3	!
		sll	%l0,%l2,%l0	! ##TEMPLATE:%l0,%l0 R1,R1
		srl	%l1,%l3,%l3	! ##TEMPLATE:%l0 R1+1
		or	%l0,%l3,%l0	! ##TEMPLATE:%l0,%l0 R1,R1
		ba	%icc,i.sldl000	!
		sll	%l1,%l2,%l1	! ##TEMPLATE:%l0,%l0 R1+1,R1+1
    i.sldl001:	sll	%l1,%l3,%l0	! ##TEMPLATE:%l0,%l0 R1+1,R1
		mov	0,%l1		! ##TEMPLATE:%l0 R1+1
    i.sldl000:	st	%l0,[%i0+%i1]	! R1
		st	%l1,[%i0+%i2]	! R1+1
		ba	%icc,break0	!
		add	%g2,4,%g2	! update IAR
i.sldl0e:

	.section ".text"
	.align	4
	.global ii4_srda
ii4_srda:
	srl	%i3,20,%i5		! switch (R1)
	andcc	%i5,1,%g0		!
	bnz,pn	%icc,spec_exception	!
	nop				!
    i.srda0t:				!
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i1		! save as %i1
	ld	[%i0+%i1],%l0		! %l0
	srl	%i3,20,%i5		! R1+1
	and	%i5,0xf,%i5		! |
	add	%i5,1,%i5		! |
	sll	%i5,2,%i2		! save as %i2
	ld	[%i0+%i2],%l1		! %l1
	srl	%i3,12,%i5		! B2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l3		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l3		! %l3
	and	%i3,0xfff,%l4		! D2
i.srda0s:
		mov	0,%g1		! CC=0
		add	%l3,%l4,%l2	! ##TEMPLATE:%l0,imm0 B2,D2
		andcc	%l2,0x3f,%l2	!
		bz,pn	%icc,i.srda000	! if SHIFT == 0 then do nothing
		subcc	%l2,31,%g0	!
		bg,pn	%icc,i.srda003	! if SHIFT >= 32 then skip
		sub	%l2,32,%l3	!
		sub	%g0,%l3,%l3	!
		srl	%l1,%l2,%l1	! ##TEMPLATE:%l0,%l0 R1+1,R1+1
		sll	%l0,%l3,%l3	! ##TEMPLATE:%l0 R1
		or	%l1,%l3,%l1	! ##TEMPLATE:%l0,%l0 R1+1,R1+1
		ba	%icc,i.srda000	!
		sra	%l0,%l2,%l0	! ##TEMPLATE:%l0,%l0 R1,R1
    i.srda003:	sra	%l0,%l3,%l1	! ##TEMPLATE:%l0,%l0 R1,R1+1
		sra	%l0,31,%l0	! ##TEMPLATE:%l0,%l0 R1,R1
    i.srda000:	st	%l0,[%i0+%i1]	! R1
		st	%l1,[%i0+%i2]	! R1+1
		subcc	%l0,%g0,%g0	! ##TEMPLATE:%l0 R1
		bz,a	%icc,i.srda001	!
		subcc	%l1,%g0,%g0	! ##TEMPLATE:%l0 R1+1
		movg	%icc,2,%g1	! if %l0 > 0 then CC=2
		movl	%icc,1,%g1	! if %l0 < 0 then CC=1
		ba	%icc,break0	!
		add	%g2,4,%g2	! update IAR
    i.srda001:	movnz	%icc,2,%g1	! if %l0+1 != 0 then CC=2
		ba	%icc,break0	!
		add	%g2,4,%g2	! update IAR
i.srda0e:

	.section ".text"
	.align	4
	.global ii4_slda
ii4_slda:
	srl	%i3,20,%i5		! switch (R1)
	andcc	%i5,1,%g0		!
	bnz,pn	%icc,spec_exception	!
	nop				!
    i.slda0t:				!
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i1		! save as %i1
	ld	[%i0+%i1],%l0		! %l0
	srl	%i3,20,%i5		! R1+1
	and	%i5,0xf,%i5		! |
	add	%i5,1,%i5		! |
	sll	%i5,2,%i2		! save as %i2
	ld	[%i0+%i2],%l1		! %l1
	srl	%i3,12,%i5		! B2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l3		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l3		! %l3
	and	%i3,0xfff,%l4		! D2
i.slda0s:
		mov	0,%g1		! CC=0
		add	%l3,%l4,%l2	! ##TEMPLATE:%l0,imm0 B2,D2
		andcc	%l2,0x3f,%l2	!
		bnz,pt	%icc,i.slda005	! if SHIFT == 0 then do nothing
		mov	%l0,%l4		!
		mov	%l1,%l5		!
		mov	%l0,%l2		!
		ba	%icc,i.slda000	!
		mov	%l1,%l3		!
    i.slda005:	sethi	%hi(0x80000000),%o7
		and	%l0,%o7,%l4	! extract sign
		subcc	%l2,31,%g0	!
		bg,pn	%icc,i.slda003	! if SHIFT >= 32 then skip
		sub	%l2,32,%l3	!
		sub	%g0,%l3,%l3	!
		sll	%l0,%l2,%l5	!
		srl	%l1,%l3,%l3	!
		or	%l5,%l3,%l3	!
		andn	%l3,%o7,%l3	!
		or	%l3,%l4,%l4	! ##TEMPLATE:%l0 R1
		sll	%l1,%l2,%l5	! ##TEMPLATE:%l0,%l0 R1+1,R1+1
		sra	%l4,%l2,%l2	! ##TEMPLATE:%l0 R1
		ba	%icc,i.slda000	!
		mov	%l1,%l3		!
    i.slda003:	sll	%l1,%l3,%l5	!
		andn	%l5,%o7,%l5	!
		or	%l5,%l4,%l4	! ##TEMPLATE:%l0 R1
		mov	%g0,%l5		! ##TEMPLATE:%l0 R1+1
		sra	%l4,31,%l2	! ##TEMPLATE:%l0 R1
		sra	%l4,%l3,%l3	! ##TEMPLATE:%l0 R1
    i.slda000:	st	%l4,[%i0+%i1]	! R1
		st	%l5,[%i0+%i2]	! R1+1
		subcc	%l4,%g0,%g0	! ##TEMPLATE:%l0 R1
		bz,a	%icc,i.slda004	!
		subcc	%l5,%g0,%g0	! ##TEMPLATE:%l0 R1+1
		movg	%icc,2,%g1	! if %l0 > 0 then CC=2
		movl	%icc,1,%g1	! if %l0 < 0 then CC=1
		ba,a	%icc,i.slda001	!
    i.slda004:	movnz	%icc,2,%g1	! if %l0+1 != 0 then CC=2
    i.slda001:	subcc	%l0,%l2,%g0	!
		bne,pn	%icc,i.slda002	! if overflow then
		subcc	%l1,%l3,%g0	!
		be,a,pt	%icc,break0	!
		add	%g2,4,%g2	! update IAR
    i.slda002:	mov	3,%g1		!
		andcc	%g7,8,%g0	!   CC=3
		bz,a	%icc,break0	!   if fixed-point overflow mask then
		add	%g2,4,%g2	! update IAR
		sethi	%hi(0x00080000),%o7
		ba	%icc,epilog0	!
		or	%g7,%o7,%g7	!     fixed-point overflow
i.slda0e:
!================================

!
! templates
!   %i0: struct gcpu_s*
!   %i3: M instruction (upper 4 bytes)
!
	.section ".text"
	.align	4
	.global ii4_stm
ii4_stm:
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i1		! %i1
	srl	%i3,16,%i5		! R3-R1+3
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	sub	%i5,%i1,%i5		! |
	and	%i5,0x3f,%i5		! length-1
	add	%i5,3,%i2		! %i2
	srl	%i3,12,%i5		! B2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l3		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l3		! %l3
	and	%i3,0xfff,%l4		! D2
i.stm0s:
		add	%l3,%l4,%l2	! ##TEMPLATE:%l0,imm0
		and	%l2,%g3,%l2	! mask address
		add	%l2,%i2,%l3	!
		and	%l3,%g3,%l3	! mask address

		andncc	%l3,0x1ff,%g0	! check LAP
		bnz,pt	%icc,.+12	!
		andcc	%g7,0x20,%g0	!
		tnz	%icc,0x43	! LAP exception
					!
		andn	%l3,0xfff,%o1	! ST0-GS-TLB
		subcc	%g6,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g6,32,%o0	!
		call	st1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l3,0xfff,%o1	!
		mov	%o0,%l3		! save base1

		andncc	%l2,0x1ff,%g0	! check LAP
		bnz,pt	%icc,.+12	!
		andcc	%g7,0x20,%g0	!
		tnz	%icc,0x43	! LAP exception
					!
		andn	%l2,0xfff,%o1	! ST0-GS-TLB
		subcc	%g6,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g6,32,%o0	!
		call	st1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l2,0xfff,%o1	!
		mov	%l3,%o2		! restore base1
	! %o0: base0
	! %o1: offset0
	! %o2: base1
    i.stm000:	ld	[%i0+%i1],%l0	! R1->R3
		add	%i1,4,%i1	!
		and	%i1,0x3f,%i1	!
		st	%l0,[%o0+%o1]	! ##TEMPLATE:%l0
		add	%o1,4,%o1	!
		subcc	%o1,0xfff,%g0	! if page cross
		movgu	%icc,%o2,%o0	!   base1 -> base0
		subcc	%i2,4,%i2	!
		bg,a,pt	%icc,i.stm000	!
		and	%o1,0xfff,%o1	!
		ba	%icc,break0	!
		add	%g2,4,%g2	! update IAR
i.stm0e:

	.section ".text"
	.align	4
	.global ii4_tm
ii4_tm:
	srl	%i3,16,%i5		! I
	and	%i5,0xff,%l1		! %l1
	srl	%i3,12,%i5		! B2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l3		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l3		! %l3
	and	%i3,0xfff,%l4		! D2
i.tm0s:
		add	%l3,%l4,%l2	! ##TEMPLATE:%l0,imm0
		and	%l2,%g3,%l2	! mask address

		andn	%l2,0xfff,%o1	! LD0-GS-TLB
		subcc	%g5,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g5,32,%o0	!
		call	ld1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l2,0xfff,%o1	!

		ldub	[%o0+%o1],%l2	!
		add	%g2,4,%g2	! update IAR
		andcc	%l2,%l1,%l0	! ##TEMPLATE:imm0
		bz,a,pn	%icc,break0	! if result == 0    then CC=0
		mov	0,%g1		!
		subcc	%l1,%l0,%g0	! ##TEMPLATE:imm0
		movnz	%icc,1,%g1	! if result != mask then CC=1
		ba	%icc,break0	!
		movz	%icc,3,%g1	! if result == mask then CC=3
i.tm0e:

	.section ".text"
	.align	4
	.global ii4_mvi
ii4_mvi:
	srl	%i3,16,%i5		! I
	and	%i5,0xff,%l1		! %l1
	srl	%i3,12,%i5		! B2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l3		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l3		! %l3
	and	%i3,0xfff,%l4		! D2
i.mvi0s:
		add	%l3,%l4,%l2	! ##TEMPLATE:%l0,imm0
		and	%l2,%g3,%l2	! mask address

		andncc	%l2,0x1ff,%g0	! check LAP
		bnz,pt	%icc,.+12	!
		andcc	%g7,0x20,%g0	!
		tnz	%icc,0x43	! LAP exception
					!
		andn	%l2,0xfff,%o1	! ST0-GS-TLB
		subcc	%g6,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g6,32,%o0	!
		call	st1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l2,0xfff,%o1	!

		stb	%l1,[%o0+%o1]	!
		ba	%icc,break0	!
		add	%g2,4,%g2	! update IAR
i.mvi0e:

	.section ".text"
	.align	4
	.global ii4_ts
ii4_ts:
	srl	%i3,12,%i5		! B2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l3		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l3		! %l3
	and	%i3,0xfff,%l4		! D2
i.ts0s:
		add	%l3,%l4,%l2	! ##TEMPLATE:%l0,imm0
		and	%l2,%g3,%l2	! mask address

		andncc	%l2,0x1ff,%g0	! check LAP
		bnz,pt	%icc,.+12	!
		andcc	%g7,0x20,%g0	!
		tnz	%icc,0x43	! LAP exception
					!
		andn	%l2,0xfff,%o1	! ST0-GS-TLB
		subcc	%g6,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g6,32,%o0	!
		call	st1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l2,0xfff,%o1	!

		ldub	[%o0+%o1],%l2	!
		mov	0,%g1		! CC=0
		add	%g0,0xff,%l0	!
		stb	%l0,[%o0+%o1]	! store 0xff
		andcc	%l2,0x80,%g0	!
		movnz	%icc,1,%g1	! if MSB == 1 then CC=1
		ba	%icc,break0	!
		add	%g2,4,%g2	! update IAR
i.ts0e:

	.section ".text"
	.align	4
	.global ii4_ni
ii4_ni:
	srl	%i3,16,%i5		! I
	and	%i5,0xff,%l1		! %l1
	srl	%i3,12,%i5		! B2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l3		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l3		! %l3
	and	%i3,0xfff,%l4		! D2
i.ni0s:
		add	%l3,%l4,%l2	! ##TEMPLATE:%l0,imm0
		and	%l2,%g3,%l2	! mask address

		andncc	%l2,0x1ff,%g0	! check LAP
		bnz,pt	%icc,.+12	!
		andcc	%g7,0x20,%g0	!
		tnz	%icc,0x43	! LAP exception
					!
		andn	%l2,0xfff,%o1	! ST0-GS-TLB
		subcc	%g6,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g6,32,%o0	!
		call	st1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l2,0xfff,%o1	!

		ldub	[%o0+%o1],%l2	!
		mov	0,%g1		! CC=0
		andcc	%l2,%l1,%l0	! ##TEMPLATE:imm0
		stb	%l0,[%o0+%o1]	!
		movnz	%icc,1,%g1	! if result != 0 then CC=1
		ba	%icc,break0	!
		add	%g2,4,%g2	! update IAR
i.ni0e:

	.section ".text"
	.align	4
	.global ii4_cli
ii4_cli:
	srl	%i3,16,%i5		! I
	and	%i5,0xff,%l1		! %l1
	srl	%i3,12,%i5		! B2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l3		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l3		! %l3
	and	%i3,0xfff,%l4		! D2
i.cli0s:
		add	%l3,%l4,%l2	! ##TEMPLATE:%l0,imm0
		and	%l2,%g3,%l2	! mask address

		andn	%l2,0xfff,%o1	! LD0-GS-TLB
		subcc	%g5,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g5,32,%o0	!
		call	ld1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l2,0xfff,%o1	!

		ldub	[%o0+%o1],%l2	!
		mov	0,%g1		! CC=0
		subcc	%l2,%l1,%g0	! ##TEMPLATE:imm0
		movgu	%icc,2,%g1	! if %l0 > 0 then CC=2
		movcs	%icc,1,%g1	! if %l0 < 0 then CC=1
		ba	%icc,break0	!
		add	%g2,4,%g2	! update IAR
i.cli0e:

	.section ".text"
	.align	4
	.global ii4_oi
ii4_oi:
	srl	%i3,16,%i5		! I
	and	%i5,0xff,%l1		! %l1
	srl	%i3,12,%i5		! B2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l3		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l3		! %l3
	and	%i3,0xfff,%l4		! D2
i.oi0s:
		add	%l3,%l4,%l2	! ##TEMPLATE:%l0,imm0
		and	%l2,%g3,%l2	! mask address

		andncc	%l2,0x1ff,%g0	! check LAP
		bnz,pt	%icc,.+12	!
		andcc	%g7,0x20,%g0	!
		tnz	%icc,0x43	! LAP exception
					!
		andn	%l2,0xfff,%o1	! ST0-GS-TLB
		subcc	%g6,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g6,32,%o0	!
		call	st1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l2,0xfff,%o1	!

		ldub	[%o0+%o1],%l2	!
		mov	0,%g1		! CC=0
		orcc	%l2,%l1,%l0	! ##TEMPLATE:imm0
		stb	%l0,[%o0+%o1]	!
		movnz	%icc,1,%g1	! if result != 0 then CC=1
		ba	%icc,break0	!
		add	%g2,4,%g2	! update IAR
i.oi0e:

	.section ".text"
	.align	4
	.global ii4_xi
ii4_xi:
	srl	%i3,16,%i5		! I
	and	%i5,0xff,%l1		! %l1
	srl	%i3,12,%i5		! B2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l3		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l3		! %l3
	and	%i3,0xfff,%l4		! D2
i.xi0s:
		add	%l3,%l4,%l2	! ##TEMPLATE:%l0,imm0
		and	%l2,%g3,%l2	! mask address

		andncc	%l2,0x1ff,%g0	! check LAP
		bnz,pt	%icc,.+12	!
		andcc	%g7,0x20,%g0	!
		tnz	%icc,0x43	! LAP exception
					!
		andn	%l2,0xfff,%o1	! ST0-GS-TLB
		subcc	%g6,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g6,32,%o0	!
		call	st1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l2,0xfff,%o1	!

		ldub	[%o0+%o1],%l2	!
		mov	0,%g1		! CC=0
		xorcc	%l2,%l1,%l0	! ##TEMPLATE:imm0
		stb	%l0,[%o0+%o1]	!
		movnz	%icc,1,%g1	! if result != 0 then CC=1
		ba	%icc,break0	!
		add	%g2,4,%g2	! update IAR
i.xi0e:

	.section ".text"
	.align	4
	.global ii4_lm
ii4_lm:
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i1		! %i1
	srl	%i3,16,%i5		! R3-R1+3
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	sub	%i5,%i1,%i5		! |
	and	%i5,0x3f,%i5		! length-1
	add	%i5,3,%i2		! %i2
	srl	%i3,12,%i5		! B2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l3		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l3		! %l3
	and	%i3,0xfff,%l4		! D2
i.lm0s:
		add	%l3,%l4,%l2	! ##TEMPLATE:%l0,imm0
		and	%l2,%g3,%l2	! mask address
		add	%l2,%i2,%l3	!
		and	%l3,%g3,%l3	! mask address

		andn	%l3,0xfff,%o1	! LD0-GS-TLB
		subcc	%g5,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g5,32,%o0	!
		call	ld1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l3,0xfff,%o1	!
		mov	%o0,%l3		! save base1

		andn	%l2,0xfff,%o1	! LD0-GS-TLB
		subcc	%g5,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g5,32,%o0	!
		call	ld1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l2,0xfff,%o1	!
		mov	%l3,%o2		! restore base1
	! %o0: base0
	! %o1: offset0
	! %o2: base1
    i.lm000:	ld	[%o0+%o1],%l0	! ##TEMPLATE:%l0
		add	%o1,4,%o1	!
		subcc	%o1,0xfff,%g0	! if page cross
		movgu	%icc,%o2,%o0	!   base1 -> base0
		and	%o1,0xfff,%o1	!
		st	%l0,[%i0+%i1]	! R1->R3
		add	%i1,4,%i1	!
		subcc	%i2,4,%i2	!
		bg,a,pt	%icc,i.lm000	!
		and	%i1,0x3f,%i1	!
		ba	%icc,break0	!
		add	%g2,4,%g2	! update IAR
i.lm0e:

	.section ".text"
	.align	4
	.global ic4_9cxx
ic4_9cxx:
i.9cxx0s:
		st	%i3,[%i0+704]	! store minsn (upper)
		st	%g0,[%i0+708]	! store minsn (lower)
		sethi	%hi(0x80000000),%o7
		ba	%icc,epilog0	!
		or	%g7,%o7,%g7	! Special Instruction (FC=2)
i.9cxx0e:

	.section ".text"
	.align	4
	.global ic4_9dxx
ic4_9dxx:
i.9dxx0s:
		st	%i3,[%i0+704]	! store minsn (upper)
		st	%g0,[%i0+708]	! store minsn (lower)
		sethi	%hi(0x80000000),%o7
		ba	%icc,epilog0	!
		or	%g7,%o7,%g7	! Special Instruction (FC=2)
i.9dxx0e:

	.section ".text"
	.align	4
	.global ic4_9exx
ic4_9exx:
i.9exx0s:
		st	%i3,[%i0+704]	! store minsn (upper)
		st	%g0,[%i0+708]	! store minsn (lower)
		sethi	%hi(0x80000000),%o7
		ba	%icc,epilog0	!
		or	%g7,%o7,%g7	! Special Instruction (FC=2)
i.9exx0e:

	.section ".text"
	.align	4
	.global ic4_9fxx
ic4_9fxx:
i.9fxx0s:
		st	%i3,[%i0+704]	! store minsn (upper)
		st	%g0,[%i0+708]	! store minsn (lower)
		sethi	%hi(0x80000000),%o7
		ba	%icc,epilog0	!
		or	%g7,%o7,%g7	! Special Instruction (FC=2)
i.9fxx0e:
!================================

!
! templates
!   %i0: struct gcpu_s*
!   %i3: M instruction (upper 4 bytes)
!
	.section ".text"
	.align	4
	.global ii4_ai
ii4_ai:
	srl	%i3,16,%i5		! I
	and	%i5,0xff,%l1		! %l1
	srl	%i3,12,%i5		! B2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l3		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l3		! %l3
	and	%i3,0xfff,%l4		! D2
i.ai0s:
		add	%l3,%l4,%l2	! ##TEMPLATE:%l0,imm0
		and	%l2,%g3,%l2	! mask address

		andncc	%l2,0x1ff,%g0	! check LAP
		bnz,pt	%icc,.+12	!
		andcc	%g7,0x20,%g0	!
		tnz	%icc,0x43	! LAP exception
					!
		andn	%l2,0xfff,%o1	! ST0-GS-TLB
		subcc	%g6,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g6,32,%o0	!
		call	st1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l2,0xfff,%o1	!

		ldub	[%o0+%o1],%l2	!
		mov	0,%g1		! CC=0
		add	%l2,%l1,%l0	! ##TEMPLATE:imm0
		stb	%l0,[%o0+%o1]	!
		andcc	%l0,0xff,%g0	!
		movnz	%icc,1,%g1	! if result != 0 then CC=1,3
		andncc	%l0,0xff,%g0	!
		bnz,a	%icc,i.ai001	! if carry then
		or	%g1,2,%g1	!   CC=2,4
    i.ai001:	ba	%icc,break0	!
		add	%g2,4,%g2	! update IAR
i.ai0e:

	.section ".text"
	.align	4
	.global	ii4_stext
ii4_stext:
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l0		! %l0
	srl	%i3,16,%i5		! R3
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l1		! %l1
	srl	%i3,12,%i5		! B2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l3		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l3		! %l3
	and	%i3,0xfff,%l4		! D2
i.stext0s:
		add	%l3,%l4,%l2	! ##TEMPLATE:%l0,imm0
		and	%l2,%g3,%l2	! mask address

		andncc	%l2,0x1ff,%g0	! check LAP
		bnz,pt	%icc,.+12	!
		andcc	%g7,0x20,%g0	!
		tnz	%icc,0x43	! LAP exception
					!
		andn	%l2,0xfff,%o1	! ST0-GS-TLB
		subcc	%g6,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g6,32,%o0	!
		call	st1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l2,0xfff,%o1	!

		ld	[%o0+%o1],%l2	!
		and	%l0,%l1,%l0	! ##TEMPLATE:%l0,%l0
		andn	%l2,%l1,%l2	! ##TEMPLATE:%l0
		or	%l0,%l2,%l0	!
		st	%l0,[%o0+%o1]	!
		ba	%icc,break0	!
		add	%g2,4,%g2	! update IAR
i.stext0e:

	.section ".text"
	.align	4
	.global ii4_svg
ii4_svg:
	srl	%i3,20,%i4		! R1
	and	%i4,0xf,%i4		!
	srl	%i3,16,%i5		! R3
	and	%i5,0xf,%i5		!	
	sub	%i5,%i4,%i7		!
	and	%i7,0xf,%i7		! # of Regs.
	sub	%i5,13,%i5		!
	and	%i5,0xf,%i5		! # of Regs. after #13
	subcc	%i7,%i5,%g0		!
	bge,pn	%icc,spec_exception	!
	nop				!
    i.svg0t:				!
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i1		! %i1
	srl	%i3,16,%i5		! R3
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i2		! %i2
	srl	%i3,12,%i5		! B2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l3		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l3		! %l3
	and	%i3,0xfff,%l4		! D2
i.svg0s:
		add	%l3,%l4,%l2	! ##TEMPLATE:%l0,imm0
		and	%l2,%g3,%l4	! mask address

		andncc	%l4,0x1ff,%g0	! check LAP
		bnz,pt	%icc,.+12	!
		andcc	%g7,0x20,%g0	!
		tnz	%icc,0x43	! LAP exception
					!
		andn	%l4,0xfff,%o1	! ST0-GS-TLB
		subcc	%g6,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g6,32,%o0	!
		call	st1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l4,0xfff,%o1	!
		! result discarded (pagein only)

		sethi	%hi(0xff000000),%o7
		ld	[%i0+52],%l3	! load #13
		andn	%l3,%o7,%l5	!
		add	%l5,8,%l5	! top-address
		add	%i2,8,%l6	!
		and	%l6,0x3f,%l6	!
		add	%l6,7,%l6	!
		add	%l5,%l6,%l6	! bot-address

		andncc	%l6,0x1ff,%g0	! check LAP
		bnz,pt	%icc,.+12	!
		andcc	%g7,0x20,%g0	!
		tnz	%icc,0x43	! LAP exception
					!
		andn	%l6,0xfff,%o1	! ST0-GS-TLB
		subcc	%g6,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g6,32,%o0	!
		call	st1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l6,0xfff,%o1	!
		mov	%o0,%l6		! save base1

		andncc	%l5,0x1ff,%g0	! check LAP
		bnz,pt	%icc,.+12	!
		andcc	%g7,0x20,%g0	!
		tnz	%icc,0x43	! LAP exception
					!
		andn	%l5,0xfff,%o1	! ST0-GS-TLB
		subcc	%g6,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g6,32,%o0	!
		call	st1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l5,0xfff,%o1	!
		mov	%l6,%o2		! restore base1
	! %o0: base0
	! %o1: offset0
	! %o2: base1
		st	%l2,[%o0+%o1]	! store OP2
		add	%i1,8,%i3	!
		and	%i3,0x3f,%i3	!
		add	%i3,4,%i3	!
		add	%o1,%i3,%o1	!
		subcc	%o1,0xfff,%g0	! if page cross
		movgu	%icc,%o2,%o0	!   base1 -> base0
		and	%o1,0xfff,%o1	!
    i.svg000:	ld	[%i0+%i1],%l0	! R1->R3
		add	%i1,4,%i1	!
		and	%i1,0x3f,%i1	!
		st	%l0,[%o0+%o1]	!
		add	%o1,4,%o1	!
		subcc	%o1,0xfff,%g0	! if page cross
		movgu	%icc,%o2,%o0	!   base1 -> base0
		subcc	%i1,%i2,%g0	!
		bne,pt	%icc,i.svg000	!
		and	%o1,0xfff,%o1	!

		andncc	%l4,0x1ff,%g0	! check LAP
		bnz,pt	%icc,.+12	!
		andcc	%g7,0x20,%g0	!
		tnz	%icc,0x43	! LAP exception
					!
		andn	%l4,0xfff,%o1	! ST0-GS-TLB
		subcc	%g6,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g6,32,%o0	!
		call	st1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l4,0xfff,%o1	!

		st	%l3,[%o0+%o1]	! store old #13
		st	%l2,[%i0+52]	! move OP2 to #13
		ba	%icc,break0	!
		add	%g2,4,%g2	! update IAR
i.svg0e:

	.section ".text"
	.align	4
	.global ic4_stnsm
ic4_stnsm:
i.stnsm0s:
		st	%i3,[%i0+704]	! store minsn (upper)
		st	%g0,[%i0+708]	! store minsn (lower)
		sethi	%hi(0x80000000),%o7
		ba	%icc,epilog0	!
		or	%g7,%o7,%g7	! Special Instruction (FC=2)
i.stnsm0e:

	.section ".text"
	.align	4
	.global ic4_stosm
ic4_stosm:
i.stosm0s:
		st	%i3,[%i0+704]	! store minsn (upper)
		st	%g0,[%i0+708]	! store minsn (lower)
		sethi	%hi(0x80000000),%o7
		ba	%icc,epilog0	!
		or	%g7,%o7,%g7	! Special Instruction (FC=2)
i.stosm0e:

	.section ".text"
	.align	4
	.global ic4_sigp
ic4_sigp:
i.sigp0s:
		st	%i3,[%i0+704]	! store minsn (upper)
		st	%g0,[%i0+708]	! store minsn (lower)
		sethi	%hi(0x80000000),%o7
		ba	%icc,epilog0	!
		or	%g7,%o7,%g7	! Special Instruction (FC=2)
i.sigp0e:

	.section ".text"
	.align	4
	.global ii4_mc
ii4_mc:
	srl	%i3,20,%i5		! switch (upper 4bit of I2)
	andcc	%i5,0xf,%g0		!
	bnz,pn	%icc,spec_exception	!
	nop				!
i.mc0s:
		lduh	[%i0+226],%l0	! get CR8.[16-31]
		subcc	%l0,%g0,%g0	!
		bz,a,pt	%icc,break0	!
		add	%g2,4,%g2	!
		st	%i3,[%i0+704]	! store minsn (upper)
		st	%g0,[%i0+708]	! store minsn (lower)
		sethi	%hi(0x80000000),%o7
		ba	%icc,epilog0	!
		or	%g7,%o7,%g7	! Special Instruction (FC=2)
i.mc0e:
!================================

!
! templates
!   %i0: struct gcpu_s*
!   %i3: M instruction (upper 4 bytes)
!
	.section ".text"
	.align	4
	.global ic4_lra
ic4_lra:
i.lra0s:
		st	%i3,[%i0+704]	! store minsn (upper)
		st	%g0,[%i0+708]	! store minsn (lower)
		sethi	%hi(0x80000000),%o7
		ba	%icc,epilog0	!
		or	%g7,%o7,%g7	! Special Instruction (FC=2)
i.lra0e:

	.section ".text"
	.align	4
	.global ic4_b2xx
ic4_b2xx:
	srl	%i3,16,%i5		! switch (2byte opcd)
	and	%i5,0xff,%i5		!
	sll	%i5,5,%i5		!
	add	%i5,4,%i5		!
	sethi	%hi(optb2xx),%o7	! 1024 aligned
	ld	[%o7+%i5],%i5		! load optb2xx[opcd].ifunc
	jmpl	%i5,%g0			! jmp to ifunc()
	nop				!

	.section ".text"
	.align	4
	.global ii4_ipm
ii4_ipm:
	srl	%i3,4,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i1		! save as %i1
	ld	[%i0+%i1],%l0		! %l0
i.ipm0s:
		sethi	%hi(0xff000000),%o7
		andn	%l0,%o7,%l0	! ##TEMPLATE:%l0
		sll	%g1,28,%l1	! CC
		or	%l1,%l0,%l0	!
		and	%g7,0xf,%l1	! Prog-Mask
		sll	%l1,24,%l1	!
		or	%l1,%l0,%l0	! ##TEMPLATE:%l0
		st	%l0,[%i0+%i1]	! R1
		ba	%icc,break0	!
		add	%g2,4,%g2	! update IAR
i.ipm0e:

	.section ".text"
	.align	4
	.global if4_dxr
if4_dxr:
	srl	%i3,4,%i4		! switch (R1)
	srl	%i3,0,%i5		! switch (R2)
	or	%i4,%i5,%i5		!
	andcc	%i5,3,%g0		!
	bnz,pn	%icc,spec_exception	!
	nop				!
    i.dxr0t:				!
	srl	%i3,4,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	add	%i5,64,%i1		! %i1
	srl	%i3,0,%i5		! R2
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	add	%i5,64,%i2		! %i2
i.dxr0s:
		add	%i0,%i1,%o1	! ##TEMPLATE:%imm
		add	%i0,%i2,%o2	! ##TEMPLATE:%imm
		and	%g7,0xf,%o3	! give Program Mask
		stx	%g1,[%i0+648]	!
		stx	%g2,[%i0+656]	!
		stx	%g3,[%i0+664]	!
		stx	%g4,[%i0+672]	!
		stx	%g5,[%i0+680]	!
		stx	%g6,[%i0+688]	!
		call	fl_div_ext	!
		mov	%i0,%o0		! struct gcpu_s*
		ldx	[%i0+648],%g1	!
		ldx	[%i0+656],%g2	!
		ldx	[%i0+664],%g3	!
		ldx	[%i0+672],%g4	!
		ldx	[%i0+680],%g5	!
		ldx	[%i0+688],%g6	!
		sethi	%hi(0x00ff0000),%o7
		andcc	%o0,%o7,%o0	! extract exception
		bz,a,pt	%icc,break0	!   exit
		add	%g2,4,%g2	! update IAR
		ba	%icc,epilog0	!
		or	%g7,%o0,%g7	! INTR-CODE=retval
i.dxr0e:

	.section ".text"
	.align	4
	.global	ic4_stctl
ic4_stctl:
i.stctl0s:
		st	%i3,[%i0+704]	! store minsn (upper)
		st	%g0,[%i0+708]	! store minsn (lower)
		sethi	%hi(0x80000000),%o7
		ba	%icc,epilog0	!
		or	%g7,%o7,%g7	! Special Instruction (FC=2)
i.stctl0e:

	.section ".text"
	.align	4
	.global ic4_lctl
ic4_lctl:
i.lctl0s:
		st	%i3,[%i0+704]	! store minsn (upper)
		st	%g0,[%i0+708]	! store minsn (lower)
		sethi	%hi(0x80000000),%o7
		ba	%icc,epilog0	!
		or	%g7,%o7,%g7	! Special Instruction (FC=2)
i.lctl0e:

	.section ".text"
	.align	4
	.global ii4_cs
ii4_cs:
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i1		! save as %i1
	ld	[%i0+%i1],%l0		! %l0
	srl	%i3,16,%i5		! R3
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l4		! %l4
	srl	%i3,12,%i5		! B2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l3		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l2		! %l2
	and	%i3,0xfff,%l3		! D2
i.cs0s:
		add	%l2,%l3,%l2	! ##TEMPLATE:%l0,imm0
		and	%l2,%g3,%l2	! mask address
		andcc	%l2,3,%g0	!
		bnz,pn	%icc,spec_exception
		nop			! specification exception

		andncc	%l2,0x1ff,%g0	! check LAP
		bnz,pt	%icc,.+12	!
		andcc	%g7,0x20,%g0	!
		tnz	%icc,0x43	! LAP exception
					!
		andn	%l2,0xfff,%o1	! ST0-GS-TLB
		subcc	%g6,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g6,32,%o0	!
		call	st1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l2,0xfff,%o1	!

    i.cs000:	st	%l2,[%i0+712]	! cs address for emm
		ld	[%i0+716],%l6	! get cslocka

    i.cslock:	ldstub	[%l6],%l3	! try locking ibufbpa
		subcc	%l3,0,%g0	!
		be	%icc,i.cslout	!
		nop			!
    i.cslwait:	ldub	[%l6],%l3	!
		subcc	%l3,0,%g0	!
		bne	%icc,i.cslwait	!
		nop			!
		ba,a	%icc,i.cslock	! retry locking ibufbpa

    i.cslout:	sethi	%hi(0x00008000),%o7
		or	%g7,%o7,%g7	! --- M CS start ---
		ld	[%o0+%o1],%l2	!
		mov	0,%g1		! CC=0
		subcc	%l0,%l2,%g0	! ##TEMPLATE:%l0
		be,a	%icc,i.cs001	!
		st	%l4,[%o0+%o1]	!
		st	%l2,[%i0+%i1]	! R1
		mov	1,%g1		! CC=1
    i.cs001:	andn	%g7,%o7,%g7	! --- M CS end ---
		stbar			!
		stb	%g0,[%l6]	! unlock ibufbpa
		ba	%icc,break0	!
		add	%g2,4,%g2	! update IAR
i.cs0e:

	.section ".text"
	.align	4
	.global ii4_cds
ii4_cds:
	srl	%i3,20,%i4		! switch (R1,R3)
	srl	%i3,16,%i5		!
	or	%i4,%i5,%i5		!
	andcc	%i5,1,%g0		!
	bnz,pn	%icc,spec_exception	!
	nop				!
    i.cds0t:				!
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i1		! save as %i1
	ld	[%i0+%i1],%l0		! %l0
	srl	%i3,20,%i5		! R1+1
	and	%i5,0xf,%i5		! |
	add	%i5,1,%i5		! |
	sll	%i5,2,%i2		! save as %i2
	ld	[%i0+%i2],%l1		! %l1
	srl	%i3,16,%i5		! R3
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l4		! %l4
	srl	%i3,16,%i5		! R3+1
	and	%i5,0xf,%i5		! |
	add	%i5,1,%i5		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l5		! %l5
	srl	%i3,12,%i5		! B2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l3		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l2		! %l2
	and	%i3,0xfff,%l3		! D2
i.cds0s:
    i.cds0t0:	add	%l2,%l3,%l2	! ##TEMPLATE:%l0,imm0
		and	%l2,%g3,%l2	! mask address
		andcc	%l2,7,%g0	!
		bnz,pn	%icc,spec_exception
		nop			! specification exception

		andncc	%l2,0x1ff,%g0	! check LAP
		bnz,pt	%icc,.+12	!
		andcc	%g7,0x20,%g0	!
		tnz	%icc,0x43	! LAP exception
					!
		andn	%l2,0xfff,%o1	! ST0-GS-TLB
		subcc	%g6,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g6,32,%o0	!
		call	st1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l2,0xfff,%o1	!

    i.cds000:	st	%l2,[%i0+712]	! cs address for emm
		ld	[%i0+716],%l6	! get cslocka

    i.cdslock:	ldstub	[%l6],%l3	! try locking ibufbpa
		subcc	%l3,0,%g0	!
		be	%icc,i.cdslout	!
		nop			!
    i.cdslwait:	ldub	[%l6],%l3	!
		subcc	%l3,0,%g0	!
		bne	%icc,i.cdslwait	!
		nop			!
		ba,a	%icc,i.cdslock	! retry locking ibufbpa

    i.cdslout:	sethi	%hi(0x00008000),%o7
		or	%g7,%o7,%g7	! --- M CS start ---
		ldd	[%o0+%o1],%l2	!
		mov	0,%g1		! CC=0
		subcc	%l1,%l3,%g0	! ##TEMPLATE:%l0+1
		bne	%icc,i.cds002	!
		subcc	%l0,%l2,%g0	! ##TEMPLATE:%l0
		be,a	%icc,i.cds001	!
		std	%l4,[%o0+%o1]	!
    i.cds002:	std	%l2,[%i0+%i1]	! R1,R1+1
		mov	1,%g1		! CC=1
    i.cds001:	andn	%g7,%o7,%g7	! --- M CS end ---
		stbar			!
		stb	%g0,[%l6]	! unlock ibufbpa
		ba	%icc,break0	!
		add	%g2,4,%g2	! update IAR
i.cds0e:

	.section ".text"
	.align	4
	.global ic4_bcxx
ic4_bcxx:
i.bcxx0s:
		st	%i3,[%i0+704]	! store minsn (upper)
		st	%g0,[%i0+708]	! store minsn (lower)
		sethi	%hi(0x80000000),%o7
		ba	%icc,epilog0	!
		or	%g7,%o7,%g7	! Special Instruction (FC=2)
i.bcxx0e:

	.section ".text"
	.align	4
	.global	ii4_clm
ii4_clm:
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l0		! %l0
	srl	%i3,16,%i5		! M3
	and	%i5,0xf,%l1		! %l1
	srl	%i3,12,%i5		! B2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l3		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l3		! %l3
	and	%i3,0xfff,%l4		! D2
i.clm0s:
		add	%l3,%l4,%l2	! ##TEMPLATE:%l0,imm0
		and	%l2,%g3,%l2	! mask address
		sethi	%hi(i.clmtab),%o7
		or	%o7,%lo(i.clmtab),%o7
		ldub	[%o7+%l1],%l3	!
		add	%l2,%l3,%l3	!
		and	%l3,%g3,%l3	! mask address

		andn	%l3,0xfff,%o1	! LD0-GS-TLB
		subcc	%g5,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g5,32,%o0	!
		call	ld1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l3,0xfff,%o1	!
		mov	%o0,%l3		! save base1

		andn	%l2,0xfff,%o1	! LD0-GS-TLB
		subcc	%g5,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g5,32,%o0	!
		call	ld1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l2,0xfff,%o1	!
		mov	%l3,%o2		! restore base1
	! %o0: base0
	! %o1: offset0
	! %o2: base1
		mov	0,%g1		! CC=0
    i.clm000:	andcc	%l1,0xf,%l1	!
		bz	%icc,i.clm004	!
		andcc	%l1,8,%g0	!
		bz	%icc,i.clm001	!
		srl	%l0,24,%l2	!
		ldub	[%o0+%o1],%l3	!
		subcc	%l2,%l3,%g0	!
		bne	%icc,i.clm002	!
		add	%o1,1,%o1	!
		subcc	%o1,0xfff,%g0	! if page cross
		movgu	%icc,%o2,%o0	!   base1 -> base0
		and	%o1,0xfff,%o1	!
    i.clm001:	sll	%l0,8,%l0	!
		ba	%icc,i.clm000	!
		sll	%l1,1,%l1	!
    i.clm002:	movgu	%icc,2,%g1	! if R1 > OP2 then CC=2
		movcs	%icc,1,%g1	! if R1 < OP2 then CC=1
    i.clm004:	ba	%icc,break0	!
		add	%g2,4,%g2	! update IAR
i.clm0e:
i.clmtab:
	.byte	0,0,0,1,0,1,1,2,0,1,1,2,1,2,2,3

	.section ".text"
	.align	4
	.global ii4_stcm
ii4_stcm:
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l0		! %l0
	srl	%i3,16,%i5		! M3
	and	%i5,0xf,%l1		! %l1
	srl	%i3,12,%i5		! B2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l3		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l3		! %l3
	and	%i3,0xfff,%l4		! D2
i.stcm0s:
		add	%l3,%l4,%l2	! ##TEMPLATE:%l0,imm0
		and	%l2,%g3,%l2	! mask address
		sethi	%hi(i.stcmtab),%o7
		or	%o7,%lo(i.stcmtab),%o7
		ldub	[%o7+%l1],%l3	!
		add	%l2,%l3,%l3	!
		and	%l3,%g3,%l3	! mask address

		andncc	%l3,0x1ff,%g0	! check LAP
		bnz,pt	%icc,.+12	!
		andcc	%g7,0x20,%g0	!
		tnz	%icc,0x43	! LAP exception
					!
		andn	%l3,0xfff,%o1	! ST0-GS-TLB
		subcc	%g6,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g6,32,%o0	!
		call	st1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l3,0xfff,%o1	!
		mov	%o0,%l3		! save base1

		andncc	%l2,0x1ff,%g0	! check LAP
		bnz,pt	%icc,.+12	!
		andcc	%g7,0x20,%g0	!
		tnz	%icc,0x43	! LAP exception
					!
		andn	%l2,0xfff,%o1	! ST0-GS-TLB
		subcc	%g6,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g6,32,%o0	!
		call	st1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l2,0xfff,%o1	!
		mov	%l3,%o2		! restore base1
	! %o0: base0
	! %o1: offset0
	! %o2: base1
    i.stcm000:	andcc	%l1,0xf,%l1	!
		bz	%icc,i.stcm002	!
		andcc	%l1,8,%g0	!
		bz	%icc,i.stcm001	!
		srl	%l0,24,%l2	!
		stb	%l2,[%o0+%o1]	!
		add	%o1,1,%o1	!
		subcc	%o1,0xfff,%g0	! if page cross
		movgu	%icc,%o2,%o0	!   base1 -> base0
		and	%o1,0xfff,%o1	!
    i.stcm001:	sll	%l0,8,%l0	!
		ba	%icc,i.stcm000	!
		sll	%l1,1,%l1	!
    i.stcm002:	ba	%icc,break0	!
		add	%g2,4,%g2	! update IAR
i.stcm0e:
i.stcmtab:
	.byte	0,0,0,1,0,1,1,2,0,1,1,2,1,2,2,3

	.section ".text"
	.align	4
	.global ii4_icm
ii4_icm:
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i1		! save as %i1
	ld	[%i0+%i1],%l0		! %l0
	srl	%i3,16,%i5		! M3
	and	%i5,0xf,%l1		! %l1
	srl	%i3,12,%i5		! B2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l3		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l3		! %l3
	and	%i3,0xfff,%l4		! D2
i.icm0s:
		add	%l3,%l4,%l2	! ##TEMPLATE:%l0,imm0
		and	%l2,%g3,%l2	! mask address
		sethi	%hi(i.icmtab),%o7
		or	%o7,%lo(i.icmtab),%o7
		ldub	[%o7+%l1],%l3	!
		add	%l2,%l3,%l3	!
		and	%l3,%g3,%l3	! mask address

		andn	%l3,0xfff,%o1	! LD0-GS-TLB
		subcc	%g5,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g5,32,%o0	!
		call	ld1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l3,0xfff,%o1	!
		mov	%o0,%l3		! save base1

		andn	%l2,0xfff,%o1	! LD0-GS-TLB
		subcc	%g5,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g5,32,%o0	!
		call	ld1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l2,0xfff,%o1	!
		mov	%l3,%o2		! restore base1
	! %o0: base0
	! %o1: offset0
	! %o2: base1
		mov	0,%g1		! CC=0
		add	%g0,32,%l3	! reg rest shift count
		add	%g0,32,%l4	! mem rest shift count
		add	%g0,0,%l5	! result bits
		add	%g0,0,%l6	! loaded bits
    i.icm000:	andcc	%l1,0xf,%l1	!
		bz	%icc,i.icm002	!
		andcc	%l1,8,%g0	!
		bz	%icc,i.icm001	!
		srl	%l0,24,%l2	!
		ldub	[%o0+%o1],%l2	!
		add	%o1,1,%o1	!
		subcc	%o1,0xfff,%g0	! if page cross
		movgu	%icc,%o2,%o0	!   base1 -> base0
		and	%o1,0xfff,%o1	!
		sub	%l4,8,%l4	! decr.  loaded bits
		sll	%l6,8,%l6	! shift  loaded bits
		or	%l6,%l2,%l6	! update loaded bits
    i.icm001:	sub	%l3,8,%l3	! decr.  result bits
		sll	%l5,8,%l5	! shift  result bits
		or	%l5,%l2,%l5	! update result bits
		sll	%l0,8,%l0	!
		ba	%icc,i.icm000	!
		sll	%l1,1,%l1	!
    i.icm002:	sll	%l5,%l3,%l5	! align result bits left
		sub	%g0,%l3,%l3	!
		add	%l3,32,%l3	!
		srl	%l0,%l3,%l0	!
		or	%l5,%l0,%l5	! or rest bits
		st	%l5,[%i0+%i1]	! R1
		sll	%l6,%l4,%l6	! align loaded bits left
		subcc	%l6,0,%g0	!
		movg	%icc,2,%g1	! if inserted bits > 0 CC=2
		movl	%icc,1,%g1	! if inserted bits < 0 CC=1
		ba	%icc,break0	!
		add	%g2,4,%g2	! update IAR
i.icm0e:
i.icmtab:
	.byte	0,0,0,1,0,1,1,2,0,1,1,2,1,2,2,3
!================================

!
! templates
!   %i0: struct gcpu_s*
!   %i3: M instruction (upper 4 bytes)
!   %i4: M instruction (lower 2 bytes)
!
	.section ".text"
	.align	4
	.global ii6_mvn
ii6_mvn:
	srl	%i3,12,%i5		! B1
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l0		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l0		! %l0
	and	%i3,0xfff,%l1		! D1
	srl	%i4,28,%i5		! B2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l2		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l2		! %l2
	srl	%i4,16,%i5		! D2
	and	%i5,0xfff,%l3		! %l3
	srl	%i3,16,%i5		! L
	and	%i5,0xff,%l4		! %l4
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=6
	add	%g0,6,%l7		!
	movnz	%icc,4,%l7		! if EX=1 then IAR+=4
i.mvn0s:
		add	%l0,%l1,%l0	! OP1
		and	%l0,%g3,%l0	! mask address
		add	%l2,%l3,%l2	! OP2
		and	%l2,%g3,%l2	! mask address
		add	%l0,%l4,%l1	! OP1+length-1
		and	%l1,%g3,%l1	! mask address
		add	%l2,%l4,%l3	! OP2+length-1
		and	%l3,%g3,%l3	! mask address

		andn	%l3,0xfff,%o1	! LD0-GS-TLB
		subcc	%g5,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g5,32,%o0	!
		call	ld1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l3,0xfff,%o1	!
		mov	%o0,%l3		! save base3

		andn	%l2,0xfff,%o1	! LD0-GS-TLB
		subcc	%g5,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g5,32,%o0	!
		call	ld1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l2,0xfff,%o1	!
		mov	%o0,%l2		! save base2
		mov	%o1,%l6		! save offset2

		andncc	%l1,0x1ff,%g0	! check LAP
		bnz,pt	%icc,.+12	!
		andcc	%g7,0x20,%g0	!
		tnz	%icc,0x43	! LAP exception
					!
		andn	%l1,0xfff,%o1	! ST0-GS-TLB
		subcc	%g6,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g6,32,%o0	!
		call	st1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l1,0xfff,%o1	!
		mov	%o0,%l1		! save base1

		andncc	%l0,0x1ff,%g0	! check LAP
		bnz,pt	%icc,.+12	!
		andcc	%g7,0x20,%g0	!
		tnz	%icc,0x43	! LAP exception
					!
		andn	%l0,0xfff,%o1	! ST0-GS-TLB
		subcc	%g6,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g6,32,%o0	!
		call	st1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l0,0xfff,%o1	!
		mov	%l1,%o2		! restore base1
		mov	%l2,%o3		! restore base2
		mov	%l6,%o4		! restore offset2
		mov	%l3,%o5		! restore base3
	! %o0: base0
	! %o1: offset0
	! %o2: base1
	! %o3: base2
	! %o4: offset2
	! %o5: base3
	! %l4: length-1
		sethi	%hi(0xf0f0f0f0),%l5
		or	%l5,%lo(0xf0f0f0f0),%l5
		srl	%l5,4,%l6	!
    i.mvn0lp:	mov	0xfff,%o7	!
		sub	%o7,%o1,%l2	! Until 4K PAGE Boundary
		subcc	%l4,%l2,%g0	! if L >= UPB length = UPB
		movl	%icc,%l4,%l2	! else        length = L
		sub	%o7,%o4,%l3	! Until 4K PAGE Boundary
		subcc	%l4,%l3,%g0	! if L >= UPB length = UPB
		movl	%icc,%l4,%l3	! else        length = L
		subcc	%l2,%l3,%g0	! compare length
		movgu	%icc,%l3,%l2	! select shorter one
		add	%l2,1,%l2	! length-1 -> length

		or	%o1,%o4,%l0	!
		or	%l0,%l2,%l0	!
		andcc	%l0,3,%g0	! if 4byte aligned
		bnz,pn	%icc,i.mvn010	!   short cut
		mov	%l2,%l3		! counter

    i.mvn000:	ld	[%o0+%o1],%l0	!
		ld	[%o3+%o4],%l1	!
		add	%o4,4,%o4	!
		and	%l0,%l5,%l0	!
		and	%l1,%l6,%l1	!
		or	%l0,%l1,%l0	!
		st	%l0,[%o0+%o1]	!
		subcc	%l3,4,%l3	!
		bg	%icc,i.mvn000	!
		add	%o1,4,%o1	!
		ba,a	%icc,i.mvn0end	!
		nop			!

    i.mvn010:	ldub	[%o0+%o1],%l0	!
		ldub	[%o3+%o4],%l1	!
		add	%o4,1,%o4	!
		and	%l0,0xf0,%l0	!
		and	%l1,0x0f,%l1	!
		or	%l0,%l1,%l0	!
		stb	%l0,[%o0+%o1]	!
		subcc	%l3,1,%l3	!
		bg	%icc,i.mvn010	!
		add	%o1,1,%o1	!

    i.mvn0end:	subcc	%o1,0xfff,%g0	! if page cross
		movgu	%icc,%o2,%o0	!   base1 -> base0
		and	%o1,0xfff,%o1	!
		subcc	%o4,0xfff,%g0	! if page cross
		movgu	%icc,%o5,%o3	!   base3 -> base2
		and	%o4,0xfff,%o4	!
		subcc	%l4,%l2,%l4	!
		bge	%icc,i.mvn0lp	!
		nop			!
		ba	%icc,break0	!
		add	%g2,%l7,%g2	! ##TEMPLATE:IAR
i.mvn0e:

	.section ".text"
	.align	4
	.global ii6_mvc
ii6_mvc:
	srl	%i3,12,%i5		! B1
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l0		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l0		! %l0
	and	%i3,0xfff,%l1		! D1
	srl	%i4,28,%i5		! B2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l2		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l2		! %l2
	srl	%i4,16,%i5		! D2
	and	%i5,0xfff,%l3		! %l3
	srl	%i3,16,%i5		! L
	and	%i5,0xff,%l4		! %l4
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=6
	add	%g0,6,%l7		!
	movnz	%icc,4,%l7		! if EX=1 then IAR+=4
i.mvc0s:
		add	%l0,%l1,%l0	! OP1
		and	%l0,%g3,%l0	! mask address
		add	%l2,%l3,%l2	! OP2
		and	%l2,%g3,%l2	! mask address
		add	%l0,%l4,%l1	! OP1+length-1
		and	%l1,%g3,%l1	! mask address
		add	%l2,%l4,%l3	! OP2+length-1
		and	%l3,%g3,%l3	! mask address

		andn	%l3,0xfff,%o1	! LD0-GS-TLB
		subcc	%g5,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g5,32,%o0	!
		call	ld1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l3,0xfff,%o1	!
		mov	%o0,%l3		! save base3

		andn	%l2,0xfff,%o1	! LD0-GS-TLB
		subcc	%g5,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g5,32,%o0	!
		call	ld1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l2,0xfff,%o1	!
		mov	%o0,%l2		! save base2
		mov	%o1,%l6		! save offset2

		andncc	%l1,0x1ff,%g0	! check LAP
		bnz,pt	%icc,.+12	!
		andcc	%g7,0x20,%g0	!
		tnz	%icc,0x43	! LAP exception
					!
		andn	%l1,0xfff,%o1	! ST0-GS-TLB
		subcc	%g6,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g6,32,%o0	!
		call	st1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l1,0xfff,%o1	!
		mov	%o0,%l1		! save base1

		andncc	%l0,0x1ff,%g0	! check LAP
		bnz,pt	%icc,.+12	!
		andcc	%g7,0x20,%g0	!
		tnz	%icc,0x43	! LAP exception
					!
		andn	%l0,0xfff,%o1	! ST0-GS-TLB
		subcc	%g6,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g6,32,%o0	!
		call	st1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l0,0xfff,%o1	!
		mov	%l1,%o2		! restore base1
		mov	%l2,%o3		! restore base2
		mov	%l6,%o4		! restore offset2
		mov	%l3,%o5		! restore base3
	! %o0: base0
	! %o1: offset0
	! %o2: base1
	! %o3: base2
	! %o4: offset2
	! %o5: base3
	! %l4: length-1
    i.mvc0lp:	mov	0xfff,%o7	!
		sub	%o7,%o1,%l2	! Until 4K PAGE Boundary
		subcc	%l4,%l2,%g0	! if L >= UPB length = UPB
		movl	%icc,%l4,%l2	! else        length = L
		sub	%o7,%o4,%l3	! Until 4K PAGE Boundary
		subcc	%l4,%l3,%g0	! if L >= UPB length = UPB
		movl	%icc,%l4,%l3	! else        length = L
		subcc	%l2,%l3,%g0	! compare length
		movgu	%icc,%l3,%l2	! select shorter one
		add	%l2,1,%l2	! length-1 -> length

		or	%o1,%o4,%l0	!
		or	%l0,%l2,%l0	!
		andcc	%l0,3,%g0	! if 4byte aligned
		bnz,pn	%icc,i.mvc010	!   short cut
		mov	%l2,%l3		! counter

    i.mvc000:	ld	[%o3+%o4],%l0	!
		add	%o4,4,%o4	!
		st	%l0,[%o0+%o1]	!
		subcc	%l3,4,%l3	!
		bg	%icc,i.mvc000	!
		add	%o1,4,%o1	!
		ba,a	%icc,i.mvc0end	!
		nop			!

    i.mvc010:	ldub	[%o3+%o4],%l0	!
		add	%o4,1,%o4	!
		stb	%l0,[%o0+%o1]	!
		subcc	%l3,1,%l3	!
		bg	%icc,i.mvc010	!
		add	%o1,1,%o1	!

    i.mvc0end:	subcc	%o1,0xfff,%g0	! if page cross
		movgu	%icc,%o2,%o0	!   base1 -> base0
		and	%o1,0xfff,%o1	!
		subcc	%o4,0xfff,%g0	! if page cross
		movgu	%icc,%o5,%o3	!   base3 -> base2
		and	%o4,0xfff,%o4	!
		subcc	%l4,%l2,%l4	!
		bge	%icc,i.mvc0lp	!
		nop			!
		ba	%icc,break0	!
		add	%g2,%l7,%g2	! ##TEMPLATE:IAR
i.mvc0e:

	.section ".text"
	.align	4
	.global ii6_mvz
ii6_mvz:
	srl	%i3,12,%i5		! B1
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l0		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l0		! %l0
	and	%i3,0xfff,%l1		! D1
	srl	%i4,28,%i5		! B2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l2		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l2		! %l2
	srl	%i4,16,%i5		! D2
	and	%i5,0xfff,%l3		! %l3
	srl	%i3,16,%i5		! L
	and	%i5,0xff,%l4		! %l4
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=6
	add	%g0,6,%l7		!
	movnz	%icc,4,%l7		! if EX=1 then IAR+=4
i.mvz0s:
		add	%l0,%l1,%l0	! OP1
		and	%l0,%g3,%l0	! mask address
		add	%l2,%l3,%l2	! OP2
		and	%l2,%g3,%l2	! mask address
		add	%l0,%l4,%l1	! OP1+length-1
		and	%l1,%g3,%l1	! mask address
		add	%l2,%l4,%l3	! OP2+length-1
		and	%l3,%g3,%l3	! mask address

		andn	%l3,0xfff,%o1	! LD0-GS-TLB
		subcc	%g5,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g5,32,%o0	!
		call	ld1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l3,0xfff,%o1	!
		mov	%o0,%l3		! save base3

		andn	%l2,0xfff,%o1	! LD0-GS-TLB
		subcc	%g5,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g5,32,%o0	!
		call	ld1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l2,0xfff,%o1	!
		mov	%o0,%l2		! save base2
		mov	%o1,%l6		! save offset2

		andncc	%l1,0x1ff,%g0	! check LAP
		bnz,pt	%icc,.+12	!
		andcc	%g7,0x20,%g0	!
		tnz	%icc,0x43	! LAP exception
					!
		andn	%l1,0xfff,%o1	! ST0-GS-TLB
		subcc	%g6,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g6,32,%o0	!
		call	st1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l1,0xfff,%o1	!
		mov	%o0,%l1		! save base1

		andncc	%l0,0x1ff,%g0	! check LAP
		bnz,pt	%icc,.+12	!
		andcc	%g7,0x20,%g0	!
		tnz	%icc,0x43	! LAP exception
					!
		andn	%l0,0xfff,%o1	! ST0-GS-TLB
		subcc	%g6,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g6,32,%o0	!
		call	st1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l0,0xfff,%o1	!
		mov	%l1,%o2		! restore base1
		mov	%l2,%o3		! restore base2
		mov	%l6,%o4		! restore offset2
		mov	%l3,%o5		! restore base3
	! %o0: base0
	! %o1: offset0
	! %o2: base1
	! %o3: base2
	! %o4: offset2
	! %o5: base3
	! %l4: length-1
		sethi	%hi(0xf0f0f0f0),%l5
		or	%l5,%lo(0xf0f0f0f0),%l5
		srl	%l5,4,%l6	!
    i.mvz0lp:	mov	0xfff,%o7	!
		sub	%o7,%o1,%l2	! Until 4K PAGE Boundary
		subcc	%l4,%l2,%g0	! if L >= UPB length = UPB
		movl	%icc,%l4,%l2	! else        length = L
		sub	%o7,%o4,%l3	! Until 4K PAGE Boundary
		subcc	%l4,%l3,%g0	! if L >= UPB length = UPB
		movl	%icc,%l4,%l3	! else        length = L
		subcc	%l2,%l3,%g0	! compare length
		movgu	%icc,%l3,%l2	! select shorter one
		add	%l2,1,%l2	! length-1 -> length

		or	%o1,%o4,%l0	!
		or	%l0,%l2,%l0	!
		andcc	%l0,3,%g0	! if 4byte aligned
		bnz,pn	%icc,i.mvz010	!   short cut
		mov	%l2,%l3		! counter

    i.mvz000:	ld	[%o0+%o1],%l0	!
		ld	[%o3+%o4],%l1	!
		add	%o4,4,%o4	!
		and	%l0,%l6,%l0	!
		and	%l1,%l5,%l1	!
		or	%l0,%l1,%l0	!
		st	%l0,[%o0+%o1]	!
		subcc	%l3,4,%l3	!
		bg	%icc,i.mvz000	!
		add	%o1,4,%o1	!
		ba,a	%icc,i.mvz0end	!
		nop			!

    i.mvz010:	ldub	[%o0+%o1],%l0	!
		ldub	[%o3+%o4],%l1	!
		add	%o4,1,%o4	!
		and	%l0,0x0f,%l0	!
		and	%l1,0xf0,%l1	!
		or	%l0,%l1,%l0	!
		stb	%l0,[%o0+%o1]	!
		subcc	%l3,1,%l3	!
		bg	%icc,i.mvz010	!
		add	%o1,1,%o1	!

    i.mvz0end:	subcc	%o1,0xfff,%g0	! if page cross
		movgu	%icc,%o2,%o0	!   base1 -> base0
		and	%o1,0xfff,%o1	!
		subcc	%o4,0xfff,%g0	! if page cross
		movgu	%icc,%o5,%o3	!   base3 -> base2
		and	%o4,0xfff,%o4	!
		subcc	%l4,%l2,%l4	!
		bge	%icc,i.mvz0lp	!
		nop			!
		ba	%icc,break0	!
		add	%g2,%l7,%g2	! ##TEMPLATE:IAR
i.mvz0e:

	.section ".text"
	.align	4
	.global ii6_nc
ii6_nc:
	srl	%i3,12,%i5		! B1
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l0		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l0		! %l0
	and	%i3,0xfff,%l1		! D1
	srl	%i4,28,%i5		! B2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l2		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l2		! %l2
	srl	%i4,16,%i5		! D2
	and	%i5,0xfff,%l3		! %l3
	srl	%i3,16,%i5		! L
	and	%i5,0xff,%l4		! %l4
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=6
	add	%g0,6,%l7		!
	movnz	%icc,4,%l7		! if EX=1 then IAR+=4
i.nc0s:
		add	%l0,%l1,%l0	! OP1
		and	%l0,%g3,%l0	! mask address
		add	%l2,%l3,%l2	! OP2
		and	%l2,%g3,%l2	! mask address
		add	%l0,%l4,%l1	! OP1+length-1
		and	%l1,%g3,%l1	! mask address
		add	%l2,%l4,%l3	! OP2+length-1
		and	%l3,%g3,%l3	! mask address

		andn	%l3,0xfff,%o1	! LD0-GS-TLB
		subcc	%g5,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g5,32,%o0	!
		call	ld1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l3,0xfff,%o1	!
		mov	%o0,%l3		! save base3

		andn	%l2,0xfff,%o1	! LD0-GS-TLB
		subcc	%g5,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g5,32,%o0	!
		call	ld1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l2,0xfff,%o1	!
		mov	%o0,%l2		! save base2
		mov	%o1,%l6		! save offset2

		andncc	%l1,0x1ff,%g0	! check LAP
		bnz,pt	%icc,.+12	!
		andcc	%g7,0x20,%g0	!
		tnz	%icc,0x43	! LAP exception
					!
		andn	%l1,0xfff,%o1	! ST0-GS-TLB
		subcc	%g6,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g6,32,%o0	!
		call	st1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l1,0xfff,%o1	!
		mov	%o0,%l1		! save base1

		andncc	%l0,0x1ff,%g0	! check LAP
		bnz,pt	%icc,.+12	!
		andcc	%g7,0x20,%g0	!
		tnz	%icc,0x43	! LAP exception
					!
		andn	%l0,0xfff,%o1	! ST0-GS-TLB
		subcc	%g6,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g6,32,%o0	!
		call	st1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l0,0xfff,%o1	!
		mov	%l1,%o2		! restore base1
		mov	%l2,%o3		! restore base2
		mov	%l6,%o4		! restore offset2
		mov	%l3,%o5		! restore base3
	! %o0: base0
	! %o1: offset0
	! %o2: base1
	! %o3: base2
	! %o4: offset2
	! %o5: base3
	! %l4: length-1
		mov	0,%g1		! CC=0
		mov	0,%l5		! ORed value
    i.nc0lp:	mov	0xfff,%o7	!
		sub	%o7,%o1,%l2	! Until 4K PAGE Boundary
		subcc	%l4,%l2,%g0	! if L >= UPB length = UPB
		movl	%icc,%l4,%l2	! else        length = L
		sub	%o7,%o4,%l3	! Until 4K PAGE Boundary
		subcc	%l4,%l3,%g0	! if L >= UPB length = UPB
		movl	%icc,%l4,%l3	! else        length = L
		subcc	%l2,%l3,%g0	! compare length
		movgu	%icc,%l3,%l2	! select shorter one
		add	%l2,1,%l2	! length-1 -> length

		or	%o1,%o4,%l0	!
		or	%l0,%l2,%l0	!
		andcc	%l0,3,%g0	! if 4byte aligned
		bnz,pn	%icc,i.nc010	!   short cut
		mov	%l2,%l3		! counter

    i.nc000:	ld	[%o0+%o1],%l0	!
		ld	[%o3+%o4],%l1	!
		add	%o4,4,%o4	!
		and	%l0,%l1,%l0	!
		or	%l5,%l0,%l5	!
		st	%l0,[%o0+%o1]	!
		subcc	%l3,4,%l3	!
		bg	%icc,i.nc000	!
		add	%o1,4,%o1	!
		ba,a	%icc,i.nc0end	!
		nop			!

    i.nc010:	ldub	[%o0+%o1],%l0	!
		ldub	[%o3+%o4],%l1	!
		add	%o4,1,%o4	!
		and	%l0,%l1,%l0	!
		or	%l5,%l0,%l5	!
		stb	%l0,[%o0+%o1]	!
		subcc	%l3,1,%l3	!
		bg	%icc,i.nc010	!
		add	%o1,1,%o1	!

    i.nc0end:	subcc	%o1,0xfff,%g0	! if page cross
		movgu	%icc,%o2,%o0	!   base1 -> base0
		and	%o1,0xfff,%o1	!
		subcc	%o4,0xfff,%g0	! if page cross
		movgu	%icc,%o5,%o3	!   base3 -> base2
		and	%o4,0xfff,%o4	!
		subcc	%l4,%l2,%l4	!
		bge	%icc,i.nc0lp	!
		subcc	%l5,0,%g0	!
		movnz	%icc,1,%g1	! if Result != 0 then CC=1
		ba	%icc,break0	!
		add	%g2,%l7,%g2	! ##TEMPLATE:IAR
i.nc0e:

	.section ".text"
	.align	4
	.global ii6_clc
ii6_clc:
	srl	%i3,12,%i5		! B1
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l0		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l0		! %l0
	and	%i3,0xfff,%l1		! D1
	srl	%i4,28,%i5		! B2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l2		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l2		! %l2
	srl	%i4,16,%i5		! D2
	and	%i5,0xfff,%l3		! %l3
	srl	%i3,16,%i5		! L
	and	%i5,0xff,%l4		! %l4
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=6
	add	%g0,6,%l7		!
	movnz	%icc,4,%l7		! if EX=1 then IAR+=4
i.clc0s:
		add	%l0,%l1,%l0	! OP1
		and	%l0,%g3,%l0	! mask address
		add	%l2,%l3,%l2	! OP2
		and	%l2,%g3,%l2	! mask address
		add	%l0,%l4,%l1	! OP1+length-1
		and	%l1,%g3,%l1	! mask address
		add	%l2,%l4,%l3	! OP2+length-1
		and	%l3,%g3,%l3	! mask address

		andn	%l3,0xfff,%o1	! LD0-GS-TLB
		subcc	%g5,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g5,32,%o0	!
		call	ld1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l3,0xfff,%o1	!
		mov	%o0,%l3		! save base3

		andn	%l2,0xfff,%o1	! LD0-GS-TLB
		subcc	%g5,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g5,32,%o0	!
		call	ld1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l2,0xfff,%o1	!
		mov	%o0,%l2		! save base2
		mov	%o1,%l6		! save offset2

		andn	%l1,0xfff,%o1	! LD0-GS-TLB
		subcc	%g5,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g5,32,%o0	!
		call	ld1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l1,0xfff,%o1	!
		mov	%o0,%l1		! save base1

		andn	%l0,0xfff,%o1	! LD0-GS-TLB
		subcc	%g5,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g5,32,%o0	!
		call	ld1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l0,0xfff,%o1	!
		mov	%l1,%o2		! restore base1
		mov	%l2,%o3		! restore base2
		mov	%l6,%o4		! restore offset2
		mov	%l3,%o5		! restore base3
	! %o0: base0
	! %o1: offset0
	! %o2: base1
	! %o3: base2
	! %o4: offset2
	! %o5: base3
	! %l4: length-1
		mov	0,%g1		! CC=0
    i.clc0lp:	mov	0xfff,%o7	!
		sub	%o7,%o1,%l2	! Until 4K PAGE Boundary
		subcc	%l4,%l2,%g0	! if L >= UPB length = UPB
		movl	%icc,%l4,%l2	! else        length = L
		sub	%o7,%o4,%l3	! Until 4K PAGE Boundary
		subcc	%l4,%l3,%g0	! if L >= UPB length = UPB
		movl	%icc,%l4,%l3	! else        length = L
		subcc	%l2,%l3,%g0	! compare length
		movgu	%icc,%l3,%l2	! select shorter one
		add	%l2,1,%l2	! length-1 -> length

		or	%o1,%o4,%l0	!
		or	%l0,%l2,%l0	!
		andcc	%l0,3,%g0	! if 4byte aligned
		bnz,pn	%icc,i.clc010	!   short cut
		mov	%l2,%l3		! counter

    i.clc000:	ld	[%o0+%o1],%l0	!
		add	%o1,4,%o1	!
		ld	[%o3+%o4],%l1	!
		subcc	%l0,%l1,%g0	!
		bne	%icc,i.clc0exit	!
		subcc	%l3,4,%l3	!
		bg	%icc,i.clc000	!
		add	%o4,4,%o4	!
		ba,a	%icc,i.clc0end	!
		nop			!

    i.clc010:	ldub	[%o0+%o1],%l0	!
		add	%o1,1,%o1	!
		ldub	[%o3+%o4],%l1	!
		subcc	%l0,%l1,%g0	!
		bne	%icc,i.clc0exit	!
		subcc	%l3,1,%l3	!
		bg	%icc,i.clc010	!
		add	%o4,1,%o4	!

    i.clc0end:	subcc	%o1,0xfff,%g0	! if page cross
		movgu	%icc,%o2,%o0	!   base1 -> base0
		and	%o1,0xfff,%o1	!
		subcc	%o4,0xfff,%g0	! if page cross
		movgu	%icc,%o5,%o3	!   base3 -> base2
		and	%o4,0xfff,%o4	!
		subcc	%l4,%l2,%l4	!
		bge	%icc,i.clc0lp	!
    i.clc0exit:	subcc	%l0,%l1,%g0	!
		movgu	%icc,2,%g1	! if left > right then CC=2
		movcs	%icc,1,%g1	! if left < right then CC=1
		ba	%icc,break0	!
		add	%g2,%l7,%g2	! ##TEMPLATE:IAR
i.clc0e:

	.section ".text"
	.align	4
	.global ii6_oc
ii6_oc:
	srl	%i3,12,%i5		! B1
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l0		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l0		! %l0
	and	%i3,0xfff,%l1		! D1
	srl	%i4,28,%i5		! B2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l2		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l2		! %l2
	srl	%i4,16,%i5		! D2
	and	%i5,0xfff,%l3		! %l3
	srl	%i3,16,%i5		! L
	and	%i5,0xff,%l4		! %l4
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=6
	add	%g0,6,%l7		!
	movnz	%icc,4,%l7		! if EX=1 then IAR+=4
i.oc0s:
		add	%l0,%l1,%l0	! OP1
		and	%l0,%g3,%l0	! mask address
		add	%l2,%l3,%l2	! OP2
		and	%l2,%g3,%l2	! mask address
		add	%l0,%l4,%l1	! OP1+length-1
		and	%l1,%g3,%l1	! mask address
		add	%l2,%l4,%l3	! OP2+length-1
		and	%l3,%g3,%l3	! mask address

		andn	%l3,0xfff,%o1	! LD0-GS-TLB
		subcc	%g5,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g5,32,%o0	!
		call	ld1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l3,0xfff,%o1	!
		mov	%o0,%l3		! save base3

		andn	%l2,0xfff,%o1	! LD0-GS-TLB
		subcc	%g5,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g5,32,%o0	!
		call	ld1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l2,0xfff,%o1	!
		mov	%o0,%l2		! save base2
		mov	%o1,%l6		! save offset2

		andncc	%l1,0x1ff,%g0	! check LAP
		bnz,pt	%icc,.+12	!
		andcc	%g7,0x20,%g0	!
		tnz	%icc,0x43	! LAP exception
					!
		andn	%l1,0xfff,%o1	! ST0-GS-TLB
		subcc	%g6,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g6,32,%o0	!
		call	st1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l1,0xfff,%o1	!
		mov	%o0,%l1		! save base1

		andncc	%l0,0x1ff,%g0	! check LAP
		bnz,pt	%icc,.+12	!
		andcc	%g7,0x20,%g0	!
		tnz	%icc,0x43	! LAP exception
					!
		andn	%l0,0xfff,%o1	! ST0-GS-TLB
		subcc	%g6,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g6,32,%o0	!
		call	st1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l0,0xfff,%o1	!
		mov	%l1,%o2		! restore base1
		mov	%l2,%o3		! restore base2
		mov	%l6,%o4		! restore offset2
		mov	%l3,%o5		! restore base3
	! %o0: base0
	! %o1: offset0
	! %o2: base1
	! %o3: base2
	! %o4: offset2
	! %o5: base3
	! %l4: length-1
		mov	0,%g1		! CC=0
		mov	0,%l5		! ORed value
    i.oc0lp:	mov	0xfff,%o7	!
		sub	%o7,%o1,%l2	! Until 4K PAGE Boundary
		subcc	%l4,%l2,%g0	! if L >= UPB length = UPB
		movl	%icc,%l4,%l2	! else        length = L
		sub	%o7,%o4,%l3	! Until 4K PAGE Boundary
		subcc	%l4,%l3,%g0	! if L >= UPB length = UPB
		movl	%icc,%l4,%l3	! else        length = L
		subcc	%l2,%l3,%g0	! compare length
		movgu	%icc,%l3,%l2	! select shorter one
		add	%l2,1,%l2	! length-1 -> length

		or	%o1,%o4,%l0	!
		or	%l0,%l2,%l0	!
		andcc	%l0,3,%g0	! if 4byte aligned
		bnz,pn	%icc,i.oc010	!   short cut
		mov	%l2,%l3		! counter

    i.oc000:	ld	[%o0+%o1],%l0	!
		ld	[%o3+%o4],%l1	!
		add	%o4,4,%o4	!
		or	%l0,%l1,%l0	!
		or	%l5,%l0,%l5	!
		st	%l0,[%o0+%o1]	!
		subcc	%l3,4,%l3	!
		bg	%icc,i.oc000	!
		add	%o1,4,%o1	!
		ba,a	%icc,i.oc0end	!
		nop			!

    i.oc010:	ldub	[%o0+%o1],%l0	!
		ldub	[%o3+%o4],%l1	!
		add	%o4,1,%o4	!
		or	%l0,%l1,%l0	!
		or	%l5,%l0,%l5	!
		stb	%l0,[%o0+%o1]	!
		subcc	%l3,1,%l3	!
		bg	%icc,i.oc010	!
		add	%o1,1,%o1	!

    i.oc0end:	subcc	%o1,0xfff,%g0	! if page cross
		movgu	%icc,%o2,%o0	!   base1 -> base0
		and	%o1,0xfff,%o1	!
		subcc	%o4,0xfff,%g0	! if page cross
		movgu	%icc,%o5,%o3	!   base3 -> base2
		and	%o4,0xfff,%o4	!
		subcc	%l4,%l2,%l4	!
		bge	%icc,i.oc0lp	!
		subcc	%l5,0,%g0	!
		movnz	%icc,1,%g1	! if Result != 0 then CC=1
		ba	%icc,break0	!
		add	%g2,%l7,%g2	! ##TEMPLATE:IAR
i.oc0e:

	.section ".text"
	.align	4
	.global ii6_xc
ii6_xc:
	srl	%i3,12,%i5		! B1
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l0		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l0		! %l0
	and	%i3,0xfff,%l1		! D1
	srl	%i4,28,%i5		! B2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l2		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l2		! %l2
	srl	%i4,16,%i5		! D2
	and	%i5,0xfff,%l3		! %l3
	srl	%i3,16,%i5		! L
	and	%i5,0xff,%l4		! %l4
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=6
	add	%g0,6,%l7		!
	movnz	%icc,4,%l7		! if EX=1 then IAR+=4
i.xc0s:
		add	%l0,%l1,%l0	! OP1
		and	%l0,%g3,%l0	! mask address
		add	%l2,%l3,%l2	! OP2
		and	%l2,%g3,%l2	! mask address
		add	%l0,%l4,%l1	! OP1+length-1
		and	%l1,%g3,%l1	! mask address
		add	%l2,%l4,%l3	! OP2+length-1
		and	%l3,%g3,%l3	! mask address

		andn	%l3,0xfff,%o1	! LD0-GS-TLB
		subcc	%g5,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g5,32,%o0	!
		call	ld1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l3,0xfff,%o1	!
		mov	%o0,%l3		! save base3

		andn	%l2,0xfff,%o1	! LD0-GS-TLB
		subcc	%g5,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g5,32,%o0	!
		call	ld1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l2,0xfff,%o1	!
		mov	%o0,%l2		! save base2
		mov	%o1,%l6		! save offset2

		andncc	%l1,0x1ff,%g0	! check LAP
		bnz,pt	%icc,.+12	!
		andcc	%g7,0x20,%g0	!
		tnz	%icc,0x43	! LAP exception
					!
		andn	%l1,0xfff,%o1	! ST0-GS-TLB
		subcc	%g6,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g6,32,%o0	!
		call	st1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l1,0xfff,%o1	!
		mov	%o0,%l1		! save base1

		andncc	%l0,0x1ff,%g0	! check LAP
		bnz,pt	%icc,.+12	!
		andcc	%g7,0x20,%g0	!
		tnz	%icc,0x43	! LAP exception
					!
		andn	%l0,0xfff,%o1	! ST0-GS-TLB
		subcc	%g6,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g6,32,%o0	!
		call	st1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l0,0xfff,%o1	!
		mov	%l1,%o2		! restore base1
		mov	%l2,%o3		! restore base2
		mov	%l6,%o4		! restore offset2
		mov	%l3,%o5		! restore base3
	! %o0: base0
	! %o1: offset0
	! %o2: base1
	! %o3: base2
	! %o4: offset2
	! %o5: base3
	! %l4: length-1
		mov	0,%g1		! CC=0
		mov	0,%l5		! ORed value
    i.xc0lp:	mov	0xfff,%o7	!
		sub	%o7,%o1,%l2	! Until 4K PAGE Boundary
		subcc	%l4,%l2,%g0	! if L >= UPB length = UPB
		movl	%icc,%l4,%l2	! else        length = L
		sub	%o7,%o4,%l3	! Until 4K PAGE Boundary
		subcc	%l4,%l3,%g0	! if L >= UPB length = UPB
		movl	%icc,%l4,%l3	! else        length = L
		subcc	%l2,%l3,%g0	! compare length
		movgu	%icc,%l3,%l2	! select shorter one
		add	%l2,1,%l2	! length-1 -> length

		or	%o1,%o4,%l0	!
		or	%l0,%l2,%l0	!
		andcc	%l0,3,%g0	! if 4byte aligned
		bnz,pn	%icc,i.xc010	!   short cut
		mov	%l2,%l3		! counter

    i.xc000:	ld	[%o0+%o1],%l0	!
		ld	[%o3+%o4],%l1	!
		add	%o4,4,%o4	!
		xor	%l0,%l1,%l0	!
		or	%l5,%l0,%l5	!
		st	%l0,[%o0+%o1]	!
		subcc	%l3,4,%l3	!
		bg	%icc,i.xc000	!
		add	%o1,4,%o1	!
		ba,a	%icc,i.xc0end	!
		nop			!

    i.xc010:	ldub	[%o0+%o1],%l0	!
		ldub	[%o3+%o4],%l1	!
		add	%o4,1,%o4	!
		xor	%l0,%l1,%l0	!
		or	%l5,%l0,%l5	!
		stb	%l0,[%o0+%o1]	!
		subcc	%l3,1,%l3	!
		bg	%icc,i.xc010	!
		add	%o1,1,%o1	!

    i.xc0end:	subcc	%o1,0xfff,%g0	! if page cross
		movgu	%icc,%o2,%o0	!   base1 -> base0
		and	%o1,0xfff,%o1	!
		subcc	%o4,0xfff,%g0	! if page cross
		movgu	%icc,%o5,%o3	!   base3 -> base2
		and	%o4,0xfff,%o4	!
		subcc	%l4,%l2,%l4	!
		bge	%icc,i.xc0lp	!
		subcc	%l5,0,%g0	!
		movnz	%icc,1,%g1	! if Result != 0 then CC=1
		ba	%icc,break0	!
		add	%g2,%l7,%g2	! ##TEMPLATE:IAR
i.xc0e:

	.section ".text"
	.align	4
	.global ii6_tr
ii6_tr:
	srl	%i3,12,%i5		! B1
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l0		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l0		! %l0
	and	%i3,0xfff,%l1		! D1
	srl	%i4,28,%i5		! B2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l2		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l2		! %l2
	srl	%i4,16,%i5		! D2
	and	%i5,0xfff,%l3		! %l3
	srl	%i3,16,%i5		! L
	and	%i5,0xff,%l4		! %l4
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=6
	add	%g0,6,%l7		!
	movnz	%icc,4,%l7		! if EX=1 then IAR+=4
i.tr0s:
		add	%l0,%l1,%l0	! OP1
		and	%l0,%g3,%l0	! mask address
		add	%l2,%l3,%l2	! OP2
		and	%l2,%g3,%l2	! mask address

		add	%g0,0,%l5	! TRIAL-EXEC counter
    i.tr000:	add	%l0,%l5,%l1	! TRIAL-EXEC
	
		andncc	%l1,0x1ff,%g0	! TRIAL-EXEC check LAP
		bnz,pt	%icc,.+12	! TRIAL-EXEC
		andcc	%g7,0x20,%g0	! TRIAL-EXEC
		tnz	%icc,0x43	! TRIAL-EXEC LAP exception
					!
		andn	%l1,0xfff,%o1	! TRIAL-EXEC ST0-GS-TLB
		subcc	%g6,%o1,%g0	! TRIAL-EXEC
		be,a,pt	%icc,.+16	! TRIAL-EXEC
		srlx	%g6,32,%o0	! TRIAL-EXEC
		call	st1_gs_tlb	! TRIAL-EXEC %o0:DS-LA
		mov	%i0,%o0		! TRIAL-EXEC
		and	%l1,0xfff,%o1	! TRIAL-EXEC
		add	%o0,%o1,%l3	! TRIAL-EXEC save address

		ldub	[%o0+%o1],%l1	! TRIAL-EXEC get index
		add	%l2,%l1,%l1	! TRIAL-EXEC

		andn	%l1,0xfff,%o1	! TRIAL-EXEC LD0-GS-TLB
		subcc	%g5,%o1,%g0	! TRIAL-EXEC
		be,a,pt	%icc,.+16	! TRIAL-EXEC
		srlx	%g5,32,%o0	! TRIAL-EXEC
		call	ld1_gs_tlb	! TRIAL-EXEC %o0:DS-LA
		mov	%i0,%o0		! TRIAL-EXEC
		and	%l1,0xfff,%o1	! TRIAL-EXEC
	
		subcc	%l4,%l5,%g0	! TRIAL-EXEC ##TEMPLATE:imm0 (L)
		bne	%icc,i.tr000	! TRIAL-EXEC
		add	%l5,1,%l5	! TRIAL-EXEC

		add	%g0,0,%l5	! counter
    i.tr001:	add	%l0,%l5,%l1	!
	
		andncc	%l1,0x1ff,%g0	! check LAP
		bnz,pt	%icc,.+12	!
		andcc	%g7,0x20,%g0	!
		tnz	%icc,0x43	! LAP exception
					!
		andn	%l1,0xfff,%o1	! ST0-GS-TLB
		subcc	%g6,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g6,32,%o0	!
		call	st1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l1,0xfff,%o1	!
		add	%o0,%o1,%l3	! save address

		ldub	[%o0+%o1],%l1	! get index
		add	%l2,%l1,%l1	!

		andn	%l1,0xfff,%o1	! LD0-GS-TLB
		subcc	%g5,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g5,32,%o0	!
		call	ld1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l1,0xfff,%o1	!
	
		ldub	[%o0+%o1],%l1	! get indexed character
		subcc	%l4,%l5,%g0	! ##TEMPLATE:imm0 (L)
		stb	%l1,[%l3]	! store indexed character
		bne	%icc,i.tr001	!
		add	%l5,1,%l5	!
		ba	%icc,break0	!
		add	%g2,%l7,%g2	! ##TEMPLATE:IAR
i.tr0e:

	.section ".text"
	.align	4
	.global ii6_trt
ii6_trt:
	srl	%i3,12,%i5		! B1
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l0		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l0		! %l0
	and	%i3,0xfff,%l1		! D1
	srl	%i4,28,%i5		! B2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l2		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l2		! %l2
	srl	%i4,16,%i5		! D2
	and	%i5,0xfff,%l3		! %l3
	srl	%i3,16,%i5		! L
	and	%i5,0xff,%l4		! %l4
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=6
	add	%g0,6,%l7		!
	movnz	%icc,4,%l7		! if EX=1 then IAR+=4
i.trt0s:
		add	%l0,%l1,%l0	! OP1
		and	%l0,%g3,%l0	! mask address
		add	%l2,%l3,%l2	! OP2
		and	%l2,%g3,%l2	! mask address

		add	%g0,0,%l5	! TRIAL-EXEC counter
    i.trt000:	add	%l0,%l5,%l1	! TRIAL-EXEC

		andn	%l1,0xfff,%o1	! TRIAL-EXEC LD0-GS-TLB
		subcc	%g5,%o1,%g0	! TRIAL-EXEC
		be,a,pt	%icc,.+16	! TRIAL-EXEC
		srlx	%g5,32,%o0	! TRIAL-EXEC
		call	ld1_gs_tlb	! TRIAL-EXEC %o0:DS-LA
		mov	%i0,%o0		! TRIAL-EXEC
		and	%l1,0xfff,%o1	! TRIAL-EXEC

		ldub	[%o0+%o1],%l1	! TRIAL-EXEC get index
		add	%l2,%l1,%l1	! TRIAL-EXEC

		andn	%l1,0xfff,%o1	! TRIAL-EXEC LD0-GS-TLB
		subcc	%g5,%o1,%g0	! TRIAL-EXEC
		be,a,pt	%icc,.+16	! TRIAL-EXEC
		srlx	%g5,32,%o0	! TRIAL-EXEC
		call	ld1_gs_tlb	! TRIAL-EXEC %o0:DS-LA
		mov	%i0,%o0		! TRIAL-EXEC
		and	%l1,0xfff,%o1	! TRIAL-EXEC

		ldub	[%o0+%o1],%l1	! TRIAL-EXEC get indexed character	
		subcc	%l1,0,%g0	! TRIAL-EXEC
		bnz	%icc,i.trt001	! TRIAL-EXEC
		subcc	%l4,%l5,%g0	! TRIAL-EXEC ##TEMPLATE:imm0 (L)
		bne	%icc,i.trt000	! TRIAL-EXEC
		add	%l5,1,%l5	! TRIAL-EXEC
	
    i.trt001:	ld	[%i0+4],%i1	! ##Mreg1 -> %i1
		ld	[%i0+8],%i2	! ##Mreg2 -> %i2
		mov	0,%g1		! CC=0
		add	%g0,0,%l5	! counter
    i.trt002:	add	%l0,%l5,%l1	!

		andn	%l1,0xfff,%o1	! LD0-GS-TLB
		subcc	%g5,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g5,32,%o0	!
		call	ld1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l1,0xfff,%o1	!

		ldub	[%o0+%o1],%l1	! get index
		add	%l2,%l1,%l1	!

		andn	%l1,0xfff,%o1	! LD0-GS-TLB
		subcc	%g5,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g5,32,%o0	!
		call	ld1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l1,0xfff,%o1	!

		ldub	[%o0+%o1],%l1	! get indexed character	
		subcc	%l1,0,%g0	!
		bnz	%icc,i.trt006	!
		subcc	%l4,%l5,%g0	! ##TEMPLATE:imm0 (L)
		bne	%icc,i.trt002	!
		add	%l5,1,%l5	!
		ba,a	%icc,i.trt005	!
    i.trt006:	add	%l0,%l5,%l0	!
		andcc	%g7,0x10,%g0	! check AM(address mode)
		bnz,pt	%icc,i.trt003	!
		srl	%i1,24,%i1	!
		sll	%i1,24,%i1	!
		sll	%l0,8,%l0	!
		srl	%l0,8,%l0	!
		ba	%icc,i.trt004	!
		or	%i1,%l0,%i1	! 24bit argument address
    i.trt003:	sll	%l0,1,%l0	!
		srl	%l0,1,%i1	! 31bit argument address
    i.trt004:	andn	%i2,0xff,%i2	!
		or	%i2,%l1,%i2	! function byte
		subcc	%l4,%l5,%g0	! ##TEMPLATE:imm0 (L)
		movne	%icc,1,%g1	! if not last byte CC=1
		move	%icc,2,%g1	! if last byte CC=2
    i.trt005:	st	%i1,[%i0+4]	!
		st	%i2,[%i0+8]	!
		ba	%icc,break0	!
		add	%g2,%l7,%g2	! ##TEMPLATE:IAR
i.trt0e:

	.section ".text"
	.align	4
	.global id6_ed
id6_ed:
	srl	%i3,12,%i5		! B1
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l0		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l0		! %l0
	and	%i3,0xfff,%l1		! D1
	srl	%i4,28,%i5		! B2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l2		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l2		! %l2
	srl	%i4,16,%i5		! D2
	and	%i5,0xfff,%l3		! %l3
	srl	%i3,16,%i5		! L
	and	%i5,0xff,%l4		! %l4
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=6
	add	%g0,6,%l7		!
	movnz	%icc,4,%l7		! if EX=1 then IAR+=4
	st	%l7,[%i0+832]		! save mlen
i.ed0s:
		add	%l0,%l1,%l0	! OP1
		and	%l0,%g3,%i1	! mask address
		add	%l2,%l3,%l2	! OP2
		and	%l2,%g3,%i2	! mask address
		mov	%l4,%i3		! length
	!   %i1: B1+D1
	!   %i2: B2+D2
	!   %i3: L

		/******** TRIAL EXECUTION *********/
		add	%g0,0,%l4	! reset R1 counter
		add	%g0,0,%l5	! reset R2 counter
		add	%i1,%l4,%i7	!
	
		andn	%i7,0xfff,%o1	! LD0-GS-TLB
		subcc	%g5,%o1,%g0	! 
		be,a,pt	%icc,.+16	! 
		srlx	%g5,32,%o0	! 
		call	ld1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		! 
		and	%i7,0xfff,%o1	! 

		ba	__edtop		!
		ldub	[%o0+%o1],%l0	! get fill-byte

    __edloop:	subcc	%i3,%l4,%g0	!
		be	__edbreak	!
		add	%l4,1,%l4	! update R1 counter
    __edtop:	add	%i1,%l4,%i7	!
	
		andn	%i7,0xfff,%o1	! LD0-GS-TLB
		subcc	%g5,%o1,%g0	! 
		be,a,pt	%icc,.+16	! 
		srlx	%g5,32,%o0	! 
		call	ld1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		! 
		and	%i7,0xfff,%o1	! 

		ldub	[%o0+%o1],%l1	! get pattern-byte
		subcc	%l1,0x20,%g0	!
		be	__ed0		!
		subcc	%l1,0x21,%g0	! if pattern-byte == 0x20/0x21 then
		bne	__edloop	!
    __ed0:	andcc	%l5,1,%g0	!
		bnz,a	__edloop	!
		add	%l5,1,%l5	!   update counter
		srl	%l5,1,%i4	! if left 4bit then
		add	%i2,%i4,%i7	!

		andn	%i7,0xfff,%o1	! LD0-GS-TLB
		subcc	%g5,%o1,%g0	! 
		be,a,pt	%icc,.+16	! 
		srlx	%g5,32,%o0	! 
		call	ld1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		! 
		and	%i7,0xfff,%o1	! 

		ldub	[%o0+%o1],%l2	!   get new source-byte
		srl	%l2,4,%i4	!   get left 4bit
		and	%l2,0xf,%i5	!
		subcc	%i4,0xa,%g0	!
		sethi	%hi(0x00070000),%o7
		bge,a	_edexit		!   if not digit then
		or	%g7,%o7,%g7	!     data exception
		subcc	%i5,0xa,%g0	!
		bge,a	__ed0s		!   if right 4bit is sign then
		add	%l5,1,%l5	!     increment counter to skip sign
    __ed0s:	ba	__edloop	!
		add	%l5,1,%l5	!   update counter
					! ====
    __edbreak:				!

		/******** ACTUAL EXECUTION ********/
		add	%g0,0,%l4	! reset R1 counter
		add	%g0,0,%l5	! reset R2 counter
		add	%g0,0,%l6	! reset significance-indicator
		add	%g0,0,%l7	! reset internal-NZ
		add	%i1,%l4,%i7	!
	
		andn	%i7,0xfff,%o1	! LD0-GS-TLB
		subcc	%g5,%o1,%g0	! 
		be,a,pt	%icc,.+16	! 
		srlx	%g5,32,%o0	! 
		call	ld1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		! 
		and	%i7,0xfff,%o1	! 

		ba	_edtop		!
		ldub	[%o0+%o1],%l0	! get fill-byte
    _edloop:	subcc	%i3,%l4,%g0	!
		be	_edbreak	!
		add	%l4,1,%l4	! update R1 counter
    _edtop:	add	%i1,%l4,%i7	!
	
		andn	%i7,0xfff,%o1	! LD0-GS-TLB
		subcc	%g5,%o1,%g0	! 
		be,a,pt	%icc,.+16	! 
		srlx	%g5,32,%o0	! 
		call	ld1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		! 
		and	%i7,0xfff,%o1	! 

		ldub	[%o0+%o1],%l1	! get pattern-byte
		subcc	%l1,0x20,%g0	!
		bne,a	_ed1		!
		subcc	%l1,0x21,%g0	! if pattern-byte == 0x20 then
		andcc	%l5,1,%g0	!
		and	%l2,0xf,%i4	!
		bnz,a	_ed0r		!
		add	%g0,0,%i5	!
    _ed0l:	srl	%l5,1,%i4	! if left 4bit then
		add	%i2,%i4,%i7	!

		andn	%i7,0xfff,%o1	! LD0-GS-TLB
		subcc	%g5,%o1,%g0	! 
		be,a,pt	%icc,.+16	! 
		srlx	%g5,32,%o0	! 
		call	ld1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		! 
		and	%i7,0xfff,%o1	! 

		ldub	[%o0+%o1],%l2	!   get new source-byte
		srl	%l2,4,%i4	!   get left 4bit
		and	%l2,0xf,%i5	!
    _ed0r:	subcc	%i4,0xa,%g0	!
		sethi	%hi(0x00070000),%o7
		bge,a	_edexit		!   if not digit then
		or	%g7,%o7,%g7	!     data exception
		subcc	%i5,0xa,%g0	!
		bge,a	_ed0s		!   if right 4bit is sign then
		add	%l5,1,%l5	!     increment counter to skip sign
    _ed0s:	add	%l5,1,%l5	!   update counter
		subcc	%l6,0,%g0	!
		bnz	_ed0on		!   if sig-ind == off then
		subcc	%i4,0,%g0	!     if left 4bit == 0 then
    _ed0of:	bnz,a	_ed0ofnz	!
		add	%g0,1,%l7	!       (mark NZ)
    _ed0ofe:	add	%i1,%l4,%i7	!

		andncc	%i7,0x1ff,%g0	! check LAP
		bnz,pt	%icc,.+12	!
		andcc	%g7,0x20,%g0	!
		tnz	%icc,0x43	! LAP exception
					!
		andn	%i7,0xfff,%o1	! ST0-GS-TLB
		subcc	%g6,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g6,32,%o0	!
		call	st1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%i7,0xfff,%o1	!

		ba	_edloop		!
		stb	%l0,[%o0+%o1]	! store fill-byte
					! ----
    _ed0ofnz:	subcc	%i5,0xa,%g0	!     if left 4bit != 0 then
		be	_ed0ofnze	!       if right 4bit != '+' then
		subcc	%i5,0xc,%g0	!         force sig-ind = on
		be	_ed0ofnze	!
		subcc	%i5,0xe,%g0	!
		bge	_ed0ofnze	!
		nop			!
		add	%g0,1,%l6	!       endif
    _ed0ofnze:	or	%i4,0xf0,%i5	!       pack -> zone
		add	%i1,%l4,%i7	!

		andncc	%i7,0x1ff,%g0	! check LAP
		bnz,pt	%icc,.+12	!
		andcc	%g7,0x20,%g0	!
		tnz	%icc,0x43	! LAP exception
					!
		andn	%i7,0xfff,%o1	! ST0-GS-TLB
		subcc	%g6,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g6,32,%o0	!
		call	st1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%i7,0xfff,%o1	!	
	
		ba	_edloop		!
		stb	%i5,[%o0+%o1]	! store digit
					! ----
    _ed0on:	bnz,a	_ed0onnz	!   if sig-ind == on then
		add	%g0,1,%l7	!     if if left 4bit == 0 then
    _ed0onnz:	subcc	%i5,0xa,%g0	!       (mark NZ)
		be,a	_ed0one		!     if right 4bit == '+' then
		add	%g0,0,%l6	!       force sig-ind = off
		subcc	%i5,0xc,%g0	!
		be,a	_ed0one		!
		add	%g0,0,%l6	!
		subcc	%i5,0xe,%g0	!
		bge,a	_ed0one		!
		add	%g0,0,%l6	!     endif
    _ed0one:	or	%i4,0xf0,%i5	!     pack -> zone
		add	%i1,%l4,%i7	!

		andncc	%i7,0x1ff,%g0	! check LAP
		bnz,pt	%icc,.+12	!
		andcc	%g7,0x20,%g0	!
		tnz	%icc,0x43	! LAP exception
					!
		andn	%i7,0xfff,%o1	! ST0-GS-TLB
		subcc	%g6,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g6,32,%o0	!
		call	st1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%i7,0xfff,%o1	!	
	
		ba	_edloop		!
		stb	%i5,[%o0+%o1]	! store digit
					! ====
    _ed1:	bne,a	_ed2		!
		subcc	%l1,0x22,%g0	! if pattern-byte == 0x21 then
		andcc	%l5,1,%g0	!
		and	%l2,0xf,%i4	!
		bnz,a	_ed1r		!
		add	%g0,0,%i5	!
    _ed1l:	srl	%l5,1,%i4	! if left 4bit then
		add	%i2,%i4,%i7	!

		andn	%i7,0xfff,%o1	! LD0-GS-TLB
		subcc	%g5,%o1,%g0	! 
		be,a,pt	%icc,.+16	! 
		srlx	%g5,32,%o0	! 
		call	ld1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		! 
		and	%i7,0xfff,%o1	! 

		ldub	[%o0+%o1],%l2	!   get new source-byte
		srl	%l2,4,%i4	!   get left 4bit
		and	%l2,0xf,%i5	!
    _ed1r:	subcc	%i4,0xa,%g0	!
		sethi	%hi(0x00070000),%o7
		bge,a	_edexit		!   if not digit then
		or	%g7,%o7,%g7	!     data exception
		subcc	%i5,0xa,%g0	!
		bge,a	_ed1s		!   if right 4bit is sign then
		add	%l5,1,%l5	!     increment counter to skip sign
    _ed1s:	add	%l5,1,%l5	!   update counter
		subcc	%l6,0,%g0	!
		bnz	_ed1on		!   if sig-ind == off then
		subcc	%i4,0,%g0	!     if left 4bit == 0 then
    _ed1of:	bnz,a	_ed1ofnz	!
		add	%g0,1,%l7	!       (mark NZ)
		subcc	%i5,0xa,%g0	!       if right 4bit != '+' then
		be	_ed1ofe		!         force sig-ind = on
		subcc	%i5,0xc,%g0	!
		be	_ed1ofe		!
		subcc	%i5,0xe,%g0	!
		bge	_ed1ofe		!
		nop			!
		add	%g0,1,%l6	!       endif
    _ed1ofe:	add	%i1,%l4,%i7	!

		andncc	%i7,0x1ff,%g0	! check LAP
		bnz,pt	%icc,.+12	!
		andcc	%g7,0x20,%g0	!
		tnz	%icc,0x43	! LAP exception
					!
		andn	%i7,0xfff,%o1	! ST0-GS-TLB
		subcc	%g6,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g6,32,%o0	!
		call	st1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%i7,0xfff,%o1	!	

		ba	_edloop		!
		stb	%l0,[%o0+%o1]	! store fill-byte
					! ----
    _ed1ofnz:	subcc	%i5,0xa,%g0	!     if left 4bit != 0 then
		be	_ed1ofnze	!       if right 4bit != '+' then
		subcc	%i5,0xc,%g0	!         force sig-ind = on
		be	_ed1ofnze	!
		subcc	%i5,0xe,%g0	!
		bge	_ed1ofnze	!
		nop			!
		add	%g0,1,%l6	!       endif
    _ed1ofnze:	or	%i4,0xf0,%i5	!       pack -> zone
		add	%i1,%l4,%i7	!

		andncc	%i7,0x1ff,%g0	! check LAP
		bnz,pt	%icc,.+12	!
		andcc	%g7,0x20,%g0	!
		tnz	%icc,0x43	! LAP exception
					!
		andn	%i7,0xfff,%o1	! ST0-GS-TLB
		subcc	%g6,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g6,32,%o0	!
		call	st1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%i7,0xfff,%o1	!	
	
		ba	_edloop		!
		stb	%i5,[%o0+%o1]	! store digit
					! ----
    _ed1on:	bnz,a	_ed1onnz	!   if sig-ind == on then  
		add	%g0,1,%l7	!     if left 4bit == 0 then
    _ed1onnz:	subcc	%i5,0xa,%g0	!       (mark NZ)
		be,a	_ed1one		!     if right 4bit == '+' then
		add	%g0,0,%l6	!       force sig-ind = off
		subcc	%i5,0xc,%g0	!
		be,a	_ed1one		!
		add	%g0,0,%l6	!
		subcc	%i5,0xe,%g0	!
		bge,a	_ed1one		!
		add	%g0,0,%l6	!     endif
    _ed1one:	or	%i4,0xf0,%i5	!     pack -> zone
		add	%i1,%l4,%i7	!

		andncc	%i7,0x1ff,%g0	! check LAP
		bnz,pt	%icc,.+12	!
		andcc	%g7,0x20,%g0	!
		tnz	%icc,0x43	! LAP exception
					!
		andn	%i7,0xfff,%o1	! ST0-GS-TLB
		subcc	%g6,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g6,32,%o0	!
		call	st1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%i7,0xfff,%o1	!	
	
		ba	_edloop		!
		stb	%i5,[%o0+%o1]	! store digit
					! ====
    _ed2:	bne,a	_ed3		!
		nop			! if pattern-byte == 0x22 then
		add	%g0,0,%l6	!   force sig-ind = off
		add	%g0,0,%l7	!   reset NZ
		add	%i1,%l4,%i7	!

		andncc	%i7,0x1ff,%g0	! check LAP
		bnz,pt	%icc,.+12	!
		andcc	%g7,0x20,%g0	!
		tnz	%icc,0x43	! LAP exception
					!
		andn	%i7,0xfff,%o1	! ST0-GS-TLB
		subcc	%g6,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g6,32,%o0	!
		call	st1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%i7,0xfff,%o1	!	
	
		ba	_edloop		!
		stb	%l0,[%o0+%o1]	! store fill-byte
					! ====
    _ed3:	add	%i1,%l4,%i7	!

		andncc	%i7,0x1ff,%g0	! check LAP
		bnz,pt	%icc,.+12	!
		andcc	%g7,0x20,%g0	!
		tnz	%icc,0x43	! LAP exception
					!
		andn	%i7,0xfff,%o1	! ST0-GS-TLB
		subcc	%g6,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g6,32,%o0	!
		call	st1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%i7,0xfff,%o1	!	
	
		subcc	%l6,0,%g0	! if pattern-byte == message then
		bz,a	_edloop		!   if sig-ind == off then
		stb	%l0,[%o0+%o1]	!     store fill-byte
		ba	_edloop		!   if sig-ind == on then
		stb	%l1,[%o0+%o1]	!     store message-byte
					! ====
    _edbreak:	mov	0,%g1		! CC=0
		subcc	%l7,0,%g0	! if NZ == 0 then
		bz	_edexit		!   CC=0
		subcc	%l6,0,%g0	! if sig-ind == on then
		movnz	%icc,1,%g1	!   CC=1
		movz	%icc,2,%g1	! else CC=2
	
		/* RETURN */
    _edexit:	ld	[%i0+832],%l7	! restore mlen
		sethi	%hi(0x00ff0000),%o7
		andcc	%g7,%o7,%g0	! if intermediate intr. then
		bz,a	%icc,break0	!   exit
		add	%g2,%l7,%g2	! ##TEMPLATE:IAR
		ba,a	%icc,epilog0	!
		nop			!
i.ed0e:

	.section ".text"
	.align	4
	.global id6_edmk
id6_edmk:
	srl	%i3,12,%i5		! B1
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l0		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l0		! %l0
	and	%i3,0xfff,%l1		! D1
	srl	%i4,28,%i5		! B2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l2		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l2		! %l2
	srl	%i4,16,%i5		! D2
	and	%i5,0xfff,%l3		! %l3
	srl	%i3,16,%i5		! L
	and	%i5,0xff,%l4		! %l4
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=6
	add	%g0,6,%l7		!
	movnz	%icc,4,%l7		! if EX=1 then IAR+=4
	st	%l7,[%i0+832]		! save mlen
i.edmk0s:
		add	%l0,%l1,%l0	! OP1
		and	%l0,%g3,%i1	! mask address
		add	%l2,%l3,%l2	! OP2
		and	%l2,%g3,%i2	! mask address
		mov	%l4,%i3		! length
	!   %i1: B1+D1
	!   %i2: B2+D2
	!   %i3: L

		/******** TRIAL EXECUTION *********/
		add	%g0,0,%l4	! reset R1 counter
		add	%g0,0,%l5	! reset R2 counter
		add	%i1,%l4,%i7	!
	
		andn	%i7,0xfff,%o1	! LD0-GS-TLB
		subcc	%g5,%o1,%g0	! 
		be,a,pt	%icc,.+16	! 
		srlx	%g5,32,%o0	! 
		call	ld1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		! 
		and	%i7,0xfff,%o1	! 

		ba	__edmktop	!
		ldub	[%o0+%o1],%l0	! get fill-byte

    __edmkloop:	subcc	%i3,%l4,%g0	!
		be	__edmkbreak	!
		add	%l4,1,%l4	! update R1 counter
    __edmktop:	add	%i1,%l4,%i7	!
	
		andn	%i7,0xfff,%o1	! LD0-GS-TLB
		subcc	%g5,%o1,%g0	! 
		be,a,pt	%icc,.+16	! 
		srlx	%g5,32,%o0	! 
		call	ld1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		! 
		and	%i7,0xfff,%o1	! 

		ldub	[%o0+%o1],%l1	! get pattern-byte
		subcc	%l1,0x20,%g0	!
		be	__edmk0		!
		subcc	%l1,0x21,%g0	! if pattern-byte == 0x20/0x21 then
		bne	__edmkloop	!
    __edmk0:	andcc	%l5,1,%g0	!
		bnz,a	__edmkloop	!
		add	%l5,1,%l5	!   update counter
		srl	%l5,1,%i4	! if left 4bit then
		add	%i2,%i4,%i7	!

		andn	%i7,0xfff,%o1	! LD0-GS-TLB
		subcc	%g5,%o1,%g0	! 
		be,a,pt	%icc,.+16	! 
		srlx	%g5,32,%o0	! 
		call	ld1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		! 
		and	%i7,0xfff,%o1	! 

		ldub	[%o0+%o1],%l2	!   get new source-byte
		srl	%l2,4,%i4	!   get left 4bit
		and	%l2,0xf,%i5	!
		subcc	%i4,0xa,%g0	!
		sethi	%hi(0x00070000),%o7
		bge,a	_edmkexit	!   if not digit then
		or	%g7,%o7,%g7	!     data exception
		subcc	%i5,0xa,%g0	!
		bge,a	__edmk0s	!   if right 4bit is sign then
		add	%l5,1,%l5	!     increment counter to skip sign
    __edmk0s:	ba	__edmkloop	!
		add	%l5,1,%l5	!   update counter
					! ====
    __edmkbreak:			!
	
		/******** ACTUAL EXECUTION ********/
		ld	[%i0+4],%l3	! reset internal-MARK
		add	%g0,0,%l4	! reset R1 counter
		add	%g0,0,%l5	! reset R2 counter
		add	%g0,0,%l6	! reset significance-indicator
		add	%g0,0,%l7	! reset internal-NZ
		add	%i1,%l4,%i7	!
	
		andn	%i7,0xfff,%o1	! LD0-GS-TLB
		subcc	%g5,%o1,%g0	! 
		be,a,pt	%icc,.+16	! 
		srlx	%g5,32,%o0	! 
		call	ld1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		! 
		and	%i7,0xfff,%o1	! 

		ba	_edmktop	!
		ldub	[%o0+%o1],%l0	! get fill-byte
    _edmkloop:	subcc	%i3,%l4,%g0	!
		be	_edmkbreak	!
		add	%l4,1,%l4	! update R1 counter
    _edmktop:	add	%i1,%l4,%i7	!
	
		andn	%i7,0xfff,%o1	! LD0-GS-TLB
		subcc	%g5,%o1,%g0	! 
		be,a,pt	%icc,.+16	! 
		srlx	%g5,32,%o0	! 
		call	ld1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		! 
		and	%i7,0xfff,%o1	! 

		ldub	[%o0+%o1],%l1	! get pattern-byte
		subcc	%l1,0x20,%g0	!
		bne,a	_edmk1		!
		subcc	%l1,0x21,%g0	! if pattern-byte == 0x20 then
		andcc	%l5,1,%g0	!
		and	%l2,0xf,%i4	!
		bnz,a	_edmk0r		!
		add	%g0,0,%i5	!
    _edmk0l:	srl	%l5,1,%i4	! if left 4bit then
		add	%i2,%i4,%i7	!

		andn	%i7,0xfff,%o1	! LD0-GS-TLB
		subcc	%g5,%o1,%g0	! 
		be,a,pt	%icc,.+16	! 
		srlx	%g5,32,%o0	! 
		call	ld1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		! 
		and	%i7,0xfff,%o1	! 

		ldub	[%o0+%o1],%l2	!   get new source-byte
		srl	%l2,4,%i4	!   get left 4bit
		and	%l2,0xf,%i5	!
    _edmk0r:	subcc	%i4,0xa,%g0	!
		sethi	%hi(0x00070000),%o7
		bge,a	_edmkexit	!   if not digit then
		or	%g7,%o7,%g7	!     data exception
		subcc	%i5,0xa,%g0	!
		bge,a	_edmk0s		!   if right 4bit is sign then
		add	%l5,1,%l5	!     increment counter to skip sign
    _edmk0s:	add	%l5,1,%l5	!   update counter
		subcc	%l6,0,%g0	!
		bnz	_edmk0on	!   if sig-ind == off then
		subcc	%i4,0,%g0	!     if left 4bit == 0 then
    _edmk0of:	bnz,a	_edmk0ofnz	!
		add	%g0,1,%l7	!       (mark NZ)
    _edmk0ofe:	add	%i1,%l4,%i7	!

		andncc	%i7,0x1ff,%g0	! check LAP
		bnz,pt	%icc,.+12	!
		andcc	%g7,0x20,%g0	!
		tnz	%icc,0x43	! LAP exception
					!
		andn	%i7,0xfff,%o1	! ST0-GS-TLB
		subcc	%g6,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g6,32,%o0	!
		call	st1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%i7,0xfff,%o1	!

		ba	_edmkloop	!
		stb	%l0,[%o0+%o1]	!       store fill-byte
					! ----
    _edmk0ofnz:	subcc	%i5,0xa,%g0	!     if left 4bit != 0 then
		be	_edmk0ofnze	!       if right 4bit != '+' then
		subcc	%i5,0xc,%g0	!         force sig-ind = on
		be	_edmk0ofnze	!
		subcc	%i5,0xe,%g0	!
		bge	_edmk0ofnze	!
		nop			!
		add	%g0,1,%l6	!       endif
    _edmk0ofnze:add	%i1,%l4,%l3	!       MARK
		or	%i4,0xf0,%i5	!       pack -> zone
		add	%i1,%l4,%i7	!

		andncc	%i7,0x1ff,%g0	! check LAP
		bnz,pt	%icc,.+12	!
		andcc	%g7,0x20,%g0	!
		tnz	%icc,0x43	! LAP exception
					!
		andn	%i7,0xfff,%o1	! ST0-GS-TLB
		subcc	%g6,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g6,32,%o0	!
		call	st1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%i7,0xfff,%o1	!	
	
		ba	_edmkloop	!
		stb	%i5,[%o0+%o1]	! store digit
					! ----
    _edmk0on:	bnz,a	_edmk0onnz	!   if sig-ind == on then
		add	%g0,1,%l7	!     if if left 4bit == 0 then
    _edmk0onnz:	subcc	%i5,0xa,%g0	!       (mark NZ)
		be,a	_edmk0one	!     if right 4bit == '+' then
		add	%g0,0,%l6	!       force sig-ind = off
		subcc	%i5,0xc,%g0	!
		be,a	_edmk0one	!
		add	%g0,0,%l6	!
		subcc	%i5,0xe,%g0	!
		bge,a	_edmk0one	!
		add	%g0,0,%l6	!     endif
    _edmk0one:	or	%i4,0xf0,%i5	!     pack -> zone
		add	%i1,%l4,%i7	!

		andncc	%i7,0x1ff,%g0	! check LAP
		bnz,pt	%icc,.+12	!
		andcc	%g7,0x20,%g0	!
		tnz	%icc,0x43	! LAP exception
					!
		andn	%i7,0xfff,%o1	! ST0-GS-TLB
		subcc	%g6,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g6,32,%o0	!
		call	st1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%i7,0xfff,%o1	!	
	
		ba	_edmkloop	!
		stb	%i5,[%o0+%o1]	! store digit
					! ====
    _edmk1:	bne,a	_edmk2		!
		subcc	%l1,0x22,%g0	! if pattern-byte == 0x21 then
		andcc	%l5,1,%g0	!
		and	%l2,0xf,%i4	!
		bnz,a	_edmk1r		!
		add	%g0,0,%i5	!
    _edmk1l:	srl	%l5,1,%i4	! if left 4bit then
		add	%i2,%i4,%i7	!

		andn	%i7,0xfff,%o1	! LD0-GS-TLB
		subcc	%g5,%o1,%g0	! 
		be,a,pt	%icc,.+16	! 
		srlx	%g5,32,%o0	! 
		call	ld1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		! 
		and	%i7,0xfff,%o1	! 

		ldub	[%o0+%o1],%l2	!   get new source-byte
		srl	%l2,4,%i4	!   get left 4bit
		and	%l2,0xf,%i5	!
    _edmk1r:	subcc	%i4,0xa,%g0	!
		sethi	%hi(0x00070000),%o7
		bge,a	_edmkexit	!   if not digit then
		or	%g7,%o7,%g7	!     data exception
		subcc	%i5,0xa,%g0	!
		bge,a	_edmk1s		!   if right 4bit is sign then
		add	%l5,1,%l5	!     increment counter to skip sign
    _edmk1s:	add	%l5,1,%l5	!   update counter
		subcc	%l6,0,%g0	!
		bnz	_edmk1on	!   if sig-ind == off then
		subcc	%i4,0,%g0	!     if left 4bit == 0 then
    _edmk1of:	bnz,a	_edmk1ofnz	!
		add	%g0,1,%l7	!       (mark NZ)
		subcc	%i5,0xa,%g0	!       if right 4bit != '+' then
		be	_edmk1ofe	!         force sig-ind = on
		subcc	%i5,0xc,%g0	!
		be	_edmk1ofe	!
		subcc	%i5,0xe,%g0	!
		bge	_edmk1ofe	!
		nop			!
		add	%g0,1,%l6	!       endif
    _edmk1ofe:	add	%i1,%l4,%i7	!

		andncc	%i7,0x1ff,%g0	! check LAP
		bnz,pt	%icc,.+12	!
		andcc	%g7,0x20,%g0	!
		tnz	%icc,0x43	! LAP exception
					!
		andn	%i7,0xfff,%o1	! ST0-GS-TLB
		subcc	%g6,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g6,32,%o0	!
		call	st1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%i7,0xfff,%o1	!	
	
		ba	_edmkloop	!
		stb	%l0,[%o0+%o1]	! store fill-byte
					! ----
    _edmk1ofnz:	subcc	%i5,0xa,%g0	!     if left 4bit != 0 then
		be	_edmk1ofnze	!       if right 4bit != '+' then
		subcc	%i5,0xc,%g0	!         force sig-ind = on
		be	_edmk1ofnze	!
		subcc	%i5,0xe,%g0	!
		bge	_edmk1ofnze	!
		nop			!
		add	%g0,1,%l6	!       endif
    _edmk1ofnze:add	%i1,%l4,%l3	!       MARK
		or	%i4,0xf0,%i5	!       pack -> zone
		add	%i1,%l4,%i7	!

		andncc	%i7,0x1ff,%g0	! check LAP
		bnz,pt	%icc,.+12	!
		andcc	%g7,0x20,%g0	!
		tnz	%icc,0x43	! LAP exception
					!
		andn	%i7,0xfff,%o1	! ST0-GS-TLB
		subcc	%g6,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g6,32,%o0	!
		call	st1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%i7,0xfff,%o1	!	
	
		ba	_edmkloop	!
		stb	%i5,[%o0+%o1]	! store digit
					! ----
    _edmk1on:	bnz,a	_edmk1onnz	!   if sig-ind == on then  
		add	%g0,1,%l7	!     if left 4bit == 0 then
    _edmk1onnz:	subcc	%i5,0xa,%g0	!       (mark NZ)
		be,a	_edmk1one	!     if right 4bit == '+' then
		add	%g0,0,%l6	!       force sig-ind = off
		subcc	%i5,0xc,%g0	!
		be,a	_edmk1one	!
		add	%g0,0,%l6	!
		subcc	%i5,0xe,%g0	!
		bge,a	_edmk1one	!
		add	%g0,0,%l6	!     endif
    _edmk1one:	or	%i4,0xf0,%i5	!     pack -> zone
		add	%i1,%l4,%i7	!

		andncc	%i7,0x1ff,%g0	! check LAP
		bnz,pt	%icc,.+12	!
		andcc	%g7,0x20,%g0	!
		tnz	%icc,0x43	! LAP exception
					!
		andn	%i7,0xfff,%o1	! ST0-GS-TLB
		subcc	%g6,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g6,32,%o0	!
		call	st1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%i7,0xfff,%o1	!	
	
		ba	_edmkloop	!
		stb	%i5,[%o0+%o1]	! store digit
					! ====
    _edmk2:	bne,a	_edmk3		!
		nop			! if pattern-byte == 0x22 then
		add	%g0,0,%l6	!   force sig-ind = off
		add	%g0,0,%l7	!   reset NZ
		add	%i1,%l4,%i7	!

		andncc	%i7,0x1ff,%g0	! check LAP
		bnz,pt	%icc,.+12	!
		andcc	%g7,0x20,%g0	!
		tnz	%icc,0x43	! LAP exception
					!
		andn	%i7,0xfff,%o1	! ST0-GS-TLB
		subcc	%g6,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g6,32,%o0	!
		call	st1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%i7,0xfff,%o1	!	
	
		ba	_edmkloop	!
		stb	%l0,[%o0+%o1]	! store fill-byte
					! ====
    _edmk3:	add	%i1,%l4,%i7	!

		andncc	%i7,0x1ff,%g0	! check LAP
		bnz,pt	%icc,.+12	!
		andcc	%g7,0x20,%g0	!
		tnz	%icc,0x43	! LAP exception
					!
		andn	%i7,0xfff,%o1	! ST0-GS-TLB
		subcc	%g6,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g6,32,%o0	!
		call	st1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%i7,0xfff,%o1	!	
	
		subcc	%l6,0,%g0	! if pattern-byte == message then
		bz,a	_edmkloop	!   if sig-ind == off then
		stb	%l0,[%o0+%o1]	!     store fill-byte
		ba	_edmkloop	!   if sig-ind == on then
		stb	%l1,[%o0+%o1]	!     store message-byte
					! ====
    _edmkbreak:	andcc	%g7,0x10,%g0	! if AM == 1 then
		sethi	%hi(0x80000000),%o7
		bnz,a	_edmk31bit	!   get 31bit address
		andn	%l3,%o7,%l3	!   rewrite Mreg#1
		sethi	%hi(0xff000000),%o7
		ld	[%i0+4],%l2	!
		and	%l2,%o7,%l2	! if AM == 0 then
		andn	%l3,%o7,%l3	!   get 24bit address
		or	%l2,%l3,%l3	!   rewrite Mreg#1
    _edmk31bit:	mov	0,%g1		! CC=0
		subcc	%l7,0,%g0	! if NZ == 0 then
		bz	_edmkexit	!   CC=0
		subcc	%l6,0,%g0	! if sig-ind == on then
		movnz	%icc,1,%g1	!   CC=1
		movz	%icc,2,%g1	! else CC=2
	
		/* RETURN */
    _edmkexit:	st	%l3,[%i0+4]	! ##%o5 -> Mreg1
		ld	[%i0+832],%l7	! restore mlen
		sethi	%hi(0x00ff0000),%o7
		andcc	%g7,%o7,%g0	! if intermediate intr. then
		bz,a	%icc,break0	!   exit
		add	%g2,%l7,%g2	! ##TEMPLATE:IAR
		ba,a	%icc,epilog0	!
		nop			!
i.edmk0e:
!================================

!
! templates
!   %i0: struct gcpu_s*
!   %i3: M instruction (upper 4 bytes)
!   %i4: M instruction (lower 2 bytes)
!
	.section ".text"
	.align	4
	.global ic6_e5xx
ic6_e5xx:
i.e5xx0s:
		st	%i3,[%i0+704]	! store minsn (upper)
		st	%i4,[%i0+708]	! store minsn (lower)
		sethi	%hi(0x80000000),%o7
		ba	%icc,epilog0	!
		or	%g7,%o7,%g7	! Special Instruction (FC=2)
i.e5xx0e:

	.section ".text"
	.align	4
	.global ii6_mvcin
ii6_mvcin:
	srl	%i3,12,%i5		! B1
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l0		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l0		! %l0
	and	%i3,0xfff,%l1		! D1
	srl	%i4,28,%i5		! B2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l2		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l2		! %l2
	srl	%i4,16,%i5		! D2
	and	%i5,0xfff,%l3		! %l3
	srl	%i3,16,%i5		! L
	and	%i5,0xff,%l4		! %l4
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=6
	add	%g0,6,%l7		!
	movnz	%icc,4,%l7		! if EX=1 then IAR+=4
i.mvcin0s:
		add	%l0,%l1,%l0	! OP1
		and	%l0,%g3,%l0	! mask address
		add	%l2,%l3,%l3	! OP2
		and	%l3,%g3,%l3	! mask address
		add	%l0,%l4,%l1	! OP1+length-1
		and	%l1,%g3,%l1	! mask address
		sub	%l3,%l4,%l2	! OP2-length+1
		and	%l2,%g3,%l2	! mask address

		andn	%l3,0xfff,%o1	! LD0-GS-TLB
		subcc	%g5,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g5,32,%o0	!
		call	ld1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l3,0xfff,%o1	!
		mov	%o0,%l3		! save base3
		mov	%o1,%l6		! save offset3

		andn	%l2,0xfff,%o1	! LD0-GS-TLB
		subcc	%g5,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g5,32,%o0	!
		call	ld1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l2,0xfff,%o1	!
		mov	%o0,%l2		! save base2

		andncc	%l1,0x1ff,%g0	! check LAP
		bnz,pt	%icc,.+12	!
		andcc	%g7,0x20,%g0	!
		tnz	%icc,0x43	! LAP exception
					!
		andn	%l1,0xfff,%o1	! ST0-GS-TLB
		subcc	%g6,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g6,32,%o0	!
		call	st1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l1,0xfff,%o1	!
		mov	%o0,%l1		! save base1

		andncc	%l0,0x1ff,%g0	! check LAP
		bnz,pt	%icc,.+12	!
		andcc	%g7,0x20,%g0	!
		tnz	%icc,0x43	! LAP exception
					!
		andn	%l0,0xfff,%o1	! ST0-GS-TLB
		subcc	%g6,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g6,32,%o0	!
		call	st1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l0,0xfff,%o1	!
		mov	%l1,%o2		! restore base1
		mov	%l2,%o3		! restore base2
		mov	%l3,%o5		! restore base3
		mov	%l6,%o4		! restore offset3
	! %o0: base0
	! %o1: offset0
	! %o2: base1
	! %o3: base2
	! %o4: offset3
	! %o5: base3
	! %l4: length-1
    i.mvcin0lp:	ldub	[%o5+%o4],%l0	!
		sub	%o4,1,%o4	!
		subcc	%o4,0xfff,%g0	! if page cross
		movgu	%icc,%o3,%o5	!   base2 -> base3
		and	%o4,0xfff,%o4	!
		stb	%l0,[%o0+%o1]	!
		add	%o1,1,%o1	!
		subcc	%o1,0xfff,%g0	! if page cross
		movgu	%icc,%o2,%o0	!   base1 -> base0
		subcc	%l4,1,%l4	!
		bge	%icc,i.mvcin0lp	!
		and	%o1,0xfff,%o1	!
		ba	%icc,break0	!
		add	%g2,%l7,%g2	! ##TEMPLATE:IAR
i.mvcin0e:
!================================

!
! templates
!   %i0: struct gcpu_s*
!   %i3: M instruction (upper 4 bytes)
!   %i4: M instruction (lower 2 bytes)
!
	.section ".text"
	.align	4
	.global id6_srp
id6_srp:
	srl	%i3,12,%i5		! B1
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l0		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l0		! %l0
	and	%i3,0xfff,%l1		! D1
	srl	%i4,28,%i5		! B2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l2		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l2		! %l2
	srl	%i4,16,%i5		! D2
	and	%i5,0xfff,%l3		! %l3
	srl	%i3,20,%i5		! L1
	and	%i5,0xf,%l4		! %l4
	srl	%i3,16,%i5		! I3
	and	%i5,0xf,%i3		! %i3
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=6
	add	%g0,6,%l7		!
	movnz	%icc,4,%l7		! if EX=1 then IAR+=4
i.srp0s:
		add	%l0,%l1,%l0	! OP1
		and	%l0,%g3,%l0	! mask address
		add	%l2,%l3,%l5	! OP2
		add	%l0,%l4,%l1	! OP1+length-1
		and	%l1,%g3,%l1	! mask address

		andncc	%l1,0x1ff,%g0	! check LAP
		bnz,pt	%icc,.+12	!
		andcc	%g7,0x20,%g0	!
		tnz	%icc,0x43	! LAP exception
					!
		andn	%l1,0xfff,%o1	! ST0-GS-TLB
		subcc	%g6,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g6,32,%o0	!
		call	st1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l1,0xfff,%o1	!
		mov	%o0,%l1		! save base1

		andncc	%l0,0x1ff,%g0	! check LAP
		bnz,pt	%icc,.+12	!
		andcc	%g7,0x20,%g0	!
		tnz	%icc,0x43	! LAP exception
					!
		andn	%l0,0xfff,%o1	! ST0-GS-TLB
		subcc	%g6,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g6,32,%o0	!
		call	st1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l0,0xfff,%o1	!
		mov	%l1,%o2		! restore base1
	! %i3: I3
	! %o0: base0
	! %o1: offset0
	! %o2: base1
	! %l4: length-1
	! %l5: shift
		mov	%o0,%l1		!
		mov	%o1,%l2		!
		mov	%o2,%l3		!
	
		mov	0,%l6		!
		add	%i0,800,%o7	!
i.srp0lp1:	ldub	[%o0+%o1],%l0	!
		add	%o1,1,%o1	!
		subcc	%o1,0xfff,%g0	! if page cross
		movgu	%icc,%o2,%o0	!   base1 -> base0
		stb	%l0,[%o7+%l6]	!
		add	%l6,1,%l6	!
		subcc	%l4,%l6,%g0	!
		bge	%icc,i.srp0lp1	!
		and	%o1,0xfff,%o1	!

		add	%i0,800,%o1	!
		mov	%l5,%o2		! shift count
		mov	%l4,%o3		! ##TEMPLATE:imm0 (L1)
		mov	%i3,%o4		! ##TEMPLATE:imm0 (I3)
		call	il_srp		!
		mov	%i0,%o0		! struct gcpu_s*

		mov	%l1,%o0		!
		mov	%l2,%o1		!
		mov	%l3,%o2		!

		mov	0,%l6		!
		add	%i0,800,%o7	!
    i.srp0lp0:	ldub	[%o7+%l6],%l0	!
		stb	%l0,[%o0+%o1]	!
		add	%o1,1,%o1	!
		subcc	%o1,0xfff,%g0	! if page cross
		movgu	%icc,%o2,%o0	!   base1 -> base0
		add	%l6,1,%l6	!
		subcc	%l4,%l6,%g0	!
		bge	%icc,i.srp0lp0	!
		and	%o1,0xfff,%o1	!
	
		sethi	%hi(0x00ff0000),%o7
		andcc	%g7,%o7,%g0	! if intermediate intr. then
		bz,a	%icc,break0	!   exit
		add	%g2,%l7,%g2	! ##TEMPLATE:IAR
		ba,a	%icc,epilog0	!
		nop			!
i.srp0e:

	.section ".text"
	.align	4
	.global ii6_mvo
ii6_mvo:
	srl	%i3,12,%i5		! B1
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l0		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l0		! %l0
	and	%i3,0xfff,%l1		! D1
	srl	%i4,28,%i5		! B2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l2		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l2		! %l2
	srl	%i4,16,%i5		! D2
	and	%i5,0xfff,%l3		! %l3
	srl	%i3,20,%i5		! L1
	and	%i5,0xf,%l4		! %l4
	srl	%i3,16,%i5		! L2
	and	%i5,0xf,%l5		! %l5
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=6
	add	%g0,6,%l7		!
	movnz	%icc,4,%l7		! if EX=1 then IAR+=4
i.mvo0s:
		add	%l0,%l1,%l0	! OP1
		and	%l0,%g3,%l0	! mask address
		add	%l2,%l3,%l2	! OP2
		and	%l2,%g3,%l2	! mask address
		add	%l0,%l4,%l1	! OP1+length1-1
		and	%l1,%g3,%l1	! mask address
		add	%l2,%l5,%l3	! OP2+length2-1
		and	%l3,%g3,%l3	! mask address

		andn	%l2,0xfff,%o1	! LD0-GS-TLB
		subcc	%g5,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g5,32,%o0	!
		call	ld1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l2,0xfff,%o1	!
		mov	%o0,%l2		! save base2

		andn	%l3,0xfff,%o1	! LD0-GS-TLB
		subcc	%g5,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g5,32,%o0	!
		call	ld1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l3,0xfff,%o1	!
		mov	%o0,%l3		! save base3
		mov	%o1,%l6		! save offset3

		andncc	%l0,0x1ff,%g0	! check LAP
		bnz,pt	%icc,.+12	!
		andcc	%g7,0x20,%g0	!
		tnz	%icc,0x43	! LAP exception
					!
		andn	%l0,0xfff,%o1	! ST0-GS-TLB
		subcc	%g6,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g6,32,%o0	!
		call	st1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l0,0xfff,%o1	!
		mov	%o0,%l0		! save base0

		andncc	%l1,0x1ff,%g0	! check LAP
		bnz,pt	%icc,.+12	!
		andcc	%g7,0x20,%g0	!
		tnz	%icc,0x43	! LAP exception
					!
		andn	%l1,0xfff,%o1	! ST0-GS-TLB
		subcc	%g6,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g6,32,%o0	!
		call	st1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l1,0xfff,%o1	!
		mov	%o0,%o2		!
		mov	%l0,%o0		! restore base0
		mov	%l2,%o3		! restore base2
		mov	%l3,%o5		! restore base3
		mov	%l6,%o4		! restore offset3
	! %o0: base0
	! %o1: offset1
	! %o2: base1
	! %o3: base2
	! %o4: offset3
	! %o5: base3
	! %l4: length1-1
	! %l5: length2-1
		ldub	[%o2+%o1],%l0	!
		and	%l0,0xf,%l0	!
		subcc	%l4,%l5,%g0	!
		bg	%icc,i.mvo010	!
		nop			!

    i.mvo000:	ldub	[%o5+%o4],%l1	!
		sub	%o4,1,%o4	!
		subcc	%o4,0xfff,%g0	! if page cross
		movgu	%icc,%o3,%o5	!   base2 -> base3
		and	%o4,0xfff,%o4	!
		sll	%l1,4,%l1	!
		or	%l0,%l1,%l0	!
		stb	%l0,[%o2+%o1]	!
		sub	%o1,1,%o1	!
		subcc	%o1,0xfff,%g0	! if page cross
		movgu	%icc,%o0,%o2	!   base0-> base1
		and	%o1,0xfff,%o1	!
		srl	%l1,8,%l0	!
		subcc	%l4,1,%l4	!
		bge	%icc,i.mvo000	!
		sub	%l5,1,%l5	!
		ba	%icc,break0	!
		add	%g2,%l7,%g2	! ##TEMPLATE:IAR

    i.mvo010:	ldub	[%o5+%o4],%l1	!
		sub	%o4,1,%o4	!
		subcc	%o4,0xfff,%g0	! if page cross
		movgu	%icc,%o3,%o5	!   base2 -> base3
		and	%o4,0xfff,%o4	!
		sll	%l1,4,%l1	!
		or	%l0,%l1,%l0	!
		stb	%l0,[%o2+%o1]	!
		sub	%o1,1,%o1	!
		subcc	%o1,0xfff,%g0	! if page cross
		movgu	%icc,%o0,%o2	!   base0-> base1
		and	%o1,0xfff,%o1	!
		srl	%l1,8,%l0	!
		subcc	%l5,1,%l5	!
		bge	%icc,i.mvo010	!
		sub	%l4,1,%l4	!
    i.mvo011:	stb	%l0,[%o2+%o1]	!
		sub	%o1,1,%o1	!
		subcc	%o1,0xfff,%g0	! if page cross
		movgu	%icc,%o0,%o2	!   base0-> base1
		and	%o1,0xfff,%o1	!
		subcc	%l4,1,%l4	!
		bge	%icc,i.mvo011	!
		mov	0,%l0		!
		ba	%icc,break0	!
		add	%g2,%l7,%g2	! ##TEMPLATE:IAR
i.mvo0e:

	.section ".text"
	.align	4
	.global ii6_pack
ii6_pack:
	srl	%i3,12,%i5		! B1
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l0		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l0		! %l0
	and	%i3,0xfff,%l1		! D1
	srl	%i4,28,%i5		! B2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l2		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l2		! %l2
	srl	%i4,16,%i5		! D2
	and	%i5,0xfff,%l3		! %l3
	srl	%i3,20,%i5		! L1
	and	%i5,0xf,%l4		! %l4
	srl	%i3,16,%i5		! L2
	and	%i5,0xf,%l5		! %l5
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=6
	add	%g0,6,%l7		!
	movnz	%icc,4,%l7		! if EX=1 then IAR+=4
i.pack0s:
		add	%l0,%l1,%l0	! OP1
		and	%l0,%g3,%l0	! mask address
		add	%l2,%l3,%l2	! OP2
		and	%l2,%g3,%l2	! mask address
		add	%l0,%l4,%l1	! OP1+length1-1
		and	%l1,%g3,%l1	! mask address
		add	%l2,%l5,%l3	! OP2+length2-1
		and	%l3,%g3,%l3	! mask address

		andn	%l2,0xfff,%o1	! LD0-GS-TLB
		subcc	%g5,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g5,32,%o0	!
		call	ld1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l2,0xfff,%o1	!
		mov	%o0,%l2		! save base2

		andn	%l3,0xfff,%o1	! LD0-GS-TLB
		subcc	%g5,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g5,32,%o0	!
		call	ld1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l3,0xfff,%o1	!
		mov	%o0,%l3		! save base3
		mov	%o1,%l6		! save offset3

		andncc	%l0,0x1ff,%g0	! check LAP
		bnz,pt	%icc,.+12	!
		andcc	%g7,0x20,%g0	!
		tnz	%icc,0x43	! LAP exception
					!
		andn	%l0,0xfff,%o1	! ST0-GS-TLB
		subcc	%g6,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g6,32,%o0	!
		call	st1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l0,0xfff,%o1	!
		mov	%o0,%l0		! save base0

		andncc	%l1,0x1ff,%g0	! check LAP
		bnz,pt	%icc,.+12	!
		andcc	%g7,0x20,%g0	!
		tnz	%icc,0x43	! LAP exception
					!
		andn	%l1,0xfff,%o1	! ST0-GS-TLB
		subcc	%g6,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g6,32,%o0	!
		call	st1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l1,0xfff,%o1	!
		mov	%o0,%o2		!
		mov	%l0,%o0		! restore base0
		mov	%l2,%o3		! restore base2
		mov	%l3,%o5		! restore base3
		mov	%l6,%o4		! restore offset3
	! %o0: base0
	! %o1: offset1
	! %o2: base1
	! %o3: base2
	! %o4: offset3
	! %o5: base3
	! %l4: length1-1
	! %l5: length2-1
		add	%l5,1,%i5	!
		srl	%i5,1,%i5	!
		subcc	%l4,%i5,%g0	!
		bge	%icc,i.pack010	!
		nop			!

    i.pack000:	ldub	[%o5+%o4],%l0	!
		sub	%o4,1,%o4	!
		subcc	%o4,0xfff,%g0	! if page cross
		movgu	%icc,%o3,%o5	!   base2 -> base3
		and	%o4,0xfff,%o4	!
		srl	%l0,4,%l1	!
		sll	%l0,4,%l0	!
		or	%l0,%l1,%l0	!
		stb	%l0,[%o2+%o1]	!
		sub	%o1,1,%o1	!
		subcc	%o1,0xfff,%g0	! if page cross
		movgu	%icc,%o0,%o2	!   base0-> base1
		and	%o1,0xfff,%o1	!
		subcc	%l4,1,%l4	!
		bneg,a	%icc,break0	!
		add	%g2,%l7,%g2	! ##TEMPLATE:IAR

    i.pack001:	ldub	[%o5+%o4],%l0	!
		sub	%o4,1,%o4	!
		subcc	%o4,0xfff,%g0	! if page cross
		movgu	%icc,%o3,%o5	!   base2 -> base3
		and	%o4,0xfff,%o4	!
		and	%l0,0xf,%l0	!
		ldub	[%o5+%o4],%l1	!
		sub	%o4,1,%o4	!
		subcc	%o4,0xfff,%g0	! if page cross
		movgu	%icc,%o3,%o5	!   base2 -> base3
		and	%o4,0xfff,%o4	!
		sll	%l1,4,%l1	!
		or	%l0,%l1,%l0	!
		stb	%l0,[%o2+%o1]	!
		sub	%o1,1,%o1	!
		subcc	%o1,0xfff,%g0	! if page cross
		movgu	%icc,%o0,%o2	!   base0-> base1
		and	%o1,0xfff,%o1	!
		subcc	%l4,1,%l4	!
		bpos	%icc,i.pack001	!
		nop			!
		ba	%icc,break0	!
		add	%g2,%l7,%g2	! ##TEMPLATE:IAR

    i.pack010:	ldub	[%o5+%o4],%l0	!
		sub	%o4,1,%o4	!
		subcc	%o4,0xfff,%g0	! if page cross
		movgu	%icc,%o3,%o5	!   base2 -> base3
		and	%o4,0xfff,%o4	!
		srl	%l0,4,%l1	!
		sll	%l0,4,%l0	!
		or	%l0,%l1,%l0	!
		stb	%l0,[%o2+%o1]	!
		sub	%o1,1,%o1	!
		subcc	%o1,0xfff,%g0	! if page cross
		movgu	%icc,%o0,%o2	!   base0-> base1
		and	%o1,0xfff,%o1	!
		subcc	%l5,1,%l5	!
		bneg	%icc,i.pack013	!
		subcc	%l4,1,%l4	!

    i.pack011:	ldub	[%o5+%o4],%l0	!
		sub	%o4,1,%o4	!
		subcc	%o4,0xfff,%g0	! if page cross
		movgu	%icc,%o3,%o5	!   base2 -> base3
		and	%o4,0xfff,%o4	!
		subcc	%l5,1,%l5	!
		bneg	%icc,i.pack012	!
		and	%l0,0xf,%l0	!
		ldub	[%o5+%o4],%l1	!
		sub	%o4,1,%o4	!
		subcc	%o4,0xfff,%g0	! if page cross
		movgu	%icc,%o3,%o5	!   base2 -> base3
		and	%o4,0xfff,%o4	!
		sll	%l1,4,%l1	!
		or	%l0,%l1,%l0	!
    i.pack012:	stb	%l0,[%o2+%o1]	!
		sub	%o1,1,%o1	!
		subcc	%o1,0xfff,%g0	! if page cross
		movgu	%icc,%o0,%o2	!   base0-> base1
		and	%o1,0xfff,%o1	!
		subcc	%l5,1,%l5	!
		bpos	%icc,i.pack011	!
		subcc	%l4,1,%l4	!
    i.pack013:	bneg,a	%icc,break0	!
		add	%g2,%l7,%g2	! ##TEMPLATE:IAR
	
    i.pack014:	stb	%g0,[%o2+%o1]	!
		sub	%o1,1,%o1	!
		subcc	%o1,0xfff,%g0	! if page cross
		movgu	%icc,%o0,%o2	!   base0-> base1
		and	%o1,0xfff,%o1	!
		subcc	%l4,1,%l4	!
		bpos	%icc,i.pack014	!
		nop			!
		ba	%icc,break0	!
		add	%g2,%l7,%g2	! ##TEMPLATE:IAR
i.pack0e:

	.section ".text"
	.align	4
	.global ii6_unpk
ii6_unpk:
	srl	%i3,12,%i5		! B1
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l0		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l0		! %l0
	and	%i3,0xfff,%l1		! D1
	srl	%i4,28,%i5		! B2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l2		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l2		! %l2
	srl	%i4,16,%i5		! D2
	and	%i5,0xfff,%l3		! %l3
	srl	%i3,20,%i5		! L1
	and	%i5,0xf,%l4		! %l4
	srl	%i3,16,%i5		! L2
	and	%i5,0xf,%l5		! %l5
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=6
	add	%g0,6,%l7		!
	movnz	%icc,4,%l7		! if EX=1 then IAR+=4
i.unpk0s:
		add	%l0,%l1,%l0	! OP1
		and	%l0,%g3,%l0	! mask address
		add	%l2,%l3,%l2	! OP2
		and	%l2,%g3,%l2	! mask address
		add	%l0,%l4,%l1	! OP1+length1-1
		and	%l1,%g3,%l1	! mask address
		add	%l2,%l5,%l3	! OP2+length2-1
		and	%l3,%g3,%l3	! mask address

		andn	%l2,0xfff,%o1	! LD0-GS-TLB
		subcc	%g5,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g5,32,%o0	!
		call	ld1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l2,0xfff,%o1	!
		mov	%o0,%l2		! save base2

		andn	%l3,0xfff,%o1	! LD0-GS-TLB
		subcc	%g5,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g5,32,%o0	!
		call	ld1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l3,0xfff,%o1	!
		mov	%o0,%l3		! save base3
		mov	%o1,%l6		! save offset3

		andncc	%l0,0x1ff,%g0	! check LAP
		bnz,pt	%icc,.+12	!
		andcc	%g7,0x20,%g0	!
		tnz	%icc,0x43	! LAP exception
					!
		andn	%l0,0xfff,%o1	! ST0-GS-TLB
		subcc	%g6,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g6,32,%o0	!
		call	st1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l0,0xfff,%o1	!
		mov	%o0,%l0		! save base0

		andncc	%l1,0x1ff,%g0	! check LAP
		bnz,pt	%icc,.+12	!
		andcc	%g7,0x20,%g0	!
		tnz	%icc,0x43	! LAP exception
					!
		andn	%l1,0xfff,%o1	! ST0-GS-TLB
		subcc	%g6,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g6,32,%o0	!
		call	st1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l1,0xfff,%o1	!
		mov	%o0,%o2		!
		mov	%l0,%o0		! restore base0
		mov	%l2,%o3		! restore base2
		mov	%l3,%o5		! restore base3
		mov	%l6,%o4		! restore offset3
	! %o0: base0
	! %o1: offset1
	! %o2: base1
	! %o3: base2
	! %o4: offset3
	! %o5: base3
	! %l4: length1-1
	! %l5: length2-1
		srl	%l4,1,%i5	!
		subcc	%i5,%l5,%g0	!
		bge	%icc,i.unpk010	!
		nop			!

    i.unpk000:	ldub	[%o5+%o4],%l0	!
		sub	%o4,1,%o4	!
		subcc	%o4,0xfff,%g0	! if page cross
		movgu	%icc,%o3,%o5	!   base2 -> base3
		and	%o4,0xfff,%o4	!
		srl	%l0,4,%l1	!
		sll	%l0,4,%l0	!
		or	%l0,%l1,%l0	!
		stb	%l0,[%o2+%o1]	!
		sub	%o1,1,%o1	!
		subcc	%o1,0xfff,%g0	! if page cross
		movgu	%icc,%o0,%o2	!   base0-> base1
		and	%o1,0xfff,%o1	!
		subcc	%l4,1,%l4	!
		bneg,a	%icc,break0	!
		add	%g2,%l7,%g2	! ##TEMPLATE:IAR
	
    i.unpk001:	ldub	[%o5+%o4],%l0	!
		sub	%o4,1,%o4	!
		subcc	%o4,0xfff,%g0	! if page cross
		movgu	%icc,%o3,%o5	!   base2 -> base3
		and	%o4,0xfff,%o4	!
		and	%l0,0xf,%l1	!
		or	%l1,0xf0,%l1	!
		stb	%l1,[%o2+%o1]	!
		sub	%o1,1,%o1	!
		subcc	%o1,0xfff,%g0	! if page cross
		movgu	%icc,%o0,%o2	!   base0-> base1
		and	%o1,0xfff,%o1	!
		subcc	%l4,1,%l4	!
		bneg,a	%icc,break0	!
		add	%g2,%l7,%g2	! ##TEMPLATE:IAR
	
		srl	%l0,4,%l1	!
		or	%l1,0xf0,%l1	!
		stb	%l1,[%o2+%o1]	!
		sub	%o1,1,%o1	!
		subcc	%o1,0xfff,%g0	! if page cross
		movgu	%icc,%o0,%o2	!   base0-> base1
		and	%o1,0xfff,%o1	!
		subcc	%l4,1,%l4	!
		bpos	%icc,i.unpk001	!
		nop			!
		ba	%icc,break0	!
		add	%g2,%l7,%g2	! ##TEMPLATE:IAR

    i.unpk010:	ldub	[%o5+%o4],%l0	!
		sub	%o4,1,%o4	!
		subcc	%o4,0xfff,%g0	! if page cross
		movgu	%icc,%o3,%o5	!   base2 -> base3
		and	%o4,0xfff,%o4	!
		srl	%l0,4,%l1	!
		sll	%l0,4,%l0	!
		or	%l0,%l1,%l0	!
		stb	%l0,[%o2+%o1]	!
		sub	%o1,1,%o1	!
		subcc	%o1,0xfff,%g0	! if page cross
		movgu	%icc,%o0,%o2	!   base0-> base1
		and	%o1,0xfff,%o1	!
		subcc	%l5,1,%l5	!
		bneg	%icc,i.unpk012	!
		subcc	%l4,1,%l4	!

    i.unpk011:	ldub	[%o5+%o4],%l0	!
		sub	%o4,1,%o4	!
		subcc	%o4,0xfff,%g0	! if page cross
		movgu	%icc,%o3,%o5	!   base2 -> base3
		and	%o4,0xfff,%o4	!
		and	%l0,0xf,%l1	!
		or	%l1,0xf0,%l1	!
		stb	%l1,[%o2+%o1]	!
		sub	%o1,1,%o1	!
		subcc	%o1,0xfff,%g0	! if page cross
		movgu	%icc,%o0,%o2	!   base0-> base1
		and	%o1,0xfff,%o1	!
		sub	%l4,1,%l4	!
		srl	%l0,4,%l1	!
		or	%l1,0xf0,%l1	!
		stb	%l1,[%o2+%o1]	!
		sub	%o1,1,%o1	!
		subcc	%o1,0xfff,%g0	! if page cross
		movgu	%icc,%o0,%o2	!   base0-> base1
		and	%o1,0xfff,%o1	!
		subcc	%l5,1,%l5	!
		bpos	%icc,i.unpk011	!
		subcc	%l4,1,%l4	!
    i.unpk012:	bneg,a	%icc,break0	!
		add	%g2,%l7,%g2	! ##TEMPLATE:IAR

		add	%g0,0xf0,%l1	!
    i.unpk013:	stb	%l1,[%o2+%o1]	!
		sub	%o1,1,%o1	!
		subcc	%o1,0xfff,%g0	! if page cross
		movgu	%icc,%o0,%o2	!   base0-> base1
		and	%o1,0xfff,%o1	!
		subcc	%l4,1,%l4	!
		bpos	%icc,i.unpk013	!
		nop			!
		ba	%icc,break0	!
		add	%g2,%l7,%g2	! ##TEMPLATE:IAR
i.unpk1e:

	.section ".text"
	.align	4
	.global id6_zap
id6_zap:
	srl	%i3,12,%i5		! B1
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l0		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l0		! %l0
	and	%i3,0xfff,%l1		! D1
	srl	%i4,28,%i5		! B2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l2		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l2		! %l2
	srl	%i4,16,%i5		! D2
	and	%i5,0xfff,%l3		! %l3
	srl	%i3,20,%i5		! L1
	and	%i5,0xf,%l4		! %l4
	srl	%i3,16,%i5		! L2
	and	%i5,0xf,%l5		! %l5
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=6
	add	%g0,6,%l7		!
	movnz	%icc,4,%l7		! if EX=1 then IAR+=4
i.zap0s:
		add	%l0,%l1,%l0	! OP1
		and	%l0,%g3,%l0	! mask address
		add	%l2,%l3,%l2	! OP2
		and	%l2,%g3,%l2	! mask address
		add	%l0,%l4,%l1	! OP1+length1-1
		and	%l1,%g3,%l1	! mask address
		add	%l2,%l5,%l3	! OP2+length2-1
		and	%l3,%g3,%l3	! mask address

		/* CHECK B2 <= B1+L1 < B2+L2 */
		subcc	%l2,%l1,%g0	!
		bgu	%icc,i.zap000	!
		subcc	%l1,%l3,%g0	!
		sethi	%hi(0x00070000),%o7
		blu,a	%icc,i.zap001	!
		or	%g7,%o7,%g7	!   data exception

    i.zap000:	andn	%l3,0xfff,%o1	! LD0-GS-TLB
		subcc	%g5,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g5,32,%o0	!
		call	ld1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l3,0xfff,%o1	!
		mov	%o0,%l3		! save base3

		andn	%l2,0xfff,%o1	! LD0-GS-TLB
		subcc	%g5,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g5,32,%o0	!
		call	ld1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l2,0xfff,%o1	!
		mov	%o0,%l2		! save base2
		mov	%o1,%l6		! save offset2

		andncc	%l1,0x1ff,%g0	! check LAP
		bnz,pt	%icc,.+12	!
		andcc	%g7,0x20,%g0	!
		tnz	%icc,0x43	! LAP exception
					!
		andn	%l1,0xfff,%o1	! ST0-GS-TLB
		subcc	%g6,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g6,32,%o0	!
		call	st1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l1,0xfff,%o1	!
		mov	%o0,%l1		! save base1

		andncc	%l0,0x1ff,%g0	! check LAP
		bnz,pt	%icc,.+12	!
		andcc	%g7,0x20,%g0	!
		tnz	%icc,0x43	! LAP exception
					!
		andn	%l0,0xfff,%o1	! ST0-GS-TLB
		subcc	%g6,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g6,32,%o0	!
		call	st1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l0,0xfff,%o1	!
		mov	%l1,%o2		! restore base1
		mov	%l2,%o3		! restore base2
		mov	%l6,%o4		! restore offset2
		mov	%l3,%o5		! restore base3
	! %o0: base0
	! %o1: offset0
	! %o2: base1
	! %o3: base2
	! %o4: offset2
	! %o5: base3
	! %l4: length1-1
	! %l5: length2-1
		mov	0,%l6		!
		add	%i0,816,%o7	!
    i.zap0lp2:	ldub	[%o3+%o4],%l0	!
		add	%o4,1,%o4	!
		subcc	%o4,0xfff,%g0	! if page cross
		movgu	%icc,%o5,%o3	!   base1 -> base0
		stb	%l0,[%o7+%l6]	!
		add	%l6,1,%l6	!
		subcc	%l5,%l6,%g0	!
		bge	%icc,i.zap0lp2	!
		and	%o4,0xfff,%o4	!

		mov	%o0,%l1		!
		mov	%o1,%l2		!
		mov	%o2,%l3		!

		add	%i0,800,%o1	!
		add	%i0,816,%o2	!
		mov	%l4,%o3		! ##TEMPLATE:imm0 (L1)
		mov	%l5,%o4		! ##TEMPLATE:imm0 (L2)
		call	il_zap		!
		mov	%i0,%o0		! struct gcpu_s*

		mov	%l1,%o0		!
		mov	%l2,%o1		!
		mov	%l3,%o2		!

		mov	0,%l6		!
		add	%i0,800,%o7	!
    i.zap0lp0:	ldub	[%o7+%l6],%l0	!
		stb	%l0,[%o0+%o1]	!
		add	%o1,1,%o1	!
		subcc	%o1,0xfff,%g0	! if page cross
		movgu	%icc,%o2,%o0	!   base1 -> base0
		add	%l6,1,%l6	!
		subcc	%l4,%l6,%g0	!
		bge	%icc,i.zap0lp0	!
		and	%o1,0xfff,%o1	!

    i.zap001:	sethi	%hi(0x00ff0000),%o7
		andcc	%g7,%o7,%g0	! if intermediate intr. then
		bz,a	%icc,break0	!   exit
		add	%g2,%l7,%g2	! ##TEMPLATE:IAR
		ba,a	%icc,epilog0	!
		nop			!
i.zap0e:

	.section ".text"
	.align	4
	.global id6_cp
id6_cp:
	srl	%i3,12,%i5		! B1
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l0		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l0		! %l0
	and	%i3,0xfff,%l1		! D1
	srl	%i4,28,%i5		! B2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l2		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l2		! %l2
	srl	%i4,16,%i5		! D2
	and	%i5,0xfff,%l3		! %l3
	srl	%i3,20,%i5		! L1
	and	%i5,0xf,%l4		! %l4
	srl	%i3,16,%i5		! L2
	and	%i5,0xf,%l5		! %l5
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=6
	add	%g0,6,%l7		!
	movnz	%icc,4,%l7		! if EX=1 then IAR+=4
i.cp0s:
		add	%l0,%l1,%l0	! OP1
		and	%l0,%g3,%l0	! mask address
		add	%l2,%l3,%l2	! OP2
		and	%l2,%g3,%l2	! mask address
		add	%l0,%l4,%l1	! OP1+length1-1
		and	%l1,%g3,%l1	! mask address
		add	%l2,%l5,%l3	! OP2+length2-1
		and	%l3,%g3,%l3	! mask address

		andn	%l3,0xfff,%o1	! LD0-GS-TLB
		subcc	%g5,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g5,32,%o0	!
		call	ld1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l3,0xfff,%o1	!
		mov	%o0,%l3		! save base3

		andn	%l2,0xfff,%o1	! LD0-GS-TLB
		subcc	%g5,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g5,32,%o0	!
		call	ld1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l2,0xfff,%o1	!
		mov	%o0,%l2		! save base2
		mov	%o1,%l6		! save offset2

		andn	%l1,0xfff,%o1	! LD0-GS-TLB
		subcc	%g5,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g5,32,%o0	!
		call	ld1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l1,0xfff,%o1	!
		mov	%o0,%l1		! save base1

		andn	%l0,0xfff,%o1	! LD0-GS-TLB
		subcc	%g5,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g5,32,%o0	!
		call	ld1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l0,0xfff,%o1	!
		mov	%l1,%o2		! restore base1
		mov	%l2,%o3		! restore base2
		mov	%l6,%o4		! restore offset2
		mov	%l3,%o5		! restore base3
	! %o0: base0
	! %o1: offset0
	! %o2: base1
	! %o3: base2
	! %o4: offset2
	! %o5: base3
	! %l4: length1-1
	! %l5: length2-1
		mov	0,%l6		!
		add	%i0,816,%o7	!
    i.cp0lp2:	ldub	[%o3+%o4],%l0	!
		add	%o4,1,%o4	!
		subcc	%o4,0xfff,%g0	! if page cross
		movgu	%icc,%o5,%o3	!   base1 -> base0
		stb	%l0,[%o7+%l6]	!
		add	%l6,1,%l6	!
		subcc	%l5,%l6,%g0	!
		bge	%icc,i.cp0lp2	!
		and	%o4,0xfff,%o4	!

		mov	%o0,%l1		!
		mov	%o1,%l2		!
		mov	%o2,%l3		!

		mov	0,%l6		!
		add	%i0,800,%o7	!
    i.cp0lp1:	ldub	[%o0+%o1],%l0	!
		add	%o1,1,%o1	!
		subcc	%o1,0xfff,%g0	! if page cross
		movgu	%icc,%o2,%o0	!   base1 -> base0
		stb	%l0,[%o7+%l6]	!
		add	%l6,1,%l6	!
		subcc	%l4,%l6,%g0	!
		bge	%icc,i.cp0lp1	!
		and	%o1,0xfff,%o1	!

		add	%i0,800,%o1	!
		add	%i0,816,%o2	!
		mov	%l4,%o3		! ##TEMPLATE:imm0 (L1)
		mov	%l5,%o4		! ##TEMPLATE:imm0 (L2)
		call	il_cp		!
		mov	%i0,%o0		! struct gcpu_s*
		sethi	%hi(0x00ff0000),%o7
		andcc	%g7,%o7,%g0	! if intermediate intr. then
		bz,a	%icc,break0	!   exit
		add	%g2,%l7,%g2	! ##TEMPLATE:IAR
		ba,a	%icc,epilog0	!
		nop			!
i.cp0e:

	.section ".text"
	.align	4
	.global id6_ap
id6_ap:
	srl	%i3,12,%i5		! B1
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l0		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l0		! %l0
	and	%i3,0xfff,%l1		! D1
	srl	%i4,28,%i5		! B2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l2		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l2		! %l2
	srl	%i4,16,%i5		! D2
	and	%i5,0xfff,%l3		! %l3
	srl	%i3,20,%i5		! L1
	and	%i5,0xf,%l4		! %l4
	srl	%i3,16,%i5		! L2
	and	%i5,0xf,%l5		! %l5
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=6
	add	%g0,6,%l7		!
	movnz	%icc,4,%l7		! if EX=1 then IAR+=4
i.ap0s:
		add	%l0,%l1,%l0	! OP1
		and	%l0,%g3,%l0	! mask address
		add	%l2,%l3,%l2	! OP2
		and	%l2,%g3,%l2	! mask address
		add	%l0,%l4,%l1	! OP1+length1-1
		and	%l1,%g3,%l1	! mask address
		add	%l2,%l5,%l3	! OP2+length2-1
		and	%l3,%g3,%l3	! mask address

		andn	%l3,0xfff,%o1	! LD0-GS-TLB
		subcc	%g5,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g5,32,%o0	!
		call	ld1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l3,0xfff,%o1	!
		mov	%o0,%l3		! save base3

		andn	%l2,0xfff,%o1	! LD0-GS-TLB
		subcc	%g5,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g5,32,%o0	!
		call	ld1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l2,0xfff,%o1	!
		mov	%o0,%l2		! save base2
		mov	%o1,%l6		! save offset2

		andncc	%l1,0x1ff,%g0	! check LAP
		bnz,pt	%icc,.+12	!
		andcc	%g7,0x20,%g0	!
		tnz	%icc,0x43	! LAP exception
					!
		andn	%l1,0xfff,%o1	! ST0-GS-TLB
		subcc	%g6,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g6,32,%o0	!
		call	st1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l1,0xfff,%o1	!
		mov	%o0,%l1		! save base1

		andncc	%l0,0x1ff,%g0	! check LAP
		bnz,pt	%icc,.+12	!
		andcc	%g7,0x20,%g0	!
		tnz	%icc,0x43	! LAP exception
					!
		andn	%l0,0xfff,%o1	! ST0-GS-TLB
		subcc	%g6,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g6,32,%o0	!
		call	st1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l0,0xfff,%o1	!
		mov	%l1,%o2		! restore base1
		mov	%l2,%o3		! restore base2
		mov	%l6,%o4		! restore offset2
		mov	%l3,%o5		! restore base3
	! %o0: base0
	! %o1: offset0
	! %o2: base1
	! %o3: base2
	! %o4: offset2
	! %o5: base3
	! %l4: length1-1
	! %l5: length2-1
		mov	0,%l6		!
		add	%i0,816,%o7	!
    i.ap0lp2:	ldub	[%o3+%o4],%l0	!
		add	%o4,1,%o4	!
		subcc	%o4,0xfff,%g0	! if page cross
		movgu	%icc,%o5,%o3	!   base1 -> base0
		stb	%l0,[%o7+%l6]	!
		add	%l6,1,%l6	!
		subcc	%l5,%l6,%g0	!
		bge	%icc,i.ap0lp2	!
		and	%o4,0xfff,%o4	!

		mov	%o0,%l1		!
		mov	%o1,%l2		!
		mov	%o2,%l3		!

		mov	0,%l6		!
		add	%i0,800,%o7	!
    i.ap0lp1:	ldub	[%o0+%o1],%l0	!
		add	%o1,1,%o1	!
		subcc	%o1,0xfff,%g0	! if page cross
		movgu	%icc,%o2,%o0	!   base1 -> base0
		stb	%l0,[%o7+%l6]	!
		add	%l6,1,%l6	!
		subcc	%l4,%l6,%g0	!
		bge	%icc,i.ap0lp1	!
		and	%o1,0xfff,%o1	!

		add	%i0,800,%o1	!
		add	%i0,816,%o2	!
		mov	%l4,%o3		! ##TEMPLATE:imm0 (L1)
		mov	%l5,%o4		! ##TEMPLATE:imm0 (L2)
		call	il_ap		!
		mov	%i0,%o0		! struct gcpu_s*

		mov	%l1,%o0		!
		mov	%l2,%o1		!
		mov	%l3,%o2		!

		mov	0,%l6		!
		add	%i0,800,%o7	!
    i.ap0lp0:	ldub	[%o7+%l6],%l0	!
		stb	%l0,[%o0+%o1]	!
		add	%o1,1,%o1	!
		subcc	%o1,0xfff,%g0	! if page cross
		movgu	%icc,%o2,%o0	!   base1 -> base0
		add	%l6,1,%l6	!
		subcc	%l4,%l6,%g0	!
		bge	%icc,i.ap0lp0	!
		and	%o1,0xfff,%o1	!
	
		sethi	%hi(0x00ff0000),%o7
		andcc	%g7,%o7,%g0	! if intermediate intr. then
		bz,a	%icc,break0	!   exit
		add	%g2,%l7,%g2	! ##TEMPLATE:IAR
		ba,a	%icc,epilog0	!
		nop			!
i.ap0e:

	.section ".text"
	.align	4
	.global id6_sp
id6_sp:
	srl	%i3,12,%i5		! B1
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l0		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l0		! %l0
	and	%i3,0xfff,%l1		! D1
	srl	%i4,28,%i5		! B2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l2		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l2		! %l2
	srl	%i4,16,%i5		! D2
	and	%i5,0xfff,%l3		! %l3
	srl	%i3,20,%i5		! L1
	and	%i5,0xf,%l4		! %l4
	srl	%i3,16,%i5		! L2
	and	%i5,0xf,%l5		! %l5
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=6
	add	%g0,6,%l7		!
	movnz	%icc,4,%l7		! if EX=1 then IAR+=4
i.sp0s:
		add	%l0,%l1,%l0	! OP1
		and	%l0,%g3,%l0	! mask address
		add	%l2,%l3,%l2	! OP2
		and	%l2,%g3,%l2	! mask address
		add	%l0,%l4,%l1	! OP1+length1-1
		and	%l1,%g3,%l1	! mask address
		add	%l2,%l5,%l3	! OP2+length2-1
		and	%l3,%g3,%l3	! mask address

		andn	%l3,0xfff,%o1	! LD0-GS-TLB
		subcc	%g5,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g5,32,%o0	!
		call	ld1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l3,0xfff,%o1	!
		mov	%o0,%l3		! save base3

		andn	%l2,0xfff,%o1	! LD0-GS-TLB
		subcc	%g5,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g5,32,%o0	!
		call	ld1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l2,0xfff,%o1	!
		mov	%o0,%l2		! save base2
		mov	%o1,%l6		! save offset2

		andncc	%l1,0x1ff,%g0	! check LAP
		bnz,pt	%icc,.+12	!
		andcc	%g7,0x20,%g0	!
		tnz	%icc,0x43	! LAP exception
					!
		andn	%l1,0xfff,%o1	! ST0-GS-TLB
		subcc	%g6,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g6,32,%o0	!
		call	st1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l1,0xfff,%o1	!
		mov	%o0,%l1		! save base1

		andncc	%l0,0x1ff,%g0	! check LAP
		bnz,pt	%icc,.+12	!
		andcc	%g7,0x20,%g0	!
		tnz	%icc,0x43	! LAP exception
					!
		andn	%l0,0xfff,%o1	! ST0-GS-TLB
		subcc	%g6,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g6,32,%o0	!
		call	st1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l0,0xfff,%o1	!
		mov	%l1,%o2		! restore base1
		mov	%l2,%o3		! restore base2
		mov	%l6,%o4		! restore offset2
		mov	%l3,%o5		! restore base3
	! %o0: base0
	! %o1: offset0
	! %o2: base1
	! %o3: base2
	! %o4: offset2
	! %o5: base3
	! %l4: length1-1
	! %l5: length2-1
		mov	0,%l6		!
		add	%i0,816,%o7	!
    i.sp0lp2:	ldub	[%o3+%o4],%l0	!
		add	%o4,1,%o4	!
		subcc	%o4,0xfff,%g0	! if page cross
		movgu	%icc,%o5,%o3	!   base1 -> base0
		stb	%l0,[%o7+%l6]	!
		add	%l6,1,%l6	!
		subcc	%l5,%l6,%g0	!
		bge	%icc,i.sp0lp2	!
		and	%o4,0xfff,%o4	!

		mov	%o0,%l1		!
		mov	%o1,%l2		!
		mov	%o2,%l3		!

		mov	0,%l6		!
		add	%i0,800,%o7	!
    i.sp0lp1:	ldub	[%o0+%o1],%l0	!
		add	%o1,1,%o1	!
		subcc	%o1,0xfff,%g0	! if page cross
		movgu	%icc,%o2,%o0	!   base1 -> base0
		stb	%l0,[%o7+%l6]	!
		add	%l6,1,%l6	!
		subcc	%l4,%l6,%g0	!
		bge	%icc,i.sp0lp1	!
		and	%o1,0xfff,%o1	!

		add	%i0,800,%o1	!
		add	%i0,816,%o2	!
		mov	%l4,%o3		! ##TEMPLATE:imm0 (L1)
		mov	%l5,%o4		! ##TEMPLATE:imm0 (L2)
		call	il_sp		!
		mov	%i0,%o0		! struct gcpu_s*

		mov	%l1,%o0		!
		mov	%l2,%o1		!
		mov	%l3,%o2		!

		mov	0,%l6		!
		add	%i0,800,%o7	!
    i.sp0lp0:	ldub	[%o7+%l6],%l0	!
		stb	%l0,[%o0+%o1]	!
		add	%o1,1,%o1	!
		subcc	%o1,0xfff,%g0	! if page cross
		movgu	%icc,%o2,%o0	!   base1 -> base0
		add	%l6,1,%l6	!
		subcc	%l4,%l6,%g0	!
		bge	%icc,i.sp0lp0	!
		and	%o1,0xfff,%o1	!
	
		sethi	%hi(0x00ff0000),%o7
		andcc	%g7,%o7,%g0	! if intermediate intr. then
		bz,a	%icc,break0	!   exit
		add	%g2,%l7,%g2	! ##TEMPLATE:IAR
		ba,a	%icc,epilog0	!
		nop			!
i.sp0e:

	.section ".text"
	.align	4
	.global id6_mp
id6_mp:
	srl	%i3,12,%i5		! B1
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l0		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l0		! %l0
	and	%i3,0xfff,%l1		! D1
	srl	%i4,28,%i5		! B2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l2		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l2		! %l2
	srl	%i4,16,%i5		! D2
	and	%i5,0xfff,%l3		! %l3
	srl	%i3,20,%i5		! L1
	and	%i5,0xf,%l4		! %l4
	srl	%i3,16,%i5		! L2
	and	%i5,0xf,%l5		! %l5
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=6
	add	%g0,6,%l7		!
	movnz	%icc,4,%l7		! if EX=1 then IAR+=4
i.mp0s:
		add	%l0,%l1,%l0	! OP1
		and	%l0,%g3,%l0	! mask address
		add	%l2,%l3,%l2	! OP2
		and	%l2,%g3,%l2	! mask address
		add	%l0,%l4,%l1	! OP1+length1-1
		and	%l1,%g3,%l1	! mask address
		add	%l2,%l5,%l3	! OP2+length2-1
		and	%l3,%g3,%l3	! mask address

		andn	%l3,0xfff,%o1	! LD0-GS-TLB
		subcc	%g5,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g5,32,%o0	!
		call	ld1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l3,0xfff,%o1	!
		mov	%o0,%l3		! save base3

		andn	%l2,0xfff,%o1	! LD0-GS-TLB
		subcc	%g5,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g5,32,%o0	!
		call	ld1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l2,0xfff,%o1	!
		mov	%o0,%l2		! save base2
		mov	%o1,%l6		! save offset2

		andncc	%l1,0x1ff,%g0	! check LAP
		bnz,pt	%icc,.+12	!
		andcc	%g7,0x20,%g0	!
		tnz	%icc,0x43	! LAP exception
					!
		andn	%l1,0xfff,%o1	! ST0-GS-TLB
		subcc	%g6,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g6,32,%o0	!
		call	st1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l1,0xfff,%o1	!
		mov	%o0,%l1		! save base1

		andncc	%l0,0x1ff,%g0	! check LAP
		bnz,pt	%icc,.+12	!
		andcc	%g7,0x20,%g0	!
		tnz	%icc,0x43	! LAP exception
					!
		andn	%l0,0xfff,%o1	! ST0-GS-TLB
		subcc	%g6,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g6,32,%o0	!
		call	st1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l0,0xfff,%o1	!
		mov	%l1,%o2		! restore base1
		mov	%l2,%o3		! restore base2
		mov	%l6,%o4		! restore offset2
		mov	%l3,%o5		! restore base3
	! %o0: base0
	! %o1: offset0
	! %o2: base1
	! %o3: base2
	! %o4: offset2
	! %o5: base3
	! %l4: length1-1
	! %l5: length2-1
		mov	0,%l6		!
		add	%i0,816,%o7	!
    i.mp0lp2:	ldub	[%o3+%o4],%l0	!
		add	%o4,1,%o4	!
		subcc	%o4,0xfff,%g0	! if page cross
		movgu	%icc,%o5,%o3	!   base1 -> base0
		stb	%l0,[%o7+%l6]	!
		add	%l6,1,%l6	!
		subcc	%l5,%l6,%g0	!
		bge	%icc,i.mp0lp2	!
		and	%o4,0xfff,%o4	!

		mov	%o0,%l1		!
		mov	%o1,%l2		!
		mov	%o2,%l3		!

		mov	0,%l6		!
		add	%i0,800,%o7	!
    i.mp0lp1:	ldub	[%o0+%o1],%l0	!
		add	%o1,1,%o1	!
		subcc	%o1,0xfff,%g0	! if page cross
		movgu	%icc,%o2,%o0	!   base1 -> base0
		stb	%l0,[%o7+%l6]	!
		add	%l6,1,%l6	!
		subcc	%l4,%l6,%g0	!
		bge	%icc,i.mp0lp1	!
		and	%o1,0xfff,%o1	!

		add	%i0,800,%o1	!
		add	%i0,816,%o2	!
		mov	%l4,%o3		! ##TEMPLATE:imm0 (L1)
		mov	%l5,%o4		! ##TEMPLATE:imm0 (L2)
		call	il_mp		!
		mov	%i0,%o0		! struct gcpu_s*

		mov	%l1,%o0		!
		mov	%l2,%o1		!
		mov	%l3,%o2		!

		mov	0,%l6		!
		add	%i0,800,%o7	!
    i.mp0lp0:	ldub	[%o7+%l6],%l0	!
		stb	%l0,[%o0+%o1]	!
		add	%o1,1,%o1	!
		subcc	%o1,0xfff,%g0	! if page cross
		movgu	%icc,%o2,%o0	!   base1 -> base0
		add	%l6,1,%l6	!
		subcc	%l4,%l6,%g0	!
		bge	%icc,i.mp0lp0	!
		and	%o1,0xfff,%o1	!
	
		sethi	%hi(0x00ff0000),%o7
		andcc	%g7,%o7,%g0	! if intermediate intr. then
		bz,a	%icc,break0	!   exit
		add	%g2,%l7,%g2	! ##TEMPLATE:IAR
		ba,a	%icc,epilog0	!
		nop			!
i.mp0e:

	.section ".text"
	.align	4
	.global id6_dp
id6_dp:
	srl	%i3,12,%i5		! B1
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l0		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l0		! %l0
	and	%i3,0xfff,%l1		! D1
	srl	%i4,28,%i5		! B2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l2		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l2		! %l2
	srl	%i4,16,%i5		! D2
	and	%i5,0xfff,%l3		! %l3
	srl	%i3,20,%i5		! L1
	and	%i5,0xf,%l4		! %l4
	srl	%i3,16,%i5		! L2
	and	%i5,0xf,%l5		! %l5
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=6
	add	%g0,6,%l7		!
	movnz	%icc,4,%l7		! if EX=1 then IAR+=4
i.dp0s:
		add	%l0,%l1,%l0	! OP1
		and	%l0,%g3,%l0	! mask address
		add	%l2,%l3,%l2	! OP2
		and	%l2,%g3,%l2	! mask address
		add	%l0,%l4,%l1	! OP1+length1-1
		and	%l1,%g3,%l1	! mask address
		add	%l2,%l5,%l3	! OP2+length2-1
		and	%l3,%g3,%l3	! mask address

		andn	%l3,0xfff,%o1	! LD0-GS-TLB
		subcc	%g5,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g5,32,%o0	!
		call	ld1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l3,0xfff,%o1	!
		mov	%o0,%l3		! save base3

		andn	%l2,0xfff,%o1	! LD0-GS-TLB
		subcc	%g5,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g5,32,%o0	!
		call	ld1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l2,0xfff,%o1	!
		mov	%o0,%l2		! save base2
		mov	%o1,%l6		! save offset2

		andncc	%l1,0x1ff,%g0	! check LAP
		bnz,pt	%icc,.+12	!
		andcc	%g7,0x20,%g0	!
		tnz	%icc,0x43	! LAP exception
					!
		andn	%l1,0xfff,%o1	! ST0-GS-TLB
		subcc	%g6,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g6,32,%o0	!
		call	st1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l1,0xfff,%o1	!
		mov	%o0,%l1		! save base1

		andncc	%l0,0x1ff,%g0	! check LAP
		bnz,pt	%icc,.+12	!
		andcc	%g7,0x20,%g0	!
		tnz	%icc,0x43	! LAP exception
					!
		andn	%l0,0xfff,%o1	! ST0-GS-TLB
		subcc	%g6,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g6,32,%o0	!
		call	st1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l0,0xfff,%o1	!
		mov	%l1,%o2		! restore base1
		mov	%l2,%o3		! restore base2
		mov	%l6,%o4		! restore offset2
		mov	%l3,%o5		! restore base3
	! %o0: base0
	! %o1: offset0
	! %o2: base1
	! %o3: base2
	! %o4: offset2
	! %o5: base3
	! %l4: length1-1
	! %l5: length2-1
		mov	0,%l6		!
		add	%i0,816,%o7	!
    i.dp0lp2:	ldub	[%o3+%o4],%l0	!
		add	%o4,1,%o4	!
		subcc	%o4,0xfff,%g0	! if page cross
		movgu	%icc,%o5,%o3	!   base1 -> base0
		stb	%l0,[%o7+%l6]	!
		add	%l6,1,%l6	!
		subcc	%l5,%l6,%g0	!
		bge	%icc,i.dp0lp2	!
		and	%o4,0xfff,%o4	!

		mov	%o0,%l1		!
		mov	%o1,%l2		!
		mov	%o2,%l3		!

		mov	0,%l6		!
		add	%i0,800,%o7	!
    i.dp0lp1:	ldub	[%o0+%o1],%l0	!
		add	%o1,1,%o1	!
		subcc	%o1,0xfff,%g0	! if page cross
		movgu	%icc,%o2,%o0	!   base1 -> base0
		stb	%l0,[%o7+%l6]	!
		add	%l6,1,%l6	!
		subcc	%l4,%l6,%g0	!
		bge	%icc,i.dp0lp1	!
		and	%o1,0xfff,%o1	!

		add	%i0,800,%o1	!
		add	%i0,816,%o2	!
		mov	%l4,%o3		! ##TEMPLATE:imm0 (L1)
		mov	%l5,%o4		! ##TEMPLATE:imm0 (L2)
		call	il_dp		!
		mov	%i0,%o0		! struct gcpu_s*

		mov	%l1,%o0		!
		mov	%l2,%o1		!
		mov	%l3,%o2		!

		mov	0,%l6		!
		add	%i0,800,%o7	!
    i.dp0lp0:	ldub	[%o7+%l6],%l0	!
		stb	%l0,[%o0+%o1]	!
		add	%o1,1,%o1	!
		subcc	%o1,0xfff,%g0	! if page cross
		movgu	%icc,%o2,%o0	!   base1 -> base0
		add	%l6,1,%l6	!
		subcc	%l4,%l6,%g0	!
		bge	%icc,i.dp0lp0	!
		and	%o1,0xfff,%o1	!
	
		sethi	%hi(0x00ff0000),%o7
		andcc	%g7,%o7,%g0	! if intermediate intr. then
		bz,a	%icc,break0	!   exit
		add	%g2,%l7,%g2	! ##TEMPLATE:IAR
		ba,a	%icc,epilog0	!
		nop			!
i.dp0e:
!================================

!
! templates
!   %i0: struct gcpu_s*
!   %i3: M instruction (upper 2 bytes)
!
	.section ".text"
	.align	4
	.global if2_lpdr
if2_lpdr:
	srl	%i3,20,%i4		! switch (R1)
	srl	%i3,16,%i5		! switch (R2)
	or	%i4,%i5,%i5		!
	andcc	%i5,1,%g0		!
	bnz,pn	%icc,spec_exception	!
	nop				!
    i.lpdr0t:				!
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	add	%i5,64,%i1		! %i1
	srl	%i3,16,%i5		! R2
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	add	%i5,64,%i2		! %i2
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	add	%g0,2,%l7		!
	movnz	%icc,4,%l7		! if EX=1 then IAR+=4
i.lpdr0s:
		mov	0,%g1		! CC=0
		ldd	[%i0+%i2],%l0	! ##TEMPLATE:%imm
		sethi	%hi(0x80000000),%l2
		andn	%l0,%l2,%l0	! set sign
		std	%l0,[%i0+%i1]	! ##TEMPLATE:%imm
		sll	%l0,8,%l0	!
		orcc	%l0,%l1,%g0	! if fraction == 0 then CC=0
		movnz	%icc,2,%g1	! else CC=2
		ba	%icc,break0	!
		add	%g2,%l7,%g2	! ##TEMPLATE:IAR
i.lpdr0e:

	.section ".text"
	.align	4
	.global if2_lndr
if2_lndr:
	srl	%i3,20,%i4		! switch (R1)
	srl	%i3,16,%i5		! switch (R2)
	or	%i4,%i5,%i5		!
	andcc	%i5,1,%g0		!
	bnz,pn	%icc,spec_exception	!
	nop				!
    i.lndr0t:				!
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	add	%i5,64,%i1		! %i1
	srl	%i3,16,%i5		! R2
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	add	%i5,64,%i2		! %i2
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	add	%g0,2,%l7		!
	movnz	%icc,4,%l7		! if EX=1 then IAR+=4
i.lndr0s:
		mov	0,%g1		! CC=0
		ldd	[%i0+%i2],%l0	! ##TEMPLATE:%imm
		sethi	%hi(0x80000000),%l2
		or	%l0,%l2,%l0	! set sign
		std	%l0,[%i0+%i1]	! ##TEMPLATE:%imm
		sll	%l0,8,%l0	!
		orcc	%l0,%l1,%g0	! if fraction == 0 then CC=0
		movnz	%icc,1,%g1	! else CC=1
		ba	%icc,break0	!
		add	%g2,%l7,%g2	! ##TEMPLATE:IAR
i.lndr0e:

	.section ".text"
	.align	4
	.global if2_ltdr
if2_ltdr:
	srl	%i3,20,%i4		! switch (R1)
	srl	%i3,16,%i5		! switch (R2)
	or	%i4,%i5,%i5		!
	andcc	%i5,1,%g0		!
	bnz,pn	%icc,spec_exception	!
	nop				!
    i.ltdr0t:				!
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	add	%i5,64,%i1		! %i1
	srl	%i3,16,%i5		! R2
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	add	%i5,64,%i2		! %i2
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	add	%g0,2,%l7		!
	movnz	%icc,4,%l7		! if EX=1 then IAR+=4
i.ltdr0s:
		mov	0,%g1		! CC=0
		ldd	[%i0+%i2],%l0	! ##TEMPLATE:%imm
		std	%l0,[%i0+%i1]	! ##TEMPLATE:%imm
		sll	%l0,8,%l2	!
		orcc	%l2,%l1,%g0	!
		bz,pn	%icc,break0	! if fraction == 0 then
		add	%g2,%l7,%g2	! ##TEMPLATE:IAR
		subcc	%l0,%g0,%g0	! 
		movpos	%icc,2,%g1	! if %l0 >= 0 then CC=2
		ba	%icc,break0	!
		movneg	%icc,1,%g1	! else CC=1
i.ltdr0e:

	.section ".text"
	.align	4
	.global if2_lcdr
if2_lcdr:
	srl	%i3,20,%i4		! switch (R1)
	srl	%i3,16,%i5		! switch (R2)
	or	%i4,%i5,%i5		!
	andcc	%i5,1,%g0		!
	bnz,pn	%icc,spec_exception	!
	nop				!
    i.lcdr0t:				!
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	add	%i5,64,%i1		! %i1
	srl	%i3,16,%i5		! R2
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	add	%i5,64,%i2		! %i2
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	add	%g0,2,%l7		!
	movnz	%icc,4,%l7		! if EX=1 then IAR+=4
i.lcdr0s:
		mov	0,%g1		! CC=0
		ldd	[%i0+%i2],%l0	! ##TEMPLATE:%imm
		sethi	%hi(0x80000000),%l2
		xor	%l0,%l2,%l0	! invert sign
		std	%l0,[%i0+%i1]	! ##TEMPLATE:%imm
		sll	%l0,8,%l2	!
		orcc	%l2,%l1,%g0	!
		bz,pn	%icc,break0	! if fraction == 0 then
		add	%g2,%l7,%g2	! ##TEMPLATE:IAR
		subcc	%l0,%g0,%g0	!
		movpos	%icc,2,%g1	! if %l0 >= 0 then CC=2
		ba	%icc,break0	!
		movneg	%icc,1,%g1	! else CC=1
i.lcdr0e:

	.section ".text"
	.align	4
	.global if2_hdr
if2_hdr:
	srl	%i3,20,%i4		! switch (R1)
	srl	%i3,16,%i5		! switch (R2)
	or	%i4,%i5,%i5		!
	andcc	%i5,1,%g0		!
	bnz,pn	%icc,spec_exception	!
	nop				!
    i.hdr0t:				!
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	add	%i5,64,%i1		! %i1
	srl	%i3,16,%i5		! R2
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	add	%i5,64,%i2		! %i2
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	add	%g0,2,%l7		!
	movnz	%icc,4,%l7		! if EX=1 then IAR+=4
i.hdr0s:
		add	%i0,%i1,%o1	! ##TEMPLATE:%imm
		add	%i0,%i2,%o2	! ##TEMPLATE:%imm
		and	%g7,0xf,%o3	! give Program Mask
		stx	%g1,[%i0+648]	!
		stx	%g2,[%i0+656]	!
		stx	%g3,[%i0+664]	!
		stx	%g4,[%i0+672]	!
		stx	%g5,[%i0+680]	!
		stx	%g6,[%i0+688]	!
		call	fl_halve_long	!
		mov	%i0,%o0		! struct gcpu_s*
		ldx	[%i0+648],%g1	!
		ldx	[%i0+656],%g2	!
		ldx	[%i0+664],%g3	!
		ldx	[%i0+672],%g4	!
		ldx	[%i0+680],%g5	!
		ldx	[%i0+688],%g6	!
		sethi	%hi(0x00ff0000),%o7
		andcc	%o0,%o7,%o0	! extract exception
		bz,a,pt	%icc,break0	!   exit
		add	%g2,%l7,%g2	! ##TEMPLATE:IAR
		ba	%icc,epilog0	!
		or	%g7,%o0,%g7	! INTR-CODE=retval
i.hdr0e:

	.section ".text"
	.align	4
	.global if2_lrdr
if2_lrdr:
	srl	%i3,20,%i5		! switch (R1)
	andcc	%i5,1,%g0		!
	bnz,pn	%icc,spec_exception	!
	srl	%i3,16,%i5		! switch (R2)
	andcc	%i5,3,%g0		!
	bnz,pn	%icc,spec_exception	!
	nop				!
    i.lrdr0t:				!
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	add	%i5,64,%i1		! %i1
	srl	%i3,16,%i5		! R2
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	add	%i5,64,%i2		! %i2
	add	%i2,8,%i3		! %i3
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	add	%g0,2,%l7		!
	movnz	%icc,4,%l7		! if EX=1 then IAR+=4
i.lrdr0s:
		ldd	[%i0+%i2],%l0	! ##TEMPLATE:%imm
		ld	[%i0+%i3],%l2	! ##TEMPLATE:%imm
		sll	%l2,8,%l2	!
		sethi	%hi(0x80000000),%l4
		addcc	%l2,%l4,%g0	! if no carry-in then
		bcc	%icc,i.lrdr000	!   skip
		nop			!
		addcc	%l1,1,%l1	! add fraction(L) with 1
		bcc	%icc,i.lrdr000	! if no carry-out(L) then
		sll	%l0,8,%l3	!   skip
		addcc	%l3,0x100,%g0	! if no carry-out(H) then
		bcc,a	%icc,i.lrdr000	!   add fraction with 1
		add	%l0,1,%l0	!   skip
		sll	%l0,8,%l3	! add fraction with 1
		srl	%l3,8,%l3	!
		add	%l3,1,%l3	!
		srl	%l3,4,%l3	! shift fraction right 4bits
		srl	%l0,24,%l2	! add characteristic with 1
		sll	%l2,25,%l2	!
		sethi	%hi(0x02000000),%l4
		addcc	%l2,%l4,%l2	!
		srl	%l0,31,%l0	! extract sign bit
		sll	%l0,31,%l0	!
		srl	%l2,1,%l2	! extract characteristic
		or	%l0,%l2,%l0	! merge characteristic
		or	%l0,%l3,%l0	! merge fraction
    i.lrdr000:	std	%l0,[%i0+%i1]	! ##TEMPLATE:%imm
		bcc,a,pt %icc,break0	! if characteristic overflow then
		add	%g2,%l7,%g2	! ##TEMPLATE:IAR
		sethi	%hi(0x000C0000),%o7
		ba	%icc,epilog0	!
		or	%g7,%o7,%g7	!     exponent overflow
i.lrdr0e:

	.section ".text"
	.align	4
	.global if2_mxr
if2_mxr:
	srl	%i3,20,%i4		! switch (R1)
	srl	%i3,16,%i5		! switch (R2)
	or	%i4,%i5,%i5		!
	andcc	%i5,3,%g0		!
	bnz,pn	%icc,spec_exception	!
	nop				!
    i.mxr0t:				!
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	add	%i5,64,%i1		! %i1
	srl	%i3,16,%i5		! R2
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	add	%i5,64,%i2		! %i2
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	add	%g0,2,%l7		!
	movnz	%icc,4,%l7		! if EX=1 then IAR+=4
i.mxr0s:
		add	%i0,%i1,%o1	! ##TEMPLATE:%imm
		add	%i0,%i2,%o2	! ##TEMPLATE:%imm
		and	%g7,0xf,%o3	! give Program Mask
		stx	%g1,[%i0+648]	!
		stx	%g2,[%i0+656]	!
		stx	%g3,[%i0+664]	!
		stx	%g4,[%i0+672]	!
		stx	%g5,[%i0+680]	!
		stx	%g6,[%i0+688]	!
		call	fl_mult_ext2ext	!
		mov	%i0,%o0		! struct gcpu_s*
		ldx	[%i0+648],%g1	!
		ldx	[%i0+656],%g2	!
		ldx	[%i0+664],%g3	!
		ldx	[%i0+672],%g4	!
		ldx	[%i0+680],%g5	!
		ldx	[%i0+688],%g6	!
		sethi	%hi(0x00ff0000),%o7
		andcc	%o0,%o7,%o0	! extract exception
		bz,a,pt	%icc,break0	!   exit
		add	%g2,%l7,%g2	! ##TEMPLATE:IAR
		ba	%icc,epilog0	!
		or	%g7,%o0,%g7	! INTR-CODE=retval
i.mxr0e:

	.section ".text"
	.align	4
	.global if2_mxdr
if2_mxdr:
	srl	%i3,20,%i5		! switch (R1)
	andcc	%i5,3,%g0		!
	bnz,pn	%icc,spec_exception	!
	srl	%i3,16,%i5		! switch (R2)
	andcc	%i5,1,%g0		!
	bnz,pn	%icc,spec_exception	!
	nop				!
    i.mxdr0t:				!
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	add	%i5,64,%i1		! %i1
	srl	%i3,16,%i5		! R2
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	add	%i5,64,%i2		! %i2
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	add	%g0,2,%l7		!
	movnz	%icc,4,%l7		! if EX=1 then IAR+=4
i.mxdr0s:
		add	%i0,%i1,%o1	! ##TEMPLATE:%imm
		add	%i0,%i2,%o2	! ##TEMPLATE:%imm
		and	%g7,0xf,%o3	! give Program Mask
		stx	%g1,[%i0+648]	!
		stx	%g2,[%i0+656]	!
		stx	%g3,[%i0+664]	!
		stx	%g4,[%i0+672]	!
		stx	%g5,[%i0+680]	!
		stx	%g6,[%i0+688]	!
		call	fl_mult_long2ext!
		mov	%i0,%o0		! struct gcpu_s*
		ldx	[%i0+648],%g1	!
		ldx	[%i0+656],%g2	!
		ldx	[%i0+664],%g3	!
		ldx	[%i0+672],%g4	!
		ldx	[%i0+680],%g5	!
		ldx	[%i0+688],%g6	!
		sethi	%hi(0x00ff0000),%o7
		andcc	%o0,%o7,%o0	! extract exception
		bz,a,pt	%icc,break0	!   exit
		add	%g2,%l7,%g2	! ##TEMPLATE:IAR
		ba	%icc,epilog0	!
		or	%g7,%o0,%g7	! INTR-CODE=retval
i.mxdr0e:

	.section ".text"
	.align	4
	.global if2_ldr
if2_ldr:
	srl	%i3,20,%i4		! switch (R1)
	srl	%i3,16,%i5		! switch (R2)
	or	%i4,%i5,%i5		!
	andcc	%i5,1,%g0		!
	bnz,pn	%icc,spec_exception	!
	nop				!
    i.ldr0t:				!
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	add	%i5,64,%i1		! %i1
	srl	%i3,16,%i5		! R2
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	add	%i5,64,%i2		! %i2
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	add	%g0,2,%l7		!
	movnz	%icc,4,%l7		! if EX=1 then IAR+=4
i.ldr0s:
		ldd	[%i0+%i2],%l0	! ##TEMPLATE:%imm
		std	%l0,[%i0+%i1]	! ##TEMPLATE:%imm
		ba	%icc,break0	!
		add	%g2,%l7,%g2	! ##TEMPLATE:IAR
i.ldr0e:

	.section ".text"
	.align	4
	.global if2_cdr
if2_cdr:
	srl	%i3,20,%i4		! switch (R1)
	srl	%i3,16,%i5		! switch (R2)
	or	%i4,%i5,%i5		!
	andcc	%i5,1,%g0		!
	bnz,pn	%icc,spec_exception	!
	nop				!
    i.cdr0t:				!
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	add	%i5,64,%i1		! %i1
	srl	%i3,16,%i5		! R2
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	add	%i5,64,%i2		! %i2
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	add	%g0,2,%l7		!
	movnz	%icc,4,%l7		! if EX=1 then IAR+=4
i.cdr0s:
		add	%i0,%i1,%o1	! ##TEMPLATE:%imm
		add	%i0,%i2,%o2	! ##TEMPLATE:%imm
		and	%g7,0xf,%o3	! give Program Mask
		stx	%g1,[%i0+648]	!
		stx	%g2,[%i0+656]	!
		stx	%g3,[%i0+664]	!
		stx	%g4,[%i0+672]	!
		stx	%g5,[%i0+680]	!
		stx	%g6,[%i0+688]	!
		call	fl_comp_long	!
		mov	%i0,%o0		! struct gcpu_s*
		ldx	[%i0+648],%g1	!
		ldx	[%i0+656],%g2	!
		ldx	[%i0+664],%g3	!
		ldx	[%i0+672],%g4	!
		ldx	[%i0+680],%g5	!
		ldx	[%i0+688],%g6	!
		and	%o0,3,%g1	! CC=retval
		ba	%icc,break0	!
		add	%g2,%l7,%g2	! ##TEMPLATE:IAR
i.cdr0e:

	.section ".text"
	.align	4
	.global if2_adr
if2_adr:
	srl	%i3,20,%i4		! switch (R1)
	srl	%i3,16,%i5		! switch (R2)
	or	%i4,%i5,%i5		!
	andcc	%i5,1,%g0		!
	bnz,pn	%icc,spec_exception	!
	nop				!
    i.adr0t:				!
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	add	%i5,64,%i1		! %i1
	srl	%i3,16,%i5		! R2
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	add	%i5,64,%i2		! %i2
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	add	%g0,2,%l7		!
	movnz	%icc,4,%l7		! if EX=1 then IAR+=4
i.adr0s:
		add	%i0,%i1,%o1	! ##TEMPLATE:%imm
		add	%i0,%i2,%o2	! ##TEMPLATE:%imm
		and	%g7,0xf,%o3	! give Program Mask
		add	%g0,0,%o4	!
		stx	%g1,[%i0+648]	!
		stx	%g2,[%i0+656]	!
		stx	%g3,[%i0+664]	!
		stx	%g4,[%i0+672]	!
		stx	%g5,[%i0+680]	!
		stx	%g6,[%i0+688]	!
		call	fl_addsub_long_norm
		mov	%i0,%o0		! struct gcpu_s*
		ldx	[%i0+648],%g1	!
		ldx	[%i0+656],%g2	!
		ldx	[%i0+664],%g3	!
		ldx	[%i0+672],%g4	!
		ldx	[%i0+680],%g5	!
		ldx	[%i0+688],%g6	!
		and	%o0,3,%g1	! CC=retval
		sethi	%hi(0x00ff0000),%o7
		andcc	%o0,%o7,%o0	! extract exception
		bz,a,pt	%icc,break0	!   exit
		add	%g2,%l7,%g2	! ##TEMPLATE:IAR
		ba	%icc,epilog0	!
		or	%g7,%o0,%g7	! INTR-CODE=retval
i.adr0e:

	.section ".text"
	.align	4
	.global if2_sdr
if2_sdr:
	srl	%i3,20,%i4		! switch (R1)
	srl	%i3,16,%i5		! switch (R2)
	or	%i4,%i5,%i5		!
	andcc	%i5,1,%g0		!
	bnz,pn	%icc,spec_exception	!
	nop				!
    i.sdr0t:				!
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	add	%i5,64,%i1		! %i1
	srl	%i3,16,%i5		! R2
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	add	%i5,64,%i2		! %i2
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	add	%g0,2,%l7		!
	movnz	%icc,4,%l7		! if EX=1 then IAR+=4
i.sdr0s:
		add	%i0,%i1,%o1	! ##TEMPLATE:%imm
		add	%i0,%i2,%o2	! ##TEMPLATE:%imm
		and	%g7,0xf,%o3	! give Program Mask
		add	%g0,1,%o4	! call library in fltlib.s
		stx	%g1,[%i0+648]	!
		stx	%g2,[%i0+656]	!
		stx	%g3,[%i0+664]	!
		stx	%g4,[%i0+672]	!
		stx	%g5,[%i0+680]	!
		stx	%g6,[%i0+688]	!
		call	fl_addsub_long_norm
		mov	%i0,%o0		! struct gcpu_s*
		ldx	[%i0+648],%g1	!
		ldx	[%i0+656],%g2	!
		ldx	[%i0+664],%g3	!
		ldx	[%i0+672],%g4	!
		ldx	[%i0+680],%g5	!
		ldx	[%i0+688],%g6	!
		and	%o0,3,%g1	! CC=retval
		sethi	%hi(0x00ff0000),%o7
		andcc	%o0,%o7,%o0	! extract exception
		bz,a,pt	%icc,break0	!   exit
		add	%g2,%l7,%g2	! ##TEMPLATE:IAR
		ba	%icc,epilog0	!
		or	%g7,%o0,%g7	! INTR-CODE=retval
i.sdr0e:

	.section ".text"
	.align	4
	.global if2_mdr
if2_mdr:
	srl	%i3,20,%i4		! switch (R1)
	srl	%i3,16,%i5		! switch (R2)
	or	%i4,%i5,%i5		!
	andcc	%i5,1,%g0		!
	bnz,pn	%icc,spec_exception	!
	nop				!
    i.mdr0t:				!
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	add	%i5,64,%i1		! %i1
	srl	%i3,16,%i5		! R2
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	add	%i5,64,%i2		! %i2
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	add	%g0,2,%l7		!
	movnz	%icc,4,%l7		! if EX=1 then IAR+=4
i.mdr0s:
		add	%i0,%i1,%o1	! ##TEMPLATE:%imm
		add	%i0,%i2,%o2	! ##TEMPLATE:%imm
		and	%g7,0xf,%o3	! give Program Mask
		stx	%g1,[%i0+648]	!
		stx	%g2,[%i0+656]	!
		stx	%g3,[%i0+664]	!
		stx	%g4,[%i0+672]	!
		stx	%g5,[%i0+680]	!
		stx	%g6,[%i0+688]	!
		call	fl_mult_long2long
		mov	%i0,%o0		! struct gcpu_s*
		ldx	[%i0+648],%g1	!
		ldx	[%i0+656],%g2	!
		ldx	[%i0+664],%g3	!
		ldx	[%i0+672],%g4	!
		ldx	[%i0+680],%g5	!
		ldx	[%i0+688],%g6	!
		sethi	%hi(0x00ff0000),%o7
		andcc	%o0,%o7,%o0	! extract exception
		bz,a,pt	%icc,break0	!   exit
		add	%g2,%l7,%g2	! ##TEMPLATE:IAR
		ba	%icc,epilog0	!
		or	%g7,%o0,%g7	! INTR-CODE=retval
i.mdr0e:

	.section ".text"
	.align	4
	.global if2_ddr
if2_ddr:
	srl	%i3,20,%i4		! switch (R1)
	srl	%i3,16,%i5		! switch (R2)
	or	%i4,%i5,%i5		!
	andcc	%i5,1,%g0		!
	bnz,pn	%icc,spec_exception	!
	nop				!
    i.ddr0t:				!
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	add	%i5,64,%i1		! %i1
	srl	%i3,16,%i5		! R2
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	add	%i5,64,%i2		! %i2
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	add	%g0,2,%l7		!
	movnz	%icc,4,%l7		! if EX=1 then IAR+=4
i.ddr0s:
		add	%i0,%i1,%o1	! ##TEMPLATE:%imm
		add	%i0,%i2,%o2	! ##TEMPLATE:%imm
		and	%g7,0xf,%o3	! give Program Mask
		stx	%g1,[%i0+648]	!
		stx	%g2,[%i0+656]	!
		stx	%g3,[%i0+664]	!
		stx	%g4,[%i0+672]	!
		stx	%g5,[%i0+680]	!
		stx	%g6,[%i0+688]	!
		call	fl_div_long	!
		mov	%i0,%o0		! struct gcpu_s*
		ldx	[%i0+648],%g1	!
		ldx	[%i0+656],%g2	!
		ldx	[%i0+664],%g3	!
		ldx	[%i0+672],%g4	!
		ldx	[%i0+680],%g5	!
		ldx	[%i0+688],%g6	!
		sethi	%hi(0x00ff0000),%o7
		andcc	%o0,%o7,%o0	! extract exception
		bz,a,pt	%icc,break0	!   exit
		add	%g2,%l7,%g2	! ##TEMPLATE:IAR
		ba	%icc,epilog0	!
		or	%g7,%o0,%g7	! INTR-CODE=retval
i.ddr0e:

	.section ".text"
	.align	4
	.global if2_awr
if2_awr:
	srl	%i3,20,%i4		! switch (R1)
	srl	%i3,16,%i5		! switch (R2)
	or	%i4,%i5,%i5		!
	andcc	%i5,1,%g0		!
	bnz,pn	%icc,spec_exception	!
	nop				!
    i.awr0t:				!
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	add	%i5,64,%i1		! %i1
	srl	%i3,16,%i5		! R2
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	add	%i5,64,%i2		! %i2
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	add	%g0,2,%l7		!
	movnz	%icc,4,%l7		! if EX=1 then IAR+=4
i.awr0s:
		add	%i0,%i1,%o1	! ##TEMPLATE:%imm
		add	%i0,%i2,%o2	! ##TEMPLATE:%imm
		and	%g7,0xf,%o3	! give Program Mask
		add	%g0,0,%o4	!
		stx	%g1,[%i0+648]	!
		stx	%g2,[%i0+656]	!
		stx	%g3,[%i0+664]	!
		stx	%g4,[%i0+672]	!
		stx	%g5,[%i0+680]	!
		stx	%g6,[%i0+688]	!
		call	fl_addsub_long_unnorm
		mov	%i0,%o0		! struct gcpu_s*
		ldx	[%i0+648],%g1	!
		ldx	[%i0+656],%g2	!
		ldx	[%i0+664],%g3	!
		ldx	[%i0+672],%g4	!
		ldx	[%i0+680],%g5	!
		ldx	[%i0+688],%g6	!
		and	%o0,3,%g1	! CC=retval
		sethi	%hi(0x00ff0000),%o7
		andcc	%o0,%o7,%o0	! extract exception
		bz,a,pt	%icc,break0	!   exit
		add	%g2,%l7,%g2	! ##TEMPLATE:IAR
		ba	%icc,epilog0	!
		or	%g7,%o0,%g7	! INTR-CODE=retval
i.awr0e:

	.section ".text"
	.align	4
	.global if2_swr
if2_swr:
	srl	%i3,20,%i4		! switch (R1)
	srl	%i3,16,%i5		! switch (R2)
	or	%i4,%i5,%i5		!
	andcc	%i5,1,%g0		!
	bnz,pn	%icc,spec_exception	!
	nop				!
    i.swr0t:				!
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	add	%i5,64,%i1		! %i1
	srl	%i3,16,%i5		! R2
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	add	%i5,64,%i2		! %i2
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	add	%g0,2,%l7		!
	movnz	%icc,4,%l7		! if EX=1 then IAR+=4
i.swr0s:
		add	%i0,%i1,%o1	! ##TEMPLATE:%imm
		add	%i0,%i2,%o2	! ##TEMPLATE:%imm
		and	%g7,0xf,%o3	! give Program Mask
		add	%g0,1,%o4	!
		stx	%g1,[%i0+648]	!
		stx	%g2,[%i0+656]	!
		stx	%g3,[%i0+664]	!
		stx	%g4,[%i0+672]	!
		stx	%g5,[%i0+680]	!
		stx	%g6,[%i0+688]	!
		call	fl_addsub_long_unnorm
		mov	%i0,%o0		! struct gcpu_s*
		ldx	[%i0+648],%g1	!
		ldx	[%i0+656],%g2	!
		ldx	[%i0+664],%g3	!
		ldx	[%i0+672],%g4	!
		ldx	[%i0+680],%g5	!
		ldx	[%i0+688],%g6	!
		and	%o0,3,%g1	! CC=retval
		sethi	%hi(0x00ff0000),%o7
		andcc	%o0,%o7,%o0	! extract exception
		bz,a,pt	%icc,break0	!   exit
		add	%g2,%l7,%g2	! ##TEMPLATE:IAR
		ba	%icc,epilog0	!
		or	%g7,%o0,%g7	! INTR-CODE=retval
i.swr0e:
!================================

!
! templates
!   %i0: struct gcpu_s*
!   %i3: M instruction (upper 2 bytes)
!
	.section ".text"
	.align	4
	.global if2_lper
if2_lper:
	srl	%i3,20,%i4		! switch (R1)
	srl	%i3,16,%i5		! switch (R2)
	or	%i4,%i5,%i5		!
	andcc	%i5,1,%g0		!
	bnz,pn	%icc,spec_exception	!
	nop				!
    i.lper0t:				!
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	add	%i5,64,%i1		! %i1
	srl	%i3,16,%i5		! R2
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	add	%i5,64,%i2		! %i2
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	add	%g0,2,%l7		!
	movnz	%icc,4,%l7		! if EX=1 then IAR+=4
i.lper0s:
		mov	0,%g1		! CC=0
		ld	[%i0+%i2],%l0	! ##TEMPLATE:%imm
		sethi	%hi(0x80000000),%l2
		andn	%l0,%l2,%l0	! set sign
		st	%l0,[%i0+%i1]	! ##TEMPLATE:%imm
		sll	%l0,8,%l0	!
		orcc	%l0,%g0,%g0	! if fraction == 0 then CC=0
		movnz	%icc,2,%g1	! else CC=2
		ba	%icc,break0	!
		add	%g2,%l7,%g2	! ##TEMPLATE:IAR
i.lper0e:

	.section ".text"
	.align	4
	.global if2_lner
if2_lner:
	srl	%i3,20,%i4		! switch (R1)
	srl	%i3,16,%i5		! switch (R2)
	or	%i4,%i5,%i5		!
	andcc	%i5,1,%g0		!
	bnz,pn	%icc,spec_exception	!
	nop				!
    i.lner0t:				!
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	add	%i5,64,%i1		! %i1
	srl	%i3,16,%i5		! R2
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	add	%i5,64,%i2		! %i2
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	add	%g0,2,%l7		!
	movnz	%icc,4,%l7		! if EX=1 then IAR+=4
i.lner0s:
		mov	0,%g1		! CC=0
		ld	[%i0+%i2],%l0	! ##TEMPLATE:%imm
		sethi	%hi(0x80000000),%l2
		or	%l0,%l2,%l0	! set sign
		st	%l0,[%i0+%i1]	! ##TEMPLATE:%imm
		sll	%l0,8,%l0	!
		orcc	%l0,%g0,%g0	! if fraction == 0 then CC=0
		movnz	%icc,1,%g1	! else CC=1
		ba	%icc,break0	!
		add	%g2,%l7,%g2	! ##TEMPLATE:IAR
i.lner0e:

	.section ".text"
	.align	4
	.global if2_lter
if2_lter:
	srl	%i3,20,%i4		! switch (R1)
	srl	%i3,16,%i5		! switch (R2)
	or	%i4,%i5,%i5		!
	andcc	%i5,1,%g0		!
	bnz,pn	%icc,spec_exception	!
	nop				!
    i.lter0t:				!
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	add	%i5,64,%i1		! %i1
	srl	%i3,16,%i5		! R2
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	add	%i5,64,%i2		! %i2
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	add	%g0,2,%l7		!
	movnz	%icc,4,%l7		! if EX=1 then IAR+=4
i.lter0s:
		mov	0,%g1		! CC=0
		ld	[%i0+%i2],%l0	! ##TEMPLATE:%imm
		st	%l0,[%i0+%i1]	! ##TEMPLATE:%imm
		sll	%l0,8,%l2	!
		orcc	%l2,%g0,%g0	!
		bz,pn	%icc,break0	! if fraction == 0 then
		add	%g2,%l7,%g2	! ##TEMPLATE:IAR
		subcc	%l0,%g0,%g0	!
		movpos	%icc,2,%g1	! if %l0 >= 0 then CC=2
		ba	%icc,break0	!
		movneg	%icc,1,%g1	! else CC=1
i.lter0e:

	.section ".text"
	.align	4
	.global if2_lcer
if2_lcer:
	srl	%i3,20,%i4		! switch (R1)
	srl	%i3,16,%i5		! switch (R2)
	or	%i4,%i5,%i5		!
	andcc	%i5,1,%g0		!
	bnz,pn	%icc,spec_exception	!
	nop				!
    i.lcer0t:				!
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	add	%i5,64,%i1		! %i1
	srl	%i3,16,%i5		! R2
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	add	%i5,64,%i2		! %i2
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	add	%g0,2,%l7		!
	movnz	%icc,4,%l7		! if EX=1 then IAR+=4
i.lcer0s:
		mov	0,%g1		! CC=0
		ld	[%i0+%i2],%l0	! ##TEMPLATE:%imm
		sethi	%hi(0x80000000),%l2
		xor	%l0,%l2,%l0	! invert sign
		st	%l0,[%i0+%i1]	! ##TEMPLATE:%imm
		sll	%l0,8,%l2	!
		orcc	%l2,%g0,%g0	!
		bz,pn	%icc,break0	! if fraction == 0 then
		add	%g2,%l7,%g2	! ##TEMPLATE:IAR
		subcc	%l0,%g0,%g0	!
		movpos	%icc,2,%g1	! if %l0 >= 0 then CC=2
		ba	%icc,break0	!
		movneg	%icc,1,%g1	! else CC=1
i.lcer0e:

	.section ".text"
	.align	4
	.global if2_her
if2_her:
	srl	%i3,20,%i4		! switch (R1)
	srl	%i3,16,%i5		! switch (R2)
	or	%i4,%i5,%i5		!
	andcc	%i5,1,%g0		!
	bnz,pn	%icc,spec_exception	!
	nop				!
    i.her0t:				!
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	add	%i5,64,%i1		! %i1
	srl	%i3,16,%i5		! R2
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	add	%i5,64,%i2		! %i2
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	add	%g0,2,%l7		!
	movnz	%icc,4,%l7		! if EX=1 then IAR+=4
i.her0s:
		add	%i0,%i1,%o1	! ##TEMPLATE:%imm
		add	%i0,%i2,%o2	! ##TEMPLATE:%imm
		and	%g7,0xf,%o3	! give Program Mask
		stx	%g1,[%i0+648]	!
		stx	%g2,[%i0+656]	!
		stx	%g3,[%i0+664]	!
		stx	%g4,[%i0+672]	!
		stx	%g5,[%i0+680]	!
		stx	%g6,[%i0+688]	!
		call	fl_halve_short	!
		mov	%i0,%o0		! struct gcpu_s*
		ldx	[%i0+648],%g1	!
		ldx	[%i0+656],%g2	!
		ldx	[%i0+664],%g3	!
		ldx	[%i0+672],%g4	!
		ldx	[%i0+680],%g5	!
		ldx	[%i0+688],%g6	!
		sethi	%hi(0x00ff0000),%o7
		andcc	%o0,%o7,%o0	! extract exception
		bz,a,pt	%icc,break0	!   exit
		add	%g2,%l7,%g2	! ##TEMPLATE:IAR
		ba	%icc,epilog0	!
		or	%g7,%o0,%g7	! INTR-CODE=retval
i.her0e:

	.section ".text"
	.align	4
	.global if2_lrer
if2_lrer:
	srl	%i3,20,%i4		! switch (R1)
	srl	%i3,16,%i5		! switch (R2)
	or	%i4,%i5,%i5		!
	andcc	%i5,1,%g0		!
	bnz,pn	%icc,spec_exception	!
	nop				!
    i.lrer0t:				!
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	add	%i5,64,%i1		! %i1
	srl	%i3,16,%i5		! R2
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	add	%i5,64,%i2		! %i2
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	add	%g0,2,%l7		!
	movnz	%icc,4,%l7		! if EX=1 then IAR+=4
i.lrer0s:
		ldd	[%i0+%i2],%l0	! ##TEMPLATE:%imm
		sethi	%hi(0x80000000),%l4
		addcc	%l1,%l4,%g0	! if no carry-in then
		bcc	%icc,i.lrer000	!   skip
		sll	%l0,8,%l3	!
		addcc	%l3,0x100,%g0	! if no carry-out then
		bcc,a	%icc,i.lrer000	!   add fraction with 1
		add	%l0,1,%l0	!   skip
		sll	%l0,8,%l3	! add fraction with 1
		srl	%l3,8,%l3	!
		add	%l3,1,%l3	!
		srl	%l3,4,%l3	! shift fraction right 4bits
		srl	%l0,24,%l2	! add characteristic with 1
		sll	%l2,25,%l2	!
		sethi	%hi(0x02000000),%l4
		addcc	%l2,%l4,%l2	!
		srl	%l0,31,%l0	! extract sign bit
		sll	%l0,31,%l0	!
		srl	%l2,1,%l2	! extract characteristic
		or	%l0,%l2,%l0	! merge characteristic
		or	%l0,%l3,%l0	! merge fraction
    i.lrer000:	st	%l0,[%i0+%i1]	! ##TEMPLATE:%imm
		bcc,a,pt %icc,break0	! if characteristic overflow then
		add	%g2,%l7,%g2	! ##TEMPLATE:IAR
		sethi	%hi(0x000C0000),%o7
		ba	%icc,epilog0	!
		or	%g7,%o7,%g7	!     exponent overflow
i.lrer0e:

	.section ".text"
	.align	4
	.global if2_axr
if2_axr:
	srl	%i3,20,%i4		! switch (R1)
	srl	%i3,16,%i5		! switch (R2)
	or	%i4,%i5,%i5		!
	andcc	%i5,3,%g0		!
	bnz,pn	%icc,spec_exception	!
	nop				!
    i.axr0t:				!
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	add	%i5,64,%i1		! %i1
	srl	%i3,16,%i5		! R2
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	add	%i5,64,%i2		! %i2
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	add	%g0,2,%l7		!
	movnz	%icc,4,%l7		! if EX=1 then IAR+=4
i.axr0s:
		add	%i0,%i1,%o1	! ##TEMPLATE:%imm
		add	%i0,%i2,%o2	! ##TEMPLATE:%imm
		and	%g7,0xf,%o3	! give Program Mask
		add	%g0,0,%o4	! call library in fltlib.s
		stx	%g1,[%i0+648]	!
		stx	%g2,[%i0+656]	!
		stx	%g3,[%i0+664]	!
		stx	%g4,[%i0+672]	!
		stx	%g5,[%i0+680]	!
		stx	%g6,[%i0+688]	!
		call	fl_addsub_ext_norm
		mov	%i0,%o0		! struct gcpu_s*
		ldx	[%i0+648],%g1	!
		ldx	[%i0+656],%g2	!
		ldx	[%i0+664],%g3	!
		ldx	[%i0+672],%g4	!
		ldx	[%i0+680],%g5	!
		ldx	[%i0+688],%g6	!
		and	%o0,3,%g1	! CC=retval
		sethi	%hi(0x00ff0000),%o7
		andcc	%o0,%o7,%o0	! extract exception
		bz,a,pt	%icc,break0	!   exit
		add	%g2,%l7,%g2	! ##TEMPLATE:IAR
		ba	%icc,epilog0	!
		or	%g7,%o0,%g7	! INTR-CODE=retval
i.axr0e:

	.section ".text"
	.align	4
	.global if2_sxr
if2_sxr:
	srl	%i3,20,%i4		! switch (R1)
	srl	%i3,16,%i5		! switch (R2)
	or	%i4,%i5,%i5		!
	andcc	%i5,3,%g0		!
	bnz,pn	%icc,spec_exception	!
	nop				!
    i.sxr0t:				!
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	add	%i5,64,%i1		! %i1
	srl	%i3,16,%i5		! R2
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	add	%i5,64,%i2		! %i2
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	add	%g0,2,%l7		!
	movnz	%icc,4,%l7		! if EX=1 then IAR+=4
i.sxr0s:
		add	%i0,%i1,%o1	! ##TEMPLATE:%imm
		add	%i0,%i2,%o2	! ##TEMPLATE:%imm
		and	%g7,0xf,%o3	! give Program Mask
		add	%g0,1,%o4	! call library in fltlib.s
		stx	%g1,[%i0+648]	!
		stx	%g2,[%i0+656]	!
		stx	%g3,[%i0+664]	!
		stx	%g4,[%i0+672]	!
		stx	%g5,[%i0+680]	!
		stx	%g6,[%i0+688]	!
		call	fl_addsub_ext_norm
		mov	%i0,%o0		! struct gcpu_s*
		ldx	[%i0+648],%g1	!
		ldx	[%i0+656],%g2	!
		ldx	[%i0+664],%g3	!
		ldx	[%i0+672],%g4	!
		ldx	[%i0+680],%g5	!
		ldx	[%i0+688],%g6	!
		and	%o0,3,%g1	! CC=retval
		sethi	%hi(0x00ff0000),%o7
		andcc	%o0,%o7,%o0	! extract exception
		bz,a,pt	%icc,break0	!   exit
		add	%g2,%l7,%g2	! ##TEMPLATE:IAR
		ba	%icc,epilog0	!
		or	%g7,%o0,%g7	! INTR-CODE=retval
i.sxr0e:

	.section ".text"
	.align	4
	.global	if2_ler
if2_ler:
	srl	%i3,20,%i4		! switch (R1)
	srl	%i3,16,%i5		! switch (R2)
	or	%i4,%i5,%i5		!
	andcc	%i5,1,%g0		!
	bnz,pn	%icc,spec_exception	!
	nop				!
    i.ler0t:				!
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	add	%i5,64,%i1		! %i1
	srl	%i3,16,%i5		! R2
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	add	%i5,64,%i2		! %i2
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	add	%g0,2,%l7		!
	movnz	%icc,4,%l7		! if EX=1 then IAR+=4
i.ler0s:
		ld	[%i0+%i2],%l0	! ##TEMPLATE:%imm
		st	%l0,[%i0+%i1]	! ##TEMPLATE:%imm
		ba	%icc,break0	!
		add	%g2,%l7,%g2	! ##TEMPLATE:IAR
i.ler0e:

	.section ".text"
	.align	4
	.global if2_cer
if2_cer:
	srl	%i3,20,%i4		! switch (R1)
	srl	%i3,16,%i5		! switch (R2)
	or	%i4,%i5,%i5		!
	andcc	%i5,1,%g0		!
	bnz,pn	%icc,spec_exception	!
	nop				!
    i.cer0t:				!
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	add	%i5,64,%i1		! %i1
	srl	%i3,16,%i5		! R2
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	add	%i5,64,%i2		! %i2
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	add	%g0,2,%l7		!
	movnz	%icc,4,%l7		! if EX=1 then IAR+=4
i.cer0s:
		add	%i0,%i1,%o1	! ##TEMPLATE:%imm
		add	%i0,%i2,%o2	! ##TEMPLATE:%imm
		and	%g7,0xf,%o3	! give Program Mask
		stx	%g1,[%i0+648]	!
		stx	%g2,[%i0+656]	!
		stx	%g3,[%i0+664]	!
		stx	%g4,[%i0+672]	!
		stx	%g5,[%i0+680]	!
		stx	%g6,[%i0+688]	!
		call	fl_comp_short	!
		mov	%i0,%o0		! struct gcpu_s*
		ldx	[%i0+648],%g1	!
		ldx	[%i0+656],%g2	!
		ldx	[%i0+664],%g3	!
		ldx	[%i0+672],%g4	!
		ldx	[%i0+680],%g5	!
		ldx	[%i0+688],%g6	!
		and	%o0,3,%g1	! CC=retval
		ba	%icc,break0	!
		add	%g2,%l7,%g2	! ##TEMPLATE:IAR
i.cer0e:

	.section ".text"
	.align	4
	.global if2_aer
if2_aer:
	srl	%i3,20,%i4		! switch (R1)
	srl	%i3,16,%i5		! switch (R2)
	or	%i4,%i5,%i5		!
	andcc	%i5,1,%g0		!
	bnz,pn	%icc,spec_exception	!
	nop				!
    i.aer0t:				!
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	add	%i5,64,%i1		! %i1
	srl	%i3,16,%i5		! R2
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	add	%i5,64,%i2		! %i2
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	add	%g0,2,%l7		!
	movnz	%icc,4,%l7		! if EX=1 then IAR+=4
i.aer0s:
		add	%i0,%i1,%o1	! ##TEMPLATE:%imm
		add	%i0,%i2,%o2	! ##TEMPLATE:%imm
		and	%g7,0xf,%o3	! give Program Mask
		add	%g0,0,%o4	! call library in fltlib.s
		stx	%g1,[%i0+648]	!
		stx	%g2,[%i0+656]	!
		stx	%g3,[%i0+664]	!
		stx	%g4,[%i0+672]	!
		stx	%g5,[%i0+680]	!
		stx	%g6,[%i0+688]	!
		call	fl_addsub_short_norm
		mov	%i0,%o0		! struct gcpu_s*
		ldx	[%i0+648],%g1	!
		ldx	[%i0+656],%g2	!
		ldx	[%i0+664],%g3	!
		ldx	[%i0+672],%g4	!
		ldx	[%i0+680],%g5	!
		ldx	[%i0+688],%g6	!
		and	%o0,3,%g1	! CC=retval
		sethi	%hi(0x00ff0000),%o7
		andcc	%o0,%o7,%o0	! extract exception
		bz,a,pt	%icc,break0	!   exit
		add	%g2,%l7,%g2	! ##TEMPLATE:IAR
		ba	%icc,epilog0	!
		or	%g7,%o0,%g7	! INTR-CODE=retval
i.aer0e:

	.section ".text"
	.align	4
	.global	if2_ser
if2_ser:
	srl	%i3,20,%i4		! switch (R1)
	srl	%i3,16,%i5		! switch (R2)
	or	%i4,%i5,%i5		!
	andcc	%i5,1,%g0		!
	bnz,pn	%icc,spec_exception	!
	nop				!
    i.ser0t:				!
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	add	%i5,64,%i1		! %i1
	srl	%i3,16,%i5		! R2
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	add	%i5,64,%i2		! %i2
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	add	%g0,2,%l7		!
	movnz	%icc,4,%l7		! if EX=1 then IAR+=4
i.ser0s:
		add	%i0,%i1,%o1	! ##TEMPLATE:%imm
		add	%i0,%i2,%o2	! ##TEMPLATE:%imm
		and	%g7,0xf,%o3	! give Program Mask
		add	%g0,1,%o4	! call library in fltlib.s
		stx	%g1,[%i0+648]	!
		stx	%g2,[%i0+656]	!
		stx	%g3,[%i0+664]	!
		stx	%g4,[%i0+672]	!
		stx	%g5,[%i0+680]	!
		stx	%g6,[%i0+688]	!
		call	fl_addsub_short_norm
		mov	%i0,%o0		! struct gcpu_s*
		ldx	[%i0+648],%g1	!
		ldx	[%i0+656],%g2	!
		ldx	[%i0+664],%g3	!
		ldx	[%i0+672],%g4	!
		ldx	[%i0+680],%g5	!
		ldx	[%i0+688],%g6	!
		and	%o0,3,%g1	! CC=retval
		sethi	%hi(0x00ff0000),%o7
		andcc	%o0,%o7,%o0	! extract exception
		bz,a,pt	%icc,break0	!   exit
		add	%g2,%l7,%g2	! ##TEMPLATE:IAR
		ba	%icc,epilog0	!
		or	%g7,%o0,%g7	! INTR-CODE=retval
i.ser0e:

	.section ".text"
	.align	4
	.global if2_mer
if2_mer:
	srl	%i3,20,%i4		! switch (R1)
	srl	%i3,16,%i5		! switch (R2)
	or	%i4,%i5,%i5		!
	andcc	%i5,1,%g0		!
	bnz,pn	%icc,spec_exception	!
	nop				!
    i.mer0t:				!
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	add	%i5,64,%i1		! %i1
	srl	%i3,16,%i5		! R2
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	add	%i5,64,%i2		! %i2
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	add	%g0,2,%l7		!
	movnz	%icc,4,%l7		! if EX=1 then IAR+=4
i.mer0s:
		add	%i0,%i1,%o1	! ##TEMPLATE:%imm
		add	%i0,%i2,%o2	! ##TEMPLATE:%imm
		and	%g7,0xf,%o3	! give Program Mask
		stx	%g1,[%i0+648]	!
		stx	%g2,[%i0+656]	!
		stx	%g3,[%i0+664]	!
		stx	%g4,[%i0+672]	!
		stx	%g5,[%i0+680]	!
		stx	%g6,[%i0+688]	!
		call	fl_mult_short2long
		mov	%i0,%o0		! struct gcpu_s*
		ldx	[%i0+648],%g1	!
		ldx	[%i0+656],%g2	!
		ldx	[%i0+664],%g3	!
		ldx	[%i0+672],%g4	!
		ldx	[%i0+680],%g5	!
		ldx	[%i0+688],%g6	!
		sethi	%hi(0x00ff0000),%o7
		andcc	%o0,%o7,%o0	! extract exception
		bz,a,pt	%icc,break0	!   exit
		add	%g2,%l7,%g2	! ##TEMPLATE:IAR
		ba	%icc,epilog0	!
		or	%g7,%o0,%g7	! INTR-CODE=retval
i.mer0e:

	.section ".text"
	.align	4
	.global if2_der
if2_der:
	srl	%i3,20,%i4		! switch (R1)
	srl	%i3,16,%i5		! switch (R2)
	or	%i4,%i5,%i5		!
	andcc	%i5,1,%g0		!
	bnz,pn	%icc,spec_exception	!
	nop				!
    i.der0t:				!
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	add	%i5,64,%i1		! %i1
	srl	%i3,16,%i5		! R2
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	add	%i5,64,%i2		! %i2
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	add	%g0,2,%l7		!
	movnz	%icc,4,%l7		! if EX=1 then IAR+=4
i.der0s:
		add	%i0,%i1,%o1	! ##TEMPLATE:%imm
		add	%i0,%i2,%o2	! ##TEMPLATE:%imm
		and	%g7,0xf,%o3	! give Program Mask
		stx	%g1,[%i0+648]	!
		stx	%g2,[%i0+656]	!
		stx	%g3,[%i0+664]	!
		stx	%g4,[%i0+672]	!
		stx	%g5,[%i0+680]	!
		stx	%g6,[%i0+688]	!
		call	fl_div_short	!
		mov	%i0,%o0		! struct gcpu_s*
		ldx	[%i0+648],%g1	!
		ldx	[%i0+656],%g2	!
		ldx	[%i0+664],%g3	!
		ldx	[%i0+672],%g4	!
		ldx	[%i0+680],%g5	!
		ldx	[%i0+688],%g6	!
		sethi	%hi(0x00ff0000),%o7
		andcc	%o0,%o7,%o0	! extract exception
		bz,a,pt	%icc,break0	!   exit
		add	%g2,%l7,%g2	! ##TEMPLATE:IAR
		ba	%icc,epilog0	!
		or	%g7,%o0,%g7	! INTR-CODE=retval
i.der0e:

	.section ".text"
	.align	4
	.global if2_aur
if2_aur:
	srl	%i3,20,%i4		! switch (R1)
	srl	%i3,16,%i5		! switch (R2)
	or	%i4,%i5,%i5		!
	andcc	%i5,1,%g0		!
	bnz,pn	%icc,spec_exception	!
	nop				!
    i.aur0t:				!
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	add	%i5,64,%i1		! %i1
	srl	%i3,16,%i5		! R2
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	add	%i5,64,%i2		! %i2
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	add	%g0,2,%l7		!
	movnz	%icc,4,%l7		! if EX=1 then IAR+=4
i.aur0s:
		add	%i0,%i1,%o1	! ##TEMPLATE:%imm
		add	%i0,%i2,%o2	! ##TEMPLATE:%imm
		and	%g7,0xf,%o3	! give Program Mask
		add	%g0,0,%o4	! call library in fltlib.s
		stx	%g1,[%i0+648]	!
		stx	%g2,[%i0+656]	!
		stx	%g3,[%i0+664]	!
		stx	%g4,[%i0+672]	!
		stx	%g5,[%i0+680]	!
		stx	%g6,[%i0+688]	!
		call	fl_addsub_short_unnorm
		mov	%i0,%o0		! struct gcpu_s*
		ldx	[%i0+648],%g1	!
		ldx	[%i0+656],%g2	!
		ldx	[%i0+664],%g3	!
		ldx	[%i0+672],%g4	!
		ldx	[%i0+680],%g5	!
		ldx	[%i0+688],%g6	!
		and	%o0,3,%g1	! CC=retval
		sethi	%hi(0x00ff0000),%o7
		andcc	%o0,%o7,%o0	! extract exception
		bz,a,pt	%icc,break0	!   exit
		add	%g2,%l7,%g2	! ##TEMPLATE:IAR
		ba	%icc,epilog0	!
		or	%g7,%o0,%g7	! INTR-CODE=retval
i.aur0e:

	.section ".text"
	.align	4
	.global if2_sur
if2_sur:
	srl	%i3,20,%i4		! switch (R1)
	srl	%i3,16,%i5		! switch (R2)
	or	%i4,%i5,%i5		!
	andcc	%i5,1,%g0		!
	bnz,pn	%icc,spec_exception	!
	nop				!
    i.sur0t:				!
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	add	%i5,64,%i1		! %i1
	srl	%i3,16,%i5		! R2
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	add	%i5,64,%i2		! %i2
	andcc	%g7,0x40,%g0		! if EX=0 then IAR+=2
	add	%g0,2,%l7		!
	movnz	%icc,4,%l7		! if EX=1 then IAR+=4
i.sur0s:
		add	%i0,%i1,%o1	! ##TEMPLATE:%imm
		add	%i0,%i2,%o2	! ##TEMPLATE:%imm
		and	%g7,0xf,%o3	! give Program Mask
		add	%g0,1,%o4	! call library in fltlib.s
		stx	%g1,[%i0+648]	!
		stx	%g2,[%i0+656]	!
		stx	%g3,[%i0+664]	!
		stx	%g4,[%i0+672]	!
		stx	%g5,[%i0+680]	!
		stx	%g6,[%i0+688]	!
		call	fl_addsub_short_unnorm
		mov	%i0,%o0		! struct gcpu_s*
		ldx	[%i0+648],%g1	!
		ldx	[%i0+656],%g2	!
		ldx	[%i0+664],%g3	!
		ldx	[%i0+672],%g4	!
		ldx	[%i0+680],%g5	!
		ldx	[%i0+688],%g6	!
		and	%o0,3,%g1	! CC=retval
		sethi	%hi(0x00ff0000),%o7
		andcc	%o0,%o7,%o0	! extract exception
		bz,a,pt	%icc,break0	!   exit
		add	%g2,%l7,%g2	! ##TEMPLATE:IAR
		ba	%icc,epilog0	!
		or	%g7,%o0,%g7	! INTR-CODE=retval
i.sur0e:
!================================

!
! templates
!   %i0: struct gcpu_s*
!   %i3: M instruction (upper 4 bytes)
!
	.section ".text"
	.align	4
	.global if4_std
if4_std:
	srl	%i3,20,%i5		! switch (R1)
	andcc	%i5,1,%g0		!
	bnz,pn	%icc,spec_exception	!
	nop				!
    i.std0t:				!
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	add	%i5,64,%i1		! %i1
	srl	%i3,16,%i5		! X2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l2		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l2		! %l2
	srl	%i3,12,%i5		! B2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l3		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l3		! %l3
	and	%i3,0xfff,%l4		! D2
i.std0s:
		add	%l2,%l3,%l2	! ##TEMPLATE:%l0,%l0
		add	%l2,%l4,%l2	! ##TEMPLATE:imm0
		and	%l2,%g3,%l2	! mask address
		ldd	[%i0+%i1],%l0	! ##TEMPLATE:%imm

		andncc	%l2,0x1ff,%g0	! check LAP
		bnz,pt	%icc,.+12	!
		andcc	%g7,0x20,%g0	!
		tnz	%icc,0x43	! LAP exception
					!
		andn	%l2,0xfff,%o1	! ST0-GS-TLB
		subcc	%g6,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g6,32,%o0	!
		call	st1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l2,0xfff,%o1	!

		st	%l0,[%o0+%o1]	! store upper word
		add	%l2,4,%l2	!
		and	%l2,%g3,%l2	! mask address

		andncc	%l2,0x1ff,%g0	! check LAP
		bnz,pt	%icc,.+12	!
		andcc	%g7,0x20,%g0	!
		tnz	%icc,0x43	! LAP exception
					!
		andn	%l2,0xfff,%o1	! ST0-GS-TLB
		subcc	%g6,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g6,32,%o0	!
		call	st1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l2,0xfff,%o1	!

		st	%l1,[%o0+%o1]	! store lower word
		ba	%icc,break0	!
		add	%g2,4,%g2	! update IAR
i.std0e:

	.section ".text"
	.align	4
	.global if4_mxd
if4_mxd:
	srl	%i3,20,%i5		! switch (R1)
	andcc	%i5,3,%g0		!
	bnz,pn	%icc,spec_exception	!
	nop				!
    i.mxd0t:				!
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	add	%i5,64,%i1		! %i1
	srl	%i3,16,%i5		! X2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l2		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l2		! %l2
	srl	%i3,12,%i5		! B2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l3		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l3		! %l3
	and	%i3,0xfff,%l4		! D2
i.mxd0s:
		add	%l2,%l3,%l2	! ##TEMPLATE:%l0,%l0
		add	%l2,%l4,%l2	! ##TEMPLATE:imm0
		and	%l2,%g3,%l2	! mask address

		andn	%l2,0xfff,%o1	! LD0-GS-TLB
		subcc	%g5,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g5,32,%o0	!
		call	ld1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l2,0xfff,%o1	!

		ld	[%o0+%o1],%l0	! get op#2
		add	%l2,4,%l2	!
		and	%l2,%g3,%l2	! mask address

		andn	%l2,0xfff,%o1	! LD0-GS-TLB
		subcc	%g5,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g5,32,%o0	!
		call	ld1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l2,0xfff,%o1	!

		ld	[%o0+%o1],%l1	! get op#2
		std	%l0,[%i0+800]	! store op#2
		add	%i0,%i1,%o1	! ##TEMPLATE:%imm
		add	%i0,800,%o2	!
		and	%g7,0xf,%o3	! give Program Mask
		stx	%g1,[%i0+648]	!
		stx	%g2,[%i0+656]	!
		stx	%g3,[%i0+664]	!
		stx	%g4,[%i0+672]	!
		stx	%g5,[%i0+680]	!
		stx	%g6,[%i0+688]	!
		call	fl_mult_long2ext!
		mov	%i0,%o0		! struct gcpu_s*
		ldx	[%i0+648],%g1	!
		ldx	[%i0+656],%g2	!
		ldx	[%i0+664],%g3	!
		ldx	[%i0+672],%g4	!
		ldx	[%i0+680],%g5	!
		ldx	[%i0+688],%g6	!
		sethi	%hi(0x00ff0000),%o7
		andcc	%o0,%o7,%o0	! extract exception
		bz,a	%icc,break0	!   exit
		add	%g2,4,%g2	! update IAR
		ba	%icc,epilog0	!
		or	%g7,%o0,%g7	! INTR-CODE=retval
i.mxd0e:

	.section ".text"
	.align	4
	.global if4_ld
if4_ld:
	srl	%i3,20,%i5		! switch (R1)
	andcc	%i5,1,%g0		!
	bnz,pn	%icc,spec_exception	!
	nop				!
    i.ld0t:				!
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	add	%i5,64,%i1		! %i1
	srl	%i3,16,%i5		! X2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l2		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l2		! %l2
	srl	%i3,12,%i5		! B2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l3		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l3		! %l3
	and	%i3,0xfff,%l4		! D2
i.ld0s:
		add	%l2,%l3,%l2	! ##TEMPLATE:%l0,%l0
		add	%l2,%l4,%l2	! ##TEMPLATE:imm0
		and	%l2,%g3,%l2	! mask address

		andn	%l2,0xfff,%o1	! LD0-GS-TLB
		subcc	%g5,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g5,32,%o0	!
		call	ld1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l2,0xfff,%o1	!

		ld	[%o0+%o1],%l0	! get op#2
		add	%l2,4,%l2	!
		and	%l2,%g3,%l2	! mask address

		andn	%l2,0xfff,%o1	! LD0-GS-TLB
		subcc	%g5,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g5,32,%o0	!
		call	ld1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l2,0xfff,%o1	!

		ld	[%o0+%o1],%l1	! get op#2
		std	%l0,[%i0+%i1]	! ##TEMPLATE:%imm
		ba	%icc,break0	!
		add	%g2,4,%g2	! update IAR
i.ld0e:

	.section ".text"
	.align	4
	.global if4_cd
if4_cd:
	srl	%i3,20,%i5		! switch (R1)
	andcc	%i5,1,%g0		!
	bnz,pn	%icc,spec_exception	!
	nop				!
    i.cd0t:				!
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	add	%i5,64,%i1		! %i1
	srl	%i3,16,%i5		! X2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l2		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l2		! %l2
	srl	%i3,12,%i5		! B2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l3		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l3		! %l3
	and	%i3,0xfff,%l4		! D2
i.cd0s:
		add	%l2,%l3,%l2	! ##TEMPLATE:%l0,%l0
		add	%l2,%l4,%l2	! ##TEMPLATE:imm0
		and	%l2,%g3,%l2	! mask address

		andn	%l2,0xfff,%o1	! LD0-GS-TLB
		subcc	%g5,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g5,32,%o0	!
		call	ld1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l2,0xfff,%o1	!

		ld	[%o0+%o1],%l0	! get op#2
		add	%l2,4,%l2	!
		and	%l2,%g3,%l2	! mask address

		andn	%l2,0xfff,%o1	! LD0-GS-TLB
		subcc	%g5,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g5,32,%o0	!
		call	ld1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l2,0xfff,%o1	!

		ld	[%o0+%o1],%l1	! get op#2
		std	%l0,[%i0+800]	! store op#2
		add	%i0,%i1,%o1	! ##TEMPLATE:%imm
		add	%i0,800,%o2	!
		and	%g7,0xf,%o3	! give Program Mask
		stx	%g1,[%i0+648]	!
		stx	%g2,[%i0+656]	!
		stx	%g3,[%i0+664]	!
		stx	%g4,[%i0+672]	!
		stx	%g5,[%i0+680]	!
		stx	%g6,[%i0+688]	!
		call	fl_comp_long	!
		mov	%i0,%o0		! struct gcpu_s*
		ldx	[%i0+648],%g1	!
		ldx	[%i0+656],%g2	!
		ldx	[%i0+664],%g3	!
		ldx	[%i0+672],%g4	!
		ldx	[%i0+680],%g5	!
		ldx	[%i0+688],%g6	!
		and	%o0,3,%g1	! CC=retval
		ba	%icc,break0	!
		add	%g2,4,%g2	! update IAR
i.cd0e:

	.section ".text"
	.align	4
	.global if4_ad
if4_ad:
	srl	%i3,20,%i5		! switch (R1)
	andcc	%i5,1,%g0		!
	bnz,pn	%icc,spec_exception	!
	nop				!
    i.ad0t:				!
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	add	%i5,64,%i1		! %i1
	srl	%i3,16,%i5		! X2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l2		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l2		! %l2
	srl	%i3,12,%i5		! B2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l3		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l3		! %l3
	and	%i3,0xfff,%l4		! D2
i.ad0s:
		add	%l2,%l3,%l2	! ##TEMPLATE:%l0,%l0
		add	%l2,%l4,%l2	! ##TEMPLATE:imm0
		and	%l2,%g3,%l2	! mask address

		andn	%l2,0xfff,%o1	! LD0-GS-TLB
		subcc	%g5,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g5,32,%o0	!
		call	ld1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l2,0xfff,%o1	!

		ld	[%o0+%o1],%l0	! get op#2
		add	%l2,4,%l2	!
		and	%l2,%g3,%l2	! mask address

 		andn	%l2,0xfff,%o1	! LD0-GS-TLB
		subcc	%g5,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g5,32,%o0	!
		call	ld1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l2,0xfff,%o1	!

		ld	[%o0+%o1],%l1	! get op#2
		std	%l0,[%i0+800]	! store op#2
		add	%i0,%i1,%o1	! ##TEMPLATE:%imm
		add	%i0,800,%o2	!
		and	%g7,0xf,%o3	! give Program Mask
		add	%g0,0,%o4	! call library in fltlib.s
		stx	%g1,[%i0+648]	!
		stx	%g2,[%i0+656]	!
		stx	%g3,[%i0+664]	!
		stx	%g4,[%i0+672]	!
		stx	%g5,[%i0+680]	!
		stx	%g6,[%i0+688]	!
		call	fl_addsub_long_norm
		mov	%i0,%o0		! struct gcpu_s*
		ldx	[%i0+648],%g1	!
		ldx	[%i0+656],%g2	!
		ldx	[%i0+664],%g3	!
		ldx	[%i0+672],%g4	!
		ldx	[%i0+680],%g5	!
		ldx	[%i0+688],%g6	!
		and	%o0,3,%g1	! CC=retval
		sethi	%hi(0x00ff0000),%o7
		andcc	%o0,%o7,%o0	! extract exception
		bz,a	%icc,break0	!   exit
		add	%g2,4,%g2	! update IAR
		ba	%icc,epilog0	!
		or	%g7,%o0,%g7	! INTR-CODE=retval
i.ad0e:

	.section ".text"
	.align	4
	.global if4_sd
if4_sd:
	srl	%i3,20,%i5		! switch (R1)
	andcc	%i5,1,%g0		!
	bnz,pn	%icc,spec_exception	!
	nop				!
    i.sd0t:				!
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	add	%i5,64,%i1		! %i1
	srl	%i3,16,%i5		! X2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l2		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l2		! %l2
	srl	%i3,12,%i5		! B2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l3		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l3		! %l3
	and	%i3,0xfff,%l4		! D2
i.sd0s:
		add	%l2,%l3,%l2	! ##TEMPLATE:%l0,%l0
		add	%l2,%l4,%l2	! ##TEMPLATE:imm0
		and	%l2,%g3,%l2	! mask address

		andn	%l2,0xfff,%o1	! LD0-GS-TLB
		subcc	%g5,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g5,32,%o0	!
		call	ld1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l2,0xfff,%o1	!

		ld	[%o0+%o1],%l0	! get op#2
		add	%l2,4,%l2	!
		and	%l2,%g3,%l2	! mask address

		andn	%l2,0xfff,%o1	! LD0-GS-TLB
		subcc	%g5,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g5,32,%o0	!
		call	ld1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l2,0xfff,%o1	!

		ld	[%o0+%o1],%l1	! get op#2
		std	%l0,[%i0+800]	! store op#2
		add	%i0,%i1,%o1	! ##TEMPLATE:%imm
		add	%i0,800,%o2	!
		and	%g7,0xf,%o3	! give Program Mask
		add	%g0,1,%o4	! call library in fltlib.s
		stx	%g1,[%i0+648]	!
		stx	%g2,[%i0+656]	!
		stx	%g3,[%i0+664]	!
		stx	%g4,[%i0+672]	!
		stx	%g5,[%i0+680]	!
		stx	%g6,[%i0+688]	!
		call	fl_addsub_long_norm
		mov	%i0,%o0		! struct gcpu_s*
		ldx	[%i0+648],%g1	!
		ldx	[%i0+656],%g2	!
		ldx	[%i0+664],%g3	!
		ldx	[%i0+672],%g4	!
		ldx	[%i0+680],%g5	!
		ldx	[%i0+688],%g6	!
		and	%o0,3,%g1	! CC=retval
		sethi	%hi(0x00ff0000),%o7
		andcc	%o0,%o7,%o0	! extract exception
		bz,a	%icc,break0	!   exit
		add	%g2,4,%g2	! update IAR
		ba	%icc,epilog0	!
		or	%g7,%o0,%g7	! INTR-CODE=retval
i.sd0e:

	.section ".text"
	.align	4
	.global if4_md
if4_md:
	srl	%i3,20,%i5		! switch (R1)
	andcc	%i5,1,%g0		!
	bnz,pn	%icc,spec_exception	!
	nop				!
    i.md0t:				!
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	add	%i5,64,%i1		! %i1
	srl	%i3,16,%i5		! X2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l2		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l2		! %l2
	srl	%i3,12,%i5		! B2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l3		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l3		! %l3
	and	%i3,0xfff,%l4		! D2
i.md0s:
		add	%l2,%l3,%l2	! ##TEMPLATE:%l0,%l0
		add	%l2,%l4,%l2	! ##TEMPLATE:imm0
		and	%l2,%g3,%l2	! mask address

		andn	%l2,0xfff,%o1	! LD0-GS-TLB
		subcc	%g5,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g5,32,%o0	!
		call	ld1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l2,0xfff,%o1	!

		ld	[%o0+%o1],%l0	! get op#2
		add	%l2,4,%l2	!
		and	%l2,%g3,%l2	! mask address

		andn	%l2,0xfff,%o1	! LD0-GS-TLB
		subcc	%g5,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g5,32,%o0	!
		call	ld1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l2,0xfff,%o1	!

		ld	[%o0+%o1],%l1	! get op#2
		std	%l0,[%i0+800]	! store op#2
		add	%i0,%i1,%o1	! ##TEMPLATE:%imm
		add	%i0,800,%o2	!
		and	%g7,0xf,%o3	! give Program Mask
		stx	%g1,[%i0+648]	!
		stx	%g2,[%i0+656]	!
		stx	%g3,[%i0+664]	!
		stx	%g4,[%i0+672]	!
		stx	%g5,[%i0+680]	!
		stx	%g6,[%i0+688]	!
		call	fl_mult_long2long
		mov	%i0,%o0		! struct gcpu_s*
		ldx	[%i0+648],%g1	!
		ldx	[%i0+656],%g2	!
		ldx	[%i0+664],%g3	!
		ldx	[%i0+672],%g4	!
		ldx	[%i0+680],%g5	!
		ldx	[%i0+688],%g6	!
		sethi	%hi(0x00ff0000),%o7
		andcc	%o0,%o7,%o0	! extract exception
		bz,a	%icc,break0	!   exit
		add	%g2,4,%g2	! update IAR
		ba	%icc,epilog0	!
		or	%g7,%o0,%g7	! INTR-CODE=retval
i.md0e:

	.section ".text"
	.align	4
	.global if4_dd
if4_dd:
	srl	%i3,20,%i5		! switch (R1)
	andcc	%i5,1,%g0		!
	bnz,pn	%icc,spec_exception	!
	nop				!
    i.dd0t:				!
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	add	%i5,64,%i1		! %i1
	srl	%i3,16,%i5		! X2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l2		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l2		! %l2
	srl	%i3,12,%i5		! B2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l3		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l3		! %l3
	and	%i3,0xfff,%l4		! D2
i.dd0s:
		add	%l2,%l3,%l2	! ##TEMPLATE:%l0,%l0
		add	%l2,%l4,%l2	! ##TEMPLATE:imm0
		and	%l2,%g3,%l2	! mask address

		andn	%l2,0xfff,%o1	! LD0-GS-TLB
		subcc	%g5,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g5,32,%o0	!
		call	ld1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l2,0xfff,%o1	!

		ld	[%o0+%o1],%l0	! get op#2
		add	%l2,4,%l2	!
		and	%l2,%g3,%l2	! mask address

		andn	%l2,0xfff,%o1	! LD0-GS-TLB
		subcc	%g5,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g5,32,%o0	!
		call	ld1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l2,0xfff,%o1	!

		ld	[%o0+%o1],%l1	! get op#2
		std	%l0,[%i0+800]	! store op#2
		add	%i0,%i1,%o1	! ##TEMPLATE:%imm
		add	%i0,800,%o2	!
		and	%g7,0xf,%o3	! give Program Mask
		stx	%g1,[%i0+648]	!
		stx	%g2,[%i0+656]	!
		stx	%g3,[%i0+664]	!
		stx	%g4,[%i0+672]	!
		stx	%g5,[%i0+680]	!
		stx	%g6,[%i0+688]	!
		call	fl_div_long	!
		mov	%i0,%o0		! struct gcpu_s*
		ldx	[%i0+648],%g1	!
		ldx	[%i0+656],%g2	!
		ldx	[%i0+664],%g3	!
		ldx	[%i0+672],%g4	!
		ldx	[%i0+680],%g5	!
		ldx	[%i0+688],%g6	!
		sethi	%hi(0x00ff0000),%o7
		andcc	%o0,%o7,%o0	! extract exception
		bz,a	%icc,break0	!   exit
		add	%g2,4,%g2	! update IAR
		ba	%icc,epilog0	!
		or	%g7,%o0,%g7	! INTR-CODE=retval
i.dd0e:

	.section ".text"
	.align	4
	.global if4_aw
if4_aw:
	srl	%i3,20,%i5		! switch (R1)
	andcc	%i5,1,%g0		!
	bnz,pn	%icc,spec_exception	!
	nop				!
    i.aw0t:				!
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	add	%i5,64,%i1		! %i1
	srl	%i3,16,%i5		! X2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l2		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l2		! %l2
	srl	%i3,12,%i5		! B2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l3		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l3		! %l3
	and	%i3,0xfff,%l4		! D2
i.aw0s:
		add	%l2,%l3,%l2	! ##TEMPLATE:%l0,%l0
		add	%l2,%l4,%l2	! ##TEMPLATE:imm0
		and	%l2,%g3,%l2	! mask address

		andn	%l2,0xfff,%o1	! LD0-GS-TLB
		subcc	%g5,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g5,32,%o0	!
		call	ld1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l2,0xfff,%o1	!

		ld	[%o0+%o1],%l0	! get op#2
		add	%l2,4,%l2	!
		and	%l2,%g3,%l2	! mask address

		andn	%l2,0xfff,%o1	! LD0-GS-TLB
		subcc	%g5,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g5,32,%o0	!
		call	ld1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l2,0xfff,%o1	!

		ld	[%o0+%o1],%l1	! get op#2
		std	%l0,[%i0+800]	! store op#2
		add	%i0,%i1,%o1	! ##TEMPLATE:%imm
		add	%i0,800,%o2	!
		and	%g7,0xf,%o3	! give Program Mask
		add	%g0,0,%o4	! call library in fltlib.s
		stx	%g1,[%i0+648]	!
		stx	%g2,[%i0+656]	!
		stx	%g3,[%i0+664]	!
		stx	%g4,[%i0+672]	!
		stx	%g5,[%i0+680]	!
		stx	%g6,[%i0+688]	!
		call	fl_addsub_long_unnorm
		mov	%i0,%o0		! struct gcpu_s*
		ldx	[%i0+648],%g1	!
		ldx	[%i0+656],%g2	!
		ldx	[%i0+664],%g3	!
		ldx	[%i0+672],%g4	!
		ldx	[%i0+680],%g5	!
		ldx	[%i0+688],%g6	!
		and	%o0,3,%g1	! CC=retval
		sethi	%hi(0x00ff0000),%o7
		andcc	%o0,%o7,%o0	! extract exception
		bz,a	%icc,break0	!   exit
		add	%g2,4,%g2	! update IAR
		ba	%icc,epilog0	!
		or	%g7,%o0,%g7	! INTR-CODE=retval
i.aw0e:

	.section ".text"
	.align	4
	.global if4_sw
if4_sw:
	srl	%i3,20,%i5		! switch (R1)
	andcc	%i5,1,%g0		!
	bnz,pn	%icc,spec_exception	!
	nop				!
    i.sw0t:				!
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	add	%i5,64,%i1		! %i1
	srl	%i3,16,%i5		! X2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l2		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l2		! %l2
	srl	%i3,12,%i5		! B2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l3		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l3		! %l3
	and	%i3,0xfff,%l4		! D2
i.sw0s:
		add	%l2,%l3,%l2	! ##TEMPLATE:%l0,%l0
		add	%l2,%l4,%l2	! ##TEMPLATE:imm0
		and	%l2,%g3,%l2	! mask address

		andn	%l2,0xfff,%o1	! LD0-GS-TLB
		subcc	%g5,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g5,32,%o0	!
		call	ld1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l2,0xfff,%o1	!

		ld	[%o0+%o1],%l0	! get op#2
		add	%l2,4,%l2	!
		and	%l2,%g3,%l2	! mask address

		andn	%l2,0xfff,%o1	! LD0-GS-TLB
		subcc	%g5,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g5,32,%o0	!
		call	ld1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l2,0xfff,%o1	!

		ld	[%o0+%o1],%l1	! get op#2
		std	%l0,[%i0+800]	! store op#2
		add	%i0,%i1,%o1	! ##TEMPLATE:%imm
		add	%i0,800,%o2	!
		and	%g7,0xf,%o3	! give Program Mask
		add	%g0,1,%o4	! call library in fltlib.s
		stx	%g1,[%i0+648]	!
		stx	%g2,[%i0+656]	!
		stx	%g3,[%i0+664]	!
		stx	%g4,[%i0+672]	!
		stx	%g5,[%i0+680]	!
		stx	%g6,[%i0+688]	!
		call	fl_addsub_long_unnorm
		mov	%i0,%o0		! struct gcpu_s*
		ldx	[%i0+648],%g1	!
		ldx	[%i0+656],%g2	!
		ldx	[%i0+664],%g3	!
		ldx	[%i0+672],%g4	!
		ldx	[%i0+680],%g5	!
		ldx	[%i0+688],%g6	!
		and	%o0,3,%g1	! CC=retval
		sethi	%hi(0x00ff0000),%o7
		andcc	%o0,%o7,%o0	! extract exception
		bz,a	%icc,break0	!   exit
		add	%g2,4,%g2	! update IAR
		ba	%icc,epilog0	!
		or	%g7,%o0,%g7	! INTR-CODE=retval
i.sw0e:
!================================

!
! templates
!   %i0: struct gcpu_s*
!   %i3: M instruction (upper 4 bytes)
!
	.section ".text"
	.align	4
	.global if4_ste
if4_ste:
	srl	%i3,20,%i5		! switch (R1)
	andcc	%i5,1,%g0		!
	bnz,pn	%icc,spec_exception	!
	nop				!
    i.ste0t:				!
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	add	%i5,64,%i1		! %i1
	srl	%i3,16,%i5		! X2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l2		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l2		! %l2
	srl	%i3,12,%i5		! B2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l3		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l3		! %l3
	and	%i3,0xfff,%l4		! D2
i.ste0s:
		add	%l2,%l3,%l2	! ##TEMPLATE:%l0,%l0
		add	%l2,%l4,%l2	! ##TEMPLATE:imm0
		and	%l2,%g3,%l2	! mask address
		ld	[%i0+%i1],%l0	! ##TEMPLATE:%imm

		andncc	%l2,0x1ff,%g0	! check LAP
		bnz,pt	%icc,.+12	!
		andcc	%g7,0x20,%g0	!
		tnz	%icc,0x43	! LAP exception
					!
		andn	%l2,0xfff,%o1	! ST0-GS-TLB
		subcc	%g6,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g6,32,%o0	!
		call	st1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l2,0xfff,%o1	!

		st	%l0,[%o0+%o1]	!
		ba	%icc,break0	!
		add	%g2,4,%g2	! update IAR
i.ste0e:

	.section ".text"
	.align	4
	.global if4_cei
if4_cei:
	srl	%i3,20,%i5		! switch (R1)
	andcc	%i5,1,%g0		!
	bnz,pn	%icc,spec_exception	!
	nop				!
    i.cei0t:				!
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	add	%i5,64,%i1		! %i1
	srl	%i3,16,%i5		! X2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l2		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l2		! %l2
	srl	%i3,12,%i5		! B2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l3		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l3		! %l3
	and	%i3,0xfff,%l4		! D2
i.cei0s:
		add	%i0,800,%o1	! call library in fltlib.s
		ld	[%i0+%i1],%o2	! ##TEMPLATE:%imm
		add	%g0,0,%o3	!
		and	%g7,0xf,%o4	! give Program Mask
		stx	%g1,[%i0+648]	!
		stx	%g2,[%i0+656]	!
		stx	%g3,[%i0+664]	!
		stx	%g4,[%i0+672]	!
		stx	%g5,[%i0+680]	!
		stx	%g6,[%i0+688]	!
		call	fl_conv_float2int
		mov	%i0,%o0		! struct gcpu_s*
		ldx	[%i0+648],%g1	!
		ldx	[%i0+656],%g2	!
		ldx	[%i0+664],%g3	!
		ldx	[%i0+672],%g4	!
		ldx	[%i0+680],%g5	!
		ldx	[%i0+688],%g6	!
		ld	[%i0+800],%l0	!
		mov	%o0,%l1		!
		add	%l2,%l3,%l2	! ##TEMPLATE:%l0,%l0
		add	%l2,%l4,%l2	! ##TEMPLATE:imm0
		and	%l2,%g3,%l2	! mask address

		andncc	%l2,0x1ff,%g0	! check LAP
		bnz,pt	%icc,.+12	!
		andcc	%g7,0x20,%g0	!
		tnz	%icc,0x43	! LAP exception
					!
		andn	%l2,0xfff,%o1	! ST0-GS-TLB
		subcc	%g6,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g6,32,%o0	!
		call	st1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l2,0xfff,%o1	!

		st	%l0,[%o0+%o1]	! store integer
		and	%l1,3,%g1	! CC=retval
		sethi	%hi(0x00ff0000),%o7
		andcc	%l1,%o7,%l1	! extract exception
		bz,a	%icc,break0	!   exit
		add	%g2,4,%g2	! update IAR
		ba	%icc,epilog0	!
		or	%g7,%l1,%g7	! INTR-CODE=retval
i.cei0e:

	.section ".text"
	.align	4
	.global if4_cdi
if4_cdi:
	srl	%i3,20,%i5		! switch (R1)
	andcc	%i5,1,%g0		!
	bnz,pn	%icc,spec_exception	!
	nop				!
    i.cdi0t:				!
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	add	%i5,64,%i1		! %i1
	srl	%i3,16,%i5		! X2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l2		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l2		! %l2
	srl	%i3,12,%i5		! B2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l3		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l3		! %l3
	and	%i3,0xfff,%l4		! D2
i.cdi0s:
		add	%i0,800,%o1	! call library in fltlib.s
		ldd	[%i0+%i1],%o2	! ##TEMPLATE:%imm
		and	%g7,0xf,%o4	! give Program Mask
		stx	%g1,[%i0+648]	!
		stx	%g2,[%i0+656]	!
		stx	%g3,[%i0+664]	!
		stx	%g4,[%i0+672]	!
		stx	%g5,[%i0+680]	!
		stx	%g6,[%i0+688]	!
		call	fl_conv_float2int
		mov	%i0,%o0		! struct gcpu_s*
		ldx	[%i0+648],%g1	!
		ldx	[%i0+656],%g2	!
		ldx	[%i0+664],%g3	!
		ldx	[%i0+672],%g4	!
		ldx	[%i0+680],%g5	!
		ldx	[%i0+688],%g6	!
		ld	[%i0+800],%l0	!
		mov	%o0,%l1		!
		add	%l2,%l3,%l2	! ##TEMPLATE:%l0,%l0
		add	%l2,%l4,%l2	! ##TEMPLATE:imm0
		and	%l2,%g3,%l2	! mask address

		andncc	%l2,0x1ff,%g0	! check LAP
		bnz,pt	%icc,.+12	!
		andcc	%g7,0x20,%g0	!
		tnz	%icc,0x43	! LAP exception
					!
		andn	%l2,0xfff,%o1	! ST0-GS-TLB
		subcc	%g6,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g6,32,%o0	!
		call	st1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l2,0xfff,%o1	!

		st	%l0,[%o0+%o1]	! store integer
		and	%l1,3,%g1	! CC=retval
		sethi	%hi(0x00ff0000),%o7
		andcc	%l1,%o7,%l1	! extract exception
		bz,a	%icc,break0	!   exit
		add	%g2,4,%g2	! update IAR
		ba	%icc,epilog0	!
		or	%g7,%l1,%g7	! INTR-CODE=retval
i.cdi0e:

	.section ".text"
	.align	4
	.global if4_cie
if4_cie:
	srl	%i3,20,%i5		! switch (R1)
	andcc	%i5,1,%g0		!
	bnz,pn	%icc,spec_exception	!
	nop				!
    i.cie0t:				!
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	add	%i5,64,%i1		! %i1
	srl	%i3,16,%i5		! X2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l2		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l2		! %l2
	srl	%i3,12,%i5		! B2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l3		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l3		! %l3
	and	%i3,0xfff,%l4		! D2
i.cie0s:
		add	%l2,%l3,%l2	! ##TEMPLATE:%l0,%l0
		add	%l2,%l4,%l2	! ##TEMPLATE:imm0
		and	%l2,%g3,%l2	! mask address

		andn	%l2,0xfff,%o1	! LD0-GS-TLB
		subcc	%g5,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g5,32,%o0	!
		call	ld1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l2,0xfff,%o1	!

		ld	[%o0+%o1],%o1	! get op#2
		add	%i0,800,%o2	! call library in fltlib.s
		stx	%g1,[%i0+648]	!
		stx	%g2,[%i0+656]	!
		stx	%g3,[%i0+664]	!
		stx	%g4,[%i0+672]	!
		stx	%g5,[%i0+680]	!
		stx	%g6,[%i0+688]	!
		call	fl_conv_int2float
		mov	%i0,%o0		! struct gcpu_s*
		ldx	[%i0+648],%g1	!
		ldx	[%i0+656],%g2	!
		ldx	[%i0+664],%g3	!
		ldx	[%i0+672],%g4	!
		ldx	[%i0+680],%g5	!
		ldx	[%i0+688],%g6	!
		ld	[%i0+800],%l0	!
		st	%l0,[%i0+%i1]	! ##TEMPLATE:%imm
		and	%o0,3,%g1	! CC=retval
		ba	%icc,break0	!
		add	%g2,4,%g2	! update IAR
i.cie0e:

	.section ".text"
	.align	4
	.global if4_cid
if4_cid:
	srl	%i3,20,%i5		! switch (R1)
	andcc	%i5,1,%g0		!
	bnz,pn	%icc,spec_exception	!
	nop				!
    i.cid0t:				!
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	add	%i5,64,%i1		! %i1
	srl	%i3,16,%i5		! X2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l2		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l2		! %l2
	srl	%i3,12,%i5		! B2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l3		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l3		! %l3
	and	%i3,0xfff,%l4		! D2
i.cid0s:
		add	%l2,%l3,%l2	! ##TEMPLATE:%l0,%l0
		add	%l2,%l4,%l2	! ##TEMPLATE:imm0
		and	%l2,%g3,%l2	! mask address

		andn	%l2,0xfff,%o1	! LD0-GS-TLB
		subcc	%g5,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g5,32,%o0	!
		call	ld1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l2,0xfff,%o1	!

		ld	[%o0+%o1],%o1	! get op#2
		add	%i0,800,%o2	! call library in fltlib.s
		stx	%g1,[%i0+648]	!
		stx	%g2,[%i0+656]	!
		stx	%g3,[%i0+664]	!
		stx	%g4,[%i0+672]	!
		stx	%g5,[%i0+680]	!
		stx	%g6,[%i0+688]	!
		call	fl_conv_int2float
		mov	%i0,%o0		! struct gcpu_s*
		ldx	[%i0+648],%g1	!
		ldx	[%i0+656],%g2	!
		ldx	[%i0+664],%g3	!
		ldx	[%i0+672],%g4	!
		ldx	[%i0+680],%g5	!
		ldx	[%i0+688],%g6	!
		ldd	[%i0+800],%l0	!
		std	%l0,[%i0+%i1]	! ##TEMPLATE:%imm
		and	%o0,3,%g1	! CC=retval
		ba	%icc,break0	!
		add	%g2,4,%g2	! update IAR
i.cid0e:

	.section ".text"
	.align	4
	.global if4_le
if4_le:
	srl	%i3,20,%i5		! switch (R1)
	andcc	%i5,1,%g0		!
	bnz,pn	%icc,spec_exception	!
	nop				!
    i.le0t:				!
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	add	%i5,64,%i1		! %i1
	srl	%i3,16,%i5		! X2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l2		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l2		! %l2
	srl	%i3,12,%i5		! B2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l3		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l3		! %l3
	and	%i3,0xfff,%l4		! D2
i.le0s:
		add	%l2,%l3,%l2	! ##TEMPLATE:%l0,%l0
		add	%l2,%l4,%l2	! ##TEMPLATE:imm0
		and	%l2,%g3,%l2	! mask address

		andn	%l2,0xfff,%o1	! LD0-GS-TLB
		subcc	%g5,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g5,32,%o0	!
		call	ld1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l2,0xfff,%o1	!

		ld	[%o0+%o1],%l0	! get op#2
		st	%l0,[%i0+%i1]	! ##TEMPLATE:%imm
		ba	%icc,break0	!
		add	%g2,4,%g2	! update IAR
i.le0e:

	.section ".text"
	.align	4
	.global if4_ce
if4_ce:
	srl	%i3,20,%i5		! switch (R1)
	andcc	%i5,1,%g0		!
	bnz,pn	%icc,spec_exception	!
	nop				!
    i.ce0t:				!
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	add	%i5,64,%i1		! %i1
	srl	%i3,16,%i5		! X2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l2		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l2		! %l2
	srl	%i3,12,%i5		! B2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l3		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l3		! %l3
	and	%i3,0xfff,%l4		! D2
i.ce0s:
		add	%l2,%l3,%l2	! ##TEMPLATE:%l0,%l0
		add	%l2,%l4,%l2	! ##TEMPLATE:imm0
		and	%l2,%g3,%l2	! mask address

		andn	%l2,0xfff,%o1	! LD0-GS-TLB
		subcc	%g5,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g5,32,%o0	!
		call	ld1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l2,0xfff,%o1	!

		ld	[%o0+%o1],%l0	! get op#2
		st	%l0,[%i0+800]	! store op#2
		add	%i0,%i1,%o1	! ##TEMPLATE:%imm
		add	%i0,800,%o2	!
		and	%g7,0xf,%o3	! give Program Mask
		stx	%g1,[%i0+648]	!
		stx	%g2,[%i0+656]	!
		stx	%g3,[%i0+664]	!
		stx	%g4,[%i0+672]	!
		stx	%g5,[%i0+680]	!
		stx	%g6,[%i0+688]	!
		call	fl_comp_short	!
		mov	%i0,%o0		! struct gcpu_s*
		ldx	[%i0+648],%g1	!
		ldx	[%i0+656],%g2	!
		ldx	[%i0+664],%g3	!
		ldx	[%i0+672],%g4	!
		ldx	[%i0+680],%g5	!
		ldx	[%i0+688],%g6	!
		and	%o0,3,%g1	! CC=retval
		ba	%icc,break0	!
		add	%g2,4,%g2	! update IAR
i.ce0e:

	.section ".text"
	.align	4
	.global	if4_ae
if4_ae:
	srl	%i3,20,%i5		! switch (R1)
	andcc	%i5,1,%g0		!
	bnz,pn	%icc,spec_exception	!
	nop				!
    i.ae0t:				!
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	add	%i5,64,%i1		! %i1
	srl	%i3,16,%i5		! X2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l2		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l2		! %l2
	srl	%i3,12,%i5		! B2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l3		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l3		! %l3
	and	%i3,0xfff,%l4		! D2
i.ae0s:
		add	%l2,%l3,%l2	! ##TEMPLATE:%l0,%l0
		add	%l2,%l4,%l2	! ##TEMPLATE:imm0
		and	%l2,%g3,%l2	! mask address

		andn	%l2,0xfff,%o1	! LD0-GS-TLB
		subcc	%g5,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g5,32,%o0	!
		call	ld1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l2,0xfff,%o1	!

		ld	[%o0+%o1],%l0	! get op#2
		st	%l0,[%i0+800]	! store op#2
		add	%i0,%i1,%o1	! ##TEMPLATE:%imm
		add	%i0,800,%o2	!
		and	%g7,0xf,%o3	! give Program Mask
		add	%g0,0,%o4	! call library in fltlib.s
		stx	%g1,[%i0+648]	!
		stx	%g2,[%i0+656]	!
		stx	%g3,[%i0+664]	!
		stx	%g4,[%i0+672]	!
		stx	%g5,[%i0+680]	!
		stx	%g6,[%i0+688]	!
		call	fl_addsub_short_norm
		mov	%i0,%o0		! struct gcpu_s*
		ldx	[%i0+648],%g1	!
		ldx	[%i0+656],%g2	!
		ldx	[%i0+664],%g3	!
		ldx	[%i0+672],%g4	!
		ldx	[%i0+680],%g5	!
		ldx	[%i0+688],%g6	!
		and	%o0,3,%g1	! CC=retval
		sethi	%hi(0x00ff0000),%o7
		andcc	%o0,%o7,%o0	! extract exception
		bz,a	%icc,break0	!   exit
		add	%g2,4,%g2	! update IAR
		ba	%icc,epilog0	!
		or	%g7,%o0,%g7	! INTR-CODE=retval
i.ae0e:

	.section ".text"
	.align	4
	.global if4_se
if4_se:
	srl	%i3,20,%i5		! switch (R1)
	andcc	%i5,1,%g0		!
	bnz,pn	%icc,spec_exception	!
	nop				!
    i.se0t:				!
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	add	%i5,64,%i1		! %i1
	srl	%i3,16,%i5		! X2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l2		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l2		! %l2
	srl	%i3,12,%i5		! B2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l3		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l3		! %l3
	and	%i3,0xfff,%l4		! D2
i.se0s:
		add	%l2,%l3,%l2	! ##TEMPLATE:%l0,%l0
		add	%l2,%l4,%l2	! ##TEMPLATE:imm0
		and	%l2,%g3,%l2	! mask address

		andn	%l2,0xfff,%o1	! LD0-GS-TLB
		subcc	%g5,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g5,32,%o0	!
		call	ld1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l2,0xfff,%o1	!

		ld	[%o0+%o1],%l0	! get op#2
		st	%l0,[%i0+800]	! store op#2
		add	%i0,%i1,%o1	! ##TEMPLATE:%imm
		add	%i0,800,%o2	!
		and	%g7,0xf,%o3	! give Program Mask
		add	%g0,1,%o4	! call library in fltlib.s
		stx	%g1,[%i0+648]	!
		stx	%g2,[%i0+656]	!
		stx	%g3,[%i0+664]	!
		stx	%g4,[%i0+672]	!
		stx	%g5,[%i0+680]	!
		stx	%g6,[%i0+688]	!
		call	fl_addsub_short_norm
		mov	%i0,%o0		! struct gcpu_s*
		ldx	[%i0+648],%g1	!
		ldx	[%i0+656],%g2	!
		ldx	[%i0+664],%g3	!
		ldx	[%i0+672],%g4	!
		ldx	[%i0+680],%g5	!
		ldx	[%i0+688],%g6	!
		and	%o0,3,%g1	! CC=retval
		sethi	%hi(0x00ff0000),%o7
		andcc	%o0,%o7,%o0	! extract exception
		bz,a	%icc,break0	!   exit
		add	%g2,4,%g2	! update IAR
		ba	%icc,epilog0	!
		or	%g7,%o0,%g7	! INTR-CODE=retval
i.se0e:

	.section ".text"
	.align	4
	.global if4_me
if4_me:
	srl	%i3,20,%i5		! switch (R1)
	andcc	%i5,1,%g0		!
	bnz,pn	%icc,spec_exception	!
	nop				!
    i.me0t:				!
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	add	%i5,64,%i1		! %i1
	srl	%i3,16,%i5		! X2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l2		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l2		! %l2
	srl	%i3,12,%i5		! B2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l3		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l3		! %l3
	and	%i3,0xfff,%l4		! D2
i.me0s:
		add	%l2,%l3,%l2	! ##TEMPLATE:%l0,%l0
		add	%l2,%l4,%l2	! ##TEMPLATE:imm0
		and	%l2,%g3,%l2	! mask address

		andn	%l2,0xfff,%o1	! LD0-GS-TLB
		subcc	%g5,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g5,32,%o0	!
		call	ld1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l2,0xfff,%o1	!

		ld	[%o0+%o1],%l0	! get op#2
		st	%l0,[%i0+800]	! store op#2
		add	%i0,%i1,%o1	! ##TEMPLATE:%imm
		add	%i0,800,%o2	!
		and	%g7,0xf,%o3	! give Program Mask
		stx	%g1,[%i0+648]	!
		stx	%g2,[%i0+656]	!
		stx	%g3,[%i0+664]	!
		stx	%g4,[%i0+672]	!
		stx	%g5,[%i0+680]	!
		stx	%g6,[%i0+688]	!
		call	fl_mult_short2long
		mov	%i0,%o0		! struct gcpu_s*
		ldx	[%i0+648],%g1	!
		ldx	[%i0+656],%g2	!
		ldx	[%i0+664],%g3	!
		ldx	[%i0+672],%g4	!
		ldx	[%i0+680],%g5	!
		ldx	[%i0+688],%g6	!
		sethi	%hi(0x00ff0000),%o7
		andcc	%o0,%o7,%o0	! extract exception
		bz,a	%icc,break0	!   exit
		add	%g2,4,%g2	! update IAR
		ba	%icc,epilog0	!
		or	%g7,%o0,%g7	! INTR-CODE=retval
i.me0e:

	.section ".text"
	.align	4
	.global if4_de
if4_de:
	srl	%i3,20,%i5		! switch (R1)
	andcc	%i5,1,%g0		!
	bnz,pn	%icc,spec_exception	!
	nop				!
    i.de0t:				!
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	add	%i5,64,%i1		! %i1
	srl	%i3,16,%i5		! X2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l2		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l2		! %l2
	srl	%i3,12,%i5		! B2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l3		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l3		! %l3
	and	%i3,0xfff,%l4		! D2
i.de0s:
		add	%l2,%l3,%l2	! ##TEMPLATE:%l0,%l0
		add	%l2,%l4,%l2	! ##TEMPLATE:imm0
		and	%l2,%g3,%l2	! mask address

		andn	%l2,0xfff,%o1	! LD0-GS-TLB
		subcc	%g5,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g5,32,%o0	!
		call	ld1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l2,0xfff,%o1	!

		ld	[%o0+%o1],%l0	! get op#2
		st	%l0,[%i0+800]	! store op#2
		add	%i0,%i1,%o1	! ##TEMPLATE:%imm
		add	%i0,800,%o2	!
		and	%g7,0xf,%o3	! give Program Mask
		stx	%g1,[%i0+648]	!
		stx	%g2,[%i0+656]	!
		stx	%g3,[%i0+664]	!
		stx	%g4,[%i0+672]	!
		stx	%g5,[%i0+680]	!
		stx	%g6,[%i0+688]	!
		call	fl_div_short	!
		mov	%i0,%o0		! struct gcpu_s*
		ldx	[%i0+648],%g1	!
		ldx	[%i0+656],%g2	!
		ldx	[%i0+664],%g3	!
		ldx	[%i0+672],%g4	!
		ldx	[%i0+680],%g5	!
		ldx	[%i0+688],%g6	!
		sethi	%hi(0x00ff0000),%o7
		andcc	%o0,%o7,%o0	! extract exception
		bz,a	%icc,break0	!   exit
		add	%g2,4,%g2	! update IAR
		ba	%icc,epilog0	!
		or	%g7,%o0,%g7	! INTR-CODE=retval
i.de0e:

	.section ".text"
	.align	4
	.global if4_au
if4_au:
	srl	%i3,20,%i5		! switch (R1)
	andcc	%i5,1,%g0		!
	bnz,pn	%icc,spec_exception	!
	nop				!
    i.au0t:				!
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	add	%i5,64,%i1		! %i1
	srl	%i3,16,%i5		! X2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l2		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l2		! %l2
	srl	%i3,12,%i5		! B2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l3		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l3		! %l3
	and	%i3,0xfff,%l4		! D2
i.au0s:
		add	%l2,%l3,%l2	! ##TEMPLATE:%l0,%l0
		add	%l2,%l4,%l2	! ##TEMPLATE:imm0
		and	%l2,%g3,%l2	! mask address

		andn	%l2,0xfff,%o1	! LD0-GS-TLB
		subcc	%g5,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g5,32,%o0	!
		call	ld1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l2,0xfff,%o1	!

		ld	[%o0+%o1],%l0	! get op#2
		st	%l0,[%i0+800]	! store op#2
		add	%i0,%i1,%o1	! ##TEMPLATE:%imm
		add	%i0,800,%o2	!
		and	%g7,0xf,%o3	! give Program Mask
		add	%g0,0,%o4	! call library in fltlib.s
		stx	%g1,[%i0+648]	!
		stx	%g2,[%i0+656]	!
		stx	%g3,[%i0+664]	!
		stx	%g4,[%i0+672]	!
		stx	%g5,[%i0+680]	!
		stx	%g6,[%i0+688]	!
		call	fl_addsub_short_unnorm
		mov	%i0,%o0		! struct gcpu_s*
		ldx	[%i0+648],%g1	!
		ldx	[%i0+656],%g2	!
		ldx	[%i0+664],%g3	!
		ldx	[%i0+672],%g4	!
		ldx	[%i0+680],%g5	!
		ldx	[%i0+688],%g6	!
		and	%o0,3,%g1	! CC=retval
		sethi	%hi(0x00ff0000),%o7
		andcc	%o0,%o7,%o0	! extract exception
		bz,a	%icc,break0	!   exit
		add	%g2,4,%g2	! update IAR
		ba	%icc,epilog0	!
		or	%g7,%o0,%g7	! INTR-CODE=retval
i.au0e:

	.section ".text"
	.align	4
	.global if4_su
if4_su:
	srl	%i3,20,%i5		! switch (R1)
	andcc	%i5,1,%g0		!
	bnz,pn	%icc,spec_exception	!
	nop				!
    i.su0t:				!
	srl	%i3,20,%i5		! R1
	and	%i5,0xf,%i5		! |
	sll	%i5,2,%i5		! |
	add	%i5,64,%i1		! %i1
	srl	%i3,16,%i5		! X2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l2		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l2		! %l2
	srl	%i3,12,%i5		! B2
	andcc	%i5,0xf,%i5		! |
	bz,a	%icc,.+16		! |
	add	%g0,%g0,%l3		! |
	sll	%i5,2,%i5		! |
	ld	[%i0+%i5],%l3		! %l3
	and	%i3,0xfff,%l4		! D2
i.su0s:
		add	%l2,%l3,%l2	! ##TEMPLATE:%l0,%l0
		add	%l2,%l4,%l2	! ##TEMPLATE:imm0
		and	%l2,%g3,%l2	! mask address

		andn	%l2,0xfff,%o1	! LD0-GS-TLB
		subcc	%g5,%o1,%g0	!
		be,a,pt	%icc,.+16	!
		srlx	%g5,32,%o0	!
		call	ld1_gs_tlb	! %o0:DS-LA
		mov	%i0,%o0		!
		and	%l2,0xfff,%o1	!

		ld	[%o0+%o1],%l0	! get op#2
		st	%l0,[%i0+800]	! store op#2
		add	%i0,%i1,%o1	! ##TEMPLATE:%imm
		add	%i0,800,%o2	!
		and	%g7,0xf,%o3	! give Program Mask
		add	%g0,1,%o4	! call library in fltlib.s
		stx	%g1,[%i0+648]	!
		stx	%g2,[%i0+656]	!
		stx	%g3,[%i0+664]	!
		stx	%g4,[%i0+672]	!
		stx	%g5,[%i0+680]	!
		stx	%g6,[%i0+688]	!
		call	fl_addsub_short_unnorm
		mov	%i0,%o0		! struct gcpu_s*
		ldx	[%i0+648],%g1	!
		ldx	[%i0+656],%g2	!
		ldx	[%i0+664],%g3	!
		ldx	[%i0+672],%g4	!
		ldx	[%i0+680],%g5	!
		ldx	[%i0+688],%g6	!
		and	%o0,3,%g1	! CC=retval
		sethi	%hi(0x00ff0000),%o7
		andcc	%o0,%o7,%o0	! extract exception
		bz,a	%icc,break0	!   exit
		add	%g2,4,%g2	! update IAR
		ba	%icc,epilog0	!
		or	%g7,%o0,%g7	! INTR-CODE=retval
i.su0e:
!================================

!
! <M opcd table>
!
	.section ".data"
	.align	1024
	.global optable
optable:
!
!   struct m_op {
!	int      mlen;
!	unsigned ifunc;
!	unsigned *name;
!	unsigned *args;
!	unsigned rsv0;
!	unsigned rsv1;
!	unsigned rsv2;
!	unsigned rsv3;
!   };
!
	.word	2,ii2_OPX2,  opn_OPX2, opa_OPX2, 0,0,0,0 /* 00 */
	.word	2,ii2_OPX2,  opn_OPX2, opa_OPX2, 0,0,0,0 /* 01 */
	.word	2,ii2_OPX2,  opn_OPX2, opa_OPX2, 0,0,0,0 /* 02 */
	.word	2,ii2_OPX2,  opn_OPX2, opa_OPX2, 0,0,0,0 /* 03 */
	.word	2,ii2_spm,   opn_spm,  opa_spm,  0,0,0,0 /* 04 */
	.word	2,ii2_balr,  opn_balr, opa_balr, 0,0,0,0 /* 05 */
	.word	2,ii2_bctr,  opn_bctr, opa_bctr, 0,0,0,0 /* 06 */
	.word	2,ii2_bcr,   opn_bcr,  opa_bcr,  0,0,0,0 /* 07 */
	.word	2,ic2_ssk,   opn_ssk,  opa_ssk,  0,0,0,0 /* 08 */
	.word	2,ic2_isk,   opn_isk,  opa_isk,  0,0,0,0 /* 09 */
	.word	2,ii2_svc,   opn_svc,  opa_svc,  0,0,0,0 /* 0a */
	.word	2,ii2_bsm,   opn_bsm,  opa_bsm,  0,0,0,0 /* 0b */
	.word	2,ii2_bassm, opn_bassm,opa_bassm,0,0,0,0 /* 0c */
	.word	2,ii2_basr,  opn_basr, opa_basr, 0,0,0,0 /* 0d */
	.word	2,ii2_mvcl,  opn_mvcl, opa_mvcl, 0,0,0,0 /* 0e */
	.word	2,ii2_clcl,  opn_clcl, opa_clcl, 0,0,0,0 /* 0f */

	.word	2,ii2_lpr,   opn_lpr,  opa_lpr,  0,0,0,0 /* 10 */
	.word	2,ii2_lnr,   opn_lnr,  opa_lnr,  0,0,0,0 /* 11 */
	.word	2,ii2_ltr,   opn_ltr,  opa_ltr,  0,0,0,0 /* 12 */
	.word	2,ii2_lcr,   opn_lcr,  opa_lcr,  0,0,0,0 /* 13 */
	.word	2,ii2_nr,    opn_nr,   opa_nr,   0,0,0,0 /* 14 */
	.word	2,ii2_clr,   opn_clr,  opa_clr,  0,0,0,0 /* 15 */
	.word	2,ii2_or,    opn_or,   opa_or,   0,0,0,0 /* 16 */
	.word	2,ii2_xr,    opn_xr,   opa_xr,   0,0,0,0 /* 17 */
	.word	2,ii2_lr,    opn_lr,   opa_lr,   0,0,0,0 /* 18 */
	.word	2,ii2_cr,    opn_cr,   opa_cr,   0,0,0,0 /* 19 */
	.word	2,ii2_ar,    opn_ar,   opa_ar,   0,0,0,0 /* 1a */
	.word	2,ii2_sr,    opn_sr,   opa_sr,   0,0,0,0 /* 1b */
	.word	2,ii2_mr,    opn_mr,   opa_mr,   0,0,0,0 /* 1c */
	.word	2,ii2_dr,    opn_dr,   opa_dr,   0,0,0,0 /* 1d */
	.word	2,ii2_alr,   opn_alr,  opa_alr,  0,0,0,0 /* 1e */
	.word	2,ii2_slr,   opn_slr,  opa_slr,  0,0,0,0 /* 1f */

	.word	2,if2_lpdr,  opn_lpdr, opa_lpdr, 0,0,0,0 /* 20 */
	.word	2,if2_lndr,  opn_lndr, opa_lndr, 0,0,0,0 /* 21 */
	.word	2,if2_ltdr,  opn_ltdr, opa_ltdr, 0,0,0,0 /* 22 */
	.word	2,if2_lcdr,  opn_lcdr, opa_lcdr, 0,0,0,0 /* 23 */
	.word	2,if2_hdr,   opn_hdr,  opa_hdr,  0,0,0,0 /* 24 */
	.word	2,if2_lrdr,  opn_lrdr, opa_lrdr, 0,0,0,0 /* 25 */
	.word	2,if2_mxr,   opn_mxr,  opa_mxr,  0,0,0,0 /* 26 */
	.word	2,if2_mxdr,  opn_mxdr, opa_mxdr, 0,0,0,0 /* 27 */
	.word	2,if2_ldr,   opn_ldr,  opa_ldr,  0,0,0,0 /* 28 */
	.word	2,if2_cdr,   opn_cdr,  opa_cdr,  0,0,0,0 /* 29 */
	.word	2,if2_adr,   opn_adr,  opa_adr,  0,0,0,0 /* 2a */
	.word	2,if2_sdr,   opn_sdr,  opa_sdr,  0,0,0,0 /* 2b */
	.word	2,if2_mdr,   opn_mdr,  opa_mdr,  0,0,0,0 /* 2c */
	.word	2,if2_ddr,   opn_ddr,  opa_ddr,  0,0,0,0 /* 2d */
	.word	2,if2_awr,   opn_awr,  opa_awr,  0,0,0,0 /* 2e */
	.word	2,if2_swr,   opn_swr,  opa_swr,  0,0,0,0 /* 2f */

	.word	2,if2_lper,  opn_lper, opa_lper, 0,0,0,0 /* 30 */
	.word	2,if2_lner,  opn_lner, opa_lner, 0,0,0,0 /* 31 */
	.word	2,if2_lter,  opn_lter, opa_lter, 0,0,0,0 /* 32 */
	.word	2,if2_lcer,  opn_lcer, opa_lcer, 0,0,0,0 /* 33 */
	.word	2,if2_her,   opn_her,  opa_her,  0,0,0,0 /* 34 */
	.word	2,if2_lrer,  opn_lrer, opa_lrer, 0,0,0,0 /* 35 */
	.word	2,if2_axr,   opn_axr,  opa_axr,  0,0,0,0 /* 36 */
	.word	2,if2_sxr,   opn_sxr,  opa_sxr,  0,0,0,0 /* 37 */
	.word	2,if2_ler,   opn_ler,  opa_ler,  0,0,0,0 /* 38 */
	.word	2,if2_cer,   opn_cer,  opa_cer,  0,0,0,0 /* 39 */
	.word	2,if2_aer,   opn_aer,  opa_aer,  0,0,0,0 /* 3a */
	.word	2,if2_ser,   opn_ser,  opa_ser,  0,0,0,0 /* 3b */
	.word	2,if2_mer,   opn_mer,  opa_mer,  0,0,0,0 /* 3c */
	.word	2,if2_der,   opn_der,  opa_der,  0,0,0,0 /* 3d */
	.word	2,if2_aur,   opn_aur,  opa_aur,  0,0,0,0 /* 3e */
	.word	2,if2_sur,   opn_sur,  opa_sur,  0,0,0,0 /* 3f */

	.word	4,ii4_sth,   opn_sth,  opa_sth,  0,0,0,0 /* 40 */
	.word	4,ii4_la,    opn_la,   opa_la,   0,0,0,0 /* 41 */
	.word	4,ii4_stc,   opn_stc,  opa_stc,  0,0,0,0 /* 42 */
	.word	4,ii4_ic,    opn_ic,   opa_ic,   0,0,0,0 /* 43 */
	.word	4,ii4_ex,    opn_ex,   opa_ex,   0,0,0,0 /* 44 */
	.word	4,ii4_bal,   opn_bal,  opa_bal,  0,0,0,0 /* 45 */
	.word	4,ii4_bct,   opn_bct,  opa_bct,  0,0,0,0 /* 46 */
	.word	4,ii4_bc,    opn_bc,   opa_bc,   0,0,0,0 /* 47 */
	.word	4,ii4_lh,    opn_lh,   opa_lh,   0,0,0,0 /* 48 */
	.word	4,ii4_ch,    opn_ch,   opa_ch,   0,0,0,0 /* 49 */
	.word	4,ii4_ah,    opn_ah,   opa_ah,   0,0,0,0 /* 4a */
	.word	4,ii4_sh,    opn_sh,   opa_sh,   0,0,0,0 /* 4b */
	.word	4,ii4_mh,    opn_mh,   opa_mh,   0,0,0,0 /* 4c */
	.word	4,ii4_bas,   opn_bas,  opa_bas,  0,0,0,0 /* 4d */
	.word	4,ii4_cvd,   opn_cvd,  opa_cvd,  0,0,0,0 /* 4e */
	.word	4,ii4_cvb,   opn_cvb,  opa_cvb,  0,0,0,0 /* 4f */

	.word	4,ii4_st,    opn_st,   opa_st,   0,0,0,0 /* 50 */
	.word	4,ii4_flm,   opn_flm,  opa_flm,  0,0,0,0 /* 51 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* 52 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* 53 */
	.word	4,ii4_n,     opn_n,    opa_n,    0,0,0,0 /* 54 */
	.word	4,ii4_cl,    opn_cl,   opa_cl,   0,0,0,0 /* 55 */
	.word	4,ii4_o,     opn_o,    opa_o,    0,0,0,0 /* 56 */
	.word	4,ii4_x,     opn_x,    opa_x,    0,0,0,0 /* 57 */
	.word	4,ii4_l,     opn_l,    opa_l,    0,0,0,0 /* 58 */
	.word	4,ii4_c,     opn_c,    opa_c,    0,0,0,0 /* 59 */
	.word	4,ii4_a,     opn_a,    opa_a,    0,0,0,0 /* 5a */
	.word	4,ii4_s,     opn_s,    opa_s,    0,0,0,0 /* 5b */
	.word	4,ii4_m,     opn_m,    opa_m,    0,0,0,0 /* 5c */
	.word	4,ii4_d,     opn_d,    opa_d,    0,0,0,0 /* 5d */
	.word	4,ii4_al,    opn_al,   opa_al,   0,0,0,0 /* 5e */
	.word	4,ii4_sl,    opn_sl,   opa_sl,   0,0,0,0 /* 5f */

	.word	4,if4_std,   opn_std,  opa_std,  0,0,0,0 /* 60 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* 61 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* 62 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* 63 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* 64 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* 65 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* 66 */
	.word	4,if4_mxd,   opn_mxd,  opa_mxd,  0,0,0,0 /* 67 */
	.word	4,if4_ld,    opn_ld,   opa_ld,   0,0,0,0 /* 68 */
	.word	4,if4_cd,    opn_cd,   opa_cd,   0,0,0,0 /* 69 */
	.word	4,if4_ad,    opn_ad,   opa_ad,   0,0,0,0 /* 6a */
	.word	4,if4_sd,    opn_sd,   opa_sd,   0,0,0,0 /* 6b */
	.word	4,if4_md,    opn_md,   opa_md,   0,0,0,0 /* 6c */
	.word	4,if4_dd,    opn_dd,   opa_dd,   0,0,0,0 /* 6d */
	.word	4,if4_aw,    opn_aw,   opa_aw,   0,0,0,0 /* 6e */
	.word	4,if4_sw,    opn_sw,   opa_sw,   0,0,0,0 /* 6f */

	.word	4,if4_ste,   opn_ste,  opa_ste,  0,0,0,0 /* 70 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* 71 */
	.word	4,if4_cei,   opn_cei,  opa_cei,  0,0,0,0 /* 72 */
	.word	4,if4_cdi,   opn_cdi,  opa_cdi,  0,0,0,0 /* 73 */
	.word	4,if4_cie,   opn_cie,  opa_cie,  0,0,0,0 /* 74 */
	.word	4,if4_cid,   opn_cid,  opa_cid,  0,0,0,0 /* 75 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* 76 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* 77 */
	.word	4,if4_le,    opn_le,   opa_le,   0,0,0,0 /* 78 */
	.word	4,if4_ce,    opn_ce,   opa_ce,   0,0,0,0 /* 79 */
	.word	4,if4_ae,    opn_ae,   opa_ae,   0,0,0,0 /* 7a */
	.word	4,if4_se,    opn_se,   opa_se,   0,0,0,0 /* 7b */
	.word	4,if4_me,    opn_me,   opa_me,   0,0,0,0 /* 7c */
	.word	4,if4_de,    opn_de,   opa_de,   0,0,0,0 /* 7d */
	.word	4,if4_au,    opn_au,   opa_au,   0,0,0,0 /* 7e */
	.word	4,if4_su,    opn_su,   opa_su,   0,0,0,0 /* 7f */

	.word	4,ic4_ssm,   opn_ssm,  opa_ssm,  0,0,0,0 /* 80 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* 81 */
	.word	4,ic4_lpsw,  opn_lpsw, opa_lpsw, 0,0,0,0 /* 82 */
	.word	4,ic4_diag,  opn_diag, opa_diag, 0,0,0,0 /* 83 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* 84 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* 85 */
	.word	4,ii4_bxh,   opn_bxh,  opa_bxh,  0,0,0,0 /* 86 */
	.word	4,ii4_bxle,  opn_bxle, opa_bxle, 0,0,0,0 /* 87 */
	.word	4,ii4_srl,   opn_srl,  opa_srl,  0,0,0,0 /* 88 */
	.word	4,ii4_sll,   opn_sll,  opa_sll,  0,0,0,0 /* 89 */
	.word	4,ii4_sra,   opn_sra,  opa_sra,  0,0,0,0 /* 8a */
	.word	4,ii4_sla,   opn_sla,  opa_sla,  0,0,0,0 /* 8b */
	.word	4,ii4_srdl,  opn_srdl, opa_srdl, 0,0,0,0 /* 8c */
	.word	4,ii4_sldl,  opn_sldl, opa_sldl, 0,0,0,0 /* 8d */
	.word	4,ii4_srda,  opn_srda, opa_srda, 0,0,0,0 /* 8e */
	.word	4,ii4_slda,  opn_slda, opa_slda, 0,0,0,0 /* 8f */

	.word	4,ii4_stm,   opn_stm,  opa_stm,  0,0,0,0 /* 90 */
	.word	4,ii4_tm,    opn_tm,   opa_tm,   0,0,0,0 /* 91 */
	.word	4,ii4_mvi,   opn_mvi,  opa_mvi,  0,0,0,0 /* 92 */
	.word	4,ii4_ts,    opn_ts,   opa_ts,   0,0,0,0 /* 93 */
	.word	4,ii4_ni,    opn_ni,   opa_ni,   0,0,0,0 /* 94 */
	.word	4,ii4_cli,   opn_cli,  opa_cli,  0,0,0,0 /* 95 */
	.word	4,ii4_oi,    opn_oi,   opa_oi,   0,0,0,0 /* 96 */
	.word	4,ii4_xi,    opn_xi,   opa_xi,   0,0,0,0 /* 97 */
	.word	4,ii4_lm,    opn_lm,   opa_lm,   0,0,0,0 /* 98 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* 99 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* 9a */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* 9b */
	.word	4,ic4_9cxx,  opn_9cxx, opa_9cxx, 0,0,0,0 /* 9c */
	.word	4,ic4_9dxx,  opn_9dxx, opa_9dxx, 0,0,0,0 /* 9d */
	.word	4,ic4_9exx,  opn_9exx, opa_9exx, 0,0,0,0 /* 9e */
	.word	4,ic4_9fxx,  opn_9fxx, opa_9fxx, 0,0,0,0 /* 9f */

	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* a0 */
	.word	4,ii4_ai,    opn_ai,   opa_ai,   0,0,0,0 /* a1 */
	.word	4,ii4_stext, opn_stext,opa_stext,0,0,0,0 /* a2 */
	.word	4,ii4_svg,   opn_svg,  opa_svg,  0,0,0,0 /* a3 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* a4 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* a5 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* a6 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* a7 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* a8 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* a9 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* aa */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* ab */
	.word	4,ic4_stnsm, opn_stnsm,opa_stnsm,0,0,0,0 /* ac */
	.word	4,ic4_stosm, opn_stosm,opa_stosm,0,0,0,0 /* ad */
	.word	4,ic4_sigp,  opn_sigp, opa_sigp, 0,0,0,0 /* ae */
	.word	4,ii4_mc,    opn_mc,   opa_mc,   0,0,0,0 /* af */

	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b0 */
	.word	4,ic4_lra,   opn_lra,  opa_lra,  0,0,0,0 /* b1 */
	.word	4,ic4_b2xx,  opn_b2xx, opa_b2xx, 0,0,0,0 /* b2 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b3 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b4 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b5 */
	.word	4,ic4_stctl, opn_stctl,opa_stctl,0,0,0,0 /* b6 */
	.word	4,ic4_lctl,  opn_lctl, opa_lctl, 0,0,0,0 /* b7 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b8 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b9 */
	.word	4,ii4_cs,    opn_cs,   opa_cs,   0,0,0,0 /* ba */
	.word	4,ii4_cds,   opn_cds,  opa_cds,  0,0,0,0 /* bb */
	.word	4,ic4_bcxx,  opn_bcxx, opa_bcxx, 0,0,0,0 /* bc */
	.word	4,ii4_clm,   opn_clm,  opa_clm,  0,0,0,0 /* bd */
	.word	4,ii4_stcm,  opn_stcm, opa_stcm, 0,0,0,0 /* be */
	.word	4,ii4_icm,   opn_icm,  opa_icm,  0,0,0,0 /* bf */

	.word	6,ii6_OPX6,  opn_OPX6, opa_OPX6, 0,0,0,0 /* c0 */
	.word	6,ii6_OPX6,  opn_OPX6, opa_OPX6, 0,0,0,0 /* c1 */
	.word	6,ii6_OPX6,  opn_OPX6, opa_OPX6, 0,0,0,0 /* c2 */
	.word	6,ii6_OPX6,  opn_OPX6, opa_OPX6, 0,0,0,0 /* c3 */
	.word	6,ii6_OPX6,  opn_OPX6, opa_OPX6, 0,0,0,0 /* c4 */
	.word	6,ii6_OPX6,  opn_OPX6, opa_OPX6, 0,0,0,0 /* c5 */
	.word	6,ii6_OPX6,  opn_OPX6, opa_OPX6, 0,0,0,0 /* c6 */
	.word	6,ii6_OPX6,  opn_OPX6, opa_OPX6, 0,0,0,0 /* c7 */
	.word	6,ii6_OPX6,  opn_OPX6, opa_OPX6, 0,0,0,0 /* c8 */
	.word	6,ii6_OPX6,  opn_OPX6, opa_OPX6, 0,0,0,0 /* c9 */
	.word	6,ii6_OPX6,  opn_OPX6, opa_OPX6, 0,0,0,0 /* ca */
	.word	6,ii6_OPX6,  opn_OPX6, opa_OPX6, 0,0,0,0 /* cb */
	.word	6,ii6_OPX6,  opn_OPX6, opa_OPX6, 0,0,0,0 /* cc */
	.word	6,ii6_OPX6,  opn_OPX6, opa_OPX6, 0,0,0,0 /* cd */
	.word	6,ii6_OPX6,  opn_OPX6, opa_OPX6, 0,0,0,0 /* ce */
	.word	6,ii6_OPX6,  opn_OPX6, opa_OPX6, 0,0,0,0 /* cf */

	.word	6,ii6_OPX6,  opn_OPX6, opa_OPX6, 0,0,0,0 /* d0 */
	.word	6,ii6_mvn,   opn_mvn,  opa_mvn,  0,0,0,0 /* d1 */
	.word	6,ii6_mvc,   opn_mvc,  opa_mvc,  0,0,0,0 /* d2 */
	.word	6,ii6_mvz,   opn_mvz,  opa_mvz,  0,0,0,0 /* d3 */
	.word	6,ii6_nc,    opn_nc,   opa_nc,   0,0,0,0 /* d4 */
	.word	6,ii6_clc,   opn_clc,  opa_clc,  0,0,0,0 /* d5 */
	.word	6,ii6_oc,    opn_oc,   opa_oc,   0,0,0,0 /* d6 */
	.word	6,ii6_xc,    opn_xc,   opa_xc,   0,0,0,0 /* d7 */
	.word	6,ii6_OPX6,  opn_OPX6, opa_OPX6, 0,0,0,0 /* d8 */
	.word	6,ii6_OPX6,  opn_OPX6, opa_OPX6, 0,0,0,0 /* d9 */
	.word	6,ii6_OPX6,  opn_OPX6, opa_OPX6, 0,0,0,0 /* da */
	.word	6,ii6_OPX6,  opn_OPX6, opa_OPX6, 0,0,0,0 /* db */
	.word	6,ii6_tr,    opn_tr,   opa_tr,   0,0,0,0 /* dc */
	.word	6,ii6_trt,   opn_trt,  opa_trt,  0,0,0,0 /* dd */
	.word	6,id6_ed,    opn_ed,   opa_ed,   0,0,0,0 /* de */
	.word	6,id6_edmk,  opn_edmk, opa_edmk, 0,0,0,0 /* df */

	.word	6,ii6_OPX6,  opn_OPX6, opa_OPX6, 0,0,0,0 /* e0 */
	.word	6,ii6_OPX6,  opn_OPX6, opa_OPX6, 0,0,0,0 /* e1 */
	.word	6,ii6_OPX6,  opn_OPX6, opa_OPX6, 0,0,0,0 /* e2 */
	.word	6,ii6_OPX6,  opn_OPX6, opa_OPX6, 0,0,0,0 /* e3 */
	.word	6,ii6_OPX6,  opn_OPX6, opa_OPX6, 0,0,0,0 /* e4 */
	.word	6,ic6_e5xx,  opn_e5xx, opa_e5xx, 0,0,0,0 /* e5 */
	.word	6,ii6_OPX6,  opn_OPX6, opa_OPX6, 0,0,0,0 /* e6 */
	.word	6,ii6_OPX6,  opn_OPX6, opa_OPX6, 0,0,0,0 /* e7 */
	.word	6,ii6_mvcin, opn_mvcin,opa_mvcin,0,0,0,0 /* e8 */
	.word	6,ii6_OPX6,  opn_OPX6, opa_OPX6, 0,0,0,0 /* e9 */
	.word	6,ii6_OPX6,  opn_OPX6, opa_OPX6, 0,0,0,0 /* ea */
	.word	6,ii6_OPX6,  opn_OPX6, opa_OPX6, 0,0,0,0 /* eb */
	.word	6,ii6_OPX6,  opn_OPX6, opa_OPX6, 0,0,0,0 /* ec */
	.word	6,ii6_OPX6,  opn_OPX6, opa_OPX6, 0,0,0,0 /* ed */
	.word	6,ii6_OPX6,  opn_OPX6, opa_OPX6, 0,0,0,0 /* ee */
	.word	6,ii6_OPX6,  opn_OPX6, opa_OPX6, 0,0,0,0 /* ef */

	.word	6,id6_srp,   opn_srp,  opa_srp,  0,0,0,0 /* f0 */
	.word	6,ii6_mvo,   opn_mvo,  opa_mvo,  0,0,0,0 /* f1 */
	.word	6,ii6_pack,  opn_pack, opa_pack, 0,0,0,0 /* f2 */
	.word	6,ii6_unpk,  opn_unpk, opa_unpk, 0,0,0,0 /* f3 */
	.word	6,ii6_OPX6,  opn_OPX6, opa_OPX6, 0,0,0,0 /* f4 */
	.word	6,ii6_OPX6,  opn_OPX6, opa_OPX6, 0,0,0,0 /* f5 */
	.word	6,ii6_OPX6,  opn_OPX6, opa_OPX6, 0,0,0,0 /* f6 */
	.word	6,ii6_OPX6,  opn_OPX6, opa_OPX6, 0,0,0,0 /* f7 */
	.word	6,id6_zap,   opn_zap,  opa_zap,  0,0,0,0 /* f8 */
	.word	6,id6_cp,    opn_cp,   opa_cp,   0,0,0,0 /* f9 */
	.word	6,id6_ap,    opn_ap,   opa_ap,   0,0,0,0 /* fa */
	.word	6,id6_sp,    opn_sp,   opa_sp,   0,0,0,0 /* fb */
	.word	6,id6_mp,    opn_mp,   opa_mp,   0,0,0,0 /* fc */
	.word	6,id6_dp,    opn_dp,   opa_dp,   0,0,0,0 /* fd */
	.word	6,ii6_OPX6,  opn_OPX6, opa_OPX6, 0,0,0,0 /* fe */
	.word	6,ii6_OPX6,  opn_OPX6, opa_OPX6, 0,0,0,0 /* ff */

!
! <M B2XX sub_opcd table>
!
	.section ".data"
	.align	1024
	.global optb2xx
optb2xx:
!
!   struct m_op {
!	int      mlen;
!	unsigned ifunc;
!	unsigned *name;
!	unsigned *args;
!	unsigned rsv0;
!	unsigned rsv1;
!	unsigned rsv2;
!	unsigned rsv3;
!   };
!
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b200 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b201 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b202 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b203 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b204 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b205 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b206 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b207 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b208 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b209 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b20a */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b20b */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b20c */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b20d */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b20e */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b20f */

	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b210 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b211 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b212 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b213 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b214 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b215 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b216 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b217 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b218 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b219 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b21a */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b21b */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b21c */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b21d */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b21e */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b21f */

	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b220 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b221 */
	.word	4,ii4_ipm,   opn_ipm,  opa_ipm,  0,0,0,0 /* b222 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b223 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b224 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b225 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b226 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b227 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b228 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b229 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b22a */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b22b */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b22c */
	.word	4,if4_dxr,   opn_dxr,  opa_dxr,  0,0,0,0 /* b22d */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b22e */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b22f */

	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b230 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b231 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b232 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b233 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b234 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b235 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b236 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b237 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b238 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b239 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b23a */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b23b */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b23c */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b23d */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b23e */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b23f */

	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b240 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b241 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b242 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b243 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b244 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b245 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b246 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b247 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b248 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b249 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b24a */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b24b */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b24c */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b24d */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b24e */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b24f */

	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b250 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b251 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b252 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b253 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b254 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b255 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b256 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b257 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b258 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b259 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b25a */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b25b */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b25c */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b25d */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b25e */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b25f */

	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b260 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b261 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b262 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b263 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b264 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b265 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b266 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b267 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b268 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b269 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b26a */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b26b */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b26c */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b26d */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b26e */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b26f */

	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b270 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b271 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b272 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b273 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b274 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b275 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b276 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b277 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b278 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b279 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b27a */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b27b */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b27c */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b27d */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b27e */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b27f */

	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b280 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b281 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b282 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b283 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b284 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b285 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b286 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b287 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b288 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b289 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b28a */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b28b */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b28c */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b28d */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b28e */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b28f */

	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b290 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b291 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b292 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b293 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b294 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b295 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b296 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b297 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b298 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b299 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b29a */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b29b */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b29c */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b29d */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b29e */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b29f */

	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b2a0 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b2a1 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b2a2 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b2a3 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b2a4 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b2a5 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b2a6 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b2a7 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b2a8 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b2a9 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b2aa */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b2ab */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b2ac */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b2ad */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b2ae */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b2af */

	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b2b0 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b2b1 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b2b2 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b2b3 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b2b4 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b2b5 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b2b6 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b2b7 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b2b8 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b2b9 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b2ba */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b2bb */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b2bc */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b2bd */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b2be */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b2bf */

	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b2c0 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b2c1 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b2c2 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b2c3 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b2c4 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b2c5 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b2c6 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b2c7 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b2c8 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b2c9 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b2ca */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b2cb */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b2cc */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b2cd */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b2ce */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b2cf */

	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b2d0 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b2d1 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b2d2 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b2d3 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b2d4 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b2d5 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b2d6 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b2d7 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b2d8 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b2d9 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b2da */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b2db */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b2dc */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b2dd */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b2de */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b2df */

	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b2e0 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b2e1 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b2e2 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b2e3 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b2e4 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b2e5 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b2e6 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b2e7 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b2e8 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b2e9 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b2ea */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b2eb */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b2ec */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b2ed */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b2ee */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b2ef */

	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b2f0 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b2f1 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b2f2 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b2f3 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b2f4 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b2f5 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b2f6 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b2f7 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b2f8 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b2f9 */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b2fa */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b2fb */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b2fc */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b2fd */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b2fe */
	.word	4,ii4_OPX4,  opn_OPX4, opa_OPX4, 0,0,0,0 /* b2ff */

!
! <M instruction format table>
!
	.section ".data"
	.align	1024
	.global inst_format
inst_format:
!
! /*  *args			  */
! /*	1:	  r1		  */
! /*	2:	  r2		  */
! /*	3:	  ipm/dxr-r1	  */
! /*	4:	  dxr-r2	  */
! /*	a:	  d2(x2,b2)	  */
! /*	b:	  d1(b1)/d2(b2)	  */
! /*	c:	  d1(l,b1)	  */
! /*	d:	  d2(b2)	  */
! /*	f:	  d1(l1,b1)	  */
! /*	g:	  d2(l2,b2)	  */
! /*	i:	  i		  */
! /*	j:	  i3		  */
! /*	m:	  m1		  */
! /*	n:	  m3		  */
! /*	x:	  diagnose	  */
!
	opn_OPX2:	.asciz	"??"	/* 00 */
	opa_OPX2:	.asciz	""	/* 00 */
	opn_OPX4:	.asciz	"????"	/* 00 */
	opa_OPX4:	.asciz	""	/* 00 */
	opn_OPX6:	.asciz	"??????"/* 00 */
	opa_OPX6:	.asciz	""	/* 00 */

	opn_spm:	.asciz	"SPM"	/* 04 */
	opa_spm:	.asciz	"1"	/* 04 */
	opn_balr:	.asciz	"BALR"	/* 05 */
	opa_balr:	.asciz	"1,2"	/* 05 */
	opn_bctr:	.asciz	"BCTR"	/* 06 */
	opa_bctr:	.asciz	"1,2"	/* 06 */
	opn_bcr:	.asciz	"BCR"	/* 07 */
	opa_bcr:	.asciz	"m,2"	/* 07 */
	opn_ssk:	.asciz	"SSK"	/* 08 */
	opa_ssk:	.asciz	"1,2"	/* 08 */
	opn_isk:	.asciz	"ISK"	/* 09 */
	opa_isk:	.asciz	"1,2"	/* 09 */
	opn_svc:	.asciz	"SVC"	/* 0a */
	opa_svc:	.asciz	"i"	/* 0a */
	opn_bsm:	.asciz	"BSM"	/* 0b */
	opa_bsm:	.asciz	"1,2"	/* 0b */
	opn_bassm:	.asciz	"BASSM" /* 0c */
	opa_bassm:	.asciz	"1,2"	/* 0c */
	opn_basr:	.asciz	"BASR"	/* 0d */
	opa_basr:	.asciz	"1,2"	/* 0d */
	opn_mvcl:	.asciz	"MVCL"	/* 0e */
	opa_mvcl:	.asciz	"1,2"	/* 0e */
	opn_clcl:	.asciz	"CLCL"	/* 0f */
	opa_clcl:	.asciz	"1,2"	/* 0f */

	opn_lpr:	.asciz	"LPR"	/* 10 */
	opa_lpr:	.asciz	"1,2"	/* 10 */
	opn_lnr:	.asciz	"LNR"	/* 11 */
	opa_lnr:	.asciz	"1,2"	/* 11 */
	opn_ltr:	.asciz	"LTR"	/* 12 */
	opa_ltr:	.asciz	"1,2"	/* 12 */
	opn_lcr:	.asciz	"LCR"	/* 13 */
	opa_lcr:	.asciz	"1,2"	/* 13 */
	opn_nr:		.asciz	"NR"	/* 14 */
	opa_nr:		.asciz	"1,2"	/* 14 */
	opn_clr:	.asciz	"CLR"	/* 15 */
	opa_clr:	.asciz	"1,2"	/* 15 */
	opn_or:		.asciz	"OR"	/* 16 */
	opa_or:		.asciz	"1,2"	/* 16 */
	opn_xr:		.asciz	"XR"	/* 17 */
	opa_xr:		.asciz	"1,2"	/* 17 */
	opn_lr:		.asciz	"LR"	/* 18 */
	opa_lr:		.asciz	"1,2"	/* 18 */
	opn_cr:		.asciz	"CR"	/* 19 */
	opa_cr:		.asciz	"1,2"	/* 19 */
	opn_ar:		.asciz	"AR"	/* 1a */
	opa_ar:		.asciz	"1,2"	/* 1a */
	opn_sr:		.asciz	"SR"	/* 1b */
	opa_sr:		.asciz	"1,2"	/* 1b */
	opn_mr:		.asciz	"MR"	/* 1c */
	opa_mr:		.asciz	"1,2"	/* 1c */
	opn_dr:		.asciz	"DR"	/* 1d */
	opa_dr:		.asciz	"1,2"	/* 1d */
	opn_alr:	.asciz	"ALR"	/* 1e */
	opa_alr:	.asciz	"1,2"	/* 1e */
	opn_slr:	.asciz	"SLR"	/* 1f */
	opa_slr:	.asciz	"1,2"	/* 1f */

	opn_lpdr:	.asciz	"LPDR"	/* 20 */
	opa_lpdr:	.asciz	"1,2"	/* 20 */
	opn_lndr:	.asciz	"LNDR"	/* 21 */
	opa_lndr:	.asciz	"1,2"	/* 21 */
	opn_ltdr:	.asciz	"LTDR"	/* 22 */
	opa_ltdr:	.asciz	"1,2"	/* 22 */
	opn_lcdr:	.asciz	"LCDR"	/* 23 */
	opa_lcdr:	.asciz	"1,2"	/* 23 */
	opn_hdr:	.asciz	"HDR"	/* 24 */
	opa_hdr:	.asciz	"1,2"	/* 24 */
	opn_lrdr:	.asciz	"LRDR"	/* 25 */
	opa_lrdr:	.asciz	"1,2"	/* 25 */
	opn_mxr:	.asciz	"MXR"	/* 26 */
	opa_mxr:	.asciz	"1,2"	/* 26 */
	opn_mxdr:	.asciz	"MXDR"	/* 27 */
	opa_mxdr:	.asciz	"1,2"	/* 27 */
	opn_ldr:	.asciz	"LDR"	/* 28 */
	opa_ldr:	.asciz	"1,2"	/* 28 */
	opn_cdr:	.asciz	"CDR"	/* 29 */
	opa_cdr:	.asciz	"1,2"	/* 29 */
	opn_adr:	.asciz	"ADR"	/* 2a */
	opa_adr:	.asciz	"1,2"	/* 2a */
	opn_sdr:	.asciz	"SDR"	/* 2b */
	opa_sdr:	.asciz	"1,2"	/* 2b */
	opn_mdr:	.asciz	"MDR"	/* 2c */
	opa_mdr:	.asciz	"1,2"	/* 2c */
	opn_ddr:	.asciz	"DDR"	/* 2d */
	opa_ddr:	.asciz	"1,2"	/* 2d */
	opn_awr:	.asciz	"AWR"	/* 2e */
	opa_awr:	.asciz	"1,2"	/* 2e */
	opn_swr:	.asciz	"SWR"	/* 2f */
	opa_swr:	.asciz	"1,2"	/* 2f */

	opn_lper:	.asciz	"LPER"	/* 30 */
	opa_lper:	.asciz	"1,2"	/* 30 */
	opn_lner:	.asciz	"LNER"	/* 31 */
	opa_lner:	.asciz	"1,2"	/* 31 */
	opn_lter:	.asciz	"LTER"	/* 32 */
	opa_lter:	.asciz	"1,2"	/* 32 */
	opn_lcer:	.asciz	"LCER"	/* 33 */
	opa_lcer:	.asciz	"1,2"	/* 33 */
	opn_her:	.asciz	"HER"	/* 34 */
	opa_her:	.asciz	"1,2"	/* 34 */
	opn_lrer:	.asciz	"LRER"	/* 35 */
	opa_lrer:	.asciz	"1,2"	/* 35 */
	opn_axr:	.asciz	"AXR"	/* 36 */
	opa_axr:	.asciz	"1,2"	/* 36 */
	opn_sxr:	.asciz	"SXR"	/* 37 */
	opa_sxr:	.asciz	"1,2"	/* 37 */
	opn_ler:	.asciz	"LER"	/* 38 */
	opa_ler:	.asciz	"1,2"	/* 38 */
	opn_cer:	.asciz	"CER"	/* 39 */
	opa_cer:	.asciz	"1,2"	/* 39 */
	opn_aer:	.asciz	"AER"	/* 3a */
	opa_aer:	.asciz	"1,2"	/* 3a */
	opn_ser:	.asciz	"SER"	/* 3b */
	opa_ser:	.asciz	"1,2"	/* 3b */
	opn_mer:	.asciz	"MER"	/* 3c */
	opa_mer:	.asciz	"1,2"	/* 3c */
	opn_der:	.asciz	"DER"	/* 3d */
	opa_der:	.asciz	"1,2"	/* 3d */
	opn_aur:	.asciz	"AUR"	/* 3e */
	opa_aur:	.asciz	"1,2"	/* 3e */
	opn_sur:	.asciz	"SUR"	/* 3f */
	opa_sur:	.asciz	"1,2"	/* 3f */

	opn_sth:	.asciz	"STH"	/* 40 */
	opa_sth:	.asciz	"1,a"	/* 40 */
	opn_la:		.asciz	"LA"	/* 41 */
	opa_la:		.asciz	"1,a"	/* 41 */
	opn_stc:	.asciz	"STC"	/* 42 */
	opa_stc:	.asciz	"1,a"	/* 42 */
	opn_ic:		.asciz	"IC"	/* 43 */
	opa_ic:		.asciz	"1,a"	/* 43 */
	opn_ex:		.asciz	"EX"	/* 44 */
	opa_ex:		.asciz	"1,a"	/* 44 */
	opn_bal:	.asciz	"BAL"	/* 45 */
	opa_bal:	.asciz	"1,a"	/* 45 */
	opn_bct:	.asciz	"BCT"	/* 46 */
	opa_bct:	.asciz	"1,a"	/* 46 */
	opn_bc:		.asciz	"BC"	/* 47 */
	opa_bc:		.asciz	"m,a"	/* 47 */
	opn_lh:		.asciz	"LH"	/* 48 */
	opa_lh:		.asciz	"1,a"	/* 48 */
	opn_ch:		.asciz	"CH"	/* 49 */
	opa_ch:		.asciz	"1,a"	/* 49 */
	opn_ah:		.asciz	"AH"	/* 4a */
	opa_ah:		.asciz	"1,a"	/* 4a */
	opn_sh:		.asciz	"SH"	/* 4b */
	opa_sh:		.asciz	"1,a"	/* 4b */
	opn_mh:		.asciz	"MH"	/* 4c */
	opa_mh:		.asciz	"1,a"	/* 4c */
	opn_bas:	.asciz	"BAS"	/* 4d */
	opa_bas:	.asciz	"1,a"	/* 4d */
	opn_cvd:	.asciz	"CVD"	/* 4e */
	opa_cvd:	.asciz	"1,a"	/* 4e */
	opn_cvb:	.asciz	"CVB"	/* 4f */
	opa_cvb:	.asciz	"1,a"	/* 4f */

	opn_st:		.asciz	"ST"	/* 50 */
	opa_st:		.asciz	"1,a"	/* 50 */
	opn_flm:	.asciz	"FLM"	/* 51 */
	opa_flm:	.asciz	"1,a"	/* 51 */
	opn_n:		.asciz	"N"	/* 54 */
	opa_n:		.asciz	"1,a"	/* 54 */
	opn_cl:		.asciz	"CL"	/* 55 */
	opa_cl:		.asciz	"1,a"	/* 55 */
	opn_o:		.asciz	"O"	/* 56 */
	opa_o:		.asciz	"1,a"	/* 56 */
	opn_x:		.asciz	"X"	/* 57 */
	opa_x:		.asciz	"1,a"	/* 57 */
	opn_l:		.asciz	"L"	/* 58 */
	opa_l:		.asciz	"1,a"	/* 58 */
	opn_c:		.asciz	"C"	/* 59 */
	opa_c:		.asciz	"1,a"	/* 59 */
	opn_a:		.asciz	"A"	/* 5a */
	opa_a:		.asciz	"1,a"	/* 5a */
	opn_s:		.asciz	"S"	/* 5b */
	opa_s:		.asciz	"1,a"	/* 5b */
	opn_m:		.asciz	"M"	/* 5c */
	opa_m:		.asciz	"1,a"	/* 5c */
	opn_d:		.asciz	"D"	/* 5d */
	opa_d:		.asciz	"1,a"	/* 5d */
	opn_al:		.asciz	"AL"	/* 5e */
	opa_al:		.asciz	"1,a"	/* 5e */
	opn_sl:		.asciz	"SL"	/* 5f */
	opa_sl:		.asciz	"1,a"	/* 5f */

	opn_std:	.asciz	"STD"	/* 60 */
	opa_std:	.asciz	"1,a"	/* 60 */
	opn_mxd:	.asciz	"MXD"	/* 67 */
	opa_mxd:	.asciz	"1,a"	/* 67 */
	opn_ld:		.asciz	"LD"	/* 68 */
	opa_ld:		.asciz	"1,a"	/* 68 */
	opn_cd:		.asciz	"CD"	/* 69 */
	opa_cd:		.asciz	"1,a"	/* 69 */
	opn_ad:		.asciz	"AD"	/* 6a */
	opa_ad:		.asciz	"1,a"	/* 6a */
	opn_sd:		.asciz	"SD"	/* 6b */
	opa_sd:		.asciz	"1,a"	/* 6b */
	opn_md:		.asciz	"MD"	/* 6c */
	opa_md:		.asciz	"1,a"	/* 6c */
	opn_dd:		.asciz	"DD"	/* 6d */
	opa_dd:		.asciz	"1,a"	/* 6d */
	opn_aw:		.asciz	"AW"	/* 6e */
	opa_aw:		.asciz	"1,a"	/* 6e */
	opn_sw:		.asciz	"SW"	/* 6f */
	opa_sw:		.asciz	"1,a"	/* 6f */

	opn_ste:	.asciz	"STE"	/* 70 */
	opa_ste:	.asciz	"1,a"	/* 70 */
	opn_cei:	.asciz	"CEI"	/* 72 */
	opa_cei:	.asciz	"1,a"	/* 72 */
	opn_cdi:	.asciz	"CDI"	/* 73 */
	opa_cdi:	.asciz	"1,a"	/* 73 */
	opn_cie:	.asciz	"CIE"	/* 74 */
	opa_cie:	.asciz	"1,a"	/* 74 */
	opn_cid:	.asciz	"CID"	/* 75 */
	opa_cid:	.asciz	"1,a"	/* 75 */
	opn_le:		.asciz	"LE"	/* 78 */
	opa_le:		.asciz	"1,a"	/* 78 */
	opn_ce:		.asciz	"CE"	/* 79 */
	opa_ce:		.asciz	"1,a"	/* 79 */
	opn_ae:		.asciz	"AE"	/* 7a */
	opa_ae:		.asciz	"1,a"	/* 7a */
	opn_se:		.asciz	"SE"	/* 7b */
	opa_se:		.asciz	"1,a"	/* 7b */
	opn_me:		.asciz	"ME"	/* 7c */
	opa_me:		.asciz	"1,a"	/* 7c */
	opn_de:		.asciz	"DE"	/* 7d */
	opa_de:		.asciz	"1,a"	/* 7d */
	opn_au:		.asciz	"AU"	/* 7e */
	opa_au:		.asciz	"1,a"	/* 7e */
	opn_su:		.asciz	"SU"	/* 7f */
	opa_su:		.asciz	"1,a"	/* 7f */

	opn_ssm:	.asciz	"SSM"	/* 80 */
	opa_ssm:	.asciz	"b"	/* 80 */
	opn_lpsw:	.asciz	"LPSW"	/* 82 */
	opa_lpsw:	.asciz	"b"	/* 82 */
	opn_diag:	.asciz	"DIAG"	/* 83 */
	opa_diag:	.asciz	"x"	/* 83 */
	opn_bxh:	.asciz	"BXH"	/* 86 */
	opa_bxh:	.asciz	"1,2,b" /* 86 */
	opn_bxle:	.asciz	"BXLE"	/* 87 */
	opa_bxle:	.asciz	"1,2,b" /* 87 */
	opn_srl:	.asciz	"SRL"	/* 88 */
	opa_srl:	.asciz	"1,b"	/* 88 */
	opn_sll:	.asciz	"SLL"	/* 89 */
	opa_sll:	.asciz	"1,b"	/* 89 */
	opn_sra:	.asciz	"SRA"	/* 8a */
	opa_sra:	.asciz	"1,b"	/* 8a */
	opn_sla:	.asciz	"SLA"	/* 8b */
	opa_sla:	.asciz	"1,b"	/* 8b */
	opn_srdl:	.asciz	"SRDL"	/* 8c */
	opa_srdl:	.asciz	"1,b"	/* 8c */
	opn_sldl:	.asciz	"SLDL"	/* 8d */
	opa_sldl:	.asciz	"1,b"	/* 8d */
	opn_srda:	.asciz	"SRDA"	/* 8e */
	opa_srda:	.asciz	"1,b"	/* 8e */
	opn_slda:	.asciz	"SLDA"	/* 8f */
	opa_slda:	.asciz	"1,b"	/* 8f */

	opn_stm:	.asciz	"STM"	/* 90 */
	opa_stm:	.asciz	"1,2,b" /* 90 */
	opn_tm:		.asciz	"TM"	/* 91 */
	opa_tm:		.asciz	"b,i"	/* 91 */
	opn_mvi:	.asciz	"MVI"	/* 92 */
	opa_mvi:	.asciz	"b,i"	/* 92 */
	opn_ts:		.asciz	"TS"	/* 93 */
	opa_ts:		.asciz	"b"	/* 93 */
	opn_ni:		.asciz	"NI"	/* 94 */
	opa_ni:		.asciz	"b,i"	/* 94 */
	opn_cli:	.asciz	"CLI"	/* 95 */
	opa_cli:	.asciz	"b,i"	/* 95 */
	opn_oi:		.asciz	"OI"	/* 96 */
	opa_oi:		.asciz	"b,i"	/* 96 */
	opn_xi:		.asciz	"XI"	/* 97 */
	opa_xi:		.asciz	"b,i"	/* 97 */
	opn_lm:		.asciz	"LM"	/* 98 */
	opa_lm:		.asciz	"1,2,b" /* 98 */
	opn_9cxx:	.asciz	"9CXX"	/* 9cxx */
	opa_9cxx:	.asciz	"b"	/* 9cxx */
	opn_9dxx:	.asciz	"9DXX"	/* 9dxx */
	opa_9dxx:	.asciz	"b"	/* 9dxx */
	opn_9exx:	.asciz	"9EXX"	/* 9exx */
	opa_9exx:	.asciz	"b"	/* 9exx */
	opn_9fxx:	.asciz	"9FXX"	/* 9fxx */
	opa_9fxx:	.asciz	"b"	/* 9fxx */

	opn_ai:		.asciz	"AI"	/* a1 */
	opa_ai:		.asciz	"b,i"	/* a1 */
	opn_stext:	.asciz	"STEXT"	/* a2 */
	opa_stext:	.asciz	"1,2,b" /* a2 */
	opn_svg:	.asciz	"SVG"	/* a3 */
	opa_svg:	.asciz	"1,2,b" /* a3 */
	opn_stnsm:	.asciz	"STNSM" /* ac */
	opa_stnsm:	.asciz	"b,i"	/* ac */
	opn_stosm:	.asciz	"STOSM" /* ad */
	opa_stosm:	.asciz	"b,i"	/* ad */
	opn_sigp:	.asciz	"SIGP"	/* ae */
	opa_sigp:	.asciz	"1,2,b" /* ae */
	opn_mc:		.asciz	"MC"	/* af */
	opa_mc:		.asciz	"b,i"	/* af */

	opn_lra:	.asciz	"LRA"	/* b1 */
	opa_lra:	.asciz	"1,a"	/* b1 */
	opn_b2xx:	.asciz	"B2XX"	/* b2xx */
	opa_b2xx:	.asciz	"b"	/* b2xx */
	opn_ipm:	.asciz	"IPM"	/* b222 */
	opa_ipm:	.asciz	"3"	/* b222 */
	opn_dxr:	.asciz	"DXR"	/* b22d */
	opa_dxr:	.asciz	"3,4"	/* b22d */
	opn_stctl:	.asciz	"STCTL" /* b6 */
	opa_stctl:	.asciz	"1,2,b" /* b6 */
	opn_lctl:	.asciz	"LCTL"	/* b7 */
	opa_lctl:	.asciz	"1,2,b" /* b7 */
	opn_cs:		.asciz	"CS"	/* ba */
	opa_cs:		.asciz	"1,2,b" /* ba */
	opn_cds:	.asciz	"CDS"	/* bb */
	opa_cds:	.asciz	"1,2,b" /* bb */
	opn_bcxx:	.asciz	"BCXX"	/* bcxx */
	opa_bcxx:	.asciz	"b"	/* bcxx */
	opn_clm:	.asciz	"CLM"	/* bd */
	opa_clm:	.asciz	"1,n,b" /* bd */
	opn_stcm:	.asciz	"STCM"	/* be */
	opa_stcm:	.asciz	"1,n,b" /* be */
	opn_icm:	.asciz	"ICM"	/* bf */
	opa_icm:	.asciz	"1,n,b" /* bf */

	opn_mvn:	.asciz	"MVN"	/* d1 */
	opa_mvn:	.asciz	"c,d"	/* d1 */
	opn_mvc:	.asciz	"MVC"	/* d2 */
	opa_mvc:	.asciz	"c,d"	/* d2 */
	opn_mvz:	.asciz	"MVZ"	/* d3 */
	opa_mvz:	.asciz	"c,d"	/* d3 */
	opn_nc:		.asciz	"NC"	/* d4 */
	opa_nc:		.asciz	"c,d"	/* d4 */
	opn_clc:	.asciz	"CLC"	/* d5 */
	opa_clc:	.asciz	"c,d"	/* d5 */
	opn_oc:		.asciz	"OC"	/* d6 */
	opa_oc:		.asciz	"c,d"	/* d6 */
	opn_xc:		.asciz	"XC"	/* d7 */
	opa_xc:		.asciz	"c,d"	/* d7 */
	opn_tr:		.asciz	"TR"	/* dc */
	opa_tr:		.asciz	"c,d"	/* dc */
	opn_trt:	.asciz	"TRT"	/* dd */
	opa_trt:	.asciz	"c,d"	/* dd */
	opn_ed:		.asciz	"ED"	/* de */
	opa_ed:		.asciz	"c,d"	/* de */
	opn_edmk:	.asciz	"EDMK"	/* df */
	opa_edmk:	.asciz	"c,d"	/* df */

	opn_e5xx:	.asciz	"E5XX"	/* e5 */
	opa_e5xx:	.asciz	"b,d"	/* e5 */
	opn_mvcin:	.asciz	"MVCIN" /* e8 */
	opa_mvcin:	.asciz	"c,d"	/* e8 */

	opn_srp:	.asciz	"SRP"	/* f0 */
	opa_srp:	.asciz	"f,d,j" /* f0 */
	opn_mvo:	.asciz	"MVO"	/* f1 */
	opa_mvo:	.asciz	"f,g"	/* f1 */
	opn_pack:	.asciz	"PACK"	/* f2 */
	opa_pack:	.asciz	"f,g"	/* f2 */
	opn_unpk:	.asciz	"UNPK"	/* f3 */
	opa_unpk:	.asciz	"f,g"	/* f3 */
	opn_zap:	.asciz	"ZAP"	/* f8 */
	opa_zap:	.asciz	"f,g"	/* f8 */
	opn_cp:		.asciz	"CP"	/* f9 */
	opa_cp:		.asciz	"f,g"	/* f9 */
	opn_ap:		.asciz	"AP"	/* fa */
	opa_ap:		.asciz	"f,g"	/* fa */
	opn_sp:		.asciz	"SP"	/* fb */
	opa_sp:		.asciz	"f,g"	/* fb */
	opn_mp:		.asciz	"MP"	/* fc */
	opa_mp:		.asciz	"f,g"	/* fc */
	opn_dp:		.asciz	"DP"	/* fd */
	opa_dp:		.asciz	"f,g"	/* fd */

!
! <M opcd counter>
!
	.section ".data"
	.align	1024
	.global pa_sinsn
	.global pa_pinsn
pa_sinsn:
	.space	1024
pa_pinsn:
	.space	1024

!
! <M branch history>
!
	.section ".data"
	.align	1024
	.global br_hist_top
br_hist_top:
	.space	1024

/**/
